/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/platform","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/path","vs/base/common/uri","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","electron","vs/nls","vs/base/common/types","vs/base/common/errors","vs/base/common/buffer","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/platform/product/common/productService","vs/platform/environment/electron-main/environmentMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/workspace/common/workspace","os","vs/base/common/strings","vs/base/common/extpath","fs","vs/base/common/arrays","vs/base/common/uuid","vs/platform/telemetry/common/telemetry","vs/base/common/labels","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/platform/state/electron-main/state","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/functional","vs/base/common/json","child_process","vs/base/common/decorators","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/stream","vs/base/common/objects","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/environment/common/environment","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/parts/ipc/node/ipc.net","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/keybindings","crypto","net","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/hash","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/remote/common/remoteHosts","vs/platform/sign/common/sign","vs/platform/workspaces/common/workspaces","vs/platform/storage/electron-main/storageMainService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/keyCodes","vs/base/common/processes","vs/base/common/stopwatch","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/storage/common/storage","vs/platform/terminal/node/shellEnv","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/codicons","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/keybindingParser","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/cache","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/common/worker/simpleWorker","vs/base/node/crypto","vs/base/node/decoder","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/node/shellEnv","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/resolvedKeybindingItem","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/credentials/node/credentialsMainService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/extensions/electron-main/workerMainProcessExtensionHostStarter","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","path","graceful-fs","worker_threads","vs/code/electron-main/main"],x=function(V){for(var e=[],w=0,n=V.length;w<n;w++)e[w]=Z[V[w]];return e};define(Z[106],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function w(n,L){if(!n)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}e.ok=w}),define(Z[107],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function w(P){return P?P.replace(/\$\((.*?)\)/g,(S,m)=>` ${m} `).trim():""}e.getCodiconAriaLabel=w;class n{constructor(S,m,I){this.id=S,this.definition=m,this.description=I,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.layoutActivitybarLeft=new n("layout-activitybar-left",{fontCharacter:"\\ebec"}),n.layoutActivitybarRight=new n("layout-activitybar-right",{fontCharacter:"\\ebed"}),n.layoutPanelLeft=new n("layout-panel-left",{fontCharacter:"\\ebee"}),n.layoutPanelCenter=new n("layout-panel-center",{fontCharacter:"\\ebef"}),n.layoutPanelJustify=new n("layout-panel-justify",{fontCharacter:"\\ebf0"}),n.layoutPanelRight=new n("layout-panel-right",{fontCharacter:"\\ebf1"}),n.layoutPanel=new n("layout-panel",{fontCharacter:"\\ebf2"}),n.layoutSidebarLeft=new n("layout-sidebar-left",{fontCharacter:"\\ebf3"}),n.layoutSidebarRight=new n("layout-sidebar-right",{fontCharacter:"\\ebf4"}),n.layoutStatusbar=new n("layout-statusbar",{fontCharacter:"\\ebf5"}),n.layoutMenubar=new n("layout-menubar",{fontCharacter:"\\ebf6"}),n.layoutCentered=new n("layout-centered",{fontCharacter:"\\ebf7"}),n.target=new n("target",{fontCharacter:"\\ebf8"}),n.indent=new n("indent",{fontCharacter:"\\ebf9"}),n.recordSmall=new n("record-small",{fontCharacter:"\\ebfa"}),n.errorSmall=new n("error-small",{fontCharacter:"\\ebfb"}),n.arrowCircleDown=new n("arrow-circle-down",{fontCharacter:"\\ebfc"}),n.arrowCircleLeft=new n("arrow-circle-left",{fontCharacter:"\\ebfd"}),n.arrowCircleRight=new n("arrow-circle-right",{fontCharacter:"\\ebfe"}),n.arrowCircleUp=new n("arrow-circle-up",{fontCharacter:"\\ebff"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function L(P,S){const m=["codicon","codicon-"+P];return S&&m.push("codicon-modifier-"+S),m}e.getClassNamesArray=L;var D;(function(P){P.iconNameSegment="[A-Za-z0-9]+",P.iconNameExpression="[A-Za-z0-9-]+",P.iconModifierExpression="~[A-Za-z]+",P.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${P.iconNameExpression})(${P.iconModifierExpression})?$`);function m(E){if(E instanceof n)return["codicon","codicon-"+E.id];const b=S.exec(E.id);if(!b)return m(n.error);let[,p,t]=b;const h=["codicon","codicon-"+p];return t&&h.push("codicon-modifier-"+t.substr(1)),h}P.asClassNameArray=m;function I(E){return m(E).join(" ")}P.asClassName=I;function M(E){return"."+m(E).join(".")}P.asCSSSelector=M})(D=e.CSSIcon||(e.CSSIcon={}))}),define(Z[46],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function w(P){return(S,m,I)=>{let M=null,E=null;if(typeof I.value=="function"?(M="value",E=I.value):typeof I.get=="function"&&(M="get",E=I.get),!E)throw new Error("not supported");I[M]=P(E,m)}}e.createDecorator=w;function n(P,S,m){let I=null,M=null;if(typeof m.value=="function"?(I="value",M=m.value,M.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(I="get",M=m.get),!M)throw new Error("not supported");const E=`$memoize$${S}`;m[I]=function(...b){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:M.apply(this,b)}),this[E]}}e.memoize=n;function L(P,S,m){return w((I,M)=>{const E=`$debounce$${M}`,b=`$debounce$result$${M}`;return function(...p){this[b]||(this[b]=m?m():void 0),clearTimeout(this[E]),S&&(this[b]=S(this[b],...p),p=[this[b]]),this[E]=setTimeout(()=>{I.apply(this,p),this[b]=m?m():void 0},P)}})}e.debounce=L;function D(P,S,m){return w((I,M)=>{const E=`$throttle$timer$${M}`,b=`$throttle$result$${M}`,p=`$throttle$lastRun$${M}`,t=`$throttle$pending$${M}`;return function(...h){if(this[b]||(this[b]=m?m():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),S&&(this[b]=S(this[b],...h)),this[t])return;const g=this[p]+P;g<=Date.now()?(this[p]=Date.now(),I.apply(this,[this[b]]),this[b]=m?m():void 0):(this[t]=!0,this[E]=setTimeout(()=>{this[t]=!1,this[p]=Date.now(),I.apply(this,[this[b]]),this[b]=m?m():void 0},g-Date.now()))}})}e.throttle=D}),define(Z[15],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class w{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(u){setTimeout(()=>{throw u.stack?new Error(u.message+`

`+u.stack):u},0)}}addListener(u){return this.listeners.push(u),()=>{this._removeListener(u)}}emit(u){this.listeners.forEach(c=>{c(u)})}_removeListener(u){this.listeners.splice(this.listeners.indexOf(u),1)}setUnexpectedErrorHandler(u){this.unexpectedErrorHandler=u}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(u){this.unexpectedErrorHandler(u),this.emit(u)}onUnexpectedExternalError(u){this.unexpectedErrorHandler(u)}}e.ErrorHandler=w,e.errorHandler=new w;function n(d){e.errorHandler.setUnexpectedErrorHandler(d)}e.setUnexpectedErrorHandler=n;function L(d){m(d)||e.errorHandler.onUnexpectedError(d)}e.onUnexpectedError=L;function D(d){m(d)||e.errorHandler.onUnexpectedExternalError(d)}e.onUnexpectedExternalError=D;function P(d){if(d instanceof Error){let{name:u,message:c}=d;const a=d.stacktrace||d.stack;return{$isError:!0,name:u,message:c,stack:a}}return d}e.transformErrorForSerialization=P;const S="Canceled";function m(d){return d instanceof I?!0:d instanceof Error&&d.name===S&&d.message===S}e.isCancellationError=m;class I extends Error{constructor(){super(S);this.name=this.message}}e.CancellationError=I;function M(){const d=new Error(S);return d.name=d.message,d}e.canceled=M;function E(d){return d?new Error(`Illegal argument: ${d}`):new Error("Illegal argument")}e.illegalArgument=E;function b(d){return d?new Error(`Illegal state: ${d}`):new Error("Illegal state")}e.illegalState=b;function p(d){return d?new Error(`readonly property '${d} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function t(d){const u=new Error(`${d} has been disposed`);return u.name="DISPOSED",u}e.disposed=t;function h(d){return d?d.message?d.message:d.stack?d.stack.split(`
`)[0]:String(d):"Error"}e.getErrorMessage=h;class g extends Error{constructor(u){super("NotImplemented");u&&(this.message=u)}}e.NotImplementedError=g;class y extends Error{constructor(u){super("NotSupported");u&&(this.message=u)}}e.NotSupportedError=y;class k extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=k}),define(Z[30],x([0,1,15]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function n(T,A=0){return T[T.length-(1+A)]}e.tail=n;function L(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}e.tail2=L;function D(T,A,O=(_,j)=>_===j){if(T===A)return!0;if(!T||!A||T.length!==A.length)return!1;for(let _=0,j=T.length;_<j;_++)if(!O(T[_],A[_]))return!1;return!0}e.equals=D;function P(T,A,O){let _=0,j=T.length-1;for(;_<=j;){const ie=(_+j)/2|0,ae=O(T[ie],A);if(ae<0)_=ie+1;else if(ae>0)j=ie-1;else return ie}return-(_+1)}e.binarySearch=P;function S(T,A){let O=0,_=T.length;if(_===0)return 0;for(;O<_;){const j=Math.floor((O+_)/2);A(T[j])?_=j:O=j+1}return O}e.findFirstInSorted=S;function m(T,A,O){if(T=T|0,T>=A.length)throw new TypeError("invalid index");let _=A[Math.floor(A.length*Math.random())],j=[],ie=[],ae=[];for(let ce of A){const ne=O(ce,_);ne<0?j.push(ce):ne>0?ie.push(ce):ae.push(ce)}return T<j.length?m(T,j,O):T<j.length+ae.length?ae[0]:m(T-(j.length+ae.length),ie,O)}e.quickSelect=m;function I(T,A){const O=[];let _;for(const j of T.slice(0).sort(A))!_||A(_[0],j)!==0?(_=[j],O.push(_)):_.push(j);return O}e.groupBy=I;function M(T,A,O){const _=[];function j(ce,ne,le){if(ne===0&&le.length===0)return;const he=_[_.length-1];he&&he.start+he.deleteCount===ce?(he.deleteCount+=ne,he.toInsert.push(...le)):_.push({start:ce,deleteCount:ne,toInsert:le})}let ie=0,ae=0;for(;;){if(ie===T.length){j(ie,0,A.slice(ae));break}if(ae===A.length){j(ie,T.length-ie,[]);break}const ce=T[ie],ne=A[ae],le=O(ce,ne);le===0?(ie+=1,ae+=1):le<0?(j(ie,1,[]),ie+=1):le>0&&(j(ie,0,[ne]),ae+=1)}return _}e.sortedDiff=M;function E(T,A,O){const _=M(T,A,O),j=[],ie=[];for(const ae of _)j.push(...T.slice(ae.start,ae.start+ae.deleteCount)),ie.push(...ae.toInsert);return{removed:j,added:ie}}e.delta=E;function b(T,A,O){if(O===0)return[];const _=T.slice(0,O).sort(A);return t(T,A,_,O,T.length),_}e.top=b;function p(T,A,O,_,j){return O===0?Promise.resolve([]):new Promise((ie,ae)=>{(async()=>{const ce=T.length,ne=T.slice(0,O).sort(A);for(let le=O,he=Math.min(O+_,ce);le<ce;le=he,he=Math.min(he+_,ce)){if(le>O&&await new Promise(we=>setTimeout(we)),j&&j.isCancellationRequested)throw(0,w.canceled)();t(T,A,ne,le,he)}return ne})().then(ie,ae)})}e.topAsync=p;function t(T,A,O,_,j){for(const ie=O.length;_<j;_++){const ae=T[_];if(A(ae,O[ie-1])<0){O.pop();const ce=S(O,ne=>A(ae,ne)<0);O.splice(ce,0,ae)}}}function h(T){return T.filter(A=>!!A)}e.coalesce=h;function g(T){let A=0;for(let O=0;O<T.length;O++)T[O]&&(T[A]=T[O],A+=1);T.length=A}e.coalesceInPlace=g;function y(T,A,O){T.splice(O,0,T.splice(A,1)[0])}e.move=y;function k(T){return!Array.isArray(T)||T.length===0}e.isFalsyOrEmpty=k;function d(T){return Array.isArray(T)&&T.length>0}e.isNonEmptyArray=d;function u(T,A=O=>O){const O=new Set;return T.filter(_=>{const j=A(_);return O.has(j)?!1:(O.add(j),!0)})}e.distinct=u;function c(T){const A=new Set;return O=>{const _=T(O);return A.has(_)?!1:(A.add(_),!0)}}e.uniqueFilter=c;function a(T,A){const O=f(T,A);if(O!==-1)return T[O]}e.findLast=a;function f(T,A){for(let O=T.length-1;O>=0;O--){const _=T[O];if(A(_))return O}return-1}e.lastIndex=f;function s(T,A){return T.length>0?T[0]:A}e.firstOrDefault=s;function i(T,A,O=(_,j)=>_===j){let _=0;for(let j=0,ie=Math.min(T.length,A.length);j<ie&&O(T[j],A[j]);j++)_++;return _}e.commonPrefixLength=i;function r(T){return[].concat(...T)}e.flatten=r;function o(T,A){let O=typeof A=="number"?T:0;typeof A=="number"?O=T:(O=0,A=T);const _=[];if(O<=A)for(let j=O;j<A;j++)_.push(j);else for(let j=O;j>A;j--)_.push(j);return _}e.range=o;function l(T,A,O){return T.reduce((_,j)=>(_[A(j)]=O?O(j):j,_),Object.create(null))}e.index=l;function v(T,A){return T.push(A),()=>C(T,A)}e.insert=v;function C(T,A){const O=T.indexOf(A);if(O>-1)return T.splice(O,1),A}e.remove=C;function R(T,A,O){const _=T.slice(0,A),j=T.slice(A);return _.concat(O,j)}e.arrayInsert=R;function W(T,A){let O;if(typeof A=="number"){let _=A;O=()=>{const j=Math.sin(_++)*179426549;return j-Math.floor(j)}}else O=Math.random;for(let _=T.length-1;_>0;_-=1){const j=Math.floor(O()*(_+1)),ie=T[_];T[_]=T[j],T[j]=ie}}e.shuffle=W;function U(T,A){const O=T.indexOf(A);O>-1&&(T.splice(O,1),T.unshift(A))}e.pushToStart=U;function G(T,A){const O=T.indexOf(A);O>-1&&(T.splice(O,1),T.push(A))}e.pushToEnd=G;function ee(T,A){return Array.isArray(T)?T.map(A):A(T)}e.mapArrayOrNot=ee;function X(T){return Array.isArray(T)?T:[T]}e.asArray=X;function J(T){return T[Math.floor(Math.random()*T.length)]}e.getRandomElement=J;function H(T,A){for(const O of T){const _=A(O);if(_!==void 0)return _}}e.mapFind=H;function B(T,A,O){const _=se(T,A),j=T.length,ie=O.length;T.length=j+ie;for(let ae=j-1;ae>=_;ae--)T[ae+ie]=T[ae];for(let ae=0;ae<ie;ae++)T[ae+_]=O[ae]}e.insertInto=B;function Y(T,A,O,_){const j=se(T,A),ie=T.splice(j,O);return B(T,j,_),ie}e.splice=Y;function se(T,A){return A<0?Math.max(A+T.length,0):Math.min(A,T.length)}function $(T,A){return(O,_)=>A(T(O),T(_))}e.compareBy=$;const q=(T,A)=>T-A;e.numberComparator=q;function Q(T,A){if(T.length===0)return;let O=T[0];for(let _=1;_<T.length;_++){const j=T[_];A(j,O)>0&&(O=j)}return O}e.findMaxBy=Q;function z(T,A){if(T.length===0)return;let O=T[0];for(let _=1;_<T.length;_++){const j=T[_];A(j,O)>=0&&(O=j)}return O}e.findLastMaxBy=z;function F(T,A){return Q(T,(O,_)=>-A(O,_))}e.findMinBy=F;class N{constructor(A){this.items=A,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(A){let O=this.firstIdx;for(;O<this.items.length&&A(this.items[O]);)O++;const _=O===this.firstIdx?null:this.items.slice(this.firstIdx,O);return this.firstIdx=O,_}takeFromEndWhile(A){let O=this.lastIdx;for(;O>=0&&A(this.items[O]);)O--;const _=O===this.lastIdx?null:this.items.slice(O+1,this.lastIdx+1);return this.lastIdx=O,_}peek(){return this.items[this.firstIdx]}dequeue(){const A=this.items[this.firstIdx];return this.firstIdx++,A}takeCount(A){const O=this.items.slice(this.firstIdx,this.firstIdx+A);return this.firstIdx+=A,O}}e.ArrayQueue=N}),define(Z[43],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function w(n){const L=this;let D=!1,P;return function(){return D||(D=!0,P=n.apply(L,arguments)),P}}e.once=w}),define(Z[68],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var w;(function(n){function L(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}n.is=L;const D=Object.freeze([]);function P(){return D}n.empty=P;function*S(c){yield c}n.single=S;function m(c){return c||D}n.from=m;function I(c){return!c||c[Symbol.iterator]().next().done===!0}n.isEmpty=I;function M(c){return c[Symbol.iterator]().next().value}n.first=M;function E(c,a){for(const f of c)if(a(f))return!0;return!1}n.some=E;function b(c,a){for(const f of c)if(a(f))return f}n.find=b;function*p(c,a){for(const f of c)a(f)&&(yield f)}n.filter=p;function*t(c,a){let f=0;for(const s of c)yield a(s,f++)}n.map=t;function*h(...c){for(const a of c)for(const f of a)yield f}n.concat=h;function*g(c){for(const a of c)for(const f of a)yield f}n.concatNested=g;function y(c,a,f){let s=f;for(const i of c)s=a(s,i);return s}n.reduce=y;function*k(c,a,f=c.length){for(a<0&&(a+=c.length),f<0?f+=c.length:f>c.length&&(f=c.length);a<f;a++)yield c[a]}n.slice=k;function d(c,a=Number.POSITIVE_INFINITY){const f=[];if(a===0)return[f,c];const s=c[Symbol.iterator]();for(let i=0;i<a;i++){const r=s.next();if(r.done)return[f,n.empty()];f.push(r.value)}return[f,{[Symbol.iterator](){return s}}]}n.consume=d;function u(c,a,f=(s,i)=>s===i){const s=c[Symbol.iterator](),i=a[Symbol.iterator]();for(;;){const r=s.next(),o=i.next();if(r.done!==o.done)return!1;if(r.done)return!0;if(!f(r.value,o.value))return!1}}n.equals=u})(w=e.Iterable||(e.Iterable={}))}),define(Z[44],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(a){a[a.None=0]="None",a[a.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=2]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",a[a.InvalidUnicode=4]="InvalidUnicode",a[a.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",a[a.InvalidCharacter=6]="InvalidCharacter"})(w=e.ScanError||(e.ScanError={}));var n;(function(a){a[a.OpenBraceToken=1]="OpenBraceToken",a[a.CloseBraceToken=2]="CloseBraceToken",a[a.OpenBracketToken=3]="OpenBracketToken",a[a.CloseBracketToken=4]="CloseBracketToken",a[a.CommaToken=5]="CommaToken",a[a.ColonToken=6]="ColonToken",a[a.NullKeyword=7]="NullKeyword",a[a.TrueKeyword=8]="TrueKeyword",a[a.FalseKeyword=9]="FalseKeyword",a[a.StringLiteral=10]="StringLiteral",a[a.NumericLiteral=11]="NumericLiteral",a[a.LineCommentTrivia=12]="LineCommentTrivia",a[a.BlockCommentTrivia=13]="BlockCommentTrivia",a[a.LineBreakTrivia=14]="LineBreakTrivia",a[a.Trivia=15]="Trivia",a[a.Unknown=16]="Unknown",a[a.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var L;(function(a){a[a.InvalidSymbol=1]="InvalidSymbol",a[a.InvalidNumberFormat=2]="InvalidNumberFormat",a[a.PropertyNameExpected=3]="PropertyNameExpected",a[a.ValueExpected=4]="ValueExpected",a[a.ColonExpected=5]="ColonExpected",a[a.CommaExpected=6]="CommaExpected",a[a.CloseBraceExpected=7]="CloseBraceExpected",a[a.CloseBracketExpected=8]="CloseBracketExpected",a[a.EndOfFileExpected=9]="EndOfFileExpected",a[a.InvalidCommentToken=10]="InvalidCommentToken",a[a.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=12]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",a[a.InvalidUnicode=14]="InvalidUnicode",a[a.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",a[a.InvalidCharacter=16]="InvalidCharacter"})(L=e.ParseErrorCode||(e.ParseErrorCode={}));var D;(function(a){a.DEFAULT={allowTrailingComma:!0}})(D=e.ParseOptions||(e.ParseOptions={}));function P(a,f=!1){let s=0,i=a.length,r="",o=0,l=16,v=0;function C(J){let H=0,B=0;for(;H<J;){const Y=a.charCodeAt(s);if(Y>=48&&Y<=57)B=B*16+Y-48;else if(Y>=65&&Y<=70)B=B*16+Y-65+10;else if(Y>=97&&Y<=102)B=B*16+Y-97+10;else break;s++,H++}return H<J&&(B=-1),B}function R(J){s=J,r="",o=0,l=16,v=0}function W(){const J=s;if(a.charCodeAt(s)===48)s++;else for(s++;s<a.length&&I(a.charCodeAt(s));)s++;if(s<a.length&&a.charCodeAt(s)===46)if(s++,s<a.length&&I(a.charCodeAt(s)))for(s++;s<a.length&&I(a.charCodeAt(s));)s++;else return v=3,a.substring(J,s);let H=s;if(s<a.length&&(a.charCodeAt(s)===69||a.charCodeAt(s)===101))if(s++,(s<a.length&&a.charCodeAt(s)===43||a.charCodeAt(s)===45)&&s++,s<a.length&&I(a.charCodeAt(s))){for(s++;s<a.length&&I(a.charCodeAt(s));)s++;H=s}else v=3;return a.substring(J,H)}function U(){let J="",H=s;for(;;){if(s>=i){J+=a.substring(H,s),v=2;break}const B=a.charCodeAt(s);if(B===34){J+=a.substring(H,s),s++;break}if(B===92){if(J+=a.substring(H,s),s++,s>=i){v=2;break}switch(a.charCodeAt(s++)){case 34:J+='"';break;case 92:J+="\\";break;case 47:J+="/";break;case 98:J+="\b";break;case 102:J+="\f";break;case 110:J+=`
`;break;case 114:J+="\r";break;case 116:J+="	";break;case 117:{const se=C(4);se>=0?J+=String.fromCharCode(se):v=4;break}default:v=5}H=s;continue}if(B>=0&&B<=31)if(m(B)){J+=a.substring(H,s),v=2;break}else v=6;s++}return J}function G(){if(r="",v=0,o=s,s>=i)return o=i,l=17;let J=a.charCodeAt(s);if(S(J)){do s++,r+=String.fromCharCode(J),J=a.charCodeAt(s);while(S(J));return l=15}if(m(J))return s++,r+=String.fromCharCode(J),J===13&&a.charCodeAt(s)===10&&(s++,r+=`
`),l=14;switch(J){case 123:return s++,l=1;case 125:return s++,l=2;case 91:return s++,l=3;case 93:return s++,l=4;case 58:return s++,l=6;case 44:return s++,l=5;case 34:return s++,r=U(),l=10;case 47:{const H=s-1;if(a.charCodeAt(s+1)===47){for(s+=2;s<i&&!m(a.charCodeAt(s));)s++;return r=a.substring(H,s),l=12}if(a.charCodeAt(s+1)===42){s+=2;const B=i-1;let Y=!1;for(;s<B;){if(a.charCodeAt(s)===42&&a.charCodeAt(s+1)===47){s+=2,Y=!0;break}s++}return Y||(s++,v=1),r=a.substring(H,s),l=13}return r+=String.fromCharCode(J),s++,l=16}case 45:if(r+=String.fromCharCode(J),s++,s===i||!I(a.charCodeAt(s)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=W(),l=11;default:for(;s<i&&ee(J);)s++,J=a.charCodeAt(s);if(o!==s){switch(r=a.substring(o,s),r){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return r+=String.fromCharCode(J),s++,l=16}}function ee(J){if(S(J)||m(J))return!1;switch(J){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function X(){let J;do J=G();while(J>=12&&J<=15);return J}return{setPosition:R,getPosition:()=>s,scan:f?X:G,getToken:()=>l,getTokenValue:()=>r,getTokenOffset:()=>o,getTokenLength:()=>s-o,getTokenError:()=>v}}e.createScanner=P;function S(a){return a===32||a===9||a===11||a===12||a===160||a===5760||a>=8192&&a<=8203||a===8239||a===8287||a===12288||a===65279}function m(a){return a===10||a===13||a===8232||a===8233}function I(a){return a>=48&&a<=57}var M;(function(a){a[a.nullCharacter=0]="nullCharacter",a[a.maxAsciiCharacter=127]="maxAsciiCharacter",a[a.lineFeed=10]="lineFeed",a[a.carriageReturn=13]="carriageReturn",a[a.lineSeparator=8232]="lineSeparator",a[a.paragraphSeparator=8233]="paragraphSeparator",a[a.nextLine=133]="nextLine",a[a.space=32]="space",a[a.nonBreakingSpace=160]="nonBreakingSpace",a[a.enQuad=8192]="enQuad",a[a.emQuad=8193]="emQuad",a[a.enSpace=8194]="enSpace",a[a.emSpace=8195]="emSpace",a[a.threePerEmSpace=8196]="threePerEmSpace",a[a.fourPerEmSpace=8197]="fourPerEmSpace",a[a.sixPerEmSpace=8198]="sixPerEmSpace",a[a.figureSpace=8199]="figureSpace",a[a.punctuationSpace=8200]="punctuationSpace",a[a.thinSpace=8201]="thinSpace",a[a.hairSpace=8202]="hairSpace",a[a.zeroWidthSpace=8203]="zeroWidthSpace",a[a.narrowNoBreakSpace=8239]="narrowNoBreakSpace",a[a.ideographicSpace=12288]="ideographicSpace",a[a.mathematicalSpace=8287]="mathematicalSpace",a[a.ogham=5760]="ogham",a[a._=95]="_",a[a.$=36]="$",a[a._0=48]="_0",a[a._1=49]="_1",a[a._2=50]="_2",a[a._3=51]="_3",a[a._4=52]="_4",a[a._5=53]="_5",a[a._6=54]="_6",a[a._7=55]="_7",a[a._8=56]="_8",a[a._9=57]="_9",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.ampersand=38]="ampersand",a[a.asterisk=42]="asterisk",a[a.at=64]="at",a[a.backslash=92]="backslash",a[a.bar=124]="bar",a[a.caret=94]="caret",a[a.closeBrace=125]="closeBrace",a[a.closeBracket=93]="closeBracket",a[a.closeParen=41]="closeParen",a[a.colon=58]="colon",a[a.comma=44]="comma",a[a.dot=46]="dot",a[a.doubleQuote=34]="doubleQuote",a[a.equals=61]="equals",a[a.exclamation=33]="exclamation",a[a.greaterThan=62]="greaterThan",a[a.lessThan=60]="lessThan",a[a.minus=45]="minus",a[a.openBrace=123]="openBrace",a[a.openBracket=91]="openBracket",a[a.openParen=40]="openParen",a[a.percent=37]="percent",a[a.plus=43]="plus",a[a.question=63]="question",a[a.semicolon=59]="semicolon",a[a.singleQuote=39]="singleQuote",a[a.slash=47]="slash",a[a.tilde=126]="tilde",a[a.backspace=8]="backspace",a[a.formFeed=12]="formFeed",a[a.byteOrderMark=65279]="byteOrderMark",a[a.tab=9]="tab",a[a.verticalTab=11]="verticalTab"})(M||(M={}));function E(a,f){const s=[],i=new Object;let r;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function v(C,R,W,U){o.value=C,o.offset=R,o.length=W,o.type=U,o.colonOffset=void 0,r=o}try{d(a,{onObjectBegin:(C,R)=>{if(f<=C)throw i;r=void 0,l=f>C,s.push("")},onObjectProperty:(C,R,W)=>{if(f<R||(v(C,R,W,"property"),s[s.length-1]=C,f<=R+W))throw i},onObjectEnd:(C,R)=>{if(f<=C)throw i;r=void 0,s.pop()},onArrayBegin:(C,R)=>{if(f<=C)throw i;r=void 0,s.push(0)},onArrayEnd:(C,R)=>{if(f<=C)throw i;r=void 0,s.pop()},onLiteralValue:(C,R,W)=>{if(f<R||(v(C,R,W,c(C)),f<=R+W))throw i},onSeparator:(C,R,W)=>{if(f<=R)throw i;if(C===":"&&r&&r.type==="property")r.colonOffset=R,l=!1,r=void 0;else if(C===","){const U=s[s.length-1];typeof U=="number"?s[s.length-1]=U+1:(l=!0,s[s.length-1]=""),r=void 0}}})}catch(C){if(C!==i)throw C}return{path:s,previousNode:r,isAtPropertyKey:l,matches:C=>{let R=0;for(let W=0;R<C.length&&W<s.length;W++)if(C[R]===s[W]||C[R]==="*")R++;else if(C[R]!=="**")return!1;return R===C.length}}}e.getLocation=E;function b(a,f=[],s=D.DEFAULT){let i=null,r=[];const o=[];function l(C){Array.isArray(r)?r.push(C):i!==null&&(r[i]=C)}return d(a,{onObjectBegin:()=>{const C={};l(C),o.push(r),r=C,i=null},onObjectProperty:C=>{i=C},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const C=[];l(C),o.push(r),r=C,i=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:l,onError:(C,R,W)=>{f.push({error:C,offset:R,length:W})}},s),r[0]}e.parse=b;function p(a,f=[],s=D.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(C){i.type==="property"&&(i.length=C-i.offset,i=i.parent)}function o(C){return i.children.push(C),C}d(a,{onObjectBegin:C=>{i=o({type:"object",offset:C,length:-1,parent:i,children:[]})},onObjectProperty:(C,R,W)=>{i=o({type:"property",offset:R,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:C,offset:R,length:W,parent:i})},onObjectEnd:(C,R)=>{i.length=C+R-i.offset,i=i.parent,r(C+R)},onArrayBegin:(C,R)=>{i=o({type:"array",offset:C,length:-1,parent:i,children:[]})},onArrayEnd:(C,R)=>{i.length=C+R-i.offset,i=i.parent,r(C+R)},onLiteralValue:(C,R,W)=>{o({type:c(C),offset:R,length:W,parent:i,value:C}),r(R+W)},onSeparator:(C,R,W)=>{i.type==="property"&&(C===":"?i.colonOffset=R:C===","&&r(R))},onError:(C,R,W)=>{f.push({error:C,offset:R,length:W})}},s);const v=i.children[0];return v&&delete v.parent,v}e.parseTree=p;function t(a,f){if(!a)return;let s=a;for(let i of f)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let r=!1;for(const o of s.children)if(Array.isArray(o.children)&&o.children[0].value===i){s=o.children[1],r=!0;break}if(!r)return}else{const r=i;if(s.type!=="array"||r<0||!Array.isArray(s.children)||r>=s.children.length)return;s=s.children[r]}return s}e.findNodeAtLocation=t;function h(a){if(!a.parent||!a.parent.children)return[];const f=h(a.parent);if(a.parent.type==="property"){const s=a.parent.children[0].value;f.push(s)}else if(a.parent.type==="array"){const s=a.parent.children.indexOf(a);s!==-1&&f.push(s)}return f}e.getNodePath=h;function g(a){switch(a.type){case"array":return a.children.map(g);case"object":{const f=Object.create(null);for(let s of a.children){const i=s.children[1];i&&(f[s.children[0].value]=g(i))}return f}case"null":case"string":case"number":case"boolean":return a.value;default:return}}e.getNodeValue=g;function y(a,f,s=!1){return f>=a.offset&&f<a.offset+a.length||s&&f===a.offset+a.length}e.contains=y;function k(a,f,s=!1){if(y(a,f,s)){const i=a.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=f;r++){const o=k(i[r],f,s);if(o)return o}return a}}e.findNodeAtOffset=k;function d(a,f,s=D.DEFAULT){const i=P(a,!1);function r(N){return N?()=>N(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(N){return N?T=>N(T,i.getTokenOffset(),i.getTokenLength()):()=>!0}const l=r(f.onObjectBegin),v=o(f.onObjectProperty),C=r(f.onObjectEnd),R=r(f.onArrayBegin),W=r(f.onArrayEnd),U=o(f.onLiteralValue),G=o(f.onSeparator),ee=r(f.onComment),X=o(f.onError),J=s&&s.disallowComments,H=s&&s.allowTrailingComma;function B(){for(;;){const N=i.scan();switch(i.getTokenError()){case 4:Y(14);break;case 5:Y(15);break;case 3:Y(13);break;case 1:J||Y(11);break;case 2:Y(12);break;case 6:Y(16);break}switch(N){case 12:case 13:J?Y(10):ee();break;case 16:Y(1);break;case 15:case 14:break;default:return N}}}function Y(N,T=[],A=[]){if(X(N),T.length+A.length>0){let O=i.getToken();for(;O!==17;){if(T.indexOf(O)!==-1){B();break}else if(A.indexOf(O)!==-1)break;O=B()}}}function se(N){const T=i.getTokenValue();return N?U(T):v(T),B(),!0}function $(){switch(i.getToken()){case 11:{let N=0;try{N=JSON.parse(i.getTokenValue()),typeof N!="number"&&(Y(2),N=0)}catch{Y(2)}U(N);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return B(),!0}function q(){return i.getToken()!==10?(Y(3,[],[2,5]),!1):(se(!1),i.getToken()===6?(G(":"),B(),F()||Y(4,[],[2,5])):Y(5,[],[2,5]),!0)}function Q(){l(),B();let N=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(N||Y(4,[],[]),G(","),B(),i.getToken()===2&&H)break}else N&&Y(6,[],[]);q()||Y(4,[],[2,5]),N=!0}return C(),i.getToken()!==2?Y(7,[2],[]):B(),!0}function z(){R(),B();let N=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(N||Y(4,[],[]),G(","),B(),i.getToken()===4&&H)break}else N&&Y(6,[],[]);F()||Y(4,[],[4,5]),N=!0}return W(),i.getToken()!==4?Y(8,[4],[]):B(),!0}function F(){switch(i.getToken()){case 3:return z();case 1:return Q();case 10:return se(!0);default:return $()}}return B(),i.getToken()===17?s.allowEmptyContent?!0:(Y(4,[],[]),!1):F()?(i.getToken()!==17&&Y(9,[],[]),!0):(Y(4,[],[]),!1)}e.visit=d;function u(a,f){let s=P(a),i=[],r,o=0,l;do switch(l=s.getPosition(),r=s.scan(),r){case 12:case 13:case 17:o!==l&&i.push(a.substring(o,l)),f!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,f)),o=s.getPosition();break}while(r!==17);return i.join("")}e.stripComments=u;function c(a){switch(typeof a){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(a){if(Array.isArray(a))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(Z[108],x([0,1,44]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(I,M,E){let b,p,t,h,g;if(M){for(h=M.offset,g=h+M.length,t=h;t>0&&!m(I,t-1);)t--;let l=g;for(;l<I.length&&!m(I,l);)l++;p=I.substring(t,l),b=P(p,E)}else p=I,b=0,t=0,h=0,g=I.length;const y=S(E,I);let k=!1,d=0,u;E.insertSpaces?u=D(" ",E.tabSize||4):u="	";const c=(0,w.createScanner)(p,!1);let a=!1;function f(){return y+D(u,b+d)}function s(){let l=c.scan();for(k=!1;l===15||l===14;)k=k||l===14,l=c.scan();return a=l===16||c.getTokenError()!==0,l}const i=[];function r(l,v,C){!a&&v<g&&C>h&&I.substring(v,C)!==l&&i.push({offset:v,length:C-v,content:l})}let o=s();if(o!==17){const l=c.getTokenOffset()+t,v=D(u,b);r(v,t,l)}for(;o!==17;){let l=c.getTokenOffset()+c.getTokenLength()+t,v=s(),C="";for(;!k&&(v===12||v===13);){const W=c.getTokenOffset()+t;r(" ",l,W),l=c.getTokenOffset()+c.getTokenLength()+t,C=v===12?f():"",v=s()}if(v===2)o!==1&&(d--,C=f());else if(v===4)o!==3&&(d--,C=f());else{switch(o){case 3:case 1:d++,C=f();break;case 5:case 12:C=f();break;case 13:k?C=f():C=" ";break;case 6:C=" ";break;case 10:if(v===6){C="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?C=" ":v!==5&&v!==17&&(a=!0);break;case 16:a=!0;break}k&&(v===12||v===13)&&(C=f())}const R=c.getTokenOffset()+t;r(C,l,R),o=v}return i}e.format=n;function L(I,M){const E=JSON.stringify(I,void 0,M.insertSpaces?M.tabSize||4:"	");return M.eol!==void 0?E.replace(/\r\n|\r|\n/g,M.eol):E}e.toFormattedString=L;function D(I,M){let E="";for(let b=0;b<M;b++)E+=I;return E}function P(I,M){let E=0,b=0;const p=M.tabSize||4;for(;E<I.length;){const t=I.charAt(E);if(t===" ")b++;else if(t==="	")b+=p;else break;E++}return Math.floor(b/p)}function S(I,M){for(let E=0;E<M.length;E++){const b=M.charAt(E);if(b==="\r")return E+1<M.length&&M.charAt(E+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return I&&I.eol||`
`}e.getEOL=S;function m(I,M){return`\r
`.indexOf(I.charAt(M))!==-1}e.isEOL=m}),define(Z[109],x([0,1,44,108]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function L(I,M,E){return D(I,M,void 0,E)}e.removeProperty=L;function D(I,M,E,b,p){const t=M.slice(),h=[],g=(0,w.parseTree)(I,h);let y,k;for(;t.length>0&&(k=t.pop(),y=(0,w.findNodeAtLocation)(g,t),y===void 0&&E!==void 0);)typeof k=="string"?E={[k]:E}:E=[E];if(y)if(y.type==="object"&&typeof k=="string"&&Array.isArray(y.children)){const d=(0,w.findNodeAtLocation)(y,[k]);if(d!==void 0)if(E===void 0){if(!d.parent)throw new Error("Malformed AST");const u=y.children.indexOf(d.parent);let c,a=d.parent.offset+d.parent.length;if(u>0){const f=y.children[u-1];c=f.offset+f.length}else c=y.offset+1,y.children.length>1&&(a=y.children[1].offset);return P(I,{offset:c,length:a-c,content:""},b)}else return P(I,{offset:d.offset,length:d.length,content:JSON.stringify(E)},b);else{if(E===void 0)return[];const u=`${JSON.stringify(k)}: ${JSON.stringify(E)}`,c=p?p(y.children.map(f=>f.children[0].value)):y.children.length;let a;if(c>0){const f=y.children[c-1];a={offset:f.offset+f.length,length:0,content:","+u}}else y.children.length===0?a={offset:y.offset+1,length:0,content:u}:a={offset:y.offset+1,length:0,content:u+","};return P(I,a,b)}}else if(y.type==="array"&&typeof k=="number"&&Array.isArray(y.children))if(E!==void 0){const d=`${JSON.stringify(E)}`;let u;if(y.children.length===0||k===0)u={offset:y.offset+1,length:0,content:y.children.length===0?d:d+","};else{const c=k===-1||k>y.children.length?y.children.length:k,a=y.children[c-1];u={offset:a.offset+a.length,length:0,content:","+d}}return P(I,u,b)}else{const d=k,u=y.children[d];let c;if(y.children.length===1)c={offset:y.offset+1,length:y.length-2,content:""};else if(y.children.length-1===d){const a=y.children[d-1],f=a.offset+a.length,s=y.offset+y.length;c={offset:f,length:s-2-f,content:""}}else c={offset:u.offset,length:y.children[d+1].offset-u.offset,content:""};return P(I,c,b)}else throw new Error(`Can not add ${typeof k!="number"?"index":"property"} to parent of type ${y.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return P(I,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(E)},b)}}e.setProperty=D;function P(I,M,E){let b=S(I,M),p=M.offset,t=M.offset+M.content.length;if(M.length===0||M.content.length===0){for(;p>0&&!(0,n.isEOL)(b,p-1);)p--;for(;t<b.length&&!(0,n.isEOL)(b,t);)t++}const h=(0,n.format)(b,{offset:p,length:t-p},E);for(let y=h.length-1;y>=0;y--){const k=h[y];b=S(b,k),p=Math.min(p,k.offset),t=Math.max(t,k.offset+k.length),t+=k.content.length-k.length}const g=I.length-(b.length-t)-p;return[{offset:p,length:g,content:b.substring(p,t)}]}e.withFormatting=P;function S(I,M){return I.substring(0,M.offset)+M.content+I.substring(M.offset+M.length)}e.applyEdit=S;function m(I,M){let E=M.slice(0).sort((p,t)=>{const h=p.offset-t.offset;return h===0?p.length-t.length:h}),b=I.length;for(let p=E.length-1;p>=0;p--){let t=E[p];if(t.offset+t.length<=b)I=S(I,t);else throw new Error("Overlapping edit");b=t.offset}return I}e.applyEdits=m}),define(Z[83],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=e.EVENT_KEY_CODE_MAP=e.ScanCode=e.KeyCode=void 0;var w;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.Clear=126]="Clear",t[t.MAX_VALUE=127]="MAX_VALUE"})(w=e.KeyCode||(e.KeyCode={}));var n;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.None=0]="None",t[t.Hyper=1]="Hyper",t[t.Super=2]="Super",t[t.Fn=3]="Fn",t[t.FnLock=4]="FnLock",t[t.Suspend=5]="Suspend",t[t.Resume=6]="Resume",t[t.Turbo=7]="Turbo",t[t.Sleep=8]="Sleep",t[t.WakeUp=9]="WakeUp",t[t.KeyA=10]="KeyA",t[t.KeyB=11]="KeyB",t[t.KeyC=12]="KeyC",t[t.KeyD=13]="KeyD",t[t.KeyE=14]="KeyE",t[t.KeyF=15]="KeyF",t[t.KeyG=16]="KeyG",t[t.KeyH=17]="KeyH",t[t.KeyI=18]="KeyI",t[t.KeyJ=19]="KeyJ",t[t.KeyK=20]="KeyK",t[t.KeyL=21]="KeyL",t[t.KeyM=22]="KeyM",t[t.KeyN=23]="KeyN",t[t.KeyO=24]="KeyO",t[t.KeyP=25]="KeyP",t[t.KeyQ=26]="KeyQ",t[t.KeyR=27]="KeyR",t[t.KeyS=28]="KeyS",t[t.KeyT=29]="KeyT",t[t.KeyU=30]="KeyU",t[t.KeyV=31]="KeyV",t[t.KeyW=32]="KeyW",t[t.KeyX=33]="KeyX",t[t.KeyY=34]="KeyY",t[t.KeyZ=35]="KeyZ",t[t.Digit1=36]="Digit1",t[t.Digit2=37]="Digit2",t[t.Digit3=38]="Digit3",t[t.Digit4=39]="Digit4",t[t.Digit5=40]="Digit5",t[t.Digit6=41]="Digit6",t[t.Digit7=42]="Digit7",t[t.Digit8=43]="Digit8",t[t.Digit9=44]="Digit9",t[t.Digit0=45]="Digit0",t[t.Enter=46]="Enter",t[t.Escape=47]="Escape",t[t.Backspace=48]="Backspace",t[t.Tab=49]="Tab",t[t.Space=50]="Space",t[t.Minus=51]="Minus",t[t.Equal=52]="Equal",t[t.BracketLeft=53]="BracketLeft",t[t.BracketRight=54]="BracketRight",t[t.Backslash=55]="Backslash",t[t.IntlHash=56]="IntlHash",t[t.Semicolon=57]="Semicolon",t[t.Quote=58]="Quote",t[t.Backquote=59]="Backquote",t[t.Comma=60]="Comma",t[t.Period=61]="Period",t[t.Slash=62]="Slash",t[t.CapsLock=63]="CapsLock",t[t.F1=64]="F1",t[t.F2=65]="F2",t[t.F3=66]="F3",t[t.F4=67]="F4",t[t.F5=68]="F5",t[t.F6=69]="F6",t[t.F7=70]="F7",t[t.F8=71]="F8",t[t.F9=72]="F9",t[t.F10=73]="F10",t[t.F11=74]="F11",t[t.F12=75]="F12",t[t.PrintScreen=76]="PrintScreen",t[t.ScrollLock=77]="ScrollLock",t[t.Pause=78]="Pause",t[t.Insert=79]="Insert",t[t.Home=80]="Home",t[t.PageUp=81]="PageUp",t[t.Delete=82]="Delete",t[t.End=83]="End",t[t.PageDown=84]="PageDown",t[t.ArrowRight=85]="ArrowRight",t[t.ArrowLeft=86]="ArrowLeft",t[t.ArrowDown=87]="ArrowDown",t[t.ArrowUp=88]="ArrowUp",t[t.NumLock=89]="NumLock",t[t.NumpadDivide=90]="NumpadDivide",t[t.NumpadMultiply=91]="NumpadMultiply",t[t.NumpadSubtract=92]="NumpadSubtract",t[t.NumpadAdd=93]="NumpadAdd",t[t.NumpadEnter=94]="NumpadEnter",t[t.Numpad1=95]="Numpad1",t[t.Numpad2=96]="Numpad2",t[t.Numpad3=97]="Numpad3",t[t.Numpad4=98]="Numpad4",t[t.Numpad5=99]="Numpad5",t[t.Numpad6=100]="Numpad6",t[t.Numpad7=101]="Numpad7",t[t.Numpad8=102]="Numpad8",t[t.Numpad9=103]="Numpad9",t[t.Numpad0=104]="Numpad0",t[t.NumpadDecimal=105]="NumpadDecimal",t[t.IntlBackslash=106]="IntlBackslash",t[t.ContextMenu=107]="ContextMenu",t[t.Power=108]="Power",t[t.NumpadEqual=109]="NumpadEqual",t[t.F13=110]="F13",t[t.F14=111]="F14",t[t.F15=112]="F15",t[t.F16=113]="F16",t[t.F17=114]="F17",t[t.F18=115]="F18",t[t.F19=116]="F19",t[t.F20=117]="F20",t[t.F21=118]="F21",t[t.F22=119]="F22",t[t.F23=120]="F23",t[t.F24=121]="F24",t[t.Open=122]="Open",t[t.Help=123]="Help",t[t.Select=124]="Select",t[t.Again=125]="Again",t[t.Undo=126]="Undo",t[t.Cut=127]="Cut",t[t.Copy=128]="Copy",t[t.Paste=129]="Paste",t[t.Find=130]="Find",t[t.AudioVolumeMute=131]="AudioVolumeMute",t[t.AudioVolumeUp=132]="AudioVolumeUp",t[t.AudioVolumeDown=133]="AudioVolumeDown",t[t.NumpadComma=134]="NumpadComma",t[t.IntlRo=135]="IntlRo",t[t.KanaMode=136]="KanaMode",t[t.IntlYen=137]="IntlYen",t[t.Convert=138]="Convert",t[t.NonConvert=139]="NonConvert",t[t.Lang1=140]="Lang1",t[t.Lang2=141]="Lang2",t[t.Lang3=142]="Lang3",t[t.Lang4=143]="Lang4",t[t.Lang5=144]="Lang5",t[t.Abort=145]="Abort",t[t.Props=146]="Props",t[t.NumpadParenLeft=147]="NumpadParenLeft",t[t.NumpadParenRight=148]="NumpadParenRight",t[t.NumpadBackspace=149]="NumpadBackspace",t[t.NumpadMemoryStore=150]="NumpadMemoryStore",t[t.NumpadMemoryRecall=151]="NumpadMemoryRecall",t[t.NumpadMemoryClear=152]="NumpadMemoryClear",t[t.NumpadMemoryAdd=153]="NumpadMemoryAdd",t[t.NumpadMemorySubtract=154]="NumpadMemorySubtract",t[t.NumpadClear=155]="NumpadClear",t[t.NumpadClearEntry=156]="NumpadClearEntry",t[t.ControlLeft=157]="ControlLeft",t[t.ShiftLeft=158]="ShiftLeft",t[t.AltLeft=159]="AltLeft",t[t.MetaLeft=160]="MetaLeft",t[t.ControlRight=161]="ControlRight",t[t.ShiftRight=162]="ShiftRight",t[t.AltRight=163]="AltRight",t[t.MetaRight=164]="MetaRight",t[t.BrightnessUp=165]="BrightnessUp",t[t.BrightnessDown=166]="BrightnessDown",t[t.MediaPlay=167]="MediaPlay",t[t.MediaRecord=168]="MediaRecord",t[t.MediaFastForward=169]="MediaFastForward",t[t.MediaRewind=170]="MediaRewind",t[t.MediaTrackNext=171]="MediaTrackNext",t[t.MediaTrackPrevious=172]="MediaTrackPrevious",t[t.MediaStop=173]="MediaStop",t[t.Eject=174]="Eject",t[t.MediaPlayPause=175]="MediaPlayPause",t[t.MediaSelect=176]="MediaSelect",t[t.LaunchMail=177]="LaunchMail",t[t.LaunchApp2=178]="LaunchApp2",t[t.LaunchApp1=179]="LaunchApp1",t[t.SelectTask=180]="SelectTask",t[t.LaunchScreenSaver=181]="LaunchScreenSaver",t[t.BrowserSearch=182]="BrowserSearch",t[t.BrowserHome=183]="BrowserHome",t[t.BrowserBack=184]="BrowserBack",t[t.BrowserForward=185]="BrowserForward",t[t.BrowserStop=186]="BrowserStop",t[t.BrowserRefresh=187]="BrowserRefresh",t[t.BrowserFavorites=188]="BrowserFavorites",t[t.ZoomToggle=189]="ZoomToggle",t[t.MailReply=190]="MailReply",t[t.MailForward=191]="MailForward",t[t.MailSend=192]="MailSend",t[t.MAX_VALUE=193]="MAX_VALUE"})(n=e.ScanCode||(e.ScanCode={}));class L{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(h,g){this._keyCodeToStr[h]=g,this._strToKeyCode[g.toLowerCase()]=h}keyCodeToStr(h){return this._keyCodeToStr[h]}strToKeyCode(h){return this._strToKeyCode[h.toLowerCase()]||0}}const D=new L,P=new L,S=new L;e.EVENT_KEY_CODE_MAP=new Array(230),e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const m=[],I=Object.create(null),M=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:t=>M[t]||0,toEnum:t=>I[t]||0,toString:t=>m[t]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)e.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=127;t++)e.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",h=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]];let g=[],y=[];for(const k of h){const[d,u,c,a,f,s,i,r,o,l]=k;if(y[c]||(y[c]=!0,m[c]=a,I[a]=c,M[a.toLowerCase()]=c,u&&(e.IMMUTABLE_CODE_TO_KEY_CODE[c]=f,f!==0&&f!==3&&f!==5&&f!==4&&f!==6&&f!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[f]=c))),!g[f]){if(g[f]=!0,!s)throw new Error(`String representation missing for key code ${f} around scan code ${a}`);D.define(f,s),P.define(f,o||s),S.define(f,l||o||s)}i&&(e.EVENT_KEY_CODE_MAP[i]=f),r&&(e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[r]=f)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var E;(function(t){function h(c){return D.keyCodeToStr(c)}t.toString=h;function g(c){return D.strToKeyCode(c)}t.fromString=g;function y(c){return P.keyCodeToStr(c)}t.toUserSettingsUS=y;function k(c){return S.keyCodeToStr(c)}t.toUserSettingsGeneral=k;function d(c){return P.strToKeyCode(c)||S.strToKeyCode(c)}t.fromUserSettings=d;function u(c){if(c>=93&&c<=108)return null;switch(c){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return D.keyCodeToStr(c)}t.toElectronAccelerator=u})(E=e.KeyCodeUtils||(e.KeyCodeUtils={}));var b;(function(t){t[t.CtrlCmd=2048]="CtrlCmd",t[t.Shift=1024]="Shift",t[t.Alt=512]="Alt",t[t.WinCtrl=256]="WinCtrl"})(b=e.KeyMod||(e.KeyMod={}));function p(t,h){const g=(h&65535)<<16>>>0;return(t|g)>>>0}e.KeyChord=p}),define(Z[59],x([0,1,15]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ScanCodeBinding=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=void 0;var n;(function(E){E[E.CtrlCmd=2048]="CtrlCmd",E[E.Shift=1024]="Shift",E[E.Alt=512]="Alt",E[E.WinCtrl=256]="WinCtrl",E[E.KeyCode=255]="KeyCode"})(n||(n={}));function L(E,b){if(E===0)return null;const p=(E&65535)>>>0,t=(E&4294901760)>>>16;return t!==0?new S([D(p,b),D(t,b)]):new S([D(p,b)])}e.createKeybinding=L;function D(E,b){const p=!!(E&2048),t=!!(E&256),h=b===2?t:p,g=!!(E&1024),y=!!(E&512),k=b===2?p:t,d=E&255;return new P(h,g,y,k,d)}e.createSimpleKeybinding=D;class P{constructor(b,p,t,h,g){this.ctrlKey=b,this.shiftKey=p,this.altKey=t,this.metaKey=h,this.keyCode=g}equals(b){return this.ctrlKey===b.ctrlKey&&this.shiftKey===b.shiftKey&&this.altKey===b.altKey&&this.metaKey===b.metaKey&&this.keyCode===b.keyCode}getHashCode(){const b=this.ctrlKey?"1":"0",p=this.shiftKey?"1":"0",t=this.altKey?"1":"0",h=this.metaKey?"1":"0";return`${b}${p}${t}${h}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new S([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=P;class S{constructor(b){if(b.length===0)throw(0,w.illegalArgument)("parts");this.parts=b}getHashCode(){let b="";for(let p=0,t=this.parts.length;p<t;p++)p!==0&&(b+=";"),b+=this.parts[p].getHashCode();return b}equals(b){if(b===null||this.parts.length!==b.parts.length)return!1;for(let p=0;p<this.parts.length;p++)if(!this.parts[p].equals(b.parts[p]))return!1;return!0}}e.ChordKeybinding=S;class m{constructor(b,p,t,h,g){this.ctrlKey=b,this.shiftKey=p,this.altKey=t,this.metaKey=h,this.scanCode=g}equals(b){return this.ctrlKey===b.ctrlKey&&this.shiftKey===b.shiftKey&&this.altKey===b.altKey&&this.metaKey===b.metaKey&&this.scanCode===b.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=m;class I{constructor(b,p,t,h,g,y){this.ctrlKey=b,this.shiftKey=p,this.altKey=t,this.metaKey=h,this.keyLabel=g,this.keyAriaLabel=y}}e.ResolvedKeybindingPart=I;class M{}e.ResolvedKeybinding=M}),define(Z[110],x([0,1,83,59]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class L{static _readModifiers(P){P=P.toLowerCase().trim();let S=!1,m=!1,I=!1,M=!1,E;do E=!1,/^ctrl(\+|\-)/.test(P)&&(S=!0,P=P.substr("ctrl-".length),E=!0),/^shift(\+|\-)/.test(P)&&(m=!0,P=P.substr("shift-".length),E=!0),/^alt(\+|\-)/.test(P)&&(I=!0,P=P.substr("alt-".length),E=!0),/^meta(\+|\-)/.test(P)&&(M=!0,P=P.substr("meta-".length),E=!0),/^win(\+|\-)/.test(P)&&(M=!0,P=P.substr("win-".length),E=!0),/^cmd(\+|\-)/.test(P)&&(M=!0,P=P.substr("cmd-".length),E=!0);while(E);let b;const p=P.indexOf(" ");return p>0?(b=P.substring(0,p),P=P.substring(p)):(b=P,P=""),{remains:P,ctrl:S,shift:m,alt:I,meta:M,key:b}}static parseSimpleKeybinding(P){const S=this._readModifiers(P),m=w.KeyCodeUtils.fromUserSettings(S.key);return[new n.SimpleKeybinding(S.ctrl,S.shift,S.alt,S.meta,m),S.remains]}static parseKeybinding(P,S){if(!P)return null;const m=[];let I;do[I,P]=this.parseSimpleKeybinding(P),m.push(I);while(P.length>0);return new n.ChordKeybinding(m)}static parseSimpleUserBinding(P){const S=this._readModifiers(P),m=S.key.match(/^\[([^\]]+)\]$/);if(m){const M=m[1],E=w.ScanCodeUtils.lowerCaseToEnum(M);return[new n.ScanCodeBinding(S.ctrl,S.shift,S.alt,S.meta,E),S.remains]}const I=w.KeyCodeUtils.fromUserSettings(S.key);return[new n.SimpleKeybinding(S.ctrl,S.shift,S.alt,S.meta,I),S.remains]}static parseUserBinding(P){if(!P)return[];const S=[];let m;for(;P.length>0;)[m,P]=this.parseSimpleUserBinding(P),S.push(m);return S}}e.KeybindingParser=L}),define(Z[111],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class w{constructor(L){this.executor=L,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(L){this._error=L}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(L){return new w(()=>L(this.getValue()))}}e.Lazy=w}),define(Z[3],x([0,1,43,68]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const L=!1;let D=null;function P(r){D=r}if(e.setDisposableTracker=P,L){const r="__is_disposable_tracked__";P(new class{trackDisposable(o){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[r]||console.log(l)},3e3)}setParent(o,l){if(o&&o!==k.None)try{o[r]=!0}catch{}}markAsDisposed(o){if(o&&o!==k.None)try{o[r]=!0}catch{}}markAsSingleton(o){}})}function S(r){return D?.trackDisposable(r),r}function m(r){D?.markAsDisposed(r)}function I(r,o){D?.setParent(r,o)}function M(r,o){if(!!D)for(const l of r)D.setParent(l,o)}function E(r){return D?.markAsSingleton(r),r}e.markAsSingleton=E;class b extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=b;function p(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=p;function t(r){if(n.Iterable.is(r)){let o=[];for(const l of r)if(l)try{l.dispose()}catch(v){o.push(v)}if(o.length===1)throw o[0];if(o.length>1)throw new b(o);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=t;function h(...r){const o=g(()=>t(r));return M(r,o),o}e.combinedDisposable=h;function g(r){const o=S({dispose:(0,w.once)(()=>{m(o),r()})});return o}e.toDisposable=g;class y{constructor(){this._toDispose=new Set,this._isDisposed=!1,S(this)}dispose(){this._isDisposed||(m(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{t(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return I(o,this),this._isDisposed?y.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=y,y.DISABLE_DISPOSED_WARNING=!1;class k{constructor(){this._store=new y,S(this),I(this._store,this)}dispose(){m(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=k,k.None=Object.freeze({dispose(){}});class d{constructor(){this._isDisposed=!1,S(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&I(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,m(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&I(o,null),o}}e.MutableDisposable=d;class u{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=u;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,S(this)}set(o){let l=o;return this.unset=()=>l=void 0,this.isset=()=>l!==void 0,this.dispose=()=>{l&&(l(),l=void 0,m(this))},this}}e.SafeDisposable=c;class a{constructor(){this.references=new Map}acquire(o,...l){let v=this.references.get(o);v||(v={counter:0,object:this.createReferencedObject(o,...l)},this.references.set(o,v));const{object:C}=v,R=(0,w.once)(()=>{--v.counter==0&&(this.destroyReferencedObject(o,v.object),this.references.delete(o))});return v.counter++,{object:C,dispose:R}}}e.ReferenceCollection=a;class f{constructor(o){this.referenceCollection=o}async acquire(o,...l){const v=this.referenceCollection.acquire(o,...l);try{return{object:await v.object,dispose:()=>v.dispose()}}catch(C){throw v.dispose(),C}}}e.AsyncReferenceCollection=f;class s{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=s;function i(r){const o=new y;try{r(o)}finally{o.dispose()}}e.disposeOnReturn=i}),define(Z[112],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class w{constructor(D){this.element=D,this.next=w.Undefined,this.prev=w.Undefined}}w.Undefined=new w(void 0);class n{constructor(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===w.Undefined}clear(){let D=this._first;for(;D!==w.Undefined;){const P=D.next;D.prev=w.Undefined,D.next=w.Undefined,D=P}this._first=w.Undefined,this._last=w.Undefined,this._size=0}unshift(D){return this._insert(D,!1)}push(D){return this._insert(D,!0)}_insert(D,P){const S=new w(D);if(this._first===w.Undefined)this._first=S,this._last=S;else if(P){const I=this._last;this._last=S,S.prev=I,I.next=S}else{const I=this._first;this._first=S,S.next=I,I.prev=S}this._size+=1;let m=!1;return()=>{m||(m=!0,this._remove(S))}}shift(){if(this._first!==w.Undefined){const D=this._first.element;return this._remove(this._first),D}}pop(){if(this._last!==w.Undefined){const D=this._last.element;return this._remove(this._last),D}}_remove(D){if(D.prev!==w.Undefined&&D.next!==w.Undefined){const P=D.prev;P.next=D.next,D.next.prev=P}else D.prev===w.Undefined&&D.next===w.Undefined?(this._first=w.Undefined,this._last=w.Undefined):D.next===w.Undefined?(this._last=this._last.prev,this._last.next=w.Undefined):D.prev===w.Undefined&&(this._first=this._first.next,this._first.prev=w.Undefined);this._size-=1}*[Symbol.iterator](){let D=this._first;for(;D!==w.Undefined;)yield D.element,D=D.next}}e.LinkedList=n}),function(){function V(L){const D=[];typeof L=="number"&&D.push("code/timeOrigin",L);function P(m){D.push(m,Date.now())}function S(){const m=[];for(let I=0;I<D.length;I+=2)m.push({name:D[I],startTime:D[I+1]});return m}return{mark:P,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?V():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const P of performance.getEntriesByType("mark"))D.push({name:P.name,startTime:Math.round(L+P.startTime)});return D}};if(typeof process=="object"){const L=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return V(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),V()}function w(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=w(n))}(),define(Z[2],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const w="en";let n=!1,L=!1,D=!1,P=!1,S=!1,m=!1,I=!1,M=!1,E=!1,b,p=w,t,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?g=e.globals.vscode.process:typeof process!="undefined"&&(g=process);const y=typeof g?.versions?.electron=="string",k=y&&g?.type==="renderer";if(e.isElectronSandboxed=k&&g?.sandboxed,typeof navigator=="object"&&!k)h=navigator.userAgent,n=h.indexOf("Windows")>=0,L=h.indexOf("Macintosh")>=0,M=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=h.indexOf("Linux")>=0,m=!0,b=navigator.language,p=b;else if(typeof g=="object"){n=g.platform==="win32",L=g.platform==="darwin",D=g.platform==="linux",P=D&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,I=y,E=!!g.env.CI||!!g.env.BUILD_ARTIFACTSTAGINGDIRECTORY,b=w,p=w;const o=g.env.VSCODE_NLS_CONFIG;if(o)try{const l=JSON.parse(o),v=l.availableLanguages["*"];b=l.locale,p=v||w,t=l._translationsConfigFile}catch{}S=!0}else console.error("Unable to resolve platform.");var d;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(d=e.Platform||(e.Platform={}));function u(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=u;let c=0;L?c=1:n?c=3:D&&(c=2),e.isWindows=n,e.isMacintosh=L,e.isLinux=D,e.isLinuxSnap=P,e.isNative=S,e.isElectron=I,e.isWeb=m,e.isIOS=M,e.isCI=E,e.platform=c,e.userAgent=h,e.language=p;var a;(function(o){function l(){return e.language}o.value=l;function v(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=v;function C(){return e.language==="en"}o.isDefault=C})(a=e.Language||(e.Language={})),e.locale=b,e.translationsConfigFile=t,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let o=[];e.globals.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let C=0,R=o.length;C<R;C++){const W=o[C];if(W.id===v.data.vscodeScheduleAsyncWork){o.splice(C,1),W.callback();return}}});let l=0;return v=>{const C=++l;o.push({id:C,callback:v}),e.globals.postMessage({vscodeScheduleAsyncWork:C},"*")}}return o=>setTimeout(o)})();var f;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(f=e.OperatingSystem||(e.OperatingSystem={})),e.OS=L||M?2:n?1:3;let s=!0,i=!1;function r(){if(!i){i=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,s=new Uint16Array(o.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=r,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Z[36],x([0,1,2]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof w.globals.vscode!="undefined"&&typeof w.globals.vscode.process!="undefined"){const L=w.globals.vscode.process;n={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return w.isWindows?"win32":w.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(Z[7],x([0,1,36]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,L=97,D=90,P=122,S=46,m=47,I=92,M=58,E=63;class b extends Error{constructor(u,c,a){let f;typeof c=="string"&&c.indexOf("not ")===0?(f="must not be",c=c.replace(/^not /,"")):f="must be";const s=u.indexOf(".")!==-1?"property":"argument";let i=`The "${u}" ${s} ${f} of type ${c}`;i+=`. Received type ${typeof a}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function p(d,u){if(typeof d!="string")throw new b(u,"string",d)}function t(d){return d===m||d===I}function h(d){return d===m}function g(d){return d>=n&&d<=D||d>=L&&d<=P}function y(d,u,c,a){let f="",s=0,i=-1,r=0,o=0;for(let l=0;l<=d.length;++l){if(l<d.length)o=d.charCodeAt(l);else{if(a(o))break;o=m}if(a(o)){if(!(i===l-1||r===1))if(r===2){if(f.length<2||s!==2||f.charCodeAt(f.length-1)!==S||f.charCodeAt(f.length-2)!==S){if(f.length>2){const v=f.lastIndexOf(c);v===-1?(f="",s=0):(f=f.slice(0,v),s=f.length-1-f.lastIndexOf(c)),i=l,r=0;continue}else if(f.length!==0){f="",s=0,i=l,r=0;continue}}u&&(f+=f.length>0?`${c}..`:"..",s=2)}else f.length>0?f+=`${c}${d.slice(i+1,l)}`:f=d.slice(i+1,l),s=l-i-1;i=l,r=0}else o===S&&r!==-1?++r:r=-1}return f}function k(d,u){if(u===null||typeof u!="object")throw new b("pathObject","Object",u);const c=u.dir||u.root,a=u.base||`${u.name||""}${u.ext||""}`;return c?c===u.root?`${c}${a}`:`${c}${d}${a}`:a}e.win32={resolve(...d){let u="",c="",a=!1;for(let f=d.length-1;f>=-1;f--){let s;if(f>=0){if(s=d[f],p(s,"path"),s.length===0)continue}else u.length===0?s=w.cwd():(s=w.env[`=${u}`]||w.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==u.toLowerCase()&&s.charCodeAt(2)===I)&&(s=`${u}\\`));const i=s.length;let r=0,o="",l=!1;const v=s.charCodeAt(0);if(i===1)t(v)&&(r=1,l=!0);else if(t(v))if(l=!0,t(s.charCodeAt(1))){let C=2,R=C;for(;C<i&&!t(s.charCodeAt(C));)C++;if(C<i&&C!==R){const W=s.slice(R,C);for(R=C;C<i&&t(s.charCodeAt(C));)C++;if(C<i&&C!==R){for(R=C;C<i&&!t(s.charCodeAt(C));)C++;(C===i||C!==R)&&(o=`\\\\${W}\\${s.slice(R,C)}`,r=C)}}}else r=1;else g(v)&&s.charCodeAt(1)===M&&(o=s.slice(0,2),r=2,i>2&&t(s.charCodeAt(2))&&(l=!0,r=3));if(o.length>0)if(u.length>0){if(o.toLowerCase()!==u.toLowerCase())continue}else u=o;if(a){if(u.length>0)break}else if(c=`${s.slice(r)}\\${c}`,a=l,l&&u.length>0)break}return c=y(c,!a,"\\",t),a?`${u}\\${c}`:`${u}${c}`||"."},normalize(d){p(d,"path");const u=d.length;if(u===0)return".";let c=0,a,f=!1;const s=d.charCodeAt(0);if(u===1)return h(s)?"\\":d;if(t(s))if(f=!0,t(d.charCodeAt(1))){let r=2,o=r;for(;r<u&&!t(d.charCodeAt(r));)r++;if(r<u&&r!==o){const l=d.slice(o,r);for(o=r;r<u&&t(d.charCodeAt(r));)r++;if(r<u&&r!==o){for(o=r;r<u&&!t(d.charCodeAt(r));)r++;if(r===u)return`\\\\${l}\\${d.slice(o)}\\`;r!==o&&(a=`\\\\${l}\\${d.slice(o,r)}`,c=r)}}}else c=1;else g(s)&&d.charCodeAt(1)===M&&(a=d.slice(0,2),c=2,u>2&&t(d.charCodeAt(2))&&(f=!0,c=3));let i=c<u?y(d.slice(c),!f,"\\",t):"";return i.length===0&&!f&&(i="."),i.length>0&&t(d.charCodeAt(u-1))&&(i+="\\"),a===void 0?f?`\\${i}`:i:f?`${a}\\${i}`:`${a}${i}`},isAbsolute(d){p(d,"path");const u=d.length;if(u===0)return!1;const c=d.charCodeAt(0);return t(c)||u>2&&g(c)&&d.charCodeAt(1)===M&&t(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let u,c;for(let s=0;s<d.length;++s){const i=d[s];p(i,"path"),i.length>0&&(u===void 0?u=c=i:u+=`\\${i}`)}if(u===void 0)return".";let a=!0,f=0;if(typeof c=="string"&&t(c.charCodeAt(0))){++f;const s=c.length;s>1&&t(c.charCodeAt(1))&&(++f,s>2&&(t(c.charCodeAt(2))?++f:a=!1))}if(a){for(;f<u.length&&t(u.charCodeAt(f));)f++;f>=2&&(u=`\\${u.slice(f)}`)}return e.win32.normalize(u)},relative(d,u){if(p(d,"from"),p(u,"to"),d===u)return"";const c=e.win32.resolve(d),a=e.win32.resolve(u);if(c===a||(d=c.toLowerCase(),u=a.toLowerCase(),d===u))return"";let f=0;for(;f<d.length&&d.charCodeAt(f)===I;)f++;let s=d.length;for(;s-1>f&&d.charCodeAt(s-1)===I;)s--;const i=s-f;let r=0;for(;r<u.length&&u.charCodeAt(r)===I;)r++;let o=u.length;for(;o-1>r&&u.charCodeAt(o-1)===I;)o--;const l=o-r,v=i<l?i:l;let C=-1,R=0;for(;R<v;R++){const U=d.charCodeAt(f+R);if(U!==u.charCodeAt(r+R))break;U===I&&(C=R)}if(R!==v){if(C===-1)return a}else{if(l>v){if(u.charCodeAt(r+R)===I)return a.slice(r+R+1);if(R===2)return a.slice(r+R)}i>v&&(d.charCodeAt(f+R)===I?C=R:R===2&&(C=3)),C===-1&&(C=0)}let W="";for(R=f+C+1;R<=s;++R)(R===s||d.charCodeAt(R)===I)&&(W+=W.length===0?"..":"\\..");return r+=C,W.length>0?`${W}${a.slice(r,o)}`:(a.charCodeAt(r)===I&&++r,a.slice(r,o))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const u=e.win32.resolve(d);if(u.length<=2)return d;if(u.charCodeAt(0)===I){if(u.charCodeAt(1)===I){const c=u.charCodeAt(2);if(c!==E&&c!==S)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(g(u.charCodeAt(0))&&u.charCodeAt(1)===M&&u.charCodeAt(2)===I)return`\\\\?\\${u}`;return d},dirname(d){p(d,"path");const u=d.length;if(u===0)return".";let c=-1,a=0;const f=d.charCodeAt(0);if(u===1)return t(f)?d:".";if(t(f)){if(c=a=1,t(d.charCodeAt(1))){let r=2,o=r;for(;r<u&&!t(d.charCodeAt(r));)r++;if(r<u&&r!==o){for(o=r;r<u&&t(d.charCodeAt(r));)r++;if(r<u&&r!==o){for(o=r;r<u&&!t(d.charCodeAt(r));)r++;if(r===u)return d;r!==o&&(c=a=r+1)}}}}else g(f)&&d.charCodeAt(1)===M&&(c=u>2&&t(d.charCodeAt(2))?3:2,a=c);let s=-1,i=!0;for(let r=u-1;r>=a;--r)if(t(d.charCodeAt(r))){if(!i){s=r;break}}else i=!1;if(s===-1){if(c===-1)return".";s=c}return d.slice(0,s)},basename(d,u){u!==void 0&&p(u,"ext"),p(d,"path");let c=0,a=-1,f=!0,s;if(d.length>=2&&g(d.charCodeAt(0))&&d.charCodeAt(1)===M&&(c=2),u!==void 0&&u.length>0&&u.length<=d.length){if(u===d)return"";let i=u.length-1,r=-1;for(s=d.length-1;s>=c;--s){const o=d.charCodeAt(s);if(t(o)){if(!f){c=s+1;break}}else r===-1&&(f=!1,r=s+1),i>=0&&(o===u.charCodeAt(i)?--i==-1&&(a=s):(i=-1,a=r))}return c===a?a=r:a===-1&&(a=d.length),d.slice(c,a)}for(s=d.length-1;s>=c;--s)if(t(d.charCodeAt(s))){if(!f){c=s+1;break}}else a===-1&&(f=!1,a=s+1);return a===-1?"":d.slice(c,a)},extname(d){p(d,"path");let u=0,c=-1,a=0,f=-1,s=!0,i=0;d.length>=2&&d.charCodeAt(1)===M&&g(d.charCodeAt(0))&&(u=a=2);for(let r=d.length-1;r>=u;--r){const o=d.charCodeAt(r);if(t(o)){if(!s){a=r+1;break}continue}f===-1&&(s=!1,f=r+1),o===S?c===-1?c=r:i!==1&&(i=1):c!==-1&&(i=-1)}return c===-1||f===-1||i===0||i===1&&c===f-1&&c===a+1?"":d.slice(c,f)},format:k.bind(null,"\\"),parse(d){p(d,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return u;const c=d.length;let a=0,f=d.charCodeAt(0);if(c===1)return t(f)?(u.root=u.dir=d,u):(u.base=u.name=d,u);if(t(f)){if(a=1,t(d.charCodeAt(1))){let C=2,R=C;for(;C<c&&!t(d.charCodeAt(C));)C++;if(C<c&&C!==R){for(R=C;C<c&&t(d.charCodeAt(C));)C++;if(C<c&&C!==R){for(R=C;C<c&&!t(d.charCodeAt(C));)C++;C===c?a=C:C!==R&&(a=C+1)}}}}else if(g(f)&&d.charCodeAt(1)===M){if(c<=2)return u.root=u.dir=d,u;if(a=2,t(d.charCodeAt(2))){if(c===3)return u.root=u.dir=d,u;a=3}}a>0&&(u.root=d.slice(0,a));let s=-1,i=a,r=-1,o=!0,l=d.length-1,v=0;for(;l>=a;--l){if(f=d.charCodeAt(l),t(f)){if(!o){i=l+1;break}continue}r===-1&&(o=!1,r=l+1),f===S?s===-1?s=l:v!==1&&(v=1):s!==-1&&(v=-1)}return r!==-1&&(s===-1||v===0||v===1&&s===r-1&&s===i+1?u.base=u.name=d.slice(i,r):(u.name=d.slice(i,s),u.base=d.slice(i,r),u.ext=d.slice(s,r))),i>0&&i!==a?u.dir=d.slice(0,i-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let u="",c=!1;for(let a=d.length-1;a>=-1&&!c;a--){const f=a>=0?d[a]:w.cwd();p(f,"path"),f.length!==0&&(u=`${f}/${u}`,c=f.charCodeAt(0)===m)}return u=y(u,!c,"/",h),c?`/${u}`:u.length>0?u:"."},normalize(d){if(p(d,"path"),d.length===0)return".";const u=d.charCodeAt(0)===m,c=d.charCodeAt(d.length-1)===m;return d=y(d,!u,"/",h),d.length===0?u?"/":c?"./":".":(c&&(d+="/"),u?`/${d}`:d)},isAbsolute(d){return p(d,"path"),d.length>0&&d.charCodeAt(0)===m},join(...d){if(d.length===0)return".";let u;for(let c=0;c<d.length;++c){const a=d[c];p(a,"path"),a.length>0&&(u===void 0?u=a:u+=`/${a}`)}return u===void 0?".":e.posix.normalize(u)},relative(d,u){if(p(d,"from"),p(u,"to"),d===u||(d=e.posix.resolve(d),u=e.posix.resolve(u),d===u))return"";const c=1,a=d.length,f=a-c,s=1,i=u.length-s,r=f<i?f:i;let o=-1,l=0;for(;l<r;l++){const C=d.charCodeAt(c+l);if(C!==u.charCodeAt(s+l))break;C===m&&(o=l)}if(l===r)if(i>r){if(u.charCodeAt(s+l)===m)return u.slice(s+l+1);if(l===0)return u.slice(s+l)}else f>r&&(d.charCodeAt(c+l)===m?o=l:l===0&&(o=0));let v="";for(l=c+o+1;l<=a;++l)(l===a||d.charCodeAt(l)===m)&&(v+=v.length===0?"..":"/..");return`${v}${u.slice(s+o)}`},toNamespacedPath(d){return d},dirname(d){if(p(d,"path"),d.length===0)return".";const u=d.charCodeAt(0)===m;let c=-1,a=!0;for(let f=d.length-1;f>=1;--f)if(d.charCodeAt(f)===m){if(!a){c=f;break}}else a=!1;return c===-1?u?"/":".":u&&c===1?"//":d.slice(0,c)},basename(d,u){u!==void 0&&p(u,"ext"),p(d,"path");let c=0,a=-1,f=!0,s;if(u!==void 0&&u.length>0&&u.length<=d.length){if(u===d)return"";let i=u.length-1,r=-1;for(s=d.length-1;s>=0;--s){const o=d.charCodeAt(s);if(o===m){if(!f){c=s+1;break}}else r===-1&&(f=!1,r=s+1),i>=0&&(o===u.charCodeAt(i)?--i==-1&&(a=s):(i=-1,a=r))}return c===a?a=r:a===-1&&(a=d.length),d.slice(c,a)}for(s=d.length-1;s>=0;--s)if(d.charCodeAt(s)===m){if(!f){c=s+1;break}}else a===-1&&(f=!1,a=s+1);return a===-1?"":d.slice(c,a)},extname(d){p(d,"path");let u=-1,c=0,a=-1,f=!0,s=0;for(let i=d.length-1;i>=0;--i){const r=d.charCodeAt(i);if(r===m){if(!f){c=i+1;break}continue}a===-1&&(f=!1,a=i+1),r===S?u===-1?u=i:s!==1&&(s=1):u!==-1&&(s=-1)}return u===-1||a===-1||s===0||s===1&&u===a-1&&u===c+1?"":d.slice(u,a)},format:k.bind(null,"/"),parse(d){p(d,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return u;const c=d.charCodeAt(0)===m;let a;c?(u.root="/",a=1):a=0;let f=-1,s=0,i=-1,r=!0,o=d.length-1,l=0;for(;o>=a;--o){const v=d.charCodeAt(o);if(v===m){if(!r){s=o+1;break}continue}i===-1&&(r=!1,i=o+1),v===S?f===-1?f=o:l!==1&&(l=1):f!==-1&&(l=-1)}if(i!==-1){const v=s===0&&c?1:s;f===-1||l===0||l===1&&f===i-1&&f===s+1?u.base=u.name=d.slice(v,i):(u.name=d.slice(v,f),u.base=d.slice(v,i),u.ext=d.slice(f,i))}return s>0?u.dir=d.slice(0,s-1):c&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=w.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w.platform==="win32"?e.win32.join:e.posix.join,e.resolve=w.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=w.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=w.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=w.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=w.platform==="win32"?e.win32.extname:e.posix.extname,e.format=w.platform==="win32"?e.win32.format:e.posix.format,e.parse=w.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=w.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=w.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Z[84],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var w;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(w=e.Source||(e.Source={}));var n;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(D,...P){const S=P.reduce((M,E)=>(M[E]=!0,M),{}),m=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(M=>!S[M]).forEach(M=>{for(let E=0;E<m.length;E++)if(M.search(m[E])!==-1){delete D[M];break}})}e.sanitizeProcessEnvironment=L}),define(Z[85],x([0,1,2]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=w.globals.performance&&typeof w.globals.performance.now=="function";class L{constructor(P){this._highResolution=n&&P,this._startTime=this._now(),this._stopTime=-1}static create(P=!0){return new L(P)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?w.globals.performance.now():Date.now()}}e.StopWatch=L}),define(Z[4],x([0,1,15,43,3,112,85]),function(V,e,w,n,L,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;let S=!1,m=!1;var I;(function(s){s.None=()=>L.Disposable.None;function i(z){if(m){const{onListenerDidAdd:F}=z,N=t.create();let T=0;z.onListenerDidAdd=()=>{++T==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),N.print()),F?.()}}}function r(z){return(F,N=null,T)=>{let A=!1,O;return O=z(_=>{if(!A)return O?O.dispose():A=!0,F.call(N,_)},null,T),A&&O.dispose(),O}}s.once=r;function o(z,F,N){return U((T,A=null,O)=>z(_=>T.call(A,F(_)),null,O),N)}s.map=o;function l(z,F,N){return U((T,A=null,O)=>z(_=>{F(_),T.call(A,_)},null,O),N)}s.forEach=l;function v(z,F,N){return U((T,A=null,O)=>z(_=>F(_)&&T.call(A,_),null,O),N)}s.filter=v;function C(z){return z}s.signal=C;function R(...z){return(F,N=null,T)=>(0,L.combinedDisposable)(...z.map(A=>A(O=>F.call(N,O),null,T)))}s.any=R;function W(z,F,N,T){let A=N;return o(z,O=>(A=F(A,O),A),T)}s.reduce=W;function U(z,F){let N;const T={onFirstListenerAdd(){N=z(A.fire,A)},onLastListenerRemove(){N.dispose()}};F||i(T);const A=new g(T);return F&&F.add(A),A.event}function G(z,F,N=100,T=!1,A,O){let _,j,ie,ae=0;const ce={leakWarningThreshold:A,onFirstListenerAdd(){_=z(le=>{ae++,j=F(j,le),T&&!ie&&(ne.fire(j),j=void 0),clearTimeout(ie),ie=setTimeout(()=>{const he=j;j=void 0,ie=void 0,(!T||ae>1)&&ne.fire(he),ae=0},N)})},onLastListenerRemove(){_.dispose()}};O||i(ce);const ne=new g(ce);return O&&O.add(ne),ne.event}s.debounce=G;function ee(z,F=(T,A)=>T===A,N){let T=!0,A;return v(z,O=>{const _=T||!F(O,A);return T=!1,A=O,_},N)}s.latch=ee;function X(z,F,N){return[s.filter(z,F,N),s.filter(z,T=>!F(T),N)]}s.split=X;function J(z,F=!1,N=[]){let T=N.slice(),A=z(j=>{T?T.push(j):_.fire(j)});const O=()=>{T&&T.forEach(j=>_.fire(j)),T=null},_=new g({onFirstListenerAdd(){A||(A=z(j=>_.fire(j)))},onFirstListenerDidAdd(){T&&(F?setTimeout(O):O())},onLastListenerRemove(){A&&A.dispose(),A=null}});return _.event}s.buffer=J;class H{constructor(F){this.event=F}map(F){return new H(o(this.event,F))}forEach(F){return new H(l(this.event,F))}filter(F){return new H(v(this.event,F))}reduce(F,N){return new H(W(this.event,F,N))}latch(){return new H(ee(this.event))}debounce(F,N=100,T=!1,A){return new H(G(this.event,F,N,T,A))}on(F,N,T){return this.event(F,N,T)}once(F,N,T){return r(this.event)(F,N,T)}}function B(z){return new H(z)}s.chain=B;function Y(z,F,N=T=>T){const T=(...j)=>_.fire(N(...j)),A=()=>z.on(F,T),O=()=>z.removeListener(F,T),_=new g({onFirstListenerAdd:A,onLastListenerRemove:O});return _.event}s.fromNodeEventEmitter=Y;function se(z,F,N=T=>T){const T=(...j)=>_.fire(N(...j)),A=()=>z.addEventListener(F,T),O=()=>z.removeEventListener(F,T),_=new g({onFirstListenerAdd:A,onLastListenerRemove:O});return _.event}s.fromDOMEventEmitter=se;function $(z){return new Promise(F=>r(z)(F))}s.toPromise=$;function q(z,F){return F(void 0),z(N=>F(N))}s.runAndSubscribe=q;function Q(z,F){let N=null;function T(O){N?.dispose(),N=new L.DisposableStore,F(O,N)}T(void 0);const A=z(O=>T(O));return(0,L.toDisposable)(()=>{A.dispose(),N?.dispose()})}s.runAndSubscribeWithStore=Q})(I=e.Event||(e.Event={}));class M{constructor(i){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${i}_${M._idPool++}`}start(i){this._stopWatch=new P.StopWatch(!0),this._listenerCount=i}stop(){if(this._stopWatch){const i=this._stopWatch.elapsed();this._elapsedOverall+=i,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${i.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}M._idPool=0;let E=-1;function b(s){const i=E;return E=s,{dispose(){E=i}}}e.setGlobalLeakWarningThreshold=b;class p{constructor(i,r=Math.random().toString(18).slice(2,5)){this.customThreshold=i,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(i,r){let o=E;if(typeof this.customThreshold=="number"&&(o=this.customThreshold),o<=0||r<o)return;this._stacks||(this._stacks=new Map);const l=this._stacks.get(i.value)||0;if(this._stacks.set(i.value,l+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=o*.5;let v,C=0;for(const[R,W]of this._stacks)(!v||C<W)&&(v=R,C=W);console.warn(`[${this.name}] potential listener LEAK detected, having ${r} listeners already. MOST frequent listener (${C}):`),console.warn(v)}return()=>{const v=this._stacks.get(i.value)||0;this._stacks.set(i.value,v-1)}}}class t{constructor(i){this.value=i}static create(){return new t(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class h{constructor(i,r,o){this.callback=i,this.callbackThis=r,this.stack=o,this.subscription=new L.SafeDisposable}invoke(i){this.callback.call(this.callbackThis,i)}}class g{constructor(i){this._disposed=!1,this._options=i,this._leakageMon=E>0?new p(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new M(this._options._profName):void 0}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(S){const i=Array.from(this._listeners);queueMicrotask(()=>{for(const r of i)r.subscription.isset()&&(r.subscription.unset(),r.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(i,r,o)=>{this._listeners||(this._listeners=new D.LinkedList);const l=this._listeners.isEmpty();l&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let v,C;this._leakageMon&&this._listeners.size>=30&&(C=t.create(),v=this._leakageMon.check(C,this._listeners.size+1)),S&&(C=C??t.create());const R=new h(i,r,C),W=this._listeners.push(R);l&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,i,r);const U=R.subscription.set(()=>{v&&v(),this._disposed||(W(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return o instanceof L.DisposableStore?o.add(U):Array.isArray(o)&&o.push(U),U}),this._event}fire(i){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new D.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,i]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,o]=this._deliveryQueue.shift();try{r.invoke(o)}catch(l){(0,w.onUnexpectedError)(l)}}this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=g;class y extends g{async fireAsync(i,r,o){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new D.LinkedList);for(const l of this._listeners)this._asyncDeliveryQueue.push([l,i]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[l,v]=this._asyncDeliveryQueue.shift(),C=[],R={...v,token:r,waitUntil:W=>{if(Object.isFrozen(C))throw new Error("waitUntil can NOT be called asynchronous");o&&(W=o(W,l.callback)),C.push(W)}};try{l.invoke(R)}catch(W){(0,w.onUnexpectedError)(W);continue}Object.freeze(C),await Promise.allSettled(C).then(W=>{for(const U of W)U.status==="rejected"&&(0,w.onUnexpectedError)(U.reason)})}}}}e.AsyncEmitter=y;class k extends g{constructor(i){super(i);this._isPaused=0,this._eventQueue=new D.LinkedList,this._mergeFn=i?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const i=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(i))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(i){this._listeners&&(this._isPaused!==0?this._eventQueue.push(i):super.fire(i))}}e.PauseableEmitter=k;class d extends k{constructor(i){super(i);this._delay=i.delay??100}fire(i){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(i)}}e.DebounceEmitter=d;class u extends g{constructor(i){super(i);this._queuedEvents=[],this._mergeFn=i?.merge}fire(i){this._queuedEvents.push(i),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(r=>super.fire(r)),this._queuedEvents=[]})}}e.MicrotaskEmitter=u;class c{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(i){const r={event:i,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const o=()=>{this.hasListeners&&this.unhook(r);const l=this.events.indexOf(r);this.events.splice(l,1)};return(0,L.toDisposable)((0,n.once)(o))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(i=>this.hook(i))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(i=>this.unhook(i))}hook(i){i.listener=i.event(r=>this.emitter.fire(r))}unhook(i){i.listener&&i.listener.dispose(),i.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=c;class a{constructor(){this.buffers=[]}wrapEvent(i){return(r,o,l)=>i(v=>{const C=this.buffers[this.buffers.length-1];C?C.push(()=>r.call(o,v)):r.call(o,v)},void 0,l)}bufferEvents(i){const r=[];this.buffers.push(r);const o=i();return this.buffers.pop(),r.forEach(l=>l()),o}}e.EventBufferer=a;class f{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=L.Disposable.None,this.emitter=new g({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(i){this.inputEvent=i,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=i(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=f}),define(Z[23],x([0,1,4]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(S,m){const I=setTimeout(S.bind(m),0);return{dispose(){clearTimeout(I)}}});var L;(function(S){function m(I){return I===S.None||I===S.Cancelled||I instanceof D?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}S.isCancellationToken=m,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(L=e.CancellationToken||(e.CancellationToken={}));class D{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new w.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class P{constructor(m){this._token=void 0,this._parentListener=void 0,this._parentListener=m&&m.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new D),this._token}cancel(){this._token?this._token instanceof D&&this._token.cancel():this._token=L.Cancelled}dispose(m=!1){m&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof D&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=P}),define(Z[113],x([0,1,23]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class n{constructor(P){this.task=P,this.result=null}get(){if(this.result)return this.result;const P=new w.CancellationTokenSource,S=this.task(P.token);return this.result={promise:S,dispose:()=>{this.result=null,P.cancel(),P.dispose()}},this.result}}e.Cache=n;class L{constructor(P){this.computeFn=P,this.lastCache=void 0,this.lastArgKey=void 0}get(P){const S=JSON.stringify(P);return this.lastArgKey!==S&&(this.lastArgKey=S,this.lastCache=this.computeFn(P)),this.lastCache}}e.LRUCachedComputed=L}),define(Z[48],x([0,1,15,3]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function L(d){const u=d;return u?[u.on,u.pause,u.resume,u.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=L;function D(d){const u=d;return u?L(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.isReadableBufferedStream=D;function P(d,u){return new S(d,u)}e.newWriteableStream=P;class S{constructor(u,c){this.reducer=u,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(u){if(!this.state.destroyed){if(this.state.flowing)this.emitData(u);else if(this.buffer.data.push(u),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(u){this.state.destroyed||(this.state.flowing?this.emitError(u):this.buffer.error.push(u))}end(u){this.state.destroyed||(typeof u!="undefined"&&this.write(u),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(u){this.listeners.data.slice(0).forEach(c=>c(u))}emitError(u){this.listeners.error.length===0?(0,w.onUnexpectedError)(u):this.listeners.error.slice(0).forEach(c=>c(u))}emitEnd(){this.listeners.end.slice(0).forEach(u=>u())}on(u,c){if(!this.state.destroyed)switch(u){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(u,c){if(this.state.destroyed)return;let a;switch(u){case"data":a=this.listeners.data;break;case"end":a=this.listeners.end;break;case"error":a=this.listeners.error;break}if(a){const f=a.indexOf(c);f>=0&&a.splice(f,1)}}flowData(){if(this.buffer.data.length>0){const u=this.reducer(this.buffer.data);this.emitData(u),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(a=>a())}}flowErrors(){if(this.listeners.error.length>0){for(const u of this.buffer.error)this.emitError(u);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(d,u){const c=[];let a;for(;(a=d.read())!==null;)c.push(a);return u(c)}e.consumeReadable=m;function I(d,u,c){const a=[];let f;for(;(f=d.read())!==null&&a.length<c;)a.push(f);return f===null&&a.length>0?u(a):{read:()=>{if(a.length>0)return a.shift();if(typeof f!="undefined"){const s=f;return f=void 0,s}return d.read()}}}e.peekReadable=I;function M(d,u){return new Promise((c,a)=>{const f=[];E(d,{onData:s=>{u&&f.push(s)},onError:s=>{u?a(s):c(void 0)},onEnd:()=>{c(u?u(f):void 0)}})})}e.consumeStream=M;function E(d,u){let c=!1;return d.on("error",a=>{c||u.onError(a)}),d.on("end",()=>{c||u.onEnd()}),d.on("data",a=>{c||u.onData(a)}),(0,n.toDisposable)(()=>c=!0)}e.listenStream=E;function b(d,u){return new Promise((c,a)=>{const f=new n.DisposableStore,s=[],i=l=>{if(s.push(l),s.length>u)return f.dispose(),d.pause(),c({stream:d,buffer:s,ended:!1})},r=l=>a(l),o=()=>c({stream:d,buffer:s,ended:!0});f.add((0,n.toDisposable)(()=>d.removeListener("error",r))),d.on("error",r),f.add((0,n.toDisposable)(()=>d.removeListener("end",o))),d.on("end",o),f.add((0,n.toDisposable)(()=>d.removeListener("data",i))),d.on("data",i)})}e.peekStream=b;function p(d,u){const c=P(u);return c.end(d),c}e.toStream=p;function t(){const d=P(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=t;function h(d){let u=!1;return{read:()=>u?null:(u=!0,d)}}e.toReadable=h;function g(d,u,c){const a=P(c);return E(d,{onData:f=>a.write(u.data(f)),onError:f=>a.error(u.error?u.error(f):f),onEnd:()=>a.end()}),a}e.transform=g;function y(d,u,c){let a=!1;return{read:()=>{const f=u.read();return a?f:(a=!0,f!==null?c([d,f]):d)}}}e.prefixedReadable=y;function k(d,u,c){let a=!1;const f=P(c);return E(u,{onData:s=>a?f.write(s):(a=!0,f.write(c([d,s]))),onError:s=>f.error(s),onEnd:()=>{a||(a=!0,f.write(d)),f.end()}}),f}e.prefixedStream=k}),define(Z[16],x([0,1,48]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let L,D;class P{constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}static alloc(v){return n?new P(Buffer.allocUnsafe(v)):new P(new Uint8Array(v))}static wrap(v){return n&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new P(v)}static fromString(v,C){return!(C?.dontUseNodeBuffer||!1)&&n?new P(Buffer.from(v)):(L||(L=new TextEncoder),new P(L.encode(v)))}static fromByteArray(v){const C=P.alloc(v.length);for(let R=0,W=v.length;R<W;R++)C.buffer[R]=v[R];return C}static concat(v,C){if(typeof C=="undefined"){C=0;for(let U=0,G=v.length;U<G;U++)C+=v[U].byteLength}const R=P.alloc(C);let W=0;for(let U=0,G=v.length;U<G;U++){const ee=v[U];R.set(ee,W),W+=ee.byteLength}return R}clone(){const v=P.alloc(this.byteLength);return v.set(this),v}toString(){return n?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(v,C){return new P(this.buffer.subarray(v,C))}set(v,C){if(v instanceof P)this.buffer.set(v.buffer,C);else if(v instanceof Uint8Array)this.buffer.set(v,C);else if(v instanceof ArrayBuffer)this.buffer.set(new Uint8Array(v),C);else if(ArrayBuffer.isView(v))this.buffer.set(new Uint8Array(v.buffer,v.byteOffset,v.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(v){return I(this.buffer,v)}writeUInt32BE(v,C){M(this.buffer,v,C)}readUInt32LE(v){return E(this.buffer,v)}writeUInt32LE(v,C){b(this.buffer,v,C)}readUInt8(v){return p(this.buffer,v)}writeUInt8(v,C){t(this.buffer,v,C)}}e.VSBuffer=P;function S(l,v){return l[v+0]<<0>>>0|l[v+1]<<8>>>0}e.readUInt16LE=S;function m(l,v,C){l[C+0]=v&255,v=v>>>8,l[C+1]=v&255}e.writeUInt16LE=m;function I(l,v){return l[v]*2**24+l[v+1]*2**16+l[v+2]*2**8+l[v+3]}e.readUInt32BE=I;function M(l,v,C){l[C+3]=v,v=v>>>8,l[C+2]=v,v=v>>>8,l[C+1]=v,v=v>>>8,l[C]=v}e.writeUInt32BE=M;function E(l,v){return l[v+0]<<0>>>0|l[v+1]<<8>>>0|l[v+2]<<16>>>0|l[v+3]<<24>>>0}e.readUInt32LE=E;function b(l,v,C){l[C+0]=v&255,v=v>>>8,l[C+1]=v&255,v=v>>>8,l[C+2]=v&255,v=v>>>8,l[C+3]=v&255}e.writeUInt32LE=b;function p(l,v){return l[v]}e.readUInt8=p;function t(l,v,C){l[C]=v}e.writeUInt8=t;function h(l){return w.consumeReadable(l,v=>P.concat(v))}e.readableToBuffer=h;function g(l){return w.toReadable(l)}e.bufferToReadable=g;function y(l){return w.consumeStream(l,v=>P.concat(v))}e.streamToBuffer=y;async function k(l){return l.ended?P.concat(l.buffer):P.concat([...l.buffer,await y(l.stream)])}e.bufferedStreamToBuffer=k;function d(l){return w.toStream(l,v=>P.concat(v))}e.bufferToStream=d;function u(l){return w.transform(l,{data:v=>typeof v=="string"?P.fromString(v):P.wrap(v)},v=>P.concat(v))}e.streamToBufferReadableStream=u;function c(l){return w.newWriteableStream(v=>P.concat(v),l)}e.newWriteableBufferStream=c;function a(l,v){return w.prefixedReadable(l,v,C=>P.concat(C))}e.prefixedBufferReadable=a;function f(l,v){return w.prefixedStream(l,v,C=>P.concat(C))}e.prefixedBufferStream=f;function s(l){let v=0,C=0,R=0;const W=new Uint8Array(Math.floor(l.length/4*3)),U=ee=>{switch(C){case 3:W[R++]=v|ee,C=0;break;case 2:W[R++]=v|ee>>>2,v=ee<<6,C=3;break;case 1:W[R++]=v|ee>>>4,v=ee<<4,C=2;break;default:v=ee<<2,C=1}};for(let ee=0;ee<l.length;ee++){const X=l.charCodeAt(ee);if(X>=65&&X<=90)U(X-65);else if(X>=97&&X<=122)U(X-97+26);else if(X>=48&&X<=57)U(X-48+52);else if(X===43||X===45)U(62);else if(X===47||X===95)U(63);else{if(X===61)break;throw new SyntaxError(`Unexpected base64 character ${l[ee]}`)}}const G=R;for(;C>0;)U(0);return P.wrap(W).slice(0,G)}e.decodeBase64=s;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:l},v=!0,C=!1){const R=C?r:i;let W="";const U=l.byteLength%3;let G=0;for(;G<l.byteLength-U;G+=3){const ee=l[G+0],X=l[G+1],J=l[G+2];W+=R[ee>>>2],W+=R[(ee<<4|X>>>4)&63],W+=R[(X<<2|J>>>6)&63],W+=R[J&63]}if(U===1){const ee=l[G+0];W+=R[ee>>>2],W+=R[ee<<4&63],v&&(W+="==")}else if(U===2){const ee=l[G+0],X=l[G+1];W+=R[ee>>>2],W+=R[(ee<<4|X>>>4)&63],W+=R[X<<2&63],v&&(W+="=")}return W}e.encodeBase64=o}),define(Z[27],x([0,1,113,111]),function(V,e,w,n){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function D(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=D;const P=/{(\d+)}/g;function S(K,...re){return re.length===0?K:K.replace(P,function(oe,fe){const ye=parseInt(fe,10);return isNaN(ye)||ye<0||ye>=re.length?oe:re[ye]})}e.format=S;const m=/{([^}]+)}/g;function I(K,re){return K.replace(m,(oe,fe)=>re[fe]??oe)}e.format2=I;function M(K){return K.replace(/[<>&]/g,function(re){switch(re){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return re}})}e.escape=M;function E(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function b(K,re){let oe=0;const fe=re.charCodeAt(0);for(let ye=K.length-1;ye>=0;ye--)K.charCodeAt(ye)===fe&&oe++;return oe}e.count=b;function p(K,re,oe="\u2026"){return K.length<=re?K:`${K.substr(0,re)}${oe}`}e.truncate=p;function t(K,re=" "){const oe=h(K,re);return g(oe,re)}e.trim=t;function h(K,re){if(!K||!re)return K;const oe=re.length;if(oe===0||K.length===0)return K;let fe=0;for(;K.indexOf(re,fe)===fe;)fe=fe+oe;return K.substring(fe)}e.ltrim=h;function g(K,re){if(!K||!re)return K;const oe=re.length,fe=K.length;if(oe===0||fe===0)return K;let ye=fe,Re=-1;for(;Re=K.lastIndexOf(re,ye-1),!(Re===-1||Re+oe!==ye);){if(Re===0)return"";ye=Re}return K.substring(0,ye)}e.rtrim=g;function y(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=y;function k(K){return K.replace(/\*/g,"")}e.stripWildcards=k;function d(K,re,oe={}){if(!K)throw new Error("Cannot create regex from empty string");re||(K=E(K)),oe.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let fe="";return oe.global&&(fe+="g"),oe.matchCase||(fe+="i"),oe.multiline&&(fe+="m"),oe.unicode&&(fe+="u"),new RegExp(K,fe)}e.createRegExp=d;function u(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=u;function c(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function a(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=a;function f(K){return K.split(/\r\n|\r|\n/)}e.splitLines=f;function s(K){for(let re=0,oe=K.length;re<oe;re++){const fe=K.charCodeAt(re);if(fe!==32&&fe!==9)return re}return-1}e.firstNonWhitespaceIndex=s;function i(K,re=0,oe=K.length){for(let fe=re;fe<oe;fe++){const ye=K.charCodeAt(fe);if(ye!==32&&ye!==9)return K.substring(re,fe)}return K.substring(re,oe)}e.getLeadingWhitespace=i;function r(K,re=K.length-1){for(let oe=re;oe>=0;oe--){const fe=K.charCodeAt(oe);if(fe!==32&&fe!==9)return oe}return-1}e.lastNonWhitespaceIndex=r;function o(K,re){return K<re?-1:K>re?1:0}e.compare=o;function l(K,re,oe=0,fe=K.length,ye=0,Re=re.length){for(;oe<fe&&ye<Re;oe++,ye++){let Ve=K.charCodeAt(oe),Ae=re.charCodeAt(ye);if(Ve<Ae)return-1;if(Ve>Ae)return 1}const Oe=fe-oe,Ke=Re-ye;return Oe<Ke?-1:Oe>Ke?1:0}e.compareSubstring=l;function v(K,re){return C(K,re,0,K.length,0,re.length)}e.compareIgnoreCase=v;function C(K,re,oe=0,fe=K.length,ye=0,Re=re.length){for(;oe<fe&&ye<Re;oe++,ye++){let Ve=K.charCodeAt(oe),Ae=re.charCodeAt(ye);if(Ve===Ae)continue;if(Ve>=128||Ae>=128)return l(K.toLowerCase(),re.toLowerCase(),oe,fe,ye,Re);R(Ve)&&(Ve-=32),R(Ae)&&(Ae-=32);const qe=Ve-Ae;if(qe!==0)return qe}const Oe=fe-oe,Ke=Re-ye;return Oe<Ke?-1:Oe>Ke?1:0}e.compareSubstringIgnoreCase=C;function R(K){return K>=97&&K<=122}e.isLowerAsciiLetter=R;function W(K){return K>=65&&K<=90}e.isUpperAsciiLetter=W;function U(K,re){return K.length===re.length&&C(K,re)===0}e.equalsIgnoreCase=U;function G(K,re){const oe=re.length;return re.length>K.length?!1:C(K,re,0,oe)===0}e.startsWithIgnoreCase=G;function ee(K,re){let oe,fe=Math.min(K.length,re.length);for(oe=0;oe<fe;oe++)if(K.charCodeAt(oe)!==re.charCodeAt(oe))return oe;return fe}e.commonPrefixLength=ee;function X(K,re){let oe,fe=Math.min(K.length,re.length);const ye=K.length-1,Re=re.length-1;for(oe=0;oe<fe;oe++)if(K.charCodeAt(ye-oe)!==re.charCodeAt(Re-oe))return oe;return fe}e.commonSuffixLength=X;function J(K){return 55296<=K&&K<=56319}e.isHighSurrogate=J;function H(K){return 56320<=K&&K<=57343}e.isLowSurrogate=H;function B(K,re){return(K-55296<<10)+(re-56320)+65536}e.computeCodePoint=B;function Y(K,re,oe){const fe=K.charCodeAt(oe);if(J(fe)&&oe+1<re){const ye=K.charCodeAt(oe+1);if(H(ye))return B(fe,ye)}return fe}e.getNextCodePoint=Y;function se(K,re){const oe=K.charCodeAt(re-1);if(H(oe)&&re>1){const fe=K.charCodeAt(re-2);if(J(fe))return B(fe,oe)}return oe}class ${constructor(re,oe=0){this._str=re,this._len=re.length,this._offset=oe}get offset(){return this._offset}setOffset(re){this._offset=re}prevCodePoint(){const re=se(this._str,this._offset);return this._offset-=re>=65536?2:1,re}nextCodePoint(){const re=Y(this._str,this._len,this._offset);return this._offset+=re>=65536?2:1,re}eol(){return this._offset>=this._len}}e.CodePointIterator=$;class q{constructor(re,oe=0){this._iterator=new $(re,oe)}get offset(){return this._iterator.offset}nextGraphemeLength(){const re=ze.getInstance(),oe=this._iterator,fe=oe.offset;let ye=re.getGraphemeBreakType(oe.nextCodePoint());for(;!oe.eol();){const Re=oe.offset,Oe=re.getGraphemeBreakType(oe.nextCodePoint());if(Ze(ye,Oe)){oe.setOffset(Re);break}ye=Oe}return oe.offset-fe}prevGraphemeLength(){const re=ze.getInstance(),oe=this._iterator,fe=oe.offset;let ye=re.getGraphemeBreakType(oe.prevCodePoint());for(;oe.offset>0;){const Re=oe.offset,Oe=re.getGraphemeBreakType(oe.prevCodePoint());if(Ze(Oe,ye)){oe.setOffset(Re);break}ye=Oe}return fe-oe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=q;function Q(K,re){return new q(K,re).nextGraphemeLength()}e.nextCharLength=Q;function z(K,re){return new q(K,re).prevGraphemeLength()}e.prevCharLength=z;function F(K,re){re>0&&H(K.charCodeAt(re))&&re--;const oe=re+Q(K,re);return[oe-z(K,oe),oe]}e.getCharContainingOffset=F;const N=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function T(K){return N.test(K)}e.containsRTL=T;const A=/^[\t\n\r\x20-\x7E]*$/;function O(K){return A.test(K)}e.isBasicASCII=O,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function _(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=_;function j(K){return K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=j;function ie(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129008||K>=129280&&K<=129535||K>=129648&&K<=129782}e.isEmojiImprecise=ie;function ae(K,re){if(K.length<re)return K;const oe=/\b/g;let fe=0;for(;oe.test(K)&&!(K.length-oe.lastIndex<re);)fe=oe.lastIndex,oe.lastIndex+=1;return K.substring(fe).replace(/^\s/,"")}e.lcut=ae;const ce=/\x1B\x5B[12]?K/g,ne=/\x1b\[\d+m/g,le=/\x1b\[0?m/g;function he(K){return K&&(K=K.replace(ce,""),K=K.replace(ne,""),K=K.replace(le,"")),K}e.removeAnsiEscapeCodes=he,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function we(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=we;function be(K){return we(K)?K.substr(1):K}e.stripUTF8BOM=be;function Me(K,re){if(!K||!re||K.length<re.length)return!1;const oe=re.length,fe=K.toLowerCase();let ye=0,Re=-1;for(;ye<oe;){const Oe=fe.indexOf(re[ye],Re+1);if(Oe<0)return!1;Re=Oe,ye++}return!0}e.fuzzyContains=Me;function Se(K,re=!1){return K?(re&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=Se;function pe(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=pe;function Ee(K,re=1){if(re===0)return"";let oe=-1;do oe=K.indexOf(`
`,oe+1),re--;while(re>0&&oe>=0);return oe===-1?K:(K[oe-1]==="\r"&&oe--,K.substr(0,oe))}e.getNLines=Ee;function Le(K){const re=90-65+1;return K=K%(2*re),K<re?String.fromCharCode(97+K):String.fromCharCode(65+K-re)}e.singleLetterHash=Le;function Ne(K){return ze.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=Ne;function Ze(K,re){return K===0?re!==5&&re!==7:K===2&&re===3?!1:K===4||K===2||K===3||re===4||re===2||re===3?!0:!(K===8&&(re===8||re===9||re===11||re===12)||(K===11||K===9)&&(re===9||re===10)||(K===12||K===10)&&re===10||re===5||re===13||re===7||K===1||K===13&&re===14||K===6&&re===6)}var Fe;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(Fe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ze{constructor(){this._data=Ge()}static getInstance(){return ze._INSTANCE||(ze._INSTANCE=new ze),ze._INSTANCE}getGraphemeBreakType(re){if(re<32)return re===10?3:re===13?2:4;if(re<127)return 0;const oe=this._data,fe=oe.length/3;let ye=1;for(;ye<=fe;)if(re<oe[3*ye])ye=2*ye;else if(re>oe[3*ye+1])ye=2*ye+1;else return oe[3*ye+2];return 0}}ze._INSTANCE=null;function Ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function st(K,re){if(K===0)return 0;const oe=wt(K,re);if(oe!==void 0)return oe;const fe=new $(re,K);return fe.prevCodePoint(),fe.offset}e.getLeftDeleteOffset=st;function wt(K,re){const oe=new $(re,K);let fe=oe.prevCodePoint();for(;ot(fe)||fe===65039||fe===8419;){if(oe.offset===0)return;fe=oe.prevCodePoint()}if(!ie(fe))return;let ye=oe.offset;return ye>0&&oe.prevCodePoint()===8205&&(ye=oe.offset),ye}function ot(K){return 127995<=K&&K<=127999}var Ye;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={})),e.noBreakWhitespace="\xA0";class He{constructor(re){this.confusableDictionary=re}static getInstance(re){return He.cache.get(Array.from(re))}static getLocales(){return He._locales.getValue()}isAmbiguous(re){return this.confusableDictionary.has(re)}getPrimaryConfusable(re){return this.confusableDictionary.get(re)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=He,L=He,He.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),He.cache=new w.LRUCachedComputed(K=>{function re(Ae){const qe=new Map;for(let je=0;je<Ae.length;je+=2)qe.set(Ae[je],Ae[je+1]);return qe}function oe(Ae,qe){const je=new Map(Ae);for(const[xe,tt]of qe)je.set(xe,tt);return je}function fe(Ae,qe){if(!Ae)return qe;const je=new Map;for(const[xe,tt]of Ae)qe.has(xe)&&je.set(xe,tt);return je}const ye=L.ambiguousCharacterData.getValue();let Re=K.filter(Ae=>!Ae.startsWith("_")&&Ae in ye);Re.length===0&&(Re=["_default"]);let Oe;for(const Ae of Re){const qe=re(ye[Ae]);Oe=fe(Oe,qe)}const Ke=re(ye._common),Ve=oe(Ke,Oe);return new He(Ve)}),He._locales=new n.Lazy(()=>Object.keys(He.ambiguousCharacterData.getValue()).filter(K=>!K.startsWith("_")));class Qe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Qe.getRawData())),this._data}static isInvisibleCharacter(re){return Qe.getData().has(re)}static get codePoints(){return Qe.getData()}}e.InvisibleCharacters=Qe,Qe._data=void 0}),define(Z[69],x([0,1,27]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(y){return L(y,0)}e.hash=n;function L(y,k){switch(typeof y){case"object":return y===null?D(349,k):Array.isArray(y)?m(y,k):I(y,k);case"string":return S(y,k);case"boolean":return P(y,k);case"number":return D(y,k);case"undefined":return D(937,k);default:return D(617,k)}}e.doHash=L;function D(y,k){return(k<<5)-k+y|0}e.numberHash=D;function P(y,k){return D(y?433:863,k)}function S(y,k){k=D(149417,k);for(let d=0,u=y.length;d<u;d++)k=D(y.charCodeAt(d),k);return k}e.stringHash=S;function m(y,k){return k=D(104579,k),y.reduce((d,u)=>L(u,d),k)}function I(y,k){return k=D(181387,k),Object.keys(y).sort().reduce((d,u)=>(d=S(u,d),L(y[u],d)),k)}class M{constructor(){this._value=0}get value(){return this._value}hash(k){return this._value=L(k,this._value),this._value}}e.Hasher=M;var E;(function(y){y[y.BLOCK_SIZE=64]="BLOCK_SIZE",y[y.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function b(y,k,d=32){const u=d-k,c=~((1<<u)-1);return(y<<k|(c&y)>>>u)>>>0}function p(y,k=0,d=y.byteLength,u=0){for(let c=0;c<d;c++)y[k+c]=u}function t(y,k,d="0"){for(;y.length<k;)y=d+y;return y}function h(y,k=32){return y instanceof ArrayBuffer?Array.from(new Uint8Array(y)).map(d=>d.toString(16).padStart(2,"0")).join(""):t((y>>>0).toString(16),k/4)}e.toHexString=h;class g{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(k){const d=k.length;if(d===0)return;const u=this._buff;let c=this._buffLen,a=this._leftoverHighSurrogate,f,s;for(a!==0?(f=a,s=-1,a=0):(f=k.charCodeAt(0),s=0);;){let i=f;if(w.isHighSurrogate(f))if(s+1<d){const r=k.charCodeAt(s+1);w.isLowSurrogate(r)?(s++,i=w.computeCodePoint(f,r)):i=65533}else{a=f;break}else w.isLowSurrogate(f)&&(i=65533);if(c=this._push(u,c,i),s++,s<d)f=k.charCodeAt(s);else break}this._buffLen=c,this._leftoverHighSurrogate=a}_push(k,d,u){return u<128?k[d++]=u:u<2048?(k[d++]=192|(u&1984)>>>6,k[d++]=128|(u&63)>>>0):u<65536?(k[d++]=224|(u&61440)>>>12,k[d++]=128|(u&4032)>>>6,k[d++]=128|(u&63)>>>0):(k[d++]=240|(u&1835008)>>>18,k[d++]=128|(u&258048)>>>12,k[d++]=128|(u&4032)>>>6,k[d++]=128|(u&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,k[0]=k[64+0],k[1]=k[64+1],k[2]=k[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const k=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(k/4294967296),!1),this._buffDV.setUint32(60,k%4294967296,!1),this._step()}_step(){const k=g._bigBlock32,d=this._buffDV;for(let l=0;l<64;l+=4)k.setUint32(l,d.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)k.setUint32(l,b(k.getUint32(l-12,!1)^k.getUint32(l-32,!1)^k.getUint32(l-56,!1)^k.getUint32(l-64,!1),1),!1);let u=this._h0,c=this._h1,a=this._h2,f=this._h3,s=this._h4,i,r,o;for(let l=0;l<80;l++)l<20?(i=c&a|~c&f,r=1518500249):l<40?(i=c^a^f,r=1859775393):l<60?(i=c&a|c&f|a&f,r=2400959708):(i=c^a^f,r=3395469782),o=b(u,5)+i+s+r+k.getUint32(l*4,!1)&4294967295,s=f,f=a,a=b(c,30),c=u,u=o;this._h0=this._h0+u&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+a&4294967295,this._h3=this._h3+f&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=g,g._bigBlock32=new DataView(new ArrayBuffer(320))});var Dt=this&&this.__classPrivateFieldSet||function(V,e,w,n,L){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!L)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?V!==e||!L:!e.has(V))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?L.call(V,w):L?L.value=w:e.set(V,w),w},Je=this&&this.__classPrivateFieldGet||function(V,e,w,n){if(w==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?V!==e||!n:!e.has(V))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?n:w==="a"?n.call(V):n?n.value:e.get(V)};define(Z[35],x([0,1,30,27]),function(V,e,w,n){"use strict";var L,D,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function S(s,i,r){let o=s.get(i);return o===void 0&&(o=r,s.set(i,o)),o}e.getOrSet=S;function m(s){const i=[];return s.forEach((r,o)=>{i.push(`${o} => ${r}`)}),`Map(${s.size}) {${i.join(", ")}}`}e.mapToString=m;function I(s){const i=[];return s.forEach(r=>{i.push(r)}),`Set(${s.size}) {${i.join(", ")}}`}e.setToString=I;class M{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const r=i.charCodeAt(0),o=this._value.charCodeAt(this._pos);return r-o}value(){return this._value[this._pos]}}e.StringIterator=M;class E{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class b{constructor(i=!0,r=!0){this._splitOnBackslash=i,this._caseSensitive=r}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let r=i.length-1;r>=0;r--,this._valueLen--){const o=this._value.charCodeAt(r);if(!(o===47||this._splitOnBackslash&&o===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=b;var p;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(p||(p={}));class t{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new b(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,n.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=t;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(g||(g={}));class y{constructor(i){this._iter=i}static forUris(i=()=>!1){return new y(new t(i))}static forPaths(i=!1){return new y(new b(void 0,!i))}static forStrings(){return new y(new M)}static forConfigKeys(){return new y(new E)}clear(){this._root=void 0}fill(i,r){if(r){const o=r.slice(0);(0,w.shuffle)(o);for(let l of o)this.set(l,i)}else{const o=i.slice(0);(0,w.shuffle)(o);for(let l of o)this.set(l[0],l[1])}}set(i,r){const o=this._iter.reset(i);let l;this._root||(this._root=new h,this._root.segment=o.value());const v=[];for(l=this._root;;){const R=o.cmp(l.segment);if(R>0)l.left||(l.left=new h,l.left.segment=o.value()),v.push([-1,l]),l=l.left;else if(R<0)l.right||(l.right=new h,l.right.segment=o.value()),v.push([1,l]),l=l.right;else if(o.hasNext())o.next(),l.mid||(l.mid=new h,l.mid.segment=o.value()),v.push([0,l]),l=l.mid;else break}const C=l.value;l.value=r,l.key=i;for(let R=v.length-1;R>=0;R--){const W=v[R][1];W.updateHeight();const U=W.balanceFactor();if(U<-1||U>1){const G=v[R][0],ee=v[R+1][0];if(G===1&&ee===1)v[R][1]=W.rotateLeft();else if(G===-1&&ee===-1)v[R][1]=W.rotateRight();else if(G===1&&ee===-1)W.right=v[R+1][1]=v[R+1][1].rotateRight(),v[R][1]=W.rotateLeft();else if(G===-1&&ee===1)W.left=v[R+1][1]=v[R+1][1].rotateLeft(),v[R][1]=W.rotateRight();else throw new Error;if(R>0)switch(v[R-1][0]){case-1:v[R-1][1].left=v[R][1];break;case 1:v[R-1][1].right=v[R][1];break;case 0:v[R-1][1].mid=v[R][1];break}else this._root=v[0][1]}}return C}get(i){return this._getNode(i)?.value}_getNode(i){const r=this._iter.reset(i);let o=this._root;for(;o;){const l=r.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else break}return o}has(i){const r=this._getNode(i);return!(r?.value===void 0&&r?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,r){const o=this._iter.reset(i),l=[];let v=this._root;for(;v;){const C=o.cmp(v.segment);if(C>0)l.push([-1,v]),v=v.left;else if(C<0)l.push([1,v]),v=v.right;else if(o.hasNext())o.next(),l.push([0,v]),v=v.mid;else break}if(!!v){if(r?(v.left=void 0,v.mid=void 0,v.right=void 0,v.height=1):(v.key=void 0,v.value=void 0),!v.mid&&!v.value)if(v.left&&v.right){const C=this._min(v.right),{key:R,value:W,segment:U}=C;this._delete(C.key,!1),v.key=R,v.value=W,v.segment=U}else{const C=v.left??v.right;if(l.length>0){const[R,W]=l[l.length-1];switch(R){case-1:W.left=C;break;case 0:W.mid=C;break;case 1:W.right=C;break}}else this._root=C}for(let C=l.length-1;C>=0;C--){const R=l[C][1];R.updateHeight();const W=R.balanceFactor();if(W>1?(R.right.balanceFactor()>=0||(R.right=R.right.rotateRight()),l[C][1]=R.rotateLeft()):W<-1&&(R.left.balanceFactor()<=0||(R.left=R.left.rotateLeft()),l[C][1]=R.rotateRight()),C>0)switch(l[C-1][0]){case-1:l[C-1][1].left=l[C][1];break;case 1:l[C-1][1].right=l[C][1];break;case 0:l[C-1][1].mid=l[C][1];break}else this._root=l[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const r=this._iter.reset(i);let o=this._root,l;for(;o;){const v=r.cmp(o.segment);if(v>0)o=o.left;else if(v<0)o=o.right;else if(r.hasNext())r.next(),l=o.value||l,o=o.mid;else break}return o&&o.value||l}findSuperstr(i){const r=this._iter.reset(i);let o=this._root;for(;o;){const l=r.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(i){for(const[r,o]of this)i(o,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=r=>{if(!r)return!0;const o=r.balanceFactor();return o<-1||o>1?!1:i(r.left)&&i(r.right)};return i(this._root)}}e.TernarySearchTree=y;class k{constructor(i,r){this.uri=i,this.value=r}}class d{constructor(i,r){this[L]="ResourceMap",i instanceof d?(this.map=new Map(i.map),this.toKey=r??d.defaultToKey):(this.map=new Map,this.toKey=i??d.defaultToKey)}set(i,r){return this.map.set(this.toKey(i),new k(i,r)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,r){typeof r!="undefined"&&(i=i.bind(r));for(let[o,l]of this.map)i(l.value,l.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=d,d.defaultToKey=s=>s.toString();var u;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(u=e.Touch||(e.Touch={}));class c{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,r=0){const o=this._map.get(i);if(!!o)return r!==0&&this.touch(o,r),o.value}set(i,r,o=0){let l=this._map.get(i);if(l)l.value=r,o!==0&&this.touch(l,o);else{switch(l={key:i,value:r,next:void 0,previous:void 0},o){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(i,l),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const r=this._map.get(i);if(!!r)return this._map.delete(i),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,r){const o=this._state;let l=this._head;for(;l;){if(r?i.bind(r)(l.value,l.key,this):i(l.value,l.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const i=this,r=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const v={value:o.key,done:!1};return o=o.next,v}else return{value:void 0,done:!0}}};return l}values(){const i=this,r=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const v={value:o.value,done:!1};return o=o.next,v}else return{value:void 0,done:!0}}};return l}entries(){const i=this,r=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const v={value:[o.key,o.value],done:!1};return o=o.next,v}else return{value:void 0,done:!0}}};return l}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let r=this._head,o=this.size;for(;r&&o>i;)this._map.delete(r.key),r=r.next,o--;this._head=r,this._size=o,r&&(r.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const r=i.next,o=i.previous;if(!r||!o)throw new Error("Invalid list");r.previous=o,o.next=r}i.next=void 0,i.previous=void 0,this._state++}touch(i,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(i===this._head)return;const o=i.next,l=i.previous;i===this._tail?(l.next=void 0,this._tail=l):(o.previous=l,l.next=o),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(r===2){if(i===this._tail)return;const o=i.next,l=i.previous;i===this._head?(o.previous=void 0,this._head=o):(o.previous=l,l.next=o),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((r,o)=>{i.push([o,r])}),i}fromJSON(i){this.clear();for(const[r,o]of i)this.set(r,o)}}e.LinkedMap=c;class a extends c{constructor(i,r=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,r=2){return super.get(i,r)}peek(i){return super.get(i,0)}set(i,r){return super.set(i,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class f{constructor(i){P.set(this,void 0),Dt(this,P,i,"f")}get size(){return Je(this,P,"f").size}forEach(i,r){Je(this,P,"f").forEach(i,r)}get(i){return Je(this,P,"f").get(i)}has(i){return Je(this,P,"f").has(i)}entries(){return Je(this,P,"f").entries()}keys(){return Je(this,P,"f").keys()}values(){return Je(this,P,"f").values()}[(P=new WeakMap,Symbol.iterator)](){return Je(this,P,"f").entries()}}e.ReadonlyMapView=f}),define(Z[70],x([0,1,35]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new w.LRUCache(1e4);function L(I){return m(I,"NFC",n)}e.normalizeNFC=L;const D=new w.LRUCache(1e4);function P(I){return m(I,"NFD",D)}e.normalizeNFD=P;const S=/[^\u0000-\u0080]/;function m(I,M,E){if(!I)return I;const b=E.get(I);if(b)return b;let p;return S.test(I)?p=I.normalize(M):p=I,E.set(I,p),p}e.removeAccents=function(){const I=/[\u0300-\u036f]/g;return function(M){return P(M).replace(I,"")}}()}),define(Z[14],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function w(o){return Array.isArray(o)}e.isArray=w;function n(o){return typeof o=="string"}e.isString=n;function L(o){return Array.isArray(o)&&o.every(l=>n(l))}e.isStringArray=L;function D(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.isObject=D;function P(o){return typeof o=="number"&&!isNaN(o)}e.isNumber=P;function S(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.isIterable=S;function m(o){return o===!0||o===!1}e.isBoolean=m;function I(o){return typeof o=="undefined"}e.isUndefined=I;function M(o){return!E(o)}e.isDefined=M;function E(o){return I(o)||o===null}e.isUndefinedOrNull=E;function b(o,l){if(!o)throw new Error(l?`Unexpected type, expected '${l}'`:"Unexpected type")}e.assertType=b;function p(o){if(E(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.assertIsDefined=p;function t(...o){const l=[];for(let v=0;v<o.length;v++){const C=o[v];if(E(C))throw new Error(`Assertion Failed: argument at index ${v} is undefined or null`);l.push(C)}return l}e.assertAllDefined=t;const h=Object.prototype.hasOwnProperty;function g(o){if(!D(o))return!1;for(let l in o)if(h.call(o,l))return!1;return!0}e.isEmptyObject=g;function y(o){return typeof o=="function"}e.isFunction=y;function k(...o){return o.length>0&&o.every(y)}e.areFunctions=k;function d(o,l){const v=Math.min(o.length,l.length);for(let C=0;C<v;C++)u(o[C],l[C])}e.validateConstraints=d;function u(o,l){if(n(l)){if(typeof o!==l)throw new Error(`argument does not match constraint: typeof ${l}`)}else if(y(l)){try{if(o instanceof l)return}catch{}if(!E(o)&&o.constructor===l||l.length===1&&l.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=u;function c(o){let l=[],v=Object.getPrototypeOf(o);for(;Object.prototype!==v;)l=l.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return l}e.getAllPropertyNames=c;function a(o){const l=[];for(const v of c(o))typeof o[v]=="function"&&l.push(v);return l}e.getAllMethodNames=a;function f(o,l){const v=R=>function(){const W=Array.prototype.slice.call(arguments,0);return l(R,W)};let C={};for(const R of o)C[R]=v(R);return C}e.createProxyObject=f;function s(o){return o===null?void 0:o}e.withNullAsUndefined=s;function i(o){return typeof o=="undefined"?null:o}e.withUndefinedAsNull=i;function r(o,l="Unreachable"){throw new Error(l)}e.assertNever=r}),define(Z[28],x([0,1,7,2,27,14]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function P(r){return r===47||r===92}e.isPathSeparator=P;function S(r){return r.replace(/[\\/]/g,w.posix.sep)}e.toSlashes=S;function m(r){return r.indexOf("/")===-1&&(r=S(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=m;function I(r,o=w.posix.sep){if(!r)return"";const l=r.length,v=r.charCodeAt(0);if(P(v)){if(P(r.charCodeAt(1))&&!P(r.charCodeAt(2))){let R=3;const W=R;for(;R<l&&!P(r.charCodeAt(R));R++);if(W!==R&&!P(r.charCodeAt(R+1))){for(R+=1;R<l;R++)if(P(r.charCodeAt(R)))return r.slice(0,R+1).replace(/[\\/]/g,o)}}return o}else if(y(v)&&r.charCodeAt(1)===58)return P(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let C=r.indexOf("://");if(C!==-1){for(C+=3;C<l;C++)if(P(r.charCodeAt(C)))return r.slice(0,C+1)}return""}e.getRoot=I;function M(r){if(!n.isWindows||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let l=2;const v=l;for(;l<r.length&&(o=r.charCodeAt(l),o!==92);l++);return!(v===l||(o=r.charCodeAt(l+1),isNaN(o)||o===92))}e.isUNC=M;const E=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(r,o=n.isWindows){const l=o?E:b;return!(!r||r.length===0||/^\s+$/.test(r)||(l.lastIndex=0,l.test(r))||o&&p.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=t;function h(r,o,l){const v=r===o;return!l||v?v:!r||!o?!1:(0,L.equalsIgnoreCase)(r,o)}e.isEqual=h;function g(r,o,l,v=w.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(l){if(!(0,L.startsWithIgnoreCase)(r,o))return!1;if(o.length===r.length)return!0;let R=o.length;return o.charAt(o.length-1)===v&&R--,r.charAt(R)===v}return o.charAt(o.length-1)!==v&&(o+=v),r.indexOf(o)===0}e.isEqualOrParent=g;function y(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=y;function k(r,o){return n.isWindows&&r.endsWith(":")&&(r+=w.sep),(0,w.isAbsolute)(r)||(r=(0,w.join)(o,r)),r=(0,w.normalize)(r),n.isWindows?(r=(0,L.rtrim)(r,w.sep),r.endsWith(":")&&(r+=w.sep)):(r=(0,L.rtrim)(r,w.sep),r||(r=w.sep)),r}e.sanitizeFilePath=k;function d(r){const o=(0,w.normalize)(r);return n.isWindows?r.length>3?!1:u(o)&&(r.length===2||o.charCodeAt(2)===92):o===w.posix.sep}e.isRootOrDriveLetter=d;function u(r,o){return(o!==void 0?o:n.isWindows)?y(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=u;function c(r){return u(r)?r[0]:void 0}e.getDriveLetter=c;function a(r,o,l){return o.length>r.length?-1:r===o?0:(l&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.indexOfPath=a;function f(r){const o=r.split(":");let l,v,C;for(const R of o){const W=Number(R);(0,D.isNumber)(W)?v===void 0?v=W:C===void 0&&(C=W):l=l?[l,R].join(":"):R}if(!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:v!==void 0?v:void 0,column:C!==void 0?C:v!==void 0?1:void 0}}e.parseLineAndColumnAware=f;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(r,o,l=8){let v="";for(let R=0;R<l;R++)v+=s.charAt(Math.floor(Math.random()*s.length));let C;return o?C=`${o}-${v}`:C=v,r?(0,w.join)(r,C):C}e.randomPath=i}),define(Z[49],x([0,1,14]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const g=Array.isArray(h)?[]:{};return Object.keys(h).forEach(y=>{h[y]&&typeof h[y]=="object"?g[y]=n(h[y]):g[y]=h[y]}),g}e.deepClone=n;function L(h){if(!h||typeof h!="object")return h;const g=[h];for(;g.length>0;){const y=g.shift();Object.freeze(y);for(const k in y)if(D.call(y,k)){const d=y[k];typeof d=="object"&&!Object.isFrozen(d)&&g.push(d)}}return h}e.deepFreeze=L;const D=Object.prototype.hasOwnProperty;function P(h,g){return S(h,g,new Set)}e.cloneAndChange=P;function S(h,g,y){if((0,w.isUndefinedOrNull)(h))return h;const k=g(h);if(typeof k!="undefined")return k;if((0,w.isArray)(h)){const d=[];for(const u of h)d.push(S(u,g,y));return d}if((0,w.isObject)(h)){if(y.has(h))throw new Error("Cannot clone recursive data-structure");y.add(h);const d={};for(let u in h)D.call(h,u)&&(d[u]=S(h[u],g,y));return y.delete(h),d}return h}function m(h,g,y=!0){return(0,w.isObject)(h)?((0,w.isObject)(g)&&Object.keys(g).forEach(k=>{k in h?y&&((0,w.isObject)(h[k])&&(0,w.isObject)(g[k])?m(h[k],g[k],y):h[k]=g[k]):h[k]=g[k]}),h):g}e.mixin=m;function I(h,g){if(h===g)return!0;if(h==null||g===null||g===void 0||typeof h!=typeof g||typeof h!="object"||Array.isArray(h)!==Array.isArray(g))return!1;let y,k;if(Array.isArray(h)){if(h.length!==g.length)return!1;for(y=0;y<h.length;y++)if(!I(h[y],g[y]))return!1}else{const d=[];for(k in h)d.push(k);d.sort();const u=[];for(k in g)u.push(k);if(u.sort(),!I(d,u))return!1;for(y=0;y<d.length;y++)if(!I(h[d[y]],g[d[y]]))return!1}return!0}e.equals=I;function M(h){const g=new Set;return JSON.stringify(h,(y,k)=>{if((0,w.isObject)(k)||Array.isArray(k)){if(g.has(k))return"[Circular]";g.add(k)}return k})}e.safeStringify=M;function E(h,g,y){const k=g(h);return typeof k=="undefined"?y:k}e.getOrDefault=E;function b(h,g){const y=Object.create(null);return!h||!g||Object.keys(g).forEach(d=>{const u=h[d],c=g[d];I(u,c)||(y[d]=c)}),y}e.distinct=b;function p(h,g){const y=g.toLowerCase(),k=Object.keys(h).find(d=>d.toLowerCase()===y);return k?h[k]:h[g]}e.getCaseInsensitive=p;function t(h,g){const y=Object.create(null);for(const[k,d]of Object.entries(h))g(k,d)&&(y[k]=d);return y}e.filter=t}),define(Z[8],x([0,1,7,2]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,D=/^\//,P=/^\/\//;function S(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!L.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!D.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(s,i){return!s&&!i?"file":s}function I(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==E&&(i=E+i):i=E;break}return i}const M="",E="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(i,r,o,l,v,C=!1){typeof i=="object"?(this.scheme=i.scheme||M,this.authority=i.authority||M,this.path=i.path||M,this.query=i.query||M,this.fragment=i.fragment||M):(this.scheme=m(i,C),this.authority=r||M,this.path=I(this.scheme,o||M),this.query=l||M,this.fragment=v||M,S(this,C))}static isUri(i){return i instanceof p?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return d(this,!1)}with(i){if(!i)return this;let{scheme:r,authority:o,path:l,query:v,fragment:C}=i;return r===void 0?r=this.scheme:r===null&&(r=M),o===void 0?o=this.authority:o===null&&(o=M),l===void 0?l=this.path:l===null&&(l=M),v===void 0?v=this.query:v===null&&(v=M),C===void 0?C=this.fragment:C===null&&(C=M),r===this.scheme&&o===this.authority&&l===this.path&&v===this.query&&C===this.fragment?this:new h(r,o,l,v,C)}static parse(i,r=!1){const o=b.exec(i);return o?new h(o[2]||M,f(o[4]||M),f(o[5]||M),f(o[7]||M),f(o[9]||M),r):new h(M,M,M,M,M)}static file(i){let r=M;if(n.isWindows&&(i=i.replace(/\\/g,E)),i[0]===E&&i[1]===E){const o=i.indexOf(E,2);o===-1?(r=i.substring(2),i=E):(r=i.substring(2,o),i=i.substring(o)||E)}return new h("file",r,i,M,M)}static from(i){const r=new h(i.scheme,i.authority,i.path,i.query,i.fragment);return S(r,!0),r}static joinPath(i,...r){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return n.isWindows&&i.scheme==="file"?o=p.file(w.win32.join(d(i,!0),...r)).path:o=w.posix.join(i.path,...r),i.with({path:o})}toString(i=!1){return u(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof p)return i;{const r=new h(i);return r._formatted=i.external,r._fsPath=i._sep===t?i.fsPath:null,r}}else return i}}e.URI=p;const t=n.isWindows?1:void 0;class h extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(i=!1){return i?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=t),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function y(s,i){let r,o=-1;for(let l=0;l<s.length;l++){const v=s.charCodeAt(l);if(v>=97&&v<=122||v>=65&&v<=90||v>=48&&v<=57||v===45||v===46||v===95||v===126||i&&v===47)o!==-1&&(r+=encodeURIComponent(s.substring(o,l)),o=-1),r!==void 0&&(r+=s.charAt(l));else{r===void 0&&(r=s.substr(0,l));const C=g[v];C!==void 0?(o!==-1&&(r+=encodeURIComponent(s.substring(o,l)),o=-1),r+=C):o===-1&&(o=l)}}return o!==-1&&(r+=encodeURIComponent(s.substring(o))),r!==void 0?r:s}function k(s){let i;for(let r=0;r<s.length;r++){const o=s.charCodeAt(r);o===35||o===63?(i===void 0&&(i=s.substr(0,r)),i+=g[o]):i!==void 0&&(i+=s[r])}return i!==void 0?i:s}function d(s,i){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,n.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=d;function u(s,i){const r=i?k:y;let o="",{scheme:l,authority:v,path:C,query:R,fragment:W}=s;if(l&&(o+=l,o+=":"),(v||l==="file")&&(o+=E,o+=E),v){let U=v.indexOf("@");if(U!==-1){const G=v.substr(0,U);v=v.substr(U+1),U=G.indexOf(":"),U===-1?o+=r(G,!1):(o+=r(G.substr(0,U),!1),o+=":",o+=r(G.substr(U+1),!1)),o+="@"}v=v.toLowerCase(),U=v.indexOf(":"),U===-1?o+=r(v,!1):(o+=r(v.substr(0,U),!1),o+=v.substr(U))}if(C){if(C.length>=3&&C.charCodeAt(0)===47&&C.charCodeAt(2)===58){const U=C.charCodeAt(1);U>=65&&U<=90&&(C=`/${String.fromCharCode(U+32)}:${C.substr(3)}`)}else if(C.length>=2&&C.charCodeAt(1)===58){const U=C.charCodeAt(0);U>=65&&U<=90&&(C=`${String.fromCharCode(U+32)}:${C.substr(2)}`)}o+=r(C,!0)}return R&&(o+="?",o+=r(R,!1)),W&&(o+="#",o+=i?W:y(W,!1)),o}function c(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+c(s.substr(3)):s}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function f(s){return s.match(a)?s.replace(a,i=>c(i)):s}}),define(Z[114],x([0,1,8]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(I){const M=I;return M&&typeof M.type=="string"&&typeof M.severity=="string"}e.isRemoteConsoleLog=n;function L(I){const M=[];let E;try{const b=JSON.parse(I.arguments),p=b[b.length-1];p&&p.__$stack&&(b.pop(),E=p.__$stack),M.push(...b)}catch{M.push("Unable to log remote console arguments",I.arguments)}return{args:M,stack:E}}e.parse=L;function D(I){if(typeof I!="string")return D(L(I).stack);const M=I;if(M){const E=P(M),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(b&&b.length===4)return{uri:w.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.getFirstFrame=D;function P(I){if(!I)return I;const M=I.indexOf(`
`);return M===-1?I:I.substring(0,M)}function S(I,M){const{args:E,stack:b}=L(I),p=typeof E[0]=="string"&&E.length===1;let t=P(b);t&&(t=`(${t.trim()})`);let h=[];if(typeof E[0]=="string"?t&&p?h=[`%c[${M}] %c${E[0]} %c${t}`,m("blue"),m(""),m("grey")]:h=[`%c[${M}] %c${E[0]}`,m("blue"),m(""),...E.slice(1)]:h=[`%c[${M}]%`,m("blue"),...E],t&&!p&&h.push(t),typeof console[I.severity]!="function")throw new Error("Unknown console method");console[I.severity].apply(console,h)}e.log=S;function m(I){return`color: ${I}`}}),define(Z[115],x([0,1,16,27,8]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function D(M){return JSON.stringify(M,m)}e.stringify=D;function P(M){let E=JSON.parse(M);return E=I(E),E}e.parse=P;var S;(function(M){M[M.Uri=1]="Uri",M[M.Regexp=2]="Regexp",M[M.ScmResource=3]="ScmResource",M[M.ScmResourceGroup=4]="ScmResourceGroup",M[M.ScmProvider=5]="ScmProvider",M[M.CommentController=6]="CommentController",M[M.CommentThread=7]="CommentThread",M[M.CommentThreadReply=8]="CommentThreadReply",M[M.CommentNode=9]="CommentNode",M[M.CommentThreadNode=10]="CommentThreadNode",M[M.TimelineActionContext=11]="TimelineActionContext",M[M.NotebookCellActionContext=12]="NotebookCellActionContext",M[M.TestItemContext=13]="TestItemContext",M[M.Date=14]="Date"})(S=e.MarshalledId||(e.MarshalledId={}));function m(M,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:(0,n.regExpFlags)(E)}:E}function I(M,E=0){if(!M||E>200)return M;if(typeof M=="object"){switch(M.$mid){case 1:return L.URI.revive(M);case 2:return new RegExp(M.source,M.flags);case 14:return new Date(M.source)}if(M instanceof w.VSBuffer||M instanceof Uint8Array)return M;if(Array.isArray(M))for(let b=0;b<M.length;++b)M[b]=I(M[b],E+1);else for(const b in M)Object.hasOwnProperty.call(M,b)&&(M[b]=I(M[b],E+1))}return M}e.revive=I}),define(Z[10],x([0,1,2,8]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var L;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.userData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractive="vscode-interactive",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls"})(L=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class D{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(m){this._preferredWebSchema=m}setDelegate(m){this._delegate=m}set(m,I,M){this._hosts[m]=I,this._ports[m]=M}setConnectionToken(m,I){this._connectionTokens[m]=I}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(m){if(this._delegate)return this._delegate(m);const I=m.authority;let M=this._hosts[I];M&&M.indexOf(":")!==-1&&(M=`[${M}]`);const E=this._ports[I],b=this._connectionTokens[I];let p=`path=${encodeURIComponent(m.path)}`;return typeof b=="string"&&(p+=`&${e.connectionTokenQueryName}=${encodeURIComponent(b)}`),n.URI.from({scheme:w.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${M}:${E}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new D;class P{asBrowserUri(m,I){const M=this.toUri(m,I);return M.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(M):M.scheme===L.file&&(w.isNative||typeof w.globals.importScripts=="function"&&w.globals.origin===`${L.vscodeFileResource}://${P.FALLBACK_AUTHORITY}`)?M.with({scheme:L.vscodeFileResource,authority:M.authority||P.FALLBACK_AUTHORITY,query:null,fragment:null}):M}asFileUri(m,I){const M=this.toUri(m,I);return M.scheme===L.vscodeFileResource?M.with({scheme:L.file,authority:M.authority!==P.FALLBACK_AUTHORITY?M.authority:null,query:null,fragment:null}):M}toUri(m,I){return n.URI.isUri(m)?m:n.URI.parse(I.toUrl(m))}}P.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new P}),define(Z[17],x([0,1,28,10,7,2,27,8]),function(V,e,w,n,L,D,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function m(p){return(0,S.uriToFsPath)(p,!0)}e.originalFSPath=m;class I{constructor(t){this._ignorePathCasing=t}compare(t,h,g=!1){return t===h?0:(0,P.compare)(this.getComparisonKey(t,g),this.getComparisonKey(h,g))}isEqual(t,h,g=!1){return t===h?!0:!t||!h?!1:this.getComparisonKey(t,g)===this.getComparisonKey(h,g)}getComparisonKey(t,h=!1){return t.with({path:this._ignorePathCasing(t)?t.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(t){return this._ignorePathCasing(t)}isEqualOrParent(t,h,g=!1){if(t.scheme===h.scheme){if(t.scheme===n.Schemas.file)return w.isEqualOrParent(m(t),m(h),this._ignorePathCasing(t))&&t.query===h.query&&(g||t.fragment===h.fragment);if((0,e.isEqualAuthority)(t.authority,h.authority))return w.isEqualOrParent(t.path,h.path,this._ignorePathCasing(t),"/")&&t.query===h.query&&(g||t.fragment===h.fragment)}return!1}joinPath(t,...h){return S.URI.joinPath(t,...h)}basenameOrAuthority(t){return(0,e.basename)(t)||t.authority}basename(t){return L.posix.basename(t.path)}extname(t){return L.posix.extname(t.path)}dirname(t){if(t.path.length===0)return t;let h;return t.scheme===n.Schemas.file?h=S.URI.file(L.dirname(m(t))).path:(h=L.posix.dirname(t.path),t.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${t.toString})) resulted in a relative path`),h="/")),t.with({path:h})}normalizePath(t){if(!t.path.length)return t;let h;return t.scheme===n.Schemas.file?h=S.URI.file(L.normalize(m(t))).path:h=L.posix.normalize(t.path),t.with({path:h})}relativePath(t,h){if(t.scheme!==h.scheme||!(0,e.isEqualAuthority)(t.authority,h.authority))return;if(t.scheme===n.Schemas.file){const k=L.relative(m(t),m(h));return D.isWindows?w.toSlashes(k):k}let g=t.path||"/",y=h.path||"/";if(this._ignorePathCasing(t)){let k=0;for(const d=Math.min(g.length,y.length);k<d&&!(g.charCodeAt(k)!==y.charCodeAt(k)&&g.charAt(k).toLowerCase()!==y.charAt(k).toLowerCase());k++);g=y.substr(0,k)+g.substr(k)}return L.posix.relative(g,y)}resolvePath(t,h){if(t.scheme===n.Schemas.file){const g=S.URI.file(L.resolve(m(t),h));return t.with({authority:g.authority,path:g.path})}return h=w.toPosixPath(h),t.with({path:L.posix.resolve(t.path,h)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,h){return t===h||t!==void 0&&h!==void 0&&(0,P.equalsIgnoreCase)(t,h)}hasTrailingPathSeparator(t,h=L.sep){if(t.scheme===n.Schemas.file){const g=m(t);return g.length>w.getRoot(g).length&&g[g.length-1]===h}else{const g=t.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,h=L.sep){return(0,e.hasTrailingPathSeparator)(t,h)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,h=L.sep){let g=!1;if(t.scheme===n.Schemas.file){const y=m(t);g=y!==void 0&&y.length===w.getRoot(y).length&&y[y.length-1]===h}else{h="/";const y=t.path;g=y.length===1&&y.charCodeAt(y.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(t,h)?t.with({path:t.path+"/"}):t}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(p=>p.scheme===n.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new I(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function M(p,t){const h=[];for(let g=0;g<p.length;g++){const y=t(p[g]);p.some((k,d)=>d===g?!1:(0,e.isEqualOrParent)(y,t(k)))||h.push(p[g])}return h}e.distinctParents=M;var E;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function t(h){const g=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(d=>{const[u,c]=d.split(":");u&&c&&g.set(u,c)});const k=h.path.substring(0,h.path.indexOf(";"));return k&&g.set(p.META_DATA_MIME,k),g}p.parseMetaData=t})(E=e.DataUri||(e.DataUri={}));function b(p,t,h){if(t){let g=p.path;return g&&g[0]!==L.posix.sep&&(g=L.posix.sep+g),p.with({scheme:h,authority:t,path:g})}return p.with({scheme:h})}e.toLocalResource=b}),define(Z[9],x([0,1,23,15,4,3,17,2]),function(V,e,w,n,L,D,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function m(T){return!!T&&typeof T.then=="function"}e.isThenable=m;function I(T){const A=new w.CancellationTokenSource,O=T(A.token),_=new Promise((j,ie)=>{const ae=A.token.onCancellationRequested(()=>{ae.dispose(),A.dispose(),ie(new n.CancellationError)});Promise.resolve(O).then(ce=>{ae.dispose(),A.dispose(),j(ce)},ce=>{ae.dispose(),A.dispose(),ie(ce)})});return new class{cancel(){A.cancel()}then(j,ie){return _.then(j,ie)}catch(j){return this.then(void 0,j)}finally(j){return _.finally(j)}}}e.createCancelablePromise=I;function M(T,A,O){return new Promise((_,j)=>{const ie=A.onCancellationRequested(()=>{ie.dispose(),_(O)});T.then(_,j).finally(()=>ie.dispose())})}e.raceCancellation=M;function E(T,A){return new Promise((O,_)=>{const j=A.onCancellationRequested(()=>{j.dispose(),_(new n.CancellationError)});T.then(O,_).finally(()=>j.dispose())})}e.raceCancellationError=E;async function b(T){let A=-1;const O=T.map((j,ie)=>j.then(ae=>(A=ie,ae))),_=await Promise.race(O);return T.forEach((j,ie)=>{ie!==A&&j.cancel()}),_}e.raceCancellablePromises=b;function p(T,A,O){let _;const j=setTimeout(()=>{_?.(void 0),O?.()},A);return Promise.race([T.finally(()=>clearTimeout(j)),new Promise(ie=>_=ie)])}e.raceTimeout=p;function t(T){return new Promise((A,O)=>{const _=T();m(_)?_.then(A,O):A(_)})}e.asPromise=t;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(A){if(this.activePromise){if(this.queuedPromiseFactory=A,!this.queuedPromise){const O=()=>{this.queuedPromise=null;const _=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_};this.queuedPromise=new Promise(_=>{this.activePromise.then(O,O).then(_)})}return new Promise((O,_)=>{this.queuedPromise.then(O,_)})}return this.activePromise=A(),new Promise((O,_)=>{this.activePromise.then(j=>{this.activePromise=null,O(j)},j=>{this.activePromise=null,_(j)})})}}e.Throttler=h;class g{constructor(){this.current=Promise.resolve(null)}queue(A){return this.current=this.current.then(()=>A(),()=>A())}}e.Sequencer=g;class y{constructor(){this.promiseMap=new Map}queue(A,O){const j=(this.promiseMap.get(A)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.promiseMap.get(A)===j&&this.promiseMap.delete(A)});return this.promiseMap.set(A,j),j}}e.SequencerByKey=y;const k=(T,A)=>{let O=!0;const _=setTimeout(()=>{O=!1,A()},T);return{isTriggered:()=>O,dispose:()=>{clearTimeout(_),O=!1}}},d=T=>{let A=!0;return queueMicrotask(()=>{A&&(A=!1,T())}),{isTriggered:()=>A,dispose:()=>{A=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class u{constructor(A){this.defaultDelay=A,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(A,O=this.defaultDelay){this.task=A,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((j,ie)=>{this.doResolve=j,this.doReject=ie}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const j=this.task;return this.task=null,j()}}));const _=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=O===e.MicrotaskDelay?d(_):k(O,_),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=u;class c{constructor(A){this.delayer=new u(A),this.throttler=new h}trigger(A,O){return this.delayer.trigger(()=>this.throttler.queue(A),O)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class a{constructor(){this._isOpen=!1,this._promise=new Promise((A,O)=>{this._completePromise=A})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=a;class f extends a{constructor(A){super();this._timeout=setTimeout(()=>this.open(),A)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=f;function s(T,A){return A?new Promise((O,_)=>{const j=setTimeout(()=>{ie.dispose(),O()},T),ie=A.onCancellationRequested(()=>{clearTimeout(j),ie.dispose(),_(new n.CancellationError)})}):I(O=>s(T,O))}e.timeout=s;function i(T,A=0){const O=setTimeout(T,A);return(0,D.toDisposable)(()=>clearTimeout(O))}e.disposableTimeout=i;function r(T){const A=[];let O=0;const _=T.length;function j(){return O<_?T[O++]():null}function ie(ae){ae!=null&&A.push(ae);const ce=j();return ce?ce.then(ie):Promise.resolve(A)}return Promise.resolve(null).then(ie)}e.sequence=r;function o(T,A=_=>!!_,O=null){let _=0;const j=T.length,ie=()=>{if(_>=j)return Promise.resolve(O);const ae=T[_++];return Promise.resolve(ae()).then(ne=>A(ne)?Promise.resolve(ne):ie())};return ie()}e.first=o;function l(T,A=_=>!!_,O=null){if(T.length===0)return Promise.resolve(O);let _=T.length;const j=()=>{_=-1;for(const ie of T)ie.cancel?.()};return new Promise((ie,ae)=>{for(const ce of T)ce.then(ne=>{--_>=0&&A(ne)?(j(),ie(ne)):_===0&&ie(O)}).catch(ne=>{--_>=0&&(j(),ae(ne))})})}e.firstParallel=l;class v{constructor(A){this._size=0,this.maxDegreeOfParalellism=A,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new L.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(A){return this._size++,new Promise((O,_)=>{this.outstandingPromises.push({factory:A,c:O,e:_}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const A=this.outstandingPromises.shift();this.runningPromises++;const O=A.factory();O.then(A.c,A.e),O.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=v;class C extends v{constructor(){super(1)}}e.Queue=C;class R{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const A=new $;return this.drainers.add(A),A.p}isDrained(){for(const[,A]of this.queues)if(A.size>0)return!1;return!0}queueFor(A,O=P.extUri){const _=O.getComparisonKey(A);let j=this.queues.get(_);return j||(j=new C,L.Event.once(j.onFinished)(()=>{j?.dispose(),this.queues.delete(_),this.onDidQueueFinish()}),this.queues.set(_,j)),j}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const A of this.drainers)A.complete();this.drainers.clear()}dispose(){for(const[,A]of this.queues)A.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=R;class W{constructor(A,O){this._token=-1,typeof A=="function"&&typeof O=="number"&&this.setIfNotSet(A,O)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(A,O){this.cancel(),this._token=setTimeout(()=>{this._token=-1,A()},O)}setIfNotSet(A,O){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,A()},O))}}e.TimeoutTimer=W;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(A,O){this.cancel(),this._token=setInterval(()=>{A()},O)}}e.IntervalTimer=U;class G{constructor(A,O){this.timeoutToken=-1,this.runner=A,this.timeout=O,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(A=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,A)}get delay(){return this.timeout}set delay(A){this.timeout=A}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=G;class ee{constructor(A,O){O%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.runner=A,this.timeout=O,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(A=this.timeout){A%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(A/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=ee;class X extends G{constructor(A,O){super(A,O);this.units=[]}work(A){this.units.push(A),this.isScheduled()||this.schedule()}doRun(){const A=this.units;this.units=[],this.runner&&this.runner(A)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=X;class J extends D.Disposable{constructor(A,O){super();this.options=A,this.handler=O,this.pendingWork=[],this.throttler=this._register(new D.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(A){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+A.length>this.options.maxBufferedWork)return!1}else if(this.pending+A.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...A),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new G(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=J,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=T=>{(0,S.setTimeout0)(()=>{if(A)return;const O=Date.now()+15;T(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let A=!1;return{dispose(){A||(A=!0)}}}:e.runWhenIdle=(T,A)=>{const O=requestIdleCallback(T,typeof A=="number"?{timeout:A}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(O))}}}}();class H{constructor(A){this._didRun=!1,this._executor=()=>{try{this._value=A()}catch(O){this._error=O}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=H;async function B(T,A,O){let _;for(let j=0;j<O;j++)try{return await T()}catch(ie){_=ie,await s(A)}throw _}e.retry=B;class Y{hasPending(A){return this._pending?typeof A=="number"?this._pending.taskId===A:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(A,O,_){return this._pending={taskId:A,cancel:()=>_?.(),promise:O},O.then(()=>this.donePending(A),()=>this.donePending(A)),O}donePending(A){this._pending&&A===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const A=this._next;this._next=void 0,A.run().then(A.promiseResolve,A.promiseReject)}}setNext(A){if(this._next)this._next.run=A;else{let O,_;const j=new Promise((ie,ae)=>{O=ie,_=ae});this._next={run:A,promise:j,promiseResolve:O,promiseReject:_}}return this._next.promise}}e.TaskSequentializer=Y;class se{constructor(A,O=()=>Date.now()){this.interval=A,this.nowFn=O,this.lastIncrementTime=0,this.value=0}increment(){const A=this.nowFn();return A-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=A,this.value=0),this.value++,this.value}}e.IntervalCounter=se;class ${constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((A,O)=>{this.completeCallback=A,this.errorCallback=O})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(A){return new Promise(O=>{this.completeCallback(A),this.resolved=!0,O()})}error(A){return new Promise(O=>{this.errorCallback(A),this.rejected=!0,O()})}cancel(){new Promise(A=>{this.errorCallback(new n.CancellationError),this.rejected=!0,A()})}}e.DeferredPromise=$;var q;(function(T){async function A(_){let j;const ie=await Promise.all(_.map(ae=>ae.then(ce=>ce,ce=>{j||(j=ce)})));if(typeof j!="undefined")throw j;return ie}T.settled=A;function O(_){return new Promise(async(j,ie)=>{try{await _(j,ie)}catch(ae){ie(ae)}})}T.withAsyncBody=O})(q=e.Promises||(e.Promises={}));var Q;(function(T){T[T.Initial=0]="Initial",T[T.DoneOK=1]="DoneOK",T[T.DoneError=2]="DoneError"})(Q||(Q={}));class z{constructor(A){this._state=0,this._results=[],this._error=null,this._onStateChanged=new L.Emitter,queueMicrotask(async()=>{const O={emitOne:_=>this.emitOne(_),emitMany:_=>this.emitMany(_),reject:_=>this.reject(_)};try{await Promise.resolve(A(O)),this.resolve()}catch(_){this.reject(_)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}static fromArray(A){return new z(O=>{O.emitMany(A)})}static fromPromise(A){return new z(async O=>{O.emitMany(await A)})}static fromPromises(A){return new z(async O=>{await Promise.all(A.map(async _=>O.emitOne(await _)))})}static merge(A){return new z(async O=>{await Promise.all(A.map(async _=>{for await(const j of _)O.emitOne(j)}))})}[Symbol.asyncIterator](){let A=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(A<this._results.length)return{done:!1,value:this._results[A++]};if(this._state===1)return{done:!0,value:void 0};await L.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(A,O){return new z(async _=>{for await(const j of A)_.emitOne(O(j))})}map(A){return z.map(this,A)}static filter(A,O){return new z(async _=>{for await(const j of A)O(j)&&_.emitOne(j)})}filter(A){return z.filter(this,A)}static coalesce(A){return z.filter(A,O=>!!O)}coalesce(){return z.coalesce(this)}static async toPromise(A){const O=[];for await(const _ of A)O.push(_);return O}toPromise(){return z.toPromise(this)}emitOne(A){this._state===0&&(this._results.push(A),this._onStateChanged.fire())}emitMany(A){this._state===0&&(this._results=this._results.concat(A),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(A){this._state===0&&(this._state=2,this._error=A,this._onStateChanged.fire())}}e.AsyncIterableObject=z,z.EMPTY=z.fromArray([]);class F extends z{constructor(A,O){super(O);this._source=A}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=F;function N(T){const A=new w.CancellationTokenSource,O=T(A.token);return new F(A,async _=>{const j=A.token.onCancellationRequested(()=>{j.dispose(),A.dispose(),_.reject(new n.CancellationError)});try{for await(const ie of O){if(A.token.isCancellationRequested)return;_.emitOne(ie)}j.dispose(),A.dispose()}catch(ie){j.dispose(),A.dispose(),_.reject(ie)}})}e.createCancelableAsyncIterable=N}),define(Z[116],x([0,1,9,28,35,7,2,27]),function(V,e,w,n,L,D,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function m(){return Object.create(null)}e.getEmptyExpression=m,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const I="[/\\\\]",M="[^/\\\\]",E=/\//g;function b($){switch($){case 0:return"";case 1:return`${M}*?`;default:return`(?:${I}|${M}+${I}|${I}${M}+)*?`}}function p($,q){if(!$)return[];const Q=[];let z=!1,F=!1,N="";for(const T of $){switch(T){case q:if(!z&&!F){Q.push(N),N="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":F=!0;break;case"]":F=!1;break}N+=T}return N&&Q.push(N),Q}e.splitGlobAware=p;function t($){if(!$)return"";let q="";const Q=p($,e.GLOB_SPLIT);if(Q.every(z=>z===e.GLOBSTAR))q=".*";else{let z=!1;Q.forEach((F,N)=>{if(F===e.GLOBSTAR){z||(q+=b(2),z=!0);return}let T=!1,A="",O=!1,_="";for(const j of F){if(j!=="}"&&T){A+=j;continue}if(O&&(j!=="]"||!_)){let ie;j==="-"?ie=j:(j==="^"||j==="!")&&!_?ie="^":j===e.GLOB_SPLIT?ie="":ie=(0,S.escapeRegExpCharacters)(j),_+=ie;continue}switch(j){case"{":T=!0;continue;case"[":O=!0;continue;case"}":{q+=`(?:${p(A,",").map(ce=>t(ce)).join("|")})`,T=!1,A="";break}case"]":q+="["+_+"]",O=!1,_="";break;case"?":q+=M;continue;case"*":q+=b(1);continue;default:q+=(0,S.escapeRegExpCharacters)(j)}}N<Q.length-1&&(Q[N+1]!==e.GLOBSTAR||N+2<Q.length)&&(q+=I),z=!1})}return q}const h=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,y=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,k=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,c=new L.LRUCache(1e4),a=function(){return!1},f=function(){return null};function s($,q){if(!$)return f;let Q;typeof $!="string"?Q=$.pattern:Q=$,Q=Q.trim();const z=`${Q}_${!!q.trimForExclusions}`;let F=c.get(z);if(F)return i(F,$);let N;if(h.test(Q)){const T=Q.substr(4);F=function(A,O){return typeof A=="string"&&A.endsWith(T)?Q:null}}else(N=g.exec(r(Q,q)))?F=o(N[1],Q):(q.trimForExclusions?k:y).test(Q)?F=l(Q,q):(N=d.exec(r(Q,q)))?F=v(N[1].substr(1),Q,!0):(N=u.exec(r(Q,q)))?F=v(N[1],Q,!1):F=C(Q);return c.set(z,F),i(F,$)}function i($,q){return typeof q=="string"?$:function(Q,z){return(0,n.isEqualOrParent)(Q,q.base,!P.isLinux)?$(Q.substr(q.base.length+1),z):null}}function r($,q){return q.trimForExclusions&&$.endsWith("/**")?$.substr(0,$.length-2):$}function o($,q){const Q=`/${$}`,z=`\\${$}`,F=function(T,A){return typeof T!="string"?null:A?A===$?q:null:T===$||T.endsWith(Q)||T.endsWith(z)?q:null},N=[$];return F.basenames=N,F.patterns=[q],F.allBasenames=N,F}function l($,q){const Q=se($.slice(1,-1).split(",").map(A=>s(A,q)).filter(A=>A!==f),$),z=Q.length;if(!z)return f;if(z===1)return Q[0];const F=function(A,O){for(let _=0,j=Q.length;_<j;_++)if(Q[_](A,O))return $;return null},N=Q.find(A=>!!A.allBasenames);N&&(F.allBasenames=N.allBasenames);const T=Q.reduce((A,O)=>O.allPaths?A.concat(O.allPaths):A,[]);return T.length&&(F.allPaths=T),F}function v($,q,Q){const z=D.sep===D.posix.sep,F=z?$:$.replace(E,D.sep),N=D.sep+F,T=D.posix.sep+$,A=Q?function(O,_){return typeof O=="string"&&(O===F||O.endsWith(N)||!z&&(O===$||O.endsWith(T)))?q:null}:function(O,_){return typeof O=="string"&&(O===F||!z&&O===$)?q:null};return A.allPaths=[(Q?"*/":"./")+$],A}function C($){try{const q=new RegExp(`^${t($)}$`);return function(Q){return q.lastIndex=0,typeof Q=="string"&&q.test(Q)?$:null}}catch{return f}}function R($,q,Q){return!$||typeof q!="string"?!1:W($)(q,void 0,Q)}e.match=R;function W($,q={}){if(!$)return a;if(typeof $=="string"||X($)){const Q=s($,q);if(Q===f)return a;const z=function(F,N){return!!Q(F,N)};return Q.allBasenames&&(z.allBasenames=Q.allBasenames),Q.allPaths&&(z.allPaths=Q.allPaths),z}return B($,q)}e.parse=W;function U($){if(!$)return;let q;return Q=>(q||(q=($()||Promise.resolve([])).then(z=>z?ee(z):{})),q.then(z=>!!z[Q]))}e.hasSiblingPromiseFn=U;function G($){if(!$)return;let q;return Q=>{if(!q){const z=$();q=z?ee(z):{}}return!!q[Q]}}e.hasSiblingFn=G;function ee($){const q={};for(const Q of $)q[Q]=!0;return q}function X($){const q=$;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}e.isRelativePattern=X;function J($){return $.allBasenames||[]}e.getBasenameTerms=J;function H($){return $.allPaths||[]}e.getPathTerms=H;function B($,q){const Q=se(Object.getOwnPropertyNames($).map(A=>Y(A,$[A],q)).filter(A=>A!==f)),z=Q.length;if(!z)return f;if(!Q.some(A=>!!A.requiresSiblings)){if(z===1)return Q[0];const A=function(j,ie){for(let ae=0,ce=Q.length;ae<ce;ae++){const ne=Q[ae](j,ie);if(ne)return ne}return null},O=Q.find(j=>!!j.allBasenames);O&&(A.allBasenames=O.allBasenames);const _=Q.reduce((j,ie)=>ie.allPaths?j.concat(ie.allPaths):j,[]);return _.length&&(A.allPaths=_),A}const F=function(A,O,_){let j;for(let ie=0,ae=Q.length;ie<ae;ie++){const ce=Q[ie];ce.requiresSiblings&&_&&(O||(O=(0,D.basename)(A)),j||(j=O.substr(0,O.length-(0,D.extname)(A).length)));const ne=ce(A,O,j,_);if(ne)return ne}return null},N=Q.find(A=>!!A.allBasenames);N&&(F.allBasenames=N.allBasenames);const T=Q.reduce((A,O)=>O.allPaths?A.concat(O.allPaths):A,[]);return T.length&&(F.allPaths=T),F}function Y($,q,Q){if(q===!1)return f;const z=s($,Q);if(z===f)return f;if(typeof q=="boolean")return z;if(q){const F=q.when;if(typeof F=="string"){const N=(T,A,O,_)=>{if(!_||!z(T,A))return null;const j=F.replace("$(basename)",O),ie=_(j);return(0,w.isThenable)(ie)?ie.then(ae=>ae?$:null):ie?$:null};return N.requiresSiblings=!0,N}}return z}function se($,q){const Q=$.filter(A=>!!A.basenames);if(Q.length<2)return $;const z=Q.reduce((A,O)=>{const _=O.basenames;return _?A.concat(_):A},[]);let F;if(q){F=[];for(let A=0,O=z.length;A<O;A++)F.push(q)}else F=Q.reduce((A,O)=>{const _=O.patterns;return _?A.concat(_):A},[]);const N=function(A,O){if(typeof A!="string")return null;if(!O){let j;for(j=A.length;j>0;j--){const ie=A.charCodeAt(j-1);if(ie===47||ie===92)break}O=A.substr(j)}const _=z.indexOf(O);return _!==-1?F[_]:null};N.basenames=z,N.patterns=F,N.allBasenames=z;const T=$.filter(A=>!A.basenames);return T.push(N),T}}),define(Z[33],x([0,1,28,10,7,2,17,27,8]),function(V,e,w,n,L,D,P,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function I(i,r,o){if(typeof i=="string"&&(i=m.URI.file(i)),o){const v=o.getWorkspaceFolder(i);if(v){const C=o.getWorkspace().folders.length>1;let R;if((0,P.isEqual)(v.uri,i)?R="":R=(0,P.relativePath)(v.uri,i),C){const W=v.name?v.name:(0,P.basename)(v.uri);R=R?W+" \u2022 "+R:W}return R}}if(i.scheme!==n.Schemas.file&&i.scheme!==n.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,w.hasDriveLetter)(i.fsPath))return(0,L.normalize)(E(i.fsPath));let l=(0,L.normalize)(i.fsPath);return!D.isWindows&&r?.userHome&&(l=p(l,r.userHome.fsPath)),l}e.getPathLabel=I;function M(i){if(!i)return;typeof i=="string"&&(i=m.URI.file(i));const r=(0,P.basename)(i)||(i.scheme===n.Schemas.file?i.fsPath:i.path);return D.isWindows&&(0,w.isRootOrDriveLetter)(r)?E(r):r}e.getBaseLabel=M;function E(i,r){return(0,w.hasDriveLetter)(i,r)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=E;let b=Object.create(null);function p(i,r){if(D.isWindows||!i||!r)return i;let o=b.original===r?b.normalized:void 0;return o||(o=`${(0,S.rtrim)(r,L.posix.sep)}${L.posix.sep}`,b={original:r,normalized:o}),(D.isLinux?i.startsWith(o):(0,S.startsWithIgnoreCase)(i,o))&&(i=`~/${i.substr(o.length)}`),i}e.tildify=p;function t(i,r){return i.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=t;const h="\u2026",g="\\\\",y="~";function k(i,r=L.sep){const o=new Array(i.length);let l=!1;for(let v=0;v<i.length;v++){let C=i[v];if(C===""){o[v]=`.${r}`;continue}if(!C){o[v]=C;continue}l=!0;let R="";C.indexOf(g)===0?(R=C.substr(0,C.indexOf(g)+g.length),C=C.substr(C.indexOf(g)+g.length)):C.indexOf(r)===0?(R=C.substr(0,C.indexOf(r)+r.length),C=C.substr(C.indexOf(r)+r.length)):C.indexOf(y)===0&&(R=C.substr(0,C.indexOf(y)+y.length),C=C.substr(C.indexOf(y)+y.length));const W=C.split(r);for(let U=1;l&&U<=W.length;U++)for(let G=W.length-U;l&&G>=0;G--){l=!1;let ee=W.slice(G,G+U).join(r);for(let X=0;!l&&X<i.length;X++)if(X!==v&&i[X]&&i[X].indexOf(ee)>-1){const J=G+U===W.length,H=G>0&&i[X].indexOf(r)>-1?r+ee:ee,B=i[X].endsWith(H);l=!J||B}if(!l){let X="";(W[0].endsWith(":")||R!=="")&&(G===1&&(G=0,U++,ee=W[0]+r+ee),G>0&&(X=W[0]+r),X=R+X),G>0&&(X=X+h+r),X=X+ee,G+U<W.length&&(X=X+r+h),o[v]=X}}l&&(o[v]=C)}return o}e.shorten=k;var d;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function u(i,r=Object.create(null)){const o=[];let l=!1,v="";for(const C of i)if(C==="$"||l&&C==="{")v&&o.push({value:v,type:d.TEXT}),v="",l=!0;else if(C==="}"&&l){const R=r[v];if(typeof R=="string")R.length&&o.push({value:R,type:d.VARIABLE});else if(R){const W=o[o.length-1];(!W||W.type!==d.SEPARATOR)&&o.push({value:R.label,type:d.SEPARATOR})}v="",l=!1}else v+=C;return v&&!l&&o.push({value:v,type:d.TEXT}),o.filter((C,R)=>{if(C.type===d.SEPARATOR){const W=o[R-1],U=o[R+1];return[W,U].every(G=>G&&(G.type===d.VARIABLE||G.type===d.TEXT)&&G.value.length>0)}return!0}).map(C=>C.value).join("")}e.template=u;function c(i,r){return D.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.isMacintosh?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function a(i,r){return D.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,""):D.isWindows?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=a;function f(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=f;function s(i){const r=i.indexOf("/")!==-1?L.posix:L.win32,o=r.basename(i),l=r.dirname(i);return o.length?{name:o,parentPath:l}:{name:l,parentPath:""}}e.splitName=s}),define(Z[117],x([0,1,8]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(M){return M.toJSON()}class L{constructor(E){this._uriTransformer=E}transformIncoming(E){const b=this._uriTransformer.transformIncoming(E);return b===E?E:n(w.URI.from(b))}transformOutgoing(E){const b=this._uriTransformer.transformOutgoing(E);return b===E?E:n(w.URI.from(b))}transformOutgoingURI(E){const b=this._uriTransformer.transformOutgoing(E);return b===E?E:w.URI.from(b)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(M){return M}transformOutgoing(M){return M}transformOutgoingURI(M){return M}transformOutgoingScheme(M){return M}};function D(M,E,b){if(!M||b>200)return null;if(typeof M=="object"){if(M instanceof w.URI)return E.transformOutgoing(M);for(let p in M)if(Object.hasOwnProperty.call(M,p)){const t=D(M[p],E,b+1);t!==null&&(M[p]=t)}}return null}function P(M,E){const b=D(M,E,0);return b===null?M:b}e.transformOutgoingURIs=P;function S(M,E,b,p){if(!M||p>200)return null;if(typeof M=="object"){if(M.$mid===1)return b?w.URI.revive(E.transformIncoming(M)):E.transformIncoming(M);for(let t in M)if(Object.hasOwnProperty.call(M,t)){const h=S(M[t],E,b,p+1);h!==null&&(M[t]=h)}}return null}function m(M,E){const b=S(M,E,!1,0);return b===null?M:b}e.transformIncomingURIs=m;function I(M,E){const b=S(M,E,!0,0);return b===null?M:b}e.transformAndReviveIncomingURIs=I}),define(Z[31],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(m){return w.test(m)}e.isUUID=n;const L=new Uint8Array(16),D=[];for(let m=0;m<256;m++)D.push(m.toString(16).padStart(2,"0"));let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(m){for(let I=0;I<m.length;I++)m[I]=Math.floor(Math.random()*256);return m};function S(){P(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let m=0,I="";return I+=D[L[m++]],I+=D[L[m++]],I+=D[L[m++]],I+=D[L[m++]],I+="-",I+=D[L[m++]],I+=D[L[m++]],I+="-",I+=D[L[m++]],I+=D[L[m++]],I+="-",I+=D[L[m++]],I+=D[L[m++]],I+="-",I+=D[L[m++]],I+=D[L[m++]],I+=D[L[m++]],I+=D[L[m++]],I+=D[L[m++]],I+=D[L[m++]],I}e.generateUuid=S}),define(Z[118],x([0,1,15,4,3,2,14,27]),function(V,e,w,n,L,D,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.SimpleWorkerServer=e.SimpleWorkerClient=e.logOnceWebWorkerWarning=void 0;const m="$initialize";let I=!1;function M(s){!D.isWeb||(I||(I=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(s.message))}e.logOnceWebWorkerWarning=M;var E;(function(s){s[s.Request=0]="Request",s[s.Reply=1]="Reply",s[s.SubscribeEvent=2]="SubscribeEvent",s[s.Event=3]="Event",s[s.UnsubscribeEvent=4]="UnsubscribeEvent"})(E||(E={}));class b{constructor(i,r,o,l){this.vsWorker=i,this.req=r,this.method=o,this.args=l,this.type=0}}class p{constructor(i,r,o,l){this.vsWorker=i,this.seq=r,this.res=o,this.err=l,this.type=1}}class t{constructor(i,r,o,l){this.vsWorker=i,this.req=r,this.eventName=o,this.arg=l,this.type=2}}class h{constructor(i,r,o){this.vsWorker=i,this.req=r,this.event=o,this.type=3}}class g{constructor(i,r){this.vsWorker=i,this.req=r,this.type=4}}class y{constructor(i){this._workerId=-1,this._handler=i,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(i){this._workerId=i}sendMessage(i,r){const o=String(++this._lastSentReq);return new Promise((l,v)=>{this._pendingReplies[o]={resolve:l,reject:v},this._send(new b(this._workerId,o,i,r))})}listen(i,r){let o=null;const l=new n.Emitter({onFirstListenerAdd:()=>{o=String(++this._lastSentReq),this._pendingEmitters.set(o,l),this._send(new t(this._workerId,o,i,r))},onLastListenerRemove:()=>{this._pendingEmitters.delete(o),this._send(new g(this._workerId,o)),o=null}});return l.event}handleMessage(i){!i||!i.vsWorker||this._workerId!==-1&&i.vsWorker!==this._workerId||this._handleMessage(i)}_handleMessage(i){switch(i.type){case 1:return this._handleReplyMessage(i);case 0:return this._handleRequestMessage(i);case 2:return this._handleSubscribeEventMessage(i);case 3:return this._handleEventMessage(i);case 4:return this._handleUnsubscribeEventMessage(i)}}_handleReplyMessage(i){if(!this._pendingReplies[i.seq]){console.warn("Got reply to unknown seq");return}let r=this._pendingReplies[i.seq];if(delete this._pendingReplies[i.seq],i.err){let o=i.err;i.err.$isError&&(o=new Error,o.name=i.err.name,o.message=i.err.message,o.stack=i.err.stack),r.reject(o);return}r.resolve(i.res)}_handleRequestMessage(i){let r=i.req;this._handler.handleMessage(i.method,i.args).then(l=>{this._send(new p(this._workerId,r,l,void 0))},l=>{l.detail instanceof Error&&(l.detail=(0,w.transformErrorForSerialization)(l.detail)),this._send(new p(this._workerId,r,void 0,(0,w.transformErrorForSerialization)(l)))})}_handleSubscribeEventMessage(i){const r=i.req,o=this._handler.handleEvent(i.eventName,i.arg)(l=>{this._send(new h(this._workerId,r,l))});this._pendingEvents.set(r,o)}_handleEventMessage(i){if(!this._pendingEmitters.has(i.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(i.req).fire(i.event)}_handleUnsubscribeEventMessage(i){if(!this._pendingEvents.has(i.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(i.req).dispose(),this._pendingEvents.delete(i.req)}_send(i){let r=[];if(i.type===0)for(let o=0;o<i.args.length;o++)i.args[o]instanceof ArrayBuffer&&r.push(i.args[o]);else i.type===1&&i.res instanceof ArrayBuffer&&r.push(i.res);this._handler.sendMessage(i,r)}}class k extends L.Disposable{constructor(i,r,o){super();let l=null;this._worker=this._register(i.create("vs/base/common/worker/simpleWorker",U=>{this._protocol.handleMessage(U)},U=>{l&&l(U)})),this._protocol=new y({sendMessage:(U,G)=>{this._worker.postMessage(U,G)},handleMessage:(U,G)=>{if(typeof o[U]!="function")return Promise.reject(new Error("Missing method "+U+" on main thread host."));try{return Promise.resolve(o[U].apply(o,G))}catch(ee){return Promise.reject(ee)}},handleEvent:(U,G)=>{if(u(U)){const ee=o[U].call(o,G);if(typeof ee!="function")throw new Error(`Missing dynamic event ${U} on main thread host.`);return ee}if(d(U)){const ee=o[U];if(typeof ee!="function")throw new Error(`Missing event ${U} on main thread host.`);return ee}throw new Error(`Malformed event name ${U}`)}}),this._protocol.setWorkerId(this._worker.getId());let v=null;typeof D.globals.require!="undefined"&&typeof D.globals.require.getConfig=="function"?v=D.globals.require.getConfig():typeof D.globals.requirejs!="undefined"&&(v=D.globals.requirejs.s.contexts._.config);const C=P.getAllMethodNames(o);this._onModuleLoaded=this._protocol.sendMessage(m,[this._worker.getId(),JSON.parse(JSON.stringify(v)),r,C]);const R=(U,G)=>this._request(U,G),W=(U,G)=>this._protocol.listen(U,G);this._lazyProxy=new Promise((U,G)=>{l=G,this._onModuleLoaded.then(ee=>{U(c(ee,R,W))},ee=>{G(ee),this._onError("Worker failed to load "+r,ee)})})}getProxyObject(){return this._lazyProxy}_request(i,r){return new Promise((o,l)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(i,r).then(o,l)},l)})}_onError(i,r){console.error(i),console.info(r)}}e.SimpleWorkerClient=k;function d(s){return s[0]==="o"&&s[1]==="n"&&S.isUpperAsciiLetter(s.charCodeAt(2))}function u(s){return/^onDynamic/.test(s)&&S.isUpperAsciiLetter(s.charCodeAt(9))}function c(s,i,r){const o=C=>function(){const R=Array.prototype.slice.call(arguments,0);return i(C,R)},l=C=>function(R){return r(C,R)};let v={};for(const C of s){if(u(C)){v[C]=l(C);continue}if(d(C)){v[C]=r(C,void 0);continue}v[C]=o(C)}return v}class a{constructor(i,r){this._requestHandlerFactory=r,this._requestHandler=null,this._protocol=new y({sendMessage:(o,l)=>{i(o,l)},handleMessage:(o,l)=>this._handleMessage(o,l),handleEvent:(o,l)=>this._handleEvent(o,l)})}onmessage(i){this._protocol.handleMessage(i)}_handleMessage(i,r){if(i===m)return this.initialize(r[0],r[1],r[2],r[3]);if(!this._requestHandler||typeof this._requestHandler[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._requestHandler[i].apply(this._requestHandler,r))}catch(o){return Promise.reject(o)}}_handleEvent(i,r){if(!this._requestHandler)throw new Error("Missing requestHandler");if(u(i)){const o=this._requestHandler[i].call(this._requestHandler,r);if(typeof o!="function")throw new Error(`Missing dynamic event ${i} on request handler.`);return o}if(d(i)){const o=this._requestHandler[i];if(typeof o!="function")throw new Error(`Missing event ${i} on request handler.`);return o}throw new Error(`Malformed event name ${i}`)}initialize(i,r,o,l){this._protocol.setWorkerId(i);const R=c(l,(W,U)=>this._protocol.sendMessage(W,U),(W,U)=>this._protocol.listen(W,U));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(R),Promise.resolve(P.getAllMethodNames(this._requestHandler))):(r&&(typeof r.baseUrl!="undefined"&&delete r.baseUrl,typeof r.paths!="undefined"&&typeof r.paths.vs!="undefined"&&delete r.paths.vs,typeof r.trustedTypesPolicy!==void 0&&delete r.trustedTypesPolicy,r.catchError=!0,D.globals.require.config(r)),new Promise((W,U)=>{(D.globals.require||V)([o],ee=>{if(this._requestHandler=ee.create(R),!this._requestHandler){U(new Error("No RequestHandler!"));return}W(P.getAllMethodNames(this._requestHandler))},U)}))}}e.SimpleWorkerServer=a;function f(s){return new a(s,null)}e.create=f}),define(Z[119],x([0,1,60,29,43]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function D(P,S){if(await new Promise((M,E)=>{const b=n.createReadStream(P),p=w.createHash("sha1");b.pipe(p);const t=(0,L.once)((h,g)=>{b.removeAllListeners(),p.removeAllListeners(),h?E(h):M(g)});b.once("error",t),b.once("end",t),p.once("error",t),p.once("data",h=>t(void 0,h.toString("hex")))})!==S)throw new Error("Hash mismatch")}e.checksum=D}),define(Z[120],x([0,1,249]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(D="utf8"){this.stringDecoder=new w.StringDecoder(D),this.remaining=null}write(D){const P=[],S=this.remaining?this.remaining+this.stringDecoder.write(D):this.stringDecoder.write(D);if(S.length<1)return P;let m=0,I,M=m;for(;M<S.length;)if(I=S.charCodeAt(M),I===13||I===10){if(P.push(S.substring(m,M)),M++,M<S.length){const E=I;I=S.charCodeAt(M),(E===13&&I===10||E===10&&I===13)&&M++}m=M}else M++;return this.remaining=m<S.length?S.substr(m):null,P}end(){return this.remaining}}e.LineDecoder=n}),define(Z[121],x([0,1,26]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(P){const S=P.replace(/\-/g,":").toLowerCase();return!n.has(S)}function D(){const P=(0,w.networkInterfaces)();for(let S in P){const m=P[S];if(m){for(const{mac:I}of m)if(L(I))return I}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=D}),define(Z[71],x([0,1,26,15,35,31,121]),function(V,e,w,n,L,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(M){return this._virtualMachineOUIs||(this._virtualMachineOUIs=L.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(M)}value(){if(this._value===void 0){let M=0,E=0;const b=(0,w.networkInterfaces)();for(let p in b){const t=b[p];if(t)for(const{mac:h,internal:g}of t)g||(E+=1,this._isVirtualMachineMacAddress(h.toUpperCase())&&(M+=1))}this._value=E>0?M/E:0}return this._value}};let S;async function m(){return S||(S=(async()=>await I()||D.generateUuid())()),S}e.getMachineId=m;async function I(){try{const M=await new Promise((b,p)=>{V(["crypto"],b,p)}),E=(0,P.getMac)();return M.createHash("sha256").update(E,"utf8").digest("hex")}catch(M){n.onUnexpectedError(M);return}}}),define(Z[24],x([0,1,29,26,122,9,28,70,7,2,17,8]),function(V,e,w,n,L,D,P,S,m,I,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(J){J[J.UNLINK=0]="UNLINK",J[J.MOVE=1]="MOVE"})(b=e.RimRafMode||(e.RimRafMode={}));async function p(J,H=b.UNLINK){if((0,P.isRootOrDriveLetter)(J))throw new Error("rimraf - will refuse to recursively delete root");return H===b.UNLINK?h(J):t(J)}async function t(J){try{const H=(0,P.randomPath)((0,n.tmpdir)());try{await w.promises.rename(J,H)}catch{return h(J)}h(H).catch(B=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function h(J){return(0,L.promisify)(w.rm)(J,{recursive:!0,force:!0,maxRetries:3})}function g(J){if((0,P.isRootOrDriveLetter)(J))throw new Error("rimraf - will refuse to recursively delete root");w.rmSync(J,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=g;async function y(J,H){return u(await(H?k(J):(0,L.promisify)(w.readdir)(J)))}async function k(J){try{return await(0,L.promisify)(w.readdir)(J,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const H=[],B=await y(J);for(const Y of B){let se=!1,$=!1,q=!1;try{const Q=await e.Promises.lstat((0,m.join)(J,Y));se=Q.isFile(),$=Q.isDirectory(),q=Q.isSymbolicLink()}catch(Q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Q)}H.push({name:Y,isFile:()=>se,isDirectory:()=>$,isSymbolicLink:()=>q})}return H}function d(J){return u(w.readdirSync(J))}e.readdirSync=d;function u(J){return J.map(H=>typeof H=="string"?I.isMacintosh?(0,S.normalizeNFC)(H):H:(H.name=I.isMacintosh?(0,S.normalizeNFC)(H.name):H.name,H))}async function c(J){const H=await y(J),B=[];for(const Y of H)await f.existsDirectory((0,m.join)(J,Y))&&B.push(Y);return B}function a(J,H=1e3){return new Promise(B=>{let Y=!1;const se=setInterval(()=>{Y||(Y=!0,w.access(J,$=>{Y=!1,$&&(clearInterval(se),B(void 0))}))},H)})}e.whenDeleted=a;var f;(function(J){async function H(se){let $;try{if($=await e.Promises.lstat(se),!$.isSymbolicLink())return{stat:$}}catch{}try{return{stat:await e.Promises.stat(se),symbolicLink:$?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};if(I.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(se)),symbolicLink:{dangling:!1}}}catch(Q){if(Q.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};throw Q}throw q}}J.stat=H;async function B(se){try{const{stat:$,symbolicLink:q}=await J.stat(se);return $.isFile()&&q?.dangling!==!0}catch{}return!1}J.existsFile=B;async function Y(se){try{const{stat:$,symbolicLink:q}=await J.stat(se);return $.isDirectory()&&q?.dangling!==!0}catch{}return!1}J.existsDirectory=Y})(f=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new D.ResourceQueue;function i(J,H,B){return s.queueFor(E.URI.file(J),M.extUriBiasedIgnorePathCase).queue(()=>{const Y=v(B);return new Promise((se,$)=>o(J,H,Y,q=>q?$(q):se()))})}let r=!0;function o(J,H,B,Y){if(!r)return w.writeFile(J,H,{mode:B.mode,flag:B.flag},Y);w.open(J,B.flag,B.mode,(se,$)=>{if(se)return Y(se);w.writeFile($,H,q=>{if(q)return w.close($,()=>Y(q));w.fdatasync($,Q=>(Q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Q),r=!1),w.close($,z=>Y(z))))})})}function l(J,H,B){const Y=v(B);if(!r)return w.writeFileSync(J,H,{mode:Y.mode,flag:Y.flag});const se=w.openSync(J,Y.flag,Y.mode);try{w.writeFileSync(se,H);try{w.fdatasyncSync(se)}catch($){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",$),r=!1}}finally{w.closeSync(se)}}e.writeFileSync=l;function v(J){return J?{mode:typeof J.mode=="number"?J.mode:438,flag:typeof J.flag=="string"?J.flag:"w"}:{mode:438,flag:"w"}}async function C(J,H){if(J!==H)try{await e.Promises.rename(J,H)}catch(B){if(J.toLowerCase()!==H.toLowerCase()&&B.code==="EXDEV"||J.endsWith("."))await R(J,H,{preserveSymlinks:!1}),await p(J,b.MOVE);else throw B}}async function R(J,H,B){return U(J,H,{root:{source:J,target:H},options:B,handledSourcePaths:new Set})}const W=511;async function U(J,H,B){if(B.handledSourcePaths.has(J))return;B.handledSourcePaths.add(J);const{stat:Y,symbolicLink:se}=await f.stat(J);if(se){if(B.options.preserveSymlinks)try{return await X(J,H,B)}catch($){console.warn("[node.js fs] copy of symlink failed: ",$)}if(se.dangling)return}return Y.isDirectory()?G(J,H,Y.mode&W,B):ee(J,H,Y.mode&W)}async function G(J,H,B,Y){await e.Promises.mkdir(H,{recursive:!0,mode:B});const se=await y(J);for(const $ of se)await U((0,m.join)(J,$),(0,m.join)(H,$),Y)}async function ee(J,H,B){await e.Promises.copyFile(J,H),await e.Promises.chmod(H,B)}async function X(J,H,B){let Y=await e.Promises.readlink(J);(0,P.isEqualOrParent)(Y,B.root.source,!I.isLinux)&&(Y=(0,m.join)(B.root.target,Y.substr(B.root.source.length+1))),await e.Promises.symlink(Y,H)}e.Promises=new class{get access(){return(0,L.promisify)(w.access)}get stat(){return(0,L.promisify)(w.stat)}get lstat(){return(0,L.promisify)(w.lstat)}get utimes(){return(0,L.promisify)(w.utimes)}get read(){return(J,H,B,Y,se)=>new Promise(($,q)=>{w.read(J,H,B,Y,se,(Q,z,F)=>Q?q(Q):$({bytesRead:z,buffer:F}))})}get readFile(){return(0,L.promisify)(w.readFile)}get write(){return(J,H,B,Y,se)=>new Promise(($,q)=>{w.write(J,H,B,Y,se,(Q,z,F)=>Q?q(Q):$({bytesWritten:z,buffer:F}))})}get appendFile(){return(0,L.promisify)(w.appendFile)}get fdatasync(){return(0,L.promisify)(w.fdatasync)}get truncate(){return(0,L.promisify)(w.truncate)}get rename(){return(0,L.promisify)(w.rename)}get copyFile(){return(0,L.promisify)(w.copyFile)}get open(){return(0,L.promisify)(w.open)}get close(){return(0,L.promisify)(w.close)}get symlink(){return(0,L.promisify)(w.symlink)}get readlink(){return(0,L.promisify)(w.readlink)}get chmod(){return(0,L.promisify)(w.chmod)}get mkdir(){return(0,L.promisify)(w.mkdir)}get unlink(){return(0,L.promisify)(w.unlink)}get rmdir(){return(0,L.promisify)(w.rmdir)}get realpath(){return(0,L.promisify)(w.realpath)}async exists(J){try{return await e.Promises.access(J),!0}catch{return!1}}get readdir(){return y}get readDirsInDir(){return c}get writeFile(){return i}get rm(){return p}get move(){return C}get copy(){return R}}}),define(Z[86],x([0,1,29,7,2,27,24]),function(V,e,w,n,L,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function S(b){if(L.isLinux)return b;const p=(0,n.dirname)(b);if(b===p)return b;const t=((0,n.basename)(b)||b).toLowerCase();try{const g=(0,P.readdirSync)(p).filter(y=>y.toLowerCase()===t);if(g.length===1){const y=S(p);if(y)return(0,n.join)(y,g[0])}else if(g.length>1){const y=g.indexOf(t);if(y>=0){const k=S(p);if(k)return(0,n.join)(k,g[y])}}}catch{}return null}e.realcaseSync=S;async function m(b){if(L.isLinux)return b;const p=(0,n.dirname)(b);if(b===p)return b;const t=((0,n.basename)(b)||b).toLowerCase();try{const g=(await P.Promises.readdir(p)).filter(y=>y.toLowerCase()===t);if(g.length===1){const y=await m(p);if(y)return(0,n.join)(y,g[0])}else if(g.length>1){const y=g.indexOf(t);if(y>=0){const k=await m(p);if(k)return(0,n.join)(k,g[y])}}}catch{}return null}e.realcase=m;async function I(b){try{return await P.Promises.realpath(b)}catch{const t=E(b);return await P.Promises.access(t,w.constants.R_OK),t}}e.realpath=I;function M(b){try{return w.realpathSync(b)}catch{const t=E(b);return w.accessSync(t,w.constants.R_OK),t}}e.realpathSync=M;function E(b){return(0,D.rtrim)((0,n.normalize)(b),n.sep)}}),define(Z[123],x([0,1,61]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(S,m,I,M=1){let E=!1;return new Promise(b=>{const p=setTimeout(()=>{if(!E)return E=!0,b(0)},I);L(S,m,M,t=>{if(!E)return E=!0,clearTimeout(p),b(t)})})}e.findFreePort=n;function L(S,m,I,M){if(m===0)return M(0);const E=new w.Socket;E.once("connect",()=>(P(E),L(S+I,m-1,I,M))),E.once("data",()=>{}),E.once("error",b=>(P(E),b.code!=="ECONNREFUSED"?L(S+I,m-1,I,M):M(S))),E.connect(S,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function D(S,m,I){let M=!1,E,b=1;const p=w.createServer({pauseOnConnect:!0});function t(h,g){M||(M=!0,p.removeAllListeners(),p.close(),E&&clearTimeout(E),g(h))}return new Promise(h=>{E=setTimeout(()=>{t(0,h)},I),p.on("listening",()=>{t(S,h)}),p.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&b<m?(S++,b++,p.listen(S,"127.0.0.1")):t(0,h)}),p.on("close",()=>{t(0,h)}),p.listen(S,"127.0.0.1")})}e.findFreePortFaster=D;function P(S){try{S.removeAllListeners("connect"),S.removeAllListeners("error"),S.end(),S.destroy(),S.unref()}catch(m){console.error(m)}}}),define(Z[124],x([0,1,26,7,24]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const D=/^\d+$/,P=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var m;(function(u){u[u.x64=0]="x64",u[u.x86=1]="x86",u[u.ARM=2]="ARM"})(m||(m={}));let I;switch(process.arch){case"ia32":case"x32":I=1;break;case"arm":case"arm64":I=2;break;default:I=0;break}let M;process.env.PROCESSOR_ARCHITEW6432?M=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?M=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?M=1:M=0;class E{constructor(c,a,f){this.exePath=c,this.displayName=a,this.knownToExist=f}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await L.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function b({useAlternateBitness:u=!1}={}){return u?I===0?process.env["ProgramFiles(x86)"]||null:M===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:u=!1,findPreview:c=!1}={}){const a=b({useAlternateBitness:u});if(!a)return null;const f=n.join(a,"PowerShell");if(!await L.SymlinkSupport.existsDirectory(f))return null;let s=-1,i=null;for(const l of await L.Promises.readdir(f)){let v=-1;if(c){const R=l.indexOf("-");if(R<0)continue;const W=l.substring(0,R);if(!D.test(W)||l.substring(R+1)!=="preview")continue;v=parseInt(W,10)}else{if(!D.test(l))continue;v=parseInt(l,10)}if(v<=s)continue;const C=n.join(f,l,"pwsh.exe");!await L.SymlinkSupport.existsFile(C)||(i=C,s=v)}if(!i)return null;const r=a.includes("x86")?" (x86)":"",o=c?" Preview":"";return new E(i,`PowerShell${o}${r}`,!0)}async function t({findPreview:u}={}){if(!process.env.LOCALAPPDATA)return null;const c=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await L.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:a,pwshMsixName:f}=u?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:P,pwshMsixName:"PowerShell (Store)"};for(const s of await L.Promises.readdir(c))if(a.test(s)){const i=n.join(c,s,"pwsh.exe");return new E(i,f)}return null}function h(){const u=n.join(w.homedir(),".dotnet","tools","pwsh.exe");return new E(u,".NET Core PowerShell Global Tool")}function g(){const u=n.join(process.env.windir,I===1&&M!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(u,"Windows PowerShell",!0)}async function*y(){let u=await p();u&&(yield u),u=await p({useAlternateBitness:!0}),u&&(yield u),u=await t(),u&&(yield u),u=h(),u&&(yield u),u=await p({findPreview:!0}),u&&(yield u),u=await t({findPreview:!0}),u&&(yield u),u=await p({useAlternateBitness:!0,findPreview:!0}),u&&(yield u),u=g(),u&&(yield u)}async function*k(){for await(const u of y())await u.exists()&&(yield u)}e.enumeratePowerShellInstallations=k;async function d(){for await(const u of k())return u;return null}e.getFirstAvailablePowerShellInstallation=d}),define(Z[87],x([0,1,45,10]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function L(P){return new Promise((S,m)=>{let I;const M=new Map;function E(p,t,h,g,y){const k=M.get(t);if(p===P||k){const d={name:b(h),cmd:h,pid:p,ppid:t,load:g,mem:y};M.set(p,d),p===P&&(I=d),k&&(k.children||(k.children=[]),k.children.push(d),k.children.length>1&&(k.children=k.children.sort((u,c)=>u.pid-c.pid)))}}function b(p){const t=/--vscode-window-kind=shared-process/,h=/--vscode-window-kind=issue-reporter/,g=/--vscode-window-kind=process-explorer/,y=/--utility-sub-type=network/,k=/--crashes-directory/,d=/\\pipe\\winpty-control/,u=/conhost\.exe/,c=/--type=([a-zA-Z-]+)/;if(k.exec(p))return"electron-crash-reporter";if(d.exec(p))return"winpty-process";if(u.exec(p))return"console-window-host (Windows internal process)";let a=c.exec(p);if(a&&a.length===2)return a[1]==="renderer"?t.exec(p)?"shared-process":h.exec(p)?"issue-reporter":g.exec(p)?"process-explorer":"window":a[1]==="utility"&&y.exec(p)?"utility-network-service":a[1];const f=/[a-zA-Z-]+\.js/g;let s="";do a=f.exec(p),a&&(s+=a+" ");while(a);return s&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${s}`:p}if(process.platform==="win32"){const p=t=>t.indexOf("\\\\?\\")===0||t.indexOf("\\??\\")===0?t.substr(4):t.indexOf('"\\\\?\\')===0||t.indexOf('"\\??\\')===0?'"'+t.substr(5):t;new Promise((t,h)=>{V(["windows-process-tree"],t,h)}).then(t=>{t.getProcessList(P,h=>{t.getProcessCpuUsage(h,g=>{const y=new Map;g.forEach(k=>{const d=p(k.commandLine||"");y.set(k.pid,{name:b(d),cmd:d,pid:k.pid,ppid:k.ppid,load:k.cpu||0,mem:k.memory||0})}),I=y.get(P),I?(y.forEach(k=>{const d=y.get(k.ppid);d&&(d.children||(d.children=[]),d.children.push(k))}),y.forEach(k=>{k.children&&(k.children=k.children.sort((d,u)=>d.pid-u.pid))}),S(I)):m(new Error(`Root process ${P} not found`))})},t.ProcessDataFlag.CommandLine|t.ProcessDataFlag.Memory)})}else{let p=function(){let t=[I];const h=[];for(;t.length;){const y=t.shift();y&&(h.push(y.pid),y.children&&(t=t.concat(y.children)))}let g=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",V).fsPath);g+=" "+h.join(" "),(0,w.exec)(g,{},(y,k,d)=>{if(y||d)m(y||new Error(d.toString()));else{const u=k.toString().split(`
`);for(let c=0;c<h.length;c++){const a=M.get(h[c]);a.load=parseFloat(u[c])}if(!I){m(new Error(`Root process ${P} not found`));return}S(I)}})};(0,w.exec)("which ps",{},(t,h,g)=>{if(t||g)if(process.platform!=="linux")m(t||new Error(g.toString()));else{const y=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",V).fsPath);(0,w.exec)(y,{},(k,d,u)=>{k||u?m(k||new Error(u.toString())):(D(d,E),p())})}else{const y=h.toString().trim(),k="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,w.exec)(`${y} ${k}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,u,c)=>{d||c&&!c.includes("screen size is bogus")?m(d||new Error(c.toString())):(D(u,E),process.platform==="linux"?p():I?S(I):m(new Error(`Root process ${P} not found`)))})}})}})}e.listProcesses=L;function D(P,S){const m=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,I=P.toString().split(`
`);for(const M of I){const E=m.exec(M.trim());E&&E.length===6&&S(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}}),define(Z[125],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Z[126],x([0,1,12,14,125]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function D(){w.ipcMain.on(L.CONTEXT_MENU_CHANNEL,(S,m,I,M,E)=>{const b=P(S,M,I);b.popup({window:(0,n.withNullAsUndefined)(w.BrowserWindow.fromWebContents(S.sender)),x:E?E.x:void 0,y:E?E.y:void 0,positioningItem:E?E.positioningItem:void 0,callback:()=>{b&&S.sender.send(L.CONTEXT_MENU_CLOSE_CHANNEL,m)}})})}e.registerContextMenuListener=D;function P(S,m,I){const M=new w.Menu;return I.forEach(E=>{let b;E.type==="separator"?b=new w.MenuItem({type:E.type}):Array.isArray(E.submenu)?b=new w.MenuItem({submenu:P(S,m,E.submenu),label:E.label}):b=new w.MenuItem({label:E.label,type:E.type,accelerator:E.accelerator,checked:E.checked,enabled:E.enabled,visible:E.visible,click:(p,t,h)=>S.sender.send(m,E.id,h)}),M.append(b)}),M}});var ue=this&&this.__decorate||function(V,e,w,n){var L=arguments.length,D=L<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,w):n,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(V,e,w,n);else for(var S=V.length-1;S>=0;S--)(P=V[S])&&(D=(L<3?P(D):L>3?P(e,w,D):P(e,w))||D);return L>3&&D&&Object.defineProperty(e,w,D),D};define(Z[37],x([0,1,30,9,16,23,46,15,4,3,115,27,14]),function(V,e,w,n,L,D,P,S,m,I,M,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function($){$[$.Promise=100]="Promise",$[$.PromiseCancel=101]="PromiseCancel",$[$.EventListen=102]="EventListen",$[$.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function t($){switch($){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function($){$[$.Initialize=200]="Initialize",$[$.PromiseSuccess=201]="PromiseSuccess",$[$.PromiseError=202]="PromiseError",$[$.PromiseErrorObj=203]="PromiseErrorObj",$[$.EventFire=204]="EventFire"})(h=e.ResponseType||(e.ResponseType={}));function g($){switch($){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var y;(function($){$[$.Uninitialized=0]="Uninitialized",$[$.Idle=1]="Idle"})(y||(y={}));class k{constructor(q){this.buffer=q,this.pos=0}read(q){const Q=this.buffer.slice(this.pos,this.pos+q);return this.pos+=Q.byteLength,Q}}class d{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(q){this.buffers.push(q)}}var u;(function($){$[$.Undefined=0]="Undefined",$[$.String=1]="String",$[$.Buffer=2]="Buffer",$[$.VSBuffer=3]="VSBuffer",$[$.Array=4]="Array",$[$.Object=5]="Object"})(u||(u={}));function c($){const q=L.VSBuffer.alloc(4);return q.writeUInt32BE($,0),q}function a($){return $.read(4).readUInt32BE(0)}function f($){const q=L.VSBuffer.alloc(1);return q.writeUInt8($,0),q}const s={Undefined:f(u.Undefined),String:f(u.String),Buffer:f(u.Buffer),VSBuffer:f(u.VSBuffer),Array:f(u.Array),Object:f(u.Object)},i=typeof Buffer!="undefined";function r($,q){if(typeof q=="undefined")$.write(s.Undefined);else if(typeof q=="string"){const Q=L.VSBuffer.fromString(q);$.write(s.String),$.write(c(Q.byteLength)),$.write(Q)}else if(i&&Buffer.isBuffer(q)){const Q=L.VSBuffer.wrap(q);$.write(s.Buffer),$.write(c(Q.byteLength)),$.write(Q)}else if(q instanceof L.VSBuffer)$.write(s.VSBuffer),$.write(c(q.byteLength)),$.write(q);else if(Array.isArray(q)){$.write(s.Array),$.write(c(q.length));for(const Q of q)r($,Q)}else{const Q=L.VSBuffer.fromString(JSON.stringify(q));$.write(s.Object),$.write(c(Q.byteLength)),$.write(Q)}}function o($){switch($.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return $.read(a($)).toString();case u.Buffer:return $.read(a($)).buffer;case u.VSBuffer:return $.read(a($));case u.Array:{const Q=a($),z=[];for(let F=0;F<Q;F++)z.push(o($));return z}case u.Object:return JSON.parse($.read(a($)).toString())}}class l{constructor(q,Q,z=null,F=1e3){this.protocol=q,this.ctx=Q,this.logger=z,this.timeoutDelay=F,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(N=>this.onRawMessage(N)),this.sendResponse({type:200})}registerChannel(q,Q){this.channels.set(q,Q),setTimeout(()=>this.flushPendingRequests(q),0)}sendResponse(q){switch(q.type){case 200:{const Q=this.send([q.type]);this.logger?.logOutgoing(Q,0,1,g(q.type));return}case 201:case 202:case 204:case 203:{const Q=this.send([q.type,q.id],q.data);this.logger?.logOutgoing(Q,q.id,1,g(q.type),q.data);return}}}send(q,Q=void 0){const z=new d;return r(z,q),r(z,Q),this.sendBuffer(z.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onRawMessage(q){const Q=new k(q),z=o(Q),F=o(Q),N=z[0];switch(N){case 100:return this.logger?.logIncoming(q.byteLength,z[1],1,`${t(N)}: ${z[2]}.${z[3]}`,F),this.onPromise({type:N,id:z[1],channelName:z[2],name:z[3],arg:F});case 102:return this.logger?.logIncoming(q.byteLength,z[1],1,`${t(N)}: ${z[2]}.${z[3]}`,F),this.onEventListen({type:N,id:z[1],channelName:z[2],name:z[3],arg:F});case 101:return this.logger?.logIncoming(q.byteLength,z[1],1,`${t(N)}`),this.disposeActiveRequest({type:N,id:z[1]});case 103:return this.logger?.logIncoming(q.byteLength,z[1],1,`${t(N)}`),this.disposeActiveRequest({type:N,id:z[1]})}}onPromise(q){const Q=this.channels.get(q.channelName);if(!Q){this.collectPendingRequest(q);return}const z=new D.CancellationTokenSource;let F;try{F=Q.call(this.ctx,q.name,q.arg,z.token)}catch(A){F=Promise.reject(A)}const N=q.id;F.then(A=>{this.sendResponse({id:N,data:A,type:201}),this.activeRequests.delete(q.id)},A=>{A instanceof Error?this.sendResponse({id:N,data:{message:A.message,name:A.name,stack:A.stack?A.stack.split?A.stack.split(`
`):A.stack:void 0},type:202}):this.sendResponse({id:N,data:A,type:203}),this.activeRequests.delete(q.id)});const T=(0,I.toDisposable)(()=>z.cancel());this.activeRequests.set(q.id,T)}onEventListen(q){const Q=this.channels.get(q.channelName);if(!Q){this.collectPendingRequest(q);return}const z=q.id,N=Q.listen(this.ctx,q.name,q.arg)(T=>this.sendResponse({id:z,data:T,type:204}));this.activeRequests.set(q.id,N)}disposeActiveRequest(q){const Q=this.activeRequests.get(q.id);Q&&(Q.dispose(),this.activeRequests.delete(q.id))}collectPendingRequest(q){let Q=this.pendingRequests.get(q.channelName);Q||(Q=[],this.pendingRequests.set(q.channelName,Q));const z=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.sendResponse({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Q.push({request:q,timeoutTimer:z})}flushPendingRequests(q){const Q=this.pendingRequests.get(q);if(Q){for(const z of Q)switch(clearTimeout(z.timeoutTimer),z.request.type){case 100:this.onPromise(z.request);break;case 102:this.onEventListen(z.request);break}this.pendingRequests.delete(q)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,I.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=l;var v;(function($){$[$.LocalSide=0]="LocalSide",$[$.OtherSide=1]="OtherSide"})(v=e.RequestInitiator||(e.RequestInitiator={}));class C{constructor(q,Q=null){this.protocol=q,this.isDisposed=!1,this.state=y.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(z=>this.onBuffer(z)),this.logger=Q}getChannel(q){const Q=this;return{call(z,F,N){return Q.isDisposed?Promise.reject(S.canceled()):Q.requestPromise(q,z,F,N)},listen(z,F){return Q.isDisposed?m.Event.None:Q.requestEvent(q,z,F)}}}requestPromise(q,Q,z,F=D.CancellationToken.None){const N=this.lastRequestId++,A={id:N,type:100,channelName:q,name:Q,arg:z};if(F.isCancellationRequested)return Promise.reject(S.canceled());let O;return new Promise((j,ie)=>{if(F.isCancellationRequested)return ie(S.canceled());const ae=()=>{const he=we=>{switch(we.type){case 201:this.handlers.delete(N),j(we.data);break;case 202:{this.handlers.delete(N);const be=new Error(we.data.message);be.stack=we.data.stack,be.name=we.data.name,ie(be);break}case 203:this.handlers.delete(N),ie(we.data);break}};this.handlers.set(N,he),this.sendRequest(A)};let ce=null;this.state===y.Idle?ae():(ce=(0,n.createCancelablePromise)(he=>this.whenInitialized()),ce.then(()=>{ce=null,ae()}));const ne=()=>{ce?(ce.cancel(),ce=null):this.sendRequest({id:N,type:101}),ie(S.canceled())},le=F.onCancellationRequested(ne);O=(0,I.combinedDisposable)((0,I.toDisposable)(ne),le),this.activeRequests.add(O)}).finally(()=>{this.activeRequests.delete(O)})}requestEvent(q,Q,z){const F=this.lastRequestId++,T={id:F,type:102,channelName:q,name:Q,arg:z};let A=null;const O=new m.Emitter({onFirstListenerAdd:()=>{A=(0,n.createCancelablePromise)(j=>this.whenInitialized()),A.then(()=>{A=null,this.activeRequests.add(O),this.sendRequest(T)})},onLastListenerRemove:()=>{A?(A.cancel(),A=null):(this.activeRequests.delete(O),this.sendRequest({id:F,type:103}))}}),_=j=>O.fire(j.data);return this.handlers.set(F,_),O.event}sendRequest(q){switch(q.type){case 100:case 102:{const Q=this.send([q.type,q.id,q.channelName,q.name],q.arg);this.logger&&this.logger.logOutgoing(Q,q.id,0,`${t(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const Q=this.send([q.type,q.id]);this.logger&&this.logger.logOutgoing(Q,q.id,0,t(q.type));return}}}send(q,Q=void 0){const z=new d;return r(z,q),r(z,Q),this.sendBuffer(z.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onBuffer(q){const Q=new k(q),z=o(Q),F=o(Q),N=z[0];switch(N){case 200:return this.logger&&this.logger.logIncoming(q.byteLength,0,0,g(N)),this.onResponse({type:z[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(q.byteLength,z[1],0,g(N),F),this.onResponse({type:z[0],id:z[1],data:F})}}onResponse(q){if(q.type===200){this.state=y.Idle,this._onDidInitialize.fire();return}const Q=this.handlers.get(q.id);Q&&Q(q)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===y.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,I.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ue([P.memoize],C.prototype,"onDidInitializePromise",null),e.ChannelClient=C;class R{constructor(q){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,q(({protocol:Q,onDidClientDisconnect:z})=>{m.Event.once(Q.onMessage)(N=>{const T=new k(N),A=o(T),O=new l(Q,A),_=new C(Q);this.channels.forEach((ie,ae)=>O.registerChannel(ae,ie));const j={channelServer:O,channelClient:_,ctx:A};this._connections.add(j),this._onDidAddConnection.fire(j),z(()=>{O.dispose(),_.dispose(),this._connections.delete(j),this._onDidRemoveConnection.fire(j)})})})}get connections(){const q=[];return this._connections.forEach(Q=>q.push(Q)),q}getChannel(q,Q){const z=this;return{call(F,N,T){let A;if((0,b.isFunction)(Q)){let _=(0,w.getRandomElement)(z.connections.filter(Q));A=_?Promise.resolve(_):m.Event.toPromise(m.Event.filter(z.onDidAddConnection,Q))}else A=Q.routeCall(z,F,N);const O=A.then(_=>_.channelClient.getChannel(q));return U(O).call(F,N,T)},listen(F,N){if((0,b.isFunction)(Q))return z.getMulticastEvent(q,Q,F,N);const T=Q.routeEvent(z,F,N).then(A=>A.channelClient.getChannel(q));return U(T).listen(F,N)}}}getMulticastEvent(q,Q,z,F){const N=this;let T=new I.DisposableStore;const A=new m.Emitter({onFirstListenerAdd:()=>{T=new I.DisposableStore;const O=new m.EventMultiplexer,_=new Map,j=ae=>{const ne=ae.channelClient.getChannel(q).listen(z,F),le=O.add(ne);_.set(ae,le)},ie=ae=>{const ce=_.get(ae);!ce||(ce.dispose(),_.delete(ae))};N.connections.filter(Q).forEach(j),m.Event.filter(N.onDidAddConnection,Q)(j,void 0,T),N.onDidRemoveConnection(ie,void 0,T),O.event(A.fire,A,T),T.add(O)},onLastListenerRemove:()=>{T.dispose()}});return A.event}registerChannel(q,Q){this.channels.set(q,Q),this._connections.forEach(z=>{z.channelServer.registerChannel(q,Q)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=R;class W{constructor(q,Q,z=null){const F=new d;r(F,Q),q.send(F.buffer),this.channelClient=new C(q,z),this.channelServer=new l(q,Q,z)}getChannel(q){return this.channelClient.getChannel(q)}registerChannel(q,Q){this.channelServer.registerChannel(q,Q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=W;function U($){return{call(q,Q,z){return $.then(F=>F.call(q,Q,z))},listen(q,Q){const z=new m.Relay;return $.then(F=>z.input=F.listen(q,Q)),z.event}}}e.getDelayedChannel=U;function G($){let q=!1;return{call(Q,z,F){return q?$.call(Q,z,F):(0,n.timeout)(0).then(()=>q=!0).then(()=>$.call(Q,z,F))},listen(Q,z){if(q)return $.listen(Q,z);const F=new m.Relay;return(0,n.timeout)(0).then(()=>q=!0).then(()=>F.input=$.listen(Q,z)),F.event}}}e.getNextTickChannel=G;class ee{constructor(q){this.fn=q}routeCall(q){return this.route(q)}routeEvent(q){return this.route(q)}async route(q){for(const Q of q.connections)if(await Promise.resolve(this.fn(Q.ctx)))return Promise.resolve(Q);return await m.Event.toPromise(q.onDidAddConnection),await this.route(q)}}e.StaticRouter=ee;var X;(function($){function q(N,T){const A=N,O=T&&T.disableMarshalling,_=new Map;for(const j in A)z(j)&&_.set(j,m.Event.buffer(A[j],!0));return new class{listen(j,ie,ae){const ce=_.get(ie);if(ce)return ce;if(F(ie)){const ne=A[ie];if(typeof ne=="function")return ne.call(A,ae)}throw new Error(`Event not found: ${ie}`)}call(j,ie,ae){const ce=A[ie];if(typeof ce=="function"){if(!O&&Array.isArray(ae))for(let ne=0;ne<ae.length;ne++)ae[ne]=(0,M.revive)(ae[ne]);return ce.apply(A,ae)}throw new Error(`Method not found: ${ie}`)}}}$.fromService=q;function Q(N,T){const A=T&&T.disableMarshalling;return new Proxy({},{get(O,_){if(typeof _=="string")return T?.properties?.has(_)?T.properties.get(_):F(_)?function(j){return N.listen(_,j)}:z(_)?N.listen(_):async function(...j){let ie;T&&!(0,b.isUndefinedOrNull)(T.context)?ie=[T.context,...j]:ie=j;const ae=await N.call(_,ie);return A?ae:(0,M.revive)(ae)};throw new Error(`Property not found: ${String(_)}`)}})}$.toService=Q;function z(N){return N[0]==="o"&&N[1]==="n"&&E.isUpperAsciiLetter(N.charCodeAt(2))}function F(N){return/^onDynamic/.test(N)&&E.isUpperAsciiLetter(N.charCodeAt(9))}})(X=e.ProxyChannel||(e.ProxyChannel={}));const J=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function H($){if(Array.isArray($))return $;if($&&typeof $=="object"&&typeof $.toString=="function"){let q=$.toString();if(q!=="[object Object]")return q}return $}function B($){return Array.isArray($)?$.map(H):H($)}function Y($,q,Q,z,F,N,T){T=B(T);const A=J[F],O=A[z%A.length];let _=[`%c[${$}]%c[${String(q).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(z).padStart(5," ")} - ${N}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(N)?(_=_.concat(T),_.push(")")):_.push(T),console.log.apply(console,_)}e.logWithColors=Y;class se{constructor(q,Q){this._outgoingPrefix=q,this._incomingPrefix=Q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(q,Q,z,F,N){this._totalOutgoing+=q,Y(this._outgoingPrefix,this._totalOutgoing,q,Q,z,F,N)}logIncoming(q,Q,z,F,N){this._totalIncoming+=q,Y(this._incomingPrefix,this._totalIncoming,q,Q,z,F,N)}}e.IPCLogger=se}),define(Z[127],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class w{constructor(L,D){this.sender=L,this.onMessage=D}send(L){try{this.sender.send("vscode:message",L.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=w}),define(Z[128],x([0,1,16,4,37]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class D{constructor(m){this.port=m,this.onMessage=n.Event.fromDOMEventEmitter(this.port,"message",I=>w.VSBuffer.wrap(I.data)),m.start()}send(m){this.port.postMessage(m.buffer)}disconnect(){this.port.close()}}e.Protocol=D;class P extends L.IPCClient{constructor(m,I){const M=new D(m);super(M,I);this.protocol=M}dispose(){this.protocol.disconnect()}}e.Client=P}),define(Z[88],x([0,1,16,4,3,37]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(P=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var S;(function(i){i.enableDiagnostics=!1,i.records=[];const r=new WeakMap;let o=0;function l(C,R){if(!r.has(C)){const W=String(++o);r.set(C,W)}return r.get(C)}function v(C,R,W,U){if(!i.enableDiagnostics)return;const G=l(C,R);if(U instanceof w.VSBuffer||U instanceof Uint8Array||U instanceof ArrayBuffer||ArrayBuffer.isView(U)){const ee=w.VSBuffer.alloc(U.byteLength);ee.set(U),i.records.push({timestamp:Date.now(),id:G,label:R,type:W,buff:ee})}else i.records.push({timestamp:Date.now(),id:G,label:R,type:W,data:U})}i.traceSocketEvent=v})(S=e.SocketDiagnostics||(e.SocketDiagnostics={}));var m;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(m=e.SocketCloseEventType||(e.SocketCloseEventType={}));let I=null;function M(){return I||(I=w.VSBuffer.alloc(0)),I}class E{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,o){if(r===0)return M();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const R=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=r),R}if(this._chunks[0].byteLength>r){const R=this._chunks[0].slice(0,r);return o&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),R}let l=w.VSBuffer.alloc(r),v=0,C=0;for(;r>0;){const R=this._chunks[C];if(R.byteLength>r){const W=R.slice(0,r);l.set(W,v),v+=r,o&&(this._chunks[C]=R.slice(r),this._totalLength-=r),r-=r}else l.set(R,v),v+=R.byteLength,o?(this._chunks.shift(),this._totalLength-=R.byteLength):C++,r-=R.byteLength}return l}}e.ChunkStream=E;var b;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(b||(b={}));function p(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var t;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(t=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(r,o,l,v){this.type=r,this.id=o,this.ack=l,this.data=v,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends L.Disposable{constructor(r){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new E,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:p(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const l=this._state.messageType,v=this._state.id,C=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",o),this._onMessage.fire(new h(l,v,C,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class y{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=w.VSBuffer.alloc(13);o.writeUInt8(r.type,0),o.writeUInt32BE(r.id,1),o.writeUInt32BE(r.ack,5),o.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:p(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(o,r.data)}_bufferAdd(r,o){const l=this._totalLength===0;return this._data.push(r,o),this._totalLength+=r.byteLength+o.byteLength,l}_bufferTake(){const r=w.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,o){this._bufferAdd(r,o)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class k extends L.Disposable{constructor(r){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new y(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new h(1,0,0,r))}}e.Protocol=k;class d extends D.IPCClient{constructor(r,o,l=null){super(r,o,l);this.protocol=r}static fromSocket(r,o){return new d(new k(r),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=d;class u{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=u;class c{constructor(r){this.data=r,this.next=null}}class a{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],o=0,l=this._first;for(;l;)r[o++]=l.data,l=l.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const o=new c(r);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class f{constructor(){this.lastRuns=[];const r=Date.now();for(let o=0;o<f._HISTORY_LENGTH;o++)this.lastRuns[o]=r-1e3*o;setInterval(()=>{for(let o=f._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return f._INSTANCE||(f._INSTANCE=new f),f._INSTANCE}load(){const r=Date.now(),o=(1+f._HISTORY_LENGTH)*1e3;let l=0;for(let v=0;v<f._HISTORY_LENGTH;v++)r-this.lastRuns[v]<=o&&l++;return 1-l/f._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}f._HISTORY_LENGTH=10,f._INSTANCE=null;class s{constructor(r,o=null,l=f.getInstance()){this._onControlMessage=new u,this.onControlMessage=this._onControlMessage.event,this._onMessage=new u,this.onMessage=this._onMessage.event,this._onDidDispose=new u,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new u,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new u,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new y(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(v=>this._receiveMessage(v))),this._socketDisposables.push(this._socket.onClose(v=>this._onSocketClose.fire(v))),o&&this._socketReader.acceptChunk(o)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,L.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new h(5,0,0,M());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new h(7,0,0,M());this._socketWriter.write(r)}sendResume(){const r=new h(8,0,0,M());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,o){this._isReconnecting=!0,this._socketDisposables=(0,L.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new y(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new g(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new h(3,0,this._incomingAckId,M());this._socketWriter.write(r);const o=this._outgoingUnackMsg.toArray();for(let l=0,v=o.length;l<v;l++)this._socketWriter.write(o[l]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new h(6,0,0,M())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const o=this._outgoingUnackMsg.toArray();for(let l=0,v=o.length;l<v;l++)this._socketWriter.write(o[l]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new h(1,o,this._incomingAckId,r);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(r){const o=new h(2,0,0,r);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),o=Date.now()-r.writtenTime,l=Date.now()-this._socketReader.lastReadTime,v=Date.now()-this._lastSocketTimeoutTime;if(o>=2e4&&l>=2e4&&v>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const C=Math.max(2e4-o,2e4-l,2e4-v,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},C)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new h(3,0,this._incomingAckId,M());this._socketWriter.write(r)}}e.PersistentProtocol=s}),define(Z[129],x([0,1,12,16,4,3,37,127]),function(V,e,w,n,L,D,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function m(M,E){const b=L.Event.fromNodeEventEmitter(w.ipcMain,E,(t,h)=>({event:t,message:h})),p=L.Event.filter(b,({event:t})=>t.sender.id===M);return L.Event.map(p,({message:t})=>t&&n.VSBuffer.wrap(t))}class I extends P.IPCServer{constructor(){super(I.getOnDidClientConnect())}static getOnDidClientConnect(){const E=L.Event.fromNodeEventEmitter(w.ipcMain,"vscode:hello",({sender:b})=>b);return L.Event.map(E,b=>{const p=b.id,t=I.Clients.get(p);t&&t.dispose();const h=new L.Emitter;I.Clients.set(p,(0,D.toDisposable)(()=>h.fire()));const g=m(p,"vscode:message"),y=L.Event.any(L.Event.signal(m(p,"vscode:disconnect")),h.event);return{protocol:new S.Protocol(b,g),onDidClientDisconnect:y}})}}e.Server=I,I.Clients=new Map}),define(Z[89],x([0,1,12,4,31,128]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class P extends D.Client{constructor(I,M){super({addEventListener:(E,b)=>I.addListener(E,b),removeEventListener:(E,b)=>I.removeListener(E,b),postMessage:E=>I.postMessage(E),start:()=>I.start(),close:()=>I.close()},M)}}e.Client=P;async function S(m){if(m.isDestroyed()||m.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const I=(0,L.generateUuid)();m.webContents.send("vscode:createMessageChannel",I);const M=n.Event.fromNodeEventEmitter(w.ipcMain,"vscode:createMessageChannelResult",(b,p)=>({nonce:p,port:b.ports[0]})),{port:E}=await n.Event.toPromise(n.Event.once(n.Event.filter(M,b=>b.nonce===I)));return E}e.connect=S}),define(Z[90],x([0,1,9,4,3,14]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var P;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(P=e.StorageHint||(e.StorageHint={}));function S(E){const b=E;return b?.changed instanceof Map||b?.deleted instanceof Set}e.isStorageItemsChangeEvent=S;var m;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(m||(m={}));class I extends L.Disposable{constructor(b,p=Object.create(null)){super();this.database=b,this.options=p,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=m.None,this.cache=new Map,this.flushDelayer=new w.ThrottledDelayer(I.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(b=>this.onDidChangeItemsExternal(b)))}onDidChangeItemsExternal(b){b.changed?.forEach((p,t)=>this.accept(t,p)),b.deleted?.forEach(p=>this.accept(p,void 0))}accept(b,p){if(this.state===m.Closed)return;let t=!1;(0,D.isUndefinedOrNull)(p)?t=this.cache.delete(b):this.cache.get(b)!==p&&(this.cache.set(b,p),t=!0),t&&this._onDidChangeStorage.fire(b)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===m.None&&(this.state=m.Initialized,this.options.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(b,p){const t=this.cache.get(b);return(0,D.isUndefinedOrNull)(t)?p:t}getBoolean(b,p){const t=this.get(b);return(0,D.isUndefinedOrNull)(t)?p:t==="true"}getNumber(b,p){const t=this.get(b);return(0,D.isUndefinedOrNull)(t)?p:parseInt(t,10)}async set(b,p){if(this.state===m.Closed)return;if((0,D.isUndefinedOrNull)(p))return this.delete(b);const t=String(p);if(this.cache.get(b)!==t)return this.cache.set(b,t),this.pendingInserts.set(b,t),this.pendingDeletes.delete(b),this._onDidChangeStorage.fire(b),this.doFlush()}async delete(b){if(!(this.state===m.Closed||!this.cache.delete(b)))return this.pendingDeletes.has(b)||this.pendingDeletes.add(b),this.pendingInserts.delete(b),this._onDidChangeStorage.fire(b),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=m.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const b={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(b).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(b){if(!!this.hasPending)return this.doFlush(b)}async doFlush(b){return this.flushDelayer.trigger(()=>this.flushPending(),b)}async whenFlushed(){if(!!this.hasPending)return new Promise(b=>this.whenFlushedCallbacks.push(b))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=I,I.DEFAULT_FLUSH_DELAY=100;class M{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(b){b.insert&&b.insert.forEach((p,t)=>this.items.set(t,p)),b.delete&&b.delete.forEach(p=>this.items.delete(p))}async close(){}}e.InMemoryStorageDatabase=M}),define(Z[130],x([0,1,9,4,35,7,24,2]),function(V,e,w,n,L,D,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class m{constructor(E,b=Object.create(null)){this.path=E,this.options=b,this.name=(0,D.basename)(this.path),this.logger=new I(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return n.Event.None}async getItems(){const E=await this.whenConnected,b=new Map;return(await this.all(E,"SELECT * FROM ItemTable")).forEach(t=>b.set(t.key,t.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${b.size} rows`),b}async updateItems(E){const b=await this.whenConnected;return this.doUpdateItems(b,E)}doUpdateItems(E,b){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${b.insert?(0,L.mapToString)(b.insert):"0"}), delete(${b.delete?(0,L.setToString)(b.delete):"0"})`),this.transaction(E,()=>{const p=b.insert,t=b.delete;if(p&&p.size>0){const h=[];h.push([]);let g=0;p.forEach((y,k)=>{let d=h[g];d.length>m.MAX_HOST_PARAMETERS&&(g++,d=[],h.push(d)),d.push(k,y)}),h.forEach(y=>{this.prepare(E,`INSERT INTO ItemTable VALUES ${new Array(y.length/2).fill("(?,?)").join(",")}`,k=>k.run(y),()=>{const k=[];let d=0;return p.forEach((u,c)=>{k.push(c),d+=u.length}),`Keys: ${k.join(", ")} Length: ${d}`})})}if(t&&t.size){const h=[];h.push([]);let g=0;t.forEach(y=>{let k=h[g];k.length>m.MAX_HOST_PARAMETERS&&(g++,k=[],h.push(k)),k.push(y)}),h.forEach(y=>{this.prepare(E,`DELETE FROM ItemTable WHERE key IN (${new Array(y.length).fill("?").join(",")})`,k=>k.run(y),()=>{const k=[];return t.forEach(d=>{k.push(d)}),`Keys: ${k.join(", ")}`})})}})}async close(E){this.logger.trace(`[storage ${this.name}] close()`);const b=await this.whenConnected;return this.doClose(b,E)}doClose(E,b){return new Promise((p,t)=>{E.db.close(h=>(h&&this.handleSQLiteError(E,`[storage ${this.name}] close(): ${h}`),this.path===m.IN_MEMORY_PATH?p():!E.isErroneous&&!E.isInMemory?this.backup().then(p,g=>(this.logger.error(`[storage ${this.name}] backup(): ${g}`),p())):typeof b=="function"?P.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(g=>{const y=()=>this.doClose(g,void 0);return this.doUpdateItems(g,{insert:b()}).then(()=>y(),k=>(y(),Promise.reject(k)))})).then(p,t):t(h||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const E=this.toBackupPath(this.path);return P.Promises.copy(this.path,E,{preserveSymlinks:!1})}toBackupPath(E){return`${E}.backup`}async checkIntegrity(E){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${E})`);const b=await this.whenConnected,p=await this.get(b,E?"PRAGMA integrity_check":"PRAGMA quick_check"),t=E?p.integrity_check:p.quick_check;return b.isErroneous?`${t} (last error: ${b.lastError})`:b.isInMemory?`${t} (in-memory!)`:t}async connect(E,b=!0){this.logger.trace(`[storage ${this.name}] open(${E}, retryOnBusy: ${b})`),this.logger.trace(`[storage ${this.name}] open - source: ${new Error().stack}`);try{return await this.doConnect(E)}catch(p){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${p}`),p.code==="SQLITE_BUSY"&&b)return await(0,w.timeout)(m.BUSY_OPEN_TIMEOUT),this.connect(E,!1);try{await P.Promises.unlink(E);try{await P.Promises.rename(this.toBackupPath(E),E)}catch{}return await this.doConnect(E)}catch(t){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${t}`),this.doConnect(m.IN_MEMORY_PATH)}}}handleSQLiteError(E,b){E.isErroneous=!0,E.lastError=b,this.logger.error(b)}doConnect(E){return new Promise((b,p)=>{new Promise((t,h)=>{V(["@vscode/sqlite3"],t,h)}).then(t=>{const h={db:new(this.logger.isTracing?t.verbose().Database:t.Database)(E,g=>g?h.db?h.db.close(()=>p(g)):p(g):this.exec(h,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>b(h),y=>h.db.close(()=>p(y)))),isInMemory:E===m.IN_MEMORY_PATH};h.db.on("error",g=>this.handleSQLiteError(h,`[storage ${this.name}] Error (event): ${g}`)),this.logger.isTracing&&h.db.on("trace",g=>this.logger.trace(`[storage ${this.name}] Trace (event): ${g}`))},p)})}exec(E,b){return new Promise((p,t)=>{E.db.exec(b,h=>h?(this.handleSQLiteError(E,`[storage ${this.name}] exec(): ${h}`),t(h)):p())})}get(E,b){return new Promise((p,t)=>{E.db.get(b,(h,g)=>h?(this.handleSQLiteError(E,`[storage ${this.name}] get(): ${h}`),t(h)):p(g))})}all(E,b){return new Promise((p,t)=>{E.db.all(b,(h,g)=>h?(this.handleSQLiteError(E,`[storage ${this.name}] all(): ${h}`),t(h)):p(g))})}transaction(E,b){return new Promise((p,t)=>{E.db.serialize(()=>{E.db.run("BEGIN TRANSACTION"),b(),E.db.run("END TRANSACTION",h=>h?(this.handleSQLiteError(E,`[storage ${this.name}] transaction(): ${h}`),t(h)):p())})})}prepare(E,b,p,t){const h=E.db.prepare(b),g=y=>{this.handleSQLiteError(E,`[storage ${this.name}] prepare(): ${y} (${b}). Details: ${t()}`)};h.on("error",g),p(h),h.finalize(y=>{y&&g(y),h.removeListener("error",g)})}}e.SQLiteStorageDatabase=m,m.IN_MEMORY_PATH=":memory:",m.BUSY_OPEN_TIMEOUT=2e3,m.MAX_HOST_PARAMETERS=256;class I{constructor(E){E&&typeof E.logTrace=="function"&&(process.env[I.VSCODE_TRACE_STORAGE]||S.isCI)&&(this.logTrace=E.logTrace),E&&typeof E.logError=="function"&&(this.logError=E.logError)}get isTracing(){return!!this.logTrace}trace(E){this.logTrace&&this.logTrace(E)}error(E){this.logError&&this.logError(E)}}I.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Z[131],x([13,11]),function(V,e){return V.create("vs/base/common/date",e)}),define(Z[132],x([0,1,131]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,L=n*60,D=L*24,P=D*7,S=D*30,m=D*365;function I(E,b,p){typeof E!="number"&&(E=E.getTime());const t=Math.round((new Date().getTime()-E)/1e3);if(t<-30)return(0,w.localize)(0,null,I(new Date().getTime()+t*1e3,!1));if(t<30)return(0,w.localize)(1,null);let h;return t<n?(h=t,b?h===1?p?(0,w.localize)(2,null,h):(0,w.localize)(3,null,h):p?(0,w.localize)(4,null,h):(0,w.localize)(5,null,h):h===1?p?(0,w.localize)(6,null,h):(0,w.localize)(7,null,h):p?(0,w.localize)(8,null,h):(0,w.localize)(9,null,h)):t<L?(h=Math.floor(t/n),b?h===1?p?(0,w.localize)(10,null,h):(0,w.localize)(11,null,h):p?(0,w.localize)(12,null,h):(0,w.localize)(13,null,h):h===1?p?(0,w.localize)(14,null,h):(0,w.localize)(15,null,h):p?(0,w.localize)(16,null,h):(0,w.localize)(17,null,h)):t<D?(h=Math.floor(t/L),b?h===1?p?(0,w.localize)(18,null,h):(0,w.localize)(19,null,h):p?(0,w.localize)(20,null,h):(0,w.localize)(21,null,h):h===1?p?(0,w.localize)(22,null,h):(0,w.localize)(23,null,h):p?(0,w.localize)(24,null,h):(0,w.localize)(25,null,h)):t<P?(h=Math.floor(t/D),b?h===1?(0,w.localize)(26,null,h):(0,w.localize)(27,null,h):h===1?(0,w.localize)(28,null,h):(0,w.localize)(29,null,h)):t<S?(h=Math.floor(t/P),b?h===1?p?(0,w.localize)(30,null,h):(0,w.localize)(31,null,h):p?(0,w.localize)(32,null,h):(0,w.localize)(33,null,h):h===1?p?(0,w.localize)(34,null,h):(0,w.localize)(35,null,h):p?(0,w.localize)(36,null,h):(0,w.localize)(37,null,h)):t<m?(h=Math.floor(t/S),b?h===1?p?(0,w.localize)(38,null,h):(0,w.localize)(39,null,h):p?(0,w.localize)(40,null,h):(0,w.localize)(41,null,h):h===1?p?(0,w.localize)(42,null,h):(0,w.localize)(43,null,h):p?(0,w.localize)(44,null,h):(0,w.localize)(45,null,h)):(h=Math.floor(t/m),b?h===1?p?(0,w.localize)(46,null,h):(0,w.localize)(47,null,h):p?(0,w.localize)(48,null,h):(0,w.localize)(49,null,h):h===1?p?(0,w.localize)(50,null,h):(0,w.localize)(51,null,h):p?(0,w.localize)(52,null,h):(0,w.localize)(53,null,h))}e.fromNow=I;function M(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=M}),define(Z[133],x([13,11]),function(V,e){return V.create("vs/base/common/errorMessage",e)}),define(Z[39],x([0,1,30,14,133]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function D(E,b){return b&&(E.stack||E.stacktrace)?L.localize(0,null,S(E),P(E.stack)||P(E.stacktrace)):S(E)}function P(E){return Array.isArray(E)?E.join(`
`):E}function S(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?L.localize(1,null,E.message):E.message||L.localize(2,null)}function m(E=null,b=!1){if(!E)return L.localize(3,null);if(Array.isArray(E)){const p=w.coalesce(E),t=m(p[0],b);return p.length>1?L.localize(4,null,t,p.length):t}if(n.isString(E))return E;if(E.detail){const p=E.detail;if(p.error)return D(p.error,b);if(p.exception)return D(p.exception,b)}return E.stack?D(E,b):E.message?E.message:L.localize(5,null)}e.toErrorMessage=m;function I(E){const b=E;return b instanceof Error&&Array.isArray(b.actions)}e.isErrorWithActions=I;function M(E,b=Object.create(null)){const p=new Error(E);return b.actions&&(p.actions=b.actions),p}e.createErrorWithActions=M}),define(Z[134],x([13,11]),function(V,e){return V.create("vs/base/common/keybindingLabels",e)}),define(Z[135],x([0,1,134]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class n{constructor(P,S,m=S){this.modifierLabels=[null],this.modifierLabels[2]=P,this.modifierLabels[1]=S,this.modifierLabels[3]=m}toLabel(P,S,m){if(S.length===0)return null;const I=[];for(let M=0,E=S.length;M<E;M++){const b=S[M],p=m(b);if(p===null)return null;I[M]=L(b,p,this.modifierLabels[P])}return I.join(" ")}}e.ModifierLabelProvider=n,e.UILabelProvider=new n({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:w.localize(0,null),shiftKey:w.localize(1,null),altKey:w.localize(2,null),metaKey:w.localize(3,null),separator:"+"},{ctrlKey:w.localize(4,null),shiftKey:w.localize(5,null),altKey:w.localize(6,null),metaKey:w.localize(7,null),separator:"+"}),e.AriaLabelProvider=new n({ctrlKey:w.localize(8,null),shiftKey:w.localize(9,null),altKey:w.localize(10,null),metaKey:w.localize(11,null),separator:"+"},{ctrlKey:w.localize(12,null),shiftKey:w.localize(13,null),altKey:w.localize(14,null),metaKey:w.localize(15,null),separator:"+"},{ctrlKey:w.localize(16,null),shiftKey:w.localize(17,null),altKey:w.localize(18,null),metaKey:w.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new n({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new n({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function L(D,P,S){if(P===null)return"";const m=[];return D.ctrlKey&&m.push(S.ctrlKey),D.shiftKey&&m.push(S.shiftKey),D.altKey&&m.push(S.altKey),D.metaKey&&m.push(S.metaKey),P!==""&&m.push(P),m.join(S.separator)}}),define(Z[136],x([13,11]),function(V,e){return V.create("vs/base/node/processes",e)}),define(Z[72],x([0,1,45,28,10,49,7,2,36,84,14,120,24,136]),function(V,e,w,n,L,D,P,S,m,I,M,E,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function t(a){switch(a){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(a,f){if(S.isWindows)try{const s={stdio:["pipe","pipe","ignore"]};f&&(s.cwd=f);const i=w.execFile("taskkill",["/T","/F","/PID",a.pid.toString()],s);return new Promise(r=>{i.once("error",o=>{r({success:!1,error:o})}),i.once("exit",(o,l)=>{r(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(s){return Promise.resolve({success:!1,error:s,code:s.status?t(s.status):1})}else if(S.isLinux||S.isMacintosh)try{const s=L.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",V).fsPath;return new Promise(i=>{w.execFile(s,[a.pid.toString()],{encoding:"utf8",shell:!0},(r,o,l)=>{i(r?{success:!1,error:r}:{success:!0})})})}catch(s){return Promise.resolve({success:!1,error:s})}else a.kill("SIGKILL");return Promise.resolve({success:!0})}function g(a){!a||(delete a.DEBUG,S.isMacintosh&&delete a.DYLD_LIBRARY_PATH,S.isLinux&&delete a.LD_PRELOAD)}e.removeDangerousEnvVariables=g;function y(a=m.env){return a.comspec||"cmd.exe"}e.getWindowsShell=y;class k{constructor(f,s,i,r){if(s!==void 0&&i!==void 0&&r!==void 0)this.cmd=f,this.args=s,this.shell=i,this.options=r;else{const o=f;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(m.env).forEach(l=>{o[l]=m.env[l]}),Object.keys(this.options.env).forEach(l=>{o[l]=this.options.env[l]}),this.options.env=o}}getSanitizedCommand(){let f=this.cmd.toLowerCase();const s=f.lastIndexOf(P.sep);return s!==-1&&(f=f.substring(s+1)),k.WellKnowCommands[f]?f:"other"}start(f){return S.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(m.cwd()))?Promise.reject(new Error(p.localize(0,null))):this.useExec().then(s=>{let i,r;const o=new Promise((l,v)=>{i=l,r=v});if(s){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=w.exec(l,this.options,(v,C,R)=>{this.childProcess=null;const W=v;W&&W.killed?r({killed:this.terminateRequested,stdout:C.toString(),stderr:R.toString()}):this.handleExec(i,f,v,C,R)})}else{let l=null;const v=C=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(C,i,f,r);const R={terminated:this.terminateRequested};M.isNumber(C)&&(R.cmdCode=C),i(R)};if(this.shell&&S.isWindows){const C=D.deepClone(this.options);C.windowsVerbatimArguments=!0,C.detached=!1;let R=!1,W=!1;const U=[];let G=this.ensureQuotes(this.cmd);U.push(G.value),R=G.quoted,this.args&&this.args.forEach(X=>{G=this.ensureQuotes(X),U.push(G.value),W=W&&G.quoted});const ee=["/s","/c"];R?W?ee.push('"'+U.join(" ")+'"'):U.length>1?ee.push('"'+U[0]+'" '+U.slice(1).join(" ")):ee.push('"'+U[0]+'"'):ee.push(U.join(" ")),l=w.spawn(y(),ee,C)}else this.cmd&&(l=w.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(M.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",C=>{this.childProcess=null,r({terminated:this.terminateRequested,error:C})}),l.pid&&(this.childProcess.on("close",v),this.handleSpawn(l,i,f,r,!0)))}return o})}handleClose(f,s,i,r){}ensureQuotes(f){return k.regexp.test(f)?{value:'"'+f+'"',quoted:!0}:{value:f,quoted:f.length>0&&f[0]==='"'&&f[f.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(f=>f.pid,f=>-1):new Promise(f=>{this.pidResolve=f})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(f=>(this.terminateRequested=!0,h(f,this.options.cwd).then(s=>(s.success&&(this.childProcess=null),s))),f=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(f=>{if(!this.shell||!S.isWindows)return f(!1);const s=w.spawn(y(),["/s","/c"]);s.on("error",i=>f(!0)),s.on("exit",i=>f(!1))})}}e.AbstractProcess=k,k.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},k.regexp=/^[^"].* .*[^"]/;class d extends k{constructor(f,s,i,r){super(f,s,i,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(f,s,i,r,o){[r,o].forEach((l,v)=>{const C=new E.LineDecoder;C.write(l).forEach(U=>{s({line:U,source:v===0?0:1})});const W=C.end();W&&s({line:W,source:v===0?0:1})}),f({terminated:this.terminateRequested,error:i})}handleSpawn(f,s,i,r,o){const l=new E.LineDecoder,v=new E.LineDecoder;f.stdout.on("data",C=>{l.write(C).forEach(W=>i({line:W,source:0}))}),f.stderr.on("data",C=>{v.write(C).forEach(W=>i({line:W,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=v}handleClose(f,s,i,r){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&i({line:o,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&i({line:l,source:1})}}e.LineProcess=d;function u(a){let f=[],s=!1;const i=function(r){if(s){f.push(r);return}(!a.send(r,l=>{if(l&&console.error(l),s=!1,f.length>0){const v=f.slice(0);f=[],v.forEach(C=>i(C))}})||S.isWindows)&&(s=!0)};return{send:i}}e.createQueuedSender=u;var c;(function(a){async function f(s,i,r){if(P.isAbsolute(s))return s;if(i===void 0&&(i=m.cwd()),P.dirname(s)!=="."||(r===void 0&&M.isString(m.env.PATH)&&(r=m.env.PATH.split(P.delimiter)),r===void 0||r.length===0))return P.join(i,s);async function l(v){if(await b.Promises.exists(v)){let C;try{C=await b.Promises.stat(v)}catch(R){R.message.startsWith("EACCES")&&(C=await b.Promises.lstat(v))}return C?!C.isDirectory():!1}return!1}for(let v of r){let C;if(P.isAbsolute(v)?C=P.join(v,s):C=P.join(i,v,s),await l(C))return C;let R=C+".com";if(await l(R)||(R=C+".exe",await l(R)))return R}return P.join(i,s)}a.findExecutable=f})(c=e.win32||(e.win32={}))}),define(Z[137],x([0,1,26,2,124,72]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function P(p,t){return p===1?n.isWindows?E():D.getWindowsShell(t):I(p,t)}e.getSystemShell=P;function S(p,t){return p===1?n.isWindows?b(t):D.getWindowsShell(t):I(p,t)}e.getSystemShellSync=S;let m=null;function I(p,t){if(n.isLinux&&p===2||n.isMacintosh&&p===3)return"/bin/bash";if(!m){let h;if(n.isWindows)h="/bin/bash";else{if(h=t.SHELL,!h)try{h=(0,w.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}m=h}return m}let M=null;async function E(){return M||(M=(await(0,L.getFirstAvailablePowerShellInstallation)()).exePath),M}function b(p){if(M)return M;const t=n.isWindows&&parseFloat((0,w.release)())>=10,h=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),g=`${p.windir}\\${h?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return t?g:D.getWindowsShell(p)}}),define(Z[138],x([0,1,45,9,16,23,114,15,4,3,49,72,37]),function(V,e,w,n,L,D,P,S,m,I,M,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends b.ChannelServer{constructor(g){super({send:y=>{try{process.send&&process.send(y.buffer.toString("base64"))}catch{}},onMessage:m.Event.fromNodeEventEmitter(process,"message",y=>L.VSBuffer.wrap(Buffer.from(y,"base64")))},g);process.once("disconnect",()=>this.dispose())}}e.Server=p;class t{constructor(g,y){this.modulePath=g,this.options=y,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new m.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const k=y&&y.timeout?y.timeout:6e4;this.disposeDelayer=new n.Delayer(k),this.child=null,this._client=null}getChannel(g){const y=this;return{call(k,d,u){return y.requestPromise(g,k,d,u)},listen(k,d){return y.requestEvent(g,k,d)}}}requestPromise(g,y,k,d=D.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(S.canceled());this.disposeDelayer.cancel();const u=this.getCachedChannel(g),c=(0,n.createCancelablePromise)(s=>u.call(y,k,s)),a=d.onCancellationRequested(()=>c.cancel()),f=(0,I.toDisposable)(()=>c.cancel());return this.activeRequests.add(f),c.finally(()=>{a.dispose(),this.activeRequests.delete(f),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),c}requestEvent(g,y,k){if(!this.disposeDelayer)return m.Event.None;this.disposeDelayer.cancel();let d;const u=new m.Emitter({onFirstListenerAdd:()=>{d=this.getCachedChannel(g).listen(y,k)(u.fire,u),this.activeRequests.add(d)},onLastListenerRemove:()=>{this.activeRequests.delete(d),d.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return u.event}get client(){if(!this._client){const g=this.options&&this.options.args?this.options.args:[],y=Object.create(null);y.env={...(0,M.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(y.env={...y.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(y.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(y.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(y.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),y.execArgv===void 0&&(y.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i))),(0,E.removeDangerousEnvVariables)(y.env),this.child=(0,w.fork)(this.modulePath,g,y);const k=new m.Emitter;m.Event.fromNodeEventEmitter(this.child,"message",i=>i)(i=>{if((0,P.isRemoteConsoleLog)(i)){(0,P.log)(i,`IPC Library: ${this.options.serverName}`);return}k.fire(L.VSBuffer.wrap(Buffer.from(i,"base64")))});const u=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,c=i=>this.child&&this.child.connected&&u.send(i.buffer.toString("base64")),a=k.event,f={send:c,onMessage:a};this._client=new b.ChannelClient(f);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",i=>console.warn('IPC "'+this.options.serverName+'" errored with '+i)),this.child.on("exit",(i,r)=>{process.removeListener("exit",s),this.activeRequests.forEach(o=>(0,I.dispose)(o)),this.activeRequests.clear(),i!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+i+" and signal "+r),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:i,signal:r})})}return this._client}getCachedChannel(g){let y=this.channels.get(g);return y||(y=this.client.getChannel(g),this.channels.set(g,y)),y}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=t}),define(Z[139],x([13,11]),function(V,e){return V.create("vs/code/electron-main/app",e)}),define(Z[140],x([13,11]),function(V,e){return V.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[141],x([13,11]),function(V,e){return V.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Z[142],x([13,11]),function(V,e){return V.create("vs/platform/environment/node/argv",e)}),define(Z[143],x([13,11]),function(V,e){return V.create("vs/platform/environment/node/argvHelper",e)}),define(Z[144],x([13,11]),function(V,e){return V.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Z[145],x([13,11]),function(V,e){return V.create("vs/platform/files/common/fileService",e)}),define(Z[146],x([13,11]),function(V,e){return V.create("vs/platform/files/common/files",e)}),define(Z[147],x([13,11]),function(V,e){return V.create("vs/platform/files/common/io",e)}),define(Z[148],x([13,11]),function(V,e){return V.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(Z[149],x([13,11]),function(V,e){return V.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[150],x([13,11]),function(V,e){return V.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Z[151],x([13,11]),function(V,e){return V.create("vs/platform/menubar/electron-main/menubar",e)}),define(Z[152],x([13,11]),function(V,e){return V.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Z[153],x([13,11]),function(V,e){return V.create("vs/platform/request/common/request",e)}),define(Z[154],x([13,11]),function(V,e){return V.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[155],x([13,11]),function(V,e){return V.create("vs/platform/terminal/node/shellEnv",e)}),define(Z[156],x([13,11]),function(V,e){return V.create("vs/platform/update/common/update.config.contribution",e)}),define(Z[157],x([13,11]),function(V,e){return V.create("vs/platform/windows/electron-main/window",e)}),define(Z[158],x([13,11]),function(V,e){return V.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Z[159],x([13,11]),function(V,e){return V.create("vs/platform/workspace/common/workspace",e)}),define(Z[160],x([13,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Z[161],x([13,11]),function(V,e){return V.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Z[162],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function w(L){return L&&L.hasOwnProperty("folderUri")}e.isFolderBackupInfo=w;function n(L){return L&&L.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=n}),define(Z[163],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=void 0;function w(n){return typeof n?.backupFolder=="string"}e.isEmptyWindowBackupInfo=w}),define(Z[164],x([0,1,4,3]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class L{constructor(){this._onCloseEmitter=new w.Emitter,this._onReloadEmitter=new w.Emitter,this._onTerminateEmitter=new w.Emitter,this._onAttachEmitter=new w.Emitter}call(S,m,I){switch(m){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:I[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:I[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:I[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:I[0],port:I[1],subId:I[2]}))}throw new Error("Method not implemented.")}listen(S,m,I){switch(m){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=L,L.ChannelName="extensionhostdebugservice";class D extends n.Disposable{constructor(S){super();this.channel=S}reload(S){this.channel.call("reload",[S])}get onReload(){return this.channel.listen("reload")}close(S){this.channel.call("close",[S])}get onClose(){return this.channel.listen("close")}attachSession(S,m,I){this.channel.call("attach",[S,m,I])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(S,m){this.channel.call("terminate",[S,m])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(S,m){return this.channel.call("openExtensionDevelopmentHostWindow",[S,m])}}e.ExtensionHostDebugChannelClient=D}),define(Z[165],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class w{constructor(P){this.driver=P}listen(P,S){throw new Error(`No event found: ${S}`)}call(P,S,m){switch(S){case"click":return this.driver.click(m[0],m[1],m[2]);case"doubleClick":return this.driver.doubleClick(m);case"setValue":return this.driver.setValue(m[0],m[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(m);case"getElements":return this.driver.getElements(m[0],m[1]);case"getElementXY":return this.driver.getElementXY(m[0],m[1],m[2]);case"typeInEditor":return this.driver.typeInEditor(m[0],m[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(m);case"writeInTerminal":return this.driver.writeInTerminal(m[0],m[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${S}`)}}e.WindowDriverChannel=w;class n{constructor(P){this.channel=P}click(P,S,m){return this.channel.call("click",[P,S,m])}doubleClick(P){return this.channel.call("doubleClick",P)}setValue(P,S){return this.channel.call("setValue",[P,S])}getTitle(){return this.channel.call("getTitle")}isActiveElement(P){return this.channel.call("isActiveElement",P)}getElements(P,S){return this.channel.call("getElements",[P,S])}getElementXY(P,S,m){return this.channel.call("getElementXY",[P,S,m])}typeInEditor(P,S){return this.channel.call("typeInEditor",[P,S])}getTerminalBuffer(P){return this.channel.call("getTerminalBuffer",P)}writeInTerminal(P,S){return this.channel.call("writeInTerminal",[P,S])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=n;class L{constructor(P){this.channel=P}registerWindowDriver(P){return this.channel.call("registerWindowDriver",P)}reloadWindowDriver(P){return this.channel.call("reloadWindowDriver",P)}}e.WindowDriverRegistryChannelClient=L}),define(Z[166],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class w{constructor(L){this.machineId=L}encryption(){return new Promise((L,D)=>V(["vscode-encrypt"],L,D))}async encrypt(L){try{return(await this.encryption()).encrypt(this.machineId,L)}catch{return L}}async decrypt(L){try{return(await this.encryption()).decrypt(this.machineId,L)}catch{return L}}}e.EncryptionMainService=w}),define(Z[167],x([0,1,132,46,10,7,36,17,8]),function(V,e,w,n,L,D,P,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class I{constructor(h,g,y){this._args=h,this.paths=g,this.productService=y}get appRoot(){return(0,D.dirname)(L.FileAccess.asFileUri("",V).fsPath)}get userHome(){return m.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return m.URI.file((0,D.join)(this.userDataPath,"User"))}get tmpDir(){return m.URI.file(this.paths.tmpDir)}get cacheHome(){return m.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,S.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,S.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return m.URI.file((0,D.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.joinPath)(m.URI.file((0,D.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return m.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return m.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,S.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,S.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=P.env.VSCODE_PORTABLE;return h?m.URI.file((0,D.join)(h,"argv.json")):(0,S.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,S.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return m.URI.file((0,D.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,D.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,D.resolve)(h):(0,D.normalize)((0,D.join)(L.FileAccess.asFileUri("",V).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?(0,D.resolve)(h):(0,D.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,D.resolve)(h);const g=P.env.VSCODE_EXTENSIONS;if(g)return g;const y=P.env.VSCODE_PORTABLE;return y?(0,D.join)(y,"extensions"):(0,S.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(g=>/^[^:/?#]+?:\/\//.test(g)?m.URI.parse(g):m.URI.file((0,D.normalize)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?m.URI.parse(h):m.URI.file((0,D.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return M(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!P.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,S.joinPath)(m.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return m.URI.file((0,D.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ue([n.memoize],I.prototype,"appRoot",null),ue([n.memoize],I.prototype,"userHome",null),ue([n.memoize],I.prototype,"userDataPath",null),ue([n.memoize],I.prototype,"appSettingsHome",null),ue([n.memoize],I.prototype,"tmpDir",null),ue([n.memoize],I.prototype,"cacheHome",null),ue([n.memoize],I.prototype,"userRoamingDataHome",null),ue([n.memoize],I.prototype,"settingsResource",null),ue([n.memoize],I.prototype,"userDataSyncHome",null),ue([n.memoize],I.prototype,"userDataSyncLogResource",null),ue([n.memoize],I.prototype,"sync",null),ue([n.memoize],I.prototype,"machineSettingsResource",null),ue([n.memoize],I.prototype,"globalStorageHome",null),ue([n.memoize],I.prototype,"workspaceStorageHome",null),ue([n.memoize],I.prototype,"keybindingsResource",null),ue([n.memoize],I.prototype,"keyboardLayoutResource",null),ue([n.memoize],I.prototype,"argvResource",null),ue([n.memoize],I.prototype,"snippetsHome",null),ue([n.memoize],I.prototype,"isExtensionDevelopment",null),ue([n.memoize],I.prototype,"untitledWorkspacesHome",null),ue([n.memoize],I.prototype,"installSourcePath",null),ue([n.memoize],I.prototype,"builtinExtensionsPath",null),ue([n.memoize],I.prototype,"extensionsPath",null),ue([n.memoize],I.prototype,"extensionDevelopmentLocationURI",null),ue([n.memoize],I.prototype,"extensionDevelopmentKind",null),ue([n.memoize],I.prototype,"extensionTestsLocationURI",null),ue([n.memoize],I.prototype,"debugExtensionHost",null),ue([n.memoize],I.prototype,"serviceMachineIdResource",null),ue([n.memoize],I.prototype,"telemetryLogResource",null),ue([n.memoize],I.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=I;function M(t,h){return p(t["inspect-extensions"],t["inspect-brk-extensions"],5870,h,t.debugId,t.extensionEnvironment)}e.parseExtensionHostPort=M;function E(t,h){return p(t["inspect-search"],t["inspect-brk-search"],5876,h,t.extensionEnvironment)}e.parseSearchPort=E;function b(t,h){return p(t["inspect-ptyhost"],t["inspect-brk-ptyhost"],5877,h,t.extensionEnvironment)}e.parsePtyHostPort=b;function p(t,h,g,y,k,d){const c=Number(h||t)||(y?null:g),a=c?Boolean(!!h):!1;let f;if(d)try{f=JSON.parse(d)}catch{}return{port:c,break:a,debugId:k,env:f}}}),define(Z[91],x([0,1,250,2,142]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const D={o:(0,L.localize)(0,null),e:(0,L.localize)(1,null),t:(0,L.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,L.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,L.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,L.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,L.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,L.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,L.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,L.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,L.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,L.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,L.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,L.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,L.localize)(14,null)},category:{type:"string",cat:"e",description:(0,L.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,L.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,L.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,L.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"ext-id",description:(0,L.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,L.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,L.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,L.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,L.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,L.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,L.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,L.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,L.localize)(27,null),args:["on | off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,L.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,L.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,L.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,L.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,L.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const P={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function S(t,h,g=P){const y={},k=[],d=[];for(let f in h){const s=h[f];s.alias&&(y[f]=s.alias),s.type==="string"||s.type==="string[]"?(k.push(f),s.deprecates&&k.push(...s.deprecates)):s.type==="boolean"&&(d.push(f),s.deprecates&&d.push(...s.deprecates))}const u=w(t,{string:k,boolean:d,alias:y}),c={},a=u;c._=u._.map(f=>String(f)).filter(f=>f.length>0),delete a._;for(let f in h){const s=h[f];s.alias&&delete a[s.alias];let i=a[f];if(s.deprecates)for(const r of s.deprecates)a.hasOwnProperty(r)&&(i||(i=a[r],i&&g.onDeprecatedOption(r,s.deprecationMessage||(0,L.localize)(33,null))),delete a[r]);typeof i!="undefined"&&(s.type==="string[]"?i&&!Array.isArray(i)&&(i=[i]):s.type==="string"&&Array.isArray(i)&&(i=i.pop(),g.onMultipleValues(f,i)),c[f]=i,s.deprecationMessage&&g.onDeprecatedOption(f,s.deprecationMessage)),delete a[f]}for(let f in a)g.onUnknownOption(f);return c}e.parseArgs=S;function m(t,h){let g="";return h.args&&(Array.isArray(h.args)?g=` <${h.args.join("> <")}>`:g=` <${h.args}>`),h.alias?`-${h.alias} --${t}${g}`:`--${t}${g}`}function I(t,h){let g=0,y=[];for(const c in t){const a=t[c],f=m(c,a);g=Math.max(g,f.length),y.push([f,a.description])}let k=g+2+1;if(h-k<25)return y.reduce((c,a)=>c.concat([`  ${a[0]}`,`      ${a[1]}`]),[]);let d=h-k-1,u=[];for(const c of y){let a=c[0],f=E(c[1],d),s=M(k-a.length-2);u.push("  "+a+s+f[0]);for(let i=1;i<f.length;i++)u.push(M(k)+f[i])}return u}e.formatOptions=I;function M(t){return" ".repeat(t)}function E(t,h){let g=[];for(;t.length;){let y=t.length<h?t.length:t.lastIndexOf(" ",h),k=t.slice(0,y).trim();t=t.slice(y),g.push(k)}return g}function b(t,h,g,y,k){const d=process.stdout.isTTY&&process.stdout.columns||80,u=k?.noInputFiles!==!0?`[${(0,L.localize)(34,null)}...]`:"",c=[`${t} ${g}`];c.push(""),c.push(`${(0,L.localize)(35,null)}: ${h} [${(0,L.localize)(36,null)}]${u}`),c.push(""),k?.noPipe!==!0&&(n.isWindows?c.push((0,L.localize)(37,null,h)):c.push((0,L.localize)(38,null,h)),c.push(""));const a={};for(const f in y){const s=y[f];if(s.description&&s.cat){let i=a[s.cat];i||(a[s.cat]=i={}),i[f]=s}}for(let f in a){const s=f;let i=a[s];i&&(c.push(D[s]),c.push(...I(i,d)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=b;function p(t,h){return`${t||(0,L.localize)(39,null)}
${h||(0,L.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=p}),define(Z[168],x([0,1,61,164,91]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class D extends n.ExtensionHostDebugBroadcastChannel{constructor(S){super();this.windowsMainService=S}call(S,m,I){return m==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(I[0],I[1]):super.call(S,m,I)}async openExtensionDevelopmentHostWindow(S,m){const I=(0,L.parseArgs)(S,L.OPTIONS);I.debugRenderer=m;const M=I.extensionDevelopmentPath;if(!M)return{success:!1};const[E]=this.windowsMainService.openExtensionDevelopmentHostWindow(M,{context:5,cli:I});if(!m)return{success:!0};const b=E.win;if(!b)return{success:!0};const p=b.webContents.debugger;let t=p.isAttached()?1/0:0;const h=(0,w.createServer)(g=>{t++==0&&p.attach();let y=!1;const k=c=>{y||g.write(JSON.stringify(c)+"\0")},d=(c,a,f,s)=>k({method:a,params:f,sessionId:s});b.on("close",()=>{p.removeListener("message",d),g.end(),y=!0}),p.addListener("message",d);let u=Buffer.alloc(0);g.on("data",c=>{u=Buffer.concat([u,c]);for(let a=u.indexOf(0);a!==-1;a=u.indexOf(0)){let f;try{const s=u.slice(0,a).toString("utf8");u=u.slice(a+1),f=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}p.sendCommand(f.method,f.params,f.sessionId).then(s=>k({id:f.id,sessionId:f.sessionId,result:s})).catch(s=>k({id:f.id,sessionId:f.sessionId,error:{code:0,message:s.message}}))}}),g.on("error",c=>{console.error("error on cdp pipe:",c)}),g.on("close",()=>{y=!0,--t==0&&p.detach()})});return await new Promise(g=>h.listen(0,g)),b.on("close",()=>h.close()),{rendererDebugPort:h.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=D}),define(Z[50],x([0,1,251,143,91]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const D=2048;function P(b,p){const t={onUnknownOption:g=>{console.warn((0,n.localize)(0,null,g))},onMultipleValues:(g,y)=>{console.warn((0,n.localize)(1,null,g,y))},onDeprecatedOption:(g,y)=>{console.warn((0,n.localize)(2,null,g,y))}},h=(0,L.parseArgs)(b,L.OPTIONS,p?t:void 0);return h.goto&&h._.forEach(g=>w(/^(\w:)?[^:]+(:\d*){0,2}$/.test(g),(0,n.localize)(3,null))),h["max-memory"]&&w(parseInt(h["max-memory"])>=D,`The max-memory argument cannot be specified lower than ${D} MB.`),h}function S(b){const p=b.findIndex(t=>!/^-/.test(t));if(p>-1)return[...b.slice(0,p),...b.slice(p+1)]}function m(b){let[,...p]=b;process.env.VSCODE_DEV&&(p=S(p)||[]);const t=!E(process.env);return P(p,t)}e.parseMainProcessArgv=m;function I(b){const[,,...p]=b;return P(p,!0)}e.parseCLIProcessArgv=I;function M(b,...p){const t=b.indexOf("--");return t===-1?b.push(...p):b.splice(t,0,...p),b}e.addArg=M;function E(b){return b.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),function(){"use strict";function V(e,w,n,L){function D(S){const m=P(S),I=[m];return e.isAbsolute(m)||I.unshift(L),e.resolve(...I)}function P(S){const m=process.env.VSCODE_PORTABLE;if(m)return e.join(m,"user-data");let I=process.env.VSCODE_APPDATA;if(I)return e.join(I,n);const M=S["user-data-dir"];if(M)return M;switch(process.platform){case"win32":if(I=process.env.APPDATA,!I){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");I=e.join(E,"AppData","Roaming")}break;case"darwin":I=e.join(w.homedir(),"Library","Application Support");break;case"linux":I=process.env.XDG_CONFIG_HOME||e.join(w.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(I,n)}return{getUserDataPath:D}}if(typeof define=="function")define(Z[169],x([0,252,26,10,17,36]),function(e,w,n,L,D,P){const S=D.dirname(L.FileAccess.asFileUri("",e)),m=e.__$__nodeRequire(D.joinPath(S,"package.json").fsPath);return V(w,n,m.name,P.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),w=require("path"),n=require("os");module.exports=V(w,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[170],x([0,1,26,167,169]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class D extends n.AbstractNativeEnvironmentService{constructor(S,m){super(S,{homeDir:(0,w.homedir)(),tmpDir:(0,w.tmpdir)(),userDataDir:(0,L.getUserDataPath)(S)},m)}}e.NativeEnvironmentService=D}),define(Z[171],x([0,1,29,26,28]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function D(P){const S=(0,L.randomPath)((0,n.tmpdir)());try{return(0,w.writeFileSync)(S,""),P&&console.log(`Marker file for --wait created: ${S}`),S}catch(m){P&&console.error(`Failed to create marker file for --wait: ${m}`);return}}e.createWaitMarkerFile=D}),define(Z[172],x([0,1,16,31]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function L(D,P,S){let m=S&&S.get("storage.serviceMachineId",0)||null;if(m)return m;try{const M=(await P.readFile(D.serviceMachineIdResource)).value.toString();m=(0,n.isUUID)(M)?M:null}catch{m=null}if(!m){m=(0,n.generateUuid)();try{await P.writeFile(D.serviceMachineIdResource,w.VSBuffer.fromString(m))}catch{}}return S&&S.store("storage.serviceMachineId",m,0,1),m}e.getServiceMachineId=L}),define(Z[73],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class w{constructor(L,D=[],P=!1){this.ctor=L,this.staticArguments=D,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=w}),define(Z[173],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class w{constructor(D){this.incoming=new Map,this.outgoing=new Map,this.data=D}}e.Node=w;class n{constructor(D){this._hashFn=D,this._nodes=new Map}roots(){const D=[];for(let P of this._nodes.values())P.outgoing.size===0&&D.push(P);return D}insertEdge(D,P){const S=this.lookupOrInsertNode(D),m=this.lookupOrInsertNode(P);S.outgoing.set(this._hashFn(P),m),m.incoming.set(this._hashFn(D),S)}removeNode(D){const P=this._hashFn(D);this._nodes.delete(P);for(let S of this._nodes.values())S.outgoing.delete(P),S.incoming.delete(P)}lookupOrInsertNode(D){const P=this._hashFn(D);let S=this._nodes.get(P);return S||(S=new w(D),this._nodes.set(P,S)),S}lookup(D){return this._nodes.get(this._hashFn(D))}isEmpty(){return this._nodes.size===0}toString(){let D=[];for(let[P,S]of this._nodes)D.push(`${P}, (incoming)[${[...S.incoming.keys()].join(", ")}], (outgoing)[${[...S.outgoing.keys()].join(",")}]`);return D.join(`
`)}findCycleSlow(){for(let[D,P]of this._nodes){const S=new Set([D]),m=this._findCycle(P,S);if(m)return m}}_findCycle(D,P){for(let[S,m]of D.outgoing){if(P.has(S))return[...P,S].join(" -> ");P.add(S);const I=this._findCycle(m,P);if(I)return I;P.delete(S)}}}e.Graph=n}),define(Z[5],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function S(m){return m[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=S})(w=e._util||(e._util={})),e.IInstantiationService=L("instantiationService");function n(P,S,m){S[w.DI_TARGET]===S?S[w.DI_DEPENDENCIES].push({id:P,index:m}):(S[w.DI_DEPENDENCIES]=[{id:P,index:m}],S[w.DI_TARGET]=S)}function L(P){if(w.serviceIds.has(P))return w.serviceIds.get(P);const S=function(m,I,M){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(S,m,M)};return S.toString=()=>P,w.serviceIds.set(P,S),S}e.createDecorator=L;function D(P){return P}e.refineServiceDecorator=D}),define(Z[51],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,w.createDecorator)("backupMainService")}),define(Z[19],x([0,1,14,8,5]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,L.createDecorator)("configurationService");function D(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof n.URI)}e.isConfigurationOverrides=D;function P(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||w.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=P;var S;(function(g){g[g.USER=1]="USER",g[g.USER_LOCAL=2]="USER_LOCAL",g[g.USER_REMOTE=3]="USER_REMOTE",g[g.WORKSPACE=4]="WORKSPACE",g[g.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",g[g.DEFAULT=6]="DEFAULT",g[g.MEMORY=7]="MEMORY"})(S=e.ConfigurationTarget||(e.ConfigurationTarget={}));function m(g){switch(g){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=m;function I(g,y){const k=Object.create(null);for(let d in g)M(k,d,g[d],y);return k}e.toValuesTree=I;function M(g,y,k,d){const u=y.split("."),c=u.pop();let a=g;for(let f=0;f<u.length;f++){let s=u[f],i=a[s];switch(typeof i){case"undefined":i=a[s]=Object.create(null);break;case"object":break;default:d(`Ignoring ${y} as ${u.slice(0,f+1).join(".")} is ${JSON.stringify(i)}`);return}a=i}if(typeof a=="object"&&a!==null)try{a[c]=k}catch{d(`Ignoring ${y} as ${u.join(".")} is ${JSON.stringify(a)}`)}else d(`Ignoring ${y} as ${u.join(".")} is ${JSON.stringify(a)}`)}e.addToValueTree=M;function E(g,y){const k=y.split(".");b(g,k)}e.removeFromValueTree=E;function b(g,y){const k=y.shift();if(y.length===0){delete g[k];return}if(Object.keys(g).indexOf(k)!==-1){const d=g[k];typeof d=="object"&&!Array.isArray(d)&&(b(d,y),Object.keys(d).length===0&&delete g[k])}}function p(g,y,k){function d(a,f){let s=a;for(const i of f){if(typeof s!="object"||s===null)return;s=s[i]}return s}const u=y.split("."),c=d(g,u);return typeof c=="undefined"?k:c}e.getConfigurationValue=p;function t(g,y,k){Object.keys(y).forEach(d=>{d!=="__proto__"&&(d in g?w.isObject(g[d])&&w.isObject(y[d])?t(g[d],y[d],k):k&&(g[d]=y[d]):g[d]=y[d])})}e.merge=t;function h(g,y,k){const d=g.inspect(y),u=g.inspect(k);return typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:d.defaultValue}e.getMigratedSettingValue=h}),define(Z[74],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,w.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,w.createDecorator)("credentialsMainService");class n{constructor(){this.secretVault={}}async getPassword(D,P){return this.secretVault[D]?.[P]??null}async setPassword(D,P,S){this.secretVault[D]=this.secretVault[D]??{},this.secretVault[D][P]=S}async deletePassword(D,P){return this.secretVault[D]?.[P]?(delete this.secretVault[D][P],Object.keys(this.secretVault[D]).length===0&&delete this.secretVault[D],!0):!1}async findPassword(D){return JSON.stringify(this.secretVault[D])??null}async findCredentials(D){const P=[];for(const S of Object.keys(this.secretVault[D]||{}))P.push({account:S,password:this.secretVault[D][S]});return P}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=n}),define(Z[75],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,w.createDecorator)(e.ID);function n(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=n}),define(Z[92],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,w.createDecorator)("encryptionMainService")}),define(Z[52],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,w.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,w.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[174],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,w.createDecorator)("extensionUrlTrustService")}),define(Z[175],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,w.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(Z[93],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,w.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,w.createDecorator)("externalTerminal")}),define(Z[176],x([0,1,45,10,7,2,84,24,72,144,93]),function(V,e,w,n,L,D,P,S,m,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const E=I.localize(0,null);class b{async getDefaultTerminalForPlatforms(){return{windows:p.getDefaultTerminalWindows(),linux:await h.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class p extends b{openTerminal(u,c){return this.spawnTerminal(w,u,m.getWindowsShell(),c)}spawnTerminal(u,c,a,f){const s=c.windowsExec||p.getDefaultTerminalWindows();f&&f[1]===":"&&(f=f[0].toUpperCase()+f.substr(1));const i=L.basename(s).toLowerCase();if(i==="cmder"||i==="cmder.exe")return u.spawn(s,f?[f]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return s.indexOf(" ")>=0&&r.push('""'),r.push(s),(i==="wt"||i==="wt.exe")&&r.push("-d ."),new Promise((o,l)=>{const v=g(process),C=u.spawn(a,r,{cwd:f,env:v});C.on("error",l),C.on("exit",()=>o())})}runInTerminal(u,c,a,f,s){const i="windowsExec"in s&&s.windowsExec?s.windowsExec:p.getDefaultTerminalWindows();return new Promise((r,o)=>{const l=`"${c} - ${E}"`,v=`""${a.join('" "')}" & pause"`,C=["/c","start",l,"/wait",i,"/c",v],R=Object.assign({},g(process),f);Object.keys(R).filter(G=>R[G]===null).forEach(G=>delete R[G]);const W={cwd:c,env:R,windowsVerbatimArguments:!0};w.spawn(p.CMD,C,W).on("error",G=>{o(y(G))}),r(void 0)})}static getDefaultTerminalWindows(){if(!p._DEFAULT_TERMINAL_WINDOWS){const u=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");p._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${u?"Sysnative":"System32"}\\cmd.exe`}return p._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=p,p.CMD="cmd.exe";class t extends b{openTerminal(u,c){return this.spawnTerminal(w,u,c)}runInTerminal(u,c,a,f,s){const i=s.osxExec||M.DEFAULT_TERMINAL_OSX;return new Promise((r,o)=>{if(i===M.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const l=i===M.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",C=[n.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${l}.scpt`,V).fsPath,"-t",u||E,"-w",c];for(let U of a)C.push("-a"),C.push(U);if(f){const U=Object.assign({},g(process),f);for(let G in U){const ee=U[G];ee===null?(C.push("-u"),C.push(G)):(C.push("-e"),C.push(`${G}=${ee}`))}}let R="";const W=w.spawn(t.OSASCRIPT,C);W.on("error",U=>{o(y(U))}),W.stderr.on("data",U=>{R+=U.toString()}),W.on("exit",U=>{if(U===0)r(void 0);else if(R){const G=R.split(`
`,1);o(new Error(G[0]))}else o(new Error(I.localize(1,null,l,U)))})}else o(new Error(I.localize(2,null,i)))})}spawnTerminal(u,c,a){const f=c.osxExec||M.DEFAULT_TERMINAL_OSX;return new Promise((s,i)=>{const r=["-a",f];a&&r.push(a);const o=g(process),l=u.spawn("/usr/bin/open",r,{cwd:a,env:o});l.on("error",i),l.on("exit",()=>s())})}}e.MacExternalTerminalService=t,t.OSASCRIPT="/usr/bin/osascript";class h extends b{openTerminal(u,c){return this.spawnTerminal(w,u,c)}runInTerminal(u,c,a,f,s){const i=s.linuxExec?Promise.resolve(s.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((r,o)=>{let l=[];i.then(v=>{v.indexOf("gnome-terminal")>=0?l.push("-x"):l.push("-e"),l.push("bash"),l.push("-c");const C=`${k(a)}; echo; read -p "${h.WAIT_MESSAGE}" -n1;`;l.push(`''${C}''`);const R=Object.assign({},g(process),f);Object.keys(R).filter(ee=>R[ee]===null).forEach(ee=>delete R[ee]);const W={cwd:c,env:R};let U="";const G=w.spawn(v,l,W);G.on("error",ee=>{o(y(ee))}),G.stderr.on("data",ee=>{U+=ee.toString()}),G.on("exit",ee=>{if(ee===0)r(void 0);else if(U){const X=U.split(`
`,1);o(new Error(X[0]))}else o(new Error(I.localize(4,null,v,ee)))})})})}static async getDefaultTerminalLinuxReady(){if(!h._DEFAULT_TERMINAL_LINUX_READY)if(!D.isLinux)h._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const u=await S.Promises.exists("/etc/debian_version");h._DEFAULT_TERMINAL_LINUX_READY=new Promise(c=>{u?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm")})}return h._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(u,c,a){const f=c.linuxExec?Promise.resolve(c.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((s,i)=>{f.then(r=>{const o=g(process),l=u.spawn(r,[],{cwd:a,env:o});l.on("error",i),l.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=h,h.WAIT_MESSAGE=I.localize(3,null);function g(d){const u={...d.env};return(0,P.sanitizeProcessEnvironment)(u),u}function y(d){return"errno"in d&&d.errno==="ENOENT"&&"path"in d&&typeof d.path=="string"?new Error(I.localize(5,null,d.path)):d}function k(d){let u="";for(let c of d)c.indexOf(" ")>=0?u+='"'+c+'"':u+=c,u+=" ";return u}}),define(Z[20],x([0,1,35,7,27,14,8,146,5]),function(V,e,w,n,L,D,P,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,m.createDecorator)("fileService");function I(B){return B.create===!0}e.isFileOpenForWriteOptions=I;var M;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(M=e.FileType||(e.FileType={}));var E;(function(B){B[B.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var b;(function(B){B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock",B[B.FileAtomicRead=16384]="FileAtomicRead"})(b=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(B){return!!(B.capabilities&2)}e.hasReadWriteCapability=p;function t(B){return!!(B.capabilities&8)}e.hasFileFolderCopyCapability=t;function h(B){return!!(B.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function g(B){return!!(B.capabilities&16)}e.hasFileReadStreamCapability=g;function y(B){return p(B)?!!(B.capabilities&16384):!1}e.hasFileAtomicReadCapability=y;var k;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(k=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class d extends Error{constructor(Y,se){super(Y);this.code=se}}e.FileSystemProviderError=d;function u(B,Y){const se=new d(B.toString(),Y);return a(se,Y),se}e.createFileSystemProviderError=u;function c(B){return B||u((0,S.localize)(0,null),k.Unknown)}e.ensureFileSystemProviderError=c;function a(B,Y){return B.name=Y?`${Y} (FileSystemError)`:"FileSystemError",B}e.markAsFileSystemProviderError=a;function f(B){if(!B)return k.Unknown;if(B instanceof d)return B.code;const Y=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!Y)return k.Unknown;switch(Y[1]){case k.FileExists:return k.FileExists;case k.FileIsADirectory:return k.FileIsADirectory;case k.FileNotADirectory:return k.FileNotADirectory;case k.FileNotFound:return k.FileNotFound;case k.FileExceedsMemoryLimit:return k.FileExceedsMemoryLimit;case k.FileTooLarge:return k.FileTooLarge;case k.FileWriteLocked:return k.FileWriteLocked;case k.NoPermissions:return k.NoPermissions;case k.Unavailable:return k.Unavailable}return k.Unknown}e.toFileSystemProviderErrorCode=f;function s(B){if(B instanceof C)return B.fileOperationResult;switch(f(B)){case k.FileNotFound:return 1;case k.FileIsADirectory:return 0;case k.FileNotADirectory:return 10;case k.FileWriteLocked:return 5;case k.NoPermissions:return 6;case k.FileExists:return 4;case k.FileExceedsMemoryLimit:return 9;case k.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var i;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY",B[B.WRITE=4]="WRITE"})(i=e.FileOperation||(e.FileOperation={}));class r{constructor(Y,se,$){this.resource=Y,this.operation=se,this.target=$}isOperation(Y){return this.operation===Y}}e.FileOperationEvent=r;var o;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class l{constructor(Y,se){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=Y;const $=new Map;for(const q of Y){const Q=$.get(q.type);switch(Q?Q.push([q.resource,q]):$.set(q.type,[[q.resource,q]]),q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}}for(const[q,Q]of $)switch(q){case 1:this.added=w.TernarySearchTree.forUris(()=>se),this.added.fill(Q);break;case 0:this.updated=w.TernarySearchTree.forUris(()=>se),this.updated.fill(Q);break;case 2:this.deleted=w.TernarySearchTree.forUris(()=>se),this.deleted.fill(Q);break}}contains(Y,...se){return this.doContains(Y,{includeChildren:!1},...se)}affects(Y,...se){return this.doContains(Y,{includeChildren:!0},...se)}doContains(Y,se,...$){if(!Y)return!1;const q=$.length>0;return!!((!q||$.includes(1))&&(this.added?.get(Y)||se.includeChildren&&this.added?.findSuperstr(Y))||(!q||$.includes(0))&&(this.updated?.get(Y)||se.includeChildren&&this.updated?.findSuperstr(Y))||(!q||$.includes(2))&&(this.deleted?.findSubstr(Y)||se.includeChildren&&this.deleted?.findSuperstr(Y)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=l;function v(B,Y,se){return!B||!Y||B===Y||Y.length>B.length?!1:(Y.charAt(Y.length-1)!==n.sep&&(Y+=n.sep),se?(0,L.startsWithIgnoreCase)(B,Y):B.indexOf(Y)===0)}e.isParent=v;class C extends Error{constructor(Y,se,$){super(Y);this.fileOperationResult=se,this.options=$}}e.FileOperationError=C;class R extends C{constructor(Y,se,$){super(Y,2,$);this.stat=se}}e.NotModifiedSinceFileOperationError=R;var W;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",B[B.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(W=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(U=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function G(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.etag=G;async function ee(B,Y){if(!Y.hasProvider(P.URI.from({scheme:B.scheme})))return new Promise(se=>{const $=Y.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===B.scheme&&q.added&&($.dispose(),se())})})}e.whenProviderRegistered=ee,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class X{static formatSize(Y){return(0,D.isNumber)(Y)||(Y=0),Y<X.KB?(0,S.localize)(1,null,Y.toFixed(0)):Y<X.MB?(0,S.localize)(2,null,(Y/X.KB).toFixed(2)):Y<X.GB?(0,S.localize)(3,null,(Y/X.MB).toFixed(2)):Y<X.TB?(0,S.localize)(4,null,(Y/X.GB).toFixed(2)):(0,S.localize)(5,null,(Y/X.TB).toFixed(2))}}e.ByteSize=X,X.KB=1024,X.MB=X.KB*X.KB,X.GB=X.MB*X.KB,X.TB=X.GB*X.KB;var J;(function(B){B[B.IA32=0]="IA32",B[B.OTHER=1]="OTHER"})(J=e.Arch||(e.Arch={}));function H(B){return{maxFileSize:B===0?300*X.MB:16*X.GB,maxHeapSize:B===0?700*X.MB:2*700*X.MB}}e.getPlatformLimits=H}),define(Z[177],x([0,1,16,39,15,4,3,48,8,31,20]),function(V,e,w,n,L,D,P,S,m,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class E extends P.Disposable{constructor(p,t){super();this.channel=p,this.extraCapabilities=t,this.onDidChangeCapabilities=D.Event.None,this._onDidChange=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,I.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(p){return this.channel.call("stat",[p])}readdir(p){return this.channel.call("readdir",[p])}async readFile(p,t){const{buffer:h}=await this.channel.call("readFile",[p,t]);return h}readFileStream(p,t,h){const g=(0,S.newWriteableStream)(k=>w.VSBuffer.concat(k.map(d=>w.VSBuffer.wrap(d))).buffer),y=this.channel.listen("readFileStream",[p,t])(k=>{if(k instanceof w.VSBuffer)g.write(k.buffer);else{if(k==="end")g.end();else{let d=k;d instanceof Error||(d=(0,M.createFileSystemProviderError)((0,n.toErrorMessage)(d),M.FileSystemProviderErrorCode.Unknown)),g.error(d),g.end()}y.dispose()}});return h.onCancellationRequested(()=>{g.error((0,L.canceled)()),g.end(),y.dispose()}),g}writeFile(p,t,h){return this.channel.call("writeFile",[p,w.VSBuffer.wrap(t),h])}open(p,t){return this.channel.call("open",[p,t])}close(p){return this.channel.call("close",[p])}async read(p,t,h,g,y){const[k,d]=await this.channel.call("read",[p,t,y]);return h.set(k.buffer.slice(0,d),g),d}write(p,t,h,g,y){return this.channel.call("write",[p,t,w.VSBuffer.wrap(h),g,y])}mkdir(p){return this.channel.call("mkdir",[p])}delete(p,t){return this.channel.call("delete",[p,t])}rename(p,t,h){return this.channel.call("rename",[p,t,h])}copy(p,t,h){return this.channel.call("copy",[p,t,h])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(p=>{if(Array.isArray(p)){const t=p;this._onDidChange.fire(t.map(h=>({resource:m.URI.revive(h.resource),type:h.type})))}else{const t=p;this._onDidWatchError.fire(t)}}))}watch(p,t){const h=(0,I.generateUuid)();return this.channel.call("watch",[this.sessionId,h,p,t]),(0,P.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,h]))}}e.DiskFileSystemProviderClient=E}),define(Z[94],x([0,1,16,15,147,20]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function P(M,E,b,p,t,h){let g;try{await S(M,E,b,p,t,h)}catch(y){g=y}finally{g&&t.errorTransformer&&(g=t.errorTransformer(g)),typeof g!="undefined"&&b.error(g),b.end()}}e.readFileIntoStream=P;async function S(M,E,b,p,t,h){m(h);const g=await M.open(E,{create:!1});try{m(h);let y=0,k=0,d=t&&typeof t.length=="number"?t.length:void 0,u=w.VSBuffer.alloc(Math.min(t.bufferSize,typeof d=="number"?d:t.bufferSize)),c=t&&typeof t.position=="number"?t.position:0,a=0;do k=await M.read(g,c,u.buffer,a,u.byteLength-a),c+=k,a+=k,y+=k,typeof d=="number"&&(d-=k),a===u.byteLength&&(await b.write(p(u)),u=w.VSBuffer.alloc(Math.min(t.bufferSize,typeof d=="number"?d:t.bufferSize)),a=0);while(k>0&&(typeof d!="number"||d>0)&&m(h)&&I(y,t));if(a>0){let f=a;typeof d=="number"&&(f=Math.min(a,d)),b.write(p(u.slice(0,f)))}}catch(y){throw(0,D.ensureFileSystemProviderError)(y)}finally{await M.close(g)}}function m(M){if(M.isCancellationRequested)throw(0,n.canceled)();return!0}function I(M,E){if(E?.limits){if(typeof E.limits.memory=="number"&&M>E.limits.memory)throw(0,D.createFileSystemProviderError)((0,L.localize)(0,null),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&M>E.limits.size)throw(0,D.createFileSystemProviderError)((0,L.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[62],x([0,1,3,2,8,20]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function P(p){return p.recursive===!0}e.isRecursiveWatchRequest=P;class S extends w.Disposable{constructor(t,h,g,y){super();this.onFileChanges=t,this.onLogMessage=h,this.verboseLogging=g,this.options=y,this.watcherDisposables=this._register(new w.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const t=new w.DisposableStore;this.watcherDisposables.value=t,this.watcher=this.createWatcher(t),this.watcher.setVerboseLogging(this.verboseLogging),t.add(this.watcher.onDidChangeFile(h=>this.onFileChanges(h))),t.add(this.watcher.onDidLogMessage(h=>this.onLogMessage(h))),t.add(this.watcher.onDidError(h=>this.onError(h)))}onError(t){this.options.restartOnError?this.restartCounter<S.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${t}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${t}`):this.error(t)}restart(t){this.restartCounter++,this.init(),this.watch(t)}async watch(t){this.requests=t,await this.watcher?.watch(t)}async setVerboseLogging(t){this.verboseLogging=t,await this.watcher?.setVerboseLogging(t)}error(t){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${t}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=S,S.MAX_RESTARTS=5;class m extends S{constructor(t,h,g){super(t,h,g,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=m;class I extends S{constructor(t,h,g){super(t,h,g,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=I;function M(p){return p.map(t=>({type:t.type,resource:L.URI.file(t.path)}))}e.toFileChanges=M;function E(p){const t=new b;for(const h of p)t.processEvent(h);return t.coalesce()}e.coalesceEvents=E;class b{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(t){return n.isLinux?t.path:t.path.toLowerCase()}processEvent(t){const h=this.mapPathToChange.get(this.toKey(t));let g=!1;if(h){const y=h.type,k=t.type;h.path!==t.path&&(t.type===2||t.type===1)?g=!0:y===1&&k===2?(this.mapPathToChange.delete(this.toKey(t)),this.coalesced.delete(h)):y===2&&k===1?h.type=0:y===1&&k===0||(h.type=k)}else g=!0;g&&(this.coalesced.add(t),this.mapPathToChange.set(this.toKey(t),t))}coalesce(){const t=[],h=[];return Array.from(this.coalesced).filter(g=>g.type!==2?(t.push(g),!1):!0).sort((g,y)=>g.path.length-y.path.length).filter(g=>h.some(y=>(0,D.isParent)(g.path,y,!n.isLinux))?!1:(h.push(g.path),!0)).concat(t)}}}),define(Z[178],x([0,1,29,9,23,28,116,3,70,7,2,86,24,62]),function(V,e,w,n,L,D,P,S,m,I,M,E,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class t extends S.Disposable{constructor(y,k,d,u){super();this.request=y,this.onDidFilesChange=k,this.onLogMessage=d,this.verboseLogging=u,this.throttledFileChangesWorker=new n.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},c=>this.onDidFilesChange(c)),this.fileChangesDelayer=this._register(new n.ThrottledDelayer(t.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(c=>(0,P.parse)(c)),this.cts=new L.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const y=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const k=await b.Promises.stat(y);this._register(await this.doWatch(y,k.isDirectory()))}catch(y){y.code!=="ENOENT"?this.error(y):this.trace(y)}}async normalizePath(y){let k=y.path;try{k=await b.Promises.realpath(y.path),y.path===k&&(k=await(0,E.realcase)(y.path)??y.path),y.path!==k&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${y.path}, real: ${k})`)}catch{}return k}async doWatch(y,k){if(M.isMacintosh&&(0,D.isEqualOrParent)(y,"/Volumes/",!0))return this.error(`Refusing to watch ${y} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),S.Disposable.None;const d=new L.CancellationTokenSource(this.cts.token);let u=new S.DisposableStore;try{const c=(0,I.basename)(y),a=(0,w.watch)(y);u.add((0,S.toDisposable)(()=>{a.removeAllListeners(),a.close()})),this.trace(`Started watching: '${y}'`);const f=new Set;if(k)try{for(const i of await b.Promises.readdir(y))f.add(i)}catch(i){this.error(i)}const s=new Map;u.add((0,S.toDisposable)(()=>{for(const[,i]of s)i.dispose();s.clear()})),a.on("error",(i,r)=>{this.error(`Failed to watch ${y} for changes using fs.watch() (${i}, ${r})`),this.dispose()}),a.on("change",(i,r)=>{if(d.token.isCancellationRequested)return;this.trace(`[raw] ["${i}"] ${r}`);let o="";if(r&&(o=r.toString(),M.isMacintosh&&(o=(0,m.normalizeNFC)(o))),!(!o||i!=="change"&&i!=="rename"))if(k)if(i==="rename"){s.get(o)?.dispose();const l=setTimeout(async()=>{if(s.delete(o),o===c&&!await b.Promises.exists(y)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const v=await this.existsChildStrictCase((0,I.join)(y,o));if(d.token.isCancellationRequested)return;let C;v?f.has(o)?C=0:(C=1,f.add(o)):(f.delete(o),C=2),this.onFileChange({path:(0,I.join)(this.request.path,o),type:C})},t.FILE_DELETE_HANDLER_DELAY);s.set(o,(0,S.toDisposable)(()=>clearTimeout(l)))}else{let l;f.has(o)?l=0:(l=1,f.add(o)),this.onFileChange({path:(0,I.join)(this.request.path,o),type:l})}else if(i==="rename"||o!==c){const l=setTimeout(async()=>{const v=await b.Promises.exists(y);d.token.isCancellationRequested||(v?(this.onFileChange({path:this.request.path,type:0},!0),u.add(await this.doWatch(y,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},t.FILE_DELETE_HANDLER_DELAY);u.clear(),u.add((0,S.toDisposable)(()=>clearTimeout(l)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(c){await b.Promises.exists(y)&&!d.token.isCancellationRequested&&this.error(`Failed to watch ${y} for changes using fs.watch() (${c.toString()})`)}return(0,S.toDisposable)(()=>{d.dispose(!0),u.dispose()})}async onFileChange(y,k=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.path}`),!k&&this.excludes.some(d=>d(y.path))?this.verboseLogging&&this.trace(` >> ignored ${y.path}`):this.fileChangesBuffer.push(y);try{await this.fileChangesDelayer.trigger(async()=>{const d=this.fileChangesBuffer;this.fileChangesBuffer=[];const u=(0,p.coalesceEvents)(d);if(u.length>0){if(this.verboseLogging)for(const a of u)this.trace(`>> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`);this.throttledFileChangesWorker.work(u)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(y){if(M.isLinux)return b.Promises.exists(y);try{const k=(0,I.basename)(y);return(await b.Promises.readdir((0,I.dirname)(y))).some(u=>u===k)}catch(k){return this.trace(k),!1}}setVerboseLogging(y){this.verboseLogging=y}error(y){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${y}`})}warn(y){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${y}`})}trace(y){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${y}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=t,t.FILE_DELETE_HANDLER_DELAY=100,t.FILE_CHANGES_HANDLER_DELAY=50;async function h(g,y,k,d,u=512){const c=await b.Promises.open(g,"r"),a=Buffer.allocUnsafe(u),f=new L.CancellationTokenSource(d);let s,i=!1;const r={path:g,excludes:[],recursive:!1},o=new t(r,l=>{(async()=>{for(const{type:v}of l)if(v===0){if(i)return;i=!0;try{for(;!f.token.isCancellationRequested;){const{bytesRead:C}=await b.Promises.read(c,a,0,u,null);if(!C||f.token.isCancellationRequested)break;y(a.slice(0,C))}}catch(C){s=new Error(C),f.dispose(!0)}finally{i=!1}}})()});return await o.ready,k(),new Promise((l,v)=>{f.token.onCancellationRequested(async()=>{o.dispose();try{await b.Promises.close(c)}catch(C){s=new Error(C)}s?v(s):l()})})}e.watchFileContents=h}),define(Z[179],x([0,1,30,4,3,2,178]),function(V,e,w,n,L,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class S extends L.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new n.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new n.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=n.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(I){const M=this.normalizeRequests(I),E=M.filter(p=>{const t=this.watchers.get(p.path);return t?!(0,w.equals)(t.request.excludes,p.excludes):!0}),b=Array.from(this.watchers.values()).filter(({request:p})=>!M.find(t=>t.path===p.path&&(0,w.equals)(t.excludes,p.excludes))).map(({request:p})=>p.path);E.length&&this.trace(`Request to start watching: ${E.map(p=>`${p.path} (excludes: ${p.excludes.length>0?p.excludes:"<none>"})`).join(",")}`),b.length&&this.trace(`Request to stop watching: ${b.join(",")}`);for(const p of b)this.stopWatching(p);for(const p of E)this.startWatching(p)}startWatching(I){const M=new P.NodeJSFileWatcherLibrary(I,b=>this._onDidChangeFile.fire(b),b=>this._onDidLogMessage.fire(b),this.verboseLogging),E={request:I,instance:M};this.watchers.set(I.path,E)}async stop(){for(const[I]of this.watchers)this.stopWatching(I);this.watchers.clear()}stopWatching(I){const M=this.watchers.get(I);M&&(this.watchers.delete(I),M.instance.dispose())}normalizeRequests(I){const M=new Map;for(const E of I){const b=D.isLinux?E.path:E.path.toLowerCase();M.set(b,E)}return Array.from(M.values())}async setVerboseLogging(I){this.verboseLogging=I;for(const[,M]of this.watchers)M.instance.setVerboseLogging(I)}trace(I){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(I)})}toMessage(I,M){return M?`[File Watcher (node.js)] ${I} (path: ${M.request.path})`:`[File Watcher (node.js)] ${I}`}}e.NodeJSWatcher=S}),define(Z[180],x([0,1,62,179]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class L extends w.AbstractNonRecursiveWatcherClient{constructor(P,S,m){super(P,S,m);this.init()}createWatcher(){return new n.NodeJSWatcher}}e.NodeJSWatcherClient=L}),define(Z[181],x([0,1,10,37,138,62]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class P extends D.AbstractUniversalWatcherClient{constructor(m,I,M){super(m,I,M);this.init()}createWatcher(m){const I=m.add(new L.Client(w.FileAccess.asFileUri("bootstrap-fork",V).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return m.add(I.onDidProcessExit(({code:M,signal:E})=>this.onError(`terminated by itself with code ${M}, signal: ${E}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(I.getChannel("watcher")))}}e.UniversalWatcherClient=P}),define(Z[76],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class w{constructor(...L){this._entries=new Map;for(let[D,P]of L)this.set(D,P)}set(L,D){const P=this._entries.get(L);return this._entries.set(L,D),P}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=w}),define(Z[182],x([0,1,9,15,73,173,5,76]),function(V,e,w,n,L,D,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const m=!1;class I extends Error{constructor(t){super("cyclic dependency between services");this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class M{constructor(t=new S.ServiceCollection,h=!1,g){this._activeInstantiations=new Set,this._services=t,this._strict=h,this._parent=g,this._services.set(P.IInstantiationService,this)}createChild(t){return new M(t,this._strict,this)}invokeFunction(t,...h){let g=b.traceInvocation(t),y=!1;try{return t({get:d=>{if(y)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const u=this._getOrCreateServiceInstance(d,g);if(!u)throw new Error(`[invokeFunction] unknown service '${d}'`);return u}},...h)}finally{y=!0,g.stop()}}createInstance(t,...h){let g,y;return t instanceof L.SyncDescriptor?(g=b.traceCreation(t.ctor),y=this._createInstance(t.ctor,t.staticArguments.concat(h),g)):(g=b.traceCreation(t),y=this._createInstance(t,h,g)),g.stop(),y}_createInstance(t,h=[],g){let y=P._util.getServiceDependencies(t).sort((u,c)=>u.index-c.index),k=[];for(const u of y){let c=this._getOrCreateServiceInstance(u.id,g);c||this._throwIfStrict(`[createInstance] ${t.name} depends on UNKNOWN service ${u.id}.`,!1),k.push(c)}let d=y.length>0?y[0].index:h.length;if(h.length!==d){console.warn(`[createInstance] First service dependency of ${t.name} at position ${d+1} conflicts with ${h.length} static arguments`);let u=d-h.length;u>0?h=h.concat(new Array(u)):h=h.slice(0,d)}return new t(...[...h,...k])}_setServiceInstance(t,h){if(this._services.get(t)instanceof L.SyncDescriptor)this._services.set(t,h);else if(this._parent)this._parent._setServiceInstance(t,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){let h=this._services.get(t);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):h}_getOrCreateServiceInstance(t,h){let g=this._getServiceInstanceOrDescriptor(t);return g instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,g,h.branch(t,!0)):(h.branch(t,!1),g)}_safeCreateAndCacheServiceInstance(t,h,g){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,h,g)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,h,g){const y=new D.Graph(u=>u.id.toString());let k=0;const d=[{id:t,desc:h,_trace:g}];for(;d.length;){const u=d.pop();if(y.lookupOrInsertNode(u),k++>1e3)throw new I(y);for(let c of P._util.getServiceDependencies(u.desc.ctor)){let a=this._getServiceInstanceOrDescriptor(c.id);if(a||this._throwIfStrict(`[createInstance] ${t} depends on ${c.id} which is NOT registered.`,!0),a instanceof L.SyncDescriptor){const f={id:c.id,desc:a,_trace:u._trace.branch(c.id,!0)};y.insertEdge(u,f),d.push(f)}}}for(;;){const u=y.roots();if(u.length===0){if(!y.isEmpty())throw new I(y);break}for(const{data:c}of u){if(this._getServiceInstanceOrDescriptor(c.id)instanceof L.SyncDescriptor){const f=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,f)}y.removeNode(c)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,h,g=[],y,k){if(this._services.get(t)instanceof L.SyncDescriptor)return this._createServiceInstance(h,g,y,k);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,h,g,y,k);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(t,h=[],g,y){if(g){const k=new w.IdleValue(()=>this._createInstance(t,h,y));return new Proxy(Object.create(null),{get(d,u){if(u in d)return d[u];let c=k.value,a=c[u];return typeof a!="function"||(a=a.bind(c),d[u]=a),a},set(d,u,c){return k.value[u]=c,!0}})}else return this._createInstance(t,h,y)}_throwIfStrict(t,h){if(h&&console.warn(h),this._strict)throw new Error(t)}}e.InstantiationService=M;var E;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(E||(E={}));class b{constructor(t,h){this.type=t,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(t){return m?new b(1,t.name||t.toString().substring(0,42).replace(/\n/g,"")):b._None}static traceCreation(t){return m?new b(0,t.name):b._None}branch(t,h){let g=new b(2,t.toString());return this._dep.push([t,h,g]),g}stop(){let t=Date.now()-this._start;b._totals+=t;let h=!1;function g(k,d){let u=[],c=new Array(k+1).join("	");for(const[a,f,s]of d._dep)if(f&&s){h=!0,u.push(`${c}CREATES -> ${a}`);let i=g(k+1,s);i&&u.push(i)}else u.push(`${c}uses -> ${a}`);return u.join(`
`)}let y=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${b._totals.toFixed(2)}ms)`];(t>2||h)&&console.log(y.join(`
`))}}e.Trace=b,b._None=new class extends b{constructor(){super(-1,null)}stop(){}branch(){return this}},b._totals=0}),define(Z[183],x([0,1,15,135,59]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class D extends L.ResolvedKeybinding{constructor(S,m){super();if(m.length===0)throw(0,w.illegalArgument)("parts");this._os=S,this._parts=m}getLabel(){return n.UILabelProvider.toLabel(this._os,this._parts,S=>this._getLabel(S))}getAriaLabel(){return n.AriaLabelProvider.toLabel(this._os,this._parts,S=>this._getAriaLabel(S))}getElectronAccelerator(){return this._parts.length>1||this._parts[0].isDuplicateModifierCase()?null:n.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,S=>this._getElectronAccelerator(S))}getUserSettingsLabel(){return n.UserSettingsLabelProvider.toLabel(this._os,this._parts,S=>this._getUserSettingsLabel(S))}isWYSIWYG(){return this._parts.every(S=>this._isWYSIWYG(S))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(S=>this._getPart(S))}_getPart(S){return new L.ResolvedKeybindingPart(S.ctrlKey,S.shiftKey,S.altKey,S.metaKey,this._getLabel(S),this._getAriaLabel(S))}getDispatchParts(){return this._parts.map(S=>this._getDispatchPart(S))}getSingleModifierDispatchParts(){return this._parts.map(S=>this._getSingleModifierDispatchPart(S))}}e.BaseResolvedKeybinding=D}),define(Z[184],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeElementsAfterNulls=e.ResolvedKeybindingItem=void 0;class w{constructor(D,P,S,m,I,M,E){this._resolvedKeybindingItemBrand=void 0,this.resolvedKeybinding=D,this.keypressParts=D?n(D.getDispatchParts()):[],D&&this.keypressParts.length===0&&(this.keypressParts=n(D.getSingleModifierDispatchParts())),this.bubble=P?P.charCodeAt(0)===94:!1,this.command=this.bubble?P.substr(1):P,this.commandArgs=S,this.when=m,this.isDefault=I,this.extensionId=M,this.isBuiltinExtension=E}}e.ResolvedKeybindingItem=w;function n(L){let D=[];for(let P=0,S=L.length;P<S;P++){const m=L[P];if(!m)return D;D.push(m)}return D}e.removeElementsAfterNulls=n}),define(Z[185],x([0,1,83,59,183,184]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class P extends L.BaseResolvedKeybinding{constructor(m,I){super(I,m.parts)}_keyCodeToUILabel(m){if(this._os===2)switch(m){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return w.KeyCodeUtils.toString(m)}_getLabel(m){return m.isDuplicateModifierCase()?"":this._keyCodeToUILabel(m.keyCode)}_getAriaLabel(m){return m.isDuplicateModifierCase()?"":w.KeyCodeUtils.toString(m.keyCode)}_getElectronAccelerator(m){return w.KeyCodeUtils.toElectronAccelerator(m.keyCode)}_getUserSettingsLabel(m){if(m.isDuplicateModifierCase())return"";const I=w.KeyCodeUtils.toUserSettingsUS(m.keyCode);return I&&I.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(m){return P.getDispatchStr(m)}static getDispatchStr(m){if(m.isModifierKey())return null;let I="";return m.ctrlKey&&(I+="ctrl+"),m.shiftKey&&(I+="shift+"),m.altKey&&(I+="alt+"),m.metaKey&&(I+="meta+"),I+=w.KeyCodeUtils.toString(m.keyCode),I}_getSingleModifierDispatchPart(m){return m.keyCode===5&&!m.shiftKey&&!m.altKey&&!m.metaKey?"ctrl":m.keyCode===4&&!m.ctrlKey&&!m.altKey&&!m.metaKey?"shift":m.keyCode===6&&!m.ctrlKey&&!m.shiftKey&&!m.metaKey?"alt":m.keyCode===57&&!m.ctrlKey&&!m.shiftKey&&!m.altKey?"meta":null}static _scanCodeToKeyCode(m){const I=w.IMMUTABLE_CODE_TO_KEY_CODE[m];if(I!==-1)return I;switch(m){case 10:return 31;case 11:return 32;case 12:return 33;case 13:return 34;case 14:return 35;case 15:return 36;case 16:return 37;case 17:return 38;case 18:return 39;case 19:return 40;case 20:return 41;case 21:return 42;case 22:return 43;case 23:return 44;case 24:return 45;case 25:return 46;case 26:return 47;case 27:return 48;case 28:return 49;case 29:return 50;case 30:return 51;case 31:return 52;case 32:return 53;case 33:return 54;case 34:return 55;case 35:return 56;case 36:return 22;case 37:return 23;case 38:return 24;case 39:return 25;case 40:return 26;case 41:return 27;case 42:return 28;case 43:return 29;case 44:return 30;case 45:return 21;case 51:return 83;case 52:return 81;case 53:return 87;case 54:return 89;case 55:return 88;case 56:return 0;case 57:return 80;case 58:return 90;case 59:return 86;case 60:return 82;case 61:return 84;case 62:return 85;case 106:return 92}return 0}static _resolveSimpleUserBinding(m){if(!m)return null;if(m instanceof n.SimpleKeybinding)return m;const I=this._scanCodeToKeyCode(m.scanCode);return I===0?null:new n.SimpleKeybinding(m.ctrlKey,m.shiftKey,m.altKey,m.metaKey,I)}static resolveUserBinding(m,I){const M=(0,D.removeElementsAfterNulls)(m.map(E=>this._resolveSimpleUserBinding(E)));return M.length>0?[new P(new n.ChordKeybinding(M),I)]:[]}}e.USLayoutResolvedKeybinding=P}),define(Z[186],x([0,1,9]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function n(L,D){if(L.length===0)return Promise.resolve(!1);const P=[];let S=!1;for(let m of L){if(m===!0)return Promise.resolve(!0);(0,w.isThenable)(m)&&P.push(m.then(I=>{I&&(S=!0)},I=>{D(I),S=!0}))}return w.Promises.settled(P).then(()=>S)}e.handleVetos=n}),define(Z[6],x([0,1,39,4,3,2,5]),function(V,e,w,n,L,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logCi=e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,P.createDecorator)("logService"),e.ILoggerService=(0,P.createDecorator)("loggerService");function S(){return new Date().toISOString()}var m;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(m=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=m.Info;function I(s,i,r){switch(i){case m.Trace:s.trace(r);break;case m.Debug:s.debug(r);break;case m.Info:s.info(r);break;case m.Warning:s.warn(r);break;case m.Error:s.error(r);break;case m.Critical:s.critical(r);break;default:throw new Error("Invalid log level")}}e.log=I;function M(s){let i="";for(let r=0;r<s.length;r++){let o=s[r];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}i+=(r>0?" ":"")+o}return i}e.format=M;class E extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class b extends E{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...r){this.checkLogLevel(m.Trace)&&this.log(m.Trace,M([i,...r]))}debug(i,...r){this.checkLogLevel(m.Debug)&&this.log(m.Debug,M([i,...r]))}info(i,...r){this.checkLogLevel(m.Info)&&this.log(m.Info,M([i,...r]))}warn(i,...r){this.checkLogLevel(m.Warning)&&this.log(m.Warning,M([i,...r]))}error(i,...r){if(this.checkLogLevel(m.Error))if(i instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=i.stack,this.log(m.Error,M(o))}else this.log(m.Error,M([i,...r]))}critical(i,...r){this.checkLogLevel(m.Critical)&&this.log(m.Critical,M([i,...r]))}flush(){}}e.AbstractMessageLogger=b;class p extends E{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!D.isWindows}trace(i,...r){this.getLevel()<=m.Trace&&(this.useColors?console.log(`[90m[main ${S()}][0m`,i,...r):console.log(`[main ${S()}]`,i,...r))}debug(i,...r){this.getLevel()<=m.Debug&&(this.useColors?console.log(`[90m[main ${S()}][0m`,i,...r):console.log(`[main ${S()}]`,i,...r))}info(i,...r){this.getLevel()<=m.Info&&(this.useColors?console.log(`[90m[main ${S()}][0m`,i,...r):console.log(`[main ${S()}]`,i,...r))}warn(i,...r){this.getLevel()<=m.Warning&&(this.useColors?console.warn(`[93m[main ${S()}][0m`,i,...r):console.warn(`[main ${S()}]`,i,...r))}error(i,...r){this.getLevel()<=m.Error&&(this.useColors?console.error(`[91m[main ${S()}][0m`,i,...r):console.error(`[main ${S()}]`,i,...r))}critical(i,...r){this.getLevel()<=m.Critical&&(this.useColors?console.error(`[90m[main ${S()}][0m`,i,...r):console.error(`[main ${S()}]`,i,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class t extends E{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...r){this.getLevel()<=m.Trace&&console.log("%cTRACE","color: #888",i,...r)}debug(i,...r){this.getLevel()<=m.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...r)}info(i,...r){this.getLevel()<=m.Info&&console.log("%c INFO","color: #33f",i,...r)}warn(i,...r){this.getLevel()<=m.Warning&&console.log("%c WARN","color: #993",i,...r)}error(i,...r){this.getLevel()<=m.Error&&console.log("%c  ERR","color: #f33",i,...r)}critical(i,...r){this.getLevel()<=m.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...r)}dispose(){}flush(){}}e.ConsoleLogger=t;class h extends E{constructor(i,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(r)}trace(i,...r){this.getLevel()<=m.Trace&&this.adapter.log(m.Trace,[this.extractMessage(i),...r])}debug(i,...r){this.getLevel()<=m.Debug&&this.adapter.log(m.Debug,[this.extractMessage(i),...r])}info(i,...r){this.getLevel()<=m.Info&&this.adapter.log(m.Info,[this.extractMessage(i),...r])}warn(i,...r){this.getLevel()<=m.Warning&&this.adapter.log(m.Warning,[this.extractMessage(i),...r])}error(i,...r){this.getLevel()<=m.Error&&this.adapter.log(m.Error,[this.extractMessage(i),...r])}critical(i,...r){this.getLevel()<=m.Critical&&this.adapter.log(m.Critical,[this.extractMessage(i),...r])}extractMessage(i){return typeof i=="string"?i:(0,w.toErrorMessage)(i,this.getLevel()<=m.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class g extends E{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const r of this.logServices)r.setLevel(i);super.setLevel(i)}trace(i,...r){for(const o of this.logServices)o.trace(i,...r)}debug(i,...r){for(const o of this.logServices)o.debug(i,...r)}info(i,...r){for(const o of this.logServices)o.info(i,...r)}warn(i,...r){for(const o of this.logServices)o.warn(i,...r)}error(i,...r){for(const o of this.logServices)o.error(i,...r)}critical(i,...r){for(const o of this.logServices)o.critical(i,...r)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=g;class y extends L.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...r){this.logger.trace(i,...r)}debug(i,...r){this.logger.debug(i,...r)}info(i,...r){this.logger.info(i,...r)}warn(i,...r){this.logger.warn(i,...r)}error(i,...r){this.logger.error(i,...r)}critical(i,...r){this.logger.critical(i,...r)}flush(){this.logger.flush()}}e.LogService=y;class k extends L.Disposable{constructor(i,r){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(l=>l.setLevel(o))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,r){let o=this.loggers.get(i.toString());return o||(o=this.doCreateLogger(i,r?.always?m.Trace:this.logLevel,r),this.loggers.set(i.toString(),o),r?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=k;class d{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(i){}getLevel(){return m.Info}trace(i,...r){}debug(i,...r){}info(i,...r){}warn(i,...r){}error(i,...r){}critical(i,...r){}dispose(){}flush(){}}e.NullLogService=d;function u(s){if(s.verbose)return m.Trace;if(typeof s.logLevel=="string"){const i=c(s.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=u;function c(s){switch(s){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Critical;case"off":return m.Off}}e.parseLogLevel=c;function a(s){switch(s){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Critical:return"critical";case m.Off:return"off"}}e.LogLevelToString=a;function f(s,i,...r){D.isCI?s.info.call(s,i,...r):s.trace.call(s,i,...r)}e.logCi=f}),define(Z[187],x([0,1,30,9,15,4,3,7,62,6]),function(V,e,w,n,L,D,P,S,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class M extends P.Disposable{constructor(b,p){super();this.logService=b,this.options=p,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new n.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(b,p){return p.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(b,p):this.watchNonRecursive(b,p)}watchUniversal(b,p){const t={path:this.toFilePath(b),excludes:p.excludes,recursive:p.recursive},h=(0,w.insert)(this.universalPathsToWatch,t);return this.refreshUniversalWatchers(),(0,P.toDisposable)(()=>{h(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(b=>(0,L.onUnexpectedError)(b))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(p=>this._onDidChangeFile.fire((0,m.toFileChanges)(p)),p=>this.onWatcherLogMessage(p),this.logService.getLevel()===I.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)})));const b=this.options?.watcher?.recursive?.usePolling;if(b===!0)for(const p of this.universalPathsToWatch)(0,m.isRecursiveWatchRequest)(p)&&(p.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const p of this.universalPathsToWatch)(0,m.isRecursiveWatchRequest)(p)&&b.includes(p.path)&&(p.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(b,p){const t={path:this.toFilePath(b),excludes:p.excludes,recursive:!1},h=(0,w.insert)(this.nonRecursivePathsToWatch,t);return this.refreshNonRecursiveWatchers(),(0,P.toDisposable)(()=>{h(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(b=>(0,L.onUnexpectedError)(b))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(b=>this._onDidChangeFile.fire((0,m.toFileChanges)(b)),b=>this.onWatcherLogMessage(b),this.logService.getLevel()===I.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(b){b.type==="error"&&this._onDidWatchError.fire(b.message),this.logService[b.type](b.message)}toFilePath(b){return(0,S.normalize)(b.fsPath)}}e.AbstractDiskFileSystemProvider=M});var te=this&&this.__param||function(V,e){return function(w,n){e(w,n,V)}};define(Z[188],x([0,1,30,9,16,23,4,69,68,3,35,10,63,17,48,145,20,94,6]),function(V,e,w,n,L,D,P,S,m,I,M,E,b,p,t,h,g,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let d=class extends I.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new P.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new P.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new P.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new P.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new P.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new P.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(c,a){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${c}`);const f=new I.DisposableStore;return this.provider.set(c,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:a}),f.add(a.onDidChangeFile(s=>this._onDidFilesChange.fire(new g.FileChangesEvent(s,!this.isPathCaseSensitive(a))))),typeof a.onDidWatchError=="function"&&f.add(a.onDidWatchError(s=>this._onDidWatchError.fire(new Error(s)))),f.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:c}))),(0,I.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:a}),this.provider.delete(c),(0,I.dispose)(f)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(f){a.push(f)}}),!this.provider.has(c)&&await n.Promises.settled(a)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,a){const f=this.provider.get(c.scheme);return!!(f&&f.capabilities&a)}listCapabilities(){return m.Iterable.map(this.provider,([c,a])=>({scheme:c,capabilities:a.capabilities}))}async withProvider(c){if(!(0,p.isAbsolutePath)(c))throw new g.FileOperationError((0,h.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const a=this.provider.get(c.scheme);if(!a){const f=new Error;throw f.name="ENOPRO",f.message=(0,h.localize)(1,null,c.toString()),f}return a}async withReadProvider(c){const a=await this.withProvider(c);if((0,g.hasOpenReadWriteCloseCapability)(a)||(0,g.hasReadWriteCapability)(a)||(0,g.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const a=await this.withProvider(c);if((0,g.hasOpenReadWriteCloseCapability)(a)||(0,g.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,a){try{return await this.doResolveFile(c,a)}catch(f){throw(0,g.toFileSystemProviderErrorCode)(f)===g.FileSystemProviderErrorCode.FileNotFound?new g.FileOperationError((0,h.localize)(2,null,this.resourceForError(c)),1):(0,g.ensureFileSystemProviderError)(f)}}async doResolveFile(c,a){const f=await this.withProvider(c),s=this.isPathCaseSensitive(f),i=a?.resolveTo,r=a?.resolveSingleChildDescendants,o=a?.resolveMetadata,l=await f.stat(c);let v;return this.toFileStat(f,c,l,void 0,!!o,(C,R)=>(v||(v=M.TernarySearchTree.forUris(()=>!s),v.set(c,!0),i&&v.fill(!0,i)),v.get(C.resource)||v.findSuperstr(C.resource.with({query:null,fragment:null}))?!0:C.isDirectory&&r?R===1:!1))}async toFileStat(c,a,f,s,i,r){const{providerExtUri:o}=this.getExtUri(c),l={resource:a,name:o.basename(a),isFile:(f.type&g.FileType.File)!=0,isDirectory:(f.type&g.FileType.Directory)!=0,isSymbolicLink:(f.type&g.FileType.SymbolicLink)!=0,mtime:f.mtime,ctime:f.ctime,size:f.size,readonly:Boolean((f.permissions??0)&g.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,g.etag)({mtime:f.mtime,size:f.size}),children:void 0};if(l.isDirectory&&r(l,s)){try{const v=await c.readdir(a),C=await n.Promises.settled(v.map(async([R,W])=>{try{const U=o.joinPath(a,R),G=i?await c.stat(U):{type:W};return await this.toFileStat(c,U,G,v.length,i,r)}catch(U){return this.logService.trace(U),null}}));l.children=(0,w.coalesce)(C)}catch(v){this.logService.trace(v),l.children=[]}return l}return l}async resolveAll(c){return n.Promises.settled(c.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(f){return this.logService.trace(f),{stat:void 0,success:!1}}}))}async stat(c){const a=await this.withProvider(c),f=await a.stat(c);return this.toFileStat(a,c,f,void 0,!0,()=>!1)}async exists(c){const a=await this.withProvider(c);try{return!!await a.stat(c)}catch{return!1}}async canCreateFile(c,a){try{await this.doValidateCreateFile(c,a)}catch(f){return f}return!0}async doValidateCreateFile(c,a){if(!a?.overwrite&&await this.exists(c))throw new g.FileOperationError((0,h.localize)(3,null,this.resourceForError(c)),3,a)}async createFile(c,a=L.VSBuffer.fromString(""),f){await this.doValidateCreateFile(c,f);const s=await this.writeFile(c,a);return this._onDidRunOperation.fire(new g.FileOperationEvent(c,0,s)),s}async writeFile(c,a,f){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:i}=this.getExtUri(s);try{await this.validateWriteFile(s,c,f)||await this.mkdirp(s,i.dirname(c));let o;if((0,g.hasReadWriteCapability)(s)&&!(a instanceof L.VSBuffer))if((0,t.isReadableStream)(a)){const l=await(0,t.peekStream)(a,3);l.ended?o=L.VSBuffer.concat(l.buffer):o=l}else o=(0,t.peekReadable)(a,l=>L.VSBuffer.concat(l),3);else o=a;!(0,g.hasOpenReadWriteCloseCapability)(s)||(0,g.hasReadWriteCapability)(s)&&o instanceof L.VSBuffer?await this.doWriteUnbuffered(s,c,f,o):await this.doWriteBuffered(s,c,f,o instanceof L.VSBuffer?(0,L.bufferToReadable)(o):o),this._onDidRunOperation.fire(new g.FileOperationEvent(c,4))}catch(r){throw new g.FileOperationError((0,h.localize)(4,null,this.resourceForError(c),(0,g.ensureFileSystemProviderError)(r).toString()),(0,g.toFileOperationResult)(r),f)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,a,f){if(!!f?.unlock&&!(c.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(a)));let i;try{i=await c.stat(a)}catch{return}if((i.type&g.FileType.Directory)!=0)throw new g.FileOperationError((0,h.localize)(6,null,this.resourceForError(a)),0,f);if(this.throwIfFileIsReadonly(a,i),typeof f?.mtime=="number"&&typeof f.etag=="string"&&f.etag!==g.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&f.mtime<i.mtime&&f.etag!==(0,g.etag)({mtime:f.mtime,size:i.size}))throw new g.FileOperationError((0,h.localize)(7,null),3,f);return i}async readFile(c,a,f){const s=await this.withReadProvider(c);return a?.atomic?this.doReadFileAtomic(s,c,a,f):this.doReadFile(s,c,a,f)}async doReadFileAtomic(c,a,f,s){return new Promise((i,r)=>{this.writeQueue.queueFor(a,this.getExtUri(c).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(c,a,f,s);i(o)}catch(o){r(o)}})})}async doReadFile(c,a,f,s){const i=await this.doReadFileStream(c,a,{...f,preferUnbuffered:!0},s);return{...i,value:await(0,L.streamToBuffer)(i.value)}}async readFileStream(c,a,f){const s=await this.withReadProvider(c);return this.doReadFileStream(s,c,a,f)}async doReadFileStream(c,a,f,s){const i=new D.CancellationTokenSource(s),r=this.validateReadFile(a,f).then(l=>l,l=>{throw i.cancel(),l});let o;try{return typeof f?.etag=="string"&&f.etag!==g.ETAG_DISABLED&&await r,f?.atomic&&(0,g.hasFileAtomicReadCapability)(c)||!((0,g.hasOpenReadWriteCloseCapability)(c)||(0,g.hasFileReadStreamCapability)(c))||(0,g.hasReadWriteCapability)(c)&&f?.preferUnbuffered?o=this.readFileUnbuffered(c,a,f):(0,g.hasFileReadStreamCapability)(c)?o=this.readFileStreamed(c,a,i.token,f):o=this.readFileBuffered(c,a,i.token,f),{...await r,value:o}}catch(l){o&&await(0,t.consumeStream)(o);const v=(0,h.localize)(8,null,this.resourceForError(a),(0,g.ensureFileSystemProviderError)(l).toString());throw l instanceof g.NotModifiedSinceFileOperationError?new g.NotModifiedSinceFileOperationError(v,l.stat,f):new g.FileOperationError(v,(0,g.toFileOperationResult)(l),f)}}readFileStreamed(c,a,f,s=Object.create(null)){const i=c.readFileStream(a,s,f);return(0,t.transform)(i,{data:r=>r instanceof L.VSBuffer?r:L.VSBuffer.wrap(r),error:r=>new g.FileOperationError((0,h.localize)(9,null,this.resourceForError(a),(0,g.ensureFileSystemProviderError)(r).toString()),(0,g.toFileOperationResult)(r),s)},r=>L.VSBuffer.concat(r))}readFileBuffered(c,a,f,s=Object.create(null)){const i=(0,L.newWriteableBufferStream)();return(0,y.readFileIntoStream)(c,a,i,r=>r,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new g.FileOperationError((0,h.localize)(10,null,this.resourceForError(a),(0,g.ensureFileSystemProviderError)(r).toString()),(0,g.toFileOperationResult)(r),s)},f),i}readFileUnbuffered(c,a,f){const s=(0,t.newWriteableStream)(i=>L.VSBuffer.concat(i));return(async()=>{try{let i;f?.atomic&&(0,g.hasFileAtomicReadCapability)(c)?i=await c.readFile(a,{atomic:!0}):i=await c.readFile(a),typeof f?.position=="number"&&(i=i.slice(f.position)),typeof f?.length=="number"&&(i=i.slice(0,f.length)),this.validateReadFileLimits(a,i.byteLength,f),s.end(L.VSBuffer.wrap(i))}catch(i){s.error(i),s.end()}})(),s}async validateReadFile(c,a){const f=await this.resolve(c,{resolveMetadata:!0});if(f.isDirectory)throw new g.FileOperationError((0,h.localize)(11,null,this.resourceForError(c)),0,a);if(typeof a?.etag=="string"&&a.etag!==g.ETAG_DISABLED&&a.etag===f.etag)throw new g.NotModifiedSinceFileOperationError((0,h.localize)(12,null),f,a);return this.validateReadFileLimits(c,f.size,a),f}validateReadFileLimits(c,a,f){if(f?.limits){let s;if(typeof f.limits.memory=="number"&&a>f.limits.memory&&(s=9),typeof f.limits.size=="number"&&a>f.limits.size&&(s=7),typeof s=="number")throw new g.FileOperationError((0,h.localize)(13,null,this.resourceForError(c)),s)}}async canMove(c,a,f){return this.doCanMoveCopy(c,a,"move",f)}async canCopy(c,a,f){return this.doCanMoveCopy(c,a,"copy",f)}async doCanMoveCopy(c,a,f,s){if(c.toString()!==a.toString())try{const i=f==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(i,c,r,a,f,s)}catch(i){return i}return!0}async move(c,a,f){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),r=await this.doMoveCopy(s,c,i,a,"move",!!f),o=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(c,r==="move"?2:3,o)),o}async copy(c,a,f){const s=await this.withReadProvider(c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),r=await this.doMoveCopy(s,c,i,a,"copy",!!f),o=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(c,r==="copy"?3:2,o)),o}async doMoveCopy(c,a,f,s,i,r){if(a.toString()===s.toString())return i;const{exists:o,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(c,a,f,s,i,r);if(o&&!l&&r&&await this.del(s,{recursive:!0}),await this.mkdirp(f,this.getExtUri(f).providerExtUri.dirname(s)),i==="copy"){if(c===f&&(0,g.hasFileFolderCopyCapability)(c))await c.copy(a,s,{overwrite:r});else{const v=await this.resolve(a);v.isDirectory?await this.doCopyFolder(c,v,f,s):await this.doCopyFile(c,a,f,s)}return i}else return c===f?(await c.rename(a,s,{overwrite:r}),i):(await this.doMoveCopy(c,a,f,s,"copy",r),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(c,a,f,s){if((0,g.hasOpenReadWriteCloseCapability)(c)&&(0,g.hasOpenReadWriteCloseCapability)(f))return this.doPipeBuffered(c,a,f,s);if((0,g.hasOpenReadWriteCloseCapability)(c)&&(0,g.hasReadWriteCapability)(f))return this.doPipeBufferedToUnbuffered(c,a,f,s);if((0,g.hasReadWriteCapability)(c)&&(0,g.hasOpenReadWriteCloseCapability)(f))return this.doPipeUnbufferedToBuffered(c,a,f,s);if((0,g.hasReadWriteCapability)(c)&&(0,g.hasReadWriteCapability)(f))return this.doPipeUnbuffered(c,a,f,s)}async doCopyFolder(c,a,f,s){await f.mkdir(s),Array.isArray(a.children)&&await n.Promises.settled(a.children.map(async i=>{const r=this.getExtUri(f).providerExtUri.joinPath(s,i.name);return i.isDirectory?this.doCopyFolder(c,await this.resolve(i.resource),f,r):this.doCopyFile(c,i.resource,f,r)}))}async doValidateMoveCopy(c,a,f,s,i,r){let o=!1;if(c===f){const{providerExtUri:v,isPathCaseSensitive:C}=this.getExtUri(c);if(C||(o=v.isEqual(a,s)),o&&i==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(a),this.resourceForError(s)));if(!o&&v.isEqualOrParent(s,a))throw new Error((0,h.localize)(15,null,this.resourceForError(a),this.resourceForError(s)))}const l=await this.exists(s);if(l&&!o){if(!r)throw new g.FileOperationError((0,h.localize)(16,null,this.resourceForError(a),this.resourceForError(s)),4);if(c===f){const{providerExtUri:v}=this.getExtUri(c);if(v.isEqualOrParent(a,s))throw new Error((0,h.localize)(17,null,this.resourceForError(a),this.resourceForError(s)))}}return{exists:l,isSameResourceWithDifferentPathCase:o}}getExtUri(c){const a=this.isPathCaseSensitive(c);return{providerExtUri:a?p.extUri:p.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(a,c);const f=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(c,0,f)),f}async mkdirp(c,a){const f=[],{providerExtUri:s}=this.getExtUri(c);for(;!s.isEqual(a,s.dirname(a));)try{if(((await c.stat(a)).type&g.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(a)));break}catch(i){if((0,g.toFileSystemProviderErrorCode)(i)!==g.FileSystemProviderErrorCode.FileNotFound)throw i;f.push(s.basename(a)),a=s.dirname(a)}for(let i=f.length-1;i>=0;i--){a=s.joinPath(a,f[i]);try{await c.mkdir(a)}catch(r){if((0,g.toFileSystemProviderErrorCode)(r)!==g.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(c,a){try{await this.doValidateDelete(c,a)}catch(f){return f}return!0}async doValidateDelete(c,a){const f=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!a?.useTrash&&!(f.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(c)));let i;try{i=await f.stat(c)}catch{}if(i)this.throwIfFileIsReadonly(c,i);else throw new g.FileOperationError((0,h.localize)(20,null,this.resourceForError(c)),1);if(!!!a?.recursive){const o=await this.resolve(c);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(c)))}return f}async del(c,a){const f=await this.doValidateDelete(c,a),s=!!a?.useTrash,i=!!a?.recursive;await f.delete(c,{recursive:i,useTrash:s}),this._onDidRunOperation.fire(new g.FileOperationEvent(c,1))}watch(c,a={recursive:!1,excludes:[]}){const f=new I.DisposableStore;let s=!1,i=()=>{s=!0};return f.add((0,I.toDisposable)(()=>i())),(async()=>{try{const r=await this.doWatch(c,a);s?(0,I.dispose)(r):i=()=>(0,I.dispose)(r)}catch(r){this.logService.error(r)}})(),f}async doWatch(c,a){const f=await this.withProvider(c),s=(0,S.hash)([this.getExtUri(f).providerExtUri.getComparisonKey(c),a]);let i=this.activeWatchers.get(s);return i||(i={count:0,disposable:f.watch(c,a)},this.activeWatchers.set(s,i)),i.count+=1,(0,I.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,I.dispose)(i.disposable),this.activeWatchers.delete(s)))})}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,I.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,a,f,s){return this.writeQueue.queueFor(a,this.getExtUri(c).providerExtUri).queue(async()=>{const i=await c.open(a,{create:!0,unlock:f?.unlock??!1});try{(0,t.isReadableStream)(s)||(0,t.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(c,i,s):await this.doWriteReadableBufferedQueued(c,i,s)}catch(r){throw(0,g.ensureFileSystemProviderError)(r)}finally{await c.close(i)}})}async doWriteStreamBufferedQueued(c,a,f){let s=0,i;if((0,t.isReadableBufferedStream)(f)){if(f.buffer.length>0){const r=L.VSBuffer.concat(f.buffer);await this.doWriteBuffer(c,a,r,r.byteLength,s,0),s+=r.byteLength}if(f.ended)return;i=f.stream}else i=f;return new Promise((r,o)=>{(0,t.listenStream)(i,{onData:async l=>{i.pause();try{await this.doWriteBuffer(c,a,l,l.byteLength,s,0)}catch(v){return o(v)}s+=l.byteLength,setTimeout(()=>i.resume())},onError:l=>o(l),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(c,a,f){let s=0,i;for(;(i=f.read())!==null;)await this.doWriteBuffer(c,a,i,i.byteLength,s,0),s+=i.byteLength}async doWriteBuffer(c,a,f,s,i,r){let o=0;for(;o<s;)o+=await c.write(a,i+o,f.buffer,r+o,s-o)}async doWriteUnbuffered(c,a,f,s){return this.writeQueue.queueFor(a,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,a,f,s))}async doWriteUnbufferedQueued(c,a,f,s){let i;s instanceof L.VSBuffer?i=s:(0,t.isReadableStream)(s)?i=await(0,L.streamToBuffer)(s):(0,t.isReadableBufferedStream)(s)?i=await(0,L.bufferedStreamToBuffer)(s):i=(0,L.readableToBuffer)(s),await c.writeFile(a,i.buffer,{create:!0,overwrite:!0,unlock:f?.unlock??!1})}async doPipeBuffered(c,a,f,s){return this.writeQueue.queueFor(s,this.getExtUri(f).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,a,f,s))}async doPipeBufferedQueued(c,a,f,s){let i,r;try{i=await c.open(a,{create:!1}),r=await f.open(s,{create:!0,unlock:!1});const o=L.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,v=0,C=0;do C=await c.read(i,l,o.buffer,v,o.byteLength-v),await this.doWriteBuffer(f,r,o,C,l,v),l+=C,v+=C,v===o.byteLength&&(v=0);while(C>0)}catch(o){throw(0,g.ensureFileSystemProviderError)(o)}finally{await n.Promises.settled([typeof i=="number"?c.close(i):Promise.resolve(),typeof r=="number"?f.close(r):Promise.resolve()])}}async doPipeUnbuffered(c,a,f,s){return this.writeQueue.queueFor(s,this.getExtUri(f).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,a,f,s))}async doPipeUnbufferedQueued(c,a,f,s){return f.writeFile(s,await c.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,a,f,s){return this.writeQueue.queueFor(s,this.getExtUri(f).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,a,f,s))}async doPipeUnbufferedToBufferedQueued(c,a,f,s){const i=await f.open(s,{create:!0,unlock:!1});try{const r=await c.readFile(a);await this.doWriteBuffer(f,i,L.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,g.ensureFileSystemProviderError)(r)}finally{await f.close(i)}}async doPipeBufferedToUnbuffered(c,a,f,s){const i=await(0,L.streamToBuffer)(this.readFileBuffered(c,a,D.CancellationToken.None));await this.doWriteUnbuffered(f,s,void 0,i)}throwIfFileSystemIsReadonly(c,a){if(c.capabilities&2048)throw new g.FileOperationError((0,h.localize)(22,null,this.resourceForError(a)),6);return c}throwIfFileIsReadonly(c,a){if((a.permissions??0)&g.FilePermission.Readonly)throw new g.FileOperationError((0,h.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===E.Schemas.file?c.fsPath:c.toString(!0)}};d=ue([te(0,k.ILogService)],d),e.FileService=d}),define(Z[77],x([0,1,29,253,9,35,16,4,28,3,7,2,17,48,24,149,20,94,187,39,181,180]),function(V,e,w,n,L,D,P,S,m,I,M,E,b,p,t,h,g,y,k,d,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(w)}catch(f){console.error(`Error enabling graceful-fs: ${(0,d.toErrorMessage)(f)}`)}})();class a extends k.AbstractDiskFileSystemProvider{constructor(s,i){super(s,i);this.onDidChangeCapabilities=S.Event.None,this.resourceLocks=new D.ResourceMap(r=>b.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,E.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:i,symbolicLink:r}=await t.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(i,r),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(s){try{const i=await t.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),r=[];return await Promise.all(i.map(async o=>{try{let l;o.isSymbolicLink()?l=(await this.stat((0,b.joinPath)(s,o.name))).type:l=this.toType(o),r.push([o.name,l])}catch(l){this.logService.trace(l)}})),r}catch(i){throw this.toFileSystemProviderError(i)}}toType(s,i){let r;return i?.dangling?r=g.FileType.Unknown:s.isFile()?r=g.FileType.File:s.isDirectory()?r=g.FileType.Directory:r=g.FileType.Unknown,i&&(r|=g.FileType.SymbolicLink),r}async createResourceLock(s){const i=this.toFilePath(s);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let r;for(;r=this.resourceLocks.get(s);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await r.wait();const o=new L.Barrier;return this.resourceLocks.set(s,o),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,I.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(s)===o&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(s)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(s,i){let r;try{i?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(s)})`),r=await this.createResourceLock(s));const o=this.toFilePath(s);return await t.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{r?.dispose()}}readFileStream(s,i,r){const o=(0,p.newWriteableStream)(l=>P.VSBuffer.concat(l.map(v=>P.VSBuffer.wrap(v))).buffer);return(0,y.readFileIntoStream)(this,s,o,l=>l.buffer,{...i,bufferSize:256*1024},r),o}async writeFile(s,i,r){let o;try{const l=this.toFilePath(s);if(!r.create||!r.overwrite){if(await t.Promises.exists(l)){if(!r.overwrite)throw(0,g.createFileSystemProviderError)((0,h.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,g.createFileSystemProviderError)((0,h.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(s,{create:!0,unlock:r.unlock}),await this.write(o,0,i,0,i.byteLength)}catch(l){throw await this.toFileSystemProviderWriteError(s,l)}finally{typeof o=="number"&&await this.close(o)}}async open(s,i){const r=this.toFilePath(s);let o;(0,g.isFileOpenForWriteOptions)(i)&&(o=await this.createResourceLock(s));let l;try{if((0,g.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:C}=await t.SymlinkSupport.stat(r);C.mode&128||await t.Promises.chmod(r,C.mode|128)}catch(C){this.logService.trace(C)}let v;if((0,g.isFileOpenForWriteOptions)(i)){if(E.isWindows)try{await t.Promises.truncate(r,0),v="r+"}catch(C){C.code!=="ENOENT"&&this.logService.trace(C)}v||(v="w")}else v="r";l=await t.Promises.open(r,v)}catch(v){throw o?.dispose(),(0,g.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(s,v):this.toFileSystemProviderError(v)}if(this.mapHandleToPos.set(l,0),(0,g.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(l,s),o){const v=this.mapHandleToLock.get(l);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${r})`),this.mapHandleToLock.set(l,o),v&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${r})`),v.dispose())}return l}async close(s){const i=this.mapHandleToLock.get(s);try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await t.Promises.fdatasync(s)}catch(r){this.canFlush=!1,this.logService.error(r)}return await t.Promises.close(s)}catch(r){throw this.toFileSystemProviderError(r)}finally{i&&(this.mapHandleToLock.get(s)===i&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.mapHandleToLock.delete(s)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),i.dispose())}}async read(s,i,r,o,l){const v=this.normalizePos(s,i);let C=null;try{C=(await t.Promises.read(s,r,o,l,v)).bytesRead}catch(R){throw this.toFileSystemProviderError(R)}finally{this.updatePos(s,v,C)}return C}normalizePos(s,i){return i===this.mapHandleToPos.get(s)?null:i}updatePos(s,i,r){const o=this.mapHandleToPos.get(s);typeof o=="number"&&(typeof i=="number"||(typeof r=="number"?this.mapHandleToPos.set(s,o+r):this.mapHandleToPos.delete(s)))}async write(s,i,r,o,l){return(0,L.retry)(()=>this.doWrite(s,i,r,o,l),100,3)}async doWrite(s,i,r,o,l){const v=this.normalizePos(s,i);let C=null;try{C=(await t.Promises.write(s,r,o,l,v)).bytesWritten}catch(R){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),R)}finally{this.updatePos(s,v,C)}return C}async mkdir(s){try{await t.Promises.mkdir(this.toFilePath(s))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(s,i){try{const r=this.toFilePath(s);i.recursive?await t.Promises.rm(r,t.RimRafMode.MOVE):await t.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(s,i,r){const o=this.toFilePath(s),l=this.toFilePath(i);if(o!==l)try{await this.validateTargetDeleted(s,i,"move",r.overwrite),await t.Promises.move(o,l)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,h.localize)(2,null,(0,M.basename)(o),(0,M.basename)((0,M.dirname)(l)),v.toString()))),this.toFileSystemProviderError(v)}}async copy(s,i,r){const o=this.toFilePath(s),l=this.toFilePath(i);if(o!==l)try{await this.validateTargetDeleted(s,i,"copy",r.overwrite),await t.Promises.copy(o,l,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,h.localize)(3,null,(0,M.basename)(o),(0,M.basename)((0,M.dirname)(l)),v.toString()))),this.toFileSystemProviderError(v)}}async validateTargetDeleted(s,i,r,o){const l=this.toFilePath(s),v=this.toFilePath(i);let C=!1;if(!!(this.capabilities&1024)||(C=(0,m.isEqual)(l,v,!0)),C&&r==="copy")throw(0,g.createFileSystemProviderError)((0,h.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(!C&&await t.Promises.exists(v)){if(!o)throw(0,g.createFileSystemProviderError)((0,h.localize)(5,null),g.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}createUniversalWatcher(s,i,r){return new u.UniversalWatcherClient(o=>s(o),o=>i(o),r)}createNonRecursiveWatcher(s,i,r){return new c.NodeJSWatcherClient(o=>s(o),o=>i(o),r)}toFileSystemProviderError(s){if(s instanceof g.FileSystemProviderError)return s;let i;switch(s.code){case"ENOENT":i=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=g.FileSystemProviderErrorCode.NoPermissions;break;default:i=g.FileSystemProviderErrorCode.Unknown}return(0,g.createFileSystemProviderError)(s,i)}async toFileSystemProviderWriteError(s,i){let r=this.toFileSystemProviderError(i);if(s&&r.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await t.SymlinkSupport.stat(this.toFilePath(s));o.mode&128||(r=(0,g.createFileSystemProviderError)(i,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return r}}e.DiskFileSystemProvider=a}),define(Z[189],x([0,1,4,77,3,16,48,23]),function(V,e,w,n,L,D,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class m extends L.Disposable{constructor(E,b){super();this.provider=E,this.logService=b,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(E,b,p){const t=this.getUriTransformer(E);switch(b){case"stat":return this.stat(t,p[0]);case"readdir":return this.readdir(t,p[0]);case"open":return this.open(t,p[0],p[1]);case"close":return this.close(p[0]);case"read":return this.read(p[0],p[1],p[2]);case"readFile":return this.readFile(t,p[0],p[1]);case"write":return this.write(p[0],p[1],p[2],p[3],p[4]);case"writeFile":return this.writeFile(t,p[0],p[1],p[2]);case"rename":return this.rename(t,p[0],p[1],p[2]);case"copy":return this.copy(t,p[0],p[1],p[2]);case"mkdir":return this.mkdir(t,p[0]);case"delete":return this.delete(t,p[0],p[1]);case"watch":return this.watch(t,p[0],p[1],p[2],p[3]);case"unwatch":return this.unwatch(p[0],p[1])}throw new Error(`IPC Command ${b} not found`)}listen(E,b,p){const t=this.getUriTransformer(E);switch(b){case"fileChange":return this.onFileChange(t,p[0]);case"readFileStream":return this.onReadFileStream(t,p[0],p[1])}throw new Error(`Unknown event ${b}`)}stat(E,b){const p=this.transformIncoming(E,b,!0);return this.provider.stat(p)}readdir(E,b){const p=this.transformIncoming(E,b);return this.provider.readdir(p)}async readFile(E,b,p){const t=this.transformIncoming(E,b,!0),h=await this.provider.readFile(t,p);return D.VSBuffer.wrap(h)}onReadFileStream(E,b,p){const t=this.transformIncoming(E,b,!0),h=new S.CancellationTokenSource,g=new w.Emitter({onLastListenerRemove:()=>{h.cancel()}}),y=this.provider.readFileStream(t,p,h.token);return(0,P.listenStream)(y,{onData:k=>g.fire(D.VSBuffer.wrap(k)),onError:k=>g.fire(k),onEnd:()=>{g.fire("end"),g.dispose(),h.dispose()}}),g.event}writeFile(E,b,p,t){const h=this.transformIncoming(E,b);return this.provider.writeFile(h,p.buffer,t)}open(E,b,p){const t=this.transformIncoming(E,b,!0);return this.provider.open(t,p)}close(E){return this.provider.close(E)}async read(E,b,p){const t=D.VSBuffer.alloc(p),h=0,g=await this.provider.read(E,b,t.buffer,h,p);return[t,g]}write(E,b,p,t,h){return this.provider.write(E,b,p.buffer,t,h)}mkdir(E,b){const p=this.transformIncoming(E,b);return this.provider.mkdir(p)}delete(E,b,p){const t=this.transformIncoming(E,b);return this.provider.delete(t,p)}rename(E,b,p,t){const h=this.transformIncoming(E,b),g=this.transformIncoming(E,p);return this.provider.rename(h,g,t)}copy(E,b,p,t){const h=this.transformIncoming(E,b),g=this.transformIncoming(E,p);return this.provider.copy(h,g,t)}onFileChange(E,b){const p=new w.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(b,this.createSessionFileWatcher(E,p))},onLastListenerRemove:()=>{(0,L.dispose)(this.sessionToWatcher.get(b)),this.sessionToWatcher.delete(b)}});return p.event}async watch(E,b,p,t,h){const g=this.sessionToWatcher.get(b);if(g){const y=this.transformIncoming(E,t),k=g.watch(p,y,h);this.watchRequests.set(b+p,k)}}async unwatch(E,b){const p=E+b,t=this.watchRequests.get(p);t&&((0,L.dispose)(t),this.watchRequests.delete(p))}dispose(){super.dispose();for(const[,E]of this.watchRequests)E.dispose();this.watchRequests.clear();for(const[,E]of this.sessionToWatcher)E.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=m;class I extends L.Disposable{constructor(E,b,p,t){super();this.uriTransformer=E,this.logService=p,this.environmentService=t,this.watcherRequests=new Map,this.fileWatcher=this._register(new n.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(b)}registerListeners(E){const b=this._register(new w.Emitter);this._register(b.event(p=>{E.fire(p.map(t=>({resource:this.uriTransformer.transformOutgoingURI(t.resource),type:t.type})))})),this._register(this.fileWatcher.onDidChangeFile(p=>b.fire(p))),this._register(this.fileWatcher.onDidWatchError(p=>E.fire(p)))}getRecursiveWatcherOptions(E){}getExtraExcludes(E){}watch(E,b,p){const t=this.getExtraExcludes(this.environmentService);return Array.isArray(t)&&(p.excludes=[...p.excludes,...t]),this.watcherRequests.set(E,this.fileWatcher.watch(b,p)),(0,L.toDisposable)(()=>{(0,L.dispose)(this.watcherRequests.get(E)),this.watcherRequests.delete(E)})}dispose(){super.dispose();for(const[,E]of this.watcherRequests)E.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=I}),define(Z[190],x([0,1,12,148,2,8,20,7,189,117]),function(V,e,w,n,L,D,P,S,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class M extends m.AbstractDiskFileSystemProviderChannel{constructor(p,t,h){super(p,t);this.environmentService=h}getUriTransformer(p){return I.DefaultURITransformer}transformIncoming(p,t){return D.URI.revive(t)}async delete(p,t,h){if(!h.useTrash)return super.delete(p,t,h);const g=this.transformIncoming(p,t),y=(0,S.normalize)(g.fsPath);try{await w.shell.trashItem(y)}catch{throw(0,P.createFileSystemProviderError)(L.isWindows?(0,n.localize)(0,null,(0,S.basename)(y)):(0,n.localize)(1,null,(0,S.basename)(y)),P.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(p,t){return new E(p,t,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=M;class E extends m.AbstractSessionFileWatcher{watch(p,t,h){if(h.recursive)throw(0,P.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",P.FileSystemProviderErrorCode.Unavailable);return super.watch(p,t,h)}}}),define(Z[95],x([0,1,6]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function n(D,P){switch(P){case w.LogLevel.Trace:return D.trace;case w.LogLevel.Debug:return D.debug;case w.LogLevel.Info:return D.info;case w.LogLevel.Warning:return D.warn;case w.LogLevel.Error:return D.error;case w.LogLevel.Critical:return D.critical;default:throw new Error("Invalid log level")}}class L extends w.AbstractLogger{constructor(P=w.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(P),this._register(this.onDidChangeLogLevel(S=>{this._logger&&this._logger.setLevel(S)}))}set logger(P){this._logger=P;for(const{level:S,args:m}of this.buffer)n(P,S).apply(P,m);this.buffer=[]}_log(P,...S){this._logger?n(this._logger,P).apply(this._logger,S):this.getLevel()<=P&&this.buffer.push({level:P,args:S})}trace(P,...S){this._log(w.LogLevel.Trace,P,...S)}debug(P,...S){this._log(w.LogLevel.Debug,P,...S)}info(P,...S){this._log(w.LogLevel.Info,P,...S)}warn(P,...S){this._log(w.LogLevel.Warning,P,...S)}error(P,...S){this._log(w.LogLevel.Error,P,...S)}critical(P,...S){this._log(w.LogLevel.Critical,P,...S)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=L}),define(Z[191],x([0,1,9,16,17,20,5,95,6]),function(V,e,w,n,L,D,P,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const I=5*D.ByteSize.MB;let M=class extends m.AbstractLogger{constructor(p,t,h,g,y){super();this.name=p,this.resource=t,this.donotUseFormatters=g,this.fileService=y,this.backupIndex=1,this.setLevel(h),this.queue=this._register(new w.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=m.LogLevel.Trace&&this._log(m.LogLevel.Trace,(0,m.format)(arguments))}debug(){this.getLevel()<=m.LogLevel.Debug&&this._log(m.LogLevel.Debug,(0,m.format)(arguments))}info(){this.getLevel()<=m.LogLevel.Info&&this._log(m.LogLevel.Info,(0,m.format)(arguments))}warn(){this.getLevel()<=m.LogLevel.Warning&&this._log(m.LogLevel.Warning,(0,m.format)(arguments))}error(){if(this.getLevel()<=m.LogLevel.Error){const p=arguments[0];if(p instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=p.stack,this._log(m.LogLevel.Error,(0,m.format)(t))}else this._log(m.LogLevel.Error,(0,m.format)(arguments))}}critical(){this.getLevel()<=m.LogLevel.Critical&&this._log(m.LogLevel.Critical,(0,m.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(p){if(p.fileOperationResult!==3)throw p}}_log(p,t){this.queue.queue(async()=>{await this.initializePromise;let h=await this.loadContent();h.length>I&&(await this.fileService.writeFile(this.getBackupResource(),n.VSBuffer.fromString(h)),h=""),this.donotUseFormatters?h+=t:h+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(p)}] ${t}
`,await this.fileService.writeFile(this.resource,n.VSBuffer.fromString(h))})}getCurrentTimestamp(){const p=g=>g<10?`0${g}`:g,t=g=>g<10?`00${g}`:g<100?`0${g}`:g,h=new Date;return`${h.getFullYear()}-${p(h.getMonth()+1)}-${p(h.getDate())} ${p(h.getHours())}:${p(h.getMinutes())}:${p(h.getSeconds())}.${t(h.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,L.joinPath)((0,L.dirname)(this.resource),`${(0,L.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(p){switch(p){case m.LogLevel.Critical:return"critical";case m.LogLevel.Debug:return"debug";case m.LogLevel.Error:return"error";case m.LogLevel.Info:return"info";case m.LogLevel.Trace:return"trace";case m.LogLevel.Warning:return"warning"}return""}};M=ue([te(4,D.IFileService)],M),e.FileLogger=M;let E=class extends m.AbstractLoggerService{constructor(p,t,h){super(p.getLevel(),p.onDidChangeLogLevel);this.instantiationService=t,this.fileService=h}doCreateLogger(p,t,h){const g=new S.BufferLogService(t);return(0,D.whenProviderRegistered)(p,this.fileService).then(()=>g.logger=this.instantiationService.createInstance(M,h?.name||(0,L.basename)(p),p,g.getLevel(),!!h?.donotUseFormatters)),g}};E=ue([te(0,m.ILogService),te(1,P.IInstantiationService),te(2,D.IFileService)],E),e.FileLoggerService=E}),define(Z[192],x([0,1,4,8,6]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class D{constructor(b){this.service=b,this.onDidChangeLogLevel=w.Event.buffer(b.onDidChangeLogLevel,!0)}listen(b,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(b,p,t){switch(p){case"setLevel":return this.service.setLevel(t)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=D;class P{constructor(b){this.channel=b}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(b){P.setLevel(this.channel,b)}static setLevel(b,p){return b.call("setLevel",p)}}e.LogLevelChannelClient=P;class S{constructor(b){this.loggerService=b,this.loggers=new Map}listen(b,p){throw new Error(`Event not found: ${p}`)}async call(b,p,t){switch(p){case"createLogger":this.createLogger(n.URI.revive(t[0]),t[1]);return;case"log":return this.log(n.URI.revive(t[0]),t[1]);case"consoleLog":return this.consoleLog(t[0],t[1])}throw new Error(`Call not found: ${p}`)}createLogger(b,p){this.loggers.set(b.toString(),this.loggerService.createLogger(b,p))}consoleLog(b,p){let t=console.log;switch(b){case L.LogLevel.Error:t=console.error;break;case L.LogLevel.Warning:t=console.warn;break;case L.LogLevel.Info:t=console.info;break}t.call(console,...p)}log(b,p){const t=this.loggers.get(b.toString());if(!t)throw new Error("Create the logger before logging");for(const[h,g]of p)(0,L.log)(t,h,g)}}e.LoggerChannel=S;class m extends L.AbstractLoggerService{constructor(b,p,t){super(b,p);this.channel=t}createConsoleMainLogger(){return new L.AdapterLogger({log:(b,p)=>{this.channel.call("consoleLog",[b,p])}})}doCreateLogger(b,p,t){return new I(this.channel,b,p,t)}}e.LoggerChannelClient=m;class I extends L.AbstractMessageLogger{constructor(b,p,t,h){super(h?.always);this.channel=b,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(t),this.channel.call("createLogger",[p,h]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(b,p){const t=[[b,p]];this.isLoggerCreated?this.doLog(t):this.buffer.push(...t)}doLog(b){this.channel.call("log",[this.file,b])}}class M extends L.LogService{constructor(b,p){super(p);this.parent=b,this._register(b.onDidChangeLogLevel(t=>p.setLevel(t)))}setLevel(b){super.setLevel(b),this.parent.setLevel(b)}}e.FollowerLogService=M}),define(Z[96],x([0,1,20,6]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function L(S,m,I,M,E){try{const b=await new Promise((t,h)=>{V(["spdlog"],t,h)});b.setFlushOn(n.LogLevel.Trace);const p=await b.createAsyncRotatingLogger(S,m,I,M);return E&&p.clearFormatters(),p}catch(b){console.error(b)}return null}function D(S,m,I){switch(m){case n.LogLevel.Trace:S.trace(I);break;case n.LogLevel.Debug:S.debug(I);break;case n.LogLevel.Info:S.info(I);break;case n.LogLevel.Warning:S.warn(I);break;case n.LogLevel.Error:S.error(I);break;case n.LogLevel.Critical:S.critical(I);break;default:throw new Error("Invalid log level")}}class P extends n.AbstractMessageLogger{constructor(m,I,M,E,b){super();this.buffer=[],this.setLevel(b),this._loggerCreationPromise=this._createSpdLogLogger(m,I,M,E),this._register(this.onDidChangeLogLevel(p=>{this._logger&&this._logger.setLevel(p)}))}async _createSpdLogLogger(m,I,M,E){const b=M?6:1,p=30/b*w.ByteSize.MB,t=await L(m,I,p,b,E);if(t){this._logger=t,this._logger.setLevel(this.getLevel());for(const{level:h,message:g}of this.buffer)D(this._logger,h,g);this.buffer=[]}}log(m,I){this._logger?D(this._logger,m,I):this.getLevel()<=m&&this.buffer.push({level:m,message:I})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=P}),define(Z[193],x([0,1,10,17,31,20,191,6,96]),function(V,e,w,n,L,D,P,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let I=class extends S.AbstractLoggerService{constructor(E,b){super(E.getLevel(),E.onDidChangeLogLevel);this.fileService=b}doCreateLogger(E,b,p){return E.scheme===w.Schemas.file?new m.SpdLogLogger(p?.name||(0,L.generateUuid)(),E.fsPath,!p?.donotRotate,!!p?.donotUseFormatters,b):new P.FileLogger(p?.name??(0,n.basename)(E),E,b,!!p?.donotUseFormatters,this.fileService)}};I=ue([te(0,S.ILogService),te(1,D.IFileService)],I),e.LoggerService=I}),define(Z[194],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function w(P){return P.submenu!==void 0}e.isMenubarMenuItemSubmenu=w;function n(P){return P.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=n;function L(P){return P.uri!==void 0}e.isMenubarMenuItemRecentAction=L;function D(P){return!w(P)&&!n(P)&&!L(P)}e.isMenubarMenuItemAction=D}),define(Z[53],x([0,1,10,2,36,17]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let P;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const S=n.globals.vscode.context.configuration();if(S)P=S.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof V?.__$__nodeRequire=="function"){const S=(0,D.dirname)(w.FileAccess.asFileUri("",V));P=V.__$__nodeRequire((0,D.joinPath)(S,"product.json").fsPath);const m=V.__$__nodeRequire((0,D.joinPath)(S,"package.json").fsPath);L.env.VSCODE_DEV&&Object.assign(P,{nameShort:`${P.nameShort} Dev`,nameLong:`${P.nameLong} Dev`,dataFolderName:`${P.dataFolderName}-dev`,serverDataFolderName:P.serverDataFolderName?`${P.serverDataFolderName}-dev`:void 0}),Object.assign(P,{version:m.version})}else P={},Object.keys(P).length===0&&Object.assign(P,{version:"1.65.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=P}),define(Z[21],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,w.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Z[195],x([0,1,74,4,3,6,2,52,21]),function(V,e,w,n,L,D,P,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsMainService=void 0;let I=class gt extends L.Disposable{constructor(E,b,p,t){super();this.isRunningOnServer=E,this.logService=b,this.environmentMainService=p,this.productService=t,this._onDidChangePassword=this._register(new n.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getSecretStoragePrefix(){return`${this.productService.urlProtocol}${this.isRunningOnServer?"-server":""}`}async getPassword(E,b){const p=await this.withKeytar(),t=await p.getPassword(E,b);if(t)try{let{content:h,hasNextChunk:g}=JSON.parse(t);if(!h||!g)return t;let y=1;for(;g;){const k=await p.getPassword(E,`${b}-${y}`),d=JSON.parse(k);h+=d.content,g=d.hasNextChunk,y++}return h}catch{return t}return t}async setPassword(E,b,p){const t=await this.withKeytar(),h=3,g=async(y,k,d)=>{let u=0,c;for(;u<h;)try{await t.setPassword(y,k,d);return}catch(a){c=a,this.logService.warn("Error attempting to set a password: ",a),u++,await new Promise(f=>setTimeout(f,200))}throw c};if(P.isWindows&&p.length>gt.MAX_PASSWORD_LENGTH){let y=0,k=0,d=!0;for(;d;){const u=p.substring(y,y+gt.PASSWORD_CHUNK_SIZE);y+=gt.PASSWORD_CHUNK_SIZE,d=p.length-y>0;const c={content:u,hasNextChunk:d};await g(E,k?`${b}-${k}`:b,JSON.stringify(c)),k++}}else await g(E,b,p);this._onDidChangePassword.fire({service:E,account:b})}async deletePassword(E,b){const t=await(await this.withKeytar()).deletePassword(E,b);return t&&this._onDidChangePassword.fire({service:E,account:b}),t}async findPassword(E){return(await this.withKeytar()).findPassword(E)}async findCredentials(E){return(await this.withKeytar()).findCredentials(E)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new w.InMemoryCredentialsProvider,this._keytarCache;try{this._keytarCache=await new Promise((E,b)=>{V(["keytar"],E,b)}),await this._keytarCache.findCredentials("test-keytar-loads")}catch(E){this.logService.warn(`Switching to using in-memory credential store instead because Keytar failed to load: ${E.message}`),this._keytarCache=new w.InMemoryCredentialsProvider}return this._keytarCache}clear(){return this._keytarCache instanceof w.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};I.MAX_PASSWORD_LENGTH=2500,I.PASSWORD_CHUNK_SIZE=I.MAX_PASSWORD_LENGTH-100,I=ue([te(1,D.ILogService),te(2,S.INativeEnvironmentService),te(3,m.IProductService)],I),e.CredentialsMainService=I}),define(Z[196],x([0,1,60,6,21]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let D=class{constructor(S,m){this.productService=S,this.logService=m,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(S,m){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const I=/^(.*)#([^#]+)$/.exec(m);if(!I)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",m),!1;const[,M,E]=I;let b=this.trustedExtensionUrlPublicKeys.get(S);if(!b){if(b=this.productService.trustedExtensionUrlPublicKeys[S],!b||b.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",S),!1;this.trustedExtensionUrlPublicKeys.set(S,[...b])}const p=Buffer.from(decodeURIComponent(E),"base64");if(p.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",m),!1;const t=p.slice(0,6),h=p.readUIntBE(0,6),g=Date.now()-h;if(g<0||g>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",m),!1;const y=p.slice(6),k=w.createVerify("SHA256");k.write(t),k.write(Buffer.from(M)),k.end();for(let d=0;d<b.length;d++){let u=b[d];if(u!==null){if(typeof u=="string")try{u=w.createPublicKey({key:Buffer.from(u,"base64"),format:"der",type:"spki"}),b[d]=u}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${d+1} for ${S}:`,c),b[d]=null;continue}if(k.verify(u,y))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",m),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",m),!1}};D=ue([te(0,L.IProductService),te(1,n.ILogService)],D),e.ExtensionUrlTrustService=D}),define(Z[54],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,w.createDecorator)("protocolMainService")}),define(Z[197],x([0,1,12,3,35,10,7,2,8,31,52,6]),function(V,e,w,n,L,D,P,S,m,I,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let b=class extends n.Disposable{constructor(t,h){super();this.logService=h,this.validRoots=L.TernarySearchTree.forPaths(!S.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(t.appRoot),this.addValidFileRoot(t.extensionsPath),this.addValidFileRoot(t.globalStorageHome.fsPath),this.addValidFileRoot(t.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:t}=w.session;t.protocol.registerFileProtocol(D.Schemas.vscodeFileResource,(h,g)=>this.handleResourceRequest(h,g)),t.protocol.interceptFileProtocol(D.Schemas.file,(h,g)=>this.handleFileRequest(h,g)),this._register((0,n.toDisposable)(()=>{t.protocol.unregisterProtocol(D.Schemas.vscodeFileResource),t.protocol.uninterceptProtocol(D.Schemas.file)}))}addValidFileRoot(t){const h=(0,P.normalize)(t);return this.validRoots.get(h)?n.Disposable.None:(this.validRoots.set(h,!0),(0,n.toDisposable)(()=>this.validRoots.delete(h)))}handleFileRequest(t,h){const g=m.URI.parse(t.url);return this.logService.error(`Refused to load resource ${g.fsPath} from ${D.Schemas.file}: protocol (original URL: ${t.url})`),h({error:-3})}handleResourceRequest(t,h){const g=this.requestToNormalizedFilePath(t);return this.validRoots.findSubstr(g)?h({path:g}):this.validExtensions.has((0,P.extname)(g))?h({path:g}):(this.logService.error(`${D.Schemas.vscodeFileResource}: Refused to load resource ${g} from ${D.Schemas.vscodeFileResource}: protocol (original URL: ${t.url})`),h({error:-3}))}requestToNormalizedFilePath(t){const h=m.URI.parse(t.url),g=D.FileAccess.asFileUri(h);return(0,P.normalize)(g.fsPath)}createIPCObjectUrl(){let t;const h=m.URI.from({scheme:"vscode",path:(0,I.generateUuid)()}),g=h.toString(),y=async()=>t;return w.ipcMain.handle(g,y),this.logService.trace(`IPC Object URL: Registered new channel ${g}.`),{resource:h,update:k=>t=k,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${g}.`),w.ipcMain.removeHandler(g)}}}};b=ue([te(0,M.INativeEnvironmentService),te(1,E.ILogService)],b),e.ProtocolMainService=b}),define(Z[40],x([0,1,106,14]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(P,S){w.ok(n.isString(P)),w.ok(n.isObject(S)),w.ok(!this.data.has(P),"There is already an extension with this id"),this.data.set(P,S)}knows(P){return this.data.has(P)}as(P){return this.data.get(P)||null}}e.Registry=new L}),define(Z[198],x([0,1,4,40]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class D{constructor(){this._onDidChangeSchema=new w.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(m,I){this.schemasById[L(m)]=I,this._onDidChangeSchema.fire(m)}notifySchemaChanged(m){this._onDidChangeSchema.fire(m)}getSchemaContributions(){return{schemas:this.schemasById}}}const P=new D;n.Registry.add(e.Extensions.JSONContribution,P)}),define(Z[55],x([0,1,30,4,14,140,198,40]),function(V,e,w,n,L,D,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var m;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(m=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const M=S.Registry.as(P.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},M.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(c,a=!0){this.registerConfigurations([c],a)}registerConfigurations(c,a=!0){const f=this.doRegisterConfigurations(c,a);M.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:f})}deregisterConfigurations(c){const a=this.doDeregisterConfigurations(c);M.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}updateConfigurations({add:c,remove:a}){const f=[];f.push(...this.doDeregisterConfigurations(a)),f.push(...this.doRegisterConfigurations(c,!1)),M.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,w.distinct)(f)})}registerDefaultConfigurations(c){const a=[],f=[];for(const{overrides:s,source:i}of c)for(const r in s)if(a.push(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const o={...this.configurationDefaultsOverrides.get(r)?.value||{},...s[r]};this.configurationDefaultsOverrides.set(r,{source:i,value:o});const l={type:"object",default:o,description:D.localize(1,null,r),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:o,source:L.isString(i)?void 0:i};f.push(...t(r)),this.configurationProperties[r]=l,this.defaultLanguageConfigurationOverridesNode.properties[r]=l}else{this.configurationDefaultsOverrides.set(r,{value:s[r],source:i});const o=this.configurationProperties[r];o&&(this.updatePropertyDefaultValue(r,o),this.updateSchema(r,o))}this.registerOverrideIdentifiers(f),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}deregisterDefaultConfigurations(c){const a=[];for(const{overrides:f,source:s}of c)for(const i in f){const r=this.configurationDefaultsOverrides.get(i),o=L.isString(s)?s:s?.id,l=L.isString(r?.source)?r?.source:r?.source?.id;if(o===l)if(a.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const v=this.configurationProperties[i];v&&(this.updatePropertyDefaultValue(i,v),this.updateSchema(i,v))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...c){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(c){for(const a of c)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(c,a){const f=[];return c.forEach(s=>{f.push(...this.validateAndRegisterProperties(s,a,s.extensionInfo,s.restrictedProperties)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),f}doDeregisterConfigurations(c){const a=[],f=s=>{if(s.properties)for(const i in s.properties)a.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,s.properties[i]);s.allOf&&s.allOf.forEach(i=>f(i))};for(const s of c){f(s);const i=this.configurationContributors.indexOf(s);i!==-1&&this.configurationContributors.splice(i,1)}return a}validateAndRegisterProperties(c,a=!0,f,s,i=3){i=L.isUndefinedOrNull(c.scope)?i:c.scope;let r=[],o=c.properties;if(o)for(let v in o){if(a&&k(v)){delete o[v];continue}const C=o[v];if(C.source=f,C.defaultDefaultValue=o[v].default,this.updatePropertyDefaultValue(v,C),e.OVERRIDE_PROPERTY_REGEX.test(v)?C.scope=void 0:(C.scope=L.isUndefinedOrNull(C.scope)?i:C.scope,C.restricted=L.isUndefinedOrNull(C.restricted)?!!s?.includes(v):C.restricted),o[v].hasOwnProperty("included")&&!o[v].included){this.excludedConfigurationProperties[v]=o[v],delete o[v];continue}else this.configurationProperties[v]=o[v];!o[v].deprecationMessage&&o[v].markdownDeprecationMessage&&(o[v].deprecationMessage=o[v].markdownDeprecationMessage),r.push(v)}let l=c.allOf;if(l)for(let v of l)r.push(...this.validateAndRegisterProperties(v,a,f,s,i));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(c){const a=f=>{let s=f.properties;if(s)for(const r in s)this.updateSchema(r,s[r]);let i=f.allOf;i&&i.forEach(a)};a(c)}updateSchema(c,a){switch(e.allSettings.properties[c]=a,a.scope){case 1:e.applicationSettings.properties[c]=a;break;case 2:e.machineSettings.properties[c]=a;break;case 6:e.machineOverridableSettings.properties[c]=a;break;case 3:e.windowSettings.properties[c]=a;break;case 4:e.resourceSettings.properties[c]=a;break;case 5:e.resourceSettings.properties[c]=a,this.resourceLanguageSettingsSchema.properties[c]=a;break}}removeFromSchema(c,a){switch(delete e.allSettings.properties[c],a.scope){case 1:delete e.applicationSettings.properties[c];break;case 2:delete e.machineSettings.properties[c];break;case 6:delete e.machineOverridableSettings.properties[c];break;case 3:delete e.windowSettings.properties[c];break;case 4:case 5:delete e.resourceSettings.properties[c],delete this.resourceLanguageSettingsSchema.properties[c];break}}updateOverridePropertyPatternKey(){for(const c of this.overrideIdentifiers.values()){const a=`[${c}]`,f={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,f),e.allSettings.properties[a]=f,e.applicationSettings.properties[a]=f,e.machineSettings.properties[a]=f,e.machineOverridableSettings.properties[a]=f,e.windowSettings.properties[a]=f,e.resourceSettings.properties[a]=f}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const c={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=c,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(c,a){const f=this.configurationDefaultsOverrides.get(c);let s=f?.value,i=f?.source;L.isUndefined(s)&&(s=a.defaultDefaultValue,i=void 0),L.isUndefined(s)&&(s=g(a.type)),a.default=s,a.defaultValueSource=i}}const b="\\[([^\\]]+)\\]",p=new RegExp(b,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${b})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function t(u){const c=[];if(e.OVERRIDE_PROPERTY_REGEX.test(u)){let a=p.exec(u);for(;a?.length;){const f=a[1].trim();f&&c.push(f),a=p.exec(u)}}return(0,w.distinct)(c)}e.overrideIdentifiersFromKey=t;function h(u){return u.reduce((c,a)=>`${c}[${a}]`,"")}e.keyFromOverrideIdentifiers=h;function g(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const y=new E;S.Registry.add(e.Extensions.Configuration,y);function k(u){return u.trim()?e.OVERRIDE_PROPERTY_REGEX.test(u)?D.localize(7,null,u):y.getConfigurationProperties()[u]!==void 0?D.localize(8,null,u):null:D.localize(6,null)}e.validateProperty=k;function d(){const u=[],c=y.getConfigurationProperties();for(const a of Object.keys(c))u.push([a,c[a].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.getScopes=d}),define(Z[199],x([0,1,30,4,44,3,35,49,14,8,19,55,40]),function(V,e,w,n,L,D,P,S,m,I,M,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(s={},i=[],r=[]){this._contents=s,this._keys=i,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(s){return s?(0,M.getConfigurationValue)(this.contents,s):this.contents}getOverrideValue(s,i){const r=this.getContentsForOverrideIdentifer(i);return r?s?(0,M.getConfigurationValue)(r,s):r:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const r of this.overrides)r.identifiers.includes(s)&&i.push(...r.keys);return w.distinct(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return w.distinct(s)}override(s){let i=this.overrideConfigurations.get(s);return i||(i=this.createOverrideConfigurationModel(s),this.overrideConfigurations.set(s,i)),i}merge(...s){const i=S.deepClone(this.contents),r=S.deepClone(this.overrides),o=[...this.keys];for(const l of s){this.mergeContents(i,l.contents);for(const v of l.overrides){const[C]=r.filter(R=>w.equals(R.identifiers,v.identifiers));C?(this.mergeContents(C.contents,v.contents),C.keys.push(...v.keys),C.keys=w.distinct(C.keys)):r.push(S.deepClone(v))}for(const v of l.keys)o.indexOf(v)===-1&&o.push(v)}return new p(i,o,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(s){const i=this.getContentsForOverrideIdentifer(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let r={};for(const o of w.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[o],v=i[o];v&&(typeof l=="object"&&typeof v=="object"?(l=S.deepClone(l),this.mergeContents(l,v)):l=v),r[o]=l}return new p(r,this.keys,this.overrides)}mergeContents(s,i){for(const r of Object.keys(i)){if(r in s&&m.isObject(s[r])&&m.isObject(i[r])){this.mergeContents(s[r],i[r]);continue}s[r]=S.deepClone(i[r])}}checkAndFreeze(s){return this.isFrozen&&!Object.isFrozen(s)?S.deepFreeze(s):s}getContentsForOverrideIdentifer(s){let i=null,r=null;const o=l=>{l&&(r?this.mergeContents(r,l):r=S.deepClone(l))};for(const l of this.overrides)w.equals(l.identifiers,[s])?i=l.contents:l.identifiers.includes(s)&&o(l.contents);return o(i),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(s,i){this.addKey(s),(0,M.addToValueTree)(this.contents,s,i,r=>{throw new Error(r)})}removeValue(s){this.removeKey(s)&&(0,M.removeFromValueTree)(this.contents,s)}addKey(s){let i=this.keys.length;for(let r=0;r<i;r++)s.indexOf(this.keys[r])===0&&(i=r);this.keys.splice(i,1,s)}removeKey(s){let i=this.keys.indexOf(s);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=p;class t extends p{constructor(s={}){const i=b.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(i),o=Object.create(null),l=[];for(const v in i){const C=s[v],R=C!==void 0?C:i[v].default;(0,M.addToValueTree)(o,v,R,W=>console.error(`Conflict in default settings: ${W}`))}for(const v of Object.keys(o))E.OVERRIDE_PROPERTY_REGEX.test(v)&&l.push({identifiers:(0,E.overrideIdentifiersFromKey)(v),keys:Object.keys(o[v]),contents:(0,M.toValuesTree)(o[v],C=>console.error(`Conflict in default settings file: ${C}`))});super(o,r,l)}}e.DefaultConfigurationModel=t;class h{constructor(s){this._name=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(s,i){if(!m.isUndefinedOrNull(s)){const r=this.doParseContent(s);this.parseRaw(r,i)}}reparse(s){this._raw&&this.parseRaw(this._raw,s)}parseRaw(s,i){this._raw=s;const{contents:r,keys:o,overrides:l,restricted:v}=this.doParseRaw(s,i);this._configurationModel=new p(r,o,l),this._restrictedConfigurations=v||[]}doParseContent(s){let i={},r=null,o=[],l=[],v=[];function C(W){Array.isArray(o)?o.push(W):r!==null&&(o[r]=W)}let R={onObjectBegin:()=>{let W={};C(W),l.push(o),o=W,r=null},onObjectProperty:W=>{r=W},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{let W=[];C(W),l.push(o),o=W,r=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:C,onError:(W,U,G)=>{v.push({error:W,offset:U,length:G})}};if(s)try{L.visit(s,R),i=o[0]||{}}catch(W){console.error(`Error while parsing settings file ${this._name}: ${W}`),this._parseErrors=[W]}return i}doParseRaw(s,i){const r=b.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),o=this.filter(s,r,!0,i);s=o.raw;const l=(0,M.toValuesTree)(s,R=>console.error(`Conflict in settings file ${this._name}: ${R}`)),v=Object.keys(s),C=this.toOverrides(s,R=>console.error(`Conflict in settings file ${this._name}: ${R}`));return{contents:l,keys:v,overrides:C,restricted:o.restricted}}filter(s,i,r,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:s,restricted:[]};const l={},v=[];for(let C in s)if(E.OVERRIDE_PROPERTY_REGEX.test(C)&&r){const R=this.filter(s[C],i,!1,o);l[C]=R.raw,v.push(...R.restricted)}else{const R=i[C],W=R?typeof R.scope!="undefined"?R.scope:3:void 0;R?.restricted&&v.push(C),(W===void 0||o.scopes===void 0||o.scopes.includes(W))&&(o.skipRestricted&&R?.restricted||(l[C]=s[C]))}return{raw:l,restricted:v}}toOverrides(s,i){const r=[];for(const o of Object.keys(s))if(E.OVERRIDE_PROPERTY_REGEX.test(o)){const l={};for(const v in s[o])l[v]=s[o][v];r.push({identifiers:(0,E.overrideIdentifiersFromKey)(o),keys:Object.keys(l),contents:(0,M.toValuesTree)(l,i)})}return r}}e.ConfigurationModelParser=h;class g extends D.Disposable{constructor(s,i,r,o){super();this.userSettingsResource=s,this.scopes=i,this.fileService=o,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.any(n.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource)),n.Event.filter(this.fileService.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(1)||l.isOperation(4))&&r.isEqual(l.resource,s)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const s=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(s.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=g;class y{constructor(s,i,r=new p,o=new p,l=new P.ResourceMap,v=new p,C=new P.ResourceMap,R=!0){this._defaultConfiguration=s,this._localUserConfiguration=i,this._remoteUserConfiguration=r,this._workspaceConfiguration=o,this._folderConfigurations=l,this._memoryConfiguration=v,this._memoryConfigurationByResource=C,this._freeze=R,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new P.ResourceMap,this._userConfiguration=null}getValue(s,i,r){return this.getConsolidateConfigurationModel(i,r).getValue(s)}updateValue(s,i,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=new p,this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(s):o.setValue(s,i),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(s,i,r){const o=this.getConsolidateConfigurationModel(i,r),l=this.getFolderConfigurationModelForResource(i.resource,r),v=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,C=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this._defaultConfiguration.freeze().getValue(s),R=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.userConfiguration.freeze().getValue(s),W=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.localUserConfiguration.freeze().getValue(s),U=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this.remoteUserConfiguration.freeze().getValue(s),G=r?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(s):this._workspaceConfiguration.freeze().getValue(s):void 0,ee=l?i.overrideIdentifier?l.freeze().override(i.overrideIdentifier).getValue(s):l.freeze().getValue(s):void 0,X=i.overrideIdentifier?v.override(i.overrideIdentifier).getValue(s):v.getValue(s),J=o.getValue(s),H=w.distinct(w.flatten(o.overrides.map(B=>B.identifiers))).filter(B=>o.getOverrideValue(s,B)!==void 0);return{defaultValue:C,userValue:R,userLocalValue:W,userRemoteValue:U,workspaceValue:G,workspaceFolderValue:ee,memoryValue:X,value:J,default:C!==void 0?{value:this._defaultConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,user:R!==void 0?{value:this.userConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,userLocal:W!==void 0?{value:this.localUserConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,workspace:G!==void 0?{value:this._workspaceConfiguration.freeze().getValue(s),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,workspaceFolder:ee!==void 0?{value:l?.freeze().getValue(s),override:i.overrideIdentifier?l?.freeze().getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,memory:X!==void 0?{value:v.getValue(s),override:i.overrideIdentifier?v.getOverrideValue(s,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:H.length?H:void 0}}keys(s){const i=this.getFolderConfigurationModelForResource(void 0,s);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(s){this._defaultConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(s){this._localUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(s){this._remoteUserConfiguration=s,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(s){this._workspaceConfiguration=s,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(s,i){this._folderConfigurations.set(s,i),this._foldersConsolidatedConfigurations.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this._foldersConsolidatedConfigurations.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const r=[];if(!i){const{added:o,updated:l,removed:v}=c(this._defaultConfiguration,s);i=[...o,...l,...v]}for(const o of i)for(const l of(0,E.overrideIdentifiersFromKey)(o)){const v=this._defaultConfiguration.getKeysForOverrideIdentifier(l),C=s.getKeysForOverrideIdentifier(l),R=[...C.filter(W=>v.indexOf(W)===-1),...v.filter(W=>C.indexOf(W)===-1),...v.filter(W=>!S.equals(this._defaultConfiguration.override(l).getValue(W),s.override(l).getValue(W)))];r.push([l,R])}return this.updateDefaultConfiguration(s),{keys:i,overrides:r}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:r,removed:o,overrides:l}=c(this.localUserConfiguration,s),v=[...i,...r,...o];return v.length&&this.updateLocalUserConfiguration(s),{keys:v,overrides:l}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:r,removed:o,overrides:l}=c(this.remoteUserConfiguration,s);let v=[...i,...r,...o];return v.length&&this.updateRemoteUserConfiguration(s),{keys:v,overrides:l}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:r,removed:o,overrides:l}=c(this.workspaceConfiguration,s);let v=[...i,...r,...o];return v.length&&this.updateWorkspaceConfiguration(s),{keys:v,overrides:l}}compareAndUpdateFolderConfiguration(s,i){const r=this.folderConfigurations.get(s),{added:o,updated:l,removed:v,overrides:C}=c(r,i);let R=[...o,...l,...v];return(R.length||!r)&&this.updateFolderConfiguration(s,i),{keys:R,overrides:C}}compareAndDeleteFolderConfiguration(s){const i=this.folderConfigurations.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:r,updated:o,removed:l,overrides:v}=c(i,void 0);return{keys:[...r,...o,...l],overrides:v}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(s,i){let r=this.getConsolidatedConfigurationModelForResource(s,i);return s.overrideIdentifier?r.override(s.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:s},i){let r=this.getWorkspaceConsolidatedConfiguration();if(i&&s){const o=i.getFolder(s);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const l=this._memoryConfigurationByResource.get(s);l&&(r=r.merge(l))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(s){let i=this._foldersConsolidatedConfigurations.get(s);if(!i){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(s);o?(i=r.merge(o),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(s,i)):i=r}return i}getFolderConfigurationModelForResource(s,i){if(i&&s){const r=i.getFolder(s);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((s,i)=>{const{contents:r,overrides:o,keys:l}=this._folderConfigurations.get(i);return s.push([i,{contents:r,overrides:o,keys:l}]),s},[])}}allKeys(){const s=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>s.add(i)),this.userConfiguration.freeze().keys.forEach(i=>s.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(r=>s.add(r))),[...s.values()]}allOverrideIdentifiers(){const s=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(r=>s.add(r))),[...s.values()]}getAllKeysForOverrideIdentifier(s){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(s).forEach(o=>i.add(o))),[...i.values()]}static parse(s){const i=this.parseConfigurationModel(s.defaults),r=this.parseConfigurationModel(s.user),o=this.parseConfigurationModel(s.workspace),l=s.folders.reduce((v,C)=>(v.set(I.URI.revive(C[0]),this.parseConfigurationModel(C[1])),v),new P.ResourceMap);return new y(i,r,new p,o,l,new p,new P.ResourceMap,!1)}static parseConfigurationModel(s){return new p(s.contents,s.keys,s.overrides).freeze()}}e.Configuration=y;function k(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const s=new Set,i=new Map;for(const o of f)o.keys.forEach(l=>s.add(l)),o.overrides.forEach(([l,v])=>{const C=(0,P.getOrSet)(i,l,new Set);v.forEach(R=>C.add(R))});const r=[];return i.forEach((o,l)=>r.push([l,[...o.values()]])),{keys:[...s.values()],overrides:r}}e.mergeChanges=k;class d{constructor(s,i,r,o){this.change=s,this.previous=i,this.currentConfiguraiton=r,this.currentWorkspace=o,this._previousConfiguration=void 0;const l=new Set;s.keys.forEach(C=>l.add(C)),s.overrides.forEach(([,C])=>C.forEach(R=>l.add(R))),this.affectedKeys=[...l.values()];const v=new p;this.affectedKeys.forEach(C=>v.setValue(C,{})),this.affectedKeysTree=v.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=y.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(s,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,s)){if(i){const r=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(s,i,this.currentWorkspace);return!S.equals(r,o)}return!0}return!1}doesAffectedKeysTreeContains(s,i){let r=(0,M.toValuesTree)({[i]:!0},()=>{}),o;for(;typeof r=="object"&&(o=Object.keys(r)[0]);){if(s=s[o],!s)return!1;r=r[o]}return!0}}e.ConfigurationChangeEvent=d;class u extends d{constructor(s,i,r,o){super({keys:s.allKeys(),overrides:[]},void 0,s,i);this.source=r,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=u;function c(f,s){const{added:i,removed:r,updated:o}=a(s,f),l=[],v=f?.getAllOverrideIdentifiers()||[],C=s?.getAllOverrideIdentifiers()||[];if(s){const R=C.filter(W=>!v.includes(W));for(const W of R)l.push([W,s.getKeysForOverrideIdentifier(W)])}if(f){const R=v.filter(W=>!C.includes(W));for(const W of R)l.push([W,f.getKeysForOverrideIdentifier(W)])}if(s&&f){for(const R of v)if(C.includes(R)){const W=a({contents:f.getOverrideValue(void 0,R)||{},keys:f.getKeysForOverrideIdentifier(R)},{contents:s.getOverrideValue(void 0,R)||{},keys:s.getKeysForOverrideIdentifier(R)});l.push([R,[...W.added,...W.removed,...W.updated]])}}return{added:i,removed:r,updated:o,overrides:l}}function a(f,s){const i=f?s?f.keys.filter(l=>s.keys.indexOf(l)===-1):[...f.keys]:[],r=s?f?s.keys.filter(l=>f.keys.indexOf(l)===-1):[...s.keys]:[],o=[];if(f&&s){for(const l of s.keys)if(f.keys.indexOf(l)!==-1){const v=(0,M.getConfigurationValue)(s.contents,l),C=(0,M.getConfigurationValue)(f.contents,l);S.equals(v,C)||o.push(l)}}return{added:i,removed:r,updated:o}}}),define(Z[200],x([0,1,9,4,3,17,19,199,55,40]),function(V,e,w,n,L,D,P,S,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class M extends L.Disposable{constructor(b,p){super();this.settingsResource=b,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new S.UserSettings(this.settingsResource,void 0,D.extUriBiasedIgnorePathCase,p)),this.configuration=new S.Configuration(new S.DefaultConfigurationModel,new S.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new w.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(I.Registry.as(m.Extensions.Configuration).onDidUpdateConfiguration(({properties:t})=>this.onDidDefaultConfigurationChange(t))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const b=await this.userConfiguration.loadConfiguration();this.configuration=new S.Configuration(new S.DefaultConfigurationModel,b)}getConfigurationData(){return this.configuration.toData()}getValue(b,p){const t=typeof b=="string"?b:void 0,h=(0,P.isConfigurationOverrides)(b)?b:(0,P.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(t,h,void 0)}updateValue(b,p,t,h){return Promise.reject(new Error("not supported"))}inspect(b){return this.configuration.inspect(b,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const b=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(b)}onDidChangeUserConfiguration(b){const p=this.configuration.toData(),t=this.configuration.compareAndUpdateLocalUserConfiguration(b);this.trigger(t,p,1)}onDidDefaultConfigurationChange(b){const p=this.configuration.toData(),t=this.configuration.compareAndUpdateDefaultConfiguration(new S.DefaultConfigurationModel,b);this.trigger(t,p,6)}trigger(b,p,t){const h=new S.ConfigurationChangeEvent(b,{data:p},this.configuration);h.source=t,h.sourceConfig=this.getTargetConfiguration(t),this._onDidChangeConfiguration.fire(h)}getTargetConfiguration(b){switch(b){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=M}),define(Z[201],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,w.createDecorator)("remoteAuthorityResolverService");var n;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(n=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends Error{constructor(P,S=n.Unknown,m){super(P);this._message=P,this._code=S,this._detail=m,this.isHandled=S===n.NotAvailable&&m===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}static isTemporarilyNotAvailable(P){return P instanceof L&&P._code===n.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof L&&P._code===n.NoResolverFound}static isHandled(P){return P instanceof L&&P.isHandled}}e.RemoteAuthorityResolverError=L}),define(Z[202],x([0,1,9,16,23,15,4,3,31,88,201]),function(V,e,w,n,L,D,P,S,m,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=30*1e3;var b;(function(z){z[z.Management=1]="Management",z[z.ExtensionHost=2]="ExtensionHost",z[z.Tunnel=3]="Tunnel"})(b=e.ConnectionType||(e.ConnectionType={}));function p(z){switch(z){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function t(z){const F=new L.CancellationTokenSource;return setTimeout(()=>F.cancel(),z),F.token}function h(z,F){if(z.isCancellationRequested||F.isCancellationRequested)return L.CancellationToken.Cancelled;const N=new L.CancellationTokenSource;return z.onCancellationRequested(()=>N.cancel()),F.onCancellationRequested(()=>N.cancel()),N.token}class g{constructor(F){this._state="pending",this._disposables=new S.DisposableStore,this.promise=new Promise((N,T)=>{this._resolvePromise=N,this._rejectPromise=T}),F.isCancellationRequested?this._timeout():this._disposables.add(F.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(F){this._state==="pending"?this._disposables.add(F):F.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const F=new Error("Time limit reached");return F.code="ETIMEDOUT",F.syscall="connect",F}resolve(F){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(F))}reject(F){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(F))}}function y(z,F){const N=new g(F);return N.registerDisposable(z.onControlMessage(T=>{const A=JSON.parse(T.toString()),O=Y(A);O?N.reject(O):N.resolve(A)})),N.promise}function k(z,F,N,T,A,O,_){const j=new g(_);return F.connect(N,T,A,O,(ie,ae)=>{j.didTimeout?(ie&&z.error(ie),ae?.dispose()):ie||!ae?j.reject(ie):j.resolve(ae)}),j.promise}function d(z,F){const N=new g(F);return z.then(T=>{N.didTimeout||N.resolve(T)},T=>{N.didTimeout||N.reject(T)}),N.promise}async function u(z,F,N,T){const A=q(z,F);z.logService.trace(`${A} 1/6. invoking socketFactory.connect().`);let O;try{O=await k(z.logService,z.socketFactory,z.host,z.port,`reconnectionToken=${z.reconnectionToken}&reconnection=${z.reconnectionProtocol?"true":"false"}`,`renderer-${p(F)}-${z.reconnectionToken}`,T)}catch(ce){throw z.logService.error(`${A} socketFactory.connect() failed or timed out. Error:`),z.logService.error(ce),ce}z.logService.trace(`${A} 2/6. socketFactory.connect() was successful.`);let _,j;z.reconnectionProtocol?(z.reconnectionProtocol.beginAcceptReconnection(O,null),_=z.reconnectionProtocol,j=!1):(_=new I.PersistentProtocol(O,null),j=!0),z.logService.trace(`${A} 3/6. sending AuthRequest control message.`);const ie=await d(z.signService.createNewMessage((0,m.generateUuid)()),T),ae={type:"auth",auth:z.connectionToken||"00000000000000000000",data:ie.data};_.sendControl(n.VSBuffer.fromString(JSON.stringify(ae)));try{const ce=await y(_,h(T,t(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(z.logService.trace(`${A} 4/6. received SignRequest control message.`),!await d(z.signService.validate(ie,ce.signedData),T)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const le=await d(z.signService.sign(ce.data),T),he={type:"connectionType",commit:z.commit,signedData:le,desiredConnectionType:F};return N&&(he.args=N),z.logService.trace(`${A} 5/6. sending ConnectionTypeRequest control message.`),_.sendControl(n.VSBuffer.fromString(JSON.stringify(he))),{protocol:_,ownsProtocol:j}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&(z.logService.error(`${A} the handshake timed out. Error:`),z.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&(z.logService.error(`${A} received error control message when negotiating connection. Error:`),z.logService.error(ce)),j&&B(_),ce}}async function c(z,F,N,T){const A=Date.now(),O=q(z,F),{protocol:_,ownsProtocol:j}=await u(z,F,N,T),ie=new g(T);return ie.registerDisposable(_.onControlMessage(ae=>{const ce=JSON.parse(ae.toString()),ne=Y(ce);ne?(z.logService.error(`${O} received error control message when negotiating connection. Error:`),z.logService.error(ne),j&&B(_),ie.reject(ne)):(z.reconnectionProtocol&&z.reconnectionProtocol.endAcceptReconnection(),z.logService.trace(`${O} 6/6. handshake finished, connection is up and running after ${Q(A)}!`),ie.resolve({protocol:_,firstMessage:ce}))})),ie.promise}async function a(z,F){const{protocol:N}=await c(z,1,void 0,F);return{protocol:N}}async function f(z,F,N){const{protocol:T,firstMessage:A}=await c(z,2,F,N),O=A&&A.debugPort;return{protocol:T,debugPort:O}}async function s(z,F,N){const T=Date.now(),A=q(z,3),{protocol:O}=await u(z,3,F,N);return z.logService.trace(`${A} 6/6. handshake finished, connection is up and running after ${Q(T)}!`),O}async function i(z,F,N){const{host:T,port:A,connectionToken:O}=await z.addressProvider.getAddress();return{commit:z.commit,host:T,port:A,connectionToken:O,reconnectionToken:F,reconnectionProtocol:N,socketFactory:z.socketFactory,signService:z.signService,logService:z.logService}}async function r(z,F,N){try{const T=(0,m.generateUuid)(),A=await i(z,T,null),{protocol:O}=await a(A,L.CancellationToken.None);return new J(z,F,N,T,O)}catch(T){throw z.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),z.logService.error(T),X.triggerPermanentFailure(0,0,M.RemoteAuthorityResolverError.isHandled(T)),T}}e.connectRemoteAgentManagement=r;async function o(z,F){try{const N=(0,m.generateUuid)(),T=await i(z,N,null),{protocol:A,debugPort:O}=await f(T,F,L.CancellationToken.None);return new H(z,F,N,A,O)}catch(N){throw z.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),z.logService.error(N),X.triggerPermanentFailure(0,0,M.RemoteAuthorityResolverError.isHandled(N)),N}}e.connectRemoteAgentExtensionHost=o;async function l(z,F,N){const T=await i(z,(0,m.generateUuid)(),null);return await s(T,{host:F,port:N},L.CancellationToken.None)}e.connectRemoteAgentTunnel=l;function v(z){return(0,w.createCancelablePromise)(F=>new Promise((N,T)=>{const A=setTimeout(N,z*1e3);F.onCancellationRequested(()=>{clearTimeout(A),N()})}))}var C;(function(z){z[z.ConnectionLost=0]="ConnectionLost",z[z.ReconnectionWait=1]="ReconnectionWait",z[z.ReconnectionRunning=2]="ReconnectionRunning",z[z.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",z[z.ConnectionGain=4]="ConnectionGain"})(C=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class R{constructor(F,N){this.reconnectionToken=F,this.millisSinceLastIncomingData=N,this.type=0}}e.ConnectionLostEvent=R;class W{constructor(F,N,T,A){this.reconnectionToken=F,this.millisSinceLastIncomingData=N,this.durationSeconds=T,this.cancellableTimer=A,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=W;class U{constructor(F,N,T){this.reconnectionToken=F,this.millisSinceLastIncomingData=N,this.attempt=T,this.type=2}}e.ReconnectionRunningEvent=U;class G{constructor(F,N,T){this.reconnectionToken=F,this.millisSinceLastIncomingData=N,this.attempt=T,this.type=4}}e.ConnectionGainEvent=G;class ee{constructor(F,N,T,A){this.reconnectionToken=F,this.millisSinceLastIncomingData=N,this.attempt=T,this.handled=A,this.type=3}}e.ReconnectionPermanentFailureEvent=ee;class X extends S.Disposable{constructor(F,N,T,A){super();this._connectionType=F,this._onDidStateChange=this._register(new P.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=N,this.reconnectionToken=T,this.protocol=A,this._isReconnecting=!1,this._onDidStateChange.fire(new G(this.reconnectionToken,0,0)),this._register(A.onSocketClose(O=>{const _=$(this._connectionType,this.reconnectionToken,!0);O?O.type===0?(this._options.logService.info(`${_} received socket close event (hadError: ${O.hadError}).`),O.error&&this._options.logService.error(O.error)):(this._options.logService.info(`${_} received socket close event (wasClean: ${O.wasClean}, code: ${O.code}, reason: ${O.reason}).`),O.event&&this._options.logService.error(O.event)):this._options.logService.info(`${_} received socket close event.`),this._beginReconnecting()})),this._register(A.onSocketTimeout(()=>{const O=$(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${O} received socket timeout event.`),this._beginReconnecting()})),X._instances.push(this),X._permanentFailure&&this._gotoPermanentFailure(X._permanentFailureMillisSinceLastIncomingData,X._permanentFailureAttempt,X._permanentFailureHandled)}static triggerPermanentFailure(F,N,T){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=F,this._permanentFailureAttempt=N,this._permanentFailureHandled=T,this._instances.forEach(A=>A._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(F=>F._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(F=>F._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(X._permanentFailure)return;const F=$(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${F} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new R(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const N=[0,5,5,10,10,10,10,10,30];let T=-1;do{T++;const A=T<N.length?N[T]:N[N.length-1];try{if(A>0){const _=v(A);this._onDidStateChange.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),A,_)),this._options.logService.info(`${F} waiting for ${A} seconds before reconnecting...`);try{await _}catch{}}if(X._permanentFailure){this._options.logService.error(`${F} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T+1)),this._options.logService.info(`${F} resolving connection...`);const O=await i(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${F} connecting to ${O.host}:${O.port}...`),await this._reconnect(O,t(E)),this._options.logService.info(`${F} reconnected!`),this._onDidStateChange.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T+1));break}catch(O){if(O.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${F} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(O),X.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}if(T>360){this._options.logService.error(`${F} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(O),X.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}if(M.RemoteAuthorityResolverError.isTemporarilyNotAvailable(O)){this._options.logService.info(`${F} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(O);continue}if((O.code==="ETIMEDOUT"||O.code==="ENETUNREACH"||O.code==="ECONNREFUSED"||O.code==="ECONNRESET")&&O.syscall==="connect"){this._options.logService.info(`${F} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(O);continue}if((0,D.isCancellationError)(O)){this._options.logService.info(`${F} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(O);continue}if(O instanceof M.RemoteAuthorityResolverError){this._options.logService.error(`${F} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(O),X.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),T+1,M.RemoteAuthorityResolverError.isHandled(O));break}this._options.logService.error(`${F} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(O),X.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),T+1,!1);break}}while(!X._permanentFailure)}_gotoPermanentFailure(F,N,T){this._onDidStateChange.fire(new ee(this.reconnectionToken,F,N,T)),B(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=X,X._permanentFailure=!1,X._permanentFailureMillisSinceLastIncomingData=0,X._permanentFailureAttempt=0,X._permanentFailureHandled=!1,X._instances=[];class J extends X{constructor(F,N,T,A,O){super(1,F,A,O);this.client=this._register(new I.Client(O,{remoteAuthority:N,clientId:T},F.ipcLogger))}async _reconnect(F,N){await a(F,N)}}e.ManagementPersistentConnection=J;class H extends X{constructor(F,N,T,A,O){super(2,F,T,A);this._startArguments=N,this.debugPort=O}async _reconnect(F,N){await f(F,this._startArguments,N)}}e.ExtensionHostPersistentConnection=H;function B(z){try{z.acceptDisconnect();const F=z.getSocket();z.dispose(),F.dispose()}catch(F){(0,D.onUnexpectedError)(F)}}function Y(z){if(z&&z.type==="error"){const F=new Error(`Connection error: ${z.reason}`);return F.code="VSCODE_CONNECTION_ERROR",F}return null}function se(z,F){for(;z.length<F;)z+=" ";return z}function $(z,F,N){return`[remote-connection][${se(p(z),13)}][${F.substr(0,5)}\u2026][${N?"reconnect":"initial"}]`}function q(z,F){return`${$(F,z.reconnectionToken,!!z.reconnectionProtocol)}[${z.host}:${z.port}]`}function Q(z){return`${Date.now()-z} ms`}}),define(Z[78],x([0,1,10]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function n(D){return D.scheme===w.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=n;function L(D){if(!D)return;const P=D.indexOf("+");return P<0?D:D.substr(0,P)}e.getRemoteName=L}),define(Z[56],x([0,1,16,153,55,5,40]),function(V,e,w,n,L,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,D.createDecorator)("requestService");function S(t){return t.res.statusCode&&t.res.statusCode>=200&&t.res.statusCode<300||t.res.statusCode===1223}e.isSuccess=S;function m(t){return t.res.statusCode===204}async function I(t){if(!S(t))throw new Error("Server returned "+t.res.statusCode);return m(t)?null:(await(0,w.streamToBuffer)(t.stream)).toString()}e.asText=I;async function M(t){if(!S(t))throw new Error("Server returned "+t.res.statusCode);if(m(t))return null;const g=(await(0,w.streamToBuffer)(t.stream)).toString();try{return JSON.parse(g)}catch(y){throw y.message+=`:
`+g,y}}e.asJson=M;function E(t){p(t)}e.updateProxyConfigurationsScope=E;let b;function p(t){const h=P.Registry.as(L.Extensions.Configuration),g=b;b={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:t,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},h.updateConfigurations({add:[b],remove:g?[g]:[]})}p(2)}),define(Z[203],x([0,1,204,14]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function L(P,S){return P.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:P.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function D(P,S,m={}){const I=(0,w.parse)(P),M=m.proxyUrl||L(I,S);if(!M)return null;const E=(0,w.parse)(M);if(!/^https?:$/.test(E.protocol||""))return null;const b={host:E.hostname||"",port:E.port||(E.protocol==="https"?"443":"80"),auth:E.auth,rejectUnauthorized:(0,n.isBoolean)(m.strictSSL)?m.strictSSL:!0};return I.protocol==="http:"?new(await new Promise((p,t)=>{V(["http-proxy-agent"],p,t)}))(b):new(await new Promise((p,t)=>{V(["https-proxy-agent"],p,t)}))(b)}e.getProxyAgent=D}),define(Z[79],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,w.createDecorator)(e.SIGN_SERVICE_ID)}),define(Z[205],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class w{constructor(){this.validators=new Map}vsda(){return new Promise((L,D)=>V(["vsda"],L,D))}async createNewMessage(L){try{const D=await this.vsda(),P=new D.validator;if(P){const S=String(w._nextId++);return this.validators.set(S,P),{id:S,data:P.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,D){if(!L.id)return!0;const P=this.validators.get(L.id);if(!P)return!1;this.validators.delete(L.id);try{return P.validate(D)==="ok"}catch{return!1}}async sign(L){try{const D=await this.vsda(),P=new D.signer;if(P)return P.sign(L)}catch{}return L}}e.SignService=w,w._nextId=1}),define(Z[38],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,w.createDecorator)("stateMainService")}),define(Z[18],x([0,1,12,9,4,3,2,36,14,5,186,6,38]),function(V,e,w,n,L,D,P,S,m,I,M,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,I.createDecorator)("lifecycleMainService");var p;(function(h){h[h.Starting=1]="Starting",h[h.Ready=2]="Ready",h[h.AfterWindowOpen=3]="AfterWindowOpen"})(p=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let t=class mt extends D.Disposable{constructor(g,y){super();this.logService=g,this.stateMainService=y,this._onBeforeShutdown=this._register(new L.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new L.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new L.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new L.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new L.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(mt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(mt.QUIT_AND_RESTART_KEY)}registerListeners(){const g=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),P.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown())};w.app.addListener("before-quit",g);const y=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!P.isMacintosh)&&w.app.quit()};w.app.addListener("window-all-closed",y),w.app.once("will-quit",k=>{this.logService.trace("Lifecycle#app.on(will-quit)"),k.preventDefault(),this.fireOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),w.app.removeListener("before-quit",g),w.app.removeListener("window-all-closed",y),w.app.quit()})})}fireOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const g=[];return this._onWillShutdown.fire({join(y){g.push(y)}}),this.pendingWillShutdownPromise=(async()=>{try{await n.Promises.settled(g)}catch(y){this.logService.error(y)}try{await this.stateMainService.close()}catch(y){this.logService.error(y)}})(),this.pendingWillShutdownPromise}set phase(g){if(g<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===g)return;this.logService.trace(`lifecycle (main): phase changed (value: ${g})`),this._phase=g;const y=this.phaseWhen.get(this._phase);y&&(y.open(),this.phaseWhen.delete(this._phase))}async when(g){if(g<=this._phase)return;let y=this.phaseWhen.get(g);y||(y=new n.Barrier,this.phaseWhen.set(g,y)),await y.wait()}registerWindow(g){const y=new D.DisposableStore;this.windowCounter++,y.add(g.onWillLoad(d=>this._onWillLoadWindow.fire({window:g,workspace:d.workspace,reason:d.reason})));const k=(0,m.assertIsDefined)(g.win);k.on("close",d=>{const u=g.id;if(this.windowToCloseRequest.has(u)){this.windowToCloseRequest.delete(u);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${g.id}`),d.preventDefault(),this.unload(g,1).then(c=>{if(c){this.windowToCloseRequest.delete(u);return}this.windowToCloseRequest.add(u),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${u}`),this._onBeforeCloseWindow.fire(g),g.close()})}),k.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${g.id}`),this.windowCounter--,y.dispose(),this.windowCounter===0&&(!P.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown()})}async reload(g,y){await this.unload(g,3)||g.reload(y)}async unload(g,y){if(!g.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${g.id}`);const k=this._quitRequested?2:y;let d=await this.onBeforeUnloadWindowInRenderer(g,k);return d?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${g.id})`),this.handleWindowUnloadVeto(d)):(d=await this.onBeforeUnloadWindowInMain(g,k),d?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${g.id})`),this.handleWindowUnloadVeto(d)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${g.id})`),await this.onWillUnloadWindowInRenderer(g,k),!1))}handleWindowUnloadVeto(g){return g?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(g){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(g),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(g,y){return new Promise(k=>{const d=this.oneTimeListenerTokenGenerator++,u=`vscode:ok${d}`,c=`vscode:cancel${d}`;w.ipcMain.once(u,()=>{k(!1)}),w.ipcMain.once(c,()=>{k(!0)}),g.send("vscode:onBeforeUnload",{okChannel:u,cancelChannel:c,reason:y})})}onBeforeUnloadWindowInMain(g,y){const k=[];return this._onBeforeUnloadWindow.fire({reason:y,window:g,veto(d){k.push(d)}}),(0,M.handleVetos)(k,d=>this.logService.error(d))}onWillUnloadWindowInRenderer(g,y){return new Promise(k=>{const u=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;w.ipcMain.once(u,()=>k()),g.send("vscode:onWillUnload",{replyChannel:u,reason:y})})}quit(g){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${g}`),g&&this.stateMainService.setItem(mt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(y=>{this.pendingQuitPromiseResolve=y,this.logService.trace("Lifecycle#quit() - calling app.quit()"),w.app.quit()}),this.pendingQuitPromise)}async relaunch(g){this.logService.trace("Lifecycle#relaunch()");const y=process.argv.slice(1);if(g?.addArgs&&y.push(...g.addArgs),g?.removeArgs)for(const u of g.removeArgs){const c=y.indexOf(u);c>=0&&y.splice(c,1)}const k=()=>{try{if(P.isWindows){const u=(0,S.cwd)();u!==process.cwd()&&process.chdir(u)}}catch(u){this.logService.error(u)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),w.app.relaunch({args:y})};w.app.once("quit",k),await this.quit(!0)&&w.app.removeListener("quit",k)}async kill(g){(0,E.logCi)(this.logService,"Lifecycle#kill()"),await this.fireOnWillShutdown(),await Promise.race([(0,n.timeout)(1e3),(async()=>{for(const y of w.BrowserWindow.getAllWindows())if(y&&!y.isDestroyed()){let k;y.webContents&&!y.webContents.isDestroyed()?k=new Promise(d=>y.once("closed",d)):k=Promise.resolve(),(0,E.logCi)(this.logService,"Lifecycle#kill() - window.destroy()"),y.destroy(),await k,(0,E.logCi)(this.logService,"Lifecycle#kill() - window closed")}})()]),(0,E.logCi)(this.logService,`Lifecycle#kill() - app.exit(${g})`),w.app.exit(g)}};t.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",t=ue([te(0,E.ILogService),te(1,b.IStateMainService)],t),e.LifecycleMainService=t}),define(Z[206],x([0,1,4,3,5,18]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,L.createDecorator)("keyboardLayoutMainService");let P=class extends n.Disposable{constructor(I){super();this._onDidChangeKeyboardLayout=this._register(new w.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,I.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const I=await new Promise((M,E)=>{V(["native-keymap"],M,E)});this._keyboardLayoutData=S(I),I.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=S(I),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};P=ue([te(0,D.ILifecycleMainService)],P),e.KeyboardLayoutMainService=P;function S(m){const I=m.getKeyMap(),M=m.getCurrentKeyboardLayout();return{keyboardMapping:I,keyboardLayoutInfo:M}}}),define(Z[97],x([0,1,9,4,3,63,14,90,5]),function(V,e,w,n,L,D,P,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const I="__$__targetStorageMarker";e.IStorageService=(0,m.createDecorator)("storageService");var M;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(M=e.WillSaveStateReason||(e.WillSaveStateReason={}));var E;(function(g){g[g.GLOBAL=0]="GLOBAL",g[g.WORKSPACE=1]="WORKSPACE"})(E=e.StorageScope||(e.StorageScope={}));var b;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(b=e.StorageTarget||(e.StorageTarget={}));class p extends L.Disposable{constructor(y={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super();this.options=y,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new w.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,w.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,L.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,D.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(y,k){k===I?(y===0?this._globalKeyTargets=void 0:y===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:y})):this._onDidChangeValue.fire({scope:y,key:k,target:this.getKeyTargets(y)[k]})}emitWillSaveState(y){this._onWillSaveState.fire({reason:y})}get(y,k,d){return this.getStorage(k)?.get(y,d)}getBoolean(y,k,d){return this.getStorage(k)?.getBoolean(y,d)}getNumber(y,k,d){return this.getStorage(k)?.getNumber(y,d)}store(y,k,d,u){if((0,P.isUndefinedOrNull)(k)){this.remove(y,d);return}this.withPausedEmitters(()=>{this.updateKeyTarget(y,d,u),this.getStorage(d)?.set(y,k)})}remove(y,k){this.withPausedEmitters(()=>{this.updateKeyTarget(y,k,void 0),this.getStorage(k)?.delete(y)})}withPausedEmitters(y){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{y()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(y,k){const d=[],u=this.getKeyTargets(y);for(const c of Object.keys(u))u[c]===k&&d.push(c);return d}updateKeyTarget(y,k,d){const u=this.getKeyTargets(k);typeof d=="number"?u[y]!==d&&(u[y]=d,this.getStorage(k)?.set(I,JSON.stringify(u))):typeof u[y]=="number"&&(delete u[y],this.getStorage(k)?.set(I,JSON.stringify(u)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(y){return y===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(y){const k=this.get(I,y);if(k)try{return JSON.parse(k)}catch{}return Object.create(null)}isNew(y){return this.getBoolean(e.IS_NEW_KEY,y)===!0}async flush(y=M.NONE){this._onWillSaveState.fire({reason:y});const k=this.getStorage(0),d=this.getStorage(1);switch(y){case M.NONE:await w.Promises.settled([k?.whenFlushed()??Promise.resolve(),d?.whenFlushed()??Promise.resolve()]);break;case M.SHUTDOWN:await w.Promises.settled([k?.flush(0)??Promise.resolve(),d?.flush(0)??Promise.resolve()]);break}}async logStorage(){const y=this.getStorage(0)?.items??new Map,k=this.getStorage(1)?.items??new Map;return h(y,k,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=p,p.DEFAULT_FLUSH_INTERVAL=60*1e3;class t extends p{constructor(){super();this.globalStorage=this._register(new S.Storage(new S.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new S.Storage(new S.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(y=>this.emitDidChangeValue(1,y))),this._register(this.globalStorage.onDidChangeStorage(y=>this.emitDidChangeValue(0,y)))}getStorage(y){return y===0?this.globalStorage:this.workspaceStorage}getLogDetails(y){return y===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(y){}}e.InMemoryStorageService=t;async function h(g,y,k,d){const u=o=>{try{return JSON.parse(o)}catch{return o}},c=new Map,a=new Map;g.forEach((o,l)=>{c.set(l,o),a.set(l,u(o))});const f=new Map,s=new Map;y.forEach((o,l)=>{f.set(l,o),s.set(l,u(o))}),console.group(`Storage: Global (path: ${k})`);let i=[];c.forEach((o,l)=>{i.push({key:l,value:o})}),console.table(i),console.groupEnd(),console.log(a),console.group(`Storage: Workspace (path: ${d})`);let r=[];f.forEach((o,l)=>{r.push({key:l,value:o})}),console.table(r),console.groupEnd(),console.log(s)}e.logStorage=h}),define(Z[207],x([0,1,2,36,8,31]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function P(I){if(w.platform===2&&/^penguin(\.|$)/i.test(I))return"chromebook"}async function S(I,M,E,b,p,t,h,g,y,k){const d=Object.create(null);d["common.machineId"]=h,d.sessionID=(0,D.generateUuid)()+Date.now(),d.commitHash=p,d.version=t,d["common.platformVersion"]=(M||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,w.PlatformToString)(w.platform),d["common.nodePlatform"]=n.platform,d["common.nodeArch"]=b,d["common.product"]=k||"desktop";const u=m(g||[]);u&&(d["common.msftInternal"]=u);let c=0;const a=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),w.isLinuxSnap&&(d["common.snap"]="true");const f=P(E);f&&(d["common.platformDetail"]=f);try{const s=await I.readFile(L.URI.file(y));d["common.source"]=s.value.toString().slice(0,30)}catch{}return d}e.resolveCommonProperties=S;function m(I){const M=n.env.USERDNSDOMAIN;if(!M)return!1;const E=M.toLowerCase();return I.some(b=>E===b)}e.verifyMicrosoftInternalDomain=m}),define(Z[32],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,w.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,w.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var L;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(L=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[208],x([0,1,26,68,9,44,10,7,2,8,71,24,87,75,20,21,32]),function(V,e,w,n,L,D,P,S,m,I,M,E,b,p,t,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function y(a,f){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],i=new Map,r=new Map,o=2e4;function l(R,W,U,G){const ee=W.substring(R.length+1);return L.Promises.withAsyncBody(async X=>{let J;try{J=await E.Promises.readdir(W,{withFileTypes:!0})}catch{X();return}if(G.count>=o){G.count+=J.length,G.maxReached=!0,X();return}let H=J.length;if(H===0){X();return}let B=J;G.count+J.length>o&&(G.maxReached=!0,H=o-G.count,B=J.slice(0,H)),G.count+=J.length;for(const Y of B)if(Y.isDirectory()){if(U.includes(Y.name)||await l(R,(0,S.join)(W,Y.name),U,G),--H==0){X();return}}else{const se=Y.name.lastIndexOf(".");if(se>=0){const $=Y.name.substring(se+1);$&&i.set($,(i.get($)??0)+1)}for(const $ of s)$.relativePathPattern?.test(ee)!==!1&&$.filePattern.test(Y.name)&&r.set($.tag,(r.get($.tag)??0)+1);if(--H==0){X();return}}})}const v={count:0,maxReached:!1};await l(a,a,f,v);const C=await u(a);return{configFiles:k(r),fileTypes:k(i),fileCount:v.count,maxFilesReached:v.maxReached,launchConfigFiles:C}}e.collectWorkspaceStats=y;function k(a){return[...n.Iterable.map(a.entries(),([f,s])=>({name:f,count:s}))].sort((f,s)=>s.count-f.count)}function d(){const a={os:`${w.type()} ${w.arch()} ${w.release()}`,memory:`${(w.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(M.virtualMachineHint.value()*100)}%`},f=w.cpus();return f&&f.length>0&&(a.cpus=`${f[0].model} (${f.length} x ${f[0].speed})`),a}e.getMachineInfo=d;async function u(a){try{const f=new Map,s=(0,S.join)(a,".vscode","launch.json"),i=await E.Promises.readFile(s),r=[],o=(0,D.parse)(i.toString(),r);if(r.length)return console.log(`Unable to parse ${s}`),[];if((0,D.getNodeType)(o)==="object"&&o.configurations)for(const l of o.configurations){const v=l.type;v&&(f.has(v)?f.set(v,f.get(v)+1):f.set(v,1))}return k(f)}catch{return[]}}e.collectLaunchConfigs=u;let c=class{constructor(f,s){this.telemetryService=f,this.productService=s}formatMachineInfo(f){const s=[];return s.push(`OS Version:       ${f.os}`),s.push(`CPUs:             ${f.cpus}`),s.push(`Memory (System):  ${f.memory}`),s.push(`VM:               ${f.vmHint}`),s.join(`
`)}formatEnvironment(f){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${w.type()} ${w.arch()} ${w.release()}`);const i=w.cpus();return i&&i.length>0&&s.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),s.push(`Memory (System):  ${(w.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(w.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`),m.isWindows||s.push(`Load (avg):       ${w.loadavg().map(r=>Math.round(r)).join(", ")}`),s.push(`VM:               ${Math.round(M.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${f.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${f.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(f.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(f,s){return Promise.all([(0,b.listProcesses)(f.mainPID),this.formatWorkspaceMetadata(f)]).then(async i=>{let[r,o]=i,l=this.formatProcessList(f,r);return s.forEach(v=>{if((0,p.isRemoteDiagnosticError)(v))l+=`
${v.errorMessage}`,o+=`
${v.errorMessage}`;else if(l+=`

Remote: ${v.hostName}`,v.processes&&(l+=`
${this.formatProcessList(f,v.processes)}`),v.workspaceMetadata){o+=`
|  Remote: ${v.hostName}`;for(const C of Object.keys(v.workspaceMetadata)){const R=v.workspaceMetadata[C];let W=`${R.fileCount} files`;R.maxFilesReached&&(W=`more than ${W}`),o+=`|    Folder (${C}): ${W}`,o+=this.formatWorkspaceStats(R)}}}),{processInfo:l,workspaceInfo:o}})}async getSystemInfo(f,s){const{memory:i,vmHint:r,os:o,cpus:l}=d(),v={os:o,memory:i,cpus:l,vmHint:r,processArgs:`${f.mainArguments.join(" ")}`,gpuStatus:f.gpuFeatureStatus,screenReader:`${f.screenReader?"yes":"no"}`,remoteData:s};return m.isWindows||(v.load=`${w.loadavg().map(C=>Math.round(C)).join(", ")}`),m.isLinux&&(v.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(v)}async getDiagnostics(f,s){const i=[];return(0,b.listProcesses)(f.mainPID).then(async r=>(i.push(""),i.push(this.formatEnvironment(f)),i.push(""),i.push(this.formatProcessList(f,r)),f.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(f))),s.forEach(o=>{if((0,p.isRemoteDiagnosticError)(o))i.push(`
${o.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${o.hostName}`),i.push(this.formatMachineInfo(o.machineInfo)),o.processes&&i.push(this.formatProcessList(f,o.processes)),o.workspaceMetadata)for(const l of Object.keys(o.workspaceMetadata)){const v=o.workspaceMetadata[l];let C=`${v.fileCount} files`;v.maxFilesReached&&(C=`more than ${C}`),i.push(`Folder (${l}): ${C}`),i.push(this.formatWorkspaceStats(v))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(f){const s=[],i=60;let r=0;const o=(R,W)=>{const U=` ${R}(${W})`;r+U.length>i?(s.push(l),l="|                 ",r=l.length):r+=U.length,l+=U};let l="|      File types:";const v=10;let C=f.fileTypes.length>v?v:f.fileTypes.length;for(let R=0;R<C;R++){const W=f.fileTypes[R];o(W.name,W.count)}if(s.push(l),f.configFiles.length>=0&&(l="|      Conf files:",r=0,f.configFiles.forEach(R=>{o(R.name,R.count)}),s.push(l)),f.launchConfigFiles.length>0){let R="|      Launch Configs:";f.launchConfigFiles.forEach(W=>{R+=W.count>1?` ${W.name}(${W.count})`:` ${W.name}`}),s.push(R)}return s.join(`
`)}expandGPUFeatures(f){const s=Math.max(...Object.keys(f).map(i=>i.length));return Object.keys(f).map(i=>`${i}:  ${" ".repeat(s-i.length)}  ${f[i]}`).join(`
                  `)}formatWorkspaceMetadata(f){const s=[],i=[];return f.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(s.push(`|  Window (${r.title})`),r.folderURIs.forEach(o=>{const l=I.URI.revive(o);if(l.scheme===P.Schemas.file){const v=l.fsPath;i.push(y(v,["node_modules",".git"]).then(C=>{let R=`${C.fileCount} files`;C.maxFilesReached&&(R=`more than ${R}`),s.push(`|    Folder (${(0,S.basename)(v)}): ${R}`),s.push(this.formatWorkspaceStats(C))}).catch(C=>{s.push(`|      Error: Unable to collect workspace stats for folder ${v} (${C.toString()})`)}))}else s.push(`|    Folder (${l.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(r=>s.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}formatProcessList(f,s){const i=new Map;f.windows.forEach(o=>i.set(o.pid,o.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(f.mainPID,i,r,s,0),r.join(`
`)}formatProcessItem(f,s,i,r,o){const l=o===0;let v;l?v=r.pid===f?`${this.productService.applicationName} main`:"remote agent":(v=`${"  ".repeat(o)} ${r.name}`,r.name==="window"&&(v=`${v} (${s.get(r.pid)})`));const C=process.platform==="win32"?r.mem:w.totalmem()*(r.mem/100);i.push(`${r.load.toFixed(0).padStart(5," ")}	${(C/t.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${v}`),Array.isArray(r.children)&&r.children.forEach(R=>this.formatProcessItem(f,s,i,R,o+1))}async reportWorkspaceStats(f){for(const{uri:s}of f.folders){const i=I.URI.revive(s);if(i.scheme!==P.Schemas.file)continue;const r=i.fsPath;try{const o=await y(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":f.telemetryId,rendererSessionId:f.rendererSessionId}),o.fileTypes.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:f.rendererSessionId,type:l.name,count:l.count})}),o.launchConfigFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:f.rendererSessionId,type:l.name,count:l.count})}),o.configFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:f.rendererSessionId,type:l.name,count:l.count})})}catch{}}}};c=ue([te(0,g.ITelemetryService),te(1,h.IProductService)],c),e.DiagnosticsService=c}),define(Z[209],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class w{constructor(D){this.appenders=D}listen(D,P){throw new Error(`Event not found: ${P}`)}call(D,P,{eventName:S,data:m}){return this.appenders.forEach(I=>I.log(S,m)),Promise.resolve(null)}}e.TelemetryAppenderChannel=w;class n{constructor(D){this.channel=D}log(D,P){return this.channel.call("log",{eventName:D,data:P}).then(void 0,S=>`Failed to log telemetry: ${console.warn(S)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(Z[64],x([0,1,49,14,19,32]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class P{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(y,k){return Promise.resolve(void 0)}publicLog2(y,k){return this.publicLog(y,k)}publicLogError(y,k){return Promise.resolve(void 0)}publicLogError2(y,k){return this.publicLogError(y,k)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class S{async publicLog(y,k,d){}async publicLogError(y,k,d){}}e.NullEndpointTelemetryService=S,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(g,y){return y.onDidChangeConfiguration(k=>{k.source!==6&&g.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(k.source),configurationKeys:t(k.sourceConfig)})})}e.configurationTelemetry=m;function I(g,y){return!(y.disableTelemetry||!g.enableTelemetry||y.extensionTestsLocationURI)}e.supportsTelemetry=I;function M(g){const y=g.getValue(D.TELEMETRY_SETTING_ID),k=g.getValue("telemetry.enableCrashReporter");if(g.getValue(D.TELEMETRY_OLD_SETTING_ID)===!1||k===!1)return 0;switch(y??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=M;function E(g){const y=Object.create(null),k=Object.create(null),d=Object.create(null);p(g,d);for(let u in d){u=u.length>150?u.substr(u.length-149):u;const c=d[u];typeof c=="number"?k[u]=c:typeof c=="boolean"?k[u]=c?1:0:typeof c=="string"?(c.length>8192&&console.warn(`Telemetry property: ${u} has been trimmed to 8192, the original length is ${c.length}`),y[u]=c.substring(0,8191)):typeof c!="undefined"&&c!==null&&(y[u]=c)}return{properties:y,measurements:k}}e.validateTelemetryData=E;function b(g){if(!g)return"none";let y="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(d=>{g.indexOf(`${d}+`)===0&&(y=d)}),y}e.cleanRemoteAuthority=b;function p(g,y,k=0,d){if(!!g)for(let u of Object.getOwnPropertyNames(g)){const c=g[u],a=d?d+u:u;Array.isArray(c)?y[a]=(0,w.safeStringify)(c):c instanceof Date?y[a]=c.toISOString():(0,n.isObject)(c)?k<2?p(c,y,k+1,a+"."):y[a]=(0,w.safeStringify)(c):y[a]=c}}function t(g){if(!g)return[];const y=[];return h(y,"",g),y}function h(g,y,k){k&&typeof k=="object"&&!Array.isArray(k)?Object.keys(k).forEach(d=>h(g,y?`${y}.${d}`:d,k[d])):g.push(y)}}),define(Z[210],x([0,1,172,64]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function L(D,P,S,m,I,M){const E={"X-Market-Client-Id":`VSCode ${D}`,"User-Agent":`VSCode ${D} (${P.nameShort})`},b=await(0,w.getServiceMachineId)(S,I,M);return(0,n.supportsTelemetry)(P,S)&&(0,n.getTelemetryLevel)(m)===3&&(E["X-Market-User-Id"]=b),E}e.resolveMarketplaceHeaders=L}),define(Z[211],x([0,1,3,49,2,27,154,19,55,53,40,32,64]),function(V,e,w,n,L,D,P,S,m,I,M,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(g,y){this._configurationService=y,this._experimentProperties={},this._disposables=new w.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties||Promise.resolve({}),this._piiPaths=g.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let k of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(k),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(g,y){this._experimentProperties[g]=y}_updateTelemetryLevel(){this._telemetryLevel=(0,b.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const g=await this._commonProperties;let y=g.sessionID,k=g["common.machineId"],d=g["common.firstSessionDate"],u=g["common.msftInternal"];return{sessionId:y,machineId:k,firstSessionDate:d,msftInternal:u}}dispose(){this._disposables.dispose()}_log(g,y,k,d){return this.telemetryLevel<y?Promise.resolve(void 0):this._commonProperties.then(u=>{k=(0,n.mixin)(k,u),k=(0,n.mixin)(k,this._experimentProperties),k=(0,n.cloneAndChange)(k,c=>{if(typeof c=="string")return this._cleanupInfo(c,d)}),this._appenders.forEach(c=>c.log(g,k))},u=>{console.error(u)})}publicLog(g,y,k){return this._log(g,3,y,k)}publicLog2(g,y,k){return this.publicLog(g,y,k)}publicLogError(g,y){return this.sendErrorTelemetry?this._log(g,2,y,!0):Promise.resolve(void 0)}publicLogError2(g,y){return this.publicLogError(g,y)}_anonymizeFilePaths(g){let y=g;const k=[];for(let a of this._cleanupPatterns)for(;;){const f=a.exec(g);if(!f)break;k.push([f.index,a.lastIndex])}const d=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(y="";;){const a=u.exec(g);if(!a)break;!d.test(a[0])&&k.every(([f,s])=>a.index<f||a.index>=s)&&(y+=g.substring(c,a.index)+"<REDACTED: user-file-path>",c=u.lastIndex)}return c<g.length&&(y+=g.substr(c)),y}_removePropertiesWithPossibleUserInfo(g){if(!g)return g;const y=g.toLowerCase(),k=/@[a-zA-Z0-9-.]+/,d=/(key|token|sig|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/,u=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return d.test(y)?"<REDACTED: secret>":k.test(y)?"<REDACTED: email>":u.test(y)?"<REDACTED: token>":g}_cleanupInfo(g,y){let k=g;y&&(k=this._anonymizeFilePaths(k));for(let d of this._cleanupPatterns)k=k.replace(d,"");return k=this._removePropertiesWithPossibleUserInfo(k),k}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=ue([te(1,S.IConfigurationService)],p),e.TelemetryService=p;function t(){const h=(0,P.localize)(0,null,I.default.nameLong),g=I.default.privacyStatementUrl?(0,P.localize)(2,null,"https://aka.ms/vscode-telemetry",I.default.privacyStatementUrl):(0,P.localize)(1,null,"https://aka.ms/vscode-telemetry"),y=L.isWeb?"":(0,P.localize)(3,null),k=(0,P.localize)(4,null),d=(0,P.localize)(5,null),u=(0,P.localize)(6,null),c=(0,P.localize)(7,null),a=`
|       | ${k} | ${d} | ${u} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,f=(0,P.localize)(8,null);return`
${h} ${g} ${y}

&nbsp;

${c}
${a}

&nbsp;

${f}
`}M.Registry.as(m.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,P.localize)(10,null),(0,P.localize)(11,null),(0,P.localize)(12,null),(0,P.localize)(13,null)],markdownDescription:t(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),M.Registry.as(m.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:I.default.privacyStatementUrl?(0,P.localize)(16,null,I.default.nameLong,I.default.privacyStatementUrl):(0,P.localize)(15,null,I.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,P.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[98],x([0,1,45,7,155,23,39,15,2,31,137,50,9]),function(V,e,w,n,L,D,P,S,m,I,M,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const p=1e4;let t;async function h(y,k,d){return k["force-disable-user-env"]?(y.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):m.isWindows?(y.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(d)&&!k["force-user-env"]?(y.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(d)?y.trace("resolveShellEnv(): running (--force-user-env)"):y.trace("resolveShellEnv(): running (macOS/Linux)"),t||(t=b.Promises.withAsyncBody(async(u,c)=>{const a=new D.CancellationTokenSource,f=setTimeout(()=>{a.dispose(!0),c(new Error((0,L.localize)(0,null)))},p);try{u(await g(y,a.token))}catch(s){!(0,S.isCancellationError)(s)&&!a.token.isCancellationRequested?c(new Error((0,L.localize)(1,null,(0,P.toErrorMessage)(s)))):u({})}finally{clearTimeout(f),a.dispose()}})),t)}e.getResolvedShellEnv=h;async function g(y,k){const d=process.env.ELECTRON_RUN_AS_NODE;y.trace("getUnixShellEnvironment#runAsNode",d);const u=process.env.ELECTRON_NO_ATTACH_CONSOLE;y.trace("getUnixShellEnvironment#noAttach",u);const c=(0,I.generateUuid)().replace(/-/g,"").substr(0,12),a=new RegExp(c+"(.*)"+c),f={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};y.trace("getUnixShellEnvironment#env",f);const s=await(0,M.getSystemShell)(m.OS,f);return y.trace("getUnixShellEnvironment#shell",s),new Promise((i,r)=>{if(k.isCancellationRequested)return r((0,S.canceled)());const o=(0,n.basename)(s);let l,v;const C=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(l=`& '${process.execPath}' ${C} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,v=["-Login","-Command"]):(l=`'${process.execPath}' ${C} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,o==="tcsh"?v=["-ic"]:v=["-ilc"]),y.trace("getUnixShellEnvironment#spawn",JSON.stringify(v),l);const R=(0,w.spawn)(s,[...v,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:f});k.onCancellationRequested(()=>(R.kill(),r((0,S.canceled)()))),R.on("error",G=>{y.error("getUnixShellEnvironment#errorChildProcess",(0,P.toErrorMessage)(G)),r(G)});const W=[];R.stdout.on("data",G=>W.push(G));const U=[];R.stderr.on("data",G=>U.push(G)),R.on("close",(G,ee)=>{const X=Buffer.concat(W).toString("utf8");y.trace("getUnixShellEnvironment#raw",X);const J=Buffer.concat(U).toString("utf8");if(J.trim()&&y.trace("getUnixShellEnvironment#stderr",J),G||ee)return r(new Error((0,L.localize)(2,null,G,ee)));const H=a.exec(X),B=H?H[1]:"{}";try{const Y=JSON.parse(B);d?Y.ELECTRON_RUN_AS_NODE=d:delete Y.ELECTRON_RUN_AS_NODE,u?Y.ELECTRON_NO_ATTACH_CONSOLE=u:delete Y.ELECTRON_NO_ATTACH_CONSOLE,delete Y.XDG_RUNTIME_DIR,y.trace("getUnixShellEnvironment#result",Y),i(Y)}catch(Y){y.error("getUnixShellEnvironment#errorCaught",(0,P.toErrorMessage)(Y)),r(Y)}})})}}),define(Z[212],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var w;(function(n){n.DARK="dark",n.LIGHT="light",n.HIGH_CONTRAST="hc"})(w=e.ColorScheme||(e.ColorScheme={}))}),define(Z[213],x([0,1,107,4,3,5,40,212]),function(V,e,w,n,L,D,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,D.createDecorator)("themeService");var m;(function(g){function y(k){return k&&typeof k=="object"&&typeof k.id=="string"}g.isThemeColor=y})(m=e.ThemeColor||(e.ThemeColor={}));function I(g){return{id:g}}e.themeColorFromId=I;var M;(function(g){function y(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||m.isThemeColor(i.color))}g.isThemeIcon=y;const k=new RegExp(`^\\$\\((${w.CSSIcon.iconNameExpression}(?:${w.CSSIcon.iconModifierExpression})?)\\)$`);function d(i){const r=k.exec(i);if(!r)return;let[,o]=r;return{id:o}}g.fromString=d;function u(i){return{id:i}}g.fromId=u;function c(i,r){let o=i.id;const l=o.lastIndexOf("~");return l!==-1&&(o=o.substring(0,l)),r&&(o=`${o}~${r}`),{id:o}}g.modify=c;function a(i){const r=i.id.lastIndexOf("~");if(r!==-1)return i.id.substring(r+1)}g.getModifier=a;function f(i,r){return i.id===r.id&&i.color?.id===r.color?.id}g.isEqual=f;function s(i,r){return{id:i.id,color:r?I(r):void 0}}g.asThemeIcon=s,g.asClassNameArray=w.CSSIcon.asClassNameArray,g.asClassName=w.CSSIcon.asClassName,g.asCSSSelector=w.CSSIcon.asCSSSelector})(M=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=w.Codicon.file,e.FolderThemeIcon=w.Codicon.folder;function E(g){switch(g){case S.ColorScheme.DARK:return"vs-dark";case S.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class b{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(y){return this.themingParticipants.push(y),this.onThemingParticipantAddedEmitter.fire(y),(0,L.toDisposable)(()=>{const k=this.themingParticipants.indexOf(y);this.themingParticipants.splice(k,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new b;P.Registry.add(e.Extensions.ThemingContribution,p);function t(g){return p.onColorThemeChange(g)}e.registerThemingParticipant=t;class h extends L.Disposable{constructor(y){super();this.themeService=y,this.theme=y.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(k=>this.onThemeChange(k)))}onThemeChange(y){this.theme=y,this.updateStyles()}updateStyles(){}getColor(y,k){let d=this.theme.getColor(y);return d&&k&&(d=k(d,this.theme)),d?d.toString():null}}e.Themable=h}),define(Z[65],x([0,1,12,2,5,38]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const P="#FFFFFF",S="#1E1E1E",m="#000000",I="theme",M="themeBackground",E="windowSplash";e.IThemeMainService=(0,L.createDecorator)("themeMainService");let b=class{constructor(t){this.stateMainService=t}getBackgroundColor(){if((n.isWindows||n.isMacintosh)&&w.nativeTheme.shouldUseInvertedColorScheme)return m;let t=this.stateMainService.getItem(M,null);if(!t){let h;(n.isWindows||n.isMacintosh)&&w.nativeTheme.shouldUseInvertedColorScheme?h="hc-black":h=this.stateMainService.getItem(I,"vs-dark").split(" ")[0],t=h==="hc-black"?m:h==="vs"?P:S}return n.isMacintosh&&t.toUpperCase()===S&&(t="#171717"),t}saveWindowSplash(t,h){this.stateMainService.setItems([{key:I,data:h.baseTheme},{key:M,data:h.colorInfo.background},{key:E,data:h}]),typeof t=="number"&&this.updateBackgroundColor(t,h)}updateBackgroundColor(t,h){for(const g of w.BrowserWindow.getAllWindows())if(g.id===t){g.setBackgroundColor(h.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(E)}};b=ue([te(0,D.IStateMainService)],b),e.ThemeMainService=b}),define(Z[99],x([0,1,4,2,5,6]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,L.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,L.createDecorator)("sharedTunnelsService");var P;(function(t){t.Http="http",t.Https="https"})(P=e.TunnelProtocol||(e.TunnelProtocol={}));var S;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(S=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var m;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(m=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function I(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=I,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function M(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=M,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=E;function b(t,h){return h?h!==1&&t<1024:!n.isWindows&&t<1024}e.isPortPrivileged=b;let p=class{constructor(h){this.logService=h,this._onTunnelOpened=new w.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new w.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new w.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(h){return this._tunnelProvider=h,h?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this._canElevate=h.elevation,this._privacyOptions=h.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const h=[],g=Array.from(this._tunnels.values());for(let y of g){const k=Array.from(y.values());for(let d of k){const u=await d.value;u&&h.push(u)}}return h}async dispose(){for(const h of this._tunnels.values()){for(const{value:g}of h.values())await g.then(y=>y?.dispose());h.clear()}this._tunnels.clear()}openTunnel(h,g,y,k,d=!1,u=S.Private,c){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${y} on local port ${k}.`),!h)return;g||(g="localhost");const a=this.retainOrCreateTunnel(h,g,y,k,d,u,c);return a?a.then(f=>{if(!f){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,y);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(f);return(f.tunnelRemoteHost!==g||f.tunnelRemotePort!==y)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}makeTunnel(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const g=this._tunnels.get(h.tunnelRemoteHost);if(g){const y=g.get(h.tunnelRemotePort);y&&(y.refcount--,await this.tryDisposeTunnel(h.tunnelRemoteHost,h.tunnelRemotePort,y))}}}}async tryDisposeTunnel(h,g,y){if(y.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${g}.`);const k=y.value.then(async d=>{d&&(await d.dispose(!0),this._onTunnelClosed.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this._tunnels.has(h)&&this._tunnels.get(h).delete(g),k}}async closeTunnel(h,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${g} `);const y=this._tunnels.get(h);if(y&&y.has(g)){const k=y.get(g);k.refcount=0,await this.tryDisposeTunnel(h,g,k)}}addTunnelToMap(h,g,y){this._tunnels.has(h)||this._tunnels.set(h,new Map),this._tunnels.get(h).set(g,{refcount:1,value:y})}async removeEmptyTunnelFromMap(h,g){const y=this._tunnels.get(h);y&&(await y.get(g)||y.delete(g),y.size===0&&this._tunnels.delete(h))}getTunnelFromMap(h,g){let y=[h];M(h)?(y.push(...e.LOCALHOST_ADDRESSES),y.push(...e.ALL_INTERFACES_ADDRESSES)):E(h)&&y.push(...e.ALL_INTERFACES_ADDRESSES);const k=y.map(d=>this._tunnels.get(d));for(const d of k){const u=d?.get(g);if(u)return u}}canTunnel(h){return!!I(h)}createWithProvider(h,g,y,k,d,u,c){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${y} on local port ${k}.`);const f={elevationRequired:d?b(k===void 0?y:k):!1},s={remoteAddress:{host:g,port:y},localAddressPort:k,privacy:u,public:u!==S.Private,protocol:c},i=h.forwardPort(s,f);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(g,y,i),i}};p=ue([te(0,D.ILogService)],p),e.AbstractTunnelService=p}),define(Z[41],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var n;(function(D){D.Uninitialized="uninitialized",D.Idle="idle",D.CheckingForUpdates="checking for updates",D.AvailableForDownload="available for download",D.Downloading="downloading",D.Downloaded="downloaded",D.Updating="updating",D.Ready="ready"})(n=e.StateType||(e.StateType={}));var L;(function(D){D[D.Setup=0]="Setup",D[D.Archive=1]="Archive",D[D.Snap=2]="Snap"})(L=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(D,P)=>({type:"idle",updateType:D,error:P}),CheckingForUpdates:D=>({type:"checking for updates",explicit:D}),AvailableForDownload:D=>({type:"available for download",update:D}),Downloading:D=>({type:"downloading",update:D}),Downloaded:D=>({type:"downloaded",update:D}),Updating:D=>({type:"updating",update:D}),Ready:D=>({type:"ready",update:D})},e.IUpdateService=(0,w.createDecorator)("updateService")}),define(Z[214],x([0,1,2,156,55,40]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),D.Registry.as(L.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,n.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,n.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,n.localize)(2,null),(0,n.localize)(3,null),(0,n.localize)(4,null),(0,n.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,n.localize)(6,null),deprecationMessage:(0,n.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,n.localize)(8,null),description:(0,n.localize)(9,null),included:w.isWindows&&!w.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,n.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Z[215],x([0,1,4,41]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class L{constructor(S){this.service=S}listen(S,m){switch(m){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${m}`)}call(S,m,I){switch(m){case"checkForUpdates":return this.service.checkForUpdates(I);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${m}`)}}e.UpdateChannel=L;class D{constructor(S){this.channel=S,this._onStateChange=new w.Emitter,this.onStateChange=this._onStateChange.event,this._state=n.State.Uninitialized,this.channel.listen("onStateChange")(m=>this.state=m),this.channel.call("_getInitialState").then(m=>this.state=m)}get state(){return this._state}set state(S){this._state=S,this._onStateChange.fire(S)}checkForUpdates(S){return this.channel.call("checkForUpdates",S)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=D}),define(Z[100],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,w.createDecorator)("urlService")}),define(Z[216],x([0,1,8]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class n{constructor(S){this.handler=S}listen(S,m){throw new Error(`Event not found: ${m}`)}call(S,m,I){switch(m){case"handleURL":return this.handler.handleURL(w.URI.revive(I[0]),I[1])}throw new Error(`Call not found: ${m}`)}}e.URLHandlerChannel=n;class L{constructor(S){this.channel=S}handleURL(S,m){return this.channel.call("handleURL",[S.toJSON(),m])}}e.URLHandlerChannelClient=L;class D{constructor(S){this.next=S}async routeCall(S,m,I,M){if(m!=="handleURL")throw new Error(`Call not found: ${m}`);if(I){const E=w.URI.revive(I);if(E&&E.query){const b=/\bwindowId=(\d+)/.exec(E.query);if(b){const p=b[1],t=new RegExp(`window:${p}`),h=S.connections.find(g=>t.test(g.ctx));if(h)return h}}}return this.next.routeCall(S,m,I,M)}routeEvent(S,m){throw new Error(`Event not found: ${m}`)}}e.URLHandlerRouter=D}),define(Z[217],x([0,1,9,3,8,21]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class P extends n.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(I,M){const E=[...this.handlers.values()];return(0,w.first)(E.map(b=>()=>b.handleURL(I,M)),void 0,!1).then(b=>b||!1)}registerHandler(I){return this.handlers.add(I),(0,n.toDisposable)(()=>this.handlers.delete(I))}}e.AbstractURLService=P;let S=class extends P{constructor(I){super();this.productService=I}create(I){let{authority:M,path:E,query:b,fragment:p}=I||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return M&&E&&E.indexOf("/")!==0&&(E=`/${E}`),L.URI.from({scheme:this.productService.urlProtocol,authority:M,path:E,query:b,fragment:p})}};S=ue([te(0,D.IProductService)],S),e.NativeURLService=S}),define(Z[218],x([0,1,12,9,4,3,2,8]),function(V,e,w,n,L,D,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function m(M){try{return S.URI.parse(M)}catch{return null}}class I{constructor(E,b,p,t,h){if(this.urlService=b,this.uris=[],this.retryCount=0,this.flushDisposable=D.Disposable.None,this.disposables=new D.DisposableStore,this.uris=E,P.isWindows){const k=t.isBuilt?[]:[`"${t.appRoot}"`];k.push("--open-url","--"),w.app.setAsDefaultProtocolClient(h.urlProtocol,process.execPath,k)}const g=L.Event.map(L.Event.fromNodeEventEmitter(w.app,"open-url",(k,d)=>({event:k,url:d})),({event:k,url:d})=>(k.preventDefault(),d));this.disposables.add(g(k=>{const d=m(k);!d||this.urlService.open(d,{originalUrl:k})})),p.getWindows().filter(k=>k.isReady).length>0?this.flush():L.Event.once(p.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const E=[];for(const b of this.uris)await this.urlService.open(b.uri,{originalUrl:b.url})||E.push(b);E.length!==0&&(this.uris=E,this.flushDisposable=(0,n.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=I}),define(Z[219],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,w.createDecorator)("webviewManagerService")}),define(Z[220],x([0,1,12,3,10,8]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class P extends n.Disposable{constructor(){super();const m=this.handleWebviewRequest.bind(this);w.protocol.registerFileProtocol(L.Schemas.vscodeWebview,m)}handleWebviewRequest(m,I){try{const M=D.URI.parse(m.url),E=P.validWebviewFilePaths.get(M.path);if(typeof E=="string"){const b=`vs/workbench/contrib/webview/browser/pre/${E}`,p=L.FileAccess.asFileUri(b,V);return I(decodeURIComponent(p.fsPath))}else return I({error:-10})}catch{}return I({error:-2})}}e.WebviewProtocolProvider=P,P.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(Z[66],x([0,1,2]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function n(I){return!!I.workspaceUri}e.isWorkspaceToOpen=n;function L(I){return!!I.folderUri}e.isFolderToOpen=L;function D(I){return!!I.fileUri}e.isFileToOpen=D;function P(I){const M=S(I),E=I.getValue("window.menuBarVisibility");return E==="default"||M==="native"&&E==="compact"||w.isMacintosh&&w.isNative?"classic":E}e.getMenuBarVisibility=P;function S(I){if(w.isWeb)return"custom";const M=I.getValue("window");if(M){if(w.isMacintosh&&M.nativeTabs===!0||w.isMacintosh&&M.nativeFullScreen===!1)return"native";const p=I.getValue("workbench.colorCustomizations");if(p?.["window.activeBorder"]||p?.["window.inactiveBorder"])return"custom";const t=M.titleBarStyle;if(t==="native"||t==="custom")return t}return w.isLinux?"native":"custom"}e.getTitleBarStyle=S;function m(I=0){return Math.pow(1.2,I)}e.zoomLevelToZoomFactor=m}),define(Z[101],x([0,1]),function(V,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var w;(function(S){S[S.INITIAL=1]="INITIAL",S[S.LOAD=2]="LOAD",S[S.RELOAD=3]="RELOAD"})(w=e.LoadReason||(e.LoadReason={}));var n;(function(S){S[S.CLOSE=1]="CLOSE",S[S.QUIT=2]="QUIT",S[S.RELOAD=3]="RELOAD",S[S.LOAD=4]="LOAD"})(n=e.UnloadReason||(e.UnloadReason={}));const L=function(S=1){return{width:1024,height:768,mode:S}};e.defaultWindowState=L;var D;(function(S){S[S.Maximized=0]="Maximized",S[S.Normal=1]="Normal",S[S.Minimized=2]="Minimized",S[S.Fullscreen=3]="Fullscreen"})(D=e.WindowMode||(e.WindowMode={}));var P;(function(S){S[S.UNRESPONSIVE=1]="UNRESPONSIVE",S[S.CRASHED=2]="CRASHED",S[S.LOAD=3]="LOAD"})(P=e.WindowError||(e.WindowError={}))}),define(Z[34],x([0,1,5]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,w.createDecorator)("windowsMainService");var n;(function(L){L[L.CLI=0]="CLI",L[L.DOCK=1]="DOCK",L[L.MENU=2]="MENU",L[L.DIALOG=3]="DIALOG",L[L.DESKTOP=4]="DESKTOP",L[L.API=5]="API"})(n=e.OpenContext||(e.OpenContext={}))}),define(Z[221],x([0,1,12,23,4,69,3,31,74,92,6,21,34]),function(V,e,w,n,L,D,P,S,m,I,M,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var p;(function(h){h[h.Initial=1]="Initial",h[h.StoredCredentialsUsed=2]="StoredCredentialsUsed",h[h.LoginDialogShown=3]="LoginDialogShown"})(p||(p={}));let t=class extends P.Disposable{constructor(g,y,k,d,u){super();this.logService=g,this.windowsMainService=y,this.credentialsService=k,this.encryptionMainService=d,this.productService=u,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=p.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const g=L.Event.fromNodeEventEmitter(w.app,"login",(y,k,d,u,c)=>({event:y,webContents:k,req:d,authInfo:u,callback:c}));this._register(g(this.onLogin,this))}async onLogin({event:g,authInfo:y,req:k,callback:d}){if(!y.isProxy)return;if(!this.pendingProxyResolve&&this.state===p.LoginDialogShown&&k.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}g.preventDefault();let u;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),u=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(y);try{u=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}d(u?.username,u?.password)}async resolveProxyCredentials(g){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const y=await this.doResolveProxyCredentials(g);if(y)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),y;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(g){this.logService.trace("auth#doResolveProxyCredentials - enter",g);const y=String((0,D.hash)({scheme:g.scheme,host:g.host,port:g.port}));let k,d;try{const f=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,y);if(f){const s=JSON.parse(await this.encryptionMainService.decrypt(f));k=s.username,d=s.password}}catch(f){this.logService.error(f)}if(this.state!==p.StoredCredentialsUsed&&typeof k=="string"&&typeof d=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=p.StoredCredentialsUsed,{username:k,password:d};const u=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!u){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${u.id} to handle proxy login`);const c={authInfo:g,username:this.sessionCredentials?.username??k,password:this.sessionCredentials?.password??d,replyChannel:`vscode:proxyAuthResponse:${(0,S.generateUuid)()}`};u.sendWhenReady("vscode:openProxyAuthenticationDialog",n.CancellationToken.None,c),this.state=p.LoginDialogShown;const a=await new Promise(f=>{const s=async(i,r,o)=>{if(r===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${u.id}`),u.win?.webContents.off("ipc-message",s),o){const l={username:o.username,password:o.password};try{if(o.remember){const v=await this.encryptionMainService.encrypt(JSON.stringify(l));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,y,v)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,y)}catch(v){this.logService.error(v)}f({username:l.username,password:l.password})}else f(void 0)};u.win?.webContents.on("ipc-message",s)});return this.sessionCredentials=a,a}};t=ue([te(0,M.ILogService),te(1,b.IWindowsMainService),te(2,m.ICredentialsMainService),te(3,I.IEncryptionMainService),te(4,E.IProductService)],t),e.ProxyAuthHandler=t}),define(Z[222],x([0,1,12,4,3,220,34]),function(V,e,w,n,L,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let S=class extends L.Disposable{constructor(I){super();this.windowsMainService=I,this._onFoundInFrame=this._register(new n.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new D.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(I,M){let E;if(typeof I.windowId=="number"){const{windowId:b}=I,p=this.windowsMainService.getWindowById(b);if(!p?.win)throw new Error(`Invalid windowId: ${b}`);E=p.win.webContents}else{const{webContentsId:b}=I;if(E=w.webContents.fromId(b),!E)throw new Error(`Invalid webContentsId: ${b}`)}E.isDestroyed()||E.setIgnoreMenuShortcuts(M)}async findInFrame(I,M,E,b){const t=this.getFrameByName(I,M);if(typeof t.findInFrame=="function"){t.findInFrame(E,{findNext:b.findNext,forward:b.forward});const h=(g,y)=>{y.finalUpdate&&(this._onFoundInFrame.fire(y),t.removeListener("found-in-frame",h))};t.on("found-in-frame",h)}}async stopFindInFrame(I,M,E){const p=this.getFrameByName(I,M);typeof p.stopFindInFrame=="function"&&p.stopFindInFrame(E.keepSelection?"keepSelection":"clearSelection")}getFrameByName(I,M){const E=this.windowsMainService.getWindowById(I.windowId);if(!E?.win)throw new Error(`Invalid windowId: ${I}`);const b=E.win.webContents.mainFrame.framesInSubtree.find(p=>p.name===M);if(!b)throw new Error(`Unknown frame: ${M}`);return b}};S=ue([te(0,P.IWindowsMainService)],S),e.WebviewMainService=S}),define(Z[223],x([0,1,9,4,3]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class D extends L.Disposable{constructor({onDidOpenWindow:S,onDidFocusWindow:m,getActiveWindowId:I}){super();this.disposables=this._register(new L.DisposableStore),n.Event.latch(n.Event.any(S,m))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,w.createCancelablePromise)(()=>I()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(S){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=S}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=D}),define(Z[25],x([0,1,159,7,35,17,8,5,10]),function(V,e,w,n,L,D,P,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,S.createDecorator)("contextService");function I(f){const s=f;return typeof s?.id=="string"&&P.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=I;function M(f){if(f.configuration)return{id:f.id,configPath:f.configuration};if(f.folders.length===1)return{id:f.id,uri:f.folders[0].uri}}e.toWorkspaceIdentifier=M;function E(f){const s=f;return typeof s?.id=="string"&&P.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=E;function b(f){const s=f;if(s?.uri)return{id:s.id,uri:P.URI.revive(s.uri)};const i=f;if(i?.configPath)return{id:i.id,configPath:P.URI.revive(i.configPath)};if(f?.id)return{id:f.id}}e.reviveIdentifier=b;var p;(function(f){f[f.EMPTY=1]="EMPTY",f[f.FOLDER=2]="FOLDER",f[f.WORKSPACE=3]="WORKSPACE"})(p=e.WorkbenchState||(e.WorkbenchState={}));function t(f){const s=f;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=t;function h(f){const s=f;return!!(s&&typeof s=="object"&&P.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=h;class g{constructor(s,i,r,o,l){this._id=s,this._transient=r,this._configuration=o,this._ignorePathCasing=l,this._foldersMap=L.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=i}update(s){this._id=s.id,this._configuration=s.configuration,this._transient=s.transient,this._ignorePathCasing=s._ignorePathCasing,this.folders=s.folders}get folders(){return this._folders}set folders(s){this._folders=s,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(s){this._configuration=s}getFolder(s){return s&&this._foldersMap.findSubstr(s.with({scheme:s.scheme,authority:s.authority,path:s.path}))||null}updateFoldersMap(){this._foldersMap=L.TernarySearchTree.forUris(this._ignorePathCasing);for(const s of this.folders)this._foldersMap.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=g;class y{constructor(s,i){this.raw=i,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,D.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=y;function k(f){return new y({uri:f,index:0,name:(0,D.basenameOrAuthority)(f)},{uri:f.toString()})}e.toWorkspaceFolder=k,e.WORKSPACE_EXTENSION="code-workspace";const d=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,w.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function u(f,s){return D.extUriBiasedIgnorePathCase.isEqualOrParent(f,s.untitledWorkspacesHome)}e.isUntitledWorkspace=u;function c(f){let s;return P.URI.isUri(f)?s=f:s=f.configuration,s?.scheme===m.Schemas.tmp}e.isTemporaryWorkspace=c;function a(f){return(typeof f=="string"?(0,n.extname)(f):(0,D.extname)(f))===d}e.hasWorkspaceFileExtension=a}),define(Z[47],x([0,1,12,9,69,33,3,70,7,2,14,24,141,5,6,38,25]),function(V,e,w,n,L,D,P,S,m,I,M,E,b,p,t,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,p.createDecorator)("dialogMainService");let y=class bt{constructor(d,u){this.stateMainService=d,this.logService=u,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new n.Queue}pickFileFolder(d,u){return this.doPick({...d,pickFolders:!0,pickFiles:!0,title:(0,b.localize)(0,null)},u)}pickFolder(d,u){return this.doPick({...d,pickFolders:!0,title:(0,b.localize)(1,null)},u)}pickFile(d,u){return this.doPick({...d,pickFiles:!0,title:(0,b.localize)(2,null)},u)}pickWorkspace(d,u){const c=(0,b.localize)(3,null),a=(0,D.mnemonicButtonLabel)((0,b.localize)(4,null)),f=g.WORKSPACE_FILTER;return this.doPick({...d,pickFiles:!0,title:c,filters:f,buttonLabel:a},u)}async doPick(d,u){const c={title:d.title,buttonLabel:d.buttonLabel,filters:d.filters};c.defaultPath=d.defaultPath||this.stateMainService.getItem(bt.workingDirPickerStorageKey),(typeof d.pickFiles=="boolean"||typeof d.pickFolders=="boolean")&&(c.properties=void 0,d.pickFiles&&d.pickFolders&&(c.properties=["multiSelections","openDirectory","openFile","createDirectory"])),c.properties||(c.properties=["multiSelections",d.pickFolders?"openDirectory":"openFile","createDirectory"]),I.isMacintosh&&c.properties.push("treatPackageAsDirectory");const a=u||w.BrowserWindow.getFocusedWindow(),f=await this.showOpenDialog(c,(0,M.withNullAsUndefined)(a));if(f&&f.filePaths&&f.filePaths.length>0)return this.stateMainService.setItem(bt.workingDirPickerStorageKey,(0,m.dirname)(f.filePaths[0])),f.filePaths}getWindowDialogQueue(d){if(d){let u=this.windowDialogQueues.get(d.id);return u||(u=new n.Queue,this.windowDialogQueues.set(d.id,u)),u}else return this.noWindowDialogueQueue}showMessageBox(d,u){return this.getWindowDialogQueue(u).queue(async()=>u?w.dialog.showMessageBox(u,d):w.dialog.showMessageBox(d))}async showSaveDialog(d,u){const c=this.acquireFileDialogLock(d,u);if(!c)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(u).queue(async()=>{let a;return u?a=await w.dialog.showSaveDialog(u,d):a=await w.dialog.showSaveDialog(d),a.filePath=this.normalizePath(a.filePath),a})}finally{(0,P.dispose)(c)}}normalizePath(d){return d&&I.isMacintosh&&(d=(0,S.normalizeNFC)(d)),d}normalizePaths(d){return d.map(u=>this.normalizePath(u))}async showOpenDialog(d,u){d.defaultPath&&(await E.Promises.exists(d.defaultPath)||(d.defaultPath=void 0));const c=this.acquireFileDialogLock(d,u);if(!c)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(u).queue(async()=>{let a;return u?a=await w.dialog.showOpenDialog(u,d):a=await w.dialog.showOpenDialog(d),a.filePaths=this.normalizePaths(a.filePaths),a})}finally{(0,P.dispose)(c)}}acquireFileDialogLock(d,u){if(!u)return P.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",d);let c=this.windowFileDialogLocks.get(u.id);c||(c=new Set,this.windowFileDialogLocks.set(u.id,c));const a=(0,L.hash)(d);if(!c.has(a))return this.logService.trace("[DialogMainService]: new file dialog lock created",d),c.add(a),(0,P.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",d),c?.delete(a),c?.size===0&&this.windowFileDialogLocks.delete(u.id)})}};y.workingDirPickerStorageKey="pickerWorkingDir",y=ue([te(0,h.IStateMainService),te(1,t.ILogService)],y),e.DialogMainService=y}),define(Z[224],x([0,1,4,3,25]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class D extends n.Disposable{constructor(S,m){super();this.logService=S,this.storageMainService=m,this._onDidChangeGlobalStorage=this._register(new w.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(w.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(S,m)=>(S?S.push(m):S=[m],S),D.STORAGE_CHANGE_DEBOUNCE_TIME)(S=>{S.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(S))}))}serializeGlobalStorageEvents(S){const m=new Map,I=new Set;return S.forEach(M=>{const E=this.storageMainService.globalStorage.get(M.key);typeof E=="string"?m.set(M.key,E):I.add(M.key)}),{changed:Array.from(m.entries()),deleted:Array.from(I.values())}}listen(S,m){switch(m){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${m}`)}async call(S,m,I){const M=(0,L.reviveIdentifier)(I.workspace),E=await this.withStorageInitialized(M);switch(m){case"getItems":return Array.from(E.items.entries());case"updateItems":{const b=I;if(b.insert)for(const[p,t]of b.insert)E.set(p,t);b.delete&&b.delete.forEach(p=>E.delete(p));break}case"close":{if(M)return E.close();break}default:throw new Error(`Call not found: ${m}`)}}async withStorageInitialized(S){const m=S?this.storageMainService.workspaceStorage(S):this.storageMainService.globalStorage;try{await m.init()}catch(I){this.logService.error(`StorageIPC#init: Unable to init ${S?"workspace":"global"} storage due to ${I}`)}return m}}e.StorageDatabaseChannel=D,D.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Z[225],x([0,1,9,4,3,7,2,24,90,130,6,97,32,25]),function(V,e,w,n,L,D,P,S,m,I,M,E,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class t extends L.Disposable{constructor(k){super();this.logService=k,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new n.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new m.Storage(new m.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new w.DeferredPromise,this.whenInit=this.whenInitPromise.p}get storage(){return this._storage}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const k=await this.doCreate();this._storage.dispose(),this._storage=k,this._register(k.onDidChangeStorage(u=>this._onDidChangeStorage.fire({key:u}))),await this.doInit(k);const d=k.getBoolean(E.IS_NEW_KEY);d===void 0?k.set(E.IS_NEW_KEY,!0):d&&k.set(E.IS_NEW_KEY,!1)}catch(k){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${k}`)}finally{this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:P.isCI?k=>this.logService.info(k):this.logService.getLevel()===M.LogLevel.Trace?k=>this.logService.trace(k):void 0,logError:k=>this.logService.error(k)}}doInit(k){return k.init()}get items(){return this._storage.items}get(k,d){return this._storage.get(k,d)}set(k,d){return this._storage.set(k,d)}delete(k){return this._storage.delete(k)}async close(){this.initializePromise&&await this.initializePromise,await this._storage.close(),this._onDidCloseStorage.fire()}}class h extends t{constructor(k,d,u){super(d);this.options=k,this.environmentService=u}async doCreate(){let k;return this.options.useInMemoryStorage?k=I.SQLiteStorageDatabase.IN_MEMORY_PATH:k=(0,D.join)(this.environmentService.globalStorageHome.fsPath,h.STORAGE_NAME),new m.Storage(new I.SQLiteStorageDatabase(k,{logging:this.createLoggingOptions()}))}async doInit(k){await super.doInit(k),this.updateTelemetryState(k)}updateTelemetryState(k){k.get(b.firstSessionDateStorageKey,void 0)===void 0&&k.set(b.firstSessionDateStorageKey,new Date().toUTCString());const u=k.get(b.currentSessionDateStorageKey,void 0),c=new Date().toUTCString();k.set(b.lastSessionDateStorageKey,typeof u=="undefined"?null:u),k.set(b.currentSessionDateStorageKey,c)}async close(){(0,M.logCi)(this.logService,"GlobalStorageMain#close() - begin");try{await super.close()}finally{(0,M.logCi)(this.logService,"GlobalStorageMain#close() - end")}}}e.GlobalStorageMain=h,h.STORAGE_NAME="state.vscdb";class g extends t{constructor(k,d,u,c){super(u);this.workspace=k,this.options=d,this.environmentService=c}async doCreate(){const{storageFilePath:k,wasCreated:d}=await this.prepareWorkspaceStorageFolder();return new m.Storage(new I.SQLiteStorageDatabase(k,{logging:this.createLoggingOptions()}),{hint:d?m.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:I.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const k=(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),d=(0,D.join)(k,g.WORKSPACE_STORAGE_NAME);return await S.Promises.exists(k)?{storageFilePath:d,wasCreated:!1}:(await S.Promises.mkdir(k,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(k),{storageFilePath:d,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(k){let d;if((0,p.isSingleFolderWorkspaceIdentifier)(this.workspace)?d={folder:this.workspace.uri.toString()}:(0,p.isWorkspaceIdentifier)(this.workspace)&&(d={workspace:this.workspace.configPath.toString()}),d)try{const u=(0,D.join)(k,g.WORKSPACE_META_NAME);await S.Promises.exists(u)||await S.Promises.writeFile(u,JSON.stringify(d,void 0,2))}catch(u){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${u}`)}}async close(){(0,M.logCi)(this.logService,"WorkspaceStorageMain#close() - begin");try{await super.close()}finally{(0,M.logCi)(this.logService,"WorkspaceStorageMain#close() - end")}}}e.WorkspaceStorageMain=g,g.WORKSPACE_STORAGE_NAME="state.vscdb",g.WORKSPACE_META_NAME="workspace.json"}),define(Z[102],x([0,1,17,8,25]),function(V,e,w,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function D(m,I,M){for(const b of m){const p=b.openedWorkspace;if((0,L.isWorkspaceIdentifier)(p)){const t=M(p);if(t){if(t.folders.some(h=>w.extUriBiasedIgnorePathCase.isEqualOrParent(I,h.uri)))return b}else if(w.extUriBiasedIgnorePathCase.isEqualOrParent(I,p.configPath))return b}}const E=m.filter(b=>(0,L.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqualOrParent(I,b.openedWorkspace.uri));if(E.length)return E.sort((b,p)=>-(b.openedWorkspace.uri.path.length-p.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=D;function P(m,I){for(const M of m)if((0,L.isWorkspaceIdentifier)(M.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(M.openedWorkspace.configPath,I)||(0,L.isSingleFolderWorkspaceIdentifier)(M.openedWorkspace)&&w.extUriBiasedIgnorePathCase.isEqual(M.openedWorkspace.uri,I))return M}e.findWindowOnWorkspaceOrFolder=P;function S(m,I){const M=E=>I.some(b=>w.extUriBiasedIgnorePathCase.isEqual(n.URI.file(b),n.URI.file(E)));for(const E of m)if(E.config?.extensionDevelopmentPath?.some(b=>M(b)))return E}e.findWindowOnExtensionDevelopmentPath=S}),define(Z[226],x([0,1,12,3,2,17,8,19,18,6,38,34,101,25]),function(V,e,w,n,L,D,P,S,m,I,M,E,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let t=class Et extends n.Disposable{constructor(u,c,a,f,s){super();this.windowsMainService=u,this.stateMainService=c,this.lifecycleMainService=a,this.logService=f,this.configurationService=s,this._state=h(this.stateMainService.getItem(Et.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){w.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(u=>this.onBeforeCloseWindow(u)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(u=>this.onBeforeCloseWindow(u))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const u={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!u.lastActiveWindow){let f=this.windowsMainService.getLastActiveWindow();(!f||f.isExtensionDevelopmentHost)&&(f=this.windowsMainService.getWindows().find(s=>!s.isExtensionDevelopmentHost)),f&&(u.lastActiveWindow=this.toWindowState(f))}const c=this.windowsMainService.getWindows().find(f=>f.isExtensionDevelopmentHost&&!f.isExtensionTestHost);c&&(u.lastPluginDevelopmentHostWindow=this.toWindowState(c)),this.windowsMainService.getWindowCount()>1&&(u.openedWindows=this.windowsMainService.getWindows().filter(f=>!f.isExtensionDevelopmentHost).map(f=>this.toWindowState(f)));const a=y(u);this.stateMainService.setItem(Et.windowsStateStorageKey,a),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",a)}onBeforeCloseWindow(u){if(this.lifecycleMainService.quitRequested)return;const c=this.toWindowState(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=c:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this._state.openedWindows.forEach(a=>{const f=(0,p.isWorkspaceIdentifier)(u.openedWorkspace)&&a.workspace?.id===u.openedWorkspace.id,s=(0,p.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)&&a.folderUri&&D.extUriBiasedIgnorePathCase.isEqual(a.folderUri,u.openedWorkspace.uri);(f||s)&&(a.uiState=c.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=c)}toWindowState(u){return{workspace:(0,p.isWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:(0,p.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const c=this.doGetNewWindowState(u),a=this.configurationService.getValue("window");let f;return c.hasDefaultState?f=!!(a?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(a.newWindowDimensions)>=0):(f=!!(this.lifecycleMainService.wasRestarted||a?.restoreFullscreen),f&&L.isMacintosh&&this.windowsMainService.getWindows().some(s=>s.isFullScreen)&&(f=!1)),c.mode===3&&!f&&(c.mode=1),c}doGetNewWindowState(u){const c=this.windowsMainService.getLastActiveWindow();if(!u.extensionTestsPath){if(!!u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const o=u.workspace;if((0,p.isWorkspaceIdentifier)(o)){const v=this.state.openedWindows.filter(C=>C.workspace&&C.workspace.id===o.id).map(C=>C.uiState);if(v.length)return v[0]}if((0,p.isSingleFolderWorkspaceIdentifier)(o)){const v=this.state.openedWindows.filter(C=>C.folderUri&&D.extUriBiasedIgnorePathCase.isEqual(C.folderUri,o.uri)).map(C=>C.uiState);if(v.length)return v[0]}else if(u.backupPath){const v=this.state.openedWindows.filter(C=>C.backupPath===u.backupPath).map(C=>C.uiState);if(v.length)return v[0]}const l=this.lastClosedState||this.state.lastActiveWindow;if(!c&&l)return l.uiState}let a;const f=w.screen.getAllDisplays();if(f.length===1)a=f[0];else{if(L.isMacintosh){const o=w.screen.getCursorScreenPoint();a=w.screen.getDisplayNearestPoint(o)}!a&&c&&(a=w.screen.getDisplayMatching(c.getBounds())),a||(a=w.screen.getPrimaryDisplay()||f[0])}let s=(0,b.defaultWindowState)();s.x=Math.round(a.bounds.x+a.bounds.width/2-s.width/2),s.y=Math.round(a.bounds.y+a.bounds.height/2-s.height/2);const i=this.configurationService.getValue("window");let r=!0;if(i?.newWindowDimensions){if(i.newWindowDimensions==="maximized")s.mode=0,r=!1;else if(i.newWindowDimensions==="fullscreen")s.mode=3,r=!1;else if((i.newWindowDimensions==="inherit"||i.newWindowDimensions==="offset")&&c){const o=c.serializeWindowState();o.mode===3?s.mode=3:s=o,r=s.mode!==3&&i.newWindowDimensions==="offset"}}return r&&(s=this.ensureNoOverlap(s)),s.hasDefaultState=!0,s}ensureNoOverlap(u){if(this.windowsMainService.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const c=this.windowsMainService.getWindows().map(a=>a.getBounds());for(;c.some(a=>a.x===u.x||a.y===u.y);)u.x+=30,u.y+=30;return u}};t.windowsStateStorageKey="windowsState",t=ue([te(0,E.IWindowsMainService),te(1,M.IStateMainService),te(2,m.ILifecycleMainService),te(3,I.ILogService),te(4,S.IConfigurationService)],t),e.WindowsStateHandler=t;function h(d){const u={openedWindows:[]},c=d||{openedWindows:[]};return c.lastActiveWindow&&(u.lastActiveWindow=g(c.lastActiveWindow)),c.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=g(c.lastPluginDevelopmentHostWindow)),Array.isArray(c.openedWindows)&&(u.openedWindows=c.openedWindows.map(a=>g(a))),u}e.restoreWindowsState=h;function g(d){const u={uiState:d.uiState};return d.backupPath&&(u.backupPath=d.backupPath),d.remoteAuthority&&(u.remoteAuthority=d.remoteAuthority),d.folder&&(u.folderUri=P.URI.parse(d.folder)),d.workspaceIdentifier&&(u.workspace={id:d.workspaceIdentifier.id,configPath:P.URI.parse(d.workspaceIdentifier.configURIPath)}),u}function y(d){return{lastActiveWindow:d.lastActiveWindow&&k(d.lastActiveWindow),lastPluginDevelopmentHostWindow:d.lastPluginDevelopmentHostWindow&&k(d.lastPluginDevelopmentHostWindow),openedWindows:d.openedWindows.map(u=>k(u))}}e.getWindowsStateStoreData=y;function k(d){return{workspaceIdentifier:d.workspace&&{id:d.workspace.id,configURIPath:d.workspace.configPath.toString()},folder:d.folderUri&&d.folderUri.toString(),backupPath:d.backupPath,remoteAuthority:d.remoteAuthority,uiState:d.uiState}}}),define(Z[80],x([0,1,28,44,109,33,10,7,2,17,8,5,78,25]),function(V,e,w,n,L,D,P,S,m,I,M,E,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,E.createDecorator)("workspacesService");function t(C){return C.hasOwnProperty("workspace")}e.isRecentWorkspace=t;function h(C){return C.hasOwnProperty("folderUri")}e.isRecentFolder=h;function g(C){return C.hasOwnProperty("fileUri")}e.isRecentFile=g;function y(C){return k(C)||d(C)}e.isStoredWorkspaceFolder=y;function k(C){const R=C;return typeof R?.path=="string"&&(!R.name||typeof R.name=="string")}function d(C){const R=C;return typeof R?.uri=="string"&&(!R.name||typeof R.name=="string")}function u(C,R,W,U,G=!m.isWindows,ee){if(C.scheme!==U.scheme)return{name:W,uri:C.toString(!0)};let X=R?void 0:ee.relativePath(U,C);if(X!==void 0)X.length===0?X=".":m.isWindows&&C.scheme===P.Schemas.file&&!G&&(X=X.replace(/\//g,"\\"));else if(C.scheme===P.Schemas.file)X=C.fsPath,m.isWindows&&(X=(0,D.normalizeDriveLetter)(X),G&&(X=(0,w.toSlashes)(X)));else{if(!ee.isEqualAuthority(C.authority,U.authority))return{name:W,uri:C.toString(!0)};X=C.path}return{name:W,path:X}}e.getStoredWorkspaceFolder=u;function c(C,R,W){let U=[],G=new Set;const ee=W.dirname(R);for(let X of C){let J;if(k(X))X.path&&(J=W.resolvePath(ee,X.path));else if(d(X))try{J=M.URI.parse(X.uri),J.path[0]!=="/"&&(J=J.with({path:"/"+J.path}))}catch(H){console.warn(H)}if(J){let H=W.getComparisonKey(J);if(!G.has(H)){G.add(H);const B=X.name||W.basenameOrAuthority(J);U.push(new p.WorkspaceFolder({uri:J,name:B,index:U.length},X))}}}return U}e.toWorkspaceFolders=c;function a(C,R,W,U,G){let ee=f(R,C);const X=G.dirname(R),J=G.dirname(U),H=[],B=s(ee.folders);for(const q of ee.folders){const Q=k(q)?G.resolvePath(X,q.path):M.URI.parse(q.uri);let z;W?z=!1:z=!k(q)||(0,S.isAbsolute)(q.path),H.push(u(Q,z,q.name,J,B,G))}const Y={insertSpaces:!1,tabSize:4,eol:m.isLinux||m.isMacintosh?`
`:`\r
`},se=L.setProperty(C,["folders"],H,Y);let $=L.applyEdits(C,se);return(0,I.isEqualAuthority)(ee.remoteAuthority,(0,b.getRemoteAuthority)(U))&&($=L.applyEdits($,L.removeProperty($,["remoteAuthority"],Y))),$}e.rewriteWorkspaceFileForNewLocation=a;function f(C,R){let W=n.parse(R);if(W&&Array.isArray(W.folders))W.folders=W.folders.filter(U=>y(U));else throw new Error(`${C} looks like an invalid workspace file.`);return W}function s(C){return m.isWindows?C.some(R=>k(R)&&R.path.indexOf("/")>=0):!0}e.useSlashForPath=s;function i(C){return C.workspace&&typeof C.workspace=="object"&&typeof C.workspace.id=="string"&&typeof C.workspace.configPath=="string"}function r(C){return typeof C.folderUri=="string"}function o(C){return typeof C.fileUri=="string"}function l(C,R){const W={workspaces:[],files:[]};if(C){const U=function(ee,X){for(let J=0;J<ee.length;J++)try{X(ee[J],J)}catch(H){R.warn(`Error restoring recent entry ${JSON.stringify(ee[J])}: ${H.toString()}. Skip entry.`)}},G=C;if(Array.isArray(G.entries))U(G.entries,ee=>{const X=ee.label,J=ee.remoteAuthority;i(ee)?W.workspaces.push({label:X,remoteAuthority:J,workspace:{id:ee.workspace.id,configPath:M.URI.parse(ee.workspace.configPath)}}):r(ee)?W.workspaces.push({label:X,remoteAuthority:J,folderUri:M.URI.parse(ee.folderUri)}):o(ee)&&W.files.push({label:X,remoteAuthority:J,fileUri:M.URI.parse(ee.fileUri)})});else{const ee=C;Array.isArray(ee.workspaces3)&&U(ee.workspaces3,(X,J)=>{const H=Array.isArray(ee.workspaceLabels)&&ee.workspaceLabels[J]||void 0;typeof X=="object"&&typeof X.id=="string"&&typeof X.configURIPath=="string"?W.workspaces.push({label:H,workspace:{id:X.id,configPath:M.URI.parse(X.configURIPath)}}):typeof X=="string"&&W.workspaces.push({label:H,folderUri:M.URI.parse(X)})}),Array.isArray(ee.files2)&&U(ee.files2,(X,J)=>{const H=Array.isArray(ee.fileLabels)&&ee.fileLabels[J]||void 0;typeof X=="string"&&W.files.push({label:H,fileUri:M.URI.parse(X)})})}}return W}e.restoreRecentlyOpened=l;function v(C){const R={entries:[]};for(const W of C.workspaces)h(W)?R.entries.push({folderUri:W.folderUri.toString(),label:W.label,remoteAuthority:W.remoteAuthority}):R.entries.push({workspace:{id:W.workspace.id,configPath:W.workspace.configPath.toString()},label:W.label,remoteAuthority:W.remoteAuthority});for(const W of C.files)R.entries.push({fileUri:W.fileUri.toString(),label:W.label,remoteAuthority:W.remoteAuthority});return R}e.toStoreData=v}),define(Z[103],x([0,1,60,29,10,2,17]),function(V,e,w,n,L,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function S(I){function M(){let E=I.scheme===L.Schemas.file?(0,P.originalFSPath)(I):I.toString();return D.isLinux||(E=E.toLowerCase()),(0,w.createHash)("md5").update(E).digest("hex")}return{id:M(),configPath:I}}e.getWorkspaceIdentifier=S;function m(I,M){function E(){if(I.scheme!==L.Schemas.file)return(0,w.createHash)("md5").update(I.toString()).digest("hex");if(!M)try{M=(0,n.statSync)(I.fsPath)}catch{return}let p;return D.isLinux?p=M.ino:D.isMacintosh?p=M.birthtime.getTime():D.isWindows&&(typeof M.birthtimeMs=="number"?p=Math.floor(M.birthtimeMs):p=M.birthtime.getTime()),(0,w.createHash)("md5").update(I.fsPath).update(p?String(p):"").digest("hex")}const b=E();if(typeof b=="string")return{id:b,uri:I}}e.getSingleFolderWorkspaceIdentifier=m}),define(Z[227],x([0,1,15,4,10,6,254,118,18,85]),function(V,e,w,n,L,D,P,S,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerMainProcessExtensionHostStarter=void 0;class M{constructor(t,h){this._worker=new P.Worker(L.FileAccess.asFileUri("vs/platform/extensions/node/extensionHostStarterWorkerMain.js",V).fsPath),this._worker.on("message",t),this._worker.on("error",h),this.onError=n.Event.fromNodeEventEmitter(this._worker,"error"),this.onExit=n.Event.fromNodeEventEmitter(this._worker,"exit"),this.onMessageError=n.Event.fromNodeEventEmitter(this._worker,"messageerror")}getId(){return 1}postMessage(t,h){this._worker.postMessage(t,h)}dispose(){this._worker.terminate()}}let E=class{constructor(t){this._logService=t}async logInfo(t){this._logService.info(t)}};E=ue([te(0,D.ILogService)],E);let b=class{constructor(t,h){this._logService=t,this._shutdown=!1,this._proxy=null;const g={create:(y,k,d)=>{const u=new M(k,d);return u.onError(c=>{this._logService.error("ExtensionHostStarterWorker has encountered an error:"),this._logService.error(c)}),u.onMessageError(c=>{this._logService.error("ExtensionHostStarterWorker has encountered a message error:"),this._logService.error(c)}),u.onExit(c=>this._logService.info(`ExtensionHostStarterWorker exited with code ${c}.`)),u.postMessage(y,[]),u}};this._worker=new S.SimpleWorkerClient(g,"vs/platform/extensions/node/extensionHostStarterWorker",new E(this._logService)),this._initialize(),h.onWillShutdown(y=>{this._shutdown=!0,this._proxy&&y.join(this._proxy.waitForAllExit(6e3))})}dispose(){}async _initialize(){this._proxy=await this._worker.getProxyObject(),this._logService.info("ExtensionHostStarterWorker created")}onDynamicStdout(t){return this._proxy.onDynamicStdout(t)}onDynamicStderr(t){return this._proxy.onDynamicStderr(t)}onDynamicMessage(t){return this._proxy.onDynamicMessage(t)}onDynamicError(t){return this._proxy.onDynamicError(t)}onDynamicExit(t){return this._proxy.onDynamicExit(t)}async createExtensionHost(){const t=await this._worker.getProxyObject();if(this._shutdown)throw(0,w.canceled)();return t.createExtensionHost()}async start(t,h){const g=I.StopWatch.create(!1),y=await this._worker.getProxyObject();if(this._shutdown)throw(0,w.canceled)();const k=setTimeout(()=>{this._logService.info("ExtensionHostStarterWorker.start() did not return within 30s. This might be a problem.")},3e4),d=await y.start(t,h),u=g.elapsed();return this._logService.info(`ExtensionHostStarterWorker.start() took ${u} ms.`),clearTimeout(k),d}async enableInspectPort(t){const h=await this._worker.getProxyObject();if(this._shutdown)throw(0,w.canceled)();return h.enableInspectPort(t)}async kill(t){const h=await this._worker.getProxyObject();if(this._shutdown)throw(0,w.canceled)();return h.kill(t)}};b=ue([te(0,D.ILogService),te(1,m.ILifecycleMainService)],b),e.WorkerMainProcessExtensionHostStarter=b}),define(Z[57],x([0,1,60,61,26,16,15,4,3,7,2,31,37,88,228]),function(V,e,w,n,L,D,P,S,m,I,M,E,b,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class h{constructor(R,W=""){this.debugLabel=W,this.socket=R,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=U=>{if(this.traceSocketEvent("error",{code:U?.code,message:U?.message}),U){if(U.code==="EPIPE")return;(0,P.onUnexpectedError)(U)}},this.socket.on("error",this._errorListener)}traceSocketEvent(R,W){p.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,R,W)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(R){const W=U=>{this.traceSocketEvent("read",U),R(D.VSBuffer.wrap(U))};return this.socket.on("data",W),{dispose:()=>this.socket.off("data",W)}}onClose(R){const W=U=>{this.traceSocketEvent("close",{hadError:U}),R({type:0,hadError:U,error:void 0})};return this.socket.on("close",W),{dispose:()=>this.socket.off("close",W)}}onEnd(R){const W=()=>{this.traceSocketEvent("nodeEndReceived"),R()};return this.socket.on("end",W),{dispose:()=>this.socket.off("end",W)}}write(R){if(!this.socket.destroyed)try{this.traceSocketEvent("write",R),this.socket.write(R.buffer,W=>{if(W){if(W.code==="EPIPE")return;(0,P.onUnexpectedError)(W)}})}catch(W){if(W.code==="EPIPE")return;(0,P.onUnexpectedError)(W)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((R,W)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),R();return}const U=()=>{this.socket.off("close",U),this.socket.off("end",U),this.socket.off("error",U),this.socket.off("timeout",U),this.socket.off("drain",U),this.traceSocketEvent("nodeDrainEnd"),R()};this.socket.on("close",U),this.socket.on("end",U),this.socket.on("error",U),this.socket.on("timeout",U),this.socket.on("drain",U)})}}e.NodeSocket=h;var g;(function(C){C[C.MinHeaderByteSize=2]="MinHeaderByteSize"})(g||(g={}));var y;(function(C){C[C.PeekHeader=1]="PeekHeader",C[C.ReadHeader=2]="ReadHeader",C[C.ReadBody=3]="ReadBody",C[C.Fin=4]="Fin"})(y||(y={}));class k extends m.Disposable{constructor(R,W,U,G){super();this._onData=this._register(new S.Emitter),this._onClose=this._register(new S.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=R,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:W,inflateBytesLength:U?.byteLength||0,recordInflateBytes:G}),this._flowManager=this._register(new d(this,W,U,G,this._onData,(ee,X)=>this._write(ee,X))),this._register(this._flowManager.onError(ee=>{console.error(ee),(0,P.onUnexpectedError)(ee),this._onClose.fire({type:0,hadError:!0,error:ee})})),this._incomingData=new p.ChunkStream,this._register(this.socket.onData(ee=>this._acceptChunk(ee))),this._register(this.socket.onClose(ee=>this._onClose.fire(ee)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(R,W){this.socket.traceSocketEvent(R,W)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(R){return this._onData.event(R)}onClose(R){return this._onClose.event(R)}onEnd(R){return this.socket.onEnd(R)}write(R){this._flowManager.writeMessage(R)}_write(R,W){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",R);let U=2;R.byteLength<126?U+=0:R.byteLength<2**16?U+=2:U+=8;const G=D.VSBuffer.alloc(U);if(W?G.writeUInt8(194,0):G.writeUInt8(130,0),R.byteLength<126)G.writeUInt8(R.byteLength,1);else if(R.byteLength<2**16){G.writeUInt8(126,1);let ee=1;G.writeUInt8(R.byteLength>>>8&255,++ee),G.writeUInt8(R.byteLength>>>0&255,++ee)}else{G.writeUInt8(127,1);let ee=1;G.writeUInt8(0,++ee),G.writeUInt8(0,++ee),G.writeUInt8(0,++ee),G.writeUInt8(0,++ee),G.writeUInt8(R.byteLength>>>24&255,++ee),G.writeUInt8(R.byteLength>>>16&255,++ee),G.writeUInt8(R.byteLength>>>8&255,++ee),G.writeUInt8(R.byteLength>>>0&255,++ee)}this.socket.write(D.VSBuffer.concat([G,R]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(R){if(R.byteLength!==0){for(this._incomingData.acceptChunk(R);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const W=this._incomingData.peek(this._state.readLen),U=W.readUInt8(0),G=(U&128)>>>7,ee=(U&64)>>>6,X=W.readUInt8(1),J=(X&128)>>>7,H=X&127;this._state.state=2,this._state.readLen=2+(J?4:0)+(H===126?2:0)+(H===127?8:0),this._state.fin=G,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(ee)),this._state.firstFrameOfMessage=Boolean(G),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const W=this._incomingData.read(this._state.readLen),U=W.readUInt8(1),G=(U&128)>>>7;let ee=U&127,X=1;ee===126?ee=W.readUInt8(++X)*2**8+W.readUInt8(++X):ee===127&&(ee=W.readUInt8(++X)*0+W.readUInt8(++X)*0+W.readUInt8(++X)*0+W.readUInt8(++X)*0+W.readUInt8(++X)*2**24+W.readUInt8(++X)*2**16+W.readUInt8(++X)*2**8+W.readUInt8(++X));let J=0;G&&(J=W.readUInt8(++X)*2**24+W.readUInt8(++X)*2**16+W.readUInt8(++X)*2**8+W.readUInt8(++X)),this._state.state=3,this._state.readLen=ee,this._state.mask=J,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const W=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",W),a(W,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",W),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(W,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await S.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=k;class d extends m.Disposable{constructor(R,W,U,G,ee,X){super();this._tracer=R,this._onData=ee,this._writeFn=X,this._onError=this._register(new S.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new S.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,W?(this._zlibInflateStream=this._register(new u(this._tracer,G,U,{windowBits:15})),this._zlibDeflateStream=this._register(new c(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(J=>this._onError.fire(J))),this._register(this._zlibDeflateStream.onError(J=>this._onError.fire(J)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:D.VSBuffer.alloc(0)}writeMessage(R){this._writeQueue.push(R),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const R=this._writeQueue.shift();if(this._zlibDeflateStream){const W=await this._deflateMessage(this._zlibDeflateStream,R);this._writeFn(W,!0)}else this._writeFn(R,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(R,W){return new Promise((U,G)=>{R.write(W),R.flush(ee=>U(ee))})}acceptFrame(R,W,U){this._readQueue.push({data:R,isCompressed:W,isLastFrameOfMessage:U}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const R=this._readQueue.shift();if(this._zlibInflateStream&&R.isCompressed){const W=await this._inflateFrame(this._zlibInflateStream,R.data,R.isLastFrameOfMessage);this._onData.fire(W)}else this._onData.fire(R.data)}this._isProcessingReadQueue=!1}}_inflateFrame(R,W,U){return new Promise((G,ee)=>{R.write(W),U&&R.write(D.VSBuffer.fromByteArray([0,0,255,255])),R.flush(X=>G(X))})}}class u extends m.Disposable{constructor(R,W,U,G){super();this._tracer=R,this._recordInflateBytes=W,this._onError=this._register(new S.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=t.createInflateRaw(G),this._zlibInflate.on("error",ee=>{this._tracer.traceSocketEvent("zlibInflateError",{message:ee?.message,code:ee?.code}),this._onError.fire(ee)}),this._zlibInflate.on("data",ee=>{this._tracer.traceSocketEvent("zlibInflateData",ee),this._pendingInflateData.push(D.VSBuffer.wrap(ee))}),U&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",U.buffer),this._zlibInflate.write(U.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?D.VSBuffer.concat(this._recordedInflateBytes):D.VSBuffer.alloc(0)}write(R){this._recordInflateBytes&&this._recordedInflateBytes.push(R.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",R),this._zlibInflate.write(R.buffer)}flush(R){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const W=D.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,R(W)})}}class c extends m.Disposable{constructor(R,W){super();this._tracer=R,this._onError=this._register(new S.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=t.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",U=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:U?.message,code:U?.code}),this._onError.fire(U)}),this._zlibDeflate.on("data",U=>{this._tracer.traceSocketEvent("zlibDeflateData",U),this._pendingDeflateData.push(D.VSBuffer.wrap(U))})}write(R){this._tracer.traceSocketEvent("zlibDeflateWrite",R.buffer),this._zlibDeflate.write(R.buffer)}flush(R){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let W=D.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,W=W.slice(0,W.byteLength-4),R(W)})}}function a(C,R){if(R===0)return;let W=C.byteLength>>>2;for(let H=0;H<W;H++){const B=C.readUInt32BE(H*4);C.writeUInt32BE(B^R,H*4)}let U=W*4,G=C.byteLength-U;const ee=R>>>24&255,X=R>>>16&255,J=R>>>8&255;G>=1&&C.writeUInt8(C.readUInt8(U)^ee,U),G>=2&&C.writeUInt8(C.readUInt8(U+1)^X,U+1),G>=3&&C.writeUInt8(C.readUInt8(U+2)^J,U+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const f={[2]:107,[1]:103};function s(){const C=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${C}-sock`;let R;return e.XDG_RUNTIME_DIR?R=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${C}.sock`):R=(0,I.join)((0,L.tmpdir)(),`vscode-ipc-${C}.sock`),r(R),R}e.createRandomIPCHandle=s;function i(C,R,W){const U=(0,w.createHash)("md5").update(C).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${U}-${W}-${R}-sock`;let G;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?G=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-${U.substr(0,8)}-${W}-${R}.sock`):G=(0,I.join)(C,`${W}-${R}.sock`),r(G),G}e.createStaticIPCHandle=i;function r(C){const R=f[M.platform];typeof R=="number"&&C.length>=R&&console.warn(`WARNING: IPC handle "${C}" is longer than ${R} chars, try a shorter --user-data-dir`)}class o extends b.IPCServer{constructor(R){super(o.toClientConnectionEvent(R));this.server=R}static toClientConnectionEvent(R){const W=S.Event.fromNodeEventEmitter(R,"connection");return S.Event.map(W,U=>({protocol:new p.Protocol(new h(U,"ipc-server-connection")),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(U,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function l(C){return new Promise((R,W)=>{const U=(0,n.createServer)();U.on("error",W),U.listen(C,()=>{U.removeListener("error",W),R(new o(U))})})}e.serve=l;function v(C,R){return new Promise((W,U)=>{const G=(0,n.createConnection)(C,()=>{G.removeListener("error",U),W(p.Client.fromSocket(new h(G,`ipc-client${R}`),R))});G.once("error",U)})}e.connect=v}),define(Z[229],x([0,1,57]),function(V,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class n{constructor(m){this.driver=m}listen(m,I){throw new Error("No event found")}call(m,I,M){switch(I){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(M);case"startTracing":return this.driver.startTracing(M[0],M[1]);case"stopTracing":return this.driver.stopTracing(M[0],M[1],M[2]);case"reloadWindow":return this.driver.reloadWindow(M);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(M[0],M[1]);case"click":return this.driver.click(M[0],M[1],M[2],M[3]);case"doubleClick":return this.driver.doubleClick(M[0],M[1]);case"setValue":return this.driver.setValue(M[0],M[1],M[2]);case"getTitle":return this.driver.getTitle(M[0]);case"isActiveElement":return this.driver.isActiveElement(M[0],M[1]);case"getElements":return this.driver.getElements(M[0],M[1],M[2]);case"getElementXY":return this.driver.getElementXY(M[0],M[1],M[2]);case"typeInEditor":return this.driver.typeInEditor(M[0],M[1],M[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(M[0],M[1]);case"writeInTerminal":return this.driver.writeInTerminal(M[0],M[1],M[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(M);case"getLocalizedStrings":return this.driver.getLocalizedStrings(M)}throw new Error(`Call not found: ${I}`)}}e.DriverChannel=n;class L{constructor(m){this.channel=m}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(m){return this.channel.call("capturePage",m)}startTracing(m,I){return this.channel.call("startTracing",[m,I])}stopTracing(m,I,M){return this.channel.call("stopTracing",[m,I,M])}reloadWindow(m){return this.channel.call("reloadWindow",m)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(m,I){return this.channel.call("dispatchKeybinding",[m,I])}click(m,I,M,E){return this.channel.call("click",[m,I,M,E])}doubleClick(m,I){return this.channel.call("doubleClick",[m,I])}setValue(m,I,M){return this.channel.call("setValue",[m,I,M])}getTitle(m){return this.channel.call("getTitle",[m])}isActiveElement(m,I){return this.channel.call("isActiveElement",[m,I])}getElements(m,I,M){return this.channel.call("getElements",[m,I,M])}getElementXY(m,I,M,E){return this.channel.call("getElementXY",[m,I,M,E])}typeInEditor(m,I,M){return this.channel.call("typeInEditor",[m,I,M])}getTerminalBuffer(m,I){return this.channel.call("getTerminalBuffer",[m,I])}writeInTerminal(m,I,M){return this.channel.call("writeInTerminal",[m,I,M])}getLocaleInfo(m){return this.channel.call("getLocaleInfo",m)}getLocalizedStrings(m){return this.channel.call("getLocalizedStrings",m)}}e.DriverChannelClient=L;class D{constructor(m){this.registry=m}listen(m,I){throw new Error(`Event not found: ${I}`)}call(m,I,M){switch(I){case"registerWindowDriver":return this.registry.registerWindowDriver(M);case"reloadWindowDriver":return this.registry.reloadWindowDriver(M)}throw new Error(`Call not found: ${I}`)}}e.WindowDriverRegistryChannel=D;async function P(S){const m=await(0,w.connect)(S,"driverClient"),I=m.getChannel("driver"),M=new L(I);return{client:m,driver:M}}e.connect=P}),define(Z[22],x([0,1,46,7,57,52,170,5]),function(V,e,w,n,L,D,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,S.refineServiceDecorator)(D.IEnvironmentService);class m extends P.NativeEnvironmentService{get cachedLanguagesPath(){return(0,n.join)(this.userDataPath,"clp")}get backupHome(){return(0,n.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,n.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,L.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,n.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ue([w.memoize],m.prototype,"cachedLanguagesPath",null),ue([w.memoize],m.prototype,"backupHome",null),ue([w.memoize],m.prototype,"backupWorkspacesPath",null),ue([w.memoize],m.prototype,"mainIPCHandle",null),ue([w.memoize],m.prototype,"mainLockfile",null),ue([w.memoize],m.prototype,"sandbox",null),ue([w.memoize],m.prototype,"driverVerbose",null),ue([w.memoize],m.prototype,"disableUpdates",null),ue([w.memoize],m.prototype,"disableKeytar",null),ue([w.memoize],m.prototype,"codeCachePath",null),ue([w.memoize],m.prototype,"useCodeCache",null),e.EnvironmentMainService=m}),define(Z[230],x([0,1,60,29,28,10,7,2,17,8,24,163,19,22,20,6,162,25]),function(V,e,w,n,L,D,P,S,m,I,M,E,b,p,t,h,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let k=class{constructor(u,c,a){this.configurationService=c,this.logService=a,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=m.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(f,s)=>(0,L.isEqual)(f,s,!S.isLinux)},this.backupHome=u.backupHome,this.workspacesJsonPath=u.backupWorkspacesPath}async initialize(){let u;try{u=JSON.parse(await M.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch{u=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(u.emptyWorkspaceInfos);let c=[];try{Array.isArray(u.rootURIWorkspaces)&&(c=u.rootURIWorkspaces.map(f=>({workspace:{id:f.id,configPath:I.URI.parse(f.configURIPath)},remoteAuthority:f.remoteAuthority})))}catch{}this.workspaces=await this.validateWorkspaces(c);let a=[];try{Array.isArray(u.folderWorkspaceInfos)?a=u.folderWorkspaceInfos.map(f=>({folderUri:I.URI.parse(f.folderUri),remoteAuthority:f.remoteAuthority})):Array.isArray(u.folderURIWorkspaces)&&(a=u.folderURIWorkspaces.map(f=>({folderUri:I.URI.parse(f),remoteAuthority:void 0})))}catch{}this.folders=await this.validateFolders(a),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==t.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===t.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||t.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(u,c){this.workspaces.some(f=>u.workspace.id===f.workspace.id)||(this.workspaces.push(u),this.saveSync());const a=this.getBackupPath(u.workspace.id);return c&&this.moveBackupFolderSync(a,c),a}moveBackupFolderSync(u,c){if(n.existsSync(u)&&this.convertToEmptyWindowBackupSync(u),n.existsSync(c))try{n.renameSync(c,u)}catch(a){this.logService.error(`Backup: Could not move backup folder to new location: ${a.toString()}`)}}unregisterWorkspaceBackupSync(u){const c=u.id,a=this.workspaces.findIndex(f=>f.workspace.id===c);a!==-1&&(this.workspaces.splice(a,1),this.saveSync())}registerFolderBackupSync(u){return this.folders.some(c=>this.backupUriComparer.isEqual(u.folderUri,c.folderUri))||(this.folders.push(u),this.saveSync()),this.getBackupPath(this.getFolderHash(u))}unregisterFolderBackupSync(u){const c=this.folders.findIndex(a=>this.backupUriComparer.isEqual(u,a.folderUri));c!==-1&&(this.folders.splice(c,1),this.saveSync())}registerEmptyWindowBackupSync(u,c){const a=u||this.getRandomEmptyWindowId();return this.emptyWindows.some(f=>!!f.backupFolder&&this.backupPathComparer.isEqual(f.backupFolder,a))||(this.emptyWindows.push({backupFolder:a,remoteAuthority:c}),this.saveSync()),this.getBackupPath(a)}unregisterEmptyWindowBackupSync(u){const c=this.emptyWindows.findIndex(a=>!!a.backupFolder&&this.backupPathComparer.isEqual(a.backupFolder,u));c!==-1&&(this.emptyWindows.splice(c,1),this.saveSync())}getBackupPath(u){return(0,P.join)(this.backupHome,u)}async validateWorkspaces(u){if(!Array.isArray(u))return[];const c=new Set,a=[];for(let f of u){const s=f.workspace;if(!(0,y.isWorkspaceIdentifier)(s))return[];if(!c.has(s.id)){c.add(s.id);const i=this.getBackupPath(s.id);await this.doHasBackups(i)?s.configPath.scheme!==D.Schemas.file||await M.Promises.exists(s.configPath.fsPath)?a.push(f):await this.convertToEmptyWindowBackup(i):await this.deleteStaleBackup(i)}}return a}async validateFolders(u){if(!Array.isArray(u))return[];const c=[],a=new Set;for(let f of u){const s=f.folderUri,i=this.backupUriComparer.getComparisonKey(s);if(!a.has(i)){a.add(i);const r=this.getBackupPath(this.getFolderHash(f));await this.doHasBackups(r)?s.scheme!==D.Schemas.file||await M.Promises.exists(s.fsPath)?c.push(f):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return c}async validateEmptyWorkspaces(u){if(!Array.isArray(u))return[];const c=[],a=new Set;for(let f of u){const s=f.backupFolder;if(typeof s!="string")return[];if(!a.has(s)){a.add(s);const i=this.getBackupPath(s);await this.doHasBackups(i)?c.push(f):await this.deleteStaleBackup(i)}}return c}async deleteStaleBackup(u){try{await M.Promises.exists(u)&&await M.Promises.rm(u,M.RimRafMode.MOVE)}catch(c){this.logService.error(`Backup: Could not delete stale backup: ${c.toString()}`)}}async convertToEmptyWindowBackup(u){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(f=>!!f.backupFolder&&this.backupPathComparer.isEqual(f.backupFolder,c));)c=this.getRandomEmptyWindowId();const a=this.getBackupPath(c);try{await M.Promises.rename(u,a)}catch(f){return this.logService.error(`Backup: Could not rename backup folder: ${f.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}convertToEmptyWindowBackupSync(u){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(f=>!!f.backupFolder&&this.backupPathComparer.isEqual(f.backupFolder,c));)c=this.getRandomEmptyWindowId();const a=this.getBackupPath(c);try{n.renameSync(u,a)}catch(f){return this.logService.error(`Backup: Could not rename backup folder: ${f.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}async getDirtyWorkspaces(){const u=[];for(const c of this.workspaces)await this.hasBackups(c)&&u.push(c);for(const c of this.folders)await this.hasBackups(c)&&u.push(c);return u}hasBackups(u){let c;return(0,E.isEmptyWindowBackupInfo)(u)?c=u.backupFolder:(0,g.isFolderBackupInfo)(u)?c=this.getBackupPath(this.getFolderHash(u)):c=this.getBackupPath(u.workspace.id),this.doHasBackups(c)}async doHasBackups(u){try{const c=await M.Promises.readdir(u);for(const a of c)try{if((await M.Promises.readdir((0,P.join)(u,a))).length>0)return!0}catch{}}catch{}return!1}saveSync(){try{(0,M.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}async save(){try{await M.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(u=>({id:u.workspace.id,configURIPath:u.workspace.configPath.toString(),remoteAuthority:u.remoteAuthority})),folderWorkspaceInfos:this.folders.map(u=>({folderUri:u.folderUri.toString(),remoteAuthority:u.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(u){const c=u.folderUri;let a;return c.scheme===D.Schemas.file?a=S.isLinux?c.fsPath:c.fsPath.toLowerCase():a=c.toString().toLowerCase(),(0,w.createHash)("md5").update(a).digest("hex")}};k=ue([te(0,p.IEnvironmentMainService),te(1,b.IConfigurationService),te(2,h.ILogService)],k),e.BackupMainService=k}),define(Z[231],x([0,1,9,4,110,59,3,2,37,57,165,229,22,185,18,34,20,8,7,16,6]),function(V,e,w,n,L,D,P,S,m,I,M,E,b,p,t,h,g,y,k,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function c(s){return s<21}let a=class{constructor(i,r,o,l,v,C,R){this.windowServer=i,this.options=r,this.windowsMainService=o,this.lifecycleMainService=l,this.fileService=v,this.environmentMainService=C,this.logService=R,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new n.Emitter}async registerWindowDriver(i){return this.logService.info(`[driver] registerWindowDriver(${i})`),this.registeredWindowIds.add(i),this.reloadingWindowIds.delete(i),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(i){this.logService.info(`[driver] reloadWindowDriver(${i})`),this.reloadingWindowIds.add(i)}async getWindowIds(){return this.windowsMainService.getWindows().map(r=>r.id).filter(r=>this.registeredWindowIds.has(r)&&!this.reloadingWindowIds.has(r))}async capturePage(i){const r=this.windowsMainService.getWindowById(i)??this.windowsMainService.getLastActiveWindow();if(!r?.win)throw new Error("Invalid window");return(await r.win.webContents.capturePage()).toPNG().toString("base64")}async startTracing(i,r){}async stopTracing(i,r,o){if(!o)return;const l=await this.capturePage(i),v=Buffer.from(l,"base64");await this.fileService.writeFile(y.URI.file((0,k.join)(this.environmentMainService.logsPath,`${r}.png`)),d.VSBuffer.wrap(v))}async reloadWindow(i){this.logService.info(`[driver] reloadWindow(${i})`),await this.whenUnfrozen(i);const r=this.windowsMainService.getWindowById(i);if(!r)throw new Error("Invalid window");this.reloadingWindowIds.add(i),this.lifecycleMainService.reload(r)}exitApplication(){return this.logService.info("[driver] exitApplication()"),this.lifecycleMainService.quit()}async dispatchKeybinding(i,r){await this.whenUnfrozen(i);const o=L.KeybindingParser.parseUserBinding(r);for(let l of o)await this._dispatchKeybinding(i,l)}async _dispatchKeybinding(i,r){if(r instanceof D.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const o=this.windowsMainService.getWindowById(i);if(!o?.win)throw new Error("Invalid window");const l=o.win.webContents,v=new D.SimpleKeybinding(!1,!1,!1,!1,r.keyCode),R=new p.USLayoutResolvedKeybinding(v.toChord(),S.OS).getElectronAccelerator(),W=[];r.ctrlKey&&W.push("ctrl"),r.metaKey&&W.push("meta"),r.shiftKey&&W.push("shift"),r.altKey&&W.push("alt"),l.sendInputEvent({type:"keyDown",keyCode:R,modifiers:W}),c(r.keyCode)||l.sendInputEvent({type:"char",keyCode:R,modifiers:W}),l.sendInputEvent({type:"keyUp",keyCode:R,modifiers:W}),await(0,w.timeout)(100)}async click(i,r,o,l){await(await this.getWindowDriver(i)).click(r,o,l)}async doubleClick(i,r){await(await this.getWindowDriver(i)).doubleClick(r)}async setValue(i,r,o){await(await this.getWindowDriver(i)).setValue(r,o)}async getTitle(i){return await(await this.getWindowDriver(i)).getTitle()}async isActiveElement(i,r){return await(await this.getWindowDriver(i)).isActiveElement(r)}async getElements(i,r,o){return await(await this.getWindowDriver(i)).getElements(r,o)}async getElementXY(i,r,o,l){return await(await this.getWindowDriver(i)).getElementXY(r,o,l)}async typeInEditor(i,r,o){await(await this.getWindowDriver(i)).typeInEditor(r,o)}async getTerminalBuffer(i,r){return await(await this.getWindowDriver(i)).getTerminalBuffer(r)}async writeInTerminal(i,r,o){await(await this.getWindowDriver(i)).writeInTerminal(r,o)}async getLocaleInfo(i){return await(await this.getWindowDriver(i)).getLocaleInfo()}async getLocalizedStrings(i){return await(await this.getWindowDriver(i)).getLocalizedStrings()}async getWindowDriver(i){await this.whenUnfrozen(i);const r=`window:${i}`,o=new m.StaticRouter(v=>v===r),l=this.windowServer.getChannel("windowDriver",o);return new M.WindowDriverChannelClient(l)}async whenUnfrozen(i){for(;this.reloadingWindowIds.has(i);)await n.Event.toPromise(this.onDidReloadingChange.event)}};a=ue([te(2,h.IWindowsMainService),te(3,t.ILifecycleMainService),te(4,g.IFileService),te(5,b.IEnvironmentMainService),te(6,u.ILogService)],a),e.Driver=a;async function f(s,i,r,o){const l=r.driverVerbose,v=o.createInstance(a,s,{verbose:l}),C=new E.WindowDriverRegistryChannel(v);s.registerChannel("windowDriverRegistry",C);const R=await(0,I.serve)(i),W=new E.DriverChannel(v);return R.registerChannel("driver",W),(0,P.combinedDisposable)(R,s)}e.serve=f}),define(Z[232],x([0,1,61,57]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(L,D,P,S,m){const I=E=>m(E,void 0),M=w.createConnection({host:L,port:D},()=>{M.removeListener("error",I);const E=Buffer.alloc(16);for(let h=0;h<16;h++)E[h]=Math.round(Math.random()*256);const b=E.toString("base64"),p=[`GET ws://${/:/.test(L)?`[${L}]`:L}:${D}/?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${b}`];M.write(p.join(`\r
`)+`\r
\r
`);const t=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(M.off("data",t),m(void 0,new n.NodeSocket(M,S)))};M.on("data",t)});M.setNoDelay(!0),M.once("error",I)}}}),define(Z[233],x([0,1,204,9,16,15,3,14,19,52,98,6,203,228]),function(V,e,w,n,L,D,P,S,m,I,M,E,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let t=class extends P.Disposable{constructor(g,y,k){super();this.environmentService=y,this.logService=k,this.configure(g.getValue()),this._register(g.onDidChangeConfiguration(()=>this.configure(g.getValue()),this))}configure(g){this.proxyUrl=g.http&&g.http.proxy,this.strictSSL=!!(g.http&&g.http.proxyStrictSSL),this.authorization=g.http&&g.http.proxyAuthorization}async request(g,y){this.logService.trace("RequestService#request",g.url);const{proxyUrl:k,strictSSL:d}=this;let u;try{u=await(0,M.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(f){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",f))}const c={...process.env,...u},a=g.agent?g.agent:await(0,b.getProxyAgent)(g.url||"",c,{proxyUrl:k,strictSSL:d});return g.agent=a,g.strictSSL=d,this.authorization&&(g.headers={...g.headers||{},"Proxy-Authorization":this.authorization}),this._request(g,y)}async getNodeRequest(g){return((0,w.parse)(g.url).protocol==="https:"?await new Promise((d,u)=>{V(["https"],d,u)}):await new Promise((d,u)=>{V(["http"],d,u)})).request}_request(g,y){return n.Promises.withAsyncBody(async(k,d)=>{let u;const c=(0,w.parse)(g.url),a=g.getRawRequest?g.getRawRequest(g):await this.getNodeRequest(g),f={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,S.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(f.auth=g.user+":"+g.password),u=a(f,s=>{const i=(0,S.isNumber)(g.followRedirects)?g.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&i>0&&s.headers.location)this._request({...g,url:s.headers.location,followRedirects:i-1},y).then(k,d);else{let r=s;s.headers["content-encoding"]==="gzip"&&(r=s.pipe((0,p.createGunzip)())),k({res:s,stream:(0,L.streamToBufferReadableStream)(r)})}}),u.on("error",d),g.timeout&&u.setTimeout(g.timeout),g.data&&typeof g.data=="string"&&u.write(g.data),u.end(),y.onCancellationRequested(()=>{u.abort(),d((0,D.canceled)())})})}async resolveProxy(g){}};t=ue([te(0,m.IConfigurationService),te(1,I.INativeEnvironmentService),te(2,E.ILogService)],t),e.RequestService=t}),define(Z[234],x([0,1,12,233]),function(V,e,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function L(P){return w.net.request}class D extends n.RequestService{request(S,m){return super.request({...S||{},getRawRequest:L},m)}}e.RequestMainService=D}),define(Z[235],x([0,1,12,9,4,3,10,14,89,22,18,6,53,54,65,39]),function(V,e,w,n,L,D,P,S,m,I,M,E,b,p,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let g=class extends D.Disposable{constructor(k,d,u,c,a,f,s){super();this.machineId=k,this.userEnv=d,this.environmentMainService=u,this.lifecycleMainService=c,this.logService=a,this.themeMainService=f,this.protocolMainService=s,this.firstWindowConnectionBarrier=new n.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new L.Emitter),this.onDidError=L.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){w.ipcMain.on("vscode:createSharedProcessMessageChannel",(k,d)=>this.onWindowConnection(k,d)),w.ipcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(k,d)=>this.onWorkerConnection(k,d)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(k,d){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const u=await this.connect();if(k.sender.isDestroyed())return u.close();k.sender.postMessage("vscode:createSharedProcessMessageChannelResult",d,[u])}onWorkerConnection(k,d){this.logService.trace("SharedProcess: onWorkerConnection",d);const u=new D.DisposableStore,c=f=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${f}')`,d),u.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",d))},a=w.BrowserWindow.fromId(d.reply.windowId);if(!a||a.isDestroyed()||a.webContents.isDestroyed()||!d.reply.channel){c("unavailable");return}u.add(L.Event.filter(this.lifecycleMainService.onWillLoadWindow,f=>f.window.win===a)(()=>c("load"))),u.add(L.Event.fromNodeEventEmitter(a,"closed")(()=>c("closed"))),a.webContents.postMessage(d.reply.channel,d.reply.nonce,k.ports)}onWillShutdown(){const k=this.window;!k||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(k.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{k.close()}catch{}this.window=void 0},0))}send(k,...d){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${k}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(k,...d)}catch(u){this.logService.warn(`Error sending IPC message to channel '${k}' of shared process: ${(0,h.toErrorMessage)(u)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(k=>w.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),k()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(k=>w.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),k()}))})()),this._whenIpcReady}createWindow(){const k=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new w.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${k.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1}}),k.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:b.default}),this.window.loadURL(P.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",V).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=k=>{this.logService.trace("SharedProcess#close prevented"),k.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(k,d)=>this._onDidError.fire({type:2,details:d})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(k,d,u)=>this._onDidError.fire({type:3,details:{reason:u,exitCode:d}})))}async connect(){await this.whenIpcReady;const k=(0,S.assertIsDefined)(this.window);return(0,m.connect)(k)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const k=this.window;return k?!k.isDestroyed()&&!k.webContents.isDestroyed():!1}};g=ue([te(2,I.IEnvironmentMainService),te(3,M.ILifecycleMainService),te(4,E.ILogService),te(5,t.IThemeMainService),te(6,p.IProtocolMainService)],g),e.SharedProcess=g}),define(Z[236],x([0,1,9,16,7,14,8,22,20,6]),function(V,e,w,n,L,D,P,S,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class M{constructor(p,t,h){this.storagePath=p,this.logService=t,this.fileService=h,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new w.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(p){p.fileOperationResult!==1&&this.logService.error(p)}}getItem(p,t){const h=this.storage[p];return(0,D.isUndefinedOrNull)(h)?t:h}setItem(p,t){this.setItems([{key:p,data:t}])}setItems(p){let t=!1;for(const{key:h,data:g}of p)this.storage[h]!==g&&((0,D.isUndefinedOrNull)(g)?(0,D.isUndefined)(this.storage[h])||(this.storage[h]=void 0,t=!0):(this.storage[h]=g,t=!0));t&&this.save()}removeItem(p){(0,D.isUndefined)(this.storage[p])||(this.storage[p]=void 0,this.save())}async save(p){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),p)}async doSave(){if(!this.initializing)return;await this.initializing;const p=JSON.stringify(this.storage,null,4);if(p!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,n.VSBuffer.fromString(p)),this.lastSavedStorageContents=p}catch(t){this.logService.error(t)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=M;let E=class Ct{constructor(p,t,h){this.fileStorage=new M(P.URI.file((0,L.join)(p.userDataPath,Ct.STATE_FILE)),t,h)}async init(){return this.fileStorage.init()}getItem(p,t){return this.fileStorage.getItem(p,t)}setItem(p,t){this.fileStorage.setItem(p,t)}setItems(p){this.fileStorage.setItems(p)}removeItem(p){this.fileStorage.removeItem(p)}close(){return this.fileStorage.close()}};E.STATE_FILE="storage.json",E=ue([te(0,S.IEnvironmentMainService),te(1,I.ILogService),te(2,m.IFileService)],E),e.StateMainService=E}),define(Z[81],x([0,1,43,3,52,22,5,18,6,97,225]),function(V,e,w,n,L,D,P,S,m,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GlobalStorageMainService=e.IGlobalStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,P.createDecorator)("storageMainService");let E=class extends n.Disposable{constructor(t,h,g){super();this.logService=t,this.environmentService=h,this.lifecycleMainService=g,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async t=>{t.workspace&&this.workspaceStorage(t.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(t=>{(0,m.logCi)(this.logService,"storageMainService#onWillShutdown()"),t.join(this.globalStorage.close());for(const[,h]of this.mapWorkspaceToStorage)t.join(h.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const t=new M.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,w.once)(t.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),t}createWorkspaceStorage(t){return new M.WorkspaceStorageMain(t,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(t){let h=this.mapWorkspaceToStorage.get(t.id);return h||(this.logService.trace(`StorageMainService: creating workspace storage (${t.id})`),h=this.createWorkspaceStorage(t),this.mapWorkspaceToStorage.set(t.id,h),(0,w.once)(h.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${t.id})`),this.mapWorkspaceToStorage.delete(t.id)})),h}};E=ue([te(0,m.ILogService),te(1,L.IEnvironmentService),te(2,S.ILifecycleMainService)],E),e.StorageMainService=E,e.IGlobalStorageMainService=(0,P.createDecorator)("globalStorageMainService");let b=class extends I.AbstractStorageService{constructor(t,h){super();this.environmentMainService=t,this.storageMainService=h,this.whenReady=this.storageMainService.globalStorage.whenInit}doInitialize(){return this.storageMainService.globalStorage.whenInit}getStorage(t){switch(t){case 0:return this.storageMainService.globalStorage.storage;case 1:return}}getLogDetails(t){return t===0?this.environmentMainService.globalStorageHome.fsPath:void 0}shouldFlushWhenIdle(){return!1}migrate(){throw new Error("Migrating storage is unsupported from main process")}};b=ue([te(0,D.IEnvironmentMainService),te(1,e.IStorageMainService)],b),e.GlobalStorageMainService=b}),define(Z[237],x([0,1,61,123,232,9,3,19,6,21,202,99,79]),function(V,e,w,n,L,D,P,S,m,I,M,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(k,d,u,c,a){let f;for(let s=3;s&&(f&&f.dispose(),f=await new t(k,d,u,c,a).waitForReady(),!(a&&n.BROWSER_RESTRICTED_PORTS[a]||!n.BROWSER_RESTRICTED_PORTS[f.tunnelLocalPort]));s--);return f}class t extends P.Disposable{constructor(d,u,c,a,f){super();this.defaultTunnelHost=u,this.suggestedLocalPort=f,this.privacy=E.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=d,this._server=w.createServer(),this._barrier=new D.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=a,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(u=>{u()})}async waitForReady(){let d=await(0,n.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),u=null;return this._server.listen(d,this.defaultTunnelHost),await this._barrier.wait(),u=this._server.address(),u||(d=0,this._server.listen(d,this.defaultTunnelHost),await this._barrier.wait(),u=this._server.address()),this.tunnelLocalPort=u.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${u.port}`,this}async _onConnection(d){d.pause();const u=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,M.connectRemoteAgentTunnel)(this._options,u,this.tunnelRemotePort),a=c.getSocket().socket,f=c.readEntireBuffer();c.dispose(),f.byteLength>0&&d.write(f.buffer),d.on("end",()=>{d.localAddress&&this._socketsDispose.delete(d.localAddress),a.end()}),d.on("close",()=>a.end()),d.on("error",()=>{d.localAddress&&this._socketsDispose.delete(d.localAddress),a.destroy()}),a.on("end",()=>d.end()),a.on("close",()=>d.end()),a.on("error",()=>{d.destroy()}),d.pipe(a),a.pipe(d),d.localAddress&&this._socketsDispose.set(d.localAddress,()=>{d.end(),a.end()})}}let h=class extends E.AbstractTunnelService{constructor(d,u,c,a,f){super(u);this.socketFactory=d,this.signService=c,this.productService=a,this.configurationService=f}get defaultTunnelHost(){const d=this.configurationService.getValue("remote.localPortHost");return!d||d==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(d,u,c,a,f,s,i){const r=this.getTunnelFromMap(u,c);if(r)return++r.refcount,r.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,u,c,a,f,s,i);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${u}:${c} on local port ${a}.`);const o={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:d,signService:this.signService,logService:this.logService,ipcLogger:null},l=p(o,this.defaultTunnelHost,u,c,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(u,c,l),l}}};h=ue([te(1,m.ILogService),te(2,b.ISignService),te(3,I.IProductService),te(4,S.IConfigurationService)],h),e.BaseTunnelService=h;let g=class extends h{constructor(d,u,c,a){super(L.nodeSocketFactory,d,u,c,a)}};g=ue([te(0,m.ILogService),te(1,b.ISignService),te(2,I.IProductService),te(3,S.IConfigurationService)],g),e.TunnelService=g;let y=class extends P.Disposable{constructor(d,u,c,a){super();this.logService=d,this.productService=u,this.signService=c,this.configurationService=a,this._tunnelServices=new Map}async openTunnel(d,u,c,a,f,s,i,r){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${a} on local port ${f}.`),!this._tunnelServices.has(d)){const o=new g(this.logService,this.signService,this.productService,this.configurationService);this._register(o),this._tunnelServices.set(d,o),o.onTunnelClosed(async()=>{(await o.tunnels).length===0&&(o.dispose(),this._tunnelServices.delete(d))})}return this._tunnelServices.get(d).openTunnel(u,c,a,f,s,i,r)}};y=ue([te(0,m.ILogService),te(1,I.IProductService),te(2,b.ISignService),te(3,S.IConfigurationService)],y),e.SharedTunnelsService=y}),define(Z[82],x([0,1,9,23,4,19,22,18,6,21,56,41]),function(V,e,w,n,L,D,P,S,m,I,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function b(t,h,g){return`${g.updateUrl}/api/update/${t}/${h}/${g.commit}`}e.createUpdateURL=b;let p=class{constructor(h,g,y,k,d,u){this.lifecycleMainService=h,this.configurationService=g,this.environmentMainService=y,this.requestService=k,this.logService=d,this.productService=u,this._state=E.State.Uninitialized,this._onStateChange=new L.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(h){this.logService.info("update#setState",h.type),this._state=h,this._onStateChange.fire(h)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const h=this.getUpdateMode(),g=this.getProductQuality(h);if(!g){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(g),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(E.State.Idle(this.getUpdateType())),h==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}h==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,y=>this.logService.error(y))}getUpdateMode(){return(0,D.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(h){return h==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(h=60*60*1e3){return(0,w.timeout)(h).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(h){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(h)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(h){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(h=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${h}`),!h&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(this.url){if(this.getUpdateMode()==="none")return!1}else return;return(await this.requestService.request({url:this.url},n.CancellationToken.None)).res.statusCode===204}getUpdateType(){return 1}doQuitAndInstall(){}};p=ue([te(0,S.ILifecycleMainService),te(1,D.IConfigurationService),te(2,P.IEnvironmentMainService),te(3,M.IRequestService),te(4,m.ILogService),te(5,I.IProductService)],p),e.AbstractUpdateService=p}),define(Z[238],x([0,1,12,46,4,3,19,22,18,6,21,56,32,41,82]),function(V,e,w,n,L,D,P,S,m,I,M,E,b,p,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let h=class extends t.AbstractUpdateService{constructor(y,k,d,u,c,a,f){super(y,k,u,c,a,f);this.telemetryService=d,this.disposables=new D.DisposableStore}get onRawError(){return L.Event.fromNodeEventEmitter(w.autoUpdater,"error",(y,k)=>k)}get onRawUpdateNotAvailable(){return L.Event.fromNodeEventEmitter(w.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return L.Event.fromNodeEventEmitter(w.autoUpdater,"update-available",(y,k,d)=>({url:k,version:d,productVersion:d}))}get onRawUpdateDownloaded(){return L.Event.fromNodeEventEmitter(w.autoUpdater,"update-downloaded",(y,k,d,u)=>({releaseNotes:k,version:d,productVersion:d,date:u}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(y){this.logService.error("UpdateService error:",y);const d=(this.state.type==="checking for updates"?this.state.explicit:!0)?y:void 0;this.setState(p.State.Idle(1,d))}buildUpdateFeedUrl(y){let k;this.productService.darwinUniversalAssetId?k=this.productService.darwinUniversalAssetId:k=process.arch==="x64"?"darwin":"darwin-arm64";const d=(0,t.createUpdateURL)(k,y,this.productService);try{w.autoUpdater.setFeedURL({url:d})}catch(u){this.logService.error("Failed to set update feed URL",u);return}return d}doCheckForUpdates(y){this.setState(p.State.CheckingForUpdates(y)),w.autoUpdater.checkForUpdates()}onUpdateAvailable(y){this.state.type==="checking for updates"&&this.setState(p.State.Downloading(y))}onUpdateDownloaded(y){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:y.version}),this.setState(p.State.Ready(y)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(p.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),w.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ue([n.memoize],h.prototype,"onRawError",null),ue([n.memoize],h.prototype,"onRawUpdateNotAvailable",null),ue([n.memoize],h.prototype,"onRawUpdateAvailable",null),ue([n.memoize],h.prototype,"onRawUpdateDownloaded",null),h=ue([te(0,m.ILifecycleMainService),te(1,P.IConfigurationService),te(2,b.ITelemetryService),te(3,S.IEnvironmentMainService),te(4,E.IRequestService),te(5,I.ILogService),te(6,M.IProductService)],h),e.DarwinUpdateService=h}),define(Z[239],x([0,1,45,29,9,4,7,22,18,6,32,41]),function(V,e,w,n,L,D,P,S,m,I,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let b=class{constructor(h,g,y){if(this.lifecycleMainService=h,this.logService=y,this._state=E.State.Uninitialized,this._onStateChange=new D.Emitter,this.onStateChange=this._onStateChange.event,g.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(E.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,k=>this.logService.error(k))}get state(){return this._state}setState(h){this.logService.info("update#setState",h.type),this._state=h,this._onStateChange.fire(h)}scheduleCheckForUpdates(h=60*60*1e3){return(0,L.timeout)(h).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(h){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(h)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(h){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(h=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${h}`),!h&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};b=ue([te(0,m.ILifecycleMainService),te(1,S.IEnvironmentMainService),te(2,I.ILogService)],b);let p=class extends b{constructor(h,g,y,k,d,u){super(y,k,d);this.snap=h,this.snapRevision=g,this.telemetryService=u;const c=(0,n.watch)(P.dirname(this.snap)),a=D.Event.fromNodeEventEmitter(c,"change",(r,o)=>o),f=D.Event.filter(a,r=>r==="current"),i=D.Event.debounce(f,(r,o)=>o,2e3)(()=>this.checkForUpdates(!1));y.onWillShutdown(()=>{i.dispose(),c.close()})}doCheckForUpdates(){this.setState(E.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(h=>{h?this.setState(E.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(E.State.Idle(2)))},h=>{this.logService.error(h),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(E.State.Idle(2,h.message||h))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,w.spawn)("sleep 3 && "+P.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const h=await new Promise((y,k)=>(0,n.realpath)(`${P.dirname(this.snap)}/current`,(d,u)=>d?k(d):y(u))),g=P.basename(h);return this.snapRevision!==g}isLatestVersion(){return this.isUpdateAvailable().then(void 0,h=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};p=ue([te(2,m.ILifecycleMainService),te(3,S.IEnvironmentMainService),te(4,I.ILogService),te(5,M.ITelemetryService)],p),e.SnapUpdateService=p}),define(Z[42],x([0,1,12,29,4,44,33,3,10,7,2,17,14,24,161,51,47,22,5,6,21,102,25,80,103]),function(V,e,w,n,L,D,P,S,m,I,M,E,b,p,t,h,g,y,k,d,u,c,a,f,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,k.createDecorator)("workspacesManagementMainService");let i=class extends S.Disposable{constructor(o,l,v,C,R){super();this.environmentMainService=o,this.logService=l,this.backupMainService=v,this.dialogMainService=C,this.productService=R,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new L.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new L.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(o){return this.doResolveLocalWorkspace(o,l=>(0,n.readFileSync)(l,"utf8"))}resolveLocalWorkspace(o){return this.doResolveLocalWorkspace(o,l=>p.Promises.readFile(l,"utf8"))}doResolveLocalWorkspace(o,l){if(!!this.isWorkspacePath(o)&&o.scheme===m.Schemas.file)try{const v=l(o.fsPath);return v instanceof Promise?v.then(C=>this.doResolveWorkspace(o,C),C=>{}):this.doResolveWorkspace(o,v)}catch{return}}isWorkspacePath(o){return(0,a.isUntitledWorkspace)(o,this.environmentMainService)||(0,a.hasWorkspaceFileExtension)(o)}doResolveWorkspace(o,l){try{const v=this.doParseStoredWorkspace(o,l),C=(0,s.getWorkspaceIdentifier)(o);return{id:C.id,configPath:C.configPath,folders:(0,f.toWorkspaceFolders)(v.folders,C.configPath,E.extUriBiasedIgnorePathCase),remoteAuthority:v.remoteAuthority,transient:v.transient}}catch(v){this.logService.warn(v.toString())}}doParseStoredWorkspace(o,l){const v=(0,D.parse)(l);if(v&&Array.isArray(v.folders))v.folders=v.folders.filter(C=>(0,f.isStoredWorkspaceFolder)(C));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return v}async createUntitledWorkspace(o,l){const{workspace:v,storedWorkspace:C}=this.newUntitledWorkspace(o,l),R=v.configPath.fsPath;return await p.Promises.mkdir((0,I.dirname)(R),{recursive:!0}),await p.Promises.writeFile(R,JSON.stringify(C,null,"	")),v}createUntitledWorkspaceSync(o,l){const{workspace:v,storedWorkspace:C}=this.newUntitledWorkspace(o,l),R=v.configPath.fsPath;return(0,n.mkdirSync)((0,I.dirname)(R),{recursive:!0}),(0,p.writeFileSync)(R,JSON.stringify(C,null,"	")),v}newUntitledWorkspace(o=[],l){const v=(Date.now()+Math.round(Math.random()*1e3)).toString(),C=(0,E.joinPath)(this.untitledWorkspacesHome,v),R=(0,E.joinPath)(C,a.UNTITLED_WORKSPACE_NAME),W=[];for(const U of o)W.push((0,f.getStoredWorkspaceFolder)(U.uri,!0,U.name,C,!M.isWindows,E.extUriBiasedIgnorePathCase));return{workspace:(0,s.getWorkspaceIdentifier)(R),storedWorkspace:{folders:W,remoteAuthority:l}}}async getWorkspaceIdentifier(o){return(0,s.getWorkspaceIdentifier)(o)}isUntitledWorkspace(o){return(0,a.isUntitledWorkspace)(o.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(o){!this.isUntitledWorkspace(o)||(this.doDeleteUntitledWorkspaceSync(o),this._onDidDeleteUntitledWorkspace.fire(o))}async deleteUntitledWorkspace(o){this.deleteUntitledWorkspaceSync(o)}doDeleteUntitledWorkspaceSync(o){const l=(0,E.originalFSPath)(o.configPath);try{(0,p.rimrafSync)((0,I.dirname)(l));const v=(0,I.join)(this.environmentMainService.workspaceStorageHome.fsPath,o.id);(0,n.existsSync)(v)&&(0,p.writeFileSync)((0,I.join)(v,"obsolete"),"")}catch(v){this.logService.warn(`Unable to delete untitled workspace ${l} (${v}).`)}}getUntitledWorkspacesSync(){const o=[];try{const l=(0,p.readdirSync)(this.untitledWorkspacesHome.fsPath).map(v=>(0,E.joinPath)(this.untitledWorkspacesHome,v,a.UNTITLED_WORKSPACE_NAME));for(const v of l){const C=(0,s.getWorkspaceIdentifier)(v),R=this.resolveLocalWorkspaceSync(v);R?o.push({workspace:C,remoteAuthority:R.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(C)}}catch(l){l.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${l}).`)}return o}async enterWorkspace(o,l,v){if(!o||!o.win||!o.isReady||!await this.isValidTargetWorkspacePath(o,l,v))return;const R=this.doEnterWorkspace(o,(0,s.getWorkspaceIdentifier)(v));if(!!R)return this._onDidEnterWorkspace.fire({window:o,workspace:R.workspace}),R}async isValidTargetWorkspacePath(o,l,v){if(!v)return!0;if((0,a.isWorkspaceIdentifier)(o.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(o.openedWorkspace.configPath,v))return!1;if((0,c.findWindowOnWorkspaceOrFolder)(l,v)){const C={title:this.productService.nameLong,type:"info",buttons:[(0,P.mnemonicButtonLabel)((0,t.localize)(0,null))],message:(0,t.localize)(1,null,(0,E.basename)(v)),detail:(0,t.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(C,(0,b.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(o,l){if(!o.config)return;o.focus();let v;return o.config.extensionDevelopmentPath||(v=this.backupMainService.registerWorkspaceBackupSync({workspace:l,remoteAuthority:o.remoteAuthority},o.config.backupPath)),(0,a.isWorkspaceIdentifier)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&this.deleteUntitledWorkspaceSync(o.openedWorkspace),o.config.workspace=l,o.config.backupPath=v,{workspace:l,backupPath:v}}};i=ue([te(0,y.IEnvironmentMainService),te(1,d.ILogService),te(2,h.IBackupMainService),te(3,g.IDialogMainService),te(4,u.IProductService)],i),e.WorkspacesManagementMainService=i}),define(Z[104],x([0,1,12,23,5,34,25,42]),function(V,e,w,n,L,D,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,L.createDecorator)(e.ID);let m=class{constructor(M,E){this.windowsMainService=M,this.workspacesManagementMainService=E}async getRemoteDiagnostics(M){const E=this.windowsMainService.getWindows();return(await Promise.all(E.map(p=>new Promise(t=>{const h=p.remoteAuthority;if(h){const g=`vscode:getDiagnosticInfoResponse${p.id}`,y={includeProcesses:M.includeProcesses,folders:M.includeWorkspaceMetadata?this.getFolderURIs(p):void 0};p.sendWhenReady("vscode:getDiagnosticInfo",n.CancellationToken.None,{replyChannel:g,args:y}),w.ipcMain.once(g,(k,d)=>{d||t({hostName:h,errorMessage:`Unable to resolve connection to '${h}'.`}),t(d)}),setTimeout(()=>{t({hostName:h,errorMessage:`Connection to '${h}' could not be established`})},5e3)}else t(void 0)})))).filter(p=>!!p)}getFolderURIs(M){const E=[],b=M.openedWorkspace;if((0,P.isSingleFolderWorkspaceIdentifier)(b))E.push(b.uri);else if((0,P.isWorkspaceIdentifier)(b)){const p=this.workspacesManagementMainService.resolveLocalWorkspaceSync(b.configPath);p&&p.folders.forEach(h=>{E.push(h.uri)})}return E}};m=ue([te(0,D.IWindowsMainService),te(1,S.IWorkspacesManagementMainService)],m),e.DiagnosticsMainService=m}),define(Z[105],x([0,1,12,30,2,14,8,24,19,50,5,6,100,34,25,42]),function(V,e,w,n,L,D,P,S,m,I,M,E,b,p,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,M.createDecorator)(e.ID);let g=class{constructor(k,d,u,c,a){this.logService=k,this.windowsMainService=d,this.urlService=u,this.workspacesManagementMainService=c,this.configurationService=a}async start(k,d){this.logService.trace("Received data from other instance: ",k,d),L.isMacintosh&&w.app.focus({steal:!0});const u=this.parseOpenUrl(k);if(u.length){let c=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(c=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),c.then(()=>{for(const{uri:a,url:f}of u)this.urlService.open(a,{originalUrl:f})})}else return this.startOpenWindow(k,d)}parseOpenUrl(k){return k["open-url"]&&k._urls&&k._urls.length>0?(0,n.coalesce)(k._urls.map(d=>{try{return{uri:P.URI.parse(d),url:d}}catch{return null}})):[]}async startOpenWindow(k,d){const u=(0,I.isLaunchedFromCli)(d)?0:4;let c=[];const a=k.wait&&k.waitMarkerFilePath?P.URI.file(k.waitMarkerFilePath):void 0,f=k.remote||void 0,s={context:u,cli:k,userEnv:d,waitMarkerFileURI:a,remoteAuthority:f};if(k.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(k.extensionDevelopmentPath,s);else if(!k._.length&&!k["folder-uri"]&&!k["file-uri"]){let i=!1;if(k["new-window"]||k["unity-launch"])i=!0;else if(k["reuse-window"])i=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!L.isMacintosh}if(i)c=this.windowsMainService.open({...s,forceNewWindow:!0,forceEmpty:!0});else{const r=this.windowsMainService.getLastActiveWindow();r?(this.windowsMainService.openExistingWindow(r,s),c=[r]):c=this.windowsMainService.open({...s,forceEmpty:!0})}}else c=this.windowsMainService.open({...s,forceNewWindow:k["new-window"],preferNewWindow:!k["reuse-window"]&&!k.wait,forceReuseWindow:k["reuse-window"],diffMode:k.diff,addMode:k.add,noRecentEntry:!!k["skip-add-to-recently-opened"],gotoLineMode:k.goto});if(a&&c.length===1&&c[0])return Promise.race([c[0].whenClosedOrLoaded,(0,S.whenDeleted)(a.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const k=[];return w.BrowserWindow.getAllWindows().forEach(d=>{const u=this.windowsMainService.getWindowById(d.id);u?k.push(this.codeWindowToInfo(u)):k.push(this.browserWindowToInfo(d))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:k,screenReader:!!w.app.accessibilitySupportEnabled,gpuFeatureStatus:w.app.getGPUFeatureStatus()}}getFolderURIs(k){const d=[],u=k.openedWorkspace;if((0,t.isSingleFolderWorkspaceIdentifier)(u))d.push(u.uri);else if((0,t.isWorkspaceIdentifier)(u)){const c=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.configPath);c&&c.folders.forEach(f=>{d.push(f.uri)})}return d}codeWindowToInfo(k){const d=this.getFolderURIs(k),u=(0,D.assertIsDefined)(k.win);return this.browserWindowToInfo(u,d,k.remoteAuthority)}browserWindowToInfo(k,d=[],u){return{pid:k.webContents.getOSProcessId(),title:k.getTitle(),folderURIs:d,remoteAuthority:u}}};g=ue([te(0,E.ILogService),te(1,p.IWindowsMainService),te(2,b.IURLService),te(3,h.IWorkspacesManagementMainService),te(4,m.IConfigurationService)],g),e.LaunchMainService=g}),define(Z[58],x([0,1,45,12,26,122,46,4,33,3,10,7,2,8,86,71,24,152,47,22,5,18,6,21,32,65,34,25,42]),function(V,e,w,n,L,D,P,S,m,I,M,E,b,p,t,h,g,y,k,d,u,c,a,f,s,i,r,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,u.createDecorator)("nativeHostMainService");let v=class extends I.Disposable{constructor(R,W,U,G,ee,X,J,H,B,Y){super();this.sharedProcess=R,this.windowsMainService=W,this.dialogMainService=U,this.lifecycleMainService=G,this.environmentMainService=ee,this.telemetryService=X,this.logService=J,this.productService=H,this.themeMainService=B,this.workspacesManagementMainService=Y,this.onDidOpenWindow=S.Event.map(this.windowsMainService.onDidOpenWindow,se=>se.id),this.onDidMaximizeWindow=S.Event.filter(S.Event.fromNodeEventEmitter(n.app,"browser-window-maximize",(se,$)=>$.id),se=>!!this.windowsMainService.getWindowById(se)),this.onDidUnmaximizeWindow=S.Event.filter(S.Event.fromNodeEventEmitter(n.app,"browser-window-unmaximize",(se,$)=>$.id),se=>!!this.windowsMainService.getWindowById(se)),this.onDidBlurWindow=S.Event.filter(S.Event.fromNodeEventEmitter(n.app,"browser-window-blur",(se,$)=>$.id),se=>!!this.windowsMainService.getWindowById(se)),this.onDidFocusWindow=S.Event.any(S.Event.map(S.Event.filter(S.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),se=>!!se),se=>se.id),S.Event.filter(S.Event.fromNodeEventEmitter(n.app,"browser-window-focus",(se,$)=>$.id),se=>!!this.windowsMainService.getWindowById(se))),this.onDidResumeOS=S.Event.fromNodeEventEmitter(n.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new S.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new S.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=S.Event.debounce(S.Event.any(S.Event.filter(S.Event.fromNodeEventEmitter(n.screen,"display-metrics-changed",(se,$,q)=>q),se=>!(Array.isArray(se)&&se.length===1&&se[0]==="workArea")),S.Event.fromNodeEventEmitter(n.screen,"display-added"),S.Event.fromNodeEventEmitter(n.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){n.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.osColorScheme)})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(W=>({id:W.id,workspace:W.openedWorkspace,title:W.win?.getTitle()??"",filename:W.getRepresentedFilename(),dirty:W.isDocumentEdited()}))}async getWindowCount(R){return this.windowsMainService.getWindowCount()}async getActiveWindowId(R){const W=n.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(W)return W.id}openWindow(R,W,U){return Array.isArray(W)?this.doOpenWindow(R,W,U):this.doOpenEmptyWindow(R,W)}async doOpenWindow(R,W,U=Object.create(null)){W.length>0&&this.windowsMainService.open({context:5,contextWindowId:R,urisToOpen:W,cli:this.environmentMainService.args,forceNewWindow:U.forceNewWindow,forceReuseWindow:U.forceReuseWindow,preferNewWindow:U.preferNewWindow,diffMode:U.diffMode,addMode:U.addMode,gotoLineMode:U.gotoLineMode,noRecentEntry:U.noRecentEntry,waitMarkerFileURI:U.waitMarkerFileURI,remoteAuthority:U.remoteAuthority||void 0})}async doOpenEmptyWindow(R,W){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:R},W)}async toggleFullScreen(R){const W=this.windowById(R);W&&W.toggleFullScreen()}async handleTitleDoubleClick(R){const W=this.windowById(R);W&&W.handleTitleDoubleClick()}async isMaximized(R){const W=this.windowById(R);return W?.win?W.win.isMaximized():!1}async maximizeWindow(R){const W=this.windowById(R);W?.win&&W.win.maximize()}async unmaximizeWindow(R){const W=this.windowById(R);W?.win&&W.win.unmaximize()}async minimizeWindow(R){const W=this.windowById(R);W?.win&&W.win.minimize()}async focusWindow(R,W){W&&typeof W.windowId=="number"&&(R=W.windowId);const U=this.windowById(R);U&&U.focus({force:W?.force??!1})}async setMinimumSize(R,W,U){const G=this.windowById(R);if(G?.win){const[ee,X]=G.win.getSize(),[J,H]=G.win.getMinimumSize(),[B,Y]=[W??J,U??H],[se,$]=[Math.max(ee,B),Math.max(X,Y)];(J!==B||H!==Y)&&G.win.setMinimumSize(B,Y),(ee!==se||X!==$)&&G.win.setSize(se,$)}}async saveWindowSplash(R,W){this.themeMainService.saveWindowSplash(R,W)}async installShellCommand(R){const{source:W,target:U}=await this.getShellCommandLink();try{const{symbolicLink:G}=await g.SymlinkSupport.stat(W);if(G&&!G.dangling){const ee=await(0,t.realpath)(W);if(U===ee)return}await g.Promises.unlink(W)}catch(G){if(G.code!=="ENOENT")throw G}try{await g.Promises.symlink(U,W)}catch(G){if(G.code!=="EACCES"&&G.code!=="ENOENT")throw G;const{response:ee}=await this.showMessageBox(R,{title:this.productService.nameLong,type:"info",message:(0,y.localize)(0,null,this.productService.nameShort),buttons:[(0,m.mnemonicButtonLabel)((0,y.localize)(1,null)),(0,m.mnemonicButtonLabel)((0,y.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(ee===0)try{const X=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${U}' '${W}'\\" with administrator privileges"`;await(0,D.promisify)(w.exec)(X)}catch{throw new Error((0,y.localize)(3,null,W))}}}async uninstallShellCommand(R){const{source:W}=await this.getShellCommandLink();try{await g.Promises.unlink(W)}catch(U){switch(U.code){case"EACCES":{const{response:G}=await this.showMessageBox(R,{title:this.productService.nameLong,type:"info",message:(0,y.localize)(4,null,this.productService.nameShort),buttons:[(0,m.mnemonicButtonLabel)((0,y.localize)(5,null)),(0,m.mnemonicButtonLabel)((0,y.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(G===0)try{const ee=`osascript -e "do shell script \\"rm '${W}'\\" with administrator privileges"`;await(0,D.promisify)(w.exec)(ee)}catch{throw new Error((0,y.localize)(7,null,W))}break}case"ENOENT":break;default:throw U}}}async getShellCommandLink(){const R=(0,E.resolve)(this.environmentMainService.appRoot,"bin","code"),W=`/usr/local/bin/${this.productService.applicationName}`;if(!await g.Promises.exists(R))throw new Error((0,y.localize)(8,null,R));return{source:W,target:R}}async showMessageBox(R,W){return this.dialogMainService.showMessageBox(W,this.toBrowserWindow(R))}async showSaveDialog(R,W){return this.dialogMainService.showSaveDialog(W,this.toBrowserWindow(R))}async showOpenDialog(R,W){return this.dialogMainService.showOpenDialog(W,this.toBrowserWindow(R))}toBrowserWindow(R){const W=this.windowById(R);if(W?.win)return W.win}async pickFileFolderAndOpen(R,W){const U=await this.dialogMainService.pickFileFolder(W);U&&(this.sendPickerTelemetry(U,W.telemetryEventName||"openFileFolder",W.telemetryExtraData),this.doOpenPicked(await Promise.all(U.map(async G=>await g.SymlinkSupport.existsDirectory(G)?{folderUri:p.URI.file(G)}:{fileUri:p.URI.file(G)})),W,R))}async pickFolderAndOpen(R,W){const U=await this.dialogMainService.pickFolder(W);U&&(this.sendPickerTelemetry(U,W.telemetryEventName||"openFolder",W.telemetryExtraData),this.doOpenPicked(U.map(G=>({folderUri:p.URI.file(G)})),W,R))}async pickFileAndOpen(R,W){const U=await this.dialogMainService.pickFile(W);U&&(this.sendPickerTelemetry(U,W.telemetryEventName||"openFile",W.telemetryExtraData),this.doOpenPicked(U.map(G=>({fileUri:p.URI.file(G)})),W,R))}async pickWorkspaceAndOpen(R,W){const U=await this.dialogMainService.pickWorkspace(W);U&&(this.sendPickerTelemetry(U,W.telemetryEventName||"openWorkspace",W.telemetryExtraData),this.doOpenPicked(U.map(G=>({workspaceUri:p.URI.file(G)})),W,R))}doOpenPicked(R,W,U){this.windowsMainService.open({context:3,contextWindowId:U,cli:this.environmentMainService.args,urisToOpen:R,forceNewWindow:W.forceNewWindow})}sendPickerTelemetry(R,W,U){const G=R?R.length:0;this.telemetryService.publicLog(W,{...U,outcome:G?"success":"canceled",numberOfPaths:G})}async showItemInFolder(R,W){n.shell.showItemInFolder(W)}async setRepresentedFilename(R,W){const U=this.windowById(R);U&&U.setRepresentedFilename(W)}async setDocumentEdited(R,W){const U=this.windowById(R);U&&U.setDocumentEdited(W)}async openExternal(R,W){return b.isLinuxSnap?this.safeSnapOpenExternal(W):n.shell.openExternal(W),!0}safeSnapOpenExternal(R){const W=process.env.GDK_PIXBUF_MODULE_FILE,U=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,n.shell.openExternal(R),process.env.GDK_PIXBUF_MODULE_FILE=W,process.env.GDK_PIXBUF_MODULEDIR=U}moveItemToTrash(R,W){return n.shell.trashItem(W)}async isAdmin(){let R;return b.isWindows?R=(await new Promise((W,U)=>{V(["native-is-elevated"],W,U)}))():R=process.getuid()===0,R}async writeElevated(R,W,U,G){const ee=await new Promise((X,J)=>{V(["@vscode/sudo-prompt"],X,J)});return new Promise((X,J)=>{const H=[`"${this.cliPath}"`];G?.unlock&&H.push("--file-chmod"),H.push("--file-write",`"${W.fsPath}"`,`"${U.fsPath}"`);const B={name:this.productService.nameLong.replace("-",""),icns:b.isMacintosh&&this.environmentMainService.isBuilt?(0,E.join)((0,E.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};ee.exec(H.join(" "),B,(Y,se,$)=>{se&&this.logService.trace(`[sudo-prompt] received stdout: ${se}`),$&&this.logService.trace(`[sudo-prompt] received stderr: ${$}`),Y?J(Y):X(void 0)})})}get cliPath(){return b.isWindows?this.environmentMainService.isBuilt?(0,E.join)((0,E.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,E.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):b.isLinux?this.environmentMainService.isBuilt?(0,E.join)((0,E.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,E.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,E.join)(this.environmentMainService.appRoot,"bin","code"):(0,E.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,L.totalmem)(),freemem:(0,L.freemem)(),loadavg:(0,L.loadavg)()}}async getOSProperties(){return{arch:(0,L.arch)(),platform:(0,L.platform)(),release:(0,L.release)(),type:(0,L.type)(),cpus:(0,L.cpus)()}}async getOSVirtualMachineHint(){return h.virtualMachineHint.value()}get osColorScheme(){return{highContrast:n.nativeTheme.shouldUseInvertedColorScheme||n.nativeTheme.shouldUseHighContrastColors,dark:n.nativeTheme.shouldUseDarkColors}}async getOSColorScheme(){return this.osColorScheme}async killProcess(R,W,U){process.kill(W,U)}async readClipboardText(R,W){return n.clipboard.readText(W)}async writeClipboardText(R,W,U){return n.clipboard.writeText(W,U)}async readClipboardFindText(R){return n.clipboard.readFindText()}async writeClipboardFindText(R,W){return n.clipboard.writeFindText(W)}async writeClipboardBuffer(R,W,U,G){return n.clipboard.writeBuffer(W,Buffer.from(U),G)}async readClipboardBuffer(R,W){return n.clipboard.readBuffer(W)}async hasClipboard(R,W,U){return n.clipboard.has(W,U)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){n.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){n.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){n.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){n.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){n.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(R,W){const U=this.windowById(R);U&&U.updateTouchBar(W)}async notifyReady(R){const W=this.windowById(R);W&&W.setReady()}async relaunch(R,W){return this.lifecycleMainService.relaunch(W)}async reload(R,W){const U=this.windowById(R);if(U){if((0,o.isWorkspaceIdentifier)(U.openedWorkspace)){const G=U.openedWorkspace.configPath;if(G.scheme===M.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(G))?.transient)return this.openWindow(U.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(U,W?.disableExtensions!==void 0?{_:[],"disable-extensions":W.disableExtensions}:void 0)}}async closeWindow(R){this.closeWindowById(R,R)}async closeWindowById(R,W){const U=this.windowById(W);if(U?.win)return U.win.close()}async quit(R){const W=this.windowsMainService.getLastActiveWindow();W?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&W.win?W.win.close():this.lifecycleMainService.quit()}async exit(R,W){await this.lifecycleMainService.kill(W)}async resolveProxy(R,W){const G=this.windowById(R)?.win?.webContents?.session;if(G)return G.resolveProxy(W)}async openDevTools(R,W){const U=this.windowById(R);U?.win&&U.win.webContents.openDevTools(W)}async toggleDevTools(R){const W=this.windowById(R);W?.win&&W.win.webContents.toggleDevTools()}async sendInputEvent(R,W){const U=this.windowById(R);U?.win&&(W.type==="mouseDown"||W.type==="mouseUp")&&U.win.webContents.sendInputEvent(W)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(R,W,U,G){if(!b.isWindows)return;const ee=await new Promise((X,J)=>{V(["@vscode/windows-registry"],X,J)});try{return ee.GetStringRegKey(W,U,G)}catch{return}}windowById(R){if(typeof R=="number")return this.windowsMainService.getWindowById(R)}};ue([P.memoize],v.prototype,"cliPath",null),v=ue([te(1,r.IWindowsMainService),te(2,k.IDialogMainService),te(3,c.ILifecycleMainService),te(4,d.IEnvironmentMainService),te(5,s.ITelemetryService),te(6,a.ILogService),te(7,f.IProductService),te(8,i.IThemeMainService),te(9,l.IWorkspacesManagementMainService)],v),e.NativeHostMainService=v}),define(Z[240],x([0,1,12,26,33,3,10,2,87,150,75,104,47,22,5,105,6,58,53,21,54,66]),function(V,e,w,n,L,D,P,S,m,I,M,E,b,p,t,h,g,y,k,d,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,t.createDecorator)("issueMainService");let a=class Mt{constructor(s,i,r,o,l,v,C,R,W,U){this.userEnv=s,this.environmentMainService=i,this.launchMainService=r,this.logService=o,this.diagnosticsService=l,this.diagnosticsMainService=v,this.dialogMainService=C,this.nativeHostMainService=R,this.protocolMainService=W,this.productService=U,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){w.ipcMain.on("vscode:issueSystemInfoRequest",async s=>{const[i,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),o=await this.diagnosticsService.getSystemInfo(i,r);this.safeSend(s,"vscode:issueSystemInfoResponse",o)}),w.ipcMain.on("vscode:listProcesses",async s=>{const i=[];try{const r=await this.launchMainService.getMainProcessId();i.push({name:(0,I.localize)(0,null),rootProcess:await(0,m.listProcesses)(r)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(l=>{(0,M.isRemoteDiagnosticError)(l)?i.push({name:l.hostName,rootProcess:l}):l.processes&&i.push({name:l.hostName,rootProcess:l.processes})})}catch(r){this.logService.error(`Listing processes failed: ${r}`)}this.safeSend(s,"vscode:listProcessesResponse",i)}),w.ipcMain.on("vscode:issueReporterClipboard",async s=>{const i={title:this.productService.nameLong,message:(0,I.localize)(1,null),type:"warning",buttons:[(0,L.mnemonicButtonLabel)((0,I.localize)(2,null)),(0,L.mnemonicButtonLabel)((0,I.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const r=await this.dialogMainService.showMessageBox(i,this.issueReporterWindow);this.safeSend(s,"vscode:issueReporterClipboardResponse",r.response===0)}}),w.ipcMain.on("vscode:issuePerformanceInfoRequest",async s=>{const i=await this.getPerformanceInfo();this.safeSend(s,"vscode:issuePerformanceInfoResponse",i)}),w.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const s={title:this.productService.nameLong,message:(0,I.localize)(4,null),type:"warning",buttons:[(0,L.mnemonicButtonLabel)((0,I.localize)(5,null)),(0,L.mnemonicButtonLabel)((0,I.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(s,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),w.ipcMain.on("vscode:workbenchCommand",(s,i)=>{const{id:r,from:o,args:l}=i;let v;switch(o){case"issueReporter":v=this.issueReporterParentWindow;break;case"processExplorer":v=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${o}`)}v&&v.webContents.send("vscode:runAction",{id:r,from:o,args:l})}),w.ipcMain.on("vscode:openExternal",(s,i)=>{this.nativeHostMainService.openExternal(void 0,i)}),w.ipcMain.on("vscode:closeIssueReporter",s=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),w.ipcMain.on("vscode:closeProcessExplorer",s=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),w.ipcMain.on("vscode:windowsInfoRequest",async s=>{const i=await this.launchMainService.getMainProcessInfo();this.safeSend(s,"vscode:windowsInfoResponse",i.windows)})}safeSend(s,i,...r){s.sender.isDestroyed()||s.sender.send(i,...r)}async openReporter(s){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=w.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const i=new D.DisposableStore,r=i.add(this.protocolMainService.createIPCObjectUrl()),o=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(o,r,{backgroundColor:s.styles.backgroundColor,title:(0,I.localize)(7,null),zoomLevel:s.zoomLevel,alwaysOnTop:!1},"issue-reporter"),r.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:s,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,n.type)(),arch:(0,n.arch)(),release:(0,n.release)()},product:k.default}),this.issueReporterWindow.loadURL(P.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",V).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,i.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,i.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(s){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=w.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const i=new D.DisposableStore,r=i.add(this.protocolMainService.createIPCObjectUrl()),o=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(o,r,{backgroundColor:s.styles.backgroundColor,title:(0,I.localize)(8,null),zoomLevel:s.zoomLevel,alwaysOnTop:!0},"process-explorer"),r.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:s,product:k.default}),this.processExplorerWindow.loadURL(P.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",V).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,i.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,i.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(s){s.isMinimized()&&s.restore(),s.focus()}createBrowserWindow(s,i,r,o){const l=new w.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:r.title,backgroundColor:r.backgroundColor||Mt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${i.resource.toString()}`,`--vscode-window-kind=${o}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,c.zoomLevelToZoomFactor)(r.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:r.alwaysOnTop,experimentalDarkMode:!0});return l.setMenuBarVisibility(!1),l}async getSystemStatus(){const[s,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(s,i)}getWindowPosition(s,i,r){let o;const l=w.screen.getAllDisplays();if(l.length===1)o=l[0];else{if(S.isMacintosh){const R=w.screen.getCursorScreenPoint();o=w.screen.getDisplayNearestPoint(R)}!o&&s&&(o=w.screen.getDisplayMatching(s.getBounds())),o||(o=w.screen.getPrimaryDisplay()||l[0])}const v={width:i,height:r},C=o.bounds;return v.x=C.x+C.width/2-v.width/2,v.y=C.y+C.height/2-v.height/2,C.width>0&&C.height>0&&(v.x<C.x&&(v.x=C.x),v.y<C.y&&(v.y=C.y),v.x>C.x+C.width&&(v.x=C.x),v.y>C.y+C.height&&(v.y=C.y),v.width>C.width&&(v.width=C.width),v.height>C.height&&(v.height=C.height)),v}async getPerformanceInfo(){try{const[s,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(s,i)}catch(s){throw this.logService.warn("issueService#getPerformanceInfo ",s.message),s}}};a.DEFAULT_BACKGROUND_COLOR="#1E1E1E",a=ue([te(1,p.IEnvironmentMainService),te(2,h.ILaunchMainService),te(3,g.ILogService),te(4,M.IDiagnosticsService),te(5,E.IDiagnosticsMainService),te(6,b.IDialogMainService),te(7,y.INativeHostMainService),te(8,u.IProtocolMainService),te(9,d.IProductService)],a),e.IssueMainService=a}),define(Z[241],x([0,1,23,19,22,18,6,58,21,56,32,41,82]),function(V,e,w,n,L,D,P,S,m,I,M,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let p=class extends b.AbstractUpdateService{constructor(h,g,y,k,d,u,c,a){super(h,g,k,d,u,a);this.telemetryService=y,this.nativeHostMainService=c}buildUpdateFeedUrl(h){return(0,b.createUpdateURL)(`linux-${process.arch}`,h,this.productService)}doCheckForUpdates(h){!this.url||(this.setState(E.State.CheckingForUpdates(h)),this.requestService.request({url:this.url},w.CancellationToken.None).then(I.asJson).then(g=>{!g||!g.url||!g.version||!g.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h}),this.setState(E.State.Idle(1))):this.setState(E.State.AvailableForDownload(g))}).then(void 0,g=>{this.logService.error(g),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h});const y=h?g.message||g:void 0;this.setState(E.State.Idle(1,y))}))}async doDownloadUpdate(h){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):h.update.url&&this.nativeHostMainService.openExternal(void 0,h.update.url),this.setState(E.State.Idle(1))}};p=ue([te(0,D.ILifecycleMainService),te(1,n.IConfigurationService),te(2,M.ITelemetryService),te(3,L.IEnvironmentMainService),te(4,I.IRequestService),te(5,P.ILogService),te(6,S.INativeHostMainService),te(7,m.IProductService)],p),e.LinuxUpdateService=p}),define(Z[242],x([0,1,45,29,26,9,23,46,7,8,119,24,19,22,20,18,6,58,21,56,32,41,82]),function(V,e,w,n,L,D,P,S,m,I,M,E,b,p,t,h,g,y,k,d,u,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function f(o,l=1e3){for(;!o();)await(0,D.timeout)(l)}let s;function i(){return typeof s=="undefined"&&(s=n.existsSync(m.join(m.dirname(process.execPath),"unins000.exe"))?0:1),s}let r=class extends a.AbstractUpdateService{constructor(l,v,C,R,W,U,G,ee,X){super(l,v,R,W,U,X);this.telemetryService=C,this.fileService=G,this.nativeHostMainService=ee}get cachePath(){const l=m.join((0,L.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return E.Promises.mkdir(l,{recursive:!0}).then(()=>l)}initialize(){super.initialize()}buildUpdateFeedUrl(l){let v="win32";return process.arch!=="ia32"&&(v+=`-${process.arch}`),i()===1?v+="-archive":this.productService.target==="user"&&(v+="-user"),(0,a.createUpdateURL)(v,l,this.productService)}doCheckForUpdates(l){!this.url||(this.setState(c.State.CheckingForUpdates(l)),this.requestService.request({url:this.url},P.CancellationToken.None).then(d.asJson).then(v=>{const C=i();return!v||!v.url||!v.version||!v.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!l}),this.setState(c.State.Idle(C)),Promise.resolve(null)):C===1?(this.setState(c.State.AvailableForDownload(v)),Promise.resolve(null)):(this.setState(c.State.Downloading(v)),this.cleanup(v.version).then(()=>this.getUpdatePackagePath(v.version).then(R=>E.Promises.exists(R).then(W=>{if(W)return Promise.resolve(R);const U=v.url,G=v.hash,ee=`${R}.tmp`;return this.requestService.request({url:U},P.CancellationToken.None).then(X=>this.fileService.writeFile(I.URI.file(ee),X.stream)).then(G?()=>(0,M.checksum)(ee,v.hash):()=>{}).then(()=>E.Promises.rename(ee,R)).then(()=>R)})).then(R=>{const W=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:R},W&&v.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(v)):this.setState(c.State.Ready(v))})))}).then(void 0,v=>{this.logService.error(v),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!l});const C=l?v.message||v:void 0;this.setState(c.State.Idle(i(),C))}))}async doDownloadUpdate(l){l.update.url&&this.nativeHostMainService.openExternal(void 0,l.update.url),this.setState(c.State.Idle(i()))}async getUpdatePackagePath(l){const v=await this.cachePath;return m.join(v,`CodeSetup-${this.productService.quality}-${l}.exe`)}async cleanup(l=null){const v=l?U=>!new RegExp(`${this.productService.quality}-${l}\\.exe$`).test(U):()=>!0,C=await this.cachePath,W=(await E.Promises.readdir(C)).filter(v).map(async U=>{try{await E.Promises.unlink(m.join(C,U))}catch{}});await Promise.all(W)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const l=this.state.update;this.setState(c.State.Updating(l));const v=await this.cachePath;this.availableUpdate.updateFilePath=m.join(v,`CodeSetup-${this.productService.quality}-${l.version}.flag`),await E.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,w.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(i()))});const R=`${this.productService.win32MutexName}-ready`,W=await new Promise((U,G)=>{V(["windows-mutex"],U,G)});f(()=>W.isActive(R)).then(()=>this.setState(c.State.Ready(l)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?n.unlinkSync(this.availableUpdate.updateFilePath):(0,w.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return i()}};ue([S.memoize],r.prototype,"cachePath",null),r=ue([te(0,h.ILifecycleMainService),te(1,b.IConfigurationService),te(2,u.ITelemetryService),te(3,p.IEnvironmentMainService),te(4,d.IRequestService),te(5,g.ILogService),te(6,t.IFileService),te(7,y.INativeHostMainService),te(8,k.IProductService)],r),e.Win32UpdateService=r}),define(Z[243],x([0,1,12,9,23,39,4,33,3,10,7,63,2,8,157,51,19,47,22,50,20,18,6,21,54,210,81,32,213,65,66,34,25,42,101]),function(V,e,w,n,L,D,P,S,m,I,M,E,b,p,t,h,g,y,k,d,u,c,a,f,s,i,r,o,l,v,C,R,W,U,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var ee;(function(J){J[J.NONE=0]="NONE",J[J.NAVIGATING=1]="NAVIGATING",J[J.READY=2]="READY"})(ee||(ee={}));let X=class extends m.Disposable{constructor(H,B,Y,se,$,q,Q,z,F,N,T,A,O,_,j){super();this.logService=B,this.environmentMainService=Y,this.fileService=se,this.globalStorageMainService=$,this.configurationService=q,this.themeMainService=Q,this.workspacesManagementMainService=z,this.backupMainService=F,this.telemetryService=N,this.dialogMainService=T,this.lifecycleMainService=A,this.productService=O,this.protocolMainService=_,this.windowsMainService=j,this._onWillLoad=this._register(new P.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new P.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new P.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new P.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[ie,ae]=this.restoreWindowState(H.state);this.windowState=ie,this.logService.trace("window#ctor: using window state",ie);const ce=this.windowState.mode===0||this.windowState.mode===3,ne=this.configurationService.getValue("window"),le={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:C.WindowMinimumSize.WIDTH,minHeight:C.WindowMinimumSize.HEIGHT,show:!ce,title:this.productService.nameLong,webPreferences:{preload:I.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",V).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,C.zoomLevelToZoomFactor)(ne?.zoomLevel),enableBlinkFeatures:"HighlightAPI",...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};b.isLinux?le.icon=(0,M.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):b.isWindows&&!this.environmentMainService.isBuilt&&(le.icon=(0,M.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),b.isMacintosh&&!this.useNativeFullScreen()&&(le.fullscreenable=!1),b.isMacintosh&&(le.acceptFirstMouse=!0,ne?.clickThroughInactive===!1&&(le.acceptFirstMouse=!1));const he=b.isMacintosh&&ne?.nativeTabs===!0;he&&(le.tabbingIdentifier=this.productService.nameShort);const we=(0,C.getTitleBarStyle)(this.configurationService)==="custom";if(we&&(le.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,b.isMacintosh||(le.frame=!1)),(0,E.mark)("code/willCreateCodeBrowserWindow"),this._win=new w.BrowserWindow(le),(0,E.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),b.isMacintosh&&we&&this._win.setSheetOffset(22),b.isMacintosh&&ae&&(!he||w.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(be=>typeof be=="number")){const be=this.windowState;this._win.setBounds({width:be.width,height:be.height,x:be.x,y:be.y})}ce&&((0,E.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,E.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(H){b.isMacintosh?this._win.setRepresentedFilename(H):this.representedFilename=H}getRepresentedFilename(){return b.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(H){b.isMacintosh&&this._win.setDocumentEdited(H),this.documentEdited=H}isDocumentEdited(){return b.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(H){b.isMacintosh&&H?.force&&w.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.info(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(H=>{if(this.isReady)return H(this);this.whenReadyCallbacks.push(H)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(H=>{function B(){Y.dispose(),se.dispose(),H()}const Y=this.onDidClose(()=>B()),se=this.onWillLoad(()=>B())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(B,Y)=>this.onWindowError(2,Y)),this._win.webContents.on("did-fail-load",(B,Y,se)=>this.onWindowError(3,{reason:se,exitCode:Y})),this._win.webContents.on("will-prevent-unload",B=>{B.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",B=>{this.currentConfig&&(this.currentConfig.maximized=!0),w.app.emit("browser-window-maximize",B,this._win)}),this._win.on("unmaximize",B=>{this.currentConfig&&(this.currentConfig.maximized=!1),w.app.emit("browser-window-unmaximize",B,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",L.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",L.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(B=>this.onDidDeleteUntitledWorkspace(B)));const H=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:H},async(B,Y)=>{const se=await this.getMarketplaceHeaders();Y({cancel:!1,requestHeaders:Object.assign(B.requestHeaders,se)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,i.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.globalStorageMainService)),this.marketplaceHeadersPromise}async onWindowError(H,B){switch(H){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${B?.reason||"<unknown>"}, code: ${B?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${B?.reason||"<unknown>"}, code: ${B?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:H,reason:B?.reason,code:B?.exitCode}),H){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.driverHandle){this.destroyWindow(!1);return}if(H===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const Y=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,S.mnemonicButtonLabel)((0,t.localize)(0,null)),(0,S.mnemonicButtonLabel)((0,t.localize)(1,null)),(0,S.mnemonicButtonLabel)((0,t.localize)(2,null))],message:(0,t.localize)(3,null),detail:(0,t.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(Y.response!==1){const se=Y.response===0;this.destroyWindow(se)}}else if(H===2){let Y;B?Y=(0,t.localize)(6,null,B.reason,B.exitCode??"<unknown>"):Y=(0,t.localize)(5,null);const $=(await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,S.mnemonicButtonLabel)((0,t.localize)(7,null)),(0,S.mnemonicButtonLabel)((0,t.localize)(8,null))],message:Y,detail:(0,t.localize)(9,null),noLink:!0,defaultId:0},this._win)).response===0;this.destroyWindow($)}break}}destroyWindow(H){if(this._onDidDestroy.fire(),this._win?.destroy(),H&&this.config){let B,Y;(0,W.isSingleFolderWorkspaceIdentifier)(this.openedWorkspace)?B={folderUri:this.openedWorkspace.uri}:(0,W.isWorkspaceIdentifier)(this.openedWorkspace)?B={workspaceUri:this.openedWorkspace.configPath}:Y=!0;const[se]=this.windowsMainService.open({context:5,userEnv:this.config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:B?[B]:void 0,forceEmpty:Y,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});se.focus()}}onDidDeleteUntitledWorkspace(H){this.openedWorkspace?.id===H.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const H=this.getMenuBarVisibility();H!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=H,this.setMenuBarVisibility(H));let B=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;B?.endsWith("/")&&(B=B.substr(0,B.length-1));const Y=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((B||"").indexOf("@")===-1&&(B!==this.currentHttpProxy||Y!==this.currentNoProxy)){this.currentHttpProxy=B,this.currentNoProxy=Y;const se=B||"",$=Y?`${Y},<local>`:"<local>";this.logService.trace(`Setting proxy to '${se}', bypassing '${$}'`),this._win.webContents.session.setProxy({proxyRules:se,proxyBypassRules:$,pacScript:""})}}addTabbedWindow(H){b.isMacintosh&&H.win&&this._win.addTabbedWindow(H.win)}load(H,B=Object.create(null)){this.logService.info(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!B.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),B.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(H,B),this.readyState===0?this.currentConfig=H:this.pendingLoadConfig=H,this.readyState=1,this._win.loadURL(I.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",V).toString(!0));const Y=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new n.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:H.workspace,reason:B.isReload?3:Y?2:1})}updateConfiguration(H,B){const Y=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(Y){const se=(0,d.isLaunchedFromCli)(Y)&&!(0,d.isLaunchedFromCli)(H.userEnv),$=this.isExtensionDevelopmentHost;(se||$)&&(H.userEnv={...Y,...H.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(H.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),B.disableExtensions!==void 0&&(H["disable-extensions"]=B.disableExtensions),H.fullscreen=this.isFullScreen,H.maximized=this._win.isMaximized(),H.partsSplash=this.themeMainService.getWindowSplash(),(0,E.mark)("code/willOpenNewWindow"),H.perfMarks=(0,E.getMarks)(),this.configObjectUrl.update(H)}async reload(H){const B=Object.assign({},this.currentConfig);B.workspace=await this.validateWorkspaceBeforeReload(B),delete B.filesToOpenOrCreate,delete B.filesToDiff,delete B.filesToWait,this.isExtensionDevelopmentHost&&H&&(B.verbose=H.verbose,B.debugId=H.debugId,B.extensionEnvironment=H.extensionEnvironment,B["inspect-extensions"]=H["inspect-extensions"],B["inspect-brk-extensions"]=H["inspect-brk-extensions"],B["extensions-dir"]=H["extensions-dir"]),B.isInitialStartup=!1,this.load(B,{isReload:!0,disableExtensions:H?.["disable-extensions"]})}async validateWorkspaceBeforeReload(H){if((0,W.isWorkspaceIdentifier)(H.workspace)){const B=H.workspace.configPath;if(B.scheme===I.Schemas.file&&!await this.fileService.exists(B))return}else if((0,W.isSingleFolderWorkspaceIdentifier)(H.workspace)){const B=H.workspace.uri;if(B.scheme===I.Schemas.file&&!await this.fileService.exists(B))return}return H.workspace}serializeWindowState(){if(!this._win)return(0,G.defaultWindowState)();if(this.isFullScreen){let Y;try{Y=w.screen.getDisplayMatching(this.getBounds())}catch{}const se=(0,G.defaultWindowState)();return{mode:3,display:Y?Y.id:void 0,width:this.windowState.width||se.width,height:this.windowState.height||se.height,x:this.windowState.x||0,y:this.windowState.y||0}}const H=Object.create(null);let B;if(!b.isMacintosh&&this._win.isMaximized()?B=0:B=1,B===0?H.mode=0:H.mode=1,B===1||B===0){let Y;B===1?Y=this.getBounds():Y=this._win.getNormalBounds(),H.x=Y.x,H.y=Y.y,H.width=Y.width,H.height=Y.height}return H}restoreWindowState(H){(0,E.mark)("code/willRestoreCodeWindowState");let B=!1;if(H)try{const Y=w.screen.getAllDisplays();B=Y.length>1,H=this.validateWindowState(H,Y)}catch(Y){this.logService.warn(`Unexpected error validating window state: ${Y}
${Y.stack}`)}return(0,E.mark)("code/didRestoreCodeWindowState"),[H||(0,G.defaultWindowState)(),B]}validateWindowState(H,B){if(this.logService.trace(`window#validateWindowState: validating window state on ${B.length} display(s)`,H),typeof H.x!="number"||typeof H.y!="number"||typeof H.width!="number"||typeof H.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(H.width<=0||H.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(B.length===1){const $=this.getWorkingArea(B[0]);if($){let q=function(){!H||typeof H.x!="number"||typeof H.y!="number"||!$||(H.x<$.x&&(H.x=$.x),H.y<$.y&&(H.y=$.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",$),q(),H.width>$.width&&(H.width=$.width),H.height>$.height&&(H.height=$.height),H.x>$.x+$.width-128&&(H.x=$.x+$.width-H.width),H.y>$.y+$.height-128&&(H.y=$.y+$.height-H.height),q()}return H}if(H.display&&H.mode===3){const $=B.find(q=>q.id===H.display);if($&&typeof $.bounds?.x=="number"&&typeof $.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const q=(0,G.defaultWindowState)(3);return q.x=$.bounds.x,q.y=$.bounds.y,q}}let Y,se;try{Y=w.screen.getDisplayMatching({x:H.x,y:H.y,width:H.width,height:H.height}),se=this.getWorkingArea(Y)}catch{}if(Y&&se&&H.x+H.width>se.x&&H.y+H.height>se.y&&H.x<se.x+se.width&&H.y<se.y+se.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",se),H}getWorkingArea(H){if(H.workArea.width>0&&H.workArea.height>0)return H.workArea;if(H.bounds.width>0&&H.bounds.height>0)return H.bounds}getBounds(){const[H,B]=this._win.getPosition(),[Y,se]=this._win.getSize();return{x:H,y:B,width:Y,height:se}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(H){this.useNativeFullScreen()?this.setNativeFullScreen(H):this.setSimpleFullScreen(H),this.sendWhenReady(H?"vscode:enterFullScreen":"vscode:leaveFullScreen",L.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(H){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(H)}setSimpleFullScreen(H){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(H),this._win.webContents.focus()}useNativeFullScreen(){const H=this.configurationService.getValue("window");return!H||typeof H.nativeFullScreen!="boolean"||H.nativeTabs?!0:H.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let H=(0,C.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(H)<0&&(H="classic"),H}setMenuBarVisibility(H,B=!0){b.isMacintosh||(H==="toggle"&&B&&this.send("vscode:showInfoMessage",(0,t.localize)(10,null)),H==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(H)}):this.doSetMenuBarVisibility(H))}doSetMenuBarVisibility(H){const B=this.isFullScreen;switch(H){case"classic":this._win.setMenuBarVisibility(!B),this._win.autoHideMenuBar=B;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(b.isMacintosh)switch(w.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(H,B,...Y){this.isReady?this.send(H,...Y):this.ready().then(()=>{B.isCancellationRequested||this.send(H,...Y)})}send(H,...B){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${H}' for window that is destroyed`);return}try{this._win.webContents.send(H,...B)}catch(Y){this.logService.warn(`Error sending IPC message to channel '${H}' of window ${this._id}: ${(0,D.toErrorMessage)(Y)}`)}}}updateTouchBar(H){!b.isMacintosh||this.touchBarGroups.forEach((B,Y)=>{const se=H[Y];B.segments=this.createTouchBarGroupSegments(se)})}createTouchBar(){if(!!b.isMacintosh){for(let H=0;H<10;H++){const B=this.createTouchBarGroup();this.touchBarGroups.push(B)}this._win.setTouchBar(new w.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(H=[]){const B=this.createTouchBarGroupSegments(H),Y=new w.TouchBar.TouchBarSegmentedControl({segments:B,mode:"buttons",segmentStyle:"automatic",change:se=>{this.sendWhenReady("vscode:runAction",L.CancellationToken.None,{id:Y.segments[se].id,from:"touchbar"})}});return Y}createTouchBarGroupSegments(H=[]){return H.map(Y=>{let se;Y.icon&&!l.ThemeIcon.isThemeIcon(Y.icon)&&Y.icon?.dark?.scheme===I.Schemas.file&&(se=w.nativeImage.createFromPath(p.URI.revive(Y.icon.dark).fsPath),se.isEmpty()&&(se=void 0));let $;return typeof Y.title=="string"?$=Y.title:$=Y.title.value,{id:Y.id,label:se?void 0:$,icon:se}})}dispose(){super.dispose(),this._win=null}};X=ue([te(1,a.ILogService),te(2,k.IEnvironmentMainService),te(3,u.IFileService),te(4,r.IGlobalStorageMainService),te(5,g.IConfigurationService),te(6,v.IThemeMainService),te(7,U.IWorkspacesManagementMainService),te(8,h.IBackupMainService),te(9,o.ITelemetryService),te(10,y.IDialogMainService),te(11,c.ILifecycleMainService),te(12,f.IProductService),te(13,s.IProtocolMainService),te(14,R.IWindowsMainService)],X),e.CodeWindow=X}),define(Z[67],x([0,1,12,30,9,4,33,3,10,2,17,8,24,160,5,18,6,38,81,80,25,42]),function(V,e,w,n,L,D,P,S,m,I,M,E,b,p,t,h,g,y,k,d,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,t.createDecorator)("workspacesHistoryMainService");let a=class $e extends S.Disposable{constructor(s,i,r,o,l){super();this.stateMainService=s,this.logService=i,this.workspacesManagementMainService=r,this.lifecycleMainService=o,this.globalStorageMainService=l,this._onDidChangeRecentlyOpened=this._register(new D.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new L.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(s=>this.addRecentlyOpened([{workspace:s.workspace,remoteAuthority:s.window.remoteAuthority}])))}async addRecentlyOpened(s){const i=[],r=[];for(let o of s)if((0,d.isRecentWorkspace)(o))!this.workspacesManagementMainService.isUntitledWorkspace(o.workspace)&&this.indexOfWorkspace(i,o.workspace)===-1&&i.push(o);else if((0,d.isRecentFolder)(o))this.indexOfFolder(i,o.folderUri)===-1&&i.push(o);else{const l=this.indexOfFile(r,o.fileUri)>=0,v=o.fileUri.scheme===m.Schemas.file&&$e.COMMON_FILES_FILTER.indexOf((0,M.basename)(o.fileUri))>=0;!l&&!v&&(r.push(o),I.isWindows&&o.fileUri.scheme===m.Schemas.file&&w.app.addRecentDocument(o.fileUri.fsPath))}await this.addEntriesFromStorage(i,r),i.length>$e.MAX_TOTAL_RECENT_ENTRIES&&(i.length=$e.MAX_TOTAL_RECENT_ENTRIES),r.length>$e.MAX_TOTAL_RECENT_ENTRIES&&(r.length=$e.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:i,files:r}),this._onDidChangeRecentlyOpened.fire(),I.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(s){const i=v=>{const C=this.location(v);for(const R of s)if(M.extUriBiasedIgnorePathCase.isEqual(R,C))return!1;return!0},r=await this.getRecentlyOpened(),o=r.workspaces.filter(i),l=r.files.filter(i);(o.length!==r.workspaces.length||l.length!==r.files.length)&&(await this.saveRecentlyOpened({files:l,workspaces:o}),this._onDidChangeRecentlyOpened.fire(),I.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),w.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(s){const i=[],r=[];if(s){const l=s.config?.workspace;(0,u.isWorkspaceIdentifier)(l)&&!this.workspacesManagementMainService.isUntitledWorkspace(l)?i.push({workspace:l,remoteAuthority:s.remoteAuthority}):(0,u.isSingleFolderWorkspaceIdentifier)(l)&&i.push({folderUri:l.uri,remoteAuthority:s.remoteAuthority})}const o=s?.config?.filesToOpenOrCreate;if(o)for(let l of o){const v=l.fileUri;v&&this.indexOfFile(r,v)===-1&&r.push({fileUri:v})}return await this.addEntriesFromStorage(i,r),{workspaces:i,files:r}}async addEntriesFromStorage(s,i){let r=await this.getRecentlyOpenedFromStorage();for(let o of r.workspaces){let l=(0,d.isRecentFolder)(o)?this.indexOfFolder(s,o.folderUri):this.indexOfWorkspace(s,o.workspace);l>=0?s[l].label=s[l].label||o.label:s.push(o)}for(let o of r.files){let l=this.indexOfFile(i,o.fileUri);l>=0?i[l].label=i[l].label||o.label:i.push(o)}}async getRecentlyOpenedFromStorage(){await this.globalStorageMainService.whenReady;let s;const i=this.globalStorageMainService.get($e.RECENTLY_OPENED_STORAGE_KEY,0);if(typeof i=="string")try{s=JSON.parse(i)}catch(r){this.logService.error("Unexpected error parsing opened paths list",r)}else s=this.stateMainService.getItem($e.legacyRecentlyOpenedStorageKey),s&&(this.stateMainService.removeItem($e.legacyRecentlyOpenedStorageKey),this.globalStorageMainService.store($e.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify(s),0,1));return(0,d.restoreRecentlyOpened)(s,this.logService)}async saveRecentlyOpened(s){await this.globalStorageMainService.whenReady,this.globalStorageMainService.store($e.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,d.toStoreData)(s)),0,1)}location(s){return(0,d.isRecentFolder)(s)?s.folderUri:(0,d.isRecentFile)(s)?s.fileUri:s.workspace.configPath}indexOfWorkspace(s,i){return s.findIndex(r=>(0,d.isRecentWorkspace)(r)&&r.workspace.id===i.id)}indexOfFolder(s,i){return s.findIndex(r=>(0,d.isRecentFolder)(r)&&M.extUriBiasedIgnorePathCase.isEqual(r.folderUri,i))}indexOfFile(s,i){return s.findIndex(r=>M.extUriBiasedIgnorePathCase.isEqual(r.fileUri,i))}async handleWindowsJumpList(){!I.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!I.isWindows)return;const s=[];if(s.push({type:"tasks",items:[{type:"task",title:(0,p.localize)(0,null),description:(0,p.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){let i=[];for(let l of w.app.getJumpListSettings().removedItems){const v=l.args;if(v){const C=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(v);C&&i.push(E.URI.parse(C[2]))}}await this.removeRecentlyOpened(i);let r=!1;const o=(0,n.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,$e.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(l=>{const v=(0,d.isRecentWorkspace)(l)?l.workspace:l.folderUri,{title:C,description:R}=this.getWindowsJumpListLabel(v,l.label);let W;return E.URI.isUri(v)?W=`--folder-uri "${v.toString()}"`:(r=!0,W=`--file-uri "${v.configPath.toString()}"`),{type:"task",title:C.substr(0,255),description:R.substr(0,255),program:process.execPath,args:W,iconPath:"explorer.exe",iconIndex:0}}));o.length>0&&s.push({type:"custom",name:r?(0,p.localize)(2,null):(0,p.localize)(3,null),items:o})}s.push({type:"recent"});try{w.app.setJumpList(s)}catch(i){this.logService.warn("updateWindowsJumpList#setJumpList",i)}}getWindowsJumpListLabel(s,i){if(i)return{title:(0,P.splitName)(i).name,description:i};if(E.URI.isUri(s))return{title:(0,M.basename)(s),description:this.renderJumpListPathDescription(s)};if(this.workspacesManagementMainService.isUntitledWorkspace(s))return{title:(0,p.localize)(4,null),description:""};let r=(0,M.basename)(s.configPath);return r.endsWith(u.WORKSPACE_EXTENSION)&&(r=r.substr(0,r.length-u.WORKSPACE_EXTENSION.length-1)),{title:(0,p.localize)(5,null,r),description:this.renderJumpListPathDescription(s.configPath)}}renderJumpListPathDescription(s){return s.scheme==="file"?(0,P.normalizeDriveLetter)(s.fsPath):s.toString()}async updateMacOSRecentDocuments(){if(!I.isMacintosh)return;w.app.clearRecentDocuments();const s=await this.getRecentlyOpened(),i=[];let r=0;for(let l=0;l<s.workspaces.length&&r<$e.MAX_MACOS_DOCK_RECENT_WORKSPACES;l++){const v=this.location(s.workspaces[l]);if(v.scheme===m.Schemas.file){const C=(0,M.originalFSPath)(v);await b.Promises.exists(C)&&(i.push(C),r++)}}const o=[];for(let l=0;l<s.files.length&&r<$e.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;l++){const v=this.location(s.files[l]);if(v.scheme===m.Schemas.file){const C=(0,M.originalFSPath)(v);if($e.COMMON_FILES_FILTER.includes((0,M.basename)(v))||i.includes(C))continue;await b.Promises.exists(C)&&(o.push(C),r++)}}o.reverse().forEach(l=>w.app.addRecentDocument(l)),i.reverse().forEach(l=>w.app.addRecentDocument(l))}};a.MAX_TOTAL_RECENT_ENTRIES=500,a.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",a.legacyRecentlyOpenedStorageKey="openedPathsList",a.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,a.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,a.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,a.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],a=ue([te(0,y.IStateMainService),te(1,g.ILogService),te(2,c.IWorkspacesManagementMainService),te(3,h.ILifecycleMainService),te(4,k.IGlobalStorageMainService)],a),e.WorkspacesHistoryMainService=a}),define(Z[244],x([0,1,12,9,23,33,2,8,151,19,22,18,6,194,58,21,38,32,41,66,34,67]),function(V,e,w,n,L,D,P,S,m,I,M,E,b,p,t,h,g,y,k,d,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const a="menu";let f=class It{constructor(r,o,l,v,C,R,W,U,G,ee,X){this.updateService=r,this.configurationService=o,this.windowsMainService=l,this.environmentMainService=v,this.telemetryService=C,this.workspacesHistoryMainService=R,this.stateMainService=W,this.lifecycleMainService=U,this.logService=G,this.nativeHostMainService=ee,this.productService=X,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new n.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new n.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(P.isMacintosh||(0,d.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const r=this.stateMainService.getItem(It.lastKnownMenubarStorageKey);r&&(r.menus&&(this.menubarMenus=r.menus),r.keybindings&&(this.keybindings=r.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(R,W,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:W?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(R,W,U)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:W?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(R,W,U)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:a}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(R,W,U)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(U),telemetryExtraData:{from:a}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const r=this.productService.twitterUrl;r&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(r,"openTwitterUrl"));const o=this.productService.requestFeatureUrl;o&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(o,"openUserVoiceUrl"));const l=this.productService.reportIssueUrl;l&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(l,"openReportIssues"));const v=this.productService.licenseUrl;v&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(P.language){const R=v.indexOf("?")>0?"&":"?";this.openUrl(`${v}${R}lang=${P.language}`,"openLicenseUrl")}else this.openUrl(v,"openLicenseUrl")});const C=this.productService.privacyStatementUrl;C&&v&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(C,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(r=>this.onDidChangeWindowsCount(r)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let r=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof r!="boolean"?!0:r}get currentEnableNativeTabs(){if(!P.isMacintosh)return!1;let r=this.configurationService.getValue("window.nativeTabs");return typeof r!="boolean"?!1:r}updateMenu(r,o){this.menubarMenus=r.menus,this.keybindings=r.keybindings,this.stateMainService.setItem(It.lastKnownMenubarStorageKey,r),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(r){!P.isMacintosh||(r.oldCount===0&&r.newCount>0||r.oldCount>0&&r.newCount===0)&&(this.closedLastWindow=r.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!P.isMacintosh||(this.noActiveWindow=!w.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const r=w.Menu.getApplicationMenu();if(r&&this.oldMenus.push(r),Object.keys(this.menubarMenus).length===0){w.Menu.setApplicationMenu(P.isMacintosh?new w.Menu:null);return}const o=new w.Menu;let l;if(P.isMacintosh){const C=new w.Menu;l=new w.MenuItem({label:this.productService.nameShort,submenu:C}),this.setMacApplicationMenu(C),o.append(l)}if(P.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const C=new w.Menu;C.append(new w.MenuItem({label:this.mnemonicLabel(m.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),w.app.dock.setMenu(C)}if(this.shouldDrawMenu("File")){const C=new w.Menu,R=new w.MenuItem({label:this.mnemonicLabel(m.localize(1,null)),submenu:C});this.setMenuById(C,"File"),o.append(R)}if(this.shouldDrawMenu("Edit")){const C=new w.Menu,R=new w.MenuItem({label:this.mnemonicLabel(m.localize(2,null)),submenu:C});this.setMenuById(C,"Edit"),o.append(R)}if(this.shouldDrawMenu("Selection")){const C=new w.Menu,R=new w.MenuItem({label:this.mnemonicLabel(m.localize(3,null)),submenu:C});this.setMenuById(C,"Selection"),o.append(R)}if(this.shouldDrawMenu("View")){const C=new w.Menu,R=new w.MenuItem({label:this.mnemonicLabel(m.localize(4,null)),submenu:C});this.setMenuById(C,"View"),o.append(R)}if(this.shouldDrawMenu("Go")){const C=new w.Menu,R=new w.MenuItem({label:this.mnemonicLabel(m.localize(5,null)),submenu:C});this.setMenuById(C,"Go"),o.append(R)}if(this.shouldDrawMenu("Run")){const C=new w.Menu,R=new w.MenuItem({label:this.mnemonicLabel(m.localize(6,null)),submenu:C});this.setMenuById(C,"Run"),o.append(R)}if(this.shouldDrawMenu("Terminal")){const C=new w.Menu,R=new w.MenuItem({label:this.mnemonicLabel(m.localize(7,null)),submenu:C});this.setMenuById(C,"Terminal"),o.append(R)}let v;if(this.shouldDrawMenu("Window")){const C=new w.Menu;v=new w.MenuItem({label:this.mnemonicLabel(m.localize(8,null)),submenu:C,role:"window"}),this.setMacWindowMenu(C)}if(v&&o.append(v),this.shouldDrawMenu("Help")){const C=new w.Menu,R=new w.MenuItem({label:this.mnemonicLabel(m.localize(9,null)),submenu:C,role:"help"});this.setMenuById(C,"Help"),o.append(R)}o.items&&o.items.length>0?w.Menu.setApplicationMenu(o):w.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(r){const o=this.createMenuItem(m.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),l=this.getUpdateMenuItems();let v;if(this.shouldDrawMenu("Preferences")){const J=new w.Menu;this.setMenuById(J,"Preferences"),v=new w.MenuItem({label:this.mnemonicLabel(m.localize(11,null)),submenu:J})}const C=new w.Menu,R=new w.MenuItem({label:m.localize(12,null),role:"services",submenu:C}),W=new w.MenuItem({label:m.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),U=new w.MenuItem({label:m.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),G=new w.MenuItem({label:m.localize(15,null),role:"unhide"}),ee=new w.MenuItem(this.likeAction("workbench.action.quit",{label:m.localize(16,null,this.productService.nameLong),click:()=>{const J=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!w.BrowserWindow.getFocusedWindow()||J?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),X=[o];X.push(...l),v&&X.push(s(),v),X.push(s(),R,s(),W,U,G,s(),ee),X.forEach(J=>r.append(J))}shouldDrawMenu(r){if(!P.isMacintosh&&(0,d.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(r){case"File":case"Help":if(P.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[r];case"Window":if(P.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[r]}}setMenu(r,o){o.forEach(l=>{if((0,p.isMenubarMenuItemSeparator)(l))r.append(s());else if((0,p.isMenubarMenuItemSubmenu)(l)){const v=new w.Menu,C=new w.MenuItem({label:this.mnemonicLabel(l.label),submenu:v});this.setMenu(v,l.submenu.items),r.append(C)}else(0,p.isMenubarMenuItemRecentAction)(l)?r.append(this.createOpenRecentMenuItem(l)):(0,p.isMenubarMenuItemAction)(l)&&(l.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(r),P.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[l.id]?r.append(new w.MenuItem(this.likeAction(l.id,{label:this.mnemonicLabel(l.label),click:this.fallbackMenuHandlers[l.id]}))):r.append(this.createMenuItem(l.label,l.id,!1,l.checked)):r.append(this.createMenuItem(l.label,l.id,l.enabled!==!1,!!l.checked)):r.append(this.createMenuItem(l.label,l.id,l.enabled!==!1,!!l.checked)))})}setMenuById(r,o){this.menubarMenus&&this.menubarMenus[o]&&this.setMenu(r,this.menubarMenus[o].items)}insertCheckForUpdatesItems(r){const o=this.getUpdateMenuItems();o.length&&(o.forEach(l=>r.append(l)),r.append(s()))}createOpenRecentMenuItem(r){const o=S.URI.revive(r.uri),l=r.id,v=l==="openRecentFile"?{fileUri:o}:l==="openRecentWorkspace"?{workspaceUri:o}:{folderUri:o};return new w.MenuItem(this.likeAction(l,{label:r.label,click:(C,R,W)=>{const U=this.isOptionClick(W);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[v],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:r.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([o])}},!1))}isOptionClick(r){return!!(r&&(!P.isMacintosh&&(r.ctrlKey||r.shiftKey)||P.isMacintosh&&(r.metaKey||r.altKey)))}createRoleMenuItem(r,o,l){const v={label:this.mnemonicLabel(r),role:l,enabled:!0};return new w.MenuItem(this.withKeybinding(o,v))}setMacWindowMenu(r){const o=new w.MenuItem({label:m.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),l=new w.MenuItem({label:m.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),v=new w.MenuItem({label:m.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),C=this.createMenuItem(m.localize(20,null),"workbench.action.switchWindow"),R=[];this.currentEnableNativeTabs&&(R.push(s()),R.push(this.createMenuItem(m.localize(21,null),"workbench.action.newWindowTab")),R.push(this.createRoleMenuItem(m.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),R.push(this.createRoleMenuItem(m.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),R.push(this.createRoleMenuItem(m.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),R.push(this.createRoleMenuItem(m.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[o,l,s(),C,...R,s(),v].forEach(W=>r.append(W))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new w.MenuItem({label:this.mnemonicLabel(m.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new w.MenuItem({label:m.localize(27,null),enabled:!1})];case"available for download":return[new w.MenuItem({label:this.mnemonicLabel(m.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new w.MenuItem({label:m.localize(29,null),enabled:!1})];case"downloaded":return[new w.MenuItem({label:this.mnemonicLabel(m.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new w.MenuItem({label:m.localize(31,null),enabled:!1})];case"ready":return[new w.MenuItem({label:this.mnemonicLabel(m.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(r,o,l,v){const C=this.mnemonicLabel(r),R=typeof o=="function"?o:(X,J,H)=>{const B=X?X.userSettingsLabel:null;let Y=o;Array.isArray(o)&&(Y=this.isOptionClick(H)?o[1]:o[0]),B&&H.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:B}):this.runActionInRenderer({type:"commandId",commandId:Y})},W=typeof l=="boolean"?l:this.windowsMainService.getWindowCount()>0,U=typeof v=="boolean"?v:!1,G={label:C,click:R,enabled:W};U&&(G.type="checkbox",G.checked=U);let ee;return typeof o=="string"?ee=o:Array.isArray(o)&&(ee=o[0]),P.isMacintosh&&(ee==="editor.action.clipboardCutAction"?G.role="cut":ee==="editor.action.clipboardCopyAction"?G.role="copy":ee==="editor.action.clipboardPasteAction"&&(G.role="paste"),ee==="undo"?G.click=this.makeContextAwareClickHandler(R,{inDevTools:X=>X.undo(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("undo:")}):ee==="redo"?G.click=this.makeContextAwareClickHandler(R,{inDevTools:X=>X.redo(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("redo:")}):ee==="editor.action.selectAll"&&(G.click=this.makeContextAwareClickHandler(R,{inDevTools:X=>X.selectAll(),inNoWindow:()=>w.Menu.sendActionToFirstResponder("selectAll:")}))),new w.MenuItem(this.withKeybinding(ee,G))}makeContextAwareClickHandler(r,o){return(l,v,C)=>{const R=w.BrowserWindow.getFocusedWindow();if(!R)return o.inNoWindow();if(R.webContents.isDevToolsFocused()&&R.webContents.devToolsWebContents)return o.inDevTools(R.webContents.devToolsWebContents);r(l,v||R,C)}}runActionInRenderer(r){let o=w.BrowserWindow.getFocusedWindow();if(!o){const v=this.windowsMainService.getLastActiveWindow();v?.isMinimized()&&(o=v.win)}const l=o?this.windowsMainService.getWindowById(o.id):void 0;if(l){if(this.logService.trace("menubar#runActionInRenderer",r),P.isMacintosh&&!this.environmentMainService.isBuilt&&!l.isReady&&(r.type==="commandId"&&r.commandId==="workbench.action.toggleDevTools"||r.type!=="commandId"&&r.userSettingsLabel==="alt+cmd+i"))return;if(r.type==="commandId"){const v={id:r.commandId,from:"menu"};l.sendWhenReady("vscode:runAction",L.CancellationToken.None,v)}else{const v={userSettingsLabel:r.userSettingsLabel};l.sendWhenReady("vscode:runKeybinding",L.CancellationToken.None,v)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",r)}withKeybinding(r,o){const l=typeof r=="string"?this.keybindings[r]:void 0;if(l?.label){if(l.isNative!==!1)o.accelerator=l.label,o.userSettingsLabel=l.userSettingsLabel;else if(typeof o.label=="string"){const v=o.label.indexOf("[");v>=0?o.label=`${o.label.substr(0,v)} [${l.label}]`:o.label=`${o.label} [${l.label}]`}}else o.accelerator=void 0;return o}likeAction(r,o,l=!o.accelerator){l&&(o=this.withKeybinding(r,o));const v=o.click;return o.click=(C,R,W)=>{this.reportMenuActionTelemetry(r),v&&v(C,R,W)},o}openUrl(r,o){this.nativeHostMainService.openExternal(void 0,r),this.reportMenuActionTelemetry(o)}reportMenuActionTelemetry(r){this.telemetryService.publicLog2("workbenchActionExecuted",{id:r,from:a})}mnemonicLabel(r){return(0,D.mnemonicMenuLabel)(r,!this.currentEnableMenuBarMnemonics)}};f.lastKnownMenubarStorageKey="lastKnownMenubarData",f=ue([te(0,k.IUpdateService),te(1,I.IConfigurationService),te(2,u.IWindowsMainService),te(3,M.IEnvironmentMainService),te(4,y.ITelemetryService),te(5,c.IWorkspacesHistoryMainService),te(6,g.IStateMainService),te(7,E.ILifecycleMainService),te(8,b.ILogService),te(9,t.INativeHostMainService),te(10,h.IProductService)],f),e.Menubar=f;function s(){return new w.MenuItem({type:"separator"})}}),define(Z[245],x([0,1,5,18,6,244]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,w.createDecorator)("menubarMainService");let P=class{constructor(m,I,M){this.instantiationService=m,this.lifecycleMainService=I,this.logService=M,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(D.Menubar)}async updateMenubar(m,I){this.logService.trace("menubarService#updateMenubar",m),(await this.menubar).updateMenu(I,m)}};P=ue([te(0,w.IInstantiationService),te(1,n.ILifecycleMainService),te(2,L.ILogService)],P),e.MenubarMainService=P}),define(Z[246],x([0,1,12,29,26,30,23,4,28,43,33,3,10,7,63,2,36,17,14,8,158,51,19,47,22,20,5,18,6,53,21,54,78,38,66,243,102,226,25,103,67,42]),function(V,e,w,n,L,D,P,S,m,I,M,E,b,p,t,h,g,y,k,d,u,c,a,f,s,i,r,o,l,v,C,R,W,U,G,ee,X,J,H,B,Y,se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function $(z){return(0,H.isWorkspaceIdentifier)(z?.workspace)}function q(z){return(0,H.isSingleFolderWorkspaceIdentifier)(z?.workspace)}let Q=class rt extends E.Disposable{constructor(F,N,T,A,O,_,j,ie,ae,ce,ne,le,he,we,be){super();this.machineId=F,this.initialUserEnv=N,this.logService=T,this.stateMainService=A,this.environmentMainService=O,this.lifecycleMainService=_,this.backupMainService=j,this.configurationService=ie,this.workspacesHistoryMainService=ae,this.workspacesManagementMainService=ce,this.instantiationService=ne,this.dialogMainService=le,this.fileService=he,this.productService=we,this.protocolMainService=be,this._onDidOpenWindow=this._register(new S.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new S.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new S.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new S.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new J.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(F=>this._onDidSignalReadyWindow.fire(F.window))),this._register(this.onDidSignalReadyWindow(F=>{if(F.config?.extensionDevelopmentPath||F.config?.extensionTestsPath){const N=new E.DisposableStore;if(N.add(S.Event.any(F.onDidClose,F.onDidDestroy)(()=>N.dispose())),F.config.extensionDevelopmentPath)for(const T of F.config.extensionDevelopmentPath)N.add(this.protocolMainService.addValidFileRoot(T));F.config.extensionTestsPath&&N.add(this.protocolMainService.addValidFileRoot(F.config.extensionTestsPath))}}))}openEmptyWindow(F,N){let T=this.environmentMainService.args;const A=N?.remoteAuthority||void 0,O=!0,_=N?.forceReuseWindow,j=!_;return this.open({...F,cli:T,forceEmpty:O,forceNewWindow:j,forceReuseWindow:_,remoteAuthority:A})}openExistingWindow(F,N){F.focus(),this.handleWaitMarkerFile(N,[F])}open(F){this.logService.trace("windowsManager#open"),F.addMode&&(F.initialStartup||!this.getLastActiveWindow())&&(F.addMode=!1);const N=[],T=[],A=[],O=[],_=[];let j,ie=0;const ae=this.getPathsToOpen(F);this.logService.trace("windowsManager#open pathsToOpen",ae);for(const he of ae)q(he)?F.addMode?N.push(he):T.push(he):$(he)?A.push(he):he.fileUri?(j||(j={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:he.remoteAuthority}),j.filesToOpenOrCreate.push(he)):he.backupPath?_.push({backupFolder:(0,p.basename)(he.backupPath),remoteAuthority:he.remoteAuthority}):ie++;F.diffMode&&j&&j.filesToOpenOrCreate.length>=2&&(j.filesToDiff=j.filesToOpenOrCreate.slice(0,2),j.filesToOpenOrCreate=[]),j&&F.waitMarkerFileURI&&(j.filesToWait={paths:[...j.filesToDiff,...j.filesToOpenOrCreate],waitMarkerFileUri:F.waitMarkerFileURI}),F.initialStartup?(O.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),A.push(...O),_.push(...this.backupMainService.getEmptyWindowBackupPaths())):_.length=0;const{windows:ce,filesOpenedInWindow:ne}=this.doOpen(F,A,T,_,ie,j,N);if(this.logService.trace(`windowsManager#open used window count ${ce.length} (workspacesToOpen: ${A.length}, foldersToOpen: ${T.length}, emptyToRestore: ${_.length}, emptyToOpen: ${ie})`),ce.length>1)if(ne)ne.focus();else{const he=this.windowsStateHandler.state.lastActiveWindow&&!F.forceEmpty&&!F.cli._.length&&!F.cli["file-uri"]&&!F.cli["folder-uri"]&&!(F.urisToOpen&&F.urisToOpen.length);let we=!0,be=!0;if(he){const Me=ce.filter(Se=>this.windowsStateHandler.state.lastActiveWindow&&Se.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Me.length&&(Me[0].focus(),we=!1,be=!1)}if(we)for(let Me=ce.length-1;Me>=0;Me--){const Se=ce[Me];if(!(Se.openedWorkspace&&O.some(pe=>Se.openedWorkspace&&pe.workspace.id===Se.openedWorkspace.id)||Se.backupPath&&_.some(pe=>Se.backupPath&&pe.backupFolder===(0,p.basename)(Se.backupPath)))){Se.focus(),be=!1;break}}be&&ce[ce.length-1].focus()}const le=j&&j.filesToDiff.length>0;if(!ce.some(he=>he.isExtensionDevelopmentHost)&&!le&&!F.noRecentEntry){const he=[];for(const we of ae)$(we)&&!we.transient?he.push({label:we.label,workspace:we.workspace,remoteAuthority:we.remoteAuthority}):q(we)?he.push({label:we.label,folderUri:we.workspace.uri,remoteAuthority:we.remoteAuthority}):we.fileUri&&he.push({label:we.label,fileUri:we.fileUri,remoteAuthority:we.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(he)}return this.handleWaitMarkerFile(F,ce),ce}handleWaitMarkerFile(F,N){const T=F.waitMarkerFileURI;F.context===0&&T&&N.length===1&&N[0]&&(async()=>{await N[0].whenClosedOrLoaded;try{await this.fileService.del(T)}catch{}})()}doOpen(F,N,T,A,O,_,j){const ie=[];let ae;function ce(Se,pe){ie.push(Se),pe&&(ae=Se,_=void 0)}let{openFolderInNewWindow:ne,openFilesInNewWindow:le}=this.shouldOpenNewWindow(F);if(!F.initialStartup&&j.length>0){const Se=j[0].remoteAuthority,pe=this.getLastActiveWindowForAuthority(Se);pe&&ce(this.doAddFoldersToExistingWindow(pe,j.map(Ee=>Ee.workspace.uri)))}const he=T.length+N.length+A.length;if(_&&he===0){const Se=_.filesToOpenOrCreate[0]||_.filesToDiff[0],pe=this.getWindows().filter(Le=>_&&(0,y.isEqualAuthority)(Le.remoteAuthority,_.remoteAuthority));let Ee;Se?.fileUri&&!le&&((F.context===4||F.context===0||F.context===1)&&(Ee=(0,X.findWindowOnFile)(pe,Se.fileUri,Le=>Le.configPath.scheme===b.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Le.configPath):void 0)),Ee||(Ee=this.doGetLastActiveWindow(pe))),Ee?(0,H.isWorkspaceIdentifier)(Ee.openedWorkspace)?N.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):(0,H.isSingleFolderWorkspaceIdentifier)(Ee.openedWorkspace)?T.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):ce(this.doOpenFilesInExistingWindow(F,Ee,_),!0):ce(this.openInBrowserWindow({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,filesToOpen:_,forceNewWindow:!0,remoteAuthority:_.remoteAuthority,forceNewTabbedWindow:F.forceNewTabbedWindow}),!0)}const we=(0,D.distinct)(N,Se=>Se.workspace.id);if(we.length>0){const Se=(0,D.coalesce)(we.map(pe=>(0,X.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.configPath)));if(Se.length>0){const pe=Se[0],Ee=(0,y.isEqualAuthority)(_?.remoteAuthority,pe.remoteAuthority)?_:void 0;ce(this.doOpenFilesInExistingWindow(F,pe,Ee),!!Ee),ne=!0}we.forEach(pe=>{if(Se.some(Ne=>Ne.openedWorkspace&&Ne.openedWorkspace.id===pe.workspace.id))return;const Ee=pe.remoteAuthority,Le=(0,y.isEqualAuthority)(_?.remoteAuthority,Ee)?_:void 0;ce(this.doOpenFolderOrWorkspace(F,pe,ne,Le),!!Le),ne=!0})}const be=(0,D.distinct)(T,Se=>y.extUriBiasedIgnorePathCase.getComparisonKey(Se.workspace.uri));if(be.length>0){const Se=(0,D.coalesce)(be.map(pe=>(0,X.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.uri)));if(Se.length>0){const pe=Se[0],Ee=(0,y.isEqualAuthority)(_?.remoteAuthority,pe.remoteAuthority)?_:void 0;ce(this.doOpenFilesInExistingWindow(F,pe,Ee),!!Ee),ne=!0}be.forEach(pe=>{if(Se.some(Ne=>(0,H.isSingleFolderWorkspaceIdentifier)(Ne.openedWorkspace)&&y.extUriBiasedIgnorePathCase.isEqual(Ne.openedWorkspace.uri,pe.workspace.uri)))return;const Ee=pe.remoteAuthority,Le=(0,y.isEqualAuthority)(_?.remoteAuthority,Ee)?_:void 0;ce(this.doOpenFolderOrWorkspace(F,pe,ne,Le),!!Le),ne=!0})}const Me=(0,D.distinct)(A,Se=>Se.backupFolder);if(Me.length>0&&Me.forEach(Se=>{const pe=Se.remoteAuthority,Ee=(0,y.isEqualAuthority)(_?.remoteAuthority,pe)?_:void 0;ce(this.doOpenEmpty(F,!0,pe,Ee,Se),!!Ee),ne=!0}),ie.length===0||_){_&&!O&&O++;const Se=_?_.remoteAuthority:F.remoteAuthority;for(let pe=0;pe<O;pe++)ce(this.doOpenEmpty(F,ne,Se,_),!!_),ne=!0}return{windows:(0,D.distinct)(ie),filesOpenedInWindow:ae}}doOpenFilesInExistingWindow(F,N,T){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:T}),N.focus();const A={filesToOpenOrCreate:T?.filesToOpenOrCreate,filesToDiff:T?.filesToDiff,filesToWait:T?.filesToWait,termProgram:F?.userEnv?.TERM_PROGRAM};return N.sendWhenReady("vscode:openFiles",P.CancellationToken.None,A),N}doAddFoldersToExistingWindow(F,N){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:N}),F.focus();const T={foldersToAdd:N};return F.sendWhenReady("vscode:addFolders",P.CancellationToken.None,T),F}doOpenEmpty(F,N,T,A,O){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!O,remoteAuthority:T,filesToOpen:A,forceNewWindow:N});let _;return!N&&typeof F.contextWindowId=="number"&&(_=this.getWindowById(F.contextWindowId)),this.openInBrowserWindow({userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:T,forceNewWindow:N,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:A,windowToUse:_,emptyWindowBackupInfo:O})}doOpenFolderOrWorkspace(F,N,T,A,O){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:N,filesToOpen:A}),!T&&!O&&typeof F.contextWindowId=="number"&&(O=this.getWindowById(F.contextWindowId)),this.openInBrowserWindow({workspace:N.workspace,userEnv:F.userEnv,cli:F.cli,initialStartup:F.initialStartup,remoteAuthority:N.remoteAuthority,forceNewWindow:T,forceNewTabbedWindow:F.forceNewTabbedWindow,filesToOpen:A,windowToUse:O})}getPathsToOpen(F){let N,T=!1,A=!1;if(F.urisToOpen&&F.urisToOpen.length>0?(N=this.doExtractPathsFromAPI(F),T=!0):F.forceEmpty?N=[Object.create(null)]:F.cli._.length||F.cli["folder-uri"]||F.cli["file-uri"]?(N=this.doExtractPathsFromCLI(F.cli),N.length===0&&N.push(Object.create(null)),T=!0):(N=this.doGetPathsFromLastSession(),N.length===0&&N.push(Object.create(null)),A=!0),!F.addMode&&T){const O=N.filter(_=>q(_));if(O.length>1){const _=O[0].remoteAuthority;if(O.every(j=>(0,y.isEqualAuthority)(j.remoteAuthority,_))){const j=this.workspacesManagementMainService.createUntitledWorkspaceSync(O.map(ie=>({uri:ie.workspace.uri})));N.push({workspace:j,remoteAuthority:_}),N=N.filter(ie=>!q(ie))}}}return F.initialStartup&&!A&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&N.unshift(...this.doGetPathsFromLastSession().filter(O=>$(O)||q(O)||O.backupPath)),N}doExtractPathsFromAPI(F){const N=[],T={gotoLineMode:F.gotoLineMode,remoteAuthority:F.remoteAuthority};for(const A of(0,D.coalesce)(F.urisToOpen||[])){const O=this.resolveOpenable(A,T);if(O)O.label=A.label,N.push(O);else{const _=this.resourceFromOpenable(A),j={title:this.productService.nameLong,type:"info",buttons:[(0,M.mnemonicButtonLabel)((0,u.localize)(0,null))],defaultId:0,message:_.scheme===b.Schemas.file?(0,u.localize)(1,null):(0,u.localize)(2,null),detail:_.scheme===b.Schemas.file?(0,u.localize)(3,null,(0,M.getPathLabel)(_.fsPath,this.environmentMainService)):(0,u.localize)(4,null,_.toString()),noLink:!0};this.dialogMainService.showMessageBox(j,(0,k.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow()))}}return N}doExtractPathsFromCLI(F){const N=[],T={ignoreFileNotFound:!0,gotoLineMode:F.goto,remoteAuthority:F.remote||void 0,forceOpenWorkspaceAsFile:!1},A=F["folder-uri"];if(A)for(const j of A){const ie=this.cliArgToUri(j);if(ie){const ae=this.resolveOpenable({folderUri:ie},T);ae&&N.push(ae)}}const O=F["file-uri"];if(O)for(const j of O){const ie=this.cliArgToUri(j);if(ie){const ae=this.resolveOpenable((0,H.hasWorkspaceFileExtension)(j)?{workspaceUri:ie}:{fileUri:ie},T);ae&&N.push(ae)}}const _=F._;for(const j of _){const ie=T.remoteAuthority?this.doResolvePathRemote(j,T):this.doResolveFilePath(j,T);ie&&N.push(ie)}return N}cliArgToUri(F){try{const N=d.URI.parse(F);if(!N.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${F}`);return}return N}catch(N){this.logService.error(`Invalid URI input string: ${F}, ${N.message}`)}}doGetPathsFromLastSession(){const F=this.getRestoreWindowsSetting();switch(F){case"none":return[];case"one":case"all":case"preserve":case"folders":{const N=[];F!=="one"&&N.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&N.push(this.windowsStateHandler.state.lastActiveWindow);const T=[];for(const A of N)if(A.workspace){const O=this.resolveOpenable({workspaceUri:A.workspace.configPath},{remoteAuthority:A.remoteAuthority,rejectTransientWorkspaces:!0});$(O)&&T.push(O)}else if(A.folderUri){const O=this.resolveOpenable({folderUri:A.folderUri},{remoteAuthority:A.remoteAuthority});q(O)&&T.push(O)}else F!=="folders"&&A.backupPath&&T.push({backupPath:A.backupPath,remoteAuthority:A.remoteAuthority});return T}}}getRestoreWindowsSetting(){let F;return this.lifecycleMainService.wasRestarted?F="all":(F=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(F)||(F="all")),F}resolveOpenable(F,N=Object.create(null)){let T=this.resourceFromOpenable(F);return T.scheme===b.Schemas.file?((0,G.isFileToOpen)(F)&&(N={...N,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(T.fsPath,N)):this.doResolveRemoteOpenable(F,N)}doResolveRemoteOpenable(F,N){let T=this.resourceFromOpenable(F);const A=(0,W.getRemoteAuthority)(T)||N.remoteAuthority;if(T=(0,y.removeTrailingPathSeparator)((0,y.normalizePath)(T)),(0,G.isFileToOpen)(F)){if(N.gotoLineMode){const{path:O,line:_,column:j}=(0,m.parseLineAndColumnAware)(T.path);return{fileUri:T.with({path:O}),selection:_?{startLineNumber:_,startColumn:j||1}:void 0,remoteAuthority:A}}return{fileUri:T,remoteAuthority:A}}else if((0,G.isWorkspaceToOpen)(F))return{workspace:(0,B.getWorkspaceIdentifier)(T),remoteAuthority:A};return{workspace:(0,B.getSingleFolderWorkspaceIdentifier)(T),remoteAuthority:A}}resourceFromOpenable(F){return(0,G.isWorkspaceToOpen)(F)?F.workspaceUri:(0,G.isFolderToOpen)(F)?F.folderUri:F.fileUri}doResolveFilePath(F,N){let T,A;N.gotoLineMode&&({path:F,line:T,column:A}=(0,m.parseLineAndColumnAware)(F)),F=(0,m.sanitizeFilePath)((0,p.normalize)(F),(0,g.cwd)());try{const O=(0,n.statSync)(F);if(O.isFile()){if(!N.forceOpenWorkspaceAsFile){const _=this.workspacesManagementMainService.resolveLocalWorkspaceSync(d.URI.file(F));if(_)return _.transient&&N.rejectTransientWorkspaces?void 0:{workspace:{id:_.id,configPath:_.configPath},type:i.FileType.File,exists:!0,remoteAuthority:_.remoteAuthority,transient:_.transient}}return{fileUri:d.URI.file(F),type:i.FileType.File,exists:!0,selection:T?{startLineNumber:T,startColumn:A||1}:void 0}}else{if(O.isDirectory())return{workspace:(0,B.getSingleFolderWorkspaceIdentifier)(d.URI.file(F),O),type:i.FileType.Directory,exists:!0};if(!h.isWindows&&F==="/dev/null")return{fileUri:d.URI.file(F),type:i.FileType.File,exists:!0}}}catch{const _=d.URI.file(F);if(this.workspacesHistoryMainService.removeRecentlyOpened([_]),N.ignoreFileNotFound)return{fileUri:_,type:i.FileType.File,exists:!1}}}doResolvePathRemote(F,N){const T=F.charCodeAt(0),A=N.remoteAuthority;let O,_;N.gotoLineMode&&({path:F,line:O,column:_}=(0,m.parseLineAndColumnAware)(F)),T!==47&&((0,m.isWindowsDriveLetter)(T)&&F.charCodeAt(F.charCodeAt(1))===58&&(F=(0,m.toSlashes)(F)),F=`/${F}`);const j=d.URI.from({scheme:b.Schemas.vscodeRemote,authority:A,path:F});if(F.charCodeAt(F.length-1)!==47){if((0,H.hasWorkspaceFileExtension)(F))return N.forceOpenWorkspaceAsFile?{fileUri:j,selection:O?{startLineNumber:O,startColumn:_||1}:void 0,remoteAuthority:N.remoteAuthority}:{workspace:(0,B.getWorkspaceIdentifier)(j),remoteAuthority:A};if(N.gotoLineMode||p.posix.basename(F).indexOf(".")!==-1)return{fileUri:j,selection:O?{startLineNumber:O,startColumn:_||1}:void 0,remoteAuthority:A}}return{workspace:(0,B.getSingleFolderWorkspaceIdentifier)(j),remoteAuthority:A}}shouldOpenNewWindow(F){const N=this.configurationService.getValue("window"),T=N?.openFoldersInNewWindow||"default",A=N?.openFilesInNewWindow||"off";let O=(F.preferNewWindow||F.forceNewWindow)&&!F.forceReuseWindow;!F.forceNewWindow&&!F.forceReuseWindow&&(T==="on"||T==="off")&&(O=T==="on");let _=!1;return F.forceNewWindow||F.forceReuseWindow?_=!!F.forceNewWindow&&!F.forceReuseWindow:(h.isMacintosh?F.context===1&&(_=!0):F.context!==3&&F.context!==2&&!(F.userEnv&&F.userEnv.TERM_PROGRAM==="vscode")&&(_=!0),!F.cli.extensionDevelopmentPath&&(A==="on"||A==="off")&&(_=A==="on")),{openFolderInNewWindow:!!O,openFilesInNewWindow:_}}openExtensionDevelopmentHostWindow(F,N){const T=(0,X.findWindowOnExtensionDevelopmentPath)(this.getWindows(),F);if(T)return this.lifecycleMainService.reload(T,N.cli),T.focus(),[T];let A=N.cli["folder-uri"]||[],O=N.cli["file-uri"]||[],_=N.cli._;if(!_.length&&!A.length&&!O.length&&!N.cli.extensionTestsPath){const ce=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ne=ce&&(ce.workspace||ce.folderUri);ne&&(d.URI.isUri(ne)?ne.scheme===b.Schemas.file?_=[ne.fsPath]:A=[ne.toString()]:ne.configPath.scheme===b.Schemas.file?_=[(0,y.originalFSPath)(ne.configPath)]:O=[ne.configPath.toString()])}let j=N.remoteAuthority;for(const ce of F)if(ce.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ne=d.URI.parse(ce),le=(0,W.getRemoteAuthority)(ne);le&&(j?(0,y.isEqualAuthority)(le,j)||this.logService.error("more than one extension development path authority"):j=le)}_=_.filter(ce=>{const ne=d.URI.file(ce);return(0,X.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:(0,y.isEqualAuthority)((0,W.getRemoteAuthority)(ne),j)}),A=A.filter(ce=>{const ne=this.cliArgToUri(ce);return ne&&!!(0,X.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:ne?(0,y.isEqualAuthority)((0,W.getRemoteAuthority)(ne),j):!1}),O=O.filter(ce=>{const ne=this.cliArgToUri(ce);return ne&&!!(0,X.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:ne?(0,y.isEqualAuthority)((0,W.getRemoteAuthority)(ne),j):!1}),N.cli._=_,N.cli["folder-uri"]=A,N.cli["file-uri"]=O;const ie=!_.length&&!A.length&&!O.length,ae={context:N.context,cli:N.cli,forceNewWindow:!0,forceEmpty:ie,userEnv:N.userEnv,noRecentEntry:!0,waitMarkerFileURI:N.waitMarkerFileURI,remoteAuthority:j};return this.open(ae)}openInBrowserWindow(F){const N=this.configurationService.getValue("window"),T={...this.environmentMainService.args,...F.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:F.emptyWindowBackupInfo?(0,p.join)(this.environmentMainService.backupHome,F.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:F.remoteAuthority,workspace:F.workspace,userEnv:{...this.initialUserEnv,...F.userEnv},filesToOpenOrCreate:F.filesToOpen?.filesToOpenOrCreate,filesToDiff:F.filesToOpen?.filesToDiff,filesToWait:F.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:v.default,isInitialStartup:F.initialStartup,perfMarks:(0,t.getMarks)(),os:{release:(0,L.release)(),hostname:(0,L.hostname)()},zoomLevel:typeof N?.zoomLevel=="number"?N.zoomLevel:void 0,autoDetectHighContrast:N?.autoDetectHighContrast??!0,accessibilitySupport:w.app.accessibilitySupportEnabled,colorScheme:{dark:w.nativeTheme.shouldUseDarkColors,highContrast:w.nativeTheme.shouldUseInvertedColorScheme||w.nativeTheme.shouldUseHighContrastColors}};let A;if(!F.forceNewWindow&&!F.forceNewTabbedWindow&&(A=F.windowToUse||this.getLastActiveWindow(),A&&A.focus()),A){const O=A.config;!T.extensionDevelopmentPath&&O&&!!O.extensionDevelopmentPath&&(T.extensionDevelopmentPath=O.extensionDevelopmentPath,T.verbose=O.verbose,T["inspect-brk-extensions"]=O["inspect-brk-extensions"],T.debugId=O.debugId,T.extensionEnvironment=O.extensionEnvironment,T["inspect-extensions"]=O["inspect-extensions"],T["extensions-dir"]=O["extensions-dir"])}else{const O=this.windowsStateHandler.getNewWindowState(T);(0,t.mark)("code/willCreateCodeWindow");const _=A=this.instantiationService.createInstance(ee.CodeWindow,{state:O,extensionDevelopmentPath:T.extensionDevelopmentPath,isExtensionTestHost:!!T.extensionTestsPath});if((0,t.mark)("code/didCreateCodeWindow"),F.forceNewTabbedWindow){const ie=this.getLastActiveWindow();ie&&ie.addTabbedWindow(_)}rt.WINDOWS.push(_),this._onDidOpenWindow.fire(_),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,I.once)(_.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(_)),(0,I.once)(_.onDidClose)(()=>this.onWindowClosed(_)),(0,I.once)(_.onDidDestroy)(()=>this._onDidDestroyWindow.fire(_));const j=(0,k.assertIsDefined)(_.win?.webContents);j.removeAllListeners("devtools-reload-page"),j.on("devtools-reload-page",()=>this.lifecycleMainService.reload(_)),this.lifecycleMainService.registerWindow(_)}return T.windowId=A.id,A.isReady?this.lifecycleMainService.unload(A,4).then(O=>{O||this.doOpenInBrowserWindow(A,T,F)}):this.doOpenInBrowserWindow(A,T,F),A}doOpenInBrowserWindow(F,N,T){if(!N.extensionDevelopmentPath)if((0,H.isWorkspaceIdentifier)(N.workspace))N.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:N.workspace,remoteAuthority:N.remoteAuthority});else if((0,H.isSingleFolderWorkspaceIdentifier)(N.workspace))N.backupPath=this.backupMainService.registerFolderBackupSync({folderUri:N.workspace.uri,remoteAuthority:N.remoteAuthority});else{const A=T.emptyWindowBackupInfo&&T.emptyWindowBackupInfo.backupFolder;N.backupPath=this.backupMainService.registerEmptyWindowBackupSync(A,N.remoteAuthority)}F.load(N)}onWindowClosed(F){const N=rt.WINDOWS.indexOf(F);rt.WINDOWS.splice(N,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const F=w.BrowserWindow.getFocusedWindow();if(F)return this.getWindowById(F.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(F){return this.doGetLastActiveWindow(this.getWindows().filter(N=>(0,y.isEqualAuthority)(N.remoteAuthority,F)))}doGetLastActiveWindow(F){const N=Math.max.apply(Math,F.map(T=>T.lastFocusTime));return F.find(T=>T.lastFocusTime===N)}sendToFocused(F,...N){const T=this.getFocusedWindow()||this.getLastActiveWindow();T&&T.sendWhenReady(F,P.CancellationToken.None,...N)}sendToAll(F,N,T){for(const A of this.getWindows())T&&T.indexOf(A.id)>=0||A.sendWhenReady(F,P.CancellationToken.None,N)}getWindows(){return rt.WINDOWS}getWindowCount(){return rt.WINDOWS.length}getWindowById(F){const N=this.getWindows().filter(T=>T.id===F);return(0,D.firstOrDefault)(N)}getWindowByWebContents(F){const N=w.BrowserWindow.fromWebContents(F);if(!!N)return this.getWindowById(N.id)}};Q.WINDOWS=[],Q=ue([te(2,l.ILogService),te(3,U.IStateMainService),te(4,s.IEnvironmentMainService),te(5,o.ILifecycleMainService),te(6,c.IBackupMainService),te(7,a.IConfigurationService),te(8,Y.IWorkspacesHistoryMainService),te(9,se.IWorkspacesManagementMainService),te(10,r.IInstantiationService),te(11,f.IDialogMainService),te(12,i.IFileService),te(13,C.IProductService),te(14,R.IProtocolMainService)],Q),e.WindowsMainService=Q}),define(Z[247],x([0,1,51,34,67,42]),function(V,e,w,n,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let P=class{constructor(m,I,M,E){this.workspacesManagementMainService=m,this.windowsMainService=I,this.workspacesHistoryMainService=M,this.backupMainService=E,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(m,I){const M=this.windowsMainService.getWindowById(m);if(M)return this.workspacesManagementMainService.enterWorkspace(M,this.windowsMainService.getWindows(),I)}createUntitledWorkspace(m,I,M){return this.workspacesManagementMainService.createUntitledWorkspace(I,M)}deleteUntitledWorkspace(m,I){return this.workspacesManagementMainService.deleteUntitledWorkspace(I)}getWorkspaceIdentifier(m,I){return this.workspacesManagementMainService.getWorkspaceIdentifier(I)}getRecentlyOpened(m){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(m))}addRecentlyOpened(m,I){return this.workspacesHistoryMainService.addRecentlyOpened(I)}removeRecentlyOpened(m,I){return this.workspacesHistoryMainService.removeRecentlyOpened(I)}clearRecentlyOpened(m){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};P=ue([te(0,D.IWorkspacesManagementMainService),te(1,n.IWindowsMainService),te(2,L.IWorkspacesHistoryMainService),te(3,w.IBackupMainService)],P),e.WorkspacesMainService=P}),define(Z[248],x([0,1,12,29,26,16,39,15,28,43,44,33,3,10,7,2,14,8,31,71,126,37,129,89,221,139,51,230,19,74,195,168,75,104,47,231,92,166,22,50,98,174,196,175,227,93,176,177,20,190,77,73,5,76,240,206,105,18,6,192,245,58,21,78,235,79,38,224,81,207,32,209,211,64,41,215,238,241,239,242,100,216,217,218,219,222,34,246,223,25,80,67,247,42]),function(V,e,w,n,L,D,P,S,m,I,M,E,b,p,t,h,g,y,k,d,u,c,a,f,s,i,r,o,l,v,C,R,W,U,G,ee,X,J,H,B,Y,se,$,q,Q,z,F,N,T,A,O,_,j,ie,ae,ce,ne,le,he,we,be,Me,Se,pe,Ee,Le,Ne,Ze,Fe,ze,Ge,st,wt,ot,Ye,He,Qe,K,re,oe,fe,ye,Re,Oe,Ke,Ve,Ae,qe,je,xe,tt,kt,Lt,Pt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let pt=class extends b.Disposable{constructor(de,me,ve,ge,Pe,De,Ce,Ie,ke,We){super();this.mainProcessNodeIpcServer=de,this.userEnv=me,this.mainInstantiationService=ve,this.logService=ge,this.environmentMainService=Pe,this.lifecycleMainService=De,this.configurationService=Ce,this.stateMainService=Ie,this.fileService=ke,this.productService=We,this.configureSession(),this.registerListeners()}configureSession(){const de=Ie=>Ie?.startsWith(`${p.Schemas.vscodeWebview}://`),me=new Set(["clipboard-read","clipboard-sanitized-write"]);w.session.defaultSession.setPermissionRequestHandler((Ie,ke,We,_e)=>de(_e.requestingUrl)?We(me.has(ke)):We(!1)),w.session.defaultSession.setPermissionCheckHandler((Ie,ke,We,_e)=>de(_e.requestingUrl)?me.has(ke):!1);const ve=new Set([p.Schemas.file,p.Schemas.vscodeFileResource,p.Schemas.vscodeRemoteResource,"devtools"]),ge=Ie=>{for(let ke=Ie;ke;ke=ke.parent)if(ke.url.startsWith(`${p.Schemas.vscodeWebview}://`))return!0;return!1},Pe=Ie=>Ie.resourceType==="xhr"||ge(Ie.frame),De=Ie=>{const ke=Ie.frame;if(!ke||!this.windowsMainService)return!1;const We=w.BrowserWindow.getAllWindows();for(const _e of We)if(ke.processId===_e.webContents.mainFrame.processId)return!0;return!1};w.session.defaultSession.webRequest.onBeforeRequest((Ie,ke)=>{const We=y.URI.parse(Ie.url);return We.scheme===p.Schemas.vscodeFileResource&&!De(Ie)?(this.logService.error("Blocked vscode-file request",Ie.url),ke({cancel:!0})):We.path.endsWith(".svg")&&!ve.has(We.scheme)?ke({cancel:!Pe(Ie)}):ke({cancel:!1})}),w.session.defaultSession.webRequest.onHeadersReceived((Ie,ke)=>{const We=Ie.responseHeaders,_e=We["content-type"]||We["Content-Type"];if(_e&&Array.isArray(_e)){const Xe=y.URI.parse(Ie.url);if(Xe.path.endsWith(".svg")&&ve.has(Xe.scheme))return We["Content-Type"]=["image/svg+xml"],ke({cancel:!1,responseHeaders:We});if(!Xe.path.includes(p.Schemas.vscodeRemoteResource)&&_e.some(et=>et.toLowerCase().includes("image/svg")))return ke({cancel:!Pe(Ie)})}return ke({cancel:!1})});const Ce=w.session.defaultSession;typeof Ce.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Ce.setCodeCachePath((0,t.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,S.setUnexpectedErrorHandler)(ve=>this.onUnexpectedError(ve)),process.on("uncaughtException",ve=>(0,S.onUnexpectedError)(ve)),process.on("unhandledRejection",ve=>(0,S.onUnexpectedError)(ve)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,u.registerContextMenuListener)(),w.app.on("accessibility-support-changed",(ve,ge)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",ge)}),w.app.on("activate",(ve,ge)=>{this.logService.trace("app#activate"),ge||this.windowsMainService?.openEmptyWindow({context:1})}),w.app.on("web-contents-created",(ve,ge)=>{ge.on("will-navigate",Pe=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Pe.preventDefault()}),ge.setWindowOpenHandler(({url:Pe})=>(this.nativeHostMainService?.openExternal(void 0,Pe),{action:"deny"}))});let de=[],me;w.app.on("open-file",(ve,ge)=>{this.logService.trace("app#open-file: ",ge),ve.preventDefault(),de.push(this.getWindowOpenableFromPathSync(ge)),me!==void 0&&(clearTimeout(me),me=void 0),me=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:de,gotoLineMode:!1,preferNewWindow:!0}),de=[],me=void 0},100)}),w.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),w.ipcMain.handle("vscode:fetchShellEnv",ve=>{const ge=this.windowsMainService?.getWindowByWebContents(ve.sender);let Pe,De;return ge?.config?(Pe=ge.config,De={...process.env,...ge.config.userEnv}):(Pe=this.environmentMainService.args,De=process.env),this.resolveShellEnvironment(Pe,De,!1)}),w.ipcMain.handle("vscode:writeNlsFile",(ve,ge,Pe)=>{const De=this.validateNlsPath([ge]);if(!De||typeof Pe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(De,D.VSBuffer.fromString(Pe))}),w.ipcMain.handle("vscode:readNlsFile",async(ve,...ge)=>{const Pe=this.validateNlsPath(ge);if(!Pe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Pe)).value.toString()}),w.ipcMain.on("vscode:toggleDevTools",ve=>ve.sender.toggleDevTools()),w.ipcMain.on("vscode:openDevTools",ve=>ve.sender.openDevTools()),w.ipcMain.on("vscode:reloadWindow",ve=>ve.sender.reload())}validateNlsPath(de){let me;for(const ve of de)typeof ve=="string"&&(typeof me!="string"?me=ve:me=(0,t.join)(me,ve));if(!(typeof me!="string"||!(0,t.isAbsolute)(me)||!(0,m.isEqualOrParent)(me,this.environmentMainService.cachedLanguagesPath,!h.isLinux)))return y.URI.file(me)}onUnexpectedError(de){if(de){const me={message:`[uncaught exception in main]: ${de.message}`,stack:de.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(me))}this.logService.error(`[uncaught exception in main]: ${de}`),de.stack&&this.logService.error(de.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const de=this.productService.win32AppUserModelId;h.isWindows&&de&&w.app.setAppUserModelId(de);try{h.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!w.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&w.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(ke){this.logService.error(ke)}const me=new a.Server;this.logService.trace("Resolving machine identifier...");const ve=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${ve}`);const{sharedProcess:ge,sharedProcessReady:Pe,sharedProcessClient:De}=this.setupSharedProcess(ve),Ce=await this.initServices(ve,ge,Pe);if(this.environmentMainService.driverHandle){const ke=await(0,ee.serve)(me,this.environmentMainService.driverHandle,this.environmentMainService,Ce);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(ke)}this._register(Ce.createInstance(s.ProxyAuthHandler)),Ce.invokeFunction(ke=>this.initChannels(ke,me,De));const Ie=Ce.invokeFunction(ke=>this.openFirstWindow(ke,me));Ce.invokeFunction(ke=>this.afterWindowOpen(ke,ge)),this.environmentMainService.args.trace&&Ce.invokeFunction(ke=>this.stopTracingEventually(ke,Ie))}async resolveMachineId(){let de=this.stateMainService.getItem(Ge.machineIdKey);return(!de||h.isMacintosh&&de==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(de=await(0,d.getMachineId)(),this.stateMainService.setItem(Ge.machineIdKey,de)),de}setupSharedProcess(de){const me=this._register(this.mainInstantiationService.createInstance(Ee.SharedProcess,de,this.userEnv)),ve=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Pe=await me.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new f.Client(Pe,"main")})(),ge=(async()=>(await me.whenReady(),ve))();return{sharedProcess:me,sharedProcessReady:ge,sharedProcessClient:ve}}async initServices(de,me,ve){const ge=new ie.ServiceCollection;switch(process.platform){case"win32":ge.set(Ye.IUpdateService,new _.SyncDescriptor(oe.Win32UpdateService));break;case"linux":h.isLinuxSnap?ge.set(Ye.IUpdateService,new _.SyncDescriptor(re.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ge.set(Ye.IUpdateService,new _.SyncDescriptor(K.LinuxUpdateService));break;case"darwin":ge.set(Ye.IUpdateService,new _.SyncDescriptor(Qe.DarwinUpdateService));break}ge.set(Ae.IWindowsMainService,new _.SyncDescriptor(qe.WindowsMainService,[de,this.userEnv])),ge.set(G.IDialogMainService,new _.SyncDescriptor(G.DialogMainService)),ge.set(ne.ILaunchMainService,new _.SyncDescriptor(ne.LaunchMainService)),ge.set(U.IDiagnosticsMainService,new _.SyncDescriptor(U.DiagnosticsMainService)),ge.set(W.IDiagnosticsService,c.ProxyChannel.toService((0,c.getDelayedChannel)(ve.then(De=>De.getChannel("diagnostics"))))),ge.set(ae.IIssueMainService,new _.SyncDescriptor(ae.IssueMainService,[this.userEnv])),ge.set(X.IEncryptionMainService,new _.SyncDescriptor(J.EncryptionMainService,[de])),ge.set(ce.IKeyboardLayoutMainService,new _.SyncDescriptor(ce.KeyboardLayoutMainService)),ge.set(Me.INativeHostMainService,new _.SyncDescriptor(Me.NativeHostMainService,[me])),ge.set(v.ICredentialsMainService,new _.SyncDescriptor(C.CredentialsMainService,[!1])),ge.set(Ke.IWebviewManagerService,new _.SyncDescriptor(Ve.WebviewMainService)),ge.set(tt.IWorkspacesService,new _.SyncDescriptor(Lt.WorkspacesMainService)),ge.set(Pt.IWorkspacesManagementMainService,new _.SyncDescriptor(Pt.WorkspacesManagementMainService)),ge.set(kt.IWorkspacesHistoryMainService,new _.SyncDescriptor(kt.WorkspacesHistoryMainService)),ge.set(be.IMenubarMainService,new _.SyncDescriptor(be.MenubarMainService)),ge.set(se.IExtensionUrlTrustService,new _.SyncDescriptor($.ExtensionUrlTrustService)),ge.set(q.IExtensionHostStarter,new _.SyncDescriptor(Q.WorkerMainProcessExtensionHostStarter)),ge.set(Fe.IStorageMainService,new _.SyncDescriptor(Fe.StorageMainService)),ge.set(Fe.IGlobalStorageMainService,new _.SyncDescriptor(Fe.GlobalStorageMainService)),h.isWindows?ge.set(z.IExternalTerminalMainService,new _.SyncDescriptor(F.WindowsExternalTerminalService)):h.isMacintosh?ge.set(z.IExternalTerminalMainService,new _.SyncDescriptor(F.MacExternalTerminalService)):h.isLinux&&ge.set(z.IExternalTerminalMainService,new _.SyncDescriptor(F.LinuxExternalTerminalService));const Pe=new o.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ge.set(r.IBackupMainService,Pe),ge.set(fe.IURLService,new _.SyncDescriptor(Re.NativeURLService)),(0,ot.supportsTelemetry)(this.productService,this.environmentMainService)){const De=(0,c.getDelayedChannel)(ve.then(_e=>_e.getChannel("telemetryAppender"))),Ce=new st.TelemetryAppenderClient(De),Ie=(0,ze.resolveCommonProperties)(this.fileService,(0,L.release)(),(0,L.hostname)(),process.arch,this.productService.commit,this.productService.version,de,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),ke=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],We={appenders:[Ce],commonProperties:Ie,piiPaths:ke,sendErrorTelemetry:!0};ge.set(Ge.ITelemetryService,new _.SyncDescriptor(wt.TelemetryService,[We]))}else ge.set(Ge.ITelemetryService,ot.NullTelemetryService);return await Pe.initialize(),this.mainInstantiationService.createChild(ge)}initChannels(de,me,ve){const ge=c.ProxyChannel.fromService(de.get(ne.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ge);const Pe=c.ProxyChannel.fromService(de.get(U.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",Pe);const De=this.fileService.getProvider(p.Schemas.file);(0,g.assertType)(De instanceof O.DiskFileSystemProvider);const Ce=new A.DiskFileSystemProviderChannel(De,this.logService,this.environmentMainService);me.registerChannel(N.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Ce),ve.then(Be=>Be.registerChannel(N.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Ce));const Ie=new He.UpdateChannel(de.get(Ye.IUpdateService));me.registerChannel("update",Ie);const ke=c.ProxyChannel.fromService(de.get(ae.IIssueMainService));me.registerChannel("issue",ke);const We=c.ProxyChannel.fromService(de.get(X.IEncryptionMainService));me.registerChannel("encryption",We);const _e=c.ProxyChannel.fromService(de.get(v.ICredentialsMainService));me.registerChannel("credentials",_e);const Xe=c.ProxyChannel.fromService(de.get(Le.ISignService));me.registerChannel("sign",Xe);const et=c.ProxyChannel.fromService(de.get(ce.IKeyboardLayoutMainService));me.registerChannel("keyboardLayout",et),this.nativeHostMainService=de.get(Me.INativeHostMainService);const ut=c.ProxyChannel.fromService(this.nativeHostMainService);me.registerChannel("nativeHost",ut),ve.then(Be=>Be.registerChannel("nativeHost",ut));const vt=c.ProxyChannel.fromService(de.get(tt.IWorkspacesService));me.registerChannel("workspaces",vt);const Ue=c.ProxyChannel.fromService(de.get(be.IMenubarMainService));me.registerChannel("menubar",Ue);const ht=c.ProxyChannel.fromService(de.get(fe.IURLService));me.registerChannel("url",ht);const at=c.ProxyChannel.fromService(de.get(se.IExtensionUrlTrustService));me.registerChannel("extensionUrlTrust",at);const ct=c.ProxyChannel.fromService(de.get(Ke.IWebviewManagerService));me.registerChannel("webview",ct);const lt=this._register(new Ze.StorageDatabaseChannel(this.logService,de.get(Fe.IStorageMainService)));me.registerChannel("storage",lt),ve.then(Be=>Be.registerChannel("storage",lt));const dt=c.ProxyChannel.fromService(de.get(z.IExternalTerminalMainService));me.registerChannel("externalTerminal",dt);const it=new we.LogLevelChannel(de.get(he.ILogService));me.registerChannel("logLevel",it),ve.then(Be=>Be.registerChannel("logLevel",it));const nt=new we.LoggerChannel(de.get(he.ILoggerService));me.registerChannel("logger",nt),ve.then(Be=>Be.registerChannel("logger",nt));const ft=new R.ElectronExtensionHostDebugBroadcastChannel(de.get(Ae.IWindowsMainService));me.registerChannel("extensionhostdebugservice",ft);const Te=c.ProxyChannel.fromService(de.get(q.IExtensionHostStarter));me.registerChannel(q.ipcExtensionHostStarterChannelName,Te)}openFirstWindow(de,me){const ve=this.windowsMainService=de.get(Ae.IWindowsMainService),ge=de.get(fe.IURLService),Pe=de.get(Me.INativeHostMainService);this.lifecycleMainService.phase=2;const De=[],Ce=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Te=>{try{return{uri:y.URI.parse(Te),url:Te}}catch{return}}).filter(Te=>{if(!Te||this.shouldBlockURI(Te.uri))return!1;const Be=this.getWindowOpenableFromProtocolLink(Te.uri);return Be?(De.push(Be),!1):!0}),Ie=this,ke=this.environmentMainService,We=this.productService,_e=this.logService;ge.registerHandler({async handleURL(Te,Be){if(_e.trace("app#handleURL: ",Te.toString(!0),Be),Te.scheme===We.urlProtocol&&Te.path==="workspace"&&(Te=Te.with({authority:"file",path:y.URI.parse(Te.query).path,query:""})),Ie.shouldBlockURI(Te))return!0;const yt=Ie.getWindowOpenableFromProtocolLink(Te);if(_e.trace("app#handleURL: windowOpenableFromProtocolLink = ",yt),yt){const[St]=ve.open({context:5,cli:{...ke.args},urisToOpen:[yt],gotoLineMode:!0});return St.focus(),!0}if(h.isMacintosh&&ve.getWindowCount()===0){const[St]=ve.open({context:5,cli:{...ke.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,pe.getRemoteAuthority)(Te)});return await St.ready(),ge.open(Te,Be)}return!1}});const Xe=this._register(new je.ActiveWindowManager({onDidOpenWindow:Pe.onDidOpenWindow,onDidFocusWindow:Pe.onDidFocusWindow,getActiveWindowId:()=>Pe.getActiveWindowId(-1)})),et=new c.StaticRouter(Te=>Xe.getActiveClientId().then(Be=>Te===Be)),ut=new ye.URLHandlerRouter(et),vt=me.getChannel("urlHandler",ut);ge.registerHandler(new ye.URLHandlerChannelClient(vt)),this._register(new Oe.ElectronURLListener(Ce,ge,ve,this.environmentMainService,this.productService));const Ue=this.environmentMainService.args,ht=global.macOpenFiles,at=(0,B.isLaunchedFromCli)(process.env)?0:4,ct=Ue._.length,lt=!!Ue["folder-uri"],dt=!!Ue["file-uri"],it=Ue["skip-add-to-recently-opened"]===!0,nt=Ue.wait&&Ue.waitMarkerFilePath?y.URI.file(Ue.waitMarkerFilePath):void 0,ft=Ue.remote||void 0;return De.length>0?ve.open({context:at,cli:Ue,urisToOpen:De,gotoLineMode:!0,initialStartup:!0}):Ue["new-window"]&&!ct&&!lt&&!dt?ve.open({context:at,cli:Ue,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:it,waitMarkerFileURI:nt,initialStartup:!0,remoteAuthority:ft}):ht.length&&!ct&&!lt&&!dt?ve.open({context:1,cli:Ue,urisToOpen:ht.map(Te=>this.getWindowOpenableFromPathSync(Te)),noRecentEntry:it,waitMarkerFileURI:nt,initialStartup:!0}):ve.open({context:at,cli:Ue,forceNewWindow:Ue["new-window"]||!ct&&Ue["unity-launch"],diffMode:Ue.diff,noRecentEntry:it,waitMarkerFileURI:nt,gotoLineMode:Ue.goto,initialStartup:!0,remoteAuthority:ft})}shouldBlockURI(de){return!!(de.authority===p.Schemas.file&&h.isWindows&&w.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,E.mnemonicButtonLabel)((0,i.localize)(0,null)),(0,E.mnemonicButtonLabel)((0,i.localize)(1,null))],defaultId:0,cancelId:1,message:(0,i.localize)(2,null,(0,E.getPathLabel)(de.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,i.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(de){if(!!de.path){if(de.authority===p.Schemas.file){const me=y.URI.file(de.fsPath);return(0,xe.hasWorkspaceFileExtension)(me)?{workspaceUri:me}:{fileUri:me}}else if(de.authority===p.Schemas.vscodeRemote){const me=de.path.indexOf(t.posix.sep,1);if(me!==-1){const ve=de.path.substring(1,me),ge=de.path.substring(me),Pe=y.URI.from({scheme:p.Schemas.vscodeRemote,authority:ve,path:ge,query:de.query,fragment:de.fragment});return(0,xe.hasWorkspaceFileExtension)(ge)?{workspaceUri:Pe}:/:[\d]+$/.test(ge)?{fileUri:Pe}:{folderUri:Pe}}}}}getWindowOpenableFromPathSync(de){try{if((0,n.statSync)(de).isDirectory())return{folderUri:y.URI.file(de)};if((0,xe.hasWorkspaceFileExtension)(de))return{workspaceUri:y.URI.file(de)}}catch{}return{fileUri:y.URI.file(de)}}async afterWindowOpen(de,me){this.lifecycleMainService.phase=3;let ve=!1;(0,I.once)(this.lifecycleMainService.onWillShutdown)(()=>ve=!0);const ge=de.get(Ge.ITelemetryService);this._register(me.onDidError(({type:Ce,details:Ie})=>{let ke;switch(Ce){case 1:ke="SharedProcess: detected unresponsive window";break;case 2:ke=`SharedProcess: crashed (detail: ${Ie?.reason??"<unknown>"}, code: ${Ie?.exitCode??"<unknown>"})`;break;case 3:ke=`SharedProcess: failed to load (detail: ${Ie?.reason??"<unknown>"}, code: ${Ie?.exitCode??"<unknown>"})`;break}(0,S.onUnexpectedError)(new Error(ke)),ge.publicLog2("sharedprocesserror",{type:Ce,reason:Ie?.reason,code:Ie?.exitCode,visible:me.isVisible(),shuttingdown:ve})}));const Pe=this.productService.win32MutexName;if(h.isWindows&&Pe)try{const Ce=V.__$__nodeRequire("windows-mutex").Mutex,Ie=new Ce(Pe);(0,I.once)(this.lifecycleMainService.onWillShutdown)(()=>Ie.release())}catch(Ce){this.logService.error(Ce)}w.protocol.registerHttpProtocol(p.Schemas.vscodeRemoteResource,(Ce,Ie)=>{Ie({url:Ce.url.replace(/^vscode-remote-resource:/,"http:"),method:Ce.method})});const De=de.get(Ye.IUpdateService);(De instanceof oe.Win32UpdateService||De instanceof K.LinuxUpdateService||De instanceof Qe.DarwinUpdateService)&&De.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const Ie=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,M.stripComments)(Ie))["enable-crash-reporter"]===void 0){const _e=(0,ot.getTelemetryLevel)(this.configurationService)>=1,Xe=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${_e},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,k.generateUuid)()}"`,"}"],et=Ie.substring(0,Ie.length-2).concat(`,
`,Xe.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,D.VSBuffer.fromString(et))}}catch(Ce){this.logService.error(Ce)}}async resolveShellEnvironment(de,me,ve){try{return await(0,Y.getResolvedShellEnv)(this.logService,de,me)}catch(ge){const Pe=(0,P.toErrorMessage)(ge);ve?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Pe):this.logService.error(Pe)}return{}}stopTracingEventually(de,me){this.logService.info("Tracing: waiting for windows to get ready...");const ve=de.get(G.IDialogMainService);let ge=!1;const Pe=async Ce=>{if(ge)return;ge=!0;const Ie=await w.contentTracing.stopRecording(`${(0,m.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);Ce?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Ie}`):ve.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,i.localize)(4,null),detail:(0,i.localize)(5,null,Ie),buttons:[(0,E.mnemonicButtonLabel)((0,i.localize)(6,null))],defaultId:0,noLink:!0},(0,g.withNullAsUndefined)(w.BrowserWindow.getFocusedWindow()))},De=setTimeout(()=>Pe(!0),3e4);Promise.all(me.map(Ce=>Ce.ready())).then(()=>{clearTimeout(De),Pe(!1)})}};pt=ue([te(2,j.IInstantiationService),te(3,he.ILogService),te(4,H.IEnvironmentMainService),te(5,le.ILifecycleMainService),te(6,l.IConfigurationService),te(7,Ne.IStateMainService),te(8,T.IFileService),te(9,Se.IProductService)],pt),e.CodeApplication=pt}),define(Z[255],x([0,1,12,29,30,9,39,15,28,43,33,10,7,63,2,36,27,24,37,57,248,11,19,200,208,22,50,171,20,188,77,73,182,76,18,95,6,193,96,53,21,54,197,99,237,56,234,79,205,38,236,64,65,214]),function(V,e,w,n,L,D,P,S,m,I,M,E,b,p,t,h,g,y,k,d,u,c,a,f,s,i,r,o,l,v,C,R,W,U,G,ee,X,J,H,B,Y,se,$,q,Q,z,F,N,T,A,O,_,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ie{main(){try{this.startup()}catch(ne){console.error(ne.message),w.app.exit(1)}}async startup(){(0,S.setUnexpectedErrorHandler)(pe=>console.error(pe));const[ne,le,he,we,be,Me,Se]=this.createServices();try{try{await this.initServices(he,we,be)}catch(pe){throw this.handleStartupDataDirError(he,Se.nameLong,pe),pe}await ne.invokeFunction(async pe=>{const Ee=pe.get(X.ILogService),Le=pe.get(G.ILifecycleMainService),Ne=pe.get(l.IFileService),Ze=await this.claimInstance(Ee,he,Le,ne,Se,!0);return y.Promises.writeFile(he.mainLockfile,String(process.pid)).catch(Fe=>{Ee.warn(`Error writing main lockfile: ${Fe.stack}`)}),Me.logger=new H.SpdLogLogger("main",(0,b.join)(he.logsPath,"main.log"),!0,!1,Me.getLevel()),(0,I.once)(Le.onWillShutdown)(Fe=>{Ne.dispose(),we.dispose(),Fe.join(y.Promises.unlink(he.mainLockfile).catch(()=>{}))}),ne.createInstance(u.CodeApplication,Ze,le).startup()})}catch(pe){ne.invokeFunction(this.quit,pe)}}createServices(){const ne=new U.ServiceCollection,le={_serviceBrand:void 0,...B.default};ne.set(Y.IProductService,le);const he=new i.EnvironmentMainService(this.resolveArgs(),le),we=this.patchEnvironment(he);ne.set(i.IEnvironmentMainService,he);const be=new ee.BufferLogService,Me=new X.MultiplexLogService([new X.ConsoleMainLogger((0,X.getLogLevel)(he)),be]);process.once("exit",()=>Me.dispose()),ne.set(X.ILogService,Me);const Se=new v.FileService(Me);ne.set(l.IFileService,Se);const pe=new C.DiskFileSystemProvider(Me);Se.registerProvider(E.Schemas.file,pe),ne.set(X.ILoggerService,new J.LoggerService(Me,Se));const Ee=new f.ConfigurationService(he.settingsResource,Se);ne.set(a.IConfigurationService,Ee),ne.set(G.ILifecycleMainService,new R.SyncDescriptor(G.LifecycleMainService));const Le=new O.StateMainService(he,Me,Se);return ne.set(A.IStateMainService,Le),ne.set(z.IRequestService,new R.SyncDescriptor(F.RequestMainService)),ne.set(j.IThemeMainService,new R.SyncDescriptor(j.ThemeMainService)),ne.set(N.ISignService,new R.SyncDescriptor(T.SignService)),ne.set(q.ITunnelService,new R.SyncDescriptor(Q.TunnelService)),ne.set(se.IProtocolMainService,new R.SyncDescriptor($.ProtocolMainService)),[new W.InstantiationService(ne,!0),we,he,Ee,Le,be,le]}patchEnvironment(ne){const le={VSCODE_IPC_HOOK:ne.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(he=>{const we=process.env[he];typeof we=="string"&&(le[he]=we)}),Object.assign(process.env,le),le}initServices(ne,le,he){return D.Promises.settled([Promise.all([ne.extensionsPath,ne.codeCachePath,ne.logsPath,ne.globalStorageHome.fsPath,ne.workspaceStorageHome.fsPath,ne.backupHome].map(we=>we?y.Promises.mkdir(we,{recursive:!0}):void 0)),le.initialize(),he.init()])}async claimInstance(ne,le,he,we,be,Me){let Se;try{(0,p.mark)("code/willStartMainServer"),Se=await(0,d.serve)(le.mainIPCHandle),(0,p.mark)("code/didStartMainServer"),(0,I.once)(he.onWillShutdown)(()=>Se.dispose())}catch(pe){if(pe.code!=="EADDRINUSE")throw this.handleStartupDataDirError(le,be.nameLong,pe),pe;let Ee;try{Ee=await(0,d.connect)(le.mainIPCHandle,"main")}catch(Fe){if(!Me||t.isWindows||Fe.code!=="ECONNREFUSED")throw Fe.code==="EPERM"&&this.showStartupWarningDialog((0,c.localize)(0,null,be.nameShort),(0,c.localize)(1,null),be.nameLong),Fe;try{(0,n.unlinkSync)(le.mainIPCHandle)}catch(ze){throw ne.warn("Could not delete obsolete instance handle",ze),ze}return this.claimInstance(ne,le,he,we,be,!1)}if(le.extensionTestsLocationURI&&!le.debugExtensionHost.break){const Fe="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw ne.error(Fe),Ee.dispose(),new Error(Fe)}let Le;!le.args.wait&&!le.args.status&&(Le=setTimeout(()=>{this.showStartupWarningDialog((0,c.localize)(2,null,be.nameShort),(0,c.localize)(3,null),be.nameLong)},1e4));const Ne=k.ProxyChannel.toService(Ee.getChannel("launch"),{disableMarshalling:!0}),Ze=k.ProxyChannel.toService(Ee.getChannel("diagnostics"),{disableMarshalling:!0});if(le.args.status)return we.invokeFunction(async()=>{const Fe=new s.DiagnosticsService(_.NullTelemetryService,be),ze=await Ne.getMainProcessInfo(),Ge=await Ze.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),st=await Fe.getDiagnostics(ze,Ge);throw console.log(st),new S.ExpectedError});throw t.isWindows&&await this.windowsAllowSetForegroundWindow(Ne,ne),ne.trace("Sending env to running instance..."),await Ne.start(le.args,process.env),Ee.dispose(),Le&&clearTimeout(Le),new S.ExpectedError("Sent env to running instance. Terminating...")}if(le.args.status)throw ne.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new S.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Se}handleStartupDataDirError(ne,le,he){if(he.code==="EACCES"||he.code==="EPERM"){const we=(0,L.coalesce)([ne.userDataPath,ne.extensionsPath,d.XDG_RUNTIME_DIR]).map(be=>(0,M.getPathLabel)(be,ne));this.showStartupWarningDialog((0,c.localize)(4,null),(0,c.localize)(5,null,(0,P.toErrorMessage)(he),we.join(`
`)),le)}}showStartupWarningDialog(ne,le,he){w.dialog.showMessageBoxSync({title:he,type:"warning",buttons:[(0,M.mnemonicButtonLabel)((0,c.localize)(6,null))],message:ne,detail:le,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(ne,le){if(t.isWindows){const he=await ne.getMainProcessId();le.trace("Sending some foreground love to the running instance:",he);try{(await new Promise((we,be)=>{V(["windows-foreground-love"],we,be)})).allowSetForegroundWindow(he)}catch(we){le.error(we)}}}quit(ne,le){const he=ne.get(X.ILogService),we=ne.get(G.ILifecycleMainService);let be=0;le&&(le.isExpected?le.message&&he.trace(le.message):(be=1,le.stack?he.error(le.stack):he.error(`Startup error: ${le.toString()}`))),we.kill(be)}resolveArgs(){const ne=this.validatePaths((0,r.parseMainProcessArgv)(process.argv));if(ne.wait&&!ne.waitMarkerFilePath){const le=(0,o.createWaitMarkerFile)(ne.verbose);le&&((0,r.addArg)(process.argv,"--waitMarkerFilePath",le),ne.waitMarkerFilePath=le)}return ne}validatePaths(ne){if(ne["open-url"]&&(ne._urls=ne._,ne._=[]),!ne.remote){const le=this.doValidatePaths(ne._,ne.goto);ne._=le}return ne}doValidatePaths(ne,le){const he=(0,h.cwd)(),we=ne.map(Se=>{let pe=String(Se),Ee;le&&(Ee=(0,m.parseLineAndColumnAware)(pe),pe=Ee.path),pe&&(pe=this.preparePath(he,pe));const Le=(0,m.sanitizeFilePath)(pe,he),Ne=(0,b.basename)(Le);return Ne&&!(0,m.isValidBasename)(Ne)?null:le&&Ee?(Ee.path=Le,this.toPath(Ee)):Le}),be=t.isWindows||t.isMacintosh,Me=(0,L.distinct)(we,Se=>Se&&be?Se.toLowerCase():Se||"");return(0,L.coalesce)(Me)}preparePath(ne,le){return t.isWindows&&(le=(0,g.rtrim)(le,'"')),le=(0,g.trim)((0,g.trim)(le," "),"	"),t.isWindows&&(le=(0,b.resolve)(ne,le),le=(0,g.rtrim)(le,".")),le}toPath(ne){const le=[ne.path];return typeof ne.line=="number"&&le.push(String(ne.line)),typeof ne.column=="number"&&le.push(String(ne.column)),le.join(":")}}new ie().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0f4d3788605a486980fa3a6b3b9d1a38b1102481/core/vs/code/electron-main/main.js.map
