/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Y=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/types","vs/base/common/event","vs/base/common/errors","vs/base/common/uri","vs/base/common/network","vs/base/common/path","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/arrays","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetry","vs/platform/product/common/productService","os","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/stream","child_process","vs/platform/instantiation/common/descriptors","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/node/zip","vs/base/common/decorators","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/base/common/map","vs/base/common/assert","vs/base/common/json","vs/base/common/processes","vs/base/common/skipList","vs/base/common/hash","vs/base/common/console","vs/base/common/marshalling","vs/base/common/labels","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/node/shellEnv","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/terminal/node/shellEnv","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/iterator","graceful-fs","crypto","vs/platform/environment/node/argvHelper","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Q=function(j){for(var t=[],C=0,D=j.length;C<D;C++)t[C]=Y[j[C]];return t};define(Y[55],Q([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function C(D,b){if(!D)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}t.ok=C}),define(Y[44],Q([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function C(T){return(P,c,w)=>{let I=null,L=null;if(typeof w.value=="function"?(I="value",L=w.value):typeof w.get=="function"&&(I="get",L=w.get),!L)throw new Error("not supported");w[I]=T(L,c)}}t.createDecorator=C;function D(T,P,c){let w=null,I=null;if(typeof c.value=="function"?(w="value",I=c.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(w="get",I=c.get),!I)throw new Error("not supported");const L=`$memoize$${P}`;c[w]=function(...h){return this.hasOwnProperty(L)||Object.defineProperty(this,L,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,h)}),this[L]}}t.memoize=D;function b(T,P,c){return C((w,I)=>{const L=`$debounce$${I}`,h=`$debounce$result$${I}`;return function(...y){this[h]||(this[h]=c?c():void 0),clearTimeout(this[L]),P&&(this[h]=P(this[h],...y),y=[this[h]]),this[L]=setTimeout(()=>{w.apply(this,y),this[h]=c?c():void 0},T)}})}t.debounce=b;function R(T,P,c){return C((w,I)=>{const L=`$throttle$timer$${I}`,h=`$throttle$result$${I}`,y=`$throttle$lastRun$${I}`,E=`$throttle$pending$${I}`;return function(...g){if(this[h]||(this[h]=c?c():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),P&&(this[h]=P(this[h],...g)),this[E])return;const l=this[y]+T;l<=Date.now()?(this[y]=Date.now(),w.apply(this,[this[h]]),this[h]=c?c():void 0):(this[E]=!0,this[L]=setTimeout(()=>{this[E]=!1,this[y]=Date.now(),w.apply(this,[this[h]]),this[h]=c?c():void 0},l-Date.now()))}})}t.throttle=R}),define(Y[56],Q([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var C;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(C=t.ScanError||(t.ScanError={}));var D;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(D=t.SyntaxKind||(t.SyntaxKind={}));var b;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(b=t.ParseErrorCode||(t.ParseErrorCode={}));var R;(function(e){e.DEFAULT={allowTrailingComma:!0}})(R=t.ParseOptions||(t.ParseOptions={}));function T(e,s=!1){let i=0,n=e.length,r="",a=0,u=16,d=0;function S(ie){let he=0,ue=0;for(;he<ie;){const x=e.charCodeAt(i);if(x>=48&&x<=57)ue=ue*16+x-48;else if(x>=65&&x<=70)ue=ue*16+x-65+10;else if(x>=97&&x<=102)ue=ue*16+x-97+10;else break;i++,he++}return he<ie&&(ue=-1),ue}function O(ie){i=ie,r="",a=0,u=16,d=0}function N(){const ie=i;if(e.charCodeAt(i)===48)i++;else for(i++;i<e.length&&w(e.charCodeAt(i));)i++;if(i<e.length&&e.charCodeAt(i)===46)if(i++,i<e.length&&w(e.charCodeAt(i)))for(i++;i<e.length&&w(e.charCodeAt(i));)i++;else return d=3,e.substring(ie,i);let he=i;if(i<e.length&&(e.charCodeAt(i)===69||e.charCodeAt(i)===101))if(i++,(i<e.length&&e.charCodeAt(i)===43||e.charCodeAt(i)===45)&&i++,i<e.length&&w(e.charCodeAt(i))){for(i++;i<e.length&&w(e.charCodeAt(i));)i++;he=i}else d=3;return e.substring(ie,he)}function _(){let ie="",he=i;for(;;){if(i>=n){ie+=e.substring(he,i),d=2;break}const ue=e.charCodeAt(i);if(ue===34){ie+=e.substring(he,i),i++;break}if(ue===92){if(ie+=e.substring(he,i),i++,i>=n){d=2;break}switch(e.charCodeAt(i++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:{const te=S(4);te>=0?ie+=String.fromCharCode(te):d=4;break}default:d=5}he=i;continue}if(ue>=0&&ue<=31)if(c(ue)){ie+=e.substring(he,i),d=2;break}else d=6;i++}return ie}function J(){if(r="",d=0,a=i,i>=n)return a=n,u=17;let ie=e.charCodeAt(i);if(P(ie)){do i++,r+=String.fromCharCode(ie),ie=e.charCodeAt(i);while(P(ie));return u=15}if(c(ie))return i++,r+=String.fromCharCode(ie),ie===13&&e.charCodeAt(i)===10&&(i++,r+=`
`),u=14;switch(ie){case 123:return i++,u=1;case 125:return i++,u=2;case 91:return i++,u=3;case 93:return i++,u=4;case 58:return i++,u=6;case 44:return i++,u=5;case 34:return i++,r=_(),u=10;case 47:{const he=i-1;if(e.charCodeAt(i+1)===47){for(i+=2;i<n&&!c(e.charCodeAt(i));)i++;return r=e.substring(he,i),u=12}if(e.charCodeAt(i+1)===42){i+=2;const ue=n-1;let x=!1;for(;i<ue;){if(e.charCodeAt(i)===42&&e.charCodeAt(i+1)===47){i+=2,x=!0;break}i++}return x||(i++,d=1),r=e.substring(he,i),u=13}return r+=String.fromCharCode(ie),i++,u=16}case 45:if(r+=String.fromCharCode(ie),i++,i===n||!w(e.charCodeAt(i)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=N(),u=11;default:for(;i<n&&re(ie);)i++,ie=e.charCodeAt(i);if(a!==i){switch(r=e.substring(a,i),r){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return r+=String.fromCharCode(ie),i++,u=16}}function re(ie){if(P(ie)||c(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ee(){let ie;do ie=J();while(ie>=12&&ie<=15);return ie}return{setPosition:O,getPosition:()=>i,scan:s?ee:J,getToken:()=>u,getTokenValue:()=>r,getTokenOffset:()=>a,getTokenLength:()=>i-a,getTokenError:()=>d}}t.createScanner=T;function P(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function c(e){return e===10||e===13||e===8232||e===8233}function w(e){return e>=48&&e<=57}var I;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(I||(I={}));function L(e,s){const i=[],n=new Object;let r;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function d(S,O,N,_){a.value=S,a.offset=O,a.length=N,a.type=_,a.colonOffset=void 0,r=a}try{p(e,{onObjectBegin:(S,O)=>{if(s<=S)throw n;r=void 0,u=s>S,i.push("")},onObjectProperty:(S,O,N)=>{if(s<O||(d(S,O,N,"property"),i[i.length-1]=S,s<=O+N))throw n},onObjectEnd:(S,O)=>{if(s<=S)throw n;r=void 0,i.pop()},onArrayBegin:(S,O)=>{if(s<=S)throw n;r=void 0,i.push(0)},onArrayEnd:(S,O)=>{if(s<=S)throw n;r=void 0,i.pop()},onLiteralValue:(S,O,N)=>{if(s<O||(d(S,O,N,o(S)),s<=O+N))throw n},onSeparator:(S,O,N)=>{if(s<=O)throw n;if(S===":"&&r&&r.type==="property")r.colonOffset=O,u=!1,r=void 0;else if(S===","){const _=i[i.length-1];typeof _=="number"?i[i.length-1]=_+1:(u=!0,i[i.length-1]=""),r=void 0}}})}catch(S){if(S!==n)throw S}return{path:i,previousNode:r,isAtPropertyKey:u,matches:S=>{let O=0;for(let N=0;O<S.length&&N<i.length;N++)if(S[O]===i[N]||S[O]==="*")O++;else if(S[O]!=="**")return!1;return O===S.length}}}t.getLocation=L;function h(e,s=[],i=R.DEFAULT){let n=null,r=[];const a=[];function u(S){Array.isArray(r)?r.push(S):n!==null&&(r[n]=S)}return p(e,{onObjectBegin:()=>{const S={};u(S),a.push(r),r=S,n=null},onObjectProperty:S=>{n=S},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const S=[];u(S),a.push(r),r=S,n=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:u,onError:(S,O,N)=>{s.push({error:S,offset:O,length:N})}},i),r[0]}t.parse=h;function y(e,s=[],i=R.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(S){n.type==="property"&&(n.length=S-n.offset,n=n.parent)}function a(S){return n.children.push(S),S}p(e,{onObjectBegin:S=>{n=a({type:"object",offset:S,length:-1,parent:n,children:[]})},onObjectProperty:(S,O,N)=>{n=a({type:"property",offset:O,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:S,offset:O,length:N,parent:n})},onObjectEnd:(S,O)=>{n.length=S+O-n.offset,n=n.parent,r(S+O)},onArrayBegin:(S,O)=>{n=a({type:"array",offset:S,length:-1,parent:n,children:[]})},onArrayEnd:(S,O)=>{n.length=S+O-n.offset,n=n.parent,r(S+O)},onLiteralValue:(S,O,N)=>{a({type:o(S),offset:O,length:N,parent:n,value:S}),r(O+N)},onSeparator:(S,O,N)=>{n.type==="property"&&(S===":"?n.colonOffset=O:S===","&&r(O))},onError:(S,O,N)=>{s.push({error:S,offset:O,length:N})}},i);const d=n.children[0];return d&&delete d.parent,d}t.parseTree=y;function E(e,s){if(!e)return;let i=e;for(let n of s)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let r=!1;for(const a of i.children)if(Array.isArray(a.children)&&a.children[0].value===n){i=a.children[1],r=!0;break}if(!r)return}else{const r=n;if(i.type!=="array"||r<0||!Array.isArray(i.children)||r>=i.children.length)return;i=i.children[r]}return i}t.findNodeAtLocation=E;function g(e){if(!e.parent||!e.parent.children)return[];const s=g(e.parent);if(e.parent.type==="property"){const i=e.parent.children[0].value;s.push(i)}else if(e.parent.type==="array"){const i=e.parent.children.indexOf(e);i!==-1&&s.push(i)}return s}t.getNodePath=g;function l(e){switch(e.type){case"array":return e.children.map(l);case"object":{const s=Object.create(null);for(let i of e.children){const n=i.children[1];n&&(s[i.children[0].value]=l(n))}return s}case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=l;function f(e,s,i=!1){return s>=e.offset&&s<e.offset+e.length||i&&s===e.offset+e.length}t.contains=f;function v(e,s,i=!1){if(f(e,s,i)){const n=e.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=s;r++){const a=v(n[r],s,i);if(a)return a}return e}}t.findNodeAtOffset=v;function p(e,s,i=R.DEFAULT){const n=T(e,!1);function r(K){return K?()=>K(n.getTokenOffset(),n.getTokenLength()):()=>!0}function a(K){return K?Z=>K(Z,n.getTokenOffset(),n.getTokenLength()):()=>!0}const u=r(s.onObjectBegin),d=a(s.onObjectProperty),S=r(s.onObjectEnd),O=r(s.onArrayBegin),N=r(s.onArrayEnd),_=a(s.onLiteralValue),J=a(s.onSeparator),re=r(s.onComment),ee=a(s.onError),ie=i&&i.disallowComments,he=i&&i.allowTrailingComma;function ue(){for(;;){const K=n.scan();switch(n.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:ie||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(K){case 12:case 13:ie?x(10):re();break;case 16:x(1);break;case 15:case 14:break;default:return K}}}function x(K,Z=[],q=[]){if(ee(K),Z.length+q.length>0){let M=n.getToken();for(;M!==17;){if(Z.indexOf(M)!==-1){ue();break}else if(q.indexOf(M)!==-1)break;M=ue()}}}function te(K){const Z=n.getTokenValue();return K?_(Z):d(Z),ue(),!0}function U(){switch(n.getToken()){case 11:{let K=0;try{K=JSON.parse(n.getTokenValue()),typeof K!="number"&&(x(2),K=0)}catch{x(2)}_(K);break}case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return ue(),!0}function k(){return n.getToken()!==10?(x(3,[],[2,5]),!1):(te(!1),n.getToken()===6?(J(":"),ue(),ne()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function z(){u(),ue();let K=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(K||x(4,[],[]),J(","),ue(),n.getToken()===2&&he)break}else K&&x(6,[],[]);k()||x(4,[],[2,5]),K=!0}return S(),n.getToken()!==2?x(7,[2],[]):ue(),!0}function G(){O(),ue();let K=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(K||x(4,[],[]),J(","),ue(),n.getToken()===4&&he)break}else K&&x(6,[],[]);ne()||x(4,[],[4,5]),K=!0}return N(),n.getToken()!==4?x(8,[4],[]):ue(),!0}function ne(){switch(n.getToken()){case 3:return G();case 1:return z();case 10:return te(!0);default:return U()}}return ue(),n.getToken()===17?i.allowEmptyContent?!0:(x(4,[],[]),!1):ne()?(n.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}t.visit=p;function m(e,s){let i=T(e),n=[],r,a=0,u;do switch(u=i.getPosition(),r=i.scan(),r){case 12:case 13:case 17:a!==u&&n.push(e.substring(a,u)),s!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,s)),a=i.getPosition();break}while(r!==17);return n.join("")}t.stripComments=m;function o(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=o}),function(){function j(b){const R=[];typeof b=="number"&&R.push("code/timeOrigin",b);function T(c){R.push(c,Date.now())}function P(){const c=[];for(let w=0;w<R.length;w+=2)c.push({name:R[w],startTime:R[w+1]});return c}return{mark:T,getMarks:P}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?j():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const T of performance.getEntriesByType("mark"))R.push({name:T.name,startTime:Math.round(b+T.startTime)});return R}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return j(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),j()}function C(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=t()),b.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=C(D))}(),define(Y[57],Q([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.sanitizeProcessEnvironment=t.TerminateResponseCode=t.Source=void 0;var C;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(C=t.Source||(t.Source={}));var D;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(D=t.TerminateResponseCode||(t.TerminateResponseCode={}));function b(R,...T){const P=T.reduce((I,L)=>(I[L]=!0,I),{}),c=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(I=>!P[I]).forEach(I=>{for(let L=0;L<c.length;L++)if(I.search(c[L])!==-1){delete R[I];break}})}t.sanitizeProcessEnvironment=b}),function(j,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var C=t();for(var D in C)(typeof exports=="object"?exports:j)[D]=C[D]}}(typeof self!="undefined"?self:this,function(){return function(j){var t={};function C(D){if(t[D])return t[D].exports;var b=t[D]={i:D,l:!1,exports:{}};return j[D].call(b.exports,b,b.exports,C),b.l=!0,b.exports}return C.m=j,C.c=t,C.d=function(D,b,R){C.o(D,b)||Object.defineProperty(D,b,{enumerable:!0,get:R})},C.r=function(D){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},C.t=function(D,b){if(1&b&&(D=C(D)),8&b||4&b&&typeof D=="object"&&D&&D.__esModule)return D;var R=Object.create(null);if(C.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:D}),2&b&&typeof D!="string")for(var T in D)C.d(R,T,function(P){return D[P]}.bind(null,T));return R},C.n=function(D){var b=D&&D.__esModule?function(){return D.default}:function(){return D};return C.d(b,"a",b),b},C.o=function(D,b){return Object.prototype.hasOwnProperty.call(D,b)},C.p="",C(C.s=0)}([function(j,t,C){(function(D){var b;t=j.exports=q,b=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var F=Array.prototype.slice.call(arguments,0);F.unshift("SEMVER"),console.log.apply(console,F)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var R=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,P=t.re=[],c=t.src=[],w=0,I=w++;c[I]="0|[1-9]\\d*";var L=w++;c[L]="[0-9]+";var h=w++;c[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=w++;c[y]="("+c[I]+")\\.("+c[I]+")\\.("+c[I]+")";var E=w++;c[E]="("+c[L]+")\\.("+c[L]+")\\.("+c[L]+")";var g=w++;c[g]="(?:"+c[I]+"|"+c[h]+")";var l=w++;c[l]="(?:"+c[L]+"|"+c[h]+")";var f=w++;c[f]="(?:-("+c[g]+"(?:\\."+c[g]+")*))";var v=w++;c[v]="(?:-?("+c[l]+"(?:\\."+c[l]+")*))";var p=w++;c[p]="[0-9A-Za-z-]+";var m=w++;c[m]="(?:\\+("+c[p]+"(?:\\."+c[p]+")*))";var o=w++,e="v?"+c[y]+c[f]+"?"+c[m]+"?";c[o]="^"+e+"$";var s="[v=\\s]*"+c[E]+c[v]+"?"+c[m]+"?",i=w++;c[i]="^"+s+"$";var n=w++;c[n]="((?:<|>)?=?)";var r=w++;c[r]=c[L]+"|x|X|\\*";var a=w++;c[a]=c[I]+"|x|X|\\*";var u=w++;c[u]="[v=\\s]*("+c[a]+")(?:\\.("+c[a]+")(?:\\.("+c[a]+")(?:"+c[f]+")?"+c[m]+"?)?)?";var d=w++;c[d]="[v=\\s]*("+c[r]+")(?:\\.("+c[r]+")(?:\\.("+c[r]+")(?:"+c[v]+")?"+c[m]+"?)?)?";var S=w++;c[S]="^"+c[n]+"\\s*"+c[u]+"$";var O=w++;c[O]="^"+c[n]+"\\s*"+c[d]+"$";var N=w++;c[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=w++;c[_]="(?:~>?)";var J=w++;c[J]="(\\s*)"+c[_]+"\\s+",P[J]=new RegExp(c[J],"g");var re=w++;c[re]="^"+c[_]+c[u]+"$";var ee=w++;c[ee]="^"+c[_]+c[d]+"$";var ie=w++;c[ie]="(?:\\^)";var he=w++;c[he]="(\\s*)"+c[ie]+"\\s+",P[he]=new RegExp(c[he],"g");var ue=w++;c[ue]="^"+c[ie]+c[u]+"$";var x=w++;c[x]="^"+c[ie]+c[d]+"$";var te=w++;c[te]="^"+c[n]+"\\s*("+s+")$|^$";var U=w++;c[U]="^"+c[n]+"\\s*("+e+")$|^$";var k=w++;c[k]="(\\s*)"+c[n]+"\\s*("+s+"|"+c[u]+")",P[k]=new RegExp(c[k],"g");var z=w++;c[z]="^\\s*("+c[u]+")\\s+-\\s+("+c[u]+")\\s*$";var G=w++;c[G]="^\\s*("+c[d]+")\\s+-\\s+("+c[d]+")\\s*$";var ne=w++;c[ne]="(<|>)?=?\\s*\\*";for(var K=0;K<35;K++)b(K,c[K]),P[K]||(P[K]=new RegExp(c[K]));function Z(F,W){if(F instanceof q)return F;if(typeof F!="string"||F.length>R||!(W?P[i]:P[o]).test(F))return null;try{return new q(F,W)}catch{return null}}function q(F,W){if(F instanceof q){if(F.loose===W)return F;F=F.version}else if(typeof F!="string")throw new TypeError("Invalid Version: "+F);if(F.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof q))return new q(F,W);b("SemVer",F,W),this.loose=W;var $=F.trim().match(W?P[i]:P[o]);if(!$)throw new TypeError("Invalid Version: "+F);if(this.raw=F,this.major=+$[1],this.minor=+$[2],this.patch=+$[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");$[4]?this.prerelease=$[4].split(".").map(function(le){if(/^[0-9]+$/.test(le)){var de=+le;if(de>=0&&de<T)return de}return le}):this.prerelease=[],this.build=$[5]?$[5].split("."):[],this.format()}t.parse=Z,t.valid=function(F,W){var $=Z(F,W);return $?$.version:null},t.clean=function(F,W){var $=Z(F.trim().replace(/^[=v]+/,""),W);return $?$.version:null},t.SemVer=q,q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},q.prototype.toString=function(){return this.version},q.prototype.compare=function(F){return b("SemVer.compare",this.version,this.loose,F),F instanceof q||(F=new q(F,this.loose)),this.compareMain(F)||this.comparePre(F)},q.prototype.compareMain=function(F){return F instanceof q||(F=new q(F,this.loose)),A(this.major,F.major)||A(this.minor,F.minor)||A(this.patch,F.patch)},q.prototype.comparePre=function(F){if(F instanceof q||(F=new q(F,this.loose)),this.prerelease.length&&!F.prerelease.length)return-1;if(!this.prerelease.length&&F.prerelease.length)return 1;if(!this.prerelease.length&&!F.prerelease.length)return 0;var W=0;do{var $=this.prerelease[W],le=F.prerelease[W];if(b("prerelease compare",W,$,le),$===void 0&&le===void 0)return 0;if(le===void 0)return 1;if($===void 0)return-1;if($!==le)return A($,le)}while(++W)},q.prototype.inc=function(F,W){switch(F){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",W);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",W);break;case"prepatch":this.prerelease.length=0,this.inc("patch",W),this.inc("pre",W);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",W),this.inc("pre",W);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var $=this.prerelease.length;--$>=0;)typeof this.prerelease[$]=="number"&&(this.prerelease[$]++,$=-2);$===-1&&this.prerelease.push(0)}W&&(this.prerelease[0]===W?isNaN(this.prerelease[1])&&(this.prerelease=[W,0]):this.prerelease=[W,0]);break;default:throw new Error("invalid increment argument: "+F)}return this.format(),this.raw=this.version,this},t.inc=function(F,W,$,le){typeof $=="string"&&(le=$,$=void 0);try{return new q(F,$).inc(W,le).version}catch{return null}},t.diff=function(F,W){if(X(F,W))return null;var $=Z(F),le=Z(W);if($.prerelease.length||le.prerelease.length){for(var de in $)if((de==="major"||de==="minor"||de==="patch")&&$[de]!==le[de])return"pre"+de;return"prerelease"}for(var de in $)if((de==="major"||de==="minor"||de==="patch")&&$[de]!==le[de])return de},t.compareIdentifiers=A;var M=/^[0-9]+$/;function A(F,W){var $=M.test(F),le=M.test(W);return $&&le&&(F=+F,W=+W),$&&!le?-1:le&&!$?1:F<W?-1:F>W?1:0}function V(F,W,$){return new q(F,$).compare(new q(W,$))}function B(F,W,$){return V(F,W,$)>0}function H(F,W,$){return V(F,W,$)<0}function X(F,W,$){return V(F,W,$)===0}function ae(F,W,$){return V(F,W,$)!==0}function ce(F,W,$){return V(F,W,$)>=0}function we(F,W,$){return V(F,W,$)<=0}function fe(F,W,$,le){var de;switch(W){case"===":typeof F=="object"&&(F=F.version),typeof $=="object"&&($=$.version),de=F===$;break;case"!==":typeof F=="object"&&(F=F.version),typeof $=="object"&&($=$.version),de=F!==$;break;case"":case"=":case"==":de=X(F,$,le);break;case"!=":de=ae(F,$,le);break;case">":de=B(F,$,le);break;case">=":de=ce(F,$,le);break;case"<":de=H(F,$,le);break;case"<=":de=we(F,$,le);break;default:throw new TypeError("Invalid operator: "+W)}return de}function se(F,W){if(F instanceof se){if(F.loose===W)return F;F=F.value}if(!(this instanceof se))return new se(F,W);b("comparator",F,W),this.loose=W,this.parse(F),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}t.rcompareIdentifiers=function(F,W){return A(W,F)},t.major=function(F,W){return new q(F,W).major},t.minor=function(F,W){return new q(F,W).minor},t.patch=function(F,W){return new q(F,W).patch},t.compare=V,t.compareLoose=function(F,W){return V(F,W,!0)},t.rcompare=function(F,W,$){return V(W,F,$)},t.sort=function(F,W){return F.sort(function($,le){return t.compare($,le,W)})},t.rsort=function(F,W){return F.sort(function($,le){return t.rcompare($,le,W)})},t.gt=B,t.lt=H,t.eq=X,t.neq=ae,t.gte=ce,t.lte=we,t.cmp=fe,t.Comparator=se;var pe={};function me(F,W){if(F instanceof me)return F.loose===W?F:new me(F.raw,W);if(F instanceof se)return new me(F.value,W);if(!(this instanceof me))return new me(F,W);if(this.loose=W,this.raw=F,this.set=F.split(/\s*\|\|\s*/).map(function($){return this.parseRange($.trim())},this).filter(function($){return $.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+F);this.format()}function Ee(F){return!F||F.toLowerCase()==="x"||F==="*"}function Ie(F,W,$,le,de,Ce,Se,ke,Re,Oe,Ne,De,Le){return((W=Ee($)?"":Ee(le)?">="+$+".0.0":Ee(de)?">="+$+"."+le+".0":">="+W)+" "+(ke=Ee(Re)?"":Ee(Oe)?"<"+(+Re+1)+".0.0":Ee(Ne)?"<"+Re+"."+(+Oe+1)+".0":De?"<="+Re+"."+Oe+"."+Ne+"-"+De:"<="+ke)).trim()}function Me(F,W){for(var $=0;$<F.length;$++)if(!F[$].test(W))return!1;if(W.prerelease.length){for($=0;$<F.length;$++)if(b(F[$].semver),F[$].semver!==pe&&F[$].semver.prerelease.length>0){var le=F[$].semver;if(le.major===W.major&&le.minor===W.minor&&le.patch===W.patch)return!0}return!1}return!0}function xe(F,W,$){try{W=new me(W,$)}catch{return!1}return W.test(F)}function Ve(F,W,$,le){var de,Ce,Se,ke,Re;switch(F=new q(F,le),W=new me(W,le),$){case">":de=B,Ce=we,Se=H,ke=">",Re=">=";break;case"<":de=H,Ce=ce,Se=B,ke="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(xe(F,W,le))return!1;for(var Oe=0;Oe<W.set.length;++Oe){var Ne=W.set[Oe],De=null,Le=null;if(Ne.forEach(function(Ae){Ae.semver===pe&&(Ae=new se(">=0.0.0")),De=De||Ae,Le=Le||Ae,de(Ae.semver,De.semver,le)?De=Ae:Se(Ae.semver,Le.semver,le)&&(Le=Ae)}),De.operator===ke||De.operator===Re||(!Le.operator||Le.operator===ke)&&Ce(F,Le.semver)||Le.operator===Re&&Se(F,Le.semver))return!1}return!0}se.prototype.parse=function(F){var W=this.loose?P[te]:P[U],$=F.match(W);if(!$)throw new TypeError("Invalid comparator: "+F);this.operator=$[1],this.operator==="="&&(this.operator=""),$[2]?this.semver=new q($[2],this.loose):this.semver=pe},se.prototype.toString=function(){return this.value},se.prototype.test=function(F){return b("Comparator.test",F,this.loose),this.semver===pe||(typeof F=="string"&&(F=new q(F,this.loose)),fe(F,this.operator,this.semver,this.loose))},se.prototype.intersects=function(F,W){if(!(F instanceof se))throw new TypeError("a Comparator is required");var $;if(this.operator==="")return $=new me(F.value,W),xe(this.value,$,W);if(F.operator==="")return $=new me(this.value,W),xe(F.semver,$,W);var le=!(this.operator!==">="&&this.operator!==">"||F.operator!==">="&&F.operator!==">"),de=!(this.operator!=="<="&&this.operator!=="<"||F.operator!=="<="&&F.operator!=="<"),Ce=this.semver.version===F.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||F.operator!==">="&&F.operator!=="<="),ke=fe(this.semver,"<",F.semver,W)&&(this.operator===">="||this.operator===">")&&(F.operator==="<="||F.operator==="<"),Re=fe(this.semver,">",F.semver,W)&&(this.operator==="<="||this.operator==="<")&&(F.operator===">="||F.operator===">");return le||de||Ce&&Se||ke||Re},t.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(F){return F.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(F){var W=this.loose;F=F.trim(),b("range",F,W);var $=W?P[G]:P[z];F=F.replace($,Ie),b("hyphen replace",F),F=F.replace(P[k],"$1$2$3"),b("comparator trim",F,P[k]),F=(F=(F=F.replace(P[J],"$1~")).replace(P[he],"$1^")).split(/\s+/).join(" ");var le=W?P[te]:P[U],de=F.split(" ").map(function(Ce){return function(Se,ke){return b("comp",Se),Se=function(Re,Oe){return Re.trim().split(/\s+/).map(function(Ne){return function(De,Le){b("caret",De,Le);var Ae=Le?P[x]:P[ue];return De.replace(Ae,function(Fe,ve,ye,be,Pe){var Te;return b("caret",De,Fe,ve,ye,be,Pe),Ee(ve)?Te="":Ee(ye)?Te=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ee(be)?Te=ve==="0"?">="+ve+"."+ye+".0 <"+ve+"."+(+ye+1)+".0":">="+ve+"."+ye+".0 <"+(+ve+1)+".0.0":Pe?(b("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Te=ve==="0"?ye==="0"?">="+ve+"."+ye+"."+be+Pe+" <"+ve+"."+ye+"."+(+be+1):">="+ve+"."+ye+"."+be+Pe+" <"+ve+"."+(+ye+1)+".0":">="+ve+"."+ye+"."+be+Pe+" <"+(+ve+1)+".0.0"):(b("no pr"),Te=ve==="0"?ye==="0"?">="+ve+"."+ye+"."+be+" <"+ve+"."+ye+"."+(+be+1):">="+ve+"."+ye+"."+be+" <"+ve+"."+(+ye+1)+".0":">="+ve+"."+ye+"."+be+" <"+(+ve+1)+".0.0"),b("caret return",Te),Te})}(Ne,Oe)}).join(" ")}(Se,ke),b("caret",Se),Se=function(Re,Oe){return Re.trim().split(/\s+/).map(function(Ne){return function(De,Le){var Ae=Le?P[ee]:P[re];return De.replace(Ae,function(Fe,ve,ye,be,Pe){var Te;return b("tilde",De,Fe,ve,ye,be,Pe),Ee(ve)?Te="":Ee(ye)?Te=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ee(be)?Te=">="+ve+"."+ye+".0 <"+ve+"."+(+ye+1)+".0":Pe?(b("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Te=">="+ve+"."+ye+"."+be+Pe+" <"+ve+"."+(+ye+1)+".0"):Te=">="+ve+"."+ye+"."+be+" <"+ve+"."+(+ye+1)+".0",b("tilde return",Te),Te})}(Ne,Oe)}).join(" ")}(Se,ke),b("tildes",Se),Se=function(Re,Oe){return b("replaceXRanges",Re,Oe),Re.split(/\s+/).map(function(Ne){return function(De,Le){De=De.trim();var Ae=Le?P[O]:P[S];return De.replace(Ae,function(Fe,ve,ye,be,Pe,Te){b("xRange",De,Fe,ve,ye,be,Pe,Te);var je=Ee(ye),Ue=je||Ee(be),ze=Ue||Ee(Pe);return ve==="="&&ze&&(ve=""),je?Fe=ve===">"||ve==="<"?"<0.0.0":"*":ve&&ze?(Ue&&(be=0),ze&&(Pe=0),ve===">"?(ve=">=",Ue?(ye=+ye+1,be=0,Pe=0):ze&&(be=+be+1,Pe=0)):ve==="<="&&(ve="<",Ue?ye=+ye+1:be=+be+1),Fe=ve+ye+"."+be+"."+Pe):Ue?Fe=">="+ye+".0.0 <"+(+ye+1)+".0.0":ze&&(Fe=">="+ye+"."+be+".0 <"+ye+"."+(+be+1)+".0"),b("xRange return",Fe),Fe})}(Ne,Oe)}).join(" ")}(Se,ke),b("xrange",Se),Se=function(Re,Oe){return b("replaceStars",Re,Oe),Re.trim().replace(P[ne],"")}(Se,ke),b("stars",Se),Se}(Ce,W)}).join(" ").split(/\s+/);return this.loose&&(de=de.filter(function(Ce){return!!Ce.match(le)})),de=de.map(function(Ce){return new se(Ce,W)})},me.prototype.intersects=function(F,W){if(!(F instanceof me))throw new TypeError("a Range is required");return this.set.some(function($){return $.every(function(le){return F.set.some(function(de){return de.every(function(Ce){return le.intersects(Ce,W)})})})})},t.toComparators=function(F,W){return new me(F,W).set.map(function($){return $.map(function(le){return le.value}).join(" ").trim().split(" ")})},me.prototype.test=function(F){if(!F)return!1;typeof F=="string"&&(F=new q(F,this.loose));for(var W=0;W<this.set.length;W++)if(Me(this.set[W],F))return!0;return!1},t.satisfies=xe,t.maxSatisfying=function(F,W,$){var le=null,de=null;try{var Ce=new me(W,$)}catch{return null}return F.forEach(function(Se){Ce.test(Se)&&(le&&de.compare(Se)!==-1||(de=new q(le=Se,$)))}),le},t.minSatisfying=function(F,W,$){var le=null,de=null;try{var Ce=new me(W,$)}catch{return null}return F.forEach(function(Se){Ce.test(Se)&&(le&&de.compare(Se)!==1||(de=new q(le=Se,$)))}),le},t.validRange=function(F,W){try{return new me(F,W).range||"*"}catch{return null}},t.ltr=function(F,W,$){return Ve(F,W,"<",$)},t.gtr=function(F,W,$){return Ve(F,W,">",$)},t.outside=Ve,t.prerelease=function(F,W){var $=Z(F,W);return $&&$.prerelease.length?$.prerelease:null},t.intersects=function(F,W,$){return F=new me(F,$),W=new me(W,$),F.intersects(W)},t.coerce=function(F){if(F instanceof q)return F;if(typeof F!="string")return null;var W=F.match(P[N]);return W==null?null:Z((W[1]||"0")+"."+(W[2]||"0")+"."+(W[3]||"0"))}}).call(this,C(1))},function(j,t){var C,D,b=j.exports={};function R(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function P(l){if(C===setTimeout)return setTimeout(l,0);if((C===R||!C)&&setTimeout)return C=setTimeout,setTimeout(l,0);try{return C(l,0)}catch{try{return C.call(null,l,0)}catch{return C.call(this,l,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:R}catch{C=R}try{D=typeof clearTimeout=="function"?clearTimeout:T}catch{D=T}})();var c,w=[],I=!1,L=-1;function h(){I&&c&&(I=!1,c.length?w=c.concat(w):L=-1,w.length&&y())}function y(){if(!I){var l=P(h);I=!0;for(var f=w.length;f;){for(c=w,w=[];++L<f;)c&&c[L].run();L=-1,f=w.length}c=null,I=!1,function(v){if(D===clearTimeout)return clearTimeout(v);if((D===T||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(v);try{D(v)}catch{try{return D.call(null,v)}catch{return D.call(this,v)}}}(l)}}function E(l,f){this.fun=l,this.array=f}function g(){}b.nextTick=function(l){var f=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)f[v-1]=arguments[v];w.push(new E(l,f)),w.length!==1||I||P(y)},E.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=g,b.addListener=g,b.once=g,b.off=g,b.removeListener=g,b.removeAllListeners=g,b.emit=g,b.prependListener=g,b.prependOnceListener=g,b.listeners=function(l){return[]},b.binding=function(l){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(l){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(Y[58],Q([0,1]),function(j,t){"use strict";var C;Object.defineProperty(t,"__esModule",{value:!0}),t.SkipList=void 0;class D{constructor(P,c,w){this.level=P,this.key=c,this.value=w,this.forward=[]}}const b=void 0;class R{constructor(P,c=2**16){this.comparator=P,this[C]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(c)|0),this._header=new D(this._maxLevel,b,b)}get size(){return this._size}clear(){this._header=new D(this._maxLevel,b,b)}has(P){return Boolean(R._search(this,P,this.comparator))}get(P){return R._search(this,P,this.comparator)?.value}set(P,c){return R._insert(this,P,c,this.comparator)&&(this._size+=1),this}delete(P){const c=R._delete(this,P,this.comparator);return c&&(this._size-=1),c}forEach(P,c){let w=this._header.forward[0];for(;w;)P.call(c,w.value,w.key,this),w=w.forward[0]}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",c=this._header.forward[0];for(;c;)P+=`node(${c.key}, ${c.value}, lvl:${c.level})`,c=c.forward[0];return P}static _search(P,c,w){let I=P._header;for(let L=P._level-1;L>=0;L--)for(;I.forward[L]&&w(I.forward[L].key,c)<0;)I=I.forward[L];if(I=I.forward[0],I&&w(I.key,c)===0)return I}static _insert(P,c,w,I){let L=[],h=P._header;for(let y=P._level-1;y>=0;y--){for(;h.forward[y]&&I(h.forward[y].key,c)<0;)h=h.forward[y];L[y]=h}if(h=h.forward[0],h&&I(h.key,c)===0)return h.value=w,!1;{let y=R._randomLevel(P);if(y>P._level){for(let E=P._level;E<y;E++)L[E]=P._header;P._level=y}h=new D(y,c,w);for(let E=0;E<y;E++)h.forward[E]=L[E].forward[E],L[E].forward[E]=h;return!0}}static _randomLevel(P,c=.5){let w=1;for(;Math.random()<c&&w<P._maxLevel;)w+=1;return w}static _delete(P,c,w){let I=[],L=P._header;for(let h=P._level-1;h>=0;h--){for(;L.forward[h]&&w(L.forward[h].key,c)<0;)L=L.forward[h];I[h]=L}if(L=L.forward[0],!L||w(L.key,c)!==0)return!1;for(let h=0;h<P._level&&I[h].forward[h]===L;h++)I[h].forward[h]=L.forward[h];for(;P._level>0&&P._header.forward[P._level-1]===b;)P._level-=1;return!0}}t.SkipList=R}),define(Y[38],Q([0,1,8,2]),function(j,t,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function b(p){const m=p;return m?[m.on,m.pause,m.resume,m.destroy].every(o=>typeof o=="function"):!1}t.isReadableStream=b;function R(p){const m=p;return m?b(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}t.isReadableBufferedStream=R;function T(p,m){return new P(p,m)}t.newWriteableStream=T;class P{constructor(m,o){this.reducer=m,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(m){if(!this.state.destroyed){if(this.state.flowing)this.emitData(m);else if(this.buffer.data.push(m),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(m){this.state.destroyed||(this.state.flowing?this.emitError(m):this.buffer.error.push(m))}end(m){this.state.destroyed||(typeof m!="undefined"&&this.write(m),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(m){this.listeners.data.slice(0).forEach(o=>o(m))}emitError(m){this.listeners.error.length===0?(0,C.onUnexpectedError)(m):this.listeners.error.slice(0).forEach(o=>o(m))}emitEnd(){this.listeners.end.slice(0).forEach(m=>m())}on(m,o){if(!this.state.destroyed)switch(m){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(m,o){if(this.state.destroyed)return;let e;switch(m){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const s=e.indexOf(o);s>=0&&e.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const m=this.reducer(this.buffer.data);this.emitData(m),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const m of this.buffer.error)this.emitError(m);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(p,m){const o=[];let e;for(;(e=p.read())!==null;)o.push(e);return m(o)}t.consumeReadable=c;function w(p,m,o){const e=[];let s;for(;(s=p.read())!==null&&e.length<o;)e.push(s);return s===null&&e.length>0?m(e):{read:()=>{if(e.length>0)return e.shift();if(typeof s!="undefined"){const i=s;return s=void 0,i}return p.read()}}}t.peekReadable=w;function I(p,m){return new Promise((o,e)=>{const s=[];L(p,{onData:i=>{m&&s.push(i)},onError:i=>{m?e(i):o(void 0)},onEnd:()=>{o(m?m(s):void 0)}})})}t.consumeStream=I;function L(p,m){let o=!1;return p.on("error",e=>{o||m.onError(e)}),p.on("end",()=>{o||m.onEnd()}),p.on("data",e=>{o||m.onData(e)}),(0,D.toDisposable)(()=>o=!0)}t.listenStream=L;function h(p,m){return new Promise((o,e)=>{const s=new D.DisposableStore,i=[],n=u=>{if(i.push(u),i.length>m)return s.dispose(),p.pause(),o({stream:p,buffer:i,ended:!1})},r=u=>e(u),a=()=>o({stream:p,buffer:i,ended:!0});s.add((0,D.toDisposable)(()=>p.removeListener("error",r))),p.on("error",r),s.add((0,D.toDisposable)(()=>p.removeListener("end",a))),p.on("end",a),s.add((0,D.toDisposable)(()=>p.removeListener("data",n))),p.on("data",n)})}t.peekStream=h;function y(p,m){const o=T(m);return o.end(p),o}t.toStream=y;function E(){const p=T(()=>{throw new Error("not supported")});return p.end(),p}t.emptyStream=E;function g(p){let m=!1;return{read:()=>m?null:(m=!0,p)}}t.toReadable=g;function l(p,m,o){const e=T(o);return L(p,{onData:s=>e.write(m.data(s)),onError:s=>e.error(m.error?m.error(s):s),onEnd:()=>e.end()}),e}t.transform=l;function f(p,m,o){let e=!1;return{read:()=>{const s=m.read();return e?s:(e=!0,s!==null?o([p,s]):p)}}}t.prefixedReadable=f;function v(p,m,o){let e=!1;const s=T(o);return L(m,{onData:i=>e?s.write(i):(e=!0,s.write(o([p,i]))),onError:i=>s.error(i),onEnd:()=>{e||(e=!0,s.write(p)),s.end()}}),s}t.prefixedStream=v}),define(Y[17],Q([0,1,38]),function(j,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const D=typeof Buffer!="undefined";let b,R;class T{constructor(d){this.buffer=d,this.byteLength=this.buffer.byteLength}static alloc(d){return D?new T(Buffer.allocUnsafe(d)):new T(new Uint8Array(d))}static wrap(d){return D&&!Buffer.isBuffer(d)&&(d=Buffer.from(d.buffer,d.byteOffset,d.byteLength)),new T(d)}static fromString(d,S){return!(S?.dontUseNodeBuffer||!1)&&D?new T(Buffer.from(d)):(b||(b=new TextEncoder),new T(b.encode(d)))}static fromByteArray(d){const S=T.alloc(d.length);for(let O=0,N=d.length;O<N;O++)S.buffer[O]=d[O];return S}static concat(d,S){if(typeof S=="undefined"){S=0;for(let _=0,J=d.length;_<J;_++)S+=d[_].byteLength}const O=T.alloc(S);let N=0;for(let _=0,J=d.length;_<J;_++){const re=d[_];O.set(re,N),N+=re.byteLength}return O}clone(){const d=T.alloc(this.byteLength);return d.set(this),d}toString(){return D?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(d,S){return new T(this.buffer.subarray(d,S))}set(d,S){if(d instanceof T)this.buffer.set(d.buffer,S);else if(d instanceof Uint8Array)this.buffer.set(d,S);else if(d instanceof ArrayBuffer)this.buffer.set(new Uint8Array(d),S);else if(ArrayBuffer.isView(d))this.buffer.set(new Uint8Array(d.buffer,d.byteOffset,d.byteLength),S);else throw new Error("Unknown argument 'array'")}readUInt32BE(d){return w(this.buffer,d)}writeUInt32BE(d,S){I(this.buffer,d,S)}readUInt32LE(d){return L(this.buffer,d)}writeUInt32LE(d,S){h(this.buffer,d,S)}readUInt8(d){return y(this.buffer,d)}writeUInt8(d,S){E(this.buffer,d,S)}}t.VSBuffer=T;function P(u,d){return u[d+0]<<0>>>0|u[d+1]<<8>>>0}t.readUInt16LE=P;function c(u,d,S){u[S+0]=d&255,d=d>>>8,u[S+1]=d&255}t.writeUInt16LE=c;function w(u,d){return u[d]*2**24+u[d+1]*2**16+u[d+2]*2**8+u[d+3]}t.readUInt32BE=w;function I(u,d,S){u[S+3]=d,d=d>>>8,u[S+2]=d,d=d>>>8,u[S+1]=d,d=d>>>8,u[S]=d}t.writeUInt32BE=I;function L(u,d){return u[d+0]<<0>>>0|u[d+1]<<8>>>0|u[d+2]<<16>>>0|u[d+3]<<24>>>0}t.readUInt32LE=L;function h(u,d,S){u[S+0]=d&255,d=d>>>8,u[S+1]=d&255,d=d>>>8,u[S+2]=d&255,d=d>>>8,u[S+3]=d&255}t.writeUInt32LE=h;function y(u,d){return u[d]}t.readUInt8=y;function E(u,d,S){u[S]=d}t.writeUInt8=E;function g(u){return C.consumeReadable(u,d=>T.concat(d))}t.readableToBuffer=g;function l(u){return C.toReadable(u)}t.bufferToReadable=l;function f(u){return C.consumeStream(u,d=>T.concat(d))}t.streamToBuffer=f;async function v(u){return u.ended?T.concat(u.buffer):T.concat([...u.buffer,await f(u.stream)])}t.bufferedStreamToBuffer=v;function p(u){return C.toStream(u,d=>T.concat(d))}t.bufferToStream=p;function m(u){return C.transform(u,{data:d=>typeof d=="string"?T.fromString(d):T.wrap(d)},d=>T.concat(d))}t.streamToBufferReadableStream=m;function o(u){return C.newWriteableStream(d=>T.concat(d),u)}t.newWriteableBufferStream=o;function e(u,d){return C.prefixedReadable(u,d,S=>T.concat(S))}t.prefixedBufferReadable=e;function s(u,d){return C.prefixedStream(u,d,S=>T.concat(S))}t.prefixedBufferStream=s;function i(u){let d=0,S=0,O=0;const N=new Uint8Array(Math.floor(u.length/4*3)),_=re=>{switch(S){case 3:N[O++]=d|re,S=0;break;case 2:N[O++]=d|re>>>2,d=re<<6,S=3;break;case 1:N[O++]=d|re>>>4,d=re<<4,S=2;break;default:d=re<<2,S=1}};for(let re=0;re<u.length;re++){const ee=u.charCodeAt(re);if(ee>=65&&ee<=90)_(ee-65);else if(ee>=97&&ee<=122)_(ee-97+26);else if(ee>=48&&ee<=57)_(ee-48+52);else if(ee===43||ee===45)_(62);else if(ee===47||ee===95)_(63);else{if(ee===61)break;throw new SyntaxError(`Unexpected base64 character ${u[re]}`)}}const J=O;for(;S>0;)_(0);return T.wrap(N).slice(0,J)}t.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:u},d=!0,S=!1){const O=S?r:n;let N="";const _=u.byteLength%3;let J=0;for(;J<u.byteLength-_;J+=3){const re=u[J+0],ee=u[J+1],ie=u[J+2];N+=O[re>>>2],N+=O[(re<<4|ee>>>4)&63],N+=O[(ee<<2|ie>>>6)&63],N+=O[ie&63]}if(_===1){const re=u[J+0];N+=O[re>>>2],N+=O[re<<4&63],d&&(N+="==")}else if(_===2){const re=u[J+0],ee=u[J+1];N+=O[re>>>2],N+=O[(re<<4|ee>>>4)&63],N+=O[ee<<2&63],d&&(N+="=")}return N}t.encodeBase64=a}),define(Y[59],Q([0,1,26]),function(j,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function D(f){return b(f,0)}t.hash=D;function b(f,v){switch(typeof f){case"object":return f===null?R(349,v):Array.isArray(f)?c(f,v):w(f,v);case"string":return P(f,v);case"boolean":return T(f,v);case"number":return R(f,v);case"undefined":return R(937,v);default:return R(617,v)}}t.doHash=b;function R(f,v){return(v<<5)-v+f|0}t.numberHash=R;function T(f,v){return R(f?433:863,v)}function P(f,v){v=R(149417,v);for(let p=0,m=f.length;p<m;p++)v=R(f.charCodeAt(p),v);return v}t.stringHash=P;function c(f,v){return v=R(104579,v),f.reduce((p,m)=>b(m,p),v)}function w(f,v){return v=R(181387,v),Object.keys(f).sort().reduce((p,m)=>(p=P(m,p),b(f[m],p)),v)}class I{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=b(v,this._value),this._value}}t.Hasher=I;var L;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(L||(L={}));function h(f,v,p=32){const m=p-v,o=~((1<<m)-1);return(f<<v|(o&f)>>>m)>>>0}function y(f,v=0,p=f.byteLength,m=0){for(let o=0;o<p;o++)f[v+o]=m}function E(f,v,p="0"){for(;f.length<v;)f=p+f;return f}function g(f,v=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(p=>p.toString(16).padStart(2,"0")).join(""):E((f>>>0).toString(16),v/4)}t.toHexString=g;class l{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const p=v.length;if(p===0)return;const m=this._buff;let o=this._buffLen,e=this._leftoverHighSurrogate,s,i;for(e!==0?(s=e,i=-1,e=0):(s=v.charCodeAt(0),i=0);;){let n=s;if(C.isHighSurrogate(s))if(i+1<p){const r=v.charCodeAt(i+1);C.isLowSurrogate(r)?(i++,n=C.computeCodePoint(s,r)):n=65533}else{e=s;break}else C.isLowSurrogate(s)&&(n=65533);if(o=this._push(m,o,n),i++,i<p)s=v.charCodeAt(i);else break}this._buffLen=o,this._leftoverHighSurrogate=e}_push(v,p,m){return m<128?v[p++]=m:m<2048?(v[p++]=192|(m&1984)>>>6,v[p++]=128|(m&63)>>>0):m<65536?(v[p++]=224|(m&61440)>>>12,v[p++]=128|(m&4032)>>>6,v[p++]=128|(m&63)>>>0):(v[p++]=240|(m&1835008)>>>18,v[p++]=128|(m&258048)>>>12,v[p++]=128|(m&4032)>>>6,v[p++]=128|(m&63)>>>0),p>=64&&(this._step(),p-=64,this._totalLen+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),p}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=l._bigBlock32,p=this._buffDV;for(let u=0;u<64;u+=4)v.setUint32(u,p.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)v.setUint32(u,h(v.getUint32(u-12,!1)^v.getUint32(u-32,!1)^v.getUint32(u-56,!1)^v.getUint32(u-64,!1),1),!1);let m=this._h0,o=this._h1,e=this._h2,s=this._h3,i=this._h4,n,r,a;for(let u=0;u<80;u++)u<20?(n=o&e|~o&s,r=1518500249):u<40?(n=o^e^s,r=1859775393):u<60?(n=o&e|o&s|e&s,r=2400959708):(n=o^e^s,r=3395469782),a=h(m,5)+n+i+r+v.getUint32(u*4,!1)&4294967295,i=s,s=e,e=h(o,30),o=m,m=a;this._h0=this._h0+m&4294967295,this._h1=this._h1+o&4294967295,this._h2=this._h2+e&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+i&4294967295}}t.StringSHA1=l,l._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Y[22],Q([0,1,6]),function(j,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function D(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const l=Array.isArray(g)?[]:{};return Object.keys(g).forEach(f=>{g[f]&&typeof g[f]=="object"?l[f]=D(g[f]):l[f]=g[f]}),l}t.deepClone=D;function b(g){if(!g||typeof g!="object")return g;const l=[g];for(;l.length>0;){const f=l.shift();Object.freeze(f);for(const v in f)if(R.call(f,v)){const p=f[v];typeof p=="object"&&!Object.isFrozen(p)&&l.push(p)}}return g}t.deepFreeze=b;const R=Object.prototype.hasOwnProperty;function T(g,l){return P(g,l,new Set)}t.cloneAndChange=T;function P(g,l,f){if((0,C.isUndefinedOrNull)(g))return g;const v=l(g);if(typeof v!="undefined")return v;if((0,C.isArray)(g)){const p=[];for(const m of g)p.push(P(m,l,f));return p}if((0,C.isObject)(g)){if(f.has(g))throw new Error("Cannot clone recursive data-structure");f.add(g);const p={};for(let m in g)R.call(g,m)&&(p[m]=P(g[m],l,f));return f.delete(g),p}return g}function c(g,l,f=!0){return(0,C.isObject)(g)?((0,C.isObject)(l)&&Object.keys(l).forEach(v=>{v in g?f&&((0,C.isObject)(g[v])&&(0,C.isObject)(l[v])?c(g[v],l[v],f):g[v]=l[v]):g[v]=l[v]}),g):l}t.mixin=c;function w(g,l){if(g===l)return!0;if(g==null||l===null||l===void 0||typeof g!=typeof l||typeof g!="object"||Array.isArray(g)!==Array.isArray(l))return!1;let f,v;if(Array.isArray(g)){if(g.length!==l.length)return!1;for(f=0;f<g.length;f++)if(!w(g[f],l[f]))return!1}else{const p=[];for(v in g)p.push(v);p.sort();const m=[];for(v in l)m.push(v);if(m.sort(),!w(p,m))return!1;for(f=0;f<p.length;f++)if(!w(g[p[f]],l[p[f]]))return!1}return!0}t.equals=w;function I(g){const l=new Set;return JSON.stringify(g,(f,v)=>{if((0,C.isObject)(v)||Array.isArray(v)){if(l.has(v))return"[Circular]";l.add(v)}return v})}t.safeStringify=I;function L(g,l,f){const v=l(g);return typeof v=="undefined"?f:v}t.getOrDefault=L;function h(g,l){const f=Object.create(null);return!g||!l||Object.keys(l).forEach(p=>{const m=g[p],o=l[p];w(m,o)||(f[p]=o)}),f}t.distinct=h;function y(g,l){const f=l.toLowerCase(),v=Object.keys(g).find(p=>p.toLowerCase()===f);return v?g[v]:g[l]}t.getCaseInsensitive=y;function E(g,l){const f=Object.create(null);for(const[v,p]of Object.entries(g))l(v,p)&&(f[v]=p);return f}t.filter=E}),define(Y[60],Q([0,1,9]),function(j,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function D(w){const I=w;return I&&typeof I.type=="string"&&typeof I.severity=="string"}t.isRemoteConsoleLog=D;function b(w){const I=[];let L;try{const h=JSON.parse(w.arguments),y=h[h.length-1];y&&y.__$stack&&(h.pop(),L=y.__$stack),I.push(...h)}catch{I.push("Unable to log remote console arguments",w.arguments)}return{args:I,stack:L}}t.parse=b;function R(w){if(typeof w!="string")return R(b(w).stack);const I=w;if(I){const L=T(I),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(L||"");if(h&&h.length===4)return{uri:C.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}t.getFirstFrame=R;function T(w){if(!w)return w;const I=w.indexOf(`
`);return I===-1?w:w.substring(0,I)}function P(w,I){const{args:L,stack:h}=b(w),y=typeof L[0]=="string"&&L.length===1;let E=T(h);E&&(E=`(${E.trim()})`);let g=[];if(typeof L[0]=="string"?E&&y?g=[`%c[${I}] %c${L[0]} %c${E}`,c("blue"),c(""),c("grey")]:g=[`%c[${I}] %c${L[0]}`,c("blue"),c(""),...L.slice(1)]:g=[`%c[${I}]%`,c("blue"),...L],E&&!y&&g.push(E),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,g)}t.log=P;function c(w){return`color: ${w}`}}),define(Y[61],Q([0,1,17,26,9]),function(j,t,C,D,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function R(I){return JSON.stringify(I,c)}t.stringify=R;function T(I){let L=JSON.parse(I);return L=w(L),L}t.parse=T;var P;(function(I){I[I.Uri=1]="Uri",I[I.Regexp=2]="Regexp",I[I.ScmResource=3]="ScmResource",I[I.ScmResourceGroup=4]="ScmResourceGroup",I[I.ScmProvider=5]="ScmProvider",I[I.CommentController=6]="CommentController",I[I.CommentThread=7]="CommentThread",I[I.CommentThreadReply=8]="CommentThreadReply",I[I.CommentNode=9]="CommentNode",I[I.CommentThreadNode=10]="CommentThreadNode",I[I.TimelineActionContext=11]="TimelineActionContext",I[I.NotebookCellActionContext=12]="NotebookCellActionContext",I[I.TestItemContext=13]="TestItemContext",I[I.Date=14]="Date"})(P=t.MarshalledId||(t.MarshalledId={}));function c(I,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,D.regExpFlags)(L)}:L}function w(I,L=0){if(!I||L>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return b.URI.revive(I);case 2:return new RegExp(I.source,I.flags);case 14:return new Date(I.source)}if(I instanceof C.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let h=0;h<I.length;++h)I[h]=w(I[h],L+1);else for(const h in I)Object.hasOwnProperty.call(I,h)&&(I[h]=w(I[h],L+1))}return I}t.revive=w}),define(Y[62],Q([0,1,45,10,11,12,19,26,9]),function(j,t,C,D,b,R,T,P,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function w(n,r,a){if(typeof n=="string"&&(n=c.URI.file(n)),a){const d=a.getWorkspaceFolder(n);if(d){const S=a.getWorkspace().folders.length>1;let O;if((0,T.isEqual)(d.uri,n)?O="":O=(0,T.relativePath)(d.uri,n),S){const N=d.name?d.name:(0,T.basename)(d.uri);O=O?N+" \u2022 "+O:N}return O}}if(n.scheme!==D.Schemas.file&&n.scheme!==D.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,C.hasDriveLetter)(n.fsPath))return(0,b.normalize)(L(n.fsPath));let u=(0,b.normalize)(n.fsPath);return!R.isWindows&&r?.userHome&&(u=y(u,r.userHome.fsPath)),u}t.getPathLabel=w;function I(n){if(!n)return;typeof n=="string"&&(n=c.URI.file(n));const r=(0,T.basename)(n)||(n.scheme===D.Schemas.file?n.fsPath:n.path);return R.isWindows&&(0,C.isRootOrDriveLetter)(r)?L(r):r}t.getBaseLabel=I;function L(n,r){return(0,C.hasDriveLetter)(n,r)?n.charAt(0).toUpperCase()+n.slice(1):n}t.normalizeDriveLetter=L;let h=Object.create(null);function y(n,r){if(R.isWindows||!n||!r)return n;let a=h.original===r?h.normalized:void 0;return a||(a=`${(0,P.rtrim)(r,b.posix.sep)}${b.posix.sep}`,h={original:r,normalized:a}),(R.isLinux?n.startsWith(a):(0,P.startsWithIgnoreCase)(n,a))&&(n=`~/${n.substr(a.length)}`),n}t.tildify=y;function E(n,r){return n.replace(/^~($|\/|\\)/,`${r}$1`)}t.untildify=E;const g="\u2026",l="\\\\",f="~";function v(n,r=b.sep){const a=new Array(n.length);let u=!1;for(let d=0;d<n.length;d++){let S=n[d];if(S===""){a[d]=`.${r}`;continue}if(!S){a[d]=S;continue}u=!0;let O="";S.indexOf(l)===0?(O=S.substr(0,S.indexOf(l)+l.length),S=S.substr(S.indexOf(l)+l.length)):S.indexOf(r)===0?(O=S.substr(0,S.indexOf(r)+r.length),S=S.substr(S.indexOf(r)+r.length)):S.indexOf(f)===0&&(O=S.substr(0,S.indexOf(f)+f.length),S=S.substr(S.indexOf(f)+f.length));const N=S.split(r);for(let _=1;u&&_<=N.length;_++)for(let J=N.length-_;u&&J>=0;J--){u=!1;let re=N.slice(J,J+_).join(r);for(let ee=0;!u&&ee<n.length;ee++)if(ee!==d&&n[ee]&&n[ee].indexOf(re)>-1){const ie=J+_===N.length,he=J>0&&n[ee].indexOf(r)>-1?r+re:re,ue=n[ee].endsWith(he);u=!ie||ue}if(!u){let ee="";(N[0].endsWith(":")||O!=="")&&(J===1&&(J=0,_++,re=N[0]+r+re),J>0&&(ee=N[0]+r),ee=O+ee),J>0&&(ee=ee+g+r),ee=ee+re,J+_<N.length&&(ee=ee+r+g),a[d]=ee}}u&&(a[d]=S)}return a}t.shorten=v;var p;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function m(n,r=Object.create(null)){const a=[];let u=!1,d="";for(const S of n)if(S==="$"||u&&S==="{")d&&a.push({value:d,type:p.TEXT}),d="",u=!0;else if(S==="}"&&u){const O=r[d];if(typeof O=="string")O.length&&a.push({value:O,type:p.VARIABLE});else if(O){const N=a[a.length-1];(!N||N.type!==p.SEPARATOR)&&a.push({value:O.label,type:p.SEPARATOR})}d="",u=!1}else d+=S;return d&&!u&&a.push({value:d,type:p.TEXT}),a.filter((S,O)=>{if(S.type===p.SEPARATOR){const N=a[O-1],_=a[O+1];return[N,_].every(J=>J&&(J.type===p.VARIABLE||J.type===p.TEXT)&&J.value.length>0)}return!0}).map(S=>S.value).join("")}t.template=m;function o(n,r){return R.isMacintosh||r?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):n.replace(/&&|&/g,a=>a==="&"?"&&":"&")}t.mnemonicMenuLabel=o;function e(n,r){return R.isMacintosh||r?n.replace(/\(&&\w\)|&&/g,""):R.isWindows?n.replace(/&&|&/g,a=>a==="&"?"&&":"&"):n.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function s(n){return n.replace(/&/g,"&&")}t.unmnemonicLabel=s;function i(n){const r=n.indexOf("/")!==-1?b.posix:b.win32,a=r.basename(n),u=r.dirname(n);return a.length?{name:a,parentPath:u}:{name:u,parentPath:""}}t.splitName=i}),define(Y[27],Q([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.generateUuid=t.isUUID=void 0;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(c){return C.test(c)}t.isUUID=D;const b=new Uint8Array(16),R=[];for(let c=0;c<256;c++)R.push(c.toString(16).padStart(2,"0"));let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(c){for(let w=0;w<c.length;w++)c[w]=Math.floor(Math.random()*256);return c};function P(){T(b),b[6]=b[6]&15|64,b[8]=b[8]&63|128;let c=0,w="";return w+=R[b[c++]],w+=R[b[c++]],w+=R[b[c++]],w+=R[b[c++]],w+="-",w+=R[b[c++]],w+=R[b[c++]],w+="-",w+=R[b[c++]],w+=R[b[c++]],w+="-",w+=R[b[c++]],w+=R[b[c++]],w+="-",w+=R[b[c++]],w+=R[b[c++]],w+=R[b[c++]],w+=R[b[c++]],w+=R[b[c++]],w+=R[b[c++]],w}t.generateUuid=P}),define(Y[63],Q([0,1,132]),function(j,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class D{constructor(R="utf8"){this.stringDecoder=new C.StringDecoder(R),this.remaining=null}write(R){const T=[],P=this.remaining?this.remaining+this.stringDecoder.write(R):this.stringDecoder.write(R);if(P.length<1)return T;let c=0,w,I=c;for(;I<P.length;)if(w=P.charCodeAt(I),w===13||w===10){if(T.push(P.substring(c,I)),I++,I<P.length){const L=w;w=P.charCodeAt(I),(L===13&&w===10||L===10&&w===13)&&I++}c=I}else I++;return this.remaining=c<P.length?P.substr(c):null,T}end(){return this.remaining}}t.LineDecoder=D}),define(Y[64],Q([0,1,33,11,15]),function(j,t,C,D,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,T=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var c;(function(m){m[m.x64=0]="x64",m[m.x86=1]="x86",m[m.ARM=2]="ARM"})(c||(c={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class L{constructor(o,e,s){this.exePath=o,this.displayName=e,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await b.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function h({useAlternateBitness:m=!1}={}){return m?w===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:m=!1,findPreview:o=!1}={}){const e=h({useAlternateBitness:m});if(!e)return null;const s=D.join(e,"PowerShell");if(!await b.SymlinkSupport.existsDirectory(s))return null;let i=-1,n=null;for(const u of await b.Promises.readdir(s)){let d=-1;if(o){const O=u.indexOf("-");if(O<0)continue;const N=u.substring(0,O);if(!R.test(N)||u.substring(O+1)!=="preview")continue;d=parseInt(N,10)}else{if(!R.test(u))continue;d=parseInt(u,10)}if(d<=i)continue;const S=D.join(s,u,"pwsh.exe");!await b.SymlinkSupport.existsFile(S)||(n=S,i=d)}if(!n)return null;const r=e.includes("x86")?" (x86)":"",a=o?" Preview":"";return new L(n,`PowerShell${a}${r}`,!0)}async function E({findPreview:m}={}){if(!process.env.LOCALAPPDATA)return null;const o=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await b.SymlinkSupport.existsDirectory(o))return null;const{pwshMsixDirRegex:e,pwshMsixName:s}=m?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const i of await b.Promises.readdir(o))if(e.test(i)){const n=D.join(o,i,"pwsh.exe");return new L(n,s)}return null}function g(){const m=D.join(C.homedir(),".dotnet","tools","pwsh.exe");return new L(m,".NET Core PowerShell Global Tool")}function l(){const m=D.join(process.env.windir,w===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new L(m,"Windows PowerShell",!0)}async function*f(){let m=await y();m&&(yield m),m=await y({useAlternateBitness:!0}),m&&(yield m),m=await E(),m&&(yield m),m=g(),m&&(yield m),m=await y({findPreview:!0}),m&&(yield m),m=await E({findPreview:!0}),m&&(yield m),m=await y({useAlternateBitness:!0,findPreview:!0}),m&&(yield m),m=l(),m&&(yield m)}async function*v(){for await(const m of f())await m.exists()&&(yield m)}t.enumeratePowerShellInstallations=v;async function p(){for await(const m of v())return m;return null}t.getFirstAvailablePowerShellInstallation=p});var ge=this&&this.__decorate||function(j,t,C,D){var b=arguments.length,R=b<3?t:D===null?D=Object.getOwnPropertyDescriptor(t,C):D,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(j,t,C,D);else for(var P=j.length-1;P>=0;P--)(T=j[P])&&(R=(b<3?T(R):b>3?T(t,C,R):T(t,C))||R);return b>3&&R&&Object.defineProperty(t,C,R),R};define(Y[46],Q([0,1,18,3,17,24,44,8,7,2,61,26,6]),function(j,t,C,D,b,R,T,P,c,w,I,L,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var y;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(y=t.RequestType||(t.RequestType={}));function E(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(g=t.ResponseType||(t.ResponseType={}));function l(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(f||(f={}));class v{constructor(k){this.buffer=k,this.pos=0}read(k){const z=this.buffer.slice(this.pos,this.pos+k);return this.pos+=z.byteLength,z}}class p{constructor(){this.buffers=[]}get buffer(){return b.VSBuffer.concat(this.buffers)}write(k){this.buffers.push(k)}}var m;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object"})(m||(m={}));function o(U){const k=b.VSBuffer.alloc(4);return k.writeUInt32BE(U,0),k}function e(U){return U.read(4).readUInt32BE(0)}function s(U){const k=b.VSBuffer.alloc(1);return k.writeUInt8(U,0),k}const i={Undefined:s(m.Undefined),String:s(m.String),Buffer:s(m.Buffer),VSBuffer:s(m.VSBuffer),Array:s(m.Array),Object:s(m.Object)},n=typeof Buffer!="undefined";function r(U,k){if(typeof k=="undefined")U.write(i.Undefined);else if(typeof k=="string"){const z=b.VSBuffer.fromString(k);U.write(i.String),U.write(o(z.byteLength)),U.write(z)}else if(n&&Buffer.isBuffer(k)){const z=b.VSBuffer.wrap(k);U.write(i.Buffer),U.write(o(z.byteLength)),U.write(z)}else if(k instanceof b.VSBuffer)U.write(i.VSBuffer),U.write(o(k.byteLength)),U.write(k);else if(Array.isArray(k)){U.write(i.Array),U.write(o(k.length));for(const z of k)r(U,z)}else{const z=b.VSBuffer.fromString(JSON.stringify(k));U.write(i.Object),U.write(o(z.byteLength)),U.write(z)}}function a(U){switch(U.read(1).readUInt8(0)){case m.Undefined:return;case m.String:return U.read(e(U)).toString();case m.Buffer:return U.read(e(U)).buffer;case m.VSBuffer:return U.read(e(U));case m.Array:{const z=e(U),G=[];for(let ne=0;ne<z;ne++)G.push(a(U));return G}case m.Object:return JSON.parse(U.read(e(U)).toString())}}class u{constructor(k,z,G=null,ne=1e3){this.protocol=k,this.ctx=z,this.logger=G,this.timeoutDelay=ne,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(k,z){this.channels.set(k,z),setTimeout(()=>this.flushPendingRequests(k),0)}sendResponse(k){switch(k.type){case 200:{const z=this.send([k.type]);this.logger?.logOutgoing(z,0,1,l(k.type));return}case 201:case 202:case 204:case 203:{const z=this.send([k.type,k.id],k.data);this.logger?.logOutgoing(z,k.id,1,l(k.type),k.data);return}}}send(k,z=void 0){const G=new p;return r(G,k),r(G,z),this.sendBuffer(G.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch{return 0}}onRawMessage(k){const z=new v(k),G=a(z),ne=a(z),K=G[0];switch(K){case 100:return this.logger?.logIncoming(k.byteLength,G[1],1,`${E(K)}: ${G[2]}.${G[3]}`,ne),this.onPromise({type:K,id:G[1],channelName:G[2],name:G[3],arg:ne});case 102:return this.logger?.logIncoming(k.byteLength,G[1],1,`${E(K)}: ${G[2]}.${G[3]}`,ne),this.onEventListen({type:K,id:G[1],channelName:G[2],name:G[3],arg:ne});case 101:return this.logger?.logIncoming(k.byteLength,G[1],1,`${E(K)}`),this.disposeActiveRequest({type:K,id:G[1]});case 103:return this.logger?.logIncoming(k.byteLength,G[1],1,`${E(K)}`),this.disposeActiveRequest({type:K,id:G[1]})}}onPromise(k){const z=this.channels.get(k.channelName);if(!z){this.collectPendingRequest(k);return}const G=new R.CancellationTokenSource;let ne;try{ne=z.call(this.ctx,k.name,k.arg,G.token)}catch(q){ne=Promise.reject(q)}const K=k.id;ne.then(q=>{this.sendResponse({id:K,data:q,type:201}),this.activeRequests.delete(k.id)},q=>{q instanceof Error?this.sendResponse({id:K,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.sendResponse({id:K,data:q,type:203}),this.activeRequests.delete(k.id)});const Z=(0,w.toDisposable)(()=>G.cancel());this.activeRequests.set(k.id,Z)}onEventListen(k){const z=this.channels.get(k.channelName);if(!z){this.collectPendingRequest(k);return}const G=k.id,K=z.listen(this.ctx,k.name,k.arg)(Z=>this.sendResponse({id:G,data:Z,type:204}));this.activeRequests.set(k.id,K)}disposeActiveRequest(k){const z=this.activeRequests.get(k.id);z&&(z.dispose(),this.activeRequests.delete(k.id))}collectPendingRequest(k){let z=this.pendingRequests.get(k.channelName);z||(z=[],this.pendingRequests.set(k.channelName,z));const G=setTimeout(()=>{console.error(`Unknown channel: ${k.channelName}`),k.type===100&&this.sendResponse({id:k.id,data:{name:"Unknown channel",message:`Channel name '${k.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);z.push({request:k,timeoutTimer:G})}flushPendingRequests(k){const z=this.pendingRequests.get(k);if(z){for(const G of z)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.onPromise(G.request);break;case 102:this.onEventListen(G.request);break}this.pendingRequests.delete(k)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,w.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelServer=u;var d;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(d=t.RequestInitiator||(t.RequestInitiator={}));class S{constructor(k,z=null){this.protocol=k,this.isDisposed=!1,this.state=f.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new c.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(G=>this.onBuffer(G)),this.logger=z}getChannel(k){const z=this;return{call(G,ne,K){return z.isDisposed?Promise.reject(P.canceled()):z.requestPromise(k,G,ne,K)},listen(G,ne){return z.isDisposed?c.Event.None:z.requestEvent(k,G,ne)}}}requestPromise(k,z,G,ne=R.CancellationToken.None){const K=this.lastRequestId++,q={id:K,type:100,channelName:k,name:z,arg:G};if(ne.isCancellationRequested)return Promise.reject(P.canceled());let M;return new Promise((V,B)=>{if(ne.isCancellationRequested)return B(P.canceled());const H=()=>{const we=fe=>{switch(fe.type){case 201:this.handlers.delete(K),V(fe.data);break;case 202:{this.handlers.delete(K);const se=new Error(fe.data.message);se.stack=fe.data.stack,se.name=fe.data.name,B(se);break}case 203:this.handlers.delete(K),B(fe.data);break}};this.handlers.set(K,we),this.sendRequest(q)};let X=null;this.state===f.Idle?H():(X=(0,D.createCancelablePromise)(we=>this.whenInitialized()),X.then(()=>{X=null,H()}));const ae=()=>{X?(X.cancel(),X=null):this.sendRequest({id:K,type:101}),B(P.canceled())},ce=ne.onCancellationRequested(ae);M=(0,w.combinedDisposable)((0,w.toDisposable)(ae),ce),this.activeRequests.add(M)}).finally(()=>{this.activeRequests.delete(M)})}requestEvent(k,z,G){const ne=this.lastRequestId++,Z={id:ne,type:102,channelName:k,name:z,arg:G};let q=null;const M=new c.Emitter({onFirstListenerAdd:()=>{q=(0,D.createCancelablePromise)(V=>this.whenInitialized()),q.then(()=>{q=null,this.activeRequests.add(M),this.sendRequest(Z)})},onLastListenerRemove:()=>{q?(q.cancel(),q=null):(this.activeRequests.delete(M),this.sendRequest({id:ne,type:103}))}}),A=V=>M.fire(V.data);return this.handlers.set(ne,A),M.event}sendRequest(k){switch(k.type){case 100:case 102:{const z=this.send([k.type,k.id,k.channelName,k.name],k.arg);this.logger&&this.logger.logOutgoing(z,k.id,0,`${E(k.type)}: ${k.channelName}.${k.name}`,k.arg);return}case 101:case 103:{const z=this.send([k.type,k.id]);this.logger&&this.logger.logOutgoing(z,k.id,0,E(k.type));return}}}send(k,z=void 0){const G=new p;return r(G,k),r(G,z),this.sendBuffer(G.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch{return 0}}onBuffer(k){const z=new v(k),G=a(z),ne=a(z),K=G[0];switch(K){case 200:return this.logger&&this.logger.logIncoming(k.byteLength,0,0,l(K)),this.onResponse({type:G[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(k.byteLength,G[1],0,l(K),ne),this.onResponse({type:G[0],id:G[1],data:ne})}}onResponse(k){if(k.type===200){this.state=f.Idle,this._onDidInitialize.fire();return}const z=this.handlers.get(k.id);z&&z(k)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,w.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ge([T.memoize],S.prototype,"onDidInitializePromise",null),t.ChannelClient=S;class O{constructor(k){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new c.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new c.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,k(({protocol:z,onDidClientDisconnect:G})=>{c.Event.once(z.onMessage)(K=>{const Z=new v(K),q=a(Z),M=new u(z,q),A=new S(z);this.channels.forEach((B,H)=>M.registerChannel(H,B));const V={channelServer:M,channelClient:A,ctx:q};this._connections.add(V),this._onDidAddConnection.fire(V),G(()=>{M.dispose(),A.dispose(),this._connections.delete(V),this._onDidRemoveConnection.fire(V)})})})}get connections(){const k=[];return this._connections.forEach(z=>k.push(z)),k}getChannel(k,z){const G=this;return{call(ne,K,Z){let q;if((0,h.isFunction)(z)){let A=(0,C.getRandomElement)(G.connections.filter(z));q=A?Promise.resolve(A):c.Event.toPromise(c.Event.filter(G.onDidAddConnection,z))}else q=z.routeCall(G,ne,K);const M=q.then(A=>A.channelClient.getChannel(k));return _(M).call(ne,K,Z)},listen(ne,K){if((0,h.isFunction)(z))return G.getMulticastEvent(k,z,ne,K);const Z=z.routeEvent(G,ne,K).then(q=>q.channelClient.getChannel(k));return _(Z).listen(ne,K)}}}getMulticastEvent(k,z,G,ne){const K=this;let Z=new w.DisposableStore;const q=new c.Emitter({onFirstListenerAdd:()=>{Z=new w.DisposableStore;const M=new c.EventMultiplexer,A=new Map,V=H=>{const ae=H.channelClient.getChannel(k).listen(G,ne),ce=M.add(ae);A.set(H,ce)},B=H=>{const X=A.get(H);!X||(X.dispose(),A.delete(H))};K.connections.filter(z).forEach(V),c.Event.filter(K.onDidAddConnection,z)(V,void 0,Z),K.onDidRemoveConnection(B,void 0,Z),M.event(q.fire,q,Z),Z.add(M)},onLastListenerRemove:()=>{Z.dispose()}});return q.event}registerChannel(k,z){this.channels.set(k,z),this._connections.forEach(G=>{G.channelServer.registerChannel(k,z)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=O;class N{constructor(k,z,G=null){const ne=new p;r(ne,z),k.send(ne.buffer),this.channelClient=new S(k,G),this.channelServer=new u(k,z,G)}getChannel(k){return this.channelClient.getChannel(k)}registerChannel(k,z){this.channelServer.registerChannel(k,z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=N;function _(U){return{call(k,z,G){return U.then(ne=>ne.call(k,z,G))},listen(k,z){const G=new c.Relay;return U.then(ne=>G.input=ne.listen(k,z)),G.event}}}t.getDelayedChannel=_;function J(U){let k=!1;return{call(z,G,ne){return k?U.call(z,G,ne):(0,D.timeout)(0).then(()=>k=!0).then(()=>U.call(z,G,ne))},listen(z,G){if(k)return U.listen(z,G);const ne=new c.Relay;return(0,D.timeout)(0).then(()=>k=!0).then(()=>ne.input=U.listen(z,G)),ne.event}}}t.getNextTickChannel=J;class re{constructor(k){this.fn=k}routeCall(k){return this.route(k)}routeEvent(k){return this.route(k)}async route(k){for(const z of k.connections)if(await Promise.resolve(this.fn(z.ctx)))return Promise.resolve(z);return await c.Event.toPromise(k.onDidAddConnection),await this.route(k)}}t.StaticRouter=re;var ee;(function(U){function k(K,Z){const q=K,M=Z&&Z.disableMarshalling,A=new Map;for(const V in q)G(V)&&A.set(V,c.Event.buffer(q[V],!0));return new class{listen(V,B,H){const X=A.get(B);if(X)return X;if(ne(B)){const ae=q[B];if(typeof ae=="function")return ae.call(q,H)}throw new Error(`Event not found: ${B}`)}call(V,B,H){const X=q[B];if(typeof X=="function"){if(!M&&Array.isArray(H))for(let ae=0;ae<H.length;ae++)H[ae]=(0,I.revive)(H[ae]);return X.apply(q,H)}throw new Error(`Method not found: ${B}`)}}}U.fromService=k;function z(K,Z){const q=Z&&Z.disableMarshalling;return new Proxy({},{get(M,A){if(typeof A=="string")return Z?.properties?.has(A)?Z.properties.get(A):ne(A)?function(V){return K.listen(A,V)}:G(A)?K.listen(A):async function(...V){let B;Z&&!(0,h.isUndefinedOrNull)(Z.context)?B=[Z.context,...V]:B=V;const H=await K.call(A,B);return q?H:(0,I.revive)(H)};throw new Error(`Property not found: ${String(A)}`)}})}U.toService=z;function G(K){return K[0]==="o"&&K[1]==="n"&&L.isUpperAsciiLetter(K.charCodeAt(2))}function ne(K){return/^onDynamic/.test(K)&&L.isUpperAsciiLetter(K.charCodeAt(9))}})(ee=t.ProxyChannel||(t.ProxyChannel={}));const ie=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function he(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){let k=U.toString();if(k!=="[object Object]")return k}return U}function ue(U){return Array.isArray(U)?U.map(he):he(U)}function x(U,k,z,G,ne,K,Z){Z=ue(Z);const q=ie[ne],M=q[G%q.length];let A=[`%c[${U}]%c[${String(k).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(K)?(A=A.concat(Z),A.push(")")):A.push(Z),console.log.apply(console,A)}t.logWithColors=x;class te{constructor(k,z){this._outgoingPrefix=k,this._incomingPrefix=z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(k,z,G,ne,K){this._totalOutgoing+=k,x(this._outgoingPrefix,this._totalOutgoing,k,z,G,ne,K)}logIncoming(k,z,G,ne,K){this._totalIncoming+=k,x(this._incomingPrefix,this._totalIncoming,k,z,G,ne,K)}}t.IPCLogger=te}),define(Y[65],Q([0,1,3,7,2,6]),function(j,t,C,D,b,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.isStorageItemsChangeEvent=t.StorageHint=void 0;var T;(function(L){L[L.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=t.StorageHint||(t.StorageHint={}));function P(L){const h=L;return h?.changed instanceof Map||h?.deleted instanceof Set}t.isStorageItemsChangeEvent=P;var c;(function(L){L[L.None=0]="None",L[L.Initialized=1]="Initialized",L[L.Closed=2]="Closed"})(c||(c={}));class w extends b.Disposable{constructor(h,y=Object.create(null)){super();this.database=h,this.options=y,this._onDidChangeStorage=this._register(new D.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=c.None,this.cache=new Map,this.flushDelayer=new C.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(h=>this.onDidChangeItemsExternal(h)))}onDidChangeItemsExternal(h){h.changed?.forEach((y,E)=>this.accept(E,y)),h.deleted?.forEach(y=>this.accept(y,void 0))}accept(h,y){if(this.state===c.Closed)return;let E=!1;(0,R.isUndefinedOrNull)(y)?E=this.cache.delete(h):this.cache.get(h)!==y&&(this.cache.set(h,y),E=!0),E&&this._onDidChangeStorage.fire(h)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===c.None&&(this.state=c.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(h,y){const E=this.cache.get(h);return(0,R.isUndefinedOrNull)(E)?y:E}getBoolean(h,y){const E=this.get(h);return(0,R.isUndefinedOrNull)(E)?y:E==="true"}getNumber(h,y){const E=this.get(h);return(0,R.isUndefinedOrNull)(E)?y:parseInt(E,10)}async set(h,y){if(this.state===c.Closed)return;if((0,R.isUndefinedOrNull)(y))return this.delete(h);const E=String(y);if(this.cache.get(h)!==E)return this.cache.set(h,E),this.pendingInserts.set(h,E),this.pendingDeletes.delete(h),this._onDidChangeStorage.fire(h),this.doFlush()}async delete(h){if(!(this.state===c.Closed||!this.cache.delete(h)))return this.pendingDeletes.has(h)||this.pendingDeletes.add(h),this.pendingInserts.delete(h),this._onDidChangeStorage.fire(h),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=c.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const h={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(h).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(h){if(!!this.hasPending)return this.doFlush(h)}async doFlush(h){return this.flushDelayer.trigger(()=>this.flushPending(),h)}async whenFlushed(){if(!!this.hasPending)return new Promise(h=>this.whenFlushedCallbacks.push(h))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=w,w.DEFAULT_FLUSH_DELAY=100;class I{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(h){h.insert&&h.insert.forEach((y,E)=>this.items.set(E,y)),h.delete&&h.delete.forEach(y=>this.items.delete(y))}async close(){}}t.InMemoryStorageDatabase=I}),define(Y[66],Q([4,5]),function(j,t){return j.create("vs/base/common/date",t)}),define(Y[67],Q([0,1,66]),function(j,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const D=60,b=D*60,R=b*24,T=R*7,P=R*30,c=R*365;function w(L,h,y){typeof L!="number"&&(L=L.getTime());const E=Math.round((new Date().getTime()-L)/1e3);if(E<-30)return(0,C.localize)(0,null,w(new Date().getTime()+E*1e3,!1));if(E<30)return(0,C.localize)(1,null);let g;return E<D?(g=E,h?g===1?y?(0,C.localize)(2,null,g):(0,C.localize)(3,null,g):y?(0,C.localize)(4,null,g):(0,C.localize)(5,null,g):g===1?y?(0,C.localize)(6,null,g):(0,C.localize)(7,null,g):y?(0,C.localize)(8,null,g):(0,C.localize)(9,null,g)):E<b?(g=Math.floor(E/D),h?g===1?y?(0,C.localize)(10,null,g):(0,C.localize)(11,null,g):y?(0,C.localize)(12,null,g):(0,C.localize)(13,null,g):g===1?y?(0,C.localize)(14,null,g):(0,C.localize)(15,null,g):y?(0,C.localize)(16,null,g):(0,C.localize)(17,null,g)):E<R?(g=Math.floor(E/b),h?g===1?y?(0,C.localize)(18,null,g):(0,C.localize)(19,null,g):y?(0,C.localize)(20,null,g):(0,C.localize)(21,null,g):g===1?y?(0,C.localize)(22,null,g):(0,C.localize)(23,null,g):y?(0,C.localize)(24,null,g):(0,C.localize)(25,null,g)):E<T?(g=Math.floor(E/R),h?g===1?(0,C.localize)(26,null,g):(0,C.localize)(27,null,g):g===1?(0,C.localize)(28,null,g):(0,C.localize)(29,null,g)):E<P?(g=Math.floor(E/T),h?g===1?y?(0,C.localize)(30,null,g):(0,C.localize)(31,null,g):y?(0,C.localize)(32,null,g):(0,C.localize)(33,null,g):g===1?y?(0,C.localize)(34,null,g):(0,C.localize)(35,null,g):y?(0,C.localize)(36,null,g):(0,C.localize)(37,null,g)):E<c?(g=Math.floor(E/P),h?g===1?y?(0,C.localize)(38,null,g):(0,C.localize)(39,null,g):y?(0,C.localize)(40,null,g):(0,C.localize)(41,null,g):g===1?y?(0,C.localize)(42,null,g):(0,C.localize)(43,null,g):y?(0,C.localize)(44,null,g):(0,C.localize)(45,null,g)):(g=Math.floor(E/c),h?g===1?y?(0,C.localize)(46,null,g):(0,C.localize)(47,null,g):y?(0,C.localize)(48,null,g):(0,C.localize)(49,null,g):g===1?y?(0,C.localize)(50,null,g):(0,C.localize)(51,null,g):y?(0,C.localize)(52,null,g):(0,C.localize)(53,null,g))}t.fromNow=w;function I(L){return L.getFullYear()+"-"+String(L.getMonth()+1).padStart(2,"0")+"-"+String(L.getDate()).padStart(2,"0")+"T"+String(L.getHours()).padStart(2,"0")+":"+String(L.getMinutes()).padStart(2,"0")+":"+String(L.getSeconds()).padStart(2,"0")+"."+(L.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=I}),define(Y[68],Q([4,5]),function(j,t){return j.create("vs/base/common/errorMessage",t)}),define(Y[28],Q([0,1,18,6,68]),function(j,t,C,D,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createErrorWithActions=t.isErrorWithActions=t.toErrorMessage=void 0;function R(L,h){return h&&(L.stack||L.stacktrace)?b.localize(0,null,P(L),T(L.stack)||T(L.stacktrace)):P(L)}function T(L){return Array.isArray(L)?L.join(`
`):L}function P(L){return typeof L.code=="string"&&typeof L.errno=="number"&&typeof L.syscall=="string"?b.localize(1,null,L.message):L.message||b.localize(2,null)}function c(L=null,h=!1){if(!L)return b.localize(3,null);if(Array.isArray(L)){const y=C.coalesce(L),E=c(y[0],h);return y.length>1?b.localize(4,null,E,y.length):E}if(D.isString(L))return L;if(L.detail){const y=L.detail;if(y.error)return R(y.error,h);if(y.exception)return R(y.exception,h)}return L.stack?R(L,h):L.message?L.message:b.localize(5,null)}t.toErrorMessage=c;function w(L){const h=L;return h instanceof Error&&Array.isArray(h.actions)}t.isErrorWithActions=w;function I(L,h=Object.create(null)){const y=new Error(L);return h.actions&&(y.actions=h.actions),y}t.createErrorWithActions=I}),define(Y[69],Q([4,5]),function(j,t){return j.create("vs/base/node/processes",t)}),define(Y[47],Q([0,1,39,45,10,22,11,12,29,57,6,63,15,69]),function(j,t,C,D,b,R,T,P,c,w,I,L,h,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.removeDangerousEnvVariables=t.TerminateResponseCode=t.Source=void 0,Object.defineProperty(t,"Source",{enumerable:!0,get:function(){return w.Source}}),Object.defineProperty(t,"TerminateResponseCode",{enumerable:!0,get:function(){return w.TerminateResponseCode}});function E(e){switch(e){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(e,s){if(P.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};s&&(i.cwd=s);const n=C.execFile("taskkill",["/T","/F","/PID",e.pid.toString()],i);return new Promise(r=>{n.once("error",a=>{r({success:!1,error:a})}),n.once("exit",(a,u)=>{r(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?E(i.status):1})}else if(P.isLinux||P.isMacintosh)try{const i=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",j).fsPath;return new Promise(n=>{C.execFile(i,[e.pid.toString()],{encoding:"utf8",shell:!0},(r,a,u)=>{n(r?{success:!1,error:r}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else e.kill("SIGKILL");return Promise.resolve({success:!0})}function l(e){!e||(delete e.DEBUG,P.isMacintosh&&delete e.DYLD_LIBRARY_PATH,P.isLinux&&delete e.LD_PRELOAD)}t.removeDangerousEnvVariables=l;function f(e=c.env){return e.comspec||"cmd.exe"}t.getWindowsShell=f;class v{constructor(s,i,n,r){if(i!==void 0&&n!==void 0&&r!==void 0)this.cmd=s,this.args=i,this.shell=n,this.options=r;else{const a=s;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(c.env).forEach(u=>{a[u]=c.env[u]}),Object.keys(this.options.env).forEach(u=>{a[u]=this.options.env[u]}),this.options.env=a}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const i=s.lastIndexOf(T.sep);return i!==-1&&(s=s.substring(i+1)),v.WellKnowCommands[s]?s:"other"}start(s){return P.isWindows&&(this.options&&this.options.cwd&&D.isUNC(this.options.cwd)||!this.options&&D.isUNC(c.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(i=>{let n,r;const a=new Promise((u,d)=>{n=u,r=d});if(i){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=C.exec(u,this.options,(d,S,O)=>{this.childProcess=null;const N=d;N&&N.killed?r({killed:this.terminateRequested,stdout:S.toString(),stderr:O.toString()}):this.handleExec(n,s,d,S,O)})}else{let u=null;const d=S=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(S,n,s,r);const O={terminated:this.terminateRequested};I.isNumber(S)&&(O.cmdCode=S),n(O)};if(this.shell&&P.isWindows){const S=R.deepClone(this.options);S.windowsVerbatimArguments=!0,S.detached=!1;let O=!1,N=!1;const _=[];let J=this.ensureQuotes(this.cmd);_.push(J.value),O=J.quoted,this.args&&this.args.forEach(ee=>{J=this.ensureQuotes(ee),_.push(J.value),N=N&&J.quoted});const re=["/s","/c"];O?N?re.push('"'+_.join(" ")+'"'):_.length>1?re.push('"'+_[0]+'" '+_.slice(1).join(" ")):re.push('"'+_[0]+'"'):re.push(_.join(" ")),u=C.spawn(f(),re,S)}else this.cmd&&(u=C.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(I.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",S=>{this.childProcess=null,r({terminated:this.terminateRequested,error:S})}),u.pid&&(this.childProcess.on("close",d),this.handleSpawn(u,n,s,r,!0)))}return a})}handleClose(s,i,n,r){}ensureQuotes(s){return v.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,g(s,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!P.isWindows)return s(!1);const i=C.spawn(f(),["/s","/c"]);i.on("error",n=>s(!0)),i.on("exit",n=>s(!1))})}}t.AbstractProcess=v,v.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},v.regexp=/^[^"].* .*[^"]/;class p extends v{constructor(s,i,n,r){super(s,i,n,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,i,n,r,a){[r,a].forEach((u,d)=>{const S=new L.LineDecoder;S.write(u).forEach(_=>{i({line:_,source:d===0?0:1})});const N=S.end();N&&i({line:N,source:d===0?0:1})}),s({terminated:this.terminateRequested,error:n})}handleSpawn(s,i,n,r,a){const u=new L.LineDecoder,d=new L.LineDecoder;s.stdout.on("data",S=>{u.write(S).forEach(N=>n({line:N,source:0}))}),s.stderr.on("data",S=>{d.write(S).forEach(N=>n({line:N,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=d}handleClose(s,i,n,r){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&n({line:a,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&n({line:u,source:1})}}t.LineProcess=p;function m(e){let s=[],i=!1;const n=function(r){if(i){s.push(r);return}(!e.send(r,u=>{if(u&&console.error(u),i=!1,s.length>0){const d=s.slice(0);s=[],d.forEach(S=>n(S))}})||P.isWindows)&&(i=!0)};return{send:n}}t.createQueuedSender=m;var o;(function(e){async function s(i,n,r){if(T.isAbsolute(i))return i;if(n===void 0&&(n=c.cwd()),T.dirname(i)!=="."||(r===void 0&&I.isString(c.env.PATH)&&(r=c.env.PATH.split(T.delimiter)),r===void 0||r.length===0))return T.join(n,i);async function u(d){if(await h.Promises.exists(d)){let S;try{S=await h.Promises.stat(d)}catch(O){O.message.startsWith("EACCES")&&(S=await h.Promises.lstat(d))}return S?!S.isDirectory():!1}return!1}for(let d of r){let S;if(T.isAbsolute(d)?S=T.join(d,i):S=T.join(n,d,i),await u(S))return S;let O=S+".com";if(await u(O)||(O=S+".exe",await u(O)))return O}return T.join(n,i)}e.findExecutable=s})(o=t.win32||(t.win32={}))}),define(Y[70],Q([0,1,33,12,64,47]),function(j,t,C,D,b,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function T(y,E){return y===1?D.isWindows?L():R.getWindowsShell(E):w(y,E)}t.getSystemShell=T;function P(y,E){return y===1?D.isWindows?h(E):R.getWindowsShell(E):w(y,E)}t.getSystemShellSync=P;let c=null;function w(y,E){if(D.isLinux&&y===2||D.isMacintosh&&y===3)return"/bin/bash";if(!c){let g;if(D.isWindows)g="/bin/bash";else{if(g=E.SHELL,!g)try{g=(0,C.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}c=g}return c}let I=null;async function L(){return I||(I=(await(0,b.getFirstAvailablePowerShellInstallation)()).exePath),I}function h(y){if(I)return I;const E=D.isWindows&&parseFloat((0,C.release)())>=10,g=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),l=`${y.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return E?l:R.getWindowsShell(y)}}),define(Y[71],Q([0,1,39,3,17,24,60,8,7,2,22,47,46]),function(j,t,C,D,b,R,T,P,c,w,I,L,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class y extends h.ChannelServer{constructor(l){super({send:f=>{try{process.send&&process.send(f.buffer.toString("base64"))}catch{}},onMessage:c.Event.fromNodeEventEmitter(process,"message",f=>b.VSBuffer.wrap(Buffer.from(f,"base64")))},l);process.once("disconnect",()=>this.dispose())}}t.Server=y;class E{constructor(l,f){this.modulePath=l,this.options=f,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new c.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const v=f&&f.timeout?f.timeout:6e4;this.disposeDelayer=new D.Delayer(v),this.child=null,this._client=null}getChannel(l){const f=this;return{call(v,p,m){return f.requestPromise(l,v,p,m)},listen(v,p){return f.requestEvent(l,v,p)}}}requestPromise(l,f,v,p=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const m=this.getCachedChannel(l),o=(0,D.createCancelablePromise)(i=>m.call(f,v,i)),e=p.onCancellationRequested(()=>o.cancel()),s=(0,w.toDisposable)(()=>o.cancel());return this.activeRequests.add(s),o.finally(()=>{e.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),o}requestEvent(l,f,v){if(!this.disposeDelayer)return c.Event.None;this.disposeDelayer.cancel();let p;const m=new c.Emitter({onFirstListenerAdd:()=>{p=this.getCachedChannel(l).listen(f,v)(m.fire,m),this.activeRequests.add(p)},onLastListenerRemove:()=>{this.activeRequests.delete(p),p.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return m.event}get client(){if(!this._client){const l=this.options&&this.options.args?this.options.args:[],f=Object.create(null);f.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(f.env={...f.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(f.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n))),(0,L.removeDangerousEnvVariables)(f.env),this.child=(0,C.fork)(this.modulePath,l,f);const v=new c.Emitter;c.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,T.isRemoteConsoleLog)(n)){(0,T.log)(n,`IPC Library: ${this.options.serverName}`);return}v.fire(b.VSBuffer.wrap(Buffer.from(n,"base64")))});const m=this.options.useQueue?(0,L.createQueuedSender)(this.child):this.child,o=n=>this.child&&this.child.connected&&m.send(n.buffer.toString("base64")),e=v.event,s={send:o,onMessage:e};this._client=new h.ChannelClient(s);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,r)=>{process.removeListener("exit",i),this.activeRequests.forEach(a=>(0,w.dispose)(a)),this.activeRequests.clear(),n!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+r),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:r})})}return this._client}getCachedChannel(l){let f=this.channels.get(l);return f||(f=this.client.getChannel(l),this.channels.set(l,f)),f}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=E}),define(Y[72],Q([4,5]),function(j,t){return j.create("vs/base/node/zip",t)}),define(Y[73],Q([4,5]),function(j,t){return j.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Y[74],Q([4,5]),function(j,t){return j.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(Y[75],Q([4,5]),function(j,t){return j.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Y[76],Q([4,5]),function(j,t){return j.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Y[77],Q([4,5]),function(j,t){return j.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Y[78],Q([4,5]),function(j,t){return j.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Y[79],Q([4,5]),function(j,t){return j.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Y[80],Q([4,5]),function(j,t){return j.create("vs/platform/extensions/common/extensionValidator",t)}),define(Y[81],Q([4,5]),function(j,t){return j.create("vs/platform/files/common/fileService",t)}),define(Y[82],Q([4,5]),function(j,t){return j.create("vs/platform/files/common/io",t)}),define(Y[83],Q([4,5]),function(j,t){return j.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Y[84],Q([4,5]),function(j,t){return j.create("vs/platform/request/common/request",t)}),define(Y[85],Q([4,5]),function(j,t){return j.create("vs/platform/telemetry/common/telemetryService",t)}),define(Y[86],Q([4,5]),function(j,t){return j.create("vs/platform/terminal/node/shellEnv",t)}),define(Y[87],Q([0,1,67,44,10,11,29,19,9]),function(j,t,C,D,b,R,T,P,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parsePtyHostPort=t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class w{constructor(g,l,f){this._args=g,this.paths=l,this.productService=f}get appRoot(){return(0,R.dirname)(b.FileAccess.asFileUri("",j).fsPath)}get userHome(){return c.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return c.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return c.URI.file(this.paths.tmpDir)}get cacheHome(){return c.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return c.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(c.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return c.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return c.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=T.env.VSCODE_PORTABLE;return g?c.URI.file((0,R.join)(g,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return c.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,R.resolve)(g):(0,R.normalize)((0,R.join)(b.FileAccess.asFileUri("",j).fsPath,"..","extensions"))}get extensionsDownloadPath(){const g=this.args["extensions-download-dir"];return g?(0,R.resolve)(g):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,R.resolve)(g);const l=T.env.VSCODE_EXTENSIONS;if(l)return l;const f=T.env.VSCODE_PORTABLE;return f?(0,R.join)(f,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(l=>/^[^:/?#]+?:\/\//.test(l)?c.URI.parse(l):c.URI.file((0,R.normalize)(l)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?c.URI.parse(g):c.URI.file((0,R.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(c.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return c.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ge([D.memoize],w.prototype,"appRoot",null),ge([D.memoize],w.prototype,"userHome",null),ge([D.memoize],w.prototype,"userDataPath",null),ge([D.memoize],w.prototype,"appSettingsHome",null),ge([D.memoize],w.prototype,"tmpDir",null),ge([D.memoize],w.prototype,"cacheHome",null),ge([D.memoize],w.prototype,"userRoamingDataHome",null),ge([D.memoize],w.prototype,"settingsResource",null),ge([D.memoize],w.prototype,"userDataSyncHome",null),ge([D.memoize],w.prototype,"userDataSyncLogResource",null),ge([D.memoize],w.prototype,"sync",null),ge([D.memoize],w.prototype,"machineSettingsResource",null),ge([D.memoize],w.prototype,"globalStorageHome",null),ge([D.memoize],w.prototype,"workspaceStorageHome",null),ge([D.memoize],w.prototype,"keybindingsResource",null),ge([D.memoize],w.prototype,"keyboardLayoutResource",null),ge([D.memoize],w.prototype,"argvResource",null),ge([D.memoize],w.prototype,"snippetsHome",null),ge([D.memoize],w.prototype,"isExtensionDevelopment",null),ge([D.memoize],w.prototype,"untitledWorkspacesHome",null),ge([D.memoize],w.prototype,"installSourcePath",null),ge([D.memoize],w.prototype,"builtinExtensionsPath",null),ge([D.memoize],w.prototype,"extensionsPath",null),ge([D.memoize],w.prototype,"extensionDevelopmentLocationURI",null),ge([D.memoize],w.prototype,"extensionDevelopmentKind",null),ge([D.memoize],w.prototype,"extensionTestsLocationURI",null),ge([D.memoize],w.prototype,"debugExtensionHost",null),ge([D.memoize],w.prototype,"serviceMachineIdResource",null),ge([D.memoize],w.prototype,"telemetryLogResource",null),ge([D.memoize],w.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=w;function I(E,g){return y(E["inspect-extensions"],E["inspect-brk-extensions"],5870,g,E.debugId,E.extensionEnvironment)}t.parseExtensionHostPort=I;function L(E,g){return y(E["inspect-search"],E["inspect-brk-search"],5876,g,E.extensionEnvironment)}t.parseSearchPort=L;function h(E,g){return y(E["inspect-ptyhost"],E["inspect-brk-ptyhost"],5877,g,E.extensionEnvironment)}t.parsePtyHostPort=h;function y(E,g,l,f,v,p){const o=Number(g||E)||(f?null:l),e=o?Boolean(!!g):!1;let s;if(p)try{s=JSON.parse(p)}catch{}return{port:o,break:e,debugId:v,env:s}}}),function(){"use strict";function j(t,C,D,b){function R(P){const c=T(P),w=[c];return t.isAbsolute(c)||w.unshift(b),t.resolve(...w)}function T(P){const c=process.env.VSCODE_PORTABLE;if(c)return t.join(c,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return t.join(w,D);const I=P["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const L=process.env.USERPROFILE;if(typeof L!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=t.join(L,"AppData","Roaming")}break;case"darwin":w=t.join(C.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||t.join(C.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(w,D)}return{getUserDataPath:R}}if(typeof define=="function")define(Y[88],Q([0,133,33,10,19,29]),function(t,C,D,b,R,T){const P=R.dirname(b.FileAccess.asFileUri("",t)),c=t.__$__nodeRequire(R.joinPath(P,"package.json").fsPath);return j(C,D,c.name,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),C=require("path"),D=require("os");module.exports=j(C,D,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Y[89],Q([0,1,33,87,88]),function(j,t,C,D,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class R extends D.AbstractNativeEnvironmentService{constructor(P,c){super(P,{homeDir:(0,C.homedir)(),tmpDir:(0,C.tmpdir)(),userDataDir:(0,b.getUserDataPath)(P)},c)}}t.NativeEnvironmentService=R}),define(Y[90],Q([0,1,22]),function(j,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const D=/^%([\w\d.-]+)%$/i;function b(R,T){const P=c=>{if(typeof c!="string")return;const w=D.exec(c);if(!w)return;const I=T[w[1]]??c;return typeof I=="string"?I:typeof I.message=="string"?I.message:c};return(0,C.cloneAndChange)(R,P)}t.localizeManifest=b}),define(Y[48],Q([0,1,80]),function(j,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function R(h){return h=h.trim(),h==="*"||D.test(h)}t.isValidVersionStr=R;function T(h){if(!R(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=h.match(D);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}t.parseVersion=T;function P(h){if(!h)return null;let y=h.majorBase,E=h.majorMustEqual,g=h.minorBase,l=h.minorMustEqual,f=h.patchBase,v=h.patchMustEqual;h.hasCaret&&(y===0||(l=!1),v=!1);let p=0;if(h.preRelease){const m=b.exec(h.preRelease);if(m){const[,o,e,s]=m;p=Date.UTC(Number(o),Number(e)-1,Number(s))}}return{majorBase:y,majorMustEqual:E,minorBase:g,minorMustEqual:l,patchBase:f,patchMustEqual:v,isMinimum:h.hasGreaterEquals,notBefore:p}}t.normalizeVersion=P;function c(h,y,E){let g;typeof h=="string"?g=P(T(h)):g=h;let l;y instanceof Date?l=y.getTime():typeof y=="string"&&(l=new Date(y).getTime());let f;if(typeof E=="string"?f=P(T(E)):f=E,!g||!f)return!1;let v=g.majorBase,p=g.minorBase,m=g.patchBase,o=f.majorBase,e=f.minorBase,s=f.patchBase,i=f.notBefore,n=f.majorMustEqual,r=f.minorMustEqual,a=f.patchMustEqual;return f.isMinimum?v>o?!0:v<o?!1:p>e?!0:p<e||l&&l<i?!1:m>=s:(v===1&&o===0&&(!n||!r||!a)&&(o=1,e=0,s=0,n=!0,r=!1,a=!1),v<o?!1:v>o?!n:p<e?!1:p>e?!r:m<s?!1:m>s?!a:!(l&&l<i))}t.isValidVersion=c;function w(h,y,E,g){return E.isBuiltin||typeof E.main=="undefined"?!0:L(h,y,E.engines.vscode,g)}t.isValidExtensionVersion=w;function I(h,y,E){return h==="*"||L(y,E,h)}t.isEngineValid=I;function L(h,y,E,g=[]){let l=P(T(E));if(!l)return g.push(C.localize(0,null,E)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return g.push(C.localize(1,null,E)),!1}else if(!l.majorMustEqual)return g.push(C.localize(2,null,E)),!1;return c(h,y,l)?!0:(g.push(C.localize(3,null,h,E)),!1)}}),define(Y[91],Q([0,1,17,27]),function(j,t,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function b(R,T,P){let c=P&&P.get("storage.serviceMachineId",0)||null;if(c)return c;try{const I=(await T.readFile(R.serviceMachineIdResource)).value.toString();c=(0,D.isUUID)(I)?I:null}catch{c=null}if(!c){c=(0,D.generateUuid)();try{await T.writeFile(R.serviceMachineIdResource,C.VSBuffer.fromString(c))}catch{}}return P&&P.store("storage.serviceMachineId",c,0,1),c}t.getServiceMachineId=b}),define(Y[40],Q([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class C{constructor(b,R=[],T=!1){this.ctor=b,this.staticArguments=R,this.supportsDelayedInstantiation=T}}t.SyncDescriptor=C}),define(Y[92],Q([0,1,40]),function(j,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSingletonServiceDescriptors=t.registerSingleton=void 0;const D=[];function b(T,P,c){P instanceof C.SyncDescriptor||(P=new C.SyncDescriptor(P,[],c)),D.push([T,P])}t.registerSingleton=b;function R(){return D}t.getSingletonServiceDescriptors=R}),define(Y[93],Q([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class C{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}t.Node=C;class D{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(let T of this._nodes.values())T.outgoing.size===0&&R.push(T);return R}insertEdge(R,T){const P=this.lookupOrInsertNode(R),c=this.lookupOrInsertNode(T);P.outgoing.set(this._hashFn(T),c),c.incoming.set(this._hashFn(R),P)}removeNode(R){const T=this._hashFn(R);this._nodes.delete(T);for(let P of this._nodes.values())P.outgoing.delete(T),P.incoming.delete(T)}lookupOrInsertNode(R){const T=this._hashFn(R);let P=this._nodes.get(T);return P||(P=new C(R),this._nodes.set(T,P)),P}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){let R=[];for(let[T,P]of this._nodes)R.push(`${T}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(let[R,T]of this._nodes){const P=new Set([R]),c=this._findCycle(T,P);if(c)return c}}_findCycle(R,T){for(let[P,c]of R.outgoing){if(T.has(P))return[...T,P].join(" -> ");T.add(P);const w=this._findCycle(c,T);if(w)return w;T.delete(P)}}}t.Graph=D}),define(Y[25],Q([0,1,6,9,13]),function(j,t,C,D,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationUpdateOverrides=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,b.createDecorator)("configurationService");function R(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof D.URI)}t.isConfigurationOverrides=R;function T(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||C.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof D.URI)}t.isConfigurationUpdateOverrides=T;var P;(function(l){l[l.USER=1]="USER",l[l.USER_LOCAL=2]="USER_LOCAL",l[l.USER_REMOTE=3]="USER_REMOTE",l[l.WORKSPACE=4]="WORKSPACE",l[l.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",l[l.DEFAULT=6]="DEFAULT",l[l.MEMORY=7]="MEMORY"})(P=t.ConfigurationTarget||(t.ConfigurationTarget={}));function c(l){switch(l){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=c;function w(l,f){const v=Object.create(null);for(let p in l)I(v,p,l[p],f);return v}t.toValuesTree=w;function I(l,f,v,p){const m=f.split("."),o=m.pop();let e=l;for(let s=0;s<m.length;s++){let i=m[s],n=e[i];switch(typeof n){case"undefined":n=e[i]=Object.create(null);break;case"object":break;default:p(`Ignoring ${f} as ${m.slice(0,s+1).join(".")} is ${JSON.stringify(n)}`);return}e=n}if(typeof e=="object"&&e!==null)try{e[o]=v}catch{p(`Ignoring ${f} as ${m.join(".")} is ${JSON.stringify(e)}`)}else p(`Ignoring ${f} as ${m.join(".")} is ${JSON.stringify(e)}`)}t.addToValueTree=I;function L(l,f){const v=f.split(".");h(l,v)}t.removeFromValueTree=L;function h(l,f){const v=f.shift();if(f.length===0){delete l[v];return}if(Object.keys(l).indexOf(v)!==-1){const p=l[v];typeof p=="object"&&!Array.isArray(p)&&(h(p,f),Object.keys(p).length===0&&delete l[v])}}function y(l,f,v){function p(e,s){let i=e;for(const n of s){if(typeof i!="object"||i===null)return;i=i[n]}return i}const m=f.split("."),o=p(l,m);return typeof o=="undefined"?v:o}t.getConfigurationValue=y;function E(l,f,v){Object.keys(f).forEach(p=>{p!=="__proto__"&&(p in l?C.isObject(l[p])&&C.isObject(f[p])?E(l[p],f[p],v):v&&(l[p]=f[p]):l[p]=f[p])})}t.merge=E;function g(l,f,v){const p=l.inspect(f),m=l.inspect(v);return typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:p.defaultValue}t.getMigratedSettingValue=g}),define(Y[49],Q([0,1,13]),function(j,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,C.createDecorator)("downloadService")}),define(Y[20],Q([0,1,13]),function(j,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,C.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,C.refineServiceDecorator)(t.IEnvironmentService)}),define(Y[50],Q([0,1,17,8,82,16]),function(j,t,C,D,b,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function T(I,L,h,y,E,g){let l;try{await P(I,L,h,y,E,g)}catch(f){l=f}finally{l&&E.errorTransformer&&(l=E.errorTransformer(l)),typeof l!="undefined"&&h.error(l),h.end()}}t.readFileIntoStream=T;async function P(I,L,h,y,E,g){c(g);const l=await I.open(L,{create:!1});try{c(g);let f=0,v=0,p=E&&typeof E.length=="number"?E.length:void 0,m=C.VSBuffer.alloc(Math.min(E.bufferSize,typeof p=="number"?p:E.bufferSize)),o=E&&typeof E.position=="number"?E.position:0,e=0;do v=await I.read(l,o,m.buffer,e,m.byteLength-e),o+=v,e+=v,f+=v,typeof p=="number"&&(p-=v),e===m.byteLength&&(await h.write(y(m)),m=C.VSBuffer.alloc(Math.min(E.bufferSize,typeof p=="number"?p:E.bufferSize)),e=0);while(v>0&&(typeof p!="number"||p>0)&&c(g)&&w(f,E));if(e>0){let s=e;typeof p=="number"&&(s=Math.min(e,p)),h.write(y(m.slice(0,s)))}}catch(f){throw(0,R.ensureFileSystemProviderError)(f)}finally{await I.close(l)}}function c(I){if(I.isCancellationRequested)throw(0,D.canceled)();return!0}function w(I,L){if(L?.limits){if(typeof L.limits.memory=="number"&&I>L.limits.memory)throw(0,R.createFileSystemProviderError)((0,b.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof L.limits.size=="number"&&I>L.limits.size)throw(0,R.createFileSystemProviderError)((0,b.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Y[94],Q([0,1,18,7,2,12,134]),function(j,t,C,D,b,R,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NodeJSWatcher=void 0;class P extends b.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new D.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=D.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(w){const I=this.normalizeRequests(w),L=I.filter(y=>{const E=this.watchers.get(y.path);return E?!(0,C.equals)(E.request.excludes,y.excludes):!0}),h=Array.from(this.watchers.values()).filter(({request:y})=>!I.find(E=>E.path===y.path&&(0,C.equals)(E.excludes,y.excludes))).map(({request:y})=>y.path);L.length&&this.trace(`Request to start watching: ${L.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"})`).join(",")}`),h.length&&this.trace(`Request to stop watching: ${h.join(",")}`);for(const y of h)this.stopWatching(y);for(const y of L)this.startWatching(y)}startWatching(w){const I=new T.NodeJSFileWatcherLibrary(w,h=>this._onDidChangeFile.fire(h),h=>this._onDidLogMessage.fire(h),this.verboseLogging),L={request:w,instance:I};this.watchers.set(w.path,L)}async stop(){for(const[w]of this.watchers)this.stopWatching(w);this.watchers.clear()}stopWatching(w){const I=this.watchers.get(w);I&&(this.watchers.delete(w),I.instance.dispose())}normalizeRequests(w){const I=new Map;for(const L of w){const h=R.isLinux?L.path:L.path.toLowerCase();I.set(h,L)}return Array.from(I.values())}async setVerboseLogging(w){this.verboseLogging=w;for(const[,I]of this.watchers)I.instance.setVerboseLogging(w)}trace(w){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(w)})}toMessage(w,I){return I?`[File Watcher (node.js)] ${w} (path: ${I.request.path})`:`[File Watcher (node.js)] ${w}`}}t.NodeJSWatcher=P}),define(Y[95],Q([0,1,51,94]),function(j,t,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NodeJSWatcherClient=void 0;class b extends C.AbstractNonRecursiveWatcherClient{constructor(T,P,c){super(T,P,c);this.init()}createWatcher(){return new D.NodeJSWatcher}}t.NodeJSWatcherClient=b}),define(Y[96],Q([0,1,10,46,71,51]),function(j,t,C,D,b,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UniversalWatcherClient=void 0;class T extends R.AbstractUniversalWatcherClient{constructor(c,w,I){super(c,w,I);this.init()}createWatcher(c){const w=c.add(new b.Client(C.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return c.add(w.onDidProcessExit(({code:I,signal:L})=>this.onError(`terminated by itself with code ${I}, signal: ${L}`))),D.ProxyChannel.toService((0,D.getNextTickChannel)(w.getChannel("watcher")))}}t.UniversalWatcherClient=T}),define(Y[52],Q([0,1]),function(j,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class C{constructor(...b){this._entries=new Map;for(let[R,T]of b)this.set(R,T)}set(b,R){const T=this._entries.get(b);return this._entries.set(b,R),T}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}t.ServiceCollection=C}),define(Y[97],Q([0,1,3,8,40,93,13,52]),function(j,t,C,D,b,R,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Trace=t.InstantiationService=void 0;const c=!1;class w extends Error{constructor(E){super("cyclic dependency between services");this.message=E.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${E.toString()}`}}class I{constructor(E=new P.ServiceCollection,g=!1,l){this._activeInstantiations=new Set,this._services=E,this._strict=g,this._parent=l,this._services.set(T.IInstantiationService,this)}createChild(E){return new I(E,this._strict,this)}invokeFunction(E,...g){let l=h.traceInvocation(E),f=!1;try{return E({get:p=>{if(f)throw(0,D.illegalState)("service accessor is only valid during the invocation of its target method");const m=this._getOrCreateServiceInstance(p,l);if(!m)throw new Error(`[invokeFunction] unknown service '${p}'`);return m}},...g)}finally{f=!0,l.stop()}}createInstance(E,...g){let l,f;return E instanceof b.SyncDescriptor?(l=h.traceCreation(E.ctor),f=this._createInstance(E.ctor,E.staticArguments.concat(g),l)):(l=h.traceCreation(E),f=this._createInstance(E,g,l)),l.stop(),f}_createInstance(E,g=[],l){let f=T._util.getServiceDependencies(E).sort((m,o)=>m.index-o.index),v=[];for(const m of f){let o=this._getOrCreateServiceInstance(m.id,l);o||this._throwIfStrict(`[createInstance] ${E.name} depends on UNKNOWN service ${m.id}.`,!1),v.push(o)}let p=f.length>0?f[0].index:g.length;if(g.length!==p){console.warn(`[createInstance] First service dependency of ${E.name} at position ${p+1} conflicts with ${g.length} static arguments`);let m=p-g.length;m>0?g=g.concat(new Array(m)):g=g.slice(0,p)}return new E(...[...g,...v])}_setServiceInstance(E,g){if(this._services.get(E)instanceof b.SyncDescriptor)this._services.set(E,g);else if(this._parent)this._parent._setServiceInstance(E,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(E){let g=this._services.get(E);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(E):g}_getOrCreateServiceInstance(E,g){let l=this._getServiceInstanceOrDescriptor(E);return l instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(E,l,g.branch(E,!0)):(g.branch(E,!1),l)}_safeCreateAndCacheServiceInstance(E,g,l){if(this._activeInstantiations.has(E))throw new Error(`illegal state - RECURSIVELY instantiating service '${E}'`);this._activeInstantiations.add(E);try{return this._createAndCacheServiceInstance(E,g,l)}finally{this._activeInstantiations.delete(E)}}_createAndCacheServiceInstance(E,g,l){const f=new R.Graph(m=>m.id.toString());let v=0;const p=[{id:E,desc:g,_trace:l}];for(;p.length;){const m=p.pop();if(f.lookupOrInsertNode(m),v++>1e3)throw new w(f);for(let o of T._util.getServiceDependencies(m.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(o.id);if(e||this._throwIfStrict(`[createInstance] ${E} depends on ${o.id} which is NOT registered.`,!0),e instanceof b.SyncDescriptor){const s={id:o.id,desc:e,_trace:m._trace.branch(o.id,!0)};f.insertEdge(m,s),p.push(s)}}}for(;;){const m=f.roots();if(m.length===0){if(!f.isEmpty())throw new w(f);break}for(const{data:o}of m){if(this._getServiceInstanceOrDescriptor(o.id)instanceof b.SyncDescriptor){const s=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,s)}f.removeNode(o)}}return this._getServiceInstanceOrDescriptor(E)}_createServiceInstanceWithOwner(E,g,l=[],f,v){if(this._services.get(E)instanceof b.SyncDescriptor)return this._createServiceInstance(g,l,f,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(E,g,l,f,v);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(E,g=[],l,f){if(l){const v=new C.IdleValue(()=>this._createInstance(E,g,f));return new Proxy(Object.create(null),{get(p,m){if(m in p)return p[m];let o=v.value,e=o[m];return typeof e!="function"||(e=e.bind(o),p[m]=e),e},set(p,m,o){return v.value[m]=o,!0}})}else return this._createInstance(E,g,f)}_throwIfStrict(E,g){if(g&&console.warn(g),this._strict)throw new Error(E)}}t.InstantiationService=I;var L;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(L||(L={}));class h{constructor(E,g){this.type=E,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(E){return c?new h(1,E.name||E.toString().substring(0,42).replace(/\n/g,"")):h._None}static traceCreation(E){return c?new h(0,E.name):h._None}branch(E,g){let l=new h(2,E.toString());return this._dep.push([E,g,l]),l}stop(){let E=Date.now()-this._start;h._totals+=E;let g=!1;function l(v,p){let m=[],o=new Array(v+1).join("	");for(const[e,s,i]of p._dep)if(s&&i){g=!0,m.push(`${o}CREATES -> ${e}`);let n=l(v+1,i);n&&m.push(n)}else m.push(`${o}uses -> ${e}`);return m.join(`
`)}let f=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${l(1,this)}`,`DONE, took ${E.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(E>2||g)&&console.log(f.join(`
`))}}t.Trace=h,h._None=new class extends h{constructor(){super(-1,null)}stop(){}branch(){return this}},h._totals=0}),define(Y[53],Q([0,1,13]),function(j,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,C.createDecorator)("localizationsService");function D(b){if(typeof b.languageId!="string"||!Array.isArray(b.translations)||b.translations.length===0)return!1;for(const R of b.translations)if(typeof R.id!="string"||typeof R.path!="string")return!1;return!(b.languageName&&typeof b.languageName!="string"||b.localizedLanguageName&&typeof b.localizedLanguageName!="string")}t.isValidLocalization=D}),define(Y[14],Q([0,1,28,7,2,12,13]),function(j,t,C,D,b,R,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logCi=t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.format=t.log=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,T.createDecorator)("logService"),t.ILoggerService=(0,T.createDecorator)("loggerService");function P(){return new Date().toISOString()}var c;(function(i){i[i.Trace=0]="Trace",i[i.Debug=1]="Debug",i[i.Info=2]="Info",i[i.Warning=3]="Warning",i[i.Error=4]="Error",i[i.Critical=5]="Critical",i[i.Off=6]="Off"})(c=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=c.Info;function w(i,n,r){switch(n){case c.Trace:i.trace(r);break;case c.Debug:i.debug(r);break;case c.Info:i.info(r);break;case c.Warning:i.warn(r);break;case c.Error:i.error(r);break;case c.Critical:i.critical(r);break;default:throw new Error("Invalid log level")}}t.log=w;function I(i){let n="";for(let r=0;r<i.length;r++){let a=i[r];if(typeof a=="object")try{a=JSON.stringify(a)}catch{}n+=(r>0?" ":"")+a}return n}t.format=I;class L extends b.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=L;class h extends L{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...r){this.checkLogLevel(c.Trace)&&this.log(c.Trace,I([n,...r]))}debug(n,...r){this.checkLogLevel(c.Debug)&&this.log(c.Debug,I([n,...r]))}info(n,...r){this.checkLogLevel(c.Info)&&this.log(c.Info,I([n,...r]))}warn(n,...r){this.checkLogLevel(c.Warning)&&this.log(c.Warning,I([n,...r]))}error(n,...r){if(this.checkLogLevel(c.Error))if(n instanceof Error){const a=Array.prototype.slice.call(arguments);a[0]=n.stack,this.log(c.Error,I(a))}else this.log(c.Error,I([n,...r]))}critical(n,...r){this.checkLogLevel(c.Critical)&&this.log(c.Critical,I([n,...r]))}flush(){}}t.AbstractMessageLogger=h;class y extends L{constructor(n=t.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!R.isWindows}trace(n,...r){this.getLevel()<=c.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,n,...r):console.log(`[main ${P()}]`,n,...r))}debug(n,...r){this.getLevel()<=c.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,n,...r):console.log(`[main ${P()}]`,n,...r))}info(n,...r){this.getLevel()<=c.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,n,...r):console.log(`[main ${P()}]`,n,...r))}warn(n,...r){this.getLevel()<=c.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,n,...r):console.warn(`[main ${P()}]`,n,...r))}error(n,...r){this.getLevel()<=c.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,n,...r):console.error(`[main ${P()}]`,n,...r))}critical(n,...r){this.getLevel()<=c.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,n,...r):console.error(`[main ${P()}]`,n,...r))}dispose(){}flush(){}}t.ConsoleMainLogger=y;class E extends L{constructor(n=t.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...r){this.getLevel()<=c.Trace&&console.log("%cTRACE","color: #888",n,...r)}debug(n,...r){this.getLevel()<=c.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...r)}info(n,...r){this.getLevel()<=c.Info&&console.log("%c INFO","color: #33f",n,...r)}warn(n,...r){this.getLevel()<=c.Warning&&console.log("%c WARN","color: #993",n,...r)}error(n,...r){this.getLevel()<=c.Error&&console.log("%c  ERR","color: #f33",n,...r)}critical(n,...r){this.getLevel()<=c.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...r)}dispose(){}flush(){}}t.ConsoleLogger=E;class g extends L{constructor(n,r=t.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(r)}trace(n,...r){this.getLevel()<=c.Trace&&this.adapter.log(c.Trace,[this.extractMessage(n),...r])}debug(n,...r){this.getLevel()<=c.Debug&&this.adapter.log(c.Debug,[this.extractMessage(n),...r])}info(n,...r){this.getLevel()<=c.Info&&this.adapter.log(c.Info,[this.extractMessage(n),...r])}warn(n,...r){this.getLevel()<=c.Warning&&this.adapter.log(c.Warning,[this.extractMessage(n),...r])}error(n,...r){this.getLevel()<=c.Error&&this.adapter.log(c.Error,[this.extractMessage(n),...r])}critical(n,...r){this.getLevel()<=c.Critical&&this.adapter.log(c.Critical,[this.extractMessage(n),...r])}extractMessage(n){return typeof n=="string"?n:(0,C.toErrorMessage)(n,this.getLevel()<=c.Trace)}dispose(){}flush(){}}t.AdapterLogger=g;class l extends L{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const r of this.logServices)r.setLevel(n);super.setLevel(n)}trace(n,...r){for(const a of this.logServices)a.trace(n,...r)}debug(n,...r){for(const a of this.logServices)a.debug(n,...r)}info(n,...r){for(const a of this.logServices)a.info(n,...r)}warn(n,...r){for(const a of this.logServices)a.warn(n,...r)}error(n,...r){for(const a of this.logServices)a.error(n,...r)}critical(n,...r){for(const a of this.logServices)a.critical(n,...r)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}t.MultiplexLogService=l;class f extends b.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...r){this.logger.trace(n,...r)}debug(n,...r){this.logger.debug(n,...r)}info(n,...r){this.logger.info(n,...r)}warn(n,...r){this.logger.warn(n,...r)}error(n,...r){this.logger.error(n,...r)}critical(n,...r){this.logger.critical(n,...r)}flush(){this.logger.flush()}}t.LogService=f;class v extends b.Disposable{constructor(n,r){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(a=>{this.logLevel=a,this.logLevelChangeableLoggers.forEach(u=>u.setLevel(a))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,r){let a=this.loggers.get(n.toString());return a||(a=this.doCreateLogger(n,r?.always?c.Trace:this.logLevel,r),this.loggers.set(n.toString(),a),r?.always||this.logLevelChangeableLoggers.push(a)),a}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=v;class p{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(n){}getLevel(){return c.Info}trace(n,...r){}debug(n,...r){}info(n,...r){}warn(n,...r){}error(n,...r){}critical(n,...r){}dispose(){}flush(){}}t.NullLogService=p;function m(i){if(i.verbose)return c.Trace;if(typeof i.logLevel=="string"){const n=o(i.logLevel.toLowerCase());if(n!==void 0)return n}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=m;function o(i){switch(i){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Critical;case"off":return c.Off}}t.parseLogLevel=o;function e(i){switch(i){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Critical:return"critical";case c.Off:return"off"}}t.LogLevelToString=e;function s(i,n,...r){R.isCI?i.info.call(i,n,...r):i.trace.call(i,n,...r)}t.logCi=s});var oe=this&&this.__param||function(j,t){return function(C,D){t(C,D,j)}};define(Y[98],Q([0,1,39,3,28,7,2,10,11,15,20,14]),function(j,t,C,D,b,R,T,P,c,w,I,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let h=class extends T.Disposable{constructor(E,g){super();this.environmentService=E,this.logService=g,this.processesLimiter=new D.Limiter(5)}async postUninstall(E){const g=this.parseScript(E,"uninstall");return g&&(this.logService.info(E.identifier.id,E.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(g.script,"uninstall",g.args,!0,E).then(()=>this.logService.info(E.identifier.id,E.manifest.version,"Finished running post uninstall script"),l=>this.logService.error(E.identifier.id,E.manifest.version,`Failed to run post uninstall script: ${l}`)))),w.Promises.rm(this.getExtensionStoragePath(E)).then(void 0,l=>this.logService.error("Error while removing extension storage path",l))}parseScript(E,g){const l=`vscode:${g}`;if(E.location.scheme===P.Schemas.file&&E.manifest&&E.manifest.scripts&&typeof E.manifest.scripts[l]=="string"){const f=E.manifest.scripts[l].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.logService.warn(E.identifier.id,E.manifest.version,`${l} should be a node script`),null):{script:(0,c.join)(E.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}runLifecycleHook(E,g,l,f,v){return new Promise((p,m)=>{const o=this.start(E,g,l,v);let e;const s=i=>{e&&(clearTimeout(e),e=null),i?m(i):p(void 0)};o.on("error",i=>{s((0,b.toErrorMessage)(i)||"Unknown")}),o.on("exit",(i,n)=>{s(i?`post-${g} process exited with code ${i}`:void 0)}),f&&(e=setTimeout(()=>{e=null,o.kill(),m("timed out")},5e3))})}start(E,g,l,f){const v={silent:!0,execArgv:void 0},p=(0,C.fork)(E,[`--type=extension-post-${g}`,...l],v);p.stdout.setEncoding("utf8"),p.stderr.setEncoding("utf8");const m=R.Event.fromNodeEventEmitter(p.stdout,"data"),o=R.Event.fromNodeEventEmitter(p.stderr,"data");m(i=>this.logService.info(f.identifier.id,f.manifest.version,`post-${g}`,i)),o(i=>this.logService.error(f.identifier.id,f.manifest.version,`post-${g}`,i));const e=R.Event.any(R.Event.map(m,i=>({data:`%c${i}`,format:[""]})),R.Event.map(o,i=>({data:`%c${i}`,format:["color: red"]})));return R.Event.debounce(e,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(f.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),p}getExtensionStoragePath(E){return(0,c.join)(this.environmentService.globalStorageHome.fsPath,E.identifier.id.toLowerCase())}};h=ge([oe(0,I.IEnvironmentService),oe(1,L.ILogService)],h),t.ExtensionsLifecycle=h}),define(Y[99],Q([0,1,18,3,8,7,2,11,51,14]),function(j,t,C,D,b,R,T,P,c,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractDiskFileSystemProvider=void 0;class I extends T.Disposable{constructor(h,y){super();this.logService=h,this.options=y,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new D.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new D.ThrottledDelayer(0))}watch(h,y){return y.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(h,y):this.watchNonRecursive(h,y)}watchUniversal(h,y){const E={path:this.toFilePath(h),excludes:y.excludes,recursive:y.recursive},g=(0,C.insert)(this.universalPathsToWatch,E);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{g(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(h=>(0,b.onUnexpectedError)(h))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(y=>this._onDidChangeFile.fire((0,c.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===w.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)})));const h=this.options?.watcher?.recursive?.usePolling;if(h===!0)for(const y of this.universalPathsToWatch)(0,c.isRecursiveWatchRequest)(y)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(h))for(const y of this.universalPathsToWatch)(0,c.isRecursiveWatchRequest)(y)&&h.includes(y.path)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(h,y){const E={path:this.toFilePath(h),excludes:y.excludes,recursive:!1},g=(0,C.insert)(this.nonRecursivePathsToWatch,E);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{g(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(h=>(0,b.onUnexpectedError)(h))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(h=>this._onDidChangeFile.fire((0,c.toFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===w.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(h){h.type==="error"&&this._onDidWatchError.fire(h.message),this.logService[h.type](h.message)}toFilePath(h){return(0,P.normalize)(h.fsPath)}}t.AbstractDiskFileSystemProvider=I}),define(Y[100],Q([0,1,18,3,17,24,7,59,135,2,54,10,101,19,38,81,16,50,14]),function(j,t,C,D,b,R,T,P,c,w,I,L,h,y,E,g,l,f,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let p=class extends w.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new D.ResourceQueue)}registerProvider(o,e){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,h.mark)(`code/registerFilesystem/${o}`);const s=new w.DisposableStore;return this.provider.set(o,e),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:e}),s.add(e.onDidChangeFile(i=>this._onDidFilesChange.fire(new l.FileChangesEvent(i,!this.isPathCaseSensitive(e))))),typeof e.onDidWatchError=="function"&&s.add(e.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),s.add(e.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:e,scheme:o}))),(0,w.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:e}),this.provider.delete(o),(0,w.dispose)(s)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const e=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(s){e.push(s)}}),!this.provider.has(o)&&await D.Promises.settled(e)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,e){const s=this.provider.get(o.scheme);return!!(s&&s.capabilities&e)}listCapabilities(){return c.Iterable.map(this.provider,([o,e])=>({scheme:o,capabilities:e.capabilities}))}async withProvider(o){if(!(0,y.isAbsolutePath)(o))throw new l.FileOperationError((0,g.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const e=this.provider.get(o.scheme);if(!e){const s=new Error;throw s.name="ENOPRO",s.message=(0,g.localize)(1,null,o.toString()),s}return e}async withReadProvider(o){const e=await this.withProvider(o);if((0,l.hasOpenReadWriteCloseCapability)(e)||(0,l.hasReadWriteCapability)(e)||(0,l.hasFileReadStreamCapability)(e))return e;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const e=await this.withProvider(o);if((0,l.hasOpenReadWriteCloseCapability)(e)||(0,l.hasReadWriteCapability)(e))return e;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,e){try{return await this.doResolveFile(o,e)}catch(s){throw(0,l.toFileSystemProviderErrorCode)(s)===l.FileSystemProviderErrorCode.FileNotFound?new l.FileOperationError((0,g.localize)(2,null,this.resourceForError(o)),1):(0,l.ensureFileSystemProviderError)(s)}}async doResolveFile(o,e){const s=await this.withProvider(o),i=this.isPathCaseSensitive(s),n=e?.resolveTo,r=e?.resolveSingleChildDescendants,a=e?.resolveMetadata,u=await s.stat(o);let d;return this.toFileStat(s,o,u,void 0,!!a,(S,O)=>(d||(d=I.TernarySearchTree.forUris(()=>!i),d.set(o,!0),n&&d.fill(!0,n)),d.get(S.resource)||d.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&r?O===1:!1))}async toFileStat(o,e,s,i,n,r){const{providerExtUri:a}=this.getExtUri(o),u={resource:e,name:a.basename(e),isFile:(s.type&l.FileType.File)!=0,isDirectory:(s.type&l.FileType.Directory)!=0,isSymbolicLink:(s.type&l.FileType.SymbolicLink)!=0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:Boolean((s.permissions??0)&l.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,l.etag)({mtime:s.mtime,size:s.size}),children:void 0};if(u.isDirectory&&r(u,i)){try{const d=await o.readdir(e),S=await D.Promises.settled(d.map(async([O,N])=>{try{const _=a.joinPath(e,O),J=n?await o.stat(_):{type:N};return await this.toFileStat(o,_,J,d.length,n,r)}catch(_){return this.logService.trace(_),null}}));u.children=(0,C.coalesce)(S)}catch(d){this.logService.trace(d),u.children=[]}return u}return u}async resolveAll(o){return D.Promises.settled(o.map(async e=>{try{return{stat:await this.doResolveFile(e.resource,e.options),success:!0}}catch(s){return this.logService.trace(s),{stat:void 0,success:!1}}}))}async stat(o){const e=await this.withProvider(o),s=await e.stat(o);return this.toFileStat(e,o,s,void 0,!0,()=>!1)}async exists(o){const e=await this.withProvider(o);try{return!!await e.stat(o)}catch{return!1}}async canCreateFile(o,e){try{await this.doValidateCreateFile(o,e)}catch(s){return s}return!0}async doValidateCreateFile(o,e){if(!e?.overwrite&&await this.exists(o))throw new l.FileOperationError((0,g.localize)(3,null,this.resourceForError(o)),3,e)}async createFile(o,e=b.VSBuffer.fromString(""),s){await this.doValidateCreateFile(o,s);const i=await this.writeFile(o,e);return this._onDidRunOperation.fire(new l.FileOperationEvent(o,0,i)),i}async writeFile(o,e,s){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,o,s)||await this.mkdirp(i,n.dirname(o));let a;if((0,l.hasReadWriteCapability)(i)&&!(e instanceof b.VSBuffer))if((0,E.isReadableStream)(e)){const u=await(0,E.peekStream)(e,3);u.ended?a=b.VSBuffer.concat(u.buffer):a=u}else a=(0,E.peekReadable)(e,u=>b.VSBuffer.concat(u),3);else a=e;!(0,l.hasOpenReadWriteCloseCapability)(i)||(0,l.hasReadWriteCapability)(i)&&a instanceof b.VSBuffer?await this.doWriteUnbuffered(i,o,s,a):await this.doWriteBuffered(i,o,s,a instanceof b.VSBuffer?(0,b.bufferToReadable)(a):a),this._onDidRunOperation.fire(new l.FileOperationEvent(o,4))}catch(r){throw new l.FileOperationError((0,g.localize)(4,null,this.resourceForError(o),(0,l.ensureFileSystemProviderError)(r).toString()),(0,l.toFileOperationResult)(r),s)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,e,s){if(!!s?.unlock&&!(o.capabilities&8192))throw new Error((0,g.localize)(5,null,this.resourceForError(e)));let n;try{n=await o.stat(e)}catch{return}if((n.type&l.FileType.Directory)!=0)throw new l.FileOperationError((0,g.localize)(6,null,this.resourceForError(e)),0,s);if(this.throwIfFileIsReadonly(e,n),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==l.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&s.mtime<n.mtime&&s.etag!==(0,l.etag)({mtime:s.mtime,size:n.size}))throw new l.FileOperationError((0,g.localize)(7,null),3,s);return n}async readFile(o,e,s){const i=await this.withReadProvider(o);return e?.atomic?this.doReadFileAtomic(i,o,e,s):this.doReadFile(i,o,e,s)}async doReadFileAtomic(o,e,s,i){return new Promise((n,r)=>{this.writeQueue.queueFor(e,this.getExtUri(o).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(o,e,s,i);n(a)}catch(a){r(a)}})})}async doReadFile(o,e,s,i){const n=await this.doReadFileStream(o,e,{...s,preferUnbuffered:!0},i);return{...n,value:await(0,b.streamToBuffer)(n.value)}}async readFileStream(o,e,s){const i=await this.withReadProvider(o);return this.doReadFileStream(i,o,e,s)}async doReadFileStream(o,e,s,i){const n=new R.CancellationTokenSource(i),r=this.validateReadFile(e,s).then(u=>u,u=>{throw n.cancel(),u});let a;try{return typeof s?.etag=="string"&&s.etag!==l.ETAG_DISABLED&&await r,s?.atomic&&(0,l.hasFileAtomicReadCapability)(o)||!((0,l.hasOpenReadWriteCloseCapability)(o)||(0,l.hasFileReadStreamCapability)(o))||(0,l.hasReadWriteCapability)(o)&&s?.preferUnbuffered?a=this.readFileUnbuffered(o,e,s):(0,l.hasFileReadStreamCapability)(o)?a=this.readFileStreamed(o,e,n.token,s):a=this.readFileBuffered(o,e,n.token,s),{...await r,value:a}}catch(u){a&&await(0,E.consumeStream)(a);const d=(0,g.localize)(8,null,this.resourceForError(e),(0,l.ensureFileSystemProviderError)(u).toString());throw u instanceof l.NotModifiedSinceFileOperationError?new l.NotModifiedSinceFileOperationError(d,u.stat,s):new l.FileOperationError(d,(0,l.toFileOperationResult)(u),s)}}readFileStreamed(o,e,s,i=Object.create(null)){const n=o.readFileStream(e,i,s);return(0,E.transform)(n,{data:r=>r instanceof b.VSBuffer?r:b.VSBuffer.wrap(r),error:r=>new l.FileOperationError((0,g.localize)(9,null,this.resourceForError(e),(0,l.ensureFileSystemProviderError)(r).toString()),(0,l.toFileOperationResult)(r),i)},r=>b.VSBuffer.concat(r))}readFileBuffered(o,e,s,i=Object.create(null)){const n=(0,b.newWriteableBufferStream)();return(0,f.readFileIntoStream)(o,e,n,r=>r,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new l.FileOperationError((0,g.localize)(10,null,this.resourceForError(e),(0,l.ensureFileSystemProviderError)(r).toString()),(0,l.toFileOperationResult)(r),i)},s),n}readFileUnbuffered(o,e,s){const i=(0,E.newWriteableStream)(n=>b.VSBuffer.concat(n));return(async()=>{try{let n;s?.atomic&&(0,l.hasFileAtomicReadCapability)(o)?n=await o.readFile(e,{atomic:!0}):n=await o.readFile(e),typeof s?.position=="number"&&(n=n.slice(s.position)),typeof s?.length=="number"&&(n=n.slice(0,s.length)),this.validateReadFileLimits(e,n.byteLength,s),i.end(b.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(o,e){const s=await this.resolve(o,{resolveMetadata:!0});if(s.isDirectory)throw new l.FileOperationError((0,g.localize)(11,null,this.resourceForError(o)),0,e);if(typeof e?.etag=="string"&&e.etag!==l.ETAG_DISABLED&&e.etag===s.etag)throw new l.NotModifiedSinceFileOperationError((0,g.localize)(12,null),s,e);return this.validateReadFileLimits(o,s.size,e),s}validateReadFileLimits(o,e,s){if(s?.limits){let i;if(typeof s.limits.memory=="number"&&e>s.limits.memory&&(i=9),typeof s.limits.size=="number"&&e>s.limits.size&&(i=7),typeof i=="number")throw new l.FileOperationError((0,g.localize)(13,null,this.resourceForError(o)),i)}}async canMove(o,e,s){return this.doCanMoveCopy(o,e,"move",s)}async canCopy(o,e,s){return this.doCanMoveCopy(o,e,"copy",s)}async doCanMoveCopy(o,e,s,i){if(o.toString()!==e.toString())try{const n=s==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e);await this.doValidateMoveCopy(n,o,r,e,s,i)}catch(n){return n}return!0}async move(o,e,s){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e),r=await this.doMoveCopy(i,o,n,e,"move",!!s),a=await this.resolve(e,{resolveMetadata:!0});return this._onDidRunOperation.fire(new l.FileOperationEvent(o,r==="move"?2:3,a)),a}async copy(o,e,s){const i=await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e),r=await this.doMoveCopy(i,o,n,e,"copy",!!s),a=await this.resolve(e,{resolveMetadata:!0});return this._onDidRunOperation.fire(new l.FileOperationEvent(o,r==="copy"?3:2,a)),a}async doMoveCopy(o,e,s,i,n,r){if(e.toString()===i.toString())return n;const{exists:a,isSameResourceWithDifferentPathCase:u}=await this.doValidateMoveCopy(o,e,s,i,n,r);if(a&&!u&&r&&await this.del(i,{recursive:!0}),await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(i)),n==="copy"){if(o===s&&(0,l.hasFileFolderCopyCapability)(o))await o.copy(e,i,{overwrite:r});else{const d=await this.resolve(e);d.isDirectory?await this.doCopyFolder(o,d,s,i):await this.doCopyFile(o,e,s,i)}return n}else return o===s?(await o.rename(e,i,{overwrite:r}),n):(await this.doMoveCopy(o,e,s,i,"copy",r),await this.del(e,{recursive:!0}),"copy")}async doCopyFile(o,e,s,i){if((0,l.hasOpenReadWriteCloseCapability)(o)&&(0,l.hasOpenReadWriteCloseCapability)(s))return this.doPipeBuffered(o,e,s,i);if((0,l.hasOpenReadWriteCloseCapability)(o)&&(0,l.hasReadWriteCapability)(s))return this.doPipeBufferedToUnbuffered(o,e,s,i);if((0,l.hasReadWriteCapability)(o)&&(0,l.hasOpenReadWriteCloseCapability)(s))return this.doPipeUnbufferedToBuffered(o,e,s,i);if((0,l.hasReadWriteCapability)(o)&&(0,l.hasReadWriteCapability)(s))return this.doPipeUnbuffered(o,e,s,i)}async doCopyFolder(o,e,s,i){await s.mkdir(i),Array.isArray(e.children)&&await D.Promises.settled(e.children.map(async n=>{const r=this.getExtUri(s).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(o,await this.resolve(n.resource),s,r):this.doCopyFile(o,n.resource,s,r)}))}async doValidateMoveCopy(o,e,s,i,n,r){let a=!1;if(o===s){const{providerExtUri:d,isPathCaseSensitive:S}=this.getExtUri(o);if(S||(a=d.isEqual(e,i)),a&&n==="copy")throw new Error((0,g.localize)(14,null,this.resourceForError(e),this.resourceForError(i)));if(!a&&d.isEqualOrParent(i,e))throw new Error((0,g.localize)(15,null,this.resourceForError(e),this.resourceForError(i)))}const u=await this.exists(i);if(u&&!a){if(!r)throw new l.FileOperationError((0,g.localize)(16,null,this.resourceForError(e),this.resourceForError(i)),4);if(o===s){const{providerExtUri:d}=this.getExtUri(o);if(d.isEqualOrParent(e,i))throw new Error((0,g.localize)(17,null,this.resourceForError(e),this.resourceForError(i)))}}return{exists:u,isSameResourceWithDifferentPathCase:a}}getExtUri(o){const e=this.isPathCaseSensitive(o);return{providerExtUri:e?y.extUri:y.extUriIgnorePathCase,isPathCaseSensitive:e}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(e,o);const s=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new l.FileOperationEvent(o,0,s)),s}async mkdirp(o,e){const s=[],{providerExtUri:i}=this.getExtUri(o);for(;!i.isEqual(e,i.dirname(e));)try{if(((await o.stat(e)).type&l.FileType.Directory)==0)throw new Error((0,g.localize)(18,null,this.resourceForError(e)));break}catch(n){if((0,l.toFileSystemProviderErrorCode)(n)!==l.FileSystemProviderErrorCode.FileNotFound)throw n;s.push(i.basename(e)),e=i.dirname(e)}for(let n=s.length-1;n>=0;n--){e=i.joinPath(e,s[n]);try{await o.mkdir(e)}catch(r){if((0,l.toFileSystemProviderErrorCode)(r)!==l.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(o,e){try{await this.doValidateDelete(o,e)}catch(s){return s}return!0}async doValidateDelete(o,e){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!e?.useTrash&&!(s.capabilities&4096))throw new Error((0,g.localize)(19,null,this.resourceForError(o)));let n;try{n=await s.stat(o)}catch{}if(n)this.throwIfFileIsReadonly(o,n);else throw new l.FileOperationError((0,g.localize)(20,null,this.resourceForError(o)),1);if(!!!e?.recursive){const a=await this.resolve(o);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,g.localize)(21,null,this.resourceForError(o)))}return s}async del(o,e){const s=await this.doValidateDelete(o,e),i=!!e?.useTrash,n=!!e?.recursive;await s.delete(o,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new l.FileOperationEvent(o,1))}watch(o,e={recursive:!1,excludes:[]}){const s=new w.DisposableStore;let i=!1,n=()=>{i=!0};return s.add((0,w.toDisposable)(()=>n())),(async()=>{try{const r=await this.doWatch(o,e);i?(0,w.dispose)(r):n=()=>(0,w.dispose)(r)}catch(r){this.logService.error(r)}})(),s}async doWatch(o,e){const s=await this.withProvider(o),i=(0,P.hash)([this.getExtUri(s).providerExtUri.getComparisonKey(o),e]);let n=this.activeWatchers.get(i);return n||(n={count:0,disposable:s.watch(o,e)},this.activeWatchers.set(i,n)),n.count+=1,(0,w.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,w.dispose)(n.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,w.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,e,s,i){return this.writeQueue.queueFor(e,this.getExtUri(o).providerExtUri).queue(async()=>{const n=await o.open(e,{create:!0,unlock:s?.unlock??!1});try{(0,E.isReadableStream)(i)||(0,E.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(o,n,i):await this.doWriteReadableBufferedQueued(o,n,i)}catch(r){throw(0,l.ensureFileSystemProviderError)(r)}finally{await o.close(n)}})}async doWriteStreamBufferedQueued(o,e,s){let i=0,n;if((0,E.isReadableBufferedStream)(s)){if(s.buffer.length>0){const r=b.VSBuffer.concat(s.buffer);await this.doWriteBuffer(o,e,r,r.byteLength,i,0),i+=r.byteLength}if(s.ended)return;n=s.stream}else n=s;return new Promise((r,a)=>{(0,E.listenStream)(n,{onData:async u=>{n.pause();try{await this.doWriteBuffer(o,e,u,u.byteLength,i,0)}catch(d){return a(d)}i+=u.byteLength,setTimeout(()=>n.resume())},onError:u=>a(u),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(o,e,s){let i=0,n;for(;(n=s.read())!==null;)await this.doWriteBuffer(o,e,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(o,e,s,i,n,r){let a=0;for(;a<i;)a+=await o.write(e,n+a,s.buffer,r+a,i-a)}async doWriteUnbuffered(o,e,s,i){return this.writeQueue.queueFor(e,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,e,s,i))}async doWriteUnbufferedQueued(o,e,s,i){let n;i instanceof b.VSBuffer?n=i:(0,E.isReadableStream)(i)?n=await(0,b.streamToBuffer)(i):(0,E.isReadableBufferedStream)(i)?n=await(0,b.bufferedStreamToBuffer)(i):n=(0,b.readableToBuffer)(i),await o.writeFile(e,n.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1})}async doPipeBuffered(o,e,s,i){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,e,s,i))}async doPipeBufferedQueued(o,e,s,i){let n,r;try{n=await o.open(e,{create:!1}),r=await s.open(i,{create:!0,unlock:!1});const a=b.VSBuffer.alloc(this.BUFFER_SIZE);let u=0,d=0,S=0;do S=await o.read(n,u,a.buffer,d,a.byteLength-d),await this.doWriteBuffer(s,r,a,S,u,d),u+=S,d+=S,d===a.byteLength&&(d=0);while(S>0)}catch(a){throw(0,l.ensureFileSystemProviderError)(a)}finally{await D.Promises.settled([typeof n=="number"?o.close(n):Promise.resolve(),typeof r=="number"?s.close(r):Promise.resolve()])}}async doPipeUnbuffered(o,e,s,i){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,e,s,i))}async doPipeUnbufferedQueued(o,e,s,i){return s.writeFile(i,await o.readFile(e),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,e,s,i){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,e,s,i))}async doPipeUnbufferedToBufferedQueued(o,e,s,i){const n=await s.open(i,{create:!0,unlock:!1});try{const r=await o.readFile(e);await this.doWriteBuffer(s,n,b.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,l.ensureFileSystemProviderError)(r)}finally{await s.close(n)}}async doPipeBufferedToUnbuffered(o,e,s,i){const n=await(0,b.streamToBuffer)(this.readFileBuffered(o,e,R.CancellationToken.None));await this.doWriteUnbuffered(s,i,void 0,n)}throwIfFileSystemIsReadonly(o,e){if(o.capabilities&2048)throw new l.FileOperationError((0,g.localize)(22,null,this.resourceForError(e)),6);return o}throwIfFileIsReadonly(o,e){if((e.permissions??0)&l.FilePermission.Readonly)throw new l.FileOperationError((0,g.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===L.Schemas.file?o.fsPath:o.toString(!0)}};p=ge([oe(0,v.ILogService)],p),t.FileService=p}),define(Y[102],Q([0,1,103,136,3,54,17,7,45,2,11,12,19,38,15,83,16,50,99,28,96,95]),function(j,t,C,D,b,R,T,P,c,w,I,L,h,y,E,g,l,f,v,p,m,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0,(()=>{try{(0,D.gracefulify)(C)}catch(s){console.error(`Error enabling graceful-fs: ${(0,p.toErrorMessage)(s)}`)}})();class e extends v.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n);this.onDidChangeCapabilities=P.Event.None,this.resourceLocks=new R.ResourceMap(r=>h.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,L.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:n,symbolicLink:r}=await E.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.toFileSystemProviderError(n)}}async readdir(i){try{const n=await E.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async a=>{try{let u;a.isSymbolicLink()?u=(await this.stat((0,h.joinPath)(i,a.name))).type:u=this.toType(a),r.push([a.name,u])}catch(u){this.logService.trace(u)}})),r}catch(n){throw this.toFileSystemProviderError(n)}}toType(i,n){let r;return n?.dangling?r=l.FileType.Unknown:i.isFile()?r=l.FileType.File:i.isDirectory()?r=l.FileType.Directory:r=l.FileType.Unknown,n&&(r|=l.FileType.SymbolicLink),r}async createResourceLock(i){const n=this.toFilePath(i);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const a=new b.Barrier;return this.resourceLocks.set(i,a),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,w.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.resourceLocks.get(i)===a&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.resourceLocks.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),a.open()})}async readFile(i,n){let r;try{n?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),r=await this.createResourceLock(i));const a=this.toFilePath(i);return await E.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}finally{r?.dispose()}}readFileStream(i,n,r){const a=(0,y.newWriteableStream)(u=>T.VSBuffer.concat(u.map(d=>T.VSBuffer.wrap(d))).buffer);return(0,f.readFileIntoStream)(this,i,a,u=>u.buffer,{...n,bufferSize:256*1024},r),a}async writeFile(i,n,r){let a;try{const u=this.toFilePath(i);if(!r.create||!r.overwrite){if(await E.Promises.exists(u)){if(!r.overwrite)throw(0,l.createFileSystemProviderError)((0,g.localize)(0,null),l.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,l.createFileSystemProviderError)((0,g.localize)(1,null),l.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(i,{create:!0,unlock:r.unlock}),await this.write(a,0,n,0,n.byteLength)}catch(u){throw await this.toFileSystemProviderWriteError(i,u)}finally{typeof a=="number"&&await this.close(a)}}async open(i,n){const r=this.toFilePath(i);let a;(0,l.isFileOpenForWriteOptions)(n)&&(a=await this.createResourceLock(i));let u;try{if((0,l.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:S}=await E.SymlinkSupport.stat(r);S.mode&128||await E.Promises.chmod(r,S.mode|128)}catch(S){this.logService.trace(S)}let d;if((0,l.isFileOpenForWriteOptions)(n)){if(L.isWindows)try{await E.Promises.truncate(r,0),d="r+"}catch(S){S.code!=="ENOENT"&&this.logService.trace(S)}d||(d="w")}else d="r";u=await E.Promises.open(r,d)}catch(d){throw a?.dispose(),(0,l.isFileOpenForWriteOptions)(n)?await this.toFileSystemProviderWriteError(i,d):this.toFileSystemProviderError(d)}if(this.mapHandleToPos.set(u,0),(0,l.isFileOpenForWriteOptions)(n)&&this.writeHandles.set(u,i),a){const d=this.mapHandleToLock.get(u);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${u} (${r})`),this.mapHandleToLock.set(u,a),d&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${u} (${r})`),d.dispose())}return u}async close(i){const n=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await E.Promises.fdatasync(i)}catch(r){this.canFlush=!1,this.logService.error(r)}return await E.Promises.close(i)}catch(r){throw this.toFileSystemProviderError(r)}finally{n&&(this.mapHandleToLock.get(i)===n&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,r,a,u){const d=this.normalizePos(i,n);let S=null;try{S=(await E.Promises.read(i,r,a,u,d)).bytesRead}catch(O){throw this.toFileSystemProviderError(O)}finally{this.updatePos(i,d,S)}return S}normalizePos(i,n){return n===this.mapHandleToPos.get(i)?null:n}updatePos(i,n,r){const a=this.mapHandleToPos.get(i);typeof a=="number"&&(typeof n=="number"||(typeof r=="number"?this.mapHandleToPos.set(i,a+r):this.mapHandleToPos.delete(i)))}async write(i,n,r,a,u){return(0,b.retry)(()=>this.doWrite(i,n,r,a,u),100,3)}async doWrite(i,n,r,a,u){const d=this.normalizePos(i,n);let S=null;try{S=(await E.Promises.write(i,r,a,u,d)).bytesWritten}catch(O){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),O)}finally{this.updatePos(i,d,S)}return S}async mkdir(i){try{await E.Promises.mkdir(this.toFilePath(i))}catch(n){throw this.toFileSystemProviderError(n)}}async delete(i,n){try{const r=this.toFilePath(i);n.recursive?await E.Promises.rm(r,E.RimRafMode.MOVE):await E.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(i,n,r){const a=this.toFilePath(i),u=this.toFilePath(n);if(a!==u)try{await this.validateTargetDeleted(i,n,"move",r.overwrite),await E.Promises.move(a,u)}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,g.localize)(2,null,(0,I.basename)(a),(0,I.basename)((0,I.dirname)(u)),d.toString()))),this.toFileSystemProviderError(d)}}async copy(i,n,r){const a=this.toFilePath(i),u=this.toFilePath(n);if(a!==u)try{await this.validateTargetDeleted(i,n,"copy",r.overwrite),await E.Promises.copy(a,u,{preserveSymlinks:!0})}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,g.localize)(3,null,(0,I.basename)(a),(0,I.basename)((0,I.dirname)(u)),d.toString()))),this.toFileSystemProviderError(d)}}async validateTargetDeleted(i,n,r,a){const u=this.toFilePath(i),d=this.toFilePath(n);let S=!1;if(!!(this.capabilities&1024)||(S=(0,c.isEqual)(u,d,!0)),S&&r==="copy")throw(0,l.createFileSystemProviderError)((0,g.localize)(4,null),l.FileSystemProviderErrorCode.FileExists);if(!S&&await E.Promises.exists(d)){if(!a)throw(0,l.createFileSystemProviderError)((0,g.localize)(5,null),l.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}createUniversalWatcher(i,n,r){return new m.UniversalWatcherClient(a=>i(a),a=>n(a),r)}createNonRecursiveWatcher(i,n,r){return new o.NodeJSWatcherClient(a=>i(a),a=>n(a),r)}toFileSystemProviderError(i){if(i instanceof l.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=l.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=l.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=l.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=l.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=l.FileSystemProviderErrorCode.NoPermissions;break;default:n=l.FileSystemProviderErrorCode.Unknown}return(0,l.createFileSystemProviderError)(i,n)}async toFileSystemProviderWriteError(i,n){let r=this.toFileSystemProviderError(n);if(i&&r.code===l.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await E.SymlinkSupport.stat(this.toFilePath(i));a.mode&128||(r=(0,l.createFileSystemProviderError)(n,l.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return r}}t.DiskFileSystemProvider=e}),define(Y[104],Q([0,1,16,14]),function(j,t,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=void 0;async function b(P,c,w,I,L){try{const h=await new Promise((E,g)=>{j(["spdlog"],E,g)});h.setFlushOn(D.LogLevel.Trace);const y=await h.createAsyncRotatingLogger(P,c,w,I);return L&&y.clearFormatters(),y}catch(h){console.error(h)}return null}function R(P,c,w){switch(c){case D.LogLevel.Trace:P.trace(w);break;case D.LogLevel.Debug:P.debug(w);break;case D.LogLevel.Info:P.info(w);break;case D.LogLevel.Warning:P.warn(w);break;case D.LogLevel.Error:P.error(w);break;case D.LogLevel.Critical:P.critical(w);break;default:throw new Error("Invalid log level")}}class T extends D.AbstractMessageLogger{constructor(c,w,I,L,h){super();this.buffer=[],this.setLevel(h),this._loggerCreationPromise=this._createSpdLogLogger(c,w,I,L),this._register(this.onDidChangeLogLevel(y=>{this._logger&&this._logger.setLevel(y)}))}async _createSpdLogLogger(c,w,I,L){const h=I?6:1,y=30/h*C.ByteSize.MB,E=await b(c,w,y,h,L);if(E){this._logger=E,this._logger.setLevel(this.getLevel());for(const{level:g,message:l}of this.buffer)R(this._logger,g,l);this.buffer=[]}}log(c,w){this._logger?R(this._logger,c,w):this.getLevel()<=c&&this.buffer.push({level:c,message:w})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=T}),define(Y[32],Q([0,1,13]),function(j,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.productSchemaId=t.IProductService=void 0,t.IProductService=(0,C.createDecorator)("productService"),t.productSchemaId="vscode://schemas/vscode-product"}),define(Y[30],Q([0,1,55,6]),function(j,t,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class b{constructor(){this.data=new Map}add(T,P){C.ok(D.isString(T)),C.ok(D.isObject(P)),C.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,P)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}t.Registry=new b}),define(Y[105],Q([0,1,7,30]),function(j,t,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function b(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class R{constructor(){this._onDidChangeSchema=new C.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(c,w){this.schemasById[b(c)]=w,this._onDidChangeSchema.fire(c)}notifySchemaChanged(c){this._onDidChangeSchema.fire(c)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new R;D.Registry.add(t.Extensions.JSONContribution,T)}),define(Y[34],Q([0,1,18,7,6,73,105,30]),function(j,t,C,D,b,R,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.keyFromOverrideIdentifiers=t.overrideIdentifiersFromKey=t.OVERRIDE_PROPERTY_REGEX=t.OVERRIDE_PROPERTY_PATTERN=t.configurationDefaultsSchemaId=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var c;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(c=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var w;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(w=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",t.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=P.Registry.as(T.Extensions.JSONContribution);class L{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new D.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new D.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},I.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(o,e=!0){this.registerConfigurations([o],e)}registerConfigurations(o,e=!0){const s=this.doRegisterConfigurations(o,e);I.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(o){const e=this.doDeregisterConfigurations(o);I.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:e})}updateConfigurations({add:o,remove:e}){const s=[];s.push(...this.doDeregisterConfigurations(e)),s.push(...this.doRegisterConfigurations(o,!1)),I.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,C.distinct)(s)})}registerDefaultConfigurations(o){const e=[],s=[];for(const{overrides:i,source:n}of o)for(const r in i)if(e.push(r),t.OVERRIDE_PROPERTY_REGEX.test(r)){const a={...this.configurationDefaultsOverrides.get(r)?.value||{},...i[r]};this.configurationDefaultsOverrides.set(r,{source:n,value:a});const u={type:"object",default:a,description:R.localize(1,null,r),$ref:t.resourceLanguageSettingsSchemaId,defaultDefaultValue:a,source:b.isString(n)?void 0:n};s.push(...E(r)),this.configurationProperties[r]=u,this.defaultLanguageConfigurationOverridesNode.properties[r]=u}else{this.configurationDefaultsOverrides.set(r,{value:i[r],source:n});const a=this.configurationProperties[r];a&&(this.updatePropertyDefaultValue(r,a),this.updateSchema(r,a))}this.registerOverrideIdentifiers(s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:e,defaultsOverrides:!0})}deregisterDefaultConfigurations(o){const e=[];for(const{overrides:s,source:i}of o)for(const n in s){const r=this.configurationDefaultsOverrides.get(n),a=b.isString(i)?i:i?.id,u=b.isString(r?.source)?r?.source:r?.source?.id;if(a===u)if(e.push(n),this.configurationDefaultsOverrides.delete(n),t.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const d=this.configurationProperties[n];d&&(this.updatePropertyDefaultValue(n,d),this.updateSchema(n,d))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:e,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){for(const e of o)this.overrideIdentifiers.add(e);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,e){const s=[];return o.forEach(i=>{s.push(...this.validateAndRegisterProperties(i,e,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),s}doDeregisterConfigurations(o){const e=[],s=i=>{if(i.properties)for(const n in i.properties)e.push(n),delete this.configurationProperties[n],this.removeFromSchema(n,i.properties[n]);i.allOf&&i.allOf.forEach(n=>s(n))};for(const i of o){s(i);const n=this.configurationContributors.indexOf(i);n!==-1&&this.configurationContributors.splice(n,1)}return e}validateAndRegisterProperties(o,e=!0,s,i,n=3){n=b.isUndefinedOrNull(o.scope)?n:o.scope;let r=[],a=o.properties;if(a)for(let d in a){if(e&&v(d)){delete a[d];continue}const S=a[d];if(S.source=s,S.defaultDefaultValue=a[d].default,this.updatePropertyDefaultValue(d,S),t.OVERRIDE_PROPERTY_REGEX.test(d)?S.scope=void 0:(S.scope=b.isUndefinedOrNull(S.scope)?n:S.scope,S.restricted=b.isUndefinedOrNull(S.restricted)?!!i?.includes(d):S.restricted),a[d].hasOwnProperty("included")&&!a[d].included){this.excludedConfigurationProperties[d]=a[d],delete a[d];continue}else this.configurationProperties[d]=a[d];!a[d].deprecationMessage&&a[d].markdownDeprecationMessage&&(a[d].deprecationMessage=a[d].markdownDeprecationMessage),r.push(d)}let u=o.allOf;if(u)for(let d of u)r.push(...this.validateAndRegisterProperties(d,e,s,i,n));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(o){const e=s=>{let i=s.properties;if(i)for(const r in i)this.updateSchema(r,i[r]);let n=s.allOf;n&&n.forEach(e)};e(o)}updateSchema(o,e){switch(t.allSettings.properties[o]=e,e.scope){case 1:t.applicationSettings.properties[o]=e;break;case 2:t.machineSettings.properties[o]=e;break;case 6:t.machineOverridableSettings.properties[o]=e;break;case 3:t.windowSettings.properties[o]=e;break;case 4:t.resourceSettings.properties[o]=e;break;case 5:t.resourceSettings.properties[o]=e,this.resourceLanguageSettingsSchema.properties[o]=e;break}}removeFromSchema(o,e){switch(delete t.allSettings.properties[o],e.scope){case 1:delete t.applicationSettings.properties[o];break;case 2:delete t.machineSettings.properties[o];break;case 6:delete t.machineOverridableSettings.properties[o];break;case 3:delete t.windowSettings.properties[o];break;case 4:case 5:delete t.resourceSettings.properties[o],delete this.resourceLanguageSettingsSchema.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const e=`[${o}]`,s={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(e,s),t.allSettings.properties[e]=s,t.applicationSettings.properties[e]=s,t.machineSettings.properties[e]=s,t.machineOverridableSettings.properties[e]=s,t.windowSettings.properties[e]=s,t.resourceSettings.properties[e]=s}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const o={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:t.resourceLanguageSettingsSchemaId};t.allSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=o,t.applicationSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=o,t.machineSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=o,t.machineOverridableSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=o,t.windowSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=o,t.resourceSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=o,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,e){const s=this.configurationDefaultsOverrides.get(o);let i=s?.value,n=s?.source;b.isUndefined(i)&&(i=e.defaultDefaultValue,n=void 0),b.isUndefined(i)&&(i=l(e.type)),e.default=i,e.defaultValueSource=n}}const h="\\[([^\\]]+)\\]",y=new RegExp(h,"g");t.OVERRIDE_PROPERTY_PATTERN=`^(${h})+$`,t.OVERRIDE_PROPERTY_REGEX=new RegExp(t.OVERRIDE_PROPERTY_PATTERN);function E(m){const o=[];if(t.OVERRIDE_PROPERTY_REGEX.test(m)){let e=y.exec(m);for(;e?.length;){const s=e[1].trim();s&&o.push(s),e=y.exec(m)}}return(0,C.distinct)(o)}t.overrideIdentifiersFromKey=E;function g(m){return m.reduce((o,e)=>`${o}[${e}]`,"")}t.keyFromOverrideIdentifiers=g;function l(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=l;const f=new L;P.Registry.add(t.Extensions.Configuration,f);function v(m){return m.trim()?t.OVERRIDE_PROPERTY_REGEX.test(m)?R.localize(7,null,m):f.getConfigurationProperties()[m]!==void 0?R.localize(8,null,m):null:R.localize(6,null)}t.validateProperty=v;function p(){const m=[],o=f.getConfigurationProperties();for(const e of Object.keys(o))m.push([e,o[e].scope]);return m.push(["launch",4]),m.push(["task",4]),m}t.getScopes=p}),define(Y[106],Q([0,1,18,7,56,2,54,22,6,9,25,34,30]),function(j,t,C,D,b,R,T,P,c,w,I,L,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class y{constructor(i={},n=[],r=[]){this._contents=i,this._keys=n,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,I.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,n){const r=this.getContentsForOverrideIdentifer(n);return r?i?(0,I.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const r of this.overrides)r.identifiers.includes(i)&&n.push(...r.keys);return C.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return C.distinct(i)}override(i){let n=this.overrideConfigurations.get(i);return n||(n=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,n)),n}merge(...i){const n=P.deepClone(this.contents),r=P.deepClone(this.overrides),a=[...this.keys];for(const u of i){this.mergeContents(n,u.contents);for(const d of u.overrides){const[S]=r.filter(O=>C.equals(O.identifiers,d.identifiers));S?(this.mergeContents(S.contents,d.contents),S.keys.push(...d.keys),S.keys=C.distinct(S.keys)):r.push(P.deepClone(d))}for(const d of u.keys)a.indexOf(d)===-1&&a.push(d)}return new y(n,a,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const n=this.getContentsForOverrideIdentifer(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let r={};for(const a of C.distinct([...Object.keys(this.contents),...Object.keys(n)])){let u=this.contents[a],d=n[a];d&&(typeof u=="object"&&typeof d=="object"?(u=P.deepClone(u),this.mergeContents(u,d)):u=d),r[a]=u}return new y(r,this.keys,this.overrides)}mergeContents(i,n){for(const r of Object.keys(n)){if(r in i&&c.isObject(i[r])&&c.isObject(n[r])){this.mergeContents(i[r],n[r]);continue}i[r]=P.deepClone(n[r])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?P.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let n=null,r=null;const a=u=>{u&&(r?this.mergeContents(r,u):r=P.deepClone(u))};for(const u of this.overrides)C.equals(u.identifiers,[i])?n=u.contents:u.identifiers.includes(i)&&a(u.contents);return a(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,n){this.addKey(i),(0,I.addToValueTree)(this.contents,i,n,r=>{throw new Error(r)})}removeValue(i){this.removeKey(i)&&(0,I.removeFromValueTree)(this.contents,i)}addKey(i){let n=this.keys.length;for(let r=0;r<n;r++)i.indexOf(this.keys[r])===0&&(n=r);this.keys.splice(n,1,i)}removeKey(i){let n=this.keys.indexOf(i);return n!==-1?(this.keys.splice(n,1),!0):!1}}t.ConfigurationModel=y;class E extends y{constructor(i={}){const n=h.Registry.as(L.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(n),a=Object.create(null),u=[];for(const d in n){const S=i[d],O=S!==void 0?S:n[d].default;(0,I.addToValueTree)(a,d,O,N=>console.error(`Conflict in default settings: ${N}`))}for(const d of Object.keys(a))L.OVERRIDE_PROPERTY_REGEX.test(d)&&u.push({identifiers:(0,L.overrideIdentifiersFromKey)(d),keys:Object.keys(a[d]),contents:(0,I.toValuesTree)(a[d],S=>console.error(`Conflict in default settings file: ${S}`))});super(a,r,u)}}t.DefaultConfigurationModel=E;class g{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,n){if(!c.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,n)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,n){this._raw=i;const{contents:r,keys:a,overrides:u,restricted:d}=this.doParseRaw(i,n);this._configurationModel=new y(r,a,u),this._restrictedConfigurations=d||[]}doParseContent(i){let n={},r=null,a=[],u=[],d=[];function S(N){Array.isArray(a)?a.push(N):r!==null&&(a[r]=N)}let O={onObjectBegin:()=>{let N={};S(N),u.push(a),a=N,r=null},onObjectProperty:N=>{r=N},onObjectEnd:()=>{a=u.pop()},onArrayBegin:()=>{let N=[];S(N),u.push(a),a=N,r=null},onArrayEnd:()=>{a=u.pop()},onLiteralValue:S,onError:(N,_,J)=>{d.push({error:N,offset:_,length:J})}};if(i)try{b.visit(i,O),n=a[0]||{}}catch(N){console.error(`Error while parsing settings file ${this._name}: ${N}`),this._parseErrors=[N]}return n}doParseRaw(i,n){const r=h.Registry.as(L.Extensions.Configuration).getConfigurationProperties(),a=this.filter(i,r,!0,n);i=a.raw;const u=(0,I.toValuesTree)(i,O=>console.error(`Conflict in settings file ${this._name}: ${O}`)),d=Object.keys(i),S=this.toOverrides(i,O=>console.error(`Conflict in settings file ${this._name}: ${O}`));return{contents:u,keys:d,overrides:S,restricted:a.restricted}}filter(i,n,r,a){if(!a?.scopes&&!a?.skipRestricted)return{raw:i,restricted:[]};const u={},d=[];for(let S in i)if(L.OVERRIDE_PROPERTY_REGEX.test(S)&&r){const O=this.filter(i[S],n,!1,a);u[S]=O.raw,d.push(...O.restricted)}else{const O=n[S],N=O?typeof O.scope!="undefined"?O.scope:3:void 0;O?.restricted&&d.push(S),(N===void 0||a.scopes===void 0||a.scopes.includes(N))&&(a.skipRestricted&&O?.restricted||(u[S]=i[S]))}return{raw:u,restricted:d}}toOverrides(i,n){const r=[];for(const a of Object.keys(i))if(L.OVERRIDE_PROPERTY_REGEX.test(a)){const u={};for(const d in i[a])u[d]=i[a][d];r.push({identifiers:(0,L.overrideIdentifiersFromKey)(a),keys:Object.keys(u),contents:(0,I.toValuesTree)(u,n)})}return r}}t.ConfigurationModelParser=g;class l extends R.Disposable{constructor(i,n,r,a){super();this.userSettingsResource=i,this.scopes=n,this.fileService=a,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(D.Event.any(D.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource)),D.Event.filter(this.fileService.onDidRunOperation,u=>(u.isOperation(0)||u.isOperation(1)||u.isOperation(4))&&r.isEqual(u.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=l;class f{constructor(i,n,r=new y,a=new y,u=new T.ResourceMap,d=new y,S=new T.ResourceMap,O=!0){this._defaultConfiguration=i,this._localUserConfiguration=n,this._remoteUserConfiguration=r,this._workspaceConfiguration=a,this._folderConfigurations=u,this._memoryConfiguration=d,this._memoryConfigurationByResource=S,this._freeze=O,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(i,n,r){return this.getConsolidateConfigurationModel(n,r).getValue(i)}updateValue(i,n,r={}){let a;r.resource?(a=this._memoryConfigurationByResource.get(r.resource),a||(a=new y,this._memoryConfigurationByResource.set(r.resource,a))):a=this._memoryConfiguration,n===void 0?a.removeValue(i):a.setValue(i,n),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,n,r){const a=this.getConsolidateConfigurationModel(n,r),u=this.getFolderConfigurationModelForResource(n.resource,r),d=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,S=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),O=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),N=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),_=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),J=r?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,re=u?n.overrideIdentifier?u.freeze().override(n.overrideIdentifier).getValue(i):u.freeze().getValue(i):void 0,ee=n.overrideIdentifier?d.override(n.overrideIdentifier).getValue(i):d.getValue(i),ie=a.getValue(i),he=C.distinct(C.flatten(a.overrides.map(ue=>ue.identifiers))).filter(ue=>a.getOverrideValue(i,ue)!==void 0);return{defaultValue:S,userValue:O,userLocalValue:N,userRemoteValue:_,workspaceValue:J,workspaceFolderValue:re,memoryValue:ee,value:ie,default:S!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,user:O!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,userLocal:N!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,userRemote:_!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,workspace:J!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,workspaceFolder:re!==void 0?{value:u?.freeze().getValue(i),override:n.overrideIdentifier?u?.freeze().getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,memory:ee!==void 0?{value:d.getValue(i),override:n.overrideIdentifier?d.getOverrideValue(i,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:he.length?he:void 0}}keys(i){const n=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,n){this._folderConfigurations.set(i,n),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const r=[];if(!n){const{added:a,updated:u,removed:d}=o(this._defaultConfiguration,i);n=[...a,...u,...d]}for(const a of n)for(const u of(0,L.overrideIdentifiersFromKey)(a)){const d=this._defaultConfiguration.getKeysForOverrideIdentifier(u),S=i.getKeysForOverrideIdentifier(u),O=[...S.filter(N=>d.indexOf(N)===-1),...d.filter(N=>S.indexOf(N)===-1),...d.filter(N=>!P.equals(this._defaultConfiguration.override(u).getValue(N),i.override(u).getValue(N)))];r.push([u,O])}return this.updateDefaultConfiguration(i),{keys:n,overrides:r}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:r,removed:a,overrides:u}=o(this.localUserConfiguration,i),d=[...n,...r,...a];return d.length&&this.updateLocalUserConfiguration(i),{keys:d,overrides:u}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:r,removed:a,overrides:u}=o(this.remoteUserConfiguration,i);let d=[...n,...r,...a];return d.length&&this.updateRemoteUserConfiguration(i),{keys:d,overrides:u}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:r,removed:a,overrides:u}=o(this.workspaceConfiguration,i);let d=[...n,...r,...a];return d.length&&this.updateWorkspaceConfiguration(i),{keys:d,overrides:u}}compareAndUpdateFolderConfiguration(i,n){const r=this.folderConfigurations.get(i),{added:a,updated:u,removed:d,overrides:S}=o(r,n);let O=[...a,...u,...d];return(O.length||!r)&&this.updateFolderConfiguration(i,n),{keys:O,overrides:S}}compareAndDeleteFolderConfiguration(i){const n=this.folderConfigurations.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:a,removed:u,overrides:d}=o(n,void 0);return{keys:[...r,...a,...u],overrides:d}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,n){let r=this.getConsolidatedConfigurationModelForResource(i,n);return i.overrideIdentifier?r.override(i.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:i},n){let r=this.getWorkspaceConsolidatedConfiguration();if(n&&i){const a=n.getFolder(i);a&&(r=this.getFolderConsolidatedConfiguration(a.uri)||r);const u=this._memoryConfigurationByResource.get(i);u&&(r=r.merge(u))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let n=this._foldersConsolidatedConfigurations.get(i);if(!n){const r=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(i);a?(n=r.merge(a),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(i,n)):n=r}return n}getFolderConfigurationModelForResource(i,n){if(n&&i){const r=n.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,n)=>{const{contents:r,overrides:a,keys:u}=this._folderConfigurations.get(n);return i.push([n,{contents:r,overrides:a,keys:u}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>i.add(n)),this.userConfiguration.freeze().keys.forEach(n=>i.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(r=>i.add(r))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(a=>n.add(a))),[...n.values()]}static parse(i){const n=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.user),a=this.parseConfigurationModel(i.workspace),u=i.folders.reduce((d,S)=>(d.set(w.URI.revive(S[0]),this.parseConfigurationModel(S[1])),d),new T.ResourceMap);return new f(n,r,new y,a,u,new y,new T.ResourceMap,!1)}static parseConfigurationModel(i){return new y(i.contents,i.keys,i.overrides).freeze()}}t.Configuration=f;function v(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const i=new Set,n=new Map;for(const a of s)a.keys.forEach(u=>i.add(u)),a.overrides.forEach(([u,d])=>{const S=(0,T.getOrSet)(n,u,new Set);d.forEach(O=>S.add(O))});const r=[];return n.forEach((a,u)=>r.push([u,[...a.values()]])),{keys:[...i.values()],overrides:r}}t.mergeChanges=v;class p{constructor(i,n,r,a){this.change=i,this.previous=n,this.currentConfiguraiton=r,this.currentWorkspace=a,this._previousConfiguration=void 0;const u=new Set;i.keys.forEach(S=>u.add(S)),i.overrides.forEach(([,S])=>S.forEach(O=>u.add(O))),this.affectedKeys=[...u.values()];const d=new y;this.affectedKeys.forEach(S=>d.setValue(S,{})),this.affectedKeysTree=d.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=f.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(n){const r=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.previous?.workspace):void 0,a=this.currentConfiguraiton.getValue(i,n,this.currentWorkspace);return!P.equals(r,a)}return!0}return!1}doesAffectedKeysTreeContains(i,n){let r=(0,I.toValuesTree)({[n]:!0},()=>{}),a;for(;typeof r=="object"&&(a=Object.keys(r)[0]);){if(i=i[a],!i)return!1;r=r[a]}return!0}}t.ConfigurationChangeEvent=p;class m extends p{constructor(i,n,r,a){super({keys:i.allKeys(),overrides:[]},void 0,i,n);this.source=r,this.sourceConfig=a}}t.AllKeysConfigurationChangeEvent=m;function o(s,i){const{added:n,removed:r,updated:a}=e(i,s),u=[],d=s?.getAllOverrideIdentifiers()||[],S=i?.getAllOverrideIdentifiers()||[];if(i){const O=S.filter(N=>!d.includes(N));for(const N of O)u.push([N,i.getKeysForOverrideIdentifier(N)])}if(s){const O=d.filter(N=>!S.includes(N));for(const N of O)u.push([N,s.getKeysForOverrideIdentifier(N)])}if(i&&s){for(const O of d)if(S.includes(O)){const N=e({contents:s.getOverrideValue(void 0,O)||{},keys:s.getKeysForOverrideIdentifier(O)},{contents:i.getOverrideValue(void 0,O)||{},keys:i.getKeysForOverrideIdentifier(O)});u.push([O,[...N.added,...N.removed,...N.updated]])}}return{added:n,removed:r,updated:a,overrides:u}}function e(s,i){const n=s?i?s.keys.filter(u=>i.keys.indexOf(u)===-1):[...s.keys]:[],r=i?s?i.keys.filter(u=>s.keys.indexOf(u)===-1):[...i.keys]:[],a=[];if(s&&i){for(const u of i.keys)if(s.keys.indexOf(u)!==-1){const d=(0,I.getConfigurationValue)(i.contents,u),S=(0,I.getConfigurationValue)(s.contents,u);P.equals(d,S)||a.push(u)}}return{added:n,removed:r,updated:a}}}),define(Y[107],Q([0,1,3,7,2,19,25,106,34,30]),function(j,t,C,D,b,R,T,P,c,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class I extends b.Disposable{constructor(h,y){super();this.settingsResource=h,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,y)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new C.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(w.Registry.as(c.Extensions.Configuration).onDidUpdateConfiguration(({properties:E})=>this.onDidDefaultConfigurationChange(E))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const h=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,h)}getConfigurationData(){return this.configuration.toData()}getValue(h,y){const E=typeof h=="string"?h:void 0,g=(0,T.isConfigurationOverrides)(h)?h:(0,T.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(E,g,void 0)}updateValue(h,y,E,g){return Promise.reject(new Error("not supported"))}inspect(h){return this.configuration.inspect(h,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const h=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(h)}onDidChangeUserConfiguration(h){const y=this.configuration.toData(),E=this.configuration.compareAndUpdateLocalUserConfiguration(h);this.trigger(E,y,1)}onDidDefaultConfigurationChange(h){const y=this.configuration.toData(),E=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,h);this.trigger(E,y,6)}trigger(h,y,E){const g=new P.ConfigurationChangeEvent(h,{data:y},this.configuration);g.source=E,g.sourceConfig=this.getTargetConfiguration(E),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(h){switch(h){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=I}),define(Y[108],Q([0,1,10]),function(j,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getRemoteName=t.getRemoteAuthority=void 0;function D(R){return R.scheme===C.Schemas.vscodeRemote?R.authority:void 0}t.getRemoteAuthority=D;function b(R){if(!R)return;const T=R.indexOf("+");return T<0?R:R.substr(0,T)}t.getRemoteName=b}),define(Y[35],Q([0,1,26,13,108]),function(j,t,C,D,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isResolverExtension=t.isAuthenticationProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.UNDEFINED_PUBLISHER=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.UNDEFINED_PUBLISHER="undefined_publisher",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}t.getWorkspaceSupportTypeMessage=R;function T(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}t.isIExtensionIdentifier=T,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(P=t.ExtensionType||(t.ExtensionType={}));class c{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,E){if(typeof y=="undefined"||y===null)return typeof E=="undefined"||E===null;if(typeof E=="undefined"||E===null)return!1;if(typeof y=="string"||typeof E=="string"){let g=typeof y=="string"?y:y.value,l=typeof E=="string"?E:E.value;return C.equalsIgnoreCase(g,l)}return y._lower===E._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}t.ExtensionIdentifier=c;function w(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}t.isLanguagePackExtension=w;function I(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}t.isAuthenticationProviderExtension=I;function L(h,y){if(y){const E=`onResolveRemoteAuthority:${(0,b.getRemoteName)(y)}`;return h.activationEvents?.indexOf(E)!==-1}return!1}t.isResolverExtension=L,t.IBuiltinExtensionsScannerService=(0,D.createDecorator)("IBuiltinExtensionsScannerService")}),define(Y[21],Q([0,1,26,35]),function(j,t,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function b(E,g){return E.uuid&&g.uuid?E.uuid===g.uuid:E.id===g.id?!0:(0,C.compareIgnoreCase)(E.id,g.id)===0}t.areSameExtensions=b;class R{constructor(g,l){this.version=l,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof R?b(this,g)&&this.version===g.version:!1}}t.ExtensionIdentifierWithVersion=R;function T(E,g){return`${E}.${g}`}t.getExtensionId=T;function P(E){return E.toLocaleLowerCase()}t.adoptToGalleryExtensionId=P;function c(E,g){return P(T(E,g))}t.getGalleryExtensionId=c;function w(E,g){const l=[],f=v=>{for(const p of l)if(p.some(m=>b(g(m),g(v))))return p;return null};for(const v of E){const p=f(v);p?p.push(v):l.push([v])}return l}t.groupByExtension=w;function I(E){return{id:E.identifier.id,name:E.manifest.name,galleryId:null,publisherId:E.publisherId,publisherName:E.manifest.publisher,publisherDisplayName:E.publisherDisplayName,dependencies:E.manifest.extensionDependencies&&E.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=I;function L(E){return{id:E.identifier.id,name:E.name,galleryId:E.identifier.uuid,publisherId:E.publisherId,publisherName:E.publisher,publisherDisplayName:E.publisherDisplayName,isPreReleaseVersion:E.properties.isPreReleaseVersion,dependencies:!!(E.properties.dependencies&&E.properties.dependencies.length>0),...E.telemetryData}}t.getGalleryExtensionTelemetryData=L,t.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function h(E){const g=new Set;if(E.malicious)for(const l of E.malicious)g.add(l.id);return g}t.getMaliciousExtensionsSet=h;function y(E,g){const l=[],f=g.manifest.extensionDependencies?.slice(0)??[];for(;f.length;){const v=f.shift();if(v&&l.every(p=>!b(p.identifier,{id:v}))){const p=E.filter(m=>b(m.identifier,{id:v}));p.length===1&&(l.push(p[0]),f.push(...p[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}t.getExtensionDependencies=y}),define(Y[23],Q([0,1,10,75,21,13]),function(j,t,C,D,b,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.ExtensionManagementErrorCode=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.getFallbackTargetPlarforms=t.isTargetPlatformCompatible=t.isNotWebExtensionInWebTargetPlatform=t.getTargetPlatform=t.toTargetPlatform=t.TargetPlatformToString=t.TargetPlatform=t.getIdAndVersion=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";const T=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function P(e){const s=T.exec(e);return s&&s[1]?[(0,b.adoptToGalleryExtensionId)(s[1]),s[2]]:[(0,b.adoptToGalleryExtensionId)(e),void 0]}t.getIdAndVersion=P;var c;(function(e){e.WIN32_X64="win32-x64",e.WIN32_IA32="win32-ia32",e.WIN32_ARM64="win32-arm64",e.LINUX_X64="linux-x64",e.LINUX_ARM64="linux-arm64",e.LINUX_ARMHF="linux-armhf",e.ALPINE_X64="alpine-x64",e.ALPINE_ARM64="alpine-arm64",e.DARWIN_X64="darwin-x64",e.DARWIN_ARM64="darwin-arm64",e.WEB="web",e.UNIVERSAL="universal",e.UNKNOWN="unknown",e.UNDEFINED="undefined"})(c=t.TargetPlatform||(t.TargetPlatform={}));function w(e){switch(e){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}t.TargetPlatformToString=w;function I(e){switch(e){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}t.toTargetPlatform=I;function L(e,s){switch(e){case 3:return s==="x64"?"win32-x64":s==="ia32"?"win32-ia32":s==="arm64"?"win32-arm64":"unknown";case 2:return s==="x64"?"linux-x64":s==="arm64"?"linux-arm64":s==="arm"?"linux-armhf":"unknown";case"alpine":return s==="x64"?"alpine-x64":s==="arm64"?"alpine-arm64":"unknown";case 1:return s==="x64"?"darwin-x64":s==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}t.getTargetPlatform=L;function h(e,s){return s==="web"&&!e.includes("web")}t.isNotWebExtensionInWebTargetPlatform=h;function y(e,s,i){return h(s,i)?!1:e==="undefined"||e==="universal"?!0:e==="unknown"?!1:e===i?!0:E(i).includes(e)}t.isTargetPlatformCompatible=y;function E(e){switch(e){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}t.getFallbackTargetPlarforms=E;function g(e){return e&&typeof e=="object"&&typeof e.id=="string"&&(!e.uuid||typeof e.uuid=="string")}t.isIExtensionIdentifier=g;var l;(function(e){e[e.NoneOrRelevance=0]="NoneOrRelevance",e[e.LastUpdatedDate=1]="LastUpdatedDate",e[e.Title=2]="Title",e[e.PublisherName=3]="PublisherName",e[e.InstallCount=4]="InstallCount",e[e.PublishedDate=10]="PublishedDate",e[e.AverageRating=6]="AverageRating",e[e.WeightedRating=12]="WeightedRating"})(l=t.SortBy||(t.SortBy={}));var f;(function(e){e[e.Default=0]="Default",e[e.Ascending=1]="Ascending",e[e.Descending=2]="Descending"})(f=t.SortOrder||(t.SortOrder={}));var v;(function(e){e.Install="install",e.Uninstall="uninstall"})(v=t.StatisticType||(t.StatisticType={}));var p;(function(e){e[e.None=1]="None",e[e.Install=2]="Install",e[e.Update=3]="Update",e[e.Migrate=4]="Migrate"})(p=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var m;(function(e){e.Unsupported="Unsupported",e.UnsupportedPreRelease="UnsupportedPreRelease",e.Malicious="Malicious",e.Incompatible="Incompatible",e.IncompatiblePreRelease="IncompatiblePreRelease",e.IncompatibleTargetPlatform="IncompatibleTargetPlatform",e.ReleaseVersionNotFound="ReleaseVersionNotFound",e.Invalid="Invalid",e.Download="Download",e.Extract="Extract",e.Delete="Delete",e.Rename="Rename",e.CorruptZip="CorruptZip",e.IncompleteZip="IncompleteZip",e.Internal="Internal"})(m=t.ExtensionManagementErrorCode||(t.ExtensionManagementErrorCode={}));class o extends Error{constructor(s,i){super(s);this.code=i,this.name=i}}t.ExtensionManagementError=o,t.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=C.FileAccess.asBrowserUri("./media/defaultIcon.png",j).toString(!0),t.ExtensionsLabel=(0,D.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,D.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,R.createDecorator)("IExtensionManagementCLIService")}),define(Y[109],Q([0,1,24,8,62,10,41,9,76,23,21,35]),function(j,t,C,D,b,R,T,P,c,w,I,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=void 0;const h=l=>(0,c.localize)(0,null,l),y=(0,c.localize)(1,null,"ms-dotnettools.csharp");function E(l,f){return f?`${l.publisher}.${l.name}@${l.version}`:`${l.publisher}.${l.name}`}let g=class{constructor(f,v){this.extensionManagementService=f,this.extensionGalleryService=v}get location(){}async listExtensions(f,v,p=console){let m=await this.extensionManagementService.getInstalled(1);const o=L.EXTENSION_CATEGORIES.map(s=>s.toLowerCase());if(v&&v!==""){if(o.indexOf(v.toLowerCase())<0){p.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}m=m.filter(s=>s.manifest.categories?s.manifest.categories.map(n=>n.toLowerCase()).indexOf(v.toLowerCase())>-1:!1)}else if(v===""){p.log("Possible Categories: "),o.forEach(s=>{p.log(s)});return}this.location&&p.log((0,c.localize)(2,null,this.location)),m=m.sort((s,i)=>s.identifier.id.localeCompare(i.identifier.id));let e;for(let s of m)e!==s.identifier.id&&(e=s.identifier.id,p.log(E(s.manifest,f)))}async installExtensions(f,v,p,m,o=console){const e=[],s=[];f.length&&o.log(this.location?(0,c.localize)(3,null,this.location):(0,c.localize)(4,null));const i=await this.extensionManagementService.getInstalled(1),n=(u,d)=>{const S=i.find(O=>(0,I.areSameExtensions)(O.identifier,{id:u}));if(S){if(!d&&!m)return o.log((0,c.localize)(5,null,u,S.manifest.version,u)),!1;if(d&&S.manifest.version===d)return o.log((0,c.localize)(6,null,`${u}@${d}`)),!1}return!0},r=[],a=[];for(const u of f)if(u instanceof P.URI)r.push(u);else{const[d,S]=(0,w.getIdAndVersion)(u);n(d,S)&&a.push({id:d,version:S,installOptions:{...p,isBuiltin:!1}})}for(const u of v){const[d,S]=(0,w.getIdAndVersion)(u);n(d,S)&&a.push({id:d,version:S,installOptions:{...p,isBuiltin:!0}})}if(r.length&&await Promise.all(r.map(async u=>{try{const d=await this.installVSIX(u,{...p,isBuiltin:!1},m,o);d&&s.push(d)}catch(d){o.error(d.message||d.stack||d),e.push(u.toString())}})),a.length){const u=await this.getGalleryExtensions(a);await Promise.all(a.map(async d=>{const S=u.get(d.id.toLowerCase());if(S)try{const O=await this.installFromGallery(d,S,i,m,o);O&&s.push(O)}catch(O){o.error(O.message||O.stack||O),e.push(d.id)}else o.error(`${h(d.version?`${d.id}@${d.version}`:d.id)}
${y}`),e.push(d.id)}))}if(e.length)throw new Error((0,c.localize)(7,null,e.join(", ")))}async installVSIX(f,v,p,m){const o=await this.extensionManagementService.getManifest(f);if(!o)throw new Error("Invalid vsix");if(await this.validateVSIX(o,p,m))try{return await this.extensionManagementService.install(f,v),m.log((0,c.localize)(8,null,(0,b.getBaseLabel)(f))),o}catch(s){if((0,D.isCancellationError)(s))return m.log((0,c.localize)(9,null,(0,b.getBaseLabel)(f))),null;throw s}return null}async getGalleryExtensions(f){const v=new Map,p=f.some(o=>o.installOptions.installPreReleaseVersion),m=await this.extensionGalleryService.getExtensions(f.map(o=>({...o,preRelease:p})),C.CancellationToken.None);for(const o of m)v.set(o.identifier.id.toLowerCase(),o);return v}async installFromGallery({id:f,version:v,installOptions:p},m,o,e,s){const i=await this.extensionGalleryService.getManifest(m,C.CancellationToken.None);if(i&&!this.validateExtensionKind(i,s))return null;const n=o.find(r=>(0,I.areSameExtensions)(r.identifier,m.identifier));if(n){if(m.version===n.manifest.version)return s.log((0,c.localize)(10,null,v?`${f}@${v}`:f)),null;s.log((0,c.localize)(11,null,f,m.version))}try{return p.isBuiltin?s.log(v?(0,c.localize)(12,null,f,v):(0,c.localize)(13,null,f)):s.log(v?(0,c.localize)(14,null,f,v):(0,c.localize)(15,null,f)),await this.extensionManagementService.installFromGallery(m,{...p,installGivenVersion:!!v}),s.log((0,c.localize)(16,null,f,m.version)),i}catch(r){if((0,D.isCancellationError)(r))return s.log((0,c.localize)(17,null,f)),null;throw r}}validateExtensionKind(f,v){return!0}async validateVSIX(f,v,p){const m={id:(0,I.getGalleryExtensionId)(f.publisher,f.name)},e=(await this.extensionManagementService.getInstalled(1)).find(s=>(0,I.areSameExtensions)(m,s.identifier)&&(0,T.gt)(s.manifest.version,f.version));return e&&!v?(p.log((0,c.localize)(18,null,e.identifier.id,e.manifest.version,f.version)),!1):this.validateExtensionKind(f,p)}async uninstallExtensions(f,v,p=console){const m=async e=>{if(e instanceof P.URI){const s=await this.extensionManagementService.getManifest(e);return E(s)}return e},o=[];for(const e of f){const s=await m(e),n=(await this.extensionManagementService.getInstalled()).filter(r=>(0,I.areSameExtensions)(r.identifier,{id:s}));if(!n.length)throw new Error(`${this.notInstalled(s)}
${y}`);if(n.some(r=>r.type===0)){p.log((0,c.localize)(19,null,s));return}if(!v&&n.some(r=>r.isBuiltin)){p.log((0,c.localize)(20,null,s));return}p.log((0,c.localize)(21,null,s));for(const r of n)await this.extensionManagementService.uninstall(r),o.push(r);this.location?p.log((0,c.localize)(22,null,s,this.location)):p.log((0,c.localize)(23,null,s))}}async locateExtension(f,v=console){const p=await this.extensionManagementService.getInstalled();f.forEach(m=>{p.forEach(o=>{if(o.identifier.id===m&&o.location.scheme===R.Schemas.file){v.log(o.location.fsPath);return}})})}notInstalled(f){return this.location?(0,c.localize)(24,null,f,this.location):(0,c.localize)(25,null,f)}};g=ge([oe(0,w.IExtensionManagementService),oe(1,w.IExtensionGalleryService)],g),t.ExtensionManagementCLIService=g}),define(Y[110],Q([0,1,3,8,2,12,19,41,9,27,15,20,23,21,16,14]),function(j,t,C,D,b,R,T,P,c,w,I,L,h,y,E,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const l=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let f=class extends b.Disposable{constructor(p,m,o,e){super();this.fileService=m,this.extensionGalleryService=o,this.logService=e,this.extensionsDownloadDir=c.URI.file(p.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(p,m){await this.cleanUpPromise;const o=this.getName(p),e=(0,T.joinPath)(this.extensionsDownloadDir,o);if(!await this.fileService.exists(e)){const s=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,w.generateUuid)()}`);await this.fileService.exists(s)||await this.extensionGalleryService.download(p,s,m);try{await this.rename(s,e,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(s)}catch{}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",p.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,s.path),i}}return e}async delete(p){await this.cleanUpPromise,await this.fileService.del(p)}async rename(p,m,o){try{await I.Promises.rename(p.fsPath,m.fsPath)}catch(e){if(R.isWindows&&e&&e.code==="EPERM"&&Date.now()<o)return this.logService.info(`Failed renaming ${p} to ${m} with 'EPERM' error. Trying again...`),this.rename(p,m,o);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const p=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(p.children){const m=[],o=[];for(const i of p.children){const n=this.parse(i.name);n&&o.push([n,i])}const e=(0,y.groupByExtension)(o,([i])=>i),s=[];for(const i of e)i.sort((n,r)=>P.rcompare(n[0].version,r[0].version)),m.push(...i.slice(1).map(n=>n[1].resource)),s.push(i[0][1]);s.sort((i,n)=>i.mtime-n.mtime),m.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(i=>i.resource)),await C.Promises.settled(m.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(p){this.logService.error(p)}}getName(p){return this.cache?`${new y.ExtensionIdentifierWithVersion(p.identifier,p.version).key().toLowerCase()}${p.properties.targetPlatform!=="undefined"?`-${p.properties.targetPlatform}`:""}`:(0,w.generateUuid)()}parse(p){const m=l.exec(p);return m&&m[1]&&m[2]?new y.ExtensionIdentifierWithVersion({id:m[1]},m[2]):null}};f=ge([oe(0,L.INativeEnvironmentService),oe(1,E.IFileService),oe(2,h.IExtensionGalleryService),oe(3,g.ILogService)],f),t.ExtensionsDownloader=f}),define(Y[111],Q([0,1,2,11,15,35]),function(j,t,C,D,b,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class T extends C.Disposable{constructor(c,w){super();this.environmentService=c,this.extensionsManifestCache=(0,D.join)(this.environmentService.userDataPath,R.MANIFEST_CACHE_FOLDER,R.USER_MANIFEST_CACHE_FILE),this._register(w.onDidInstallExtensions(I=>this.onDidInstallExtensions(I))),this._register(w.onDidUninstallExtension(I=>this.onDidUnInstallExtension(I)))}onDidInstallExtensions(c){c.some(w=>!!w.local)&&this.invalidate()}onDidUnInstallExtension(c){c.error||this.invalidate()}invalidate(){b.Promises.rm(this.extensionsManifestCache,b.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=T}),define(Y[112],Q([0,1,137,18,3,2,10,11,15,20,23,21,53,14]),function(j,t,C,D,b,R,T,P,c,w,I,L,h,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let E=class extends R.Disposable{constructor(f,v,p){super();this.extensionManagementService=f,this.logService=p,this.cache=this._register(new g(v,p)),this.extensionManagementService.registerParticipant({postInstall:async m=>this.postInstallExtension(m),postUninstall:async m=>this.postUninstallExtension(m)})}async getLanguageIds(){const f=await this.cache.getLanguagePacks(),v=["en",...Object.keys(f)];return(0,D.distinct)(v)}async postInstallExtension(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",f.identifier.id),await this.update())}async postUninstallExtension(f){const v=await this.cache.getLanguagePacks();Object.keys(v).some(p=>v[p]&&v[p].extensions.some(m=>(0,L.areSameExtensions)(m.extensionIdentifier,f.identifier)))&&(this.logService.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,v]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),p=await this.cache.update(v);return!(0,D.equals)(Object.keys(f),Object.keys(p))}};E=ge([oe(0,I.IExtensionManagementService),oe(1,w.INativeEnvironmentService),oe(2,y.ILogService)],E),t.LocalizationsService=E;let g=class extends R.Disposable{constructor(f,v){super();this.logService=v,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(f.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new b.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(f){return this.withLanguagePacks(v=>{Object.keys(v).forEach(p=>delete v[p]),this.createLanguagePacksFromExtensions(v,...f)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(f,...v){for(const p of v)p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(f,p);Object.keys(f).forEach(p=>this.updateHash(f[p]))}createLanguagePacksFromExtension(f,v){const p=v.identifier,m=v.manifest.contributes&&v.manifest.contributes.localizations?v.manifest.contributes.localizations:[];for(const o of m)if(v.location.scheme===T.Schemas.file&&(0,h.isValidLocalization)(o)){let e=f[o.languageId];e||(e={hash:"",extensions:[],translations:{}},f[o.languageId]=e);let s=e.extensions.filter(i=>(0,L.areSameExtensions)(i.extensionIdentifier,p))[0];s?s.version=v.manifest.version:e.extensions.push({extensionIdentifier:p,version:v.manifest.version});for(const i of o.translations)e.translations[i.id]=(0,P.join)(v.location.fsPath,i.path)}}updateHash(f){if(f){const v=(0,C.createHash)("md5");for(const p of f.extensions)v.update(p.extensionIdentifier.uuid||p.extensionIdentifier.id).update(p.version);f.hash=v.digest("hex")}}withLanguagePacks(f=()=>null){return this.languagePacksFileLimiter.queue(()=>{let v=null;return c.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,p=>p.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(p)).then(p=>{try{return JSON.parse(p)}catch{return{}}}).then(p=>(v=f(p),p)).then(p=>{for(const o of Object.keys(p))p[o]||delete p[o];this.languagePacks=p,this.initializedCache=!0;const m=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",m),c.Promises.writeFile(this.languagePacksFilePath,m)}).then(()=>v,p=>this.logService.error(p))})}};g=ge([oe(0,w.INativeEnvironmentService),oe(1,y.ILogService)],g)}),define(Y[42],Q([0,1,17,84,34,13,30]),function(j,t,C,D,b,R,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,R.createDecorator)("requestService");function P(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}t.isSuccess=P;function c(E){return E.res.statusCode===204}async function w(E){if(!P(E))throw new Error("Server returned "+E.res.statusCode);return c(E)?null:(await(0,C.streamToBuffer)(E.stream)).toString()}t.asText=w;async function I(E){if(!P(E))throw new Error("Server returned "+E.res.statusCode);if(c(E))return null;const l=(await(0,C.streamToBuffer)(E.stream)).toString();try{return JSON.parse(l)}catch(f){throw f.message+=`:
`+l,f}}t.asJson=I;function L(E){y(E)}t.updateProxyConfigurationsScope=L;let h;function y(E){const g=T.Registry.as(b.Extensions.Configuration),l=h;h={id:"http",order:15,title:(0,D.localize)(0,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(4,null),(0,D.localize)(5,null),(0,D.localize)(6,null),(0,D.localize)(7,null)],default:"override",description:(0,D.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(9,null),restricted:!0}}},g.updateConfigurations({add:[h],remove:l?[l]:[]})}y(2)}),define(Y[113],Q([0,1,24,10,16,42]),function(j,t,C,D,b,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadService=void 0;let T=class{constructor(c,w){this.requestService=c,this.fileService=w}async download(c,w,I=C.CancellationToken.None){if(c.scheme===D.Schemas.file||c.scheme===D.Schemas.vscodeRemote){await this.fileService.copy(c,w);return}const L={type:"GET",url:c.toString()},h=await this.requestService.request(L,I);if(h.res.statusCode===200)await this.fileService.writeFile(w,h.stream);else{const y=await(0,R.asText)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${y}`)}}};T=ge([oe(0,R.IRequestService),oe(1,b.IFileService)],T),t.DownloadService=T}),define(Y[114],Q([0,1,115,6]),function(j,t,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function b(T,P){return T.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:T.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function R(T,P,c={}){const w=(0,C.parse)(T),I=c.proxyUrl||b(w,P);if(!I)return null;const L=(0,C.parse)(I);if(!/^https?:$/.test(L.protocol||""))return null;const h={host:L.hostname||"",port:L.port||(L.protocol==="https"?"443":"80"),auth:L.auth,rejectUnauthorized:(0,D.isBoolean)(c.strictSSL)?c.strictSSL:!0};return w.protocol==="http:"?new(await new Promise((y,E)=>{j(["http-proxy-agent"],y,E)}))(h):new(await new Promise((y,E)=>{j(["https-proxy-agent"],y,E)}))(h)}t.getProxyAgent=R}),define(Y[116],Q([0,1,3,7,2,101,6,65,13]),function(j,t,C,D,b,R,T,P,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const w="__$__targetStorageMarker";t.IStorageService=(0,c.createDecorator)("storageService");var I;(function(l){l[l.NONE=0]="NONE",l[l.SHUTDOWN=1]="SHUTDOWN"})(I=t.WillSaveStateReason||(t.WillSaveStateReason={}));var L;(function(l){l[l.GLOBAL=0]="GLOBAL",l[l.WORKSPACE=1]="WORKSPACE"})(L=t.StorageScope||(t.StorageScope={}));var h;(function(l){l[l.USER=0]="USER",l[l.MACHINE=1]="MACHINE"})(h=t.StorageTarget||(t.StorageTarget={}));class y extends b.Disposable{constructor(f={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super();this.options=f,this._onDidChangeValue=this._register(new D.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new D.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new D.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new C.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new b.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,C.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,b.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(f,v){v===w?(f===0?this._globalKeyTargets=void 0:f===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:f})):this._onDidChangeValue.fire({scope:f,key:v,target:this.getKeyTargets(f)[v]})}emitWillSaveState(f){this._onWillSaveState.fire({reason:f})}get(f,v,p){return this.getStorage(v)?.get(f,p)}getBoolean(f,v,p){return this.getStorage(v)?.getBoolean(f,p)}getNumber(f,v,p){return this.getStorage(v)?.getNumber(f,p)}store(f,v,p,m){if((0,T.isUndefinedOrNull)(v)){this.remove(f,p);return}this.withPausedEmitters(()=>{this.updateKeyTarget(f,p,m),this.getStorage(p)?.set(f,v)})}remove(f,v){this.withPausedEmitters(()=>{this.updateKeyTarget(f,v,void 0),this.getStorage(v)?.delete(f)})}withPausedEmitters(f){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{f()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(f,v){const p=[],m=this.getKeyTargets(f);for(const o of Object.keys(m))m[o]===v&&p.push(o);return p}updateKeyTarget(f,v,p){const m=this.getKeyTargets(v);typeof p=="number"?m[f]!==p&&(m[f]=p,this.getStorage(v)?.set(w,JSON.stringify(m))):typeof m[f]=="number"&&(delete m[f],this.getStorage(v)?.set(w,JSON.stringify(m)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(f){return f===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(f){const v=this.get(w,f);if(v)try{return JSON.parse(v)}catch{}return Object.create(null)}isNew(f){return this.getBoolean(t.IS_NEW_KEY,f)===!0}async flush(f=I.NONE){this._onWillSaveState.fire({reason:f});const v=this.getStorage(0),p=this.getStorage(1);switch(f){case I.NONE:await C.Promises.settled([v?.whenFlushed()??Promise.resolve(),p?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await C.Promises.settled([v?.flush(0)??Promise.resolve(),p?.flush(0)??Promise.resolve()]);break}}async logStorage(){const f=this.getStorage(0)?.items??new Map,v=this.getStorage(1)?.items??new Map;return g(f,v,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=y,y.DEFAULT_FLUSH_INTERVAL=60*1e3;class E extends y{constructor(){super();this.globalStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(f=>this.emitDidChangeValue(1,f))),this._register(this.globalStorage.onDidChangeStorage(f=>this.emitDidChangeValue(0,f)))}getStorage(f){return f===0?this.globalStorage:this.workspaceStorage}getLogDetails(f){return f===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(f){}}t.InMemoryStorageService=E;async function g(l,f,v,p){const m=a=>{try{return JSON.parse(a)}catch{return a}},o=new Map,e=new Map;l.forEach((a,u)=>{o.set(u,a),e.set(u,m(a))});const s=new Map,i=new Map;f.forEach((a,u)=>{s.set(u,a),i.set(u,m(a))}),console.group(`Storage: Global (path: ${v})`);let n=[];o.forEach((a,u)=>{n.push({key:u,value:a})}),console.table(n),console.groupEnd(),console.log(e),console.group(`Storage: Workspace (path: ${p})`);let r=[];s.forEach((a,u)=>{r.push({key:u,value:a})}),console.table(r),console.groupEnd(),console.log(i)}t.logStorage=g}),define(Y[117],Q([0,1,12,29,9,27]),function(j,t,C,D,b,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function T(w){if(C.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function P(w,I,L,h,y,E,g,l,f,v){const p=Object.create(null);p["common.machineId"]=g,p.sessionID=(0,R.generateUuid)()+Date.now(),p.commitHash=y,p.version=E,p["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,C.PlatformToString)(C.platform),p["common.nodePlatform"]=D.platform,p["common.nodeArch"]=h,p["common.product"]=v||"desktop";const m=c(l||[]);m&&(p["common.msftInternal"]=m);let o=0;const e=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>o++,enumerable:!0}}),C.isLinuxSnap&&(p["common.snap"]="true");const s=T(L);s&&(p["common.platformDetail"]=s);try{const i=await w.readFile(b.URI.file(f));p["common.source"]=i.value.toString().slice(0,30)}catch{}return p}t.resolveCommonProperties=P;function c(w){const I=D.env.USERDNSDOMAIN;if(!I)return!1;const L=I.toLowerCase();return w.some(h=>L===h)}t.verifyMicrosoftInternalDomain=c}),define(Y[31],Q([0,1,13]),function(j,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.TELEMETRY_OLD_SETTING_ID=t.TELEMETRY_SETTING_ID=t.TELEMETRY_SECTION_ID=t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,C.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,C.createDecorator)("customEndpointTelemetryService"),t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId",t.TELEMETRY_SECTION_ID="telemetry",t.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",t.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var D;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(D=t.TelemetryLevel||(t.TelemetryLevel={}));var b;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(b=t.TelemetryConfiguration||(t.TelemetryConfiguration={}))}),define(Y[118],Q([0,1,18,3,24,8,7,2,12,6,9,74,23,21,14,32,31]),function(j,t,C,D,b,R,T,P,c,w,I,L,h,y,E,g,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=void 0;let f=class extends P.Disposable{constructor(s,i,n,r){super();this.galleryService=s,this.telemetryService=i,this.logService=n,this.productService=r,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new T.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new T.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new T.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(a=>a.cancel()),this.uninstallingExtensions.forEach(a=>a.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(s){const i=await this.getTargetPlatform();return s.allTargetPlatforms.some(n=>(0,h.isTargetPlatformCompatible)(n,s.allTargetPlatforms,i))}async installFromGallery(s,i={}){try{if(!this.galleryService.isEnabled())throw new h.ExtensionManagementError(L.localize(0,null),h.ExtensionManagementErrorCode.Internal);const n=await this.checkAndGetCompatibleVersion(s,!i.installGivenVersion,!!i.installPreReleaseVersion);return await this.installExtension(n.manifest,n.extension,i)}catch(n){throw m(this.telemetryService,"extensionGallery:install",(0,y.getGalleryExtensionTelemetryData)(s),void 0,n),this.logService.error("Failed to install extension.",s.identifier.id),this.logService.error(n),p(n)}}async uninstall(s,i={}){return this.logService.trace("ExtensionManagementService#uninstall",s.identifier.id),this.unininstallExtension(s,i)}async reinstallFromGallery(s){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",s.identifier.id),!this.galleryService.isEnabled())throw new Error(L.localize(1,null));const i=await this.getTargetPlatform(),[n]=await this.galleryService.getExtensions([{...s.identifier,preRelease:s.preRelease}],{targetPlatform:i,compatible:!0},b.CancellationToken.None);if(!n)throw new Error(L.localize(2,null));await this.createUninstallExtensionTask(s,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(n)}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.extensionsControlManifest||s-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=s),this.extensionsControlManifest}registerParticipant(s){this.participants.push(s)}async installExtension(s,i,n){if(!I.URI.isUri(i)){let S=this.installingExtensions.get(new y.ExtensionIdentifierWithVersion(i.identifier,i.version).key());if(S)return this.logService.info("Extensions is already requested to install",i.identifier.id),S.waitUntilTaskIsFinished();n={...n,installOnlyNewlyAddedFromExtensionPack:!0}}const r=[],a=[],u=this.createInstallExtensionTask(s,i,n);I.URI.isUri(i)||this.installingExtensions.set(new y.ExtensionIdentifierWithVersion(u.identifier,s.version).key(),u),this._onInstallExtension.fire({identifier:u.identifier,source:i}),this.logService.info("Installing extension:",u.identifier.id),r.push({task:u,manifest:s});let d=!1;try{if(n.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",u.identifier.id);else try{const O=await this.getAllDepsAndPackExtensionsToInstall(u.identifier,s,!!n.installOnlyNewlyAddedFromExtensionPack,!!n.installPreReleaseVersion);for(const{gallery:N,manifest:_}of O)if(d=d||!!_.extensionDependencies?.some(J=>(0,y.areSameExtensions)({id:J},u.identifier)),this.installingExtensions.has(new y.ExtensionIdentifierWithVersion(N.identifier,N.version).key()))this.logService.info("Extension is already requested to install",N.identifier.id);else{const J=this.createInstallExtensionTask(_,N,{...n,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new y.ExtensionIdentifierWithVersion(J.identifier,_.version).key(),J),this._onInstallExtension.fire({identifier:J.identifier,source:N}),this.logService.info("Installing extension:",J.identifier.id),r.push({task:J,manifest:_})}}catch(O){if(I.URI.isUri(u.source))(0,C.isNonEmptyArray)(s.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",u.identifier.id,O.message),(0,C.isNonEmptyArray)(s.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",u.identifier.id,O.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",u.identifier.id),O}const S=r.reduce((O,{task:N,manifest:_})=>(O.set(N.identifier.id.toLowerCase(),{task:N,manifest:_}),O),new Map);for(;S.size;){let O;const N=[...S.values()].filter(({manifest:_})=>!_.extensionDependencies?.some(J=>S.has(J.toLowerCase())));N.length?O=S.size===1?N:N.filter(({task:_})=>!(_===u&&!d)):(this.logService.info("Found extensions with circular dependencies",N.map(({task:_})=>_.identifier.id)),O=[...S.values()]),await this.joinAllSettled(O.map(async({task:_})=>{const J=new Date().getTime(),re=(0,w.isUndefined)(n.operation)?_.operation:n.operation;try{const ee=await _.run();if(await this.joinAllSettled(this.participants.map(ie=>ie.postInstall(ee,_.source,n,b.CancellationToken.None))),!I.URI.isUri(_.source)&&(m(this.telemetryService,re===3?"extensionGallery:update":"extensionGallery:install",(0,y.getGalleryExtensionTelemetryData)(_.source),new Date().getTime()-J,void 0),c.isWeb&&re!==3))try{await this.galleryService.reportStatistic(ee.manifest.publisher,ee.manifest.name,ee.manifest.version,"install")}catch{}a.push({local:ee,identifier:_.identifier,operation:re,source:_.source})}catch(ee){throw I.URI.isUri(_.source)||m(this.telemetryService,re===3?"extensionGallery:update":"extensionGallery:install",(0,y.getGalleryExtensionTelemetryData)(_.source),new Date().getTime()-J,ee),this.logService.error("Error while installing the extension:",_.identifier.id),ee}finally{S.delete(_.identifier.id.toLowerCase())}}))}return a.forEach(({identifier:O})=>this.logService.info("Extension installed successfully:",O.id)),this._onDidInstallExtensions.fire(a),a.filter(({identifier:O})=>(0,y.areSameExtensions)(O,u.identifier))[0].local}catch(S){if(r.forEach(({task:O})=>O.cancel()),a.length)try{const O=await Promise.allSettled(a.map(({local:N})=>this.createUninstallExtensionTask(N,{versionOnly:!0}).run()));for(let N=0;N<O.length;N++){const _=O[N],{identifier:J}=a[N];_.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",J.id):this.logService.warn("Rollback: Error while uninstalling extension",J.id,(0,R.getErrorMessage)(_.reason))}}catch(O){this.logService.warn("Error while rolling back extensions",(0,R.getErrorMessage)(O),a.map(({identifier:N})=>N.id))}throw this._onDidInstallExtensions.fire(r.map(({task:O})=>({identifier:O.identifier,operation:2,source:O.source}))),S}finally{for(const{task:S,manifest:O}of r)if(!I.URI.isUri(S.source)){const N=new y.ExtensionIdentifierWithVersion(S.identifier,O.version).key();this.installingExtensions.delete(N)||this.logService.warn("Installation task is not found in the cache",N)}}}async joinAllSettled(s){const i=[],n=[],r=await Promise.allSettled(s);for(const a of r)a.status==="fulfilled"?i.push(a.value):n.push(a.reason);if(n.length)throw v(n);return i}async getAllDepsAndPackExtensionsToInstall(s,i,n,r){if(!this.galleryService.isEnabled())return[];let a=await this.getInstalled();const u=[s,...a.map(O=>O.identifier)],d=[],S=async(O,N)=>{const _=N.extensionDependencies||[],J=[..._];if(N.extensionPack){const re=n?a.find(ee=>(0,y.areSameExtensions)(ee.identifier,O)):void 0;for(const ee of N.extensionPack)re&&re.manifest.extensionPack&&re.manifest.extensionPack.some(ie=>(0,y.areSameExtensions)({id:ie},{id:ee}))||J.every(ie=>!(0,y.areSameExtensions)({id:ie},{id:ee}))&&J.push(ee)}if(J.length){const re=[...u,...d.map(ie=>ie.gallery.identifier)],ee=J.filter(ie=>re.every(he=>!(0,y.areSameExtensions)(he,{id:ie})));if(ee.length){const ie=await this.galleryService.getExtensions(ee.map(he=>({id:he,preRelease:r})),b.CancellationToken.None);for(const he of ie){if(re.find(te=>(0,y.areSameExtensions)(te,he.identifier)))continue;const ue=_.some(te=>(0,y.areSameExtensions)({id:te},he.identifier));let x;try{x=await this.checkAndGetCompatibleVersion(he,!0,r)}catch(te){if(te instanceof h.ExtensionManagementError&&te.code===h.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!ue){this.logService.info("Skipping the packed extension as it cannot be installed",he.identifier.id);continue}else throw te}d.push({gallery:x.extension,manifest:x.manifest}),await S(x.extension.identifier,x.manifest)}}}};return await S(s,i),a=await this.getInstalled(),d.filter(O=>!a.some(N=>(0,y.areSameExtensions)(N.identifier,O.gallery.identifier)))}async checkAndGetCompatibleVersion(s,i,n){const r=await this.getExtensionsControlManifest();if((0,y.getMaliciousExtensionsSet)(r).has(s.identifier.id))throw new h.ExtensionManagementError(L.localize(3,null,s.identifier.id),h.ExtensionManagementErrorCode.Malicious);if(!!r.unsupportedPreReleaseExtensions&&!!r.unsupportedPreReleaseExtensions[s.identifier.id])throw new h.ExtensionManagementError(L.localize(4,null,s.identifier.id,r.unsupportedPreReleaseExtensions[s.identifier.id].displayName),h.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(s)){const d=await this.getTargetPlatform();throw new h.ExtensionManagementError(L.localize(5,null,s.identifier.id,this.productService.nameLong,(0,h.TargetPlatformToString)(d)),h.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const a=await this.getCompatibleVersion(s,i,n);if(a){if(n&&i&&s.hasPreReleaseVersion&&!a.properties.isPreReleaseVersion)throw new h.ExtensionManagementError(L.localize(6,null,s.identifier.id,this.productService.nameLong,this.productService.version),h.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!n&&s.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([s.identifier],b.CancellationToken.None))[0]?new h.ExtensionManagementError(L.localize(7,null,s.identifier.id),h.ExtensionManagementErrorCode.ReleaseVersionNotFound):new h.ExtensionManagementError(L.localize(8,null,s.identifier.id,this.productService.nameLong,this.productService.version),h.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",a.identifier.id);const u=await this.galleryService.getManifest(a,b.CancellationToken.None);if(u===null)throw new h.ExtensionManagementError(`Missing manifest for extension ${s.identifier.id}`,h.ExtensionManagementErrorCode.Invalid);if(u.version!==a.version)throw new h.ExtensionManagementError(`Cannot install '${s.identifier.id}' extension because of version mismatch in Marketplace`,h.ExtensionManagementErrorCode.Invalid);return{extension:a,manifest:u}}async getCompatibleVersion(s,i,n){const r=await this.getTargetPlatform();let a=null;return i&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==n&&(a=(await this.galleryService.getExtensions([{...s.identifier,preRelease:n}],{targetPlatform:r,compatible:!0},b.CancellationToken.None))[0]||null),!a&&await this.galleryService.isExtensionCompatible(s,n,r)&&(a=s),!a&&i&&(a=await this.galleryService.getCompatibleExtension(s,n,r)),a}async unininstallExtension(s,i){const n=this.uninstallingExtensions.get(s.identifier.id.toLowerCase());if(n)return this.logService.info("Extensions is already requested to uninstall",s.identifier.id),n.waitUntilTaskIsFinished();const r=(S,O)=>{const N=this.createUninstallExtensionTask(S,O);return this.uninstallingExtensions.set(N.extension.identifier.id.toLowerCase(),N),this.logService.info("Uninstalling extension:",S.identifier.id),this._onUninstallExtension.fire(S.identifier),N},a=(S,O)=>{O?this.logService.error("Failed to uninstall extension:",S.identifier.id,O.message):this.logService.info("Successfully uninstalled extension:",S.identifier.id),m(this.telemetryService,"extensionGallery:uninstall",(0,y.getLocalExtensionTelemetryData)(S),void 0,O),this._onDidUninstallExtension.fire({identifier:S.identifier,error:O?.code})},u=[],d=[];try{u.push(r(s,{}));const S=await this.getInstalled(1);if(i.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",s.identifier.id);else{const O=this.getAllPackExtensionsToUninstall(s,S);for(const N of O)this.uninstallingExtensions.has(N.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",N.identifier.id):u.push(r(N,{}))}i.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",s.identifier.id):this.checkForDependents(u.map(O=>O.extension),S,s),await this.joinAllSettled(u.map(async O=>{try{if(await O.run(),await this.joinAllSettled(this.participants.map(N=>N.postUninstall(O.extension,i,b.CancellationToken.None))),O.extension.identifier.uuid)try{await this.galleryService.reportStatistic(O.extension.manifest.publisher,O.extension.manifest.name,O.extension.manifest.version,"uninstall")}catch{}a(O.extension)}catch(N){const _=N instanceof h.ExtensionManagementError?N:new h.ExtensionManagementError((0,R.getErrorMessage)(N),h.ExtensionManagementErrorCode.Internal);throw a(O.extension,_),_}finally{d.push(O)}}))}catch(S){const O=S instanceof h.ExtensionManagementError?S:new h.ExtensionManagementError((0,R.getErrorMessage)(S),h.ExtensionManagementErrorCode.Internal);for(const N of u){try{N.cancel()}catch{}d.includes(N)||a(N.extension,O)}throw O}finally{for(const S of u)this.uninstallingExtensions.delete(S.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",S.extension.identifier.id)}}checkForDependents(s,i,n){for(const r of s){const a=this.getDependents(r,i);if(a.length){const u=a.filter(d=>!s.some(S=>(0,y.areSameExtensions)(S.identifier,d.identifier)));if(u.length)throw new Error(this.getDependentsErrorMessage(r,u,n))}}}getDependentsErrorMessage(s,i,n){return n===s?i.length===1?L.localize(9,null,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?L.localize(10,null,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):L.localize(11,null,n.manifest.displayName||n.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?L.localize(12,null,n.manifest.displayName||n.manifest.name,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?L.localize(13,null,n.manifest.displayName||n.manifest.name,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):L.localize(14,null,n.manifest.displayName||n.manifest.name,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}getAllPackExtensionsToUninstall(s,i,n=[]){if(n.indexOf(s)!==-1)return[];n.push(s);const r=s.manifest.extensionPack?s.manifest.extensionPack:[];if(r.length){const a=i.filter(d=>!d.isBuiltin&&r.some(S=>(0,y.areSameExtensions)({id:S},d.identifier))),u=[];for(const d of a)u.push(...this.getAllPackExtensionsToUninstall(d,i,n));return[...a,...u]}return[]}getDependents(s,i){return i.filter(n=>n.manifest.extensionDependencies&&n.manifest.extensionDependencies.some(r=>(0,y.areSameExtensions)({id:r},s.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const s=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",s),s}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};f=ge([oe(0,h.IExtensionGalleryService),oe(1,l.ITelemetryService),oe(2,E.ILogService),oe(3,g.IProductService)],f),t.AbstractExtensionManagementService=f;function v(e){const s=Array.isArray(e)?e:[e];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((i,n)=>new Error(`${i.message}${i.message?",":""}${n instanceof Error?n.message:n}`),new Error(""))}t.joinErrors=v;function p(e){if(e instanceof h.ExtensionManagementError)return e;const s=new h.ExtensionManagementError(e.message,h.ExtensionManagementErrorCode.Internal);return s.stack=e.stack,s}function m(e,s,i,n,r){const a=r?r instanceof h.ExtensionManagementError?r.code:h.ExtensionManagementErrorCode.Internal:void 0;e.publicLogError(s,{...i,success:!r,duration:n,errorcode:a})}t.reportTelemetry=m;class o{constructor(){this.barrier=new D.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,D.createCancelablePromise)(s=>this.doRun(s))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,D.createCancelablePromise)(s=>new Promise((i,n)=>{const r=s.onCancellationRequested(()=>{r.dispose(),n((0,R.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=o}),define(Y[36],Q([0,1,22,6,25,31]),function(j,t,C,D,b,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.getTelemetryLevel=t.supportsTelemetry=t.configurationTelemetry=t.NullAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=t.NullTelemetryServiceShape=void 0;class T{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(f,v){return Promise.resolve(void 0)}publicLog2(f,v){return this.publicLog(f,v)}publicLogError(f,v){return Promise.resolve(void 0)}publicLogError2(f,v){return this.publicLogError(f,v)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}t.NullTelemetryServiceShape=T,t.NullTelemetryService=new T;class P{async publicLog(f,v,p){}async publicLogError(f,v,p){}}t.NullEndpointTelemetryService=P,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function c(l,f){return f.onDidChangeConfiguration(v=>{v.source!==6&&l.publicLog2("updateConfiguration",{configurationSource:(0,b.ConfigurationTargetToString)(v.source),configurationKeys:E(v.sourceConfig)})})}t.configurationTelemetry=c;function w(l,f){return!(f.disableTelemetry||!l.enableTelemetry||f.extensionTestsLocationURI)}t.supportsTelemetry=w;function I(l){const f=l.getValue(R.TELEMETRY_SETTING_ID),v=l.getValue("telemetry.enableCrashReporter");if(l.getValue(R.TELEMETRY_OLD_SETTING_ID)===!1||v===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}t.getTelemetryLevel=I;function L(l){const f=Object.create(null),v=Object.create(null),p=Object.create(null);y(l,p);for(let m in p){m=m.length>150?m.substr(m.length-149):m;const o=p[m];typeof o=="number"?v[m]=o:typeof o=="boolean"?v[m]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${m} has been trimmed to 8192, the original length is ${o.length}`),f[m]=o.substring(0,8191)):typeof o!="undefined"&&o!==null&&(f[m]=o)}return{properties:f,measurements:v}}t.validateTelemetryData=L;function h(l){if(!l)return"none";let f="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(p=>{l.indexOf(`${p}+`)===0&&(f=p)}),f}t.cleanRemoteAuthority=h;function y(l,f,v=0,p){if(!!l)for(let m of Object.getOwnPropertyNames(l)){const o=l[m],e=p?p+m:m;Array.isArray(o)?f[e]=(0,C.safeStringify)(o):o instanceof Date?f[e]=o.toISOString():(0,D.isObject)(o)?v<2?y(o,f,v+1,e+"."):f[e]=(0,C.safeStringify)(o):f[e]=o}}function E(l){if(!l)return[];const f=[];return g(f,"",l),f}function g(l,f,v){v&&typeof v=="object"&&!Array.isArray(v)?Object.keys(v).forEach(p=>g(l,f?`${f}.${p}`:p,v[p])):l.push(f)}}),define(Y[119],Q([0,1,91,36]),function(j,t,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=void 0;async function b(R,T,P,c,w,I){const L={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${T.nameShort})`},h=await(0,C.getServiceMachineId)(P,w,I);return(0,D.supportsTelemetry)(T,P)&&(0,D.getTelemetryLevel)(c)===3&&(L["X-Market-User-Id"]=h),L}t.resolveMarketplaceHeaders=b}),define(Y[120],Q([0,1,18,24,8,22,12,29,6,9,25,20,23,21,48,16,14,32,42,119,116,31]),function(j,t,C,D,b,R,T,P,c,w,I,L,h,y,E,g,l,f,v,p,m,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionGalleryServiceWithNoStorageService=t.ExtensionGalleryService=t.sortExtensionVersions=void 0;const e=T.isWeb?"web":(0,h.getTargetPlatform)(T.platform,P.arch);var s;(function(M){M[M.None=0]="None",M[M.IncludeVersions=1]="IncludeVersions",M[M.IncludeFiles=2]="IncludeFiles",M[M.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",M[M.IncludeSharedAccounts=8]="IncludeSharedAccounts",M[M.IncludeVersionProperties=16]="IncludeVersionProperties",M[M.ExcludeNonValidated=32]="ExcludeNonValidated",M[M.IncludeInstallationTargets=64]="IncludeInstallationTargets",M[M.IncludeAssetUri=128]="IncludeAssetUri",M[M.IncludeStatistics=256]="IncludeStatistics",M[M.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",M[M.Unpublished=4096]="Unpublished",M[M.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function i(...M){return String(M.reduce((A,V)=>A|V,0))}var n;(function(M){M[M.Tag=1]="Tag",M[M.ExtensionId=4]="ExtensionId",M[M.Category=5]="Category",M[M.ExtensionName=7]="ExtensionName",M[M.Target=8]="Target",M[M.Featured=9]="Featured",M[M.SearchText=10]="SearchText",M[M.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},d={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class S{constructor(A=d){this.state=A}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(A,V=this.state.pageSize){return new S({...this.state,pageNumber:A,pageSize:V})}withFilter(A,...V){const B=[...this.state.criteria,...V.length?V.map(H=>({filterType:A,value:H})):[{filterType:A}]];return new S({...this.state,criteria:B})}withSortBy(A){return new S({...this.state,sortBy:A})}withSortOrder(A){return new S({...this.state,sortOrder:A})}withFlags(...A){return new S({...this.state,flags:A.reduce((V,B)=>V|B,0)})}withAssetTypes(...A){return new S({...this.state,assetTypes:A})}get raw(){const{criteria:A,pageNumber:V,pageSize:B,sortBy:H,sortOrder:X,flags:ae,assetTypes:ce}=this.state;return{filters:[{criteria:A,pageNumber:V,pageSize:B,sortBy:H,sortOrder:X}],assetTypes:ce,flags:ae}}get searchText(){const A=this.state.criteria.filter(V=>V.filterType===n.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(A=>String(A.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function O(M,A){const V=(M||[]).filter(B=>B.statisticName===A)[0];return V?V.value:0}function N(M){const A="Microsoft.VisualStudio.Code.Translation.";return M.files.filter(B=>B.assetType.indexOf(A)===0).reduce((B,H)=>{const X=ee(M,H.assetType);return X&&B.push([H.assetType.substring(A.length),X]),B},[])}function _(M){if(M.properties){const A=M.properties.filter(H=>H.key===r.Repository),V=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),B=A.filter(H=>V.test(H.value))[0];return B?{uri:B.value,fallbackUri:B.value}:null}return ee(M,r.Repository)}function J(M){return{uri:`${M.fallbackAssetUri}/${r.VSIX}?redirect=true${M.targetPlatform?`&targetPlatform=${M.targetPlatform}`:""}`,fallbackUri:`${M.fallbackAssetUri}/${r.VSIX}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`}}function re(M){const A=ee(M,r.Icon);if(A)return A;const V=h.DefaultIconPath;return{uri:V,fallbackUri:V}}function ee(M,A){return M.files.filter(B=>B.assetType===A)[0]?{uri:`${M.assetUri}/${A}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`,fallbackUri:`${M.fallbackAssetUri}/${A}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`}:null}function ie(M,A){const V=M.properties?M.properties.filter(H=>H.key===A):[],B=V.length>0&&V[0].value;return B?B.split(",").map(H=>(0,y.adoptToGalleryExtensionId)(H)):[]}function he(M){const A=M.properties?M.properties.filter(V=>V.key===a.Engine):[];return A.length>0&&A[0].value||""}function ue(M){const A=M.properties?M.properties.filter(V=>V.key===a.PreRelease):[];return A.length>0&&A[0].value==="true"}function x(M){const A=M.properties?M.properties.filter(B=>B.key===a.LocalizedLanguages):[],V=A.length>0&&A[0].value||"";return V?V.split(","):[]}function te(M){return M.indexOf("preview")!==-1}function U(M){return M.targetPlatform?(0,h.toTargetPlatform)(M.targetPlatform):"undefined"}function k(M){const A=(0,C.distinct)(M.versions.map(U)),V=!!M.tags?.includes(h.WEB_EXTENSION_TAG),B=A.indexOf("web");return V?B===-1&&A.push("web"):B!==-1&&A.splice(B,1),A}function z(M,A){const V=(0,h.getFallbackTargetPlarforms)(A);for(let B=0;B<M.length;B++){const H=M[B];if(H.version===M[B-1]?.version){let X=B;const ae=U(H);if(ae===A)for(;X>0&&M[X-1].version===H.version;)X--;else if(V.includes(ae))for(;X>0&&M[X-1].version===H.version&&U(M[X-1])!==A;)X--;X!==B&&(M.splice(B,1),M.splice(X,0,H))}}return M}t.sortExtensionVersions=z;function G(M,A,V){M.telemetryData={index:A,querySource:V}}function ne(M,A,V){const B=M.versions[0],H={manifest:ee(A,r.Manifest),readme:ee(A,r.Details),changelog:ee(A,r.Changelog),license:ee(A,r.License),repository:_(A),download:J(A),icon:re(A),coreTranslations:N(A)};return{identifier:{id:(0,y.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},name:M.extensionName,version:A.version,displayName:M.displayName,publisherId:M.publisher.publisherId,publisher:M.publisher.publisherName,publisherDisplayName:M.publisher.displayName,publisherDomain:M.publisher.domain?{link:M.publisher.domain,verified:!!M.publisher.isDomainVerified}:void 0,description:M.shortDescription||"",installCount:O(M.statistics,"install"),rating:O(M.statistics,"averagerating"),ratingCount:O(M.statistics,"ratingcount"),categories:M.categories||[],tags:M.tags||[],releaseDate:Date.parse(M.releaseDate),lastUpdated:Date.parse(M.lastUpdated),allTargetPlatforms:V,assets:H,properties:{dependencies:ie(A,a.Dependency),extensionPack:ie(A,a.ExtensionPack),engine:he(A),localizedLanguages:x(A),targetPlatform:U(A),isPreReleaseVersion:ue(A)},hasPreReleaseVersion:ue(B),hasReleaseVersion:!0,preview:te(M.flags)}}let K=class{constructor(A,V,B,H,X,ae,ce,we){this.requestService=V,this.logService=B,this.environmentService=H,this.telemetryService=X,this.fileService=ae,this.productService=ce,this.configurationService=we;const fe=ce.extensionsGallery;this.extensionsGalleryUrl=fe&&fe.serviceUrl,this.extensionsControlUrl=fe&&fe.controlUrl,this.commonHeadersPromise=(0,p.resolveMarketplaceHeaders)(ce.version,ce,this.environmentService,this.configurationService,this.fileService,A)}api(A=""){return`${this.extensionsGalleryUrl}${A}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(A,V,B){const H=D.CancellationToken.isCancellationToken(V)?{}:V,X=D.CancellationToken.isCancellationToken(V)?V:B,ae=[],ce=[],we=[],fe=[];let se=!0;for(const Ee of A){Ee.uuid?ce.push(Ee.uuid):ae.push(Ee.id);const Ie=!!(Ee.version||Ee.preRelease);we.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Ie}),Ee.version&&fe.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),se=se&&!!Ee.hasPreRelease&&!Ie}if(!ce.length&&!ae.length)return[];let pe=new S().withPage(1,A.length);ce.length&&(pe=pe.withFilter(n.ExtensionId,...ce)),ae.length&&(pe=pe.withFilter(n.ExtensionName,...ae)),(H.queryAllVersions||se)&&(pe=pe.withFlags(pe.flags,s.IncludeVersions));const{extensions:me}=await this.queryGalleryExtensions(pe,{targetPlatform:H.targetPlatform??e,includePreRelease:we,versions:fe,compatible:!!H.compatible},X);return H.source&&me.forEach((Ee,Ie)=>G(Ee,Ie,H.source)),me}async getCompatibleExtension(A,V,B){if((0,h.isNotWebExtensionInWebTargetPlatform)(A.allTargetPlatforms,B))return null;if(await this.isExtensionCompatible(A,V,B))return A;const H=new S().withFlags(s.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,A.identifier.uuid),{extensions:X}=await this.queryGalleryExtensions(H,{targetPlatform:B,compatible:!0,includePreRelease:V},D.CancellationToken.None);return X[0]||null}async isExtensionCompatible(A,V,B){if(!(0,h.isTargetPlatformCompatible)(A.properties.targetPlatform,A.allTargetPlatforms,B)||!V&&A.properties.isPreReleaseVersion)return!1;let H=A.properties.engine;if(!H){const X=await this.getManifest(A,D.CancellationToken.None);if(!X)throw new Error("Manifest was not found");H=X.engines.vscode}return(0,E.isEngineValid)(H,this.productService.version,this.productService.date)}async isValidVersion(A,V,B,H,X){if(!(0,h.isTargetPlatformCompatible)(U(A),H,X)||V!=="any"&&ue(A)!==(V==="prerelease"))return!1;if(B){const ae=await this.getEngine(A);if(!(0,E.isEngineValid)(ae,this.productService.version,this.productService.date))return!1}return!0}async query(A,V){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let B=A.text||"";const H=(0,R.getOrDefault)(A,se=>se.pageSize,50);let X=new S().withPage(1,H);B?(B=B.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(se,pe,me)=>(X=X.withFilter(n.Category,me||pe),"")),B=B.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(se,pe,me)=>(X=X.withFilter(n.Tag,me||pe),"")),B=B.replace(/\bfeatured(\s+|\b|$)/g,()=>(X=X.withFilter(n.Featured),"")),B=B.trim(),B&&(B=B.length<200?B:B.substring(0,200),X=X.withFilter(n.SearchText,B)),X=X.withSortBy(0)):A.ids?X=X.withFilter(n.ExtensionId,...A.ids):A.names?X=X.withFilter(n.ExtensionName,...A.names):X=X.withSortBy(4),typeof A.sortBy=="number"&&(X=X.withSortBy(A.sortBy)),typeof A.sortOrder=="number"&&(X=X.withSortOrder(A.sortOrder));const ae=async(se,pe)=>{const{extensions:me,total:Ee}=await this.queryGalleryExtensions(se,{targetPlatform:e,compatible:!1,includePreRelease:!!A.includePreRelease},pe);return me.forEach((Ie,Me)=>G(Ie,(se.pageNumber-1)*se.pageSize+Me,A.source)),{extensions:me,total:Ee}},{extensions:ce,total:we}=await ae(X,V),fe=async(se,pe)=>{if(pe.isCancellationRequested)throw new b.CancellationError;const{extensions:me}=await ae(X.withPage(se+1),pe);return me};return{firstPage:ce,total:we,pageSize:X.pageSize,getPage:fe}}async queryGalleryExtensions(A,V,B){const H=A.flags;!!(A.flags&s.IncludeLatestVersionOnly)&&!!(A.flags&s.IncludeVersions)&&(A=A.withFlags(A.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(A.flags&s.IncludeLatestVersionOnly)&&!(A.flags&s.IncludeVersions)&&(A=A.withFlags(A.flags,s.IncludeLatestVersionOnly)),V.versions?.length&&(A=A.withFlags(A.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),A=A.withFlags(A.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:X,total:ae}=await this.queryRawGalleryExtensions(A,B);if(!(A.flags&s.IncludeLatestVersionOnly)){const se=[];for(const pe of X){const me=await this.toGalleryExtensionWithCriteria(pe,V,!0);me&&se.push(me)}return{extensions:se,total:ae}}const we=[],fe=new Map;for(let se=0;se<X.length;se++){const pe=X[se],me={id:(0,y.getGalleryExtensionId)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},Ee=(0,c.isBoolean)(V.includePreRelease)?V.includePreRelease:!!V.includePreRelease.find(Me=>(0,y.areSameExtensions)(Me,me))?.includePreRelease;let Ie=await this.toGalleryExtensionWithCriteria(pe,V,!1);!Ie||Ie.properties.isPreReleaseVersion&&(!Ee||!Ie.hasReleaseVersion)||!Ie.properties.isPreReleaseVersion&&Ie.properties.targetPlatform!==V.targetPlatform&&Ie.hasPreReleaseVersion?fe.set(pe.extensionId,se):we.push([se,Ie])}if(fe.size){const se=new Date().getTime(),pe=new S().withFlags(H&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,fe.size).withFilter(n.ExtensionId,...fe.keys()),{extensions:me}=await this.queryGalleryExtensions(pe,V,B);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-se,count:fe.size});for(const Ee of me){const Ie=fe.get(Ee.identifier.uuid);we.push([Ie,Ee])}}return{extensions:we.sort((se,pe)=>se[0]-pe[0]).map(([,se])=>se),total:ae}}async toGalleryExtensionWithCriteria(A,V,B){const H={id:(0,y.getGalleryExtensionId)(A.publisher.publisherName,A.extensionName),uuid:A.extensionId},X=V.versions?.find(fe=>(0,y.areSameExtensions)(fe,H))?.version,ae=(0,c.isBoolean)(V.includePreRelease)?V.includePreRelease:!!V.includePreRelease.find(fe=>(0,y.areSameExtensions)(fe,H))?.includePreRelease,ce=k(A),we=z(A.versions,V.targetPlatform);if(V.compatible&&B&&(0,h.isNotWebExtensionInWebTargetPlatform)(ce,V.targetPlatform))return null;for(let fe=0;fe<we.length;fe++){const se=we[fe];if(!(X&&se.version!==X)){if(await this.isValidVersion(se,ae?"any":"release",V.compatible,ce,V.targetPlatform))return ne(A,se,ce);if(X&&se.version===X)return null}}return X||V.compatible?null:ne(A,A.versions[0],ce)}async queryRawGalleryExtensions(A,V){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,s.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(s.Unpublished));const B=await this.commonHeadersPromise,H=JSON.stringify(A.raw),X={...B,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(H.length)},ae=new Date().getTime();let ce,we,fe=0;try{if(ce=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:H,headers:X},V),ce.res.statusCode&&ce.res.statusCode>=400&&ce.res.statusCode<500)return{galleryExtensions:[],total:fe};const se=await(0,v.asJson)(ce);if(se){const pe=se.results[0],me=pe.extensions,Ee=pe.resultMetadata&&pe.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return fe=Ee&&Ee.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:me,total:fe}}return{galleryExtensions:[],total:fe}}catch(se){throw we=se,se}finally{this.telemetryService.publicLog2("galleryService:query",{...A.telemetryData,requestBodySize:String(H.length),duration:new Date().getTime()-ae,success:!!ce&&(0,v.isSuccess)(ce),responseBodySize:ce?.res.headers["Content-Length"],statusCode:ce?String(ce.res.statusCode):void 0,errorCode:we?(0,b.isCancellationError)(we)?"canceled":(0,b.getErrorMessage)(we).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(fe)})}}async reportStatistic(A,V,B,H){if(!this.isEnabled())return;const X=T.isWeb?this.api(`/itemName/${A}.${V}/version/${B}/statType/${H==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${A}/extensions/${V}/${B}/stats?statType=${H}`),ae=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",we={...await this.commonHeadersPromise,Accept:ae};try{await this.requestService.request({type:"POST",url:X,headers:we},D.CancellationToken.None)}catch{}}async download(A,V,B){this.logService.trace("ExtensionGalleryService#download",A.identifier.id);const H=(0,y.getGalleryExtensionTelemetryData)(A),X=new Date().getTime(),ae=se=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...H,duration:se}),ce=B===2?"install":B===3?"update":"",we=ce?{uri:`${A.assets.download.uri}${w.URI.parse(A.assets.download.uri).query?"&":"?"}${ce}=true`,fallbackUri:`${A.assets.download.fallbackUri}${w.URI.parse(A.assets.download.fallbackUri).query?"&":"?"}${ce}=true`}:A.assets.download,fe=await this.getAsset(we);await this.fileService.writeFile(V,fe.stream),ae(new Date().getTime()-X)}async getReadme(A,V){if(A.assets.readme){const B=await this.getAsset(A.assets.readme,{},V);return await(0,v.asText)(B)||""}return""}async getManifest(A,V){if(A.assets.manifest){const B=await this.getAsset(A.assets.manifest,{},V),H=await(0,v.asText)(B);return H?JSON.parse(H):null}return null}async getManifestFromRawExtensionVersion(A,V){const B=ee(A,r.Manifest);if(!B)throw new Error("Manifest was not found");const H={"Accept-Encoding":"gzip"},X=await this.getAsset(B,{headers:H});return await(0,v.asJson)(X)}async getCoreTranslation(A,V){const B=A.assets.coreTranslations.filter(H=>H[0]===V.toUpperCase())[0];if(B){const H=await this.getAsset(B[1]),X=await(0,v.asText)(H);return X?JSON.parse(X):null}return null}async getChangelog(A,V){if(A.assets.changelog){const B=await this.getAsset(A.assets.changelog,{},V);return await(0,v.asText)(B)||""}return""}async getAllCompatibleVersions(A,V,B){let H=new S().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);A.identifier.uuid?H=H.withFilter(n.ExtensionId,A.identifier.uuid):H=H.withFilter(n.ExtensionName,A.identifier.id);const{galleryExtensions:X}=await this.queryRawGalleryExtensions(H,D.CancellationToken.None);if(!X.length)return[];const ae=k(X[0]);if((0,h.isNotWebExtensionInWebTargetPlatform)(ae,B))return[];const ce=[],we=new Set;return await Promise.all(X[0].versions.map(async fe=>{try{if(we.has(fe.version))return;await this.isValidVersion(fe,V?"any":"release",!0,ae,B)&&(ce.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:ue(fe)}),we.add(fe.version))}catch{}})),ce}async getAsset(A,V={},B=D.CancellationToken.None){const H=await this.commonHeadersPromise,X={type:"GET"},ae={...H,...V.headers||{}};V={...V,...X,headers:ae};const ce=A.uri,we=A.fallbackUri,fe={...V,url:ce};try{const se=await this.requestService.request(fe,B);if(se.res.statusCode===200)return se;const pe=await(0,v.asText)(se);throw new Error(`Expected 200, got back ${se.res.statusCode} instead.

${pe}`)}catch(se){if((0,b.isCancellationError)(se))throw se;const pe=(0,b.getErrorMessage)(se);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ce,message:pe});const me={...V,url:we};return this.requestService.request(me,B)}}async getEngine(A){let V=he(A);if(!V){const B=await this.getManifestFromRawExtensionVersion(A,D.CancellationToken.None);if(!B)throw new Error("Manifest was not found");V=B.engines.vscode}return V}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const A=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},D.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const V=await(0,v.asJson)(A),B=[],H={};if(V){for(const X of V.malicious)B.push({id:X});if(V.unsupported)for(const X of Object.keys(V.unsupported)){const ae=V.unsupported[X];(0,c.isBoolean)(ae)||(H[X.toLowerCase()]=ae.preReleaseExtension)}if(V.migrateToPreRelease)for(const[X,ae]of Object.entries(V.migrateToPreRelease))(!ae.engine||(0,E.isEngineValid)(ae.engine,this.productService.version,this.productService.date))&&(H[X.toLowerCase()]=ae)}return{malicious:B,unsupportedPreReleaseExtensions:H}}};K=ge([oe(1,v.IRequestService),oe(2,l.ILogService),oe(3,L.IEnvironmentService),oe(4,o.ITelemetryService),oe(5,g.IFileService),oe(6,f.IProductService),oe(7,I.IConfigurationService)],K);let Z=class extends K{constructor(A,V,B,H,X,ae,ce,we){super(A,V,B,H,X,ae,ce,we)}};Z=ge([oe(0,m.IStorageService),oe(1,v.IRequestService),oe(2,l.ILogService),oe(3,L.IEnvironmentService),oe(4,o.ITelemetryService),oe(5,g.IFileService),oe(6,f.IProductService),oe(7,I.IConfigurationService)],Z),t.ExtensionGalleryService=Z;let q=class extends K{constructor(A,V,B,H,X,ae,ce){super(void 0,A,V,B,H,X,ae,ce)}};q=ge([oe(0,v.IRequestService),oe(1,l.ILogService),oe(2,L.IEnvironmentService),oe(3,o.ITelemetryService),oe(4,g.IFileService),oe(5,f.IProductService),oe(6,I.IConfigurationService)],q),t.ExtensionGalleryServiceWithNoStorageService=q}),define(Y[121],Q([0,1,2,22,12,26,85,25,34,122,30,31,36]),function(j,t,C,D,b,R,T,P,c,w,I,L,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let y=class{constructor(l,f){this._configurationService=f,this._experimentProperties={},this._disposables=new C.DisposableStore,this._cleanupPatterns=[],this._appenders=l.appenders,this._commonProperties=l.commonProperties||Promise.resolve({}),this._piiPaths=l.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!l.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let v of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(v),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(l,f){this._experimentProperties[l]=f}_updateTelemetryLevel(){this._telemetryLevel=(0,h.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const l=await this._commonProperties;let f=l.sessionID,v=l["common.machineId"],p=l["common.firstSessionDate"],m=l["common.msftInternal"];return{sessionId:f,machineId:v,firstSessionDate:p,msftInternal:m}}dispose(){this._disposables.dispose()}_log(l,f,v,p){return this.telemetryLevel<f?Promise.resolve(void 0):this._commonProperties.then(m=>{v=(0,D.mixin)(v,m),v=(0,D.mixin)(v,this._experimentProperties),v=(0,D.cloneAndChange)(v,o=>{if(typeof o=="string")return this._cleanupInfo(o,p)}),this._appenders.forEach(o=>o.log(l,v))},m=>{console.error(m)})}publicLog(l,f,v){return this._log(l,3,f,v)}publicLog2(l,f,v){return this.publicLog(l,f,v)}publicLogError(l,f){return this.sendErrorTelemetry?this._log(l,2,f,!0):Promise.resolve(void 0)}publicLogError2(l,f){return this.publicLogError(l,f)}_anonymizeFilePaths(l){let f=l;const v=[];for(let e of this._cleanupPatterns)for(;;){const s=e.exec(l);if(!s)break;v.push([s.index,e.lastIndex])}const p=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,m=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(f="";;){const e=m.exec(l);if(!e)break;!p.test(e[0])&&v.every(([s,i])=>e.index<s||e.index>=i)&&(f+=l.substring(o,e.index)+"<REDACTED: user-file-path>",o=m.lastIndex)}return o<l.length&&(f+=l.substr(o)),f}_removePropertiesWithPossibleUserInfo(l){if(!l)return l;const f=l.toLowerCase(),v=/@[a-zA-Z0-9-.]+/,p=/(key|token|sig|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/,m=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return p.test(f)?"<REDACTED: secret>":v.test(f)?"<REDACTED: email>":m.test(f)?"<REDACTED: token>":l}_cleanupInfo(l,f){let v=l;f&&(v=this._anonymizeFilePaths(v));for(let p of this._cleanupPatterns)v=v.replace(p,"");return v=this._removePropertiesWithPossibleUserInfo(v),v}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=ge([oe(1,P.IConfigurationService)],y),t.TelemetryService=y;function E(){const g=(0,T.localize)(0,null,w.default.nameLong),l=w.default.privacyStatementUrl?(0,T.localize)(2,null,"https://aka.ms/vscode-telemetry",w.default.privacyStatementUrl):(0,T.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=b.isWeb?"":(0,T.localize)(3,null),v=(0,T.localize)(4,null),p=(0,T.localize)(5,null),m=(0,T.localize)(6,null),o=(0,T.localize)(7,null),e=`
|       | ${v} | ${p} | ${m} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,T.localize)(8,null);return`
${g} ${l} ${f}

&nbsp;

${o}
${e}

&nbsp;

${s}
`}I.Registry.as(c.Extensions.Configuration).registerConfiguration({id:L.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(9,null),properties:{[L.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,T.localize)(10,null),(0,T.localize)(11,null),(0,T.localize)(12,null),(0,T.localize)(13,null)],markdownDescription:E(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),I.Registry.as(c.Extensions.Configuration).registerConfiguration({id:L.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(14,null),properties:{[L.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:w.default.privacyStatementUrl?(0,T.localize)(16,null,w.default.nameLong,w.default.privacyStatementUrl):(0,T.localize)(15,null,w.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(17,null,`\`#${L.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Y[123],Q([0,1,8,22,36]),function(j,t,C,D,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function R(P,c){const w=await new Promise((L,h)=>{j(["applicationinsights"],L,h)});let I;return w.defaultClient?(I=new w.TelemetryClient(P),I.channel.setUseDiskRetryCaching(!0)):(w.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),I=w.defaultClient),P.indexOf("AIF-")===0&&(I.config.endpointUrl=c?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),I}class T{constructor(c,w,I,L,h){this._eventPrefix=c,this._defaultData=w,this.testCollector=L,this.mirrored=h,this._defaultData||(this._defaultData=Object.create(null)),typeof I=="function"?this._aiClient=I():this._aiClient=I,this._asyncAIClient=null}_withAIClient(c){if(!!this._aiClient){if(typeof this._aiClient!="string"){c(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=R(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(w=>{c(w)},w=>{(0,C.onUnexpectedError)(w),console.error(w)})}}log(c,w){if(!!this._aiClient){w=(0,D.mixin)(w,this._defaultData),w=(0,b.validateTelemetryData)(w),this.testCollector&&(w.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++");try{this._withAIClient(I=>I.trackEvent({name:this._eventPrefix+"/"+c,properties:w.properties,measurements:w.measurements}))}catch{}}}flush(){return this._aiClient?new Promise(c=>{this._withAIClient(w=>{try{w.flush({callback:()=>{this._aiClient=void 0,c(void 0)}})}catch{}})}):Promise.resolve(void 0)}}t.AppInsightsAppender=T}),define(Y[124],Q([0,1,11,15]),function(j,t,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function b(R,T){const P=Object.create(null),c=(I,L)=>{const h=JSON.parse(I);P[L]=h};if(T){const I=[],L=await D.Promises.readdir(T);for(const y of L)try{(await D.Promises.stat((0,C.join)(T,y))).isDirectory()&&I.push(y)}catch{}const h=[];for(const y of I)(await D.Promises.readdir((0,C.join)(T,y))).filter(g=>g==="telemetry.json").length===1&&h.push(y);for(const y of h){const E=(await D.Promises.readFile((0,C.join)(T,y,"telemetry.json"))).toString();c(E,y)}}let w=(await D.Promises.readFile((0,C.join)(R,"telemetry-core.json"))).toString();return c(w,"vscode-core"),w=(await D.Promises.readFile((0,C.join)(R,"telemetry-extensions.json"))).toString(),c(w,"vscode-extensions"),JSON.stringify(P,null,4)}t.buildTelemetryMessage=b}),define(Y[125],Q([0,1,39,11,86,24,28,8,12,27,70,138,3]),function(j,t,C,D,b,R,T,P,c,w,I,L,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getResolvedShellEnv=void 0;const y=1e4;let E;async function g(f,v,p){return v["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):c.isWindows?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,L.isLaunchedFromCli)(p)&&!v["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,L.isLaunchedFromCli)(p)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),E||(E=h.Promises.withAsyncBody(async(m,o)=>{const e=new R.CancellationTokenSource,s=setTimeout(()=>{e.dispose(!0),o(new Error((0,b.localize)(0,null)))},y);try{m(await l(f,e.token))}catch(i){!(0,P.isCancellationError)(i)&&!e.token.isCancellationRequested?o(new Error((0,b.localize)(1,null,(0,T.toErrorMessage)(i)))):m({})}finally{clearTimeout(s),e.dispose()}})),E)}t.getResolvedShellEnv=g;async function l(f,v){const p=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",p);const m=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",m);const o=(0,w.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(o+"(.*)"+o),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};f.trace("getUnixShellEnvironment#env",s);const i=await(0,I.getSystemShell)(c.OS,s);return f.trace("getUnixShellEnvironment#shell",i),new Promise((n,r)=>{if(v.isCancellationRequested)return r((0,P.canceled)());const a=(0,D.basename)(i);let u,d;const S=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(u=`& '${process.execPath}' ${S} -p '''${o}'' + JSON.stringify(process.env) + ''${o}'''`,d=["-Login","-Command"]):(u=`'${process.execPath}' ${S} -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,a==="tcsh"?d=["-ic"]:d=["-ilc"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(d),u);const O=(0,C.spawn)(i,[...d,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});v.onCancellationRequested(()=>(O.kill(),r((0,P.canceled)()))),O.on("error",J=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(J)),r(J)});const N=[];O.stdout.on("data",J=>N.push(J));const _=[];O.stderr.on("data",J=>_.push(J)),O.on("close",(J,re)=>{const ee=Buffer.concat(N).toString("utf8");f.trace("getUnixShellEnvironment#raw",ee);const ie=Buffer.concat(_).toString("utf8");if(ie.trim()&&f.trace("getUnixShellEnvironment#stderr",ie),J||re)return r(new Error((0,b.localize)(2,null,J,re)));const he=e.exec(ee),ue=he?he[1]:"{}";try{const x=JSON.parse(ue);p?x.ELECTRON_RUN_AS_NODE=p:delete x.ELECTRON_RUN_AS_NODE,m?x.ELECTRON_NO_ATTACH_CONSOLE=m:delete x.ELECTRON_NO_ATTACH_CONSOLE,delete x.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",x),n(x)}catch(x){f.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(x)),r(x)}})})}}),define(Y[37],Q([0,1,13]),function(j,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IUriIdentityService=void 0,t.IUriIdentityService=(0,C.createDecorator)("IUriIdentityService")}),define(Y[126],Q([0,1,7,2,9,20,21,16,14,37]),function(j,t,C,D,b,R,T,P,c,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let I=class extends D.Disposable{constructor(h,y,E,g,l){super();this.extensionsManagementService=h,this.logService=g,this.uriIdentityService=l,this._onDidChangeExtensionsByAnotherSource=this._register(new C.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(v=>{this.installedExtensions=v.map(p=>p.identifier),this.startTimestamp=Date.now()}),this._register(h.onInstallExtension(v=>this.onInstallExtension(v))),this._register(h.onDidInstallExtensions(v=>this.onDidInstallExtensions(v))),this._register(h.onDidUninstallExtension(v=>this.onDidUninstallExtension(v)));const f=b.URI.file(E.extensionsPath);this._register(y.watch(f)),this._register(C.Event.filter(y.onDidFilesChange,v=>v.rawChanges.some(p=>this.doesChangeAffects(p,f)))(()=>this.onDidChange()))}doesChangeAffects(h,y){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(h.resource),y)?this.uriIdentityService.extUri.isEqual(h.resource,this.uriIdentityService.extUri.joinPath(y,".obsolete"))?!0:!(h.type!==1&&h.type!==2||this.uriIdentityService.extUri.basename(h.resource).startsWith(".")):!1}onInstallExtension(h){this.addInstallingExtension(h.identifier)}onDidInstallExtensions(h){for(const y of h)this.removeInstallingExtension(y.identifier),y.local&&this.addInstalledExtension(y.identifier)}onDidUninstallExtension(h){h.error||this.removeInstalledExtension(h.identifier)}addInstallingExtension(h){this.removeInstallingExtension(h),this.installingExtensions.push(h)}removeInstallingExtension(h){this.installingExtensions=this.installingExtensions.filter(y=>!(0,T.areSameExtensions)(y,h))}addInstalledExtension(h){this.installedExtensions&&(this.removeInstalledExtension(h),this.installedExtensions.push(h))}removeInstalledExtension(h){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(y=>!(0,T.areSameExtensions)(y,h)))}async onDidChange(){if(this.installedExtensions){const h=await this.extensionsManagementService.getInstalled(1),y=h.filter(g=>[...this.installingExtensions,...this.installedExtensions].some(l=>(0,T.areSameExtensions)(l,g.identifier))?!1:g.installedTimestamp&&g.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",g.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",g.identifier.id),!1)),E=this.installedExtensions.filter(g=>this.installingExtensions.some(l=>(0,T.areSameExtensions)(l,g))?!1:h.every(l=>!(0,T.areSameExtensions)(l.identifier,g))?(this.logService.info("Detected extension removed from another source",g.id),!0):!1);this.installedExtensions=h.map(g=>g.identifier),(y.length||E.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:y,removed:E})}}};I=ge([oe(1,P.IFileService),oe(2,R.INativeEnvironmentService),oe(3,c.ILogService),oe(4,w.IUriIdentityService)],I),t.ExtensionsWatcher=I}),define(Y[127],Q([0,1,37,92,16,19,58,7,2]),function(j,t,C,D,b,R,T,P,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UriIdentityService=void 0;class w{constructor(h){this.uri=h,this.time=w._clock++}touch(){return this.time=w._clock++,this}}w._clock=0;let I=class{constructor(h){this._fileService=h,this._dispooables=new c.DisposableStore,this._limit=2**16;const y=new Map,E=g=>{let l=y.get(g.scheme);return l===void 0&&(l=h.hasProvider(g)&&!this._fileService.hasCapability(g,1024),y.set(g.scheme,l)),l};this._dispooables.add(P.Event.any(h.onDidChangeFileSystemProviderRegistrations,h.onDidChangeFileSystemProviderCapabilities)(g=>{y.delete(g.scheme)})),this.extUri=new R.ExtUri(E),this._canonicalUris=new T.SkipList((g,l)=>this.extUri.compare(g,l,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(h){this._fileService.hasProvider(h)&&(h=(0,R.normalizePath)(h));let y=this._canonicalUris.get(h);return y?y.touch().uri.with({fragment:h.fragment}):(this._canonicalUris.set(h,new w(h)),this._checkTrim(),h)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const h=[...this._canonicalUris.entries()].sort((E,g)=>E[1].touch<g[1].touch?1:E[1].touch>g[1].touch?-1:0);w._clock=0,this._canonicalUris.clear();const y=this._limit*.5;for(let E=0;E<y;E++)this._canonicalUris.set(h[E][0],h[E][1].touch())}};I=ge([oe(0,b.IFileService)],I),t.UriIdentityService=I,(0,D.registerSingleton)(C.IUriIdentityService,I,!0)}),define(Y[43],Q([0,1,103,3,11,6,15,72,139,140]),function(j,t,C,D,b,R,T,P,c,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class I extends Error{constructor(e,s){let i=s.message;switch(e){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=e,this.cause=s}}t.ExtractError=I;function L(o){const e=o.externalFileAttributes>>16||33188;return[448,56,7].map(s=>e&s).reduce((s,i)=>s+i,e&61440)}function h(o){if(o instanceof I)return o;let e;return/end of central directory record signature not found/.test(o.message)&&(e="CorruptZip"),new I(e,o)}function y(o,e,s,i,n,r){const a=b.dirname(e),u=b.join(i,a);if(!u.startsWith(i))return Promise.reject(new Error(P.localize(0,null,e)));const d=b.join(i,e);let S;return r.onCancellationRequested(()=>{S&&S.destroy()}),Promise.resolve(T.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((O,N)=>{if(!r.isCancellationRequested)try{S=(0,C.createWriteStream)(d,{mode:s}),S.once("close",()=>O()),S.once("error",N),o.once("error",N),o.pipe(S)}catch(_){N(_)}}))}function E(o,e,s,i){let n=(0,D.createCancelablePromise)(()=>Promise.resolve()),r=0;return i.onCancellationRequested(()=>{n.cancel(),o.close()}),new Promise((a,u)=>{const d=new D.Sequencer,S=O=>{O.isCancellationRequested||(r++,o.readEntry())};o.once("error",u),o.once("close",()=>n.then(()=>{i.isCancellationRequested||o.entryCount===r?a():u(new I("Incomplete",new Error(P.localize(1,null,r,o.entryCount))))},u)),o.readEntry(),o.on("entry",O=>{if(i.isCancellationRequested)return;if(!s.sourcePathRegex.test(O.fileName)){S(i);return}const N=O.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(N)){const re=b.join(e,N);n=(0,D.createCancelablePromise)(ee=>T.Promises.mkdir(re,{recursive:!0}).then(()=>S(ee)).then(void 0,u));return}const _=l(o,O),J=L(O);n=(0,D.createCancelablePromise)(re=>d.queue(()=>_.then(ee=>y(ee,N,J,e,s,re).then(()=>S(re)))).then(null,u))})})}function g(o,e=!1){return new Promise((s,i)=>{(0,c.open)(o,e?{lazyEntries:!0}:void 0,(n,r)=>{n?i(h(n)):s((0,R.assertIsDefined)(r))})})}function l(o,e){return new Promise((s,i)=>{o.openReadStream(e,(n,r)=>{n?i(h(n)):s((0,R.assertIsDefined)(r))})})}function f(o,e){return new Promise((s,i)=>{const n=new w.ZipFile;e.forEach(a=>{a.contents?n.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&n.addFile(a.localPath,a.path)}),n.end();const r=(0,C.createWriteStream)(o);n.outputStream.pipe(r),n.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>s(o))})}t.zip=f;function v(o,e,s={},i){const n=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let r=g(o,!0);return s.overwrite&&(r=r.then(a=>T.Promises.rm(e).then(()=>a))),r.then(a=>E(a,e,{sourcePathRegex:n},i))}t.extract=v;function p(o,e){return g(o).then(s=>new Promise((i,n)=>{s.on("entry",r=>{r.fileName===e&&l(s,r).then(a=>i(a),a=>n(a))}),s.once("close",()=>n(new Error(P.localize(2,null,e))))}))}function m(o,e){return p(o,e).then(s=>new Promise((i,n)=>{const r=[];s.once("error",n),s.on("data",a=>r.push(a)),s.on("end",()=>i(Buffer.concat(r)))}))}t.buffer=m}),define(Y[128],Q([0,1,43,78]),function(j,t,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function b(R){return(0,C.buffer)(R,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}t.getManifest=b}),define(Y[129],Q([0,1,18,3,8,2,10,11,12,19,41,9,27,15,43,79,20,23,21,90,35,16,14,32]),function(j,t,C,D,b,R,T,P,c,w,I,L,h,y,E,g,l,f,v,p,m,o,e,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;let i=class extends R.Disposable{constructor(r,a,u,d,S){super();this.beforeRemovingExtension=r,this.fileService=a,this.logService=u,this.environmentService=d,this.productService=S,this._devSystemExtensionsPath=null,this.systemExtensionsPath=d.builtinExtensionsPath,this.extensionsPath=d.extensionsPath,this.uninstalledPath=P.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new D.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(r){const a=[];(r===null||r===0)&&a.push(this.scanSystemExtensions().then(null,u=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(u).message,f.ExtensionManagementErrorCode.Internal)))),(r===null||r===1)&&a.push(this.scanUserExtensions(!0).then(null,u=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(u).message,f.ExtensionManagementErrorCode.Internal))));try{const u=await Promise.all(a);return(0,C.flatten)(u)}catch(u){throw this.joinErrors(u)}}async scanUserExtensions(r){this.logService.trace("Started scanning user extensions");let[a,u]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return u=u.filter(d=>!a[new v.ExtensionIdentifierWithVersion(d.identifier,d.manifest.version).key()]),r&&(u=(0,v.groupByExtension)(u,S=>S.identifier).map(S=>S.sort((O,N)=>I.rcompare(O.manifest.version,N.manifest.version))[0])),this.logService.trace("Scanned user extensions:",u.length),u}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(r,a,u,d){const S=r.key(),O=P.join(this.extensionsPath,`.${(0,h.generateUuid)()}`),N=P.join(this.extensionsPath,S);try{await y.Promises.rm(N)}catch{try{await y.Promises.rm(N)}catch{}throw new f.ExtensionManagementError((0,g.localize)(0,null,N,r.id),f.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(r,a,O,d);let _=await this.scanExtension(L.URI.file(O),1);if(!_)throw new Error((0,g.localize)(1,null,O));await this.storeMetadata(_,{...u,installedTimestamp:Date.now()});try{await this.rename(r,O,N,Date.now()+2*60*1e3),this.logService.info("Renamed to",N)}catch(J){try{await y.Promises.rm(O)}catch{}if(J.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",r.id);else throw this.logService.info(`Rename failed because of ${(0,b.getErrorMessage)(J)}. Deleted from extracted location`,O),J}try{_=await this.scanExtension(L.URI.file(N),1)}catch{}if(_)return _;throw new Error((0,g.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(r,a){return this.setMetadata(r,a),await this.storeMetadata(r,{...a,installedTimestamp:r.installedTimestamp}),r}async storeMetadata(r,a){a.isMachineScoped=a.isMachineScoped||void 0,a.isBuiltin=a.isBuiltin||void 0,a.installedTimestamp=a.installedTimestamp||void 0;const u=P.join(r.location.fsPath,"package.json"),d=await y.Promises.readFile(u,"utf8"),{manifest:S}=await this.parseManifest(d);return S.__metadata=a,await y.Promises.writeFile(u,JSON.stringify(S,null,"	")),r}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...r){const a=r.map(u=>new v.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version));await this.withUninstalledExtensions(u=>{a.forEach(d=>u[d.key()]=!0)})}async setInstalled(r){await this.withUninstalledExtensions(d=>delete d[r.key()]);const u=(await this.scanExtensions(1)).find(d=>new v.ExtensionIdentifierWithVersion(d.identifier,d.manifest.version).equals(r))||null;return u?(await this.storeMetadata(u,{installedTimestamp:Date.now()}),this.scanExtension(u.location,1)):null}async withUninstalledExtensions(r){return this.uninstalledFileLimiter.queue(async()=>{let a;try{a=await y.Promises.readFile(this.uninstalledPath,"utf8")}catch(d){if(d.code!=="ENOENT")throw d}let u={};if(a)try{u=JSON.parse(a)}catch{}return r&&(r(u),Object.keys(u).length?await y.Promises.writeFile(this.uninstalledPath,JSON.stringify(u)):await y.Promises.rm(this.uninstalledPath)),u})}async removeExtension(r,a){this.logService.trace(`Deleting ${a} extension from disk`,r.identifier.id,r.location.fsPath),await y.Promises.rm(r.location.fsPath),this.logService.info("Deleted from disk",r.identifier.id,r.location.fsPath)}async removeUninstalledExtension(r){await this.removeExtension(r,"uninstalled"),await this.withUninstalledExtensions(a=>delete a[new v.ExtensionIdentifierWithVersion(r.identifier,r.manifest.version).key()])}async extractAtLocation(r,a,u,d){this.logService.trace(`Started extracting the extension from ${a} to ${u}`);try{await y.Promises.rm(u)}catch(S){throw new f.ExtensionManagementError(this.joinErrors(S).message,f.ExtensionManagementErrorCode.Delete)}try{await(0,E.extract)(a,u,{sourcePath:"extension",overwrite:!0},d),this.logService.info(`Extracted extension to ${u}:`,r.id)}catch(S){try{await y.Promises.rm(u)}catch{}let O=f.ExtensionManagementErrorCode.Extract;throw S instanceof E.ExtractError&&(S.type==="CorruptZip"?O=f.ExtensionManagementErrorCode.CorruptZip:S.type==="Incomplete"&&(O=f.ExtensionManagementErrorCode.IncompleteZip)),new f.ExtensionManagementError(S.message,O)}}async rename(r,a,u,d){try{await y.Promises.rename(a,u)}catch(S){if(c.isWindows&&S&&S.code==="EPERM"&&Date.now()<d)return this.logService.info(`Failed renaming ${a} to ${u} with 'EPERM' error. Trying again...`,r.id),this.rename(r,a,u,d);throw new f.ExtensionManagementError(S.message||(0,g.localize)(3,null,a,u),S.code||f.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const r=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return r;const a=this.scanDevSystemExtensions(),[u,d]=await Promise.all([r,a]);return[...u,...d]}async scanExtensionsInDir(r,a){const u=new D.Limiter(10),d=await this.fileService.resolve(L.URI.file(r));return d.children?(await Promise.all(d.children.filter(O=>O.isDirectory).map(O=>u.queue(async()=>a===1&&(0,w.basename)(O.resource).indexOf(".")===0?null:this.scanExtension(O.resource,a))))).filter(O=>O&&O.identifier):[]}async scanExtension(r,a){try{const u=await this.fileService.resolve(r);if(u.children){const{manifest:d,metadata:S}=await this.readManifest(r.fsPath),O=u.children.find(({name:re})=>/^readme(\.txt|\.md|)$/i.test(re))?.resource,N=u.children.find(({name:re})=>/^changelog(\.txt|\.md|)$/i.test(re))?.resource,_={id:(0,v.getGalleryExtensionId)(d.publisher,d.name)},J={type:a,identifier:_,manifest:d,location:r,readmeUrl:O,changelogUrl:N,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:a===0};return this.setMetadata(J,S),J}}catch(u){a!==0&&this.logService.trace(u)}return null}async scanDefaultSystemExtensions(){const r=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",r.length),r}async scanDevSystemExtensions(){const r=this.getDevSystemExtensionsList();if(r.length){const a=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",a.length),a.filter(u=>r.some(d=>(0,v.areSameExtensions)(u.identifier,{id:d})))}else return[]}setMetadata(r,a){r.publisherDisplayName=a?.publisherDisplayName||null,r.publisherId=a?.publisherId||null,r.identifier.uuid=a?.id,r.isMachineScoped=!!a?.isMachineScoped,r.isPreReleaseVersion=!!a?.isPreReleaseVersion,r.preRelease=!!a?.preRelease,r.isBuiltin=r.type===0||!!a?.isBuiltin,r.installedTimestamp=a?.installedTimestamp}async removeUninstalledExtensions(){const r=await this.getUninstalledExtensions(),a=await this.scanAllUserExtensions(),u=new Set;for(const O of a)r[new v.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).key()]||u.add(O.identifier.id.toLowerCase());const d=(0,v.groupByExtension)(a,O=>O.identifier);await D.Promises.settled(d.map(async O=>{const N=O.sort((_,J)=>I.rcompare(_.manifest.version,J.manifest.version))[0];u.has(N.identifier.id.toLowerCase())||await this.beforeRemovingExtension(N)}));const S=a.filter(O=>r[new v.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).key()]);await D.Promises.settled(S.map(O=>this.removeUninstalledExtension(O)))}async removeOutdatedExtensions(){const r=await this.scanAllUserExtensions(),a=[],u=(0,v.groupByExtension)(r,d=>d.identifier);a.push(...(0,C.flatten)(u.map(d=>d.sort((S,O)=>I.rcompare(S.manifest.version,O.manifest.version)).slice(1)))),await D.Promises.settled(a.map(d=>this.removeExtension(d,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(r=>r.name)}joinErrors(r){const a=Array.isArray(r)?r:[r];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((u,d)=>new Error(`${u.message}${u.message?",":""}${d instanceof Error?d.message:d}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=P.normalize(P.join(T.FileAccess.asFileUri("",j).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(r){const a=[y.Promises.readFile(P.join(r,"package.json"),"utf8").then(O=>this.parseManifest(O)),y.Promises.readFile(P.join(r,"package.nls.json"),"utf8").then(void 0,O=>O.code!=="ENOENT"?Promise.reject(O):"{}").then(O=>JSON.parse(O))],[{manifest:u,metadata:d},S]=await Promise.all(a);return{manifest:(0,p.localizeManifest)(u,S),metadata:d}}parseManifest(r){return new Promise((a,u)=>{try{const d=JSON.parse(r);d.publisher||(d.publisher=m.UNDEFINED_PUBLISHER);const S=d.__metadata||null;a({manifest:d,metadata:S})}catch{u(new Error((0,g.localize)(4,null)))}})}};i=ge([oe(1,o.IFileService),oe(2,e.ILogService),oe(3,l.INativeEnvironmentService),oe(4,s.IProductService)],i),t.ExtensionsScanner=i}),define(Y[130],Q([0,1,28,8,10,11,12,29,19,41,6,9,27,15,43,77,49,20,118,23,21,110,98,128,111,129,126,48,16,13,14,32,31,37]),function(j,t,C,D,b,R,T,P,c,w,I,L,h,y,E,g,l,f,v,p,m,o,e,s,i,n,r,a,u,d,S,O,N,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;let J=class extends v.AbstractExtensionManagementService{constructor(x,te,U,k,z,G,ne,K,Z){super(x,te,U,K);this.environmentService=k,this.downloadService=z,this.fileService=ne;const q=this._register(G.createInstance(e.ExtensionsLifecycle));this.extensionsScanner=this._register(G.createInstance(n.ExtensionsScanner,A=>q.postUninstall(A))),this.manifestCache=this._register(new i.ExtensionsManifestCache(k,this)),this.extensionsDownloader=this._register(G.createInstance(o.ExtensionsDownloader));const M=this._register(new r.ExtensionsWatcher(this,ne,k,U,Z));this._register(M.onDidChangeExtensionsByAnotherSource(({added:A,removed:V})=>{A.length&&this._onDidInstallExtensions.fire(A.map(B=>({identifier:B.identifier,operation:1,local:B}))),V.forEach(B=>this._onDidUninstallExtension.fire({identifier:B}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const x=await this.isAlpineLinux(),te=(0,p.getTargetPlatform)(x?"alpine":T.platform,P.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",te),te})()),this._targetPlatformPromise}async isAlpineLinux(){if(!T.isLinux)return!1;let x;try{x=(await this.fileService.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{x=(await this.fileService.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(U){this.logService.debug("Error while getting the os-release file.",(0,D.getErrorMessage)(U))}}return!!x&&(x.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(x){this.logService.trace("ExtensionManagementService#zip",x.identifier.id);const te=await this.collectFiles(x),U=await(0,E.zip)((0,c.joinPath)(this.environmentService.tmpDir,(0,h.generateUuid)()).fsPath,te);return L.URI.file(U)}async unzip(x){return this.logService.trace("ExtensionManagementService#unzip",x.toString()),(await this.install(x)).identifier}async getManifest(x){const te=await this.downloadVsix(x),U=R.resolve(te.fsPath);return(0,s.getManifest)(U)}getInstalled(x=null){return this.extensionsScanner.scanExtensions(x)}async install(x,te={}){this.logService.trace("ExtensionManagementService#install",x.toString());const U=await this.downloadVsix(x),k=await(0,s.getManifest)(R.resolve(U.fsPath));if(k.engines&&k.engines.vscode&&!(0,a.isEngineValid)(k.engines.vscode,this.productService.version,this.productService.date))throw new Error(g.localize(0,null,(0,m.getGalleryExtensionId)(k.publisher,k.name),this.productService.version));return this.installExtension(k,U,te)}async updateMetadata(x,te){this.logService.trace("ExtensionManagementService#updateMetadata",x.identifier.id);const U={...x.manifest.__metadata||{},...te};return te.isPreReleaseVersion&&(U.preRelease=!0),x=await this.extensionsScanner.saveMetadataForLocalExtension(x,U),this.manifestCache.invalidate(),x}async updateExtensionScope(x,te){return this.logService.trace("ExtensionManagementService#updateExtensionScope",x.identifier.id),x=await this.extensionsScanner.saveMetadataForLocalExtension(x,{...x.manifest.__metadata||{},isMachineScoped:te}),this.manifestCache.invalidate(),x}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(x){if(x.scheme===b.Schemas.file)return x;const te=(0,c.joinPath)(this.environmentService.tmpDir,(0,h.generateUuid)());return await this.downloadService.download(x,te),te}createInstallExtensionTask(x,te,U){return L.URI.isUri(te)?new ie(x,te,U,this.galleryService,this.extensionsScanner,this.logService):new ee(te,U,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(x,te){return new he(x,te,this.extensionsScanner)}async collectFiles(x){const te=async k=>{let z=await y.Promises.readdir(k);z=z.map(K=>R.join(k,K));const G=await Promise.all(z.map(K=>y.Promises.stat(K)));let ne=Promise.resolve([]);return G.forEach((K,Z)=>{const q=z[Z];K.isFile()&&(ne=ne.then(M=>[...M,q])),K.isDirectory()&&(ne=ne.then(M=>te(q).then(A=>[...M,...A])))}),ne};return(await te(x.location.fsPath)).map(k=>({path:`extension/${R.relative(x.location.fsPath,k)}`,localPath:k}))}};J=ge([oe(0,p.IExtensionGalleryService),oe(1,N.ITelemetryService),oe(2,S.ILogService),oe(3,f.INativeEnvironmentService),oe(4,l.IDownloadService),oe(5,d.IInstantiationService),oe(6,u.IFileService),oe(7,O.IProductService),oe(8,_.IUriIdentityService)],J),t.ExtensionManagementService=J;class re extends v.AbstractExtensionTask{constructor(x,te,U,k){super();this.identifier=x,this.source=te,this.extensionsScanner=U,this.logService=k,this._operation=2}get operation(){return this._operation}async installExtension(x,te){try{const U=await this.unsetUninstalledAndGetLocal(x.identifierWithVersion);if(U)return x.metadata?this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},...x.metadata}):U}catch{throw T.isMacintosh?new p.ExtensionManagementError(g.localize(1,null),p.ExtensionManagementErrorCode.Internal):new p.ExtensionManagementError(g.localize(2,null),p.ExtensionManagementErrorCode.Internal)}return this.extract(x,te)}async unsetUninstalledAndGetLocal(x){if(!await this.isUninstalled(x))return null;this.logService.trace("Removing the extension from uninstalled list:",x.id);const U=await this.extensionsScanner.setInstalled(x);return this.logService.info("Removed the extension from uninstalled list:",x.id),U}async isUninstalled(x){return!!(await this.extensionsScanner.getUninstalledExtensions())[x.key()]}async extract({zipPath:x,identifierWithVersion:te,metadata:U},k){let z=await this.extensionsScanner.extractUserExtension(te,x,U,k);return this.logService.info("Extracting completed.",te.id),z}}class ee extends re{constructor(x,te,U,k,z){super(x.identifier,x,k,z);this.gallery=x,this.options=te,this.extensionsDownloader=U}async doRun(x){const U=(await this.extensionsScanner.scanExtensions(null)).find(z=>(0,m.areSameExtensions)(z.identifier,this.gallery.identifier));U&&(this._operation=3);const k=await this.downloadInstallableExtension(this.gallery,this._operation);k.metadata.isMachineScoped=this.options.isMachineScoped||U?.isMachineScoped,k.metadata.isBuiltin=this.options.isBuiltin||U?.isBuiltin,k.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,k.metadata.preRelease=this.gallery.properties.isPreReleaseVersion||((0,I.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:U?.preRelease);try{const z=await this.installExtension(k,x);return U&&w.neq(U.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(U),z}catch(z){throw await this.deleteDownloadedVSIX(k.zipPath),z}}async deleteDownloadedVSIX(x){try{await this.extensionsDownloader.delete(L.URI.file(x))}catch(te){this.logService.warn("Error while deleting the downloaded vsix",x.toString(),(0,D.getErrorMessage)(te))}}async downloadInstallableExtension(x,te){const U={id:x.identifier.uuid,publisherId:x.publisherId,publisherDisplayName:x.publisherDisplayName};let k;try{this.logService.trace("Started downloading extension:",x.identifier.id),k=(await this.extensionsDownloader.downloadExtension(x,te)).fsPath,this.logService.info("Downloaded extension:",x.identifier.id,k)}catch(z){throw new p.ExtensionManagementError((0,v.joinErrors)(z).message,p.ExtensionManagementErrorCode.Download)}try{const z=await(0,s.getManifest)(k);return{zipPath:k,identifierWithVersion:new m.ExtensionIdentifierWithVersion(x.identifier,z.version),metadata:U}}catch(z){throw await this.deleteDownloadedVSIX(k),new p.ExtensionManagementError((0,v.joinErrors)(z).message,p.ExtensionManagementErrorCode.Invalid)}}}class ie extends re{constructor(x,te,U,k,z,G){super({id:(0,m.getGalleryExtensionId)(x.publisher,x.name)},te,z,G);this.manifest=x,this.location=te,this.options=U,this.galleryService=k}async doRun(x){const te=new m.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),k=(await this.extensionsScanner.scanExtensions(1)).find(G=>(0,m.areSameExtensions)(this.identifier,G.identifier)),z=await this.getMetadata(this.identifier.id,this.manifest.version,x);if(z.isMachineScoped=this.options.isMachineScoped||k?.isMachineScoped,z.isBuiltin=this.options.isBuiltin||k?.isBuiltin,k)if(this._operation=3,te.equals(new m.ExtensionIdentifierWithVersion(k.identifier,k.manifest.version)))try{await this.extensionsScanner.removeExtension(k,"existing")}catch{throw new Error(g.localize(3,null,this.manifest.displayName||this.manifest.name))}else w.gt(k.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(k);else{const G=await this.unsetUninstalledAndGetLocal(te);if(G)try{await this.extensionsScanner.removeExtension(G,"existing")}catch{throw new Error(g.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:R.resolve(this.location.fsPath),identifierWithVersion:te,metadata:z},x)}async getMetadata(x,te,U){try{let[k]=await this.galleryService.getExtensions([{id:x,version:te}],U);if(k||([k]=await this.galleryService.getExtensions([{id:x}],U)),k)return{id:k.identifier.uuid,publisherDisplayName:k.publisherDisplayName,publisherId:k.publisherId,isPreReleaseVersion:k.properties.isPreReleaseVersion,preRelease:k.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class he extends v.AbstractExtensionTask{constructor(x,te,U){super();this.extension=x,this.options=te,this.extensionsScanner=U}async doRun(x){const te=[],U=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const k=new m.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);te.push(...U.filter(z=>k.equals(new m.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version))))}else te.push(...U.filter(k=>(0,m.areSameExtensions)(k.identifier,this.extension.identifier)));if(!te.length)throw new Error(g.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...te),this.options.remove)for(const k of te)try{x.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(k)}catch(z){throw new Error(g.localize(6,null,(0,C.toErrorMessage)(z)))}}}}),define(Y[131],Q([0,1,115,3,17,8,2,6,25,20,125,14,114,141]),function(j,t,C,D,b,R,T,P,c,w,I,L,h,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let E=class extends T.Disposable{constructor(l,f,v){super();this.environmentService=f,this.logService=v,this.configure(l.getValue()),this._register(l.onDidChangeConfiguration(()=>this.configure(l.getValue()),this))}configure(l){this.proxyUrl=l.http&&l.http.proxy,this.strictSSL=!!(l.http&&l.http.proxyStrictSSL),this.authorization=l.http&&l.http.proxyAuthorization}async request(l,f){this.logService.trace("RequestService#request",l.url);const{proxyUrl:v,strictSSL:p}=this;let m;try{m=await(0,I.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(s){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",s))}const o={...process.env,...m},e=l.agent?l.agent:await(0,h.getProxyAgent)(l.url||"",o,{proxyUrl:v,strictSSL:p});return l.agent=e,l.strictSSL=p,this.authorization&&(l.headers={...l.headers||{},"Proxy-Authorization":this.authorization}),this._request(l,f)}async getNodeRequest(l){return((0,C.parse)(l.url).protocol==="https:"?await new Promise((p,m)=>{j(["https"],p,m)}):await new Promise((p,m)=>{j(["http"],p,m)})).request}_request(l,f){return D.Promises.withAsyncBody(async(v,p)=>{let m;const o=(0,C.parse)(l.url),e=l.getRawRequest?l.getRawRequest(l):await this.getNodeRequest(l),s={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:l.type||"GET",headers:l.headers,agent:l.agent,rejectUnauthorized:(0,P.isBoolean)(l.strictSSL)?l.strictSSL:!0};l.user&&l.password&&(s.auth=l.user+":"+l.password),m=e(s,i=>{const n=(0,P.isNumber)(l.followRedirects)?l.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...l,url:i.headers.location,followRedirects:n-1},f).then(v,p);else{let r=i;i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,y.createGunzip)())),v({res:i,stream:(0,b.streamToBufferReadableStream)(r)})}}),m.on("error",p),l.timeout&&m.setTimeout(l.timeout),l.data&&typeof l.data=="string"&&m.write(l.data),m.end(),f.onCancellationRequested(()=>{m.abort(),p((0,R.canceled)())})})}async resolveProxy(l){}};E=ge([oe(0,c.IConfigurationService),oe(1,w.INativeEnvironmentService),oe(2,L.ILogService)],E),t.RequestService=E}),define(Y[142],Q([0,1,33,3,17,28,8,2,10,11,29,9,15,25,107,49,113,20,89,120,23,109,130,16,100,102,40,97,52,53,112,14,104,122,32,42,131,117,31,121,36,123,124,37,127]),function(j,t,C,D,b,R,T,P,c,w,I,L,h,y,E,g,l,f,v,p,m,o,e,s,i,n,r,a,u,d,S,O,N,_,J,re,ee,ie,he,ue,x,te,U,k,z){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class G extends P.Disposable{constructor(Z){super();this.argv=Z,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[Z,q]=await this.initServices();return Z.invokeFunction(async M=>{const A=M.get(O.ILogService),V=M.get(s.IFileService),B=M.get(f.INativeEnvironmentService),H=M.get(m.IExtensionManagementCLIService);A.info("CLI main",this.argv),this.registerErrorHandler(A),await this.doRun(B,H,V),await Promise.all(q.map(X=>{(0,D.raceTimeout)(X.flush(),1e3)}))})}async initServices(){const Z=new u.ServiceCollection,q={_serviceBrand:void 0,..._.default};Z.set(J.IProductService,q);const M=new v.NativeEnvironmentService(this.argv,q);Z.set(f.INativeEnvironmentService,M),await Promise.all([M.appSettingsHome.fsPath,M.extensionsPath].map(we=>we?h.Promises.mkdir(we,{recursive:!0}):void 0));const A=(0,O.getLogLevel)(M),V=[];V.push(new N.SpdLogLogger("cli",(0,w.join)(M.logsPath,"cli.log"),!0,!1,A)),A===O.LogLevel.Trace&&V.push(new O.ConsoleLogger(A));const B=this._register(new O.MultiplexLogService(V));Z.set(O.ILogService,B);const H=this._register(new i.FileService(B));Z.set(s.IFileService,H);const X=this._register(new n.DiskFileSystemProvider(B));H.registerProvider(c.Schemas.file,X);const ae=this._register(new E.ConfigurationService(M.settingsResource,H));Z.set(y.IConfigurationService,ae),await ae.initialize(),Z.set(k.IUriIdentityService,new z.UriIdentityService(H)),Z.set(re.IRequestService,new r.SyncDescriptor(ee.RequestService)),Z.set(g.IDownloadService,new r.SyncDescriptor(l.DownloadService)),Z.set(m.IExtensionManagementService,new r.SyncDescriptor(e.ExtensionManagementService)),Z.set(m.IExtensionGalleryService,new r.SyncDescriptor(p.ExtensionGalleryServiceWithNoStorageService)),Z.set(m.IExtensionManagementCLIService,new r.SyncDescriptor(o.ExtensionManagementCLIService)),Z.set(d.ILocalizationsService,new r.SyncDescriptor(S.LocalizationsService));const ce=[];if((0,x.supportsTelemetry)(q,M)){q.aiConfig&&q.aiConfig.asimovKey&&ce.push(new te.AppInsightsAppender("monacoworkbench",null,q.aiConfig.asimovKey));const{appRoot:we,extensionsPath:fe,installSourcePath:se}=M,pe={appenders:ce,sendErrorTelemetry:!1,commonProperties:(async()=>{let me;try{const Ee=await h.Promises.readFile((0,w.join)(M.userDataPath,"storage.json"));me=JSON.parse(Ee.toString())[he.machineIdKey]}catch(Ee){Ee.code!=="ENOENT"&&B.error(Ee)}return(0,ie.resolveCommonProperties)(H,(0,C.release)(),(0,C.hostname)(),process.arch,q.commit,q.version,me,q.msftInternalDomains,se)})(),piiPaths:[we,fe]};Z.set(he.ITelemetryService,new r.SyncDescriptor(ue.TelemetryService,[pe]))}else Z.set(he.ITelemetryService,x.NullTelemetryService);return[new a.InstantiationService(Z),ce]}registerErrorHandler(Z){(0,T.setUnexpectedErrorHandler)(q=>{const M=(0,R.toErrorMessage)(q,!0);!M||Z.error(`[uncaught exception in CLI]: ${M}`)}),process.on("uncaughtException",q=>(0,T.onUnexpectedError)(q)),process.on("unhandledRejection",q=>(0,T.onUnexpectedError)(q))}async doRun(Z,q,M){if(this.argv["install-source"])return this.setInstallSource(Z,M,this.argv["install-source"]);if(this.argv["list-extensions"])return q.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const A={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"]};return q.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],A,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return q.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return q.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,U.buildTelemetryMessage)(Z.appRoot,Z.extensionsPath))}}asExtensionIdOrVSIX(Z){return Z.map(q=>/\.vsix$/i.test(q)?L.URI.file((0,w.isAbsolute)(q)?q:(0,w.join)((0,I.cwd)(),q)):q)}async setInstallSource(Z,q,M){await q.writeFile(L.URI.file(Z.installSourcePath),b.VSBuffer.fromString(M.slice(0,30)))}}async function ne(K){const Z=new G(K);try{await Z.run()}finally{Z.dispose()}}t.main=ne})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0f4d3788605a486980fa3a6b3b9d1a38b1102481/core/vs/code/node/cliProcessMain.js.map
