/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/types","vs/workbench/api/common/extHostTypeConverters","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/base/node/pfs","vs/base/common/extpath","vs/workbench/services/extensions/common/extensions","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/editor/common/core/range","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/severity","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/hash","vs/base/common/marshalling","fs","os","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/codicons","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/normalization","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testCollection","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/languageSelector","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/services/semanticTokensDto","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/tunnel/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagement","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/node/uriTransformer","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","util","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],we=function(ee){for(var e=[],h=0,n=ee.length;h<n;h++)e[h]=ve[ee[h]];return e};define(ve[55],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function h(n,I){if(!n)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}e.ok=h}),define(ve[72],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function h(C){return C?C.replace(/\$\((.*?)\)/g,(k,S)=>` ${S} `).trim():""}e.getCodiconAriaLabel=h;class n{constructor(k,S,R){this.id=k,this.definition=S,this.description=R,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.layoutActivitybarLeft=new n("layout-activitybar-left",{fontCharacter:"\\ebec"}),n.layoutActivitybarRight=new n("layout-activitybar-right",{fontCharacter:"\\ebed"}),n.layoutPanelLeft=new n("layout-panel-left",{fontCharacter:"\\ebee"}),n.layoutPanelCenter=new n("layout-panel-center",{fontCharacter:"\\ebef"}),n.layoutPanelJustify=new n("layout-panel-justify",{fontCharacter:"\\ebf0"}),n.layoutPanelRight=new n("layout-panel-right",{fontCharacter:"\\ebf1"}),n.layoutPanel=new n("layout-panel",{fontCharacter:"\\ebf2"}),n.layoutSidebarLeft=new n("layout-sidebar-left",{fontCharacter:"\\ebf3"}),n.layoutSidebarRight=new n("layout-sidebar-right",{fontCharacter:"\\ebf4"}),n.layoutStatusbar=new n("layout-statusbar",{fontCharacter:"\\ebf5"}),n.layoutMenubar=new n("layout-menubar",{fontCharacter:"\\ebf6"}),n.layoutCentered=new n("layout-centered",{fontCharacter:"\\ebf7"}),n.target=new n("target",{fontCharacter:"\\ebf8"}),n.indent=new n("indent",{fontCharacter:"\\ebf9"}),n.recordSmall=new n("record-small",{fontCharacter:"\\ebfa"}),n.errorSmall=new n("error-small",{fontCharacter:"\\ebfb"}),n.arrowCircleDown=new n("arrow-circle-down",{fontCharacter:"\\ebfc"}),n.arrowCircleLeft=new n("arrow-circle-left",{fontCharacter:"\\ebfd"}),n.arrowCircleRight=new n("arrow-circle-right",{fontCharacter:"\\ebfe"}),n.arrowCircleUp=new n("arrow-circle-up",{fontCharacter:"\\ebff"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function I(C,k){const S=["codicon","codicon-"+C];return k&&S.push("codicon-modifier-"+k),S}e.getClassNamesArray=I;var T;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function S(D){if(D instanceof n)return["codicon","codicon-"+D.id];const p=k.exec(D.id);if(!p)return S(n.error);let[,_,g]=p;const d=["codicon","codicon-"+_];return g&&d.push("codicon-modifier-"+g.substr(1)),d}C.asClassNameArray=S;function R(D){return S(D).join(" ")}C.asClassName=R;function F(D){return"."+S(D).join(".")}C.asCSSSelector=F})(T=e.CSSIcon||(e.CSSIcon={}))}),define(ve[73],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const h=Object.prototype.hasOwnProperty;function n(F){const D=[];for(let p in F)h.call(F,p)&&D.push(F[p]);return D}e.values=n;function I(F,D){for(let p in F)if(h.call(F,p)&&D({key:p,value:F[p]},function(){delete F[p]})===!1)return}e.forEach=I;function T(F,D){const p=Object.create(null);for(const _ of F){const g=D(_);let d=p[g];d||(d=p[g]=[]),d.push(_)}return p}e.groupBy=T;function C(F){const D=Object.create(null);return F&&F.forEach((p,_)=>{D[_]=p}),D}e.fromMap=C;function k(F,D){const p=[],_=[];for(let g of F)D.has(g)||p.push(g);for(let g of D)F.has(g)||_.push(g);return{removed:p,added:_}}e.diffSets=k;function S(F,D){const p=[],_=[];for(let[g,d]of F)D.has(g)||p.push(d);for(let[g,d]of D)F.has(g)||_.push(d);return{removed:p,added:_}}e.diffMaps=S;class R{constructor(){this.map=new Map}add(D,p){let _=this.map.get(D);_||(_=new Set,this.map.set(D,_)),_.add(p)}delete(D,p){const _=this.map.get(D);!_||(_.delete(p),_.size===0&&this.map.delete(D))}forEach(D,p){const _=this.map.get(D);!_||_.forEach(p)}}e.SetMap=R}),define(ve[56],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function h(C){return(k,S,R)=>{let F=null,D=null;if(typeof R.value=="function"?(F="value",D=R.value):typeof R.get=="function"&&(F="get",D=R.get),!D)throw new Error("not supported");R[F]=C(D,S)}}e.createDecorator=h;function n(C,k,S){let R=null,F=null;if(typeof S.value=="function"?(R="value",F=S.value,F.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(R="get",F=S.get),!F)throw new Error("not supported");const D=`$memoize$${k}`;S[R]=function(...p){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:F.apply(this,p)}),this[D]}}e.memoize=n;function I(C,k,S){return h((R,F)=>{const D=`$debounce$${F}`,p=`$debounce$result$${F}`;return function(..._){this[p]||(this[p]=S?S():void 0),clearTimeout(this[D]),k&&(this[p]=k(this[p],..._),_=[this[p]]),this[D]=setTimeout(()=>{R.apply(this,_),this[p]=S?S():void 0},C)}})}e.debounce=I;function T(C,k,S){return h((R,F)=>{const D=`$throttle$timer$${F}`,p=`$throttle$result$${F}`,_=`$throttle$lastRun$${F}`,g=`$throttle$pending$${F}`;return function(...d){if(this[p]||(this[p]=S?S():void 0),(this[_]===null||this[_]===void 0)&&(this[_]=-Number.MAX_VALUE),k&&(this[p]=k(this[p],...d)),this[g])return;const v=this[_]+C;v<=Date.now()?(this[_]=Date.now(),R.apply(this,[this[p]]),this[p]=S?S():void 0):(this[g]=!0,this[D]=setTimeout(()=>{this[g]=!1,this[_]=Date.now(),R.apply(this,[this[p]]),this[p]=S?S():void 0},v-Date.now()))}})}e.throttle=T}),define(ve[17],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class h{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(c){setTimeout(()=>{throw c.stack?new Error(c.message+`

`+c.stack):c},0)}}addListener(c){return this.listeners.push(c),()=>{this._removeListener(c)}}emit(c){this.listeners.forEach(m=>{m(c)})}_removeListener(c){this.listeners.splice(this.listeners.indexOf(c),1)}setUnexpectedErrorHandler(c){this.unexpectedErrorHandler=c}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(c){this.unexpectedErrorHandler(c),this.emit(c)}onUnexpectedExternalError(c){this.unexpectedErrorHandler(c)}}e.ErrorHandler=h,e.errorHandler=new h;function n(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=n;function I(a){S(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=I;function T(a){S(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=T;function C(a){if(a instanceof Error){let{name:c,message:m}=a;const s=a.stacktrace||a.stack;return{$isError:!0,name:c,message:m,stack:s}}return a}e.transformErrorForSerialization=C;const k="Canceled";function S(a){return a instanceof R?!0:a instanceof Error&&a.name===k&&a.message===k}e.isCancellationError=S;class R extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=R;function F(){const a=new Error(k);return a.name=a.message,a}e.canceled=F;function D(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=D;function p(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=p;function _(a){return a?new Error(`readonly property '${a} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=_;function g(a){const c=new Error(`${a} has been disposed`);return c.name="DISPOSED",c}e.disposed=g;function d(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=d;class v extends Error{constructor(c){super("NotImplemented");c&&(this.message=c)}}e.NotImplementedError=v;class A extends Error{constructor(c){super("NotSupported");c&&(this.message=c)}}e.NotSupportedError=A;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b}),define(ve[18],we([1,0,17]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function n(Z,Q=0){return Z[Z.length-(1+Q)]}e.tail=n;function I(Z){if(Z.length===0)throw new Error("Invalid tail call");return[Z.slice(0,Z.length-1),Z[Z.length-1]]}e.tail2=I;function T(Z,Q,se=(de,ge)=>de===ge){if(Z===Q)return!0;if(!Z||!Q||Z.length!==Q.length)return!1;for(let de=0,ge=Z.length;de<ge;de++)if(!se(Z[de],Q[de]))return!1;return!0}e.equals=T;function C(Z,Q,se){let de=0,ge=Z.length-1;for(;de<=ge;){const Te=(de+ge)/2|0,Ne=se(Z[Te],Q);if(Ne<0)de=Te+1;else if(Ne>0)ge=Te-1;else return Te}return-(de+1)}e.binarySearch=C;function k(Z,Q){let se=0,de=Z.length;if(de===0)return 0;for(;se<de;){const ge=Math.floor((se+de)/2);Q(Z[ge])?de=ge:se=ge+1}return se}e.findFirstInSorted=k;function S(Z,Q,se){if(Z=Z|0,Z>=Q.length)throw new TypeError("invalid index");let de=Q[Math.floor(Q.length*Math.random())],ge=[],Te=[],Ne=[];for(let be of Q){const Ee=se(be,de);Ee<0?ge.push(be):Ee>0?Te.push(be):Ne.push(be)}return Z<ge.length?S(Z,ge,se):Z<ge.length+Ne.length?Ne[0]:S(Z-(ge.length+Ne.length),Te,se)}e.quickSelect=S;function R(Z,Q){const se=[];let de;for(const ge of Z.slice(0).sort(Q))!de||Q(de[0],ge)!==0?(de=[ge],se.push(de)):de.push(ge);return se}e.groupBy=R;function F(Z,Q,se){const de=[];function ge(be,Ee,$){if(Ee===0&&$.length===0)return;const U=de[de.length-1];U&&U.start+U.deleteCount===be?(U.deleteCount+=Ee,U.toInsert.push(...$)):de.push({start:be,deleteCount:Ee,toInsert:$})}let Te=0,Ne=0;for(;;){if(Te===Z.length){ge(Te,0,Q.slice(Ne));break}if(Ne===Q.length){ge(Te,Z.length-Te,[]);break}const be=Z[Te],Ee=Q[Ne],$=se(be,Ee);$===0?(Te+=1,Ne+=1):$<0?(ge(Te,1,[]),Te+=1):$>0&&(ge(Te,0,[Ee]),Ne+=1)}return de}e.sortedDiff=F;function D(Z,Q,se){const de=F(Z,Q,se),ge=[],Te=[];for(const Ne of de)ge.push(...Z.slice(Ne.start,Ne.start+Ne.deleteCount)),Te.push(...Ne.toInsert);return{removed:ge,added:Te}}e.delta=D;function p(Z,Q,se){if(se===0)return[];const de=Z.slice(0,se).sort(Q);return g(Z,Q,de,se,Z.length),de}e.top=p;function _(Z,Q,se,de,ge){return se===0?Promise.resolve([]):new Promise((Te,Ne)=>{(async()=>{const be=Z.length,Ee=Z.slice(0,se).sort(Q);for(let $=se,U=Math.min(se+de,be);$<be;$=U,U=Math.min(U+de,be)){if($>se&&await new Promise(N=>setTimeout(N)),ge&&ge.isCancellationRequested)throw(0,h.canceled)();g(Z,Q,Ee,$,U)}return Ee})().then(Te,Ne)})}e.topAsync=_;function g(Z,Q,se,de,ge){for(const Te=se.length;de<ge;de++){const Ne=Z[de];if(Q(Ne,se[Te-1])<0){se.pop();const be=k(se,Ee=>Q(Ne,Ee)<0);se.splice(be,0,Ne)}}}function d(Z){return Z.filter(Q=>!!Q)}e.coalesce=d;function v(Z){let Q=0;for(let se=0;se<Z.length;se++)Z[se]&&(Z[Q]=Z[se],Q+=1);Z.length=Q}e.coalesceInPlace=v;function A(Z,Q,se){Z.splice(se,0,Z.splice(Q,1)[0])}e.move=A;function b(Z){return!Array.isArray(Z)||Z.length===0}e.isFalsyOrEmpty=b;function a(Z){return Array.isArray(Z)&&Z.length>0}e.isNonEmptyArray=a;function c(Z,Q=se=>se){const se=new Set;return Z.filter(de=>{const ge=Q(de);return se.has(ge)?!1:(se.add(ge),!0)})}e.distinct=c;function m(Z){const Q=new Set;return se=>{const de=Z(se);return Q.has(de)?!1:(Q.add(de),!0)}}e.uniqueFilter=m;function s(Z,Q){const se=E(Z,Q);if(se!==-1)return Z[se]}e.findLast=s;function E(Z,Q){for(let se=Z.length-1;se>=0;se--){const de=Z[se];if(Q(de))return se}return-1}e.lastIndex=E;function l(Z,Q){return Z.length>0?Z[0]:Q}e.firstOrDefault=l;function i(Z,Q,se=(de,ge)=>de===ge){let de=0;for(let ge=0,Te=Math.min(Z.length,Q.length);ge<Te&&se(Z[ge],Q[ge]);ge++)de++;return de}e.commonPrefixLength=i;function r(Z){return[].concat(...Z)}e.flatten=r;function t(Z,Q){let se=typeof Q=="number"?Z:0;typeof Q=="number"?se=Z:(se=0,Q=Z);const de=[];if(se<=Q)for(let ge=se;ge<Q;ge++)de.push(ge);else for(let ge=se;ge>Q;ge--)de.push(ge);return de}e.range=t;function o(Z,Q,se){return Z.reduce((de,ge)=>(de[Q(ge)]=se?se(ge):ge,de),Object.create(null))}e.index=o;function f(Z,Q){return Z.push(Q),()=>u(Z,Q)}e.insert=f;function u(Z,Q){const se=Z.indexOf(Q);if(se>-1)return Z.splice(se,1),Q}e.remove=u;function w(Z,Q,se){const de=Z.slice(0,Q),ge=Z.slice(Q);return de.concat(se,ge)}e.arrayInsert=w;function P(Z,Q){let se;if(typeof Q=="number"){let de=Q;se=()=>{const ge=Math.sin(de++)*179426549;return ge-Math.floor(ge)}}else se=Math.random;for(let de=Z.length-1;de>0;de-=1){const ge=Math.floor(se()*(de+1)),Te=Z[de];Z[de]=Z[ge],Z[ge]=Te}}e.shuffle=P;function L(Z,Q){const se=Z.indexOf(Q);se>-1&&(Z.splice(se,1),Z.unshift(Q))}e.pushToStart=L;function O(Z,Q){const se=Z.indexOf(Q);se>-1&&(Z.splice(se,1),Z.push(Q))}e.pushToEnd=O;function y(Z,Q){return Array.isArray(Z)?Z.map(Q):Q(Z)}e.mapArrayOrNot=y;function z(Z){return Array.isArray(Z)?Z:[Z]}e.asArray=z;function M(Z){return Z[Math.floor(Math.random()*Z.length)]}e.getRandomElement=M;function B(Z,Q){for(const se of Z){const de=Q(se);if(de!==void 0)return de}}e.mapFind=B;function V(Z,Q,se){const de=H(Z,Q),ge=Z.length,Te=se.length;Z.length=ge+Te;for(let Ne=ge-1;Ne>=de;Ne--)Z[Ne+Te]=Z[Ne];for(let Ne=0;Ne<Te;Ne++)Z[Ne+de]=se[Ne]}e.insertInto=V;function Y(Z,Q,se,de){const ge=H(Z,Q),Te=Z.splice(ge,se);return V(Z,ge,de),Te}e.splice=Y;function H(Z,Q){return Q<0?Math.max(Q+Z.length,0):Math.min(Q,Z.length)}function q(Z,Q){return(se,de)=>Q(Z(se),Z(de))}e.compareBy=q;const K=(Z,Q)=>Z-Q;e.numberComparator=K;function G(Z,Q){if(Z.length===0)return;let se=Z[0];for(let de=1;de<Z.length;de++){const ge=Z[de];Q(ge,se)>0&&(se=ge)}return se}e.findMaxBy=G;function ie(Z,Q){if(Z.length===0)return;let se=Z[0];for(let de=1;de<Z.length;de++){const ge=Z[de];Q(ge,se)>=0&&(se=ge)}return se}e.findLastMaxBy=ie;function oe(Z,Q){return G(Z,(se,de)=>-Q(se,de))}e.findMinBy=oe;class ue{constructor(Q){this.items=Q,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(Q){let se=this.firstIdx;for(;se<this.items.length&&Q(this.items[se]);)se++;const de=se===this.firstIdx?null:this.items.slice(this.firstIdx,se);return this.firstIdx=se,de}takeFromEndWhile(Q){let se=this.lastIdx;for(;se>=0&&Q(this.items[se]);)se--;const de=se===this.lastIdx?null:this.items.slice(se+1,this.lastIdx+1);return this.lastIdx=se,de}peek(){return this.items[this.firstIdx]}dequeue(){const Q=this.items[this.firstIdx];return this.firstIdx++,Q}takeCount(Q){const se=this.items.slice(this.firstIdx,this.firstIdx+Q);return this.firstIdx+=Q,se}}e.ArrayQueue=ue}),define(ve[74],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function h(n){const I=this;let T=!1,C;return function(){return T||(T=!0,C=n.apply(I,arguments)),C}}e.once=h}),define(ve[75],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class h{constructor(I){this._prefix=I,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=h,e.defaultGenerator=new h("id#")}),define(ve[76],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var h;(function(n){function I(m){return m&&typeof m=="object"&&typeof m[Symbol.iterator]=="function"}n.is=I;const T=Object.freeze([]);function C(){return T}n.empty=C;function*k(m){yield m}n.single=k;function S(m){return m||T}n.from=S;function R(m){return!m||m[Symbol.iterator]().next().done===!0}n.isEmpty=R;function F(m){return m[Symbol.iterator]().next().value}n.first=F;function D(m,s){for(const E of m)if(s(E))return!0;return!1}n.some=D;function p(m,s){for(const E of m)if(s(E))return E}n.find=p;function*_(m,s){for(const E of m)s(E)&&(yield E)}n.filter=_;function*g(m,s){let E=0;for(const l of m)yield s(l,E++)}n.map=g;function*d(...m){for(const s of m)for(const E of s)yield E}n.concat=d;function*v(m){for(const s of m)for(const E of s)yield E}n.concatNested=v;function A(m,s,E){let l=E;for(const i of m)l=s(l,i);return l}n.reduce=A;function*b(m,s,E=m.length){for(s<0&&(s+=m.length),E<0?E+=m.length:E>m.length&&(E=m.length);s<E;s++)yield m[s]}n.slice=b;function a(m,s=Number.POSITIVE_INFINITY){const E=[];if(s===0)return[E,m];const l=m[Symbol.iterator]();for(let i=0;i<s;i++){const r=l.next();if(r.done)return[E,n.empty()];E.push(r.value)}return[E,{[Symbol.iterator](){return l}}]}n.consume=a;function c(m,s,E=(l,i)=>l===i){const l=m[Symbol.iterator](),i=s[Symbol.iterator]();for(;;){const r=l.next(),t=i.next();if(r.done!==t.done)return!1;if(r.done)return!0;if(!E(r.value,t.value))return!1}}n.equals=c})(h=e.Iterable||(e.Iterable={}))}),define(ve[141],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var h;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(h=e.ScanError||(e.ScanError={}));var n;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(s){s.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function C(s,E=!1){let l=0,i=s.length,r="",t=0,o=16,f=0;function u(M){let B=0,V=0;for(;B<M;){const Y=s.charCodeAt(l);if(Y>=48&&Y<=57)V=V*16+Y-48;else if(Y>=65&&Y<=70)V=V*16+Y-65+10;else if(Y>=97&&Y<=102)V=V*16+Y-97+10;else break;l++,B++}return B<M&&(V=-1),V}function w(M){l=M,r="",t=0,o=16,f=0}function P(){const M=l;if(s.charCodeAt(l)===48)l++;else for(l++;l<s.length&&R(s.charCodeAt(l));)l++;if(l<s.length&&s.charCodeAt(l)===46)if(l++,l<s.length&&R(s.charCodeAt(l)))for(l++;l<s.length&&R(s.charCodeAt(l));)l++;else return f=3,s.substring(M,l);let B=l;if(l<s.length&&(s.charCodeAt(l)===69||s.charCodeAt(l)===101))if(l++,(l<s.length&&s.charCodeAt(l)===43||s.charCodeAt(l)===45)&&l++,l<s.length&&R(s.charCodeAt(l))){for(l++;l<s.length&&R(s.charCodeAt(l));)l++;B=l}else f=3;return s.substring(M,B)}function L(){let M="",B=l;for(;;){if(l>=i){M+=s.substring(B,l),f=2;break}const V=s.charCodeAt(l);if(V===34){M+=s.substring(B,l),l++;break}if(V===92){if(M+=s.substring(B,l),l++,l>=i){f=2;break}switch(s.charCodeAt(l++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const H=u(4);H>=0?M+=String.fromCharCode(H):f=4;break}default:f=5}B=l;continue}if(V>=0&&V<=31)if(S(V)){M+=s.substring(B,l),f=2;break}else f=6;l++}return M}function O(){if(r="",f=0,t=l,l>=i)return t=i,o=17;let M=s.charCodeAt(l);if(k(M)){do l++,r+=String.fromCharCode(M),M=s.charCodeAt(l);while(k(M));return o=15}if(S(M))return l++,r+=String.fromCharCode(M),M===13&&s.charCodeAt(l)===10&&(l++,r+=`
`),o=14;switch(M){case 123:return l++,o=1;case 125:return l++,o=2;case 91:return l++,o=3;case 93:return l++,o=4;case 58:return l++,o=6;case 44:return l++,o=5;case 34:return l++,r=L(),o=10;case 47:{const B=l-1;if(s.charCodeAt(l+1)===47){for(l+=2;l<i&&!S(s.charCodeAt(l));)l++;return r=s.substring(B,l),o=12}if(s.charCodeAt(l+1)===42){l+=2;const V=i-1;let Y=!1;for(;l<V;){if(s.charCodeAt(l)===42&&s.charCodeAt(l+1)===47){l+=2,Y=!0;break}l++}return Y||(l++,f=1),r=s.substring(B,l),o=13}return r+=String.fromCharCode(M),l++,o=16}case 45:if(r+=String.fromCharCode(M),l++,l===i||!R(s.charCodeAt(l)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=P(),o=11;default:for(;l<i&&y(M);)l++,M=s.charCodeAt(l);if(t!==l){switch(r=s.substring(t,l),r){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return r+=String.fromCharCode(M),l++,o=16}}function y(M){if(k(M)||S(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let M;do M=O();while(M>=12&&M<=15);return M}return{setPosition:w,getPosition:()=>l,scan:E?z:O,getToken:()=>o,getTokenValue:()=>r,getTokenOffset:()=>t,getTokenLength:()=>l-t,getTokenError:()=>f}}e.createScanner=C;function k(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function S(s){return s===10||s===13||s===8232||s===8233}function R(s){return s>=48&&s<=57}var F;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(F||(F={}));function D(s,E){const l=[],i=new Object;let r;const t={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function f(u,w,P,L){t.value=u,t.offset=w,t.length=P,t.type=L,t.colonOffset=void 0,r=t}try{a(s,{onObjectBegin:(u,w)=>{if(E<=u)throw i;r=void 0,o=E>u,l.push("")},onObjectProperty:(u,w,P)=>{if(E<w||(f(u,w,P,"property"),l[l.length-1]=u,E<=w+P))throw i},onObjectEnd:(u,w)=>{if(E<=u)throw i;r=void 0,l.pop()},onArrayBegin:(u,w)=>{if(E<=u)throw i;r=void 0,l.push(0)},onArrayEnd:(u,w)=>{if(E<=u)throw i;r=void 0,l.pop()},onLiteralValue:(u,w,P)=>{if(E<w||(f(u,w,P,m(u)),E<=w+P))throw i},onSeparator:(u,w,P)=>{if(E<=w)throw i;if(u===":"&&r&&r.type==="property")r.colonOffset=w,o=!1,r=void 0;else if(u===","){const L=l[l.length-1];typeof L=="number"?l[l.length-1]=L+1:(o=!0,l[l.length-1]=""),r=void 0}}})}catch(u){if(u!==i)throw u}return{path:l,previousNode:r,isAtPropertyKey:o,matches:u=>{let w=0;for(let P=0;w<u.length&&P<l.length;P++)if(u[w]===l[P]||u[w]==="*")w++;else if(u[w]!=="**")return!1;return w===u.length}}}e.getLocation=D;function p(s,E=[],l=T.DEFAULT){let i=null,r=[];const t=[];function o(u){Array.isArray(r)?r.push(u):i!==null&&(r[i]=u)}return a(s,{onObjectBegin:()=>{const u={};o(u),t.push(r),r=u,i=null},onObjectProperty:u=>{i=u},onObjectEnd:()=>{r=t.pop()},onArrayBegin:()=>{const u=[];o(u),t.push(r),r=u,i=null},onArrayEnd:()=>{r=t.pop()},onLiteralValue:o,onError:(u,w,P)=>{E.push({error:u,offset:w,length:P})}},l),r[0]}e.parse=p;function _(s,E=[],l=T.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(u){i.type==="property"&&(i.length=u-i.offset,i=i.parent)}function t(u){return i.children.push(u),u}a(s,{onObjectBegin:u=>{i=t({type:"object",offset:u,length:-1,parent:i,children:[]})},onObjectProperty:(u,w,P)=>{i=t({type:"property",offset:w,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:u,offset:w,length:P,parent:i})},onObjectEnd:(u,w)=>{i.length=u+w-i.offset,i=i.parent,r(u+w)},onArrayBegin:(u,w)=>{i=t({type:"array",offset:u,length:-1,parent:i,children:[]})},onArrayEnd:(u,w)=>{i.length=u+w-i.offset,i=i.parent,r(u+w)},onLiteralValue:(u,w,P)=>{t({type:m(u),offset:w,length:P,parent:i,value:u}),r(w+P)},onSeparator:(u,w,P)=>{i.type==="property"&&(u===":"?i.colonOffset=w:u===","&&r(w))},onError:(u,w,P)=>{E.push({error:u,offset:w,length:P})}},l);const f=i.children[0];return f&&delete f.parent,f}e.parseTree=_;function g(s,E){if(!s)return;let l=s;for(let i of E)if(typeof i=="string"){if(l.type!=="object"||!Array.isArray(l.children))return;let r=!1;for(const t of l.children)if(Array.isArray(t.children)&&t.children[0].value===i){l=t.children[1],r=!0;break}if(!r)return}else{const r=i;if(l.type!=="array"||r<0||!Array.isArray(l.children)||r>=l.children.length)return;l=l.children[r]}return l}e.findNodeAtLocation=g;function d(s){if(!s.parent||!s.parent.children)return[];const E=d(s.parent);if(s.parent.type==="property"){const l=s.parent.children[0].value;E.push(l)}else if(s.parent.type==="array"){const l=s.parent.children.indexOf(s);l!==-1&&E.push(l)}return E}e.getNodePath=d;function v(s){switch(s.type){case"array":return s.children.map(v);case"object":{const E=Object.create(null);for(let l of s.children){const i=l.children[1];i&&(E[l.children[0].value]=v(i))}return E}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=v;function A(s,E,l=!1){return E>=s.offset&&E<s.offset+s.length||l&&E===s.offset+s.length}e.contains=A;function b(s,E,l=!1){if(A(s,E,l)){const i=s.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=E;r++){const t=b(i[r],E,l);if(t)return t}return s}}e.findNodeAtOffset=b;function a(s,E,l=T.DEFAULT){const i=C(s,!1);function r(ue){return ue?()=>ue(i.getTokenOffset(),i.getTokenLength()):()=>!0}function t(ue){return ue?Z=>ue(Z,i.getTokenOffset(),i.getTokenLength()):()=>!0}const o=r(E.onObjectBegin),f=t(E.onObjectProperty),u=r(E.onObjectEnd),w=r(E.onArrayBegin),P=r(E.onArrayEnd),L=t(E.onLiteralValue),O=t(E.onSeparator),y=r(E.onComment),z=t(E.onError),M=l&&l.disallowComments,B=l&&l.allowTrailingComma;function V(){for(;;){const ue=i.scan();switch(i.getTokenError()){case 4:Y(14);break;case 5:Y(15);break;case 3:Y(13);break;case 1:M||Y(11);break;case 2:Y(12);break;case 6:Y(16);break}switch(ue){case 12:case 13:M?Y(10):y();break;case 16:Y(1);break;case 15:case 14:break;default:return ue}}}function Y(ue,Z=[],Q=[]){if(z(ue),Z.length+Q.length>0){let se=i.getToken();for(;se!==17;){if(Z.indexOf(se)!==-1){V();break}else if(Q.indexOf(se)!==-1)break;se=V()}}}function H(ue){const Z=i.getTokenValue();return ue?L(Z):f(Z),V(),!0}function q(){switch(i.getToken()){case 11:{let ue=0;try{ue=JSON.parse(i.getTokenValue()),typeof ue!="number"&&(Y(2),ue=0)}catch{Y(2)}L(ue);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return V(),!0}function K(){return i.getToken()!==10?(Y(3,[],[2,5]),!1):(H(!1),i.getToken()===6?(O(":"),V(),oe()||Y(4,[],[2,5])):Y(5,[],[2,5]),!0)}function G(){o(),V();let ue=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ue||Y(4,[],[]),O(","),V(),i.getToken()===2&&B)break}else ue&&Y(6,[],[]);K()||Y(4,[],[2,5]),ue=!0}return u(),i.getToken()!==2?Y(7,[2],[]):V(),!0}function ie(){w(),V();let ue=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ue||Y(4,[],[]),O(","),V(),i.getToken()===4&&B)break}else ue&&Y(6,[],[]);oe()||Y(4,[],[4,5]),ue=!0}return P(),i.getToken()!==4?Y(8,[4],[]):V(),!0}function oe(){switch(i.getToken()){case 3:return ie();case 1:return G();case 10:return H(!0);default:return q()}}return V(),i.getToken()===17?l.allowEmptyContent?!0:(Y(4,[],[]),!1):oe()?(i.getToken()!==17&&Y(9,[],[]),!0):(Y(4,[],[]),!1)}e.visit=a;function c(s,E){let l=C(s),i=[],r,t=0,o;do switch(o=l.getPosition(),r=l.scan(),r){case 12:case 13:case 17:t!==o&&i.push(s.substring(t,o)),E!==void 0&&i.push(l.getTokenValue().replace(/[^\r\n]/g,E)),t=l.getPosition();break}while(r!==17);return i.join("")}e.stripComments=c;function m(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=m}),define(ve[89],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class h{constructor(I){this.executor=I,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(I){this._error=I}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(I){return new h(()=>I(this.getValue()))}}e.Lazy=h}),define(ve[6],we([1,0,74,76]),function(ee,e,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const I=!1;let T=null;function C(r){T=r}if(e.setDisposableTracker=C,I){const r="__is_disposable_tracked__";C(new class{trackDisposable(t){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{t[r]||console.log(o)},3e3)}setParent(t,o){if(t&&t!==b.None)try{t[r]=!0}catch{}}markAsDisposed(t){if(t&&t!==b.None)try{t[r]=!0}catch{}}markAsSingleton(t){}})}function k(r){return T?.trackDisposable(r),r}function S(r){T?.markAsDisposed(r)}function R(r,t){T?.setParent(r,t)}function F(r,t){if(!!T)for(const o of r)T.setParent(o,t)}function D(r){return T?.markAsSingleton(r),r}e.markAsSingleton=D;class p extends Error{constructor(t){super(`Encountered errors while disposing of store. Errors: [${t.join(", ")}]`);this.errors=t}}e.MultiDisposeError=p;function _(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=_;function g(r){if(n.Iterable.is(r)){let t=[];for(const o of r)if(o)try{o.dispose()}catch(f){t.push(f)}if(t.length===1)throw t[0];if(t.length>1)throw new p(t);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=g;function d(...r){const t=v(()=>g(r));return F(r,t),t}e.combinedDisposable=d;function v(r){const t=k({dispose:(0,h.once)(()=>{S(t),r()})});return t}e.toDisposable=v;class A{constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{g(this._toDispose.values())}finally{this._toDispose.clear()}}add(t){if(!t)return t;if(t===this)throw new Error("Cannot register a disposable on itself!");return R(t,this),this._isDisposed?A.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(t),t}}e.DisposableStore=A,A.DISABLE_DISPOSED_WARNING=!1;class b{constructor(){this._store=new A,k(this),R(this._store,this)}dispose(){S(this),this._store.dispose()}_register(t){if(t===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(t)}}e.Disposable=b,b.None=Object.freeze({dispose(){}});class a{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(t){this._isDisposed||t===this._value||(this._value?.dispose(),t&&R(t,this),this._value=t)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const t=this._value;return this._value=void 0,t&&R(t,null),t}}e.MutableDisposable=a;class c{constructor(t){this._disposable=t,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class m{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(t){let o=t;return this.unset=()=>o=void 0,this.isset=()=>o!==void 0,this.dispose=()=>{o&&(o(),o=void 0,S(this))},this}}e.SafeDisposable=m;class s{constructor(){this.references=new Map}acquire(t,...o){let f=this.references.get(t);f||(f={counter:0,object:this.createReferencedObject(t,...o)},this.references.set(t,f));const{object:u}=f,w=(0,h.once)(()=>{--f.counter==0&&(this.destroyReferencedObject(t,f.object),this.references.delete(t))});return f.counter++,{object:u,dispose:w}}}e.ReferenceCollection=s;class E{constructor(t){this.referenceCollection=t}async acquire(t,...o){const f=this.referenceCollection.acquire(t,...o);try{return{object:await f.object,dispose:()=>f.dispose()}}catch(u){throw f.dispose(),u}}}e.AsyncReferenceCollection=E;class l{constructor(t){this.object=t}dispose(){}}e.ImmortalReference=l;function i(r){const t=new A;try{r(t)}finally{t.dispose()}}e.disposeOnReturn=i}),define(ve[90],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class h{constructor(T){this.element=T,this.next=h.Undefined,this.prev=h.Undefined}}h.Undefined=new h(void 0);class n{constructor(){this._first=h.Undefined,this._last=h.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===h.Undefined}clear(){let T=this._first;for(;T!==h.Undefined;){const C=T.next;T.prev=h.Undefined,T.next=h.Undefined,T=C}this._first=h.Undefined,this._last=h.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,C){const k=new h(T);if(this._first===h.Undefined)this._first=k,this._last=k;else if(C){const R=this._last;this._last=k,k.prev=R,R.next=k}else{const R=this._first;this._first=k,k.next=R,R.prev=k}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(k))}}shift(){if(this._first!==h.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==h.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==h.Undefined&&T.next!==h.Undefined){const C=T.prev;C.next=T.next,T.next.prev=C}else T.prev===h.Undefined&&T.next===h.Undefined?(this._first=h.Undefined,this._last=h.Undefined):T.next===h.Undefined?(this._last=this._last.prev,this._last.next=h.Undefined):T.prev===h.Undefined&&(this._first=this._first.next,this._first.prev=h.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==h.Undefined;)yield T.element,T=T.next}}e.LinkedList=n}),function(ee,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(ve[142],we([0]),e):(ee=typeof globalThis!="undefined"?globalThis:ee||self,e(ee.marked={}))}(this,function(ee){"use strict";function e(be,Ee){for(var $=0;$<Ee.length;$++){var U=Ee[$];U.enumerable=U.enumerable||!1,U.configurable=!0,"value"in U&&(U.writable=!0),Object.defineProperty(be,U.key,U)}}function h(be,Ee,$){return Ee&&e(be.prototype,Ee),$&&e(be,$),Object.defineProperty(be,"prototype",{writable:!1}),be}function n(be,Ee){if(!!be){if(typeof be=="string")return I(be,Ee);var $=Object.prototype.toString.call(be).slice(8,-1);if($==="Object"&&be.constructor&&($=be.constructor.name),$==="Map"||$==="Set")return Array.from(be);if($==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test($))return I(be,Ee)}}function I(be,Ee){(Ee==null||Ee>be.length)&&(Ee=be.length);for(var $=0,U=new Array(Ee);$<Ee;$++)U[$]=be[$];return U}function T(be,Ee){var $=typeof Symbol!="undefined"&&be[Symbol.iterator]||be["@@iterator"];if($)return($=$.call(be)).next.bind($);if(Array.isArray(be)||($=n(be))||Ee&&be&&typeof be.length=="number"){$&&(be=$);var U=0;return function(){return U>=be.length?{done:!0}:{done:!1,value:be[U++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ee.defaults=C();function k(be){ee.defaults=be}var S=/[&<>"']/,R=/[&<>"']/g,F=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,p={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},_=function(Ee){return p[Ee]};function g(be,Ee){if(Ee){if(S.test(be))return be.replace(R,_)}else if(F.test(be))return be.replace(D,_);return be}var d=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function v(be){return be.replace(d,function(Ee,$){return $=$.toLowerCase(),$==="colon"?":":$.charAt(0)==="#"?$.charAt(1)==="x"?String.fromCharCode(parseInt($.substring(2),16)):String.fromCharCode(+$.substring(1)):""})}var A=/(^|[^\[])\^/g;function b(be,Ee){be=be.source||be,Ee=Ee||"";var $={replace:function(N,W){return W=W.source||W,W=W.replace(A,"$1"),be=be.replace(N,W),$},getRegex:function(){return new RegExp(be,Ee)}};return $}var a=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function m(be,Ee,$){if(be){var U;try{U=decodeURIComponent(v($)).replace(a,"").toLowerCase()}catch{return null}if(U.indexOf("javascript:")===0||U.indexOf("vbscript:")===0||U.indexOf("data:")===0)return null}Ee&&!c.test($)&&($=r(Ee,$));try{$=encodeURI($).replace(/%25/g,"%")}catch{return null}return $}var s={},E=/^[^:]+:\/*[^/]*$/,l=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(be,Ee){s[" "+be]||(E.test(be)?s[" "+be]=be+"/":s[" "+be]=u(be,"/",!0)),be=s[" "+be];var $=be.indexOf(":")===-1;return Ee.substring(0,2)==="//"?$?Ee:be.replace(l,"$1")+Ee:Ee.charAt(0)==="/"?$?Ee:be.replace(i,"$1")+Ee:be+Ee}var t={exec:function(){}};function o(be){for(var Ee=1,$,U;Ee<arguments.length;Ee++){$=arguments[Ee];for(U in $)Object.prototype.hasOwnProperty.call($,U)&&(be[U]=$[U])}return be}function f(be,Ee){var $=be.replace(/\|/g,function(W,j,re){for(var he=!1,Ce=j;--Ce>=0&&re[Ce]==="\\";)he=!he;return he?"|":" |"}),U=$.split(/ \|/),N=0;if(U[0].trim()||U.shift(),U[U.length-1].trim()||U.pop(),U.length>Ee)U.splice(Ee);else for(;U.length<Ee;)U.push("");for(;N<U.length;N++)U[N]=U[N].trim().replace(/\\\|/g,"|");return U}function u(be,Ee,$){var U=be.length;if(U===0)return"";for(var N=0;N<U;){var W=be.charAt(U-N-1);if(W===Ee&&!$)N++;else if(W!==Ee&&$)N++;else break}return be.substr(0,U-N)}function w(be,Ee){if(be.indexOf(Ee[1])===-1)return-1;for(var $=be.length,U=0,N=0;N<$;N++)if(be[N]==="\\")N++;else if(be[N]===Ee[0])U++;else if(be[N]===Ee[1]&&(U--,U<0))return N;return-1}function P(be){be&&be.sanitize&&!be.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(be,Ee){if(Ee<1)return"";for(var $="";Ee>1;)Ee&1&&($+=be),Ee>>=1,be+=be;return $+be}function O(be,Ee,$,U){var N=Ee.href,W=Ee.title?g(Ee.title):null,j=be[1].replace(/\\([\[\]])/g,"$1");if(be[0].charAt(0)!=="!"){U.state.inLink=!0;var re={type:"link",raw:$,href:N,title:W,text:j,tokens:U.inlineTokens(j,[])};return U.state.inLink=!1,re}else return{type:"image",raw:$,href:N,title:W,text:g(j)}}function y(be,Ee){var $=be.match(/^(\s+)(?:```)/);if($===null)return Ee;var U=$[1];return Ee.split(`
`).map(function(N){var W=N.match(/^\s+/);if(W===null)return N;var j=W[0];return j.length>=U.length?N.slice(U.length):N}).join(`
`)}var z=function(){function be($){this.options=$||ee.defaults}var Ee=be.prototype;return Ee.space=function(U){var N=this.rules.block.newline.exec(U);if(N&&N[0].length>0)return{type:"space",raw:N[0]}},Ee.code=function(U){var N=this.rules.block.code.exec(U);if(N){var W=N[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:N[0],codeBlockStyle:"indented",text:this.options.pedantic?W:u(W,`
`)}}},Ee.fences=function(U){var N=this.rules.block.fences.exec(U);if(N){var W=N[0],j=y(W,N[3]||"");return{type:"code",raw:W,lang:N[2]?N[2].trim():N[2],text:j}}},Ee.heading=function(U){var N=this.rules.block.heading.exec(U);if(N){var W=N[2].trim();if(/#$/.test(W)){var j=u(W,"#");(this.options.pedantic||!j||/ $/.test(j))&&(W=j.trim())}var re={type:"heading",raw:N[0],depth:N[1].length,text:W,tokens:[]};return this.lexer.inline(re.text,re.tokens),re}},Ee.hr=function(U){var N=this.rules.block.hr.exec(U);if(N)return{type:"hr",raw:N[0]}},Ee.blockquote=function(U){var N=this.rules.block.blockquote.exec(U);if(N){var W=N[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:N[0],tokens:this.lexer.blockTokens(W,[]),text:W}}},Ee.list=function(U){var N=this.rules.block.list.exec(U);if(N){var W,j,re,he,Ce,Ae,We,ze,qe,He,Ue,Je,et=N[1].trim(),Le=et.length>1,it={type:"list",raw:"",ordered:Le,start:Le?+et.slice(0,-1):"",loose:!1,items:[]};et=Le?"\\d{1,9}\\"+et.slice(-1):"\\"+et,this.options.pedantic&&(et=Le?et:"[*+-]");for(var ne=new RegExp("^( {0,3}"+et+")((?: [^\\n]*)?(?:\\n|$))");U&&(Je=!1,!(!(N=ne.exec(U))||this.rules.block.hr.test(U)));){if(W=N[0],U=U.substring(W.length),ze=N[2].split(`
`,1)[0],qe=U.split(`
`,1)[0],this.options.pedantic?(he=2,Ue=ze.trimLeft()):(he=N[2].search(/[^ ]/),he=he>4?1:he,Ue=ze.slice(he),he+=N[1].length),Ae=!1,!ze&&/^ *$/.test(qe)&&(W+=qe+`
`,U=U.substring(qe.length+1),Je=!0),!Je)for(var ae=new RegExp("^ {0,"+Math.min(3,he-1)+"}(?:[*+-]|\\d{1,9}[.)])");U&&(He=U.split(`
`,1)[0],ze=He,this.options.pedantic&&(ze=ze.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!ae.test(ze));){if(ze.search(/[^ ]/)>=he||!ze.trim())Ue+=`
`+ze.slice(he);else if(!Ae)Ue+=`
`+ze;else break;!Ae&&!ze.trim()&&(Ae=!0),W+=He+`
`,U=U.substring(He.length+1)}it.loose||(We?it.loose=!0:/\n *\n *$/.test(W)&&(We=!0)),this.options.gfm&&(j=/^\[[ xX]\] /.exec(Ue),j&&(re=j[0]!=="[ ] ",Ue=Ue.replace(/^\[[ xX]\] +/,""))),it.items.push({type:"list_item",raw:W,task:!!j,checked:re,loose:!1,text:Ue}),it.raw+=W}it.items[it.items.length-1].raw=W.trimRight(),it.items[it.items.length-1].text=Ue.trimRight(),it.raw=it.raw.trimRight();var J=it.items.length;for(Ce=0;Ce<J;Ce++){this.lexer.state.top=!1,it.items[Ce].tokens=this.lexer.blockTokens(it.items[Ce].text,[]);var pe=it.items[Ce].tokens.filter(function(Me){return Me.type==="space"}),Se=pe.every(function(Me){for(var $e=Me.raw.split(""),Ye=0,lt=T($e),vt;!(vt=lt()).done;){var wt=vt.value;if(wt===`
`&&(Ye+=1),Ye>1)return!0}return!1});!it.loose&&pe.length&&Se&&(it.loose=!0,it.items[Ce].loose=!0)}return it}},Ee.html=function(U){var N=this.rules.block.html.exec(U);if(N){var W={type:"html",raw:N[0],pre:!this.options.sanitizer&&(N[1]==="pre"||N[1]==="script"||N[1]==="style"),text:N[0]};return this.options.sanitize&&(W.type="paragraph",W.text=this.options.sanitizer?this.options.sanitizer(N[0]):g(N[0]),W.tokens=[],this.lexer.inline(W.text,W.tokens)),W}},Ee.def=function(U){var N=this.rules.block.def.exec(U);if(N){N[3]&&(N[3]=N[3].substring(1,N[3].length-1));var W=N[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:W,raw:N[0],href:N[2],title:N[3]}}},Ee.table=function(U){var N=this.rules.block.table.exec(U);if(N){var W={type:"table",header:f(N[1]).map(function(We){return{text:We}}),align:N[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:N[3]?N[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(W.header.length===W.align.length){W.raw=N[0];var j=W.align.length,re,he,Ce,Ae;for(re=0;re<j;re++)/^ *-+: *$/.test(W.align[re])?W.align[re]="right":/^ *:-+: *$/.test(W.align[re])?W.align[re]="center":/^ *:-+ *$/.test(W.align[re])?W.align[re]="left":W.align[re]=null;for(j=W.rows.length,re=0;re<j;re++)W.rows[re]=f(W.rows[re],W.header.length).map(function(We){return{text:We}});for(j=W.header.length,he=0;he<j;he++)W.header[he].tokens=[],this.lexer.inlineTokens(W.header[he].text,W.header[he].tokens);for(j=W.rows.length,he=0;he<j;he++)for(Ae=W.rows[he],Ce=0;Ce<Ae.length;Ce++)Ae[Ce].tokens=[],this.lexer.inlineTokens(Ae[Ce].text,Ae[Ce].tokens);return W}}},Ee.lheading=function(U){var N=this.rules.block.lheading.exec(U);if(N){var W={type:"heading",raw:N[0],depth:N[2].charAt(0)==="="?1:2,text:N[1],tokens:[]};return this.lexer.inline(W.text,W.tokens),W}},Ee.paragraph=function(U){var N=this.rules.block.paragraph.exec(U);if(N){var W={type:"paragraph",raw:N[0],text:N[1].charAt(N[1].length-1)===`
`?N[1].slice(0,-1):N[1],tokens:[]};return this.lexer.inline(W.text,W.tokens),W}},Ee.text=function(U){var N=this.rules.block.text.exec(U);if(N){var W={type:"text",raw:N[0],text:N[0],tokens:[]};return this.lexer.inline(W.text,W.tokens),W}},Ee.escape=function(U){var N=this.rules.inline.escape.exec(U);if(N)return{type:"escape",raw:N[0],text:g(N[1])}},Ee.tag=function(U){var N=this.rules.inline.tag.exec(U);if(N)return!this.lexer.state.inLink&&/^<a /i.test(N[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(N[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(N[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(N[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:N[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(N[0]):g(N[0]):N[0]}},Ee.link=function(U){var N=this.rules.inline.link.exec(U);if(N){var W=N[2].trim();if(!this.options.pedantic&&/^</.test(W)){if(!/>$/.test(W))return;var j=u(W.slice(0,-1),"\\");if((W.length-j.length)%2==0)return}else{var re=w(N[2],"()");if(re>-1){var he=N[0].indexOf("!")===0?5:4,Ce=he+N[1].length+re;N[2]=N[2].substring(0,re),N[0]=N[0].substring(0,Ce).trim(),N[3]=""}}var Ae=N[2],We="";if(this.options.pedantic){var ze=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);ze&&(Ae=ze[1],We=ze[3])}else We=N[3]?N[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(W)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),O(N,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:We&&We.replace(this.rules.inline._escapes,"$1")},N[0],this.lexer)}},Ee.reflink=function(U,N){var W;if((W=this.rules.inline.reflink.exec(U))||(W=this.rules.inline.nolink.exec(U))){var j=(W[2]||W[1]).replace(/\s+/g," ");if(j=N[j.toLowerCase()],!j||!j.href){var re=W[0].charAt(0);return{type:"text",raw:re,text:re}}return O(W,j,W[0],this.lexer)}},Ee.emStrong=function(U,N,W){W===void 0&&(W="");var j=this.rules.inline.emStrong.lDelim.exec(U);if(!!j&&!(j[3]&&W.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var re=j[1]||j[2]||"";if(!re||re&&(W===""||this.rules.inline.punctuation.exec(W))){var he=j[0].length-1,Ce,Ae,We=he,ze=0,qe=j[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(qe.lastIndex=0,N=N.slice(-1*U.length+he);(j=qe.exec(N))!=null;)if(Ce=j[1]||j[2]||j[3]||j[4]||j[5]||j[6],!!Ce){if(Ae=Ce.length,j[3]||j[4]){We+=Ae;continue}else if((j[5]||j[6])&&he%3&&!((he+Ae)%3)){ze+=Ae;continue}if(We-=Ae,!(We>0)){if(Ae=Math.min(Ae,Ae+We+ze),Math.min(he,Ae)%2){var He=U.slice(1,he+j.index+Ae);return{type:"em",raw:U.slice(0,he+j.index+Ae+1),text:He,tokens:this.lexer.inlineTokens(He,[])}}var Ue=U.slice(2,he+j.index+Ae-1);return{type:"strong",raw:U.slice(0,he+j.index+Ae+1),text:Ue,tokens:this.lexer.inlineTokens(Ue,[])}}}}}},Ee.codespan=function(U){var N=this.rules.inline.code.exec(U);if(N){var W=N[2].replace(/\n/g," "),j=/[^ ]/.test(W),re=/^ /.test(W)&&/ $/.test(W);return j&&re&&(W=W.substring(1,W.length-1)),W=g(W,!0),{type:"codespan",raw:N[0],text:W}}},Ee.br=function(U){var N=this.rules.inline.br.exec(U);if(N)return{type:"br",raw:N[0]}},Ee.del=function(U){var N=this.rules.inline.del.exec(U);if(N)return{type:"del",raw:N[0],text:N[2],tokens:this.lexer.inlineTokens(N[2],[])}},Ee.autolink=function(U,N){var W=this.rules.inline.autolink.exec(U);if(W){var j,re;return W[2]==="@"?(j=g(this.options.mangle?N(W[1]):W[1]),re="mailto:"+j):(j=g(W[1]),re=j),{type:"link",raw:W[0],text:j,href:re,tokens:[{type:"text",raw:j,text:j}]}}},Ee.url=function(U,N){var W;if(W=this.rules.inline.url.exec(U)){var j,re;if(W[2]==="@")j=g(this.options.mangle?N(W[0]):W[0]),re="mailto:"+j;else{var he;do he=W[0],W[0]=this.rules.inline._backpedal.exec(W[0])[0];while(he!==W[0]);j=g(W[0]),W[1]==="www."?re="http://"+j:re=j}return{type:"link",raw:W[0],text:j,href:re,tokens:[{type:"text",raw:j,text:j}]}}},Ee.inlineText=function(U,N){var W=this.rules.inline.text.exec(U);if(W){var j;return this.lexer.state.inRawBlock?j=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(W[0]):g(W[0]):W[0]:j=g(this.options.smartypants?N(W[0]):W[0]),{type:"text",raw:W[0],text:j}}},be}(),M={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:t,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};M._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,M._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,M.def=b(M.def).replace("label",M._label).replace("title",M._title).getRegex(),M.bullet=/(?:[*+-]|\d{1,9}[.)])/,M.listItemStart=b(/^( *)(bull) */).replace("bull",M.bullet).getRegex(),M.list=b(M.list).replace(/bull/g,M.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+M.def.source+")").getRegex(),M._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",M._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,M.html=b(M.html,"i").replace("comment",M._comment).replace("tag",M._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),M.paragraph=b(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.blockquote=b(M.blockquote).replace("paragraph",M.paragraph).getRegex(),M.normal=o({},M),M.gfm=o({},M.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),M.gfm.table=b(M.gfm.table).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.gfm.paragraph=b(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",M.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.pedantic=o({},M.normal,{html:b(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",M._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:t,paragraph:b(M.normal._paragraph).replace("hr",M.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",M.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var B={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:t,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:t,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};B._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",B.punctuation=b(B.punctuation).replace(/punctuation/g,B._punctuation).getRegex(),B.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,B.escapedEmSt=/\\\*|\\_/g,B._comment=b(M._comment).replace("(?:-->|$)","-->").getRegex(),B.emStrong.lDelim=b(B.emStrong.lDelim).replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimAst=b(B.emStrong.rDelimAst,"g").replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimUnd=b(B.emStrong.rDelimUnd,"g").replace(/punct/g,B._punctuation).getRegex(),B._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,B._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,B._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,B.autolink=b(B.autolink).replace("scheme",B._scheme).replace("email",B._email).getRegex(),B._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,B.tag=b(B.tag).replace("comment",B._comment).replace("attribute",B._attribute).getRegex(),B._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,B._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,B._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,B.link=b(B.link).replace("label",B._label).replace("href",B._href).replace("title",B._title).getRegex(),B.reflink=b(B.reflink).replace("label",B._label).replace("ref",M._label).getRegex(),B.nolink=b(B.nolink).replace("ref",M._label).getRegex(),B.reflinkSearch=b(B.reflinkSearch,"g").replace("reflink",B.reflink).replace("nolink",B.nolink).getRegex(),B.normal=o({},B),B.pedantic=o({},B.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:b(/^!?\[(label)\]\((.*?)\)/).replace("label",B._label).getRegex(),reflink:b(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",B._label).getRegex()}),B.gfm=o({},B.normal,{escape:b(B.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),B.gfm.url=b(B.gfm.url,"i").replace("email",B.gfm._extended_email).getRegex(),B.breaks=o({},B.gfm,{br:b(B.br).replace("{2,}","*").getRegex(),text:b(B.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function V(be){return be.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Y(be){var Ee="",$,U,N=be.length;for($=0;$<N;$++)U=be.charCodeAt($),Math.random()>.5&&(U="x"+U.toString(16)),Ee+="&#"+U+";";return Ee}var H=function(){function be($){this.tokens=[],this.tokens.links=Object.create(null),this.options=$||ee.defaults,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var U={block:M.normal,inline:B.normal};this.options.pedantic?(U.block=M.pedantic,U.inline=B.pedantic):this.options.gfm&&(U.block=M.gfm,this.options.breaks?U.inline=B.breaks:U.inline=B.gfm),this.tokenizer.rules=U}be.lex=function(U,N){var W=new be(N);return W.lex(U)},be.lexInline=function(U,N){var W=new be(N);return W.inlineTokens(U)};var Ee=be.prototype;return Ee.lex=function(U){U=U.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(U,this.tokens);for(var N;N=this.inlineQueue.shift();)this.inlineTokens(N.src,N.tokens);return this.tokens},Ee.blockTokens=function(U,N){var W=this;N===void 0&&(N=[]),this.options.pedantic&&(U=U.replace(/^ +$/gm,""));for(var j,re,he,Ce;U;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(We){return(j=We.call({lexer:W},U,N))?(U=U.substring(j.raw.length),N.push(j),!0):!1}))){if(j=this.tokenizer.space(U)){U=U.substring(j.raw.length),j.raw.length===1&&N.length>0?N[N.length-1].raw+=`
`:N.push(j);continue}if(j=this.tokenizer.code(U)){U=U.substring(j.raw.length),re=N[N.length-1],re&&(re.type==="paragraph"||re.type==="text")?(re.raw+=`
`+j.raw,re.text+=`
`+j.text,this.inlineQueue[this.inlineQueue.length-1].src=re.text):N.push(j);continue}if(j=this.tokenizer.fences(U)){U=U.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.heading(U)){U=U.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.hr(U)){U=U.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.blockquote(U)){U=U.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.list(U)){U=U.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.html(U)){U=U.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.def(U)){U=U.substring(j.raw.length),re=N[N.length-1],re&&(re.type==="paragraph"||re.type==="text")?(re.raw+=`
`+j.raw,re.text+=`
`+j.raw,this.inlineQueue[this.inlineQueue.length-1].src=re.text):this.tokens.links[j.tag]||(this.tokens.links[j.tag]={href:j.href,title:j.title});continue}if(j=this.tokenizer.table(U)){U=U.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.lheading(U)){U=U.substring(j.raw.length),N.push(j);continue}if(he=U,this.options.extensions&&this.options.extensions.startBlock&&function(){var We=1/0,ze=U.slice(1),qe=void 0;W.options.extensions.startBlock.forEach(function(He){qe=He.call({lexer:this},ze),typeof qe=="number"&&qe>=0&&(We=Math.min(We,qe))}),We<1/0&&We>=0&&(he=U.substring(0,We+1))}(),this.state.top&&(j=this.tokenizer.paragraph(he))){re=N[N.length-1],Ce&&re.type==="paragraph"?(re.raw+=`
`+j.raw,re.text+=`
`+j.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=re.text):N.push(j),Ce=he.length!==U.length,U=U.substring(j.raw.length);continue}if(j=this.tokenizer.text(U)){U=U.substring(j.raw.length),re=N[N.length-1],re&&re.type==="text"?(re.raw+=`
`+j.raw,re.text+=`
`+j.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=re.text):N.push(j);continue}if(U){var Ae="Infinite loop on byte: "+U.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,N},Ee.inline=function(U,N){this.inlineQueue.push({src:U,tokens:N})},Ee.inlineTokens=function(U,N){var W=this;N===void 0&&(N=[]);var j,re,he,Ce=U,Ae,We,ze;if(this.tokens.links){var qe=Object.keys(this.tokens.links);if(qe.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)qe.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,Ae.index)+"["+L("a",Ae[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,Ae.index)+"["+L("a",Ae[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,Ae.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;U;)if(We||(ze=""),We=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ue){return(j=Ue.call({lexer:W},U,N))?(U=U.substring(j.raw.length),N.push(j),!0):!1}))){if(j=this.tokenizer.escape(U)){U=U.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.tag(U)){U=U.substring(j.raw.length),re=N[N.length-1],re&&j.type==="text"&&re.type==="text"?(re.raw+=j.raw,re.text+=j.text):N.push(j);continue}if(j=this.tokenizer.link(U)){U=U.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.reflink(U,this.tokens.links)){U=U.substring(j.raw.length),re=N[N.length-1],re&&j.type==="text"&&re.type==="text"?(re.raw+=j.raw,re.text+=j.text):N.push(j);continue}if(j=this.tokenizer.emStrong(U,Ce,ze)){U=U.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.codespan(U)){U=U.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.br(U)){U=U.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.del(U)){U=U.substring(j.raw.length),N.push(j);continue}if(j=this.tokenizer.autolink(U,Y)){U=U.substring(j.raw.length),N.push(j);continue}if(!this.state.inLink&&(j=this.tokenizer.url(U,Y))){U=U.substring(j.raw.length),N.push(j);continue}if(he=U,this.options.extensions&&this.options.extensions.startInline&&function(){var Ue=1/0,Je=U.slice(1),et=void 0;W.options.extensions.startInline.forEach(function(Le){et=Le.call({lexer:this},Je),typeof et=="number"&&et>=0&&(Ue=Math.min(Ue,et))}),Ue<1/0&&Ue>=0&&(he=U.substring(0,Ue+1))}(),j=this.tokenizer.inlineText(he,V)){U=U.substring(j.raw.length),j.raw.slice(-1)!=="_"&&(ze=j.raw.slice(-1)),We=!0,re=N[N.length-1],re&&re.type==="text"?(re.raw+=j.raw,re.text+=j.text):N.push(j);continue}if(U){var He="Infinite loop on byte: "+U.charCodeAt(0);if(this.options.silent){console.error(He);break}else throw new Error(He)}}return N},h(be,null,[{key:"rules",get:function(){return{block:M,inline:B}}}]),be}(),q=function(){function be($){this.options=$||ee.defaults}var Ee=be.prototype;return Ee.code=function(U,N,W){var j=(N||"").match(/\S*/)[0];if(this.options.highlight){var re=this.options.highlight(U,j);re!=null&&re!==U&&(W=!0,U=re)}return U=U.replace(/\n$/,"")+`
`,j?'<pre><code class="'+this.options.langPrefix+g(j,!0)+'">'+(W?U:g(U,!0))+`</code></pre>
`:"<pre><code>"+(W?U:g(U,!0))+`</code></pre>
`},Ee.blockquote=function(U){return`<blockquote>
`+U+`</blockquote>
`},Ee.html=function(U){return U},Ee.heading=function(U,N,W,j){return this.options.headerIds?"<h"+N+' id="'+this.options.headerPrefix+j.slug(W)+'">'+U+"</h"+N+`>
`:"<h"+N+">"+U+"</h"+N+`>
`},Ee.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ee.list=function(U,N,W){var j=N?"ol":"ul",re=N&&W!==1?' start="'+W+'"':"";return"<"+j+re+`>
`+U+"</"+j+`>
`},Ee.listitem=function(U){return"<li>"+U+`</li>
`},Ee.checkbox=function(U){return"<input "+(U?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ee.paragraph=function(U){return"<p>"+U+`</p>
`},Ee.table=function(U,N){return N&&(N="<tbody>"+N+"</tbody>"),`<table>
<thead>
`+U+`</thead>
`+N+`</table>
`},Ee.tablerow=function(U){return`<tr>
`+U+`</tr>
`},Ee.tablecell=function(U,N){var W=N.header?"th":"td",j=N.align?"<"+W+' align="'+N.align+'">':"<"+W+">";return j+U+"</"+W+`>
`},Ee.strong=function(U){return"<strong>"+U+"</strong>"},Ee.em=function(U){return"<em>"+U+"</em>"},Ee.codespan=function(U){return"<code>"+U+"</code>"},Ee.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ee.del=function(U){return"<del>"+U+"</del>"},Ee.link=function(U,N,W){if(U=m(this.options.sanitize,this.options.baseUrl,U),U===null)return W;var j='<a href="'+g(U)+'"';return N&&(j+=' title="'+N+'"'),j+=">"+W+"</a>",j},Ee.image=function(U,N,W){if(U=m(this.options.sanitize,this.options.baseUrl,U),U===null)return W;var j='<img src="'+U+'" alt="'+W+'"';return N&&(j+=' title="'+N+'"'),j+=this.options.xhtml?"/>":">",j},Ee.text=function(U){return U},be}(),K=function(){function be(){}var Ee=be.prototype;return Ee.strong=function(U){return U},Ee.em=function(U){return U},Ee.codespan=function(U){return U},Ee.del=function(U){return U},Ee.html=function(U){return U},Ee.text=function(U){return U},Ee.link=function(U,N,W){return""+W},Ee.image=function(U,N,W){return""+W},Ee.br=function(){return""},be}(),G=function(){function be(){this.seen={}}var Ee=be.prototype;return Ee.serialize=function(U){return U.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ee.getNextSafeSlug=function(U,N){var W=U,j=0;if(this.seen.hasOwnProperty(W)){j=this.seen[U];do j++,W=U+"-"+j;while(this.seen.hasOwnProperty(W))}return N||(this.seen[U]=j,this.seen[W]=0),W},Ee.slug=function(U,N){N===void 0&&(N={});var W=this.serialize(U);return this.getNextSafeSlug(W,N.dryrun)},be}(),ie=function(){function be($){this.options=$||ee.defaults,this.options.renderer=this.options.renderer||new q,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new K,this.slugger=new G}be.parse=function(U,N){var W=new be(N);return W.parse(U)},be.parseInline=function(U,N){var W=new be(N);return W.parseInline(U)};var Ee=be.prototype;return Ee.parse=function(U,N){N===void 0&&(N=!0);var W="",j,re,he,Ce,Ae,We,ze,qe,He,Ue,Je,et,Le,it,ne,ae,J,pe,Se,Me=U.length;for(j=0;j<Me;j++){if(Ue=U[j],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ue.type]&&(Se=this.options.extensions.renderers[Ue.type].call({parser:this},Ue),Se!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ue.type))){W+=Se||"";continue}switch(Ue.type){case"space":continue;case"hr":{W+=this.renderer.hr();continue}case"heading":{W+=this.renderer.heading(this.parseInline(Ue.tokens),Ue.depth,v(this.parseInline(Ue.tokens,this.textRenderer)),this.slugger);continue}case"code":{W+=this.renderer.code(Ue.text,Ue.lang,Ue.escaped);continue}case"table":{for(qe="",ze="",Ce=Ue.header.length,re=0;re<Ce;re++)ze+=this.renderer.tablecell(this.parseInline(Ue.header[re].tokens),{header:!0,align:Ue.align[re]});for(qe+=this.renderer.tablerow(ze),He="",Ce=Ue.rows.length,re=0;re<Ce;re++){for(We=Ue.rows[re],ze="",Ae=We.length,he=0;he<Ae;he++)ze+=this.renderer.tablecell(this.parseInline(We[he].tokens),{header:!1,align:Ue.align[he]});He+=this.renderer.tablerow(ze)}W+=this.renderer.table(qe,He);continue}case"blockquote":{He=this.parse(Ue.tokens),W+=this.renderer.blockquote(He);continue}case"list":{for(Je=Ue.ordered,et=Ue.start,Le=Ue.loose,Ce=Ue.items.length,He="",re=0;re<Ce;re++)ne=Ue.items[re],ae=ne.checked,J=ne.task,it="",ne.task&&(pe=this.renderer.checkbox(ae),Le?ne.tokens.length>0&&ne.tokens[0].type==="paragraph"?(ne.tokens[0].text=pe+" "+ne.tokens[0].text,ne.tokens[0].tokens&&ne.tokens[0].tokens.length>0&&ne.tokens[0].tokens[0].type==="text"&&(ne.tokens[0].tokens[0].text=pe+" "+ne.tokens[0].tokens[0].text)):ne.tokens.unshift({type:"text",text:pe}):it+=pe),it+=this.parse(ne.tokens,Le),He+=this.renderer.listitem(it,J,ae);W+=this.renderer.list(He,Je,et);continue}case"html":{W+=this.renderer.html(Ue.text);continue}case"paragraph":{W+=this.renderer.paragraph(this.parseInline(Ue.tokens));continue}case"text":{for(He=Ue.tokens?this.parseInline(Ue.tokens):Ue.text;j+1<Me&&U[j+1].type==="text";)Ue=U[++j],He+=`
`+(Ue.tokens?this.parseInline(Ue.tokens):Ue.text);W+=N?this.renderer.paragraph(He):He;continue}default:{var $e='Token with "'+Ue.type+'" type was not found.';if(this.options.silent){console.error($e);return}else throw new Error($e)}}}return W},Ee.parseInline=function(U,N){N=N||this.renderer;var W="",j,re,he,Ce=U.length;for(j=0;j<Ce;j++){if(re=U[j],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[re.type]&&(he=this.options.extensions.renderers[re.type].call({parser:this},re),he!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(re.type))){W+=he||"";continue}switch(re.type){case"escape":{W+=N.text(re.text);break}case"html":{W+=N.html(re.text);break}case"link":{W+=N.link(re.href,re.title,this.parseInline(re.tokens,N));break}case"image":{W+=N.image(re.href,re.title,re.text);break}case"strong":{W+=N.strong(this.parseInline(re.tokens,N));break}case"em":{W+=N.em(this.parseInline(re.tokens,N));break}case"codespan":{W+=N.codespan(re.text);break}case"br":{W+=N.br();break}case"del":{W+=N.del(this.parseInline(re.tokens,N));break}case"text":{W+=N.text(re.text);break}default:{var Ae='Token with "'+re.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return W},be}();function oe(be,Ee,$){if(typeof be=="undefined"||be===null)throw new Error("marked(): input parameter is undefined or null");if(typeof be!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(be)+", string expected");if(typeof Ee=="function"&&($=Ee,Ee=null),Ee=o({},oe.defaults,Ee||{}),P(Ee),$){var U=Ee.highlight,N;try{N=H.lex(be,Ee)}catch(he){return $(he)}var W=function(Ce){var Ae;if(!Ce)try{Ee.walkTokens&&oe.walkTokens(N,Ee.walkTokens),Ae=ie.parse(N,Ee)}catch(We){Ce=We}return Ee.highlight=U,Ce?$(Ce):$(null,Ae)};if(!U||U.length<3||(delete Ee.highlight,!N.length))return W();var j=0;oe.walkTokens(N,function(he){he.type==="code"&&(j++,setTimeout(function(){U(he.text,he.lang,function(Ce,Ae){if(Ce)return W(Ce);Ae!=null&&Ae!==he.text&&(he.text=Ae,he.escaped=!0),j--,j===0&&W()})},0))}),j===0&&W();return}try{var re=H.lex(be,Ee);return Ee.walkTokens&&oe.walkTokens(re,Ee.walkTokens),ie.parse(re,Ee)}catch(he){if(he.message+=`
Please report this to https://github.com/markedjs/marked.`,Ee.silent)return"<p>An error occurred:</p><pre>"+g(he.message+"",!0)+"</pre>";throw he}}oe.options=oe.setOptions=function(be){return o(oe.defaults,be),k(oe.defaults),oe},oe.getDefaults=C,oe.defaults=ee.defaults,oe.use=function(){for(var be=arguments.length,Ee=new Array(be),$=0;$<be;$++)Ee[$]=arguments[$];var U=o.apply(void 0,[{}].concat(Ee)),N=oe.defaults.extensions||{renderers:{},childTokens:{}},W;Ee.forEach(function(j){if(j.extensions&&(W=!0,j.extensions.forEach(function(he){if(!he.name)throw new Error("extension name required");if(he.renderer){var Ce=N.renderers?N.renderers[he.name]:null;Ce?N.renderers[he.name]=function(){for(var Ae=arguments.length,We=new Array(Ae),ze=0;ze<Ae;ze++)We[ze]=arguments[ze];var qe=he.renderer.apply(this,We);return qe===!1&&(qe=Ce.apply(this,We)),qe}:N.renderers[he.name]=he.renderer}if(he.tokenizer){if(!he.level||he.level!=="block"&&he.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");N[he.level]?N[he.level].unshift(he.tokenizer):N[he.level]=[he.tokenizer],he.start&&(he.level==="block"?N.startBlock?N.startBlock.push(he.start):N.startBlock=[he.start]:he.level==="inline"&&(N.startInline?N.startInline.push(he.start):N.startInline=[he.start]))}he.childTokens&&(N.childTokens[he.name]=he.childTokens)})),j.renderer&&function(){var he=oe.defaults.renderer||new q,Ce=function(ze){var qe=he[ze];he[ze]=function(){for(var He=arguments.length,Ue=new Array(He),Je=0;Je<He;Je++)Ue[Je]=arguments[Je];var et=j.renderer[ze].apply(he,Ue);return et===!1&&(et=qe.apply(he,Ue)),et}};for(var Ae in j.renderer)Ce(Ae);U.renderer=he}(),j.tokenizer&&function(){var he=oe.defaults.tokenizer||new z,Ce=function(ze){var qe=he[ze];he[ze]=function(){for(var He=arguments.length,Ue=new Array(He),Je=0;Je<He;Je++)Ue[Je]=arguments[Je];var et=j.tokenizer[ze].apply(he,Ue);return et===!1&&(et=qe.apply(he,Ue)),et}};for(var Ae in j.tokenizer)Ce(Ae);U.tokenizer=he}(),j.walkTokens){var re=oe.defaults.walkTokens;U.walkTokens=function(he){j.walkTokens.call(this,he),re&&re.call(this,he)}}W&&(U.extensions=N),oe.setOptions(U)})},oe.walkTokens=function(be,Ee){for(var $=function(){var j=N.value;switch(Ee.call(oe,j),j.type){case"table":{for(var re=T(j.header),he;!(he=re()).done;){var Ce=he.value;oe.walkTokens(Ce.tokens,Ee)}for(var Ae=T(j.rows),We;!(We=Ae()).done;)for(var ze=We.value,qe=T(ze),He;!(He=qe()).done;){var Ue=He.value;oe.walkTokens(Ue.tokens,Ee)}break}case"list":{oe.walkTokens(j.items,Ee);break}default:oe.defaults.extensions&&oe.defaults.extensions.childTokens&&oe.defaults.extensions.childTokens[j.type]?oe.defaults.extensions.childTokens[j.type].forEach(function(Je){oe.walkTokens(j[Je],Ee)}):j.tokens&&oe.walkTokens(j.tokens,Ee)}},U=T(be),N;!(N=U()).done;)$()},oe.parseInline=function(be,Ee){if(typeof be=="undefined"||be===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof be!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(be)+", string expected");Ee=o({},oe.defaults,Ee||{}),P(Ee);try{var $=H.lexInline(be,Ee);return Ee.walkTokens&&oe.walkTokens($,Ee.walkTokens),ie.parseInline($,Ee)}catch(U){if(U.message+=`
Please report this to https://github.com/markedjs/marked.`,Ee.silent)return"<p>An error occurred:</p><pre>"+g(U.message+"",!0)+"</pre>";throw U}},oe.Parser=ie,oe.parser=ie.parse,oe.Renderer=q,oe.TextRenderer=K,oe.Lexer=H,oe.lexer=H.lex,oe.Tokenizer=z,oe.Slugger=G,oe.parse=oe;var ue=oe.options,Z=oe.setOptions,Q=oe.use,se=oe.walkTokens,de=oe.parseInline,ge=oe,Te=ie.parse,Ne=H.lex;ee.Lexer=H,ee.Parser=ie,ee.Renderer=q,ee.Slugger=G,ee.TextRenderer=K,ee.Tokenizer=z,ee.getDefaults=C,ee.lexer=Ne,ee.marked=oe,ee.options=ue,ee.parse=ge,ee.parseInline=de,ee.parser=Te,ee.setOptions=Z,ee.use=Q,ee.walkTokens=se,Object.defineProperty(ee,"__esModule",{value:!0})}),define(ve[91],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function h(k,S,R){return Math.min(Math.max(k,S),R)}e.clamp=h;function n(k,S){return(S+k%S)%S}e.rot=n;class I{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=I;class T{constructor(){this._n=1,this._val=0}update(S){return this._val=this._val+(S-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=T;class C{constructor(S){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(S),this._values.fill(0,0,S)}update(S){const R=this._values[this._index];return this._values[this._index]=S,this._index=(this._index+1)%this._values.length,this._sum-=R,this._sum+=S,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=C}),function(){function ee(I){const T=[];typeof I=="number"&&T.push("code/timeOrigin",I);function C(S){T.push(S,Date.now())}function k(){const S=[];for(let R=0;R<T.length;R+=2)S.push({name:T[R],startTime:T[R+1]});return S}return{mark:C,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const C of performance.getEntriesByType("mark"))T.push({name:C.name,startTime:Math.round(I+C.startTime)});return T}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function h(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return h(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=h(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=h(n))}(),define(ve[12],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const h="en";let n=!1,I=!1,T=!1,C=!1,k=!1,S=!1,R=!1,F=!1,D=!1,p,_=h,g,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let v;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?v=e.globals.vscode.process:typeof process!="undefined"&&(v=process);const A=typeof v?.versions?.electron=="string",b=A&&v?.type==="renderer";if(e.isElectronSandboxed=b&&v?.sandboxed,typeof navigator=="object"&&!b)d=navigator.userAgent,n=d.indexOf("Windows")>=0,I=d.indexOf("Macintosh")>=0,F=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=d.indexOf("Linux")>=0,S=!0,p=navigator.language,_=p;else if(typeof v=="object"){n=v.platform==="win32",I=v.platform==="darwin",T=v.platform==="linux",C=T&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,R=A,D=!!v.env.CI||!!v.env.BUILD_ARTIFACTSTAGINGDIRECTORY,p=h,_=h;const t=v.env.VSCODE_NLS_CONFIG;if(t)try{const o=JSON.parse(t),f=o.availableLanguages["*"];p=o.locale,_=f||h,g=o._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var a;(function(t){t[t.Web=0]="Web",t[t.Mac=1]="Mac",t[t.Linux=2]="Linux",t[t.Windows=3]="Windows"})(a=e.Platform||(e.Platform={}));function c(t){switch(t){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let m=0;I?m=1:n?m=3:T&&(m=2),e.isWindows=n,e.isMacintosh=I,e.isLinux=T,e.isLinuxSnap=C,e.isNative=k,e.isElectron=R,e.isWeb=S,e.isIOS=F,e.isCI=D,e.platform=m,e.userAgent=d,e.language=_;var s;(function(t){function o(){return e.language}t.value=o;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}t.isDefaultVariant=f;function u(){return e.language==="en"}t.isDefault=u})(s=e.Language||(e.Language={})),e.locale=p,e.translationsConfigFile=g,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let t=[];e.globals.addEventListener("message",f=>{if(f.data&&f.data.vscodeScheduleAsyncWork)for(let u=0,w=t.length;u<w;u++){const P=t[u];if(P.id===f.data.vscodeScheduleAsyncWork){t.splice(u,1),P.callback();return}}});let o=0;return f=>{const u=++o;t.push({id:u,callback:f}),e.globals.postMessage({vscodeScheduleAsyncWork:u},"*")}}return t=>setTimeout(t)})();var E;(function(t){t[t.Windows=1]="Windows",t[t.Macintosh=2]="Macintosh",t[t.Linux=3]="Linux"})(E=e.OperatingSystem||(e.OperatingSystem={})),e.OS=I||F?2:n?1:3;let l=!0,i=!1;function r(){if(!i){i=!0;const t=new Uint8Array(2);t[0]=1,t[1]=2,l=new Uint16Array(t.buffer)[0]===(2<<8)+1}return l}e.isLittleEndian=r,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ve[41],we([1,0,12]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof h.globals.vscode!="undefined"&&typeof h.globals.vscode.process!="undefined"){const I=h.globals.vscode.process;n={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return h.isWindows?"win32":h.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(ve[9],we([1,0,41]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,I=97,T=90,C=122,k=46,S=47,R=92,F=58,D=63;class p extends Error{constructor(c,m,s){let E;typeof m=="string"&&m.indexOf("not ")===0?(E="must not be",m=m.replace(/^not /,"")):E="must be";const l=c.indexOf(".")!==-1?"property":"argument";let i=`The "${c}" ${l} ${E} of type ${m}`;i+=`. Received type ${typeof s}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function _(a,c){if(typeof a!="string")throw new p(c,"string",a)}function g(a){return a===S||a===R}function d(a){return a===S}function v(a){return a>=n&&a<=T||a>=I&&a<=C}function A(a,c,m,s){let E="",l=0,i=-1,r=0,t=0;for(let o=0;o<=a.length;++o){if(o<a.length)t=a.charCodeAt(o);else{if(s(t))break;t=S}if(s(t)){if(!(i===o-1||r===1))if(r===2){if(E.length<2||l!==2||E.charCodeAt(E.length-1)!==k||E.charCodeAt(E.length-2)!==k){if(E.length>2){const f=E.lastIndexOf(m);f===-1?(E="",l=0):(E=E.slice(0,f),l=E.length-1-E.lastIndexOf(m)),i=o,r=0;continue}else if(E.length!==0){E="",l=0,i=o,r=0;continue}}c&&(E+=E.length>0?`${m}..`:"..",l=2)}else E.length>0?E+=`${m}${a.slice(i+1,o)}`:E=a.slice(i+1,o),l=o-i-1;i=o,r=0}else t===k&&r!==-1?++r:r=-1}return E}function b(a,c){if(c===null||typeof c!="object")throw new p("pathObject","Object",c);const m=c.dir||c.root,s=c.base||`${c.name||""}${c.ext||""}`;return m?m===c.root?`${m}${s}`:`${m}${a}${s}`:s}e.win32={resolve(...a){let c="",m="",s=!1;for(let E=a.length-1;E>=-1;E--){let l;if(E>=0){if(l=a[E],_(l,"path"),l.length===0)continue}else c.length===0?l=h.cwd():(l=h.env[`=${c}`]||h.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==c.toLowerCase()&&l.charCodeAt(2)===R)&&(l=`${c}\\`));const i=l.length;let r=0,t="",o=!1;const f=l.charCodeAt(0);if(i===1)g(f)&&(r=1,o=!0);else if(g(f))if(o=!0,g(l.charCodeAt(1))){let u=2,w=u;for(;u<i&&!g(l.charCodeAt(u));)u++;if(u<i&&u!==w){const P=l.slice(w,u);for(w=u;u<i&&g(l.charCodeAt(u));)u++;if(u<i&&u!==w){for(w=u;u<i&&!g(l.charCodeAt(u));)u++;(u===i||u!==w)&&(t=`\\\\${P}\\${l.slice(w,u)}`,r=u)}}}else r=1;else v(f)&&l.charCodeAt(1)===F&&(t=l.slice(0,2),r=2,i>2&&g(l.charCodeAt(2))&&(o=!0,r=3));if(t.length>0)if(c.length>0){if(t.toLowerCase()!==c.toLowerCase())continue}else c=t;if(s){if(c.length>0)break}else if(m=`${l.slice(r)}\\${m}`,s=o,o&&c.length>0)break}return m=A(m,!s,"\\",g),s?`${c}\\${m}`:`${c}${m}`||"."},normalize(a){_(a,"path");const c=a.length;if(c===0)return".";let m=0,s,E=!1;const l=a.charCodeAt(0);if(c===1)return d(l)?"\\":a;if(g(l))if(E=!0,g(a.charCodeAt(1))){let r=2,t=r;for(;r<c&&!g(a.charCodeAt(r));)r++;if(r<c&&r!==t){const o=a.slice(t,r);for(t=r;r<c&&g(a.charCodeAt(r));)r++;if(r<c&&r!==t){for(t=r;r<c&&!g(a.charCodeAt(r));)r++;if(r===c)return`\\\\${o}\\${a.slice(t)}\\`;r!==t&&(s=`\\\\${o}\\${a.slice(t,r)}`,m=r)}}}else m=1;else v(l)&&a.charCodeAt(1)===F&&(s=a.slice(0,2),m=2,c>2&&g(a.charCodeAt(2))&&(E=!0,m=3));let i=m<c?A(a.slice(m),!E,"\\",g):"";return i.length===0&&!E&&(i="."),i.length>0&&g(a.charCodeAt(c-1))&&(i+="\\"),s===void 0?E?`\\${i}`:i:E?`${s}\\${i}`:`${s}${i}`},isAbsolute(a){_(a,"path");const c=a.length;if(c===0)return!1;const m=a.charCodeAt(0);return g(m)||c>2&&v(m)&&a.charCodeAt(1)===F&&g(a.charCodeAt(2))},join(...a){if(a.length===0)return".";let c,m;for(let l=0;l<a.length;++l){const i=a[l];_(i,"path"),i.length>0&&(c===void 0?c=m=i:c+=`\\${i}`)}if(c===void 0)return".";let s=!0,E=0;if(typeof m=="string"&&g(m.charCodeAt(0))){++E;const l=m.length;l>1&&g(m.charCodeAt(1))&&(++E,l>2&&(g(m.charCodeAt(2))?++E:s=!1))}if(s){for(;E<c.length&&g(c.charCodeAt(E));)E++;E>=2&&(c=`\\${c.slice(E)}`)}return e.win32.normalize(c)},relative(a,c){if(_(a,"from"),_(c,"to"),a===c)return"";const m=e.win32.resolve(a),s=e.win32.resolve(c);if(m===s||(a=m.toLowerCase(),c=s.toLowerCase(),a===c))return"";let E=0;for(;E<a.length&&a.charCodeAt(E)===R;)E++;let l=a.length;for(;l-1>E&&a.charCodeAt(l-1)===R;)l--;const i=l-E;let r=0;for(;r<c.length&&c.charCodeAt(r)===R;)r++;let t=c.length;for(;t-1>r&&c.charCodeAt(t-1)===R;)t--;const o=t-r,f=i<o?i:o;let u=-1,w=0;for(;w<f;w++){const L=a.charCodeAt(E+w);if(L!==c.charCodeAt(r+w))break;L===R&&(u=w)}if(w!==f){if(u===-1)return s}else{if(o>f){if(c.charCodeAt(r+w)===R)return s.slice(r+w+1);if(w===2)return s.slice(r+w)}i>f&&(a.charCodeAt(E+w)===R?u=w:w===2&&(u=3)),u===-1&&(u=0)}let P="";for(w=E+u+1;w<=l;++w)(w===l||a.charCodeAt(w)===R)&&(P+=P.length===0?"..":"\\..");return r+=u,P.length>0?`${P}${s.slice(r,t)}`:(s.charCodeAt(r)===R&&++r,s.slice(r,t))},toNamespacedPath(a){if(typeof a!="string")return a;if(a.length===0)return"";const c=e.win32.resolve(a);if(c.length<=2)return a;if(c.charCodeAt(0)===R){if(c.charCodeAt(1)===R){const m=c.charCodeAt(2);if(m!==D&&m!==k)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(v(c.charCodeAt(0))&&c.charCodeAt(1)===F&&c.charCodeAt(2)===R)return`\\\\?\\${c}`;return a},dirname(a){_(a,"path");const c=a.length;if(c===0)return".";let m=-1,s=0;const E=a.charCodeAt(0);if(c===1)return g(E)?a:".";if(g(E)){if(m=s=1,g(a.charCodeAt(1))){let r=2,t=r;for(;r<c&&!g(a.charCodeAt(r));)r++;if(r<c&&r!==t){for(t=r;r<c&&g(a.charCodeAt(r));)r++;if(r<c&&r!==t){for(t=r;r<c&&!g(a.charCodeAt(r));)r++;if(r===c)return a;r!==t&&(m=s=r+1)}}}}else v(E)&&a.charCodeAt(1)===F&&(m=c>2&&g(a.charCodeAt(2))?3:2,s=m);let l=-1,i=!0;for(let r=c-1;r>=s;--r)if(g(a.charCodeAt(r))){if(!i){l=r;break}}else i=!1;if(l===-1){if(m===-1)return".";l=m}return a.slice(0,l)},basename(a,c){c!==void 0&&_(c,"ext"),_(a,"path");let m=0,s=-1,E=!0,l;if(a.length>=2&&v(a.charCodeAt(0))&&a.charCodeAt(1)===F&&(m=2),c!==void 0&&c.length>0&&c.length<=a.length){if(c===a)return"";let i=c.length-1,r=-1;for(l=a.length-1;l>=m;--l){const t=a.charCodeAt(l);if(g(t)){if(!E){m=l+1;break}}else r===-1&&(E=!1,r=l+1),i>=0&&(t===c.charCodeAt(i)?--i==-1&&(s=l):(i=-1,s=r))}return m===s?s=r:s===-1&&(s=a.length),a.slice(m,s)}for(l=a.length-1;l>=m;--l)if(g(a.charCodeAt(l))){if(!E){m=l+1;break}}else s===-1&&(E=!1,s=l+1);return s===-1?"":a.slice(m,s)},extname(a){_(a,"path");let c=0,m=-1,s=0,E=-1,l=!0,i=0;a.length>=2&&a.charCodeAt(1)===F&&v(a.charCodeAt(0))&&(c=s=2);for(let r=a.length-1;r>=c;--r){const t=a.charCodeAt(r);if(g(t)){if(!l){s=r+1;break}continue}E===-1&&(l=!1,E=r+1),t===k?m===-1?m=r:i!==1&&(i=1):m!==-1&&(i=-1)}return m===-1||E===-1||i===0||i===1&&m===E-1&&m===s+1?"":a.slice(m,E)},format:b.bind(null,"\\"),parse(a){_(a,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return c;const m=a.length;let s=0,E=a.charCodeAt(0);if(m===1)return g(E)?(c.root=c.dir=a,c):(c.base=c.name=a,c);if(g(E)){if(s=1,g(a.charCodeAt(1))){let u=2,w=u;for(;u<m&&!g(a.charCodeAt(u));)u++;if(u<m&&u!==w){for(w=u;u<m&&g(a.charCodeAt(u));)u++;if(u<m&&u!==w){for(w=u;u<m&&!g(a.charCodeAt(u));)u++;u===m?s=u:u!==w&&(s=u+1)}}}}else if(v(E)&&a.charCodeAt(1)===F){if(m<=2)return c.root=c.dir=a,c;if(s=2,g(a.charCodeAt(2))){if(m===3)return c.root=c.dir=a,c;s=3}}s>0&&(c.root=a.slice(0,s));let l=-1,i=s,r=-1,t=!0,o=a.length-1,f=0;for(;o>=s;--o){if(E=a.charCodeAt(o),g(E)){if(!t){i=o+1;break}continue}r===-1&&(t=!1,r=o+1),E===k?l===-1?l=o:f!==1&&(f=1):l!==-1&&(f=-1)}return r!==-1&&(l===-1||f===0||f===1&&l===r-1&&l===i+1?c.base=c.name=a.slice(i,r):(c.name=a.slice(i,l),c.base=a.slice(i,r),c.ext=a.slice(l,r))),i>0&&i!==s?c.dir=a.slice(0,i-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...a){let c="",m=!1;for(let s=a.length-1;s>=-1&&!m;s--){const E=s>=0?a[s]:h.cwd();_(E,"path"),E.length!==0&&(c=`${E}/${c}`,m=E.charCodeAt(0)===S)}return c=A(c,!m,"/",d),m?`/${c}`:c.length>0?c:"."},normalize(a){if(_(a,"path"),a.length===0)return".";const c=a.charCodeAt(0)===S,m=a.charCodeAt(a.length-1)===S;return a=A(a,!c,"/",d),a.length===0?c?"/":m?"./":".":(m&&(a+="/"),c?`/${a}`:a)},isAbsolute(a){return _(a,"path"),a.length>0&&a.charCodeAt(0)===S},join(...a){if(a.length===0)return".";let c;for(let m=0;m<a.length;++m){const s=a[m];_(s,"path"),s.length>0&&(c===void 0?c=s:c+=`/${s}`)}return c===void 0?".":e.posix.normalize(c)},relative(a,c){if(_(a,"from"),_(c,"to"),a===c||(a=e.posix.resolve(a),c=e.posix.resolve(c),a===c))return"";const m=1,s=a.length,E=s-m,l=1,i=c.length-l,r=E<i?E:i;let t=-1,o=0;for(;o<r;o++){const u=a.charCodeAt(m+o);if(u!==c.charCodeAt(l+o))break;u===S&&(t=o)}if(o===r)if(i>r){if(c.charCodeAt(l+o)===S)return c.slice(l+o+1);if(o===0)return c.slice(l+o)}else E>r&&(a.charCodeAt(m+o)===S?t=o:o===0&&(t=0));let f="";for(o=m+t+1;o<=s;++o)(o===s||a.charCodeAt(o)===S)&&(f+=f.length===0?"..":"/..");return`${f}${c.slice(l+t)}`},toNamespacedPath(a){return a},dirname(a){if(_(a,"path"),a.length===0)return".";const c=a.charCodeAt(0)===S;let m=-1,s=!0;for(let E=a.length-1;E>=1;--E)if(a.charCodeAt(E)===S){if(!s){m=E;break}}else s=!1;return m===-1?c?"/":".":c&&m===1?"//":a.slice(0,m)},basename(a,c){c!==void 0&&_(c,"ext"),_(a,"path");let m=0,s=-1,E=!0,l;if(c!==void 0&&c.length>0&&c.length<=a.length){if(c===a)return"";let i=c.length-1,r=-1;for(l=a.length-1;l>=0;--l){const t=a.charCodeAt(l);if(t===S){if(!E){m=l+1;break}}else r===-1&&(E=!1,r=l+1),i>=0&&(t===c.charCodeAt(i)?--i==-1&&(s=l):(i=-1,s=r))}return m===s?s=r:s===-1&&(s=a.length),a.slice(m,s)}for(l=a.length-1;l>=0;--l)if(a.charCodeAt(l)===S){if(!E){m=l+1;break}}else s===-1&&(E=!1,s=l+1);return s===-1?"":a.slice(m,s)},extname(a){_(a,"path");let c=-1,m=0,s=-1,E=!0,l=0;for(let i=a.length-1;i>=0;--i){const r=a.charCodeAt(i);if(r===S){if(!E){m=i+1;break}continue}s===-1&&(E=!1,s=i+1),r===k?c===-1?c=i:l!==1&&(l=1):c!==-1&&(l=-1)}return c===-1||s===-1||l===0||l===1&&c===s-1&&c===m+1?"":a.slice(c,s)},format:b.bind(null,"/"),parse(a){_(a,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(a.length===0)return c;const m=a.charCodeAt(0)===S;let s;m?(c.root="/",s=1):s=0;let E=-1,l=0,i=-1,r=!0,t=a.length-1,o=0;for(;t>=s;--t){const f=a.charCodeAt(t);if(f===S){if(!r){l=t+1;break}continue}i===-1&&(r=!1,i=t+1),f===k?E===-1?E=t:o!==1&&(o=1):E!==-1&&(o=-1)}if(i!==-1){const f=l===0&&m?1:l;E===-1||o===0||o===1&&E===i-1&&E===l+1?c.base=c.name=a.slice(f,i):(c.name=a.slice(f,E),c.base=a.slice(f,i),c.ext=a.slice(E,i))}return l>0?c.dir=a.slice(0,l-1):m&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=h.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=h.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=h.platform==="win32"?e.win32.join:e.posix.join,e.resolve=h.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=h.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=h.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=h.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=h.platform==="win32"?e.win32.extname:e.posix.extname,e.format=h.platform==="win32"?e.win32.format:e.posix.format,e.parse=h.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=h.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=h.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=h.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ve[92],we([1,0,9]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var n;(function(D){D.text="text/plain",D.binary="application/octet-stream",D.unknown="application/unknown",D.markdown="text/markdown",D.latex="text/latex",D.uriList="text/uri-list"})(n=e.Mimes||(e.Mimes={}));const I={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},T={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function C(D){const p=(0,h.extname)(D),_=I[p.toLowerCase()];return _!==void 0?_:k(D)}e.getMediaOrTextMime=C;function k(D){const p=(0,h.extname)(D);return T[p.toLowerCase()]}e.getMediaMime=k;function S(D){for(const p in T)if(T[p]===D)return p}e.getExtensionForMimeType=S;const R=/^(.+)\/(.+?)(;.+)?$/;function F(D,p){const _=R.exec(D);return _?`${_[1].toLowerCase()}/${_[2].toLowerCase()}${_[3]??""}`:p?void 0:D}e.normalizeMimeType=F}),define(ve[93],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var h;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(h=e.Source||(e.Source={}));var n;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function I(T,...C){const k=C.reduce((F,D)=>(F[D]=!0,F),{}),S=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(F=>!k[F]).forEach(F=>{for(let D=0;D<S.length;D++)if(F.search(S[D])!==-1){delete T[F];break}})}e.sanitizeProcessEnvironment=I}),define(ve[46],we([1,0,12]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=h.globals.performance&&typeof h.globals.performance.now=="function";class I{constructor(C){this._highResolution=n&&C,this._startTime=this._now(),this._stopTime=-1}static create(C=!0){return new I(C)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?h.globals.performance.now():Date.now()}}e.StopWatch=I}),define(ve[3],we([1,0,17,74,6,90,46]),function(ee,e,h,n,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;let k=!1,S=!1;var R;(function(l){l.None=()=>I.Disposable.None;function i(ie){if(S){const{onListenerDidAdd:oe}=ie,ue=g.create();let Z=0;ie.onListenerDidAdd=()=>{++Z==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ue.print()),oe?.()}}}function r(ie){return(oe,ue=null,Z)=>{let Q=!1,se;return se=ie(de=>{if(!Q)return se?se.dispose():Q=!0,oe.call(ue,de)},null,Z),Q&&se.dispose(),se}}l.once=r;function t(ie,oe,ue){return L((Z,Q=null,se)=>ie(de=>Z.call(Q,oe(de)),null,se),ue)}l.map=t;function o(ie,oe,ue){return L((Z,Q=null,se)=>ie(de=>{oe(de),Z.call(Q,de)},null,se),ue)}l.forEach=o;function f(ie,oe,ue){return L((Z,Q=null,se)=>ie(de=>oe(de)&&Z.call(Q,de),null,se),ue)}l.filter=f;function u(ie){return ie}l.signal=u;function w(...ie){return(oe,ue=null,Z)=>(0,I.combinedDisposable)(...ie.map(Q=>Q(se=>oe.call(ue,se),null,Z)))}l.any=w;function P(ie,oe,ue,Z){let Q=ue;return t(ie,se=>(Q=oe(Q,se),Q),Z)}l.reduce=P;function L(ie,oe){let ue;const Z={onFirstListenerAdd(){ue=ie(Q.fire,Q)},onLastListenerRemove(){ue.dispose()}};oe||i(Z);const Q=new v(Z);return oe&&oe.add(Q),Q.event}function O(ie,oe,ue=100,Z=!1,Q,se){let de,ge,Te,Ne=0;const be={leakWarningThreshold:Q,onFirstListenerAdd(){de=ie($=>{Ne++,ge=oe(ge,$),Z&&!Te&&(Ee.fire(ge),ge=void 0),clearTimeout(Te),Te=setTimeout(()=>{const U=ge;ge=void 0,Te=void 0,(!Z||Ne>1)&&Ee.fire(U),Ne=0},ue)})},onLastListenerRemove(){de.dispose()}};se||i(be);const Ee=new v(be);return se&&se.add(Ee),Ee.event}l.debounce=O;function y(ie,oe=(Z,Q)=>Z===Q,ue){let Z=!0,Q;return f(ie,se=>{const de=Z||!oe(se,Q);return Z=!1,Q=se,de},ue)}l.latch=y;function z(ie,oe,ue){return[l.filter(ie,oe,ue),l.filter(ie,Z=>!oe(Z),ue)]}l.split=z;function M(ie,oe=!1,ue=[]){let Z=ue.slice(),Q=ie(ge=>{Z?Z.push(ge):de.fire(ge)});const se=()=>{Z&&Z.forEach(ge=>de.fire(ge)),Z=null},de=new v({onFirstListenerAdd(){Q||(Q=ie(ge=>de.fire(ge)))},onFirstListenerDidAdd(){Z&&(oe?setTimeout(se):se())},onLastListenerRemove(){Q&&Q.dispose(),Q=null}});return de.event}l.buffer=M;class B{constructor(oe){this.event=oe}map(oe){return new B(t(this.event,oe))}forEach(oe){return new B(o(this.event,oe))}filter(oe){return new B(f(this.event,oe))}reduce(oe,ue){return new B(P(this.event,oe,ue))}latch(){return new B(y(this.event))}debounce(oe,ue=100,Z=!1,Q){return new B(O(this.event,oe,ue,Z,Q))}on(oe,ue,Z){return this.event(oe,ue,Z)}once(oe,ue,Z){return r(this.event)(oe,ue,Z)}}function V(ie){return new B(ie)}l.chain=V;function Y(ie,oe,ue=Z=>Z){const Z=(...ge)=>de.fire(ue(...ge)),Q=()=>ie.on(oe,Z),se=()=>ie.removeListener(oe,Z),de=new v({onFirstListenerAdd:Q,onLastListenerRemove:se});return de.event}l.fromNodeEventEmitter=Y;function H(ie,oe,ue=Z=>Z){const Z=(...ge)=>de.fire(ue(...ge)),Q=()=>ie.addEventListener(oe,Z),se=()=>ie.removeEventListener(oe,Z),de=new v({onFirstListenerAdd:Q,onLastListenerRemove:se});return de.event}l.fromDOMEventEmitter=H;function q(ie){return new Promise(oe=>r(ie)(oe))}l.toPromise=q;function K(ie,oe){return oe(void 0),ie(ue=>oe(ue))}l.runAndSubscribe=K;function G(ie,oe){let ue=null;function Z(se){ue?.dispose(),ue=new I.DisposableStore,oe(se,ue)}Z(void 0);const Q=ie(se=>Z(se));return(0,I.toDisposable)(()=>{Q.dispose(),ue?.dispose()})}l.runAndSubscribeWithStore=G})(R=e.Event||(e.Event={}));class F{constructor(i){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${i}_${F._idPool++}`}start(i){this._stopWatch=new C.StopWatch(!0),this._listenerCount=i}stop(){if(this._stopWatch){const i=this._stopWatch.elapsed();this._elapsedOverall+=i,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${i.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}F._idPool=0;let D=-1;function p(l){const i=D;return D=l,{dispose(){D=i}}}e.setGlobalLeakWarningThreshold=p;class _{constructor(i,r=Math.random().toString(18).slice(2,5)){this.customThreshold=i,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(i,r){let t=D;if(typeof this.customThreshold=="number"&&(t=this.customThreshold),t<=0||r<t)return;this._stacks||(this._stacks=new Map);const o=this._stacks.get(i.value)||0;if(this._stacks.set(i.value,o+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=t*.5;let f,u=0;for(const[w,P]of this._stacks)(!f||u<P)&&(f=w,u=P);console.warn(`[${this.name}] potential listener LEAK detected, having ${r} listeners already. MOST frequent listener (${u}):`),console.warn(f)}return()=>{const f=this._stacks.get(i.value)||0;this._stacks.set(i.value,f-1)}}}class g{constructor(i){this.value=i}static create(){return new g(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class d{constructor(i,r,t){this.callback=i,this.callbackThis=r,this.stack=t,this.subscription=new I.SafeDisposable}invoke(i){this.callback.call(this.callbackThis,i)}}class v{constructor(i){this._disposed=!1,this._options=i,this._leakageMon=D>0?new _(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new F(this._options._profName):void 0}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(k){const i=Array.from(this._listeners);queueMicrotask(()=>{for(const r of i)r.subscription.isset()&&(r.subscription.unset(),r.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(i,r,t)=>{this._listeners||(this._listeners=new T.LinkedList);const o=this._listeners.isEmpty();o&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let f,u;this._leakageMon&&this._listeners.size>=30&&(u=g.create(),f=this._leakageMon.check(u,this._listeners.size+1)),k&&(u=u??g.create());const w=new d(i,r,u),P=this._listeners.push(w);o&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,i,r);const L=w.subscription.set(()=>{f&&f(),this._disposed||(P(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return t instanceof I.DisposableStore?t.add(L):Array.isArray(t)&&t.push(L),L}),this._event}fire(i){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,i]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,t]=this._deliveryQueue.shift();try{r.invoke(t)}catch(o){(0,h.onUnexpectedError)(o)}}this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=v;class A extends v{async fireAsync(i,r,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const o of this._listeners)this._asyncDeliveryQueue.push([o,i]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[o,f]=this._asyncDeliveryQueue.shift(),u=[],w={...f,token:r,waitUntil:P=>{if(Object.isFrozen(u))throw new Error("waitUntil can NOT be called asynchronous");t&&(P=t(P,o.callback)),u.push(P)}};try{o.invoke(w)}catch(P){(0,h.onUnexpectedError)(P);continue}Object.freeze(u),await Promise.allSettled(u).then(P=>{for(const L of P)L.status==="rejected"&&(0,h.onUnexpectedError)(L.reason)})}}}}e.AsyncEmitter=A;class b extends v{constructor(i){super(i);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=i?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const i=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(i))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(i){this._listeners&&(this._isPaused!==0?this._eventQueue.push(i):super.fire(i))}}e.PauseableEmitter=b;class a extends b{constructor(i){super(i);this._delay=i.delay??100}fire(i){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(i)}}e.DebounceEmitter=a;class c extends v{constructor(i){super(i);this._queuedEvents=[],this._mergeFn=i?.merge}fire(i){this._queuedEvents.push(i),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(r=>super.fire(r)),this._queuedEvents=[]})}}e.MicrotaskEmitter=c;class m{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(i){const r={event:i,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const t=()=>{this.hasListeners&&this.unhook(r);const o=this.events.indexOf(r);this.events.splice(o,1)};return(0,I.toDisposable)((0,n.once)(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(i=>this.hook(i))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(i=>this.unhook(i))}hook(i){i.listener=i.event(r=>this.emitter.fire(r))}unhook(i){i.listener&&i.listener.dispose(),i.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=m;class s{constructor(){this.buffers=[]}wrapEvent(i){return(r,t,o)=>i(f=>{const u=this.buffers[this.buffers.length-1];u?u.push(()=>r.call(t,f)):r.call(t,f)},void 0,o)}bufferEvents(i){const r=[];this.buffers.push(r);const t=i();return this.buffers.pop(),r.forEach(o=>o()),t}}e.EventBufferer=s;class E{constructor(){this.listening=!1,this.inputEvent=R.None,this.inputEventListener=I.Disposable.None,this.emitter=new v({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(i){this.inputEvent=i,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=i(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E}),define(ve[21],we([1,0,3]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(k,S){const R=setTimeout(k.bind(S),0);return{dispose(){clearTimeout(R)}}});var I;(function(k){function S(R){return R===k.None||R===k.Cancelled||R instanceof T?!0:!R||typeof R!="object"?!1:typeof R.isCancellationRequested=="boolean"&&typeof R.onCancellationRequested=="function"}k.isCancellationToken=S,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:h.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(I=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new h.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class C{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=I.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=I.None}}e.CancellationTokenSource=C}),define(ve[143],we([1,0,21]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class n{constructor(C){this.task=C,this.result=null}get(){if(this.result)return this.result;const C=new h.CancellationTokenSource,k=this.task(C.token);return this.result={promise:k,dispose:()=>{this.result=null,C.cancel(),C.dispose()}},this.result}}e.Cache=n;class I{constructor(C){this.computeFn=C,this.lastCache=void 0,this.lastArgKey=void 0}get(C){const k=JSON.stringify(C);return this.lastArgKey!==k&&(this.lastArgKey=k,this.lastCache=this.computeFn(C)),this.lastCache}}e.LRUCachedComputed=I}),define(ve[94],we([1,0,17,6]),function(ee,e,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function I(a){const c=a;return c?[c.on,c.pause,c.resume,c.destroy].every(m=>typeof m=="function"):!1}e.isReadableStream=I;function T(a){const c=a;return c?I(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=T;function C(a,c){return new k(a,c)}e.newWriteableStream=C;class k{constructor(c,m){this.reducer=c,this.options=m,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(m=>this.pendingWritePromises.push(m))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(m=>m(c))}emitError(c){this.listeners.error.length===0?(0,h.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(m=>m(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,m){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(m),this.resume();break;case"end":this.listeners.end.push(m),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(m),this.state.flowing&&this.flowErrors();break}}removeListener(c,m){if(this.state.destroyed)return;let s;switch(c){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const E=s.indexOf(m);E>=0&&s.splice(E,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const m=[...this.pendingWritePromises];this.pendingWritePromises.length=0,m.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(a,c){const m=[];let s;for(;(s=a.read())!==null;)m.push(s);return c(m)}e.consumeReadable=S;function R(a,c,m){const s=[];let E;for(;(E=a.read())!==null&&s.length<m;)s.push(E);return E===null&&s.length>0?c(s):{read:()=>{if(s.length>0)return s.shift();if(typeof E!="undefined"){const l=E;return E=void 0,l}return a.read()}}}e.peekReadable=R;function F(a,c){return new Promise((m,s)=>{const E=[];D(a,{onData:l=>{c&&E.push(l)},onError:l=>{c?s(l):m(void 0)},onEnd:()=>{m(c?c(E):void 0)}})})}e.consumeStream=F;function D(a,c){let m=!1;return a.on("error",s=>{m||c.onError(s)}),a.on("end",()=>{m||c.onEnd()}),a.on("data",s=>{m||c.onData(s)}),(0,n.toDisposable)(()=>m=!0)}e.listenStream=D;function p(a,c){return new Promise((m,s)=>{const E=new n.DisposableStore,l=[],i=o=>{if(l.push(o),l.length>c)return E.dispose(),a.pause(),m({stream:a,buffer:l,ended:!1})},r=o=>s(o),t=()=>m({stream:a,buffer:l,ended:!0});E.add((0,n.toDisposable)(()=>a.removeListener("error",r))),a.on("error",r),E.add((0,n.toDisposable)(()=>a.removeListener("end",t))),a.on("end",t),E.add((0,n.toDisposable)(()=>a.removeListener("data",i))),a.on("data",i)})}e.peekStream=p;function _(a,c){const m=C(c);return m.end(a),m}e.toStream=_;function g(){const a=C(()=>{throw new Error("not supported")});return a.end(),a}e.emptyStream=g;function d(a){let c=!1;return{read:()=>c?null:(c=!0,a)}}e.toReadable=d;function v(a,c,m){const s=C(m);return D(a,{onData:E=>s.write(c.data(E)),onError:E=>s.error(c.error?c.error(E):E),onEnd:()=>s.end()}),s}e.transform=v;function A(a,c,m){let s=!1;return{read:()=>{const E=c.read();return s?E:(s=!0,E!==null?m([a,E]):a)}}}e.prefixedReadable=A;function b(a,c,m){let s=!1;const E=C(m);return D(c,{onData:l=>s?E.write(l):(s=!0,E.write(m([a,l]))),onError:l=>E.error(l),onEnd:()=>{s||(s=!0,E.write(a)),E.end()}}),E}e.prefixedStream=b}),define(ve[22],we([1,0,94]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let I,T;class C{constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}static alloc(f){return n?new C(Buffer.allocUnsafe(f)):new C(new Uint8Array(f))}static wrap(f){return n&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new C(f)}static fromString(f,u){return!(u?.dontUseNodeBuffer||!1)&&n?new C(Buffer.from(f)):(I||(I=new TextEncoder),new C(I.encode(f)))}static fromByteArray(f){const u=C.alloc(f.length);for(let w=0,P=f.length;w<P;w++)u.buffer[w]=f[w];return u}static concat(f,u){if(typeof u=="undefined"){u=0;for(let L=0,O=f.length;L<O;L++)u+=f[L].byteLength}const w=C.alloc(u);let P=0;for(let L=0,O=f.length;L<O;L++){const y=f[L];w.set(y,P),P+=y.byteLength}return w}clone(){const f=C.alloc(this.byteLength);return f.set(this),f}toString(){return n?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(f,u){return new C(this.buffer.subarray(f,u))}set(f,u){if(f instanceof C)this.buffer.set(f.buffer,u);else if(f instanceof Uint8Array)this.buffer.set(f,u);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),u);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),u);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return R(this.buffer,f)}writeUInt32BE(f,u){F(this.buffer,f,u)}readUInt32LE(f){return D(this.buffer,f)}writeUInt32LE(f,u){p(this.buffer,f,u)}readUInt8(f){return _(this.buffer,f)}writeUInt8(f,u){g(this.buffer,f,u)}}e.VSBuffer=C;function k(o,f){return o[f+0]<<0>>>0|o[f+1]<<8>>>0}e.readUInt16LE=k;function S(o,f,u){o[u+0]=f&255,f=f>>>8,o[u+1]=f&255}e.writeUInt16LE=S;function R(o,f){return o[f]*2**24+o[f+1]*2**16+o[f+2]*2**8+o[f+3]}e.readUInt32BE=R;function F(o,f,u){o[u+3]=f,f=f>>>8,o[u+2]=f,f=f>>>8,o[u+1]=f,f=f>>>8,o[u]=f}e.writeUInt32BE=F;function D(o,f){return o[f+0]<<0>>>0|o[f+1]<<8>>>0|o[f+2]<<16>>>0|o[f+3]<<24>>>0}e.readUInt32LE=D;function p(o,f,u){o[u+0]=f&255,f=f>>>8,o[u+1]=f&255,f=f>>>8,o[u+2]=f&255,f=f>>>8,o[u+3]=f&255}e.writeUInt32LE=p;function _(o,f){return o[f]}e.readUInt8=_;function g(o,f,u){o[u]=f}e.writeUInt8=g;function d(o){return h.consumeReadable(o,f=>C.concat(f))}e.readableToBuffer=d;function v(o){return h.toReadable(o)}e.bufferToReadable=v;function A(o){return h.consumeStream(o,f=>C.concat(f))}e.streamToBuffer=A;async function b(o){return o.ended?C.concat(o.buffer):C.concat([...o.buffer,await A(o.stream)])}e.bufferedStreamToBuffer=b;function a(o){return h.toStream(o,f=>C.concat(f))}e.bufferToStream=a;function c(o){return h.transform(o,{data:f=>typeof f=="string"?C.fromString(f):C.wrap(f)},f=>C.concat(f))}e.streamToBufferReadableStream=c;function m(o){return h.newWriteableStream(f=>C.concat(f),o)}e.newWriteableBufferStream=m;function s(o,f){return h.prefixedReadable(o,f,u=>C.concat(u))}e.prefixedBufferReadable=s;function E(o,f){return h.prefixedStream(o,f,u=>C.concat(u))}e.prefixedBufferStream=E;function l(o){let f=0,u=0,w=0;const P=new Uint8Array(Math.floor(o.length/4*3)),L=y=>{switch(u){case 3:P[w++]=f|y,u=0;break;case 2:P[w++]=f|y>>>2,f=y<<6,u=3;break;case 1:P[w++]=f|y>>>4,f=y<<4,u=2;break;default:f=y<<2,u=1}};for(let y=0;y<o.length;y++){const z=o.charCodeAt(y);if(z>=65&&z<=90)L(z-65);else if(z>=97&&z<=122)L(z-97+26);else if(z>=48&&z<=57)L(z-48+52);else if(z===43||z===45)L(62);else if(z===47||z===95)L(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${o[y]}`)}}const O=w;for(;u>0;)L(0);return C.wrap(P).slice(0,O)}e.decodeBase64=l;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function t({buffer:o},f=!0,u=!1){const w=u?r:i;let P="";const L=o.byteLength%3;let O=0;for(;O<o.byteLength-L;O+=3){const y=o[O+0],z=o[O+1],M=o[O+2];P+=w[y>>>2],P+=w[(y<<4|z>>>4)&63],P+=w[(z<<2|M>>>6)&63],P+=w[M&63]}if(L===1){const y=o[O+0];P+=w[y>>>2],P+=w[y<<4&63],f&&(P+="==")}else if(L===2){const y=o[O+0],z=o[O+1];P+=w[y>>>2],P+=w[(y<<4|z>>>4)&63],P+=w[z<<2&63],f&&(P+="=")}return P}e.encodeBase64=t}),define(ve[8],we([1,0,143,89]),function(ee,e,h,n){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function T(J){return!J||typeof J!="string"?!0:J.trim().length===0}e.isFalsyOrWhitespace=T;const C=/{(\d+)}/g;function k(J,...pe){return pe.length===0?J:J.replace(C,function(Se,Me){const $e=parseInt(Me,10);return isNaN($e)||$e<0||$e>=pe.length?Se:pe[$e]})}e.format=k;const S=/{([^}]+)}/g;function R(J,pe){return J.replace(S,(Se,Me)=>pe[Me]??Se)}e.format2=R;function F(J){return J.replace(/[<>&]/g,function(pe){switch(pe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return pe}})}e.escape=F;function D(J){return J.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=D;function p(J,pe){let Se=0;const Me=pe.charCodeAt(0);for(let $e=J.length-1;$e>=0;$e--)J.charCodeAt($e)===Me&&Se++;return Se}e.count=p;function _(J,pe,Se="\u2026"){return J.length<=pe?J:`${J.substr(0,pe)}${Se}`}e.truncate=_;function g(J,pe=" "){const Se=d(J,pe);return v(Se,pe)}e.trim=g;function d(J,pe){if(!J||!pe)return J;const Se=pe.length;if(Se===0||J.length===0)return J;let Me=0;for(;J.indexOf(pe,Me)===Me;)Me=Me+Se;return J.substring(Me)}e.ltrim=d;function v(J,pe){if(!J||!pe)return J;const Se=pe.length,Me=J.length;if(Se===0||Me===0)return J;let $e=Me,Ye=-1;for(;Ye=J.lastIndexOf(pe,$e-1),!(Ye===-1||Ye+Se!==$e);){if(Ye===0)return"";$e=Ye}return J.substring(0,$e)}e.rtrim=v;function A(J){return J.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=A;function b(J){return J.replace(/\*/g,"")}e.stripWildcards=b;function a(J,pe,Se={}){if(!J)throw new Error("Cannot create regex from empty string");pe||(J=D(J)),Se.wholeWord&&(/\B/.test(J.charAt(0))||(J="\\b"+J),/\B/.test(J.charAt(J.length-1))||(J=J+"\\b"));let Me="";return Se.global&&(Me+="g"),Se.matchCase||(Me+="i"),Se.multiline&&(Me+="m"),Se.unicode&&(Me+="u"),new RegExp(J,Me)}e.createRegExp=a;function c(J){return J.source==="^"||J.source==="^$"||J.source==="$"||J.source==="^\\s*$"?!1:!!(J.exec("")&&J.lastIndex===0)}e.regExpLeadsToEndlessLoop=c;function m(J){return!!J.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=m;function s(J){return(J.global?"g":"")+(J.ignoreCase?"i":"")+(J.multiline?"m":"")+(J.unicode?"u":"")}e.regExpFlags=s;function E(J){return J.split(/\r\n|\r|\n/)}e.splitLines=E;function l(J){for(let pe=0,Se=J.length;pe<Se;pe++){const Me=J.charCodeAt(pe);if(Me!==32&&Me!==9)return pe}return-1}e.firstNonWhitespaceIndex=l;function i(J,pe=0,Se=J.length){for(let Me=pe;Me<Se;Me++){const $e=J.charCodeAt(Me);if($e!==32&&$e!==9)return J.substring(pe,Me)}return J.substring(pe,Se)}e.getLeadingWhitespace=i;function r(J,pe=J.length-1){for(let Se=pe;Se>=0;Se--){const Me=J.charCodeAt(Se);if(Me!==32&&Me!==9)return Se}return-1}e.lastNonWhitespaceIndex=r;function t(J,pe){return J<pe?-1:J>pe?1:0}e.compare=t;function o(J,pe,Se=0,Me=J.length,$e=0,Ye=pe.length){for(;Se<Me&&$e<Ye;Se++,$e++){let wt=J.charCodeAt(Se),je=pe.charCodeAt($e);if(wt<je)return-1;if(wt>je)return 1}const lt=Me-Se,vt=Ye-$e;return lt<vt?-1:lt>vt?1:0}e.compareSubstring=o;function f(J,pe){return u(J,pe,0,J.length,0,pe.length)}e.compareIgnoreCase=f;function u(J,pe,Se=0,Me=J.length,$e=0,Ye=pe.length){for(;Se<Me&&$e<Ye;Se++,$e++){let wt=J.charCodeAt(Se),je=pe.charCodeAt($e);if(wt===je)continue;if(wt>=128||je>=128)return o(J.toLowerCase(),pe.toLowerCase(),Se,Me,$e,Ye);w(wt)&&(wt-=32),w(je)&&(je-=32);const st=wt-je;if(st!==0)return st}const lt=Me-Se,vt=Ye-$e;return lt<vt?-1:lt>vt?1:0}e.compareSubstringIgnoreCase=u;function w(J){return J>=97&&J<=122}e.isLowerAsciiLetter=w;function P(J){return J>=65&&J<=90}e.isUpperAsciiLetter=P;function L(J,pe){return J.length===pe.length&&u(J,pe)===0}e.equalsIgnoreCase=L;function O(J,pe){const Se=pe.length;return pe.length>J.length?!1:u(J,pe,0,Se)===0}e.startsWithIgnoreCase=O;function y(J,pe){let Se,Me=Math.min(J.length,pe.length);for(Se=0;Se<Me;Se++)if(J.charCodeAt(Se)!==pe.charCodeAt(Se))return Se;return Me}e.commonPrefixLength=y;function z(J,pe){let Se,Me=Math.min(J.length,pe.length);const $e=J.length-1,Ye=pe.length-1;for(Se=0;Se<Me;Se++)if(J.charCodeAt($e-Se)!==pe.charCodeAt(Ye-Se))return Se;return Me}e.commonSuffixLength=z;function M(J){return 55296<=J&&J<=56319}e.isHighSurrogate=M;function B(J){return 56320<=J&&J<=57343}e.isLowSurrogate=B;function V(J,pe){return(J-55296<<10)+(pe-56320)+65536}e.computeCodePoint=V;function Y(J,pe,Se){const Me=J.charCodeAt(Se);if(M(Me)&&Se+1<pe){const $e=J.charCodeAt(Se+1);if(B($e))return V(Me,$e)}return Me}e.getNextCodePoint=Y;function H(J,pe){const Se=J.charCodeAt(pe-1);if(B(Se)&&pe>1){const Me=J.charCodeAt(pe-2);if(M(Me))return V(Me,Se)}return Se}class q{constructor(pe,Se=0){this._str=pe,this._len=pe.length,this._offset=Se}get offset(){return this._offset}setOffset(pe){this._offset=pe}prevCodePoint(){const pe=H(this._str,this._offset);return this._offset-=pe>=65536?2:1,pe}nextCodePoint(){const pe=Y(this._str,this._len,this._offset);return this._offset+=pe>=65536?2:1,pe}eol(){return this._offset>=this._len}}e.CodePointIterator=q;class K{constructor(pe,Se=0){this._iterator=new q(pe,Se)}get offset(){return this._iterator.offset}nextGraphemeLength(){const pe=He.getInstance(),Se=this._iterator,Me=Se.offset;let $e=pe.getGraphemeBreakType(Se.nextCodePoint());for(;!Se.eol();){const Ye=Se.offset,lt=pe.getGraphemeBreakType(Se.nextCodePoint());if(ze($e,lt)){Se.setOffset(Ye);break}$e=lt}return Se.offset-Me}prevGraphemeLength(){const pe=He.getInstance(),Se=this._iterator,Me=Se.offset;let $e=pe.getGraphemeBreakType(Se.prevCodePoint());for(;Se.offset>0;){const Ye=Se.offset,lt=pe.getGraphemeBreakType(Se.prevCodePoint());if(ze(lt,$e)){Se.setOffset(Ye);break}$e=lt}return Me-Se.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=K;function G(J,pe){return new K(J,pe).nextGraphemeLength()}e.nextCharLength=G;function ie(J,pe){return new K(J,pe).prevGraphemeLength()}e.prevCharLength=ie;function oe(J,pe){pe>0&&B(J.charCodeAt(pe))&&pe--;const Se=pe+G(J,pe);return[Se-ie(J,Se),Se]}e.getCharContainingOffset=oe;const ue=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Z(J){return ue.test(J)}e.containsRTL=Z;const Q=/^[\t\n\r\x20-\x7E]*$/;function se(J){return Q.test(J)}e.isBasicASCII=se,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function de(J){return e.UNUSUAL_LINE_TERMINATORS.test(J)}e.containsUnusualLineTerminators=de;function ge(J){return J>=11904&&J<=55215||J>=63744&&J<=64255||J>=65281&&J<=65374}e.isFullWidthCharacter=ge;function Te(J){return J>=127462&&J<=127487||J===8986||J===8987||J===9200||J===9203||J>=9728&&J<=10175||J===11088||J===11093||J>=127744&&J<=128591||J>=128640&&J<=128764||J>=128992&&J<=129008||J>=129280&&J<=129535||J>=129648&&J<=129782}e.isEmojiImprecise=Te;function Ne(J,pe){if(J.length<pe)return J;const Se=/\b/g;let Me=0;for(;Se.test(J)&&!(J.length-Se.lastIndex<pe);)Me=Se.lastIndex,Se.lastIndex+=1;return J.substring(Me).replace(/^\s/,"")}e.lcut=Ne;const be=/\x1B\x5B[12]?K/g,Ee=/\x1b\[\d+m/g,$=/\x1b\[0?m/g;function U(J){return J&&(J=J.replace(be,""),J=J.replace(Ee,""),J=J.replace($,"")),J}e.removeAnsiEscapeCodes=U,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function N(J){return!!(J&&J.length>0&&J.charCodeAt(0)===65279)}e.startsWithUTF8BOM=N;function W(J){return N(J)?J.substr(1):J}e.stripUTF8BOM=W;function j(J,pe){if(!J||!pe||J.length<pe.length)return!1;const Se=pe.length,Me=J.toLowerCase();let $e=0,Ye=-1;for(;$e<Se;){const lt=Me.indexOf(pe[$e],Ye+1);if(lt<0)return!1;Ye=lt,$e++}return!0}e.fuzzyContains=j;function re(J,pe=!1){return J?(pe&&(J=J.replace(/\\./g,"")),J.toLowerCase()!==J):!1}e.containsUppercaseCharacter=re;function he(J){return J.charAt(0).toUpperCase()+J.slice(1)}e.uppercaseFirstLetter=he;function Ce(J,pe=1){if(pe===0)return"";let Se=-1;do Se=J.indexOf(`
`,Se+1),pe--;while(pe>0&&Se>=0);return Se===-1?J:(J[Se-1]==="\r"&&Se--,J.substr(0,Se))}e.getNLines=Ce;function Ae(J){const pe=90-65+1;return J=J%(2*pe),J<pe?String.fromCharCode(97+J):String.fromCharCode(65+J-pe)}e.singleLetterHash=Ae;function We(J){return He.getInstance().getGraphemeBreakType(J)}e.getGraphemeBreakType=We;function ze(J,pe){return J===0?pe!==5&&pe!==7:J===2&&pe===3?!1:J===4||J===2||J===3||pe===4||pe===2||pe===3?!0:!(J===8&&(pe===8||pe===9||pe===11||pe===12)||(J===11||J===9)&&(pe===9||pe===10)||(J===12||J===10)&&pe===10||pe===5||pe===13||pe===7||J===1||J===13&&pe===14||J===6&&pe===6)}var qe;(function(J){J[J.Other=0]="Other",J[J.Prepend=1]="Prepend",J[J.CR=2]="CR",J[J.LF=3]="LF",J[J.Control=4]="Control",J[J.Extend=5]="Extend",J[J.Regional_Indicator=6]="Regional_Indicator",J[J.SpacingMark=7]="SpacingMark",J[J.L=8]="L",J[J.V=9]="V",J[J.T=10]="T",J[J.LV=11]="LV",J[J.LVT=12]="LVT",J[J.ZWJ=13]="ZWJ",J[J.Extended_Pictographic=14]="Extended_Pictographic"})(qe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class He{constructor(){this._data=Ue()}static getInstance(){return He._INSTANCE||(He._INSTANCE=new He),He._INSTANCE}getGraphemeBreakType(pe){if(pe<32)return pe===10?3:pe===13?2:4;if(pe<127)return 0;const Se=this._data,Me=Se.length/3;let $e=1;for(;$e<=Me;)if(pe<Se[3*$e])$e=2*$e;else if(pe>Se[3*$e+1])$e=2*$e+1;else return Se[3*$e+2];return 0}}He._INSTANCE=null;function Ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Je(J,pe){if(J===0)return 0;const Se=et(J,pe);if(Se!==void 0)return Se;const Me=new q(pe,J);return Me.prevCodePoint(),Me.offset}e.getLeftDeleteOffset=Je;function et(J,pe){const Se=new q(pe,J);let Me=Se.prevCodePoint();for(;Le(Me)||Me===65039||Me===8419;){if(Se.offset===0)return;Me=Se.prevCodePoint()}if(!Te(Me))return;let $e=Se.offset;return $e>0&&Se.prevCodePoint()===8205&&($e=Se.offset),$e}function Le(J){return 127995<=J&&J<=127999}var it;(function(J){J[J.zwj=8205]="zwj",J[J.emojiVariantSelector=65039]="emojiVariantSelector",J[J.enclosingKeyCap=8419]="enclosingKeyCap"})(it||(it={})),e.noBreakWhitespace="\xA0";class ne{constructor(pe){this.confusableDictionary=pe}static getInstance(pe){return ne.cache.get(Array.from(pe))}static getLocales(){return ne._locales.getValue()}isAmbiguous(pe){return this.confusableDictionary.has(pe)}getPrimaryConfusable(pe){return this.confusableDictionary.get(pe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ne,I=ne,ne.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ne.cache=new h.LRUCachedComputed(J=>{function pe(je){const st=new Map;for(let _t=0;_t<je.length;_t+=2)st.set(je[_t],je[_t+1]);return st}function Se(je,st){const _t=new Map(je);for(const[nt,ct]of st)_t.set(nt,ct);return _t}function Me(je,st){if(!je)return st;const _t=new Map;for(const[nt,ct]of je)st.has(nt)&&_t.set(nt,ct);return _t}const $e=I.ambiguousCharacterData.getValue();let Ye=J.filter(je=>!je.startsWith("_")&&je in $e);Ye.length===0&&(Ye=["_default"]);let lt;for(const je of Ye){const st=pe($e[je]);lt=Me(lt,st)}const vt=pe($e._common),wt=Se(vt,lt);return new ne(wt)}),ne._locales=new n.Lazy(()=>Object.keys(ne.ambiguousCharacterData.getValue()).filter(J=>!J.startsWith("_")));class ae{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(ae.getRawData())),this._data}static isInvisibleCharacter(pe){return ae.getData().has(pe)}static get codePoints(){return ae.getData()}}e.InvisibleCharacters=ae,ae._data=void 0}),define(ve[57],we([1,0,8]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(A){return I(A,0)}e.hash=n;function I(A,b){switch(typeof A){case"object":return A===null?T(349,b):Array.isArray(A)?S(A,b):R(A,b);case"string":return k(A,b);case"boolean":return C(A,b);case"number":return T(A,b);case"undefined":return T(937,b);default:return T(617,b)}}e.doHash=I;function T(A,b){return(b<<5)-b+A|0}e.numberHash=T;function C(A,b){return T(A?433:863,b)}function k(A,b){b=T(149417,b);for(let a=0,c=A.length;a<c;a++)b=T(A.charCodeAt(a),b);return b}e.stringHash=k;function S(A,b){return b=T(104579,b),A.reduce((a,c)=>I(c,a),b)}function R(A,b){return b=T(181387,b),Object.keys(A).sort().reduce((a,c)=>(a=k(c,a),I(A[c],a)),b)}class F{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=I(b,this._value),this._value}}e.Hasher=F;var D;(function(A){A[A.BLOCK_SIZE=64]="BLOCK_SIZE",A[A.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(D||(D={}));function p(A,b,a=32){const c=a-b,m=~((1<<c)-1);return(A<<b|(m&A)>>>c)>>>0}function _(A,b=0,a=A.byteLength,c=0){for(let m=0;m<a;m++)A[b+m]=c}function g(A,b,a="0"){for(;A.length<b;)A=a+A;return A}function d(A,b=32){return A instanceof ArrayBuffer?Array.from(new Uint8Array(A)).map(a=>a.toString(16).padStart(2,"0")).join(""):g((A>>>0).toString(16),b/4)}e.toHexString=d;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const a=b.length;if(a===0)return;const c=this._buff;let m=this._buffLen,s=this._leftoverHighSurrogate,E,l;for(s!==0?(E=s,l=-1,s=0):(E=b.charCodeAt(0),l=0);;){let i=E;if(h.isHighSurrogate(E))if(l+1<a){const r=b.charCodeAt(l+1);h.isLowSurrogate(r)?(l++,i=h.computeCodePoint(E,r)):i=65533}else{s=E;break}else h.isLowSurrogate(E)&&(i=65533);if(m=this._push(c,m,i),l++,l<a)E=b.charCodeAt(l);else break}this._buffLen=m,this._leftoverHighSurrogate=s}_push(b,a,c){return c<128?b[a++]=c:c<2048?(b[a++]=192|(c&1984)>>>6,b[a++]=128|(c&63)>>>0):c<65536?(b[a++]=224|(c&61440)>>>12,b[a++]=128|(c&4032)>>>6,b[a++]=128|(c&63)>>>0):(b[a++]=240|(c&1835008)>>>18,b[a++]=128|(c&258048)>>>12,b[a++]=128|(c&4032)>>>6,b[a++]=128|(c&63)>>>0),a>=64&&(this._step(),a-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),a}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,_(this._buff,this._buffLen),this._buffLen>56&&(this._step(),_(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=v._bigBlock32,a=this._buffDV;for(let o=0;o<64;o+=4)b.setUint32(o,a.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)b.setUint32(o,p(b.getUint32(o-12,!1)^b.getUint32(o-32,!1)^b.getUint32(o-56,!1)^b.getUint32(o-64,!1),1),!1);let c=this._h0,m=this._h1,s=this._h2,E=this._h3,l=this._h4,i,r,t;for(let o=0;o<80;o++)o<20?(i=m&s|~m&E,r=1518500249):o<40?(i=m^s^E,r=1859775393):o<60?(i=m&s|m&E|s&E,r=2400959708):(i=m^s^E,r=3395469782),t=p(c,5)+i+l+r+b.getUint32(o*4,!1)&4294967295,l=E,E=s,s=p(m,30),m=c,c=t;this._h0=this._h0+c&4294967295,this._h1=this._h1+m&4294967295,this._h2=this._h2+s&4294967295,this._h3=this._h3+E&4294967295,this._h4=this._h4+l&4294967295}}e.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,h,n,I){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?I.call(ee,h):I?I.value=h:e.set(ee,h),h},Pe=this&&this.__classPrivateFieldGet||function(ee,e,h,n){if(h==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!n:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?n:h==="a"?n.call(ee):n?n.value:e.get(ee)};define(ve[24],we([1,0,18,8]),function(ee,e,h,n){"use strict";var I,T,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(l,i,r){let t=l.get(i);return t===void 0&&(t=r,l.set(i,t)),t}e.getOrSet=k;function S(l){const i=[];return l.forEach((r,t)=>{i.push(`${t} => ${r}`)}),`Map(${l.size}) {${i.join(", ")}}`}e.mapToString=S;function R(l){const i=[];return l.forEach(r=>{i.push(r)}),`Set(${l.size}) {${i.join(", ")}}`}e.setToString=R;class F{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const r=i.charCodeAt(0),t=this._value.charCodeAt(this._pos);return r-t}value(){return this._value[this._pos]}}e.StringIterator=F;class D{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=D;class p{constructor(i=!0,r=!0){this._splitOnBackslash=i,this._caseSensitive=r}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let r=i.length-1;r>=0;r--,this._valueLen--){const t=this._value.charCodeAt(r);if(!(t===47||this._splitOnBackslash&&t===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=p;var _;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(_||(_={}));class g{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new p(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,n.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=g;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(v||(v={}));class A{constructor(i){this._iter=i}static forUris(i=()=>!1){return new A(new g(i))}static forPaths(i=!1){return new A(new p(void 0,!i))}static forStrings(){return new A(new F)}static forConfigKeys(){return new A(new D)}clear(){this._root=void 0}fill(i,r){if(r){const t=r.slice(0);(0,h.shuffle)(t);for(let o of t)this.set(o,i)}else{const t=i.slice(0);(0,h.shuffle)(t);for(let o of t)this.set(o[0],o[1])}}set(i,r){const t=this._iter.reset(i);let o;this._root||(this._root=new d,this._root.segment=t.value());const f=[];for(o=this._root;;){const w=t.cmp(o.segment);if(w>0)o.left||(o.left=new d,o.left.segment=t.value()),f.push([-1,o]),o=o.left;else if(w<0)o.right||(o.right=new d,o.right.segment=t.value()),f.push([1,o]),o=o.right;else if(t.hasNext())t.next(),o.mid||(o.mid=new d,o.mid.segment=t.value()),f.push([0,o]),o=o.mid;else break}const u=o.value;o.value=r,o.key=i;for(let w=f.length-1;w>=0;w--){const P=f[w][1];P.updateHeight();const L=P.balanceFactor();if(L<-1||L>1){const O=f[w][0],y=f[w+1][0];if(O===1&&y===1)f[w][1]=P.rotateLeft();else if(O===-1&&y===-1)f[w][1]=P.rotateRight();else if(O===1&&y===-1)P.right=f[w+1][1]=f[w+1][1].rotateRight(),f[w][1]=P.rotateLeft();else if(O===-1&&y===1)P.left=f[w+1][1]=f[w+1][1].rotateLeft(),f[w][1]=P.rotateRight();else throw new Error;if(w>0)switch(f[w-1][0]){case-1:f[w-1][1].left=f[w][1];break;case 1:f[w-1][1].right=f[w][1];break;case 0:f[w-1][1].mid=f[w][1];break}else this._root=f[0][1]}}return u}get(i){return this._getNode(i)?.value}_getNode(i){const r=this._iter.reset(i);let t=this._root;for(;t;){const o=r.cmp(t.segment);if(o>0)t=t.left;else if(o<0)t=t.right;else if(r.hasNext())r.next(),t=t.mid;else break}return t}has(i){const r=this._getNode(i);return!(r?.value===void 0&&r?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,r){const t=this._iter.reset(i),o=[];let f=this._root;for(;f;){const u=t.cmp(f.segment);if(u>0)o.push([-1,f]),f=f.left;else if(u<0)o.push([1,f]),f=f.right;else if(t.hasNext())t.next(),o.push([0,f]),f=f.mid;else break}if(!!f){if(r?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const u=this._min(f.right),{key:w,value:P,segment:L}=u;this._delete(u.key,!1),f.key=w,f.value=P,f.segment=L}else{const u=f.left??f.right;if(o.length>0){const[w,P]=o[o.length-1];switch(w){case-1:P.left=u;break;case 0:P.mid=u;break;case 1:P.right=u;break}}else this._root=u}for(let u=o.length-1;u>=0;u--){const w=o[u][1];w.updateHeight();const P=w.balanceFactor();if(P>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),o[u][1]=w.rotateLeft()):P<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),o[u][1]=w.rotateRight()),u>0)switch(o[u-1][0]){case-1:o[u-1][1].left=o[u][1];break;case 1:o[u-1][1].right=o[u][1];break;case 0:o[u-1][1].mid=o[u][1];break}else this._root=o[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const r=this._iter.reset(i);let t=this._root,o;for(;t;){const f=r.cmp(t.segment);if(f>0)t=t.left;else if(f<0)t=t.right;else if(r.hasNext())r.next(),o=t.value||o,t=t.mid;else break}return t&&t.value||o}findSuperstr(i){const r=this._iter.reset(i);let t=this._root;for(;t;){const o=r.cmp(t.segment);if(o>0)t=t.left;else if(o<0)t=t.right;else if(r.hasNext())r.next(),t=t.mid;else return t.mid?this._entries(t.mid):void 0}}forEach(i){for(const[r,t]of this)i(t,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=r=>{if(!r)return!0;const t=r.balanceFactor();return t<-1||t>1?!1:i(r.left)&&i(r.right)};return i(this._root)}}e.TernarySearchTree=A;class b{constructor(i,r){this.uri=i,this.value=r}}class a{constructor(i,r){this[I]="ResourceMap",i instanceof a?(this.map=new Map(i.map),this.toKey=r??a.defaultToKey):(this.map=new Map,this.toKey=i??a.defaultToKey)}set(i,r){return this.map.set(this.toKey(i),new b(i,r)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,r){typeof r!="undefined"&&(i=i.bind(r));for(let[t,o]of this.map)i(o.value,o.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=a,a.defaultToKey=l=>l.toString();var c;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class m{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,r=0){const t=this._map.get(i);if(!!t)return r!==0&&this.touch(t,r),t.value}set(i,r,t=0){let o=this._map.get(i);if(o)o.value=r,t!==0&&this.touch(o,t);else{switch(o={key:i,value:r,next:void 0,previous:void 0},t){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(i,o),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const r=this._map.get(i);if(!!r)return this._map.delete(i),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,r){const t=this._state;let o=this._head;for(;o;){if(r?i.bind(r)(o.value,o.key,this):i(o.value,o.key,this),this._state!==t)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const i=this,r=this._state;let t=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(t){const f={value:t.key,done:!1};return t=t.next,f}else return{value:void 0,done:!0}}};return o}values(){const i=this,r=this._state;let t=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(t){const f={value:t.value,done:!1};return t=t.next,f}else return{value:void 0,done:!0}}};return o}entries(){const i=this,r=this._state;let t=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(t){const f={value:[t.key,t.value],done:!1};return t=t.next,f}else return{value:void 0,done:!0}}};return o}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let r=this._head,t=this.size;for(;r&&t>i;)this._map.delete(r.key),r=r.next,t--;this._head=r,this._size=t,r&&(r.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const r=i.next,t=i.previous;if(!r||!t)throw new Error("Invalid list");r.previous=t,t.next=r}i.next=void 0,i.previous=void 0,this._state++}touch(i,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(i===this._head)return;const t=i.next,o=i.previous;i===this._tail?(o.next=void 0,this._tail=o):(t.previous=o,o.next=t),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(r===2){if(i===this._tail)return;const t=i.next,o=i.previous;i===this._head?(t.previous=void 0,this._head=t):(t.previous=o,o.next=t),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((r,t)=>{i.push([t,r])}),i}fromJSON(i){this.clear();for(const[r,t]of i)this.set(r,t)}}e.LinkedMap=m;class s extends m{constructor(i,r=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,r=2){return super.get(i,r)}peek(i){return super.get(i,0)}set(i,r){return super.set(i,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s;class E{constructor(i){C.set(this,void 0),Xe(this,C,i,"f")}get size(){return Pe(this,C,"f").size}forEach(i,r){Pe(this,C,"f").forEach(i,r)}get(i){return Pe(this,C,"f").get(i)}has(i){return Pe(this,C,"f").has(i)}entries(){return Pe(this,C,"f").entries()}keys(){return Pe(this,C,"f").keys()}values(){return Pe(this,C,"f").values()}[(C=new WeakMap,Symbol.iterator)](){return Pe(this,C,"f").entries()}}e.ReadonlyMapView=E}),define(ve[95],we([1,0,24,8]),function(ee,e,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...N){return function(W,j){for(let re=0,he=N.length;re<he;re++){const Ce=N[re](W,j);if(Ce)return Ce}return null}}e.or=I,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(N,W,j){if(!j||j.length<W.length)return null;let re;return N?re=n.startsWithIgnoreCase(j,W):re=j.indexOf(W)===0,re?W.length>0?[{start:0,end:W.length}]:[]:null}function C(N,W){const j=W.toLowerCase().indexOf(N.toLowerCase());return j===-1?null:[{start:j,end:j+N.length}]}e.matchesContiguousSubString=C;function k(N,W){return S(N.toLowerCase(),W.toLowerCase(),0,0)}e.matchesSubString=k;function S(N,W,j,re){if(j===N.length)return[];if(re===W.length)return null;if(N[j]===W[re]){let he=null;return(he=S(N,W,j+1,re+1))?A({start:re,end:re+1},he):null}return S(N,W,j,re+1)}function R(N){return 97<=N&&N<=122}function F(N){return 65<=N&&N<=90}e.isUpper=F;function D(N){return 48<=N&&N<=57}function p(N){return N===32||N===9||N===10||N===13}const _=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(N=>_.add(N.charCodeAt(0)));function g(N){return p(N)||_.has(N)}function d(N,W){return N===W||g(N)&&g(W)}function v(N){return R(N)||F(N)||D(N)}function A(N,W){return W.length===0?W=[N]:N.end===W[0].start?W[0].start=N.start:W.unshift(N),W}function b(N,W){for(let j=W;j<N.length;j++){const re=N.charCodeAt(j);if(F(re)||D(re)||j>0&&!v(N.charCodeAt(j-1)))return j}return N.length}function a(N,W,j,re){if(j===N.length)return[];if(re===W.length)return null;if(N[j]!==W[re].toLowerCase())return null;{let he=null,Ce=re+1;for(he=a(N,W,j+1,re+1);!he&&(Ce=b(W,Ce))<W.length;)he=a(N,W,j+1,Ce),Ce++;return he===null?null:A({start:re,end:re+1},he)}}function c(N){let W=0,j=0,re=0,he=0,Ce=0;for(let He=0;He<N.length;He++)Ce=N.charCodeAt(He),F(Ce)&&W++,R(Ce)&&j++,v(Ce)&&re++,D(Ce)&&he++;const Ae=W/N.length,We=j/N.length,ze=re/N.length,qe=he/N.length;return{upperPercent:Ae,lowerPercent:We,alphaPercent:ze,numericPercent:qe}}function m(N){const{upperPercent:W,lowerPercent:j}=N;return j===0&&W>.6}function s(N){const{upperPercent:W,lowerPercent:j,alphaPercent:re,numericPercent:he}=N;return j>.2&&W<.8&&re>.6&&he<.2}function E(N){let W=0,j=0,re=0,he=0;for(let Ce=0;Ce<N.length;Ce++)re=N.charCodeAt(Ce),F(re)&&W++,R(re)&&j++,p(re)&&he++;return(W===0||j===0)&&he===0?N.length<=30:W<=5}function l(N,W){if(!W||(W=W.trim(),W.length===0)||!E(N)||W.length>60)return null;const j=c(W);if(!s(j)){if(!m(j))return null;W=W.toLowerCase()}let re=null,he=0;for(N=N.toLowerCase();he<W.length&&(re=a(N,W,0,he))===null;)he=b(W,he+1);return re}e.matchesCamelCase=l;function i(N,W,j=!1){if(!W||W.length===0)return null;let re=null,he=0;for(N=N.toLowerCase(),W=W.toLowerCase();he<W.length&&(re=r(N,W,0,he,j))===null;)he=t(W,he+1);return re}e.matchesWords=i;function r(N,W,j,re,he){if(j===N.length)return[];if(re===W.length)return null;if(d(N.charCodeAt(j),W.charCodeAt(re))){let Ce=null,Ae=re+1;if(Ce=r(N,W,j+1,re+1,he),!he)for(;!Ce&&(Ae=t(W,Ae))<W.length;)Ce=r(N,W,j+1,Ae,he),Ae++;return Ce===null?null:A({start:re,end:re+1},Ce)}else return null}function t(N,W){for(let j=W;j<N.length;j++)if(g(N.charCodeAt(j))||j>0&&g(N.charCodeAt(j-1)))return j;return N.length}const o=I(e.matchesPrefix,l,C),f=I(e.matchesPrefix,l,k),u=new h.LRUCache(1e4);function w(N,W,j=!1){if(typeof N!="string"||typeof W!="string")return null;let re=u.get(N);re||(re=new RegExp(n.convertSimple2RegExpPattern(N),"i"),u.set(N,re));const he=re.exec(W);return he?[{start:he.index,end:he.index+he[0].length}]:j?f(N,W):o(N,W)}e.matchesFuzzy=w;function P(N,W){const j=ge(N,N.toLowerCase(),0,W,W.toLowerCase(),0,!0);return j?O(j):null}e.matchesFuzzy2=P;function L(N,W,j,re,he,Ce){const Ae=Math.min(13,N.length);for(;j<Ae;j++){const We=ge(N,W,j,re,he,Ce,!1);if(We)return We}return[0,Ce]}e.anyScore=L;function O(N){if(typeof N=="undefined")return[];const W=[],j=N[1];for(let re=N.length-1;re>1;re--){const he=N[re]+j,Ce=W[W.length-1];Ce&&Ce.end===he?Ce.end=he+1:W.push({start:he,end:he+1})}return W}e.createMatches=O;const y=128;function z(){const N=[],W=[];for(let j=0;j<=y;j++)W[j]=0;for(let j=0;j<=y;j++)N.push(W.slice(0));return N}function M(N){const W=[];for(let j=0;j<=N;j++)W[j]=0;return W}const B=M(2*y),V=M(2*y),Y=z(),H=z(),q=z(),K=!1;function G(N,W,j,re,he){function Ce(We,ze,qe=" "){for(;We.length<ze;)We=qe+We;return We}let Ae=` |   |${re.split("").map(We=>Ce(We,3)).join("|")}
`;for(let We=0;We<=j;We++)We===0?Ae+=" |":Ae+=`${W[We-1]}|`,Ae+=N[We].slice(0,he+1).map(ze=>Ce(ze.toString(),3)).join("|")+`
`;return Ae}function ie(N,W,j,re){N=N.substr(W),j=j.substr(re),console.log(G(H,N,N.length,j,j.length)),console.log(G(q,N,N.length,j,j.length)),console.log(G(Y,N,N.length,j,j.length))}function oe(N,W){if(W<0||W>=N.length)return!1;const j=N.codePointAt(W);switch(j){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!n.isEmojiImprecise(j)}}function ue(N,W){if(W<0||W>=N.length)return!1;switch(N.charCodeAt(W)){case 32:case 9:return!0;default:return!1}}function Z(N,W,j){return W[N]!==j[N]}function Q(N,W,j,re,he,Ce,Ae=!1){for(;W<j&&he<Ce;)N[W]===re[he]&&(Ae&&(B[W]=he),W+=1),he+=1;return W===j}e.isPatternInWord=Q;var se;(function(N){N[N.Diag=1]="Diag",N[N.Left=2]="Left",N[N.LeftLeft=3]="LeftLeft"})(se||(se={}));var de;(function(N){N.Default=[-100,0];function W(j){return!j||j.length===2&&j[0]===-100&&j[1]===0}N.isDefault=W})(de=e.FuzzyScore||(e.FuzzyScore={}));function ge(N,W,j,re,he,Ce,Ae){const We=N.length>y?y:N.length,ze=re.length>y?y:re.length;if(j>=We||Ce>=ze||We-j>ze-Ce||!Q(W,j,We,he,Ce,ze,!0))return;Te(We,ze,j,Ce,W,he);let qe=1,He=1,Ue=j,Je=Ce;const et=[!1];for(qe=1,Ue=j;Ue<We;qe++,Ue++){const J=B[Ue],pe=V[Ue],Se=Ue+1<We?V[Ue+1]:ze;for(He=J-Ce+1,Je=J;Je<Se;He++,Je++){let Me=Number.MIN_SAFE_INTEGER,$e=!1;Je<=pe&&(Me=Ne(N,W,Ue,j,re,he,Je,ze,Ce,Y[qe-1][He-1]===0,et));let Ye=0;Me!==Number.MAX_SAFE_INTEGER&&($e=!0,Ye=Me+H[qe-1][He-1]);const lt=Je>J,vt=lt?H[qe][He-1]+(Y[qe][He-1]>0?-5:0):0,wt=Je>J+1&&Y[qe][He-1]>0,je=wt?H[qe][He-2]+(Y[qe][He-2]>0?-5:0):0;if(wt&&(!lt||je>=vt)&&(!$e||je>=Ye))H[qe][He]=je,q[qe][He]=3,Y[qe][He]=0;else if(lt&&(!$e||vt>=Ye))H[qe][He]=vt,q[qe][He]=2,Y[qe][He]=0;else if($e)H[qe][He]=Ye,q[qe][He]=1,Y[qe][He]=Y[qe-1][He-1]+1;else throw new Error("not possible")}}if(K&&ie(N,j,re,Ce),!et[0]&&!Ae)return;qe--,He--;const Le=[H[qe][He],Ce];let it=0,ne=0;for(;qe>=1;){let J=He;do{const pe=q[qe][J];if(pe===3)J=J-2;else if(pe===2)J=J-1;else break}while(J>=1);it>1&&W[j+qe-1]===he[Ce+He-1]&&!Z(J+Ce-1,re,he)&&it+1>Y[qe][J]&&(J=He),J===He?it++:it=1,ne||(ne=J),qe--,He=J-1,Le.push(He)}ze===We&&(Le[0]+=2);const ae=ne-We;return Le[0]-=ae,Le}e.fuzzyScore=ge;function Te(N,W,j,re,he,Ce){let Ae=N-1,We=W-1;for(;Ae>=j&&We>=re;)he[Ae]===Ce[We]&&(V[Ae]=We,Ae--),We--}function Ne(N,W,j,re,he,Ce,Ae,We,ze,qe,He){if(W[j]!==Ce[Ae])return Number.MIN_SAFE_INTEGER;let Ue=1,Je=!1;return Ae===j-re?Ue=N[j]===he[Ae]?7:5:Z(Ae,he,Ce)&&(Ae===0||!Z(Ae-1,he,Ce))?(Ue=N[j]===he[Ae]?7:5,Je=!0):oe(Ce,Ae)&&(Ae===0||!oe(Ce,Ae-1))?Ue=5:(oe(Ce,Ae-1)||ue(Ce,Ae-1))&&(Ue=5,Je=!0),Ue>1&&j===re&&(He[0]=!0),Je||(Je=Z(Ae,he,Ce)||oe(Ce,Ae-1)||ue(Ce,Ae-1)),j===re?Ae>ze&&(Ue-=Je?3:5):qe?Ue+=Je?2:0:Ue+=Je?0:1,Ae+1===We&&(Ue-=Je?3:5),Ue}function be(N,W,j,re,he,Ce,Ae){return $(N,W,j,re,he,Ce,!0,Ae)}e.fuzzyScoreGracefulAggressive=be;function Ee(N,W,j,re,he,Ce,Ae){return $(N,W,j,re,he,Ce,!1,Ae)}e.fuzzyScoreGraceful=Ee;function $(N,W,j,re,he,Ce,Ae,We){let ze=ge(N,W,j,re,he,Ce,We);if(ze&&!Ae)return ze;if(N.length>=3){const qe=Math.min(7,N.length-1);for(let He=j+1;He<qe;He++){const Ue=U(N,He);if(Ue){const Je=ge(Ue,Ue.toLowerCase(),j,re,he,Ce,We);Je&&(Je[0]-=3,(!ze||Je[0]>ze[0])&&(ze=Je))}}}return ze}function U(N,W){if(W+1>=N.length)return;const j=N[W],re=N[W+1];if(j!==re)return N.slice(0,W)+re+j+N.slice(W+2)}}),define(ve[144],we([1,0,72,95,8]),function(ee,e,h,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${h.CSSIcon.iconNameExpression}(?:${h.CSSIcon.iconModifierExpression})?\\)`,"g"),C=new RegExp(h.CSSIcon.iconNameCharacter),k=new RegExp(`(\\\\)?${T.source}`,"g");function S(v){return v.replace(k,(A,b)=>b?A:`\\${A}`)}e.escapeIcons=S;const R=new RegExp(`\\\\${T.source}`,"g");function F(v){return v.replace(R,A=>`\\${A}`)}e.markdownEscapeEscapedIcons=F;const D=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function p(v){return v.indexOf(e.iconStartMarker)===-1?v:v.replace(D,(A,b,a,c)=>a?A:b||c||"")}e.stripIcons=p;function _(v){const A=v.indexOf(e.iconStartMarker);return A===-1?{text:v}:g(v,A)}e.parseLabelWithIcons=_;function g(v,A){const b=[];let a="";function c(o){if(o){a+=o;for(const f of o)b.push(E)}}let m=-1,s="",E=0,l,i,r=A;const t=v.length;for(c(v.substr(0,A));r<t;)l=v[r],i=v[r+1],l===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(m=r,c(s),s=e.iconStartMarker,r++):l===")"&&m!==-1?(E+=r-m+1,m=-1,s=""):m!==-1?C.test(l)?s+=l:(c(s),m=-1,s=""):c(l),r++;return c(s),{text:a,iconOffsets:b}}function d(v,A,b=!1){const{text:a,iconOffsets:c}=A;if(!c||c.length===0)return(0,n.matchesFuzzy)(v,a,b);const m=(0,I.ltrim)(a," "),s=a.length-m.length,E=(0,n.matchesFuzzy)(v,m,b);if(E)for(const l of E){const i=c[l.start+s]+s;l.start+=i,l.end+=i}return E}e.matchesFuzzyIconAware=d}),define(ve[77],we([1,0,24]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new h.LRUCache(1e4);function I(R){return S(R,"NFC",n)}e.normalizeNFC=I;const T=new h.LRUCache(1e4);function C(R){return S(R,"NFD",T)}e.normalizeNFD=C;const k=/[^\u0000-\u0080]/;function S(R,F,D){if(!R)return R;const p=D.get(R);if(p)return p;let _;return k.test(R)?_=R.normalize(F):_=R,D.set(R,_),_}e.removeAccents=function(){const R=/[\u0300-\u036f]/g;return function(F){return C(F).replace(R,"")}}()}),define(ve[47],we([1,0,8]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var n;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(n||(n={})),function(I){const T="error",C="warning",k="warn",S="info",R="ignore";function F(p){return p?h.equalsIgnoreCase(T,p)?I.Error:h.equalsIgnoreCase(C,p)||h.equalsIgnoreCase(k,p)?I.Warning:h.equalsIgnoreCase(S,p)?I.Info:I.Ignore:I.Ignore}I.fromValue=F;function D(p){switch(p){case I.Error:return T;case I.Warning:return C;case I.Info:return S;default:return R}}I.toString=D}(n||(n={})),e.default=n}),define(ve[13],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function h(t){return Array.isArray(t)}e.isArray=h;function n(t){return typeof t=="string"}e.isString=n;function I(t){return Array.isArray(t)&&t.every(o=>n(o))}e.isStringArray=I;function T(t){return typeof t=="object"&&t!==null&&!Array.isArray(t)&&!(t instanceof RegExp)&&!(t instanceof Date)}e.isObject=T;function C(t){return typeof t=="number"&&!isNaN(t)}e.isNumber=C;function k(t){return!!t&&typeof t[Symbol.iterator]=="function"}e.isIterable=k;function S(t){return t===!0||t===!1}e.isBoolean=S;function R(t){return typeof t=="undefined"}e.isUndefined=R;function F(t){return!D(t)}e.isDefined=F;function D(t){return R(t)||t===null}e.isUndefinedOrNull=D;function p(t,o){if(!t)throw new Error(o?`Unexpected type, expected '${o}'`:"Unexpected type")}e.assertType=p;function _(t){if(D(t))throw new Error("Assertion Failed: argument is undefined or null");return t}e.assertIsDefined=_;function g(...t){const o=[];for(let f=0;f<t.length;f++){const u=t[f];if(D(u))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);o.push(u)}return o}e.assertAllDefined=g;const d=Object.prototype.hasOwnProperty;function v(t){if(!T(t))return!1;for(let o in t)if(d.call(t,o))return!1;return!0}e.isEmptyObject=v;function A(t){return typeof t=="function"}e.isFunction=A;function b(...t){return t.length>0&&t.every(A)}e.areFunctions=b;function a(t,o){const f=Math.min(t.length,o.length);for(let u=0;u<f;u++)c(t[u],o[u])}e.validateConstraints=a;function c(t,o){if(n(o)){if(typeof t!==o)throw new Error(`argument does not match constraint: typeof ${o}`)}else if(A(o)){try{if(t instanceof o)return}catch{}if(!D(t)&&t.constructor===o||o.length===1&&o.call(void 0,t)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function m(t){let o=[],f=Object.getPrototypeOf(t);for(;Object.prototype!==f;)o=o.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return o}e.getAllPropertyNames=m;function s(t){const o=[];for(const f of m(t))typeof t[f]=="function"&&o.push(f);return o}e.getAllMethodNames=s;function E(t,o){const f=w=>function(){const P=Array.prototype.slice.call(arguments,0);return o(w,P)};let u={};for(const w of t)u[w]=f(w);return u}e.createProxyObject=E;function l(t){return t===null?void 0:t}e.withNullAsUndefined=l;function i(t){return typeof t=="undefined"?null:t}e.withUndefinedAsNull=i;function r(t,o="Unreachable"){throw new Error(o)}e.assertNever=r}),define(ve[29],we([1,0,9,12,8,13]),function(ee,e,h,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(r){return r===47||r===92}e.isPathSeparator=C;function k(r){return r.replace(/[\\/]/g,h.posix.sep)}e.toSlashes=k;function S(r){return r.indexOf("/")===-1&&(r=k(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=S;function R(r,t=h.posix.sep){if(!r)return"";const o=r.length,f=r.charCodeAt(0);if(C(f)){if(C(r.charCodeAt(1))&&!C(r.charCodeAt(2))){let w=3;const P=w;for(;w<o&&!C(r.charCodeAt(w));w++);if(P!==w&&!C(r.charCodeAt(w+1))){for(w+=1;w<o;w++)if(C(r.charCodeAt(w)))return r.slice(0,w+1).replace(/[\\/]/g,t)}}return t}else if(A(f)&&r.charCodeAt(1)===58)return C(r.charCodeAt(2))?r.slice(0,2)+t:r.slice(0,2);let u=r.indexOf("://");if(u!==-1){for(u+=3;u<o;u++)if(C(r.charCodeAt(u)))return r.slice(0,u+1)}return""}e.getRoot=R;function F(r){if(!n.isWindows||!r||r.length<5)return!1;let t=r.charCodeAt(0);if(t!==92||(t=r.charCodeAt(1),t!==92))return!1;let o=2;const f=o;for(;o<r.length&&(t=r.charCodeAt(o),t!==92);o++);return!(f===o||(t=r.charCodeAt(o+1),isNaN(t)||t===92))}e.isUNC=F;const D=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,_=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(r,t=n.isWindows){const o=t?D:p;return!(!r||r.length===0||/^\s+$/.test(r)||(o.lastIndex=0,o.test(r))||t&&_.test(r)||r==="."||r===".."||t&&r[r.length-1]==="."||t&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=g;function d(r,t,o){const f=r===t;return!o||f?f:!r||!t?!1:(0,I.equalsIgnoreCase)(r,t)}e.isEqual=d;function v(r,t,o,f=h.sep){if(r===t)return!0;if(!r||!t||t.length>r.length)return!1;if(o){if(!(0,I.startsWithIgnoreCase)(r,t))return!1;if(t.length===r.length)return!0;let w=t.length;return t.charAt(t.length-1)===f&&w--,r.charAt(w)===f}return t.charAt(t.length-1)!==f&&(t+=f),r.indexOf(t)===0}e.isEqualOrParent=v;function A(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=A;function b(r,t){return n.isWindows&&r.endsWith(":")&&(r+=h.sep),(0,h.isAbsolute)(r)||(r=(0,h.join)(t,r)),r=(0,h.normalize)(r),n.isWindows?(r=(0,I.rtrim)(r,h.sep),r.endsWith(":")&&(r+=h.sep)):(r=(0,I.rtrim)(r,h.sep),r||(r=h.sep)),r}e.sanitizeFilePath=b;function a(r){const t=(0,h.normalize)(r);return n.isWindows?r.length>3?!1:c(t)&&(r.length===2||t.charCodeAt(2)===92):t===h.posix.sep}e.isRootOrDriveLetter=a;function c(r,t){return(t!==void 0?t:n.isWindows)?A(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function m(r){return c(r)?r[0]:void 0}e.getDriveLetter=m;function s(r,t,o){return t.length>r.length?-1:r===t?0:(o&&(r=r.toLowerCase(),t=t.toLowerCase()),r.indexOf(t))}e.indexOfPath=s;function E(r){const t=r.split(":");let o,f,u;for(const w of t){const P=Number(w);(0,T.isNumber)(P)?f===void 0?f=P:u===void 0&&(u=P):o=o?[o,w].join(":"):w}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:f!==void 0?f:void 0,column:u!==void 0?u:f!==void 0?1:void 0}}e.parseLineAndColumnAware=E;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(r,t,o=8){let f="";for(let w=0;w<o;w++)f+=l.charAt(Math.floor(Math.random()*l.length));let u;return t?u=`${t}-${f}`:u=f,r?(0,h.join)(r,u):u}e.randomPath=i}),define(ve[25],we([1,0,13]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const v=Array.isArray(d)?[]:{};return Object.keys(d).forEach(A=>{d[A]&&typeof d[A]=="object"?v[A]=n(d[A]):v[A]=d[A]}),v}e.deepClone=n;function I(d){if(!d||typeof d!="object")return d;const v=[d];for(;v.length>0;){const A=v.shift();Object.freeze(A);for(const b in A)if(T.call(A,b)){const a=A[b];typeof a=="object"&&!Object.isFrozen(a)&&v.push(a)}}return d}e.deepFreeze=I;const T=Object.prototype.hasOwnProperty;function C(d,v){return k(d,v,new Set)}e.cloneAndChange=C;function k(d,v,A){if((0,h.isUndefinedOrNull)(d))return d;const b=v(d);if(typeof b!="undefined")return b;if((0,h.isArray)(d)){const a=[];for(const c of d)a.push(k(c,v,A));return a}if((0,h.isObject)(d)){if(A.has(d))throw new Error("Cannot clone recursive data-structure");A.add(d);const a={};for(let c in d)T.call(d,c)&&(a[c]=k(d[c],v,A));return A.delete(d),a}return d}function S(d,v,A=!0){return(0,h.isObject)(d)?((0,h.isObject)(v)&&Object.keys(v).forEach(b=>{b in d?A&&((0,h.isObject)(d[b])&&(0,h.isObject)(v[b])?S(d[b],v[b],A):d[b]=v[b]):d[b]=v[b]}),d):v}e.mixin=S;function R(d,v){if(d===v)return!0;if(d==null||v===null||v===void 0||typeof d!=typeof v||typeof d!="object"||Array.isArray(d)!==Array.isArray(v))return!1;let A,b;if(Array.isArray(d)){if(d.length!==v.length)return!1;for(A=0;A<d.length;A++)if(!R(d[A],v[A]))return!1}else{const a=[];for(b in d)a.push(b);a.sort();const c=[];for(b in v)c.push(b);if(c.sort(),!R(a,c))return!1;for(A=0;A<a.length;A++)if(!R(d[a[A]],v[a[A]]))return!1}return!0}e.equals=R;function F(d){const v=new Set;return JSON.stringify(d,(A,b)=>{if((0,h.isObject)(b)||Array.isArray(b)){if(v.has(b))return"[Circular]";v.add(b)}return b})}e.safeStringify=F;function D(d,v,A){const b=v(d);return typeof b=="undefined"?A:b}e.getOrDefault=D;function p(d,v){const A=Object.create(null);return!d||!v||Object.keys(v).forEach(a=>{const c=d[a],m=v[a];R(c,m)||(A[a]=m)}),A}e.distinct=p;function _(d,v){const A=v.toLowerCase(),b=Object.keys(d).find(a=>a.toLowerCase()===A);return b?d[b]:d[v]}e.getCaseInsensitive=_;function g(d,v){const A=Object.create(null);for(const[b,a]of Object.entries(d))v(b,a)&&(A[b]=a);return A}e.filter=g}),define(ve[96],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var h;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(h=e.Constants||(e.Constants={}));function n(T){return T<0?0:T>255?255:T|0}e.toUint8=n;function I(T){return T<0?0:T>4294967295?4294967295:T|0}e.toUint32=I}),define(ve[2],we([1,0,9,12]),function(ee,e,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const I=/^\w[\w\d+.-]*$/,T=/^\//,C=/^\/\//;function k(l,i){if(!l.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!I.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!T.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(l,i){return!l&&!i?"file":l}function R(l,i){switch(l){case"https":case"http":case"file":i?i[0]!==D&&(i=D+i):i=D;break}return i}const F="",D="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class _{constructor(i,r,t,o,f,u=!1){typeof i=="object"?(this.scheme=i.scheme||F,this.authority=i.authority||F,this.path=i.path||F,this.query=i.query||F,this.fragment=i.fragment||F):(this.scheme=S(i,u),this.authority=r||F,this.path=R(this.scheme,t||F),this.query=o||F,this.fragment=f||F,k(this,u))}static isUri(i){return i instanceof _?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return a(this,!1)}with(i){if(!i)return this;let{scheme:r,authority:t,path:o,query:f,fragment:u}=i;return r===void 0?r=this.scheme:r===null&&(r=F),t===void 0?t=this.authority:t===null&&(t=F),o===void 0?o=this.path:o===null&&(o=F),f===void 0?f=this.query:f===null&&(f=F),u===void 0?u=this.fragment:u===null&&(u=F),r===this.scheme&&t===this.authority&&o===this.path&&f===this.query&&u===this.fragment?this:new d(r,t,o,f,u)}static parse(i,r=!1){const t=p.exec(i);return t?new d(t[2]||F,E(t[4]||F),E(t[5]||F),E(t[7]||F),E(t[9]||F),r):new d(F,F,F,F,F)}static file(i){let r=F;if(n.isWindows&&(i=i.replace(/\\/g,D)),i[0]===D&&i[1]===D){const t=i.indexOf(D,2);t===-1?(r=i.substring(2),i=D):(r=i.substring(2,t),i=i.substring(t)||D)}return new d("file",r,i,F,F)}static from(i){const r=new d(i.scheme,i.authority,i.path,i.query,i.fragment);return k(r,!0),r}static joinPath(i,...r){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let t;return n.isWindows&&i.scheme==="file"?t=_.file(h.win32.join(a(i,!0),...r)).path:t=h.posix.join(i.path,...r),i.with({path:t})}toString(i=!1){return c(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof _)return i;{const r=new d(i);return r._formatted=i.external,r._fsPath=i._sep===g?i.fsPath:null,r}}else return i}}e.URI=_;const g=n.isWindows?1:void 0;class d extends _{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(i=!1){return i?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=g),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function A(l,i){let r,t=-1;for(let o=0;o<l.length;o++){const f=l.charCodeAt(o);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||i&&f===47)t!==-1&&(r+=encodeURIComponent(l.substring(t,o)),t=-1),r!==void 0&&(r+=l.charAt(o));else{r===void 0&&(r=l.substr(0,o));const u=v[f];u!==void 0?(t!==-1&&(r+=encodeURIComponent(l.substring(t,o)),t=-1),r+=u):t===-1&&(t=o)}}return t!==-1&&(r+=encodeURIComponent(l.substring(t))),r!==void 0?r:l}function b(l){let i;for(let r=0;r<l.length;r++){const t=l.charCodeAt(r);t===35||t===63?(i===void 0&&(i=l.substr(0,r)),i+=v[t]):i!==void 0&&(i+=l[r])}return i!==void 0?i:l}function a(l,i){let r;return l.authority&&l.path.length>1&&l.scheme==="file"?r=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?i?r=l.path.substr(1):r=l.path[1].toLowerCase()+l.path.substr(2):r=l.path,n.isWindows&&(r=r.replace(/\//g,"\\")),r}e.uriToFsPath=a;function c(l,i){const r=i?b:A;let t="",{scheme:o,authority:f,path:u,query:w,fragment:P}=l;if(o&&(t+=o,t+=":"),(f||o==="file")&&(t+=D,t+=D),f){let L=f.indexOf("@");if(L!==-1){const O=f.substr(0,L);f=f.substr(L+1),L=O.indexOf(":"),L===-1?t+=r(O,!1):(t+=r(O.substr(0,L),!1),t+=":",t+=r(O.substr(L+1),!1)),t+="@"}f=f.toLowerCase(),L=f.indexOf(":"),L===-1?t+=r(f,!1):(t+=r(f.substr(0,L),!1),t+=f.substr(L))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const L=u.charCodeAt(1);L>=65&&L<=90&&(u=`/${String.fromCharCode(L+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const L=u.charCodeAt(0);L>=65&&L<=90&&(u=`${String.fromCharCode(L+32)}:${u.substr(2)}`)}t+=r(u,!0)}return w&&(t+="?",t+=r(w,!1)),P&&(t+="#",t+=i?P:A(P,!1)),t}function m(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+m(l.substr(3)):l}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function E(l){return l.match(s)?l.replace(s,i=>m(i)):l}}),define(ve[58],we([1,0,22,8,2]),function(ee,e,h,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function T(F){return JSON.stringify(F,S)}e.stringify=T;function C(F){let D=JSON.parse(F);return D=R(D),D}e.parse=C;var k;(function(F){F[F.Uri=1]="Uri",F[F.Regexp=2]="Regexp",F[F.ScmResource=3]="ScmResource",F[F.ScmResourceGroup=4]="ScmResourceGroup",F[F.ScmProvider=5]="ScmProvider",F[F.CommentController=6]="CommentController",F[F.CommentThread=7]="CommentThread",F[F.CommentThreadReply=8]="CommentThreadReply",F[F.CommentNode=9]="CommentNode",F[F.CommentThreadNode=10]="CommentThreadNode",F[F.TimelineActionContext=11]="TimelineActionContext",F[F.NotebookCellActionContext=12]="NotebookCellActionContext",F[F.TestItemContext=13]="TestItemContext",F[F.Date=14]="Date"})(k=e.MarshalledId||(e.MarshalledId={}));function S(F,D){return D instanceof RegExp?{$mid:2,source:D.source,flags:(0,n.regExpFlags)(D)}:D}function R(F,D=0){if(!F||D>200)return F;if(typeof F=="object"){switch(F.$mid){case 1:return I.URI.revive(F);case 2:return new RegExp(F.source,F.flags);case 14:return new Date(F.source)}if(F instanceof h.VSBuffer||F instanceof Uint8Array)return F;if(Array.isArray(F))for(let p=0;p<F.length;++p)F[p]=R(F[p],D+1);else for(const p in F)Object.hasOwnProperty.call(F,p)&&(F[p]=R(F[p],D+1))}return F}e.revive=R}),define(ve[10],we([1,0,12,2]),function(ee,e,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var I;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls"})(I=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,R,F){this._hosts[S]=R,this._ports[S]=F}setConnectionToken(S,R){this._connectionTokens[S]=R}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(S){if(this._delegate)return this._delegate(S);const R=S.authority;let F=this._hosts[R];F&&F.indexOf(":")!==-1&&(F=`[${F}]`);const D=this._ports[R],p=this._connectionTokens[R];let _=`path=${encodeURIComponent(S.path)}`;return typeof p=="string"&&(_+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),n.URI.from({scheme:h.isWeb?this._preferredWebSchema:I.vscodeRemoteResource,authority:`${F}:${D}`,path:"/vscode-remote-resource",query:_})}}e.RemoteAuthorities=new T;class C{asBrowserUri(S,R){const F=this.toUri(S,R);return F.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(F):F.scheme===I.file&&(h.isNative||typeof h.globals.importScripts=="function"&&h.globals.origin===`${I.vscodeFileResource}://${C.FALLBACK_AUTHORITY}`)?F.with({scheme:I.vscodeFileResource,authority:F.authority||C.FALLBACK_AUTHORITY,query:null,fragment:null}):F}asFileUri(S,R){const F=this.toUri(S,R);return F.scheme===I.vscodeFileResource?F.with({scheme:I.file,authority:F.authority!==C.FALLBACK_AUTHORITY?F.authority:null,query:null,fragment:null}):F}toUri(S,R){return n.URI.isUri(S)?S:n.URI.parse(R.toUrl(S))}}C.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new C}),define(ve[23],we([1,0,29,10,9,12,8,2]),function(ee,e,h,n,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(_){return(0,k.uriToFsPath)(_,!0)}e.originalFSPath=S;class R{constructor(g){this._ignorePathCasing=g}compare(g,d,v=!1){return g===d?0:(0,C.compare)(this.getComparisonKey(g,v),this.getComparisonKey(d,v))}isEqual(g,d,v=!1){return g===d?!0:!g||!d?!1:this.getComparisonKey(g,v)===this.getComparisonKey(d,v)}getComparisonKey(g,d=!1){return g.with({path:this._ignorePathCasing(g)?g.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(g){return this._ignorePathCasing(g)}isEqualOrParent(g,d,v=!1){if(g.scheme===d.scheme){if(g.scheme===n.Schemas.file)return h.isEqualOrParent(S(g),S(d),this._ignorePathCasing(g))&&g.query===d.query&&(v||g.fragment===d.fragment);if((0,e.isEqualAuthority)(g.authority,d.authority))return h.isEqualOrParent(g.path,d.path,this._ignorePathCasing(g),"/")&&g.query===d.query&&(v||g.fragment===d.fragment)}return!1}joinPath(g,...d){return k.URI.joinPath(g,...d)}basenameOrAuthority(g){return(0,e.basename)(g)||g.authority}basename(g){return I.posix.basename(g.path)}extname(g){return I.posix.extname(g.path)}dirname(g){if(g.path.length===0)return g;let d;return g.scheme===n.Schemas.file?d=k.URI.file(I.dirname(S(g))).path:(d=I.posix.dirname(g.path),g.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),d="/")),g.with({path:d})}normalizePath(g){if(!g.path.length)return g;let d;return g.scheme===n.Schemas.file?d=k.URI.file(I.normalize(S(g))).path:d=I.posix.normalize(g.path),g.with({path:d})}relativePath(g,d){if(g.scheme!==d.scheme||!(0,e.isEqualAuthority)(g.authority,d.authority))return;if(g.scheme===n.Schemas.file){const b=I.relative(S(g),S(d));return T.isWindows?h.toSlashes(b):b}let v=g.path||"/",A=d.path||"/";if(this._ignorePathCasing(g)){let b=0;for(const a=Math.min(v.length,A.length);b<a&&!(v.charCodeAt(b)!==A.charCodeAt(b)&&v.charAt(b).toLowerCase()!==A.charAt(b).toLowerCase());b++);v=A.substr(0,b)+v.substr(b)}return I.posix.relative(v,A)}resolvePath(g,d){if(g.scheme===n.Schemas.file){const v=k.URI.file(I.resolve(S(g),d));return g.with({authority:v.authority,path:v.path})}return d=h.toPosixPath(d),g.with({path:I.posix.resolve(g.path,d)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,d){return g===d||g!==void 0&&d!==void 0&&(0,C.equalsIgnoreCase)(g,d)}hasTrailingPathSeparator(g,d=I.sep){if(g.scheme===n.Schemas.file){const v=S(g);return v.length>h.getRoot(v).length&&v[v.length-1]===d}else{const v=g.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,d=I.sep){return(0,e.hasTrailingPathSeparator)(g,d)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,d=I.sep){let v=!1;if(g.scheme===n.Schemas.file){const A=S(g);v=A!==void 0&&A.length===h.getRoot(A).length&&A[A.length-1]===d}else{d="/";const A=g.path;v=A.length===1&&A.charCodeAt(A.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(g,d)?g.with({path:g.path+"/"}):g}}e.ExtUri=R,e.extUri=new R(()=>!1),e.extUriBiasedIgnorePathCase=new R(_=>_.scheme===n.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new R(_=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function F(_,g){const d=[];for(let v=0;v<_.length;v++){const A=g(_[v]);_.some((b,a)=>a===v?!1:(0,e.isEqualOrParent)(A,g(b)))||d.push(_[v])}return d}e.distinctParents=F;var D;(function(_){_.META_DATA_LABEL="label",_.META_DATA_DESCRIPTION="description",_.META_DATA_SIZE="size",_.META_DATA_MIME="mime";function g(d){const v=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(a=>{const[c,m]=a.split(":");c&&m&&v.set(c,m)});const b=d.path.substring(0,d.path.indexOf(";"));return b&&v.set(_.META_DATA_MIME,b),v}_.parseMetaData=g})(D=e.DataUri||(e.DataUri={}));function p(_,g,d){if(g){let v=_.path;return v&&v[0]!==I.posix.sep&&(v=I.posix.sep+v),_.with({scheme:d,authority:g,path:v})}return _.with({scheme:d})}e.toLocalResource=p}),define(ve[15],we([1,0,21,17,3,6,23,12]),function(ee,e,h,n,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(Z){return!!Z&&typeof Z.then=="function"}e.isThenable=S;function R(Z){const Q=new h.CancellationTokenSource,se=Z(Q.token),de=new Promise((ge,Te)=>{const Ne=Q.token.onCancellationRequested(()=>{Ne.dispose(),Q.dispose(),Te(new n.CancellationError)});Promise.resolve(se).then(be=>{Ne.dispose(),Q.dispose(),ge(be)},be=>{Ne.dispose(),Q.dispose(),Te(be)})});return new class{cancel(){Q.cancel()}then(ge,Te){return de.then(ge,Te)}catch(ge){return this.then(void 0,ge)}finally(ge){return de.finally(ge)}}}e.createCancelablePromise=R;function F(Z,Q,se){return new Promise((de,ge)=>{const Te=Q.onCancellationRequested(()=>{Te.dispose(),de(se)});Z.then(de,ge).finally(()=>Te.dispose())})}e.raceCancellation=F;function D(Z,Q){return new Promise((se,de)=>{const ge=Q.onCancellationRequested(()=>{ge.dispose(),de(new n.CancellationError)});Z.then(se,de).finally(()=>ge.dispose())})}e.raceCancellationError=D;async function p(Z){let Q=-1;const se=Z.map((ge,Te)=>ge.then(Ne=>(Q=Te,Ne))),de=await Promise.race(se);return Z.forEach((ge,Te)=>{Te!==Q&&ge.cancel()}),de}e.raceCancellablePromises=p;function _(Z,Q,se){let de;const ge=setTimeout(()=>{de?.(void 0),se?.()},Q);return Promise.race([Z.finally(()=>clearTimeout(ge)),new Promise(Te=>de=Te)])}e.raceTimeout=_;function g(Z){return new Promise((Q,se)=>{const de=Z();S(de)?de.then(Q,se):Q(de)})}e.asPromise=g;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Q){if(this.activePromise){if(this.queuedPromiseFactory=Q,!this.queuedPromise){const se=()=>{this.queuedPromise=null;const de=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,de};this.queuedPromise=new Promise(de=>{this.activePromise.then(se,se).then(de)})}return new Promise((se,de)=>{this.queuedPromise.then(se,de)})}return this.activePromise=Q(),new Promise((se,de)=>{this.activePromise.then(ge=>{this.activePromise=null,se(ge)},ge=>{this.activePromise=null,de(ge)})})}}e.Throttler=d;class v{constructor(){this.current=Promise.resolve(null)}queue(Q){return this.current=this.current.then(()=>Q(),()=>Q())}}e.Sequencer=v;class A{constructor(){this.promiseMap=new Map}queue(Q,se){const ge=(this.promiseMap.get(Q)??Promise.resolve()).catch(()=>{}).then(se).finally(()=>{this.promiseMap.get(Q)===ge&&this.promiseMap.delete(Q)});return this.promiseMap.set(Q,ge),ge}}e.SequencerByKey=A;const b=(Z,Q)=>{let se=!0;const de=setTimeout(()=>{se=!1,Q()},Z);return{isTriggered:()=>se,dispose:()=>{clearTimeout(de),se=!1}}},a=Z=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,Z())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class c{constructor(Q){this.defaultDelay=Q,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Q,se=this.defaultDelay){this.task=Q,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ge,Te)=>{this.doResolve=ge,this.doReject=Te}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ge=this.task;return this.task=null,ge()}}));const de=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=se===e.MicrotaskDelay?a(de):b(se,de),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=c;class m{constructor(Q){this.delayer=new c(Q),this.throttler=new d}trigger(Q,se){return this.delayer.trigger(()=>this.throttler.queue(Q),se)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=m;class s{constructor(){this._isOpen=!1,this._promise=new Promise((Q,se)=>{this._completePromise=Q})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class E extends s{constructor(Q){super();this._timeout=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=E;function l(Z,Q){return Q?new Promise((se,de)=>{const ge=setTimeout(()=>{Te.dispose(),se()},Z),Te=Q.onCancellationRequested(()=>{clearTimeout(ge),Te.dispose(),de(new n.CancellationError)})}):R(se=>l(Z,se))}e.timeout=l;function i(Z,Q=0){const se=setTimeout(Z,Q);return(0,T.toDisposable)(()=>clearTimeout(se))}e.disposableTimeout=i;function r(Z){const Q=[];let se=0;const de=Z.length;function ge(){return se<de?Z[se++]():null}function Te(Ne){Ne!=null&&Q.push(Ne);const be=ge();return be?be.then(Te):Promise.resolve(Q)}return Promise.resolve(null).then(Te)}e.sequence=r;function t(Z,Q=de=>!!de,se=null){let de=0;const ge=Z.length,Te=()=>{if(de>=ge)return Promise.resolve(se);const Ne=Z[de++];return Promise.resolve(Ne()).then(Ee=>Q(Ee)?Promise.resolve(Ee):Te())};return Te()}e.first=t;function o(Z,Q=de=>!!de,se=null){if(Z.length===0)return Promise.resolve(se);let de=Z.length;const ge=()=>{de=-1;for(const Te of Z)Te.cancel?.()};return new Promise((Te,Ne)=>{for(const be of Z)be.then(Ee=>{--de>=0&&Q(Ee)?(ge(),Te(Ee)):de===0&&Te(se)}).catch(Ee=>{--de>=0&&(ge(),Ne(Ee))})})}e.firstParallel=o;class f{constructor(Q){this._size=0,this.maxDegreeOfParalellism=Q,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new I.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(Q){return this._size++,new Promise((se,de)=>{this.outstandingPromises.push({factory:Q,c:se,e:de}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Q=this.outstandingPromises.shift();this.runningPromises++;const se=Q.factory();se.then(Q.c,Q.e),se.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=f;class u extends f{constructor(){super(1)}}e.Queue=u;class w{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Q=new q;return this.drainers.add(Q),Q.p}isDrained(){for(const[,Q]of this.queues)if(Q.size>0)return!1;return!0}queueFor(Q,se=C.extUri){const de=se.getComparisonKey(Q);let ge=this.queues.get(de);return ge||(ge=new u,I.Event.once(ge.onFinished)(()=>{ge?.dispose(),this.queues.delete(de),this.onDidQueueFinish()}),this.queues.set(de,ge)),ge}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Q of this.drainers)Q.complete();this.drainers.clear()}dispose(){for(const[,Q]of this.queues)Q.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=w;class P{constructor(Q,se){this._token=-1,typeof Q=="function"&&typeof se=="number"&&this.setIfNotSet(Q,se)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Q,se){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Q()},se)}setIfNotSet(Q,se){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Q()},se))}}e.TimeoutTimer=P;class L{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Q,se){this.cancel(),this._token=setInterval(()=>{Q()},se)}}e.IntervalTimer=L;class O{constructor(Q,se){this.timeoutToken=-1,this.runner=Q,this.timeout=se,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Q=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Q)}get delay(){return this.timeout}set delay(Q){this.timeout=Q}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=O;class y{constructor(Q,se){se%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${se}ms is not a multiple of 1000ms.`),this.runner=Q,this.timeout=se,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Q=this.timeout){Q%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Q/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=y;class z extends O{constructor(Q,se){super(Q,se);this.units=[]}work(Q){this.units.push(Q),this.isScheduled()||this.schedule()}doRun(){const Q=this.units;this.units=[],this.runner&&this.runner(Q)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=z;class M extends T.Disposable{constructor(Q,se){super();this.options=Q,this.handler=se,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Q){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Q.length>this.options.maxBufferedWork)return!1}else if(this.pending+Q.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...Q),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new O(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=Z=>{(0,k.setTimeout0)(()=>{if(Q)return;const se=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,se-Date.now())}}))});let Q=!1;return{dispose(){Q||(Q=!0)}}}:e.runWhenIdle=(Z,Q)=>{const se=requestIdleCallback(Z,typeof Q=="number"?{timeout:Q}:void 0);let de=!1;return{dispose(){de||(de=!0,cancelIdleCallback(se))}}}}();class B{constructor(Q){this._didRun=!1,this._executor=()=>{try{this._value=Q()}catch(se){this._error=se}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=B;async function V(Z,Q,se){let de;for(let ge=0;ge<se;ge++)try{return await Z()}catch(Te){de=Te,await l(Q)}throw de}e.retry=V;class Y{hasPending(Q){return this._pending?typeof Q=="number"?this._pending.taskId===Q:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(Q,se,de){return this._pending={taskId:Q,cancel:()=>de?.(),promise:se},se.then(()=>this.donePending(Q),()=>this.donePending(Q)),se}donePending(Q){this._pending&&Q===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Q=this._next;this._next=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}setNext(Q){if(this._next)this._next.run=Q;else{let se,de;const ge=new Promise((Te,Ne)=>{se=Te,de=Ne});this._next={run:Q,promise:ge,promiseResolve:se,promiseReject:de}}return this._next.promise}}e.TaskSequentializer=Y;class H{constructor(Q,se=()=>Date.now()){this.interval=Q,this.nowFn=se,this.lastIncrementTime=0,this.value=0}increment(){const Q=this.nowFn();return Q-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Q,this.value=0),this.value++,this.value}}e.IntervalCounter=H;class q{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Q,se)=>{this.completeCallback=Q,this.errorCallback=se})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(Q){return new Promise(se=>{this.completeCallback(Q),this.resolved=!0,se()})}error(Q){return new Promise(se=>{this.errorCallback(Q),this.rejected=!0,se()})}cancel(){new Promise(Q=>{this.errorCallback(new n.CancellationError),this.rejected=!0,Q()})}}e.DeferredPromise=q;var K;(function(Z){async function Q(de){let ge;const Te=await Promise.all(de.map(Ne=>Ne.then(be=>be,be=>{ge||(ge=be)})));if(typeof ge!="undefined")throw ge;return Te}Z.settled=Q;function se(de){return new Promise(async(ge,Te)=>{try{await de(ge,Te)}catch(Ne){Te(Ne)}})}Z.withAsyncBody=se})(K=e.Promises||(e.Promises={}));var G;(function(Z){Z[Z.Initial=0]="Initial",Z[Z.DoneOK=1]="DoneOK",Z[Z.DoneError=2]="DoneError"})(G||(G={}));class ie{constructor(Q){this._state=0,this._results=[],this._error=null,this._onStateChanged=new I.Emitter,queueMicrotask(async()=>{const se={emitOne:de=>this.emitOne(de),emitMany:de=>this.emitMany(de),reject:de=>this.reject(de)};try{await Promise.resolve(Q(se)),this.resolve()}catch(de){this.reject(de)}finally{se.emitOne=void 0,se.emitMany=void 0,se.reject=void 0}})}static fromArray(Q){return new ie(se=>{se.emitMany(Q)})}static fromPromise(Q){return new ie(async se=>{se.emitMany(await Q)})}static fromPromises(Q){return new ie(async se=>{await Promise.all(Q.map(async de=>se.emitOne(await de)))})}static merge(Q){return new ie(async se=>{await Promise.all(Q.map(async de=>{for await(const ge of de)se.emitOne(ge)}))})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Q<this._results.length)return{done:!1,value:this._results[Q++]};if(this._state===1)return{done:!0,value:void 0};await I.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Q,se){return new ie(async de=>{for await(const ge of Q)de.emitOne(se(ge))})}map(Q){return ie.map(this,Q)}static filter(Q,se){return new ie(async de=>{for await(const ge of Q)se(ge)&&de.emitOne(ge)})}filter(Q){return ie.filter(this,Q)}static coalesce(Q){return ie.filter(Q,se=>!!se)}coalesce(){return ie.coalesce(this)}static async toPromise(Q){const se=[];for await(const de of Q)se.push(de);return se}toPromise(){return ie.toPromise(this)}emitOne(Q){this._state===0&&(this._results.push(Q),this._onStateChanged.fire())}emitMany(Q){this._state===0&&(this._results=this._results.concat(Q),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Q){this._state===0&&(this._state=2,this._error=Q,this._onStateChanged.fire())}}e.AsyncIterableObject=ie,ie.EMPTY=ie.fromArray([]);class oe extends ie{constructor(Q,se){super(se);this._source=Q}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=oe;function ue(Z){const Q=new h.CancellationTokenSource,se=Z(Q.token);return new oe(Q,async de=>{const ge=Q.token.onCancellationRequested(()=>{ge.dispose(),Q.dispose(),de.reject(new n.CancellationError)});try{for await(const Te of se){if(Q.token.isCancellationRequested)return;de.emitOne(Te)}ge.dispose(),Q.dispose()}catch(Te){ge.dispose(),Q.dispose(),de.reject(Te)}})}e.createCancelableAsyncIterable=ue}),define(ve[97],we([1,0,15,9]),function(ee,e,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const I=new h.IdleValue(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),T=new h.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),C=new h.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(u,w,P=!1){const L=u||"",O=w||"",y=I.value.collator.compare(L,O);return I.value.collatorIsNumeric&&y===0&&L!==O?L<O?-1:1:y}e.compareFileNames=k;function S(u,w){const P=T.value.collator;return u=u||"",w=w||"",m(P,u,w)}e.compareFileNamesDefault=S;function R(u,w){const P=T.value.collator;return u=u||"",w=w||"",i(u,w)||m(P,u,w)}e.compareFileNamesUpper=R;function F(u,w){const P=T.value.collator;return u=u||"",w=w||"",l(u,w)||m(P,u,w)}e.compareFileNamesLower=F;function D(u,w){return u=u||"",w=w||"",u===w?0:u<w?-1:1}e.compareFileNamesUnicode=D;function p(u,w,P=!1){P||(u=u&&u.toLowerCase(),w=w&&w.toLowerCase());const[L,O]=a(u),[y,z]=a(w);return L!==y?L<y?-1:1:O===z?0:O<z?-1:1}e.noIntlCompareFileNames=p;function _(u,w){const[P,L]=a(u),[O,y]=a(w);let z=I.value.collator.compare(L,y);if(z===0){if(I.value.collatorIsNumeric&&L!==y)return L<y?-1:1;if(z=I.value.collator.compare(P,O),I.value.collatorIsNumeric&&z===0&&P!==O)return P<O?-1:1}return z}e.compareFileExtensions=_;function g(u,w){u=u||"",w=w||"";const P=c(u),L=c(w),O=T.value.collator,y=C.value.collator;return m(y,P,L)||m(O,u,w)}e.compareFileExtensionsDefault=g;function d(u,w){u=u||"",w=w||"";const P=c(u),L=c(w),O=T.value.collator,y=C.value.collator;return m(y,P,L)||i(u,w)||m(O,u,w)}e.compareFileExtensionsUpper=d;function v(u,w){u=u||"",w=w||"";const P=c(u),L=c(w),O=T.value.collator,y=C.value.collator;return m(y,P,L)||l(u,w)||m(O,u,w)}e.compareFileExtensionsLower=v;function A(u,w){u=u||"",w=w||"";const P=c(u).toLowerCase(),L=c(w).toLowerCase();return P!==L?P<L?-1:1:u!==w?u<w?-1:1:0}e.compareFileExtensionsUnicode=A;const b=/^(.*?)(\.([^.]*))?$/;function a(u,w=!1){const P=u?b.exec(u):[];let L=[P&&P[1]||"",P&&P[3]||""];return w&&(!L[0]&&L[1]||L[0]&&L[0].charAt(0)===".")&&(L=[L[0]+"."+L[1],""]),L}function c(u){const w=u?b.exec(u):[];return w&&w[1]&&w[1].charAt(0)!=="."&&w[3]||""}function m(u,w,P){let L=u.compare(w,P);return L!==0?L:w.length!==P.length?w.length<P.length?-1:1:0}function s(u){const w=u.charAt(0);return w.toLocaleUpperCase()!==w}function E(u){const w=u.charAt(0);return w.toLocaleLowerCase()!==w}function l(u,w){return s(u)&&E(w)?-1:E(u)&&s(w)?1:0}function i(u,w){return E(u)&&s(w)?-1:s(u)&&E(w)?1:0}function r(u,w,P=!1){return P||(u=u&&u.toLowerCase(),w=w&&w.toLowerCase()),u===w?0:u<w?-1:1}function t(u,w,P=!1){const L=u.split(n.sep),O=w.split(n.sep),y=L.length-1,z=O.length-1;let M,B;for(let V=0;;V++){if(M=y===V,B=z===V,M&&B)return k(L[V],O[V],P);if(M)return-1;if(B)return 1;const Y=r(L[V],O[V],P);if(Y!==0)return Y}}e.comparePaths=t;function o(u,w,P){const L=u.toLowerCase(),O=w.toLowerCase(),y=f(u,w,P);if(y)return y;const z=L.endsWith(P),M=O.endsWith(P);if(z!==M)return z?-1:1;const B=k(L,O);return B!==0?B:L.localeCompare(O)}e.compareAnything=o;function f(u,w,P){const L=u.toLowerCase(),O=w.toLowerCase(),y=L.startsWith(P),z=O.startsWith(P);if(y!==z)return y?-1:1;if(y&&z){if(L.length<O.length)return-1;if(L.length>O.length)return 1}return 0}e.compareByPrefix=f}),define(ve[98],we([1,0,97,95,57,9,12,8]),function(ee,e,h,n,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const S=0,R=[S,[]];function F(Y,H,q,K){if(!Y||!H)return R;const G=Y.length,ie=H.length;if(G<ie)return R;const oe=Y.toLowerCase();return D(H,q,ie,Y,oe,G,K)}e.scoreFuzzy=F;function D(Y,H,q,K,G,ie,oe){const ue=[],Z=[];for(let ge=0;ge<q;ge++){const Te=ge*ie,Ne=Te-ie,be=ge>0,Ee=Y[ge],$=H[ge];for(let U=0;U<ie;U++){const N=U>0,W=Te+U,j=W-1,re=Ne+U-1,he=N?ue[j]:0,Ce=be&&N?ue[re]:0,Ae=be&&N?Z[re]:0;let We;!Ce&&be?We=0:We=p(Ee,$,K,G,U,Ae),We&&Ce+We>=he&&(oe||be||G.startsWith(H,U))?(Z[W]=Ae+1,ue[W]=Ce+We):(Z[W]=S,ue[W]=he)}}const Q=[];let se=q-1,de=ie-1;for(;se>=0&&de>=0;){const ge=se*ie+de;Z[ge]===S||(Q.push(de),se--),de--}return[ue[q*ie-1],Q.reverse()]}function p(Y,H,q,K,G,ie){let oe=0;if(!_(H,K[G]))return oe;if(oe+=1,ie>0&&(oe+=ie*5),Y===q[G]&&(oe+=1),G===0)oe+=8;else{const ue=g(q.charCodeAt(G-1));ue?oe+=ue:(0,n.isUpper)(q.charCodeAt(G))&&ie===0&&(oe+=2)}return oe}function _(Y,H){return Y===H?!0:Y==="/"||Y==="\\"?H==="/"||H==="\\":!1}function g(Y){switch(Y){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const d=[void 0,[]];function v(Y,H,q=0,K=0){const G=H;return G.values&&G.values.length>1?A(Y,G.values,q,K):b(Y,H,q,K)}e.scoreFuzzy2=v;function A(Y,H,q,K){let G=0;const ie=[];for(const oe of H){const[ue,Z]=b(Y,oe,q,K);if(typeof ue!="number")return d;G+=ue,ie.push(...Z)}return[G,f(ie)]}function b(Y,H,q,K){const G=(0,n.fuzzyScore)(H.original,H.originalLowercase,q,Y,Y.toLowerCase(),K,!0);return G?[G[0],(0,n.createMatches)(G)]:d}const a=Object.freeze({score:0}),c=1<<18,m=1<<17,s=1<<16;function E(Y,H,q,K){const G=K.values?K.values:[K];return(0,I.hash)({[K.normalized]:{values:G.map(oe=>({value:oe.normalized,expectContiguousMatch:oe.expectContiguousMatch})),label:Y,description:H,allowNonContiguousMatches:q}})}function l(Y,H,q,K,G){if(!Y||!H.normalized)return a;const ie=K.getItemLabel(Y);if(!ie)return a;const oe=K.getItemDescription(Y),ue=E(ie,oe,q,H),Z=G[ue];if(Z)return Z;const Q=i(ie,oe,K.getItemPath(Y),H,q);return G[ue]=Q,Q}e.scoreItemFuzzy=l;function i(Y,H,q,K,G){const ie=!q||!K.containsPathSeparator;return q&&(C.isLinux?K.pathNormalized===q:(0,k.equalsIgnoreCase)(K.pathNormalized,q))?{score:c,labelMatch:[{start:0,end:Y.length}],descriptionMatch:H?[{start:0,end:H.length}]:void 0}:K.values&&K.values.length>1?r(Y,H,q,K.values,ie,G):t(Y,H,q,K,ie,G)}function r(Y,H,q,K,G,ie){let oe=0;const ue=[],Z=[];for(const Q of K){const{score:se,labelMatch:de,descriptionMatch:ge}=t(Y,H,q,Q,G,ie);if(se===S)return a;oe+=se,de&&ue.push(...de),ge&&Z.push(...ge)}return{score:oe,labelMatch:f(ue),descriptionMatch:f(Z)}}function t(Y,H,q,K,G,ie){if(G||!H){const[oe,ue]=F(Y,K.normalized,K.normalizedLowercase,ie&&!K.expectContiguousMatch);if(oe){const Z=(0,n.matchesPrefix)(K.normalized,Y);let Q;return Z?(Q=m,Q+=Math.round(K.normalized.length/Y.length*100)):Q=s,{score:Q+oe,labelMatch:Z||o(ue)}}}if(H){let oe=H;q&&(oe=`${H}${T.sep}`);const ue=oe.length,Z=`${oe}${Y}`,[Q,se]=F(Z,K.normalized,K.normalizedLowercase,ie&&!K.expectContiguousMatch);if(Q){const de=o(se),ge=[],Te=[];return de.forEach(Ne=>{Ne.start<ue&&Ne.end>ue?(ge.push({start:0,end:Ne.end-ue}),Te.push({start:Ne.start,end:ue})):Ne.start>=ue?ge.push({start:Ne.start-ue,end:Ne.end-ue}):Te.push(Ne)}),{score:Q,labelMatch:ge,descriptionMatch:Te}}}return a}function o(Y){const H=[];if(!Y)return H;let q;for(const K of Y)q&&q.end===K?q.end+=1:(q={start:K,end:K+1},H.push(q));return H}function f(Y){const H=Y.sort((G,ie)=>G.start-ie.start),q=[];let K;for(const G of H)!K||!u(K,G)?(K=G,q.push(G)):(K.start=Math.min(K.start,G.start),K.end=Math.max(K.end,G.end));return q}function u(Y,H){return!(Y.end<H.start||H.end<Y.start)}function w(Y,H,q,K,G,ie){const oe=l(Y,q,K,G,ie),ue=l(H,q,K,G,ie),Z=oe.score,Q=ue.score;if((Z===c||Q===c)&&Z!==Q)return Z===c?-1:1;if(Z>s||Q>s){if(Z!==Q)return Z>Q?-1:1;if(Z<m&&Q<m){const Ee=L(oe.labelMatch,ue.labelMatch);if(Ee!==0)return Ee}const Ne=G.getItemLabel(Y)||"",be=G.getItemLabel(H)||"";if(Ne.length!==be.length)return Ne.length-be.length}if(Z!==Q)return Z>Q?-1:1;const se=Array.isArray(oe.labelMatch)&&oe.labelMatch.length>0,de=Array.isArray(ue.labelMatch)&&ue.labelMatch.length>0;if(se&&!de)return-1;if(de&&!se)return 1;const ge=P(Y,oe,G),Te=P(H,ue,G);return ge&&Te&&ge!==Te?Te>ge?-1:1:O(Y,H,q,G)}e.compareItemsByFuzzyScore=w;function P(Y,H,q){let K=-1,G=-1;if(H.descriptionMatch&&H.descriptionMatch.length?K=H.descriptionMatch[0].start:H.labelMatch&&H.labelMatch.length&&(K=H.labelMatch[0].start),H.labelMatch&&H.labelMatch.length){if(G=H.labelMatch[H.labelMatch.length-1].end,H.descriptionMatch&&H.descriptionMatch.length){const ie=q.getItemDescription(Y);ie&&(G+=ie.length)}}else H.descriptionMatch&&H.descriptionMatch.length&&(G=H.descriptionMatch[H.descriptionMatch.length-1].end);return G-K}function L(Y,H){if(!Y&&!H||(!Y||!Y.length)&&(!H||!H.length))return 0;if(!H||!H.length)return-1;if(!Y||!Y.length)return 1;const q=Y[0].start,G=Y[Y.length-1].end-q,ie=H[0].start,ue=H[H.length-1].end-ie;return G===ue?0:ue<G?1:-1}function O(Y,H,q,K){const G=K.getItemLabel(Y)||"",ie=K.getItemLabel(H)||"",oe=K.getItemDescription(Y),ue=K.getItemDescription(H),Z=G.length+(oe?oe.length:0),Q=ie.length+(ue?ue.length:0);if(Z!==Q)return Z-Q;const se=K.getItemPath(Y),de=K.getItemPath(H);return se&&de&&se.length!==de.length?se.length-de.length:G!==ie?(0,h.compareAnything)(G,ie,q.normalized):oe&&ue&&oe!==ue?(0,h.compareAnything)(oe,ue,q.normalized):se&&de&&se!==de?(0,h.compareAnything)(se,de,q.normalized):0}function y(Y){return Y.startsWith('"')&&Y.endsWith('"')}const z=" ";function M(Y){typeof Y!="string"&&(Y="");const H=Y.toLowerCase(),{pathNormalized:q,normalized:K,normalizedLowercase:G}=B(Y),ie=q.indexOf(T.sep)>=0,oe=y(Y);let ue;const Z=Y.split(z);if(Z.length>1)for(const Q of Z){const se=y(Q),{pathNormalized:de,normalized:ge,normalizedLowercase:Te}=B(Q);ge&&(ue||(ue=[]),ue.push({original:Q,originalLowercase:Q.toLowerCase(),pathNormalized:de,normalized:ge,normalizedLowercase:Te,expectContiguousMatch:se}))}return{original:Y,originalLowercase:H,pathNormalized:q,normalized:K,normalizedLowercase:G,values:ue,containsPathSeparator:ie,expectContiguousMatch:oe}}e.prepareQuery=M;function B(Y){let H;C.isWindows?H=Y.replace(/\//g,T.sep):H=Y.replace(/\\/g,T.sep);const q=(0,k.stripWildcards)(H).replace(/\s|"/g,"");return{pathNormalized:H,normalized:q,normalizedLowercase:q.toLowerCase()}}function V(Y){return Array.isArray(Y)?M(Y.map(H=>H.original).join(z)):M(Y.original)}e.pieceToQuery=V}),define(ve[32],we([1,0,15,29,24,9,12,8]),function(ee,e,h,n,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function S(){return Object.create(null)}e.getEmptyExpression=S,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",F="[^/\\\\]",D=/\//g;function p(q){switch(q){case 0:return"";case 1:return`${F}*?`;default:return`(?:${R}|${F}+${R}|${R}${F}+)*?`}}function _(q,K){if(!q)return[];const G=[];let ie=!1,oe=!1,ue="";for(const Z of q){switch(Z){case K:if(!ie&&!oe){G.push(ue),ue="";continue}break;case"{":ie=!0;break;case"}":ie=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}ue+=Z}return ue&&G.push(ue),G}e.splitGlobAware=_;function g(q){if(!q)return"";let K="";const G=_(q,e.GLOB_SPLIT);if(G.every(ie=>ie===e.GLOBSTAR))K=".*";else{let ie=!1;G.forEach((oe,ue)=>{if(oe===e.GLOBSTAR){ie||(K+=p(2),ie=!0);return}let Z=!1,Q="",se=!1,de="";for(const ge of oe){if(ge!=="}"&&Z){Q+=ge;continue}if(se&&(ge!=="]"||!de)){let Te;ge==="-"?Te=ge:(ge==="^"||ge==="!")&&!de?Te="^":ge===e.GLOB_SPLIT?Te="":Te=(0,k.escapeRegExpCharacters)(ge),de+=Te;continue}switch(ge){case"{":Z=!0;continue;case"[":se=!0;continue;case"}":{K+=`(?:${_(Q,",").map(be=>g(be)).join("|")})`,Z=!1,Q="";break}case"]":K+="["+de+"]",se=!1,de="";break;case"?":K+=F;continue;case"*":K+=p(1);continue;default:K+=(0,k.escapeRegExpCharacters)(ge)}}ue<G.length-1&&(G[ue+1]!==e.GLOBSTAR||ue+2<G.length)&&(K+=R),ie=!1})}return K}const d=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,A=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,m=new I.LRUCache(1e4),s=function(){return!1},E=function(){return null};function l(q,K){if(!q)return E;let G;typeof q!="string"?G=q.pattern:G=q,G=G.trim();const ie=`${G}_${!!K.trimForExclusions}`;let oe=m.get(ie);if(oe)return i(oe,q);let ue;if(d.test(G)){const Z=G.substr(4);oe=function(Q,se){return typeof Q=="string"&&Q.endsWith(Z)?G:null}}else(ue=v.exec(r(G,K)))?oe=t(ue[1],G):(K.trimForExclusions?b:A).test(G)?oe=o(G,K):(ue=a.exec(r(G,K)))?oe=f(ue[1].substr(1),G,!0):(ue=c.exec(r(G,K)))?oe=f(ue[1],G,!1):oe=u(G);return m.set(ie,oe),i(oe,q)}function i(q,K){return typeof K=="string"?q:function(G,ie){return(0,n.isEqualOrParent)(G,K.base,!C.isLinux)?q(G.substr(K.base.length+1),ie):null}}function r(q,K){return K.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function t(q,K){const G=`/${q}`,ie=`\\${q}`,oe=function(Z,Q){return typeof Z!="string"?null:Q?Q===q?K:null:Z===q||Z.endsWith(G)||Z.endsWith(ie)?K:null},ue=[q];return oe.basenames=ue,oe.patterns=[K],oe.allBasenames=ue,oe}function o(q,K){const G=H(q.slice(1,-1).split(",").map(Q=>l(Q,K)).filter(Q=>Q!==E),q),ie=G.length;if(!ie)return E;if(ie===1)return G[0];const oe=function(Q,se){for(let de=0,ge=G.length;de<ge;de++)if(G[de](Q,se))return q;return null},ue=G.find(Q=>!!Q.allBasenames);ue&&(oe.allBasenames=ue.allBasenames);const Z=G.reduce((Q,se)=>se.allPaths?Q.concat(se.allPaths):Q,[]);return Z.length&&(oe.allPaths=Z),oe}function f(q,K,G){const ie=T.sep===T.posix.sep,oe=ie?q:q.replace(D,T.sep),ue=T.sep+oe,Z=T.posix.sep+q,Q=G?function(se,de){return typeof se=="string"&&(se===oe||se.endsWith(ue)||!ie&&(se===q||se.endsWith(Z)))?K:null}:function(se,de){return typeof se=="string"&&(se===oe||!ie&&se===q)?K:null};return Q.allPaths=[(G?"*/":"./")+q],Q}function u(q){try{const K=new RegExp(`^${g(q)}$`);return function(G){return K.lastIndex=0,typeof G=="string"&&K.test(G)?q:null}}catch{return E}}function w(q,K,G){return!q||typeof K!="string"?!1:P(q)(K,void 0,G)}e.match=w;function P(q,K={}){if(!q)return s;if(typeof q=="string"||z(q)){const G=l(q,K);if(G===E)return s;const ie=function(oe,ue){return!!G(oe,ue)};return G.allBasenames&&(ie.allBasenames=G.allBasenames),G.allPaths&&(ie.allPaths=G.allPaths),ie}return V(q,K)}e.parse=P;function L(q){if(!q)return;let K;return G=>(K||(K=(q()||Promise.resolve([])).then(ie=>ie?y(ie):{})),K.then(ie=>!!ie[G]))}e.hasSiblingPromiseFn=L;function O(q){if(!q)return;let K;return G=>{if(!K){const ie=q();K=ie?y(ie):{}}return!!K[G]}}e.hasSiblingFn=O;function y(q){const K={};for(const G of q)K[G]=!0;return K}function z(q){const K=q;return K?typeof K.base=="string"&&typeof K.pattern=="string":!1}e.isRelativePattern=z;function M(q){return q.allBasenames||[]}e.getBasenameTerms=M;function B(q){return q.allPaths||[]}e.getPathTerms=B;function V(q,K){const G=H(Object.getOwnPropertyNames(q).map(Q=>Y(Q,q[Q],K)).filter(Q=>Q!==E)),ie=G.length;if(!ie)return E;if(!G.some(Q=>!!Q.requiresSiblings)){if(ie===1)return G[0];const Q=function(ge,Te){for(let Ne=0,be=G.length;Ne<be;Ne++){const Ee=G[Ne](ge,Te);if(Ee)return Ee}return null},se=G.find(ge=>!!ge.allBasenames);se&&(Q.allBasenames=se.allBasenames);const de=G.reduce((ge,Te)=>Te.allPaths?ge.concat(Te.allPaths):ge,[]);return de.length&&(Q.allPaths=de),Q}const oe=function(Q,se,de){let ge;for(let Te=0,Ne=G.length;Te<Ne;Te++){const be=G[Te];be.requiresSiblings&&de&&(se||(se=(0,T.basename)(Q)),ge||(ge=se.substr(0,se.length-(0,T.extname)(Q).length)));const Ee=be(Q,se,ge,de);if(Ee)return Ee}return null},ue=G.find(Q=>!!Q.allBasenames);ue&&(oe.allBasenames=ue.allBasenames);const Z=G.reduce((Q,se)=>se.allPaths?Q.concat(se.allPaths):Q,[]);return Z.length&&(oe.allPaths=Z),oe}function Y(q,K,G){if(K===!1)return E;const ie=l(q,G);if(ie===E)return E;if(typeof K=="boolean")return ie;if(K){const oe=K.when;if(typeof oe=="string"){const ue=(Z,Q,se,de)=>{if(!de||!ie(Z,Q))return null;const ge=oe.replace("$(basename)",se),Te=de(ge);return(0,h.isThenable)(Te)?Te.then(Ne=>Ne?q:null):Te?q:null};return ue.requiresSiblings=!0,ue}}return ie}function H(q,K){const G=q.filter(Q=>!!Q.basenames);if(G.length<2)return q;const ie=G.reduce((Q,se)=>{const de=se.basenames;return de?Q.concat(de):Q},[]);let oe;if(K){oe=[];for(let Q=0,se=ie.length;Q<se;Q++)oe.push(K)}else oe=G.reduce((Q,se)=>{const de=se.patterns;return de?Q.concat(de):Q},[]);const ue=function(Q,se){if(typeof Q!="string")return null;if(!se){let ge;for(ge=Q.length;ge>0;ge--){const Te=Q.charCodeAt(ge-1);if(Te===47||Te===92)break}se=Q.substr(ge)}const de=ie.indexOf(se);return de!==-1?oe[de]:null};ue.basenames=ie,ue.patterns=oe,ue.allBasenames=ie;const Z=q.filter(Q=>!Q.basenames);return Z.push(ue),Z}}),define(ve[99],we([1,0,17,144,23,2]),function(ee,e,h,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var C;(function(g){g[g.Paragraph=0]="Paragraph",g[g.Break=1]="Break"})(C=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class k{constructor(d="",v=!1){if(this.value=d,typeof this.value!="string")throw(0,h.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(d,v=0){return this.value+=D(this.supportThemeIcons?(0,n.escapeIcons)(d):d).replace(/([ \t]+)/g,(A,b)=>"&nbsp;".repeat(b.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,v){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}}e.MarkdownString=k;function S(g){return R(g)?!g.value:Array.isArray(g)?g.every(S):!0}e.isEmptyMarkdownString=S;function R(g){return g instanceof k?!0:g&&typeof g=="object"?typeof g.value=="string"&&(typeof g.isTrusted=="boolean"||g.isTrusted===void 0)&&(typeof g.supportThemeIcons=="boolean"||g.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function F(g,d){return g===d?!0:!g||!d?!1:g.value===d.value&&g.isTrusted===d.isTrusted&&g.supportThemeIcons===d.supportThemeIcons&&g.supportHtml===d.supportHtml&&(g.baseUri===d.baseUri||!!g.baseUri&&!!d.baseUri&&(0,I.isEqual)(T.URI.from(g.baseUri),T.URI.from(d.baseUri)))}e.markdownStringEqual=F;function D(g){return g.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=D;function p(g){return g&&g.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=p;function _(g){const d=[],v=g.split("|").map(b=>b.trim());g=v[0];const A=v[1];if(A){const b=/height=(\d+)/.exec(A),a=/width=(\d+)/.exec(A),c=b?b[1]:"",m=a?a[1]:"",s=isFinite(parseInt(m)),E=isFinite(parseInt(c));s&&d.push(`width="${m}"`),E&&d.push(`height="${c}"`)}return{href:g,dimensions:d}}e.parseHrefAndDimensions=_}),define(ve[100],we([1,0,29,10,9,12,23,8,2]),function(ee,e,h,n,I,T,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function R(i,r,t){if(typeof i=="string"&&(i=S.URI.file(i)),t){const f=t.getWorkspaceFolder(i);if(f){const u=t.getWorkspace().folders.length>1;let w;if((0,C.isEqual)(f.uri,i)?w="":w=(0,C.relativePath)(f.uri,i),u){const P=f.name?f.name:(0,C.basename)(f.uri);w=w?P+" \u2022 "+w:P}return w}}if(i.scheme!==n.Schemas.file&&i.scheme!==n.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,h.hasDriveLetter)(i.fsPath))return(0,I.normalize)(D(i.fsPath));let o=(0,I.normalize)(i.fsPath);return!T.isWindows&&r?.userHome&&(o=_(o,r.userHome.fsPath)),o}e.getPathLabel=R;function F(i){if(!i)return;typeof i=="string"&&(i=S.URI.file(i));const r=(0,C.basename)(i)||(i.scheme===n.Schemas.file?i.fsPath:i.path);return T.isWindows&&(0,h.isRootOrDriveLetter)(r)?D(r):r}e.getBaseLabel=F;function D(i,r){return(0,h.hasDriveLetter)(i,r)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=D;let p=Object.create(null);function _(i,r){if(T.isWindows||!i||!r)return i;let t=p.original===r?p.normalized:void 0;return t||(t=`${(0,k.rtrim)(r,I.posix.sep)}${I.posix.sep}`,p={original:r,normalized:t}),(T.isLinux?i.startsWith(t):(0,k.startsWithIgnoreCase)(i,t))&&(i=`~/${i.substr(t.length)}`),i}e.tildify=_;function g(i,r){return i.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=g;const d="\u2026",v="\\\\",A="~";function b(i,r=I.sep){const t=new Array(i.length);let o=!1;for(let f=0;f<i.length;f++){let u=i[f];if(u===""){t[f]=`.${r}`;continue}if(!u){t[f]=u;continue}o=!0;let w="";u.indexOf(v)===0?(w=u.substr(0,u.indexOf(v)+v.length),u=u.substr(u.indexOf(v)+v.length)):u.indexOf(r)===0?(w=u.substr(0,u.indexOf(r)+r.length),u=u.substr(u.indexOf(r)+r.length)):u.indexOf(A)===0&&(w=u.substr(0,u.indexOf(A)+A.length),u=u.substr(u.indexOf(A)+A.length));const P=u.split(r);for(let L=1;o&&L<=P.length;L++)for(let O=P.length-L;o&&O>=0;O--){o=!1;let y=P.slice(O,O+L).join(r);for(let z=0;!o&&z<i.length;z++)if(z!==f&&i[z]&&i[z].indexOf(y)>-1){const M=O+L===P.length,B=O>0&&i[z].indexOf(r)>-1?r+y:y,V=i[z].endsWith(B);o=!M||V}if(!o){let z="";(P[0].endsWith(":")||w!=="")&&(O===1&&(O=0,L++,y=P[0]+r+y),O>0&&(z=P[0]+r),z=w+z),O>0&&(z=z+d+r),z=z+y,O+L<P.length&&(z=z+r+d),t[f]=z}}o&&(t[f]=u)}return t}e.shorten=b;var a;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function c(i,r=Object.create(null)){const t=[];let o=!1,f="";for(const u of i)if(u==="$"||o&&u==="{")f&&t.push({value:f,type:a.TEXT}),f="",o=!0;else if(u==="}"&&o){const w=r[f];if(typeof w=="string")w.length&&t.push({value:w,type:a.VARIABLE});else if(w){const P=t[t.length-1];(!P||P.type!==a.SEPARATOR)&&t.push({value:w.label,type:a.SEPARATOR})}f="",o=!1}else f+=u;return f&&!o&&t.push({value:f,type:a.TEXT}),t.filter((u,w)=>{if(u.type===a.SEPARATOR){const P=t[w-1],L=t[w+1];return[P,L].every(O=>O&&(O.type===a.VARIABLE||O.type===a.TEXT)&&O.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=c;function m(i,r){return T.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):i.replace(/&&|&/g,t=>t==="&"?"&&":"&")}e.mnemonicMenuLabel=m;function s(i,r){return T.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,""):T.isWindows?i.replace(/&&|&/g,t=>t==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=s;function E(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=E;function l(i){const r=i.indexOf("/")!==-1?I.posix:I.win32,t=r.basename(i),o=r.dirname(i);return t.length?{name:t,parentPath:o}:{name:o,parentPath:""}}e.splitName=l}),define(ve[101],we([1,0,2]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(F){return F.toJSON()}class I{constructor(D){this._uriTransformer=D}transformIncoming(D){const p=this._uriTransformer.transformIncoming(D);return p===D?D:n(h.URI.from(p))}transformOutgoing(D){const p=this._uriTransformer.transformOutgoing(D);return p===D?D:n(h.URI.from(p))}transformOutgoingURI(D){const p=this._uriTransformer.transformOutgoing(D);return p===D?D:h.URI.from(p)}transformOutgoingScheme(D){return this._uriTransformer.transformOutgoingScheme(D)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(F){return F}transformOutgoing(F){return F}transformOutgoingURI(F){return F}transformOutgoingScheme(F){return F}};function T(F,D,p){if(!F||p>200)return null;if(typeof F=="object"){if(F instanceof h.URI)return D.transformOutgoing(F);for(let _ in F)if(Object.hasOwnProperty.call(F,_)){const g=T(F[_],D,p+1);g!==null&&(F[_]=g)}}return null}function C(F,D){const p=T(F,D,0);return p===null?F:p}e.transformOutgoingURIs=C;function k(F,D,p,_){if(!F||_>200)return null;if(typeof F=="object"){if(F.$mid===1)return p?h.URI.revive(D.transformIncoming(F)):D.transformIncoming(F);for(let g in F)if(Object.hasOwnProperty.call(F,g)){const d=k(F[g],D,p,_+1);d!==null&&(F[g]=d)}}return null}function S(F,D){const p=k(F,D,!1,0);return p===null?F:p}e.transformIncomingURIs=S;function R(F,D){const p=k(F,D,!0,0);return p===null?F:p}e.transformAndReviveIncomingURIs=R}),define(ve[33],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const h=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(S){return h.test(S)}e.isUUID=n;const I=new Uint8Array(16),T=[];for(let S=0;S<256;S++)T.push(S.toString(16).padStart(2,"0"));let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(S){for(let R=0;R<S.length;R++)S[R]=Math.floor(Math.random()*256);return S};function k(){C(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let S=0,R="";return R+=T[I[S++]],R+=T[I[S++]],R+=T[I[S++]],R+=T[I[S++]],R+="-",R+=T[I[S++]],R+=T[I[S++]],R+="-",R+=T[I[S++]],R+=T[I[S++]],R+="-",R+=T[I[S++]],R+=T[I[S++]],R+="-",R+=T[I[S++]],R+=T[I[S++]],R+=T[I[S++]],R+=T[I[S++]],R+=T[I[S++]],R+=T[I[S++]],R}e.generateUuid=k}),define(ve[145],we([1,0,102]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(T="utf8"){this.stringDecoder=new h.StringDecoder(T),this.remaining=null}write(T){const C=[],k=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(k.length<1)return C;let S=0,R,F=S;for(;F<k.length;)if(R=k.charCodeAt(F),R===13||R===10){if(C.push(k.substring(S,F)),F++,F<k.length){const D=R;R=k.charCodeAt(F),(D===13&&R===10||D===10&&R===13)&&F++}S=F}else F++;return this.remaining=S<k.length?k.substr(S):null,C}end(){return this.remaining}}e.LineDecoder=n}),define(ve[28],we([1,0,59,60,291,15,29,77,9,12,23,2]),function(ee,e,h,n,I,T,C,k,S,R,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function _(M,B=p.UNLINK){if((0,C.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return B===p.UNLINK?d(M):g(M)}async function g(M){try{const B=(0,C.randomPath)((0,n.tmpdir)());try{await h.promises.rename(M,B)}catch{return d(M)}d(B).catch(V=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function d(M){return(0,I.promisify)(h.rm)(M,{recursive:!0,force:!0,maxRetries:3})}function v(M){if((0,C.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");h.rmSync(M,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=v;async function A(M,B){return c(await(B?b(M):(0,I.promisify)(h.readdir)(M)))}async function b(M){try{return await(0,I.promisify)(h.readdir)(M,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const B=[],V=await A(M);for(const Y of V){let H=!1,q=!1,K=!1;try{const G=await e.Promises.lstat((0,S.join)(M,Y));H=G.isFile(),q=G.isDirectory(),K=G.isSymbolicLink()}catch(G){console.warn("[node.js fs] unexpected error from lstat after readdir: ",G)}B.push({name:Y,isFile:()=>H,isDirectory:()=>q,isSymbolicLink:()=>K})}return B}function a(M){return c(h.readdirSync(M))}e.readdirSync=a;function c(M){return M.map(B=>typeof B=="string"?R.isMacintosh?(0,k.normalizeNFC)(B):B:(B.name=R.isMacintosh?(0,k.normalizeNFC)(B.name):B.name,B))}async function m(M){const B=await A(M),V=[];for(const Y of B)await E.existsDirectory((0,S.join)(M,Y))&&V.push(Y);return V}function s(M,B=1e3){return new Promise(V=>{let Y=!1;const H=setInterval(()=>{Y||(Y=!0,h.access(M,q=>{Y=!1,q&&(clearInterval(H),V(void 0))}))},B)})}e.whenDeleted=s;var E;(function(M){async function B(H){let q;try{if(q=await e.Promises.lstat(H),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(K){if(K.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(R.isWindows&&K.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(G){if(G.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw G}throw K}}M.stat=B;async function V(H){try{const{stat:q,symbolicLink:K}=await M.stat(H);return q.isFile()&&K?.dangling!==!0}catch{}return!1}M.existsFile=V;async function Y(H){try{const{stat:q,symbolicLink:K}=await M.stat(H);return q.isDirectory()&&K?.dangling!==!0}catch{}return!1}M.existsDirectory=Y})(E=e.SymlinkSupport||(e.SymlinkSupport={}));const l=new T.ResourceQueue;function i(M,B,V){return l.queueFor(D.URI.file(M),F.extUriBiasedIgnorePathCase).queue(()=>{const Y=f(V);return new Promise((H,q)=>t(M,B,Y,K=>K?q(K):H()))})}let r=!0;function t(M,B,V,Y){if(!r)return h.writeFile(M,B,{mode:V.mode,flag:V.flag},Y);h.open(M,V.flag,V.mode,(H,q)=>{if(H)return Y(H);h.writeFile(q,B,K=>{if(K)return h.close(q,()=>Y(K));h.fdatasync(q,G=>(G&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",G),r=!1),h.close(q,ie=>Y(ie))))})})}function o(M,B,V){const Y=f(V);if(!r)return h.writeFileSync(M,B,{mode:Y.mode,flag:Y.flag});const H=h.openSync(M,Y.flag,Y.mode);try{h.writeFileSync(H,B);try{h.fdatasyncSync(H)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),r=!1}}finally{h.closeSync(H)}}e.writeFileSync=o;function f(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function u(M,B){if(M!==B)try{await e.Promises.rename(M,B)}catch(V){if(M.toLowerCase()!==B.toLowerCase()&&V.code==="EXDEV"||M.endsWith("."))await w(M,B,{preserveSymlinks:!1}),await _(M,p.MOVE);else throw V}}async function w(M,B,V){return L(M,B,{root:{source:M,target:B},options:V,handledSourcePaths:new Set})}const P=511;async function L(M,B,V){if(V.handledSourcePaths.has(M))return;V.handledSourcePaths.add(M);const{stat:Y,symbolicLink:H}=await E.stat(M);if(H){if(V.options.preserveSymlinks)try{return await z(M,B,V)}catch(q){console.warn("[node.js fs] copy of symlink failed: ",q)}if(H.dangling)return}return Y.isDirectory()?O(M,B,Y.mode&P,V):y(M,B,Y.mode&P)}async function O(M,B,V,Y){await e.Promises.mkdir(B,{recursive:!0,mode:V});const H=await A(M);for(const q of H)await L((0,S.join)(M,q),(0,S.join)(B,q),Y)}async function y(M,B,V){await e.Promises.copyFile(M,B),await e.Promises.chmod(B,V)}async function z(M,B,V){let Y=await e.Promises.readlink(M);(0,C.isEqualOrParent)(Y,V.root.source,!R.isLinux)&&(Y=(0,S.join)(V.root.target,Y.substr(V.root.source.length+1))),await e.Promises.symlink(Y,B)}e.Promises=new class{get access(){return(0,I.promisify)(h.access)}get stat(){return(0,I.promisify)(h.stat)}get lstat(){return(0,I.promisify)(h.lstat)}get utimes(){return(0,I.promisify)(h.utimes)}get read(){return(M,B,V,Y,H)=>new Promise((q,K)=>{h.read(M,B,V,Y,H,(G,ie,oe)=>G?K(G):q({bytesRead:ie,buffer:oe}))})}get readFile(){return(0,I.promisify)(h.readFile)}get write(){return(M,B,V,Y,H)=>new Promise((q,K)=>{h.write(M,B,V,Y,H,(G,ie,oe)=>G?K(G):q({bytesWritten:ie,buffer:oe}))})}get appendFile(){return(0,I.promisify)(h.appendFile)}get fdatasync(){return(0,I.promisify)(h.fdatasync)}get truncate(){return(0,I.promisify)(h.truncate)}get rename(){return(0,I.promisify)(h.rename)}get copyFile(){return(0,I.promisify)(h.copyFile)}get open(){return(0,I.promisify)(h.open)}get close(){return(0,I.promisify)(h.close)}get symlink(){return(0,I.promisify)(h.symlink)}get readlink(){return(0,I.promisify)(h.readlink)}get chmod(){return(0,I.promisify)(h.chmod)}get mkdir(){return(0,I.promisify)(h.mkdir)}get unlink(){return(0,I.promisify)(h.unlink)}get rmdir(){return(0,I.promisify)(h.rmdir)}get realpath(){return(0,I.promisify)(h.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return A}get readDirsInDir(){return m}get writeFile(){return i}get rm(){return _}get move(){return u}get copy(){return w}}}),define(ve[103],we([1,0,59,9,12,8,28]),function(ee,e,h,n,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function k(p){if(I.isLinux)return p;const _=(0,n.dirname)(p);if(p===_)return p;const g=((0,n.basename)(p)||p).toLowerCase();try{const v=(0,C.readdirSync)(_).filter(A=>A.toLowerCase()===g);if(v.length===1){const A=k(_);if(A)return(0,n.join)(A,v[0])}else if(v.length>1){const A=v.indexOf(g);if(A>=0){const b=k(_);if(b)return(0,n.join)(b,v[A])}}}catch{}return null}e.realcaseSync=k;async function S(p){if(I.isLinux)return p;const _=(0,n.dirname)(p);if(p===_)return p;const g=((0,n.basename)(p)||p).toLowerCase();try{const v=(await C.Promises.readdir(_)).filter(A=>A.toLowerCase()===g);if(v.length===1){const A=await S(_);if(A)return(0,n.join)(A,v[0])}else if(v.length>1){const A=v.indexOf(g);if(A>=0){const b=await S(_);if(b)return(0,n.join)(b,v[A])}}}catch{}return null}e.realcase=S;async function R(p){try{return await C.Promises.realpath(p)}catch{const g=D(p);return await C.Promises.access(g,h.constants.R_OK),g}}e.realpath=R;function F(p){try{return h.realpathSync(p)}catch{const g=D(p);return h.accessSync(g,h.constants.R_OK),g}}e.realpathSync=F;function D(p){return(0,T.rtrim)((0,n.normalize)(p),n.sep)}});var Be=this&&this.__decorate||function(ee,e,h,n){var I=arguments.length,T=I<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,h):n,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(ee,e,h,n);else for(var k=ee.length-1;k>=0;k--)(C=ee[k])&&(T=(I<3?C(T):I>3?C(e,h,T):C(e,h))||T);return I>3&&T&&Object.defineProperty(e,h,T),T};define(ve[104],we([1,0,18,15,22,21,56,17,3,6,58,8,13]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var _;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(_=e.RequestType||(e.RequestType={}));function g(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(d=e.ResponseType||(e.ResponseType={}));function v(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var A;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(A||(A={}));class b{constructor(K){this.buffer=K,this.pos=0}read(K){const G=this.buffer.slice(this.pos,this.pos+K);return this.pos+=G.byteLength,G}}class a{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(K){this.buffers.push(K)}}var c;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object"})(c||(c={}));function m(q){const K=I.VSBuffer.alloc(4);return K.writeUInt32BE(q,0),K}function s(q){return q.read(4).readUInt32BE(0)}function E(q){const K=I.VSBuffer.alloc(1);return K.writeUInt8(q,0),K}const l={Undefined:E(c.Undefined),String:E(c.String),Buffer:E(c.Buffer),VSBuffer:E(c.VSBuffer),Array:E(c.Array),Object:E(c.Object)},i=typeof Buffer!="undefined";function r(q,K){if(typeof K=="undefined")q.write(l.Undefined);else if(typeof K=="string"){const G=I.VSBuffer.fromString(K);q.write(l.String),q.write(m(G.byteLength)),q.write(G)}else if(i&&Buffer.isBuffer(K)){const G=I.VSBuffer.wrap(K);q.write(l.Buffer),q.write(m(G.byteLength)),q.write(G)}else if(K instanceof I.VSBuffer)q.write(l.VSBuffer),q.write(m(K.byteLength)),q.write(K);else if(Array.isArray(K)){q.write(l.Array),q.write(m(K.length));for(const G of K)r(q,G)}else{const G=I.VSBuffer.fromString(JSON.stringify(K));q.write(l.Object),q.write(m(G.byteLength)),q.write(G)}}function t(q){switch(q.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return q.read(s(q)).toString();case c.Buffer:return q.read(s(q)).buffer;case c.VSBuffer:return q.read(s(q));case c.Array:{const G=s(q),ie=[];for(let oe=0;oe<G;oe++)ie.push(t(q));return ie}case c.Object:return JSON.parse(q.read(s(q)).toString())}}class o{constructor(K,G,ie=null,oe=1e3){this.protocol=K,this.ctx=G,this.logger=ie,this.timeoutDelay=oe,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ue=>this.onRawMessage(ue)),this.sendResponse({type:200})}registerChannel(K,G){this.channels.set(K,G),setTimeout(()=>this.flushPendingRequests(K),0)}sendResponse(K){switch(K.type){case 200:{const G=this.send([K.type]);this.logger?.logOutgoing(G,0,1,v(K.type));return}case 201:case 202:case 204:case 203:{const G=this.send([K.type,K.id],K.data);this.logger?.logOutgoing(G,K.id,1,v(K.type),K.data);return}}}send(K,G=void 0){const ie=new a;return r(ie,K),r(ie,G),this.sendBuffer(ie.buffer)}sendBuffer(K){try{return this.protocol.send(K),K.byteLength}catch{return 0}}onRawMessage(K){const G=new b(K),ie=t(G),oe=t(G),ue=ie[0];switch(ue){case 100:return this.logger?.logIncoming(K.byteLength,ie[1],1,`${g(ue)}: ${ie[2]}.${ie[3]}`,oe),this.onPromise({type:ue,id:ie[1],channelName:ie[2],name:ie[3],arg:oe});case 102:return this.logger?.logIncoming(K.byteLength,ie[1],1,`${g(ue)}: ${ie[2]}.${ie[3]}`,oe),this.onEventListen({type:ue,id:ie[1],channelName:ie[2],name:ie[3],arg:oe});case 101:return this.logger?.logIncoming(K.byteLength,ie[1],1,`${g(ue)}`),this.disposeActiveRequest({type:ue,id:ie[1]});case 103:return this.logger?.logIncoming(K.byteLength,ie[1],1,`${g(ue)}`),this.disposeActiveRequest({type:ue,id:ie[1]})}}onPromise(K){const G=this.channels.get(K.channelName);if(!G){this.collectPendingRequest(K);return}const ie=new T.CancellationTokenSource;let oe;try{oe=G.call(this.ctx,K.name,K.arg,ie.token)}catch(Q){oe=Promise.reject(Q)}const ue=K.id;oe.then(Q=>{this.sendResponse({id:ue,data:Q,type:201}),this.activeRequests.delete(K.id)},Q=>{Q instanceof Error?this.sendResponse({id:ue,data:{message:Q.message,name:Q.name,stack:Q.stack?Q.stack.split?Q.stack.split(`
`):Q.stack:void 0},type:202}):this.sendResponse({id:ue,data:Q,type:203}),this.activeRequests.delete(K.id)});const Z=(0,R.toDisposable)(()=>ie.cancel());this.activeRequests.set(K.id,Z)}onEventListen(K){const G=this.channels.get(K.channelName);if(!G){this.collectPendingRequest(K);return}const ie=K.id,ue=G.listen(this.ctx,K.name,K.arg)(Z=>this.sendResponse({id:ie,data:Z,type:204}));this.activeRequests.set(K.id,ue)}disposeActiveRequest(K){const G=this.activeRequests.get(K.id);G&&(G.dispose(),this.activeRequests.delete(K.id))}collectPendingRequest(K){let G=this.pendingRequests.get(K.channelName);G||(G=[],this.pendingRequests.set(K.channelName,G));const ie=setTimeout(()=>{console.error(`Unknown channel: ${K.channelName}`),K.type===100&&this.sendResponse({id:K.id,data:{name:"Unknown channel",message:`Channel name '${K.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);G.push({request:K,timeoutTimer:ie})}flushPendingRequests(K){const G=this.pendingRequests.get(K);if(G){for(const ie of G)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.onPromise(ie.request);break;case 102:this.onEventListen(ie.request);break}this.pendingRequests.delete(K)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,R.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=o;var f;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));class u{constructor(K,G=null){this.protocol=K,this.isDisposed=!1,this.state=A.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ie=>this.onBuffer(ie)),this.logger=G}getChannel(K){const G=this;return{call(ie,oe,ue){return G.isDisposed?Promise.reject(k.canceled()):G.requestPromise(K,ie,oe,ue)},listen(ie,oe){return G.isDisposed?S.Event.None:G.requestEvent(K,ie,oe)}}}requestPromise(K,G,ie,oe=T.CancellationToken.None){const ue=this.lastRequestId++,Q={id:ue,type:100,channelName:K,name:G,arg:ie};if(oe.isCancellationRequested)return Promise.reject(k.canceled());let se;return new Promise((ge,Te)=>{if(oe.isCancellationRequested)return Te(k.canceled());const Ne=()=>{const U=N=>{switch(N.type){case 201:this.handlers.delete(ue),ge(N.data);break;case 202:{this.handlers.delete(ue);const W=new Error(N.data.message);W.stack=N.data.stack,W.name=N.data.name,Te(W);break}case 203:this.handlers.delete(ue),Te(N.data);break}};this.handlers.set(ue,U),this.sendRequest(Q)};let be=null;this.state===A.Idle?Ne():(be=(0,n.createCancelablePromise)(U=>this.whenInitialized()),be.then(()=>{be=null,Ne()}));const Ee=()=>{be?(be.cancel(),be=null):this.sendRequest({id:ue,type:101}),Te(k.canceled())},$=oe.onCancellationRequested(Ee);se=(0,R.combinedDisposable)((0,R.toDisposable)(Ee),$),this.activeRequests.add(se)}).finally(()=>{this.activeRequests.delete(se)})}requestEvent(K,G,ie){const oe=this.lastRequestId++,Z={id:oe,type:102,channelName:K,name:G,arg:ie};let Q=null;const se=new S.Emitter({onFirstListenerAdd:()=>{Q=(0,n.createCancelablePromise)(ge=>this.whenInitialized()),Q.then(()=>{Q=null,this.activeRequests.add(se),this.sendRequest(Z)})},onLastListenerRemove:()=>{Q?(Q.cancel(),Q=null):(this.activeRequests.delete(se),this.sendRequest({id:oe,type:103}))}}),de=ge=>se.fire(ge.data);return this.handlers.set(oe,de),se.event}sendRequest(K){switch(K.type){case 100:case 102:{const G=this.send([K.type,K.id,K.channelName,K.name],K.arg);this.logger&&this.logger.logOutgoing(G,K.id,0,`${g(K.type)}: ${K.channelName}.${K.name}`,K.arg);return}case 101:case 103:{const G=this.send([K.type,K.id]);this.logger&&this.logger.logOutgoing(G,K.id,0,g(K.type));return}}}send(K,G=void 0){const ie=new a;return r(ie,K),r(ie,G),this.sendBuffer(ie.buffer)}sendBuffer(K){try{return this.protocol.send(K),K.byteLength}catch{return 0}}onBuffer(K){const G=new b(K),ie=t(G),oe=t(G),ue=ie[0];switch(ue){case 200:return this.logger&&this.logger.logIncoming(K.byteLength,0,0,v(ue)),this.onResponse({type:ie[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(K.byteLength,ie[1],0,v(ue),oe),this.onResponse({type:ie[0],id:ie[1],data:oe})}}onResponse(K){if(K.type===200){this.state=A.Idle,this._onDidInitialize.fire();return}const G=this.handlers.get(K.id);G&&G(K)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===A.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,R.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Be([C.memoize],u.prototype,"onDidInitializePromise",null),e.ChannelClient=u;class w{constructor(K){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,K(({protocol:G,onDidClientDisconnect:ie})=>{S.Event.once(G.onMessage)(ue=>{const Z=new b(ue),Q=t(Z),se=new o(G,Q),de=new u(G);this.channels.forEach((Te,Ne)=>se.registerChannel(Ne,Te));const ge={channelServer:se,channelClient:de,ctx:Q};this._connections.add(ge),this._onDidAddConnection.fire(ge),ie(()=>{se.dispose(),de.dispose(),this._connections.delete(ge),this._onDidRemoveConnection.fire(ge)})})})}get connections(){const K=[];return this._connections.forEach(G=>K.push(G)),K}getChannel(K,G){const ie=this;return{call(oe,ue,Z){let Q;if((0,p.isFunction)(G)){let de=(0,h.getRandomElement)(ie.connections.filter(G));Q=de?Promise.resolve(de):S.Event.toPromise(S.Event.filter(ie.onDidAddConnection,G))}else Q=G.routeCall(ie,oe,ue);const se=Q.then(de=>de.channelClient.getChannel(K));return L(se).call(oe,ue,Z)},listen(oe,ue){if((0,p.isFunction)(G))return ie.getMulticastEvent(K,G,oe,ue);const Z=G.routeEvent(ie,oe,ue).then(Q=>Q.channelClient.getChannel(K));return L(Z).listen(oe,ue)}}}getMulticastEvent(K,G,ie,oe){const ue=this;let Z=new R.DisposableStore;const Q=new S.Emitter({onFirstListenerAdd:()=>{Z=new R.DisposableStore;const se=new S.EventMultiplexer,de=new Map,ge=Ne=>{const Ee=Ne.channelClient.getChannel(K).listen(ie,oe),$=se.add(Ee);de.set(Ne,$)},Te=Ne=>{const be=de.get(Ne);!be||(be.dispose(),de.delete(Ne))};ue.connections.filter(G).forEach(ge),S.Event.filter(ue.onDidAddConnection,G)(ge,void 0,Z),ue.onDidRemoveConnection(Te,void 0,Z),se.event(Q.fire,Q,Z),Z.add(se)},onLastListenerRemove:()=>{Z.dispose()}});return Q.event}registerChannel(K,G){this.channels.set(K,G),this._connections.forEach(ie=>{ie.channelServer.registerChannel(K,G)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=w;class P{constructor(K,G,ie=null){const oe=new a;r(oe,G),K.send(oe.buffer),this.channelClient=new u(K,ie),this.channelServer=new o(K,G,ie)}getChannel(K){return this.channelClient.getChannel(K)}registerChannel(K,G){this.channelServer.registerChannel(K,G)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=P;function L(q){return{call(K,G,ie){return q.then(oe=>oe.call(K,G,ie))},listen(K,G){const ie=new S.Relay;return q.then(oe=>ie.input=oe.listen(K,G)),ie.event}}}e.getDelayedChannel=L;function O(q){let K=!1;return{call(G,ie,oe){return K?q.call(G,ie,oe):(0,n.timeout)(0).then(()=>K=!0).then(()=>q.call(G,ie,oe))},listen(G,ie){if(K)return q.listen(G,ie);const oe=new S.Relay;return(0,n.timeout)(0).then(()=>K=!0).then(()=>oe.input=q.listen(G,ie)),oe.event}}}e.getNextTickChannel=O;class y{constructor(K){this.fn=K}routeCall(K){return this.route(K)}routeEvent(K){return this.route(K)}async route(K){for(const G of K.connections)if(await Promise.resolve(this.fn(G.ctx)))return Promise.resolve(G);return await S.Event.toPromise(K.onDidAddConnection),await this.route(K)}}e.StaticRouter=y;var z;(function(q){function K(ue,Z){const Q=ue,se=Z&&Z.disableMarshalling,de=new Map;for(const ge in Q)ie(ge)&&de.set(ge,S.Event.buffer(Q[ge],!0));return new class{listen(ge,Te,Ne){const be=de.get(Te);if(be)return be;if(oe(Te)){const Ee=Q[Te];if(typeof Ee=="function")return Ee.call(Q,Ne)}throw new Error(`Event not found: ${Te}`)}call(ge,Te,Ne){const be=Q[Te];if(typeof be=="function"){if(!se&&Array.isArray(Ne))for(let Ee=0;Ee<Ne.length;Ee++)Ne[Ee]=(0,F.revive)(Ne[Ee]);return be.apply(Q,Ne)}throw new Error(`Method not found: ${Te}`)}}}q.fromService=K;function G(ue,Z){const Q=Z&&Z.disableMarshalling;return new Proxy({},{get(se,de){if(typeof de=="string")return Z?.properties?.has(de)?Z.properties.get(de):oe(de)?function(ge){return ue.listen(de,ge)}:ie(de)?ue.listen(de):async function(...ge){let Te;Z&&!(0,p.isUndefinedOrNull)(Z.context)?Te=[Z.context,...ge]:Te=ge;const Ne=await ue.call(de,Te);return Q?Ne:(0,F.revive)(Ne)};throw new Error(`Property not found: ${String(de)}`)}})}q.toService=G;function ie(ue){return ue[0]==="o"&&ue[1]==="n"&&D.isUpperAsciiLetter(ue.charCodeAt(2))}function oe(ue){return/^onDynamic/.test(ue)&&D.isUpperAsciiLetter(ue.charCodeAt(9))}})(z=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function B(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){let K=q.toString();if(K!=="[object Object]")return K}return q}function V(q){return Array.isArray(q)?q.map(B):B(q)}function Y(q,K,G,ie,oe,ue,Z){Z=V(Z);const Q=M[oe],se=Q[ie%Q.length];let de=[`%c[${q}]%c[${String(K).padStart(7," ")}]%c[len: ${String(G).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${ue}`,"color: darkgreen","color: grey","color: grey",`color: ${se}`];/\($/.test(ue)?(de=de.concat(Z),de.push(")")):de.push(Z),console.log.apply(console,de)}e.logWithColors=Y;class H{constructor(K,G){this._outgoingPrefix=K,this._incomingPrefix=G,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(K,G,ie,oe,ue){this._totalOutgoing+=K,Y(this._outgoingPrefix,this._totalOutgoing,K,G,ie,oe,ue)}logIncoming(K,G,ie,oe,ue){this._totalIncoming+=K,Y(this._incomingPrefix,this._totalIncoming,K,G,ie,oe,ue)}}e.IPCLogger=H}),define(ve[105],we([1,0,22,3,6,104]),function(ee,e,h,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var C;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(C=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var k;(function(i){i.enableDiagnostics=!1,i.records=[];const r=new WeakMap;let t=0;function o(u,w){if(!r.has(u)){const P=String(++t);r.set(u,P)}return r.get(u)}function f(u,w,P,L){if(!i.enableDiagnostics)return;const O=o(u,w);if(L instanceof h.VSBuffer||L instanceof Uint8Array||L instanceof ArrayBuffer||ArrayBuffer.isView(L)){const y=h.VSBuffer.alloc(L.byteLength);y.set(L),i.records.push({timestamp:Date.now(),id:O,label:w,type:P,buff:y})}else i.records.push({timestamp:Date.now(),id:O,label:w,type:P,data:L})}i.traceSocketEvent=f})(k=e.SocketDiagnostics||(e.SocketDiagnostics={}));var S;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let R=null;function F(){return R||(R=h.VSBuffer.alloc(0)),R}class D{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,t){if(r===0)return F();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const w=this._chunks[0];return t&&(this._chunks.shift(),this._totalLength-=r),w}if(this._chunks[0].byteLength>r){const w=this._chunks[0].slice(0,r);return t&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),w}let o=h.VSBuffer.alloc(r),f=0,u=0;for(;r>0;){const w=this._chunks[u];if(w.byteLength>r){const P=w.slice(0,r);o.set(P,f),f+=r,t&&(this._chunks[u]=w.slice(r),this._totalLength-=r),r-=r}else o.set(w,f),f+=w.byteLength,t?(this._chunks.shift(),this._totalLength-=w.byteLength):u++,r-=w.byteLength}return o}}e.ChunkStream=D;var p;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(p||(p={}));function _(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var g;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(g=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(r,t,o,f){this.type=r,this.id=t,this.ack=o,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends I.Disposable{constructor(r){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new D,this._register(this._socket.onData(t=>this.acceptChunk(t))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const t=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=t.readUInt32BE(9),this._state.messageType=t.readUInt8(0),this._state.id=t.readUInt32BE(1),this._state.ack=t.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:_(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const o=this._state.messageType,f=this._state.id,u=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",t),this._onMessage.fire(new d(o,f,u,t)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class A{constructor(r){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const t=h.VSBuffer.alloc(13);t.writeUInt8(r.type,0),t.writeUInt32BE(r.id,1),t.writeUInt32BE(r.ack,5),t.writeUInt32BE(r.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:_(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",r.data),this._writeSoon(t,r.data)}_bufferAdd(r,t){const o=this._totalLength===0;return this._data.push(r,t),this._totalLength+=r.byteLength+t.byteLength,o}_bufferTake(){const r=h.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,t){this._bufferAdd(r,t)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const r=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this._socket.write(r)}}class b extends I.Disposable{constructor(r){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new A(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(t=>{t.type===1&&this._onMessage.fire(t.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new d(1,0,0,r))}}e.Protocol=b;class a extends T.IPCClient{constructor(r,t,o=null){super(r,t,o);this.protocol=r}static fromSocket(r,t){return new a(new b(r),t)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=a;class c{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=c;class m{constructor(r){this.data=r,this.next=null}}class s{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],t=0,o=this._first;for(;o;)r[t++]=o.data,o=o.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const t=new m(r);if(!this._first){this._first=t,this._last=t;return}this._last.next=t,this._last=t}}class E{constructor(){this.lastRuns=[];const r=Date.now();for(let t=0;t<E._HISTORY_LENGTH;t++)this.lastRuns[t]=r-1e3*t;setInterval(()=>{for(let t=E._HISTORY_LENGTH;t>=1;t--)this.lastRuns[t]=this.lastRuns[t-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return E._INSTANCE||(E._INSTANCE=new E),E._INSTANCE}load(){const r=Date.now(),t=(1+E._HISTORY_LENGTH)*1e3;let o=0;for(let f=0;f<E._HISTORY_LENGTH;f++)r-this.lastRuns[f]<=t&&o++;return 1-o/E._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}E._HISTORY_LENGTH=10,E._INSTANCE=null;class l{constructor(r,t=null,o=E.getInstance()){this._onControlMessage=new c,this.onControlMessage=this._onControlMessage.event,this._onMessage=new c,this.onMessage=this._onMessage.event,this._onDidDispose=new c,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new c,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new c,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=o,this._isReconnecting=!1,this._outgoingUnackMsg=new s,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=r,this._socketWriter=new A(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),t&&this._socketReader.acceptChunk(t)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,I.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new d(5,0,0,F());this._socketWriter.write(r),this._socketWriter.flush()}sendPause(){const r=new d(7,0,0,F());this._socketWriter.write(r)}sendResume(){const r=new d(8,0,0,F());this._socketWriter.write(r)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,t){this._isReconnecting=!0,this._socketDisposables=(0,I.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=r,this._socketWriter=new A(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(o=>this._onSocketClose.fire(o))),this._socketReader.acceptChunk(t)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const r=new d(3,0,this._incomingAckId,F());this._socketWriter.write(r);const t=this._outgoingUnackMsg.toArray();for(let o=0,f=t.length;o<f;o++)this._socketWriter.write(t[o]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const t=this._outgoingUnackMsg.peek();if(t&&t.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const t=Date.now();t-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=t,this._socketWriter.write(new d(6,0,0,F())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data);break}case 2:{this._onControlMessage.fire(r.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const t=this._outgoingUnackMsg.toArray();for(let o=0,f=t.length;o<f;o++)this._socketWriter.write(t[o]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const t=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new d(1,t,this._incomingAckId,r);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(r){const t=new d(2,0,0,r);this._socketWriter.write(t)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),t=Date.now()-r.writtenTime,o=Date.now()-this._socketReader.lastReadTime,f=Date.now()-this._lastSocketTimeoutTime;if(t>=2e4&&o>=2e4&&f>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const u=Math.max(2e4-t,2e4-o,2e4-f,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},u)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new d(3,0,this._incomingAckId,F());this._socketWriter.write(r)}}e.PersistentProtocol=l}),define(ve[106],we([1,0,96]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class n{constructor(k){const S=(0,h.toUint8)(k);this._defaultValue=S,this._asciiMap=n._createAsciiMap(S),this._map=new Map}static _createAsciiMap(k){const S=new Uint8Array(256);for(let R=0;R<256;R++)S[R]=k;return S}set(k,S){const R=(0,h.toUint8)(S);k>=0&&k<256?this._asciiMap[k]=R:this._map.set(k,R)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=n;var I;(function(C){C[C.False=0]="False",C[C.True=1]="True"})(I||(I={}));class T{constructor(){this._actual=new n(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=T}),define(ve[48],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class h{constructor(I,T){this.lineNumber=I,this.column=T}with(I=this.lineNumber,T=this.column){return I===this.lineNumber&&T===this.column?this:new h(I,T)}delta(I=0,T=0){return this.with(this.lineNumber+I,this.column+T)}equals(I){return h.equals(this,I)}static equals(I,T){return!I&&!T?!0:!!I&&!!T&&I.lineNumber===T.lineNumber&&I.column===T.column}isBefore(I){return h.isBefore(this,I)}static isBefore(I,T){return I.lineNumber<T.lineNumber?!0:T.lineNumber<I.lineNumber?!1:I.column<T.column}isBeforeOrEqual(I){return h.isBeforeOrEqual(this,I)}static isBeforeOrEqual(I,T){return I.lineNumber<T.lineNumber?!0:T.lineNumber<I.lineNumber?!1:I.column<=T.column}static compare(I,T){const C=I.lineNumber|0,k=T.lineNumber|0;if(C===k){const S=I.column|0,R=T.column|0;return S-R}return C-k}clone(){return new h(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(I){return new h(I.lineNumber,I.column)}static isIPosition(I){return I&&typeof I.lineNumber=="number"&&typeof I.column=="number"}}e.Position=h}),define(ve[35],we([1,0,48]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class n{constructor(T,C,k,S){T>k||T===k&&C>S?(this.startLineNumber=k,this.startColumn=S,this.endLineNumber=T,this.endColumn=C):(this.startLineNumber=T,this.startColumn=C,this.endLineNumber=k,this.endColumn=S)}isEmpty(){return n.isEmpty(this)}static isEmpty(T){return T.startLineNumber===T.endLineNumber&&T.startColumn===T.endColumn}containsPosition(T){return n.containsPosition(this,T)}static containsPosition(T,C){return!(C.lineNumber<T.startLineNumber||C.lineNumber>T.endLineNumber||C.lineNumber===T.startLineNumber&&C.column<T.startColumn||C.lineNumber===T.endLineNumber&&C.column>T.endColumn)}static strictContainsPosition(T,C){return!(C.lineNumber<T.startLineNumber||C.lineNumber>T.endLineNumber||C.lineNumber===T.startLineNumber&&C.column<=T.startColumn||C.lineNumber===T.endLineNumber&&C.column>=T.endColumn)}containsRange(T){return n.containsRange(this,T)}static containsRange(T,C){return!(C.startLineNumber<T.startLineNumber||C.endLineNumber<T.startLineNumber||C.startLineNumber>T.endLineNumber||C.endLineNumber>T.endLineNumber||C.startLineNumber===T.startLineNumber&&C.startColumn<T.startColumn||C.endLineNumber===T.endLineNumber&&C.endColumn>T.endColumn)}strictContainsRange(T){return n.strictContainsRange(this,T)}static strictContainsRange(T,C){return!(C.startLineNumber<T.startLineNumber||C.endLineNumber<T.startLineNumber||C.startLineNumber>T.endLineNumber||C.endLineNumber>T.endLineNumber||C.startLineNumber===T.startLineNumber&&C.startColumn<=T.startColumn||C.endLineNumber===T.endLineNumber&&C.endColumn>=T.endColumn)}plusRange(T){return n.plusRange(this,T)}static plusRange(T,C){let k,S,R,F;return C.startLineNumber<T.startLineNumber?(k=C.startLineNumber,S=C.startColumn):C.startLineNumber===T.startLineNumber?(k=C.startLineNumber,S=Math.min(C.startColumn,T.startColumn)):(k=T.startLineNumber,S=T.startColumn),C.endLineNumber>T.endLineNumber?(R=C.endLineNumber,F=C.endColumn):C.endLineNumber===T.endLineNumber?(R=C.endLineNumber,F=Math.max(C.endColumn,T.endColumn)):(R=T.endLineNumber,F=T.endColumn),new n(k,S,R,F)}intersectRanges(T){return n.intersectRanges(this,T)}static intersectRanges(T,C){let k=T.startLineNumber,S=T.startColumn,R=T.endLineNumber,F=T.endColumn,D=C.startLineNumber,p=C.startColumn,_=C.endLineNumber,g=C.endColumn;return k<D?(k=D,S=p):k===D&&(S=Math.max(S,p)),R>_?(R=_,F=g):R===_&&(F=Math.min(F,g)),k>R||k===R&&S>F?null:new n(k,S,R,F)}equalsRange(T){return n.equalsRange(this,T)}static equalsRange(T,C){return!!T&&!!C&&T.startLineNumber===C.startLineNumber&&T.startColumn===C.startColumn&&T.endLineNumber===C.endLineNumber&&T.endColumn===C.endColumn}getEndPosition(){return n.getEndPosition(this)}static getEndPosition(T){return new h.Position(T.endLineNumber,T.endColumn)}getStartPosition(){return n.getStartPosition(this)}static getStartPosition(T){return new h.Position(T.startLineNumber,T.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(T,C){return new n(this.startLineNumber,this.startColumn,T,C)}setStartPosition(T,C){return new n(T,C,this.endLineNumber,this.endColumn)}collapseToStart(){return n.collapseToStart(this)}static collapseToStart(T){return new n(T.startLineNumber,T.startColumn,T.startLineNumber,T.startColumn)}static fromPositions(T,C=T){return new n(T.lineNumber,T.column,C.lineNumber,C.column)}static lift(T){return T?new n(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):null}static isIRange(T){return T&&typeof T.startLineNumber=="number"&&typeof T.startColumn=="number"&&typeof T.endLineNumber=="number"&&typeof T.endColumn=="number"}static areIntersectingOrTouching(T,C){return!(T.endLineNumber<C.startLineNumber||T.endLineNumber===C.startLineNumber&&T.endColumn<C.startColumn||C.endLineNumber<T.startLineNumber||C.endLineNumber===T.startLineNumber&&C.endColumn<T.startColumn)}static areIntersecting(T,C){return!(T.endLineNumber<C.startLineNumber||T.endLineNumber===C.startLineNumber&&T.endColumn<=C.startColumn||C.endLineNumber<T.startLineNumber||C.endLineNumber===T.startLineNumber&&C.endColumn<=T.startColumn)}static compareRangesUsingStarts(T,C){if(T&&C){const R=T.startLineNumber|0,F=C.startLineNumber|0;if(R===F){const D=T.startColumn|0,p=C.startColumn|0;if(D===p){const _=T.endLineNumber|0,g=C.endLineNumber|0;if(_===g){const d=T.endColumn|0,v=C.endColumn|0;return d-v}return _-g}return D-p}return R-F}return(T?1:0)-(C?1:0)}static compareRangesUsingEnds(T,C){return T.endLineNumber===C.endLineNumber?T.endColumn===C.endColumn?T.startLineNumber===C.startLineNumber?T.startColumn-C.startColumn:T.startLineNumber-C.startLineNumber:T.endColumn-C.endColumn:T.endLineNumber-C.endLineNumber}static spansMultipleLines(T){return T.endLineNumber>T.startLineNumber}toJSON(){return this}}e.Range=n}),define(ve[146],we([1,0,48,35]),function(ee,e,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var I;(function(C){C[C.LTR=0]="LTR",C[C.RTL=1]="RTL"})(I=e.SelectionDirection||(e.SelectionDirection={}));class T extends n.Range{constructor(k,S,R,F){super(k,S,R,F);this.selectionStartLineNumber=k,this.selectionStartColumn=S,this.positionLineNumber=R,this.positionColumn=F}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return T.selectionsEqual(this,k)}static selectionsEqual(k,S){return k.selectionStartLineNumber===S.selectionStartLineNumber&&k.selectionStartColumn===S.selectionStartColumn&&k.positionLineNumber===S.positionLineNumber&&k.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,S){return this.getDirection()===0?new T(this.startLineNumber,this.startColumn,k,S):new T(k,S,this.startLineNumber,this.startColumn)}getPosition(){return new h.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new h.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(k,S){return this.getDirection()===0?new T(k,S,this.endLineNumber,this.endColumn):new T(this.endLineNumber,this.endColumn,k,S)}static fromPositions(k,S=k){return new T(k.lineNumber,k.column,S.lineNumber,S.column)}static fromRange(k,S){return S===0?new T(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):new T(k.endLineNumber,k.endColumn,k.startLineNumber,k.startColumn)}static liftSelection(k){return new T(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,S){if(k&&!S||!k&&S)return!1;if(!k&&!S)return!0;if(k.length!==S.length)return!1;for(let R=0,F=k.length;R<F;R++)if(!this.selectionsEqual(k[R],S[R]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,S,R,F,D){return D===0?new T(k,S,R,F):new T(R,F,k,S)}}e.Selection=T}),define(ve[147],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}}}),define(ve[148],we([1,0,106]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var n;(function(C){C[C.Regular=0]="Regular",C[C.Whitespace=1]="Whitespace",C[C.WordSeparator=2]="WordSeparator"})(n=e.WordCharacterClass||(e.WordCharacterClass={}));class I extends h.CharacterClassifier{constructor(k){super(0);for(let S=0,R=k.length;S<R;S++)this.set(k.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=I;function T(C){const k={};return S=>(k.hasOwnProperty(S)||(k[S]=C(S)),k[S])}e.getMapForWordSeparators=T(C=>new I(C))}),define(ve[107],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function h(k=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const R of e.USUAL_WORD_SEPARATORS)k.indexOf(R)>=0||(S+="\\"+R);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=h();function n(k){let S=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)S=k;else{let R="g";k.ignoreCase&&(R+="i"),k.multiline&&(R+="m"),k.unicode&&(R+="u"),S=new RegExp(k.source,R)}return S.lastIndex=0,S}e.ensureValidWordDefinition=n;const I={maxLen:1e3,windowSize:15,timeBudget:150};function T(k,S,R,F,D=I){if(R.length>D.maxLen){let v=k-D.maxLen/2;return v<0?v=0:F+=v,R=R.substring(v,k+D.maxLen/2),T(k,S,R,F,D)}const p=Date.now(),_=k-1-F;let g=-1,d=null;for(let v=1;!(Date.now()-p>=D.timeBudget);v++){const A=_-D.windowSize*v;S.lastIndex=Math.max(0,A);const b=C(S,R,_,g);if(!b&&d||(d=b,A<=0))break;g=A}if(d){const v={word:d[0],startColumn:F+1+d.index,endColumn:F+1+d.index+d[0].length};return S.lastIndex=0,v}return null}e.getWordAtText=T;function C(k,S,R,F){let D;for(;D=k.exec(S);){const p=D.index||0;if(p<=R&&k.lastIndex>=R)return D;if(F>0&&p>F)return null}return null}}),define(ve[108],we([1,0,32,9]),function(ee,e,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(T,C,k,S,R){if(Array.isArray(T)){let F=0;for(const D of T){const p=I(D,C,k,S,R);if(p===10)return p;p>F&&(F=p)}return F}else{if(typeof T=="string")return S?T==="*"?5:T===k?10:0:0;if(T){const{language:F,pattern:D,scheme:p,hasAccessToAllModels:_,notebookType:g}=T;if(!S&&!_)return 0;let d=0;if(p)if(p===C.scheme)d=10;else if(p==="*")d=5;else return 0;if(F)if(F===k)d=10;else if(F==="*")d=Math.max(d,5);else return 0;if(g)if(g===R)d=10;else if(g==="*")d=Math.max(d,5);else return 0;if(D){let v;if(typeof D=="string"?v=D:v={...D,base:(0,n.normalize)(D.base)},v===C.fsPath||(0,h.match)(v,C.fsPath))d=10;else return 0}return d}else return 0}}e.score=I}),define(ve[149],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var h;(function(C){C[C.None=0]="None",C[C.Indent=1]="Indent",C[C.IndentOutdent=2]="IndentOutdent",C[C.Outdent=3]="Outdent"})(h=e.IndentAction||(e.IndentAction={}));class n{constructor(k){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=k.open,this.close=k.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(k.notIn))for(let S=0,R=k.notIn.length;S<R;S++)switch(k.notIn[S]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(k){switch(k){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(k,S){if(k.getTokenCount()===0)return!0;const R=k.findTokenIndexAtOffset(S-2),F=k.getStandardTokenType(R);return this.isOK(F)}_findNeutralCharacterInRange(k,S){for(let R=k;R<=S;R++){const F=String.fromCharCode(R);if(!this.open.includes(F)&&!this.close.includes(F))return F}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=n;class I{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of k)T(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),T(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),T(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),T(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&T(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=I;function T(C,k,S){C.has(k)?C.get(k).push(S):C.set(k,[S])}}),define(ve[150],we([1,0,106]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var n;(function(_){_[_.Invalid=0]="Invalid",_[_.Start=1]="Start",_[_.H=2]="H",_[_.HT=3]="HT",_[_.HTT=4]="HTT",_[_.HTTP=5]="HTTP",_[_.F=6]="F",_[_.FI=7]="FI",_[_.FIL=8]="FIL",_[_.BeforeColon=9]="BeforeColon",_[_.AfterColon=10]="AfterColon",_[_.AlmostThere=11]="AlmostThere",_[_.End=12]="End",_[_.Accept=13]="Accept",_[_.LastKnownState=14]="LastKnownState"})(n=e.State||(e.State={}));class I{constructor(g,d,v){const A=new Uint8Array(g*d);for(let b=0,a=g*d;b<a;b++)A[b]=v;this._data=A,this.rows=g,this.cols=d}get(g,d){return this._data[g*this.cols+d]}set(g,d,v){this._data[g*this.cols+d]=v}}e.Uint8Matrix=I;class T{constructor(g){let d=0,v=0;for(let b=0,a=g.length;b<a;b++){const[c,m,s]=g[b];m>d&&(d=m),c>v&&(v=c),s>v&&(v=s)}d++,v++;const A=new I(v,d,0);for(let b=0,a=g.length;b<a;b++){const[c,m,s]=g[b];A.set(c,m,s)}this._states=A,this._maxCharCode=d}nextState(g,d){return d<0||d>=this._maxCharCode?0:this._states.get(g,d)}}e.StateMachine=T;let C=null;function k(){return C===null&&(C=new T([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),C}var S;(function(_){_[_.None=0]="None",_[_.ForceTermination=1]="ForceTermination",_[_.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let R=null;function F(){if(R===null){R=new h.CharacterClassifier(0);const _=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<_.length;d++)R.set(_.charCodeAt(d),1);const g=".,;";for(let d=0;d<g.length;d++)R.set(g.charCodeAt(d),2)}return R}class D{static _createLink(g,d,v,A,b){let a=b-1;do{const c=d.charCodeAt(a);if(g.get(c)!==2)break;a--}while(a>A);if(A>0){const c=d.charCodeAt(A-1),m=d.charCodeAt(a);(c===40&&m===41||c===91&&m===93||c===123&&m===125)&&a--}return{range:{startLineNumber:v,startColumn:A+1,endLineNumber:v,endColumn:a+2},url:d.substring(A,a+1)}}static computeLinks(g,d=k()){const v=F(),A=[];for(let b=1,a=g.getLineCount();b<=a;b++){const c=g.getLineContent(b),m=c.length;let s=0,E=0,l=0,i=1,r=!1,t=!1,o=!1,f=!1;for(;s<m;){let u=!1;const w=c.charCodeAt(s);if(i===13){let P;switch(w){case 40:r=!0,P=0;break;case 41:P=r?0:1;break;case 91:o=!0,t=!0,P=0;break;case 93:o=!1,P=t?0:1;break;case 123:f=!0,P=0;break;case 125:P=f?0:1;break;case 39:P=l===34||l===96?0:1;break;case 34:P=l===39||l===96?0:1;break;case 96:P=l===39||l===34?0:1;break;case 42:P=l===42?1:0;break;case 124:P=l===124?1:0;break;case 32:P=o?0:1;break;default:P=v.get(w)}P===1&&(A.push(D._createLink(v,c,b,E,s)),u=!0)}else if(i===12){let P;w===91?(t=!0,P=0):P=v.get(w),P===1?u=!0:i=13}else i=d.nextState(i,w),i===0&&(u=!0);u&&(i=1,r=!1,t=!1,f=!1,E=s+1,l=w),s++}i===13&&A.push(D._createLink(v,c,b,E,m))}return A}}e.LinkComputer=D;function p(_){return!_||typeof _.getLineCount!="function"||typeof _.getLineContent!="function"?[]:D.computeLinks(_)}e.computeLinks=p}),define(ve[109],we([1,0,25]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var n;(function(b){b[b.Left=1]="Left",b[b.Center=2]="Center",b[b.Right=4]="Right",b[b.Full=7]="Full"})(n=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(b){b[b.Inline=1]="Inline",b[b.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var T;(function(b){b[b.Both=0]="Both",b[b.Right=1]="Right",b[b.Left=2]="Left",b[b.None=3]="None"})(T=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var C;(function(b){b[b.TextDefined=0]="TextDefined",b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var k;(function(b){b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(k=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(b){b[b.LF=0]="LF",b[b.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class R{constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),this.indentSize=a.tabSize|0,this.insertSpaces=Boolean(a.insertSpaces),this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=Boolean(a.trimAutoWhitespace),this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,h.equals)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.TextModelResolvedOptions=R;class F{constructor(a,c){this._findMatchBrand=void 0,this.range=a,this.matches=c}}e.FindMatch=F;var D;(function(b){b[b.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",b[b.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",b[b.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",b[b.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(D=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var p;(function(b){b[b.Left=0]="Left",b[b.Right=1]="Right",b[b.None=2]="None"})(p=e.PositionAffinity||(e.PositionAffinity={}));var _;(function(b){b[b.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(_=e.ModelConstants||(e.ModelConstants={}));class g{constructor(a,c,m,s,E,l){this.identifier=a,this.range=c,this.text=m,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=E,this._isTracked=l}}e.ValidAnnotatedEditOperation=g;class d{constructor(a,c,m){this.regex=a,this.wordSeparators=c,this.simpleSearch=m}}e.SearchData=d;class v{constructor(a,c,m){this.reverseEdits=a,this.changes=c,this.trimAutoWhitespaceLineNumbers=m}}e.ApplyEditsResult=v;function A(b){return!b.isTooLargeForSyncing()&&!b.isForSimpleWidget}e.shouldSynchronizeModel=A}),define(ve[110],we([1,0,18,96]),function(ee,e,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class I{constructor(S){this.values=S,this.prefixSum=new Uint32Array(S.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(S,R){S=(0,n.toUint32)(S);const F=this.values,D=this.prefixSum,p=R.length;return p===0?!1:(this.values=new Uint32Array(F.length+p),this.values.set(F.subarray(0,S),0),this.values.set(F.subarray(S),S+p),this.values.set(R,S),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(D.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(S,R){return S=(0,n.toUint32)(S),R=(0,n.toUint32)(R),this.values[S]===R?!1:(this.values[S]=R,S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),!0)}removeValues(S,R){S=(0,n.toUint32)(S),R=(0,n.toUint32)(R);const F=this.values,D=this.prefixSum;if(S>=F.length)return!1;const p=F.length-S;return R>=p&&(R=p),R===0?!1:(this.values=new Uint32Array(F.length-R),this.values.set(F.subarray(0,S),0),this.values.set(F.subarray(S+R),S),this.prefixSum=new Uint32Array(this.values.length),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(D.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(S){return S<0?0:(S=(0,n.toUint32)(S),this._getPrefixSum(S))}_getPrefixSum(S){if(S<=this.prefixSumValidIndex[0])return this.prefixSum[S];let R=this.prefixSumValidIndex[0]+1;R===0&&(this.prefixSum[0]=this.values[0],R++),S>=this.values.length&&(S=this.values.length-1);for(let F=R;F<=S;F++)this.prefixSum[F]=this.prefixSum[F-1]+this.values[F];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],S),this.prefixSum[S]}getIndexOf(S){S=Math.floor(S),this.getTotalSum();let R=0,F=this.values.length-1,D=0,p=0,_=0;for(;R<=F;)if(D=R+(F-R)/2|0,p=this.prefixSum[D],_=p-this.values[D],S<_)F=D-1;else if(S>=p)R=D+1;else break;return new C(D,S-_)}}e.PrefixSumComputer=I;class T{constructor(S){this._values=S,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(S){return this._ensureValid(),S===0?0:this._prefixSum[S-1]}getIndexOf(S){this._ensureValid();const R=this._indexBySum[S],F=R>0?this._prefixSum[R-1]:0;return new C(R,S-F)}removeValues(S,R){this._values.splice(S,R),this._invalidate(S)}insertValues(S,R){this._values=(0,h.arrayInsert)(this._values,S,R),this._invalidate(S)}_invalidate(S){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,S-1)}_ensureValid(){if(!this._isValid){for(let S=this._validEndIndex+1,R=this._values.length;S<R;S++){const F=this._values[S],D=S>0?this._prefixSum[S-1]:0;this._prefixSum[S]=D+F;for(let p=0;p<F;p++)this._indexBySum[D+p]=S}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(S,R){this._values[S]!==R&&(this._values[S]=R,this._invalidate(S))}}e.ConstantTimePrefixSumComputer=T;class C{constructor(S,R){this.index=S,this.remainder=R,this._prefixSumIndexOfResultBrand=void 0,this.index=S,this.remainder=R}}e.PrefixSumIndexOfResult=C}),define(ve[151],we([1,0,8,48,110]),function(ee,e,h,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class T{constructor(k,S,R,F){this._uri=k,this._lines=S,this._eol=R,this._versionId=F,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const S=k.changes;for(const R of S)this._acceptDeleteRange(R.range),this._acceptInsertText(new n.Position(R.range.startLineNumber,R.range.startColumn),R.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,S=this._lines.length,R=new Uint32Array(S);for(let F=0;F<S;F++)R[F]=this._lines[F].length+k;this._lineStarts=new I.PrefixSumComputer(R)}}_setLineText(k,S){this._lines[k]=S,this._lineStarts&&this._lineStarts.setValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,S){if(S.length===0)return;const R=(0,h.splitLines)(S);if(R.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+R[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}R[R.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+R[0]);const F=new Uint32Array(R.length-1);for(let D=1;D<R.length;D++)this._lines.splice(k.lineNumber+D-1,0,R[D]),F[D-1]=R[D].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,F)}}e.MirrorTextModel=T}),define(ve[152],we([1,0,8,148,48,35,109]),function(ee,e,h,n,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class S{constructor(b,a,c,m){this.searchString=b,this.isRegex=a,this.matchCase=c,this.wordSeparators=m}parseSearchRequest(){if(this.searchString==="")return null;let b;this.isRegex?b=R(this.searchString):b=this.searchString.indexOf(`
`)>=0;let a=null;try{a=h.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:b,global:!0,unicode:!0})}catch{return null}if(!a)return null;let c=!this.isRegex&&!b;return c&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(c=this.matchCase),new C.SearchData(a,this.wordSeparators?(0,n.getMapForWordSeparators)(this.wordSeparators):null,c?this.searchString:null)}}e.SearchParams=S;function R(A){if(!A||A.length===0)return!1;for(let b=0,a=A.length;b<a;b++)if(A.charCodeAt(b)===92){if(b++,b>=a)break;const m=A.charCodeAt(b);if(m===110||m===114||m===87)return!0}return!1}e.isMultilineRegexSource=R;function F(A,b,a){if(!a)return new C.FindMatch(A,null);const c=[];for(let m=0,s=b.length;m<s;m++)c[m]=b[m];return new C.FindMatch(A,c)}e.createFindMatch=F;class D{constructor(b){const a=[];let c=0;for(let m=0,s=b.length;m<s;m++)b.charCodeAt(m)===10&&(a[c++]=m);this._lineFeedsOffsets=a}findLineFeedCountBeforeOffset(b){const a=this._lineFeedsOffsets;let c=0,m=a.length-1;if(m===-1||b<=a[0])return 0;for(;c<m;){const s=c+((m-c)/2>>0);a[s]>=b?m=s-1:a[s+1]>=b?(c=s,m=s):c=s+1}return c+1}}class p{static findMatches(b,a,c,m,s){const E=a.parseSearchRequest();return E?E.regex.multiline?this._doFindMatchesMultiline(b,c,new v(E.wordSeparators,E.regex),m,s):this._doFindMatchesLineByLine(b,c,E,m,s):[]}static _getMultilineMatchRange(b,a,c,m,s,E){let l,i=0;m?(i=m.findLineFeedCountBeforeOffset(s),l=a+s+i):l=a+s;let r;if(m){const u=m.findLineFeedCountBeforeOffset(s+E.length)-i;r=l+E.length+u}else r=l+E.length;const t=b.getPositionAt(l),o=b.getPositionAt(r);return new T.Range(t.lineNumber,t.column,o.lineNumber,o.column)}static _doFindMatchesMultiline(b,a,c,m,s){const E=b.getOffsetAt(a.getStartPosition()),l=b.getValueInRange(a,1),i=b.getEOL()===`\r
`?new D(l):null,r=[];let t=0,o;for(c.reset(0);o=c.next(l);)if(r[t++]=F(this._getMultilineMatchRange(b,E,l,i,o.index,o[0]),o,m),t>=s)return r;return r}static _doFindMatchesLineByLine(b,a,c,m,s){const E=[];let l=0;if(a.startLineNumber===a.endLineNumber){const r=b.getLineContent(a.startLineNumber).substring(a.startColumn-1,a.endColumn-1);return l=this._findMatchesInLine(c,r,a.startLineNumber,a.startColumn-1,l,E,m,s),E}const i=b.getLineContent(a.startLineNumber).substring(a.startColumn-1);l=this._findMatchesInLine(c,i,a.startLineNumber,a.startColumn-1,l,E,m,s);for(let r=a.startLineNumber+1;r<a.endLineNumber&&l<s;r++)l=this._findMatchesInLine(c,b.getLineContent(r),r,0,l,E,m,s);if(l<s){const r=b.getLineContent(a.endLineNumber).substring(0,a.endColumn-1);l=this._findMatchesInLine(c,r,a.endLineNumber,0,l,E,m,s)}return E}static _findMatchesInLine(b,a,c,m,s,E,l,i){const r=b.wordSeparators;if(!l&&b.simpleSearch){const f=b.simpleSearch,u=f.length,w=a.length;let P=-u;for(;(P=a.indexOf(f,P+u))!==-1;)if((!r||d(r,a,w,P,u))&&(E[s++]=new C.FindMatch(new T.Range(c,P+1+m,c,P+1+u+m),null),s>=i))return s;return s}const t=new v(b.wordSeparators,b.regex);let o;t.reset(0);do if(o=t.next(a),o&&(E[s++]=F(new T.Range(c,o.index+1+m,c,o.index+1+o[0].length+m),o,l),s>=i))return s;while(o);return s}static findNextMatch(b,a,c,m){const s=a.parseSearchRequest();if(!s)return null;const E=new v(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindNextMatchMultiline(b,c,E,m):this._doFindNextMatchLineByLine(b,c,E,m)}static _doFindNextMatchMultiline(b,a,c,m){const s=new I.Position(a.lineNumber,1),E=b.getOffsetAt(s),l=b.getLineCount(),i=b.getValueInRange(new T.Range(s.lineNumber,s.column,l,b.getLineMaxColumn(l)),1),r=b.getEOL()===`\r
`?new D(i):null;c.reset(a.column-1);let t=c.next(i);return t?F(this._getMultilineMatchRange(b,E,i,r,t.index,t[0]),t,m):a.lineNumber!==1||a.column!==1?this._doFindNextMatchMultiline(b,new I.Position(1,1),c,m):null}static _doFindNextMatchLineByLine(b,a,c,m){const s=b.getLineCount(),E=a.lineNumber,l=b.getLineContent(E),i=this._findFirstMatchInLine(c,l,E,a.column,m);if(i)return i;for(let r=1;r<=s;r++){const t=(E+r-1)%s,o=b.getLineContent(t+1),f=this._findFirstMatchInLine(c,o,t+1,1,m);if(f)return f}return null}static _findFirstMatchInLine(b,a,c,m,s){b.reset(m-1);const E=b.next(a);return E?F(new T.Range(c,E.index+1,c,E.index+1+E[0].length),E,s):null}static findPreviousMatch(b,a,c,m){const s=a.parseSearchRequest();if(!s)return null;const E=new v(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindPreviousMatchMultiline(b,c,E,m):this._doFindPreviousMatchLineByLine(b,c,E,m)}static _doFindPreviousMatchMultiline(b,a,c,m){const s=this._doFindMatchesMultiline(b,new T.Range(1,1,a.lineNumber,a.column),c,m,10*k);if(s.length>0)return s[s.length-1];const E=b.getLineCount();return a.lineNumber!==E||a.column!==b.getLineMaxColumn(E)?this._doFindPreviousMatchMultiline(b,new I.Position(E,b.getLineMaxColumn(E)),c,m):null}static _doFindPreviousMatchLineByLine(b,a,c,m){const s=b.getLineCount(),E=a.lineNumber,l=b.getLineContent(E).substring(0,a.column-1),i=this._findLastMatchInLine(c,l,E,m);if(i)return i;for(let r=1;r<=s;r++){const t=(s+E-r-1)%s,o=b.getLineContent(t+1),f=this._findLastMatchInLine(c,o,t+1,m);if(f)return f}return null}static _findLastMatchInLine(b,a,c,m){let s=null,E;for(b.reset(0);E=b.next(a);)s=F(new T.Range(c,E.index+1,c,E.index+1+E[0].length),E,m);return s}}e.TextModelSearch=p;function _(A,b,a,c,m){if(c===0)return!0;const s=b.charCodeAt(c-1);if(A.get(s)!==0||s===13||s===10)return!0;if(m>0){const E=b.charCodeAt(c);if(A.get(E)!==0)return!0}return!1}function g(A,b,a,c,m){if(c+m===a)return!0;const s=b.charCodeAt(c+m);if(A.get(s)!==0||s===13||s===10)return!0;if(m>0){const E=b.charCodeAt(c+m-1);if(A.get(E)!==0)return!0}return!1}function d(A,b,a,c,m){return _(A,b,a,c,m)&&g(A,b,a,c,m)}e.isValidMatch=d;class v{constructor(b,a){this._wordSeparators=b,this._searchRegex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(b){this._searchRegex.lastIndex=b,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(b){const a=b.length;let c;do{if(this._prevMatchStartIndex+this._prevMatchLength===a||(c=this._searchRegex.exec(b),!c))return null;const m=c.index,s=c[0].length;if(m===this._prevMatchStartIndex&&s===this._prevMatchLength){if(s===0){h.getNextCodePoint(b,a,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=m,this._prevMatchLength=s,!this._wordSeparators||d(this._wordSeparators,b,a,m,s))return c}while(c);return null}}e.Searcher=v}),define(ve[111],we([1,0,22,12]),function(ee,e,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var I;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(I||(I={}));function T(D){for(let p=0,_=D.length;p<_;p+=4){const g=D[p+0],d=D[p+1],v=D[p+2],A=D[p+3];D[p+0]=A,D[p+1]=v,D[p+2]=d,D[p+3]=g}}function C(D){const p=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return n.isLittleEndian()||T(p),h.VSBuffer.wrap(p)}function k(D){const p=D.buffer;if(n.isLittleEndian()||T(p),p.byteOffset%4==0)return new Uint32Array(p.buffer,p.byteOffset,p.length/4);{const _=new Uint8Array(p.byteLength);return _.set(p),new Uint32Array(_.buffer,_.byteOffset,_.length/4)}}function S(D){const p=new Uint32Array(R(D));let _=0;if(p[_++]=D.id,D.type==="full")p[_++]=1,p[_++]=D.data.length,p.set(D.data,_),_+=D.data.length;else{p[_++]=2,p[_++]=D.deltas.length;for(const g of D.deltas)p[_++]=g.start,p[_++]=g.deleteCount,g.data?(p[_++]=g.data.length,p.set(g.data,_),_+=g.data.length):p[_++]=0}return C(p)}e.encodeSemanticTokensDto=S;function R(D){let p=0;if(p+=1+1,D.type==="full")p+=1+D.data.length;else{p+=1,p+=(1+1+1)*D.deltas.length;for(const _ of D.deltas)_.data&&(p+=_.data.length)}return p}function F(D){const p=k(D);let _=0;const g=p[_++];if(p[_++]===1){const b=p[_++],a=p.subarray(_,_+b);return _+=b,{id:g,type:"full",data:a}}const v=p[_++],A=[];for(let b=0;b<v;b++){const a=p[_++],c=p[_++],m=p[_++];let s;m>0&&(s=p.subarray(_,_+m),_+=m),A[b]={start:a,deleteCount:c,data:s}}return{id:g,type:"delta",deltas:A}}e.decodeSemanticTokensDto=F}),define(ve[153],we([1,0,3,6]),function(ee,e,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class I{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new h.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(k){this._onDidChange.fire({changedLanguages:k,changedColorMap:!1})}register(k,S){return this._map.set(k,S),this.fire([k]),(0,n.toDisposable)(()=>{this._map.get(k)===S&&(this._map.delete(k),this.fire([k]))})}registerFactory(k,S){this._factories.get(k)?.dispose();const R=new T(this,k,S);return this._factories.set(k,R),(0,n.toDisposable)(()=>{const F=this._factories.get(k);!F||F!==R||(this._factories.delete(k),F.dispose())})}async getOrCreate(k){const S=this.get(k);if(S)return S;const R=this._factories.get(k);return!R||R.isResolved?null:(await R.resolve(),this.get(k))}get(k){return this._map.get(k)||null}isResolved(k){if(this.get(k))return!0;const R=this._factories.get(k);return!!(!R||R.isResolved)}setColorMap(k){this._colorMap=k,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=I;class T extends n.Disposable{constructor(k,S,R){super();this._registry=k,this._languageId=S,this._factory=R,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const k=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,k&&!this._isDisposed&&this._register(this._registry.register(this._languageId,k))}}}),define(ve[78],we([1,0,2,35,153,72]),function(ee,e,h,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var C;(function(O){O[O.Null=0]="Null",O[O.PlainText=1]="PlainText"})(C=e.LanguageId||(e.LanguageId={}));var k;(function(O){O[O.NotSet=-1]="NotSet",O[O.None=0]="None",O[O.Italic=1]="Italic",O[O.Bold=2]="Bold",O[O.Underline=4]="Underline",O[O.Strikethrough=8]="Strikethrough"})(k=e.FontStyle||(e.FontStyle={}));var S;(function(O){O[O.None=0]="None",O[O.DefaultForeground=1]="DefaultForeground",O[O.DefaultBackground=2]="DefaultBackground"})(S=e.ColorId||(e.ColorId={}));var R;(function(O){O[O.Other=0]="Other",O[O.Comment=1]="Comment",O[O.String=2]="String",O[O.RegEx=3]="RegEx"})(R=e.StandardTokenType||(e.StandardTokenType={}));var F;(function(O){O[O.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",O[O.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",O[O.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",O[O.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",O[O.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",O[O.ITALIC_MASK=1024]="ITALIC_MASK",O[O.BOLD_MASK=2048]="BOLD_MASK",O[O.UNDERLINE_MASK=4096]="UNDERLINE_MASK",O[O.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",O[O.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",O[O.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",O[O.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",O[O.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",O[O.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",O[O.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",O[O.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",O[O.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",O[O.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",O[O.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",O[O.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(F=e.MetadataConsts||(e.MetadataConsts={}));class D{static getLanguageId(y){return(y&255)>>>0}static getTokenType(y){return(y&768)>>>8}static getFontStyle(y){return(y&15360)>>>10}static getForeground(y){return(y&8372224)>>>14}static getBackground(y){return(y&4286578688)>>>23}static getClassNameFromMetadata(y){const z=this.getForeground(y);let M="mtk"+z;const B=this.getFontStyle(y);return B&1&&(M+=" mtki"),B&2&&(M+=" mtkb"),B&4&&(M+=" mtku"),B&8&&(M+=" mtks"),M}static getInlineStyleFromMetadata(y,z){const M=this.getForeground(y),B=this.getFontStyle(y);let V=`color: ${z[M]};`;B&1&&(V+="font-style: italic;"),B&2&&(V+="font-weight: bold;");let Y="";return B&4&&(Y+=" underline"),B&8&&(Y+=" line-through"),Y&&(V+=`text-decoration:${Y};`),V}static getPresentationFromMetadata(y){const z=this.getForeground(y),M=this.getFontStyle(y);return{foreground:z,italic:Boolean(M&1),bold:Boolean(M&2),underline:Boolean(M&4),strikethrough:Boolean(M&8)}}}e.TokenMetadata=D;class p{constructor(y,z,M){this._tokenBrand=void 0,this.offset=y,this.type=z,this.language=M}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=p;class _{constructor(y,z){this._tokenizationResultBrand=void 0,this.tokens=y,this.endState=z}}e.TokenizationResult=_;class g{constructor(y,z){this._encodedTokenizationResultBrand=void 0,this.tokens=y,this.endState=z}}e.EncodedTokenizationResult=g;var d;(function(O){O[O.Method=0]="Method",O[O.Function=1]="Function",O[O.Constructor=2]="Constructor",O[O.Field=3]="Field",O[O.Variable=4]="Variable",O[O.Class=5]="Class",O[O.Struct=6]="Struct",O[O.Interface=7]="Interface",O[O.Module=8]="Module",O[O.Property=9]="Property",O[O.Event=10]="Event",O[O.Operator=11]="Operator",O[O.Unit=12]="Unit",O[O.Value=13]="Value",O[O.Constant=14]="Constant",O[O.Enum=15]="Enum",O[O.EnumMember=16]="EnumMember",O[O.Keyword=17]="Keyword",O[O.Text=18]="Text",O[O.Color=19]="Color",O[O.File=20]="File",O[O.Reference=21]="Reference",O[O.Customcolor=22]="Customcolor",O[O.Folder=23]="Folder",O[O.TypeParameter=24]="TypeParameter",O[O.User=25]="User",O[O.Issue=26]="Issue",O[O.Snippet=27]="Snippet"})(d=e.CompletionItemKind||(e.CompletionItemKind={}));var v;(function(O){const y=new Map;y.set(0,T.Codicon.symbolMethod),y.set(1,T.Codicon.symbolFunction),y.set(2,T.Codicon.symbolConstructor),y.set(3,T.Codicon.symbolField),y.set(4,T.Codicon.symbolVariable),y.set(5,T.Codicon.symbolClass),y.set(6,T.Codicon.symbolStruct),y.set(7,T.Codicon.symbolInterface),y.set(8,T.Codicon.symbolModule),y.set(9,T.Codicon.symbolProperty),y.set(10,T.Codicon.symbolEvent),y.set(11,T.Codicon.symbolOperator),y.set(12,T.Codicon.symbolUnit),y.set(13,T.Codicon.symbolValue),y.set(15,T.Codicon.symbolEnum),y.set(14,T.Codicon.symbolConstant),y.set(15,T.Codicon.symbolEnum),y.set(16,T.Codicon.symbolEnumMember),y.set(17,T.Codicon.symbolKeyword),y.set(27,T.Codicon.symbolSnippet),y.set(18,T.Codicon.symbolText),y.set(19,T.Codicon.symbolColor),y.set(20,T.Codicon.symbolFile),y.set(21,T.Codicon.symbolReference),y.set(22,T.Codicon.symbolCustomColor),y.set(23,T.Codicon.symbolFolder),y.set(24,T.Codicon.symbolTypeParameter),y.set(25,T.Codicon.account),y.set(26,T.Codicon.issues);function z(V){let Y=y.get(V);return Y||(console.info("No codicon found for CompletionItemKind "+V),Y=T.Codicon.symbolProperty),Y}O.toIcon=z;const M=new Map;M.set("method",0),M.set("function",1),M.set("constructor",2),M.set("field",3),M.set("variable",4),M.set("class",5),M.set("struct",6),M.set("interface",7),M.set("module",8),M.set("property",9),M.set("event",10),M.set("operator",11),M.set("unit",12),M.set("value",13),M.set("constant",14),M.set("enum",15),M.set("enum-member",16),M.set("enumMember",16),M.set("keyword",17),M.set("snippet",27),M.set("text",18),M.set("color",19),M.set("file",20),M.set("reference",21),M.set("customcolor",22),M.set("folder",23),M.set("type-parameter",24),M.set("typeParameter",24),M.set("account",25),M.set("issue",26);function B(V,Y){let H=M.get(V);return typeof H=="undefined"&&!Y&&(H=9),H}O.fromString=B})(v=e.CompletionItemKinds||(e.CompletionItemKinds={}));var A;(function(O){O[O.Deprecated=1]="Deprecated"})(A=e.CompletionItemTag||(e.CompletionItemTag={}));var b;(function(O){O[O.KeepWhitespace=1]="KeepWhitespace",O[O.InsertAsSnippet=4]="InsertAsSnippet"})(b=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var a;(function(O){O[O.Invoke=0]="Invoke",O[O.TriggerCharacter=1]="TriggerCharacter",O[O.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(a=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var c;(function(O){O[O.Automatic=0]="Automatic",O[O.Explicit=1]="Explicit"})(c=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var m;(function(O){O[O.Invoke=1]="Invoke",O[O.Auto=2]="Auto"})(m=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var s;(function(O){O[O.Invoke=1]="Invoke",O[O.TriggerCharacter=2]="TriggerCharacter",O[O.ContentChange=3]="ContentChange"})(s=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var E;(function(O){O[O.Text=0]="Text",O[O.Read=1]="Read",O[O.Write=2]="Write"})(E=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function l(O){return O&&h.URI.isUri(O.uri)&&n.Range.isIRange(O.range)&&(n.Range.isIRange(O.originSelectionRange)||n.Range.isIRange(O.targetSelectionRange))}e.isLocationLink=l;var i;(function(O){O[O.File=0]="File",O[O.Module=1]="Module",O[O.Namespace=2]="Namespace",O[O.Package=3]="Package",O[O.Class=4]="Class",O[O.Method=5]="Method",O[O.Property=6]="Property",O[O.Field=7]="Field",O[O.Constructor=8]="Constructor",O[O.Enum=9]="Enum",O[O.Interface=10]="Interface",O[O.Function=11]="Function",O[O.Variable=12]="Variable",O[O.Constant=13]="Constant",O[O.String=14]="String",O[O.Number=15]="Number",O[O.Boolean=16]="Boolean",O[O.Array=17]="Array",O[O.Object=18]="Object",O[O.Key=19]="Key",O[O.Null=20]="Null",O[O.EnumMember=21]="EnumMember",O[O.Struct=22]="Struct",O[O.Event=23]="Event",O[O.Operator=24]="Operator",O[O.TypeParameter=25]="TypeParameter"})(i=e.SymbolKind||(e.SymbolKind={}));var r;(function(O){O[O.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var t;(function(O){const y=new Map;y.set(0,T.Codicon.symbolFile),y.set(1,T.Codicon.symbolModule),y.set(2,T.Codicon.symbolNamespace),y.set(3,T.Codicon.symbolPackage),y.set(4,T.Codicon.symbolClass),y.set(5,T.Codicon.symbolMethod),y.set(6,T.Codicon.symbolProperty),y.set(7,T.Codicon.symbolField),y.set(8,T.Codicon.symbolConstructor),y.set(9,T.Codicon.symbolEnum),y.set(10,T.Codicon.symbolInterface),y.set(11,T.Codicon.symbolFunction),y.set(12,T.Codicon.symbolVariable),y.set(13,T.Codicon.symbolConstant),y.set(14,T.Codicon.symbolString),y.set(15,T.Codicon.symbolNumber),y.set(16,T.Codicon.symbolBoolean),y.set(17,T.Codicon.symbolArray),y.set(18,T.Codicon.symbolObject),y.set(19,T.Codicon.symbolKey),y.set(20,T.Codicon.symbolNull),y.set(21,T.Codicon.symbolEnumMember),y.set(22,T.Codicon.symbolStruct),y.set(23,T.Codicon.symbolEvent),y.set(24,T.Codicon.symbolOperator),y.set(25,T.Codicon.symbolTypeParameter);function z(M){let B=y.get(M);return B||(console.info("No codicon found for SymbolKind "+M),B=T.Codicon.symbolProperty),B}O.toIcon=z})(t=e.SymbolKinds||(e.SymbolKinds={}));class o{constructor(y){this.value=y}}e.FoldingRangeKind=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var f;(function(O){function y(z){return!z||typeof z!="object"?!1:typeof z.id=="string"&&typeof z.title=="string"}O.is=y})(f=e.Command||(e.Command={}));var u;(function(O){O[O.Collapsed=0]="Collapsed",O[O.Expanded=1]="Expanded"})(u=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var w;(function(O){O[O.Editing=0]="Editing",O[O.Preview=1]="Preview"})(w=e.CommentMode||(e.CommentMode={}));var P;(function(O){O[O.Type=1]="Type",O[O.Parameter=2]="Parameter"})(P=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new I.TokenizationRegistry;var L;(function(O){O[O.None=0]="None",O[O.Option=1]="Option",O[O.Default=2]="Default",O[O.Preferred=3]="Preferred"})(L=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ve[154],we([19,20]),function(ee,e){return ee.create("vs/base/common/date",e)}),define(ve[155],we([1,0,154]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,I=n*60,T=I*24,C=T*7,k=T*30,S=T*365;function R(D,p,_){typeof D!="number"&&(D=D.getTime());const g=Math.round((new Date().getTime()-D)/1e3);if(g<-30)return(0,h.localize)(0,null,R(new Date().getTime()+g*1e3,!1));if(g<30)return(0,h.localize)(1,null);let d;return g<n?(d=g,p?d===1?_?(0,h.localize)(2,null,d):(0,h.localize)(3,null,d):_?(0,h.localize)(4,null,d):(0,h.localize)(5,null,d):d===1?_?(0,h.localize)(6,null,d):(0,h.localize)(7,null,d):_?(0,h.localize)(8,null,d):(0,h.localize)(9,null,d)):g<I?(d=Math.floor(g/n),p?d===1?_?(0,h.localize)(10,null,d):(0,h.localize)(11,null,d):_?(0,h.localize)(12,null,d):(0,h.localize)(13,null,d):d===1?_?(0,h.localize)(14,null,d):(0,h.localize)(15,null,d):_?(0,h.localize)(16,null,d):(0,h.localize)(17,null,d)):g<T?(d=Math.floor(g/I),p?d===1?_?(0,h.localize)(18,null,d):(0,h.localize)(19,null,d):_?(0,h.localize)(20,null,d):(0,h.localize)(21,null,d):d===1?_?(0,h.localize)(22,null,d):(0,h.localize)(23,null,d):_?(0,h.localize)(24,null,d):(0,h.localize)(25,null,d)):g<C?(d=Math.floor(g/T),p?d===1?(0,h.localize)(26,null,d):(0,h.localize)(27,null,d):d===1?(0,h.localize)(28,null,d):(0,h.localize)(29,null,d)):g<k?(d=Math.floor(g/C),p?d===1?_?(0,h.localize)(30,null,d):(0,h.localize)(31,null,d):_?(0,h.localize)(32,null,d):(0,h.localize)(33,null,d):d===1?_?(0,h.localize)(34,null,d):(0,h.localize)(35,null,d):_?(0,h.localize)(36,null,d):(0,h.localize)(37,null,d)):g<S?(d=Math.floor(g/k),p?d===1?_?(0,h.localize)(38,null,d):(0,h.localize)(39,null,d):_?(0,h.localize)(40,null,d):(0,h.localize)(41,null,d):d===1?_?(0,h.localize)(42,null,d):(0,h.localize)(43,null,d):_?(0,h.localize)(44,null,d):(0,h.localize)(45,null,d)):(d=Math.floor(g/S),p?d===1?_?(0,h.localize)(46,null,d):(0,h.localize)(47,null,d):_?(0,h.localize)(48,null,d):(0,h.localize)(49,null,d):d===1?_?(0,h.localize)(50,null,d):(0,h.localize)(51,null,d):_?(0,h.localize)(52,null,d):(0,h.localize)(53,null,d))}e.fromNow=R;function F(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=F}),define(ve[156],we([19,20]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(ve[49],we([1,0,18,13,156]),function(ee,e,h,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function T(D,p){return p&&(D.stack||D.stacktrace)?I.localize(0,null,k(D),C(D.stack)||C(D.stacktrace)):k(D)}function C(D){return Array.isArray(D)?D.join(`
`):D}function k(D){return typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?I.localize(1,null,D.message):D.message||I.localize(2,null)}function S(D=null,p=!1){if(!D)return I.localize(3,null);if(Array.isArray(D)){const _=h.coalesce(D),g=S(_[0],p);return _.length>1?I.localize(4,null,g,_.length):g}if(n.isString(D))return D;if(D.detail){const _=D.detail;if(_.error)return T(_.error,p);if(_.exception)return T(_.exception,p)}return D.stack?T(D,p):D.message?D.message:I.localize(5,null)}e.toErrorMessage=S;function R(D){const p=D;return p instanceof Error&&Array.isArray(p.actions)}e.isErrorWithActions=R;function F(D,p=Object.create(null)){const _=new Error(D);return p.actions&&(_.actions=p.actions),_}e.createErrorWithActions=F}),define(ve[157],we([19,20]),function(ee,e){return ee.create("vs/base/node/processes",e)}),define(ve[112],we([1,0,38,29,10,25,9,12,41,93,13,145,28,157]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function g(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(s,E){if(k.isWindows)try{const l={stdio:["pipe","pipe","ignore"]};E&&(l.cwd=E);const i=h.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],l);return new Promise(r=>{i.once("error",t=>{r({success:!1,error:t})}),i.once("exit",(t,o)=>{r(t===0?{success:!0}:{success:!1,code:t!==null?t:1})})})}catch(l){return Promise.resolve({success:!1,error:l,code:l.status?g(l.status):1})}else if(k.isLinux||k.isMacintosh)try{const l=I.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",ee).fsPath;return new Promise(i=>{h.execFile(l,[s.pid.toString()],{encoding:"utf8",shell:!0},(r,t,o)=>{i(r?{success:!1,error:r}:{success:!0})})})}catch(l){return Promise.resolve({success:!1,error:l})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function v(s){!s||(delete s.DEBUG,k.isMacintosh&&delete s.DYLD_LIBRARY_PATH,k.isLinux&&delete s.LD_PRELOAD)}e.removeDangerousEnvVariables=v;function A(s=S.env){return s.comspec||"cmd.exe"}e.getWindowsShell=A;class b{constructor(E,l,i,r){if(l!==void 0&&i!==void 0&&r!==void 0)this.cmd=E,this.args=l,this.shell=i,this.options=r;else{const t=E;this.cmd=t.command,this.shell=t.isShellCommand,this.args=t.args.slice(0),this.options=t.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const t=Object.create(null);Object.keys(S.env).forEach(o=>{t[o]=S.env[o]}),Object.keys(this.options.env).forEach(o=>{t[o]=this.options.env[o]}),this.options.env=t}}getSanitizedCommand(){let E=this.cmd.toLowerCase();const l=E.lastIndexOf(C.sep);return l!==-1&&(E=E.substring(l+1)),b.WellKnowCommands[E]?E:"other"}start(E){return k.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(S.cwd()))?Promise.reject(new Error(_.localize(0,null))):this.useExec().then(l=>{let i,r;const t=new Promise((o,f)=>{i=o,r=f});if(l){let o=this.cmd;this.args&&(o=o+" "+this.args.join(" ")),this.childProcess=h.exec(o,this.options,(f,u,w)=>{this.childProcess=null;const P=f;P&&P.killed?r({killed:this.terminateRequested,stdout:u.toString(),stderr:w.toString()}):this.handleExec(i,E,f,u,w)})}else{let o=null;const f=u=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(u,i,E,r);const w={terminated:this.terminateRequested};F.isNumber(u)&&(w.cmdCode=u),i(w)};if(this.shell&&k.isWindows){const u=T.deepClone(this.options);u.windowsVerbatimArguments=!0,u.detached=!1;let w=!1,P=!1;const L=[];let O=this.ensureQuotes(this.cmd);L.push(O.value),w=O.quoted,this.args&&this.args.forEach(z=>{O=this.ensureQuotes(z),L.push(O.value),P=P&&O.quoted});const y=["/s","/c"];w?P?y.push('"'+L.join(" ")+'"'):L.length>1?y.push('"'+L[0]+'" '+L.slice(1).join(" ")):y.push('"'+L[0]+'"'):y.push(L.join(" ")),o=h.spawn(A(),y,u)}else this.cmd&&(o=h.spawn(this.cmd,this.args,this.options));o&&(this.childProcess=o,this.childProcessPromise=Promise.resolve(o),this.pidResolve&&(this.pidResolve(F.isNumber(o.pid)?o.pid:-1),this.pidResolve=void 0),o.on("error",u=>{this.childProcess=null,r({terminated:this.terminateRequested,error:u})}),o.pid&&(this.childProcess.on("close",f),this.handleSpawn(o,i,E,r,!0)))}return t})}handleClose(E,l,i,r){}ensureQuotes(E){return b.regexp.test(E)?{value:'"'+E+'"',quoted:!0}:{value:E,quoted:E.length>0&&E[0]==='"'&&E[E.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(E=>E.pid,E=>-1):new Promise(E=>{this.pidResolve=E})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(E=>(this.terminateRequested=!0,d(E,this.options.cwd).then(l=>(l.success&&(this.childProcess=null),l))),E=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(E=>{if(!this.shell||!k.isWindows)return E(!1);const l=h.spawn(A(),["/s","/c"]);l.on("error",i=>E(!0)),l.on("exit",i=>E(!1))})}}e.AbstractProcess=b,b.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},b.regexp=/^[^"].* .*[^"]/;class a extends b{constructor(E,l,i,r){super(E,l,i,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(E,l,i,r,t){[r,t].forEach((o,f)=>{const u=new D.LineDecoder;u.write(o).forEach(L=>{l({line:L,source:f===0?0:1})});const P=u.end();P&&l({line:P,source:f===0?0:1})}),E({terminated:this.terminateRequested,error:i})}handleSpawn(E,l,i,r,t){const o=new D.LineDecoder,f=new D.LineDecoder;E.stdout.on("data",u=>{o.write(u).forEach(P=>i({line:P,source:0}))}),E.stderr.on("data",u=>{f.write(u).forEach(P=>i({line:P,source:1}))}),this.stdoutLineDecoder=o,this.stderrLineDecoder=f}handleClose(E,l,i,r){const t=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;t&&i({line:t,source:0});const o=this.stderrLineDecoder?this.stderrLineDecoder.end():null;o&&i({line:o,source:1})}}e.LineProcess=a;function c(s){let E=[],l=!1;const i=function(r){if(l){E.push(r);return}(!s.send(r,o=>{if(o&&console.error(o),l=!1,E.length>0){const f=E.slice(0);E=[],f.forEach(u=>i(u))}})||k.isWindows)&&(l=!0)};return{send:i}}e.createQueuedSender=c;var m;(function(s){async function E(l,i,r){if(C.isAbsolute(l))return l;if(i===void 0&&(i=S.cwd()),C.dirname(l)!=="."||(r===void 0&&F.isString(S.env.PATH)&&(r=S.env.PATH.split(C.delimiter)),r===void 0||r.length===0))return C.join(i,l);async function o(f){if(await p.Promises.exists(f)){let u;try{u=await p.Promises.stat(f)}catch(w){w.message.startsWith("EACCES")&&(u=await p.Promises.lstat(f))}return u?!u.isDirectory():!1}return!1}for(let f of r){let u;if(C.isAbsolute(f)?u=C.join(f,l):u=C.join(i,f,l),await o(u))return u;let w=u+".com";if(await o(w)||(w=u+".exe",await o(w)))return w}return C.join(i,l)}s.findExecutable=E})(m=e.win32||(e.win32={}))}),define(ve[158],we([19,20]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(ve[113],we([1,0,158,12,107,18,25,147]),function(ee,e,h,n,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(ne){ne[ne.None=0]="None",ne[ne.Keep=1]="Keep",ne[ne.Brackets=2]="Brackets",ne[ne.Advanced=3]="Advanced",ne[ne.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class R{constructor(ae){this._values=ae}hasChanged(ae){return this._values[ae]}}e.ConfigurationChangedEvent=R;class F{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=F;class D{constructor(ae,J,pe,Se){this.id=ae,this.name=J,this.defaultValue=pe,this.schema=Se}applyUpdate(ae,J){return _(ae,J)}compute(ae,J,pe){return pe}}class p{constructor(ae,J){this.newValue=ae,this.didChange=J}}e.ApplyUpdateResult=p;function _(ne,ae){if(typeof ne!="object"||typeof ae!="object"||!ne||!ae)return new p(ae,ne!==ae);if(Array.isArray(ne)||Array.isArray(ae)){const pe=Array.isArray(ne)&&Array.isArray(ae)&&T.equals(ne,ae);return new p(ae,pe)}let J=!1;for(const pe in ae)if(ae.hasOwnProperty(pe)){const Se=_(ne[pe],ae[pe]);Se.didChange&&(ne[pe]=Se.newValue,J=!0)}return new p(ne,J)}class g{constructor(ae){this.schema=void 0,this.id=ae,this.name="_never_",this.defaultValue=void 0}applyUpdate(ae,J){return _(ae,J)}validate(ae){return this.defaultValue}}class d{constructor(ae,J,pe,Se){this.id=ae,this.name=J,this.defaultValue=pe,this.schema=Se}applyUpdate(ae,J){return _(ae,J)}validate(ae){return typeof ae=="undefined"?this.defaultValue:ae}compute(ae,J,pe){return pe}}function v(ne,ae){return typeof ne=="undefined"?ae:ne==="false"?!1:Boolean(ne)}e.boolean=v;class A extends d{constructor(ae,J,pe,Se=void 0){typeof Se!="undefined"&&(Se.type="boolean",Se.default=pe);super(ae,J,pe,Se)}validate(ae){return v(ae,this.defaultValue)}}function b(ne,ae,J,pe){if(typeof ne=="undefined")return ae;let Se=parseInt(ne,10);return isNaN(Se)?ae:(Se=Math.max(J,Se),Se=Math.min(pe,Se),Se|0)}e.clampedInt=b;class a extends d{constructor(ae,J,pe,Se,Me,$e=void 0){typeof $e!="undefined"&&($e.type="integer",$e.default=pe,$e.minimum=Se,$e.maximum=Me);super(ae,J,pe,$e);this.minimum=Se,this.maximum=Me}static clampedInt(ae,J,pe,Se){return b(ae,J,pe,Se)}validate(ae){return a.clampedInt(ae,this.defaultValue,this.minimum,this.maximum)}}class c extends d{constructor(ae,J,pe,Se,Me){typeof Me!="undefined"&&(Me.type="number",Me.default=pe);super(ae,J,pe,Me);this.validationFn=Se}static clamp(ae,J,pe){return ae<J?J:ae>pe?pe:ae}static float(ae,J){if(typeof ae=="number")return ae;if(typeof ae=="undefined")return J;const pe=parseFloat(ae);return isNaN(pe)?J:pe}validate(ae){return this.validationFn(c.float(ae,this.defaultValue))}}class m extends d{static string(ae,J){return typeof ae!="string"?J:ae}constructor(ae,J,pe,Se=void 0){typeof Se!="undefined"&&(Se.type="string",Se.default=pe);super(ae,J,pe,Se)}validate(ae){return m.string(ae,this.defaultValue)}}function s(ne,ae,J){return typeof ne!="string"||J.indexOf(ne)===-1?ae:ne}e.stringSet=s;class E extends d{constructor(ae,J,pe,Se,Me=void 0){typeof Me!="undefined"&&(Me.type="string",Me.enum=Se,Me.default=pe);super(ae,J,pe,Me);this._allowedValues=Se}validate(ae){return s(ae,this.defaultValue,this._allowedValues)}}class l extends D{constructor(ae,J,pe,Se,Me,$e,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="string",Ye.enum=Me,Ye.default=Se);super(ae,J,pe,Ye);this._allowedValues=Me,this._convert=$e}validate(ae){return typeof ae!="string"?this.defaultValue:this._allowedValues.indexOf(ae)===-1?this.defaultValue:this._convert(ae)}}function i(ne){switch(ne){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class r extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[h.localize(0,null),h.localize(1,null),h.localize(2,null)],default:"auto",description:h.localize(3,null)})}validate(ae){switch(ae){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ae,J,pe){return pe===0?ae.accessibilitySupport:pe}}class t extends D{constructor(){const ae={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",ae,{"editor.comments.insertSpace":{type:"boolean",default:ae.insertSpace,description:h.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ae.ignoreEmptyLines,description:h.localize(5,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{insertSpace:v(J.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:v(J.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var o;(function(ne){ne[ne.Hidden=0]="Hidden",ne[ne.Blink=1]="Blink",ne[ne.Smooth=2]="Smooth",ne[ne.Phase=3]="Phase",ne[ne.Expand=4]="Expand",ne[ne.Solid=5]="Solid"})(o=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function f(ne){switch(ne){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var u;(function(ne){ne[ne.Line=1]="Line",ne[ne.Block=2]="Block",ne[ne.Underline=3]="Underline",ne[ne.LineThin=4]="LineThin",ne[ne.BlockOutline=5]="BlockOutline",ne[ne.UnderlineThin=6]="UnderlineThin"})(u=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function w(ne){switch(ne){case u.Line:return"line";case u.Block:return"block";case u.Underline:return"underline";case u.LineThin:return"line-thin";case u.BlockOutline:return"block-outline";case u.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=w;function P(ne){switch(ne){case"line":return u.Line;case"block":return u.Block;case"underline":return u.Underline;case"line-thin":return u.LineThin;case"block-outline":return u.BlockOutline;case"underline-thin":return u.UnderlineThin}}class L extends g{constructor(){super(128)}compute(ae,J,pe){const Se=["monaco-editor"];return J.get(33)&&Se.push(J.get(33)),ae.extraEditorClassName&&Se.push(ae.extraEditorClassName),J.get(66)==="default"?Se.push("mouse-default"):J.get(66)==="copy"&&Se.push("mouse-copy"),J.get(100)&&Se.push("showUnused"),J.get(126)&&Se.push("showDeprecated"),Se.join(" ")}}class O extends A{constructor(){super(32,"emptySelectionClipboard",!0,{description:h.localize(6,null)})}compute(ae,J,pe){return pe&&ae.emptySelectionClipboard}}class y extends D{constructor(){const ae={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",ae,{"editor.find.cursorMoveOnType":{type:"boolean",default:ae.cursorMoveOnType,description:h.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ae.seedSearchStringFromSelection,enumDescriptions:[h.localize(8,null),h.localize(9,null),h.localize(10,null)],description:h.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ae.autoFindInSelection,enumDescriptions:[h.localize(12,null),h.localize(13,null),h.localize(14,null)],description:h.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ae.globalFindClipboard,description:h.localize(16,null),included:n.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ae.addExtraSpaceOnTop,description:h.localize(17,null)},"editor.find.loop":{type:"boolean",default:ae.loop,description:h.localize(18,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{cursorMoveOnType:v(J.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ae.seedSearchStringFromSelection=="boolean"?ae.seedSearchStringFromSelection?"always":"never":s(J.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ae.autoFindInSelection=="boolean"?ae.autoFindInSelection?"always":"never":s(J.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:v(J.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:v(J.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:v(J.loop,this.defaultValue.loop)}}}class z extends D{constructor(){super(45,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:h.localize(19,null)},{type:"string",description:h.localize(20,null)}],description:h.localize(21,null),default:!1})}validate(ae){return typeof ae=="undefined"?this.defaultValue:typeof ae=="string"?ae==="false"?z.OFF:ae==="true"?z.ON:ae:Boolean(ae)?z.ON:z.OFF}}e.EditorFontLigatures=z,z.OFF='"liga" off, "calt" off',z.ON='"liga" on, "calt" on';class M extends g{constructor(){super(44)}compute(ae,J,pe){return ae.fontInfo}}class B extends d{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:h.localize(22,null)})}validate(ae){const J=c.float(ae,this.defaultValue);return J===0?e.EDITOR_FONT_DEFAULTS.fontSize:c.clamp(J,6,100)}compute(ae,J,pe){return ae.fontInfo.fontSize}}class V extends D{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:V.MINIMUM_VALUE,maximum:V.MAXIMUM_VALUE,errorMessage:h.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:V.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:h.localize(24,null)})}validate(ae){return ae==="normal"||ae==="bold"?ae:String(a.clampedInt(ae,e.EDITOR_FONT_DEFAULTS.fontWeight,V.MINIMUM_VALUE,V.MAXIMUM_VALUE))}}V.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],V.MINIMUM_VALUE=1,V.MAXIMUM_VALUE=1e3;class Y extends D{constructor(){const ae={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},J={type:"string",enum:["peek","gotoAndPeek","goto"],default:ae.multiple,enumDescriptions:[h.localize(25,null),h.localize(26,null),h.localize(27,null)]},pe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",ae,{"editor.gotoLocation.multiple":{deprecationMessage:h.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:h.localize(29,null),...J},"editor.gotoLocation.multipleTypeDefinitions":{description:h.localize(30,null),...J},"editor.gotoLocation.multipleDeclarations":{description:h.localize(31,null),...J},"editor.gotoLocation.multipleImplementations":{description:h.localize(32,null),...J},"editor.gotoLocation.multipleReferences":{description:h.localize(33,null),...J},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ae.alternativeDefinitionCommand,enum:pe,description:h.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ae.alternativeTypeDefinitionCommand,enum:pe,description:h.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ae.alternativeDeclarationCommand,enum:pe,description:h.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ae.alternativeImplementationCommand,enum:pe,description:h.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ae.alternativeReferenceCommand,enum:pe,description:h.localize(38,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{multiple:s(J.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:J.multipleDefinitions??s(J.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:J.multipleTypeDefinitions??s(J.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:J.multipleDeclarations??s(J.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:J.multipleImplementations??s(J.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:J.multipleReferences??s(J.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:m.string(J.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:m.string(J.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:m.string(J.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:m.string(J.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:m.string(J.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class H extends D{constructor(){const ae={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",ae,{"editor.hover.enabled":{type:"boolean",default:ae.enabled,description:h.localize(39,null)},"editor.hover.delay":{type:"number",default:ae.delay,minimum:0,maximum:1e4,description:h.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:ae.sticky,description:h.localize(41,null)},"editor.hover.above":{type:"boolean",default:ae.above,description:h.localize(42,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{enabled:v(J.enabled,this.defaultValue.enabled),delay:a.clampedInt(J.delay,this.defaultValue.delay,0,1e4),sticky:v(J.sticky,this.defaultValue.sticky),above:v(J.above,this.defaultValue.above)}}}var q;(function(ne){ne[ne.None=0]="None",ne[ne.Text=1]="Text",ne[ne.Blocks=2]="Blocks"})(q=e.RenderMinimap||(e.RenderMinimap={}));class K extends g{constructor(){super(131)}compute(ae,J,pe){return K.computeLayout(J,{memory:ae.memory,outerWidth:ae.outerWidth,outerHeight:ae.outerHeight,isDominatedByLongLines:ae.isDominatedByLongLines,lineHeight:ae.fontInfo.lineHeight,viewLineCount:ae.viewLineCount,lineNumbersDigitCount:ae.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ae.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ae.fontInfo.maxDigitWidth,pixelRatio:ae.pixelRatio})}static computeContainedMinimapLineCount(ae){const J=ae.height/ae.lineHeight,pe=ae.scrollBeyondLastLine?J-1:0,Se=(ae.viewLineCount+pe)/(ae.pixelRatio*ae.height),Me=Math.floor(ae.viewLineCount/Se);return{typicalViewportLineCount:J,extraLinesBeyondLastLine:pe,desiredRatio:Se,minimapLineCount:Me}}static _computeMinimapLayout(ae,J){const pe=ae.outerWidth,Se=ae.outerHeight,Me=ae.pixelRatio;if(!ae.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Me*Se),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Se};const $e=J.stableMinimapLayoutInput,Ye=$e&&ae.outerHeight===$e.outerHeight&&ae.lineHeight===$e.lineHeight&&ae.typicalHalfwidthCharacterWidth===$e.typicalHalfwidthCharacterWidth&&ae.pixelRatio===$e.pixelRatio&&ae.scrollBeyondLastLine===$e.scrollBeyondLastLine&&ae.minimap.enabled===$e.minimap.enabled&&ae.minimap.side===$e.minimap.side&&ae.minimap.size===$e.minimap.size&&ae.minimap.showSlider===$e.minimap.showSlider&&ae.minimap.renderCharacters===$e.minimap.renderCharacters&&ae.minimap.maxColumn===$e.minimap.maxColumn&&ae.minimap.scale===$e.minimap.scale&&ae.verticalScrollbarWidth===$e.verticalScrollbarWidth&&ae.isViewportWrapping===$e.isViewportWrapping,lt=ae.lineHeight,vt=ae.typicalHalfwidthCharacterWidth,wt=ae.scrollBeyondLastLine,je=ae.minimap.renderCharacters;let st=Me>=2?Math.round(ae.minimap.scale*2):ae.minimap.scale;const _t=ae.minimap.maxColumn,nt=ae.minimap.size,ct=ae.minimap.side,Rt=ae.verticalScrollbarWidth,Tt=ae.viewLineCount,yt=ae.remainingWidth,mt=ae.isViewportWrapping,Lt=je?2:3;let Mt=Math.floor(Me*Se);const Ft=Mt/Me;let xe=!1,_e=!1,ye=Lt*st,fe=st/Me,te=1;if(nt==="fill"||nt==="fit"){const{typicalViewportLineCount:St,extraLinesBeyondLastLine:ot,desiredRatio:dt,minimapLineCount:ut}=K.computeContainedMinimapLineCount({viewLineCount:Tt,scrollBeyondLastLine:wt,height:Se,lineHeight:lt,pixelRatio:Me});if(Tt/ut>1)xe=!0,_e=!0,st=1,ye=1,fe=st/Me;else{let pt=!1,kt=st+1;if(nt==="fit"){const Ut=Math.ceil((Tt+ot)*ye);mt&&Ye&&yt<=J.stableFitRemainingWidth?(pt=!0,kt=J.stableFitMaxMinimapScale):pt=Ut>Mt}if(nt==="fill"||pt){xe=!0;const Ut=st;ye=Math.min(lt*Me,Math.max(1,Math.floor(1/dt))),mt&&Ye&&yt<=J.stableFitRemainingWidth&&(kt=J.stableFitMaxMinimapScale),st=Math.min(kt,Math.max(1,Math.floor(ye/Lt))),st>Ut&&(te=Math.min(2,st/Ut)),fe=st/Me/te,Mt=Math.ceil(Math.max(St,Tt+ot)*ye),mt?(J.stableMinimapLayoutInput=ae,J.stableFitRemainingWidth=yt,J.stableFitMaxMinimapScale=st):(J.stableMinimapLayoutInput=null,J.stableFitRemainingWidth=0)}}}const Ie=Math.floor(_t*fe),Re=Math.min(Ie,Math.max(0,Math.floor((yt-Rt-2)*fe/(vt+fe)))+e.MINIMAP_GUTTER_WIDTH);let Ve=Math.floor(Me*Re);const Ke=Ve/Me;Ve=Math.floor(Ve*te);const ht=je?1:2,Et=ct==="left"?0:pe-Re-Rt;return{renderMinimap:ht,minimapLeft:Et,minimapWidth:Re,minimapHeightIsEditorHeight:xe,minimapIsSampling:_e,minimapScale:st,minimapLineHeight:ye,minimapCanvasInnerWidth:Ve,minimapCanvasInnerHeight:Mt,minimapCanvasOuterWidth:Ke,minimapCanvasOuterHeight:Ft}}static computeLayout(ae,J){const pe=J.outerWidth|0,Se=J.outerHeight|0,Me=J.lineHeight|0,$e=J.lineNumbersDigitCount|0,Ye=J.typicalHalfwidthCharacterWidth,lt=J.maxDigitWidth,vt=J.pixelRatio,wt=J.viewLineCount,je=ae.get(123),st=je==="inherit"?ae.get(122):je,_t=st==="inherit"?ae.get(118):st,nt=ae.get(121),ct=ae.get(2),Rt=J.isDominatedByLongLines,Tt=ae.get(50),yt=ae.get(60).renderType!==0,mt=ae.get(61),Lt=ae.get(94),Mt=ae.get(65),Ft=ae.get(92),xe=Ft.verticalScrollbarSize,_e=Ft.verticalHasArrows,ye=Ft.arrowSize,fe=Ft.horizontalScrollbarSize,te=ae.get(58),Ie=ae.get(37);let Re;if(typeof te=="string"&&/^\d+(\.\d+)?ch$/.test(te)){const Ht=parseFloat(te.substr(0,te.length-2));Re=a.clampedInt(Ht*Ye,0,0,1e3)}else Re=a.clampedInt(te,0,0,1e3);Ie&&(Re+=16);let Ve=0;if(yt){const Ht=Math.max($e,mt);Ve=Math.round(Ht*lt)}let Ke=0;Tt&&(Ke=Me);let ht=0,Et=ht+Ke,St=Et+Ve,ot=St+Re;const dt=pe-Ke-Ve-Re;let ut=!1,Nt=!1,pt=-1;ct!==2&&(st==="inherit"&&Rt?(ut=!0,Nt=!0):_t==="on"||_t==="bounded"?Nt=!0:_t==="wordWrapColumn"&&(pt=nt));const kt=K._computeMinimapLayout({outerWidth:pe,outerHeight:Se,lineHeight:Me,typicalHalfwidthCharacterWidth:Ye,pixelRatio:vt,scrollBeyondLastLine:Lt,minimap:Mt,verticalScrollbarWidth:xe,viewLineCount:wt,remainingWidth:dt,isViewportWrapping:Nt},J.memory||new F);kt.renderMinimap!==0&&kt.minimapLeft===0&&(ht+=kt.minimapWidth,Et+=kt.minimapWidth,St+=kt.minimapWidth,ot+=kt.minimapWidth);const Ut=dt-kt.minimapWidth,Ct=Math.max(1,Math.floor((Ut-xe-2)/Ye)),Bt=_e?ye:0;return Nt&&(pt=Math.max(1,Ct),_t==="bounded"&&(pt=Math.min(pt,nt))),{width:pe,height:Se,glyphMarginLeft:ht,glyphMarginWidth:Ke,lineNumbersLeft:Et,lineNumbersWidth:Ve,decorationsLeft:St,decorationsWidth:Re,contentLeft:ot,contentWidth:Ut,minimap:kt,viewportColumn:Ct,isWordWrapMinified:ut,isViewportWrapping:Nt,wrappingColumn:pt,verticalScrollbarWidth:xe,horizontalScrollbarHeight:fe,overviewRuler:{top:Bt,width:xe,height:Se-2*Bt,right:0}}}}e.EditorLayoutInfoComputer=K;class G extends D{constructor(){const ae={enabled:!0};super(57,"lightbulb",ae,{"editor.lightbulb.enabled":{type:"boolean",default:ae.enabled,description:h.localize(43,null)}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{enabled:v(ae.enabled,this.defaultValue.enabled)}}}class ie extends D{constructor(){const ae={enabled:!0,fontSize:0,fontFamily:""};super(127,"inlayHints",ae,{"editor.inlayHints.enabled":{type:"boolean",default:ae.enabled,description:h.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:ae.fontSize,markdownDescription:h.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:ae.fontFamily,markdownDescription:h.localize(46,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{enabled:v(J.enabled,this.defaultValue.enabled),fontSize:a.clampedInt(J.fontSize,this.defaultValue.fontSize,0,100),fontFamily:m.string(J.fontFamily,this.defaultValue.fontFamily)}}}class oe extends c{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ae=>c.clamp(ae,0,150),{markdownDescription:h.localize(47,null)})}compute(ae,J,pe){return ae.fontInfo.lineHeight}}class ue extends D{constructor(){const ae={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",ae,{"editor.minimap.enabled":{type:"boolean",default:ae.enabled,description:h.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[h.localize(49,null),h.localize(50,null),h.localize(51,null)],default:ae.size,description:h.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ae.side,description:h.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ae.showSlider,description:h.localize(54,null)},"editor.minimap.scale":{type:"number",default:ae.scale,minimum:1,maximum:3,enum:[1,2,3],description:h.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ae.renderCharacters,description:h.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:ae.maxColumn,description:h.localize(57,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{enabled:v(J.enabled,this.defaultValue.enabled),size:s(J.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(J.side,this.defaultValue.side,["right","left"]),showSlider:s(J.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:v(J.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(J.scale,1,1,3),maxColumn:a.clampedInt(J.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Z(ne){return ne==="ctrlCmd"?n.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Q extends D{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(59,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{top:a.clampedInt(J.top,0,0,1e3),bottom:a.clampedInt(J.bottom,0,0,1e3)}}}class se extends D{constructor(){const ae={enabled:!0,cycle:!1};super(76,"parameterHints",ae,{"editor.parameterHints.enabled":{type:"boolean",default:ae.enabled,description:h.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:ae.cycle,description:h.localize(61,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{enabled:v(J.enabled,this.defaultValue.enabled),cycle:v(J.cycle,this.defaultValue.cycle)}}}class de extends g{constructor(){super(129)}compute(ae,J,pe){return ae.pixelRatio}}class ge extends D{constructor(){const ae={other:!0,comments:!1,strings:!1};super(79,"quickSuggestions",ae,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ae.strings,description:h.localize(62,null)},comments:{type:"boolean",default:ae.comments,description:h.localize(63,null)},other:{type:"boolean",default:ae.other,description:h.localize(64,null)}}}],default:ae,description:h.localize(65,null)});this.defaultValue=ae}validate(ae){if(typeof ae=="boolean")return ae;if(ae&&typeof ae=="object"){const J=ae,pe={other:v(J.other,this.defaultValue.other),comments:v(J.comments,this.defaultValue.comments),strings:v(J.strings,this.defaultValue.strings)};return pe.other&&pe.comments&&pe.strings?!0:!pe.other&&!pe.comments&&!pe.strings?!1:pe}return this.defaultValue}}var Te;(function(ne){ne[ne.Off=0]="Off",ne[ne.On=1]="On",ne[ne.Relative=2]="Relative",ne[ne.Interval=3]="Interval",ne[ne.Custom=4]="Custom"})(Te=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ne extends D{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[h.localize(66,null),h.localize(67,null),h.localize(68,null),h.localize(69,null)],default:"on",description:h.localize(70,null)})}validate(ae){let J=this.defaultValue.renderType,pe=this.defaultValue.renderFn;return typeof ae!="undefined"&&(typeof ae=="function"?(J=4,pe=ae):ae==="interval"?J=3:ae==="relative"?J=2:ae==="on"?J=1:J=0),{renderType:J,renderFn:pe}}}function be(ne){const ae=ne.get(87);return ae==="editable"?ne.get(81):ae!=="on"}e.filterValidationDecorations=be;class Ee extends D{constructor(){const ae=[],J={type:"number",description:h.localize(71,null)};super(91,"rulers",ae,{type:"array",items:{anyOf:[J,{type:["object"],properties:{column:J,color:{type:"string",description:h.localize(72,null),format:"color-hex"}}}]},default:ae,description:h.localize(73,null)})}validate(ae){if(Array.isArray(ae)){const J=[];for(let pe of ae)if(typeof pe=="number")J.push({column:a.clampedInt(pe,0,0,1e4),color:null});else if(pe&&typeof pe=="object"){const Se=pe;J.push({column:a.clampedInt(Se.column,0,0,1e4),color:Se.color})}return J.sort((pe,Se)=>pe.column-Se.column),J}return this.defaultValue}}function $(ne,ae){if(typeof ne!="string")return ae;switch(ne){case"hidden":return 2;case"visible":return 3;default:return 1}}class U extends D{constructor(){const ae={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",ae,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(74,null),h.localize(75,null),h.localize(76,null)],default:"auto",description:h.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(78,null),h.localize(79,null),h.localize(80,null)],default:"auto",description:h.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ae.verticalScrollbarSize,description:h.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ae.horizontalScrollbarSize,description:h.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ae.scrollByPage,description:h.localize(84,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae,pe=a.clampedInt(J.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Se=a.clampedInt(J.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(J.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:$(J.vertical,this.defaultValue.vertical),horizontal:$(J.horizontal,this.defaultValue.horizontal),useShadows:v(J.useShadows,this.defaultValue.useShadows),verticalHasArrows:v(J.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:v(J.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:v(J.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:v(J.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:pe,horizontalSliderSize:a.clampedInt(J.horizontalSliderSize,pe,0,1e3),verticalScrollbarSize:Se,verticalSliderSize:a.clampedInt(J.verticalSliderSize,Se,0,1e3),scrollByPage:v(J.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class N extends D{constructor(){const ae={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",ae,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.nonBasicASCII,description:h.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ae.invisibleCharacters,description:h.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ae.ambiguousCharacters,description:h.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.includeComments,description:h.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.includeStrings,description:h.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ae.allowedCharacters,description:h.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ae.allowedLocales,description:h.localize(91,null)}})}applyUpdate(ae,J){let pe=!1;J.allowedCharacters&&(C.equals(ae.allowedCharacters,J.allowedCharacters)||(ae={...ae,allowedCharacters:J.allowedCharacters},pe=!0)),J.allowedLocales&&(C.equals(ae.allowedLocales,J.allowedLocales)||(ae={...ae,allowedLocales:J.allowedLocales},pe=!0));const Se=super.applyUpdate(ae,J);return pe?new p(Se.newValue,!0):Se}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{nonBasicASCII:he(J.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:v(J.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:v(J.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:he(J.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:he(J.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(ae.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(ae.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(ae,J){if(typeof ae!="object"||!ae)return J;const pe={};for(const[Se,Me]of Object.entries(ae))Me===!0&&(pe[Se]=!0);return pe}}class W extends D{constructor(){const ae={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",ae,{"editor.inlineSuggest.enabled":{type:"boolean",default:ae.enabled,description:h.localize(92,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{enabled:v(J.enabled,this.defaultValue.enabled),mode:s(J.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class j extends D{constructor(){const ae={enabled:k.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",ae,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ae.enabled,description:h.localize(93,null)}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{enabled:v(ae.enabled,this.defaultValue.enabled)}}}class re extends D{constructor(){const ae={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",ae,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[h.localize(94,null),h.localize(95,null),h.localize(96,null)],default:ae.bracketPairs,description:h.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[h.localize(98,null),h.localize(99,null),h.localize(100,null)],default:ae.bracketPairsHorizontal,description:h.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ae.highlightActiveBracketPair,description:h.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:ae.indentation,description:h.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:ae.highlightActiveIndentation,description:h.localize(104,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{bracketPairs:he(J.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:he(J.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:v(J.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:v(J.indentation,this.defaultValue.indentation),highlightActiveIndentation:v(J.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function he(ne,ae,J){const pe=J.indexOf(ne);return pe===-1?ae:J[pe]}class Ce extends D{constructor(){const ae={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",ae,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[h.localize(105,null),h.localize(106,null)],default:ae.insertMode,description:h.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ae.filterGraceful,description:h.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:ae.localityBonus,description:h.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ae.shareSuggestSelections,markdownDescription:h.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ae.snippetsPreventQuickSuggestions,description:h.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:ae.showIcons,description:h.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ae.showStatusBar,description:h.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:ae.preview,description:h.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ae.showInlineDetails,description:h.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:h.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:h.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:h.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:h.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:h.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:h.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:h.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:h.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:h.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:h.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:h.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:h.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:h.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:h.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:h.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:h.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:h.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:h.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:h.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:h.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:h.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:h.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:h.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:h.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:h.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:h.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:h.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:h.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:h.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:h.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:h.localize(146,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const J=ae;return{insertMode:s(J.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:v(J.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:v(J.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:v(J.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:v(J.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:v(J.showIcons,this.defaultValue.showIcons),showStatusBar:v(J.showStatusBar,this.defaultValue.showStatusBar),preview:v(J.preview,this.defaultValue.preview),previewMode:s(J.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:v(J.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:v(J.showMethods,this.defaultValue.showMethods),showFunctions:v(J.showFunctions,this.defaultValue.showFunctions),showConstructors:v(J.showConstructors,this.defaultValue.showConstructors),showDeprecated:v(J.showDeprecated,this.defaultValue.showDeprecated),showFields:v(J.showFields,this.defaultValue.showFields),showVariables:v(J.showVariables,this.defaultValue.showVariables),showClasses:v(J.showClasses,this.defaultValue.showClasses),showStructs:v(J.showStructs,this.defaultValue.showStructs),showInterfaces:v(J.showInterfaces,this.defaultValue.showInterfaces),showModules:v(J.showModules,this.defaultValue.showModules),showProperties:v(J.showProperties,this.defaultValue.showProperties),showEvents:v(J.showEvents,this.defaultValue.showEvents),showOperators:v(J.showOperators,this.defaultValue.showOperators),showUnits:v(J.showUnits,this.defaultValue.showUnits),showValues:v(J.showValues,this.defaultValue.showValues),showConstants:v(J.showConstants,this.defaultValue.showConstants),showEnums:v(J.showEnums,this.defaultValue.showEnums),showEnumMembers:v(J.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:v(J.showKeywords,this.defaultValue.showKeywords),showWords:v(J.showWords,this.defaultValue.showWords),showColors:v(J.showColors,this.defaultValue.showColors),showFiles:v(J.showFiles,this.defaultValue.showFiles),showReferences:v(J.showReferences,this.defaultValue.showReferences),showFolders:v(J.showFolders,this.defaultValue.showFolders),showTypeParameters:v(J.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:v(J.showSnippets,this.defaultValue.showSnippets),showUsers:v(J.showUsers,this.defaultValue.showUsers),showIssues:v(J.showIssues,this.defaultValue.showIssues)}}}class Ae extends D{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:h.localize(147,null),default:!0,type:"boolean"}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:v(ae.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class We extends g{constructor(){super(130)}compute(ae,J,pe){return J.get(81)?!0:ae.tabFocusMode}}var ze;(function(ne){ne[ne.None=0]="None",ne[ne.Same=1]="Same",ne[ne.Indent=2]="Indent",ne[ne.DeepIndent=3]="DeepIndent"})(ze=e.WrappingIndent||(e.WrappingIndent={}));function qe(ne){switch(ne){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class He extends g{constructor(){super(132)}compute(ae,J,pe){const Se=J.get(131);return{isDominatedByLongLines:ae.isDominatedByLongLines,isWordWrapMinified:Se.isWordWrapMinified,isViewportWrapping:Se.isViewportWrapping,wrappingColumn:Se.wrappingColumn}}}const Ue="Consolas, 'Courier New', monospace",Je="Menlo, Monaco, 'Courier New', monospace",et="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:n.isMacintosh?Je:n.isLinux?et:Ue,fontWeight:"normal",fontSize:n.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(ne){return e.editorOptionsRegistry[ne.id]=ne,ne}var it;(function(ne){ne[ne.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ne[ne.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ne[ne.accessibilitySupport=2]="accessibilitySupport",ne[ne.accessibilityPageSize=3]="accessibilityPageSize",ne[ne.ariaLabel=4]="ariaLabel",ne[ne.autoClosingBrackets=5]="autoClosingBrackets",ne[ne.autoClosingDelete=6]="autoClosingDelete",ne[ne.autoClosingOvertype=7]="autoClosingOvertype",ne[ne.autoClosingQuotes=8]="autoClosingQuotes",ne[ne.autoIndent=9]="autoIndent",ne[ne.automaticLayout=10]="automaticLayout",ne[ne.autoSurround=11]="autoSurround",ne[ne.bracketPairColorization=12]="bracketPairColorization",ne[ne.guides=13]="guides",ne[ne.codeLens=14]="codeLens",ne[ne.codeLensFontFamily=15]="codeLensFontFamily",ne[ne.codeLensFontSize=16]="codeLensFontSize",ne[ne.colorDecorators=17]="colorDecorators",ne[ne.columnSelection=18]="columnSelection",ne[ne.comments=19]="comments",ne[ne.contextmenu=20]="contextmenu",ne[ne.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",ne[ne.cursorBlinking=22]="cursorBlinking",ne[ne.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",ne[ne.cursorStyle=24]="cursorStyle",ne[ne.cursorSurroundingLines=25]="cursorSurroundingLines",ne[ne.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",ne[ne.cursorWidth=27]="cursorWidth",ne[ne.disableLayerHinting=28]="disableLayerHinting",ne[ne.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",ne[ne.domReadOnly=30]="domReadOnly",ne[ne.dragAndDrop=31]="dragAndDrop",ne[ne.emptySelectionClipboard=32]="emptySelectionClipboard",ne[ne.extraEditorClassName=33]="extraEditorClassName",ne[ne.fastScrollSensitivity=34]="fastScrollSensitivity",ne[ne.find=35]="find",ne[ne.fixedOverflowWidgets=36]="fixedOverflowWidgets",ne[ne.folding=37]="folding",ne[ne.foldingStrategy=38]="foldingStrategy",ne[ne.foldingHighlight=39]="foldingHighlight",ne[ne.foldingImportsByDefault=40]="foldingImportsByDefault",ne[ne.foldingMaximumRegions=41]="foldingMaximumRegions",ne[ne.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",ne[ne.fontFamily=43]="fontFamily",ne[ne.fontInfo=44]="fontInfo",ne[ne.fontLigatures=45]="fontLigatures",ne[ne.fontSize=46]="fontSize",ne[ne.fontWeight=47]="fontWeight",ne[ne.formatOnPaste=48]="formatOnPaste",ne[ne.formatOnType=49]="formatOnType",ne[ne.glyphMargin=50]="glyphMargin",ne[ne.gotoLocation=51]="gotoLocation",ne[ne.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",ne[ne.hover=53]="hover",ne[ne.inDiffEditor=54]="inDiffEditor",ne[ne.inlineSuggest=55]="inlineSuggest",ne[ne.letterSpacing=56]="letterSpacing",ne[ne.lightbulb=57]="lightbulb",ne[ne.lineDecorationsWidth=58]="lineDecorationsWidth",ne[ne.lineHeight=59]="lineHeight",ne[ne.lineNumbers=60]="lineNumbers",ne[ne.lineNumbersMinChars=61]="lineNumbersMinChars",ne[ne.linkedEditing=62]="linkedEditing",ne[ne.links=63]="links",ne[ne.matchBrackets=64]="matchBrackets",ne[ne.minimap=65]="minimap",ne[ne.mouseStyle=66]="mouseStyle",ne[ne.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",ne[ne.mouseWheelZoom=68]="mouseWheelZoom",ne[ne.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",ne[ne.multiCursorModifier=70]="multiCursorModifier",ne[ne.multiCursorPaste=71]="multiCursorPaste",ne[ne.occurrencesHighlight=72]="occurrencesHighlight",ne[ne.overviewRulerBorder=73]="overviewRulerBorder",ne[ne.overviewRulerLanes=74]="overviewRulerLanes",ne[ne.padding=75]="padding",ne[ne.parameterHints=76]="parameterHints",ne[ne.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",ne[ne.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",ne[ne.quickSuggestions=79]="quickSuggestions",ne[ne.quickSuggestionsDelay=80]="quickSuggestionsDelay",ne[ne.readOnly=81]="readOnly",ne[ne.renameOnType=82]="renameOnType",ne[ne.renderControlCharacters=83]="renderControlCharacters",ne[ne.renderFinalNewline=84]="renderFinalNewline",ne[ne.renderLineHighlight=85]="renderLineHighlight",ne[ne.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",ne[ne.renderValidationDecorations=87]="renderValidationDecorations",ne[ne.renderWhitespace=88]="renderWhitespace",ne[ne.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",ne[ne.roundedSelection=90]="roundedSelection",ne[ne.rulers=91]="rulers",ne[ne.scrollbar=92]="scrollbar",ne[ne.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",ne[ne.scrollBeyondLastLine=94]="scrollBeyondLastLine",ne[ne.scrollPredominantAxis=95]="scrollPredominantAxis",ne[ne.selectionClipboard=96]="selectionClipboard",ne[ne.selectionHighlight=97]="selectionHighlight",ne[ne.selectOnLineNumbers=98]="selectOnLineNumbers",ne[ne.showFoldingControls=99]="showFoldingControls",ne[ne.showUnused=100]="showUnused",ne[ne.snippetSuggestions=101]="snippetSuggestions",ne[ne.smartSelect=102]="smartSelect",ne[ne.smoothScrolling=103]="smoothScrolling",ne[ne.stickyTabStops=104]="stickyTabStops",ne[ne.stopRenderingLineAfter=105]="stopRenderingLineAfter",ne[ne.suggest=106]="suggest",ne[ne.suggestFontSize=107]="suggestFontSize",ne[ne.suggestLineHeight=108]="suggestLineHeight",ne[ne.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",ne[ne.suggestSelection=110]="suggestSelection",ne[ne.tabCompletion=111]="tabCompletion",ne[ne.tabIndex=112]="tabIndex",ne[ne.unicodeHighlighting=113]="unicodeHighlighting",ne[ne.unusualLineTerminators=114]="unusualLineTerminators",ne[ne.useShadowDOM=115]="useShadowDOM",ne[ne.useTabStops=116]="useTabStops",ne[ne.wordSeparators=117]="wordSeparators",ne[ne.wordWrap=118]="wordWrap",ne[ne.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",ne[ne.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",ne[ne.wordWrapColumn=121]="wordWrapColumn",ne[ne.wordWrapOverride1=122]="wordWrapOverride1",ne[ne.wordWrapOverride2=123]="wordWrapOverride2",ne[ne.wrappingIndent=124]="wrappingIndent",ne[ne.wrappingStrategy=125]="wrappingStrategy",ne[ne.showDeprecated=126]="showDeprecated",ne[ne.inlayHints=127]="inlayHints",ne[ne.editorClassName=128]="editorClassName",ne[ne.pixelRatio=129]="pixelRatio",ne[ne.tabFocusMode=130]="tabFocusMode",ne[ne.layoutInfo=131]="layoutInfo",ne[ne.wrappingInfo=132]="wrappingInfo"})(it=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new A(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:h.localize(148,null)})),acceptSuggestionOnEnter:Le(new E(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",h.localize(149,null),""],markdownDescription:h.localize(150,null)})),accessibilitySupport:Le(new r),accessibilityPageSize:Le(new a(3,"accessibilityPageSize",10,1,1073741824,{description:h.localize(151,null)})),ariaLabel:Le(new m(4,"ariaLabel",h.localize(152,null))),autoClosingBrackets:Le(new E(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(153,null),h.localize(154,null),""],description:h.localize(155,null)})),autoClosingDelete:Le(new E(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",h.localize(156,null),""],description:h.localize(157,null)})),autoClosingOvertype:Le(new E(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",h.localize(158,null),""],description:h.localize(159,null)})),autoClosingQuotes:Le(new E(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(160,null),h.localize(161,null),""],description:h.localize(162,null)})),autoIndent:Le(new l(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],i,{enumDescriptions:[h.localize(163,null),h.localize(164,null),h.localize(165,null),h.localize(166,null),h.localize(167,null)],description:h.localize(168,null)})),automaticLayout:Le(new A(10,"automaticLayout",!1)),autoSurround:Le(new E(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[h.localize(169,null),h.localize(170,null),h.localize(171,null),""],description:h.localize(172,null)})),bracketPairColorization:Le(new j),bracketPairGuides:Le(new re),stickyTabStops:Le(new A(104,"stickyTabStops",!1,{description:h.localize(173,null)})),codeLens:Le(new A(14,"codeLens",!0,{description:h.localize(174,null)})),codeLensFontFamily:Le(new m(15,"codeLensFontFamily","",{description:h.localize(175,null)})),codeLensFontSize:Le(new a(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:h.localize(176,null)})),colorDecorators:Le(new A(17,"colorDecorators",!0,{description:h.localize(177,null)})),columnSelection:Le(new A(18,"columnSelection",!1,{description:h.localize(178,null)})),comments:Le(new t),contextmenu:Le(new A(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new A(21,"copyWithSyntaxHighlighting",!0,{description:h.localize(179,null)})),cursorBlinking:Le(new l(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],f,{description:h.localize(180,null)})),cursorSmoothCaretAnimation:Le(new A(23,"cursorSmoothCaretAnimation",!1,{description:h.localize(181,null)})),cursorStyle:Le(new l(24,"cursorStyle",u.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:h.localize(182,null)})),cursorSurroundingLines:Le(new a(25,"cursorSurroundingLines",0,0,1073741824,{description:h.localize(183,null)})),cursorSurroundingLinesStyle:Le(new E(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[h.localize(184,null),h.localize(185,null)],description:h.localize(186,null)})),cursorWidth:Le(new a(27,"cursorWidth",0,0,1073741824,{markdownDescription:h.localize(187,null)})),disableLayerHinting:Le(new A(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new A(29,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new A(30,"domReadOnly",!1)),dragAndDrop:Le(new A(31,"dragAndDrop",!0,{description:h.localize(188,null)})),emptySelectionClipboard:Le(new O),extraEditorClassName:Le(new m(33,"extraEditorClassName","")),fastScrollSensitivity:Le(new c(34,"fastScrollSensitivity",5,ne=>ne<=0?5:ne,{markdownDescription:h.localize(189,null)})),find:Le(new y),fixedOverflowWidgets:Le(new A(36,"fixedOverflowWidgets",!1)),folding:Le(new A(37,"folding",!0,{description:h.localize(190,null)})),foldingStrategy:Le(new E(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[h.localize(191,null),h.localize(192,null)],description:h.localize(193,null)})),foldingHighlight:Le(new A(39,"foldingHighlight",!0,{description:h.localize(194,null)})),foldingImportsByDefault:Le(new A(40,"foldingImportsByDefault",!1,{description:h.localize(195,null)})),foldingMaximumRegions:Le(new a(41,"foldingMaximumRegions",5e3,10,65e3,{description:h.localize(196,null)})),unfoldOnClickAfterEndOfLine:Le(new A(42,"unfoldOnClickAfterEndOfLine",!1,{description:h.localize(197,null)})),fontFamily:Le(new m(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:h.localize(198,null)})),fontInfo:Le(new M),fontLigatures2:Le(new z),fontSize:Le(new B),fontWeight:Le(new V),formatOnPaste:Le(new A(48,"formatOnPaste",!1,{description:h.localize(199,null)})),formatOnType:Le(new A(49,"formatOnType",!1,{description:h.localize(200,null)})),glyphMargin:Le(new A(50,"glyphMargin",!0,{description:h.localize(201,null)})),gotoLocation:Le(new Y),hideCursorInOverviewRuler:Le(new A(52,"hideCursorInOverviewRuler",!1,{description:h.localize(202,null)})),hover:Le(new H),inDiffEditor:Le(new A(54,"inDiffEditor",!1)),letterSpacing:Le(new c(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ne=>c.clamp(ne,-5,20),{description:h.localize(203,null)})),lightbulb:Le(new G),lineDecorationsWidth:Le(new d(58,"lineDecorationsWidth",10)),lineHeight:Le(new oe),lineNumbers:Le(new Ne),lineNumbersMinChars:Le(new a(61,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new A(62,"linkedEditing",!1,{description:h.localize(204,null)})),links:Le(new A(63,"links",!0,{description:h.localize(205,null)})),matchBrackets:Le(new E(64,"matchBrackets","always",["always","near","never"],{description:h.localize(206,null)})),minimap:Le(new ue),mouseStyle:Le(new E(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new c(67,"mouseWheelScrollSensitivity",1,ne=>ne===0?1:ne,{markdownDescription:h.localize(207,null)})),mouseWheelZoom:Le(new A(68,"mouseWheelZoom",!1,{markdownDescription:h.localize(208,null)})),multiCursorMergeOverlapping:Le(new A(69,"multiCursorMergeOverlapping",!0,{description:h.localize(209,null)})),multiCursorModifier:Le(new l(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Z,{markdownEnumDescriptions:[h.localize(210,null),h.localize(211,null)],markdownDescription:h.localize(212,null)})),multiCursorPaste:Le(new E(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[h.localize(213,null),h.localize(214,null)],markdownDescription:h.localize(215,null)})),occurrencesHighlight:Le(new A(72,"occurrencesHighlight",!0,{description:h.localize(216,null)})),overviewRulerBorder:Le(new A(73,"overviewRulerBorder",!0,{description:h.localize(217,null)})),overviewRulerLanes:Le(new a(74,"overviewRulerLanes",3,0,3)),padding:Le(new Q),parameterHints:Le(new se),peekWidgetDefaultFocus:Le(new E(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[h.localize(218,null),h.localize(219,null)],description:h.localize(220,null)})),definitionLinkOpensInPeek:Le(new A(78,"definitionLinkOpensInPeek",!1,{description:h.localize(221,null)})),quickSuggestions:Le(new ge),quickSuggestionsDelay:Le(new a(80,"quickSuggestionsDelay",10,0,1073741824,{description:h.localize(222,null)})),readOnly:Le(new A(81,"readOnly",!1)),renameOnType:Le(new A(82,"renameOnType",!1,{description:h.localize(223,null),markdownDeprecationMessage:h.localize(224,null)})),renderControlCharacters:Le(new A(83,"renderControlCharacters",!0,{description:h.localize(225,null),restricted:!0})),renderFinalNewline:Le(new A(84,"renderFinalNewline",!0,{description:h.localize(226,null)})),renderLineHighlight:Le(new E(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",h.localize(227,null)],description:h.localize(228,null)})),renderLineHighlightOnlyWhenFocus:Le(new A(86,"renderLineHighlightOnlyWhenFocus",!1,{description:h.localize(229,null)})),renderValidationDecorations:Le(new E(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new E(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",h.localize(230,null),h.localize(231,null),h.localize(232,null),""],description:h.localize(233,null)})),revealHorizontalRightPadding:Le(new a(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Le(new A(90,"roundedSelection",!0,{description:h.localize(234,null)})),rulers:Le(new Ee),scrollbar:Le(new U),scrollBeyondLastColumn:Le(new a(93,"scrollBeyondLastColumn",5,0,1073741824,{description:h.localize(235,null)})),scrollBeyondLastLine:Le(new A(94,"scrollBeyondLastLine",!0,{description:h.localize(236,null)})),scrollPredominantAxis:Le(new A(95,"scrollPredominantAxis",!0,{description:h.localize(237,null)})),selectionClipboard:Le(new A(96,"selectionClipboard",!0,{description:h.localize(238,null),included:n.isLinux})),selectionHighlight:Le(new A(97,"selectionHighlight",!0,{description:h.localize(239,null)})),selectOnLineNumbers:Le(new A(98,"selectOnLineNumbers",!0)),showFoldingControls:Le(new E(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[h.localize(240,null),h.localize(241,null)],description:h.localize(242,null)})),showUnused:Le(new A(100,"showUnused",!0,{description:h.localize(243,null)})),showDeprecated:Le(new A(126,"showDeprecated",!0,{description:h.localize(244,null)})),inlayHints:Le(new ie),snippetSuggestions:Le(new E(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[h.localize(245,null),h.localize(246,null),h.localize(247,null),h.localize(248,null)],description:h.localize(249,null)})),smartSelect:Le(new Ae),smoothScrolling:Le(new A(103,"smoothScrolling",!1,{description:h.localize(250,null)})),stopRenderingLineAfter:Le(new a(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new Ce),inlineSuggest:Le(new W),suggestFontSize:Le(new a(107,"suggestFontSize",0,0,1e3,{markdownDescription:h.localize(251,null)})),suggestLineHeight:Le(new a(108,"suggestLineHeight",0,0,1e3,{markdownDescription:h.localize(252,null)})),suggestOnTriggerCharacters:Le(new A(109,"suggestOnTriggerCharacters",!0,{description:h.localize(253,null)})),suggestSelection:Le(new E(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[h.localize(254,null),h.localize(255,null),h.localize(256,null)],description:h.localize(257,null)})),tabCompletion:Le(new E(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[h.localize(258,null),h.localize(259,null),h.localize(260,null)],description:h.localize(261,null)})),tabIndex:Le(new a(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new N),unusualLineTerminators:Le(new E(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[h.localize(262,null),h.localize(263,null),h.localize(264,null)],description:h.localize(265,null)})),useShadowDOM:Le(new A(115,"useShadowDOM",!0)),useTabStops:Le(new A(116,"useTabStops",!0,{description:h.localize(266,null)})),wordSeparators:Le(new m(117,"wordSeparators",I.USUAL_WORD_SEPARATORS,{description:h.localize(267,null)})),wordWrap:Le(new E(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[h.localize(268,null),h.localize(269,null),h.localize(270,null),h.localize(271,null)],description:h.localize(272,null)})),wordWrapBreakAfterCharacters:Le(new m(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new m(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new a(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:h.localize(273,null)})),wordWrapOverride1:Le(new E(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new E(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Le(new l(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],qe,{enumDescriptions:[h.localize(274,null),h.localize(275,null),h.localize(276,null),h.localize(277,null)],description:h.localize(278,null)})),wrappingStrategy:Le(new E(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[h.localize(279,null),h.localize(280,null)],description:h.localize(281,null)})),editorClassName:Le(new L),pixelRatio:Le(new de),tabFocusMode:Le(new We),layoutInfo:Le(new K),wrappingInfo:Le(new He)}}),define(ve[159],we([19,20]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ve[160],we([19,20]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ve[161],we([19,20]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(ve[162],we([19,20]),function(ee,e){return ee.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ve[163],we([19,20]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(ve[164],we([19,20]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(ve[165],we([19,20]),function(ee,e){return ee.create("vs/platform/workspace/common/workspace",e)}),define(ve[166],we([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ve[167],we([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ve[168],we([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(ve[169],we([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ve[170],we([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ve[171],we([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ve[172],we([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ve[173],we([19,20]),function(ee,e){return ee.create("vs/workbench/api/node/extHostDebugService",e)}),define(ve[174],we([19,20]),function(ee,e){return ee.create("vs/workbench/api/node/extHostTunnelService",e)}),define(ve[175],we([19,20]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(ve[176],we([19,20]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ve[177],we([19,20]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/debug",e)}),define(ve[178],we([19,20]),function(ee,e){return ee.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ve[179],we([19,20]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ve[180],we([19,20]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ve[181],we([19,20]),function(ee,e){return ee.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ve[182],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var h;(function(k){k[k.ACTIVATE=1]="ACTIVATE",k[k.RESTORE=2]="RESTORE",k[k.PRESERVE=3]="PRESERVE"})(h=e.EditorActivation||(e.EditorActivation={}));var n;(function(k){k[k.PICK=0]="PICK",k[k.DISABLED=1]="DISABLED",k[k.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(n=e.EditorResolution||(e.EditorResolution={}));var I;(function(k){k[k.API=0]="API",k[k.USER=1]="USER"})(I=e.EditorOpenSource||(e.EditorOpenSource={}));var T;(function(k){k[k.Center=0]="Center",k[k.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",k[k.NearTop=2]="NearTop",k[k.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var C;(function(k){k.PROGRAMMATIC="api",k.NAVIGATION="code.navigation",k.JUMP="code.jump"})(C=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),define(ve[183],we([1,0,161]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const n=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function T(p){return p=p.trim(),p==="*"||n.test(p)}e.isValidVersionStr=T;function C(p){if(!T(p))return null;if(p=p.trim(),p==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let _=p.match(n);return _?{hasCaret:_[1]==="^",hasGreaterEquals:_[1]===">=",majorBase:_[2]==="x"?0:parseInt(_[2],10),majorMustEqual:_[2]!=="x",minorBase:_[4]==="x"?0:parseInt(_[4],10),minorMustEqual:_[4]!=="x",patchBase:_[6]==="x"?0:parseInt(_[6],10),patchMustEqual:_[6]!=="x",preRelease:_[8]||null}:null}e.parseVersion=C;function k(p){if(!p)return null;let _=p.majorBase,g=p.majorMustEqual,d=p.minorBase,v=p.minorMustEqual,A=p.patchBase,b=p.patchMustEqual;p.hasCaret&&(_===0||(v=!1),b=!1);let a=0;if(p.preRelease){const c=I.exec(p.preRelease);if(c){const[,m,s,E]=c;a=Date.UTC(Number(m),Number(s)-1,Number(E))}}return{majorBase:_,majorMustEqual:g,minorBase:d,minorMustEqual:v,patchBase:A,patchMustEqual:b,isMinimum:p.hasGreaterEquals,notBefore:a}}e.normalizeVersion=k;function S(p,_,g){let d;typeof p=="string"?d=k(C(p)):d=p;let v;_ instanceof Date?v=_.getTime():typeof _=="string"&&(v=new Date(_).getTime());let A;if(typeof g=="string"?A=k(C(g)):A=g,!d||!A)return!1;let b=d.majorBase,a=d.minorBase,c=d.patchBase,m=A.majorBase,s=A.minorBase,E=A.patchBase,l=A.notBefore,i=A.majorMustEqual,r=A.minorMustEqual,t=A.patchMustEqual;return A.isMinimum?b>m?!0:b<m?!1:a>s?!0:a<s||v&&v<l?!1:c>=E:(b===1&&m===0&&(!i||!r||!t)&&(m=1,s=0,E=0,i=!0,r=!1,t=!1),b<m?!1:b>m?!i:a<s?!1:a>s?!r:c<E?!1:c>E?!t:!(v&&v<l))}e.isValidVersion=S;function R(p,_,g,d){return g.isBuiltin||typeof g.main=="undefined"?!0:D(p,_,g.engines.vscode,d)}e.isValidExtensionVersion=R;function F(p,_,g){return p==="*"||D(_,g,p)}e.isEngineValid=F;function D(p,_,g,d=[]){let v=k(C(g));if(!v)return d.push(h.localize(0,null,g)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return d.push(h.localize(1,null,g)),!1}else if(!v.majorMustEqual)return d.push(h.localize(2,null,g)),!1;return S(p,_,v)?!0:(d.push(h.localize(3,null,p,g)),!1)}}),define(ve[114],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class h{constructor(I,T=[],C=!1){this.ctor=I,this.staticArguments=T,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=h}),define(ve[79],we([1,0,114]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const n=[];function I(C,k,S){k instanceof h.SyncDescriptor||(k=new h.SyncDescriptor(k,[],S)),n.push([C,k])}e.registerSingleton=I;function T(){return n}e.getSingletonServiceDescriptors=T}),define(ve[184],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class h{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=h;class n{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let C of this._nodes.values())C.outgoing.size===0&&T.push(C);return T}insertEdge(T,C){const k=this.lookupOrInsertNode(T),S=this.lookupOrInsertNode(C);k.outgoing.set(this._hashFn(C),S),S.incoming.set(this._hashFn(T),k)}removeNode(T){const C=this._hashFn(T);this._nodes.delete(C);for(let k of this._nodes.values())k.outgoing.delete(C),k.incoming.delete(C)}lookupOrInsertNode(T){const C=this._hashFn(T);let k=this._nodes.get(C);return k||(k=new h(T),this._nodes.set(C,k)),k}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[C,k]of this._nodes)T.push(`${C}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,C]of this._nodes){const k=new Set([T]),S=this._findCycle(C,k);if(S)return S}}_findCycle(T,C){for(let[k,S]of T.outgoing){if(C.has(k))return[...C,k].join(" -> ");C.add(k);const R=this._findCycle(S,C);if(R)return R;C.delete(k)}}}e.Graph=n}),define(ve[4],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var h;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function k(S){return S[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=k})(h=e._util||(e._util={})),e.IInstantiationService=I("instantiationService");function n(C,k,S){k[h.DI_TARGET]===k?k[h.DI_DEPENDENCIES].push({id:C,index:S}):(k[h.DI_DEPENDENCIES]=[{id:C,index:S}],k[h.DI_TARGET]=k)}function I(C){if(h.serviceIds.has(C))return h.serviceIds.get(C);const k=function(S,R,F){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(k,S,F)};return k.toString=()=>C,h.serviceIds.set(C,k),k}e.createDecorator=I;function T(C){return C}e.refineServiceDecorator=T}),define(ve[115],we([1,0,13,2,4]),function(ee,e,h,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function T(v){return v&&typeof v=="object"&&(!v.overrideIdentifier||typeof v.overrideIdentifier=="string")&&(!v.resource||v.resource instanceof n.URI)}e.isConfigurationOverrides=T;function C(v){return v&&typeof v=="object"&&(!v.overrideIdentifiers||h.isArray(v.overrideIdentifiers))&&!v.overrideIdentifier&&(!v.resource||v.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=C;var k;(function(v){v[v.USER=1]="USER",v[v.USER_LOCAL=2]="USER_LOCAL",v[v.USER_REMOTE=3]="USER_REMOTE",v[v.WORKSPACE=4]="WORKSPACE",v[v.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",v[v.DEFAULT=6]="DEFAULT",v[v.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function S(v){switch(v){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=S;function R(v,A){const b=Object.create(null);for(let a in v)F(b,a,v[a],A);return b}e.toValuesTree=R;function F(v,A,b,a){const c=A.split("."),m=c.pop();let s=v;for(let E=0;E<c.length;E++){let l=c[E],i=s[l];switch(typeof i){case"undefined":i=s[l]=Object.create(null);break;case"object":break;default:a(`Ignoring ${A} as ${c.slice(0,E+1).join(".")} is ${JSON.stringify(i)}`);return}s=i}if(typeof s=="object"&&s!==null)try{s[m]=b}catch{a(`Ignoring ${A} as ${c.join(".")} is ${JSON.stringify(s)}`)}else a(`Ignoring ${A} as ${c.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=F;function D(v,A){const b=A.split(".");p(v,b)}e.removeFromValueTree=D;function p(v,A){const b=A.shift();if(A.length===0){delete v[b];return}if(Object.keys(v).indexOf(b)!==-1){const a=v[b];typeof a=="object"&&!Array.isArray(a)&&(p(a,A),Object.keys(a).length===0&&delete v[b])}}function _(v,A,b){function a(s,E){let l=s;for(const i of E){if(typeof l!="object"||l===null)return;l=l[i]}return l}const c=A.split("."),m=a(v,c);return typeof m=="undefined"?b:m}e.getConfigurationValue=_;function g(v,A,b){Object.keys(A).forEach(a=>{a!=="__proto__"&&(a in v?h.isObject(v[a])&&h.isObject(A[a])?g(v[a],A[a],b):b&&(v[a]=A[a]):v[a]=A[a])})}e.merge=g;function d(v,A,b){const a=v.inspect(A),c=v.inspect(b);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:a.defaultValue}e.getMigratedSettingValue=d}),define(ve[61],we([1,0,12,8,4]),function(ee,e,h,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",h.isMacintosh),T.set("isLinux",h.isLinux),T.set("isWindows",h.isWindows),T.set("isWeb",h.isWeb),T.set("isMacNative",h.isMacintosh&&!h.isWeb),T.set("isEdge",h.isEdge),T.set("isFirefox",h.isFirefox),T.set("isChrome",h.isChrome),T.set("isSafari",h.isSafari);const C=Object.prototype.hasOwnProperty;var k;(function(O){O[O.False=0]="False",O[O.True=1]="True",O[O.Defined=2]="Defined",O[O.Not=3]="Not",O[O.Equals=4]="Equals",O[O.NotEquals=5]="NotEquals",O[O.And=6]="And",O[O.Regex=7]="Regex",O[O.NotRegex=8]="NotRegex",O[O.Or=9]="Or",O[O.In=10]="In",O[O.NotIn=11]="NotIn",O[O.Greater=12]="Greater",O[O.GreaterEquals=13]="GreaterEquals",O[O.Smaller=14]="Smaller",O[O.SmallerEquals=15]="SmallerEquals"})(k=e.ContextKeyExprType||(e.ContextKeyExprType={}));class S{static false(){return D.INSTANCE}static true(){return p.INSTANCE}static has(y){return _.create(y)}static equals(y,z){return g.create(y,z)}static notEquals(y,z){return A.create(y,z)}static regex(y,z){return l.create(y,z)}static in(y,z){return d.create(y,z)}static not(y){return b.create(y)}static and(...y){return t.create(y,null)}static or(...y){return o.create(y,null,!0)}static greater(y,z){return c.create(y,z)}static greaterEquals(y,z){return m.create(y,z)}static smaller(y,z){return s.create(y,z)}static smallerEquals(y,z){return E.create(y,z)}static deserialize(y,z=!1){if(!!y)return this._deserializeOrExpression(y,z)}static _deserializeOrExpression(y,z){let M=y.split("||");return o.create(M.map(B=>this._deserializeAndExpression(B,z)),null,!0)}static _deserializeAndExpression(y,z){let M=y.split("&&");return t.create(M.map(B=>this._deserializeOne(B,z)),null)}static _deserializeOne(y,z){if(y=y.trim(),y.indexOf("!=")>=0){let M=y.split("!=");return A.create(M[0].trim(),this._deserializeValue(M[1],z))}if(y.indexOf("==")>=0){let M=y.split("==");return g.create(M[0].trim(),this._deserializeValue(M[1],z))}if(y.indexOf("=~")>=0){let M=y.split("=~");return l.create(M[0].trim(),this._deserializeRegexValue(M[1],z))}if(y.indexOf(" in ")>=0){let M=y.split(" in ");return d.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(y)){const M=y.split(">=");return m.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(y)){const M=y.split(">");return c.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(y)){const M=y.split("<=");return E.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(y)){const M=y.split("<");return s.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(y)?b.create(y.substr(1).trim()):_.create(y)}static _deserializeValue(y,z){if(y=y.trim(),y==="true")return!0;if(y==="false")return!1;let M=/^'([^']*)'$/.exec(y);return M?M[1].trim():y}static _deserializeRegexValue(y,z){if((0,n.isFalsyOrWhitespace)(y)){if(z)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=y.indexOf("/"),B=y.lastIndexOf("/");if(M===B||M<0){if(z)throw new Error(`bad regexp-value '${y}', missing /-enclosure`);return console.warn(`bad regexp-value '${y}', missing /-enclosure`),null}let V=y.slice(M+1,B),Y=y[B+1]==="i"?"i":"";try{return new RegExp(V,Y)}catch(H){if(z)throw new Error(`bad regexp-value '${y}', parse error: ${H}`);return console.warn(`bad regexp-value '${y}', parse error: ${H}`),null}}}e.ContextKeyExpr=S;function R(O,y){const z=O?O.substituteConstants():void 0,M=y?y.substituteConstants():void 0;return!z&&!M?!0:!z||!M?!1:z.equals(M)}e.expressionsAreEqualWithConstantSubstitution=R;function F(O,y){return O.cmp(y)}class D{constructor(){this.type=0}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}substituteConstants(){return this}evaluate(y){return!1}serialize(){return"false"}keys(){return[]}map(y){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=D,D.INSTANCE=new D;class p{constructor(){this.type=1}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}substituteConstants(){return this}evaluate(y){return!0}serialize(){return"true"}keys(){return[]}map(y){return this}negate(){return D.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class _{constructor(y,z){this.key=y,this.negated=z,this.type=2}static create(y,z=null){const M=T.get(y);return typeof M=="boolean"?M?p.INSTANCE:D.INSTANCE:new _(y,z)}cmp(y){return y.type!==this.type?this.type-y.type:u(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}substituteConstants(){const y=T.get(this.key);return typeof y=="boolean"?y?p.INSTANCE:D.INSTANCE:this}evaluate(y){return!!y.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(y){return y.mapDefined(this.key)}negate(){return this.negated||(this.negated=b.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=_;class g{constructor(y,z,M){this.key=y,this.value=z,this.negated=M,this.type=4}static create(y,z,M=null){if(typeof z=="boolean")return z?_.create(y,M):b.create(y,M);const B=T.get(y);return typeof B=="boolean"?z===(B?"true":"false")?p.INSTANCE:D.INSTANCE:new g(y,z,M)}cmp(y){return y.type!==this.type?this.type-y.type:w(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){const y=T.get(this.key);if(typeof y=="boolean"){const z=y?"true":"false";return this.value===z?p.INSTANCE:D.INSTANCE}return this}evaluate(y){return y.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(y){return y.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=A.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=g;class d{constructor(y,z){this.key=y,this.valueKey=z,this.type=10,this.negated=null}static create(y,z){return new d(y,z)}cmp(y){return y.type!==this.type?this.type-y.type:w(this.key,this.valueKey,y.key,y.valueKey)}equals(y){return y.type===this.type?this.key===y.key&&this.valueKey===y.valueKey:!1}substituteConstants(){return this}evaluate(y){const z=y.getValue(this.valueKey),M=y.getValue(this.key);return Array.isArray(z)?z.indexOf(M)>=0:typeof M=="string"&&typeof z=="object"&&z!==null?C.call(z,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(y){return y.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=v.create(this)),this.negated}}e.ContextKeyInExpr=d;class v{constructor(y){this._actual=y,this.type=11}static create(y){return new v(y)}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}substituteConstants(){return this}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new v(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotInExpr=v;class A{constructor(y,z,M){this.key=y,this.value=z,this.negated=M,this.type=5}static create(y,z,M=null){if(typeof z=="boolean")return z?b.create(y,M):_.create(y,M);const B=T.get(y);return typeof B=="boolean"?z===(B?"true":"false")?D.INSTANCE:p.INSTANCE:new A(y,z,M)}cmp(y){return y.type!==this.type?this.type-y.type:w(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){const y=T.get(this.key);if(typeof y=="boolean"){const z=y?"true":"false";return this.value===z?D.INSTANCE:p.INSTANCE}return this}evaluate(y){return y.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(y){return y.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=g.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=A;class b{constructor(y,z){this.key=y,this.negated=z,this.type=3}static create(y,z=null){const M=T.get(y);return typeof M=="boolean"?M?D.INSTANCE:p.INSTANCE:new b(y,z)}cmp(y){return y.type!==this.type?this.type-y.type:u(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}substituteConstants(){const y=T.get(this.key);return typeof y=="boolean"?y?D.INSTANCE:p.INSTANCE:this}evaluate(y){return!y.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(y){return y.mapNot(this.key)}negate(){return this.negated||(this.negated=_.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=b;function a(O,y){if(typeof O=="string"){const z=parseFloat(O);isNaN(z)||(O=z)}return typeof O=="string"||typeof O=="number"?y(O):D.INSTANCE}class c{constructor(y,z,M){this.key=y,this.value=z,this.negated=M,this.type=12}static create(y,z,M=null){return a(z,B=>new c(y,B,M))}cmp(y){return y.type!==this.type?this.type-y.type:w(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=c;class m{constructor(y,z,M){this.key=y,this.value=z,this.negated=M,this.type=13}static create(y,z,M=null){return a(z,B=>new m(y,B,M))}cmp(y){return y.type!==this.type?this.type-y.type:w(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=m;class s{constructor(y,z,M){this.key=y,this.value=z,this.negated=M,this.type=14}static create(y,z,M=null){return a(z,B=>new s(y,B,M))}cmp(y){return y.type!==this.type?this.type-y.type:w(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=s;class E{constructor(y,z,M){this.key=y,this.value=z,this.negated=M,this.type=15}static create(y,z,M=null){return a(z,B=>new E(y,B,M))}cmp(y){return y.type!==this.type?this.type-y.type:w(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=E;class l{constructor(y,z){this.key=y,this.regexp=z,this.type=7,this.negated=null}static create(y,z){return new l(y,z)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.key<y.key)return-1;if(this.key>y.key)return 1;const z=this.regexp?this.regexp.source:"",M=y.regexp?y.regexp.source:"";return z<M?-1:z>M?1:0}equals(y){if(y.type===this.type){const z=this.regexp?this.regexp.source:"",M=y.regexp?y.regexp.source:"";return this.key===y.key&&z===M}return!1}substituteConstants(){return this}evaluate(y){let z=y.getValue(this.key);return this.regexp?this.regexp.test(z):!1}serialize(){const y=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${y}`}keys(){return[this.key]}map(y){return y.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=l;class i{constructor(y){this._actual=y,this.type=8}static create(y){return new i(y)}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}substituteConstants(){return this}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new i(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function r(O){let y=null;for(let z=0,M=O.length;z<M;z++){const B=O[z].substituteConstants();if(O[z]!==B&&y===null){y=[];for(let V=0;V<z;V++)y[V]=O[V]}y!==null&&(y[z]=B)}return y===null?O:y}class t{constructor(y,z){this.expr=y,this.negated=z,this.type=6}static create(y,z){return t._normalizeArr(y,z)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let z=0,M=this.expr.length;z<M;z++){const B=F(this.expr[z],y.expr[z]);if(B!==0)return B}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let z=0,M=this.expr.length;z<M;z++)if(!this.expr[z].equals(y.expr[z]))return!1;return!0}return!1}substituteConstants(){const y=r(this.expr);return y===this.expr?this:t.create(y,this.negated)}evaluate(y){for(let z=0,M=this.expr.length;z<M;z++)if(!this.expr[z].evaluate(y))return!1;return!0}static _normalizeArr(y,z){const M=[];let B=!1;for(const V of y)if(!!V){if(V.type===1){B=!0;continue}if(V.type===0)return D.INSTANCE;if(V.type===6){M.push(...V.expr);continue}M.push(V)}if(M.length===0&&B)return p.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(F);for(let V=1;V<M.length;V++)M[V-1].equals(M[V])&&(M.splice(V,1),V--);if(M.length===1)return M[0];for(;M.length>1;){const V=M[M.length-1];if(V.type!==9)break;M.pop();const Y=M.pop(),H=M.length===0,q=o.create(V.expr.map(K=>t.create([K,Y],null)),null,H);q&&(M.push(q),M.sort(F))}return M.length===1?M[0]:new t(M,z)}}serialize(){return this.expr.map(y=>y.serialize()).join(" && ")}keys(){const y=[];for(let z of this.expr)y.push(...z.keys());return y}map(y){return new t(this.expr.map(z=>z.map(y)),null)}negate(){if(!this.negated){const y=[];for(let z of this.expr)y.push(z.negate());this.negated=o.create(y,this,!0)}return this.negated}}class o{constructor(y,z){this.expr=y,this.negated=z,this.type=9}static create(y,z,M){return o._normalizeArr(y,z,M)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let z=0,M=this.expr.length;z<M;z++){const B=F(this.expr[z],y.expr[z]);if(B!==0)return B}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let z=0,M=this.expr.length;z<M;z++)if(!this.expr[z].equals(y.expr[z]))return!1;return!0}return!1}substituteConstants(){const y=r(this.expr);return y===this.expr?this:o.create(y,this.negated,!1)}evaluate(y){for(let z=0,M=this.expr.length;z<M;z++)if(this.expr[z].evaluate(y))return!0;return!1}static _normalizeArr(y,z,M){let B=[],V=!1;if(y){for(let Y=0,H=y.length;Y<H;Y++){const q=y[Y];if(!!q){if(q.type===0){V=!0;continue}if(q.type===1)return p.INSTANCE;if(q.type===9){B=B.concat(q.expr);continue}B.push(q)}}if(B.length===0&&V)return D.INSTANCE;B.sort(F)}if(B.length!==0){if(B.length===1)return B[0];for(let Y=1;Y<B.length;Y++)B[Y-1].equals(B[Y])&&(B.splice(Y,1),Y--);if(B.length===1)return B[0];if(M){for(let Y=0;Y<B.length;Y++)for(let H=Y+1;H<B.length;H++)P(B[Y],B[H])&&(B.splice(H,1),H--);if(B.length===1)return B[0]}return new o(B,z)}}serialize(){return this.expr.map(y=>y.serialize()).join(" || ")}keys(){const y=[];for(let z of this.expr)y.push(...z.keys());return y}map(y){return new o(this.expr.map(z=>z.map(y)),null)}negate(){if(!this.negated){let y=[];for(let z of this.expr)y.push(z.negate());for(;y.length>1;){const z=y.shift(),M=y.shift(),B=[];for(const Y of L(z))for(const H of L(M))B.push(t.create([Y,H],null));const V=y.length===0;y.unshift(o.create(B,null,V))}this.negated=y[0]}return this.negated}}class f extends _{constructor(y,z,M){super(y,null);this._defaultValue=z,typeof M=="object"?f._info.push({...M,key:y}):M!==!0&&f._info.push({key:y,description:M,type:z!=null?typeof z:void 0})}static all(){return f._info.values()}bindTo(y){return y.createKey(this.key,this._defaultValue)}getValue(y){return y.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(y){return g.create(this.key,y)}notEqualsTo(y){return A.create(this.key,y)}}e.RawContextKey=f,f._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function u(O,y){return O<y?-1:O>y?1:0}function w(O,y,z,M){return O<z?-1:O>z?1:y<M?-1:y>M?1:0}function P(O,y){if(y.type===6&&O.type!==9&&O.type!==6){for(const B of y.expr)if(O.equals(B))return!0}const z=O.negate(),M=L(z).concat(L(y));M.sort(F);for(let B=0;B<M.length;B++){const Y=M[B].negate();for(let H=B+1;H<M.length;H++){const q=M[H];if(Y.equals(q))return!0}}return!1}e.implies=P;function L(O){return O.type===9?O.expr:[O]}}),define(ve[185],we([1,0,4]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,h.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,h.refineServiceDecorator)(e.IEnvironmentService)}),define(ve[186],we([1,0,4]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,h.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,h.createDecorator)("externalTerminal")}),define(ve[187],we([1,0,38,10,9,12,93,28,112,162,186]),function(ee,e,h,n,I,T,C,k,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const D=R.localize(0,null);class p{async getDefaultTerminalForPlatforms(){return{windows:_.getDefaultTerminalWindows(),linux:await d.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class _ extends p{openTerminal(c,m){return this.spawnTerminal(h,c,S.getWindowsShell(),m)}spawnTerminal(c,m,s,E){const l=m.windowsExec||_.getDefaultTerminalWindows();E&&E[1]===":"&&(E=E[0].toUpperCase()+E.substr(1));const i=I.basename(l).toLowerCase();if(i==="cmder"||i==="cmder.exe")return c.spawn(l,E?[E]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return l.indexOf(" ")>=0&&r.push('""'),r.push(l),(i==="wt"||i==="wt.exe")&&r.push("-d ."),new Promise((t,o)=>{const f=v(process),u=c.spawn(s,r,{cwd:E,env:f});u.on("error",o),u.on("exit",()=>t())})}runInTerminal(c,m,s,E,l){const i="windowsExec"in l&&l.windowsExec?l.windowsExec:_.getDefaultTerminalWindows();return new Promise((r,t)=>{const o=`"${m} - ${D}"`,f=`""${s.join('" "')}" & pause"`,u=["/c","start",o,"/wait",i,"/c",f],w=Object.assign({},v(process),E);Object.keys(w).filter(O=>w[O]===null).forEach(O=>delete w[O]);const P={cwd:m,env:w,windowsVerbatimArguments:!0};h.spawn(_.CMD,u,P).on("error",O=>{t(A(O))}),r(void 0)})}static getDefaultTerminalWindows(){if(!_._DEFAULT_TERMINAL_WINDOWS){const c=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");_._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${c?"Sysnative":"System32"}\\cmd.exe`}return _._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=_,_.CMD="cmd.exe";class g extends p{openTerminal(c,m){return this.spawnTerminal(h,c,m)}runInTerminal(c,m,s,E,l){const i=l.osxExec||F.DEFAULT_TERMINAL_OSX;return new Promise((r,t)=>{if(i===F.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const o=i===F.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",u=[n.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${o}.scpt`,ee).fsPath,"-t",c||D,"-w",m];for(let L of s)u.push("-a"),u.push(L);if(E){const L=Object.assign({},v(process),E);for(let O in L){const y=L[O];y===null?(u.push("-u"),u.push(O)):(u.push("-e"),u.push(`${O}=${y}`))}}let w="";const P=h.spawn(g.OSASCRIPT,u);P.on("error",L=>{t(A(L))}),P.stderr.on("data",L=>{w+=L.toString()}),P.on("exit",L=>{if(L===0)r(void 0);else if(w){const O=w.split(`
`,1);t(new Error(O[0]))}else t(new Error(R.localize(1,null,o,L)))})}else t(new Error(R.localize(2,null,i)))})}spawnTerminal(c,m,s){const E=m.osxExec||F.DEFAULT_TERMINAL_OSX;return new Promise((l,i)=>{const r=["-a",E];s&&r.push(s);const t=v(process),o=c.spawn("/usr/bin/open",r,{cwd:s,env:t});o.on("error",i),o.on("exit",()=>l())})}}e.MacExternalTerminalService=g,g.OSASCRIPT="/usr/bin/osascript";class d extends p{openTerminal(c,m){return this.spawnTerminal(h,c,m)}runInTerminal(c,m,s,E,l){const i=l.linuxExec?Promise.resolve(l.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((r,t)=>{let o=[];i.then(f=>{f.indexOf("gnome-terminal")>=0?o.push("-x"):o.push("-e"),o.push("bash"),o.push("-c");const u=`${b(s)}; echo; read -p "${d.WAIT_MESSAGE}" -n1;`;o.push(`''${u}''`);const w=Object.assign({},v(process),E);Object.keys(w).filter(y=>w[y]===null).forEach(y=>delete w[y]);const P={cwd:m,env:w};let L="";const O=h.spawn(f,o,P);O.on("error",y=>{t(A(y))}),O.stderr.on("data",y=>{L+=y.toString()}),O.on("exit",y=>{if(y===0)r(void 0);else if(L){const z=L.split(`
`,1);t(new Error(z[0]))}else t(new Error(R.localize(4,null,f,y)))})})})}static async getDefaultTerminalLinuxReady(){if(!d._DEFAULT_TERMINAL_LINUX_READY)if(!T.isLinux)d._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const c=await k.Promises.exists("/etc/debian_version");d._DEFAULT_TERMINAL_LINUX_READY=new Promise(m=>{c?m("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?m("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?m("konsole"):process.env.COLORTERM?m(process.env.COLORTERM):process.env.TERM?m(process.env.TERM):m("xterm")})}return d._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(c,m,s){const E=m.linuxExec?Promise.resolve(m.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((l,i)=>{E.then(r=>{const t=v(process),o=c.spawn(r,[],{cwd:s,env:t});o.on("error",i),o.on("exit",()=>l())})})}}e.LinuxExternalTerminalService=d,d.WAIT_MESSAGE=R.localize(3,null);function v(a){const c={...a.env};return(0,C.sanitizeProcessEnvironment)(c),c}function A(a){return"errno"in a&&a.errno==="ENOENT"&&"path"in a&&typeof a.path=="string"?new Error(R.localize(5,null,a.path)):a}function b(a){let c="";for(let m of a)m.indexOf(" ")>=0?c+='"'+m+'"':c+=m,c+=" ";return c}}),define(ve[42],we([1,0,24,9,8,13,2,163,4]),function(ee,e,h,n,I,T,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function R(V){return V.create===!0}e.isFileOpenForWriteOptions=R;var F;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(F=e.FileType||(e.FileType={}));var D;(function(V){V[V.Readonly=1]="Readonly"})(D=e.FilePermission||(e.FilePermission={}));var p;(function(V){V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead"})(p=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function _(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=_;function g(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=g;function d(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function v(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=v;function A(V){return _(V)?!!(V.capabilities&16384):!1}e.hasFileAtomicReadCapability=A;var b;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class a extends Error{constructor(Y,H){super(Y);this.code=H}}e.FileSystemProviderError=a;function c(V,Y){const H=new a(V.toString(),Y);return s(H,Y),H}e.createFileSystemProviderError=c;function m(V){return V||c((0,k.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=m;function s(V,Y){return V.name=Y?`${Y} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=s;function E(V){if(!V)return b.Unknown;if(V instanceof a)return V.code;const Y=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!Y)return b.Unknown;switch(Y[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=E;function l(V){if(V instanceof u)return V.fileOperationResult;switch(E(V)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=l;var i;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(i=e.FileOperation||(e.FileOperation={}));class r{constructor(Y,H,q){this.resource=Y,this.operation=H,this.target=q}isOperation(Y){return this.operation===Y}}e.FileOperationEvent=r;var t;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(t=e.FileChangeType||(e.FileChangeType={}));class o{constructor(Y,H){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=Y;const q=new Map;for(const K of Y){const G=q.get(K.type);switch(G?G.push([K.resource,K]):q.set(K.type,[[K.resource,K]]),K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}}for(const[K,G]of q)switch(K){case 1:this.added=h.TernarySearchTree.forUris(()=>H),this.added.fill(G);break;case 0:this.updated=h.TernarySearchTree.forUris(()=>H),this.updated.fill(G);break;case 2:this.deleted=h.TernarySearchTree.forUris(()=>H),this.deleted.fill(G);break}}contains(Y,...H){return this.doContains(Y,{includeChildren:!1},...H)}affects(Y,...H){return this.doContains(Y,{includeChildren:!0},...H)}doContains(Y,H,...q){if(!Y)return!1;const K=q.length>0;return!!((!K||q.includes(1))&&(this.added?.get(Y)||H.includeChildren&&this.added?.findSuperstr(Y))||(!K||q.includes(0))&&(this.updated?.get(Y)||H.includeChildren&&this.updated?.findSuperstr(Y))||(!K||q.includes(2))&&(this.deleted?.findSubstr(Y)||H.includeChildren&&this.deleted?.findSuperstr(Y)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=o;function f(V,Y,H){return!V||!Y||V===Y||Y.length>V.length?!1:(Y.charAt(Y.length-1)!==n.sep&&(Y+=n.sep),H?(0,I.startsWithIgnoreCase)(V,Y):V.indexOf(Y)===0)}e.isParent=f;class u extends Error{constructor(Y,H,q){super(Y);this.fileOperationResult=H,this.options=q}}e.FileOperationError=u;class w extends u{constructor(Y,H,q){super(Y,2,q);this.stat=H}}e.NotModifiedSinceFileOperationError=w;var P;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(P=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var L;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(L=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=O;async function y(V,Y){if(!Y.hasProvider(C.URI.from({scheme:V.scheme})))return new Promise(H=>{const q=Y.onDidChangeFileSystemProviderRegistrations(K=>{K.scheme===V.scheme&&K.added&&(q.dispose(),H())})})}e.whenProviderRegistered=y,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class z{static formatSize(Y){return(0,T.isNumber)(Y)||(Y=0),Y<z.KB?(0,k.localize)(1,null,Y.toFixed(0)):Y<z.MB?(0,k.localize)(2,null,(Y/z.KB).toFixed(2)):Y<z.GB?(0,k.localize)(3,null,(Y/z.MB).toFixed(2)):Y<z.TB?(0,k.localize)(4,null,(Y/z.GB).toFixed(2)):(0,k.localize)(5,null,(Y/z.TB).toFixed(2))}}e.ByteSize=z,z.KB=1024,z.MB=z.KB*z.KB,z.GB=z.MB*z.KB,z.TB=z.GB*z.KB;var M;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(M=e.Arch||(e.Arch={}));function B(V){return{maxFileSize:V===0?300*z.MB:16*z.GB,maxHeapSize:V===0?700*z.MB:2*700*z.MB}}e.getPlatformLimits=B}),define(ve[80],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class h{constructor(...I){this._entries=new Map;for(let[T,C]of I)this.set(T,C)}set(I,T){const C=this._entries.get(I);return this._entries.set(I,T),C}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=h}),define(ve[188],we([1,0,15,17,114,184,4,80]),function(ee,e,h,n,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const S=!1;class R extends Error{constructor(g){super("cyclic dependency between services");this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class F{constructor(g=new k.ServiceCollection,d=!1,v){this._activeInstantiations=new Set,this._services=g,this._strict=d,this._parent=v,this._services.set(C.IInstantiationService,this)}createChild(g){return new F(g,this._strict,this)}invokeFunction(g,...d){let v=p.traceInvocation(g),A=!1;try{return g({get:a=>{if(A)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(a,v);if(!c)throw new Error(`[invokeFunction] unknown service '${a}'`);return c}},...d)}finally{A=!0,v.stop()}}createInstance(g,...d){let v,A;return g instanceof I.SyncDescriptor?(v=p.traceCreation(g.ctor),A=this._createInstance(g.ctor,g.staticArguments.concat(d),v)):(v=p.traceCreation(g),A=this._createInstance(g,d,v)),v.stop(),A}_createInstance(g,d=[],v){let A=C._util.getServiceDependencies(g).sort((c,m)=>c.index-m.index),b=[];for(const c of A){let m=this._getOrCreateServiceInstance(c.id,v);m||this._throwIfStrict(`[createInstance] ${g.name} depends on UNKNOWN service ${c.id}.`,!1),b.push(m)}let a=A.length>0?A[0].index:d.length;if(d.length!==a){console.warn(`[createInstance] First service dependency of ${g.name} at position ${a+1} conflicts with ${d.length} static arguments`);let c=a-d.length;c>0?d=d.concat(new Array(c)):d=d.slice(0,a)}return new g(...[...d,...b])}_setServiceInstance(g,d){if(this._services.get(g)instanceof I.SyncDescriptor)this._services.set(g,d);else if(this._parent)this._parent._setServiceInstance(g,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(g){let d=this._services.get(g);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(g):d}_getOrCreateServiceInstance(g,d){let v=this._getServiceInstanceOrDescriptor(g);return v instanceof I.SyncDescriptor?this._safeCreateAndCacheServiceInstance(g,v,d.branch(g,!0)):(d.branch(g,!1),v)}_safeCreateAndCacheServiceInstance(g,d,v){if(this._activeInstantiations.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this._activeInstantiations.add(g);try{return this._createAndCacheServiceInstance(g,d,v)}finally{this._activeInstantiations.delete(g)}}_createAndCacheServiceInstance(g,d,v){const A=new T.Graph(c=>c.id.toString());let b=0;const a=[{id:g,desc:d,_trace:v}];for(;a.length;){const c=a.pop();if(A.lookupOrInsertNode(c),b++>1e3)throw new R(A);for(let m of C._util.getServiceDependencies(c.desc.ctor)){let s=this._getServiceInstanceOrDescriptor(m.id);if(s||this._throwIfStrict(`[createInstance] ${g} depends on ${m.id} which is NOT registered.`,!0),s instanceof I.SyncDescriptor){const E={id:m.id,desc:s,_trace:c._trace.branch(m.id,!0)};A.insertEdge(c,E),a.push(E)}}}for(;;){const c=A.roots();if(c.length===0){if(!A.isEmpty())throw new R(A);break}for(const{data:m}of c){if(this._getServiceInstanceOrDescriptor(m.id)instanceof I.SyncDescriptor){const E=this._createServiceInstanceWithOwner(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this._setServiceInstance(m.id,E)}A.removeNode(m)}}return this._getServiceInstanceOrDescriptor(g)}_createServiceInstanceWithOwner(g,d,v=[],A,b){if(this._services.get(g)instanceof I.SyncDescriptor)return this._createServiceInstance(d,v,A,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(g,d,v,A,b);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(g,d=[],v,A){if(v){const b=new h.IdleValue(()=>this._createInstance(g,d,A));return new Proxy(Object.create(null),{get(a,c){if(c in a)return a[c];let m=b.value,s=m[c];return typeof s!="function"||(s=s.bind(m),a[c]=s),s},set(a,c,m){return b.value[c]=m,!0}})}else return this._createInstance(g,d,A)}_throwIfStrict(g,d){if(d&&console.warn(d),this._strict)throw new Error(g)}}e.InstantiationService=F;var D;(function(_){_[_.Creation=0]="Creation",_[_.Invocation=1]="Invocation",_[_.Branch=2]="Branch"})(D||(D={}));class p{constructor(g,d){this.type=g,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(g){return S?new p(1,g.name||g.toString().substring(0,42).replace(/\n/g,"")):p._None}static traceCreation(g){return S?new p(0,g.name):p._None}branch(g,d){let v=new p(2,g.toString());return this._dep.push([g,d,v]),v}stop(){let g=Date.now()-this._start;p._totals+=g;let d=!1;function v(b,a){let c=[],m=new Array(b+1).join("	");for(const[s,E,l]of a._dep)if(E&&l){d=!0,c.push(`${m}CREATES -> ${s}`);let i=v(b+1,l);i&&c.push(i)}else c.push(`${m}uses -> ${s}`);return c.join(`
`)}let A=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(g>2||d)&&console.log(A.join(`
`))}}e.Trace=p,p._None=new class extends p{constructor(){super(-1,null)}stop(){}branch(){return this}},p._totals=0}),define(ve[11],we([1,0,49,3,6,12,4]),function(ee,e,h,n,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logCi=e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,C.createDecorator)("logService"),e.ILoggerService=(0,C.createDecorator)("loggerService");function k(){return new Date().toISOString()}var S;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;function R(l,i,r){switch(i){case S.Trace:l.trace(r);break;case S.Debug:l.debug(r);break;case S.Info:l.info(r);break;case S.Warning:l.warn(r);break;case S.Error:l.error(r);break;case S.Critical:l.critical(r);break;default:throw new Error("Invalid log level")}}e.log=R;function F(l){let i="";for(let r=0;r<l.length;r++){let t=l[r];if(typeof t=="object")try{t=JSON.stringify(t)}catch{}i+=(r>0?" ":"")+t}return i}e.format=F;class D extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=D;class p extends D{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...r){this.checkLogLevel(S.Trace)&&this.log(S.Trace,F([i,...r]))}debug(i,...r){this.checkLogLevel(S.Debug)&&this.log(S.Debug,F([i,...r]))}info(i,...r){this.checkLogLevel(S.Info)&&this.log(S.Info,F([i,...r]))}warn(i,...r){this.checkLogLevel(S.Warning)&&this.log(S.Warning,F([i,...r]))}error(i,...r){if(this.checkLogLevel(S.Error))if(i instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=i.stack,this.log(S.Error,F(t))}else this.log(S.Error,F([i,...r]))}critical(i,...r){this.checkLogLevel(S.Critical)&&this.log(S.Critical,F([i,...r]))}flush(){}}e.AbstractMessageLogger=p;class _ extends D{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!T.isWindows}trace(i,...r){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...r):console.log(`[main ${k()}]`,i,...r))}debug(i,...r){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...r):console.log(`[main ${k()}]`,i,...r))}info(i,...r){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...r):console.log(`[main ${k()}]`,i,...r))}warn(i,...r){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,i,...r):console.warn(`[main ${k()}]`,i,...r))}error(i,...r){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,i,...r):console.error(`[main ${k()}]`,i,...r))}critical(i,...r){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,i,...r):console.error(`[main ${k()}]`,i,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=_;class g extends D{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...r){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",i,...r)}debug(i,...r){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...r)}info(i,...r){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",i,...r)}warn(i,...r){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",i,...r)}error(i,...r){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",i,...r)}critical(i,...r){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...r)}dispose(){}flush(){}}e.ConsoleLogger=g;class d extends D{constructor(i,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(r)}trace(i,...r){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(i),...r])}debug(i,...r){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(i),...r])}info(i,...r){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(i),...r])}warn(i,...r){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(i),...r])}error(i,...r){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(i),...r])}critical(i,...r){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(i),...r])}extractMessage(i){return typeof i=="string"?i:(0,h.toErrorMessage)(i,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class v extends D{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const r of this.logServices)r.setLevel(i);super.setLevel(i)}trace(i,...r){for(const t of this.logServices)t.trace(i,...r)}debug(i,...r){for(const t of this.logServices)t.debug(i,...r)}info(i,...r){for(const t of this.logServices)t.info(i,...r)}warn(i,...r){for(const t of this.logServices)t.warn(i,...r)}error(i,...r){for(const t of this.logServices)t.error(i,...r)}critical(i,...r){for(const t of this.logServices)t.critical(i,...r)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=v;class A extends I.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...r){this.logger.trace(i,...r)}debug(i,...r){this.logger.debug(i,...r)}info(i,...r){this.logger.info(i,...r)}warn(i,...r){this.logger.warn(i,...r)}error(i,...r){this.logger.error(i,...r)}critical(i,...r){this.logger.critical(i,...r)}flush(){this.logger.flush()}}e.LogService=A;class b extends I.Disposable{constructor(i,r){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(t=>{this.logLevel=t,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(t))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,r){let t=this.loggers.get(i.toString());return t||(t=this.doCreateLogger(i,r?.always?S.Trace:this.logLevel,r),this.loggers.set(i.toString(),t),r?.always||this.logLevelChangeableLoggers.push(t)),t}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=b;class a{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(i){}getLevel(){return S.Info}trace(i,...r){}debug(i,...r){}info(i,...r){}warn(i,...r){}error(i,...r){}critical(i,...r){}dispose(){}flush(){}}e.NullLogService=a;function c(l){if(l.verbose)return S.Trace;if(typeof l.logLevel=="string"){const i=m(l.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function m(l){switch(l){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=m;function s(l){switch(l){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=s;function E(l,i,...r){T.isCI?l.info.call(l,i,...r):l.trace.call(l,i,...r)}e.logCi=E}),define(ve[189],we([1,0,42,11]),function(ee,e,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function I(k,S,R,F,D){try{const p=await new Promise((g,d)=>{ee(["spdlog"],g,d)});p.setFlushOn(n.LogLevel.Trace);const _=await p.createAsyncRotatingLogger(k,S,R,F);return D&&_.clearFormatters(),_}catch(p){console.error(p)}return null}function T(k,S,R){switch(S){case n.LogLevel.Trace:k.trace(R);break;case n.LogLevel.Debug:k.debug(R);break;case n.LogLevel.Info:k.info(R);break;case n.LogLevel.Warning:k.warn(R);break;case n.LogLevel.Error:k.error(R);break;case n.LogLevel.Critical:k.critical(R);break;default:throw new Error("Invalid log level")}}class C extends n.AbstractMessageLogger{constructor(S,R,F,D,p){super();this.buffer=[],this.setLevel(p),this._loggerCreationPromise=this._createSpdLogLogger(S,R,F,D),this._register(this.onDidChangeLogLevel(_=>{this._logger&&this._logger.setLevel(_)}))}async _createSpdLogLogger(S,R,F,D){const p=F?6:1,_=30/p*h.ByteSize.MB,g=await I(S,R,_,p,D);if(g){this._logger=g,this._logger.setLevel(this.getLevel());for(const{level:d,message:v}of this.buffer)T(this._logger,d,v);this.buffer=[]}}log(S,R){this._logger?T(this._logger,S,R):this.getLevel()<=S&&this.buffer.push({level:S,message:R})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=C}),define(ve[116],we([1,0,47,164,4]),function(ee,e,h,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var C;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function R(g,d){return d-g}S.compare=R;const F=Object.create(null);F[S.Error]=(0,n.localize)(0,null),F[S.Warning]=(0,n.localize)(1,null),F[S.Info]=(0,n.localize)(2,null);function D(g){return F[g]||""}S.toString=D;function p(g){switch(g){case h.default.Error:return S.Error;case h.default.Warning:return S.Warning;case h.default.Info:return S.Info;case h.default.Ignore:return S.Hint}}S.fromSeverity=p;function _(g){switch(g){case S.Error:return h.default.Error;case S.Warning:return h.default.Warning;case S.Info:return h.default.Info;case S.Hint:return h.default.Ignore}}S.toSeverity=_}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(S){const R="";function F(p){return D(p,!0)}S.makeKey=F;function D(p,_){let g=[R];return p.source?g.push(p.source.replace("\xA6","\\\xA6")):g.push(R),p.code?typeof p.code=="string"?g.push(p.code.replace("\xA6","\\\xA6")):g.push(p.code.value.replace("\xA6","\\\xA6")):g.push(R),p.severity!==void 0&&p.severity!==null?g.push(C.toString(p.severity)):g.push(R),p.message&&_?g.push(p.message.replace("\xA6","\\\xA6")):g.push(R),p.startLineNumber!==void 0&&p.startLineNumber!==null?g.push(p.startLineNumber.toString()):g.push(R),p.startColumn!==void 0&&p.startColumn!==null?g.push(p.startColumn.toString()):g.push(R),p.endLineNumber!==void 0&&p.endLineNumber!==null?g.push(p.endLineNumber.toString()):g.push(R),p.endColumn!==void 0&&p.endColumn!==null?g.push(p.endColumn.toString()):g.push(R),g.push(R),g.join("\xA6")}S.makeKeyOptionalMessage=D})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,I.createDecorator)("markerService")}),define(ve[190],we([1,0,3,47,4]),function(ee,e,h,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=n.default,e.INotificationService=(0,I.createDecorator)("notificationService");var T;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new S,this.onDidClose=h.Event.None,this.onDidChangeVisibility=h.Event.None}updateSeverity(F){}updateMessage(F){}updateActions(F){}close(){}}e.NoOpNotification=k;class S{infinite(){}done(){}total(F){}worked(F){}}e.NoOpProgress=S}),define(ve[117],we([1,0,6,8,2,4]),function(ee,e,h,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.selectionFragment=e.withSelectionFragment=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,T.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return h.Disposable.None},registerValidator(){return h.Disposable.None},registerExternalUriResolver(){return h.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return h.Disposable.None},async open(){return!1},async resolveExternalUri(F){return{resolved:F,dispose(){}}}});function C(F,D){return I.URI.isUri(F)?(0,n.equalsIgnoreCase)(F.scheme,D):(0,n.startsWithIgnoreCase)(F,D+":")}e.matchesScheme=C;function k(F,...D){return D.some(p=>C(F,p))}e.matchesSomeScheme=k;function S(F,D){return F.with({fragment:`${D.startLineNumber},${D.startColumn}${D.endLineNumber?`-${D.endLineNumber}${D.endColumn?`,${D.endColumn}`:""}`:""}`})}e.withSelectionFragment=S;function R(F){let D;const p=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(F.fragment);return p&&(D={startLineNumber:parseInt(p[1]),startColumn:p[2]?parseInt(p[2]):1,endLineNumber:p[4]?parseInt(p[4]):void 0,endColumn:p[4]?p[5]?parseInt(p[5]):1:void 0}),D}e.selectionFragment=R}),define(ve[191],we([1,0,10,12,41,23]),function(ee,e,h,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let C;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const k=n.globals.vscode.context.configuration();if(k)C=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof ee?.__$__nodeRequire=="function"){const k=(0,T.dirname)(h.FileAccess.asFileUri("",ee));C=ee.__$__nodeRequire((0,T.joinPath)(k,"product.json").fsPath);const S=ee.__$__nodeRequire((0,T.joinPath)(k,"package.json").fsPath);I.env.VSCODE_DEV&&Object.assign(C,{nameShort:`${C.nameShort} Dev`,nameLong:`${C.nameLong} Dev`,dataFolderName:`${C.dataFolderName}-dev`,serverDataFolderName:C.serverDataFolderName?`${C.serverDataFolderName}-dev`:void 0}),Object.assign(C,{version:S.version})}else C={},Object.keys(C).length===0&&Object.assign(C,{version:"1.65.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=C});var Fe=this&&this.__param||function(ee,e){return function(h,n){e(h,n,ee)}};define(ve[118],we([1,0,15,21,6,4]),function(ee,e,h,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,T.createDecorator)("progressService");var C;(function(F){F[F.Explorer=1]="Explorer",F[F.Scm=3]="Scm",F[F.Extensions=5]="Extensions",F[F.Window=10]="Window",F[F.Notification=15]="Notification",F[F.Dialog=20]="Dialog"})(C=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(D){this.callback=D}get value(){return this._value}report(D){this._value=D,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let S=class extends I.Disposable{constructor(D,p){super();this.deferred=new h.DeferredPromise,p.withProgress(D,_=>(this.reporter=_,this.lastStep&&_.report(this.lastStep),this.deferred.p)),this._register((0,I.toDisposable)(()=>this.deferred.complete()))}report(D){this.reporter?this.reporter.report(D):this.lastStep=D}};S=Be([Fe(1,e.IProgressService)],S),e.UnmanagedProgress=S;class R extends I.Disposable{constructor(D){super();this.progressIndicator=D,this.currentOperationId=0,this.currentOperationDisposables=this._register(new I.DisposableStore)}start(D){this.stop();const p=++this.currentOperationId,_=new n.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{p===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},D),this.currentOperationDisposables.add((0,I.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,I.toDisposable)(()=>_.cancel())),this.currentOperationDisposables.add((0,I.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:p,token:_.token,stop:()=>this.doStop(p),isCurrent:()=>this.currentOperationId===p}}stop(){this.doStop(this.currentOperationId)}doStop(D){this.currentOperationId===D&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=R,e.IEditorProgressService=(0,T.createDecorator)("editorProgressService")}),define(ve[50],we([1,0,55,13]),function(ee,e,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.data=new Map}add(C,k){h.ok(n.isString(C)),h.ok(n.isObject(k)),h.ok(!this.data.has(C),"There is already an extension with this id"),this.data.set(C,k)}knows(C){return this.data.has(C)}as(C){return this.data.get(C)||null}}e.Registry=new I}),define(ve[192],we([1,0,3,50]),function(ee,e,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class T{constructor(){this._onDidChangeSchema=new h.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,R){this.schemasById[I(S)]=R,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const C=new T;n.Registry.add(e.Extensions.JSONContribution,C)}),define(ve[119],we([1,0,18,3,13,159,192,50]),function(ee,e,h,n,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const F=k.Registry.as(C.Extensions.JSONContribution);class D{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(m,s=!0){this.registerConfigurations([m],s)}registerConfigurations(m,s=!0){const E=this.doRegisterConfigurations(m,s);F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:E})}deregisterConfigurations(m){const s=this.doDeregisterConfigurations(m);F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:m,remove:s}){const E=[];E.push(...this.doDeregisterConfigurations(s)),E.push(...this.doRegisterConfigurations(m,!1)),F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,h.distinct)(E)})}registerDefaultConfigurations(m){const s=[],E=[];for(const{overrides:l,source:i}of m)for(const r in l)if(s.push(r),e.OVERRIDE_PROPERTY_REGEX.test(r)){const t={...this.configurationDefaultsOverrides.get(r)?.value||{},...l[r]};this.configurationDefaultsOverrides.set(r,{source:i,value:t});const o={type:"object",default:t,description:T.localize(1,null,r),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:t,source:I.isString(i)?void 0:i};E.push(...g(r)),this.configurationProperties[r]=o,this.defaultLanguageConfigurationOverridesNode.properties[r]=o}else{this.configurationDefaultsOverrides.set(r,{value:l[r],source:i});const t=this.configurationProperties[r];t&&(this.updatePropertyDefaultValue(r,t),this.updateSchema(r,t))}this.registerOverrideIdentifiers(E),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}deregisterDefaultConfigurations(m){const s=[];for(const{overrides:E,source:l}of m)for(const i in E){const r=this.configurationDefaultsOverrides.get(i),t=I.isString(l)?l:l?.id,o=I.isString(r?.source)?r?.source:r?.source?.id;if(t===o)if(s.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const f=this.configurationProperties[i];f&&(this.updatePropertyDefaultValue(i,f),this.updateSchema(i,f))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...m){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(m){for(const s of m)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(m,s){const E=[];return m.forEach(l=>{E.push(...this.validateAndRegisterProperties(l,s,l.extensionInfo,l.restrictedProperties)),this.configurationContributors.push(l),this.registerJSONConfiguration(l)}),E}doDeregisterConfigurations(m){const s=[],E=l=>{if(l.properties)for(const i in l.properties)s.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,l.properties[i]);l.allOf&&l.allOf.forEach(i=>E(i))};for(const l of m){E(l);const i=this.configurationContributors.indexOf(l);i!==-1&&this.configurationContributors.splice(i,1)}return s}validateAndRegisterProperties(m,s=!0,E,l,i=3){i=I.isUndefinedOrNull(m.scope)?i:m.scope;let r=[],t=m.properties;if(t)for(let f in t){if(s&&b(f)){delete t[f];continue}const u=t[f];if(u.source=E,u.defaultDefaultValue=t[f].default,this.updatePropertyDefaultValue(f,u),e.OVERRIDE_PROPERTY_REGEX.test(f)?u.scope=void 0:(u.scope=I.isUndefinedOrNull(u.scope)?i:u.scope,u.restricted=I.isUndefinedOrNull(u.restricted)?!!l?.includes(f):u.restricted),t[f].hasOwnProperty("included")&&!t[f].included){this.excludedConfigurationProperties[f]=t[f],delete t[f];continue}else this.configurationProperties[f]=t[f];!t[f].deprecationMessage&&t[f].markdownDeprecationMessage&&(t[f].deprecationMessage=t[f].markdownDeprecationMessage),r.push(f)}let o=m.allOf;if(o)for(let f of o)r.push(...this.validateAndRegisterProperties(f,s,E,l,i));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(m){const s=E=>{let l=E.properties;if(l)for(const r in l)this.updateSchema(r,l[r]);let i=E.allOf;i&&i.forEach(s)};s(m)}updateSchema(m,s){switch(e.allSettings.properties[m]=s,s.scope){case 1:e.applicationSettings.properties[m]=s;break;case 2:e.machineSettings.properties[m]=s;break;case 6:e.machineOverridableSettings.properties[m]=s;break;case 3:e.windowSettings.properties[m]=s;break;case 4:e.resourceSettings.properties[m]=s;break;case 5:e.resourceSettings.properties[m]=s,this.resourceLanguageSettingsSchema.properties[m]=s;break}}removeFromSchema(m,s){switch(delete e.allSettings.properties[m],s.scope){case 1:delete e.applicationSettings.properties[m];break;case 2:delete e.machineSettings.properties[m];break;case 6:delete e.machineOverridableSettings.properties[m];break;case 3:delete e.windowSettings.properties[m];break;case 4:case 5:delete e.resourceSettings.properties[m],delete this.resourceLanguageSettingsSchema.properties[m];break}}updateOverridePropertyPatternKey(){for(const m of this.overrideIdentifiers.values()){const s=`[${m}]`,E={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,E),e.allSettings.properties[s]=E,e.applicationSettings.properties[s]=E,e.machineSettings.properties[s]=E,e.machineOverridableSettings.properties[s]=E,e.windowSettings.properties[s]=E,e.resourceSettings.properties[s]=E}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const m={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=m,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=m,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=m,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=m,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=m,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=m,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(m,s){const E=this.configurationDefaultsOverrides.get(m);let l=E?.value,i=E?.source;I.isUndefined(l)&&(l=s.defaultDefaultValue,i=void 0),I.isUndefined(l)&&(l=v(s.type)),s.default=l,s.defaultValueSource=i}}const p="\\[([^\\]]+)\\]",_=new RegExp(p,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${p})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function g(c){const m=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let s=_.exec(c);for(;s?.length;){const E=s[1].trim();E&&m.push(E),s=_.exec(c)}}return(0,h.distinct)(m)}e.overrideIdentifiersFromKey=g;function d(c){return c.reduce((m,s)=>`${m}[${s}]`,"")}e.keyFromOverrideIdentifiers=d;function v(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=v;const A=new D;k.Registry.add(e.Extensions.Configuration,A);function b(c){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?T.localize(7,null,c):A.getConfigurationProperties()[c]!==void 0?T.localize(8,null,c):null:T.localize(6,null)}e.validateProperty=b;function a(){const c=[],m=A.getConfigurationProperties();for(const s of Object.keys(m))c.push([s,m[s].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=a}),define(ve[193],we([1,0,18,3,141,6,24,25,13,2,115,119,50]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class _{constructor(l={},i=[],r=[]){this._contents=l,this._keys=i,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(l){return l?(0,F.getConfigurationValue)(this.contents,l):this.contents}getOverrideValue(l,i){const r=this.getContentsForOverrideIdentifer(i);return r?l?(0,F.getConfigurationValue)(r,l):r:void 0}getKeysForOverrideIdentifier(l){const i=[];for(const r of this.overrides)r.identifiers.includes(l)&&i.push(...r.keys);return h.distinct(i)}getAllOverrideIdentifiers(){const l=[];for(const i of this.overrides)l.push(...i.identifiers);return h.distinct(l)}override(l){let i=this.overrideConfigurations.get(l);return i||(i=this.createOverrideConfigurationModel(l),this.overrideConfigurations.set(l,i)),i}merge(...l){const i=k.deepClone(this.contents),r=k.deepClone(this.overrides),t=[...this.keys];for(const o of l){this.mergeContents(i,o.contents);for(const f of o.overrides){const[u]=r.filter(w=>h.equals(w.identifiers,f.identifiers));u?(this.mergeContents(u.contents,f.contents),u.keys.push(...f.keys),u.keys=h.distinct(u.keys)):r.push(k.deepClone(f))}for(const f of o.keys)t.indexOf(f)===-1&&t.push(f)}return new _(i,t,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(l){const i=this.getContentsForOverrideIdentifer(l);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let r={};for(const t of h.distinct([...Object.keys(this.contents),...Object.keys(i)])){let o=this.contents[t],f=i[t];f&&(typeof o=="object"&&typeof f=="object"?(o=k.deepClone(o),this.mergeContents(o,f)):o=f),r[t]=o}return new _(r,this.keys,this.overrides)}mergeContents(l,i){for(const r of Object.keys(i)){if(r in l&&S.isObject(l[r])&&S.isObject(i[r])){this.mergeContents(l[r],i[r]);continue}l[r]=k.deepClone(i[r])}}checkAndFreeze(l){return this.isFrozen&&!Object.isFrozen(l)?k.deepFreeze(l):l}getContentsForOverrideIdentifer(l){let i=null,r=null;const t=o=>{o&&(r?this.mergeContents(r,o):r=k.deepClone(o))};for(const o of this.overrides)h.equals(o.identifiers,[l])?i=o.contents:o.identifiers.includes(l)&&t(o.contents);return t(i),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(l,i){this.addKey(l),(0,F.addToValueTree)(this.contents,l,i,r=>{throw new Error(r)})}removeValue(l){this.removeKey(l)&&(0,F.removeFromValueTree)(this.contents,l)}addKey(l){let i=this.keys.length;for(let r=0;r<i;r++)l.indexOf(this.keys[r])===0&&(i=r);this.keys.splice(i,1,l)}removeKey(l){let i=this.keys.indexOf(l);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=_;class g extends _{constructor(l={}){const i=p.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(i),t=Object.create(null),o=[];for(const f in i){const u=l[f],w=u!==void 0?u:i[f].default;(0,F.addToValueTree)(t,f,w,P=>console.error(`Conflict in default settings: ${P}`))}for(const f of Object.keys(t))D.OVERRIDE_PROPERTY_REGEX.test(f)&&o.push({identifiers:(0,D.overrideIdentifiersFromKey)(f),keys:Object.keys(t[f]),contents:(0,F.toValuesTree)(t[f],u=>console.error(`Conflict in default settings file: ${u}`))});super(t,r,o)}}e.DefaultConfigurationModel=g;class d{constructor(l){this._name=l,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new _}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(l,i){if(!S.isUndefinedOrNull(l)){const r=this.doParseContent(l);this.parseRaw(r,i)}}reparse(l){this._raw&&this.parseRaw(this._raw,l)}parseRaw(l,i){this._raw=l;const{contents:r,keys:t,overrides:o,restricted:f}=this.doParseRaw(l,i);this._configurationModel=new _(r,t,o),this._restrictedConfigurations=f||[]}doParseContent(l){let i={},r=null,t=[],o=[],f=[];function u(P){Array.isArray(t)?t.push(P):r!==null&&(t[r]=P)}let w={onObjectBegin:()=>{let P={};u(P),o.push(t),t=P,r=null},onObjectProperty:P=>{r=P},onObjectEnd:()=>{t=o.pop()},onArrayBegin:()=>{let P=[];u(P),o.push(t),t=P,r=null},onArrayEnd:()=>{t=o.pop()},onLiteralValue:u,onError:(P,L,O)=>{f.push({error:P,offset:L,length:O})}};if(l)try{I.visit(l,w),i=t[0]||{}}catch(P){console.error(`Error while parsing settings file ${this._name}: ${P}`),this._parseErrors=[P]}return i}doParseRaw(l,i){const r=p.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),t=this.filter(l,r,!0,i);l=t.raw;const o=(0,F.toValuesTree)(l,w=>console.error(`Conflict in settings file ${this._name}: ${w}`)),f=Object.keys(l),u=this.toOverrides(l,w=>console.error(`Conflict in settings file ${this._name}: ${w}`));return{contents:o,keys:f,overrides:u,restricted:t.restricted}}filter(l,i,r,t){if(!t?.scopes&&!t?.skipRestricted)return{raw:l,restricted:[]};const o={},f=[];for(let u in l)if(D.OVERRIDE_PROPERTY_REGEX.test(u)&&r){const w=this.filter(l[u],i,!1,t);o[u]=w.raw,f.push(...w.restricted)}else{const w=i[u],P=w?typeof w.scope!="undefined"?w.scope:3:void 0;w?.restricted&&f.push(u),(P===void 0||t.scopes===void 0||t.scopes.includes(P))&&(t.skipRestricted&&w?.restricted||(o[u]=l[u]))}return{raw:o,restricted:f}}toOverrides(l,i){const r=[];for(const t of Object.keys(l))if(D.OVERRIDE_PROPERTY_REGEX.test(t)){const o={};for(const f in l[t])o[f]=l[t][f];r.push({identifiers:(0,D.overrideIdentifiersFromKey)(t),keys:Object.keys(o),contents:(0,F.toValuesTree)(o,i)})}return r}}e.ConfigurationModelParser=d;class v extends T.Disposable{constructor(l,i,r,t){super();this.userSettingsResource=l,this.scopes=i,this.fileService=t,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.any(n.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource)),n.Event.filter(this.fileService.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(1)||o.isOperation(4))&&r.isEqual(o.resource,l)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const l=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(l.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new _}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class A{constructor(l,i,r=new _,t=new _,o=new C.ResourceMap,f=new _,u=new C.ResourceMap,w=!0){this._defaultConfiguration=l,this._localUserConfiguration=i,this._remoteUserConfiguration=r,this._workspaceConfiguration=t,this._folderConfigurations=o,this._memoryConfiguration=f,this._memoryConfigurationByResource=u,this._freeze=w,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new C.ResourceMap,this._userConfiguration=null}getValue(l,i,r){return this.getConsolidateConfigurationModel(i,r).getValue(l)}updateValue(l,i,r={}){let t;r.resource?(t=this._memoryConfigurationByResource.get(r.resource),t||(t=new _,this._memoryConfigurationByResource.set(r.resource,t))):t=this._memoryConfiguration,i===void 0?t.removeValue(l):t.setValue(l,i),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(l,i,r){const t=this.getConsolidateConfigurationModel(i,r),o=this.getFolderConfigurationModelForResource(i.resource,r),f=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,u=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(l):this._defaultConfiguration.freeze().getValue(l),w=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(l):this.userConfiguration.freeze().getValue(l),P=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(l):this.localUserConfiguration.freeze().getValue(l),L=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(l):this.remoteUserConfiguration.freeze().getValue(l),O=r?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(l):this._workspaceConfiguration.freeze().getValue(l):void 0,y=o?i.overrideIdentifier?o.freeze().override(i.overrideIdentifier).getValue(l):o.freeze().getValue(l):void 0,z=i.overrideIdentifier?f.override(i.overrideIdentifier).getValue(l):f.getValue(l),M=t.getValue(l),B=h.distinct(h.flatten(t.overrides.map(V=>V.identifiers))).filter(V=>t.getOverrideValue(l,V)!==void 0);return{defaultValue:u,userValue:w,userLocalValue:P,userRemoteValue:L,workspaceValue:O,workspaceFolderValue:y,memoryValue:z,value:M,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(l),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(l,i.overrideIdentifier):void 0}:void 0,user:w!==void 0?{value:this.userConfiguration.freeze().getValue(l),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(l,i.overrideIdentifier):void 0}:void 0,userLocal:P!==void 0?{value:this.localUserConfiguration.freeze().getValue(l),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(l,i.overrideIdentifier):void 0}:void 0,userRemote:L!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(l),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(l,i.overrideIdentifier):void 0}:void 0,workspace:O!==void 0?{value:this._workspaceConfiguration.freeze().getValue(l),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(l,i.overrideIdentifier):void 0}:void 0,workspaceFolder:y!==void 0?{value:o?.freeze().getValue(l),override:i.overrideIdentifier?o?.freeze().getOverrideValue(l,i.overrideIdentifier):void 0}:void 0,memory:z!==void 0?{value:f.getValue(l),override:i.overrideIdentifier?f.getOverrideValue(l,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:B.length?B:void 0}}keys(l){const i=this.getFolderConfigurationModelForResource(void 0,l);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(l){this._defaultConfiguration=l,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(l){this._localUserConfiguration=l,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(l){this._remoteUserConfiguration=l,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(l){this._workspaceConfiguration=l,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(l,i){this._folderConfigurations.set(l,i),this._foldersConsolidatedConfigurations.delete(l)}deleteFolderConfiguration(l){this.folderConfigurations.delete(l),this._foldersConsolidatedConfigurations.delete(l)}compareAndUpdateDefaultConfiguration(l,i){const r=[];if(!i){const{added:t,updated:o,removed:f}=m(this._defaultConfiguration,l);i=[...t,...o,...f]}for(const t of i)for(const o of(0,D.overrideIdentifiersFromKey)(t)){const f=this._defaultConfiguration.getKeysForOverrideIdentifier(o),u=l.getKeysForOverrideIdentifier(o),w=[...u.filter(P=>f.indexOf(P)===-1),...f.filter(P=>u.indexOf(P)===-1),...f.filter(P=>!k.equals(this._defaultConfiguration.override(o).getValue(P),l.override(o).getValue(P)))];r.push([o,w])}return this.updateDefaultConfiguration(l),{keys:i,overrides:r}}compareAndUpdateLocalUserConfiguration(l){const{added:i,updated:r,removed:t,overrides:o}=m(this.localUserConfiguration,l),f=[...i,...r,...t];return f.length&&this.updateLocalUserConfiguration(l),{keys:f,overrides:o}}compareAndUpdateRemoteUserConfiguration(l){const{added:i,updated:r,removed:t,overrides:o}=m(this.remoteUserConfiguration,l);let f=[...i,...r,...t];return f.length&&this.updateRemoteUserConfiguration(l),{keys:f,overrides:o}}compareAndUpdateWorkspaceConfiguration(l){const{added:i,updated:r,removed:t,overrides:o}=m(this.workspaceConfiguration,l);let f=[...i,...r,...t];return f.length&&this.updateWorkspaceConfiguration(l),{keys:f,overrides:o}}compareAndUpdateFolderConfiguration(l,i){const r=this.folderConfigurations.get(l),{added:t,updated:o,removed:f,overrides:u}=m(r,i);let w=[...t,...o,...f];return(w.length||!r)&&this.updateFolderConfiguration(l,i),{keys:w,overrides:u}}compareAndDeleteFolderConfiguration(l){const i=this.folderConfigurations.get(l);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(l);const{added:r,updated:t,removed:o,overrides:f}=m(i,void 0);return{keys:[...r,...t,...o],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(l,i){let r=this.getConsolidatedConfigurationModelForResource(l,i);return l.overrideIdentifier?r.override(l.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:l},i){let r=this.getWorkspaceConsolidatedConfiguration();if(i&&l){const t=i.getFolder(l);t&&(r=this.getFolderConsolidatedConfiguration(t.uri)||r);const o=this._memoryConfigurationByResource.get(l);o&&(r=r.merge(o))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(l){let i=this._foldersConsolidatedConfigurations.get(l);if(!i){const r=this.getWorkspaceConsolidatedConfiguration(),t=this._folderConfigurations.get(l);t?(i=r.merge(t),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(l,i)):i=r}return i}getFolderConfigurationModelForResource(l,i){if(i&&l){const r=i.getFolder(l);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((l,i)=>{const{contents:r,overrides:t,keys:o}=this._folderConfigurations.get(i);return l.push([i,{contents:r,overrides:t,keys:o}]),l},[])}}allKeys(){const l=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>l.add(i)),this.userConfiguration.freeze().keys.forEach(i=>l.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>l.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(r=>l.add(r))),[...l.values()]}allOverrideIdentifiers(){const l=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>l.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>l.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>l.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(r=>l.add(r))),[...l.values()]}getAllKeysForOverrideIdentifier(l){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(l).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(l).forEach(r=>i.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(l).forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(l).forEach(t=>i.add(t))),[...i.values()]}static parse(l){const i=this.parseConfigurationModel(l.defaults),r=this.parseConfigurationModel(l.user),t=this.parseConfigurationModel(l.workspace),o=l.folders.reduce((f,u)=>(f.set(R.URI.revive(u[0]),this.parseConfigurationModel(u[1])),f),new C.ResourceMap);return new A(i,r,new _,t,o,new _,new C.ResourceMap,!1)}static parseConfigurationModel(l){return new _(l.contents,l.keys,l.overrides).freeze()}}e.Configuration=A;function b(...E){if(E.length===0)return{keys:[],overrides:[]};if(E.length===1)return E[0];const l=new Set,i=new Map;for(const t of E)t.keys.forEach(o=>l.add(o)),t.overrides.forEach(([o,f])=>{const u=(0,C.getOrSet)(i,o,new Set);f.forEach(w=>u.add(w))});const r=[];return i.forEach((t,o)=>r.push([o,[...t.values()]])),{keys:[...l.values()],overrides:r}}e.mergeChanges=b;class a{constructor(l,i,r,t){this.change=l,this.previous=i,this.currentConfiguraiton=r,this.currentWorkspace=t,this._previousConfiguration=void 0;const o=new Set;l.keys.forEach(u=>o.add(u)),l.overrides.forEach(([,u])=>u.forEach(w=>o.add(w))),this.affectedKeys=[...o.values()];const f=new _;this.affectedKeys.forEach(u=>f.setValue(u,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=A.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(l,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,l)){if(i){const r=this.previousConfiguration?this.previousConfiguration.getValue(l,i,this.previous?.workspace):void 0,t=this.currentConfiguraiton.getValue(l,i,this.currentWorkspace);return!k.equals(r,t)}return!0}return!1}doesAffectedKeysTreeContains(l,i){let r=(0,F.toValuesTree)({[i]:!0},()=>{}),t;for(;typeof r=="object"&&(t=Object.keys(r)[0]);){if(l=l[t],!l)return!1;r=r[t]}return!0}}e.ConfigurationChangeEvent=a;class c extends a{constructor(l,i,r,t){super({keys:l.allKeys(),overrides:[]},void 0,l,i);this.source=r,this.sourceConfig=t}}e.AllKeysConfigurationChangeEvent=c;function m(E,l){const{added:i,removed:r,updated:t}=s(l,E),o=[],f=E?.getAllOverrideIdentifiers()||[],u=l?.getAllOverrideIdentifiers()||[];if(l){const w=u.filter(P=>!f.includes(P));for(const P of w)o.push([P,l.getKeysForOverrideIdentifier(P)])}if(E){const w=f.filter(P=>!u.includes(P));for(const P of w)o.push([P,E.getKeysForOverrideIdentifier(P)])}if(l&&E){for(const w of f)if(u.includes(w)){const P=s({contents:E.getOverrideValue(void 0,w)||{},keys:E.getKeysForOverrideIdentifier(w)},{contents:l.getOverrideValue(void 0,w)||{},keys:l.getKeysForOverrideIdentifier(w)});o.push([w,[...P.added,...P.removed,...P.updated]])}}return{added:i,removed:r,updated:t,overrides:o}}function s(E,l){const i=E?l?E.keys.filter(o=>l.keys.indexOf(o)===-1):[...E.keys]:[],r=l?E?l.keys.filter(o=>E.keys.indexOf(o)===-1):[...l.keys]:[],t=[];if(E&&l){for(const o of l.keys)if(E.keys.indexOf(o)!==-1){const f=(0,F.getConfigurationValue)(l.contents,o),u=(0,F.getConfigurationValue)(E.contents,o);k.equals(f,u)||t.push(o)}}return{added:i,removed:r,updated:t}}}),define(ve[120],we([1,0,4]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,h.createDecorator)("remoteAuthorityResolverService");var n;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(n=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class I extends Error{constructor(C,k=n.Unknown,S){super(C);this._message=C,this._code=k,this._detail=S,this.isHandled=k===n.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,I.prototype)}static isTemporarilyNotAvailable(C){return C instanceof I&&C._code===n.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof I&&C._code===n.NoResolverFound}static isHandled(C){return C instanceof I&&C.isHandled}}e.RemoteAuthorityResolverError=I}),define(ve[121],we([1,0,10]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function n(T){return T.scheme===h.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=n;function I(T){if(!T)return;const C=T.indexOf("+");return C<0?T:T.substr(0,C)}e.getRemoteName=I}),define(ve[27],we([1,0,8,4,121]),function(ee,e,h,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.getWorkspaceSupportTypeMessage=T;function C(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class S{constructor(_){this.value=_,this._lower=_.toLowerCase()}static equals(_,g){if(typeof _=="undefined"||_===null)return typeof g=="undefined"||g===null;if(typeof g=="undefined"||g===null)return!1;if(typeof _=="string"||typeof g=="string"){let d=typeof _=="string"?_:_.value,v=typeof g=="string"?g:g.value;return h.equalsIgnoreCase(d,v)}return _._lower===g._lower}static toKey(_){return typeof _=="string"?_.toLowerCase():_._lower}}e.ExtensionIdentifier=S;function R(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.isLanguagePackExtension=R;function F(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=F;function D(p,_){if(_){const g=`onResolveRemoteAuthority:${(0,I.getRemoteName)(_)}`;return p.activationEvents?.indexOf(g)!==-1}return!1}e.isResolverExtension=D,e.IBuiltinExtensionsScannerService=(0,n.createDecorator)("IBuiltinExtensionsScannerService")}),define(ve[122],we([1,0,8,27]),function(ee,e,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function I(g,d){return g.uuid&&d.uuid?g.uuid===d.uuid:g.id===d.id?!0:(0,h.compareIgnoreCase)(g.id,d.id)===0}e.areSameExtensions=I;class T{constructor(d,v){this.version=v,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof T?I(this,d)&&this.version===d.version:!1}}e.ExtensionIdentifierWithVersion=T;function C(g,d){return`${g}.${d}`}e.getExtensionId=C;function k(g){return g.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function S(g,d){return k(C(g,d))}e.getGalleryExtensionId=S;function R(g,d){const v=[],A=b=>{for(const a of v)if(a.some(c=>I(d(c),d(b))))return a;return null};for(const b of g){const a=A(b);a?a.push(b):v.push([b])}return v}e.groupByExtension=R;function F(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=F;function D(g){return{id:g.identifier.id,name:g.name,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,isPreReleaseVersion:g.properties.isPreReleaseVersion,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0),...g.telemetryData}}e.getGalleryExtensionTelemetryData=D,e.BetterMergeId=new n.ExtensionIdentifier("pprice.better-merge");function p(g){const d=new Set;if(g.malicious)for(const v of g.malicious)d.add(v.id);return d}e.getMaliciousExtensionsSet=p;function _(g,d){const v=[],A=d.manifest.extensionDependencies?.slice(0)??[];for(;A.length;){const b=A.shift();if(b&&v.every(a=>!I(a.identifier,{id:b}))){const a=g.filter(c=>I(c.identifier,{id:b}));a.length===1&&(v.push(a[0]),A.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.getExtensionDependencies=_}),define(ve[194],we([1,0,10,160,122,4]),function(ee,e,h,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.getIdAndVersion=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";const C=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function k(s){const E=C.exec(s);return E&&E[1]?[(0,I.adoptToGalleryExtensionId)(E[1]),E[2]]:[(0,I.adoptToGalleryExtensionId)(s),void 0]}e.getIdAndVersion=k;var S;(function(s){s.WIN32_X64="win32-x64",s.WIN32_IA32="win32-ia32",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));function R(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=R;function F(s){switch(s){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=F;function D(s,E){switch(s){case 3:return E==="x64"?"win32-x64":E==="ia32"?"win32-ia32":E==="arm64"?"win32-arm64":"unknown";case 2:return E==="x64"?"linux-x64":E==="arm64"?"linux-arm64":E==="arm"?"linux-armhf":"unknown";case"alpine":return E==="x64"?"alpine-x64":E==="arm64"?"alpine-arm64":"unknown";case 1:return E==="x64"?"darwin-x64":E==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function p(s,E){return E==="web"&&!s.includes("web")}e.isNotWebExtensionInWebTargetPlatform=p;function _(s,E,l){return p(E,l)?!1:s==="undefined"||s==="universal"?!0:s==="unknown"?!1:s===l?!0:g(l).includes(s)}e.isTargetPlatformCompatible=_;function g(s){switch(s){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=g;function d(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.isIExtensionIdentifier=d;var v;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(v=e.SortBy||(e.SortBy={}));var A;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(A=e.SortOrder||(e.SortOrder={}));var b;(function(s){s.Install="install",s.Uninstall="uninstall"})(b=e.StatisticType||(e.StatisticType={}));var a;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(a=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService");var c;(function(s){s.Unsupported="Unsupported",s.UnsupportedPreRelease="UnsupportedPreRelease",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatiblePreRelease="IncompatiblePreRelease",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.ReleaseVersionNotFound="ReleaseVersionNotFound",s.Invalid="Invalid",s.Download="Download",s.Extract="Extract",s.Delete="Delete",s.Rename="Rename",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Internal="Internal"})(c=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class m extends Error{constructor(E,l){super(E);this.code=l,this.name=l}}e.ExtensionManagementError=m,e.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=h.FileAccess.asBrowserUri("./media/defaultIcon.png",ee).toString(!0),e.ExtensionsLabel=(0,n.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,n.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,T.createDecorator)("IExtensionManagementCLIService")}),define(ve[195],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class h{constructor(){this.validators=new Map}vsda(){return new Promise((I,T)=>ee(["vsda"],I,T))}async createNewMessage(I){try{const T=await this.vsda(),C=new T.validator;if(C){const k=String(h._nextId++);return this.validators.set(k,C),{id:k,data:C.createNewMessage(I)}}}catch{}return{id:"",data:I}}async validate(I,T){if(!I.id)return!0;const C=this.validators.get(I.id);if(!C)return!1;this.validators.delete(I.id);try{return C.validate(T)==="ok"}catch{return!1}}async sign(I){try{const T=await this.vsda(),C=new T.signer;if(C)return C.sign(I)}catch{}return I}}e.SignService=h,h._nextId=1}),define(ve[196],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class h{constructor(I){this._callback=I,this._terminalBufferMap=new Map}dispose(){for(const I of this._terminalBufferMap.values())I.dispose()}startBuffering(I,T,C=5){let k;return k=T(S=>{const R=typeof S=="string"?S:S.data;let F=this._terminalBufferMap.get(I);if(F){F.data.push(R);return}const D=setTimeout(()=>this.flushBuffer(I),C);F={data:[R],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(I),k.dispose()}},this._terminalBufferMap.set(I,F)}),k}stopBuffering(I){const T=this._terminalBufferMap.get(I);T&&T.dispose()}flushBuffer(I){const T=this._terminalBufferMap.get(I);T&&(this._terminalBufferMap.delete(I),this._callback(I,T.data.join("")))}}e.TerminalDataBufferer=h}),define(ve[197],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var h;(function(n){n.DARK="dark",n.LIGHT="light",n.HIGH_CONTRAST="hc"})(h=e.ColorScheme||(e.ColorScheme={}))}),define(ve[81],we([1,0,72,3,6,4,50,197]),function(ee,e,h,n,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var S;(function(v){function A(b){return b&&typeof b=="object"&&typeof b.id=="string"}v.isThemeColor=A})(S=e.ThemeColor||(e.ThemeColor={}));function R(v){return{id:v}}e.themeColorFromId=R;var F;(function(v){function A(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||S.isThemeColor(i.color))}v.isThemeIcon=A;const b=new RegExp(`^\\$\\((${h.CSSIcon.iconNameExpression}(?:${h.CSSIcon.iconModifierExpression})?)\\)$`);function a(i){const r=b.exec(i);if(!r)return;let[,t]=r;return{id:t}}v.fromString=a;function c(i){return{id:i}}v.fromId=c;function m(i,r){let t=i.id;const o=t.lastIndexOf("~");return o!==-1&&(t=t.substring(0,o)),r&&(t=`${t}~${r}`),{id:t}}v.modify=m;function s(i){const r=i.id.lastIndexOf("~");if(r!==-1)return i.id.substring(r+1)}v.getModifier=s;function E(i,r){return i.id===r.id&&i.color?.id===r.color?.id}v.isEqual=E;function l(i,r){return{id:i.id,color:r?R(r):void 0}}v.asThemeIcon=l,v.asClassNameArray=h.CSSIcon.asClassNameArray,v.asClassName=h.CSSIcon.asClassName,v.asCSSSelector=h.CSSIcon.asCSSSelector})(F=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=h.Codicon.file,e.FolderThemeIcon=h.Codicon.folder;function D(v){switch(v){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=D,e.Extensions={ThemingContribution:"base.contributions.theming"};class p{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(A){return this.themingParticipants.push(A),this.onThemingParticipantAddedEmitter.fire(A),(0,I.toDisposable)(()=>{const b=this.themingParticipants.indexOf(A);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let _=new p;C.Registry.add(e.Extensions.ThemingContribution,_);function g(v){return _.onColorThemeChange(v)}e.registerThemingParticipant=g;class d extends I.Disposable{constructor(A){super();this.themeService=A,this.theme=A.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(A){this.theme=A,this.updateStyles()}updateStyles(){}getColor(A,b){let a=this.theme.getColor(A);return a&&b&&(a=b(a,this.theme)),a?a.toString():null}}e.Themable=d}),define(ve[123],we([1,0,3,12,4,11]),function(ee,e,h,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,I.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,I.createDecorator)("sharedTunnelsService");var C;(function(g){g.Http="http",g.Https="https"})(C=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function R(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=R,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function F(g){return e.LOCALHOST_ADDRESSES.indexOf(g)>=0}e.isLocalhost=F,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function D(g){return e.ALL_INTERFACES_ADDRESSES.indexOf(g)>=0}e.isAllInterfaces=D;function p(g,d){return d?d!==1&&g<1024:!n.isWindows&&g<1024}e.isPortPrivileged=p;let _=class{constructor(d){this.logService=d,this._onTunnelOpened=new h.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new h.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new h.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(d){return this._tunnelProvider=d,d?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(d){this._canElevate=d.elevation,this._privacyOptions=d.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const d=[],v=Array.from(this._tunnels.values());for(let A of v){const b=Array.from(A.values());for(let a of b){const c=await a.value;c&&d.push(c)}}return d}async dispose(){for(const d of this._tunnels.values()){for(const{value:v}of d.values())await v.then(A=>A?.dispose());d.clear()}this._tunnels.clear()}openTunnel(d,v,A,b,a=!1,c=k.Private,m){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${A} on local port ${b}.`),!d)return;v||(v="localhost");const s=this.retainOrCreateTunnel(d,v,A,b,a,c,m);return s?s.then(E=>{if(!E){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,A);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const l=this.makeTunnel(E);return(E.tunnelRemoteHost!==v||E.tunnelRemotePort!==A)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(l),l}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const v=this._tunnels.get(d.tunnelRemoteHost);if(v){const A=v.get(d.tunnelRemotePort);A&&(A.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,A))}}}}async tryDisposeTunnel(d,v,A){if(A.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${v}.`);const b=A.value.then(async a=>{a&&(await a.dispose(!0),this._onTunnelClosed.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(v),b}}async closeTunnel(d,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${v} `);const A=this._tunnels.get(d);if(A&&A.has(v)){const b=A.get(v);b.refcount=0,await this.tryDisposeTunnel(d,v,b)}}addTunnelToMap(d,v,A){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(v,{refcount:1,value:A})}async removeEmptyTunnelFromMap(d,v){const A=this._tunnels.get(d);A&&(await A.get(v)||A.delete(v),A.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,v){let A=[d];F(d)?(A.push(...e.LOCALHOST_ADDRESSES),A.push(...e.ALL_INTERFACES_ADDRESSES)):D(d)&&A.push(...e.ALL_INTERFACES_ADDRESSES);const b=A.map(a=>this._tunnels.get(a));for(const a of b){const c=a?.get(v);if(c)return c}}canTunnel(d){return!!R(d)}createWithProvider(d,v,A,b,a,c,m){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${A} on local port ${b}.`);const E={elevationRequired:a?p(b===void 0?A:b):!1},l={remoteAddress:{host:v,port:A},localAddressPort:b,privacy:c,public:c!==k.Private,protocol:m},i=d.forwardPort(l,E);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(v,A,i),i}};_=Be([Fe(0,T.ILogService)],_),e.AbstractTunnelService=_}),define(ve[198],we([1,0,10]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function n(k){return k.scheme!==h.Schemas.file&&k.scheme!==h.Schemas.vscodeRemote}e.isVirtualResource=n;function I(k){if(k.folders.length)return k.folders.every(S=>n(S.uri))?k.folders[0].uri:void 0;if(k.configuration&&n(k.configuration))return k.configuration}e.getVirtualWorkspaceLocation=I;function T(k){return I(k)?.scheme}e.getVirtualWorkspaceScheme=T;function C(k){return I(k)!==void 0}e.isVirtualWorkspace=C}),define(ve[43],we([1,0,165,9,24,23,2,4,10]),function(ee,e,h,n,I,T,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");function R(E){const l=E;return typeof l?.id=="string"&&C.URI.isUri(l.uri)}e.isSingleFolderWorkspaceIdentifier=R;function F(E){if(E.configuration)return{id:E.id,configPath:E.configuration};if(E.folders.length===1)return{id:E.id,uri:E.folders[0].uri}}e.toWorkspaceIdentifier=F;function D(E){const l=E;return typeof l?.id=="string"&&C.URI.isUri(l.configPath)}e.isWorkspaceIdentifier=D;function p(E){const l=E;if(l?.uri)return{id:l.id,uri:C.URI.revive(l.uri)};const i=E;if(i?.configPath)return{id:i.id,configPath:C.URI.revive(i.configPath)};if(E?.id)return{id:E.id}}e.reviveIdentifier=p;var _;(function(E){E[E.EMPTY=1]="EMPTY",E[E.FOLDER=2]="FOLDER",E[E.WORKSPACE=3]="WORKSPACE"})(_=e.WorkbenchState||(e.WorkbenchState={}));function g(E){const l=E;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}e.isWorkspace=g;function d(E){const l=E;return!!(l&&typeof l=="object"&&C.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}e.isWorkspaceFolder=d;class v{constructor(l,i,r,t,o){this._id=l,this._transient=r,this._configuration=t,this._ignorePathCasing=o,this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=i}update(l){this._id=l.id,this._configuration=l.configuration,this._transient=l.transient,this._ignorePathCasing=l._ignorePathCasing,this.folders=l.folders}get folders(){return this._folders}set folders(l){this._folders=l,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(l){this._configuration=l}getFolder(l){return l&&this._foldersMap.findSubstr(l.with({scheme:l.scheme,authority:l.authority,path:l.path}))||null}updateFoldersMap(){this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing);for(const l of this.folders)this._foldersMap.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=v;class A{constructor(l,i){this.raw=i,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,T.joinPath)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=A;function b(E){return new A({uri:E,index:0,name:(0,T.basenameOrAuthority)(E)},{uri:E.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace";const a=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,h.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function c(E,l){return T.extUriBiasedIgnorePathCase.isEqualOrParent(E,l.untitledWorkspacesHome)}e.isUntitledWorkspace=c;function m(E){let l;return C.URI.isUri(E)?l=E:l=E.configuration,l?.scheme===S.Schemas.tmp}e.isTemporaryWorkspace=m;function s(E){return(typeof E=="string"?(0,n.extname)(E):(0,T.extname)(E))===a}e.hasWorkspaceFileExtension=s}),define(ve[82],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class h{constructor(I){this.id=I,this._data=new Map,this._idPool=1}add(I){const T=this._idPool++;return this._data.set(T,I),this.logDebugInfo(),T}get(I,T){return this._data.has(I)?this._data.get(I)[T]:void 0}delete(I){this._data.delete(I),this.logDebugInfo()}logDebugInfo(){!h.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=h,h.enableDebugLogging=!1}),define(ve[44],we([1,0,10,23,4]),function(ee,e,h,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class T{constructor(){this._systemSchemes=new Set(Object.keys(h.Schemas)),this._providerInfo=new Map,this.extUri=new n.ExtUri(k=>{const S=this._providerInfo.get(k.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(k,S){S===null?this._providerInfo.delete(k.scheme):this._providerInfo.set(k.scheme,S)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=T,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(ve[26],we([1,0,4]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,h.createDecorator)("IExtHostInitDataService")}),define(ve[199],we([1,0,15]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class n{constructor(C,k,S){this._deferredPromises=new Map,this._id=C,this._shared=k,this._storage=S,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(R=>(this._value=R,this)),this._storageListener=this._storage.onDidChangeStorage(R=>{R.shared===this._shared&&R.key===this._id&&(this._value=R.value)}),this._scheduler=new h.RunOnceScheduler(()=>{const R=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const F of R.values())F.complete()}catch(F){for(const D of R.values())D.error(F)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,C])=>C!==void 0).map(([C])=>C)}get whenReady(){return this._init}get(C,k){let S=this._value[C];return typeof S=="undefined"&&(S=k),S}update(C,k){this._value[C]=k;let S=this._deferredPromises.get(C);if(S!==void 0)return S.p;const R=new h.DeferredPromise;return this._deferredPromises.set(C,R),this._scheduler.isScheduled()||this._scheduler.schedule(),R.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=n;class I extends n{constructor(C,k){super(C.identifier.value,!0,k);this._extension=C}setKeysForSync(C){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},C)}}e.ExtensionGlobalMemento=I}),define(ve[200],we([1,0,3,2,11]),function(ee,e,h,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let T=class{constructor(k,S){this._logService=k,this._notebooksAndEditors=S,this._onDidChangeNotebookDocumentMetadata=new h.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new h.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(k,S,R){this._notebooksAndEditors.getNotebookDocument(n.URI.revive(k)).acceptModelChanged(S.value,R)}$acceptDirtyStateChanged(k,S){this._notebooksAndEditors.getNotebookDocument(n.URI.revive(k)).acceptDirty(S)}$acceptModelSaved(k){const S=this._notebooksAndEditors.getNotebookDocument(n.URI.revive(k));this._onDidSaveNotebookDocument.fire(S.apiNotebook)}$acceptDocumentPropertiesChanged(k,S){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",k.path,S);const R=this._notebooksAndEditors.getNotebookDocument(n.URI.revive(k));R.acceptDocumentPropertiesChanged(S),S.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:R.apiNotebook})}};T=Be([Fe(0,I.ILogService)],T),e.ExtHostNotebookDocuments=T}),define(ve[16],we([1,0,4]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,h.createDecorator)("IExtHostRpcService");class n{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=n});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,h,n,I){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?I.call(ee,h):I?I.value=h:e.set(ee,h),h},Pe=this&&this.__classPrivateFieldGet||function(ee,e,h,n){if(h==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!n:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?n:h==="a"?n.call(ee):n?n.value:e.get(ee)};define(ve[201],we([1,0,27,3]),function(ee,e,h,n){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(k,S){I.set(this,void 0),this._onDidChange=new n.Emitter,this.onDidChange=this._onDidChange.event,this._id=h.ExtensionIdentifier.toKey(k.identifier),Xe(this,I,S,"f"),Pe(this,I,"f").onDidChangePassword(R=>{R.extensionId===this._id&&this._onDidChange.fire({key:R.key})})}get(k){return Pe(this,I,"f").get(this._id,k)}store(k,S){return Pe(this,I,"f").store(this._id,k,S)}delete(k){return Pe(this,I,"f").delete(this._id,k)}}e.ExtensionSecrets=T,I=new WeakMap}),define(ve[124],we([1,0,4,3]),function(ee,e,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class I{constructor(){this._onDidChangeTelemetryEnabled=new n.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new n.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._level>=2,isUsageEnabled:this._level>=3}}$initializeTelemetryLevel(C){this._level=C}$onDidChangeTelemetryLevel(C){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=C,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=I,e.IExtHostTelemetry=(0,h.createDecorator)("IExtHostTelemetry")}),define(ve[62],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var h;(function(b){b[b.Upsert=0]="Upsert",b[b.RemoveChild=1]="RemoveChild",b[b.Invalidated=2]="Invalidated",b[b.SetProp=3]="SetProp",b[b.Bulk=4]="Bulk"})(h=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const n=new WeakMap,I=(b,a)=>{const c={controllerId:a};return n.set(b,c),c};e.createPrivateApiFor=I;const T=b=>n.get(b);e.getPrivateApiFor=T;const C=(b,a,c,m)=>{let s=c;return{enumerable:!0,configurable:!1,get(){return s},set(E){if(!m(s,E)){const l=s;s=E,b.listener?.({op:3,key:a,value:E,previous:l})}}}},k=(b,a)=>b===a,S={range:(b,a)=>b===a?!0:!b||!a?!1:b.isEqual(a),label:k,description:k,sortText:k,busy:k,error:k,canResolveChildren:k,tags:(b,a)=>!(b.length!==a.length||b.some(c=>!a.find(m=>c.id===m.id)))},R=Object.keys(S),F=(b,a)=>({range:C(b,"range",void 0,S.range),label:C(b,"label",a,S.label),description:C(b,"description",void 0,S.description),sortText:C(b,"sortText",void 0,S.sortText),canResolveChildren:C(b,"canResolveChildren",!1,S.canResolveChildren),busy:C(b,"busy",!1,S.busy),error:C(b,"error",void 0,S.error),tags:C(b,"tags",[],S.tags)}),D=(b,a)=>{const c=new Map;for(const m of R)S[m](b[m],a[m])||c.set(m,a[m]);return c};e.diffTestItems=D;class p extends Error{constructor(a){super(`Attempted to insert a duplicate test item ID ${a}`)}}e.DuplicateTestItemError=p;class _ extends Error{constructor(a){super(`TestItem with ID "${a}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=_;class g extends Error{constructor(a,c,m){super(`TestItem with ID "${a}" is from controller "${c}" and cannot be added as a child of an item from controller "${m}".`)}}e.MixedTestItemController=g;const d=b=>{const a=(0,e.getPrivateApiFor)(b);let c=new Map;return{get size(){return c.size},forEach(m,s){for(const E of c.values())m.call(s,E,this)},replace(m){const s=new Map,E=new Set(c.keys()),l={op:4,ops:[]};for(const i of m){if(!(i instanceof v))throw new _(i.id);const r=(0,e.getPrivateApiFor)(i).controllerId;if(r!==a.controllerId)throw new g(i.id,r,a.controllerId);if(s.has(i.id))throw new p(i.id);s.set(i.id,i),E.delete(i.id),l.ops.push({op:0,item:i})}for(const i of E.keys())l.ops.push({op:1,id:i});a.listener?.(l),c=s},add(m){if(!(m instanceof v))throw new _(m.id);c.set(m.id,m),a.listener?.({op:0,item:m})},delete(m){c.delete(m)&&a.listener?.({op:1,id:m})},get(m){return c.get(m)},toJSON(){return Array.from(c.values())},[Symbol.iterator](){return c.values()}}};class v{constructor(a,c,m,s){if(c.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(c)} symbol`);const E=(0,e.createPrivateApiFor)(this,a);Object.defineProperties(this,{id:{value:c,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return E.parent instanceof A?void 0:E.parent}},children:{value:d(this),enumerable:!0,writable:!1},...F(E,m)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=v;class A extends v{constructor(a,c){super(a,a,c,void 0)}}e.TestItemRootImpl=A}),define(ve[51],we([1,0,4,123,3,16]),function(ee,e,h,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var C;(function(S){function R(D){return{remoteAddress:D.remoteAddress,localAddress:D.localAddress,public:!!D.public,privacy:D.privacy??(D.public?n.TunnelPrivacyId.Public:n.TunnelPrivacyId.Private),protocol:D.protocol}}S.fromApiTunnel=R;function F(D){return{remoteAddress:{host:D.tunnelRemoteHost,port:D.tunnelRemotePort},localAddress:D.localAddress,public:D.privacy!==n.TunnelPrivacyId.ConstantPrivate&&D.privacy!==n.TunnelPrivacyId.ConstantPrivate,privacy:D.privacy,protocol:D.protocol}}S.fromServiceTunnel=F})(C=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,h.createDecorator)("IExtHostTunnelService");let k=class{constructor(R){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(R){return R}async openTunnel(R,F){}async getTunnels(){return[]}async setTunnelFactory(R){return{dispose:()=>{}}}registerPortsAttributesProvider(R,F){return{dispose:()=>{}}}async $providePortAttributes(R,F,D,p,_){return[]}async $forwardPort(R,F){}async $closeTunnel(R){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=Be([Fe(0,T.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,h,n,I){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?I.call(ee,h):I?I.value=h:e.set(ee,h),h},Pe=this&&this.__classPrivateFieldGet||function(ee,e,h,n){if(h==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!n:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?n:h==="a"?n.call(ee):n?n.value:e.get(ee)};define(ve[7],we([1,0,18,17,99,24,92,8,13,2,33,42,120]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p){"use strict";var _,g,d,v,A,b,a,c,m,s,E,l,i,r,t,o,f,u,w,P;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function L(X){function x(){return Reflect.construct(X,arguments,this.constructor)}return Object.defineProperty(x,"name",Object.getOwnPropertyDescriptor(X,"name")),Object.setPrototypeOf(x,X),Object.setPrototypeOf(x.prototype,X.prototype),x}let O=A=class{constructor(x){_.set(this,void 0),Xe(this,_,x,"f")}static from(...x){let ce=x;return new A(function(){if(ce){for(const De of ce)De&&typeof De.dispose=="function"&&De.dispose();ce=void 0}})}dispose(){typeof Pe(this,_,"f")=="function"&&(Pe(this,_,"f").call(this),Xe(this,_,void 0,"f"))}};_=new WeakMap,O=A=Be([L],O),e.Disposable=O;let y=b=class{constructor(x,ce){if(x<0)throw(0,n.illegalArgument)("line must be non-negative");if(ce<0)throw(0,n.illegalArgument)("character must be non-negative");this._line=x,this._character=ce}static Min(...x){if(x.length===0)throw new TypeError;let ce=x[0];for(let De=1;De<x.length;De++){const Ge=x[De];Ge.isBefore(ce)&&(ce=Ge)}return ce}static Max(...x){if(x.length===0)throw new TypeError;let ce=x[0];for(let De=1;De<x.length;De++){const Ge=x[De];Ge.isAfter(ce)&&(ce=Ge)}return ce}static isPosition(x){if(!x)return!1;if(x instanceof b)return!0;let{line:ce,character:De}=x;return typeof ce=="number"&&typeof De=="number"}static of(x){if(x instanceof b)return x;if(this.isPosition(x))return new b(x.line,x.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<x._character}isBeforeOrEqual(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<=x._character}isAfter(x){return!this.isBeforeOrEqual(x)}isAfterOrEqual(x){return!this.isBefore(x)}isEqual(x){return this._line===x._line&&this._character===x._character}compareTo(x){return this._line<x._line?-1:this._line>x.line?1:this._character<x._character?-1:this._character>x._character?1:0}translate(x,ce=0){if(x===null||ce===null)throw(0,n.illegalArgument)();let De;return typeof x=="undefined"?De=0:typeof x=="number"?De=x:(De=typeof x.lineDelta=="number"?x.lineDelta:0,ce=typeof x.characterDelta=="number"?x.characterDelta:0),De===0&&ce===0?this:new b(this.line+De,this.character+ce)}with(x,ce=this.character){if(x===null||ce===null)throw(0,n.illegalArgument)();let De;return typeof x=="undefined"?De=this.line:typeof x=="number"?De=x:(De=typeof x.line=="number"?x.line:this.line,ce=typeof x.character=="number"?x.character:this.character),De===this.line&&ce===this.character?this:new b(De,ce)}toJSON(){return{line:this.line,character:this.character}}};y=b=Be([L],y),e.Position=y;let z=a=class{constructor(x,ce,De,Ge){let Qe,Ze;if(typeof x=="number"&&typeof ce=="number"&&typeof De=="number"&&typeof Ge=="number"?(Qe=new y(x,ce),Ze=new y(De,Ge)):y.isPosition(x)&&y.isPosition(ce)&&(Qe=y.of(x),Ze=y.of(ce)),!Qe||!Ze)throw new Error("Invalid arguments");Qe.isBefore(Ze)?(this._start=Qe,this._end=Ze):(this._start=Ze,this._end=Qe)}static isRange(x){return x instanceof a?!0:x?y.isPosition(x.start)&&y.isPosition(x.end):!1}static of(x){if(x instanceof a)return x;if(this.isRange(x))return new a(x.start,x.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(x){return a.isRange(x)?this.contains(x.start)&&this.contains(x.end):y.isPosition(x)?!(y.of(x).isBefore(this._start)||this._end.isBefore(x)):!1}isEqual(x){return this._start.isEqual(x._start)&&this._end.isEqual(x._end)}intersection(x){const ce=y.Max(x.start,this._start),De=y.Min(x.end,this._end);if(!ce.isAfter(De))return new a(ce,De)}union(x){if(this.contains(x))return this;if(x.contains(this))return x;const ce=y.Min(x.start,this._start),De=y.Max(x.end,this.end);return new a(ce,De)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(x,ce=this.end){if(x===null||ce===null)throw(0,n.illegalArgument)();let De;return x?y.isPosition(x)?De=x:(De=x.start||this.start,ce=x.end||this.end):De=this.start,De.isEqual(this._start)&&ce.isEqual(this.end)?this:new a(De,ce)}toJSON(){return[this.start,this.end]}};z=a=Be([L],z),e.Range=z;let M=c=class extends z{constructor(x,ce,De,Ge){let Qe,Ze;if(typeof x=="number"&&typeof ce=="number"&&typeof De=="number"&&typeof Ge=="number"?(Qe=new y(x,ce),Ze=new y(De,Ge)):y.isPosition(x)&&y.isPosition(ce)&&(Qe=y.of(x),Ze=y.of(ce)),!Qe||!Ze)throw new Error("Invalid arguments");super(Qe,Ze);this._anchor=Qe,this._active=Ze}static isSelection(x){return x instanceof c?!0:x?z.isRange(x)&&y.isPosition(x.anchor)&&y.isPosition(x.active)&&typeof x.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};M=c=Be([L],M),e.Selection=M;class B{constructor(x,ce,De){if(typeof x!="string"||x.length===0)throw(0,n.illegalArgument)("host");if(typeof ce!="number"||ce===0||Math.round(ce)!==ce)throw(0,n.illegalArgument)("port");if(typeof De!="undefined"&&(typeof De!="string"||De.length===0||!/^[0-9A-Za-z\-]+$/.test(De)))throw(0,n.illegalArgument)("connectionToken");this.host=x,this.port=Math.round(ce),this.connectionToken=De}}e.ResolvedAuthority=B;class V extends Error{constructor(x,ce=p.RemoteAuthorityResolverErrorCode.Unknown,De){super(x);this._message=x,this._code=ce,this._detail=De,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,V.prototype)}static NotAvailable(x,ce){return new V(x,p.RemoteAuthorityResolverErrorCode.NotAvailable,ce)}static TemporarilyNotAvailable(x){return new V(x,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=V;var Y;(function(X){X[X.LF=1]="LF",X[X.CRLF=2]="CRLF"})(Y=e.EndOfLine||(e.EndOfLine={}));var H;(function(X){X[X.Replace=1]="Replace",X[X.Append=2]="Append",X[X.Prepend=3]="Prepend"})(H=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let q=m=class{constructor(x,ce){this._range=x,this._newText=ce}static isTextEdit(x){return x instanceof m?!0:x?z.isRange(x)&&typeof x.newText=="string":!1}static replace(x,ce){return new m(x,ce)}static insert(x,ce){return m.replace(new z(x,x),ce)}static delete(x){return m.replace(x,"")}static setEndOfLine(x){const ce=new m(new z(new y(0,0),new y(0,0)),"");return ce.newEol=x,ce}get range(){return this._range}set range(x){if(x&&!z.isRange(x))throw(0,n.illegalArgument)("range");this._range=x}get newText(){return this._newText||""}set newText(x){if(x&&typeof x!="string")throw(0,n.illegalArgument)("newText");this._newText=x}get newEol(){return this._newEol}set newEol(x){if(x&&typeof x!="number")throw(0,n.illegalArgument)("newEol");this._newEol=x}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};q=m=Be([L],q),e.TextEdit=q;var K;(function(X){X[X.File=1]="File",X[X.Text=2]="Text",X[X.Cell=3]="Cell",X[X.CellReplace=5]="CellReplace"})(K=e.FileEditType||(e.FileEditType={}));let G=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(x,ce,De,Ge){this._edits.push({_type:1,from:x,to:ce,options:De,metadata:Ge})}createFile(x,ce,De){this._edits.push({_type:1,from:void 0,to:x,options:ce,metadata:De})}deleteFile(x,ce,De){this._edits.push({_type:1,from:x,to:void 0,options:ce,metadata:De})}replaceNotebookMetadata(x,ce,De){this._edits.push({_type:3,metadata:De,uri:x,edit:{editType:5,metadata:ce},notebookMetadata:ce})}replaceNotebookCells(x,ce,De,Ge,Qe){let Ze,rt,Dt=[],At;if(Kt.isNotebookRange(ce)&&Oe.isNotebookCellDataArray(De)&&!Oe.isNotebookCellDataArray(Ge)?(Ze=ce.start,rt=ce.end,Dt=De,At=Ge):typeof ce=="number"&&typeof De=="number"&&Oe.isNotebookCellDataArray(Ge)&&(Ze=ce,rt=De,Dt=Ge,At=Qe),Ze===void 0||rt===void 0)throw new Error("Invalid arguments");(Ze!==rt||Dt.length>0)&&this._edits.push({_type:5,uri:x,index:Ze,count:rt-Ze,cells:Dt,metadata:At})}replaceNotebookCellMetadata(x,ce,De,Ge){this._edits.push({_type:3,metadata:Ge,uri:x,edit:{editType:8,index:ce,metadata:De}})}replace(x,ce,De,Ge){this._edits.push({_type:2,uri:x,edit:new q(ce,De),metadata:Ge})}insert(x,ce,De,Ge){this.replace(x,new z(ce,ce),De,Ge)}delete(x,ce,De){this.replace(x,ce,"",De)}has(x){return this._edits.some(ce=>ce._type===2&&ce.uri.toString()===x.toString())}set(x,ce){if(ce)for(const De of ce)De&&this._edits.push({_type:2,uri:x,edit:De});else{for(let De=0;De<this._edits.length;De++){const Ge=this._edits[De];Ge._type===2&&Ge.uri.toString()===x.toString()&&(this._edits[De]=void 0)}(0,h.coalesceInPlace)(this._edits)}}get(x){const ce=[];for(let De of this._edits)De._type===2&&De.uri.toString()===x.toString()&&ce.push(De.edit);return ce}entries(){const x=new T.ResourceMap;for(let ce of this._edits)if(ce._type===2){let De=x.get(ce.uri);De||(De=[ce.uri,[]],x.set(ce.uri,De)),De[1].push(ce.edit)}return[...x.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};G=Be([L],G),e.WorkspaceEdit=G;let ie=s=class{constructor(x){this._tabstop=1,this.value=x||""}static isSnippetString(x){return x instanceof s?!0:x?typeof x.value=="string":!1}static _escape(x){return x.replace(/\$|}|\\/g,"\\$&")}appendText(x){return this.value+=s._escape(x),this}appendTabstop(x=this._tabstop++){return this.value+="$",this.value+=x,this}appendPlaceholder(x,ce=this._tabstop++){if(typeof x=="function"){const De=new s;De._tabstop=this._tabstop,x(De),this._tabstop=De._tabstop,x=De.value}else x=s._escape(x);return this.value+="${",this.value+=ce,this.value+=":",this.value+=x,this.value+="}",this}appendChoice(x,ce=this._tabstop++){const De=x.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ce,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(x,ce){if(typeof ce=="function"){const De=new s;De._tabstop=this._tabstop,ce(De),this._tabstop=De._tabstop,ce=De.value}else typeof ce=="string"&&(ce=ce.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=x,ce&&(this.value+=":",this.value+=ce),this.value+="}",this}};ie=s=Be([L],ie),e.SnippetString=ie;var oe;(function(X){X[X.Unnecessary=1]="Unnecessary",X[X.Deprecated=2]="Deprecated"})(oe=e.DiagnosticTag||(e.DiagnosticTag={}));var ue;(function(X){X[X.Hint=3]="Hint",X[X.Information=2]="Information",X[X.Warning=1]="Warning",X[X.Error=0]="Error"})(ue=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Z=E=class{constructor(x,ce){if(this.uri=x,ce)if(z.isRange(ce))this.range=z.of(ce);else if(y.isPosition(ce))this.range=new z(ce,ce);else throw new Error("Illegal argument")}static isLocation(x){return x instanceof E?!0:x?z.isRange(x.range)&&R.URI.isUri(x.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Z=E=Be([L],Z),e.Location=Z;let Q=class{constructor(x,ce){this.location=x,this.message=ce}static is(x){return x?typeof x.message=="string"&&x.location&&z.isRange(x.location.range)&&R.URI.isUri(x.location.uri):!1}static isEqual(x,ce){return x===ce?!0:!x||!ce?!1:x.message===ce.message&&x.location.range.isEqual(ce.location.range)&&x.location.uri.toString()===ce.location.uri.toString()}};Q=Be([L],Q),e.DiagnosticRelatedInformation=Q;let se=class{constructor(x,ce,De=ue.Error){if(!z.isRange(x))throw new TypeError("range must be set");if(!ce)throw new TypeError("message must be set");this.range=x,this.message=ce,this.severity=De}toJSON(){return{severity:ue[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(x,ce){return x===ce?!0:!x||!ce?!1:x.message===ce.message&&x.severity===ce.severity&&x.code===ce.code&&x.severity===ce.severity&&x.source===ce.source&&x.range.isEqual(ce.range)&&(0,h.equals)(x.tags,ce.tags)&&(0,h.equals)(x.relatedInformation,ce.relatedInformation,Q.isEqual)}};se=Be([L],se),e.Diagnostic=se;let de=class{constructor(x,ce){if(!x)throw new Error("Illegal argument, contents must be defined");Array.isArray(x)?this.contents=x:this.contents=[x],this.range=ce}};de=Be([L],de),e.Hover=de;var ge;(function(X){X[X.Text=0]="Text",X[X.Read=1]="Read",X[X.Write=2]="Write"})(ge=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Te=class{constructor(x,ce=ge.Text){this.range=x,this.kind=ce}toJSON(){return{range:this.range,kind:ge[this.kind]}}};Te=Be([L],Te),e.DocumentHighlight=Te;var Ne;(function(X){X[X.File=0]="File",X[X.Module=1]="Module",X[X.Namespace=2]="Namespace",X[X.Package=3]="Package",X[X.Class=4]="Class",X[X.Method=5]="Method",X[X.Property=6]="Property",X[X.Field=7]="Field",X[X.Constructor=8]="Constructor",X[X.Enum=9]="Enum",X[X.Interface=10]="Interface",X[X.Function=11]="Function",X[X.Variable=12]="Variable",X[X.Constant=13]="Constant",X[X.String=14]="String",X[X.Number=15]="Number",X[X.Boolean=16]="Boolean",X[X.Array=17]="Array",X[X.Object=18]="Object",X[X.Key=19]="Key",X[X.Null=20]="Null",X[X.EnumMember=21]="EnumMember",X[X.Struct=22]="Struct",X[X.Event=23]="Event",X[X.Operator=24]="Operator",X[X.TypeParameter=25]="TypeParameter"})(Ne=e.SymbolKind||(e.SymbolKind={}));var be;(function(X){X[X.Deprecated=1]="Deprecated"})(be=e.SymbolTag||(e.SymbolTag={}));let Ee=l=class{constructor(x,ce,De,Ge,Qe){this.name=x,this.kind=ce,this.containerName=Qe,typeof De=="string"&&(this.containerName=De),Ge instanceof Z?this.location=Ge:De instanceof z&&(this.location=new Z(Ge,De)),l.validate(this)}static validate(x){if(!x.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ne[this.kind],location:this.location,containerName:this.containerName}}};Ee=l=Be([L],Ee),e.SymbolInformation=Ee;let $=i=class{constructor(x,ce,De,Ge,Qe){this.name=x,this.detail=ce,this.kind=De,this.range=Ge,this.selectionRange=Qe,this.children=[],i.validate(this)}static validate(x){if(!x.name)throw new Error("name must not be falsy");if(!x.range.contains(x.selectionRange))throw new Error("selectionRange must be contained in fullRange");x.children&&x.children.forEach(i.validate)}};$=i=Be([L],$),e.DocumentSymbol=$;var U;(function(X){X[X.Invoke=1]="Invoke",X[X.Automatic=2]="Automatic"})(U=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let N=class{constructor(x,ce){this.title=x,this.kind=ce}};N=Be([L],N),e.CodeAction=N;let W=r=class{constructor(x){this.value=x}append(x){return new r(this.value?this.value+r.sep+x:x)}intersects(x){return this.contains(x)||x.contains(this)}contains(x){return this.value===x.value||x.value.startsWith(this.value+r.sep)}};W.sep=".",W=r=Be([L],W),e.CodeActionKind=W,W.Empty=new W(""),W.QuickFix=W.Empty.append("quickfix"),W.Refactor=W.Empty.append("refactor"),W.RefactorExtract=W.Refactor.append("extract"),W.RefactorInline=W.Refactor.append("inline"),W.RefactorRewrite=W.Refactor.append("rewrite"),W.Source=W.Empty.append("source"),W.SourceOrganizeImports=W.Source.append("organizeImports"),W.SourceFixAll=W.Source.append("fixAll");let j=class{constructor(x,ce){if(this.range=x,this.parent=ce,ce&&!ce.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};j=Be([L],j),e.SelectionRange=j;class re{constructor(x,ce,De,Ge,Qe,Ze){this.kind=x,this.name=ce,this.detail=De,this.uri=Ge,this.range=Qe,this.selectionRange=Ze}}e.CallHierarchyItem=re;class he{constructor(x,ce){this.fromRanges=ce,this.from=x}}e.CallHierarchyIncomingCall=he;class Ce{constructor(x,ce){this.fromRanges=ce,this.to=x}}e.CallHierarchyOutgoingCall=Ce;var Ae;(function(X){X[X.Information=0]="Information",X[X.Warning=1]="Warning",X[X.Error=2]="Error"})(Ae=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let We=class{constructor(x,ce){this.range=x,this.command=ce}get isResolved(){return!!this.command}};We=Be([L],We),e.CodeLens=We;let ze=t=class{constructor(x,ce=!1){g.set(this,void 0),Xe(this,g,new I.MarkdownString(x,{supportThemeIcons:ce}),"f")}static isMarkdownString(x){return x instanceof t?!0:x&&x.appendCodeblock&&x.appendMarkdown&&x.appendText&&x.value!==void 0}get value(){return Pe(this,g,"f").value}set value(x){Pe(this,g,"f").value=x}get isTrusted(){return Pe(this,g,"f").isTrusted}set isTrusted(x){Pe(this,g,"f").isTrusted=x}get supportThemeIcons(){return Pe(this,g,"f").supportThemeIcons}set supportThemeIcons(x){Pe(this,g,"f").supportThemeIcons=x}get supportHtml(){return Pe(this,g,"f").supportHtml}set supportHtml(x){Pe(this,g,"f").supportHtml=x}get baseUri(){return Pe(this,g,"f").baseUri}set baseUri(x){Pe(this,g,"f").baseUri=x}appendText(x){return Pe(this,g,"f").appendText(x),this}appendMarkdown(x){return Pe(this,g,"f").appendMarkdown(x),this}appendCodeblock(x,ce){return Pe(this,g,"f").appendCodeblock(ce??"",x),this}};g=new WeakMap,ze=t=Be([L],ze),e.MarkdownString=ze;let qe=class{constructor(x,ce){this.label=x,this.documentation=ce}};qe=Be([L],qe),e.ParameterInformation=qe;let He=class{constructor(x,ce){this.label=x,this.documentation=ce,this.parameters=[]}};He=Be([L],He),e.SignatureInformation=He;let Ue=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ue=Be([L],Ue),e.SignatureHelp=Ue;var Je;(function(X){X[X.Invoke=1]="Invoke",X[X.TriggerCharacter=2]="TriggerCharacter",X[X.ContentChange=3]="ContentChange"})(Je=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var et;(function(X){X[X.Type=1]="Type",X[X.Parameter=2]="Parameter"})(et=e.InlayHintKind||(e.InlayHintKind={}));let Le=class{constructor(x){this.value=x}};Le=Be([L],Le),e.InlayHintLabelPart=Le;let it=class{constructor(x,ce,De){this.position=x,this.label=ce,this.kind=De}};it=Be([L],it),e.InlayHint=it;var ne;(function(X){X[X.Invoke=0]="Invoke",X[X.TriggerCharacter=1]="TriggerCharacter",X[X.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ne=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ae;(function(X){X[X.Text=0]="Text",X[X.Method=1]="Method",X[X.Function=2]="Function",X[X.Constructor=3]="Constructor",X[X.Field=4]="Field",X[X.Variable=5]="Variable",X[X.Class=6]="Class",X[X.Interface=7]="Interface",X[X.Module=8]="Module",X[X.Property=9]="Property",X[X.Unit=10]="Unit",X[X.Value=11]="Value",X[X.Enum=12]="Enum",X[X.Keyword=13]="Keyword",X[X.Snippet=14]="Snippet",X[X.Color=15]="Color",X[X.File=16]="File",X[X.Reference=17]="Reference",X[X.Folder=18]="Folder",X[X.EnumMember=19]="EnumMember",X[X.Constant=20]="Constant",X[X.Struct=21]="Struct",X[X.Event=22]="Event",X[X.Operator=23]="Operator",X[X.TypeParameter=24]="TypeParameter",X[X.User=25]="User",X[X.Issue=26]="Issue"})(ae=e.CompletionItemKind||(e.CompletionItemKind={}));var J;(function(X){X[X.Deprecated=1]="Deprecated"})(J=e.CompletionItemTag||(e.CompletionItemTag={}));let pe=class{constructor(x,ce){this.label=x,this.kind=ce}toJSON(){return{label:this.label,kind:this.kind&&ae[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};pe=Be([L],pe),e.CompletionItem=pe;let Se=class{constructor(x=[],ce=!1){this.items=x,this.isIncomplete=ce}};Se=Be([L],Se),e.CompletionList=Se;let Me=class{constructor(x,ce,De){this.insertText=x,this.range=ce,this.command=De}};Me=Be([L],Me),e.InlineSuggestion=Me;let $e=class{constructor(x){this.items=x}};$e=Be([L],$e),e.InlineSuggestions=$e;var Ye;(function(X){X[X.Active=-1]="Active",X[X.Beside=-2]="Beside",X[X.One=1]="One",X[X.Two=2]="Two",X[X.Three=3]="Three",X[X.Four=4]="Four",X[X.Five=5]="Five",X[X.Six=6]="Six",X[X.Seven=7]="Seven",X[X.Eight=8]="Eight",X[X.Nine=9]="Nine"})(Ye=e.ViewColumn||(e.ViewColumn={}));var lt;(function(X){X[X.Left=1]="Left",X[X.Right=2]="Right"})(lt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var vt;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative"})(vt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var wt;(function(X){X[X.Manual=1]="Manual",X[X.AfterDelay=2]="AfterDelay",X[X.FocusOut=3]="FocusOut"})(wt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var je;(function(X){X[X.Default=0]="Default",X[X.InCenter=1]="InCenter",X[X.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",X[X.AtTop=3]="AtTop"})(je=e.TextEditorRevealType||(e.TextEditorRevealType={}));var st;(function(X){X[X.Keyboard=1]="Keyboard",X[X.Mouse=2]="Mouse",X[X.Command=3]="Command"})(st=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var _t;(function(X){X[X.Undo=1]="Undo",X[X.Redo=2]="Redo"})(_t=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var nt;(function(X){X[X.OpenOpen=0]="OpenOpen",X[X.ClosedClosed=1]="ClosedClosed",X[X.OpenClosed=2]="OpenClosed",X[X.ClosedOpen=3]="ClosedOpen"})(nt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(X){function x(ce){switch(ce){case"keyboard":return X.Keyboard;case"mouse":return X.Mouse;case"api":return X.Command}}X.fromValue=x}(st=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ct=class{constructor(x,ce){if(ce&&!R.URI.isUri(ce))throw(0,n.illegalArgument)("target");if(!z.isRange(x)||x.isEmpty)throw(0,n.illegalArgument)("range");this.range=x,this.target=ce}};ct=Be([L],ct),e.DocumentLink=ct;let Rt=class{constructor(x,ce,De,Ge){this.red=x,this.green=ce,this.blue=De,this.alpha=Ge}};Rt=Be([L],Rt),e.Color=Rt;let Tt=class{constructor(x,ce){if(ce&&!(ce instanceof Rt))throw(0,n.illegalArgument)("color");if(!z.isRange(x)||x.isEmpty)throw(0,n.illegalArgument)("range");this.range=x,this.color=ce}};Tt=Be([L],Tt),e.ColorInformation=Tt;let yt=class{constructor(x){if(!x||typeof x!="string")throw(0,n.illegalArgument)("label");this.label=x}};yt=Be([L],yt),e.ColorPresentation=yt;var mt;(function(X){X[X.RGB=0]="RGB",X[X.HEX=1]="HEX",X[X.HSL=2]="HSL"})(mt=e.ColorFormat||(e.ColorFormat={}));var Lt;(function(X){X[X.Error=0]="Error",X[X.Warning=1]="Warning",X[X.Information=2]="Information"})(Lt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Mt{constructor(x,ce,De){if(this.startIndex=x,this.length=ce,this.tooltip=De,typeof x!="number"||x<0)throw(0,n.illegalArgument)("startIndex");if(typeof ce!="number"||ce<1)throw(0,n.illegalArgument)("length");if(De!==void 0&&typeof De!="string")throw(0,n.illegalArgument)("tooltip")}}e.TerminalLink=Mt;var Ft;(function(X){X[X.Panel=1]="Panel",X[X.Editor=2]="Editor"})(Ft=e.TerminalLocation||(e.TerminalLocation={}));class xe{constructor(x){this.options=x,typeof x!="object"&&(0,n.illegalArgument)("options")}}e.TerminalProfile=xe;var _e;(function(X){X[X.Always=1]="Always",X[X.Silent=2]="Silent",X[X.Never=3]="Never"})(_e=e.TaskRevealKind||(e.TaskRevealKind={}));var ye;(function(X){X[X.Shared=1]="Shared",X[X.Dedicated=2]="Dedicated",X[X.New=3]="New"})(ye=e.TaskPanelKind||(e.TaskPanelKind={}));let fe=o=class{constructor(x,ce){if(this.label=ce,typeof x!="string"||typeof ce!="string")throw(0,n.illegalArgument)("name");this._id=x}static from(x){switch(x){case"clean":return o.Clean;case"build":return o.Build;case"rebuild":return o.Rebuild;case"test":return o.Test;default:return}}get id(){return this._id}};fe.Clean=new o("clean","Clean"),fe.Build=new o("build","Build"),fe.Rebuild=new o("rebuild","Rebuild"),fe.Test=new o("test","Test"),fe=o=Be([L],fe),e.TaskGroup=fe;function te(X){let x="";for(let ce=0;ce<X.length;ce++)x+=X[ce].replace(/,/g,",,")+",";return x}let Ie=class{constructor(x,ce,De){if(typeof x!="string")throw(0,n.illegalArgument)("process");this._args=[],this._process=x,ce!==void 0&&(Array.isArray(ce)?(this._args=ce,this._options=De):this._options=ce)}get process(){return this._process}set process(x){if(typeof x!="string")throw(0,n.illegalArgument)("process");this._process=x}get args(){return this._args}set args(x){Array.isArray(x)||(x=[]),this._args=x}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("process"),this._process!==void 0&&x.push(this._process),this._args&&this._args.length>0)for(let ce of this._args)x.push(ce);return te(x)}};Ie=Be([L],Ie),e.ProcessExecution=Ie;let Re=class{constructor(x,ce,De){if(this._args=[],Array.isArray(ce)){if(!x)throw(0,n.illegalArgument)("command can't be undefined or null");if(typeof x!="string"&&typeof x.value!="string")throw(0,n.illegalArgument)("command");this._command=x,this._args=ce,this._options=De}else{if(typeof x!="string")throw(0,n.illegalArgument)("commandLine");this._commandLine=x,this._options=ce}}get commandLine(){return this._commandLine}set commandLine(x){if(typeof x!="string")throw(0,n.illegalArgument)("commandLine");this._commandLine=x}get command(){return this._command?this._command:""}set command(x){if(typeof x!="string"&&typeof x.value!="string")throw(0,n.illegalArgument)("command");this._command=x}get args(){return this._args}set args(x){this._args=x||[]}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("shell"),this._commandLine!==void 0&&x.push(this._commandLine),this._command!==void 0&&x.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ce of this._args)x.push(typeof ce=="string"?ce:ce.value);return te(x)}};Re=Be([L],Re),e.ShellExecution=Re;var Ve;(function(X){X[X.Escape=1]="Escape",X[X.Strong=2]="Strong",X[X.Weak=3]="Weak"})(Ve=e.ShellQuoting||(e.ShellQuoting={}));var Ke;(function(X){X[X.Global=1]="Global",X[X.Workspace=2]="Workspace"})(Ke=e.TaskScope||(e.TaskScope={}));class ht{constructor(x){this._callback=x}computeId(){return"customExecution"+(0,F.generateUuid)()}set callback(x){this._callback=x}get callback(){return this._callback}}e.CustomExecution=ht;let Et=f=class{constructor(x,ce,De,Ge,Qe,Ze){this.__deprecated=!1,this._definition=this.definition=x;let rt;typeof ce=="string"?(this._name=this.name=ce,this._source=this.source=De,this.execution=Ge,rt=Qe,this.__deprecated=!0):ce===Ke.Global||ce===Ke.Workspace?(this.target=ce,this._name=this.name=De,this._source=this.source=Ge,this.execution=Qe,rt=Ze):(this.target=ce,this._name=this.name=De,this._source=this.source=Ge,this.execution=Qe,rt=Ze),typeof rt=="string"?(this._problemMatchers=[rt],this._hasDefinedMatchers=!0):Array.isArray(rt)?(this._problemMatchers=rt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(x){this.__id=x}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ie?this._definition={type:f.ProcessType,id:this._execution.computeId()}:this._execution instanceof Re?this._definition={type:f.ShellType,id:this._execution.computeId()}:this._execution instanceof ht?this._definition={type:f.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:f.EmptyType,id:(0,F.generateUuid)()}}get definition(){return this._definition}set definition(x){if(x==null)throw(0,n.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=x}get scope(){return this._scope}set target(x){this.clear(),this._scope=x}get name(){return this._name}set name(x){if(typeof x!="string")throw(0,n.illegalArgument)("name");this.clear(),this._name=x}get execution(){return this._execution}set execution(x){x===null&&(x=void 0),this.clear(),this._execution=x;const ce=this._definition.type;(f.EmptyType===ce||f.ProcessType===ce||f.ShellType===ce||f.ExtensionCallbackType===ce)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(x){if(Array.isArray(x))this.clear(),this._problemMatchers=x,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(x){x!==!0&&x!==!1&&(x=!1),this.clear(),this._isBackground=x}get source(){return this._source}set source(x){if(typeof x!="string"||x.length===0)throw(0,n.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=x}get group(){return this._group}set group(x){x===null&&(x=void 0),this.clear(),this._group=x}get detail(){return this._detail}set detail(x){x===null&&(x=void 0),this._detail=x}get presentationOptions(){return this._presentationOptions}set presentationOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._presentationOptions=x}get runOptions(){return this._runOptions}set runOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._runOptions=x}};Et.ExtensionCallbackType="customExecution",Et.ProcessType="process",Et.ShellType="shell",Et.EmptyType="$empty",Et=f=Be([L],Et),e.Task=Et;var St;(function(X){X[X.SourceControl=1]="SourceControl",X[X.Window=10]="Window",X[X.Notification=15]="Notification"})(St=e.ProgressLocation||(e.ProgressLocation={}));let ot=class{constructor(x,ce=dt.None){this.collapsibleState=ce,R.URI.isUri(x)?this.resourceUri=x:this.label=x}};ot=Be([L],ot),e.TreeItem=ot;var dt;(function(X){X[X.None=0]="None",X[X.Collapsed=1]="Collapsed",X[X.Expanded=2]="Expanded"})(dt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let ut=class{constructor(x){this.value=x}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}};ut=Be([L],ut),e.TreeDataTransferItem=ut;let Nt=class{constructor(){this._items=new Map}get(x){return this._items.get(x)}set(x,ce){this._items.set(x,ce)}forEach(x){this._items.forEach(x)}};Nt=Be([L],Nt),e.TreeDataTransfer=Nt;let pt=class{constructor(x,ce){this.id=x,this.color=ce}};pt=Be([L],pt),e.ThemeIcon=pt,pt.File=new pt("file"),pt.Folder=new pt("folder");let kt=class{constructor(x){this.id=x}};kt=Be([L],kt),e.ThemeColor=kt;var Ut;(function(X){X[X.Global=1]="Global",X[X.Workspace=2]="Workspace",X[X.WorkspaceFolder=3]="WorkspaceFolder"})(Ut=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ct=class{constructor(x,ce){if(typeof x!="string"&&(!x||!R.URI.isUri(x)&&!R.URI.isUri(x.uri)))throw(0,n.illegalArgument)("base");if(typeof ce!="string")throw(0,n.illegalArgument)("pattern");typeof x=="string"?this.baseUri=R.URI.file(x):R.URI.isUri(x)?this.baseUri=x:this.baseUri=x.uri,this.pattern=ce}get base(){return this._base}set base(x){this._base=x,this._baseUri=R.URI.file(x)}get baseUri(){return this._baseUri}set baseUri(x){this._baseUri=x,this._base=x.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Ct=Be([L],Ct),e.RelativePattern=Ct;let Bt=class{constructor(x,ce,De,Ge){this.enabled=typeof x=="boolean"?x:!0,typeof ce=="string"&&(this.condition=ce),typeof De=="string"&&(this.hitCondition=De),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,F.generateUuid)()),this._id}};Bt=Be([L],Bt),e.Breakpoint=Bt;let Ht=class extends Bt{constructor(x,ce,De,Ge,Qe){super(ce,De,Ge,Qe);if(x===null)throw(0,n.illegalArgument)("location");this.location=x}};Ht=Be([L],Ht),e.SourceBreakpoint=Ht;let bt=class extends Bt{constructor(x,ce,De,Ge,Qe){super(ce,De,Ge,Qe);this.functionName=x}};bt=Be([L],bt),e.FunctionBreakpoint=bt;let ei=class extends Bt{constructor(x,ce,De,Ge,Qe,Ze,rt){super(Ge,Qe,Ze,rt);if(!ce)throw(0,n.illegalArgument)("dataId");this.label=x,this.dataId=ce,this.canPersist=De}};ei=Be([L],ei),e.DataBreakpoint=ei;let Xt=class{constructor(x,ce,De){this.command=x,this.args=ce||[],this.options=De}};Xt=Be([L],Xt),e.DebugAdapterExecutable=Xt;let ti=class{constructor(x,ce){this.port=x,this.host=ce}};ti=Be([L],ti),e.DebugAdapterServer=ti;let ai=class{constructor(x){this.path=x}};ai=Be([L],ai),e.DebugAdapterNamedPipeServer=ai;let Pt=class{constructor(x){this.implementation=x}};Pt=Be([L],Pt),e.DebugAdapterInlineImplementation=Pt;let ii=class{constructor(x,ce){this.range=x,this.expression=ce}};ii=Be([L],ii),e.EvaluatableExpression=ii;var bi;(function(X){X[X.Automatic=0]="Automatic",X[X.Explicit=1]="Explicit"})(bi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let qt=class{constructor(x,ce){this.range=x,this.text=ce}};qt=Be([L],qt),e.InlineValueText=qt;let Gt=class{constructor(x,ce,De=!0){this.range=x,this.variableName=ce,this.caseSensitiveLookup=De}};Gt=Be([L],Gt),e.InlineValueVariableLookup=Gt;let at=class{constructor(x,ce){this.range=x,this.expression=ce}};at=Be([L],at),e.InlineValueEvaluatableExpression=at;let li=class{constructor(x,ce){this.frameId=x,this.stoppedLocation=ce}};li=Be([L],li),e.InlineValueContext=li;var $t;(function(X){X[X.Changed=1]="Changed",X[X.Created=2]="Created",X[X.Deleted=3]="Deleted"})($t=e.FileChangeType||(e.FileChangeType={}));let xt=u=class extends Error{constructor(x,ce=D.FileSystemProviderErrorCode.Unknown,De){super(R.URI.isUri(x)?x.toString(!0):x);this.code=De?.name??"Unknown",(0,D.markAsFileSystemProviderError)(this,ce),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,u.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}static FileExists(x){return new u(x,D.FileSystemProviderErrorCode.FileExists,u.FileExists)}static FileNotFound(x){return new u(x,D.FileSystemProviderErrorCode.FileNotFound,u.FileNotFound)}static FileNotADirectory(x){return new u(x,D.FileSystemProviderErrorCode.FileNotADirectory,u.FileNotADirectory)}static FileIsADirectory(x){return new u(x,D.FileSystemProviderErrorCode.FileIsADirectory,u.FileIsADirectory)}static NoPermissions(x){return new u(x,D.FileSystemProviderErrorCode.NoPermissions,u.NoPermissions)}static Unavailable(x){return new u(x,D.FileSystemProviderErrorCode.Unavailable,u.Unavailable)}};xt=u=Be([L],xt),e.FileSystemError=xt;let ni=class{constructor(x,ce,De){this.start=x,this.end=ce,this.kind=De}};ni=Be([L],ni),e.FoldingRange=ni;var _i;(function(X){X[X.Comment=1]="Comment",X[X.Imports=2]="Imports",X[X.Region=3]="Region"})(_i=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fi;(function(X){X[X.Collapsed=0]="Collapsed",X[X.Expanded=1]="Expanded"})(fi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Si;(function(X){X[X.Editing=0]="Editing",X[X.Preview=1]="Preview"})(Si=e.CommentMode||(e.CommentMode={}));var mi;(function(X){X[X.Unresolved=0]="Unresolved",X[X.Resolved=1]="Resolved"})(mi=e.CommentThreadState||(e.CommentThreadState={}));class ri{constructor(x,ce=[]){this.tokenTypes=x,this.tokenModifiers=ce}}e.SemanticTokensLegend=ri;function Ci(X){return typeof X=="undefined"||(0,S.isStringArray)(X)}class Qt{constructor(x){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,x){this._hasLegend=!0;for(let ce=0,De=x.tokenTypes.length;ce<De;ce++)this._tokenTypeStrToInt.set(x.tokenTypes[ce],ce);for(let ce=0,De=x.tokenModifiers.length;ce<De;ce++)this._tokenModifierStrToInt.set(x.tokenModifiers[ce],ce)}}push(x,ce,De,Ge,Qe){if(typeof x=="number"&&typeof ce=="number"&&typeof De=="number"&&typeof Ge=="number"&&(typeof Qe=="number"||typeof Qe=="undefined"))return typeof Qe=="undefined"&&(Qe=0),this._pushEncoded(x,ce,De,Ge,Qe);if(z.isRange(x)&&typeof ce=="string"&&Ci(De))return this._push(x,ce,De);throw(0,n.illegalArgument)()}_push(x,ce,De){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(x.start.line!==x.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ce))throw new Error("`tokenType` is not in the provided legend");const Ge=x.start.line,Qe=x.start.character,Ze=x.end.character-x.start.character,rt=this._tokenTypeStrToInt.get(ce);let Dt=0;if(De)for(const At of De){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Wt=this._tokenModifierStrToInt.get(At);Dt|=1<<Wt>>>0}this._pushEncoded(Ge,Qe,Ze,rt,Dt)}_pushEncoded(x,ce,De,Ge,Qe){if(this._dataIsSortedAndDeltaEncoded&&(x<this._prevLine||x===this._prevLine&&ce<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Dt=this._data.length/5|0;let At=0,Wt=0;for(let zt=0;zt<Dt;zt++){let Vt=this._data[5*zt],di=this._data[5*zt+1];Vt===0?(Vt=At,di+=Wt):Vt+=At,this._data[5*zt]=Vt,this._data[5*zt+1]=di,At=Vt,Wt=di}}let Ze=x,rt=ce;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Ze-=this._prevLine,Ze===0&&(rt-=this._prevChar)),this._data[this._dataLen++]=Ze,this._data[this._dataLen++]=rt,this._data[this._dataLen++]=De,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=Qe,this._prevLine=x,this._prevChar=ce}static _sortAndDeltaEncode(x){let ce=[];const De=x.length/5|0;for(let rt=0;rt<De;rt++)ce[rt]=rt;ce.sort((rt,Dt)=>{const At=x[5*rt],Wt=x[5*Dt];if(At===Wt){const zt=x[5*rt+1],Vt=x[5*Dt+1];return zt-Vt}return At-Wt});const Ge=new Uint32Array(x.length);let Qe=0,Ze=0;for(let rt=0;rt<De;rt++){const Dt=5*ce[rt],At=x[Dt+0],Wt=x[Dt+1],zt=x[Dt+2],Vt=x[Dt+3],di=x[Dt+4],xi=At-Qe,Ji=xi===0?Wt-Ze:Wt,hi=5*rt;Ge[hi+0]=xi,Ge[hi+1]=Ji,Ge[hi+2]=zt,Ge[hi+3]=Vt,Ge[hi+4]=di,Qe=At,Ze=Wt}return Ge}build(x){return this._dataIsSortedAndDeltaEncoded?new Yt(new Uint32Array(this._data),x):new Yt(Qt._sortAndDeltaEncode(this._data),x)}}e.SemanticTokensBuilder=Qt;class Yt{constructor(x,ce){this.resultId=ce,this.data=x}}e.SemanticTokens=Yt;class yi{constructor(x,ce,De){this.start=x,this.deleteCount=ce,this.data=De}}e.SemanticTokensEdit=yi;class Di{constructor(x,ce){this.resultId=ce,this.edits=x}}e.SemanticTokensEdits=Di;var Jt;(function(X){X[X.Separate=0]="Separate",X[X.MergeWithParent=1]="MergeWithParent"})(Jt=e.DebugConsoleMode||(e.DebugConsoleMode={}));let si=class{constructor(){}};si.Back={iconPath:new pt("arrow-left")},si=Be([L],si),e.QuickInputButtons=si;var Ii;(function(X){X[X.Separator=-1]="Separator",X[X.Default=0]="Default"})(Ii=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(X){X[X.UI=1]="UI",X[X.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class Pi{constructor(x,ce,De){this.badge=x,this.tooltip=ce,this.color=De}static validate(x){if(x.badge){let ce=(0,k.nextCharLength)(x.badge,0);if(ce<x.badge.length&&(ce+=(0,k.nextCharLength)(x.badge,ce)),x.badge.length>ce)throw new Error("The 'badge'-property must be undefined or a short character")}if(!x.color&&!x.badge&&!x.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Pi;let Zt=class{constructor(x){this.kind=x}};Zt=Be([L],Zt),e.ColorTheme=Zt;var gi;(function(X){X[X.Light=1]="Light",X[X.Dark=2]="Dark",X[X.HighContrast=3]="HighContrast"})(gi=e.ColorThemeKind||(e.ColorThemeKind={}));class Kt{constructor(x,ce){if(x<0)throw(0,n.illegalArgument)("start must be positive");if(ce<0)throw(0,n.illegalArgument)("end must be positive");x<=ce?(this._start=x,this._end=ce):(this._start=ce,this._end=x)}static isNotebookRange(x){return x instanceof Kt?!0:x?typeof x.start=="number"&&typeof x.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(x){let ce=this._start,De=this._end;return x.start!==void 0&&(ce=x.start),x.end!==void 0&&(De=x.end),ce===this._start&&De===this._end?this:new Kt(ce,De)}}e.NotebookRange=Kt;class Oe{constructor(x,ce,De,Ge,Qe,Ze,rt){this.kind=x,this.value=ce,this.languageId=De,this.mime=Ge,this.outputs=Qe??[],this.metadata=Ze,this.executionSummary=rt,Oe.validate(this)}static validate(x){if(typeof x.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof x.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof x.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(x){return Array.isArray(x)&&x.every(ce=>Oe.isNotebookCellData(ce))}static isNotebookCellData(x){return!0}}e.NotebookCellData=Oe;class ci{constructor(x){this.cells=x}}e.NotebookData=ci;class Ot{constructor(x,ce){this.data=x,this.mime=ce;const De=(0,C.normalizeMimeType)(ce,!0);if(!De)throw new Error(`INVALID mime type: ${ce}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}static isNotebookCellOutputItem(x){return x instanceof Ot?!0:x?typeof x.mime=="string"&&x.data instanceof Uint8Array:!1}static error(x){const ce={name:x.name,message:x.message,stack:x.stack};return Ot.json(ce,"application/vnd.code.notebook.error")}static stdout(x){return Ot.text(x,"application/vnd.code.notebook.stdout")}static stderr(x){return Ot.text(x,"application/vnd.code.notebook.stderr")}static bytes(x,ce="application/octet-stream"){return new Ot(x,ce)}static text(x,ce=C.Mimes.text){const De=Pe(Ot,d,"f",v).encode(String(x));return new Ot(De,ce)}static json(x,ce="application/json"){const De=JSON.stringify(x,void 0,"	");return Ot.text(De,ce)}}e.NotebookCellOutputItem=Ot,d=Ot,v={value:new TextEncoder};class ft{constructor(x,ce,De){this.items=ft.ensureUniqueMimeTypes(x,!0),typeof ce=="string"?(this.id=ce,this.metadata=De):(this.id=(0,F.generateUuid)(),this.metadata=ce??De)}static isNotebookCellOutput(x){return x instanceof ft?!0:!x||typeof x!="object"?!1:typeof x.id=="string"&&(0,S.isArray)(x.items)}static ensureUniqueMimeTypes(x,ce=!1){const De=new Set,Ge=new Set;for(let Qe=0;Qe<x.length;Qe++){const Ze=x[Qe],rt=(0,C.normalizeMimeType)(Ze.mime);if(!De.has(rt)){De.add(rt);continue}Ge.add(Qe),ce&&console.warn(`DUPLICATED mime type '${Ze.mime}' will be dropped`)}return Ge.size===0?x:x.filter((Qe,Ze)=>!Ge.has(Ze))}}e.NotebookCellOutput=ft;var Ti;(function(X){X[X.Markup=1]="Markup",X[X.Code=2]="Code"})(Ti=e.NotebookCellKind||(e.NotebookCellKind={}));var Ai;(function(X){X[X.Idle=1]="Idle",X[X.Pending=2]="Pending",X[X.Executing=3]="Executing"})(Ai=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var pi;(function(X){X[X.Left=1]="Left",X[X.Right=2]="Right"})(pi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var vi;(function(X){X[X.Default=0]="Default",X[X.InCenter=1]="InCenter",X[X.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",X[X.AtTop=3]="AtTop"})(vi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ri{constructor(x,ce){this.text=x,this.alignment=ce}}e.NotebookCellStatusBarItem=Ri;var Li;(function(X){X[X.Default=1]="Default",X[X.Preferred=2]="Preferred"})(Li=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Oi{constructor(x,ce=[]){this.uri=x,this.provides=(0,h.asArray)(ce)}}e.NotebookRendererScript=Oi;let ui=class{constructor(x,ce){this.label=x,this.timestamp=ce}};ui=Be([L],ui),e.TimelineItem=ui;var wi;(function(X){X[X.Production=1]="Production",X[X.Development=2]="Development",X[X.Test=3]="Test"})(wi=e.ExtensionMode||(e.ExtensionMode={}));var Fi;(function(X){X[X.Node=1]="Node",X[X.Webworker=2]="Webworker"})(Fi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ni;(function(X){X[X.Other=0]="Other",X[X.Comment=1]="Comment",X[X.String=2]="String",X[X.RegEx=3]="RegEx"})(Ni=e.StandardTokenType||(e.StandardTokenType={}));class Mi{constructor(x,ce){this.ranges=x,this.wordPattern=ce}}e.LinkedEditingRanges=Mi;class Ui{constructor(x,ce){this._port=x,this._autoForwardAction=ce}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ui;var Bi;(function(X){X[X.Queued=1]="Queued",X[X.Running=2]="Running",X[X.Passed=3]="Passed",X[X.Failed=4]="Failed",X[X.Skipped=5]="Skipped",X[X.Errored=6]="Errored"})(Bi=e.TestResultState||(e.TestResultState={}));var le;(function(X){X[X.Run=1]="Run",X[X.Debug=2]="Debug",X[X.Coverage=3]="Coverage"})(le=e.TestRunProfileKind||(e.TestRunProfileKind={}));let me=class{constructor(x=void 0,ce=void 0,De=void 0){this.include=x,this.exclude=ce,this.profile=De}};me=Be([L],me),e.TestRunRequest=me;let ke=w=class{constructor(x){this.message=x}static diff(x,ce,De){const Ge=new w(x);return Ge.expectedOutput=ce,Ge.actualOutput=De,Ge}};ke=w=Be([L],ke),e.TestMessage=ke;let tt=class{constructor(x){this.id=x}};tt=Be([L],tt),e.TestTag=tt;let gt=class{constructor(x,ce){this.covered=x,this.total=ce}};gt=Be([L],gt),e.CoveredCount=gt;let It=P=class{constructor(x,ce,De,Ge){this.uri=x,this.statementCoverage=ce,this.branchCoverage=De,this.functionCoverage=Ge}static fromDetails(x,ce){const De=new gt(0,0),Ge=new gt(0,0),Qe=new gt(0,0);for(const rt of ce)if("branches"in rt){De.total+=1,De.covered+=rt.executionCount>0?1:0;for(const Dt of rt.branches)Ge.total+=1,Ge.covered+=Dt.executionCount>0?1:0}else Qe.total+=1,Qe.covered+=rt.executionCount>0?1:0;const Ze=new P(x,De,Ge.total>0?Ge:void 0,Qe.total>0?Qe:void 0);return Ze.detailedCoverage=ce,Ze}};It=P=Be([L],It),e.FileCoverage=It;let Wi=class{constructor(x,ce,De=[]){this.executionCount=x,this.location=ce,this.branches=De}};Wi=Be([L],Wi),e.StatementCoverage=Wi;let zi=class{constructor(x,ce){this.executionCount=x,this.location=ce}};zi=Be([L],zi),e.BranchCoverage=zi;let Hi=class{constructor(x,ce){this.executionCount=x,this.location=ce}};Hi=Be([L],Hi),e.FunctionCoverage=Hi;var Ki;(function(X){X[X.None=0]="None",X[X.Option=1]="Option",X[X.Default=2]="Default",X[X.Preferred=3]="Preferred"})(Ki=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Xi;(function(X){X[X.Untrusted=0]="Untrusted",X[X.Trusted=1]="Trusted",X[X.Unspecified=2]="Unspecified"})(Xi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Qi;(function(X){X[X.Notify=1]="Notify",X[X.OpenBrowser=2]="OpenBrowser",X[X.OpenPreview=3]="OpenPreview",X[X.Silent=4]="Silent",X[X.Ignore=5]="Ignore",X[X.OpenBrowserOnce=6]="OpenBrowserOnce"})(Qi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Yi{constructor(x,ce,De,Ge,Qe,Ze){this.kind=x,this.name=ce,this.detail=De,this.uri=Ge,this.range=Qe,this.selectionRange=Ze}}e.TypeHierarchyItem=Yi}),define(ve[125],we([1,0,55,10,8,151,107,7,18]),function(ee,e,h,n,I,T,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const R=new Map;function F(g,d){d?R.set(g,d):R.delete(g)}e.setWordDefinitionFor=F;function D(g){return R.get(g)}e.getWordDefinitionFor=D;class p extends T.MirrorTextModel{constructor(d,v,A,b,a,c,m,s){super(v,A,b,a);this._proxy=d,this._languageId=c,this._isDirty=m,this._notebook=s,this._isDisposed=!1}dispose(){(0,h.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(d){return(0,S.equals)(this._lines,d)}get document(){if(!this._document){const d=this;this._document={get uri(){return d._uri},get fileName(){return d._uri.fsPath},get isUntitled(){return d._uri.scheme===n.Schemas.untitled},get languageId(){return d._languageId},get version(){return d._versionId},get isClosed(){return d._isDisposed},get isDirty(){return d._isDirty},get notebook(){return d._notebook},save(){return d._save()},getText(v){return v?d._getTextInRange(v):d.getText()},get eol(){return d._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return d._lines.length},lineAt(v){return d._lineAt(v)},offsetAt(v){return d._offsetAt(v)},positionAt(v){return d._positionAt(v)},validateRange(v){return d._validateRange(v)},validatePosition(v){return d._validatePosition(v)},getWordRangeAtPosition(v,A){return d._getWordRangeAtPosition(v,A)}}}return Object.freeze(this._document)}_acceptLanguageId(d){(0,h.ok)(!this._isDisposed),this._languageId=d}_acceptIsDirty(d){(0,h.ok)(!this._isDisposed),this._isDirty=d}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(d){const v=this._validateRange(d);if(v.isEmpty)return"";if(v.isSingleLine)return this._lines[v.start.line].substring(v.start.character,v.end.character);const A=this._eol,b=v.start.line,a=v.end.line,c=[];c.push(this._lines[b].substring(v.start.character));for(let m=b+1;m<a;m++)c.push(this._lines[m]);return c.push(this._lines[a].substring(0,v.end.character)),c.join(A)}_lineAt(d){let v;if(d instanceof k.Position?v=d.line:typeof d=="number"&&(v=d),typeof v!="number"||v<0||v>=this._lines.length||Math.floor(v)!==v)throw new Error("Illegal value for `line`");return new _(v,this._lines[v],v===this._lines.length-1)}_offsetAt(d){return d=this._validatePosition(d),this._ensureLineStarts(),this._lineStarts.getPrefixSum(d.line-1)+d.character}_positionAt(d){d=Math.floor(d),d=Math.max(0,d),this._ensureLineStarts();const v=this._lineStarts.getIndexOf(d),A=this._lines[v.index].length;return new k.Position(v.index,Math.min(v.remainder,A))}_validateRange(d){if(!(d instanceof k.Range))throw new Error("Invalid argument");const v=this._validatePosition(d.start),A=this._validatePosition(d.end);return v===d.start&&A===d.end?d:new k.Range(v.line,v.character,A.line,A.character)}_validatePosition(d){if(!(d instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return d.with(0,0);let{line:v,character:A}=d,b=!1;if(v<0)v=0,A=0,b=!0;else if(v>=this._lines.length)v=this._lines.length-1,A=this._lines[v].length,b=!0;else{const a=this._lines[v].length;A<0?(A=0,b=!0):A>a&&(A=a,b=!0)}return b?new k.Position(v,A):d}_getWordRangeAtPosition(d,v){const A=this._validatePosition(d);if(!v)v=D(this._languageId);else if((0,I.regExpLeadsToEndlessLoop)(v))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${v.source}' because it matches the empty string.`);const b=(0,C.getWordAtText)(A.character+1,(0,C.ensureValidWordDefinition)(v),this._lines[A.line],0);if(b)return new k.Range(A.line,b.startColumn-1,A.line,b.endColumn-1)}}e.ExtHostDocumentData=p;class _{constructor(d,v,A){this._line=d,this._text=v,this._isLastLine=A}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=_}),define(ve[202],we([1,0,7,3,110,6,108,24,2,33]),function(ee,e,h,n,I,T,C,k,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class F{constructor(p,_,g,d){this._notebook=g,this._selector=d,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new n.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,R.generateUuid)()}),this._init(),this._disposables.add(_.onDidChangeDocument(A=>{const b=this._cellUris.get(A.document.uri);b!==void 0&&(this._cellLengths.setValue(b,this._cells[b].document.getText().length+1),this._cellLines.setValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const v=A=>{A===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(p.onDidChangeNotebookCells(A=>v(A.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const p=[],_=[];for(const g of this._notebook.getCells())g.kind===h.NotebookCellKind.Code&&(!this._selector||(0,C.score)(this._selector,g.document.uri,g.document.languageId,!0,void 0))&&(this._cellUris.set(g.document.uri,this._cells.length),this._cells.push(g),p.push(g.document.getText().length+1),_.push(g.document.lineCount));this._cellLengths=new I.PrefixSumComputer(new Uint32Array(p)),this._cellLines=new I.PrefixSumComputer(new Uint32Array(_))}get version(){return this._versionId}getText(p){if(!p){let b="";for(const a of this._cells)b+=a.document.getText()+`
`;return b=b.slice(0,-1),b}if(p.isEmpty)return"";const _=this.locationAt(p.start),g=this.locationAt(p.end),d=this._cellUris.get(_.uri),v=this._cellUris.get(g.uri);if(d===void 0||v===void 0)return"";if(d===v)return this._cells[d].document.getText(new h.Range(_.range.start,g.range.end));const A=[this._cells[d].document.getText(new h.Range(_.range.start,new h.Position(this._cells[d].document.lineCount,0)))];for(let b=d+1;b<v;b++)A.push(this._cells[b].document.getText());return A.push(this._cells[v].document.getText(new h.Range(new h.Position(0,0),g.range.end))),A.join(`
`)}offsetAt(p){const _=this._cellLines.getIndexOf(p.line),g=this._cellLengths.getPrefixSum(_.index-1),d=this._cells[_.index].document.offsetAt(p.with(_.remainder));return g+d}positionAt(p){if(typeof p=="number"){const g=this._cellLengths.getIndexOf(p),d=this._cellLines.getPrefixSum(g.index-1);return this._cells[g.index].document.positionAt(g.remainder).translate(d)}const _=this._cellUris.get(p.uri);if(_!==void 0){const g=this._cellLines.getPrefixSum(_-1);return new h.Position(g+p.range.start.line,p.range.start.character)}return new h.Position(0,0)}locationAt(p){h.Range.isRange(p)||(p=new h.Range(p,p));const _=this._cellLines.getIndexOf(p.start.line);let g=_;p.isEmpty||(g=this._cellLines.getIndexOf(p.end.line));const d=new h.Position(_.remainder,p.start.character),v=new h.Position(g.remainder,p.end.character),A=new h.Range(d,v),b=this._cells[_.index];return new h.Location(b.document.uri,b.document.validateRange(A))}contains(p){return this._cellUris.has(p)}validateRange(p){const _=this.validatePosition(p.start),g=this.validatePosition(p.end);return p.with(_,g)}validatePosition(p){const _=this._cellLines.getIndexOf(p.line),g=new h.Position(_.remainder,p.character),d=this._cells[_.index].document.validatePosition(g),v=this._cellLines.getPrefixSum(_.index-1);return new h.Position(v+d.line,d.character)}}e.ExtHostNotebookConcatDocument=F}),define(ve[203],we([1,0,7,16,3]),function(ee,e,h,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(k){this._actual=new h.ColorTheme(h.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new I.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let S=k==="light"?h.ColorThemeKind.Light:k==="dark"?h.ColorThemeKind.Dark:h.ColorThemeKind.HighContrast;this._actual=new h.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=Be([Fe(0,n.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(ve[63],we([1,0,4]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,h.createDecorator)("IURITransformerService");class n{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=C=>C,this.transformOutgoing=C=>C,this.transformOutgoingURI=C=>C,this.transformOutgoingScheme=C=>C)}}e.URITransformerService=n}),define(ve[204],we([1,0,22]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class n{constructor(){this.buffers=[]}add(S){let R=this.buffers.indexOf(S);return R<0&&(R=this.buffers.length,this.buffers.push(S)),R}}function I(k,S){if(S.serializeBuffersForPostMessage){const R=new n,F=(_,g)=>{if(g instanceof ArrayBuffer){const d=R.add(g);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(g)){const d=T(g);if(d){const v=R.add(g.buffer);return{$$vscode_array_buffer_reference$$:!0,index:v,view:{type:d,byteLength:g.byteLength,byteOffset:g.byteOffset}}}}return g},D=JSON.stringify(k,F),p=R.buffers.map(_=>{const g=new Uint8Array(_);return h.VSBuffer.wrap(g)});return{message:D,buffers:p}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=I;function T(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function C(k,S){const R=S.map(p=>{const _=new ArrayBuffer(p.byteLength);return new Uint8Array(_).set(p.buffer),_}),F=S.length?(p,_)=>{if(_&&typeof _=="object"&&_.$$vscode_array_buffer_reference$$){const g=_,{index:d}=g,v=R[d];if(g.view)switch(g.view.type){case 1:return new Int8Array(v,g.view.byteOffset,g.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(v,g.view.byteOffset,g.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(v,g.view.byteOffset,g.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(v,g.view.byteOffset,g.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(v,g.view.byteOffset,g.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(v,g.view.byteOffset,g.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(v,g.view.byteOffset,g.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(v,g.view.byteOffset,g.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(v,g.view.byteOffset,g.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(v,g.view.byteOffset,g.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(v,g.view.byteOffset,g.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return v}return _}:void 0;return{message:JSON.parse(k,F),arrayBuffers:R}}e.deserializeWebviewMessage=C}),define(ve[205],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var h;(function(n){function I(C){const k=new Map;return C.types.forEach((S,R)=>{k.set(S,{asString:async()=>C.items[R].asString,value:void 0})}),k}n.toITreeDataTransfer=I;async function T(C){const k={types:[],items:[]},S=Array.from(C.entries());for(const R of S)k.types.push(R[0]),k.items.push({asString:await R[1].asString()});return k}n.toTreeDataTransferDTO=T})(h=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(ve[206],we([1,0,101]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function n(T){return{transformIncoming:C=>C.scheme==="vscode-remote"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="file"?{scheme:"vscode-local",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoing:C=>C.scheme==="file"?{scheme:"vscode-remote",authority:T,path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="vscode-local"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoingScheme:C=>C==="file"?"vscode-remote":C==="vscode-local"?"file":C}}function I(T){return new h.URITransformer(n(T))}e.createURITransformer=I}),define(ve[207],we([1,0,175,13,2,6,4,50,42,18,10]),function(ee,e,h,n,I,T,C,k,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,h.localize)(0,null),providerDisplayName:(0,h.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var D;(function(B){B[B.PROGRAMMATIC=1]="PROGRAMMATIC",B[B.USER=2]="USER",B[B.EDIT=3]="EDIT",B[B.NAVIGATION=4]="NAVIGATION",B[B.JUMP=5]="JUMP"})(D=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var p;(function(B){B[B.IDENTICAL=1]="IDENTICAL",B[B.SIMILAR=2]="SIMILAR",B[B.DIFFERENT=3]="DIFFERENT"})(p=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function _(B){const V=B;return!!V&&typeof V.getSelection=="function"&&!!V.onDidChangeSelection}e.isEditorPaneWithSelection=_;function g(B,V,Y){for(const H of Y.visibleEditorPanes)if(H.group.id===V&&B.matches(H.input))return H.getViewState()}e.findViewStateForEditor=g;function d(B){if(E(B))return!1;const V=B;return I.URI.isUri(V?.resource)}e.isResourceEditorInput=d;function v(B){if(E(B))return!1;const V=B;return V?.original!==void 0&&V.modified!==void 0}e.isResourceDiffEditorInput=v;function A(B){if(E(B)||v(B))return!1;const V=B;return V?.primary!==void 0&&V.secondary!==void 0}e.isResourceSideBySideEditorInput=A;function b(B){if(E(B))return!1;const V=B;return V?V.resource===void 0||V.resource.scheme===F.Schemas.untitled||V.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=b;var a;(function(B){B[B.SHORT=0]="SHORT",B[B.MEDIUM=1]="MEDIUM",B[B.LONG=2]="LONG"})(a=e.Verbosity||(e.Verbosity={}));var c;(function(B){B[B.EXPLICIT=1]="EXPLICIT",B[B.AUTO=2]="AUTO",B[B.FOCUS_CHANGE=3]="FOCUS_CHANGE",B[B.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c=e.SaveReason||(e.SaveReason={}));var m;(function(B){B[B.None=0]="None",B[B.Readonly=2]="Readonly",B[B.Untitled=4]="Untitled",B[B.Singleton=8]="Singleton",B[B.RequiresTrust=16]="RequiresTrust",B[B.CanSplitInGroup=32]="CanSplitInGroup",B[B.ForceDescription=64]="ForceDescription"})(m=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class s extends T.Disposable{}e.AbstractEditorInput=s;function E(B){return B instanceof s}e.isEditorInput=E;function l(B){const V=B;return I.URI.isUri(V?.preferredResource)}function i(B){const V=B;return E(V?.primary)&&E(V?.secondary)}e.isSideBySideEditorInput=i;function r(B){const V=B;return E(V?.modified)&&E(V?.original)}e.isDiffEditorInput=r;function t(B){return E(B?.editor)}e.isEditorInputWithOptions=t;function o(B){const V=B;return t(B)&&V?.group!==void 0}e.isEditorInputWithOptionsAndGroup=o;function f(B){const V=B;return typeof V?.groupId=="number"&&E(V.editor)}e.isEditorIdentifier=f;var u;(function(B){B[B.UNKNOWN=0]="UNKNOWN",B[B.REPLACE=1]="REPLACE",B[B.MOVE=2]="MOVE",B[B.UNPIN=3]="UNPIN"})(u=e.EditorCloseContext||(e.EditorCloseContext={}));var w;(function(B){B[B.GROUP_ACTIVE=0]="GROUP_ACTIVE",B[B.GROUP_INDEX=1]="GROUP_INDEX",B[B.GROUP_LOCKED=2]="GROUP_LOCKED",B[B.EDITOR_OPEN=3]="EDITOR_OPEN",B[B.EDITOR_CLOSE=4]="EDITOR_CLOSE",B[B.EDITOR_MOVE=5]="EDITOR_MOVE",B[B.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",B[B.EDITOR_LABEL=7]="EDITOR_LABEL",B[B.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",B[B.EDITOR_PIN=9]="EDITOR_PIN",B[B.EDITOR_STICKY=10]="EDITOR_STICKY",B[B.EDITOR_DIRTY=11]="EDITOR_DIRTY",B[B.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(w=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var P;(function(B){B[B.PRIMARY=1]="PRIMARY",B[B.SECONDARY=2]="SECONDARY",B[B.BOTH=3]="BOTH",B[B.ANY=4]="ANY"})(P=e.SideBySideEditor||(e.SideBySideEditor={}));class L{getOriginalUri(V,Y){if(!V)return;if(Y?.supportSideBySide){const{primary:q,secondary:K}=this.getSideEditors(V);if(q&&K){if(Y?.supportSideBySide===P.BOTH)return{primary:this.getOriginalUri(q,{filterByScheme:Y.filterByScheme}),secondary:this.getOriginalUri(K,{filterByScheme:Y.filterByScheme})};if(Y?.supportSideBySide===P.ANY)return this.getOriginalUri(q,{filterByScheme:Y.filterByScheme})??this.getOriginalUri(K,{filterByScheme:Y.filterByScheme});V=Y.supportSideBySide===P.PRIMARY?q:K}}if(v(V)||A(V))return;const H=l(V)?V.preferredResource:V.resource;return!H||!Y||!Y.filterByScheme?H:this.filterUri(H,Y.filterByScheme)}getSideEditors(V){return i(V)||A(V)?{primary:V.primary,secondary:V.secondary}:r(V)||v(V)?{primary:V.modified,secondary:V.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(V,Y){if(!V)return;if(Y?.supportSideBySide){const{primary:q,secondary:K}=this.getSideEditors(V);if(q&&K){if(Y?.supportSideBySide===P.BOTH)return{primary:this.getCanonicalUri(q,{filterByScheme:Y.filterByScheme}),secondary:this.getCanonicalUri(K,{filterByScheme:Y.filterByScheme})};if(Y?.supportSideBySide===P.ANY)return this.getCanonicalUri(q,{filterByScheme:Y.filterByScheme})??this.getCanonicalUri(K,{filterByScheme:Y.filterByScheme});V=Y.supportSideBySide===P.PRIMARY?q:K}}if(v(V)||A(V))return;const H=V.resource;return!H||!Y||!Y.filterByScheme?H:this.filterUri(H,Y.filterByScheme)}filterUri(V,Y){if(Array.isArray(Y)){if(Y.some(H=>V.scheme===H))return V}else if(Y===V.scheme)return V}}e.EditorResourceAccessor=new L;var O;(function(B){B[B.LEFT=0]="LEFT",B[B.RIGHT=1]="RIGHT"})(O=e.CloseDirection||(e.CloseDirection={}));class y{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(V){const Y=this.instantiationService=V.get(C.IInstantiationService);for(const[H,q]of this.editorSerializerConstructors)this.createEditorSerializer(H,q,Y);this.editorSerializerConstructors.clear()}createEditorSerializer(V,Y,H){const q=H.createInstance(Y);this.editorSerializerInstances.set(V,q)}registerFileEditorFactory(V){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=V}getFileEditorFactory(){return(0,n.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(V,Y){if(this.editorSerializerConstructors.has(V)||this.editorSerializerInstances.has(V))throw new Error(`A editor serializer with type ID '${V}' was already registered.`);return this.instantiationService?this.createEditorSerializer(V,Y,this.instantiationService):this.editorSerializerConstructors.set(V,Y),(0,T.toDisposable)(()=>{this.editorSerializerConstructors.delete(V),this.editorSerializerInstances.delete(V)})}getEditorSerializer(V){return this.editorSerializerInstances.get(typeof V=="string"?V:V.typeId)}}k.Registry.add(e.EditorExtensions.EditorFactory,new y);async function z(B,V){if(!B||!B.length)return[];const Y=await Promise.all(B.map(async H=>{const q=I.URI.revive(H.fileUri);if(!q||!await V.canHandleResource(q))return;let G=H.exists,ie=H.type;if(typeof G!="boolean"||typeof ie!="number")try{ie=(await V.stat(q)).isDirectory?S.FileType.Directory:S.FileType.Unknown,G=!0}catch{G=!1}if(!G&&H.openOnlyIfExists||ie===S.FileType.Directory)return;const oe={selection:G?H.selection:void 0,pinned:!0,override:H.editorOverrideId};let ue;return G?ue={resource:q,options:oe}:ue={resource:q,options:oe,forceUntitled:!0},ue}));return(0,R.coalesce)(Y)}e.pathsToEditors=z;var M;(function(B){B[B.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",B[B.SEQUENTIAL=1]="SEQUENTIAL"})(M=e.EditorsOrder||(e.EditorsOrder={}))}),define(ve[83],we([1,0,10,2]),function(ee,e,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function I(k,S){return k.scheme===h.Schemas.http||k.scheme===h.Schemas.https?k:(S&&S.authority&&S.isRemote&&k.scheme===h.Schemas.file&&(k=n.URI.from({scheme:h.Schemas.vscodeRemote,authority:S.authority,path:k.path})),n.URI.from({scheme:h.Schemas.https,authority:`${k.scheme}+${T(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=I;function T(k){return k.replace(/./g,S=>{const R=S.charCodeAt(0);return R>=97&&R<=122||R>=65&&R<=90||R>=48&&R<=57?S:"-"+R.toString(16).padStart(4,"0")})}function C(k){return k.replace(/-([0-9a-f]{4})/g,(S,R)=>String.fromCharCode(parseInt(R,16)))}e.decodeAuthority=C}),define(ve[208],we([1,0,3,6,83]),function(ee,e,h,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class T{constructor(k,S,R){this._proxy=k,this._editors=S,this._initData=R,this._handlePool=0,this._disposables=new n.DisposableStore,this._insets=new Map,this._disposables.add(S.onDidChangeVisibleTextEditors(()=>{const F=S.getVisibleTextEditors();for(const D of this._insets.values())F.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,S,R,F,D){let p;for(const a of this._editors.getVisibleTextEditors(!0))if(a.value===k){p=a;break}if(!p)throw new Error("not a visible editor");const _=this,g=this._handlePool++,d=new h.Emitter,v=new h.Emitter,A=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(a){return(0,I.asWebviewUri)(a,_._initData.remote)}get cspSource(){return I.webviewGenericCspSource}set options(a){this._options=a,_._proxy.$setOptions(g,a)}get options(){return this._options}set html(a){this._html=a,_._proxy.$setHtml(g,a)}get html(){return this._html}get onDidReceiveMessage(){return d.event}postMessage(a){return _._proxy.$postMessage(g,a)}},b=new class{constructor(){this.editor=k,this.line=S,this.height=R,this.webview=A,this.onDidDispose=v.event}dispose(){_._insets.has(g)&&(_._insets.delete(g),_._proxy.$disposeEditorInset(g),v.fire(),v.dispose(),d.dispose())}};return this._proxy.$createEditorInset(g,p.id,p.value.document.uri,S+1,R,F||{},D.identifier,D.extensionLocation),this._insets.set(g,{editor:k,inset:b,onDidReceiveMessage:d}),b}$onDidDispose(k){const S=this._insets.get(k);S&&S.inset.dispose()}$onDidReceiveMessage(k,S){const R=this._insets.get(k);R&&R.onDidReceiveMessage.fire(S)}}e.ExtHostEditorInsets=T}),define(ve[126],we([1,0,3,15,176]),function(ee,e,h,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new h.Emitter,this._onExit=new h.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,S,R,F){const D={command:k};if(S&&Object.keys(S).length>0&&(D.arguments=S),this.internalSend("request",D),typeof F=="number"){const p=setTimeout(()=>{clearTimeout(p);const _=this.pendingRequests.get(D.seq);if(_){this.pendingRequests.delete(D.seq);const g={type:"response",seq:0,request_seq:D.seq,success:!1,command:k,message:(0,I.localize)(0,null,F,k)};_(g)}},F)}return R&&this.pendingRequests.set(D.seq,R),D.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,S){return k.type!=="event"||S.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,n.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":{const S=k,R=this.pendingRequests.get(S.request_seq);R&&(this.pendingRequests.delete(S.request_seq),R(S));break}}}}internalSend(k,S){S.type=k,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((S,R)=>k.set(R,S)),await(0,n.timeout)(500),k.forEach((S,R)=>{S({type:"response",seq:0,request_seq:R,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(R)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(ve[209],we([1,0,177,61,4]),function(ee,e,h,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new n.RawContextKey("debugType",void 0,{type:"string",description:h.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new n.RawContextKey("debugConfigurationType",void 0,{type:"string",description:h.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new n.RawContextKey("debugState","inactive",{type:"string",description:h.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new n.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:h.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new n.RawContextKey("inDebugMode",!1,{type:"boolean",description:h.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new n.RawContextKey("inDebugRepl",!1,{type:"boolean",description:h.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new n.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:h.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new n.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:h.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new n.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:h.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new n.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:h.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new n.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:h.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new n.RawContextKey("variablesFocused",!0,{type:"boolean",description:h.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new n.RawContextKey("expressionSelected",!1,{type:"boolean",description:h.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new n.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:h.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new n.RawContextKey("callStackItemType",void 0,{type:"string",description:h.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new n.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:h.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new n.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:h.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new n.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:h.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new n.RawContextKey("watchItemType",void 0,{type:"string",description:h.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new n.RawContextKey("canViewMemory",void 0,{type:"boolean",description:h.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new n.RawContextKey("breakpointItemType",void 0,{type:"string",description:h.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new n.RawContextKey("breakpointAccessType",void 0,{type:"string",description:h.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new n.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:h.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new n.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:h.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new n.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:h.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new n.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:h.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new n.RawContextKey("stepBackSupported",!1,{type:"boolean",description:h.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new n.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:h.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new n.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:h.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new n.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:h.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new n.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:h.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new n.RawContextKey("breakpointsExist",!1,{type:"boolean",description:h.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new n.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:h.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new n.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:h.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new n.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:h.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new n.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:h.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new n.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:h.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new n.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:h.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new n.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:h.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new n.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:h.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new n.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:h.localize(40,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new n.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:h.localize(41,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new n.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:h.localize(42,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new n.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:h.localize(43,null)}),e.CONTEXT_MULTI_SESSION_REPL=new n.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:h.localize(44,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new n.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:h.localize(45,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new n.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:h.localize(46,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new n.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:h.localize(47,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new n.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:h.localize(48,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new n.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:h.localize(49,null)});const T=D=>h.localize(50,null,D);e.debuggerDisabledMessage=T,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:h.localize(51,null)};var C;(function(D){D[D.Inactive=0]="Inactive",D[D.Initializing=1]="Initializing",D[D.Stopped=2]="Stopped",D[D.Running=3]="Running"})(C=e.State||(e.State={}));function k(D){switch(D){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=k;var S;(function(D){D[D.Valid=0]="Valid",D[D.Unreadable=1]="Unreadable",D[D.Error=2]="Error"})(S=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var R;(function(D){D[D.Initial=1]="Initial",D[D.Dynamic=2]="Dynamic"})(R=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={})),e.IDebugService=(0,I.createDecorator)(e.DEBUG_SERVICE_ID);var F;(function(D){D[D.CONDITION=0]="CONDITION",D[D.HIT_COUNT=1]="HIT_COUNT",D[D.LOG_MESSAGE=2]="LOG_MESSAGE"})(F=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(ve[210],we([1,0,8,2,9,25,10]),function(ee,e,h,n,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function S(l,i,r){return l.replace(k,function(t,o){return i&&o.length>0&&o[0]!=="_"?t:r&&r.hasOwnProperty(o)?r[o]:t})}e.formatPII=S;function R(l){const i={};for(const r of Object.keys(l))r.startsWith("!")||(i[r]=l[r]);return i}e.filterExceptionsFromTelemetry=R;function F(l){return l.configuration.request==="attach"&&!D(l)&&(!l.parentSession||F(l.parentSession))}e.isSessionAttach=F;function D(l){let i=l.configuration.type;if(!!i)return i==="vslsShare"&&(i=l.configuration.adapterProxy.configuration.type),(0,h.equalsIgnoreCase)(i,"extensionhost")||(0,h.equalsIgnoreCase)(i,"pwa-extensionhost")?l:l.parentSession?D(l.parentSession):void 0}e.getExtensionHostDebugSession=D;function p(l){return l.type&&(l.label||l.program||l.runtime)}e.isDebuggerMainContribution=p;function _(l,i,r){let t,o=0;const f=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let u=null;for(;u=f.exec(l);){const w=u.index+1,P=w+u[0].length;if(w<=i&&P>=r){t=u[0],o=w;break}}if(t){const w=/\w+/g;let P=null;for(;(P=w.exec(t))&&!(P.index+1+o+P[0].length>=r););P&&(t=t.substring(0,w.lastIndex))}return t?{start:o,end:o+t.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=_;const g=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(l){return!!(l&&l.match(g))}e.isUri=d;function v(l){if(typeof l.path=="string"&&!(typeof l.sourceReference=="number"&&l.sourceReference>0)){if(d(l.path))return n.URI.parse(l.path);if((0,I.isAbsolute)(l.path))return n.URI.file(l.path)}return l.path}function A(l){if(typeof l.path=="object"){const i=n.URI.revive(l.path);if(i)return i.scheme===C.Schemas.file?i.fsPath:i.toString()}return l.path}function b(l,i){const r=i?v:A,t=(0,T.deepClone)(l);return c(t,(o,f)=>{o&&f&&(f.path=r(f))}),t}e.convertToDAPaths=b;function a(l,i){const r=i?v:A,t=(0,T.deepClone)(l);return c(t,(o,f)=>{!o&&f&&(f.path=r(f))}),t}e.convertToVSCPaths=a;function c(l,i){switch(l.type){case"event":{const r=l;switch(r.event){case"output":i(!1,r.body.source);break;case"loadedSource":i(!1,r.body.source);break;case"breakpoint":i(!1,r.body.breakpoint.source);break;default:break}break}case"request":{const r=l;switch(r.command){case"setBreakpoints":i(!0,r.arguments.source);break;case"breakpointLocations":i(!0,r.arguments.source);break;case"source":i(!0,r.arguments.source);break;case"gotoTargets":i(!0,r.arguments.source);break;case"launchVSCode":r.arguments.args.forEach(t=>i(!1,t));break;default:break}break}case"response":{const r=l;if(r.success&&r.body)switch(r.command){case"stackTrace":r.body.stackFrames.forEach(t=>i(!1,t.source));break;case"loadedSources":r.body.sources.forEach(t=>i(!1,t));break;case"scopes":r.body.scopes.forEach(t=>i(!1,t.source));break;case"setFunctionBreakpoints":r.body.breakpoints.forEach(t=>i(!1,t.source));break;case"setBreakpoints":r.body.breakpoints.forEach(t=>i(!1,t.source));break;case"disassemble":{const t=r;t.body&&t.body.instructions.forEach(o=>i(!1,o.location))}break;default:break}break}}}function m(l){return l.filter(i=>!i.presentation?.hidden).sort((i,r)=>i.presentation?r.presentation?i.presentation.group?r.presentation.group?i.presentation.group!==r.presentation.group?i.presentation.group.localeCompare(r.presentation.group):s(i.presentation.order,r.presentation.order):-1:r.presentation.group?1:s(i.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=m;function s(l,i){return typeof l!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:l-i}async function E(l,i){const r=l.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorLanguageId});if(r!=="none"&&(await i.saveAll(),r==="allEditorsInActiveGroup")){const t=i.activeEditorPane;t&&t.input.resource?.scheme===C.Schemas.untitled&&await i.save({editor:t.input,groupId:t.group.id})}await l.reloadConfiguration()}e.saveAllBeforeDebugStart=E}),define(ve[211],we([1,0,28,38,178,127,9,8,25,12,194,126]),function(ee,e,h,n,I,T,C,k,S,R,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class p extends D.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(b,a){this.outputStream=a,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,b.on("data",c=>this.handleData(c))}sendMessage(b){if(this.outputStream){const a=JSON.stringify(b);this.outputStream.write(`Content-Length: ${Buffer.byteLength(a,"utf8")}${p.TWO_CRLF}${a}`,"utf8")}}handleData(b){for(this.rawData=Buffer.concat([this.rawData,b]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const a=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,a.length>0)try{this.acceptMessage(JSON.parse(a))}catch(c){this._onError.fire(new Error((c.message||c)+`
`+a))}continue}}else{const a=this.rawData.indexOf(p.TWO_CRLF);if(a!==-1){const m=this.rawData.toString("utf8",0,a).split(p.HEADER_LINESEPARATOR);for(const s of m){const E=s.split(p.HEADER_FIELDSEPARATOR);E[0]==="Content-Length"&&(this.contentLength=Number(E[1]))}this.rawData=this.rawData.slice(a+p.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=p,p.TWO_CRLF=`\r
\r
`,p.HEADER_LINESEPARATOR=/\r?\n/,p.HEADER_FIELDSEPARATOR=/: */;class _ extends p{startSession(){return new Promise((b,a)=>{let c=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),b(),c=!0}),this.socket.on("close",()=>{c?this._onError.fire(new Error("connection closed")):a(new Error("connection closed"))}),this.socket.on("error",m=>{c?this._onError.fire(m):a(m)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=_;class g extends _{constructor(b){super();this.adapterServer=b}createConnection(b){return T.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",b)}}e.SocketDebugAdapter=g;class d extends _{constructor(b){super();this.adapterServer=b}createConnection(b){return T.createConnection(this.adapterServer.path,b)}}e.NamedPipeDebugAdapter=d;class v extends p{constructor(b,a,c){super();this.adapterExecutable=b,this.debugType=a,this.outputService=c}async startSession(){const b=this.adapterExecutable.command,a=this.adapterExecutable.args,c=this.adapterExecutable.options||{};try{if(b)if(C.isAbsolute(b)){if(!await h.Promises.exists(b))throw new Error(I.localize(0,null,b))}else b.indexOf("/")<0&&b.indexOf("\\")<0;else throw new Error(I.localize(1,null,this.debugType));let m=process.env;if(c.env&&Object.keys(c.env).length>0&&(m=S.mixin(S.deepClone(process.env),c.env)),b==="node")if(Array.isArray(a)&&a.length>0){const E=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,l={env:m,execArgv:E?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};c.cwd&&(l.cwd=c.cwd);const i=n.fork(a[0],a.slice(1),l);if(!i.pid)throw new Error(I.localize(2,null,a[0]));this.serverProcess=i}else throw new Error(I.localize(3,null));else{const E={env:m};c.cwd&&(E.cwd=c.cwd),this.serverProcess=n.spawn(b,a,E)}this.serverProcess.on("error",E=>{this._onError.fire(E)}),this.serverProcess.on("exit",(E,l)=>{this._onExit.fire(E)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",E=>{this._onError.fire(E)}),this.serverProcess.stdin.on("error",E=>{this._onError.fire(E)});const s=this.outputService;if(s){const E=l=>l.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",l=>{const i=s.getChannel(F.ExtensionsChannelId);i&&i.append(E(l))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(m){this._onError.fire(m)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),R.isWindows?new Promise((b,a)=>{const c=n.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(m,s,E){if(m)return a(m)});c.on("exit",b),c.on("error",a)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(b,a){if(!b)return;const c=Object.create(null);b.runtime&&(b.runtime.indexOf("./")===0?c.runtime=C.join(a,b.runtime):c.runtime=b.runtime),b.runtimeArgs&&(c.runtimeArgs=b.runtimeArgs),b.program&&(C.isAbsolute(b.program)?c.program=b.program:c.program=C.join(a,b.program)),b.args&&(c.args=b.args);const m=b;return m.win&&(c.win=v.extract(m.win,a)),m.winx86&&(c.winx86=v.extract(m.winx86,a)),m.windows&&(c.windows=v.extract(m.windows,a)),m.osx&&(c.osx=v.extract(m.osx,a)),m.linux&&(c.linux=v.extract(m.linux,a)),c}static platformAdapterExecutable(b,a){let c=Object.create(null);a=a.toLowerCase();for(const r of b)if(r.contributes){const t=r.contributes.debuggers;t&&t.length>0&&t.filter(o=>typeof o.type=="string"&&k.equalsIgnoreCase(o.type,a)).forEach(o=>{const f=v.extract(o,r.extensionLocation.fsPath);c=S.mixin(c,f,r.isBuiltin)})}let m;R.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?m=c.winx86||c.win||c.windows:R.isWindows?m=c.win||c.windows:R.isMacintosh?m=c.osx:R.isLinux&&(m=c.linux),m=m||c;const s=m.program||c.program,E=m.args||c.args,l=m.runtime||c.runtime,i=m.runtimeArgs||c.runtimeArgs;if(l)return{type:"executable",command:l,args:(i||[]).concat(typeof s=="string"?[s]:[]).concat(E||[])};if(s)return{type:"executable",command:s,args:E||[]}}}e.ExecutableDebugAdapter=v}),define(ve[212],we([1,0,38,29,12]),function(ee,e,h,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function T(R,F){return new Promise((D,p)=>{let _="";const g=h.spawn(R,F);g.pid&&g.stdout.on("data",d=>{_+=d.toString()}),g.on("error",d=>{p(d)}),g.on("close",d=>{D(_)})})}async function C(R){if(R)if(I.isWindows){const F=await new Promise((D,p)=>{ee(["windows-process-tree"],D,p)});return new Promise(D=>{F.getProcessTree(R,p=>{D(p.children.length>0)})})}else return T("/usr/bin/pgrep",["-lP",String(R)]).then(F=>{const D=F.trim();return!(D.length===0||D.indexOf(" tmux")>=0)},F=>!0);return Promise.resolve(!0)}e.hasChildProcesses=C;var k;(function(R){R[R.cmd=0]="cmd",R[R.powershell=1]="powershell",R[R.bash=2]="bash"})(k||(k={}));function S(R,F,D,p){R=R.trim().toLowerCase();let _;R.indexOf("powershell")>=0||R.indexOf("pwsh")>=0?_=1:R.indexOf("cmd.exe")>=0?_=0:R.indexOf("bash")>=0?_=2:I.isWindows?_=0:_=2;let g,d=" ";switch(_){case 1:if(g=v=>(v=v.replace(/\'/g,"''"),v.length>0&&v.charAt(v.length-1)==="\\"?`'${v}\\'`:`'${v}'`),D){const v=(0,n.getDriveLetter)(D);v&&(d+=`${v}:; `),d+=`cd ${g(D)}; `}if(p)for(const v in p){const A=p[v];A===null?d+=`Remove-Item env:${v}; `:d+=`\${env:${v}}='${A}'; `}if(F.length>0){const v=g(F.shift());d+=v[0]==="'"?`& ${v} `:`${v} `;for(const A of F)d+=`${g(A)} `}break;case 0:if(g=v=>(v=v.replace(/\"/g,'""'),v.indexOf(" ")>=0||v.indexOf('"')>=0||v.length===0?`"${v}"`:v),D){const v=(0,n.getDriveLetter)(D);v&&(d+=`${v}: && `),d+=`cd ${g(D)} && `}if(p){d+='cmd /C "';for(const v in p){let A=p[v];A===null?d+=`set "${v}=" && `:(A=A.replace(/[\^\&\|\<\>]/g,b=>`^${b}`),d+=`set "${v}=${A}" && `)}}for(const v of F)d+=`${g(v)} `;p&&(d+='"');break;case 2:{g=A=>(A=A.replace(/(["'\\\$])/g,"\\$1"),A.indexOf(" ")>=0||A.indexOf(";")>=0||A.length===0?`"${A}"`:A);const v=A=>/[^\w@%\/+=,.:^-]/.test(A)?`'${A.replace(/'/g,"'\\''")}'`:A;if(D&&(d+=`cd ${g(D)} ; `),p){d+="/usr/bin/env";for(const A in p){const b=p[A];b===null?d+=` -u ${v(A)}`:d+=` ${v(`${A}=${b}`)}`}d+=" "}for(const A of F)d+=`${g(A)} `;break}}return d}e.prepareCommand=S}),define(ve[128],we([1,0,32,76,92,10,9,12,61]),function(ee,e,h,n,I,T,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var R;(function(t){t[t.Markup=1]="Markup",t[t.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",I.Mimes.latex,I.Mimes.markdown,"image/png","image/jpeg",I.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[I.Mimes.latex,I.Mimes.markdown,"application/json",I.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var F;(function(t){t[t.Running=1]="Running",t[t.Idle=2]="Idle"})(F=e.NotebookRunState||(e.NotebookRunState={}));var D;(function(t){t[t.Unconfirmed=1]="Unconfirmed",t[t.Pending=2]="Pending",t[t.Executing=3]="Executing"})(D=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var p;(function(t){t[t.WithHardKernelDependency=0]="WithHardKernelDependency",t[t.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",t[t.Pure=2]="Pure",t[t.Never=3]="Never"})(p=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var _;(function(t){t.Always="always",t.Never="never",t.Optional="optional"})(_=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var g;(function(t){t[t.ModelChange=1]="ModelChange",t[t.Move=2]="Move",t[t.ChangeLanguage=5]="ChangeLanguage",t[t.Initialize=6]="Initialize",t[t.ChangeCellMetadata=7]="ChangeCellMetadata",t[t.Output=8]="Output",t[t.OutputItem=9]="OutputItem",t[t.ChangeCellContent=10]="ChangeCellContent",t[t.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",t[t.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",t[t.ChangeCellMime=13]="ChangeCellMime",t[t.Unknown=100]="Unknown"})(g=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(t){t[t.Handle=0]="Handle",t[t.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var v;(function(t){t[t.Replace=1]="Replace",t[t.Output=2]="Output",t[t.Metadata=3]="Metadata",t[t.CellLanguage=4]="CellLanguage",t[t.DocumentMetadata=5]="DocumentMetadata",t[t.Move=6]="Move",t[t.OutputItems=7]="OutputItems",t[t.PartialMetadata=8]="PartialMetadata",t[t.PartialInternalMetadata=9]="PartialInternalMetadata"})(v=e.CellEditType||(e.CellEditType={}));var A;(function(t){t.scheme=T.Schemas.vscodeNotebookCell;const o=/^ch(\d{7,})/;function f(y,z){return y.with({scheme:t.scheme,fragment:`ch${z.toString().padStart(7,"0")}${y.scheme!==T.Schemas.file?y.scheme:""}`})}t.generate=f;function u(y){if(y.scheme!==t.scheme)return;const z=o.exec(y.fragment);return z?{handle:Number(z[1]),notebook:y.with({scheme:y.fragment.substring(z[0].length)||T.Schemas.file,fragment:null})}:void 0}t.parse=u;function w(y,z){return y.with({scheme:T.Schemas.vscodeNotebookCellOutput,fragment:`op${z??""},${y.scheme!==T.Schemas.file?y.scheme:""}`})}t.generateCellOutputUri=w;function P(y){if(y.scheme!==T.Schemas.vscodeNotebookCellOutput)return;const z=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(y.fragment);if(!z)return;const M=z[1]&&z[1]!==""?z[1]:void 0,B=z[2];return{outputId:M,notebook:y.with({scheme:B||T.Schemas.file,fragment:null})}}t.parseCellOutputUri=P;function L(y,z,M){return y.with({scheme:M,fragment:`ch${z.toString().padStart(7,"0")}${y.scheme!==T.Schemas.file?y.scheme:""}`})}t.generateCellUri=L;function O(y,z){if(y.scheme!==z)return;const M=o.exec(y.fragment);return M?{handle:Number(M[1]),notebook:y.with({scheme:y.fragment.substring(M[0].length)||T.Schemas.file,fragment:null})}:void 0}t.parseCellUri=O})(A=e.CellUri||(e.CellUri={}));const b=t=>k.isWindows?t.replace(/\//g,"\\"):t;class a{constructor(o=[],f=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=f,this.order=[...new Set(o)].map(u=>({pattern:u,matches:h.parse(b(u))}))}sort(o){const f=new Map(n.Iterable.map(o,w=>[w,b(w)]));let u=[];for(const{matches:w}of this.order)for(const[P,L]of f)if(w(L)){u.push(P),f.delete(P);break}return f.size&&(u=u.concat([...f.keys()].sort((w,P)=>this.defaultOrder.indexOf(w)-this.defaultOrder.indexOf(P)))),u}prioritize(o,f){const u=this.findIndex(o);if(u===-1){this.order.unshift({pattern:o,matches:h.parse(b(o))});return}const w=new Set(f.map(L=>this.findIndex(L,u)));w.delete(-1);const P=Array.from(w).sort();this.order.splice(u+1,0,...P.map(L=>this.order[L]));for(let L=P.length-1;L>=0;L--)this.order.splice(P[L],1)}toArray(){return this.order.map(o=>o.pattern)}findIndex(o,f=this.order.length){const u=b(o);for(let w=0;w<f;w++)if(this.order[w].matches(u))return w;return-1}}e.MimeTypeDisplayOrder=a;function c(t,o,f,u=(w,P)=>w===P){const w=[];function P(y,z,M){if(z===0&&M.length===0)return;const B=w[w.length-1];B&&B.start+B.deleteCount===y?(B.deleteCount+=z,B.toInsert.push(...M)):w.push({start:y,deleteCount:z,toInsert:M})}let L=0,O=0;for(;;){if(L===t.length){P(L,0,o.slice(O));break}if(O===o.length){P(L,t.length-L,[]);break}const y=t[L],z=o[O];if(u(y,z)){L+=1,O+=1;continue}f(z)?(P(L,1,[]),L+=1):(P(L,0,[z]),O+=1)}return w}e.diff=c,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none");var m;(function(t){t.default="default",t.option="option"})(m=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function s(t){const o=t;return!!((typeof o.include=="string"||h.isRelativePattern(o.include))&&(typeof o.exclude=="string"||h.isRelativePattern(o.exclude)))}e.isDocumentExcludePattern=s;function E(t,o,f){if(Array.isArray(t.viewType)&&t.viewType.indexOf(o)>=0||t.viewType===o)return!0;if(t.filenamePattern){const u=s(t.filenamePattern)?t.filenamePattern.include:t.filenamePattern,w=s(t.filenamePattern)?t.filenamePattern.exclude:void 0;if(h.match(u,(0,C.basename)(f.fsPath).toLowerCase()))return!(w&&h.match(w,(0,C.basename)(f.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=E;class l{constructor(o){this.textModel=o}getElements(){const o=new Int32Array(this.textModel.cells.length);for(let f=0;f<this.textModel.cells.length;f++)o[f]=this.textModel.cells[f].getHashValue();return o}}e.CellSequence=l,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var i;(function(t){t[t.Left=1]="Left",t[t.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class r{static create(o){return`${r._prefix}${o}`}static parse(o){if(o.startsWith(r._prefix))return o.substring(r._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=r,r._prefix="notebook/"}),define(ve[213],we([1,0,4]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var n;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(n=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,h.createDecorator)("INotebookExecutionService")}),define(ve[214],we([1,0,4,61]),function(ee,e,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new n.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new n.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new n.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,h.createDecorator)(e.OUTPUT_SERVICE_ID);var I;(function(T){T[T.Append=1]="Append",T[T.Replace=2]="Replace",T[T.Clear=3]="Clear"})(I=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(ve[215],we([1,0,179,4,61]),function(ee,e,h,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new I.RawContextKey("customExecutionSupported",!0,h.localize(0,null)),e.ShellExecutionSupportedContext=new I.RawContextKey("shellExecutionSupported",!1,h.localize(1,null)),e.ProcessExecutionSupportedContext=new I.RawContextKey("processExecutionSupported",!1,h.localize(2,null)),e.ITaskService=(0,n.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ve[216],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function h(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=h;function n(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=n}),define(ve[84],we([1,0,2,35]),function(ee,e,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var I;(function(r){r[r.Unset=0]="Unset",r[r.Queued=1]="Queued",r[r.Running=2]="Running",r[r.Passed=3]="Passed",r[r.Failed=4]="Failed",r[r.Skipped=5]="Skipped",r[r.Errored=6]="Errored"})(I=e.TestResultState||(e.TestResultState={}));var T;(function(r){r[r.Run=2]="Run",r[r.Debug=4]="Debug",r[r.Coverage=8]="Coverage",r[r.HasNonDefaultProfile=16]="HasNonDefaultProfile",r[r.HasConfigurable=32]="HasConfigurable"})(T=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var C;(function(r){r.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),r.deserialize=t=>({range:n.Range.lift(t.range),uri:h.URI.revive(t.uri)})})(C=e.IRichLocation||(e.IRichLocation={}));var k;(function(r){r[r.Error=0]="Error",r[r.Info=1]="Info"})(k=e.TestMessageType||(e.TestMessageType={}));var S;(function(r){r.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&C.serialize(t.location)}),r.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&C.deserialize(t.location)})})(S=e.ITestErrorMessage||(e.ITestErrorMessage={}));var R;(function(r){r.serialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&C.serialize(t.location)}),r.deserialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&C.deserialize(t.location)})})(R=e.ITestOutputMessage||(e.ITestOutputMessage={}));var F;(function(r){r.serialize=t=>t.type===0?S.serialize(t):R.serialize(t),r.deserialize=t=>t.type===0?S.deserialize(t):R.deserialize(t)})(F=e.ITestMessage||(e.ITestMessage={}));var D;(function(r){r.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(F.serialize)}),r.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(F.deserialize)})})(D=e.ITestTaskState||(e.ITestTaskState={}));const p="\0",_=(r,t)=>r+p+t;e.namespaceTestTag=_;const g=r=>{const t=r.indexOf(p);return{ctrlId:r.slice(0,t),tagId:r.slice(t+1)}};e.denamespaceTestTag=g;var d;(function(r){r.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),r.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?h.URI.revive(t.uri):void 0,range:t.range?n.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(d=e.ITestItem||(e.ITestItem={}));var v;(function(r){r[r.NotExpandable=0]="NotExpandable",r[r.Expandable=1]="Expandable",r[r.BusyExpanding=2]="BusyExpanding",r[r.Expanded=3]="Expanded"})(v=e.TestItemExpandState||(e.TestItemExpandState={}));var A;(function(r){r.serialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:d.serialize(t.item)}),r.deserialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:d.deserialize(t.item)})})(A=e.InternalTestItem||(e.InternalTestItem={}));var b;(function(r){r.serialize=t=>{let o;return t.item&&(o={},t.item.label!==void 0&&(o.label=t.item.label),t.item.tags!==void 0&&(o.tags=t.item.tags),t.item.busy!==void 0&&(o.busy=t.item.busy),t.item.uri!==void 0&&(o.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(o.range=t.item.range?.toJSON()),t.item.description!==void 0&&(o.description=t.item.description),t.item.error!==void 0&&(o.error=t.item.error),t.item.sortText!==void 0&&(o.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:o}},r.deserialize=t=>{let o;return t.item&&(o={},t.item.label!==void 0&&(o.label=t.item.label),t.item.tags!==void 0&&(o.tags=t.item.tags),t.item.busy!==void 0&&(o.busy=t.item.busy),t.item.range!==void 0&&(o.range=t.item.range?n.Range.lift(t.item.range):null),t.item.description!==void 0&&(o.description=t.item.description),t.item.error!==void 0&&(o.error=t.item.error),t.item.sortText!==void 0&&(o.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:o}}})(b=e.ITestItemUpdate||(e.ITestItemUpdate={}));const a=(r,t)=>{t.expand!==void 0&&(r.expand=t.expand),t.item!==void 0&&(r.item=r.item?Object.assign(r.item,t.item):t.item)};e.applyTestItemUpdate=a;var c;(function(r){r.serialize=(t,o)=>({...A.serialize(t),children:o,ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(D.serialize)})})(c=e.TestResultItem||(e.TestResultItem={}));var m;(function(r){r[r.Function=0]="Function",r[r.Statement=1]="Statement"})(m=e.DetailType||(e.DetailType={}));var s;(function(r){r[r.Add=0]="Add",r[r.Update=1]="Update",r[r.Remove=2]="Remove",r[r.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",r[r.Retire=4]="Retire",r[r.AddTag=5]="AddTag",r[r.RemoveTag=6]="RemoveTag"})(s=e.TestDiffOpType||(e.TestDiffOpType={}));var E;(function(r){r.deserialize=t=>t.op===0?{op:t.op,item:A.deserialize(t.item)}:t.op===1?{op:t.op,item:b.deserialize(t.item)}:t,r.serialize=t=>t.op===0?{op:t.op,item:A.serialize(t.item)}:t.op===1?{op:t.op,item:b.serialize(t.item)}:t})(E=e.TestsDiffOp||(e.TestsDiffOp={}));class l{add(t){}update(t){}remove(t,o){}complete(){}}e.IncrementalChangeCollector=l;class i{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(t){const o=this.createChangeCollector();for(const f of t)switch(f.op){case 0:{const u=A.deserialize(f.item);if(u.parent){if(this.items.has(u.parent)){const w=this.items.get(u.parent);w.children.add(u.item.extId);const P=this.createItem(u,w);this.items.set(u.item.extId,P),o.add(P)}}else{const w=this.createItem(u);this.roots.add(w),this.items.set(u.item.extId,w),o.add(w)}u.expand===2&&this.busyControllerCount++;break}case 1:{const u=b.deserialize(f.item),w=this.items.get(u.extId);if(!w)break;u.expand!==void 0&&(w.expand===2&&this.busyControllerCount--,u.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(w,u),o.update(w);break}case 2:{const u=this.items.get(f.itemId);if(!u)break;u.parent?this.items.get(u.parent).children.delete(u.item.extId):this.roots.delete(u);const w=[[f.itemId]];for(;w.length;)for(const P of w.pop()){const L=this.items.get(P);L&&(w.push(L.children),this.items.delete(P),o.remove(L,L!==u),L.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(f.itemId);break;case 3:this.updatePendingRoots(f.amount);break;case 5:this._tags.set(f.tag.id,f.tag);break;case 6:this._tags.delete(f.id);break}o.complete()}retireTest(t){}updatePendingRoots(t){this.pendingRootCount+=t}createChangeCollector(){return new l}}e.AbstractIncrementalTestCollection=i}),define(ve[85],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var h;(function(T){T.Delimiter="\0"})(h=e.TestIdPathParts||(e.TestIdPathParts={}));var n;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(n=e.TestPosition||(e.TestPosition={}));class I{constructor(C,k=C.length){if(this.path=C,this.viewEnd=k,C.length===0||k<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(C,k,S=C.parent){if(C.id===k)return new I([k]);let R=[C.id];for(let F=S;F&&F.id!==k;F=F.parent)R.push(F.id);return R.push(k),new I(R.reverse())}static isRoot(C){return!C.includes("\0")}static root(C){const k=C.indexOf("\0");return k===-1?C:C.slice(0,k)}static fromString(C){return new I(C.split("\0"))}static join(C,k){return new I([...C.path,k])}static joinToString(C,k){return C.toString()+"\0"+k}static compare(C,k){return C===k?0:k.startsWith(C+"\0")?2:C.startsWith(k+"\0")?3:1}get parentId(){return this.viewEnd>1?new I(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let C=1;C<=this.viewEnd;C++)yield new I(this.path,C)}compare(C){if(typeof C=="string")return I.compare(this.toString(),C);for(let k=0;k<C.viewEnd&&k<this.viewEnd;k++)if(C.path[k]!==this.path[k])return 1;return C.viewEnd>this.viewEnd?2:C.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let C=1;C<this.viewEnd;C++)this.stringifed+="\0",this.stringifed+=this.path[C]}return this.stringifed}}e.TestId=I}),define(ve[217],we([1,0,9,41,13,25,12,100,180]),function(ee,e,h,n,I,T,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class R{constructor(D,p,_,g){this._contributedVariables=new Map,this._context=D,this._labelService=p,this._userHomePromise=_,g&&(this._envVariablesPromise=g.then(d=>this.prepareEnv(d)))}prepareEnv(D){if(C.isWindows){const p=Object.create(null);return Object.keys(D).forEach(_=>{p[_.toLowerCase()]=D[_]}),p}return D}resolveWithEnvironment(D,p,_){return this.recursiveResolve(this.prepareEnv(D),p?p.uri:void 0,_)}async resolveAsync(D,p){const _={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(_,D?D.uri:void 0,p)}async resolveAnyBase(D,p,_,g){const d=T.deepClone(p);C.isWindows&&d.windows?Object.keys(d.windows).forEach(A=>d[A]=d.windows[A]):C.isMacintosh&&d.osx?Object.keys(d.osx).forEach(A=>d[A]=d.osx[A]):C.isLinux&&d.linux&&Object.keys(d.linux).forEach(A=>d[A]=d.linux[A]),delete d.windows,delete d.osx,delete d.linux;const v={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(v,D?D.uri:void 0,d,_,g)}async resolveAnyAsync(D,p,_){return this.resolveAnyBase(D,p,_)}async resolveAnyMap(D,p,_){const g=new Map;return{newConfig:await this.resolveAnyBase(D,p,_,g),resolvedVariables:g}}resolveWithInteractionReplace(D,p,_,g){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(D,p,_,g){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(D,p){if(this._contributedVariables.has(D))throw new Error("Variable "+D+" is contributed twice.");this._contributedVariables.set(D,p)}recursiveResolve(D,p,_,g,d){if(I.isString(_))return this.resolveString(D,p,_,g,d);if(I.isArray(_))return _.map(v=>this.recursiveResolve(D,p,v,g,d));if(I.isObject(_)){let v=Object.create(null);return Object.keys(_).forEach(A=>{const b=this.resolveString(D,p,A,g,d);v[b]=this.recursiveResolve(D,p,_[A],g,d)}),v}return _}resolveString(D,p,_,g,d){return _.replace(R.VARIABLE_REGEXP,(A,b)=>{if(b.includes(R.VARIABLE_LHS))return A;let a=this.evaluateSingleVariable(D,A,b,p,g);return d&&d.set(b,a),a!==A&&I.isString(a)&&a.match(R.VARIABLE_REGEXP)&&(a=this.resolveString(D,p,a,g,d)),a})}fsPath(D){return this._labelService?this._labelService.getUriLabel(D,{noPrefix:!0}):D.fsPath}evaluateSingleVariable(D,p,_,g,d){let v;const A=_.split(":");A.length>1&&(_=A[0],v=A[1]);const b=()=>{const m=this._context.getFilePath();if(m)return m;throw new Error((0,S.localize)(0,null,p))},a=()=>{const m=b();if(this._context.getWorkspaceFolderPathForFile){const s=this._context.getWorkspaceFolderPathForFile();if(s)return s}throw new Error((0,S.localize)(1,null,p,h.basename(m)))},c=()=>{if(v){const m=this._context.getFolderUri(v);if(m)return m;throw new Error((0,S.localize)(2,null,p,v))}if(g)return g;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,p)):new Error((0,S.localize)(4,null,p))};switch(_){case"env":if(v){if(D.env){const m=D.env[C.isWindows?v.toLowerCase():v];if(I.isString(m))return m}return""}throw new Error((0,S.localize)(5,null,p));case"config":if(v){const m=this._context.getConfigurationValue(g,v);if(I.isUndefinedOrNull(m))throw new Error((0,S.localize)(6,null,p,v));if(I.isObject(m))throw new Error((0,S.localize)(7,null,p,v));return m}throw new Error((0,S.localize)(8,null,p));case"command":return this.resolveFromMap(p,v,d,"command");case"input":return this.resolveFromMap(p,v,d,"input");default:switch(_){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(c()));case"cwd":return g||v?(0,k.normalizeDriveLetter)(this.fsPath(c())):n.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return h.basename(this.fsPath(c()));case"userHome":{if(D.userHome)return D.userHome;throw new Error((0,S.localize)(9,null,p))}case"lineNumber":{const m=this._context.getLineNumber();if(m)return m;throw new Error((0,S.localize)(10,null,p))}case"selectedText":{const m=this._context.getSelectedText();if(m)return m;throw new Error((0,S.localize)(11,null,p))}case"file":return b();case"fileWorkspaceFolder":return a();case"relativeFile":return g||v?h.relative(this.fsPath(c()),b()):b();case"relativeFileDirname":{const m=h.dirname(b());if(g||v){const s=h.relative(this.fsPath(c()),m);return s.length===0?".":s}return m}case"fileDirname":return h.dirname(b());case"fileExtname":return h.extname(b());case"fileBasename":return h.basename(b());case"fileBasenameNoExtension":{const m=h.basename(b());return m.slice(0,m.length-h.extname(m).length)}case"fileDirnameBasename":return h.basename(h.dirname(b()));case"execPath":{const m=this._context.getExecPath();return m||p}case"execInstallFolder":{const m=this._context.getAppRoot();return m||p}case"pathSeparator":return h.sep;default:try{const m=v?`${_}:${v}`:_;return this.resolveFromMap(p,m,d,void 0)}catch{return p}}}}resolveFromMap(D,p,_,g){if(p&&_){const d=g===void 0?_[p]:_[g+":"+p];if(typeof d=="string")return d;throw new Error((0,S.localize)(12,null,D))}return D}}e.AbstractVariableResolverService=R,R.VARIABLE_LHS="${",R.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ve[129],we([1,0,4,207]),function(ee,e,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,h.createDecorator)("editorGroupsService");var I;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var T;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var C;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(C=e.GroupLocation||(e.GroupLocation={}));var k;(function(g){g[g.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));function R(g){const d=g;return(0,n.isEditorInput)(d?.editor)&&(0,n.isEditorInput)(d?.replacement)}e.isEditorReplacement=R;var F;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(F=e.GroupsOrder||(e.GroupsOrder={}));var D;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(D=e.OpenEditorContext||(e.OpenEditorContext={}));function p(g){const d=g;return!!d&&typeof d.id=="number"&&Array.isArray(d.editors)}e.isEditorGroup=p;function _(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=_}),define(ve[218],we([1,0,4,129]),function(ee,e,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,h.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function I(T){const C=T;return typeof T=="number"||(0,n.isEditorGroup)(C)}e.isPreferredGroup=I}),define(ve[14],we([1,0,18,22,99,142,58,25,13,2,35,78,182,116,62,128,84,85,218,7]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_,g,d,v,A,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var c;(function(_e){function ye(te){const{selectionStartLineNumber:Ie,selectionStartColumn:Re,positionLineNumber:Ve,positionColumn:Ke}=te,ht=new a.Position(Ie-1,Re-1),Et=new a.Position(Ve-1,Ke-1);return new a.Selection(ht,Et)}_e.to=ye;function fe(te){const{anchor:Ie,active:Re}=te;return{selectionStartLineNumber:Ie.line+1,selectionStartColumn:Ie.character+1,positionLineNumber:Re.line+1,positionColumn:Re.character+1}}_e.from=fe})(c=e.Selection||(e.Selection={}));var m;(function(_e){function ye(te){if(!te)return;const{start:Ie,end:Re}=te;return{startLineNumber:Ie.line+1,startColumn:Ie.character+1,endLineNumber:Re.line+1,endColumn:Re.character+1}}_e.from=ye;function fe(te){if(!te)return;const{startLineNumber:Ie,startColumn:Re,endLineNumber:Ve,endColumn:Ke}=te;return new a.Range(Ie-1,Re-1,Ve-1,Ke-1)}_e.to=fe})(m=e.Range||(e.Range={}));var s;(function(_e){function ye(fe){switch(fe){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 3:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}_e.to=ye})(s=e.TokenType||(e.TokenType={}));var E;(function(_e){function ye(te){return new a.Position(te.lineNumber-1,te.column-1)}_e.to=ye;function fe(te){return{lineNumber:te.line+1,column:te.character+1}}_e.from=fe})(E=e.Position||(e.Position={}));var l;(function(_e){function ye(Ie,Re){return(0,h.coalesce)((0,h.asArray)(Ie).map(Ve=>fe(Ve,Re)))}_e.from=ye;function fe(Ie,Re){if(typeof Ie=="string")return{$serialized:!0,language:Ie};if(Ie)return{$serialized:!0,language:Ie.language,scheme:te(Ie.scheme,Re),pattern:J.from(Ie.pattern)??void 0,exclusive:Ie.exclusive,notebookType:Ie.notebookType}}function te(Ie,Re){return Re&&typeof Ie=="string"?Re.transformOutgoingScheme(Ie):Ie}})(l=e.DocumentSelector||(e.DocumentSelector={}));var i;(function(_e){function ye(te){switch(te){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}_e.from=ye;function fe(te){switch(te){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}_e.to=fe})(i=e.DiagnosticTag||(e.DiagnosticTag={}));var r;(function(_e){function ye(te){let Ie;return te.code&&((0,S.isString)(te.code)||(0,S.isNumber)(te.code)?Ie=String(te.code):Ie={value:String(te.code.value),target:te.code.target}),{...m.from(te.range),message:te.message,source:te.source,code:Ie,severity:o.from(te.severity),relatedInformation:te.relatedInformation&&te.relatedInformation.map(t.from),tags:Array.isArray(te.tags)?(0,h.coalesce)(te.tags.map(i.from)):void 0}}_e.from=ye;function fe(te){const Ie=new a.Diagnostic(m.to(te),te.message,o.to(te.severity));return Ie.source=te.source,Ie.code=(0,S.isString)(te.code)?te.code:te.code?.value,Ie.relatedInformation=te.relatedInformation&&te.relatedInformation.map(t.to),Ie.tags=te.tags&&(0,h.coalesce)(te.tags.map(i.to)),Ie}_e.to=fe})(r=e.Diagnostic||(e.Diagnostic={}));var t;(function(_e){function ye(te){return{...m.from(te.location.range),message:te.message,resource:te.location.uri}}_e.from=ye;function fe(te){return new a.DiagnosticRelatedInformation(new a.Location(te.resource,m.to(te)),te.message)}_e.to=fe})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var o;(function(_e){function ye(te){switch(te){case a.DiagnosticSeverity.Error:return _.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return _.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return _.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return _.MarkerSeverity.Hint}return _.MarkerSeverity.Error}_e.from=ye;function fe(te){switch(te){case _.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case _.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case _.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case _.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}_e.to=fe})(o=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var f;(function(_e){function ye(te){return typeof te=="number"&&te>=a.ViewColumn.One?te-1:te===a.ViewColumn.Beside?b.SIDE_GROUP:b.ACTIVE_GROUP}_e.from=ye;function fe(te){if(typeof te=="number"&&te>=0)return te+1;throw new Error("invalid 'EditorGroupColumn'")}_e.to=fe})(f=e.ViewColumn||(e.ViewColumn={}));function u(_e){return typeof _e.range!="undefined"}function w(_e){return _e.length===0?!0:!!u(_e[0])}e.isDecorationOptionsArr=w;var P;(function(_e){function ye(Ke){return Ke.map(_e.from)}_e.fromMany=ye;function fe(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function te(Ke){let ht;if(fe(Ke)){const{language:dt,value:ut}=Ke;ht={value:"```"+dt+`
`+ut+"\n```\n"}}else a.MarkdownString.isMarkdownString(Ke)?ht={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?ht={value:Ke}:ht={value:""};const Et=Object.create(null);ht.uris=Et;const St=dt=>{try{let ut=R.URI.parse(dt,!0);ut=ut.with({query:Ie(ut.query,Et)}),Et[dt]=ut}catch{}return""},ot=new T.marked.Renderer;return ot.link=St,ot.image=dt=>typeof dt=="string"?St(I.parseHrefAndDimensions(dt).href):"",(0,T.marked)(ht.value,{renderer:ot}),ht}_e.from=te;function Ie(Ke,ht){if(!Ke)return Ke;let Et;try{Et=(0,C.parse)(Ke)}catch{}if(!Et)return Ke;let St=!1;return Et=(0,k.cloneAndChange)(Et,ot=>{if(R.URI.isUri(ot)){const dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ht[dt]=ot,St=!0,dt}else return}),St?JSON.stringify(Et):Ke}function Re(Ke){const ht=new a.MarkdownString(Ke.value,Ke.supportThemeIcons);return ht.isTrusted=Ke.isTrusted,ht.supportHtml=Ke.supportHtml,ht.baseUri=Ke.baseUri?R.URI.from(Ke.baseUri):void 0,ht}_e.to=Re;function Ve(Ke){if(!!Ke)return typeof Ke=="string"?Ke:_e.from(Ke)}_e.fromStrict=Ve})(P=e.MarkdownString||(e.MarkdownString={}));function L(_e){return w(_e)?_e.map(ye=>({range:m.from(ye.range),hoverMessage:Array.isArray(ye.hoverMessage)?P.fromMany(ye.hoverMessage):ye.hoverMessage?P.from(ye.hoverMessage):void 0,renderOptions:ye.renderOptions})):_e.map(ye=>({range:m.from(ye)}))}e.fromRangeOrRangeWithMessage=L;function O(_e){return typeof _e=="undefined"?_e:typeof _e=="string"?R.URI.file(_e):_e}e.pathOrURIToURI=O;var y;(function(_e){function ye(fe){return typeof fe=="undefined"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?O(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}_e.from=ye})(y=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var z;(function(_e){function ye(fe){return typeof fe=="undefined"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?O(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?y.from(fe.before):void 0,after:fe.after?y.from(fe.after):void 0}}_e.from=ye})(z=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var M;(function(_e){function ye(fe){if(typeof fe=="undefined")return fe;switch(fe){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}_e.from=ye})(M=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var B;(function(_e){function ye(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?M.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?z.from(fe.light):void 0,dark:fe.dark?z.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?O(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?y.from(fe.before):void 0,after:fe.after?y.from(fe.after):void 0}}_e.from=ye})(B=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var V;(function(_e){function ye(te){return{text:te.newText,eol:te.newEol&&et.from(te.newEol),range:m.from(te.range)}}_e.from=ye;function fe(te){const Ie=new a.TextEdit(m.to(te.range),te.text);return Ie.newEol=typeof te.eol=="undefined"?void 0:et.to(te.eol),Ie}_e.to=fe})(V=e.TextEdit||(e.TextEdit={}));var Y;(function(_e){function ye(te,Ie){const Re={edits:[]};if(te instanceof a.WorkspaceEdit)for(let Ve of te._allEntries())Ve._type===1?Re.edits.push({_type:1,oldUri:Ve.from,newUri:Ve.to,options:Ve.options,metadata:Ve.metadata}):Ve._type===2?Re.edits.push({_type:2,resource:Ve.uri,edit:V.from(Ve.edit),modelVersionId:Ie?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?Re.edits.push({_type:3,metadata:Ve.metadata,resource:Ve.uri,edit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Ie?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&Re.edits.push({_type:3,metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Ie?.getNotebookDocumentVersion(Ve.uri),edit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(vt.from)}});return Re}_e.from=ye;function fe(te){const Ie=new a.WorkspaceEdit;for(const Re of te.edits)Re.edit?Ie.replace(R.URI.revive(Re.resource),m.to(Re.edit.range),Re.edit.text):Ie.renameFile(R.URI.revive(Re.oldUri),R.URI.revive(Re.newUri),Re.options);return Ie}_e.to=fe})(Y=e.WorkspaceEdit||(e.WorkspaceEdit={}));var H;(function(_e){const ye=Object.create(null);ye[a.SymbolKind.File]=0,ye[a.SymbolKind.Module]=1,ye[a.SymbolKind.Namespace]=2,ye[a.SymbolKind.Package]=3,ye[a.SymbolKind.Class]=4,ye[a.SymbolKind.Method]=5,ye[a.SymbolKind.Property]=6,ye[a.SymbolKind.Field]=7,ye[a.SymbolKind.Constructor]=8,ye[a.SymbolKind.Enum]=9,ye[a.SymbolKind.Interface]=10,ye[a.SymbolKind.Function]=11,ye[a.SymbolKind.Variable]=12,ye[a.SymbolKind.Constant]=13,ye[a.SymbolKind.String]=14,ye[a.SymbolKind.Number]=15,ye[a.SymbolKind.Boolean]=16,ye[a.SymbolKind.Array]=17,ye[a.SymbolKind.Object]=18,ye[a.SymbolKind.Key]=19,ye[a.SymbolKind.Null]=20,ye[a.SymbolKind.EnumMember]=21,ye[a.SymbolKind.Struct]=22,ye[a.SymbolKind.Event]=23,ye[a.SymbolKind.Operator]=24,ye[a.SymbolKind.TypeParameter]=25;function fe(Ie){return typeof ye[Ie]=="number"?ye[Ie]:6}_e.from=fe;function te(Ie){for(const Re in ye)if(ye[Re]===Ie)return Number(Re);return a.SymbolKind.Property}_e.to=te})(H=e.SymbolKind||(e.SymbolKind={}));var q;(function(_e){function ye(te){switch(te){case a.SymbolTag.Deprecated:return 1}}_e.from=ye;function fe(te){switch(te){case 1:return a.SymbolTag.Deprecated}}_e.to=fe})(q=e.SymbolTag||(e.SymbolTag={}));var K;(function(_e){function ye(te){return{name:te.name,kind:H.from(te.kind),tags:te.tags&&te.tags.map(q.from),containerName:te.containerName,location:Z.from(te.location)}}_e.from=ye;function fe(te){const Ie=new a.SymbolInformation(te.name,H.to(te.kind),te.containerName,Z.to(te.location));return Ie.tags=te.tags&&te.tags.map(q.to),Ie}_e.to=fe})(K=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var G;(function(_e){function ye(te){const Ie={name:te.name||"!!MISSING: name!!",detail:te.detail,range:m.from(te.range),selectionRange:m.from(te.selectionRange),kind:H.from(te.kind),tags:te.tags?.map(q.from)??[]};return te.children&&(Ie.children=te.children.map(ye)),Ie}_e.from=ye;function fe(te){const Ie=new a.DocumentSymbol(te.name,te.detail,H.to(te.kind),m.to(te.range),m.to(te.selectionRange));return(0,h.isNonEmptyArray)(te.tags)&&(Ie.tags=te.tags.map(q.to)),te.children&&(Ie.children=te.children.map(fe)),Ie}_e.to=fe})(G=e.DocumentSymbol||(e.DocumentSymbol={}));var ie;(function(_e){function ye(te){const Ie=new a.CallHierarchyItem(H.to(te.kind),te.name,te.detail||"",R.URI.revive(te.uri),m.to(te.range),m.to(te.selectionRange));return Ie._sessionId=te._sessionId,Ie._itemId=te._itemId,Ie}_e.to=ye;function fe(te,Ie,Re){if(Ie=Ie??te._sessionId,Re=Re??te._itemId,Ie===void 0||Re===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Re,name:te.name,detail:te.detail,kind:H.from(te.kind),uri:te.uri,range:m.from(te.range),selectionRange:m.from(te.selectionRange),tags:te.tags?.map(q.from)}}_e.from=fe})(ie=e.CallHierarchyItem||(e.CallHierarchyItem={}));var oe;(function(_e){function ye(fe){return new a.CallHierarchyIncomingCall(ie.to(fe.from),fe.fromRanges.map(te=>m.to(te)))}_e.to=ye})(oe=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ue;(function(_e){function ye(fe){return new a.CallHierarchyOutgoingCall(ie.to(fe.to),fe.fromRanges.map(te=>m.to(te)))}_e.to=ye})(ue=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Z;(function(_e){function ye(te){return{range:te.range&&m.from(te.range),uri:te.uri}}_e.from=ye;function fe(te){return new a.Location(R.URI.revive(te.uri),m.to(te.range))}_e.to=fe})(Z=e.location||(e.location={}));var Q;(function(_e){function ye(te){const Ie=te,Re=te;return{originSelectionRange:Ie.originSelectionRange?m.from(Ie.originSelectionRange):void 0,uri:Ie.targetUri?Ie.targetUri:Re.uri,range:m.from(Ie.targetRange?Ie.targetRange:Re.range),targetSelectionRange:Ie.targetSelectionRange?m.from(Ie.targetSelectionRange):void 0}}_e.from=ye;function fe(te){return{targetUri:R.URI.revive(te.uri),targetRange:m.to(te.range),targetSelectionRange:te.targetSelectionRange?m.to(te.targetSelectionRange):void 0,originSelectionRange:te.originSelectionRange?m.to(te.originSelectionRange):void 0}}_e.to=fe})(Q=e.DefinitionLink||(e.DefinitionLink={}));var se;(function(_e){function ye(te){return{range:m.from(te.range),contents:P.fromMany(te.contents)}}_e.from=ye;function fe(te){return new a.Hover(te.contents.map(P.to),m.to(te.range))}_e.to=fe})(se=e.Hover||(e.Hover={}));var de;(function(_e){function ye(te){return{range:m.from(te.range),expression:te.expression}}_e.from=ye;function fe(te){return new a.EvaluatableExpression(m.to(te.range),te.expression)}_e.to=fe})(de=e.EvaluatableExpression||(e.EvaluatableExpression={}));var ge;(function(_e){function ye(te){if(te instanceof a.InlineValueText)return{type:"text",range:m.from(te.range),text:te.text};if(te instanceof a.InlineValueVariableLookup)return{type:"variable",range:m.from(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};if(te instanceof a.InlineValueEvaluatableExpression)return{type:"expression",range:m.from(te.range),expression:te.expression};throw new Error("Unknown 'InlineValue' type")}_e.from=ye;function fe(te){switch(te.type){case"text":return{range:m.to(te.range),text:te.text};case"variable":return{range:m.to(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};case"expression":return{range:m.to(te.range),expression:te.expression}}}_e.to=fe})(ge=e.InlineValue||(e.InlineValue={}));var Te;(function(_e){function ye(te){return{frameId:te.frameId,stoppedLocation:m.from(te.stoppedLocation)}}_e.from=ye;function fe(te){return new a.InlineValueContext(te.frameId,m.to(te.stoppedLocation))}_e.to=fe})(Te=e.InlineValueContext||(e.InlineValueContext={}));var Ne;(function(_e){function ye(te){return{range:m.from(te.range),kind:te.kind}}_e.from=ye;function fe(te){return new a.DocumentHighlight(m.to(te.range),te.kind)}_e.to=fe})(Ne=e.DocumentHighlight||(e.DocumentHighlight={}));var be;(function(_e){function ye(fe){switch(fe){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}_e.to=ye})(be=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ee;(function(_e){function ye(fe){return{triggerKind:be.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}_e.to=ye})(Ee=e.CompletionContext||(e.CompletionContext={}));var $;(function(_e){function ye(te){switch(te){case a.CompletionItemTag.Deprecated:return 1}}_e.from=ye;function fe(te){switch(te){case 1:return a.CompletionItemTag.Deprecated}}_e.to=fe})($=e.CompletionItemTag||(e.CompletionItemTag={}));var U;(function(_e){const ye=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function fe(Re){return ye.get(Re)??9}_e.from=fe;const te=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Ie(Re){return te.get(Re)??a.CompletionItemKind.Property}_e.to=Ie})(U=e.CompletionItemKind||(e.CompletionItemKind={}));var N;(function(_e){function ye(fe,te){const Ie=new a.CompletionItem(fe.label);return Ie.insertText=fe.insertText,Ie.kind=U.to(fe.kind),Ie.tags=fe.tags?.map($.to),Ie.detail=fe.detail,Ie.documentation=I.isMarkdownString(fe.documentation)?P.to(fe.documentation):fe.documentation,Ie.sortText=fe.sortText,Ie.filterText=fe.filterText,Ie.preselect=fe.preselect,Ie.commitCharacters=fe.commitCharacters,F.Range.isIRange(fe.range)?Ie.range=m.to(fe.range):typeof fe.range=="object"&&(Ie.range={inserting:m.to(fe.range.insert),replacing:m.to(fe.range.replace)}),Ie.keepWhitespace=typeof fe.insertTextRules=="undefined"?!1:Boolean(fe.insertTextRules&1),typeof fe.insertTextRules!="undefined"&&fe.insertTextRules&4?Ie.insertText=new a.SnippetString(fe.insertText):(Ie.insertText=fe.insertText,Ie.textEdit=Ie.range instanceof a.Range?new a.TextEdit(Ie.range,Ie.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Ie.additionalTextEdits=fe.additionalTextEdits.map(Re=>V.to(Re))),Ie.command=te&&fe.command?te.fromInternal(fe.command):void 0,Ie}_e.to=ye})(N=e.CompletionItem||(e.CompletionItem={}));var W;(function(_e){function ye(te){return{label:te.label,documentation:P.fromStrict(te.documentation)}}_e.from=ye;function fe(te){return{label:te.label,documentation:I.isMarkdownString(te.documentation)?P.to(te.documentation):te.documentation}}_e.to=fe})(W=e.ParameterInformation||(e.ParameterInformation={}));var j;(function(_e){function ye(te){return{label:te.label,documentation:P.fromStrict(te.documentation),parameters:Array.isArray(te.parameters)?te.parameters.map(W.from):[],activeParameter:te.activeParameter}}_e.from=ye;function fe(te){return{label:te.label,documentation:I.isMarkdownString(te.documentation)?P.to(te.documentation):te.documentation,parameters:Array.isArray(te.parameters)?te.parameters.map(W.to):[],activeParameter:te.activeParameter}}_e.to=fe})(j=e.SignatureInformation||(e.SignatureInformation={}));var re;(function(_e){function ye(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(j.from):[]}}_e.from=ye;function fe(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(j.to):[]}}_e.to=fe})(re=e.SignatureHelp||(e.SignatureHelp={}));var he;(function(_e){function ye(fe,te){const Ie=new a.InlayHint(E.to(te.position),typeof te.label=="string"?te.label:te.label.map(Ce.to.bind(void 0,fe)),te.kind&&Ae.to(te.kind));return Ie.tooltip=I.isMarkdownString(te.tooltip)?P.to(te.tooltip):te.tooltip,Ie.command=te.command&&fe.fromInternal(te.command),Ie.paddingLeft=te.paddingLeft,Ie.paddingRight=te.paddingRight,Ie}_e.to=ye})(he=e.InlayHint||(e.InlayHint={}));var Ce;(function(_e){function ye(fe,te){const Ie=new a.InlayHintLabelPart(te.label);return Ie.tooltip=I.isMarkdownString(te.tooltip)?P.to(te.tooltip):te.tooltip,D.Command.is(te.command)&&(Ie.command=fe.fromInternal(te.command)),te.location&&(Ie.location=Z.to(te.location)),Ie}_e.to=ye})(Ce=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ae;(function(_e){function ye(te){return te}_e.from=ye;function fe(te){return te}_e.to=fe})(Ae=e.InlayHintKind||(e.InlayHintKind={}));var We;(function(_e){function ye(te){return{range:m.from(te.range),url:te.target,tooltip:te.tooltip}}_e.from=ye;function fe(te){let Ie;if(te.url)try{Ie=typeof te.url=="string"?R.URI.parse(te.url,!0):R.URI.revive(te.url)}catch{}return new a.DocumentLink(m.to(te.range),Ie)}_e.to=fe})(We=e.DocumentLink||(e.DocumentLink={}));var ze;(function(_e){function ye(te){const Ie=new a.ColorPresentation(te.label);return te.textEdit&&(Ie.textEdit=V.to(te.textEdit)),te.additionalTextEdits&&(Ie.additionalTextEdits=te.additionalTextEdits.map(Re=>V.to(Re))),Ie}_e.to=ye;function fe(te){return{label:te.label,textEdit:te.textEdit?V.from(te.textEdit):void 0,additionalTextEdits:te.additionalTextEdits?te.additionalTextEdits.map(Ie=>V.from(Ie)):void 0}}_e.from=fe})(ze=e.ColorPresentation||(e.ColorPresentation={}));var qe;(function(_e){function ye(te){return new a.Color(te[0],te[1],te[2],te[3])}_e.to=ye;function fe(te){return[te.red,te.green,te.blue,te.alpha]}_e.from=fe})(qe=e.Color||(e.Color={}));var He;(function(_e){function ye(te){return{range:m.from(te.range)}}_e.from=ye;function fe(te){return new a.SelectionRange(m.to(te.range))}_e.to=fe})(He=e.SelectionRange||(e.SelectionRange={}));var Ue;(function(_e){function ye(fe){switch(fe){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}_e.to=ye})(Ue=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Je;(function(_e){function ye(te){switch(te){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}_e.from=ye;function fe(te){switch(te){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}_e.to=fe})(Je=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var et;(function(_e){function ye(te){if(te===a.EndOfLine.CRLF)return 1;if(te===a.EndOfLine.LF)return 0}_e.from=ye;function fe(te){if(te===1)return a.EndOfLine.CRLF;if(te===0)return a.EndOfLine.LF}_e.to=fe})(et=e.EndOfLine||(e.EndOfLine={}));var Le;(function(_e){function ye(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}_e.from=ye})(Le=e.ProgressLocation||(e.ProgressLocation={}));var it;(function(_e){function ye(fe){const te={start:fe.start+1,end:fe.end+1};return fe.kind&&(te.kind=ne.from(fe.kind)),te}_e.from=ye})(it=e.FoldingRange||(e.FoldingRange={}));var ne;(function(_e){function ye(fe){if(fe)switch(fe){case a.FoldingRangeKind.Comment:return D.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports:return D.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region:return D.FoldingRangeKind.Region}}_e.from=ye})(ne=e.FoldingRangeKind||(e.FoldingRangeKind={}));var ae;(function(_e){function ye(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?m.from(fe.selection):void 0,override:typeof fe.override=="boolean"?p.EditorResolution.DISABLED:void 0}}_e.from=ye})(ae=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var J;(function(_e){function ye(Re){return Re instanceof a.RelativePattern?Re.toJSON():typeof Re=="string"?Re:fe(Re)||te(Re)?new a.RelativePattern(Re.baseUri??Re.base,Re.pattern).toJSON():Re}_e.from=ye;function fe(Re){const Ve=Re;return Ve?R.URI.isUri(Ve.baseUri)&&typeof Ve.pattern=="string":!1}function te(Re){const Ve=Re;return Ve?typeof Ve.base=="string"&&typeof Ve.pattern=="string":!1}function Ie(Re){return typeof Re=="string"?Re:new a.RelativePattern(R.URI.revive(Re.baseUri),Re.pattern)}_e.to=Ie})(J=e.GlobPattern||(e.GlobPattern={}));var pe;(function(_e){function ye(fe){if(fe){if(Array.isArray(fe))return fe.map(ye);if(typeof fe=="string")return fe;{const te=fe;return{language:te.language,scheme:te.scheme,pattern:J.from(te.pattern),exclusive:te.exclusive}}}else return}_e.from=ye})(pe=e.LanguageSelector||(e.LanguageSelector={}));var Se;(function(_e){function ye(te){return{start:te.start,end:te.end}}_e.from=ye;function fe(te){return new a.NotebookRange(te.start,te.end)}_e.to=fe})(Se=e.NotebookRange||(e.NotebookRange={}));var Me;(function(_e){function ye(te){return{timing:typeof te.runStartTime=="number"&&typeof te.runEndTime=="number"?{startTime:te.runStartTime,endTime:te.runEndTime}:void 0,executionOrder:te.executionOrder,success:te.lastRunSuccess}}_e.to=ye;function fe(te){return{lastRunSuccess:te.success,runStartTime:te.timing?.startTime,runEndTime:te.timing?.endTime,executionOrder:te.executionOrder}}_e.from=fe})(Me=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var $e;(function(_e){function ye(fe){if(fe===d.NotebookCellExecutionState.Executing)return a.NotebookCellExecutionState.Executing;if(fe===d.NotebookCellExecutionState.Pending)return a.NotebookCellExecutionState.Pending;if(fe===d.NotebookCellExecutionState.Unconfirmed)return a.NotebookCellExecutionState.Pending;throw new Error(`Unknown state: ${fe}`)}_e.to=ye})($e=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ye;(function(_e){function ye(te){switch(te){case a.NotebookCellKind.Markup:return d.CellKind.Markup;case a.NotebookCellKind.Code:default:return d.CellKind.Code}}_e.from=ye;function fe(te){switch(te){case d.CellKind.Markup:return a.NotebookCellKind.Markup;case d.CellKind.Code:default:return a.NotebookCellKind.Code}}_e.to=fe})(Ye=e.NotebookCellKind||(e.NotebookCellKind={}));var lt;(function(_e){function ye(te){const Ie={metadata:te.metadata??Object.create(null),cells:[]};for(let Re of te.cells)a.NotebookCellData.validate(Re),Ie.cells.push(vt.from(Re));return Ie}_e.from=ye;function fe(te){const Ie=new a.NotebookData(te.cells.map(vt.to));return(0,S.isEmptyObject)(te.metadata)||(Ie.metadata=te.metadata),Ie}_e.to=fe})(lt=e.NotebookData||(e.NotebookData={}));var vt;(function(_e){function ye(te){return{cellKind:Ye.from(te.kind),language:te.languageId,mime:te.mime,source:te.value,metadata:te.metadata,internalMetadata:Me.from(te.executionSummary??{}),outputs:te.outputs?te.outputs.map(je.from):[]}}_e.from=ye;function fe(te){return new a.NotebookCellData(Ye.to(te.cellKind),te.source,te.language,te.mime,te.outputs?te.outputs.map(je.to):void 0,te.metadata,te.internalMetadata?Me.to(te.internalMetadata):void 0)}_e.to=fe})(vt=e.NotebookCellData||(e.NotebookCellData={}));var wt;(function(_e){function ye(te){return{mime:te.mime,valueBytes:n.VSBuffer.wrap(te.data)}}_e.from=ye;function fe(te){return new a.NotebookCellOutputItem(te.valueBytes.buffer,te.mime)}_e.to=fe})(wt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var je;(function(_e){function ye(te){return{outputId:te.id,items:te.items.map(wt.from),metadata:te.metadata}}_e.from=ye;function fe(te){const Ie=te.items.map(wt.to);return new a.NotebookCellOutput(Ie,te.outputId,te.metadata)}_e.to=fe})(je=e.NotebookCellOutput||(e.NotebookCellOutput={}));var st;(function(_e){function ye(Ie){return te(Ie)?{include:(0,S.withNullAsUndefined)(J.from(Ie.include)),exclude:(0,S.withNullAsUndefined)(J.from(Ie.exclude))}:(0,S.withNullAsUndefined)(J.from(Ie))}_e.from=ye;function fe(Ie){return te(Ie)?{include:J.to(Ie.include),exclude:J.to(Ie.exclude)}:J.to(Ie)}_e.to=fe;function te(Ie){const Re=Ie;return Re?!!Re.include&&!!Re.exclude:!1}})(st=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var _t;(function(_e){function ye(fe){return{backgroundColor:fe.backgroundColor,borderColor:fe.borderColor,top:fe.top?y.from(fe.top):void 0}}_e.from=ye})(_t=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var nt;(function(_e){function ye(fe,te,Ie){const Re=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:te.toInternal(Re,Ie),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}_e.from=ye})(nt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ct;(function(_e){function ye(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{}}}_e.from=ye})(ct=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Rt;(function(_e){function ye(te){return{uri:te.uri,provides:te.provides}}_e.from=ye;function fe(te){return new a.NotebookRendererScript(R.URI.revive(te.uri),te.provides)}_e.to=fe})(Rt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Tt;(function(_e){function ye(te){return{message:P.fromStrict(te.message)||"",type:0,expected:te.expectedOutput,actual:te.actualOutput,location:te.location&&{range:m.from(te.location.range),uri:te.location.uri}}}_e.from=ye;function fe(te){const Ie=new a.TestMessage(typeof te.message=="string"?te.message:P.to(te.message));return Ie.actualOutput=te.actual,Ie.expectedOutput=te.expected,Ie.location=te.location?Z.to(te.location):void 0,Ie}_e.to=fe})(Tt=e.TestMessage||(e.TestMessage={}));var yt;(function(_e){_e.namespace=v.namespaceTestTag,_e.denamespace=v.denamespaceTestTag})(yt=e.TestTag||(e.TestTag={}));var mt;(function(_e){function ye(Re){const Ve=(0,g.getPrivateApiFor)(Re).controllerId;return{extId:A.TestId.fromExtHostTestItem(Re,Ve).toString(),label:Re.label,uri:R.URI.revive(Re.uri),busy:!1,tags:Re.tags.map(Ke=>yt.namespace(Ve,Ke.id)),range:F.Range.lift(m.from(Re.range)),description:Re.description||null,sortText:Re.sortText||null,error:Re.error&&P.fromStrict(Re.error)||null}}_e.from=ye;function fe(Re){return{parent:void 0,error:void 0,id:A.TestId.fromString(Re.extId).localId,label:Re.label,uri:R.URI.revive(Re.uri),tags:(Re.tags||[]).map(Ve=>{const{tagId:Ke}=yt.denamespace(Ve);return new a.TestTag(Ke)}),range:m.to(Re.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Re.description||void 0,sortText:Re.sortText||void 0}}_e.toPlain=fe;function te(Re){const Ve=A.TestId.fromString(Re.extId),Ke=new g.TestItemImpl(Ve.controllerId,Ve.localId,Re.label,R.URI.revive(Re.uri)||void 0);return Ke.range=m.to(Re.range||void 0),Ke.description=Re.description||void 0,Ke.sortText=Re.sortText||void 0,Ke}function Ie(Re){let Ve;for(const Ke of Re.tests){const ht=te(Ke.item);(0,g.getPrivateApiFor)(ht).parent=Ve,Ve=ht}return Ve}_e.toItemFromContext=Ie})(mt=e.TestItem||(e.TestItem={})),function(_e){function ye(te){return{id:te.id}}_e.from=ye;function fe(te){return new a.TestTag(te.id)}_e.to=fe}(yt=e.TestTag||(e.TestTag={}));var Lt;(function(_e){const ye=(te,Ie)=>{const Re={...mt.toPlain(te.item),parent:void 0,taskStates:te.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(Ke=>Ke.type===0).map(Tt.to)})),children:te.children.map(Ve=>Ie.get(Ve)).filter(S.isDefined).map(Ve=>ye(Ve,Ie))};for(const Ve of Re.children)Ve.parent=Re;return Re};function fe(te){const Ie=[],Re=new Map;for(const Ve of te.items)Re.set(Ve.item.extId,Ve),te.request.targets.some(Ke=>Ke.controllerId===Ve.controllerId&&Ke.testIds.includes(Ve.item.extId))&&Ie.push(Ve);return{completedAt:te.completedAt,results:Ie.map(Ve=>ye(Ve,Re))}}_e.to=fe})(Lt=e.TestResults||(e.TestResults={}));var Mt;(function(_e){function ye(Re){return{covered:Re.covered,total:Re.covered}}function fe(Re){return"line"in Re?E.from(Re):m.from(Re)}function te(Re){return"branches"in Re?{count:Re.executionCount,location:fe(Re.location),type:1,branches:Re.branches.length?Re.branches.map(Ve=>({count:Ve.executionCount,location:Ve.location&&fe(Ve.location)})):void 0}:{type:0,count:Re.executionCount,location:fe(Re.location)}}_e.fromDetailed=te;function Ie(Re){return{uri:Re.uri,statement:ye(Re.statementCoverage),branch:Re.branchCoverage&&ye(Re.branchCoverage),function:Re.functionCoverage&&ye(Re.functionCoverage),details:Re.detailedCoverage?.map(te)}}_e.fromFile=Ie})(Mt=e.TestCoverage||(e.TestCoverage={}));var Ft;(function(_e){function ye(fe){switch(fe){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}_e.to=ye})(Ft=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var xe;(function(_e){function ye(te){const Ie=new a.TypeHierarchyItem(H.to(te.kind),te.name,te.detail||"",R.URI.revive(te.uri),m.to(te.range),m.to(te.selectionRange));return Ie._sessionId=te._sessionId,Ie._itemId=te._itemId,Ie}_e.to=ye;function fe(te,Ie,Re){if(Ie=Ie??te._sessionId,Re=Re??te._itemId,Ie===void 0||Re===void 0)throw new Error("invalid item");return{_sessionId:Ie,_itemId:Re,kind:H.from(te.kind),name:te.name,detail:te.detail??"",uri:te.uri,range:m.from(te.range),selectionRange:m.from(te.selectionRange),tags:te.tags?.map(q.from)}}_e.from=fe})(xe=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(ve[219],we([1,0,2,17,7,14,90]),function(ee,e,h,n,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(R,F,D,p={timeout:1500,errors:3}){this._logService=R,this._documents=F,this._mainThreadBulkEdits=D,this._thresholds=p,this._callbacks=new C.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(R){return(F,D,p)=>{const g={dispose:this._callbacks.push([F,D,R])};return Array.isArray(p)&&p.push(g),g}}async $participateInSave(R,F){const D=h.URI.revive(R);let p=!1;const _=setTimeout(()=>p=!0,this._thresholds.timeout),g=[];try{for(let d of[...this._callbacks]){if(p)break;const v=this._documents.getDocument(D),A=await this._deliverEventAsyncAndBlameBadListeners(d,{document:v,reason:T.TextDocumentSaveReason.to(F)});g.push(A)}}finally{clearTimeout(_)}return g}_deliverEventAsyncAndBlameBadListeners([R,F,D],p){const _=this._badListeners.get(R);return typeof _=="number"&&_>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(D,R,F,p).then(()=>!0,g=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this._logService.error(g),!(g instanceof Error)||g.message!=="concurrent_edits"){const d=this._badListeners.get(R);this._badListeners.set(R,d?d+1:1),typeof d=="number"&&d>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(R,F,D,p){const _=[],g=Date.now(),{document:d,reason:v}=p,{version:A}=d,b=Object.freeze({document:d,reason:v,waitUntil(a){if(Object.isFrozen(_))throw(0,n.illegalState)("waitUntil can not be called async");_.push(Promise.resolve(a))}});try{F.apply(D,[b])}catch(a){return Promise.reject(a)}return Object.freeze(_),new Promise((a,c)=>{const m=setTimeout(()=>c(new Error("timeout")),this._thresholds.timeout);return Promise.all(_).then(s=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${R.identifier.value}' finished after ${Date.now()-g}ms`),clearTimeout(m),a(s)}).catch(s=>{clearTimeout(m),c(s)})}).then(a=>{const c={edits:[]};for(const m of a)if(Array.isArray(m)&&m.every(s=>s instanceof I.TextEdit))for(const{newText:s,newEol:E,range:l}of m)c.edits.push({_type:2,resource:d.uri,edit:{range:l&&T.Range.from(l),text:s,eol:E&&T.EndOfLine.from(E)}});if(c.edits.length!==0)return A===d.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(ve[220],we([1,0,10,25,2,14,128]),function(ee,e,h,n,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class k{constructor(D,p,_,g){this.start=D,this.deletedCount=p,this.deletedItems=_,this.items=g}static asApiEvents(D){return D.map(p=>({start:p.start,deletedCount:p.deletedCount,deletedItems:p.deletedItems,items:p.items.map(_=>_.apiCell)}))}}class S{constructor(D,p,_){this.notebook=D,this._extHostDocument=p,this._cellData=_,this.handle=_.handle,this.uri=I.URI.revive(_.uri),this.cellKind=_.cellKind,this._outputs=_.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=_.internalMetadata??{},this._metadata=Object.freeze(_.metadata??{}),this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(_.internalMetadata??{}))}static asModelAddData(D,p){return{EOL:p.eol,lines:p.source,languageId:p.language,uri:p.uri,isDirty:!1,versionId:1,notebook:D}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const D=this,p=this._extHostDocument.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:p.document,get mime(){return D._mime},set mime(_){D._mime=_},get outputs(){return D._outputs.slice(0)},get metadata(){return D._metadata},get executionSummary(){return D._previousResult}})}return this._apiCell}setOutputs(D){this._outputs=D.map(T.NotebookCellOutput.to)}setOutputItems(D,p,_){const g=_.map(T.NotebookCellOutputItem.to),d=this._outputs.find(v=>v.id===D);d&&(p||(d.items.length=0),d.items.push(...g))}setMetadata(D){this._metadata=Object.freeze(D)}setInternalMetadata(D){this._internalMetadata=D,this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.ExtHostCell=S;class R{constructor(D,p,_,g,d,v){this._proxy=D,this._textDocumentsAndEditors=p,this._textDocuments=_,this._emitter=g,this.uri=d,this.handle=R._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=v.viewType,this._metadata=Object.freeze(v.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,v.cells]],!0),this._versionId=v.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const D=this;this._notebook={get uri(){return D.uri},get version(){return D._versionId},get notebookType(){return D._notebookType},get isDirty(){return D._isDirty},get isUntitled(){return D.uri.scheme===h.Schemas.untitled},get isClosed(){return D._disposed},get metadata(){return D._metadata},get cellCount(){return D._cells.length},cellAt(p){return p=D._validateIndex(p),D._cells[p].apiCell},getCells(p){return(p?D._getCells(p):D._cells).map(g=>g.apiCell)},save(){return D._save()}}}return this._notebook}updateBackup(D){this._backup?.delete(),this._backup=D}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(D){D.metadata&&(this._metadata=Object.freeze({...this._metadata,...D.metadata}))}acceptDirty(D){this._isDirty=D}acceptModelChanged(D,p){this._versionId=D.versionId,this._isDirty=p;for(const _ of D.rawEvents)_.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(_.changes,!1):_.kind===C.NotebookCellsChangeType.Move?this._moveCell(_.index,_.newIdx):_.kind===C.NotebookCellsChangeType.Output?this._setCellOutputs(_.index,_.outputs):_.kind===C.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(_.index,_.outputId,_.append,_.outputItems):_.kind===C.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(_.index,_.language):_.kind===C.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(_.index,_.mime):_.kind===C.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(_.index,_.metadata):_.kind===C.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(_.index,_.internalMetadata)}_validateIndex(D){return D=D|0,D<0?0:D>=this._cells.length?this._cells.length-1:D}_validateRange(D){let p=D.start|0,_=D.end|0;return p<0&&(p=0),_>this._cells.length&&(_=this._cells.length),D.with({start:p,end:_})}_getCells(D){D=this._validateRange(D);const p=[];for(let _=D.start;_<D.end;_++)p.push(this._cells[_]);return p}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(D,p){if(this._disposed)return;const _=[],g=[],d=[];D.reverse().forEach(v=>{const b=v[2].map(m=>{const s=new S(this,this._textDocumentsAndEditors,m);return p||g.push(S.asModelAddData(this.apiNotebook,m)),s}),a=new k(v[0],v[1],[],b),c=this._cells.splice(v[0],v[1],...b);for(const m of c)d.push(m.uri),a.deletedItems.push(m.apiCell);_.push(a)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:g,removedDocuments:d}),p||this._emitter.emitModelChange((0,n.deepFreeze)({document:this.apiNotebook,changes:k.asApiEvents(_)}))}_moveCell(D,p){const _=this._cells.splice(D,1);this._cells.splice(p,0,..._);const g=[new k(D,1,_.map(d=>d.apiCell),[]),new k(p,0,[],_)];this._emitter.emitModelChange((0,n.deepFreeze)({document:this.apiNotebook,changes:k.asApiEvents(g)}))}_setCellOutputs(D,p){const _=this._cells[D];_.setOutputs(p),this._emitter.emitCellOutputsChange((0,n.deepFreeze)({document:this.apiNotebook,cells:[_.apiCell]}))}_setCellOutputItems(D,p,_,g){const d=this._cells[D];d.setOutputItems(p,_,g),this._emitter.emitCellOutputsChange((0,n.deepFreeze)({document:this.apiNotebook,cells:[d.apiCell]}))}_changeCellLanguage(D,p){const _=this._cells[D];_.apiCell.document.languageId!==p&&this._textDocuments.$acceptModelLanguageChanged(_.uri,p)}_changeCellMime(D,p){const _=this._cells[D];_.apiCell.mime=p}_changeCellMetadata(D,p){const _=this._cells[D],g=_.apiCell.metadata;_.setMetadata(p);const d=_.apiCell.metadata;(0,n.equals)(g,d)||this._emitter.emitCellMetadataChange((0,n.deepFreeze)({document:this.apiNotebook,cell:_.apiCell}))}_changeCellInternalMetadata(D,p){this._cells[D].setInternalMetadata(p)}getCellFromApiCell(D){return this._cells.find(p=>p.apiCell===D)}getCellFromIndex(D){return this._cells[D]}getCell(D){return this._cells.find(p=>p.handle===D)}getCellIndex(D){return this._cells.indexOf(D)}}e.ExtHostNotebookDocument=R,R._handlePool=0}),define(ve[130],we([1,0,7,14,17]),function(ee,e,h,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class T{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,R){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:S,metadata:R})}replaceCells(S,R,F){this._throwIfFinalized(),!(S===R&&F.length===0)&&this._collectedEdits.push({editType:1,index:S,count:R-S,cells:F.map(n.NotebookCellData.from)})}}class C{constructor(S,R,F,D,p,_){this.id=S,this._proxy=R,this.notebookData=F,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._visibleRanges=D,this._viewColumn=_}get apiEditor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.apiNotebook},get selections(){return S._selections},set selections(R){if(!Array.isArray(R)||!R.every(h.NotebookRange.isNotebookRange))throw(0,I.illegalArgument)("selections");S._selections=R,S._trySetSelections(R)},get visibleRanges(){return S._visibleRanges},revealRange(R,F){S._proxy.$tryRevealRange(S.id,n.NotebookRange.from(R),F??h.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},edit(R){const F=new T(this.document.version);return R(F),S._applyEdit(F.finalize())},setDecorations(R,F){return S.setDecorations(R,F)}},C.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_trySetSelections(S){this._proxy.$trySetSelections(this.id,S.map(n.NotebookRange.from))}_acceptViewColumn(S){this._viewColumn=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const R=[];let F=-1;for(let D=0;D<S.cellEdits.length;D++){if(F<0){R.push(S.cellEdits[D]),F++;continue}const _=R[F],g=S.cellEdits[D];if(_.editType===1&&g.editType===1&&_.index===g.index){_.cells.push(...S.cellEdits[D].cells),_.count+=S.cellEdits[D].count;continue}R.push(S.cellEdits[D]),F++}return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,R)}setDecorations(S,R){if(!(R.isEmpty&&!this._hasDecorationsForKey.has(S.key)))return R.isEmpty?this._hasDecorationsForKey.delete(S.key):this._hasDecorationsForKey.add(S.key),this._proxy.$trySetDecorations(this.id,n.NotebookRange.from(R),S.key)}}e.ExtHostNotebookEditor=C,C.apiEditorsToExtHost=new WeakMap}),define(ve[221],we([1,0,14,118,168,21,56,17]),function(ee,e,h,n,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(p){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=p}async withProgress(p,_,g){const d=this._handles++,{title:v,location:A,cancellable:b}=_,a={label:(0,I.localize)(0,null,p.displayName||p.name),id:p.identifier.value};return this._proxy.$startProgress(d,{location:h.ProgressLocation.from(A),title:v,source:a,cancellable:b},p.isUnderDevelopment?void 0:p.identifier.value).catch(k.onUnexpectedExternalError),this._withProgress(d,g,!!b)}_withProgress(p,_,g){let d;g&&(d=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(p,d));const v=b=>{this._proxy.$progressEnd(b),this._mapHandleToCancellationSource.delete(b),d&&d.dispose()};let A;try{A=_(new F(this._proxy,p),g&&d?d.token:T.CancellationToken.None)}catch(b){throw v(p),b}return A.then(b=>v(p),b=>v(p)),A}$acceptProgressCanceled(p){const _=this._mapHandleToCancellationSource.get(p);_&&(_.cancel(),this._mapHandleToCancellationSource.delete(p))}}e.ExtHostProgress=S;function R(D,p){return D.message=p.message,typeof p.increment=="number"&&(typeof D.increment=="number"?D.increment+=p.increment:D.increment=p.increment),D}class F extends n.Progress{constructor(p,_){super(g=>this.throttledReport(g));this._proxy=p,this._handle=_}throttledReport(p){this._proxy.$progressReport(this._handle,p)}}Be([(0,C.throttle)(100,(D,p)=>R(D,p),()=>Object.create(null))],F.prototype,"throttledReport",null)}),define(ve[131],we([1,0,55,17,75,14,7]),function(ee,e,h,n,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(p,_,g){const d=k._Keys.nextId();p.$registerTextEditorDecorationType(_.identifier,d,T.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:d,dispose(){p.$removeTextEditorDecorationType(d)}})}}e.TextEditorDecorationType=k,k._Keys=new I.IdGenerator("TextEditorDecorationType");class S{constructor(p,_){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=p,this._documentVersionId=p.version,this._undoStopBefore=_.undoStopBefore,this._undoStopAfter=_.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(p,_){this._throwIfFinalized();let g=null;if(p instanceof C.Position)g=new C.Range(p,p);else if(p instanceof C.Range)g=p;else throw new Error("Unrecognized location");this._pushEdit(g,_,!1)}insert(p,_){this._throwIfFinalized(),this._pushEdit(new C.Range(p,p),_,!0)}delete(p){this._throwIfFinalized();let _=null;if(p instanceof C.Range)_=p;else throw new Error("Unrecognized location");this._pushEdit(_,null,!0)}_pushEdit(p,_,g){const d=this._document.validateRange(p);this._collectedEdits.push({range:d,text:_,forceMoveMarkers:g})}setEndOfLine(p){if(this._throwIfFinalized(),p!==C.EndOfLine.LF&&p!==C.EndOfLine.CRLF)throw(0,n.illegalArgument)("endOfLine");this._setEndOfLine=p}}e.TextEditorEdit=S;class R{constructor(p,_,g,d){this._proxy=p,this._id=_,this._accept(g),this._logService=d;const v=this;this.value={get tabSize(){return v._tabSize},set tabSize(A){v._setTabSize(A)},get insertSpaces(){return v._insertSpaces},set insertSpaces(A){v._setInsertSpaces(A)},get cursorStyle(){return v._cursorStyle},set cursorStyle(A){v._setCursorStyle(A)},get lineNumbers(){return v._lineNumbers},set lineNumbers(A){v._setLineNumbers(A)}}}_accept(p){this._tabSize=p.tabSize,this._insertSpaces=p.insertSpaces,this._cursorStyle=p.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(p.lineNumbers)}_validateTabSize(p){if(p==="auto")return"auto";if(typeof p=="number"){const _=Math.floor(p);return _>0?_:null}if(typeof p=="string"){const _=parseInt(p,10);return isNaN(_)?null:_>0?_:null}return null}_setTabSize(p){const _=this._validateTabSize(p);if(_!==null){if(typeof _=="number"){if(this._tabSize===_)return;this._tabSize=_}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:_}))}}_validateInsertSpaces(p){return p==="auto"?"auto":p==="false"?!1:Boolean(p)}_setInsertSpaces(p){const _=this._validateInsertSpaces(p);if(typeof _=="boolean"){if(this._insertSpaces===_)return;this._insertSpaces=_}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:_}))}_setCursorStyle(p){this._cursorStyle!==p&&(this._cursorStyle=p,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:p})))}_setLineNumbers(p){this._lineNumbers!==p&&(this._lineNumbers=p,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(p)})))}assign(p){const _={};let g=!1;if(typeof p.tabSize!="undefined"){const d=this._validateTabSize(p.tabSize);d==="auto"?(g=!0,_.tabSize=d):typeof d=="number"&&this._tabSize!==d&&(this._tabSize=d,g=!0,_.tabSize=d)}if(typeof p.insertSpaces!="undefined"){const d=this._validateInsertSpaces(p.insertSpaces);d==="auto"?(g=!0,_.insertSpaces=d):this._insertSpaces!==d&&(this._insertSpaces=d,g=!0,_.insertSpaces=d)}typeof p.cursorStyle!="undefined"&&this._cursorStyle!==p.cursorStyle&&(this._cursorStyle=p.cursorStyle,g=!0,_.cursorStyle=p.cursorStyle),typeof p.lineNumbers!="undefined"&&this._lineNumbers!==p.lineNumbers&&(this._lineNumbers=p.lineNumbers,g=!0,_.lineNumbers=T.TextEditorLineNumbersStyle.from(p.lineNumbers)),g&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,_))}_warnOnError(p,_){_.catch(g=>{this._logService.warn(`ExtHostTextEditorOptions '${p}' failed:'`),this._logService.warn(g)})}}e.ExtHostTextEditorOptions=R;class F{constructor(p,_,g,d,v,A,b,a){this.id=p,this._proxy=_,this._logService=g,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=v,this._options=new R(this._proxy,this.id,A,g),this._visibleRanges=b,this._viewColumn=a;const c=this;this.value=Object.freeze({get document(){return d.getValue()},set document(m){throw(0,n.readonly)("document")},get selection(){return c._selections&&c._selections[0]},set selection(m){if(!(m instanceof C.Selection))throw(0,n.illegalArgument)("selection");c._selections=[m],c._trySetSelection()},get selections(){return c._selections},set selections(m){if(!Array.isArray(m)||m.some(s=>!(s instanceof C.Selection)))throw(0,n.illegalArgument)("selections");c._selections=m,c._trySetSelection()},get visibleRanges(){return c._visibleRanges},set visibleRanges(m){throw(0,n.readonly)("visibleRanges")},get options(){return c._options.value},set options(m){c._disposed||c._options.assign(m)},get viewColumn(){return c._viewColumn},set viewColumn(m){throw(0,n.readonly)("viewColumn")},edit(m,s={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const E=new S(d.getValue(),s);return m(E),c._applyEdit(E)},insertSnippet(m,s,E={undoStopBefore:!0,undoStopAfter:!0}){if(c._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let l;if(!s||Array.isArray(s)&&s.length===0)l=c._selections.map(i=>T.Range.from(i));else if(s instanceof C.Position){const{lineNumber:i,column:r}=T.Position.from(s);l=[{startLineNumber:i,startColumn:r,endLineNumber:i,endColumn:r}]}else if(s instanceof C.Range)l=[T.Range.from(s)];else{l=[];for(const i of s)if(i instanceof C.Range)l.push(T.Range.from(i));else{const{lineNumber:r,column:t}=T.Position.from(i);l.push({startLineNumber:r,startColumn:t,endLineNumber:r,endColumn:t})}}return _.$tryInsertSnippet(p,m.value,l,E)},setDecorations(m,s){const E=s.length===0;E&&!c._hasDecorationsForKey.has(m.key)||(E?c._hasDecorationsForKey.delete(m.key):c._hasDecorationsForKey.add(m.key),c._runOnProxy(()=>{if(T.isDecorationOptionsArr(s))return _.$trySetDecorations(p,m.key,T.fromRangeOrRangeWithMessage(s));{const l=new Array(4*s.length);for(let i=0,r=s.length;i<r;i++){const t=s[i];l[4*i]=t.start.line+1,l[4*i+1]=t.start.character+1,l[4*i+2]=t.end.line+1,l[4*i+3]=t.end.character+1}return _.$trySetDecorationsFast(p,m.key,l)}}))},revealRange(m,s){c._runOnProxy(()=>_.$tryRevealRange(p,T.Range.from(m),s||C.TextEditorRevealType.Default))},show(m){_.$tryShowEditor(p,T.ViewColumn.from(m))},hide(){_.$tryHideEditor(p)}})}dispose(){(0,h.ok)(!this._disposed),this._disposed=!0}_acceptOptions(p){(0,h.ok)(!this._disposed),this._options._accept(p)}_acceptVisibleRanges(p){(0,h.ok)(!this._disposed),this._visibleRanges=p}_acceptViewColumn(p){(0,h.ok)(!this._disposed),this._viewColumn=p}_acceptSelections(p){(0,h.ok)(!this._disposed),this._selections=p}async _trySetSelection(){const p=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,p)),this.value}_applyEdit(p){const _=p.finalize();if(_.edits.length===0&&!_.setEndOfLine)return Promise.resolve(!0);const g=_.edits.map(v=>v.range);g.sort((v,A)=>v.end.line===A.end.line?v.end.character===A.end.character?v.start.line===A.start.line?v.start.character-A.start.character:v.start.line-A.start.line:v.end.character-A.end.character:v.end.line-A.end.line);for(let v=0,A=g.length-1;v<A;v++){const b=g[v].end;if(g[v+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=_.edits.map(v=>({range:T.Range.from(v.range),text:v.text,forceMoveMarkers:v.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,d,{setEndOfLine:typeof _.setEndOfLine=="number"?T.EndOfLine.from(_.setEndOfLine):void 0,undoStopBefore:_.undoStopBefore,undoStopAfter:_.undoStopAfter})}_runOnProxy(p){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):p().then(()=>this,_=>(_ instanceof Error&&_.name==="DISPOSED"||this._logService.warn(_),null))}}e.ExtHostTextEditor=F}),define(ve[222],we([1,0,15,3,6,13,62,14,84,85,35]),function(ee,e,h,n,I,T,C,k,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class D extends I.Disposable{constructor(_){super();this.controllerId=_,this.debounceSendDiff=this._register(new h.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new n.Emitter),this.root=new C.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(_){this._resolveHandler=_;for(const g of this.tree.values())this.updateExpandability(g)}collectDiff(){const _=this.diff;return this.diff=[],_}pushDiff(_){const g=this.diff[this.diff.length-1];if(g&&_.op===1){if(g.op===1&&g.item.extId===_.item.extId){(0,S.applyTestItemUpdate)(g.item,_.item);return}if(g.op===0&&g.item.item.extId===_.item.extId){(0,S.applyTestItemUpdate)(g.item,_.item);return}}this.diff.push(_),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(_,g){const d=this.tree.get(_);if(!!d){if((d.expandLevels===void 0||g>d.expandLevels)&&(d.expandLevels=g),d.expand===1){const v=this.resolveChildren(d);return v.isOpen()?this.expandChildren(d,g-1):v.wait().then(()=>this.expandChildren(d,g-1))}else if(d.expand===3)return d.resolveBarrier?.isOpen()===!1?d.resolveBarrier.wait().then(()=>this.expandChildren(d,g-1)):this.expandChildren(d,g-1)}}dispose(){for(const _ of this.tree.values())(0,C.getPrivateApiFor)(_.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(_,g){switch(g.op){case 2:this.pushDiff({op:4,itemId:_.fullId.toString()});break;case 1:this.removeItem(R.TestId.joinToString(_.fullId,g.id));break;case 0:this.upsertItem(g.item,_);break;case 4:for(const d of g.ops)this.onTestItemEvent(_,d);break;case 3:{const{key:d,value:v,previous:A}=g,b=_.fullId.toString();switch(d){case"canResolveChildren":this.updateExpandability(_);break;case"tags":this.diffTagRefs(v,A,b);break;case"range":this.pushDiff({op:1,item:{extId:b,item:{range:F.Range.lift(k.Range.from(v))}}});break;case"error":this.pushDiff({op:1,item:{extId:b,item:{error:k.MarkdownString.fromStrict(v)||null}}});break;default:this.pushDiff({op:1,item:{extId:b,item:{[d]:v??null}}});break}break}default:(0,T.assertNever)(g)}}upsertItem(_,g){if(!(_ instanceof C.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${_.id} did not`);const d=R.TestId.fromExtHostTestItem(_,this.root.id,g?.actual),v=(0,C.getPrivateApiFor)(_);v.parent&&v.parent!==g?.actual&&v.parent.children.delete(_.id);let A=this.tree.get(d.toString());if(!A){A={fullId:d,actual:_,parent:g?d.parentId:null,expandLevels:g?.expandLevels?g.expandLevels-1:void 0,expand:0},_.tags.forEach(this.incrementTagRefs,this),this.tree.set(A.fullId.toString(),A),this.setItemParent(_,g),this.pushDiff({op:0,item:{parent:A.parent&&A.parent.toString(),controllerId:this.controllerId,expand:A.expand,item:k.TestItem.from(_)}}),this.connectItemAndChildren(_,A,g);return}if(A.actual===_){this.connectItem(_,A,g);return}const b=A.actual.children,a=A.actual,c=(0,C.diffTestItems)(a,_);(0,C.getPrivateApiFor)(a).listener=void 0,A.actual=_,A.expand=0;for(const[m,s]of c)this.onTestItemEvent(A,{op:3,key:m,value:s,previous:a[m]});this.connectItemAndChildren(_,A,g);for(const m of b)_.children.get(m.id)||this.removeItem(R.TestId.joinToString(d,m.id))}diffTagRefs(_,g,d){const v=new Set(g.map(A=>A.id));for(const A of _)v.delete(A.id)||this.incrementTagRefs(A);this.pushDiff({op:1,item:{extId:d,item:{tags:_.map(A=>k.TestTag.namespace(this.controllerId,A.id))}}}),v.forEach(this.decrementTagRefs,this)}incrementTagRefs(_){const g=this.tags.get(_.id);g?g.refCount++:(this.tags.set(_.id,{refCount:1}),this.pushDiff({op:5,tag:{id:k.TestTag.namespace(this.controllerId,_.id),ctrlLabel:this.root.label}}))}decrementTagRefs(_){const g=this.tags.get(_);g&&!--g.refCount&&(this.tags.delete(_),this.pushDiff({op:6,id:(0,S.namespaceTestTag)(this.controllerId,_)}))}setItemParent(_,g){(0,C.getPrivateApiFor)(_).parent=g&&g.actual!==this.root?g.actual:void 0}connectItem(_,g,d){this.setItemParent(_,d);const v=(0,C.getPrivateApiFor)(_);v.parent=d?.actual,v.listener=A=>this.onTestItemEvent(g,A),this.updateExpandability(g)}connectItemAndChildren(_,g,d){this.connectItem(_,g,d);for(const v of _.children)this.upsertItem(v,g)}updateExpandability(_){let g;this._resolveHandler?_.resolveBarrier?g=_.resolveBarrier.isOpen()?3:2:g=_.actual.canResolveChildren?1:0:g=0,g!==_.expand&&(_.expand=g,this.pushDiff({op:1,item:{extId:_.fullId.toString(),expand:g}}),g===1&&_.expandLevels!==void 0&&this.resolveChildren(_))}expandChildren(_,g){if(g<0)return;const d=[];for(const v of _.actual.children){const A=this.expand(R.TestId.joinToString(_.fullId,v.id),g);(0,h.isThenable)(A)&&d.push(A)}if(d.length)return Promise.all(d).then(()=>{})}resolveChildren(_){if(_.resolveBarrier)return _.resolveBarrier;if(!this._resolveHandler){const A=new h.Barrier;return A.open(),A}_.expand=2,this.pushExpandStateUpdate(_);const g=_.resolveBarrier=new h.Barrier,d=A=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),_.actual!==this.root&&(_.actual.error=A.stack||A.message||String(A))};let v;try{v=this._resolveHandler(_.actual===this.root?void 0:_.actual)}catch(A){d(A)}return(0,h.isThenable)(v)?v.catch(d).then(()=>{g.open(),this.updateExpandability(_)}):(g.open(),this.updateExpandability(_)),_.resolveBarrier}pushExpandStateUpdate(_){this.pushDiff({op:1,item:{extId:_.fullId.toString(),expand:_.expand}})}removeItem(_){const g=this.tree.get(_);if(!g)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:_});const d=[g];for(;d.length;){const v=d.pop();if(!!v){(0,C.getPrivateApiFor)(v.actual).listener=void 0;for(const A of v.actual.tags)this.decrementTagRefs(A.id);this.tree.delete(v.fullId.toString());for(const A of v.actual.children)d.push(this.tree.get(R.TestId.joinToString(v.fullId,A.id)))}}}flushDiff(){const _=this.collectDiff();_.length&&this.diffOpEmitter.fire(_)}}e.SingleUseTestCollection=D}),define(ve[223],we([1,0,4,185]),function(ee,e,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,h.refineServiceDecorator)(n.IEnvironmentService)}),define(ve[224],we([1,0,27,3,9]),function(ee,e,h,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(F){this.removedDueToLooping=F}}e.DeltaExtensionsResult=T;class C{constructor(F){this._onDidChange=new n.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=F,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const F of this._extensionDescriptions){if(this._extensionsMap.has(h.ExtensionIdentifier.toKey(F.identifier))){console.error("Extension `"+F.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(h.ExtensionIdentifier.toKey(F.identifier),F),this._extensionsArr.push(F),Array.isArray(F.activationEvents))for(let D of F.activationEvents)D==="onUri"&&(D=`onUri:${h.ExtensionIdentifier.toKey(F.identifier)}`),this._activationMap.has(D)||this._activationMap.set(D,[]),this._activationMap.get(D).push(F)}}keepOnly(F){const D=new Set;F.forEach(p=>D.add(h.ExtensionIdentifier.toKey(p))),this._extensionDescriptions=this._extensionDescriptions.filter(p=>D.has(h.ExtensionIdentifier.toKey(p.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(F,D){F.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(F));const p=C._findLoopingExtensions(this._extensionDescriptions);if(D=D.concat(p.map(_=>_.identifier)),D.length>0){const _=new Set;D.forEach(g=>_.add(h.ExtensionIdentifier.toKey(g))),this._extensionDescriptions=this._extensionDescriptions.filter(g=>!_.has(h.ExtensionIdentifier.toKey(g.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(p)}static _findLoopingExtensions(F){const D=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(v){this._nodesSet.has(v)||(this._nodesSet.add(v),this._nodesArr.push(v))}addArc(v,A){this.addNode(v),this.addNode(A),this._arcs.has(v)?this._arcs.get(v).push(A):this._arcs.set(v,[A])}getArcs(v){return this._arcs.has(v)?this._arcs.get(v):[]}hasOnlyGoodArcs(v,A){const b=D.getArcs(v);for(let a=0;a<b.length;a++)if(!A.has(b[a]))return!1;return!0}getNodes(){return this._nodesArr}};let p=new Map;for(let v of F){const A=h.ExtensionIdentifier.toKey(v.identifier);if(p.set(A,v),v.extensionDependencies)for(let b of v.extensionDependencies){const a=h.ExtensionIdentifier.toKey(b);D.addArc(A,a)}}let _=new Set;D.getNodes().filter(v=>D.getArcs(v).length===0).forEach(v=>_.add(v));let g=D.getNodes().filter(v=>!_.has(v)),d;do{d=!1;for(let v=0;v<g.length;v++){const A=g[v];D.hasOnlyGoodArcs(A,_)&&(g.splice(v,1),v--,_.add(A),d=!0)}}while(d);return g.map(v=>p.get(v))}containsActivationEvent(F){return this._activationMap.has(F)}containsExtension(F){return this._extensionsMap.has(h.ExtensionIdentifier.toKey(F))}getExtensionDescriptionsForActivationEvent(F){const D=this._activationMap.get(F);return D?D.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(F){const D=this._extensionsMap.get(h.ExtensionIdentifier.toKey(F));return D||void 0}}e.ExtensionDescriptionRegistry=C;var k;(function(R){R[R.Builtin=0]="Builtin",R[R.User=1]="User",R[R.Dev=2]="Dev"})(k||(k={}));function S(R,F){const D=R.isBuiltin?0:R.isUnderDevelopment?2:1,p=F.isBuiltin?0:F.isUnderDevelopment?2:1;if(D!==p)return D-p;const _=I.posix.basename(R.extensionLocation.path),g=I.posix.basename(F.extensionLocation.path);return _<g?-1:_>g?1:0}}),define(ve[132],we([1,0,22]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var n;(function(S){S[S.Desktop=1]="Desktop",S[S.Web=2]="Web"})(n=e.UIKind||(e.UIKind={}));var I;(function(S){S[S.VersionMismatch=55]="VersionMismatch",S[S.UnexpectedError=81]="UnexpectedError"})(I=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var T;(function(S){S[S.Initialized=0]="Initialized",S[S.Ready=1]="Ready",S[S.Terminate=2]="Terminate"})(T=e.MessageType||(e.MessageType={}));function C(S){const R=h.VSBuffer.alloc(1);switch(S){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=C;function k(S,R){if(S.byteLength!==1)return!1;switch(S.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=k}),define(ve[30],we([1,0,3,2,4,27,122]),function(ee,e,h,n,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:n.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,I.createDecorator)("extensionService");var k;(function(c){c[c.None=0]="None",c[c.LocalProcess=1]="LocalProcess",c[c.LocalWebWorker=2]="LocalWebWorker",c[c.Remote=3]="Remote"})(k=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function S(c){switch(c){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=S;class R{constructor(m){this.dependency=m}}e.MissingExtensionDependency=R;var F;(function(c){c[c.LocalProcess=0]="LocalProcess",c[c.LocalWebWorker=1]="LocalWebWorker",c[c.Remote=2]="Remote"})(F=e.ExtensionHostKind||(e.ExtensionHostKind={}));function D(c){switch(c){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=D;function p(c,m){return c.enabledApiProposals?c.enabledApiProposals.includes(m):!1}e.isProposedApiEnabled=p;function _(c,m){if(!p(c,m))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${m}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${m}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.checkProposedApiEnabled=_;class g{constructor(m,s,E,l){this.codeLoadingTime=m,this.activateCallTime=s,this.activateResolvedTime=E,this.activationReason=l}}e.ActivationTimes=g;class d{constructor(m,s){this.description=m,this.value=s}}e.ExtensionPointContribution=d,e.ExtensionHostLogFileName="exthost";var v;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(v=e.ActivationKind||(e.ActivationKind={}));function A(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation}}e.toExtension=A;function b(c,m){return{identifier:new T.ExtensionIdentifier((0,C.getExtensionId)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!m,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid}}e.toExtensionDescription=b;class a{constructor(){this.onDidRegisterExtensions=h.Event.None,this.onDidChangeExtensionsStatus=h.Event.None,this.onDidChangeExtensions=h.Event.None,this.onWillActivateByEvent=h.Event.None,this.onDidChangeResponsiveChange=h.Event.None}activateByEvent(m){return Promise.resolve(void 0)}activationEventIsDone(m){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(m){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(m){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(m){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(m,s){return Promise.resolve()}}e.NullExtensionService=a}),define(ve[225],we([1,0,17,27,30,11]),function(ee,e,h,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const C=Promise.resolve(void 0);class k{constructor(d,v,A,b){this.startup=d,this.codeLoadingTime=v,this.activateCallTime=A,this.activateResolvedTime=b}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class S{constructor(d){this._startup=d,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(d,v){return d===-1||v===-1?-1:v-d}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=S;class R{constructor(d,v,A,b,a,c){this.activationFailed=d,this.activationFailedError=v,this.activationTimes=A,this.module=b,this.exports=a,this.subscriptions=c}}e.ActivatedExtension=R;class F extends R{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=F;class D extends R{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=D;class p extends R{constructor(d){super(!0,d,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=p;let _=class{constructor(d,v,A,b,a){this._logService=a,this._isDisposed=!1,this._registry=d,this._resolvedExtensionsSet=new Set,v.forEach(c=>this._resolvedExtensionsSet.add(n.ExtensionIdentifier.toKey(c))),this._hostExtensionsMap=new Map,A.forEach(c=>this._hostExtensionsMap.set(n.ExtensionIdentifier.toKey(c),c)),this._host=b,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(d){const v=n.ExtensionIdentifier.toKey(d);return this._activatedExtensions.has(v)}getActivatedExtension(d){const v=n.ExtensionIdentifier.toKey(d),A=this._activatedExtensions.get(v);if(!A)throw new Error("Extension `"+d.value+"` is not known or not activated");return A}activateByEvent(d,v){if(this._alreadyActivatedEvents[d])return C;const A=this._registry.getExtensionDescriptionsForActivationEvent(d);return this._activateExtensions(A.map(b=>({id:b.identifier,reason:{startup:v,extensionId:b.identifier,activationEvent:d}}))).then(()=>{this._alreadyActivatedEvents[d]=!0})}activateById(d,v){const A=this._registry.getExtensionDescription(d);if(!A)throw new Error("Extension `"+d+"` is not known");return this._activateExtensions([{id:A.identifier,reason:v}])}_handleActivateRequest(d,v,A){if(this._hostExtensionsMap.has(n.ExtensionIdentifier.toKey(d.id))){v[n.ExtensionIdentifier.toKey(d.id)]=d;return}const b=this._registry.getExtensionDescription(d.id);if(!b){const m=new Error(`Cannot activate unknown extension '${d.id.value}'`);this._host.onExtensionActivationError(d.id,m,new I.MissingExtensionDependency(d.id.value)),this._activatedExtensions.set(n.ExtensionIdentifier.toKey(d.id),new p(m));return}const a=typeof b.extensionDependencies=="undefined"?[]:b.extensionDependencies;let c=!0;for(let m=0,s=a.length;m<s;m++){const E=a[m];if(this._resolvedExtensionsSet.has(n.ExtensionIdentifier.toKey(E)))continue;const l=this._activatedExtensions.get(n.ExtensionIdentifier.toKey(E));if(l&&!l.activationFailed)continue;if(l&&l.activationFailed){const o=b.displayName||b.identifier.value,f=this._registry.getExtensionDescription(E),u=f&&f.displayName||E,w=new Error(`Cannot activate the '${o}' extension because its dependency '${u}' failed to activate`);w.detail=l.activationFailedError,this._host.onExtensionActivationError(b.identifier,w,null),this._activatedExtensions.set(n.ExtensionIdentifier.toKey(b.identifier),new p(w));return}if(this._hostExtensionsMap.has(n.ExtensionIdentifier.toKey(E))){c=!1,v[n.ExtensionIdentifier.toKey(E)]={id:this._hostExtensionsMap.get(n.ExtensionIdentifier.toKey(E)),reason:d.reason};continue}const i=this._registry.getExtensionDescription(E);if(i){if(!i.main&&!i.browser)continue;c=!1,v[n.ExtensionIdentifier.toKey(E)]={id:i.identifier,reason:d.reason};continue}const r=b.displayName||b.identifier.value,t=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${E}'`);this._host.onExtensionActivationError(b.identifier,t,new I.MissingExtensionDependency(E)),this._activatedExtensions.set(n.ExtensionIdentifier.toKey(b.identifier),new p(t));return}c?v[n.ExtensionIdentifier.toKey(b.identifier)]=d:A.push(d)}_activateExtensions(d){if(d.length===0||(d=d.filter(a=>!this._activatedExtensions.has(n.ExtensionIdentifier.toKey(a.id))),d.length===0))return Promise.resolve(void 0);const v=Object.create(null),A=[];for(let a=0,c=d.length;a<c;a++)this._handleActivateRequest(d[a],v,A);for(let a=0,c=A.length;a<c;a++){const m=n.ExtensionIdentifier.toKey(A[a].id);v[m]&&delete v[m]}const b=Object.keys(v).map(a=>v[a]);return A.length===0?Promise.all(b.map(a=>this._activateExtension(a.id,a.reason))).then(a=>{}):this._activateExtensions(b).then(a=>this._activateExtensions(A))}_activateExtension(d,v){const A=n.ExtensionIdentifier.toKey(d);if(this._activatedExtensions.has(A))return Promise.resolve(void 0);const b=this._activatingExtensions.get(A);if(b)return b;const a=this._host.actualActivateExtension(d,v).then(void 0,c=>{const m=new Error;return c&&c.name&&(m.name=c.name),c&&c.message?m.message=`Activating extension '${d.value}' failed: ${c.message}.`:m.message=`Activating extension '${d.value}' failed: ${c}.`,c&&c.stack&&(m.stack=c.stack),this._isDisposed&&h.isCancellationError(c)?new p(c):(this._host.onExtensionActivationError(d,m,null),this._logService.error(`Activating extension ${d.value} failed due to an error:`),this._logService.error(c),new p(c))}).then(c=>{this._activatedExtensions.set(A,c),this._activatingExtensions.delete(A)});return this._activatingExtensions.set(A,a),a}};_=Be([Fe(4,T.ILogService)],_),e.ExtensionsActivator=_}),define(ve[226],we([1,0,11,26,30]),function(ee,e,h,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let T=class extends h.LogService{constructor(k,S){super(k.createLogger(S.logFile,{name:I.ExtensionHostLogFileName}))}};T=Be([Fe(0,h.ILoggerService),Fe(1,n.IExtHostInitDataService)],T),e.ExtHostLogService=T}),define(ve[227],we([1,0,17]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class n{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,C)=>{this._actualOk=T,this._actualErr=C,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,h.onUnexpectedError)(T))}then(T,C){return this._ensureActual().then(T,C)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=n}),define(ve[52],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class h{constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++h.count}}e.ProxyIdentifier=h,h.count=0;const n=[];function I(k){const S=new h(k);return n[S.nid]=S,S}e.createProxyIdentifier=I;function T(k){return n[k].sid}e.getStringIdentifierForProxy=T;class C{constructor(S){this.value=S}}e.SerializableObjectWithBuffers=C}),define(ve[5],we([1,0,58,2,52]),function(ee,e,h,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabKind=e.TextEditorRevealType=void 0;var T;(function(b){b[b.Default=0]="Default",b[b.InCenter=1]="InCenter",b[b.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",b[b.AtTop=3]="AtTop"})(T=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(b){b[b.SINGULAR=0]="SINGULAR",b[b.DIFF=1]="DIFF",b[b.SIDEBYSIDE=2]="SIDEBYSIDE",b[b.OTHER=3]="OTHER"})(C=e.TabKind||(e.TabKind={}));var k;(function(b){b[b.Editable=0]="Editable",b[b.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(b){b[b.Int8Array=1]="Int8Array",b[b.Uint8Array=2]="Uint8Array",b[b.Uint8ClampedArray=3]="Uint8ClampedArray",b[b.Int16Array=4]="Int16Array",b[b.Uint16Array=5]="Uint16Array",b[b.Int32Array=6]="Int32Array",b[b.Uint32Array=7]="Uint32Array",b[b.Float32Array=8]="Float32Array",b[b.Float64Array=9]="Float64Array",b[b.BigInt64Array=10]="BigInt64Array",b[b.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var R;(function(b){b[b.Text=1]="Text",b[b.Error=2]="Error",b[b.Rich=3]="Rich"})(R=e.CellOutputKind||(e.CellOutputKind={}));var F;(function(b){b[b.Default=0]="Default",b[b.InCenter=1]="InCenter",b[b.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",b[b.AtTop=3]="AtTop"})(F=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var D;(function(b){b[b.None=0]="None",b[b.Process=1]="Process",b[b.Output=2]="Output"})(D=e.CandidatePortSource||(e.CandidatePortSource={}));class p{static mixin(a){return a._id=p._n++,a}}e.IdObject=p,p._n=0;var _;(function(b){b.label="a",b.kind="b",b.detail="c",b.documentation="d",b.sortText="e",b.filterText="f",b.preselect="g",b.insertText="h",b.insertTextRules="i",b.range="j",b.commitCharacters="k",b.additionalTextEdits="l",b.command="m",b.kindModifier="n"})(_=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var g;(function(b){b.defaultRanges="a",b.completions="b",b.isIncomplete="c",b.duration="d"})(g=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var d;(function(b){b[b.File=1]="File",b[b.Text=2]="Text",b[b.Cell=3]="Cell"})(d=e.WorkspaceEditType||(e.WorkspaceEditType={}));function v(b){if(b&&b.edits)for(const a of b.edits)typeof a.resource=="object"?a.resource=n.URI.revive(a.resource):(a.newUri=n.URI.revive(a.newUri),a.oldUri=n.URI.revive(a.oldUri)),a.metadata&&a.metadata.iconPath&&(a.metadata=(0,h.revive)(a.metadata));return b}e.reviveWorkspaceEditDto=v;var A;(function(b){b[b.Workspace=0]="Workspace",b[b.TextDocument=1]="TextDocument"})(A=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,I.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,I.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,I.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,I.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,I.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createProxyIdentifier)("ExtHostTelemetry")}}),define(ve[86],we([1,0,5,3,4]),function(ee,e,h,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(k){this._onDidChangePassword=new n.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(h.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,S){return this._proxy.$getPassword(k,S)}store(k,S,R){return this._proxy.$setPassword(k,S,R)}delete(k,S){return this._proxy.$deletePassword(k,S)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")}),define(ve[64],we([1,0,4,11,5,16]),function(ee,e,h,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,h.createDecorator)("IExtHostApiDeprecationService");let C=class{constructor(S,R){this._extHostLogService=R,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(I.MainContext.MainThreadTelemetry)}report(S,R,F){const D=this.getUsageKey(S,R);this._reportedUsages.has(D)||(this._reportedUsages.add(D),R.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${F}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:R.identifier.value,apiId:S}))}getUsageKey(S,R){return`${S}-${R.identifier.value}`}};C=Be([Fe(0,T.IExtHostRpcService),Fe(1,n.ILogService)],C),e.ExtHostApiDeprecationService=C,e.NullApiDeprecationService=Object.freeze(new class{report(k,S,R){}})}),define(ve[228],we([1,0,3,5,7,27]),function(ee,e,h,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class C{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new h.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(n.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}async getSession(S,R,F,D={}){const p=T.ExtensionIdentifier.toKey(S.identifier),_=this._inFlightRequests.get(p)||[],g=[...F].sort().join(" ");let d=_.find(v=>v.scopes===g);if(d)return d.result;{const v=this._getSession(S,p,R,F,D);d={scopes:g,result:v},_.push(d),this._inFlightRequests.set(p,_);try{await v}finally{const A=_.findIndex(b=>b.scopes===g);A>-1&&(_.splice(A),this._inFlightRequests.set(p,_))}return v}}async _getSession(S,R,F,D,p={}){await this._proxy.$ensureProvider(F);const _=S.displayName||S.name;return this._proxy.$getSession(F,D,R,_,p)}async removeSession(S,R){const F=this._authenticationProviders.get(S);return F?F.provider.removeSession(R):this._proxy.$removeSession(S,R)}registerAuthenticationProvider(S,R,F,D){if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:R,provider:F,options:D??{supportsMultipleAccounts:!1}}),this._providers.find(_=>_.id===S)||this._providers.push({id:S,label:R});const p=F.onDidChangeSessions(_=>{this._proxy.$sendDidChangeSessions(S,{added:_.added??[],changed:_.changed??[],removed:_.removed??[]})});return this._proxy.$registerAuthenticationProvider(S,R,D?.supportsMultipleAccounts??!1),new I.Disposable(()=>{p.dispose(),this._authenticationProviders.delete(S);const _=this._providers.findIndex(g=>g.id===S);_>-1&&this._providers.splice(_),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,R){const F=this._authenticationProviders.get(S);if(F)return Promise.resolve(F.provider.createSession(R));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,R){const F=this._authenticationProviders.get(S);if(F)return Promise.resolve(F.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,R){const F=this._authenticationProviders.get(S);if(F)return Promise.resolve(F.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,R){return this._onDidChangeSessions.fire({provider:{id:S,label:R}}),Promise.resolve()}}e.ExtHostAuthentication=C}),define(ve[229],we([1,0,5,16,14]),function(ee,e,h,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(k,S){this._proxy=k.getProxy(h.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:R=>S.getDocument(R)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(k){const S=I.WorkspaceEdit.from(k,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(S)}};T=Be([Fe(0,n.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(ve[230],we([1,0,5]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class n{constructor(T){const C=T.getProxy(h.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return C.$readText()},writeText(k){return C.$writeText(k)}})}}e.ExtHostClipboard=n});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,h,n,I){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?I.call(ee,h):I?I.value=h:e.set(ee,h),h},Pe=this&&this.__classPrivateFieldGet||function(ee,e,h,n){if(h==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!n:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?n:h==="a"?n.call(ee):n?n.value:e.get(ee)};define(ve[39],we([1,0,13,7,14,25,5,18,11,58,35,48,2,6,4,16,62,22,52,49]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_,g,d,v,A,b,a){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let m=class{constructor(t,o){c.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,Xe(this,c,t.getProxy(C.MainContext.MainThreadCommands),"f"),this._logService=o,this.converter=new s(this,f=>{const u=this._apiCommands.get(f);return u?.result===l.Void?u:void 0},o),this._argumentProcessors=[{processArgument(f){return(0,R.revive)(f)}},{processArgument(f){return(0,T.cloneAndChange)(f,function(u){if(F.Range.isIRange(u))return I.Range.to(u);if(D.Position.isIPosition(u))return I.Position.to(u);if(F.Range.isIRange(u.range)&&p.URI.isUri(u.uri))return I.location.to(u);if(u instanceof A.VSBuffer)return u.buffer.buffer;if(!Array.isArray(u))return u})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const o=this.registerCommand(!1,t.id,async(...f)=>{const u=t.args.map((P,L)=>{if(!P.validate(f[L]))throw new Error(`Invalid argument '${P.name}' when running '${t.id}', received: ${f[L]}`);return P.convert(f[L])}),w=await this.executeCommand(t.internalId,...u);return t.result.convert(w,f,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new n.Disposable(()=>{o.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,o,f,u,w,P){if(this._logService.trace("ExtHostCommands#registerCommand",o),!o.trim().length)throw new Error("invalid id");if(this._commands.has(o))throw new Error(`command '${o}' already exists`);return this._commands.set(o,{callback:f,thisArg:u,description:w,extension:P}),t&&Pe(this,c,"f").$registerCommand(o),new n.Disposable(()=>{this._commands.delete(o)&&t&&Pe(this,c,"f").$unregisterCommand(o)})}executeCommand(t,...o){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,o,!0)}async _doExecuteCommand(t,o,f){if(this._commands.has(t))return this._executeContributedCommand(t,o,!1);{let u=!1;const w=(0,T.cloneAndChange)(o,function(P){if(P instanceof n.Position)return I.Position.from(P);if(P instanceof n.Range)return I.Range.from(P);if(P instanceof n.Location)return I.location.from(P);if(n.NotebookRange.isNotebookRange(P))return I.NotebookRange.from(P);if(P instanceof ArrayBuffer)return u=!0,A.VSBuffer.wrap(new Uint8Array(P));if(P instanceof Uint8Array)return u=!0,A.VSBuffer.wrap(P);if(!Array.isArray(P))return P});try{const P=await Pe(this,c,"f").$executeCommand(t,u?new b.SerializableObjectWithBuffers(w):w,f);return(0,R.revive)(P)}catch(P){if(P instanceof Error&&P.message==="$executeCommand:retry")return this._doExecuteCommand(t,o,!1);throw P}}}async _executeContributedCommand(t,o,f){const u=this._commands.get(t);if(!u)throw new Error("Unknown command");let{callback:w,thisArg:P,description:L}=u;if(L)for(let O=0;O<L.args.length;O++)try{(0,h.validateConstraint)(o[O],L.args[O].constraint)}catch{throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${L.args[O].name}' - ${L.args[O].description}`)}try{return await w.apply(P,o)}catch(O){if(t===this.converter.delegatingCommandId){const y=this.converter.getActualCommand(...o);y&&(t=y.command)}throw this._logService.error(O,t,u.extension?.identifier),f?new class extends Error{constructor(){super((0,a.toErrorMessage)(O));this.id=t,this.source=u.extension?.displayName??u.extension?.name}}:O}}$executeContributedCommand(t,...o){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(o=o.map(f=>this._argumentProcessors.reduce((u,w)=>w.processArgument(u),f)),this._executeContributedCommand(t,o,!0)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),Pe(this,c,"f").$getCommands().then(o=>(t&&(o=o.filter(f=>f[0]!=="_")),o))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[o,f]of this._commands){let{description:u}=f;u&&(t[o]=u)}return Promise.resolve(t)}};c=new WeakMap,m=Be([Fe(0,d.IExtHostRpcService),Fe(1,S.ILogService)],m),e.ExtHostCommands=m,e.IExtHostCommands=(0,g.createDecorator)("IExtHostCommands");class s{constructor(t,o,f){this._commands=t,this._lookupApiCommand=o,this._logService=f,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,o){if(!t)return;const f={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return f;const u=this._lookupApiCommand(t.command);if(u)f.id=u.internalId,f.arguments=u.args.map((w,P)=>w.convert(t.arguments&&t.arguments[P]));else if((0,k.isNonEmptyArray)(t.arguments)){const w=++this._cachIdPool;this._cache.set(w,t),o.add((0,_.toDisposable)(()=>{this._cache.delete(w),this._logService.trace("CommandsConverter#DISPOSE",w)})),f.$ident=w,f.id=this.delegatingCommandId,f.arguments=[w],this._logService.trace("CommandsConverter#CREATE",t.command,w)}return f}fromInternal(t){return typeof t.$ident=="number"?this._cache.get(t.$ident):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const o=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],o?o.command:"MISSING"),o?this._commands.executeCommand(o.command,...o.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=s;class E{constructor(t,o,f,u){this.name=t,this.description=o,this.validate=f,this.convert=u}optional(){return new E(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,o){return new E(t??this.name,o??this.description,this.validate,this.convert)}}e.ApiCommandArgument=E,E.Uri=new E("uri","Uri of a text document",r=>p.URI.isUri(r),r=>r),E.Position=new E("position","A position in a text document",r=>n.Position.isPosition(r),I.Position.from),E.Range=new E("range","A range in a text document",r=>n.Range.isRange(r),I.Range.from),E.Selection=new E("selection","A selection in a text document",r=>n.Selection.isSelection(r),I.Selection.from),E.Number=new E("number","",r=>typeof r=="number",r=>r),E.String=new E("string","",r=>typeof r=="string",r=>r),E.CallHierarchyItem=new E("item","A call hierarchy item",r=>r instanceof n.CallHierarchyItem,I.CallHierarchyItem.from),E.TypeHierarchyItem=new E("item","A type hierarchy item",r=>r instanceof n.TypeHierarchyItem,I.TypeHierarchyItem.from),E.TestItem=new E("testItem","A VS Code TestItem",r=>r instanceof v.TestItemImpl,I.TestItem.from);class l{constructor(t,o){this.description=t,this.convert=o}}e.ApiCommandResult=l,l.Void=new l("no result",r=>r);class i{constructor(t,o,f,u,w){this.id=t,this.internalId=o,this.description=f,this.args=u,this.result=w}}e.ApiCommand=i}),define(ve[231],we([1,0,2,14,7,78,39,18,111,117,10]),function(ee,e,h,n,I,T,C,k,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",_(n.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(d,v)=>{if((0,k.isFalsyOrEmpty)(d))return;class A extends I.SymbolInformation{static to(a){const c=new A(a.name,n.SymbolKind.to(a.kind),a.containerName||"",new I.Location(v[0],n.Range.to(a.range)));return c.detail=a.detail,c.range=c.location.range,c.selectionRange=n.Range.to(a.selectionRange),c.children=a.children?a.children.map(A.to):[],c}}return d.map(A.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(n.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(n.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",d=>typeof d=="string",d=>d),new C.ApiCommandArgument("options","Formatting options",d=>!0,d=>d)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",_(n.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",_(n.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",_(n.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",d=>Array.isArray(d)&&d.every(v=>I.Position.isPosition(v)),d=>d.map(n.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",d=>d.map(v=>{let A;for(const b of v.reverse())A=new I.SelectionRange(n.Range.to(b),A);return A}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",d=>d.map(n.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(n.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(n.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",d=>d.map(n.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",d=>{if(!!d)return{range:n.Range.to(d.range),placeholder:d.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",d=>{if(!!d){if(d.rejectReason)throw new Error(d.rejectReason);return n.WorkspaceEdit.to(d)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",d=>d.map(n.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new I.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const v=(0,S.decodeSemanticTokensDto)(d);if(v.type==="full")return new I.SemanticTokens(v.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",d=>{if(!!d)return new I.SemanticTokensLegend(d.tokenTypes,d.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",d=>{if(!d)return;const v=(0,S.decodeSemanticTokensDto)(d);if(v.type==="full")return new I.SemanticTokens(v.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(d,v,A)=>{if(!d)return new I.CompletionList([]);const b=d.suggestions.map(a=>n.CompletionItem.to(a,A));return new I.CompletionList(b,d.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",d=>{if(d)return n.SignatureHelp.to(d)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(d,v,A)=>_(b=>new I.CodeLens(n.Range.to(b.range),b.command&&A.fromInternal(b.command)))(d))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",d=>I.Range.isRange(d),d=>I.Selection.isSelection(d)?n.Selection.from(d):n.Range.from(d)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(d,v,A)=>_(b=>{if(b._isSynthetic){if(!b.command)throw new Error("Synthetic code actions must have a command");return A.fromInternal(b.command)}else{const a=new I.CodeAction(b.title,b.kind?new I.CodeActionKind(b.kind):void 0);return b.edit&&(a.edit=n.WorkspaceEdit.to(b.edit)),b.command&&(a.command=A.fromInternal(b.command)),a.isPreferred=b.isPreferred,a}})(d))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",d=>d?d.map(v=>new I.ColorInformation(n.Range.to(v.range),n.Color.to(v.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",d=>d instanceof I.Color,n.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",d=>!0,d=>({uri:d.uri,range:n.Range.from(d.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",d=>d?d.map(n.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",(d,v,A)=>d.map(n.InlayHint.to.bind(void 0,A)))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",_(d=>({viewType:d.viewType,displayName:d.displayName,options:{transientOutputs:d.options.transientOutputs,transientCellMetadata:d.options.transientCellMetadata,transientDocumentMetadata:d.options.transientDocumentMetadata},filenamePattern:d.filenamePattern.map(v=>n.NotebookExclusiveDocumentPattern.to(v))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",d=>d.map(n.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new C.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",d=>h.URI.isUri(d)||typeof d=="string"&&(0,R.matchesSomeScheme)(d,F.Schemas.http,F.Schemas.https),d=>d),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[n.ViewColumn.from(d),void 0]:[n.ViewColumn.from(d.viewColumn),n.TextEditorOpenOptions.from(d)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="number"||typeof d=="object",d=>d&&(typeof d=="number"?[n.ViewColumn.from(d),void 0]:[n.ViewColumn.from(d.viewColumn),n.TextEditorOpenOptions.from(d)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",d=>d===void 0||typeof d=="object",d=>d&&[n.ViewColumn.from(d.viewColumn),n.TextEditorOpenOptions.from(d)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(n.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(n.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",d=>d.map(n.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void)];class p{static register(v){D.forEach(v.registerApiCommand,v)}}e.ExtHostApiCommands=p;function _(d){return v=>{if(Array.isArray(v))return v.map(d)}}function g(d){if(!Array.isArray(d))return;const v=[];for(const A of d)T.isLocationLink(A)?v.push(n.DefinitionLink.to(A)):v.push(n.location.to(A));return v}}),define(ve[232],we([1,0,15,56,3,6,2,78,27,14,7,5]),function(ee,e,h,n,I,T,C,k,S,R,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function p(_,g,d){const v=_.getProxy(D.MainContext.MainThreadComments);class A{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,g.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const r=this._commentControllers.get(i.handle);return r||i}else if(i&&i.$mid===7){const r=this._commentControllers.get(i.commentControlHandle);if(!r)return i;const t=r.getCommentThread(i.commentThreadHandle);return t||i}else if(i&&i.$mid===8){const r=this._commentControllers.get(i.thread.commentControlHandle);if(!r)return i;const t=r.getCommentThread(i.thread.commentThreadHandle);return t?{thread:t,text:i.text}:i}else if(i&&i.$mid===9){const r=this._commentControllers.get(i.thread.commentControlHandle);if(!r)return i;const t=r.getCommentThread(i.thread.commentThreadHandle);if(!t)return i;let o=i.commentUniqueId,f=t.getCommentByUniqueId(o);return f||i}else if(i&&i.$mid===10){const r=this._commentControllers.get(i.thread.commentControlHandle);if(!r)return i;const t=r.getCommentThread(i.thread.commentThreadHandle);if(!t)return i;let o=i.text,f=i.commentUniqueId,u=t.getCommentByUniqueId(f);return u?(u.body=o,u):i}return i}})}createCommentController(i,r,t){const o=A.handlePool++,f=new a(i,o,r,t);this._commentControllers.set(f.handle,f);const u=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(i.identifier))||[];return u.push(f),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(i.identifier),u),f.value}$createCommentThreadTemplate(i,r,t){const o=this._commentControllers.get(i);!o||o.$createCommentThreadTemplate(r,t)}async $updateCommentThreadTemplate(i,r,t){const o=this._commentControllers.get(i);!o||o.$updateCommentThreadTemplate(r,t)}$deleteCommentThread(i,r){const t=this._commentControllers.get(i);t&&t.$deleteCommentThread(r)}$provideCommentingRanges(i,r,t){const o=this._commentControllers.get(i);if(!o||!o.commentingRangeProvider)return Promise.resolve(void 0);const f=d.getDocument(C.URI.revive(r));return(0,h.asPromise)(()=>o.commentingRangeProvider.provideCommentingRanges(f,t)).then(u=>u?u.map(w=>R.Range.from(w)):void 0)}$toggleReaction(i,r,t,o,f){const u=this._commentControllers.get(i);return!u||!u.reactionHandler?Promise.resolve(void 0):(0,h.asPromise)(()=>{const w=u.getCommentThread(r);if(w){const P=w.getCommentByUniqueId(o.uniqueIdInThread);if(u!==void 0&&P&&u.reactionHandler)return u.reactionHandler(P,s(f))}return Promise.resolve(void 0)})}dispose(){}}A.handlePool=0;class b{constructor(i,r,t,o,f,u,w){this._commentControllerHandle=r,this._id=t,this._uri=o,this._range=f,this._comments=u,this.extensionDescription=w,this.handle=b._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new I.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),v.$createCommentThread(r,this.handle,this._id,this._uri,R.Range.from(this._range),w.identifier),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=u,this._localDisposables.push({dispose:()=>{v.$deleteCommentThread(r,this.handle)}});const P=this;this.value={get uri(){return P.uri},get range(){return P.range},set range(L){P.range=L},get comments(){return P.comments},set comments(L){P.comments=L},get collapsibleState(){return P.collapsibleState},set collapsibleState(L){P.collapsibleState=L},get canReply(){return P.canReply},set canReply(L){P.canReply=L},get contextValue(){return P.contextValue},set contextValue(L){P.contextValue=L},get label(){return P.label},set label(L){P.label=L},dispose:()=>{P.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const i=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),r={};i("range")&&(r.range=R.Range.from(this._range)),i("label")&&(r.label=this.label),i("contextValue")&&(r.contextValue=this.contextValue??null),i("comments")&&(r.comments=this._comments.map(t=>c(this,t,this._commentsMap))),i("collapsibleState")&&(r.collapseState=E(this._collapseState)),i("canReply")&&(r.canReply=this.canReply),this.modifications={},v.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,r)}getCommentByUniqueId(i){for(let r of this._commentsMap){let t=r[0],o=r[1];if(i===o)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}b._handlePool=0,Be([(0,n.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class a{constructor(i,r,t,o){this._extension=i,this._handle=r,this._id=t,this._label=o,this._threads=new Map,v.$registerCommentController(this.handle,t,o);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(u){f.options=u},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(u){f.commentingRangeProvider=u},get reactionHandler(){return f.reactionHandler},set reactionHandler(u){f.reactionHandler=u},createCommentThread(u,w,P){return f.createCommentThread(u,w,P).value},dispose:()=>{f.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{v.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(i){this._commentingRangeProvider=i,v.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,v.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,v.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,r,t,o){if(typeof i=="string"){const f=new b(this.id,this.handle,i,r,t,o,this._extension);return this._threads.set(f.handle,f),f}else{const f=new b(this.id,this.handle,void 0,i,r,t,this._extension);return this._threads.set(f.handle,f),f}}$createCommentThreadTemplate(i,r){const t=new b(this.id,this.handle,void 0,C.URI.revive(i),R.Range.to(r),[],this._extension);return t.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(i,r){let t=this._threads.get(i);t&&(t.range=R.Range.to(r))}$deleteCommentThread(i){let r=this._threads.get(i);r&&r.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function c(l,i,r){let t=r.get(i);t||(t=++l.commentHandle,r.set(i,t));const o=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:t,body:typeof i.body=="string"?i.body:R.MarkdownString.from(i.body),userName:i.author.name,userIconPath:o,label:i.label,commentReactions:i.reactions?i.reactions.map(f=>m(f)):void 0,timestamp:i.timestamp?.toJSON()}}function m(l){return{label:l.label,iconPath:l.iconPath?R.pathOrURIToURI(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted}}function s(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?C.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1}}function E(l){if(l!==void 0)switch(l){case F.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case F.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}return new A}e.createExtHostComments=p}),define(ve[133],we([1,0,2,5,7,4,16,11,18,8,9]),function(ee,e,h,n,I,T,C,k,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let D=class Ei{constructor(_,g){this._logService=g,this._provider=new Map,this._proxy=_.getProxy(n.MainContext.MainThreadDecorations)}registerFileDecorationProvider(_,g){const d=Ei._handlePool++;this._provider.set(d,{provider:_,extensionId:g}),this._proxy.$registerDecorationProvider(d,g.value);const v=_.onDidChangeFileDecorations&&_.onDidChangeFileDecorations(A=>{if(!A){this._proxy.$onDidChange(d,null);return}let b=(0,S.asArray)(A);if(b.length<=Ei._maxEventSize){this._proxy.$onDidChange(d,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",g.value,b.length);const a=b.map(s=>({uri:s,rank:(0,R.count)(s.path,"/")})),c=(0,S.groupBy)(a,(s,E)=>s.rank-E.rank||(0,R.compare)(s.uri.path,E.uri.path));let m=[];e:for(let s of c){let E;for(let l of s){let i=(0,F.dirname)(l.uri.path);if(E!==i&&(E=i,m.push(l.uri)>=Ei._maxEventSize))break e}}this._proxy.$onDidChange(d,m)});return new I.Disposable(()=>{v?.dispose(),this._proxy.$unregisterDecorationProvider(d),this._provider.delete(d)})}async $provideDecorations(_,g,d){if(!this._provider.has(_))return Object.create(null);const v=Object.create(null),{provider:A,extensionId:b}=this._provider.get(_);return await Promise.all(g.map(async a=>{try{const{uri:c,id:m}=a,s=await Promise.resolve(A.provideFileDecoration(h.URI.revive(c),d));if(!s)return;try{I.FileDecoration.validate(s),v[m]=[s.propagate,s.tooltip,s.badge,s.color]}catch(E){this._logService.warn(`INVALID decoration from extension '${b.value}': ${E}`)}}catch(c){this._logService.error(c)}})),v}};D._handlePool=0,D._maxEventSize=250,D=Be([Fe(0,C.IExtHostRpcService),Fe(1,k.ILogService)],D),e.ExtHostDecorations=D,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,h,n,I){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?I.call(ee,h):I?I.value=h:e.set(ee,h),h},Pe=this&&this.__classPrivateFieldGet||function(ee,e,h,n){if(h==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!n:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?n:h==="a"?n.call(ee):n?n.value:e.get(ee)};define(ve[233],we([1,0,166,116,2,5,7,14,3,11,24,44]),function(ee,e,h,n,I,T,C,k,S,R,F,D){"use strict";var p,_,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class d{constructor(b,a,c,m,s,E){this._name=b,this._owner=a,this._maxDiagnosticsPerFile=c,p.set(this,void 0),_.set(this,void 0),g.set(this,void 0),this._isDisposed=!1,Xe(this,g,new F.ResourceMap(l=>m.getComparisonKey(l)),"f"),Xe(this,p,s,"f"),Xe(this,_,E,"f")}dispose(){this._isDisposed||(Pe(this,_,"f").fire([...Pe(this,g,"f").keys()]),Pe(this,p,"f")&&Pe(this,p,"f").$clear(this._owner),Pe(this,g,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(b,a){if(!b){this.clear();return}this._checkDisposed();let c=[];if(I.URI.isUri(b)){if(!a){this.delete(b);return}Pe(this,g,"f").set(b,a.slice()),c=[b]}else if(Array.isArray(b)){c=[];let s;b=[...b].sort(d._compareIndexedTuplesByUri);for(const E of b){const[l,i]=E;if((!s||l.toString()!==s.toString())&&(s&&Pe(this,g,"f").get(s).length===0&&Pe(this,g,"f").delete(s),s=l,c.push(l),Pe(this,g,"f").set(l,[])),i){const r=Pe(this,g,"f").get(l);r&&r.push(...i)}else{const r=Pe(this,g,"f").get(l);r&&(r.length=0)}}}if(Pe(this,_,"f").fire(c),!Pe(this,p,"f"))return;const m=[];for(let s of c){let E=[];const l=Pe(this,g,"f").get(s);if(l)if(l.length>this._maxDiagnosticsPerFile){E=[];const i=[C.DiagnosticSeverity.Error,C.DiagnosticSeverity.Warning,C.DiagnosticSeverity.Information,C.DiagnosticSeverity.Hint];e:for(let r=0;r<4;r++)for(let t of l)if(t.severity===i[r]&&E.push(k.Diagnostic.from(t))===this._maxDiagnosticsPerFile)break e;E.push({severity:n.MarkerSeverity.Info,message:(0,h.localize)(0,null,l.length-this._maxDiagnosticsPerFile),startLineNumber:E[E.length-1].startLineNumber,startColumn:E[E.length-1].startColumn,endLineNumber:E[E.length-1].endLineNumber,endColumn:E[E.length-1].endColumn})}else E=l.map(i=>k.Diagnostic.from(i));m.push([s,E])}Pe(this,p,"f").$changeMany(this._owner,m)}delete(b){this._checkDisposed(),Pe(this,_,"f").fire([b]),Pe(this,g,"f").delete(b),Pe(this,p,"f")&&Pe(this,p,"f").$changeMany(this._owner,[[b,void 0]])}clear(){this._checkDisposed(),Pe(this,_,"f").fire([...Pe(this,g,"f").keys()]),Pe(this,g,"f").clear(),Pe(this,p,"f")&&Pe(this,p,"f").$clear(this._owner)}forEach(b,a){this._checkDisposed();for(let c of Pe(this,g,"f").keys())b.apply(a,[c,this.get(c),this])}get(b){this._checkDisposed();const a=Pe(this,g,"f").get(b);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(b){return this._checkDisposed(),Array.isArray(Pe(this,g,"f").get(b))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(b,a){return b[0].toString()<a[0].toString()?-1:b[0].toString()>a[0].toString()?1:0}}e.DiagnosticCollection=d,p=new WeakMap,_=new WeakMap,g=new WeakMap;let v=class oi{constructor(b,a,c){this._logService=a,this._fileSystemInfoService=c,this._collections=new Map,this._onDidChangeDiagnostics=new S.DebounceEmitter({merge:m=>m.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this._onDidChangeDiagnostics.event,oi._mapper),this._proxy=b.getProxy(T.MainContext.MainThreadDiagnostics)}static _mapper(b){const a=new F.ResourceMap;for(const c of b)a.set(c,c);return{uris:Object.freeze(Array.from(a.values()))}}createDiagnosticCollection(b,a){const{_collections:c,_proxy:m,_onDidChangeDiagnostics:s,_logService:E,_fileSystemInfoService:l}=this,i=new class{$changeMany(o,f){m.$changeMany(o,f),E.trace("[DiagnosticCollection] change many (extension, owner, uris)",b.value,o,f.length===0?"CLEARING":f)}$clear(o){m.$clear(o),E.trace("[DiagnosticCollection] remove all (extension, owner)",b.value,o)}dispose(){m.dispose()}};let r;if(!a)a="_generated_diagnostic_collection_name_#"+oi._idPool++,r=a;else if(!c.has(a))r=a;else{this._logService.warn(`DiagnosticCollection with name '${a}' does already exist.`);do r=a+oi._idPool++;while(c.has(r))}return new class extends d{constructor(){super(a,r,oi._maxDiagnosticsPerFile,l.extUri,i,s);c.set(r,this)}dispose(){super.dispose(),c.delete(r)}}}getDiagnostics(b){if(b)return this._getDiagnostics(b);{const a=new Map,c=[];for(const m of this._collections.values())m.forEach((s,E)=>{let l=a.get(s.toString());typeof l=="undefined"&&(l=c.length,a.set(s.toString(),l),c.push([s,[]])),c[l][1]=c[l][1].concat(...E)});return c}}_getDiagnostics(b){let a=[];for(let c of this._collections.values())c.has(b)&&(a=a.concat(c.get(b)));return a}$acceptMarkersChange(b){if(!this._mirrorCollection){const a="_generated_mirror",c=new d(a,a,oi._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(a,c),this._mirrorCollection=c}for(const[a,c]of b)this._mirrorCollection.set(I.URI.revive(a),c.map(k.Diagnostic.to))}};v._idPool=0,v._maxDiagnosticsPerFile=1e3,v=Be([Fe(1,R.ILogService),Fe(2,D.IExtHostFileSystemInfo)],v),e.ExtHostDiagnostics=v}),define(ve[234],we([1,0,2,5]),function(ee,e,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class I{constructor(C){this._proxy=C.getProxy(n.MainContext.MainThreadDialogs)}showOpenDialog(C){return this._proxy.$showOpenDialog(C).then(k=>k?k.map(S=>h.URI.revive(S)):void 0)}showSaveDialog(C){return this._proxy.$showSaveDialog(C).then(k=>k?h.URI.revive(k):void 0)}}e.ExtHostDialogs=I}),define(ve[235],we([1,0,17,2,7,5,10,21,8]),function(ee,e,h,n,I,T,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class R{constructor(D,p,_){this._documentsAndEditors=p,this._logService=_,this._documentContentProviders=new Map,this._proxy=D.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,p){if(Object.keys(C.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const _=R._handlePool++;this._documentContentProviders.set(_,p),this._proxy.$registerTextContentProvider(_,D);let g;return typeof p.onDidChange=="function"&&(g=p.onDidChange(d=>{if(d.scheme!==D){this._logService.warn(`Provider for scheme '${D}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(d)&&this.$provideTextDocumentContent(_,d).then(v=>{if(!v&&typeof v!="string")return;const A=this._documentsAndEditors.getDocument(d);if(!A)return;const b=(0,S.splitLines)(v);if(!A.equalLines(b))return this._proxy.$onVirtualDocumentChange(d,v)},h.onUnexpectedError)})),new I.Disposable(()=>{this._documentContentProviders.delete(_)&&this._proxy.$unregisterTextContentProvider(_),g&&(g.dispose(),g=void 0)})}$provideTextDocumentContent(D,p){const _=this._documentContentProviders.get(D);return _?Promise.resolve(_.provideTextDocumentContent(n.URI.revive(p),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${p.scheme}`))}}e.ExtHostDocumentContentProvider=R,R._handlePool=0}),define(ve[236],we([1,0,3,6,2,5,125,14,13,25,7]),function(ee,e,h,n,I,T,C,k,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class D{constructor(_,g){this._onDidAddDocument=new h.Emitter,this._onDidRemoveDocument=new h.Emitter,this._onDidChangeDocument=new h.Emitter,this._onDidSaveDocument=new h.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new n.DisposableStore,this._documentLoader=new Map,this._proxy=_.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=g,this._documentsAndEditors.onDidRemoveDocuments(d=>{for(const v of d)this._onDidRemoveDocument.fire(v.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(d=>{for(const v of d)this._onDidAddDocument.fire(v.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(_){if(!_)return;const g=this._documentsAndEditors.getDocument(_);if(g)return g}getDocument(_){const g=this.getDocumentData(_);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${_}'`);return g.document}ensureDocumentData(_){const g=this._documentsAndEditors.getDocument(_);if(g)return Promise.resolve(g);let d=this._documentLoader.get(_.toString());return d||(d=this._proxy.$tryOpenDocument(_).then(v=>{this._documentLoader.delete(_.toString());const A=I.URI.revive(v);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(A))},v=>(this._documentLoader.delete(_.toString()),Promise.reject(v))),this._documentLoader.set(_.toString(),d)),d}createDocumentData(_){return this._proxy.$tryCreateDocument(_).then(g=>I.URI.revive(g))}$acceptModelLanguageChanged(_,g){const d=I.URI.revive(_),v=this._documentsAndEditors.getDocument(d);if(!v)throw new Error("unknown document");this._onDidRemoveDocument.fire(v.document),v._acceptLanguageId(g),this._onDidAddDocument.fire(v.document)}$acceptModelSaved(_){const g=I.URI.revive(_),d=this._documentsAndEditors.getDocument(g);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(_,!1),this._onDidSaveDocument.fire(d.document)}$acceptDirtyStateChanged(_,g){const d=I.URI.revive(_),v=this._documentsAndEditors.getDocument(d);if(!v)throw new Error("unknown document");v._acceptIsDirty(g),this._onDidChangeDocument.fire({document:v.document,contentChanges:[],reason:void 0})}$acceptModelChanged(_,g,d){const v=I.URI.revive(_),A=this._documentsAndEditors.getDocument(v);if(!A)throw new Error("unknown document");A._acceptIsDirty(d),A.onEvents(g);let b;g.isUndoing?b=F.TextDocumentChangeReason.Undo:g.isRedoing&&(b=F.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,R.deepFreeze)({document:A.document,contentChanges:g.changes.map(a=>({range:k.Range.to(a.range),rangeOffset:a.rangeOffset,rangeLength:a.rangeLength,text:a.text})),reason:b}))}setWordDefinitionFor(_,g){(0,C.setWordDefinitionFor)(_,g)}}e.ExtHostDocuments=D}),define(ve[45],we([1,0,55,3,6,2,4,5,125,16,131,14,11,24,10,76,89]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_,g,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class A{constructor(c){this.value=c,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(c,m){this._extHostRpc=c,this._logService=m,this._activeEditorId=null,this._editors=new Map,this._documents=new _.ResourceMap,this._onDidAddDocuments=new n.Emitter,this._onDidRemoveDocuments=new n.Emitter,this._onDidChangeVisibleTextEditors=new n.Emitter,this._onDidChangeActiveTextEditor=new n.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const m=[],s=[],E=[];if(c.removedDocuments)for(const l of c.removedDocuments){const i=T.URI.revive(l),r=this._documents.get(i);r?.unref()&&(this._documents.delete(i),m.push(r.value))}if(c.addedDocuments)for(const l of c.addedDocuments){const i=T.URI.revive(l.uri);let r=this._documents.get(i);if(r&&i.scheme!==g.Schemas.vscodeNotebookCell&&i.scheme!==g.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);r||(r=new A(new S.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),i,l.lines,l.EOL,l.versionId,l.languageId,l.isDirty,l.notebook)),this._documents.set(i,r),s.push(r.value)),r.ref()}if(c.removedEditors)for(const l of c.removedEditors){const i=this._editors.get(l);this._editors.delete(l),i&&E.push(i)}if(c.addedEditors)for(const l of c.addedEditors){const i=T.URI.revive(l.documentUri);h.ok(this._documents.has(i),`document '${i}' does not exist`),h.ok(!this._editors.has(l.id),`editor '${l.id}' already exists!`);const r=this._documents.get(i).value,t=new F.ExtHostTextEditor(l.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new v.Lazy(()=>r.document),l.selections.map(D.Selection.to),l.options,l.visibleRanges.map(o=>D.Range.to(o)),typeof l.editorPosition=="number"?D.ViewColumn.to(l.editorPosition):void 0);this._editors.set(l.id,t)}c.newActiveEditor!==void 0&&(h.ok(c.newActiveEditor===null||this._editors.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this._activeEditorId=c.newActiveEditor),(0,I.dispose)(m),(0,I.dispose)(E),c.removedDocuments&&this._onDidRemoveDocuments.fire(m),c.addedDocuments&&this._onDidAddDocuments.fire(s),(c.removedEditors||c.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(l=>l.value)),c.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(c){return this._documents.get(c)?.value}allDocuments(){return d.Iterable.map(this._documents.values(),c=>c.value)}getEditor(c){return this._editors.get(c)}activeEditor(c){if(!this._activeEditorId)return;const m=this._editors.get(this._activeEditorId);return c?m:m?.value}allEditors(){return[...this._editors.values()]}};b=Be([Fe(0,R.IExtHostRpcService),Fe(1,p.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,C.createDecorator)("IExtHostDocumentsAndEditors")}),define(ve[53],we([1,0,14,5,2,3,4,16]),function(ee,e,h,n,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");let S=class{constructor(F){this._onDidChangeTabGroup=new T.Emitter,this.onDidChangeTabGroup=this._onDidChangeTabGroup.event,this._tabGroups={all:[],onDidChangeTabGroup:this._onDidChangeTabGroup.event},this._proxy=F.getProxy(n.MainContext.MainThreadEditorTabs)}get tabGroups(){return this._tabGroups}$acceptEditorTabModel(F){this._tabGroups.all.length=0;for(const D of F){let p;const _=D.tabs.map(g=>{const d=this.createExtHostTabObject(g);return g.isActive&&(p=d),d});this._tabGroups.all.push(Object.freeze({isActive:D.isActive,viewColumn:h.ViewColumn.to(D.viewColumn),activeTab:p,tabs:_}))}this._onDidChangeTabGroup.fire()}createExtHostTabObject(F){return Object.freeze({label:F.label,viewColumn:h.ViewColumn.to(F.viewColumn),resource:I.URI.revive(F.resource),additionalResourcesAndViewIds:F.additionalResourcesAndViewIds.map(({resource:D,viewId:p})=>({resource:I.URI.revive(D),viewId:p})),viewId:F.editorId,isActive:F.isActive,kind:F.kind,isDirty:F.isDirty,move:async(D,p)=>{this._proxy.$moveTab(F,D,h.ViewColumn.from(p))},close:async()=>{await this._proxy.$closeTab(F)}})}};S=Be([Fe(0,k.IExtHostRpcService)],S),e.ExtHostEditorTabs=S}),define(ve[237],we([1,0,2,5,6,7,14,150,8,22,30]),function(ee,e,h,n,I,T,C,k,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class D{constructor(){this._schemes=[]}add(g){this._stateMachine=void 0,this._schemes.push(g)}delete(g){const d=this._schemes.indexOf(g);d>=0&&(this._schemes.splice(d,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const g=this._schemes.sort(),d=[];let v,A,b=14,a=14;for(const c of g){let m=v?(0,S.commonPrefixLength)(v,c):0;for(m===0?A=1:A=a;m<c.length;m++)m+1===c.length?(b=a,a=9):a+=1,d.push([A,c.toUpperCase().charCodeAt(m),a]),d.push([A,c.toLowerCase().charCodeAt(m),a]),A=a;v=c,a=b}d.push([9,58,10]),d.push([10,47,12]),this._stateMachine=new k.StateMachine(d)}}provideDocumentLinks(g){this._initStateMachine();const d=[],v=k.LinkComputer.computeLinks({getLineContent(A){return g.lineAt(A-1).text},getLineCount(){return g.lineCount}},this._stateMachine);for(const A of v){const b=C.DocumentLink.to(A);b.target&&d.push(b)}return d}}class p{constructor(g,d){this._extHostLanguageFeatures=d,this._linkProvider=new D,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=g.getProxy(n.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(g,d,v,A={}){if(this._registeredSchemes.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(g,"*",this._linkProvider));const b=this._handlePool++;this._linkProvider.add(d),this._registeredSchemes.add(d),this._fsProvider.set(b,v);let a=2;A.isCaseSensitive&&(a+=1024),A.isReadonly&&(a+=2048),typeof v.copy=="function"&&(a+=8),typeof v.open=="function"&&typeof v.close=="function"&&typeof v.read=="function"&&typeof v.write=="function"&&((0,F.checkProposedApiEnabled)(g,"fsChunks"),a+=4),this._proxy.$registerFileSystemProvider(b,d,a).catch(m=>{console.error(`FAILED to register filesystem provider of ${g.identifier.value}-extension for the scheme ${d}`),console.error(m)});const c=v.onDidChangeFile(m=>{const s=[];for(const E of m){let{uri:l,type:i}=E;if(l.scheme!==d)continue;let r;switch(i){case T.FileChangeType.Changed:r=0;break;case T.FileChangeType.Created:r=1;break;case T.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:l,type:r})}this._proxy.$onFileSystemChange(b,s)});return(0,I.toDisposable)(()=>{c.dispose(),this._linkProvider.delete(d),this._registeredSchemes.delete(d),this._fsProvider.delete(b),this._proxy.$unregisterProvider(b)})}static _asIStat(g){const{type:d,ctime:v,mtime:A,size:b,permissions:a}=g;return{type:d,ctime:v,mtime:A,size:b,permissions:a}}$stat(g,d){return Promise.resolve(this._getFsProvider(g).stat(h.URI.revive(d))).then(v=>p._asIStat(v))}$readdir(g,d){return Promise.resolve(this._getFsProvider(g).readDirectory(h.URI.revive(d)))}$readFile(g,d){return Promise.resolve(this._getFsProvider(g).readFile(h.URI.revive(d))).then(v=>R.VSBuffer.wrap(v))}$writeFile(g,d,v,A){return Promise.resolve(this._getFsProvider(g).writeFile(h.URI.revive(d),v.buffer,A))}$delete(g,d,v){return Promise.resolve(this._getFsProvider(g).delete(h.URI.revive(d),v))}$rename(g,d,v,A){return Promise.resolve(this._getFsProvider(g).rename(h.URI.revive(d),h.URI.revive(v),A))}$copy(g,d,v,A){const b=this._getFsProvider(g);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(h.URI.revive(d),h.URI.revive(v),A))}$mkdir(g,d){return Promise.resolve(this._getFsProvider(g).createDirectory(h.URI.revive(d)))}$watch(g,d,v,A){const b=this._getFsProvider(g).watch(h.URI.revive(v),A);this._watches.set(d,b)}$unwatch(g,d){const v=this._watches.get(d);v&&(v.dispose(),this._watches.delete(d))}$open(g,d,v){const A=this._getFsProvider(g);if(!A.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(A.open(h.URI.revive(d),v))}$close(g,d){const v=this._getFsProvider(g);if(!v.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(v.close(d))}$read(g,d,v,A){const b=this._getFsProvider(g);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const a=R.VSBuffer.alloc(A);return Promise.resolve(b.read(d,v,a.buffer,0,A)).then(c=>a.slice(0,c))}$write(g,d,v,A){const b=this._getFsProvider(g);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(d,v,A.buffer,0,A.byteLength))}_getFsProvider(g){const d=this._fsProvider.get(g);if(!d){const v=new Error;throw v.name="ENOPRO",v.message="no provider",v}return d}}e.ExtHostFileSystem=p}),define(ve[65],we([1,0,5,42,7,22,4,16,44,6]),function(ee,e,h,n,I,T,C,k,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let F=class jt{constructor(p,_){this._fileSystemProvider=new Map,this._proxy=p.getProxy(h.MainContext.MainThreadFileSystem);const g=this;this.value=Object.freeze({async stat(d){try{const v=g._fileSystemProvider.get(d.scheme);if(!v)return await g._proxy.$stat(d);await g._proxy.$ensureActivation(d.scheme);const A=await v.stat(d);return{type:A.type,ctime:A.ctime,mtime:A.mtime,size:A.size,permissions:A.permissions}}catch(v){jt._handleError(v)}},async readDirectory(d){try{const v=g._fileSystemProvider.get(d.scheme);return v?(await g._proxy.$ensureActivation(d.scheme),(await v.readDirectory(d)).slice()):await g._proxy.$readdir(d)}catch(v){return jt._handleError(v)}},async createDirectory(d){try{return await g._proxy.$mkdir(d)}catch(v){return jt._handleError(v)}},async readFile(d){try{const v=g._fileSystemProvider.get(d.scheme);return v?(await g._proxy.$ensureActivation(d.scheme),(await v.readFile(d)).slice()):(await g._proxy.$readFile(d)).buffer}catch(v){return jt._handleError(v)}},async writeFile(d,v){try{return await g._proxy.$writeFile(d,T.VSBuffer.wrap(v))}catch(A){return jt._handleError(A)}},async delete(d,v){try{const A=g._fileSystemProvider.get(d.scheme);return A?(await g._proxy.$ensureActivation(d.scheme),await A.delete(d,{recursive:!1,...v})):await g._proxy.$delete(d,{recursive:!1,useTrash:!1,...v})}catch(A){return jt._handleError(A)}},async rename(d,v,A){try{return await g._proxy.$rename(d,v,{overwrite:!1,...A})}catch(b){return jt._handleError(b)}},async copy(d,v,A){try{return await g._proxy.$copy(d,v,{overwrite:!1,...A})}catch(b){return jt._handleError(b)}},isWritableFileSystem(d){const v=_.getCapabilities(d);if(typeof v=="number")return!(v&2048)}})}static _handleError(p){if(p instanceof I.FileSystemError)throw p;if(!(p instanceof Error))throw new I.FileSystemError(String(p));if(p.name==="ENOPRO")throw I.FileSystemError.Unavailable(p.message);switch(p.name){case n.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(p.message);case n.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(p.message);case n.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(p.message);case n.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(p.message);case n.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(p.message);case n.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(p.message);default:throw new I.FileSystemError(p.message,p.name)}}addFileSystemProvider(p,_){return this._fileSystemProvider.set(p,_),(0,R.toDisposable)(()=>this._fileSystemProvider.delete(p))}};F=Be([Fe(0,k.IExtHostRpcService),Fe(1,S.IExtHostFileSystemInfo)],F),e.ExtHostConsumerFileSystem=F,e.IExtHostConsumerFileSystem=(0,C.createDecorator)("IExtHostConsumerFileSystem")}),define(ve[238],we([1,0,3,32,2,5,14,7]),function(ee,e,h,n,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{constructor(D,p,_,g,d,v,A,b){this._onDidCreate=new h.Emitter,this._onDidChange=new h.Emitter,this._onDidDelete=new h.Emitter;const a=this.ensureWatching(D,_,d);this._config=0,v&&(this._config+=1),A&&(this._config+=2),b&&(this._config+=4);const c=(0,n.parse)(d),m=typeof d=="string",s=g(E=>{if(!v)for(let l of E.created){const i=I.URI.revive(l);c(i.fsPath)&&(!m||p.getWorkspaceFolder(i))&&this._onDidCreate.fire(i)}if(!A)for(let l of E.changed){const i=I.URI.revive(l);c(i.fsPath)&&(!m||p.getWorkspaceFolder(i))&&this._onDidChange.fire(i)}if(!b)for(let l of E.deleted){const i=I.URI.revive(l);c(i.fsPath)&&(!m||p.getWorkspaceFolder(i))&&this._onDidDelete.fire(i)}});this._disposable=k.Disposable.from(a,this._onDidCreate,this._onDidChange,this._onDidDelete,s)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(D,p,_){let g=k.Disposable.from();if(typeof _=="string")return g;const d=D.getProxy(T.MainContext.MainThreadFileSystem);let v=!1;(_.pattern.includes(n.GLOBSTAR)||_.pattern.includes(n.GLOB_SPLIT))&&(v=!0);const A=Math.random();return d.$watch(p.identifier.value,A,_.baseUri,{recursive:v,excludes:[]}),k.Disposable.from({dispose:()=>d.$unwatch(A)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class R{constructor(D,p,_){this._mainContext=D,this._logService=p,this._extHostDocumentsAndEditors=_,this._onFileSystemEvent=new h.Emitter,this._onDidRenameFile=new h.Emitter,this._onDidCreateFile=new h.Emitter,this._onDidDeleteFile=new h.Emitter,this._onWillRenameFile=new h.AsyncEmitter,this._onWillCreateFile=new h.AsyncEmitter,this._onWillDeleteFile=new h.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(D,p,_,g,d,v){return new S(this._mainContext,D,p,this._onFileSystemEvent.event,C.GlobPattern.from(_),g,d,v)}$onFileEvent(D){this._onFileSystemEvent.fire(D)}$onDidRunFileOperation(D,p){switch(D){case 2:this._onDidRenameFile.fire(Object.freeze({files:p.map(_=>({oldUri:I.URI.revive(_.source),newUri:I.URI.revive(_.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:p.map(_=>I.URI.revive(_.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:p.map(_=>I.URI.revive(_.target))}));break;default:}}getOnWillRenameFileEvent(D){return this._createWillExecuteEvent(D,this._onWillRenameFile)}getOnWillCreateFileEvent(D){return this._createWillExecuteEvent(D,this._onWillCreateFile)}getOnWillDeleteFileEvent(D){return this._createWillExecuteEvent(D,this._onWillDeleteFile)}_createWillExecuteEvent(D,p){return(_,g,d)=>{const v=function(b){_.call(g,b)};return v.extension=D,p.event(v,void 0,d)}}async $onWillRunFileOperation(D,p,_,g){switch(D){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:p.map(d=>({oldUri:I.URI.revive(d.source),newUri:I.URI.revive(d.target)}))},_,g);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:p.map(d=>I.URI.revive(d.target))},_,g);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:p.map(d=>I.URI.revive(d.target))},_,g)}}async _fireWillEvent(D,p,_,g){const d=new Set,v=[];if(await D.fireAsync(p,g,async(b,a)=>{const c=Date.now(),m=await Promise.resolve(b);m instanceof k.WorkspaceEdit&&(v.push(m),d.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-c>_&&this._logService.warn("SLOW file-participant",a.extension.identifier)}),g.isCancellationRequested||v.length===0)return;const A={edits:[]};for(let b of v){let{edits:a}=C.WorkspaceEdit.from(b,{getTextDocumentVersion:c=>this._extHostDocumentsAndEditors.getDocument(c)?.version,getNotebookDocumentVersion:()=>{}});A.edits=A.edits.concat(a)}return{edit:A,extensionNames:Array.from(d)}}}e.ExtHostFileSystemEventService=R}),define(ve[239],we([1,0,2,39]),function(ee,e,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class I{constructor(C,k,S,R){this._extHostNotebooks=k,this._textDocumentsAndEditors=S,this._commands=R;const F=new n.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new n.ApiCommandArgument("showOptions","Show Options",D=>!0,D=>D),new n.ApiCommandArgument("resource","Interactive resource Uri",D=>!0,D=>D),new n.ApiCommandArgument("controllerId","Notebook controller Id",D=>!0,D=>D),new n.ApiCommandArgument("title","Interactive editor title",D=>!0,D=>D)],new n.ApiCommandResult("Notebook and input URI",D=>{if(D.notebookEditorId!==void 0){const p=this._extHostNotebooks.getEditorById(D.notebookEditorId);return{notebookUri:h.URI.revive(D.notebookUri),inputUri:h.URI.revive(D.inputUri),notebookEditor:p.apiEditor}}return{notebookUri:h.URI.revive(D.notebookUri),inputUri:h.URI.revive(D.inputUri)}}));this._commands.registerApiCommand(F)}$willAddInteractiveDocument(C,k,S,R){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],languageId:S,uri:C,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(h.URI.revive(R))?.apiNotebook}]})}$willRemoveInteractiveDocument(C,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[C]})}}e.ExtHostInteractive=I}),define(ve[240],we([1,0,6,5]),function(ee,e,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(C){this._handlePool=0,this._proxy=C.getProxy(n.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(C){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,C),(0,h.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=I}),define(ve[241],we([1,0,2,25,14,7,5,8,35,18,13,146,21,6,111,75,82,46,17,3,15]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_,g,d,v,A,b,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class m{constructor($,U){this._documents=$,this._provider=U}async provideDocumentSymbols($,U){const N=this._documents.getDocument($),W=await this._provider.provideDocumentSymbols(N,U);if(!(0,R.isFalsyOrEmpty)(W))return W[0]instanceof T.DocumentSymbol?W.map(I.DocumentSymbol.from):m._asDocumentSymbolTree(W)}static _asDocumentSymbolTree($){$=$.slice(0).sort((W,j)=>{let re=W.location.range.start.compareTo(j.location.range.start);return re===0&&(re=j.location.range.end.compareTo(W.location.range.end)),re});const U=[],N=[];for(const W of $){const j={name:W.name||"!!MISSING: name!!",kind:I.SymbolKind.from(W.kind),tags:W.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:W.containerName,range:I.Range.from(W.location.range),selectionRange:I.Range.from(W.location.range),children:[]};for(;;){if(N.length===0){N.push(j),U.push(j);break}const re=N[N.length-1];if(S.Range.containsRange(re.range,j.range)&&!S.Range.equalsRange(re.range,j.range)){re.children&&re.children.push(j),N.push(j);break}N.pop()}}return U}}class s{constructor($,U,N){this._documents=$,this._commands=U,this._provider=N,this._cache=new v.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses($,U){const N=this._documents.getDocument($),W=await this._provider.provideCodeLenses(N,U);if(!W||U.isCancellationRequested)return;const j=this._cache.add(W),re=new _.DisposableStore;this._disposables.set(j,re);const he={cacheId:j,lenses:[]};for(let Ce=0;Ce<W.length;Ce++)he.lenses.push({cacheId:[j,Ce],range:I.Range.from(W[Ce].range),command:this._commands.toInternal(W[Ce].command,re)});return he}async resolveCodeLens($,U){const N=$.cacheId&&this._cache.get(...$.cacheId);if(!N)return;let W;if(typeof this._provider.resolveCodeLens!="function"||N.isResolved?W=N:W=await this._provider.resolveCodeLens(N,U),W||(W=N),U.isCancellationRequested)return;const j=$.cacheId&&this._disposables.get($.cacheId[0]);if(!!j)return $.command=this._commands.toInternal(W.command??s._badCmd,j),$}releaseCodeLenses($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}}s._badCmd={command:"missing",title:"!!MISSING: command!!"};function E(Ee){return Array.isArray(Ee)?Ee.map(I.DefinitionLink.from):Ee?[I.DefinitionLink.from(Ee)]:[]}class l{constructor($,U){this._documents=$,this._provider=U}async provideDefinition($,U,N){const W=this._documents.getDocument($),j=I.Position.to(U),re=await this._provider.provideDefinition(W,j,N);return E(re)}}class i{constructor($,U){this._documents=$,this._provider=U}async provideDeclaration($,U,N){const W=this._documents.getDocument($),j=I.Position.to(U),re=await this._provider.provideDeclaration(W,j,N);return E(re)}}class r{constructor($,U){this._documents=$,this._provider=U}async provideImplementation($,U,N){const W=this._documents.getDocument($),j=I.Position.to(U),re=await this._provider.provideImplementation(W,j,N);return E(re)}}class t{constructor($,U){this._documents=$,this._provider=U}async provideTypeDefinition($,U,N){const W=this._documents.getDocument($),j=I.Position.to(U),re=await this._provider.provideTypeDefinition(W,j,N);return E(re)}}class o{constructor($,U){this._documents=$,this._provider=U}async provideHover($,U,N){const W=this._documents.getDocument($),j=I.Position.to(U),re=await this._provider.provideHover(W,j,N);if(!(!re||(0,R.isFalsyOrEmpty)(re.contents)))return re.range||(re.range=W.getWordRangeAtPosition(j)),re.range||(re.range=new T.Range(j,j)),I.Hover.from(re)}}class f{constructor($,U){this._documents=$,this._provider=U}async provideEvaluatableExpression($,U,N){const W=this._documents.getDocument($),j=I.Position.to(U),re=await this._provider.provideEvaluatableExpression(W,j,N);if(re)return I.EvaluatableExpression.from(re)}}class u{constructor($,U){this._documents=$,this._provider=U}async provideInlineValues($,U,N,W){const j=this._documents.getDocument($),re=await this._provider.provideInlineValues(j,I.Range.to(U),I.InlineValueContext.to(N),W);if(Array.isArray(re))return re.map(he=>I.InlineValue.from(he))}}class w{constructor($,U){this._documents=$,this._provider=U}async provideDocumentHighlights($,U,N){const W=this._documents.getDocument($),j=I.Position.to(U),re=await this._provider.provideDocumentHighlights(W,j,N);if(Array.isArray(re))return re.map(I.DocumentHighlight.from)}}class P{constructor($,U){this._documents=$,this._provider=U}async provideLinkedEditingRanges($,U,N){const W=this._documents.getDocument($),j=I.Position.to(U),re=await this._provider.provideLinkedEditingRanges(W,j,N);if(re&&Array.isArray(re.ranges))return{ranges:(0,R.coalesce)(re.ranges.map(I.Range.from)),wordPattern:re.wordPattern}}}class L{constructor($,U){this._documents=$,this._provider=U}async provideReferences($,U,N,W){const j=this._documents.getDocument($),re=I.Position.to(U),he=await this._provider.provideReferences(j,re,N,W);if(Array.isArray(he))return he.map(I.location.from)}}class O{constructor($,U,N,W,j,re,he){this._documents=$,this._commands=U,this._diagnostics=N,this._provider=W,this._logService=j,this._extension=re,this._apiDeprecation=he,this._cache=new v.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions($,U,N,W){const j=this._documents.getDocument($),re=D.Selection.isISelection(U)?I.Selection.to(U):I.Range.to(U),he=[];for(const He of this._diagnostics.getDiagnostics($))if(re.intersection(He.range)&&he.push(He)>O._maxCodeActionsPerFile)break;const Ce={diagnostics:he,only:N.only?new T.CodeActionKind(N.only):void 0,triggerKind:I.CodeActionTriggerKind.to(N.trigger)},Ae=await this._provider.provideCodeActions(j,re,Ce,W);if(!(0,R.isNonEmptyArray)(Ae)||W.isCancellationRequested)return;const We=this._cache.add(Ae),ze=new _.DisposableStore;this._disposables.set(We,ze);const qe=[];for(let He=0;He<Ae.length;He++){const Ue=Ae[He];!Ue||(O._isCommand(Ue)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),qe.push({_isSynthetic:!0,title:Ue.title,command:this._commands.toInternal(Ue,ze)})):(Ce.only&&(Ue.kind?Ce.only.contains(Ue.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ce.only.value} 'requested but returned code action is of kind '${Ue.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ce.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),qe.push({cacheId:[We,He],title:Ue.title,command:Ue.command&&this._commands.toInternal(Ue.command,ze),diagnostics:Ue.diagnostics&&Ue.diagnostics.map(I.Diagnostic.from),edit:Ue.edit&&I.WorkspaceEdit.from(Ue.edit),kind:Ue.kind&&Ue.kind.value,isPreferred:Ue.isPreferred,disabled:Ue.disabled?.reason})))}return{cacheId:We,actions:qe}}async resolveCodeAction($,U){const[N,W]=$,j=this._cache.get(N,W);if(!j||O._isCommand(j)||!this._provider.resolveCodeAction)return;const re=await this._provider.resolveCodeAction(j,U)??j;return re?.edit?I.WorkspaceEdit.from(re.edit):void 0}releaseCodeActions($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}static _isCommand($){return typeof $.command=="string"&&typeof $.title=="string"}}O._maxCodeActionsPerFile=1e3;class y{constructor($,U){this._documents=$,this._provider=U}async provideDocumentFormattingEdits($,U,N){const W=this._documents.getDocument($),j=await this._provider.provideDocumentFormattingEdits(W,U,N);if(Array.isArray(j))return j.map(I.TextEdit.from)}}class z{constructor($,U){this._documents=$,this._provider=U}async provideDocumentRangeFormattingEdits($,U,N,W){const j=this._documents.getDocument($),re=I.Range.to(U),he=await this._provider.provideDocumentRangeFormattingEdits(j,re,N,W);if(Array.isArray(he))return he.map(I.TextEdit.from)}}class M{constructor($,U){this._documents=$,this._provider=U,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits($,U,N,W,j){const re=this._documents.getDocument($),he=I.Position.to(U),Ce=await this._provider.provideOnTypeFormattingEdits(re,he,N,W,j);if(Array.isArray(Ce))return Ce.map(I.TextEdit.from)}}class B{constructor($,U){this._provider=$,this._logService=U,this._cache=new v.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols($,U){const N=await this._provider.provideWorkspaceSymbols($,U);if(!(0,R.isNonEmptyArray)(N))return{symbols:[]};const W=this._cache.add(N),j={cacheId:W,symbols:[]};for(let re=0;re<N.length;re++){const he=N[re];if(!he||!he.name){this._logService.warn("INVALID SymbolInformation",he);continue}j.symbols.push({...I.WorkspaceSymbol.from(he),cacheId:[W,re]})}return j}async resolveWorkspaceSymbol($,U){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!$.cacheId)return $;const N=this._cache.get(...$.cacheId);if(N){const W=await this._provider.resolveWorkspaceSymbol(N,U);return W&&(0,n.mixin)($,I.WorkspaceSymbol.from(W),!0)}}releaseWorkspaceSymbols($){this._cache.delete($)}}class V{constructor($,U,N){this._documents=$,this._provider=U,this._logService=N}static supportsResolving($){return typeof $.prepareRename=="function"}async provideRenameEdits($,U,N,W){const j=this._documents.getDocument($),re=I.Position.to(U);try{const he=await this._provider.provideRenameEdits(j,re,N,W);return he?I.WorkspaceEdit.from(he):void 0}catch(he){const Ce=V._asMessage(he);return Ce?{rejectReason:Ce,edits:void 0}:Promise.reject(he)}}async resolveRenameLocation($,U,N){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const W=this._documents.getDocument($),j=I.Position.to(U);try{const re=await this._provider.prepareRename(W,j,N);let he,Ce;if(T.Range.isRange(re)?(he=re,Ce=W.getText(re)):(0,F.isObject)(re)&&(he=re.range,Ce=re.placeholder),!he||!Ce)return;if(he.start.line>j.line||he.end.line<j.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(he),text:Ce}}catch(re){const he=V._asMessage(re);return he?{rejectReason:he,range:void 0,text:void 0}:Promise.reject(re)}}static _asMessage($){return typeof $=="string"?$:$ instanceof Error&&typeof $.message=="string"?$.message:void 0}}class Y{constructor($,U){this.resultId=$,this.tokens=U}}class H{constructor($,U){this._documents=$,this._provider=U,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens($,U,N){const W=this._documents.getDocument($),j=U!==0?this._previousResults.get(U):null;let re=typeof j?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(W,j.resultId,N):await this._provider.provideDocumentSemanticTokens(W,N);return j&&this._previousResults.delete(U),re?(re=H._fixProvidedSemanticTokens(re),this._send(H._convertToEdits(j,re),re)):null}async releaseDocumentSemanticColoring($){this._previousResults.delete($)}static _fixProvidedSemanticTokens($){return H._isSemanticTokens($)?H._isCorrectSemanticTokens($)?$:new T.SemanticTokens(new Uint32Array($.data),$.resultId):H._isSemanticTokensEdits($)?H._isCorrectSemanticTokensEdits($)?$:new T.SemanticTokensEdits($.edits.map(U=>new T.SemanticTokensEdit(U.start,U.deleteCount,U.data?new Uint32Array(U.data):U.data)),$.resultId):$}static _isSemanticTokens($){return $&&!!$.data}static _isCorrectSemanticTokens($){return $.data instanceof Uint32Array}static _isSemanticTokensEdits($){return $&&Array.isArray($.edits)}static _isCorrectSemanticTokensEdits($){for(const U of $.edits)if(!(U.data instanceof Uint32Array))return!1;return!0}static _convertToEdits($,U){if(!H._isSemanticTokens(U)||!$||!$.tokens)return U;const N=$.tokens,W=N.length,j=U.data,re=j.length;let he=0;const Ce=Math.min(W,re);for(;he<Ce&&N[he]===j[he];)he++;if(he===W&&he===re)return new T.SemanticTokensEdits([],U.resultId);let Ae=0;const We=Ce-he;for(;Ae<We&&N[W-Ae-1]===j[re-Ae-1];)Ae++;return new T.SemanticTokensEdits([{start:he,deleteCount:W-he-Ae,data:j.subarray(he,re-Ae)}],U.resultId)}_send($,U){if(H._isSemanticTokens($)){const N=this._nextResultId++;return this._previousResults.set(N,new Y($.resultId,$.data)),(0,g.encodeSemanticTokensDto)({id:N,type:"full",data:$.data})}if(H._isSemanticTokensEdits($)){const N=this._nextResultId++;return H._isSemanticTokens(U)?this._previousResults.set(N,new Y(U.resultId,U.data)):this._previousResults.set(N,new Y($.resultId)),(0,g.encodeSemanticTokensDto)({id:N,type:"delta",deltas:($.edits||[]).map(W=>({start:W.start,deleteCount:W.deleteCount,data:W.data}))})}return null}}e.DocumentSemanticTokensAdapter=H;class q{constructor($,U){this._documents=$,this._provider=U}async provideDocumentRangeSemanticTokens($,U,N){const W=this._documents.getDocument($),j=await this._provider.provideDocumentRangeSemanticTokens(W,I.Range.to(U),N);return j?this._send(j):null}_send($){return(0,g.encodeSemanticTokensDto)({id:0,type:"full",data:$.data})}}e.DocumentRangeSemanticTokensAdapter=q;class K{constructor($,U,N,W,j){this._documents=$,this._commands=U,this._provider=N,this._apiDeprecation=W,this._extension=j,this._cache=new v.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving($){return typeof $.resolveCompletionItem=="function"}async provideCompletionItems($,U,N,W){const j=this._documents.getDocument($),re=I.Position.to(U),he=j.getWordRangeAtPosition(re)||new T.Range(re,re),Ce=he.with({end:re}),Ae=new A.StopWatch(!0),We=await this._provider.provideCompletionItems(j,re,W,I.CompletionContext.to(N));if(!We||W.isCancellationRequested)return;const ze=Array.isArray(We)?new T.CompletionList(We):We,qe=K.supportsResolving(this._provider)?this._cache.add(ze.items):this._cache.add([]),He=new _.DisposableStore;this._disposables.set(qe,He);const Ue=[],Je={x:qe,b:Ue,a:{replace:I.Range.from(he),insert:I.Range.from(Ce)},c:ze.isIncomplete||void 0,d:Ae.elapsed()};for(let et=0;et<ze.items.length;et++){const Le=ze.items[et],it=this._convertCompletionItem(Le,[qe,et],Ce,he);Ue.push(it)}return Je}async resolveCompletionItem($,U){if(typeof this._provider.resolveCompletionItem!="function")return;const N=this._cache.get(...$);if(!N)return;const W=await this._provider.resolveCompletionItem(N,U);if(!!W)return this._convertCompletionItem(W,$)}releaseCompletionItems($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}_convertCompletionItem($,U,N,W){const j=this._disposables.get(U[0]);if(!j)throw Error("DisposableStore is missing...");const re={x:U,a:$.label,b:$.kind!==void 0?I.CompletionItemKind.from($.kind):void 0,n:$.tags&&$.tags.map(I.CompletionItemTag.from),c:$.detail,d:typeof $.documentation=="undefined"?void 0:I.MarkdownString.fromStrict($.documentation),e:$.sortText!==$.label?$.sortText:void 0,f:$.filterText!==$.label?$.filterText:void 0,g:$.preselect||void 0,i:$.keepWhitespace?1:0,k:$.commitCharacters,l:$.additionalTextEdits&&$.additionalTextEdits.map(I.TextEdit.from),m:this._commands.toInternal($.command,j)};$.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),re.h=$.textEdit.newText):typeof $.insertText=="string"?re.h=$.insertText:$.insertText instanceof T.SnippetString&&(re.h=$.insertText.value,re.i|=4);let he;return $.textEdit?he=$.textEdit.range:$.range&&(he=$.range),T.Range.isRange(he)?re.j=I.Range.from(he):he&&(!N?.isEqual(he.inserting)||!W?.isEqual(he.replacing))&&(re.j={insert:I.Range.from(he.inserting),replace:I.Range.from(he.replacing)}),re}}class G{constructor($,U,N){this._documents=$,this._provider=U,this._commands=N,this._cache=new v.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions($,U,N,W){const j=this._documents.getDocument($),re=I.Position.to(U),he=await this._provider.provideInlineCompletionItems(j,re,{selectedCompletionInfo:N.selectedSuggestionInfo?{range:I.Range.to(N.selectedSuggestionInfo.range),text:N.selectedSuggestionInfo.text,isSnippetText:N.selectedSuggestionInfo.isSnippetText,completionKind:I.CompletionItemKind.to(N.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:N.triggerKind},W);if(!he||W.isCancellationRequested)return;const Ce=(0,F.isArray)(he)?he:he.items,Ae=this._cache.add(Ce);let We;return{pid:Ae,items:Ce.map((ze,qe)=>{let He;ze.command&&(We||(We=new _.DisposableStore,this._disposables.set(Ae,We)),He=this._commands.toInternal(ze.command,We));const Ue=ze.insertText??ze.text;if(Ue===void 0)throw new Error("text or insertText must be defined");return{text:Ue,range:ze.range?I.Range.from(ze.range):void 0,command:He,idx:qe,completeBracketPairs:ze.completeBracketPairs}})}}disposeCompletions($){this._cache.delete($);const U=this._disposables.get($);U&&U.clear(),this._disposables.delete($)}handleDidShowCompletionItem($,U){const N=this._cache.get($,U);N&&ie.get(this._provider).fireOnDidShowCompletionItem({completionItem:N})}}class ie{constructor(){this._onDidShowCompletionItemEmitter=new a.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get($){let U=ie.map.get($);return U||(U=new ie,ie.map.set($,U)),U}fireOnDidShowCompletionItem($){this._onDidShowCompletionItemEmitter.fire($)}}e.InlineCompletionController=ie,ie.map=new WeakMap;class oe{constructor($,U){this._documents=$,this._provider=U,this._cache=new v.Cache("SignatureHelp")}async provideSignatureHelp($,U,N,W){const j=this._documents.getDocument($),re=I.Position.to(U),he=this.reviveContext(N),Ce=await this._provider.provideSignatureHelp(j,re,W,he);if(Ce){const Ae=this._cache.add([Ce]);return{...I.SignatureHelp.from(Ce),id:Ae}}}reviveContext($){let U;if($.activeSignatureHelp){const N=I.SignatureHelp.to($.activeSignatureHelp),W=this._cache.get($.activeSignatureHelp.id,0);W?(U=W,U.activeSignature=N.activeSignature,U.activeParameter=N.activeParameter):U=N}return{...$,activeSignatureHelp:U}}releaseSignatureHelp($){this._cache.delete($)}}class ue{constructor($,U,N,W,j){this._documents=$,this._commands=U,this._provider=N,this._logService=W,this._extension=j,this._cache=new v.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints($,U,N){const W=this._documents.getDocument($),j=I.Range.to(U),re=await this._provider.provideInlayHints(W,j,N);if(!Array.isArray(re)||re.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${U}`);return}if(N.isCancellationRequested)return;const he=this._cache.add(re);this._disposables.set(he,new _.DisposableStore);const Ce={hints:[],cacheId:he};for(let Ae=0;Ae<re.length;Ae++)this._isValidInlayHint(re[Ae],j)&&Ce.hints.push(this._convertInlayHint(re[Ae],[he,Ae]));return this._logService.trace(`[InlayHints] ${Ce.hints.length} inlay hints from '${this._extension.identifier.value}' for ${U}`),Ce}async resolveInlayHint($,U){if(typeof this._provider.resolveInlayHint!="function")return;const N=this._cache.get(...$);if(!N)return;const W=await this._provider.resolveInlayHint(N,U);if(!!W&&!!this._isValidInlayHint(W))return this._convertInlayHint(W,$)}releaseHints($){this._disposables.get($)?.dispose(),this._disposables.delete($),this._cache.delete($)}_isValidInlayHint($,U){return $.label.length===0||Array.isArray($.label)&&$.label.every(N=>N.value.length===0)?(console.log("INVALID inlay hint, empty label",$),!1):!(U&&!U.contains($.position))}_convertInlayHint($,U){const N=this._disposables.get(U[0]);if(!N)throw Error("DisposableStore is missing...");const W={label:"",cacheId:U,tooltip:I.MarkdownString.fromStrict($.tooltip),command:$.command&&this._commands.toInternal($.command,N),position:I.Position.from($.position),kind:$.kind&&I.InlayHintKind.from($.kind),paddingLeft:$.paddingLeft,paddingRight:$.paddingRight};return typeof $.label=="string"?W.label=$.label:W.label=$.label.map(j=>{let re={label:j.value};return re.tooltip=I.MarkdownString.fromStrict(j.tooltip),T.Location.isLocation(j.location)&&(re.location=I.location.from(j.location)),j.command&&(re.command=this._commands.toInternal(j.command,N)),re}),W}}class Z{constructor($,U){this._documents=$,this._provider=U,this._cache=new v.Cache("DocumentLink")}async provideLinks($,U){const N=this._documents.getDocument($),W=await this._provider.provideDocumentLinks(N,U);if(!(!Array.isArray(W)||W.length===0)&&!U.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:W.filter(Z._validateLink).map(I.DocumentLink.from)};{const j=this._cache.add(W),re={links:[],cacheId:j};for(let he=0;he<W.length;he++){if(!Z._validateLink(W[he]))continue;const Ce=I.DocumentLink.from(W[he]);Ce.cacheId=[j,he],re.links.push(Ce)}return re}}}static _validateLink($){return $.target&&$.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink($,U){if(typeof this._provider.resolveDocumentLink!="function")return;const N=this._cache.get(...$);if(!N)return;const W=await this._provider.resolveDocumentLink(N,U);if(!(!W||!Z._validateLink(W)))return I.DocumentLink.from(W)}releaseLinks($){this._cache.delete($)}}class Q{constructor($,U){this._documents=$,this._provider=U}async provideColors($,U){const N=this._documents.getDocument($),W=await this._provider.provideDocumentColors(N,U);return Array.isArray(W)?W.map(re=>({color:I.Color.from(re.color),range:I.Range.from(re.range)})):[]}async provideColorPresentations($,U,N){const W=this._documents.getDocument($),j=I.Range.to(U.range),re=I.Color.to(U.color),he=await this._provider.provideColorPresentations(re,{document:W,range:j},N);if(!!Array.isArray(he))return he.map(I.ColorPresentation.from)}}class se{constructor($,U){this._documents=$,this._provider=U}async provideFoldingRanges($,U,N){const W=this._documents.getDocument($),j=await this._provider.provideFoldingRanges(W,U,N);if(!!Array.isArray(j))return j.map(I.FoldingRange.from)}}class de{constructor($,U,N){this._documents=$,this._provider=U,this._logService=N}async provideSelectionRanges($,U,N){const W=this._documents.getDocument($),j=U.map(I.Position.to),re=await this._provider.provideSelectionRanges(W,j,N);if(!(0,R.isNonEmptyArray)(re))return[];if(re.length!==j.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const he=[];for(let Ce=0;Ce<j.length;Ce++){const Ae=[];he.push(Ae);let We=j[Ce],ze=re[Ce];for(;;){if(!ze.range.contains(We))throw new Error("INVALID selection range, must contain the previous range");if(Ae.push(I.SelectionRange.from(ze)),!ze.parent)break;We=ze.range,ze=ze.parent}}return he}}class ge{constructor($,U){this._documents=$,this._provider=U,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession($,U,N){const W=this._documents.getDocument($),j=I.Position.to(U),re=await this._provider.prepareCallHierarchy(W,j,N);if(!re)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(re)?re.map(Ce=>this._cacheAndConvertItem(he,Ce)):[this._cacheAndConvertItem(he,re)]}async provideCallsTo($,U,N){const W=this._itemFromCache($,U);if(!W)throw new Error("missing call hierarchy item");const j=await this._provider.provideCallHierarchyIncomingCalls(W,N);if(!!j)return j.map(re=>({from:this._cacheAndConvertItem($,re.from),fromRanges:re.fromRanges.map(he=>I.Range.from(he))}))}async provideCallsFrom($,U,N){const W=this._itemFromCache($,U);if(!W)throw new Error("missing call hierarchy item");const j=await this._provider.provideCallHierarchyOutgoingCalls(W,N);if(!!j)return j.map(re=>({to:this._cacheAndConvertItem($,re.to),fromRanges:re.fromRanges.map(he=>I.Range.from(he))}))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,U){const N=this._cache.get($),W=I.CallHierarchyItem.from(U,$,N.size.toString(36));return N.set(W._itemId,U),W}_itemFromCache($,U){return this._cache.get($)?.get(U)}}class Te{constructor($,U){this._documents=$,this._provider=U,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession($,U,N){const W=this._documents.getDocument($),j=I.Position.to(U),re=await this._provider.prepareTypeHierarchy(W,j,N);if(!re)return;const he=this._idPool.nextId();return this._cache.set(he,new Map),Array.isArray(re)?re.map(Ce=>this._cacheAndConvertItem(he,Ce)):[this._cacheAndConvertItem(he,re)]}async provideSupertypes($,U,N){const W=this._itemFromCache($,U);if(!W)throw new Error("missing type hierarchy item");const j=await this._provider.provideTypeHierarchySupertypes(W,N);if(!!j)return j.map(re=>this._cacheAndConvertItem($,re))}async provideSubtypes($,U,N){const W=this._itemFromCache($,U);if(!W)throw new Error("missing type hierarchy item");const j=await this._provider.provideTypeHierarchySubtypes(W,N);if(!!j)return j.map(re=>this._cacheAndConvertItem($,re))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,U){const N=this._cache.get($),W=I.TypeHierarchyItem.from(U,$,N.size.toString(36));return N.set(W._itemId,U),W}_itemFromCache($,U){return this._cache.get($)?.get(U)}}class Ne{constructor($,U){this.adapter=$,this.extension=U}}class be{constructor($,U,N,W,j,re,he){this._adapter=new Map,this._uriTransformer=U,this._proxy=$.getProxy(C.MainContext.MainThreadLanguageFeatures),this._documents=N,this._commands=W,this._diagnostics=j,this._logService=re,this._apiDeprecation=he}_transformDocumentSelector($){return I.DocumentSelector.from($,this._uriTransformer)}_createDisposable($){return new T.Disposable(()=>{this._adapter.delete($),this._proxy.$unregister($)})}_nextHandle(){return be._handlePool++}async _withAdapter($,U,N,W,j){const re=this._adapter.get($);if(!re||!(re.adapter instanceof U))return W;const he=Date.now();this._logService.trace(`[${re.extension.identifier.value}] INVOKE provider '${N.toString().replace(/[\r\n]/g,"")}'`);const Ce=N(re.adapter,re.extension);return Promise.resolve(Ce).catch(Ae=>{(0,b.isCancellationError)(Ae)||(this._logService.error(`[${re.extension.identifier.value}] provider FAILED`),this._logService.error(Ae))}).finally(()=>{this._logService.trace(`[${re.extension.identifier.value}] provider DONE after ${Date.now()-he}ms`)}),p.CancellationToken.isCancellationToken(j)?(0,c.raceCancellationError)(Ce,j):Ce}_addNewAdapter($,U){const N=this._nextHandle();return this._adapter.set(N,new Ne($,U)),N}static _extLabel($){return $.displayName||$.name}registerDocumentSymbolProvider($,U,N,W){const j=this._addNewAdapter(new m(this._documents,N),$),re=W&&W.label||be._extLabel($);return this._proxy.$registerDocumentSymbolProvider(j,this._transformDocumentSelector(U),re),this._createDisposable(j)}$provideDocumentSymbols($,U,N){return this._withAdapter($,m,W=>W.provideDocumentSymbols(h.URI.revive(U),N),void 0,N)}registerCodeLensProvider($,U,N){const W=this._nextHandle(),j=typeof N.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(W,new Ne(new s(this._documents,this._commands.converter,N),$)),this._proxy.$registerCodeLensSupport(W,this._transformDocumentSelector(U),j);let re=this._createDisposable(W);if(j!==void 0){const he=N.onDidChangeCodeLenses(Ce=>this._proxy.$emitCodeLensEvent(j));re=T.Disposable.from(re,he)}return re}$provideCodeLenses($,U,N){return this._withAdapter($,s,W=>W.provideCodeLenses(h.URI.revive(U),N),void 0,N)}$resolveCodeLens($,U,N){return this._withAdapter($,s,W=>W.resolveCodeLens(U,N),void 0,void 0)}$releaseCodeLenses($,U){this._withAdapter($,s,N=>Promise.resolve(N.releaseCodeLenses(U)),void 0,void 0)}registerDefinitionProvider($,U,N){const W=this._addNewAdapter(new l(this._documents,N),$);return this._proxy.$registerDefinitionSupport(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$provideDefinition($,U,N,W){return this._withAdapter($,l,j=>j.provideDefinition(h.URI.revive(U),N,W),[],W)}registerDeclarationProvider($,U,N){const W=this._addNewAdapter(new i(this._documents,N),$);return this._proxy.$registerDeclarationSupport(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$provideDeclaration($,U,N,W){return this._withAdapter($,i,j=>j.provideDeclaration(h.URI.revive(U),N,W),[],W)}registerImplementationProvider($,U,N){const W=this._addNewAdapter(new r(this._documents,N),$);return this._proxy.$registerImplementationSupport(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$provideImplementation($,U,N,W){return this._withAdapter($,r,j=>j.provideImplementation(h.URI.revive(U),N,W),[],W)}registerTypeDefinitionProvider($,U,N){const W=this._addNewAdapter(new t(this._documents,N),$);return this._proxy.$registerTypeDefinitionSupport(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$provideTypeDefinition($,U,N,W){return this._withAdapter($,t,j=>j.provideTypeDefinition(h.URI.revive(U),N,W),[],W)}registerHoverProvider($,U,N,W){const j=this._addNewAdapter(new o(this._documents,N),$);return this._proxy.$registerHoverProvider(j,this._transformDocumentSelector(U)),this._createDisposable(j)}$provideHover($,U,N,W){return this._withAdapter($,o,j=>j.provideHover(h.URI.revive(U),N,W),void 0,W)}registerEvaluatableExpressionProvider($,U,N,W){const j=this._addNewAdapter(new f(this._documents,N),$);return this._proxy.$registerEvaluatableExpressionProvider(j,this._transformDocumentSelector(U)),this._createDisposable(j)}$provideEvaluatableExpression($,U,N,W){return this._withAdapter($,f,j=>j.provideEvaluatableExpression(h.URI.revive(U),N,W),void 0,W)}registerInlineValuesProvider($,U,N,W){const j=typeof N.onDidChangeInlineValues=="function"?this._nextHandle():void 0,re=this._addNewAdapter(new u(this._documents,N),$);this._proxy.$registerInlineValuesProvider(re,this._transformDocumentSelector(U),j);let he=this._createDisposable(re);if(j!==void 0){const Ce=N.onDidChangeInlineValues(Ae=>this._proxy.$emitInlineValuesEvent(j));he=T.Disposable.from(he,Ce)}return he}$provideInlineValues($,U,N,W,j){return this._withAdapter($,u,re=>re.provideInlineValues(h.URI.revive(U),N,W,j),void 0,j)}registerDocumentHighlightProvider($,U,N){const W=this._addNewAdapter(new w(this._documents,N),$);return this._proxy.$registerDocumentHighlightProvider(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$provideDocumentHighlights($,U,N,W){return this._withAdapter($,w,j=>j.provideDocumentHighlights(h.URI.revive(U),N,W),void 0,W)}registerLinkedEditingRangeProvider($,U,N){const W=this._addNewAdapter(new P(this._documents,N),$);return this._proxy.$registerLinkedEditingRangeProvider(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$provideLinkedEditingRanges($,U,N,W){return this._withAdapter($,P,async j=>{const re=await j.provideLinkedEditingRanges(h.URI.revive(U),N,W);if(re)return{ranges:re.ranges,wordPattern:re.wordPattern?be._serializeRegExp(re.wordPattern):void 0}},void 0,W)}registerReferenceProvider($,U,N){const W=this._addNewAdapter(new L(this._documents,N),$);return this._proxy.$registerReferenceSupport(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$provideReferences($,U,N,W,j){return this._withAdapter($,L,re=>re.provideReferences(h.URI.revive(U),N,W,j),void 0,j)}registerCodeActionProvider($,U,N,W){const j=new _.DisposableStore,re=this._addNewAdapter(new O(this._documents,this._commands.converter,this._diagnostics,N,this._logService,$,this._apiDeprecation),$);return this._proxy.$registerQuickFixSupport(re,this._transformDocumentSelector(U),{providedKinds:W?.providedCodeActionKinds?.map(he=>he.value),documentation:W?.documentation?.map(he=>({kind:he.kind.value,command:this._commands.converter.toInternal(he.command,j)}))},be._extLabel($),Boolean(N.resolveCodeAction)),j.add(this._createDisposable(re)),j}$provideCodeActions($,U,N,W,j){return this._withAdapter($,O,re=>re.provideCodeActions(h.URI.revive(U),N,W,j),void 0,j)}$resolveCodeAction($,U,N){return this._withAdapter($,O,W=>W.resolveCodeAction(U,N),void 0,void 0)}$releaseCodeActions($,U){this._withAdapter($,O,N=>Promise.resolve(N.releaseCodeActions(U)),void 0,void 0)}registerDocumentFormattingEditProvider($,U,N){const W=this._addNewAdapter(new y(this._documents,N),$);return this._proxy.$registerDocumentFormattingSupport(W,this._transformDocumentSelector(U),$.identifier,$.displayName||$.name),this._createDisposable(W)}$provideDocumentFormattingEdits($,U,N,W){return this._withAdapter($,y,j=>j.provideDocumentFormattingEdits(h.URI.revive(U),N,W),void 0,W)}registerDocumentRangeFormattingEditProvider($,U,N){const W=this._addNewAdapter(new z(this._documents,N),$);return this._proxy.$registerRangeFormattingSupport(W,this._transformDocumentSelector(U),$.identifier,$.displayName||$.name),this._createDisposable(W)}$provideDocumentRangeFormattingEdits($,U,N,W,j){return this._withAdapter($,z,re=>re.provideDocumentRangeFormattingEdits(h.URI.revive(U),N,W,j),void 0,j)}registerOnTypeFormattingEditProvider($,U,N,W){const j=this._addNewAdapter(new M(this._documents,N),$);return this._proxy.$registerOnTypeFormattingSupport(j,this._transformDocumentSelector(U),W,$.identifier),this._createDisposable(j)}$provideOnTypeFormattingEdits($,U,N,W,j,re){return this._withAdapter($,M,he=>he.provideOnTypeFormattingEdits(h.URI.revive(U),N,W,j,re),void 0,re)}registerWorkspaceSymbolProvider($,U){const N=this._addNewAdapter(new B(U,this._logService),$);return this._proxy.$registerNavigateTypeSupport(N,typeof U.resolveWorkspaceSymbol=="function"),this._createDisposable(N)}$provideWorkspaceSymbols($,U,N){return this._withAdapter($,B,W=>W.provideWorkspaceSymbols(U,N),{symbols:[]},N)}$resolveWorkspaceSymbol($,U,N){return this._withAdapter($,B,W=>W.resolveWorkspaceSymbol(U,N),void 0,void 0)}$releaseWorkspaceSymbols($,U){this._withAdapter($,B,N=>N.releaseWorkspaceSymbols(U),void 0,void 0)}registerRenameProvider($,U,N){const W=this._addNewAdapter(new V(this._documents,N,this._logService),$);return this._proxy.$registerRenameSupport(W,this._transformDocumentSelector(U),V.supportsResolving(N)),this._createDisposable(W)}$provideRenameEdits($,U,N,W,j){return this._withAdapter($,V,re=>re.provideRenameEdits(h.URI.revive(U),N,W,j),void 0,j)}$resolveRenameLocation($,U,N,W){return this._withAdapter($,V,j=>j.resolveRenameLocation(h.URI.revive(U),N,W),void 0,W)}registerDocumentSemanticTokensProvider($,U,N,W){const j=this._addNewAdapter(new H(this._documents,N),$),re=typeof N.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(j,this._transformDocumentSelector(U),W,re);let he=this._createDisposable(j);if(re){const Ce=N.onDidChangeSemanticTokens(Ae=>this._proxy.$emitDocumentSemanticTokensEvent(re));he=T.Disposable.from(he,Ce)}return he}$provideDocumentSemanticTokens($,U,N,W){return this._withAdapter($,H,j=>j.provideDocumentSemanticTokens(h.URI.revive(U),N,W),null,W)}$releaseDocumentSemanticTokens($,U){this._withAdapter($,H,N=>N.releaseDocumentSemanticColoring(U),void 0,void 0)}registerDocumentRangeSemanticTokensProvider($,U,N,W){const j=this._addNewAdapter(new q(this._documents,N),$);return this._proxy.$registerDocumentRangeSemanticTokensProvider(j,this._transformDocumentSelector(U),W),this._createDisposable(j)}$provideDocumentRangeSemanticTokens($,U,N,W){return this._withAdapter($,q,j=>j.provideDocumentRangeSemanticTokens(h.URI.revive(U),N,W),null,W)}registerCompletionItemProvider($,U,N,W){const j=this._addNewAdapter(new K(this._documents,this._commands.converter,N,this._apiDeprecation,$),$);return this._proxy.$registerSuggestSupport(j,this._transformDocumentSelector(U),W,K.supportsResolving(N),`${$.identifier.value}(${W.join("")})`),this._createDisposable(j)}$provideCompletionItems($,U,N,W,j){return this._withAdapter($,K,re=>re.provideCompletionItems(h.URI.revive(U),N,W,j),void 0,j)}$resolveCompletionItem($,U,N){return this._withAdapter($,K,W=>W.resolveCompletionItem(U,N),void 0,N)}$releaseCompletionItems($,U){this._withAdapter($,K,N=>N.releaseCompletionItems(U),void 0,void 0)}registerInlineCompletionsProvider($,U,N){const W=this._addNewAdapter(new G(this._documents,N,this._commands.converter),$);return this._proxy.$registerInlineCompletionsSupport(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$provideInlineCompletions($,U,N,W,j){return this._withAdapter($,G,re=>re.provideInlineCompletions(h.URI.revive(U),N,W,j),void 0,j)}$handleInlineCompletionDidShow($,U,N){this._withAdapter($,G,async W=>{W.handleDidShowCompletionItem(U,N)},void 0,void 0)}$freeInlineCompletionsList($,U){this._withAdapter($,G,async N=>{N.disposeCompletions(U)},void 0,void 0)}registerSignatureHelpProvider($,U,N,W){const j=Array.isArray(W)?{triggerCharacters:W,retriggerCharacters:[]}:W,re=this._addNewAdapter(new oe(this._documents,N),$);return this._proxy.$registerSignatureHelpProvider(re,this._transformDocumentSelector(U),j),this._createDisposable(re)}$provideSignatureHelp($,U,N,W,j){return this._withAdapter($,oe,re=>re.provideSignatureHelp(h.URI.revive(U),N,W,j),void 0,j)}$releaseSignatureHelp($,U){this._withAdapter($,oe,N=>N.releaseSignatureHelp(U),void 0,void 0)}registerInlayHintsProvider($,U,N){const W=typeof N.onDidChangeInlayHints=="function"?this._nextHandle():void 0,j=this._addNewAdapter(new ue(this._documents,this._commands.converter,N,this._logService,$),$);this._proxy.$registerInlayHintsProvider(j,this._transformDocumentSelector(U),typeof N.resolveInlayHint=="function",W,be._extLabel($));let re=this._createDisposable(j);if(W!==void 0){const he=N.onDidChangeInlayHints(Ce=>this._proxy.$emitInlayHintsEvent(W));re=T.Disposable.from(re,he)}return re}$provideInlayHints($,U,N,W){return this._withAdapter($,ue,j=>j.provideInlayHints(h.URI.revive(U),N,W),void 0,W)}$resolveInlayHint($,U,N){return this._withAdapter($,ue,W=>W.resolveInlayHint(U,N),void 0,N)}$releaseInlayHints($,U){this._withAdapter($,ue,N=>N.releaseHints(U),void 0,void 0)}registerDocumentLinkProvider($,U,N){const W=this._addNewAdapter(new Z(this._documents,N),$);return this._proxy.$registerDocumentLinkProvider(W,this._transformDocumentSelector(U),typeof N.resolveDocumentLink=="function"),this._createDisposable(W)}$provideDocumentLinks($,U,N){return this._withAdapter($,Z,W=>W.provideLinks(h.URI.revive(U),N),void 0,N)}$resolveDocumentLink($,U,N){return this._withAdapter($,Z,W=>W.resolveLink(U,N),void 0,void 0)}$releaseDocumentLinks($,U){this._withAdapter($,Z,N=>N.releaseLinks(U),void 0,void 0)}registerColorProvider($,U,N){const W=this._addNewAdapter(new Q(this._documents,N),$);return this._proxy.$registerDocumentColorProvider(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$provideDocumentColors($,U,N){return this._withAdapter($,Q,W=>W.provideColors(h.URI.revive(U),N),[],N)}$provideColorPresentations($,U,N,W){return this._withAdapter($,Q,j=>j.provideColorPresentations(h.URI.revive(U),N,W),void 0,W)}registerFoldingRangeProvider($,U,N){const W=this._nextHandle(),j=typeof N.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(W,new Ne(new se(this._documents,N),$)),this._proxy.$registerFoldingRangeProvider(W,this._transformDocumentSelector(U),j);let re=this._createDisposable(W);if(j!==void 0){const he=N.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(j));re=T.Disposable.from(re,he)}return re}$provideFoldingRanges($,U,N,W){return this._withAdapter($,se,j=>j.provideFoldingRanges(h.URI.revive(U),N,W),void 0,W)}registerSelectionRangeProvider($,U,N){const W=this._addNewAdapter(new de(this._documents,N,this._logService),$);return this._proxy.$registerSelectionRangeProvider(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$provideSelectionRanges($,U,N,W){return this._withAdapter($,de,j=>j.provideSelectionRanges(h.URI.revive(U),N,W),[],W)}registerCallHierarchyProvider($,U,N){const W=this._addNewAdapter(new ge(this._documents,N),$);return this._proxy.$registerCallHierarchyProvider(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$prepareCallHierarchy($,U,N,W){return this._withAdapter($,ge,j=>Promise.resolve(j.prepareSession(h.URI.revive(U),N,W)),void 0,W)}$provideCallHierarchyIncomingCalls($,U,N,W){return this._withAdapter($,ge,j=>j.provideCallsTo(U,N,W),void 0,W)}$provideCallHierarchyOutgoingCalls($,U,N,W){return this._withAdapter($,ge,j=>j.provideCallsFrom(U,N,W),void 0,W)}$releaseCallHierarchy($,U){this._withAdapter($,ge,N=>Promise.resolve(N.releaseSession(U)),void 0,void 0)}registerTypeHierarchyProvider($,U,N){const W=this._addNewAdapter(new Te(this._documents,N),$);return this._proxy.$registerTypeHierarchyProvider(W,this._transformDocumentSelector(U)),this._createDisposable(W)}$prepareTypeHierarchy($,U,N,W){return this._withAdapter($,Te,j=>Promise.resolve(j.prepareSession(h.URI.revive(U),N,W)),void 0,W)}$provideTypeHierarchySupertypes($,U,N,W){return this._withAdapter($,Te,j=>j.provideSupertypes(U,N,W),void 0,W)}$provideTypeHierarchySubtypes($,U,N,W){return this._withAdapter($,Te,j=>j.provideSubtypes(U,N,W),void 0,W)}$releaseTypeHierarchy($,U){this._withAdapter($,Te,N=>Promise.resolve(N.releaseSession(U)),void 0,void 0)}static _serializeRegExp($){return{pattern:$.source,flags:(0,k.regExpFlags)($)}}static _serializeIndentationRule($){return{decreaseIndentPattern:be._serializeRegExp($.decreaseIndentPattern),increaseIndentPattern:be._serializeRegExp($.increaseIndentPattern),indentNextLinePattern:$.indentNextLinePattern?be._serializeRegExp($.indentNextLinePattern):void 0,unIndentedLinePattern:$.unIndentedLinePattern?be._serializeRegExp($.unIndentedLinePattern):void 0}}static _serializeOnEnterRule($){return{beforeText:be._serializeRegExp($.beforeText),afterText:$.afterText?be._serializeRegExp($.afterText):void 0,previousLineText:$.previousLineText?be._serializeRegExp($.previousLineText):void 0,action:$.action}}static _serializeOnEnterRules($){return $.map(be._serializeOnEnterRule)}setLanguageConfiguration($,U,N){let{wordPattern:W}=N;if(W&&(0,k.regExpLeadsToEndlessLoop)(W))throw new Error(`Invalid language configuration: wordPattern '${W}' is not allowed to match the empty string.`);W?this._documents.setWordDefinitionFor(U,W):this._documents.setWordDefinitionFor(U,void 0),N.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",$,"Do not use."),N.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",$,"Do not use.");const j=this._nextHandle(),re={comments:N.comments,brackets:N.brackets,wordPattern:N.wordPattern?be._serializeRegExp(N.wordPattern):void 0,indentationRules:N.indentationRules?be._serializeIndentationRule(N.indentationRules):void 0,onEnterRules:N.onEnterRules?be._serializeOnEnterRules(N.onEnterRules):void 0,__electricCharacterSupport:N.__electricCharacterSupport,__characterPairSupport:N.__characterPairSupport};return this._proxy.$setLanguageConfiguration(j,U,re),this._createDisposable(j)}$setWordDefinitions($){for(const U of $)this._documents.setWordDefinitionFor(U.languageId,new RegExp(U.regexSource,U.regexFlags))}}e.ExtHostLanguageFeatures=be,be._handlePool=0}),define(ve[242],we([1,0,5,14,7,47,15,6]),function(ee,e,h,n,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(F,D,p,_){this._documents=D,this._commands=p,this._uriTransformer=_,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=F.getProxy(h.MainContext.MainThreadLanguages)}$acceptLanguageIds(F){this._languageIds=F}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(F,D){await this._proxy.$changeLanguage(F,D);const p=this._documents.getDocumentData(F);if(!p)throw new Error(`document '${F.toString()}' NOT found`);return p.document}async tokenAtPosition(F,D){const p=F.version,_=n.Position.from(D),g=await this._proxy.$tokensAtPosition(F.uri,_),d={type:I.StandardTokenType.Other,range:F.getWordRangeAtPosition(D)??new I.Range(D.line,D.character,D.line,D.character)};if(!g)return d;const v={range:n.Range.to(g.range),type:n.TokenType.to(g.type)};return!v.range.contains(D)||p!==F.version?d:v}createLanguageStatusItem(F,D,p){const _=this._handlePool++,g=this._proxy,d=this._ids,v=`${F.identifier.value}/${D}`;if(d.has(v))throw new Error(`LanguageStatusItem with id '${D}' ALREADY exists`);d.add(v);const A={selector:p,id:D,name:F.displayName??F.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let b,a=new k.DisposableStore;const c=()=>{b?.dispose(),b=(0,C.disposableTimeout)(()=>{a.clear(),this._proxy.$setLanguageStatus(_,{id:v,name:A.name??F.displayName??F.name,source:F.displayName??F.name,selector:n.DocumentSelector.from(A.selector,this._uriTransformer),label:A.text,detail:A.detail??"",severity:A.severity===I.LanguageStatusSeverity.Error?T.default.Error:A.severity===I.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:A.command&&this._commands.toInternal(A.command,a),accessibilityInfo:A.accessibilityInformation,busy:A.busy})},0)},m={dispose(){a.dispose(),b?.dispose(),g.$removeLanguageStatus(_),d.delete(v)},get id(){return A.id},get name(){return A.name},set name(s){A.name=s,c()},get selector(){return A.selector},set selector(s){A.selector=s,c()},get text(){return A.text},set text(s){A.text=s,c()},get detail(){return A.detail},set detail(s){A.detail=s,c()},get severity(){return A.severity},set severity(s){A.severity=s,c()},get accessibilityInformation(){return A.accessibilityInformation},set accessibilityInformation(s){A.accessibilityInformation=s,c()},get command(){return A.command},set command(s){A.command=s,c()},get busy(){return A.busy},set busy(s){A.busy=s,c()}};return c(),m}}e.ExtHostLanguages=S}),define(ve[134],we([1,0,11,5,26,16,3]),function(ee,e,h,n,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends h.AbstractLoggerService{constructor(F,D){const p=new C.Emitter;super(D.logLevel,p.event);this._proxy=F.getProxy(n.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(p)}$setLevel(F){this._onDidChangeLogLevel.fire(F)}doCreateLogger(F,D,p){return new S(this._proxy,F,D,p)}};k=Be([Fe(0,T.IExtHostRpcService),Fe(1,I.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class S extends h.AbstractMessageLogger{constructor(F,D,p,_){super(_?.always);this.proxy=F,this.file=D,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(p),this.proxy.$createLogger(D,_).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(F,D){const p=[[F,D]];this.isLoggerCreated?this.doLog(p):this.buffer.push(...p)}doLog(F){this.proxy.$log(this.file,F)}}}),define(ve[243],we([1,0,5,11,30]),function(ee,e,h,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(k){return k&&k.title}let C=class{constructor(S,R){this._logService=R,this._proxy=S.getProxy(h.MainContext.MainThreadMessageService)}showMessage(S,R,F,D,p){const _={source:{identifier:S.identifier,label:S.displayName||S.name}};let g;typeof D=="string"||T(D)?g=[D,...p]:(_.modal=D?.modal,_.useCustom=D?.useCustom,_.detail=D?.detail,g=p),_.useCustom&&(0,I.checkProposedApiEnabled)(S,"resolvers");const d=[];for(let v=0;v<g.length;v++){const A=g[v];if(typeof A=="string")d.push({title:A,handle:v,isCloseAffordance:!1});else if(typeof A=="object"){let{title:b,isCloseAffordance:a}=A;d.push({title:b,isCloseAffordance:!!a,handle:v})}else this._logService.warn("Invalid message item:",A)}return this._proxy.$showMessage(R,F,_,d).then(v=>{if(typeof v=="number")return g[v]})}};C=Be([Fe(1,n.ILogService)],C),e.ExtHostMessageService=C}),define(ve[244],we([1,0,22,3,57,6,24,8,13,2,82,5,14,7,52,220,130]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_,g,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class A{constructor(a,c,m,s,E){this._textDocumentsAndEditors=m,this._textDocuments=s,this._extensionStoragePaths=E,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new C.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new n.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new n.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new n.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new n.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new n.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new n.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new n.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new F.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=a.getProxy(D.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=a.getProxy(D.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=a.getProxy(D.MainContext.MainThreadNotebookEditors),this._commandsConverter=c.converter,c.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===12){const i=l.notebookEditor?.notebookUri,r=l.cell.handle,o=this._documents.get(i)?.getCell(r);if(o)return o.apiCell}return l}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(a=>a.apiEditor)}getEditorById(a){const c=this._editors.get(a);if(!c)throw new Error(`unknown text editor: ${a}. known editors: ${[...this._editors.keys()]} `);return c}getIdByEditor(a){for(const[c,m]of this._editors)if(m.apiEditor===a)return c}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(a,c){const m=this._documents.get(a);if(!m&&!c)throw new Error(`NO notebook document for '${a}'`);return m}_getProviderData(a){const c=this._notebookContentProviders.get(a);if(!c)throw new Error(`NO provider for '${a}'`);return c}registerNotebookContentProvider(a,c,m,s,E){if((0,k.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(c))throw new Error(`Notebook provider for '${c}' already registered`);this._notebookContentProviders.set(c,{extension:a,provider:m});let l;return m.onDidChangeNotebookContentOptions&&(l=m.onDidChangeNotebookContentOptions(()=>{const i=p.NotebookDocumentContentOptions.from(m.options);this._notebookProxy.$updateNotebookProviderOptions(c,i)})),this._notebookProxy.$registerNotebookProvider({id:a.identifier,location:a.extensionLocation},c,p.NotebookDocumentContentOptions.from(s),A._convertNotebookRegistrationData(a,E)),new _.Disposable(()=>{l?.dispose(),this._notebookContentProviders.delete(c),this._notebookProxy.$unregisterNotebookProvider(c)})}static _convertNotebookRegistrationData(a,c){if(!c)return;const m=c.filenamePattern.map(s=>p.NotebookExclusiveDocumentPattern.from(s)).filter(s=>s!==void 0);if(c.filenamePattern&&!m){console.warn(`Notebook content provider view options file name pattern is invalid ${c.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:c.displayName,filenamePattern:m,exclusive:c.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,c,m){const s=A._notebookStatusBarItemProviderHandlePool++,E=typeof m.onDidChangeCellStatusBarItems=="function"?A._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(s,m),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(s,E,c);let l;return E!==void 0&&(l=m.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(E))),new _.Disposable(()=>{this._notebookStatusBarItemProviders.delete(s),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(s,E),l&&l.dispose()})}async createNotebookDocument(a){const c=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:a.viewType,content:a.content&&p.NotebookData.from(a.content)});return R.URI.revive(c)}async openNotebookDocument(a){const c=this._documents.get(a);if(c)return c.apiNotebook;const m=await this._notebookDocumentsProxy.$tryOpenNotebook(a),s=this._documents.get(R.URI.revive(m));return(0,S.assertIsDefined)(s?.apiNotebook)}async showNotebookDocument(a,c){R.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let m;typeof c=="object"?m={position:p.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selections:c.selections&&c.selections.map(p.NotebookRange.from),pinned:typeof c.preview=="boolean"?!c.preview:void 0}:m={preserveFocus:!1};const s=await this._notebookEditorsProxy.$tryShowNotebookDocument(a.uri,a.notebookType,m),E=s&&this._editors.get(s)?.apiEditor;if(E)return E;throw s?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,c,m,s){const E=this._notebookStatusBarItemProviders.get(a),l=R.URI.revive(c),i=this._documents.get(l);if(!i||!E)return;const r=i.getCellFromIndex(m);if(!r)return;const t=await E.provideCellStatusBarItems(r.apiCell,s);if(!t)return;const o=new T.DisposableStore,f=this._statusBarCache.add([o]),w=(Array.isArray(t)?t:[t]).map(P=>p.NotebookStatusBarItem.from(P,this._commandsConverter,o));return{cacheId:f,items:w}}$releaseNotebookCellStatusBarItems(a){this._statusBarCache.delete(a)}registerNotebookSerializer(a,c,m,s,E){if((0,k.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");const l=this._handlePool++;return this._notebookSerializer.set(l,m),this._notebookProxy.$registerNotebookSerializer(l,{id:a.identifier,location:a.extensionLocation},c,p.NotebookDocumentContentOptions.from(s),A._convertNotebookRegistrationData(a,E)),(0,T.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(l)})}async $dataToNotebook(a,c,m){const s=this._notebookSerializer.get(a);if(!s)throw new Error("NO serializer found");const E=await s.deserializeNotebook(c.buffer,m);return new g.SerializableObjectWithBuffers(p.NotebookData.from(E))}async $notebookToData(a,c,m){const s=this._notebookSerializer.get(a);if(!s)throw new Error("NO serializer found");const E=await s.serializeNotebook(p.NotebookData.to(c.value),m);return h.VSBuffer.wrap(E)}async $openNotebook(a,c,m,s,E){const{provider:l}=this._getProviderData(a),i=await l.openNotebook(R.URI.revive(c),{backupId:m,untitledDocumentData:s?.buffer},E);return new g.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(p.NotebookCellData.from)})}async $saveNotebook(a,c,m){const s=this.getNotebookDocument(R.URI.revive(c)),{provider:E}=this._getProviderData(a);return await E.saveNotebook(s.apiNotebook,m),!0}async $saveNotebookAs(a,c,m,s){const E=this.getNotebookDocument(R.URI.revive(c)),{provider:l}=this._getProviderData(a);return await l.saveNotebookAs(R.URI.revive(m),E.apiNotebook,s),!0}async $backupNotebook(a,c,m){const s=this.getNotebookDocument(R.URI.revive(c)),E=this._getProviderData(a),l=this._extensionStoragePaths.workspaceValue(E.extension)??this._extensionStoragePaths.globalValue(E.extension),i=String((0,I.hash)([s.uri.toString(),this._backupIdPool++])),r=R.URI.joinPath(l,i),t=await E.provider.backupNotebook(s.apiNotebook,{destination:r},m);return s.updateBackup(t),t.id}_createExtHostEditor(a,c,m){if(this._editors.has(c))throw new Error(`editor with id ALREADY EXSIST: ${c}`);const s=new v.ExtHostNotebookEditor(c,this._notebookEditorsProxy,a,m.visibleRanges.map(p.NotebookRange.to),m.selections.map(p.NotebookRange.to),typeof m.viewColumn=="number"?p.ViewColumn.to(m.viewColumn):void 0);this._editors.set(c,s)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const m of a.value.removedDocuments){const s=R.URI.revive(m),E=this._documents.get(s);E&&(E.dispose(),this._documents.delete(s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:E.apiNotebook.getCells().map(l=>l.document.uri)}),this._onDidCloseNotebookDocument.fire(E.apiNotebook));for(const l of this._editors.values())l.notebookData.uri.toString()===s.toString()&&this._editors.delete(l.id)}if(a.value.addedDocuments){const m=[];for(const s of a.value.addedDocuments){const E=R.URI.revive(s.uri);if(this._documents.has(E))throw new Error(`adding EXISTING notebook ${E} `);const l=this,i=new d.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(r){l._onDidChangeNotebookCells.fire(r)},emitCellOutputsChange(r){l._onDidChangeCellOutputs.fire(r)},emitCellMetadataChange(r){l._onDidChangeCellMetadata.fire(r)}},E,s);m.push(...s.cells.map(r=>d.ExtHostCell.asModelAddData(i.apiNotebook,r))),this._documents.get(E)?.dispose(),this._documents.set(E,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:m}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(a.value.addedEditors)for(const m of a.value.addedEditors){if(this._editors.has(m.id))return;const s=R.URI.revive(m.documentUri),E=this._documents.get(s);E&&this._createExtHostEditor(E,m.id,m)}const c=[];if(a.value.removedEditors)for(const m of a.value.removedEditors){const s=this._editors.get(m);s&&(this._editors.delete(m),this._activeNotebookEditor?.id===s.id&&(this._activeNotebookEditor=void 0),c.push(s))}if(a.value.visibleEditors){this._visibleNotebookEditors=a.value.visibleEditors.map(s=>this._editors.get(s)).filter(s=>!!s);const m=new Set;this._visibleNotebookEditors.forEach(s=>m.add(s.id));for(const s of this._editors.values()){const E=m.has(s.id);s._acceptVisibility(E)}this._visibleNotebookEditors=[...this._editors.values()].map(s=>s).filter(s=>s.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this._activeNotebookEditor=void 0:a.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=A,A._notebookStatusBarItemProviderHandlePool=0}),define(ve[245],we([1,0,3,75,11,5,16,14]),function(ee,e,h,n,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class S{constructor(D,p){const _=S._Keys.nextId();D.$registerNotebookEditorDecorationType(_,k.NotebookDecorationRenderOptions.from(p)),this.value={key:_,dispose(){D.$removeNotebookEditorDecorationType(_)}}}}S._Keys=new n.IdGenerator("NotebookEditorDecorationType");let R=class{constructor(D,p,_){this._logService=D,this._extHostRpc=p,this._notebooksAndEditors=_,this._onDidChangeNotebookEditorSelection=new h.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new h.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(D){return new S(this._extHostRpc.getProxy(T.MainContext.MainThreadNotebookEditors),D).value}$acceptEditorPropertiesChanged(D,p){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",D,p);const _=this._notebooksAndEditors.getEditorById(D);p.visibleRanges&&_._acceptVisibleRanges(p.visibleRanges.ranges.map(k.NotebookRange.to)),p.selections&&_._acceptSelections(p.selections.selections.map(k.NotebookRange.to)),p.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:_.apiEditor,visibleRanges:_.apiEditor.visibleRanges}),p.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:_.apiEditor,selections:_.apiEditor.selections}))}$acceptEditorViewColumns(D){for(const p in D)this._notebooksAndEditors.getEditorById(p)._acceptViewColumn(k.ViewColumn.to(D[p]))}};R=Be([Fe(0,I.ILogService),Fe(1,C.IExtHostRpcService)],R),e.ExtHostNotebookEditors=R}),define(ve[246],we([1,0,18,15,21,3,6,24,2,27,11,5,39,14,7,83,213,30,52]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_,g,d,v,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let a=class{constructor(i,r,t,o,f){this._initData=r,this._extHostNotebook=t,this._commands=o,this._logService=f,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new T.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=i.getProxy(D.MainContext.MainThreadNotebookKernels);const u=new p.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.ApiCommandArgument("options","Select kernel options",w=>!0,w=>{if(w&&"notebookEditor"in w&&"id"in w){const P=this._extHostNotebook.getIdByEditor(w.notebookEditor);return{id:w.id,extension:w.extension,notebookEditorId:P}}else if(w&&"notebookEditor"in w){const P=this._extHostNotebook.getIdByEditor(w.notebookEditor);if(P===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${w.notebookEditor.document.uri.toString()}`);return{notebookEditorId:P}}return w})],p.ApiCommandResult.Void);this._commands.registerApiCommand(u)}createNotebookController(i,r,t,o,f,u){for(const ie of this._kernelData.values())if(ie.controller.id===r&&R.ExtensionIdentifier.equals(i.identifier,ie.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const w=this._handlePool++,P=this;this._logService.trace(`NotebookController[${w}], CREATED by ${i.identifier.value}, ${r}`);const L=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${i.identifier}'`);let O=!1;const y=new C.DisposableStore,z=new T.Emitter,M=new T.Emitter,B={id:E(i,r),notebookType:t,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:o||i.identifier.value,preloads:u?u.map(_.NotebookRendererScript.from):[]};let V=f??L,Y;this._proxy.$addKernel(w,B).catch(ie=>{console.log(ie),O=!0});let H=0;const q=()=>{if(O)return;const ie=++H;Promise.resolve().then(()=>{ie===H&&this._proxy.$updateKernel(w,B)})},K=new k.ResourceMap,G={get id(){return r},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return B.label},set label(ie){B.label=ie??i.displayName??i.name,q()},get detail(){return B.detail??""},set detail(ie){B.detail=ie,q()},get description(){return B.description??""},set description(ie){B.description=ie,q()},get kind(){return(0,A.checkProposedApiEnabled)(i,"notebookControllerKind"),B.kind??""},set kind(ie){(0,A.checkProposedApiEnabled)(i,"notebookControllerKind"),B.kind=ie,q()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(ie){B.supportedLanguages=ie,q()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(ie){B.supportsExecutionOrder=ie,q()},get rendererScripts(){return B.preloads?B.preloads.map(_.NotebookRendererScript.to):[]},get executeHandler(){return V},set executeHandler(ie){V=ie??L},get interruptHandler(){return Y},set interruptHandler(ie){Y=ie,B.supportsInterrupt=Boolean(ie),q()},createNotebookCellExecution(ie){if(O)throw new Error("notebook controller is DISPOSED");if(!K.has(ie.notebook.uri))throw P._logService.trace(`NotebookController[${w}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(K.keys()).map(oe=>oe.toString())),new Error(`notebook controller is NOT associated to notebook: ${ie.notebook.uri.toString()}`);return P._createNotebookCellExecution(ie,E(i,this.id))},dispose:()=>{O||(this._logService.trace(`NotebookController[${w}], DISPOSED`),O=!0,this._kernelData.delete(w),y.dispose(),z.dispose(),M.dispose(),this._proxy.$removeKernel(w))},updateNotebookAffinity(ie,oe){P._proxy.$updateNotebookPriority(w,ie.uri,oe)},onDidReceiveMessage:M.event,postMessage(ie,oe){return(0,A.checkProposedApiEnabled)(i,"notebookMessaging"),P._proxy.$postMessage(w,oe&&P._extHostNotebook.getIdByEditor(oe),ie)},asWebviewUri(ie){return(0,A.checkProposedApiEnabled)(i,"notebookMessaging"),(0,d.asWebviewUri)(ie,P._initData.remote)}};return this._kernelData.set(w,{extensionId:i.identifier,controller:G,onDidReceiveMessage:M,onDidChangeSelection:z,associatedNotebooks:K}),G}$acceptNotebookAssociation(i,r,t){const o=this._kernelData.get(i);if(o){const f=this._extHostNotebook.getNotebookDocument(S.URI.revive(r));t?o.associatedNotebooks.set(f.uri,!0):o.associatedNotebooks.delete(f.uri),this._logService.trace(`NotebookController[${i}] ASSOCIATE notebook`,f.uri.toString(),t),o.onDidChangeSelection.fire({selected:t,notebook:f.apiNotebook})}}async $executeCells(i,r,t){const o=this._kernelData.get(i);if(!o)return;const f=this._extHostNotebook.getNotebookDocument(S.URI.revive(r)),u=[];for(const w of t){const P=f.getCell(w);P&&u.push(P.apiCell)}try{this._logService.trace(`NotebookController[${i}] EXECUTE cells`,f.uri.toString(),u.length),await o.controller.executeHandler.call(o.controller,u,f.apiNotebook,o.controller)}catch(w){this._logService.error(`NotebookController[${i}] execute cells FAILED`,w),console.error(w)}}async $cancelCells(i,r,t){const o=this._kernelData.get(i);if(!o)return;const f=this._extHostNotebook.getNotebookDocument(S.URI.revive(r));if(o.controller.interruptHandler)await o.controller.interruptHandler.call(o.controller,f.apiNotebook);else for(const u of t){const w=f.getCell(u);w&&this._activeExecutions.get(w.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,r,t){const o=this._kernelData.get(i);if(!o)return;const f=this._extHostNotebook.getEditorById(r);o.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:t}))}$cellExecutionChanged(i,r,t){const f=this._extHostNotebook.getNotebookDocument(S.URI.revive(i)).getCell(r);f&&this._onDidChangeCellExecutionState.fire({cell:f.apiCell,state:t?_.NotebookCellExecutionState.to(t):g.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(i,r){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const o=this._extHostNotebook.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!o)throw new Error("invalid cell");if(this._activeExecutions.has(o.uri))throw new Error(`duplicate execution for ${o.uri}`);const f=new m(r,o,this._proxy);this._activeExecutions.set(o.uri,f);const u=f.onDidChangeState(()=>{f.state===c.Resolved&&(f.dispose(),u.dispose(),this._activeExecutions.delete(o.uri))});return f.asApiObject()}};a=Be([Fe(4,F.ILogService)],a),e.ExtHostNotebookKernels=a;var c;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(c||(c={}));class m extends C.Disposable{constructor(i,r,t){super();this._cell=r,this._proxy=t,this._handle=m.HANDLE++,this._onDidChangeState=new T.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=c.Init,this._tokenSource=this._register(new I.CancellationTokenSource),this._collector=new s(10,o=>this.update(o)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,i,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(i){await this._collector.addItem(i)}async update(i){const r=Array.isArray(i)?i:[i];return this._proxy.$updateExecution(this._handle,new b.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===c.Init)throw new Error("Must call start before modifying cell output");if(this._state===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}validateAndConvertOutputs(i){return i.map(r=>{const t=g.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return t===r.items?_.NotebookCellOutput.from(r):_.NotebookCellOutput.from({items:t,id:r.id,metadata:r.metadata})})}async updateOutputs(i,r,t){const o=this.validateAndConvertOutputs((0,h.asArray)(i));return this.updateSoon({editType:v.CellExecutionUpdateType.Output,append:t,outputs:o})}async updateOutputItems(i,r,t){return i=g.NotebookCellOutput.ensureUniqueMimeTypes((0,h.asArray)(i),!0),this.updateSoon({editType:v.CellExecutionUpdateType.OutputItems,items:i.map(_.NotebookCellOutputItem.from),outputId:r.id,append:t})}asApiObject(){const i=this;return Object.freeze({get token(){return i._tokenSource.token},get cell(){return i._cell.apiCell},get executionOrder(){return i._executionOrder},set executionOrder(t){i._executionOrder=t,i.update([{editType:v.CellExecutionUpdateType.ExecutionState,executionOrder:i._executionOrder}])},start(t){if(i._state===c.Resolved||i._state===c.Started)throw new Error("Cannot call start again");i._state=c.Started,i._onDidChangeState.fire(),i.update({editType:v.CellExecutionUpdateType.ExecutionState,runStartTime:t})},end(t,o){if(i._state===c.Resolved)throw new Error("Cannot call resolve twice");i._state=c.Resolved,i._onDidChangeState.fire(),i._collector.flush(),i._proxy.$completeExecution(i._handle,new b.SerializableObjectWithBuffers({runEndTime:o,lastRunSuccess:t}))},clearOutput(t){return i.verifyStateForOutput(),i.updateOutputs([],t,!1)},appendOutput(t,o){return i.verifyStateForOutput(),i.updateOutputs(t,o,!0)},replaceOutput(t,o){return i.verifyStateForOutput(),i.updateOutputs(t,o,!1)},appendOutputItems(t,o){return i.verifyStateForOutput(),i.updateOutputItems(t,o,!0)},replaceOutputItems(t,o){return i.verifyStateForOutput(),i.updateOutputItems(t,o,!1)}})}}m.HANDLE=0;class s{constructor(i,r){this.delay=i,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(i){return this.batch.push(i),this.currentDeferred||(this.currentDeferred=new n.DeferredPromise,this.startedTimer=Date.now(),(0,n.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const i=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>i.complete())}}function E(l,i){return`${l.identifier.value}/${i}`}}),define(ve[247],we([1,0,3,5,130,30]),function(ee,e,h,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class C{constructor(S,R){this._extHostNotebook=R,this._rendererMessageEmitters=new Map,this.proxy=S.getProxy(n.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(S,R,F){const D=this._extHostNotebook.getEditorById(S);this._rendererMessageEmitters.get(R)?.fire({editor:D.apiEditor,message:F})}createRendererMessaging(S,R){if(!S.contributes?.notebookRenderer?.some(_=>_.id===R))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${R})`);const F=(0,T.isProposedApiEnabled)(S,"notebookEditor"),D=new WeakMap;return{onDidReceiveMessage:(_,g,d)=>{const v=F?_:A=>{const b={};D.set(b,A.editor),_({editor:b,message:A.message})};return this.getOrCreateEmitterFor(R).event(v,g,d)},postMessage:(_,g)=>{I.ExtHostNotebookEditor.apiEditorsToExtHost.has(_)&&([_,g]=[g,_]);const d=F?g:D.get(g),v=d&&I.ExtHostNotebookEditor.apiEditorsToExtHost.get(d);return this.proxy.$postMessage(v?.id,R,_)}}}getOrCreateEmitterFor(S){let R=this._rendererMessageEmitters.get(S);return R||(R=new h.Emitter({onLastListenerRemove:()=>{R?.dispose(),this._rendererMessageEmitters.delete(S)}}),this._rendererMessageEmitters.set(S,R),R)}}e.ExtHostNotebookRenderers=C}),define(ve[135],we([1,0,5,6,4,16,11,214,65,26,44,155,22,13]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class g extends n.Disposable{constructor(A,b,a,c){super();this.id=A,this.name=b,this.logger=a,this.proxy=c,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(A){this.append(A+`
`)}append(A){this.write(A),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Append))}clear(){const A=this.offset;this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Clear,A)}replace(A){const b=this.offset;this.write(A),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Replace,b),this.visible&&this.logger.flush()}show(A,b){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof A=="boolean"?A:b))}hide(){this.proxy.$close(this.id)}write(A){this.offset+=p.VSBuffer.fromString(A).byteLength,this.logger.info(A)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=g;let d=class{constructor(A,b,a,c,m){this.extHostFileSystem=a,this.extHostFileSystemInfo=c,this.loggerService=m,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=A.getProxy(h.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(b.logsLocation,`output_logging_${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(A){this.visibleChannelId=A;for(const[b,a]of this.channels)a.visible=b===this.visibleChannelId}createOutputChannel(A,b,a){if(A=A.trim(),!A)throw new Error("illegal argument `name`. must not be falsy");if((0,_.isString)(b)&&!b.trim())throw new Error("illegal argument `languageId`. must not be empty");const c=this.doCreateOutputChannel(A,b,a);return c.then(m=>{this.channels.set(m.id,m),m.visible=m.id===this.visibleChannelId}),this.createExtHostOutputChannel(A,c)}async doCreateOutputChannel(A,b,a){const c=await this.createOutputDirectory(),m=this.extHostFileSystemInfo.extUri.joinPath(c,`${this.namePool++}-${A.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=this.loggerService.createLogger(m,{always:!0,donotRotate:!0,donotUseFormatters:!0}),E=await this.proxy.$register(A,!1,m,b,a.identifier.value);return new g(E,A,s,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(A,b){let a=!1;const c=()=>{if(a)throw new Error("Channel has been closed")};return{get name(){return A},append(m){c(),b.then(s=>s.append(m))},appendLine(m){c(),b.then(s=>s.appendLine(m))},clear(){c(),b.then(m=>m.clear())},replace(m){c(),b.then(s=>s.replace(m))},show(m,s){c(),b.then(E=>E.show(m,s))},hide(){c(),b.then(m=>m.hide())},dispose(){a=!0,b.then(m=>m.dispose())}}}};d=Be([Fe(0,T.IExtHostRpcService),Fe(1,R.IExtHostInitDataService),Fe(2,S.IExtHostConsumerFileSystem),Fe(3,F.IExtHostFileSystemInfo),Fe(4,C.ILoggerService)],d),e.ExtHostOutputService=d,e.IExtHostOutputService=(0,I.createDecorator)("IExtHostOutputService")}),define(ve[248],we([1,0,15,21,3,6,5,2,7,17,18,47,81]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function _(g,d,v){const A=g.getProxy(C.MainContext.MainThreadQuickOpen);class b{constructor(t,o){this._sessions=new Map,this._instances=0,this._workspace=t,this._commands=o}showQuickPick(t,o,f=n.CancellationToken.None){this._onDidSelectItem=void 0;const u=Promise.resolve(t),w=++this._instances,P=A.$show(w,{title:o?.title,placeHolder:o?.placeHolder,matchOnDescription:o?.matchOnDescription,matchOnDetail:o?.matchOnDetail,ignoreFocusLost:o?.ignoreFocusOut,canPickMany:o?.canPickMany},f),L={},O=P.then(()=>L);return Promise.race([O,u]).then(y=>{if(y!==L)return u.then(z=>{const M=[];for(let B=0;B<z.length;B++){const V=z[B];typeof V=="string"?M.push({label:V,handle:B}):V.kind===S.QuickPickItemKind.Separator?M.push({type:"separator",label:V.label}):M.push({label:V.label,description:V.description,detail:V.detail,picked:V.picked,alwaysShow:V.alwaysShow,handle:B})}return o&&typeof o.onDidSelectItem=="function"&&(this._onDidSelectItem=B=>{o.onDidSelectItem(z[B])}),A.$setItems(w,M),P.then(B=>{if(typeof B=="number")return z[B];if(Array.isArray(B))return B.map(V=>z[V])})})}).then(void 0,y=>{if(!(0,R.isCancellationError)(y))return A.$setError(w,y),Promise.reject(y)})}$onItemSelected(t){this._onDidSelectItem&&this._onDidSelectItem(t)}showInput(t,o=n.CancellationToken.None){return this._validateInput=t?t.validateInput:void 0,A.$input(t,typeof this._validateInput=="function",o).then(void 0,f=>{if(!(0,R.isCancellationError)(f))return Promise.reject(f)})}$validateInput(t){return this._validateInput?(0,h.asPromise)(()=>this._validateInput(t)):Promise.resolve(void 0)}async showWorkspaceFolderPick(t,o=n.CancellationToken.None){const f=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[t]);if(!f)return;const u=await this._workspace.getWorkspaceFolders2();if(!!u)return u.find(w=>w.uri.toString()===f.uri.toString())}createQuickPick(t){const o=new l(t,()=>this._sessions.delete(o._id));return this._sessions.set(o._id,o),o}createInputBox(t){const o=new i(t,()=>this._sessions.delete(o._id));return this._sessions.set(o._id,o),o}$onDidChangeValue(t,o){const f=this._sessions.get(t);f&&f._fireDidChangeValue(o)}$onDidAccept(t){const o=this._sessions.get(t);o&&o._fireDidAccept()}$onDidChangeActive(t,o){const f=this._sessions.get(t);f instanceof l&&f._fireDidChangeActive(o)}$onDidChangeSelection(t,o){const f=this._sessions.get(t);f instanceof l&&f._fireDidChangeSelection(o)}$onDidTriggerButton(t,o){const f=this._sessions.get(t);f&&f._fireDidTriggerButton(o)}$onDidTriggerItemButton(t,o,f){const u=this._sessions.get(t);u instanceof l&&u._fireDidTriggerItemButton(o,f)}$onDidHide(t){const o=this._sessions.get(t);o&&o._fireDidHide()}}class a{constructor(t,o){this._extensionId=t,this._onDidDispose=o,this._id=l._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new I.Emitter,this._onDidChangeValueEmitter=new I.Emitter,this._onDidTriggerButtonEmitter=new I.Emitter,this._onDidHideEmitter=new I.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(t){this._title=t,this.update({title:t})}get step(){return this._steps}set step(t){this._steps=t,this.update({step:t})}get totalSteps(){return this._totalSteps}set totalSteps(t){this._totalSteps=t,this.update({totalSteps:t})}get enabled(){return this._enabled}set enabled(t){this._enabled=t,this.update({enabled:t})}get busy(){return this._busy}set busy(t){this._busy=t,this.update({busy:t})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(t){this._ignoreFocusOut=t,this.update({ignoreFocusOut:t})}get value(){return this._value}set value(t){this._value=t,this.update({value:t})}get placeholder(){return this._placeholder}set placeholder(t){this._placeholder=t,this.update({placeholder:t})}get buttons(){return this._buttons}set buttons(t){this._buttons=t.slice(),this._handlesToButtons.clear(),t.forEach((o,f)=>{const u=o===S.QuickInputButtons.Back?-1:f;this._handlesToButtons.set(u,o)}),this.update({buttons:t.map((o,f)=>({...E(o),tooltip:o.tooltip,handle:o===S.QuickInputButtons.Back?-1:f}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(t){this._value=t,this._onDidChangeValueEmitter.fire(t)}_fireDidTriggerButton(t){const o=this._handlesToButtons.get(t);o&&this._onDidTriggerButtonEmitter.fire(o)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),A.$dispose(this._id))}update(t){if(!this._disposed){for(const o of Object.keys(t)){const f=t[o];this._pendingUpdate[o]=f===void 0?null:f}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){A.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}a._nextId=1;function c(r){if(r instanceof S.ThemeIcon)return{id:r.id};const t=s(r),o=m(r);return{dark:typeof t=="string"?k.URI.file(t):t,light:typeof o=="string"?k.URI.file(o):o}}function m(r){return typeof r=="object"&&"light"in r?r.light:r}function s(r){return typeof r=="object"&&"dark"in r?r.dark:r}function E(r){const t=c(r.iconPath);let o,f;return"id"in t?f=p.ThemeIcon.asClassName(t):o=t,{iconPath:o,iconClass:f}}class l extends a{constructor(t,o){super(t.identifier,o);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new I.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new I.Emitter,this._onDidTriggerItemButtonEmitter=new I.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(t){this._items=t.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),t.forEach((f,u)=>{this._handlesToItems.set(u,f),this._itemsToHandles.set(f,u)});const o=[];for(let f=0;f<t.length;f++){const u=t[f];u.kind===S.QuickPickItemKind.Separator?o.push({type:"separator",label:u.label}):o.push({handle:f,label:u.label,description:u.description,detail:u.detail,picked:u.picked,alwaysShow:u.alwaysShow,buttons:u.buttons?.map((w,P)=>({...E(w),tooltip:w.tooltip,handle:P}))})}this.update({items:o})}get canSelectMany(){return this._canSelectMany}set canSelectMany(t){this._canSelectMany=t,this.update({canSelectMany:t})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(t){this._matchOnDescription=t,this.update({matchOnDescription:t})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(t){this._matchOnDetail=t,this.update({matchOnDetail:t})}get sortByLabel(){return this._sortByLabel}set sortByLabel(t){this._sortByLabel=t,this.update({sortByLabel:t})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(t){this._keepScrollPosition=t,this.update({keepScrollPosition:t})}get activeItems(){return this._activeItems}set activeItems(t){this._activeItems=t.filter(o=>this._itemsToHandles.has(o)),this.update({activeItems:this._activeItems.map(o=>this._itemsToHandles.get(o))})}get selectedItems(){return this._selectedItems}set selectedItems(t){this._selectedItems=t.filter(o=>this._itemsToHandles.has(o)),this.update({selectedItems:this._selectedItems.map(o=>this._itemsToHandles.get(o))})}_fireDidChangeActive(t){const o=(0,F.coalesce)(t.map(f=>this._handlesToItems.get(f)));this._activeItems=o,this._onDidChangeActiveEmitter.fire(o)}_fireDidChangeSelection(t){const o=(0,F.coalesce)(t.map(f=>this._handlesToItems.get(f)));this._selectedItems=o,this._onDidChangeSelectionEmitter.fire(o)}_fireDidTriggerItemButton(t,o){const f=this._handlesToItems.get(t);if(!f||!f.buttons||!f.buttons.length)return;const u=f.buttons[o];u&&this._onDidTriggerItemButtonEmitter.fire({button:u,item:f})}}class i extends a{constructor(t,o){super(t,o);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(t){this._password=t,this.update({password:t})}get prompt(){return this._prompt}set prompt(t){this._prompt=t,this.update({prompt:t})}get validationMessage(){return this._validationMessage}set validationMessage(t){this._validationMessage=t,this.update({validationMessage:t,severity:t?D.default.Error:D.default.Ignore})}}return new b(d,v)}e.createExtHostQuickOpen=_});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,h,n,I){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?I.call(ee,h):I?I.value=h:e.set(ee,h),h},Pe=this&&this.__classPrivateFieldGet||function(ee,e,h,n){if(h==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!n:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?n:h==="a"?n.call(ee):n?n.value:e.get(ee)};define(ve[249],we([1,0,2,3,56,6,15,5,18,97,11,27,81,14,30]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_,g){"use strict";var d,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function A(f){if(f)return typeof f.iconPath=="string"?h.URI.file(f.iconPath):h.URI.isUri(f.iconPath)||p.ThemeIcon.isThemeIcon(f.iconPath)?f.iconPath:void 0}function b(f,u){if(!f.iconPath&&!u.iconPath)return 0;if(f.iconPath){if(!u.iconPath)return 1}else return-1;const w=typeof f.iconPath=="string"?f.iconPath:h.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id,P=typeof u.iconPath=="string"?u.iconPath:h.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id;return(0,R.comparePaths)(w,P)}function a(f,u){let w=0;if(f.strikeThrough!==u.strikeThrough)return f.strikeThrough?1:-1;if(f.faded!==u.faded)return f.faded?1:-1;if(f.tooltip!==u.tooltip)return(f.tooltip||"").localeCompare(u.tooltip||"");if(w=b(f,u),w!==0)return w;if(f.light&&u.light)w=b(f.light,u.light);else{if(f.light)return 1;if(u.light)return-1}if(w!==0)return w;if(f.dark&&u.dark)w=b(f.dark,u.dark);else{if(f.dark)return 1;if(u.dark)return-1}return w}function c(f,u){if(f.command!==u.command)return f.command<u.command?-1:1;if(f.title!==u.title)return f.title<u.title?-1:1;if(f.tooltip!==u.tooltip){if(f.tooltip!==void 0&&u.tooltip!==void 0)return f.tooltip<u.tooltip?-1:1;if(f.tooltip!==void 0)return 1;if(u.tooltip!==void 0)return-1}if(f.arguments===u.arguments)return 0;if(f.arguments)if(u.arguments){if(f.arguments.length!==u.arguments.length)return f.arguments.length-u.arguments.length}else return 1;else return-1;for(let w=0;w<f.arguments.length;w++){const P=f.arguments[w],L=u.arguments[w];if(P!==L)return P<L?-1:1}return 0}function m(f,u){let w=(0,R.comparePaths)(f.resourceUri.fsPath,u.resourceUri.fsPath,!0);if(w!==0)return w;if(f.command&&u.command)w=c(f.command,u.command);else{if(f.command)return 1;if(u.command)return-1}if(w!==0)return w;if(f.decorations&&u.decorations)w=a(f.decorations,u.decorations);else{if(f.decorations)return 1;if(u.decorations)return-1}return w}function s(f,u){for(let w=0;w<f.length;w++)if(f[w]!==u[w])return!1;return!0}function E(f,u){return f.command===u.command&&f.title===u.title&&f.tooltip===u.tooltip&&(f.arguments&&u.arguments?s(f.arguments,u.arguments):f.arguments===u.arguments)}function l(f,u){return(0,S.equals)(f,u,E)}class i{constructor(u,w,P){this._extension=u,this._sourceControlHandle=P,d.set(this,void 0),this._value="",this._onDidChange=new n.Emitter,this._placeholder="",this._visible=!0,Xe(this,d,w,"f")}get value(){return this._value}set value(u){u=u??"",Pe(this,d,"f").$setInputBoxValue(this._sourceControlHandle,u),this.updateValue(u)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(u){Pe(this,d,"f").$setInputBoxPlaceholder(this._sourceControlHandle,u),this._placeholder=u}get validateInput(){return(0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(u){if((0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),u&&typeof u!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=u,Pe(this,d,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!u)}get visible(){return this._visible}set visible(u){u=!!u,this._visible!==u&&(this._visible=u,Pe(this,d,"f").$setInputBoxVisibility(this._sourceControlHandle,u))}showValidationMessage(u,w){(0,g.checkProposedApiEnabled)(this._extension,"scmValidation"),Pe(this,d,"f").$showValidationMessage(this._sourceControlHandle,u,w)}$onInputBoxValueChange(u){this.updateValue(u)}updateValue(u){this._value=u,this._onDidChange.fire(u)}}e.ExtHostSCMInputBox=i,d=new WeakMap;class r{constructor(u,w,P,L,O){this._proxy=u,this._commands=w,this._sourceControlHandle=P,this._id=L,this._label=O,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new n.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(u){this._label=u,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,u)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(u){this._hideWhenEmpty=u,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(u){this._resourceStates=[...u],this._onDidUpdateResourceStates.fire()}getResourceState(u){return this._resourceStatesMap.get(u)}$executeResourceCommand(u,w){const P=this._resourceStatesCommandsMap.get(u);return P?(0,C.asPromise)(()=>this._commands.executeCommand(P.command,...P.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const u=[...this._resourceStates].sort(m),P=(0,S.sortedDiff)(this._resourceSnapshot,u,m).map(y=>{const z=y.toInsert.map(M=>{const B=this._resourceHandlePool++;this._resourceStatesMap.set(B,M);const V=M.resourceUri;let Y;if(M.command)if(M.command.command==="vscode.open"||M.command.command==="vscode.diff"){const se=new T.DisposableStore;Y=this._commands.converter.toInternal(M.command,se),this._resourceStatesDisposablesMap.set(B,se)}else this._resourceStatesCommandsMap.set(B,M.command);const H=A(M.decorations),q=M.decorations&&A(M.decorations.light)||H,K=M.decorations&&A(M.decorations.dark)||H,G=[q,K],ie=M.decorations&&M.decorations.tooltip||"",oe=M.decorations&&!!M.decorations.strikeThrough,ue=M.decorations&&!!M.decorations.faded,Z=M.contextValue||"";return{rawResource:[B,V,G,ie,oe,ue,Z,Y],handle:B}});return{start:y.start,deleteCount:y.deleteCount,toInsert:z}}),L=P.map(({start:y,deleteCount:z,toInsert:M})=>[y,z,M.map(B=>B.rawResource)]),O=P.reverse();for(const{start:y,deleteCount:z,toInsert:M}of O){const B=M.map(Y=>Y.handle),V=this._handlesSnapshot.splice(y,z,...B);for(const Y of V)this._resourceStatesMap.delete(Y),this._resourceStatesCommandsMap.delete(Y),this._resourceStatesDisposablesMap.get(Y)?.dispose(),this._resourceStatesDisposablesMap.delete(Y)}return this._resourceSnapshot=u,L}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class t{constructor(u,w,P,L,O,y){this._extension=u,this._commands=P,this._id=L,this._label=O,this._rootUri=y,v.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new T.MutableDisposable,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new n.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Xe(this,v,w,"f"),this._inputBox=new i(u,Pe(this,v,"f"),this.handle),Pe(this,v,"f").$registerSourceControl(this.handle,L,O,y)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(u){this._count!==u&&(this._count=u,Pe(this,v,"f").$updateSourceControl(this.handle,{count:u}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(u){this._quickDiffProvider=u,Pe(this,v,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!u})}get commitTemplate(){return this._commitTemplate}set commitTemplate(u){u!==this._commitTemplate&&(this._commitTemplate=u,Pe(this,v,"f").$updateSourceControl(this.handle,{commitTemplate:u}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(u){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=u;const w=this._commands.converter.toInternal(u,this._acceptInputDisposables.value);Pe(this,v,"f").$updateSourceControl(this.handle,{acceptInputCommand:w})}get actionButton(){return(0,g.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(u){(0,g.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new T.DisposableStore,this._actionButton=u;const w=u!==void 0?{command:this._commands.converter.toInternal(u.command,this._actionButtonDisposables.value),description:u.description}:void 0;Pe(this,v,"f").$updateSourceControl(this.handle,{actionButton:w??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(u){if(this._statusBarCommands&&u&&l(this._statusBarCommands,u))return;this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=u;const w=(u||[]).map(P=>this._commands.converter.toInternal(P,this._statusBarDisposables.value));Pe(this,v,"f").$updateSourceControl(this.handle,{statusBarCommands:w})}get selected(){return this._selected}createResourceGroup(u,w){const P=new r(Pe(this,v,"f"),this._commands,this.handle,u,w),L=n.Event.once(P.onDidDispose)(()=>this.createdResourceGroups.delete(P));return this.createdResourceGroups.set(P,L),this.eventuallyAddResourceGroups(),P}eventuallyAddResourceGroups(){const u=[],w=[];for(const[P,L]of this.createdResourceGroups){L.dispose();const O=P.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(P),this.eventuallyUpdateResourceStates()});n.Event.once(P.onDidDispose)(()=>{this.updatedResourceGroups.delete(P),O.dispose(),this._groups.delete(P.handle),Pe(this,v,"f").$unregisterGroup(this.handle,P.handle)}),u.push([P.handle,P.id,P.label,P.features]);const y=P._takeResourceStateSnapshot();y.length>0&&w.push([P.handle,y]),this._groups.set(P.handle,P)}Pe(this,v,"f").$registerGroups(this.handle,u,w),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const u=[];this.updatedResourceGroups.forEach(w=>{const P=w._takeResourceStateSnapshot();P.length!==0&&u.push([w.handle,P])}),u.length>0&&Pe(this,v,"f").$spliceResourceStates(this.handle,u),this.updatedResourceGroups.clear()}getResourceGroup(u){return this._groups.get(u)}setSelectionState(u){this._selected=u,this._onDidChangeSelection.fire(u)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(u=>u.dispose()),Pe(this,v,"f").$unregisterSourceControl(this.handle)}}v=new WeakMap,t._handlePool=0,Be([(0,I.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),Be([(0,I.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let o=class Vi{constructor(u,w,P){this._commands=w,this.logService=P,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new n.Emitter,this._proxy=u.getProxy(k.MainContext.MainThreadSCM),this._telemetry=u.getProxy(k.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:L=>{if(L&&L.$mid===3){const O=this._sourceControls.get(L.sourceControlHandle);if(!O)return L;const y=O.getResourceGroup(L.groupHandle);return y?y.getResourceState(L.handle):L}else if(L&&L.$mid===4){const O=this._sourceControls.get(L.sourceControlHandle);return O?O.getResourceGroup(L.groupHandle):L}else if(L&&L.$mid===5){const O=this._sourceControls.get(L.handle);return O||L}return L}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(u,w,P,L){this.logService.trace("ExtHostSCM#createSourceControl",u.identifier.value,w,P,L),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:u.identifier.value});const O=Vi._handlePool++,y=new t(u,this._proxy,this._commands,w,P,L);this._sourceControls.set(O,y);const z=this._sourceControlsByExtension.get(D.ExtensionIdentifier.toKey(u.identifier))||[];return z.push(y),this._sourceControlsByExtension.set(D.ExtensionIdentifier.toKey(u.identifier),z),y}getLastInputBox(u){this.logService.trace("ExtHostSCM#getLastInputBox",u.identifier.value);const w=this._sourceControlsByExtension.get(D.ExtensionIdentifier.toKey(u.identifier)),P=w&&w[w.length-1];return P&&P.inputBox}$provideOriginalResource(u,w,P){const L=h.URI.revive(w);this.logService.trace("ExtHostSCM#$provideOriginalResource",u,L.toString());const O=this._sourceControls.get(u);return!O||!O.quickDiffProvider||!O.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,C.asPromise)(()=>O.quickDiffProvider.provideOriginalResource(L,P)).then(y=>y||null)}$onInputBoxValueChange(u,w){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",u);const P=this._sourceControls.get(u);return P&&P.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(u,w,P,L){this.logService.trace("ExtHostSCM#$executeResourceCommand",u,w,P);const O=this._sourceControls.get(u);if(!O)return Promise.resolve(void 0);const y=O.getResourceGroup(w);return y?y.$executeResourceCommand(P,L):Promise.resolve(void 0)}$validateInput(u,w,P){this.logService.trace("ExtHostSCM#$validateInput",u);const L=this._sourceControls.get(u);return!L||!L.inputBox.validateInput?Promise.resolve(void 0):(0,C.asPromise)(()=>L.inputBox.validateInput(w,P)).then(O=>{if(!O)return Promise.resolve(void 0);const y=_.MarkdownString.fromStrict(O.message);return y?Promise.resolve([y,O.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(u){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",u),u!==void 0&&this._sourceControls.get(u)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=u,Promise.resolve(void 0)}};o._handlePool=0,o=Be([Fe(2,F.ILogService)],o),e.ExtHostSCM=o});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,h,n,I){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?I.call(ee,h):I?I.value=h:e.set(ee,h),h},Pe=this&&this.__classPrivateFieldGet||function(ee,e,h,n){if(h==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!n:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?n:h==="a"?n.call(ee):n?n.value:e.get(ee)};define(ve[250],we([1,0,7,5,169,6,14,13]),function(ee,e,h,n,I,T,C,k){"use strict";var S,R;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class F{constructor(g,d,v,A,b=h.StatusBarAlignment.Left,a){S.set(this,void 0),R.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,Xe(this,S,g,"f"),Xe(this,R,d,"f"),this._entryId=F.ID_GEN++,this._extension=v,this._id=A,this._alignment=b,this._priority=this.validatePriority(a)}validatePriority(g){if(!!(0,k.isNumber)(g))return g===Number.POSITIVE_INFINITY?Number.MAX_VALUE:g===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:g}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(g){this._text=g,this.update()}set name(g){this._name=g,this.update()}set tooltip(g){this._tooltip=g,this.update()}set color(g){this._color=g,this.update()}set backgroundColor(g){g&&!F.ALLOWED_BACKGROUND_COLORS.has(g.id)&&(g=void 0),this._backgroundColor=g,this.update()}set command(g){this._command?.fromApi!==g&&(this._internalCommandRegistration.clear(),typeof g=="string"?this._command={fromApi:g,internal:Pe(this,R,"f").toInternal({title:"",command:g},this._internalCommandRegistration)}:g?this._command={fromApi:g,internal:Pe(this,R,"f").toInternal(g,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(g){this._accessibilityInformation=g,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Pe(this,S,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let g;this._extension?this._id?g=`${this._extension.identifier.value}.${this._id}`:g=this._extension.identifier.value:g=this._id;let d;this._name?d=this._name:d=(0,I.localize)(0,null,this._extension.displayName||this._extension.name);let v=this._color;this._backgroundColor&&(v=F.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const A=C.MarkdownString.fromStrict(this._tooltip);Pe(this,S,"f").$setEntry(this._entryId,g,d,this._text,A,this._command?.internal,v,this._backgroundColor,this._alignment===h.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=F,S=new WeakMap,R=new WeakMap,F.ID_GEN=0,F.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new h.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new h.ThemeColor("statusBarItem.warningForeground")]]);class D{constructor(g){this._messages=[],this._item=g.createStatusBarEntry(void 0,"status.extensionMessage",h.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,I.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(g){const d={message:g};return this._messages.unshift(d),this._update(),new h.Disposable(()=>{const v=this._messages.indexOf(d);v>=0&&(this._messages.splice(v,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class p{constructor(g,d){this._proxy=g.getProxy(n.MainContext.MainThreadStatusBar),this._commands=d,this._statusMessage=new D(this)}createStatusBarEntry(g,d,v,A){return new F(this._proxy,this._commands,g,d,v,A)}setStatusBarMessage(g,d){const v=this._statusMessage.setMessage(g);let A;return typeof d=="number"?A=setTimeout(()=>v.dispose(),d):typeof d!="undefined"&&d.then(()=>v.dispose(),()=>v.dispose()),new h.Disposable(()=>{v.dispose(),clearTimeout(A)})}}e.ExtHostStatusBar=p}),define(ve[87],we([1,0,5,3,4]),function(ee,e,h,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(k){this._onDidChangeStorage=new n.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(h.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,S){this._proxy.$registerExtensionStorageKeysToSync(k,S)}initializeExtensionStorage(k,S,R){return this._proxy.$initializeExtensionStorage(k,S).then(F=>F||R)}setValue(k,S,R){return this._proxy.$setValue(k,S,R)}$acceptValue(k,S,R){this._onDidChangeStorage.fire({shared:k,key:S,value:R})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(ve[66],we([1,0,4,26,11,65,2]),function(ee,e,h,n,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,h.createDecorator)("IExtensionStoragePaths");let k=class{constructor(R,F,D){this._logService=F,this._extHostFileSystem=D,this._workspace=R.workspace??void 0,this._environment=R.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(p=>this._value=p)}async _getWorkspaceStorageURI(R){return C.URI.joinPath(this._environment.workspaceStorageHome,R)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const R=this._workspace.id,F=await this._getWorkspaceStorageURI(R);try{return await this._extHostFileSystem.value.stat(F),this._logService.trace("[ExtHostStorage] storage dir already exists",F),F}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",F),await this._extHostFileSystem.value.createDirectory(F),await this._extHostFileSystem.value.writeFile(C.URI.joinPath(F,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:C.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),F}catch(D){this._logService.error("[ExtHostStorage]",D);return}}workspaceValue(R){if(this._value)return C.URI.joinPath(this._value,R.identifier.value)}globalValue(R){return C.URI.joinPath(this._environment.globalStorageHome,R.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=Be([Fe(0,n.IExtHostInitDataService),Fe(1,I.ILogService),Fe(2,T.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(ve[34],we([1,0,3,5,4,2,16,6,7,170,17,216,21,33,196,81,13,15]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_,g,d,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class b{constructor(t,o,f,u){this._proxy=t,this._id=o,this._creationOptions=f,this._name=u,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(P=>this._pidPromiseComplete=P);const w=this;this.value={get name(){return w._name||""},get processId(){return w._pidPromise},get creationOptions(){return w._creationOptions},get exitStatus(){return w._exitStatus},get state(){return w._state},sendText(P,L=!0){w._checkDisposed(),w._proxy.$sendText(w._id,P,L)},show(P){w._checkDisposed(),w._proxy.$show(w._id,P)},hide(){w._checkDisposed(),w._proxy.$hide(w._id)},dispose(){w._disposed||(w._disposed=!0,w._proxy.$dispose(w._id))},get dimensions(){if(!(w._cols===void 0||w._rows===void 0))return{columns:w._cols,rows:w._rows}}}}async create(t,o){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:t.name,shellPath:(0,v.withNullAsUndefined)(t.shellPath),shellArgs:(0,v.withNullAsUndefined)(t.shellArgs),cwd:(0,v.withNullAsUndefined)(t.cwd),env:(0,v.withNullAsUndefined)(t.env),icon:(0,v.withNullAsUndefined)(l(t.iconPath)),color:d.ThemeColor.isThemeColor(t.color)?t.color.id:void 0,initialText:(0,v.withNullAsUndefined)(t.message),strictEnv:(0,v.withNullAsUndefined)(t.strictEnv),hideFromUser:(0,v.withNullAsUndefined)(t.hideFromUser),isFeatureTerminal:(0,v.withNullAsUndefined)(o?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,v.withNullAsUndefined)(o?.useShellEnvironment),location:o?.location||this._serializeParentTerminal(t.location,o?.resolvedExtHostIdentifier),isTransient:(0,v.withNullAsUndefined)(t.isTransient)})}async createExtensionTerminal(t,o,f,u){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:f,color:d.ThemeColor.isThemeColor(u)?u.id:void 0,location:this._serializeParentTerminal(t,o),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(t,o){return typeof t=="object"?"parentTerminal"in t&&t.parentTerminal&&o?{parentTerminal:o}:"viewColumn"in t?{viewColumn:t.viewColumn,preserveFocus:t.preserveFocus}:void 0:t}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,o){return t===this._cols&&o===this._rows||t===0||o===0?!1:(this._cols=t,this._rows=o,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(o=>{o!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=b;class a{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new h.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new h.Emitter,this._onDidChangeProperty=new h.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new h.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(t){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${t}`)}updateProperty(t,o){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${t}, value: ${o}`)}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput?.(t)}resize(t,o){this._pty.setDimensions?.({columns:t,rows:o})}async processBinary(t){}acknowledgeDataEvent(t){}async setUnicodeVersion(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(o=>this._onProcessData.fire(o)),this._pty.onDidClose?.((o=void 0)=>{this._onProcessExit.fire(o===void 0?void 0:o)}),this._pty.onDidOverrideDimensions?.(o=>{o&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:o.columns,rows:o.rows}})}),this._pty.onDidChangeName?.(o=>{this._onDidChangeProperty.fire({type:"title",value:o})}),this._pty.open(t||void 0),t&&this._pty.setDimensions?.(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=a;let c=1,m=class extends k.Disposable{constructor(t,o){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new h.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new h.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new h.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new h.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new h.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=o.getProxy(n.MainContext.MainThreadTerminalService),this._bufferer=new g.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new h.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[f,u]of this._terminalProcesses)u.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(t,o){const f=new b(this._proxy,(0,_.generateUuid)(),t,t.name),u=new a(t.pty);return f.createExtensionTerminal(t.location,this._serializeParentTerminal(t,o).resolvedExtHostIdentifier,l(t.iconPath),i(t.color)).then(w=>{const P=this._setupExtHostProcessListeners(w,u);this._terminalProcessDisposables[w]=P}),this._terminals.push(f),f.value}_serializeParentTerminal(t,o){if(o=o||{},t.location&&typeof t.location=="object"&&"parentTerminal"in t.location){const f=t.location.parentTerminal;if(f){const u=this._terminals.find(w=>w.value===f);u&&(o.resolvedExtHostIdentifier=u._id)}}else t.location&&typeof t.location!="object"?o.location=t.location:o.location&&typeof o.location=="object"&&"splitActiveTerminal"in o.location&&(o.location={splitActiveTerminal:!0});return o}attachPtyToTerminal(t,o){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const u=new a(o),w=this._setupExtHostProcessListeners(t,u);this._terminalProcessDisposables[t]=w}async $acceptActiveTerminalChanged(t){const o=this._activeTerminal;if(t===null){this._activeTerminal=void 0,o!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const f=this._getTerminalById(t);f&&(this._activeTerminal=f,o!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,o){const f=this._getTerminalById(t);f&&this._onDidWriteTerminalData.fire({terminal:f.value,data:o})}async $acceptTerminalDimensions(t,o,f){const u=this._getTerminalById(t);u&&u.setDimensions(o,f)&&this._onDidChangeTerminalDimensions.fire({terminal:u.value,dimensions:u.value.dimensions})}async $acceptTerminalMaximumDimensions(t,o,f){this._terminalProcesses.get(t)?.resize(o,f)}async $acceptTerminalTitleChange(t,o){const f=this._getTerminalById(t);f&&(f.name=o)}async $acceptTerminalClosed(t,o){const f=this._getTerminalObjectIndexById(this._terminals,t);if(f!==null){const u=this._terminals.splice(f,1)[0];u.setExitCode(o),this._onDidCloseTerminal.fire(u.value)}}$acceptTerminalOpened(t,o,f,u){if(o){const L=this._getTerminalObjectIndexById(this._terminals,o);if(L!==null){this._terminals[L]._id=t,this._onDidOpenTerminal.fire(this.terminals[L]),this._terminals[L].isOpen=!0;return}}const w={name:u.name,shellPath:u.executable,shellArgs:u.args,cwd:typeof u.cwd=="string"?u.cwd:T.URI.revive(u.cwd),env:u.env,hideFromUser:u.hideFromUser},P=new b(this._proxy,t,w,f);this._terminals.push(P),this._onDidOpenTerminal.fire(P.value),P.isOpen=!0}async $acceptTerminalProcessId(t,o){const f=this._getTerminalById(t);f&&f._setProcessId(o)}async $startExtensionTerminal(t,o){const f=this._getTerminalById(t);if(!f)return{message:(0,R.localize)(0,null,t)};f.isOpen||await new Promise(w=>{const P=this.onDidOpenTerminal(async L=>{L===f.value&&(P.dispose(),w())})});const u=this._terminalProcesses.get(t);u?u.startSendingEvents(o):this._extensionTerminalAwaitingStart[t]={initialDimensions:o}}_setupExtHostProcessListeners(t,o){const f=new k.DisposableStore;f.add(o.onProcessReady(w=>this._proxy.$sendProcessReady(t,w.pid,w.cwd))),f.add(o.onDidChangeProperty(w=>this._proxy.$sendProcessProperty(t,w))),this._bufferer.startBuffering(t,o.onProcessData),f.add(o.onProcessExit(w=>this._onProcessExit(t,w))),this._terminalProcesses.set(t,o);const u=this._extensionTerminalAwaitingStart[t];return u&&o instanceof a&&(o.startSendingEvents(u.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),f}$acceptProcessAckDataEvent(t,o){this._terminalProcesses.get(t)?.acknowledgeDataEvent(o)}$acceptProcessInput(t,o){this._terminalProcesses.get(t)?.input(o)}$acceptTerminalInteraction(t){const o=this._getTerminalById(t);o?.setInteractedWith()&&this._onDidChangeTerminalState.fire(o.value)}$acceptProcessResize(t,o,f){try{this._terminalProcesses.get(t)?.resize(o,f)}catch(u){if(u.code!=="EPIPE"&&u.code!=="ERR_IPC_CHANNEL_CLOSED")throw u}}$acceptProcessShutdown(t,o){this._terminalProcesses.get(t)?.shutdown(o)}$acceptProcessRequestInitialCwd(t){this._terminalProcesses.get(t)?.getInitialCwd().then(o=>this._proxy.$sendProcessProperty(t,{type:"initialCwd",value:o}))}$acceptProcessRequestCwd(t){this._terminalProcesses.get(t)?.getCwd().then(o=>this._proxy.$sendProcessProperty(t,{type:"cwd",value:o}))}$acceptProcessRequestLatency(t){return Promise.resolve(t)}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(t,o,f){if(this._profileProviders.has(o))throw new Error(`Terminal profile provider "${o}" already registered`);return this._profileProviders.set(o,f),this._proxy.$registerProfileProvider(o,t.identifier.value),new S.Disposable(()=>{this._profileProviders.delete(o),this._proxy.$unregisterProfileProvider(o)})}async $createContributedProfileTerminal(t,o){const f=new p.CancellationTokenSource().token;let u=await this._profileProviders.get(t)?.provideTerminalProfile(f);if(!f.isCancellationRequested){if(u&&!("options"in u)&&(u={options:u}),!u||!("options"in u))throw new Error(`No terminal profile options provided for id "${t}"`);if("pty"in u.options){this.createExtensionTerminal(u.options,o);return}this.createTerminalFromOptions(u.options,o)}}async $provideLinks(t,o){const f=this._getTerminalById(t);if(!f)return[];this._terminalLinkCache.delete(t);const u=this._terminalLinkCancellationSource.get(t);u&&u.dispose(!0);const w=new p.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,w);const P=[],L={terminal:f.value,line:o},O=[];for(const M of this._linkProviders)O.push(A.Promises.withAsyncBody(async B=>{w.token.onCancellationRequested(()=>B({provider:M,links:[]}));const V=await M.provideTerminalLinks(L,w.token)||[];w.token.isCancellationRequested||B({provider:M,links:V})}));const y=await Promise.all(O);if(w.token.isCancellationRequested)return[];const z=new Map;for(const M of y)M&&M.links.length>0&&P.push(...M.links.map(B=>{const V={id:c++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return z.set(V.id,{provider:M.provider,link:B}),V}));return this._terminalLinkCache.set(t,z),P}$activateLink(t,o){const f=this._terminalLinkCache.get(t)?.get(o);!f||f.provider.handleTerminalLink(f.link)}_onProcessExit(t,o){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const f=this._terminalProcessDisposables[t];f&&(f.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,o)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,o){const f=this._getTerminalObjectIndexById(t,o);return f!==null?t[f]:null}_getTerminalObjectIndexById(t,o){let f=null;return t.some((u,w)=>u._id===o?(f=w,!0):!1),f}getEnvironmentVariableCollection(t){let o=this._environmentVariableCollections.get(t.identifier.value);return o||(o=new s,this._setEnvironmentVariableCollection(t.identifier.value,o)),o}_syncEnvironmentVariableCollection(t,o){const f=(0,D.serializeEnvironmentVariableCollection)(o.map);this._proxy.$setEnvironmentVariableCollection(t,o.persistent,f.length===0?void 0:f)}$initEnvironmentVariableCollections(t){t.forEach(o=>{const f=o[0],u=new s(o[1]);this._setEnvironmentVariableCollection(f,u)})}$acceptDefaultProfile(t,o){this._defaultProfile=t,this._defaultAutomationProfile=o}_setEnvironmentVariableCollection(t,o){this._environmentVariableCollections.set(t,o),o.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,o)})}};m=Be([Fe(1,C.IExtHostRpcService)],m),e.BaseExtHostTerminalService=m;class s{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new h.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,o){this._setIfDiffers(t,{value:o,type:S.EnvironmentVariableMutatorType.Replace})}append(t,o){this._setIfDiffers(t,{value:o,type:S.EnvironmentVariableMutatorType.Append})}prepend(t,o){this._setIfDiffers(t,{value:o,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,o){const f=this.map.get(t);(!f||f.value!==o.value||f.type!==o.type)&&(this.map.set(t,o),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,o){this.map.forEach((f,u)=>t.call(o,u,f,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=s;let E=class extends m{constructor(t){super(!1,t)}createTerminal(t,o,f){throw new F.NotSupportedError}createTerminalFromOptions(t,o){throw new F.NotSupportedError}};E=Be([Fe(0,C.IExtHostRpcService)],E),e.WorkerExtHostTerminalService=E;function l(r){if(!(!r||typeof r=="string"))return"id"in r?{id:r.id,color:r.color}:r}function i(r){return d.ThemeColor.isThemeColor(r)?r:void 0}});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,h,n,I){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?I.call(ee,h):I?I.value=h:e.set(ee,h),h},Pe=this&&this.__classPrivateFieldGet||function(ee,e,h,n){if(h==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!n:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?n:h==="a"?n.call(ee):n?n.value:e.get(ee)};define(ve[251],we([1,0,18,22,21,3,74,57,6,25,13,33,5,16,62,14,7,222,84,85]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_,g,d,v,A,b,a){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let m=class{constructor(L,O){this.resultsChangedEmitter=new T.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=L.getProxy(p.MainContext.MainThreadTesting),this.observer=new f(this.proxy),this.runTracker=new E(this.proxy),O.registerArgumentProcessor({processArgument:y=>y?.$mid===13?d.TestItem.toItemFromContext(y):y})}createTestController(L,O,y){if(this.controllers.has(L))throw new Error(`Attempt to insert a duplicate controller with ID "${L}"`);const z=new S.DisposableStore,M=z.add(new A.SingleUseTestCollection(L));M.root.label=O;const B=new Map,V=this.proxy,Y={items:M.root.children,get label(){return O},set label(q){O=q,M.root.label=q,V.$updateController(L,{label:O})},get refreshHandler(){return y},set refreshHandler(q){y=q,V.$updateController(L,{canRefresh:!!q})},get id(){return L},createRunProfile:(q,K,G,ie,oe)=>{let ue=(0,k.hash)(q);for(;B.has(ue);)ue++;const Z=new u(this.proxy,L,ue,q,K,G,ie,oe);return B.set(ue,Z),Z},createTestItem(q,K,G){return new g.TestItemImpl(L,q,K,G)},createTestRun:(q,K,G=!0)=>this.runTracker.createTestRun(L,M,q,K,G),set resolveHandler(q){M.resolveHandler=q},get resolveHandler(){return M.resolveHandler},dispose:()=>{z.dispose()}};V.$registerTestController(L,O,!!y),z.add((0,S.toDisposable)(()=>V.$unregisterTestController(L)));const H={controller:Y,collection:M,profiles:B};return this.controllers.set(L,H),z.add((0,S.toDisposable)(()=>this.controllers.delete(L))),z.add(M.onDidGenerateDiff(q=>V.$publishDiff(L,q.map(b.TestsDiffOp.serialize)))),Y}createTestObserver(){return this.observer.checkout()}async runTests(L,O=I.CancellationToken.None){const y=l(L);if(!y)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.controllers.get(y.controllerId);if(!z)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:L.include?.map(M=>M.id)??[z.collection.root.id],profileGroup:w[y.kind],profileId:y.profileId,controllerId:y.controllerId}],exclude:L.exclude?.map(M=>M.id)},O)}$provideFileCoverage(L,O,y){return(0,h.mapFind)(this.runTracker.trackers,M=>M.id===L?M.getCoverage(O):void 0)?.provideFileCoverage(y)??Promise.resolve([])}$resolveFileCoverage(L,O,y,z){return(0,h.mapFind)(this.runTracker.trackers,B=>B.id===L?B.getCoverage(O):void 0)?.resolveFileCoverage(y,z)??Promise.resolve([])}$configureRunProfile(L,O){this.controllers.get(L)?.profiles.get(O)?.configureHandler?.()}async $refreshTests(L,O){await this.controllers.get(L)?.controller.refreshHandler?.(O)}$publishTestResults(L){this.results=Object.freeze(L.map(O=>(0,R.deepFreeze)(d.TestResults.to(O))).concat(this.results).sort((O,y)=>y.completedAt-O.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(L,O){const y=this.controllers.get(a.TestId.fromString(L).controllerId)?.collection;y&&(await y.expand(L,O<0?1/0:O),y.flushDiff())}$acceptDiff(L){this.observer.applyDiff(L.map(b.TestsDiffOp.deserialize))}async $runControllerTests(L,O){const y=this.controllers.get(L.controllerId);if(!y)return;const{collection:z,profiles:M}=y,B=M.get(L.profileId);if(!B)return;const V=L.testIds.map(K=>z.tree.get(K)).filter(F.isDefined),Y=L.excludeExtIds.map(K=>y.collection.tree.get(K)).filter(F.isDefined).filter(K=>V.some(G=>G.fullId.compare(K.fullId)===2));if(!V.length)return;const H=new v.TestRunRequest(V.some(K=>K.actual instanceof g.TestItemRootImpl)?void 0:V.map(K=>K.actual),Y.map(K=>K.actual),B),q=this.runTracker.prepareForMainThreadTestRun(H,i.fromInternal(L,y.collection),O);try{await B.runHandler(H,O)}finally{q.isRunning&&!O.isCancellationRequested&&await T.Event.toPromise(q.onEnd),q.dispose()}}$cancelExtensionTestRun(L){L===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(L)}};m=Be([Fe(0,_.IExtHostRpcService)],m),e.ExtHostTesting=m;class s extends S.Disposable{constructor(L,O,y){super();this.dto=L,this.proxy=O,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new T.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new I.CancellationTokenSource(y)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:z}of this.tasks.values())z.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(L){return this.tasks.get(L)?.coverage}createRun(L){const O=this.dto.id,y=this.dto.controllerId,z=(0,D.generateUuid)(),M=new r(this.proxy,O,z),B=q=>(K,...G)=>{if(Y){console.warn(`Setting the state of test "${K.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(K)||(this.ensureTestIsKnown(K),q(K,...G))},V=(q,K)=>{const G=K instanceof Array?K.map(d.TestMessage.from):[d.TestMessage.from(K)];if(q.uri&&q.range){const ie={range:d.Range.from(q.range),uri:q.uri};for(const oe of G)oe.location=oe.location||ie}this.proxy.$appendTestMessagesInRun(O,z,a.TestId.fromExtHostTestItem(q,y).toString(),G)};let Y=!1;const H={isPersisted:this.dto.isPersisted,token:this.cts.token,name:L,get coverageProvider(){return M.coverageProvider},set coverageProvider(q){M.coverageProvider=q},enqueued:B(q=>{this.proxy.$updateTestStateInRun(O,z,a.TestId.fromExtHostTestItem(q,y).toString(),1)}),skipped:B(q=>{this.proxy.$updateTestStateInRun(O,z,a.TestId.fromExtHostTestItem(q,y).toString(),5)}),started:B(q=>{this.proxy.$updateTestStateInRun(O,z,a.TestId.fromExtHostTestItem(q,y).toString(),2)}),errored:B((q,K,G)=>{V(q,K),this.proxy.$updateTestStateInRun(O,z,a.TestId.fromExtHostTestItem(q,y).toString(),6,G)}),failed:B((q,K,G)=>{V(q,K),this.proxy.$updateTestStateInRun(O,z,a.TestId.fromExtHostTestItem(q,y).toString(),4,G)}),passed:B((q,K)=>{this.proxy.$updateTestStateInRun(O,z,a.TestId.fromExtHostTestItem(q,this.dto.controllerId).toString(),3,K)}),appendOutput:(q,K,G)=>{Y||(G&&(this.dto.isIncluded(G)?this.ensureTestIsKnown(G):G=void 0),this.proxy.$appendOutputToRun(O,z,n.VSBuffer.fromString(q),K&&d.location.from(K),G&&a.TestId.fromExtHostTestItem(G,y).toString()))},end:()=>{Y||(Y=!0,this.proxy.$finishedTestRunTask(O,z),this.tasks.delete(z),this.isRunning||this.dispose())}};return this.tasks.set(z,{run:H,coverage:M}),this.proxy.$startedTestRunTask(O,{id:z,name:L,running:!0}),H}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(L){if(!(L instanceof g.TestItemImpl))throw new g.InvalidTestItemError(L.id);if(this.sharedTestIds.has(a.TestId.fromExtHostTestItem(L,this.dto.controllerId).toString()))return;const O=[],y=this.dto.colllection.root;for(;;){const z=d.TestItem.from(L);if(O.unshift(z),this.sharedTestIds.has(z.extId)||(this.sharedTestIds.add(z.extId),L===y))break;L=L.parent||y}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,O)}}class E{constructor(L){this.proxy=L,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(L,O,y){return this.getTracker(L,O,y)}cancelRunById(L){for(const O of this.tracked.values())if(O.id===L){O.dispose();return}}cancelAllRuns(){for(const L of this.tracked.values())L.dispose()}createTestRun(L,O,y,z,M){const B=this.tracked.get(y);if(B)return B.createRun(z);const V=i.fromPublic(L,O,y,M),Y=l(y);this.proxy.$startedExtensionTestRun({controllerId:L,profile:Y&&{group:w[Y.kind],id:Y.profileId},exclude:y.exclude?.map(q=>q.id)??[],id:V.id,include:y.include?.map(q=>q.id)??[O.root.id],persist:M});const H=this.getTracker(y,V);return H.onEnd(()=>this.proxy.$finishedExtensionTestRun(V.id)),H.createRun(z)}getTracker(L,O,y){const z=new s(O,this.proxy,y);return this.tracked.set(L,z),z.onEnd(()=>this.tracked.delete(L)),z}}e.TestRunCoordinator=E;const l=P=>{if(!!P.profile){if(!(P.profile instanceof u))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return P.profile}};class i{constructor(L,O,y,z,M,B){this.controllerId=L,this.id=O,this.isPersisted=M,this.colllection=B,this.includePrefix=y.map(V=>V+"\0"),this.excludePrefix=z.map(V=>V+"\0")}static fromPublic(L,O,y,z){return new i(L,(0,D.generateUuid)(),y.include?.map(M=>a.TestId.fromExtHostTestItem(M,L).toString())??[L],y.exclude?.map(M=>a.TestId.fromExtHostTestItem(M,L).toString())??[],z,O)}static fromInternal(L,O){return new i(L.controllerId,L.runId,L.testIds,L.excludeExtIds,!0,O)}isIncluded(L){const O=a.TestId.fromExtHostTestItem(L,this.controllerId).toString()+"\0";for(const y of this.excludePrefix)if(O===y||O.startsWith(y))return!1;for(const y of this.includePrefix)if(O===y||O.startsWith(y))return!0;return!1}}e.TestRunDto=i;class r{constructor(L,O,y){this.proxy=L,this.runId=O,this.taskId=y}set coverageProvider(L){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!L||(this._coverageProvider=L,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(L){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(L))());try{return(await this.fileCoverage)?.map(d.TestCoverage.fromFile)??[]}catch(O){throw this.fileCoverage=void 0,O}}async resolveFileCoverage(L,O){const y=await this.fileCoverage;let z=y?.[L];return!this._coverageProvider||!y||!z?[]:(z.detailedCoverage||(z=y[L]=await this._coverageProvider.resolveFileCoverage?.(z,O)??z),z.detailedCoverage?.map(d.TestCoverage.fromDetailed)??[])}}class t extends b.IncrementalChangeCollector{constructor(L){super();this.emitter=L,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(L){this.added.add(L)}update(L){Object.assign(L.revived,d.TestItem.toPlain(L.item)),this.added.has(L)||this.updated.add(L)}remove(L){if(this.added.has(L)){this.added.delete(L);return}if(this.updated.delete(L),L.parent&&this.alreadyRemoved.has(L.parent)){this.alreadyRemoved.add(L.item.extId);return}this.removed.add(L)}getChangeEvent(){const{added:L,updated:O,removed:y}=this;return{get added(){return[...L].map(z=>z.revived)},get updated(){return[...O].map(z=>z.revived)},get removed(){return[...y].map(z=>z.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class o extends b.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new T.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(L){return this.items.get(L)}getMirroredTestDataByReference(L){return this.items.get(L.id)}createItem(L,O){return{...L,revived:d.TestItem.toPlain(L.item),depth:O?O.depth+1:0,children:new Set}}createChangeCollector(){return new t(this.changeEmitter)}}e.MirroredTestCollection=o;class f{constructor(L){this.proxy=L}checkout(){this.current||(this.current=this.createObserverData());const L=this.current;return L.observers++,{onDidChangeTest:L.tests.onDidChangeTests,get tests(){return[...L.tests.rootTests].map(O=>O.revived)},dispose:(0,C.once)(()=>{--L.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(L){return this.current?.tests.getMirroredTestDataByReference(L)}applyDiff(L){this.current?.tests.apply(L)}createObserverData(){const L=new o;return this.proxy.$subscribeToDiffs(),{observers:0,tests:L}}}class u{constructor(L,O,y,z,M,B,V=!1,Y=void 0){this.controllerId=O,this.profileId=y,this._label=z,this.kind=M,this.runHandler=B,this._isDefault=V,this._tag=Y,c.set(this,void 0),Xe(this,c,L,"f");const H=w[M];if(typeof H!="number")throw new Error(`Unknown TestRunProfile.group ${M}`);Pe(this,c,"f").$publishTestRunProfile({profileId:y,controllerId:O,tag:Y?d.TestTag.namespace(this.controllerId,Y.id):null,label:z,group:H,isDefault:V,hasConfigurationHandler:!1})}get label(){return this._label}set label(L){L!==this._label&&(this._label=L,Pe(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:L}))}get isDefault(){return this._isDefault}set isDefault(L){L!==this._isDefault&&(this._isDefault=L,Pe(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:L}))}get tag(){return this._tag}set tag(L){L?.id!==this._tag?.id&&(this._tag=L,Pe(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:L?d.TestTag.namespace(this.controllerId,L.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(L){L!==this._configureHandler&&(this._configureHandler=L,Pe(this,c,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!L}))}dispose(){Pe(this,c,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=u,c=new WeakMap;const w={[v.TestRunProfileKind.Coverage]:8,[v.TestRunProfileKind.Debug]:4,[v.TestRunProfileKind.Run]:2}}),define(ve[252],we([1,0,3,18,5,131,14,7]),function(ee,e,h,n,I,T,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(F,D){this._extHostDocumentsAndEditors=D,this._onDidChangeTextEditorSelection=new h.Emitter,this._onDidChangeTextEditorOptions=new h.Emitter,this._onDidChangeTextEditorVisibleRanges=new h.Emitter,this._onDidChangeTextEditorViewColumn=new h.Emitter,this._onDidChangeActiveTextEditor=new h.Emitter,this._onDidChangeVisibleTextEditors=new h.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=F.getProxy(I.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(p=>this._onDidChangeVisibleTextEditors.fire(p)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(p=>this._onDidChangeActiveTextEditor.fire(p))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(F){const D=this._extHostDocumentsAndEditors.allEditors();return F?D:D.map(p=>p.value)}async showTextDocument(F,D,p){let _;typeof D=="number"?_={position:C.ViewColumn.from(D),preserveFocus:p}:typeof D=="object"?_={position:C.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:typeof D.selection=="object"?C.Range.from(D.selection):void 0,pinned:typeof D.preview=="boolean"?!D.preview:void 0}:_={preserveFocus:!1};const g=await this._proxy.$tryShowTextDocument(F.uri,_),d=g&&this._extHostDocumentsAndEditors.getEditor(g);if(d)return d.value;throw g?new Error(`Could NOT open editor for "${F.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${F.uri.toString()}".`)}createTextEditorDecorationType(F,D){return new T.TextEditorDecorationType(this._proxy,F,D).value}$acceptEditorPropertiesChanged(F,D){const p=this._extHostDocumentsAndEditors.getEditor(F);if(!p)throw new Error("unknown text editor");if(D.options&&p._acceptOptions(D.options),D.selections){const _=D.selections.selections.map(C.Selection.to);p._acceptSelections(_)}if(D.visibleRanges){const _=n.coalesce(D.visibleRanges.map(C.Range.to));p._acceptVisibleRanges(_)}if(D.options&&this._onDidChangeTextEditorOptions.fire({textEditor:p.value,options:{...D.options,lineNumbers:C.TextEditorLineNumbersStyle.to(D.options.lineNumbers)}}),D.selections){const _=k.TextEditorSelectionChangeKind.fromValue(D.selections.source),g=D.selections.selections.map(C.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:p.value,selections:g,kind:_})}if(D.visibleRanges){const _=n.coalesce(D.visibleRanges.map(C.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:p.value,visibleRanges:_})}}$acceptEditorPositionData(F){for(const D in F){const p=this._extHostDocumentsAndEditors.getEditor(D);if(!p)throw new Error("Unknown text editor");const _=C.ViewColumn.to(F[D]);p.value.viewColumn!==_&&(p._acceptViewColumn(_),this._onDidChangeTextEditorViewColumn.fire({textEditor:p.value,viewColumn:_}))}}getDiffInformation(F){return Promise.resolve(this._proxy.$getDiffInformation(F))}}e.ExtHostEditors=S}),define(ve[253],we([1,0,2,4,5,6,7,14,13]),function(ee,e,h,n,I,T,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,n.createDecorator)("IExtHostTimeline");class R{constructor(p,_){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=p.getProxy(I.MainContext.MainThreadTimeline),_.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===11){const d=g.uri===void 0?void 0:h.URI.revive(g.uri);return this._itemsBySourceAndUriMap.get(g.source)?.get(F(d))?.get(g.handle)}return g}})}async $getTimeline(p,_,g,d,v){return this._providers.get(p)?.provideTimeline(h.URI.revive(_),g,d,v)}registerTimelineProvider(p,_,g,d){const v=new T.DisposableStore,A=this.convertTimelineItem(_.id,d,v).bind(this);let b;_.onDidChange&&(b=_.onDidChange(c=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...c,id:_.id}),this));const a=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({..._,scheme:p,onDidChange:void 0,async provideTimeline(c,m,s,E){E?.resetCache&&(v.clear(),a.get(_.id)?.clear());const l=await _.provideTimeline(c,m,s);if(l==null)return;const i=A(c,E);return{...l,source:_.id,items:l.items.map(i)}},dispose(){for(const c of a.values())c.get(_.id)?.clear();b?.dispose(),v.dispose()}})}convertTimelineItem(p,_,g){return(d,v)=>{let A;if(v?.cacheResults){let b=this._itemsBySourceAndUriMap.get(p);b===void 0&&(b=new Map,this._itemsBySourceAndUriMap.set(p,b));const a=F(d);A=b.get(a),A===void 0&&(A=new Map,b.set(a,A))}return b=>{const{iconPath:a,...c}=b,m=`${p}|${b.id??b.timestamp}`;A?.set(m,b);let s,E,l;b.iconPath&&(a instanceof C.ThemeIcon?l={id:a.id,color:a.color}:h.URI.isUri(a)?(s=a,E=a):{light:s,dark:E}=a);let i;return C.MarkdownString.isMarkdownString(c.detail)?i=k.MarkdownString.from(c.detail):(0,S.isString)(c.detail)&&(i=c.detail),{...c,id:c.id??void 0,handle:m,source:p,command:b.command?_.toInternal(b.command,g):void 0,icon:s,iconDark:E,themeIcon:l,detail:i,accessibilityInformation:b.accessibilityInformation}}}}registerTimelineProviderCore(p){if(this._providers.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this._proxy.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this._providers.set(p.id,p),(0,T.toDisposable)(()=>{for(const g of this._itemsBySourceAndUriMap.values())g.get(p.id)?.clear();this._providers.delete(p.id),this._proxy.$unregisterTimelineProvider(p.id),p.dispose()})}}e.ExtHostTimeline=R;function F(D){return D?.toString()}}),define(ve[254],we([1,0,6,10,2,5]),function(ee,e,h,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class C{constructor(S){this._openers=new Map,this._proxy=S.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,R,F,D){if(this._openers.has(R))throw new Error(`Opener with id '${R}' already registered`);const p=D.schemes.find(_=>!C.supportedSchemes.has(_));if(p)throw new Error(`Scheme '${p}' is not supported. Only http and https are currently supported.`);return this._openers.set(R,F),this._proxy.$registerUriOpener(R,D.schemes,S,D.label),(0,h.toDisposable)(()=>{this._openers.delete(R),this._proxy.$unregisterUriOpener(R)})}async $canOpenUri(S,R,F){const D=this._openers.get(S);if(!D)throw new Error(`Unknown opener with id: ${S}`);const p=I.URI.revive(R);return D.canOpenExternalUri(p,F)}async $openUri(S,R,F){const D=this._openers.get(S);if(!D)throw new Error(`Unknown opener id: '${S}'`);return D.openExternalUri(I.URI.revive(R.resolvedUri),{sourceUri:I.URI.revive(R.sourceUri)},F)}}e.ExtHostUriOpeners=C,C.supportedSchemes=new Set([n.Schemas.http,n.Schemas.https])}),define(ve[255],we([1,0,5,2,6,17,27]),function(ee,e,h,n,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(R){this.handles=new Set,this.handlers=new Map,this._proxy=R.getProxy(h.MainContext.MainThreadUrls)}registerUriHandler(R,F){if(this.handles.has(C.ExtensionIdentifier.toKey(R)))throw new Error(`Protocol handler already registered for extension ${R}`);const D=k.HandlePool++;return this.handles.add(C.ExtensionIdentifier.toKey(R)),this.handlers.set(D,F),this._proxy.$registerUriHandler(D,R),(0,I.toDisposable)(()=>{this.handles.delete(C.ExtensionIdentifier.toKey(R)),this.handlers.delete(D),this._proxy.$unregisterUriHandler(D)})}$handleExternalUri(R,F){const D=this.handlers.get(R);if(!D)return Promise.resolve(void 0);try{D.handleUri(n.URI.revive(F))}catch(p){(0,T.onUnexpectedError)(p)}return Promise.resolve(void 0)}async createAppUri(R){return n.URI.revive(await this._proxy.$createAppUri(R))}}e.ExtHostUrls=k,k.HandlePool=0});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,h,n,I){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?I.call(ee,h):I?I.value=h:e.set(ee,h),h},Pe=this&&this.__classPrivateFieldGet||function(ee,e,h,n){if(h==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!n:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?n:h==="a"?n.call(ee):n?n.value:e.get(ee)};define(ve[67],we([1,0,3,10,2,183,204,83,5]),function(ee,e,h,n,I,T,C,k,S){"use strict";var R,F,D,p,_,g,d,v,A,b,a,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class m{constructor(f,u,w,P,L,O,y){R.set(this,void 0),F.set(this,void 0),D.set(this,void 0),p.set(this,void 0),_.set(this,void 0),g.set(this,void 0),d.set(this,""),v.set(this,void 0),A.set(this,!1),b.set(this,!1),a.set(this,!1),this._onMessageEmitter=new h.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new h.Emitter),this._onDidDispose=Pe(this,c,"f").event,Xe(this,R,f,"f"),Xe(this,F,u,"f"),Xe(this,v,w,"f"),Xe(this,p,P,"f"),Xe(this,_,L,"f"),Xe(this,g,O,"f"),Xe(this,a,s(O),"f"),Xe(this,D,y,"f")}dispose(){Xe(this,A,!0,"f"),Pe(this,c,"f").fire(),Pe(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(f){return Xe(this,b,!0,"f"),(0,k.asWebviewUri)(f,Pe(this,p,"f").remote)}get cspSource(){const f=Pe(this,g,"f").extensionLocation;if(f.scheme===n.Schemas.https||f.scheme===n.Schemas.http){let u=f.toString();return u.endsWith("/")||(u+="/"),u+" "+k.webviewGenericCspSource}return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Pe(this,d,"f")}set html(f){this.assertNotDisposed(),Pe(this,d,"f")!==f&&(Xe(this,d,f,"f"),!Pe(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(f)&&(Xe(this,b,!0,"f"),Pe(this,D,"f").report("Webview vscode-resource: uris",Pe(this,g,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Pe(this,F,"f").$setHtml(Pe(this,R,"f"),f))}get options(){return this.assertNotDisposed(),Pe(this,v,"f")}set options(f){this.assertNotDisposed(),Pe(this,F,"f").$setOptions(Pe(this,R,"f"),i(Pe(this,g,"f"),Pe(this,_,"f"),f)),Xe(this,v,f,"f")}async postMessage(f){if(Pe(this,A,"f"))return!1;const u=(0,C.serializeWebviewMessage)(f,{serializeBuffersForPostMessage:Pe(this,a,"f")});return Pe(this,F,"f").$postMessage(Pe(this,R,"f"),u.message,...u.buffers)}assertNotDisposed(){if(Pe(this,A,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=m,R=new WeakMap,F=new WeakMap,D=new WeakMap,p=new WeakMap,_=new WeakMap,g=new WeakMap,d=new WeakMap,v=new WeakMap,A=new WeakMap,b=new WeakMap,a=new WeakMap,c=new WeakMap;function s(o){try{const f=(0,T.normalizeVersion)((0,T.parseVersion)(o.engines.vscode));return!!f&&f.majorBase>=1&&f.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=s;class E{constructor(f,u,w,P,L){this.initData=u,this.workspace=w,this._logService=P,this._deprecationService=L,this._webviews=new Map,this._webviewProxy=f.getProxy(S.MainContext.MainThreadWebviews)}$onMessage(f,u,w){const P=this.getWebview(f);if(P){const{message:L}=(0,C.deserializeWebviewMessage)(u,w.value);P._onMessageEmitter.fire(L)}}$onMissingCsp(f,u){this._logService.warn(`${u} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(f,u,w){const P=new m(f,this._webviewProxy,r(u),this.initData,this.workspace,w,this._deprecationService);return this._webviews.set(f,P),P._onDidDispose(()=>{this._webviews.delete(f)}),P}deleteWebview(f){this._webviews.delete(f)}getWebview(f){return this._webviews.get(f)}}e.ExtHostWebviews=E;function l(o){return{id:o.identifier,location:o.extensionLocation}}e.toExtensionData=l;function i(o,f,u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots||t(o,f)}}e.serializeWebviewOptions=i;function r(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(f=>I.URI.from(f))}}e.reviveOptions=r;function t(o,f){return[...(f?.getWorkspaceFolders()||[]).map(u=>u.uri),o.extensionLocation]}}),define(ve[256],we([1,0,21,57,6,10,23,2,14,67,82,5,7]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class _{constructor(s,E){this.document=s,this._storagePath=E,this._backupCounter=1,this._edits=new F.Cache("custom documents")}addEdit(s){return this._edits.add([s])}async undo(s,E){await this.getEdit(s).undo(),E||this.disposeBackup()}async redo(s,E){await this.getEdit(s).redo(),E||this.disposeBackup()}disposeEdits(s){for(const E of s)this._edits.delete(E)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const s=c(this.document.uri)+this._backupCounter++;return(0,C.joinPath)(this._storagePath,s)}updateBackup(s){this._backup?.delete(),this._backup=s}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(s){const E=this._edits.get(s,0);if(!E)throw new Error("No edit found");return E}}class g{constructor(){this._documents=new Map}get(s,E){return this._documents.get(this.key(s,E))}add(s,E,l){const i=this.key(s,E.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${s} resource:${E.uri}`);const r=new _(E,l);return this._documents.set(i,r),r}delete(s,E){const l=this.key(s,E.uri);this._documents.delete(l)}key(s,E){return`${s}@@@${E}`}}var d;(function(m){m[m.Text=0]="Text",m[m.Custom=1]="Custom"})(d||(d={}));class v{constructor(){this._providers=new Map}addTextProvider(s,E,l){return this.add(0,s,E,l)}addCustomProvider(s,E,l){return this.add(1,s,E,l)}get(s){return this._providers.get(s)}add(s,E,l,i){if(this._providers.has(E))throw new Error(`Provider for viewType:${E} already registered`);return this._providers.set(E,{type:s,extension:l,provider:i}),new p.Disposable(()=>this._providers.delete(E))}}class A{constructor(s,E,l,i,r){this._extHostDocuments=E,this._extensionStoragePaths=l,this._extHostWebview=i,this._extHostWebviewPanels=r,this._editorProviders=new v,this._documents=new g,this._proxy=s.getProxy(D.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(s,E,l,i){const r=new I.DisposableStore;return b(l)?(r.add(this._editorProviders.addTextProvider(E,s,l)),this._proxy.$registerTextEditorProvider((0,R.toExtensionData)(s),E,i.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,R.shouldSerializeBuffersForPostMessage)(s))):(r.add(this._editorProviders.addCustomProvider(E,s,l)),this.supportEditing(l)&&r.add(l.onDidChangeCustomDocument(t=>{const o=this.getCustomDocumentEntry(E,t.document.uri);if(a(t)){const f=o.addEdit(t);this._proxy.$onDidEdit(t.document.uri,E,f,t.label)}else this._proxy.$onContentChange(t.document.uri,E)})),this._proxy.$registerCustomEditorProvider((0,R.toExtensionData)(s),E,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,R.shouldSerializeBuffersForPostMessage)(s))),p.Disposable.from(r,new p.Disposable(()=>{this._proxy.$unregisterEditorProvider(E)}))}async $createCustomDocument(s,E,l,i,r){const t=this._editorProviders.get(E);if(!t)throw new Error(`No provider found for '${E}'`);if(t.type!==1)throw new Error(`Invalid provide type for '${E}'`);const o=k.URI.revive(s),f=await t.provider.openCustomDocument(o,{backupId:l,untitledDocumentData:i?.buffer},r);let u;return this.supportEditing(t.provider)&&this._extensionStoragePaths&&(u=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension)),this._documents.add(E,f,u),{editable:this.supportEditing(t.provider)}}async $disposeCustomDocument(s,E){const l=this._editorProviders.get(E);if(!l)throw new Error(`No provider found for '${E}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${E}'`);const i=k.URI.revive(s),{document:r}=this.getCustomDocumentEntry(E,i);this._documents.delete(E,r),r.dispose()}async $resolveWebviewEditor(s,E,l,i,r,t){const o=this._editorProviders.get(l);if(!o)throw new Error(`No provider found for '${l}'`);const f=S.ViewColumn.to(r),u=this._extHostWebview.createNewWebview(E,i.webviewOptions,o.extension),w=this._extHostWebviewPanels.createNewWebviewPanel(E,l,i.title,f,i.panelOptions,u),P=k.URI.revive(s);switch(o.type){case 1:{const{document:L}=this.getCustomDocumentEntry(l,P);return o.provider.resolveCustomEditor(L,w,t)}case 0:{const L=this._extHostDocuments.getDocument(P);return o.provider.resolveCustomTextEditor(L,w,t)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,E,l){this.getCustomDocumentEntry(E,s).disposeEdits(l)}async $onMoveCustomEditor(s,E,l){const i=this._editorProviders.get(l);if(!i)throw new Error(`No provider found for '${l}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const r=this._extHostWebviewPanels.getWebviewPanel(s);if(!r)throw new Error("No webview found");const t=k.URI.revive(E),o=this._extHostDocuments.getDocument(t);await i.provider.moveCustomTextEditor(o,r,h.CancellationToken.None)}async $undo(s,E,l,i){return this.getCustomDocumentEntry(E,s).undo(l,i)}async $redo(s,E,l,i){return this.getCustomDocumentEntry(E,s).redo(l,i)}async $revert(s,E,l){const i=this.getCustomDocumentEntry(E,s);await this.getCustomEditorProvider(E).revertCustomDocument(i.document,l),i.disposeBackup()}async $onSave(s,E,l){const i=this.getCustomDocumentEntry(E,s);await this.getCustomEditorProvider(E).saveCustomDocument(i.document,l),i.disposeBackup()}async $onSaveAs(s,E,l,i){const r=this.getCustomDocumentEntry(E,s);return this.getCustomEditorProvider(E).saveCustomDocumentAs(r.document,k.URI.revive(l),i)}async $backup(s,E,l){const i=this.getCustomDocumentEntry(E,s),t=await this.getCustomEditorProvider(E).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},l);return i.updateBackup(t),t.id}getCustomDocumentEntry(s,E){const l=this._documents.get(s,k.URI.revive(E));if(!l)throw new Error("No custom document found");return l}getCustomEditorProvider(s){const l=this._editorProviders.get(s)?.provider;if(!l||!this.supportEditing(l))throw new Error("Custom document is not editable");return l}supportEditing(s){return!!s.onDidChangeCustomDocument}}e.ExtHostCustomEditors=A;function b(m){return typeof m.resolveCustomTextEditor=="function"}function a(m){return typeof m.undo=="function"&&typeof m.redo=="function"}function c(m){const s=m.scheme===T.Schemas.file||m.scheme===T.Schemas.untitled?m.fsPath:m.toString();return(0,n.hash)(s)+""}});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,h,n,I){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?I.call(ee,h):I?I.value=h:e.set(ee,h),h},Pe=this&&this.__classPrivateFieldGet||function(ee,e,h,n){if(h==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!n:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?n:h==="a"?n.call(ee):n?n.value:e.get(ee)};define(ve[257],we([1,0,3,6,2,33,14,67,5,7]),function(ee,e,h,n,I,T,C,k,S,R){"use strict";var F,D,p,_,g,d,v,A,b,a,c,m,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class E extends n.Disposable{constructor(t,o,f,u,w,P,L){super();F.set(this,void 0),D.set(this,void 0),p.set(this,void 0),_.set(this,void 0),g.set(this,void 0),d.set(this,void 0),v.set(this,void 0),A.set(this,void 0),b.set(this,!0),a.set(this,!0),c.set(this,!1),m.set(this,this._register(new h.Emitter)),this.onDidDispose=Pe(this,m,"f").event,s.set(this,this._register(new h.Emitter)),this.onDidChangeViewState=Pe(this,s,"f").event,Xe(this,F,t,"f"),Xe(this,D,o,"f"),Xe(this,p,f,"f"),Xe(this,g,P,"f"),Xe(this,A,w,"f"),Xe(this,d,u,"f"),Xe(this,_,L,"f")}dispose(){Pe(this,c,"f")||(Xe(this,c,!0,"f"),Pe(this,m,"f").fire(),Pe(this,D,"f").$disposeWebview(Pe(this,F,"f")),Pe(this,_,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Pe(this,_,"f")}get viewType(){return this.assertNotDisposed(),Pe(this,p,"f")}get title(){return this.assertNotDisposed(),Pe(this,d,"f")}set title(t){this.assertNotDisposed(),Pe(this,d,"f")!==t&&(Xe(this,d,t,"f"),Pe(this,D,"f").$setTitle(Pe(this,F,"f"),t))}get iconPath(){return this.assertNotDisposed(),Pe(this,v,"f")}set iconPath(t){this.assertNotDisposed(),Pe(this,v,"f")!==t&&(Xe(this,v,t,"f"),Pe(this,D,"f").$setIconPath(Pe(this,F,"f"),I.URI.isUri(t)?{light:t,dark:t}:t))}get options(){return Pe(this,g,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Pe(this,A,"f")=="number"&&Pe(this,A,"f")<0))return Pe(this,A,"f")}get active(){return this.assertNotDisposed(),Pe(this,a,"f")}get visible(){return this.assertNotDisposed(),Pe(this,b,"f")}_updateViewState(t){Pe(this,c,"f")||(this.active!==t.active||this.visible!==t.visible||this.viewColumn!==t.viewColumn)&&(Xe(this,a,t.active,"f"),Xe(this,b,t.visible,"f"),Xe(this,A,t.viewColumn,"f"),Pe(this,s,"f").fire({webviewPanel:this}))}reveal(t,o){this.assertNotDisposed(),Pe(this,D,"f").$reveal(Pe(this,F,"f"),{viewColumn:typeof t=="undefined"?void 0:C.ViewColumn.from(t),preserveFocus:!!o})}assertNotDisposed(){if(Pe(this,c,"f"))throw new Error("Webview is disposed")}}F=new WeakMap,D=new WeakMap,p=new WeakMap,_=new WeakMap,g=new WeakMap,d=new WeakMap,v=new WeakMap,A=new WeakMap,b=new WeakMap,a=new WeakMap,c=new WeakMap,m=new WeakMap,s=new WeakMap;class l{constructor(t,o,f){this.webviews=o,this.workspace=f,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=t.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(t,o,f,u,w={}){const P=typeof u=="object"?u.viewColumn:u,L={viewColumn:C.ViewColumn.from(P),preserveFocus:typeof u=="object"&&!!u.preserveFocus},O=(0,k.shouldSerializeBuffersForPostMessage)(t),y=l.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(t),y,o,{title:f,panelOptions:i(w),webviewOptions:(0,k.serializeWebviewOptions)(t,this.workspace,w),serializeBuffersForPostMessage:O},L);const z=this.webviews.createNewWebview(y,w,t);return this.createNewWebviewPanel(y,o,f,P,w,z)}$onDidChangeWebviewPanelViewStates(t){const o=Object.keys(t);o.sort((f,u)=>{const w=t[f],P=t[u];return w.active?1:P.active?-1:+w.visible-+P.visible});for(const f of o){const u=this.getWebviewPanel(f);if(!u)continue;const w=t[f];u._updateViewState({active:w.active,visible:w.visible,viewColumn:C.ViewColumn.to(w.position)})}}async $onDidDisposeWebviewPanel(t){this.getWebviewPanel(t)?.dispose(),this._webviewPanels.delete(t),this.webviews.deleteWebview(t)}registerWebviewPanelSerializer(t,o,f){if(this._serializers.has(o))throw new Error(`Serializer for '${o}' already registered`);return this._serializers.set(o,{serializer:f,extension:t}),this._proxy.$registerSerializer(o,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(t)}),new R.Disposable(()=>{this._serializers.delete(o),this._proxy.$unregisterSerializer(o)})}async $deserializeWebviewPanel(t,o,f,u){const w=this._serializers.get(o);if(!w)throw new Error(`No serializer found for '${o}'`);const{serializer:P,extension:L}=w,O=this.webviews.createNewWebview(t,f.webviewOptions,L),y=this.createNewWebviewPanel(t,o,f.title,u,f.panelOptions,O);await P.deserializeWebviewPanel(y,f.state)}createNewWebviewPanel(t,o,f,u,w,P){const L=new E(t,this._proxy,o,f,u,w,P);return this._webviewPanels.set(t,L),L}getWebviewPanel(t){return this._webviewPanels.get(t)}}e.ExtHostWebviewPanels=l;function i(r){return{enableFindWidget:r.enableFindWidget,retainContextWhenHidden:r.retainContextWhenHidden}}});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,h,n,I){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?I.call(ee,h):I?I.value=h:e.set(ee,h),h},Pe=this&&this.__classPrivateFieldGet||function(ee,e,h,n){if(h==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!n:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?n:h==="a"?n.call(ee):n?n.value:e.get(ee)};define(ve[258],we([1,0,3,6,67,5,7]),function(ee,e,h,n,I,T,C){"use strict";var k,S,R,F,D,p,_,g,d,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class A extends n.Disposable{constructor(c,m,s,E,l,i){super();k.set(this,void 0),S.set(this,void 0),R.set(this,void 0),F.set(this,void 0),D.set(this,!1),p.set(this,void 0),_.set(this,void 0),g.set(this,void 0),d.set(this,this._register(new h.Emitter)),this.onDidChangeVisibility=Pe(this,d,"f").event,v.set(this,this._register(new h.Emitter)),this.onDidDispose=Pe(this,v,"f").event,Xe(this,R,s,"f"),Xe(this,_,E,"f"),Xe(this,k,c,"f"),Xe(this,S,m,"f"),Xe(this,F,l,"f"),Xe(this,p,i,"f")}dispose(){Pe(this,D,"f")||(Xe(this,D,!0,"f"),Pe(this,v,"f").fire(),Pe(this,F,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Pe(this,_,"f")}set title(c){this.assertNotDisposed(),Pe(this,_,"f")!==c&&(Xe(this,_,c,"f"),Pe(this,S,"f").$setWebviewViewTitle(Pe(this,k,"f"),c))}get description(){return this.assertNotDisposed(),Pe(this,g,"f")}set description(c){this.assertNotDisposed(),Pe(this,g,"f")!==c&&(Xe(this,g,c,"f"),Pe(this,S,"f").$setWebviewViewDescription(Pe(this,k,"f"),c))}get visible(){return Pe(this,p,"f")}get webview(){return Pe(this,F,"f")}get viewType(){return Pe(this,R,"f")}_setVisible(c){c===Pe(this,p,"f")||Pe(this,D,"f")||(Xe(this,p,c,"f"),Pe(this,d,"f").fire())}show(c){this.assertNotDisposed(),Pe(this,S,"f").$show(Pe(this,k,"f"),!!c)}assertNotDisposed(){if(Pe(this,D,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,S=new WeakMap,R=new WeakMap,F=new WeakMap,D=new WeakMap,p=new WeakMap,_=new WeakMap,g=new WeakMap,d=new WeakMap,v=new WeakMap;class b{constructor(c,m){this._extHostWebview=m,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=c.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(c,m,s,E){if(this._viewProviders.has(m))throw new Error(`View provider for '${m}' already registered`);return this._viewProviders.set(m,{provider:s,extension:c}),this._proxy.$registerWebviewViewProvider((0,I.toExtensionData)(c),m,{retainContextWhenHidden:E?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new C.Disposable(()=>{this._viewProviders.delete(m),this._proxy.$unregisterWebviewViewProvider(m)})}async $resolveWebviewView(c,m,s,E,l){const i=this._viewProviders.get(m);if(!i)throw new Error(`No view provider found for '${m}'`);const{provider:r,extension:t}=i,o=this._extHostWebview.createNewWebview(c,{},t),f=new A(c,this._proxy,m,s,o,!0);this._webviewViews.set(c,f),await r.resolveWebviewView(f,{state:E},l)}async $onDidChangeWebviewViewVisibility(c,m){this.getWebviewView(c)._setVisible(m)}async $disposeWebviewView(c){const m=this.getWebviewView(c);this._webviewViews.delete(c),m.dispose(),this._extHostWebview.deleteWebview(c)}getWebviewView(c){const m=this._webviewViews.get(c);if(!m)throw new Error("No webview found");return m}}e.ExtHostWebviewViews=b}),define(ve[136],we([1,0,3,5,2,10,8,4,16]),function(ee,e,h,n,I,T,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let R=class ji{constructor(D){this._onDidChangeWindowState=new h.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=ji.InitialState,this._proxy=D.getProxy(n.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(p=>this.$onDidChangeWindowFocus(p))}get state(){return this._state}$onDidChangeWindowFocus(D){D!==this._state.focused&&(this._state={...this._state,focused:D},this._onDidChangeWindowState.fire(this._state))}openUri(D,p){let _;if(typeof D=="string"){_=D;try{D=I.URI.parse(D)}catch{return Promise.reject(`Invalid uri - '${D}'`)}}return(0,C.isFalsyOrWhitespace)(D.scheme)?Promise.reject("Invalid scheme - cannot be empty"):D.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${D.scheme}'`):this._proxy.$openUri(D,_,p)}async asExternalUri(D,p){if((0,C.isFalsyOrWhitespace)(D.scheme))return Promise.reject("Invalid scheme - cannot be empty");const _=await this._proxy.$asExternalUri(D,p);return I.URI.from(_)}};R.InitialState={focused:!0},R=Be([Fe(0,S.IExtHostRpcService)],R),e.ExtHostWindow=R,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(ve[259],we([1,0,9,60,33,39,6,5,2,16]),function(ee,e,h,n,I,T,C,k,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let F=class extends C.Disposable{constructor(p,_){super();const g=p.getProxy(k.MainContext.MainThreadDownloadService);_.registerCommand(!1,"_workbench.downloadResource",async d=>{const v=S.URI.file((0,h.join)((0,n.tmpdir)(),(0,I.generateUuid)()));return await g.$download(d,v),v})}};F=Be([Fe(0,R.IExtHostRpcService),Fe(1,T.IExtHostCommands)],F),e.ExtHostDownloadService=F}),define(ve[260],we([1,0,134,10,189,33]),function(ee,e,h,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class C extends h.ExtHostLoggerService{doCreateLogger(S,R,F){return S.scheme===n.Schemas.file?new I.SpdLogLogger(F?.name||(0,T.generateUuid)(),S.fsPath,!F?.donotRotate,!!F?.donotUseFormatters,R):super.doCreateLogger(S,R,F)}}e.ExtHostLoggerService=C}),define(ve[261],we([1,0,59,9,2,66,6,10,15,28]),function(ee,e,h,n,I,T,C,k,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class F extends T.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(s){const E=await super._getWorkspaceStorageURI(s);if(E.scheme!==k.Schemas.file)return E;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${E.fsPath}.`),E;const l=E.fsPath;let i=0;do{let r;i===0?r=l:r=/[/\\]$/.test(l)?`${l.substr(0,l.length-1)}-${i}`:`${l}-${i}`,await D(r);const t=n.join(r,"vscode.lock"),o=await d(this._logService,t,!1);if(o)return this._workspaceStorageLock=o,process.on("exit",()=>{o.dispose()}),I.URI.file(r);i++}while(i<10);return E}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=F;async function D(m){try{await R.Promises.stat(m);return}catch{}try{await R.Promises.mkdir(m,{recursive:!0})}catch{}}const p=1e3,_=10*60*1e3;class g extends C.Disposable{constructor(s,E){super();this.logService=s,this.filename=E,this._timer=this._register(new S.IntervalTimer),this._timer.cancelAndSet(async()=>{const l=await v(s,E);(!l||l.pid!==process.pid)&&(s.info(`Lock '${E}': The lock was lost unexpectedly.`),this._timer.cancel());try{await R.Promises.utimes(E,new Date,new Date)}catch(i){s.error(i),s.info(`Lock '${E}': Could not update mtime.`)}},p)}dispose(){super.dispose();try{h.unlinkSync(this.filename)}catch{}}async setWillRelease(s){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${s} ms.`);try{const E={pid:process.pid,willReleaseAt:Date.now()+s};await R.Promises.writeFile(this.filename,JSON.stringify(E),{flag:"w"})}catch(E){this.logService.error(E)}}}async function d(m,s,E){try{const i={pid:process.pid,willReleaseAt:0};await R.Promises.writeFile(s,JSON.stringify(i),{flag:"wx"})}catch(i){m.error(i)}const l=await v(m,s);return!l||l.pid!==process.pid?E?(m.info(`Lock '${s}': Could not acquire lock, giving up.`),null):(m.info(`Lock '${s}': Could not acquire lock, checking if the file is stale.`),a(m,s)):(m.info(`Lock '${s}': Lock acquired.`),new g(m,s))}async function v(m,s){let E;try{E=await R.Promises.readFile(s)}catch(l){return m.error(l),null}try{return JSON.parse(String(E))}catch(l){return m.error(l),null}}async function A(m,s){let E;try{E=await R.Promises.stat(s)}catch(l){return m.error(l),0}return E.mtime.getTime()}function b(m){try{return process.kill(m,0),!0}catch{return!1}}async function a(m,s){const E=await v(m,s);if(!E)return m.info(`Lock '${s}': Could not read pid of lock holder.`),c(m,s);if(E.willReleaseAt){let o=E.willReleaseAt-Date.now();if(o<5e3){for(o>0?m.info(`Lock '${s}': The lockfile is scheduled to be released in ${o} ms.`):m.info(`Lock '${s}': The lockfile is scheduled to have been released.`);o>0;){if(await(0,S.timeout)(Math.min(100,o)),await A(m,s)===0)return c(m,s);o=E.willReleaseAt-Date.now()}return c(m,s)}}if(!b(E.pid))return m.info(`Lock '${s}': The pid ${E.pid} appears to be gone.`),c(m,s);const l=await A(m,s),i=Date.now()-l;if(i<=_)return m.info(`Lock '${s}': The lock does not look stale, elapsed: ${i} ms, giving up.`),null;m.info(`Lock '${s}': The lock looks stale, waiting for 2s.`),await(0,S.timeout)(2e3);const r=await A(m,s),t=Date.now()-r;return t<=_?(m.info(`Lock '${s}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null):(m.info(`Lock '${s}': The lock looks stale even after waiting for 2s.`),c(m,s))}async function c(m,s){m.info(`Lock '${s}': Deleting a stale lock.`);try{await R.Promises.unlink(s)}catch{}return d(m,s,!0)}}),define(ve[262],we([1,0,33,16,34]),function(ee,e,h,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let T=class extends I.BaseExtHostTerminalService{constructor(k){super(!0,k)}createTerminal(k,S,R){return this.createTerminalFromOptions({name:k,shellPath:S,shellArgs:R})}createTerminalFromOptions(k,S){const R=new I.ExtHostTerminal(this._proxy,(0,h.generateUuid)(),k,k.name);return this._terminals.push(R),R.create(k,this._serializeParentTerminal(k,S)),R.value}};T=Be([Fe(0,n.IExtHostRpcService)],T),e.ExtHostTerminalService=T}),define(ve[263],we([1,0,5,16,174,6,26,2,38,23,28,7,12,51,3,123,91,11]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_,g,d,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class b{constructor(f,u,w){this.remoteAddress=f,this.localAddress=u,this._dispose=w,this._onDispose=new g.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function a(o){const f=o.trim().split(`
`),u=[];return f.forEach(P=>{const L=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(P);L&&L.length>=3&&u.push({pid:parseInt(L[1],10),socket:parseInt(L[2],10)})}),u.reduce((P,L)=>(P[L.socket]=L,P),{})}e.getSockets=a;function c(...o){const f=[].concat(...o.map(s));return[...new Map(f.filter(u=>u.st==="0A").map(u=>{const w=u.local_address.split(":");return{socket:parseInt(u.inode,10),ip:m(w[0]),port:parseInt(w[1],16)}}).map(u=>[u.ip+":"+u.port,u])).values()]}e.loadListeningPorts=c;function m(o){let f="";if(o.length===8)for(let u=o.length-2;u>=0;u-=2)f+=parseInt(o.substr(u,2),16),u!==0&&(f+=".");else for(let u=o.length-4;u>=0;u-=4)f+=parseInt(o.substr(u,4),16).toString(16),u!==0&&(f+=":");return f}e.parseIpAddress=m;function s(o){const f=o.trim().split(`
`),u=f.shift().trim().split(/\s+/).filter(P=>P!=="rx_queue"&&P!=="tm->when");return f.map(P=>P.trim().split(/\s+/).reduce((L,O,y)=>(L[u[y]||y]=O,L),{}))}e.loadConnectionTable=s;function E(o){return!!o.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||o.indexOf("out/server-main.js")!==-1||o.indexOf("_productName=VSCode")!==-1}function l(o){const f=o.trim().split(`
`),u=[];return f.forEach(w=>{const P=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(w);P&&P.length>=4&&u.push({pid:parseInt(P[1],10),ppid:parseInt(P[2]),cmd:P[3]})}),u}e.getRootProcesses=l;async function i(o,f,u){const w=u.reduce((L,O)=>(L[O.pid]=O,L),{}),P=[];return o.forEach(({socket:L,ip:O,port:y})=>{const z=f[L]?f[L].pid:void 0,M=z?w[z]?.cmd:void 0;z&&M&&!E(M)&&P.push({host:O,port:y,detail:M,pid:z})}),P}e.findPorts=i;function r(o,f,u){const w=new Map,P=l(f);for(const L of o){const O=u.get(L.port);if(O){w.set(L.port,O);continue}const y=P.find(z=>z.cmd.includes(`${L.port}`));if(y){let z=y,M;do M=P.find(B=>B.ppid===z.pid),M&&(z=M);while(M);w.set(L.port,{host:L.ip,port:L.port,pid:z.pid,detail:z.cmd,ppid:z.ppid})}else w.set(L.port,{host:L.ip,port:L.port,ppid:Number.MAX_VALUE})}return w}e.tryFindRootPorts=r;let t=class extends T.Disposable{constructor(f,u,w){super();this.logService=w,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new g.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=f.getProxy(h.MainContext.MainThreadTunnelService),p.isLinux&&u.remote.isRemote&&u.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(f,u){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${f.identifier.value} called openTunnel API for ${u.remoteAddress.host}:${u.remoteAddress.port}.`);const w=await this._proxy.$openTunnel(u,f.displayName);if(w){const P=new b(w.remoteAddress,w.localAddress,()=>this._proxy.$closeTunnel(w.remoteAddress));return this._register(P),P}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(f){return Math.max(f*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(f,u){const w=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(w,{selector:f,provider:u}),this._proxy.$registerPortsAttributesProvider(f,w),new D.Disposable(()=>{this._portAttributesProviders.delete(w),this._proxy.$unregisterPortsAttributesProvider(w)})}async $providePortAttributes(f,u,w,P,L){const O=[];for(const z of f){const M=this._portAttributesProviders.get(z);if(!M)return[];O.push(...await Promise.all(u.map(async B=>M.provider.providePortAttributes(B,w,P,L))))}const y=O.filter(z=>!!z);return y.length>0?y.map(z=>({autoForwardAction:z.autoForwardAction,port:z.port})):[]}async $registerCandidateFinder(f){if(f&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=f;let u=new v.MovingAverage,w;for(;this._candidateFindingEnabled;){const P=new Date().getTime(),L=(await this.findCandidatePorts()).filter(y=>(0,d.isLocalhost)(y.host)||(0,d.isAllInterfaces)(y.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${L.map(y=>y.port).join(", ")}`);const O=new Date().getTime()-P;u.update(O),(!w||JSON.stringify(w)!==JSON.stringify(L))&&(w=L,await this._proxy.$onFoundNewCandidates(w)),await new Promise(y=>setTimeout(()=>y(),this.calculateDelay(u.value)))}}async setTunnelFactory(f){if(f){if(f.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(f.candidatePortSource),f.showCandidatePort&&(this._showCandidatePort=f.showCandidatePort,this._proxy.$setCandidateFilter()),f.tunnelFactory){this._forwardPortProvider=f.tunnelFactory;let u=f.tunnelFeatures?.privacyOptions??[];f.tunnelFeatures?.public&&u.length===0&&(u=[{id:"private",label:I.localize(0,null),themeIcon:"lock"},{id:"public",label:I.localize(1,null),themeIcon:"eye"}]);const w=f.tunnelFeatures?{elevation:!!f.tunnelFeatures?.elevation,public:!!f.tunnelFeatures?.public,privacyOptions:u}:void 0;this._proxy.$setTunnelProvider(w)}}else this._forwardPortProvider=void 0;return(0,T.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(f,u){if(this._extensionTunnels.has(f.host)){const w=this._extensionTunnels.get(f.host);w.has(f.port)&&(u&&w.get(f.port).disposeListener.dispose(),await w.get(f.port).tunnel.dispose(),w.delete(f.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(f,u){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const w=this._forwardPortProvider(f,u);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),w!==void 0){const P=await w;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(f.remoteAddress.host)||this._extensionTunnels.set(f.remoteAddress.host,new Map);const L=this._register(P.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(P.remoteAddress))));return this._extensionTunnels.get(f.remoteAddress.host).set(f.remoteAddress.port,{tunnel:P,disposeListener:L}),_.TunnelDtoConverter.fromApiTunnel(P)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(f){const u=await Promise.all(f.map(P=>this._showCandidatePort(P.host,P.port,P.detail??""))),w=f.filter((P,L)=>u[L]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${f.map(P=>P.port).join(", ")} to ${w.map(P=>P.port).join(", ")}`),w}async findCandidatePorts(){let f="",u="";try{f=await F.Promises.readFile("/proc/net/tcp","utf8"),u=await F.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const w=c(f,u),P=await new Promise(Y=>{(0,S.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(H,q,K)=>{Y(q)})}),L=a(P),O=await F.Promises.readdir("/proc"),y=[];for(let Y of O)try{const H=Number(Y),q=R.joinPath(k.URI.file("/proc"),Y);if((await F.Promises.stat(q.fsPath)).isDirectory()&&!isNaN(H)){const G=await F.Promises.readlink(R.joinPath(q,"cwd").fsPath),ie=await F.Promises.readFile(R.joinPath(q,"cmdline").fsPath,"utf8");y.push({pid:H,cwd:G,cmd:ie})}}catch{}const z=[],M=w.filter(Y=>{const H=L[Y.socket];return H||z.push(Y),H}),B=i(M,L,y);let V;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${z.length}`),z.length>0){const Y=await new Promise(H=>{(0,S.exec)("ps -F -A -l | grep root",(q,K,G)=>{H(K)})});this._foundRootPorts=r(z,Y,this._foundRootPorts),V=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${V.join(", ")}`)}return B.then(Y=>V?Y.concat(V):Y)}};t=Be([Fe(0,n.IExtHostRpcService),Fe(1,C.IExtHostInitDataService),Fe(2,A.ILogService)],t),e.ExtHostTunnelService=t}),define(ve[264],we([1,0,15,22,21,17,3,6,101,227,52]),function(ee,e,h,n,I,T,C,k,S,R,F){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function p(w,P){try{return JSON.stringify(w,P)}catch{return"null"}}const _="$$ref$$",g={[_]:-1};class d{constructor(P,L){this.jsonString=P,this.referencedBuffers=L}}function v(w,P=null,L=!1){const O=[];return{jsonString:(L?p:JSON.stringify)(w,(z,M)=>{if(typeof M=="undefined")return g;if(typeof M=="object"){if(M instanceof n.VSBuffer){const B=O.push(M)-1;return{[_]:B}}if(P)return P(z,M)}return M}),referencedBuffers:O}}e.stringifyJsonWithBufferRefs=v;function A(w,P,L){return JSON.parse(w,(O,y)=>{if(y){const z=y[_];if(typeof z=="number")return P[z];if(L&&y.$mid===1)return L.transformIncoming(y)}return y})}e.parseJsonAndRestoreBufferRefs=A;function b(w,P){return JSON.stringify(w,P)}function a(w){return w?(P,L)=>L&&L.$mid===1?w.transformOutgoing(L):L:null}var c;(function(w){w[w.LocalSide=0]="LocalSide",w[w.OtherSide=1]="OtherSide"})(c=e.RequestInitiator||(e.RequestInitiator={}));var m;(function(w){w[w.Responsive=0]="Responsive",w[w.Unresponsive=1]="Unresponsive"})(m=e.ResponsiveState||(e.ResponsiveState={}));const s=()=>{},E=Symbol.for("rpcProtocol"),l=Symbol.for("rpcProxy");class i extends k.Disposable{constructor(P,L=null,O=null){super();this[D]=!0,this._onDidChangeResponsiveState=this._register(new C.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=P,this._logger=L,this._uriTransformer=O,this._uriReplacer=a(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let y=0,z=F.ProxyIdentifier.count;y<z;y++)this._locals[y]=null,this._proxies[y]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new h.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(y=>this._receiveOneMessage(y))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(P=>{this._pendingRPCReplies[P].resolveErr(T.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(P){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(P){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(P){this._responsiveState!==P&&(this._responsiveState=P,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(P){return this._uriTransformer?(0,S.transformIncomingURIs)(P,this._uriTransformer):P}getProxy(P){const{nid:L,sid:O}=P;return this._proxies[L]||(this._proxies[L]=this._createProxy(L,O)),this._proxies[L]}_createProxy(P,L){let O={get:(y,z)=>(typeof z=="string"&&!y[z]&&z.charCodeAt(0)===36&&(y[z]=(...M)=>this._remoteCall(P,z,M)),z===l?L:y[z])};return new Proxy(Object.create(null),O)}set(P,L){return this._locals[P.nid]=L,L}assertRegistered(P){for(let L=0,O=P.length;L<O;L++){const y=P[L];if(!this._locals[y.nid])throw new Error(`Missing proxy instance ${y.sid}`)}}_receiveOneMessage(P){if(this._isDisposed)return;const L=P.byteLength,O=r.read(P,0),y=O.readUInt8(),z=O.readUInt32();switch(y){case 1:case 2:{let{rpcId:M,method:B,args:V}=o.deserializeRequestJSONArgs(O);this._uriTransformer&&(V=(0,S.transformIncomingURIs)(V,this._uriTransformer)),this._receiveRequest(L,z,M,B,V,y===2);break}case 3:case 4:{let{rpcId:M,method:B,args:V}=o.deserializeRequestMixedArgs(O);this._uriTransformer&&(V=(0,S.transformIncomingURIs)(V,this._uriTransformer)),this._receiveRequest(L,z,M,B,V,y===4);break}case 5:{this._logger&&this._logger.logIncoming(L,z,0,"ack"),this._onDidReceiveAcknowledge(z);break}case 6:{this._receiveCancel(L,z);break}case 7:{this._receiveReply(L,z,void 0);break}case 9:{let M=o.deserializeReplyOKJSON(O);this._uriTransformer&&(M=(0,S.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReply(L,z,M);break}case 10:{const M=o.deserializeReplyOKJSONWithBuffers(O,this._uriTransformer);this._receiveReply(L,z,M);break}case 8:{let M=o.deserializeReplyOKVSBuffer(O);this._receiveReply(L,z,M);break}case 11:{let M=o.deserializeReplyErrError(O);this._uriTransformer&&(M=(0,S.transformIncomingURIs)(M,this._uriTransformer)),this._receiveReplyErr(L,z,M);break}case 12:{this._receiveReplyErr(L,z,void 0);break}default:console.error("received unexpected message"),console.error(P)}}_receiveRequest(P,L,O,y,z,M){this._logger&&this._logger.logIncoming(P,L,1,`receiveRequest ${(0,F.getStringIdentifierForProxy)(O)}.${y}(`,z);const B=String(L);let V,Y;if(M){const q=new I.CancellationTokenSource;z.push(q.token),V=this._invokeHandler(O,y,z),Y=()=>q.cancel()}else V=this._invokeHandler(O,y,z),Y=s;this._cancelInvokedHandlers[B]=Y;const H=o.serializeAcknowledged(L);this._logger&&this._logger.logOutgoing(H.byteLength,L,1,"ack"),this._protocol.send(H),V.then(q=>{delete this._cancelInvokedHandlers[B];const K=o.serializeReplyOK(L,q,this._uriReplacer);this._logger&&this._logger.logOutgoing(K.byteLength,L,1,"reply:",q),this._protocol.send(K)},q=>{delete this._cancelInvokedHandlers[B];const K=o.serializeReplyErr(L,q);this._logger&&this._logger.logOutgoing(K.byteLength,L,1,"replyErr:",q),this._protocol.send(K)})}_receiveCancel(P,L){this._logger&&this._logger.logIncoming(P,L,1,"receiveCancel");const O=String(L);this._cancelInvokedHandlers[O]&&this._cancelInvokedHandlers[O]()}_receiveReply(P,L,O){this._logger&&this._logger.logIncoming(P,L,0,"receiveReply:",O);const y=String(L);if(!this._pendingRPCReplies.hasOwnProperty(y))return;const z=this._pendingRPCReplies[y];delete this._pendingRPCReplies[y],z.resolveOk(O)}_receiveReplyErr(P,L,O){this._logger&&this._logger.logIncoming(P,L,0,"receiveReplyErr:",O);const y=String(L);if(!this._pendingRPCReplies.hasOwnProperty(y))return;const z=this._pendingRPCReplies[y];delete this._pendingRPCReplies[y];let M;O&&(O.$isError?(M=new Error,M.name=O.name,M.message=O.message,M.stack=O.stack):M=O),z.resolveErr(M)}_invokeHandler(P,L,O){try{return Promise.resolve(this._doInvokeHandler(P,L,O))}catch(y){return Promise.reject(y)}}_doInvokeHandler(P,L,O){const y=this._locals[P];if(!y)throw new Error("Unknown actor "+(0,F.getStringIdentifierForProxy)(P));let z=y[L];if(typeof z!="function")throw new Error("Unknown method "+L+" on actor "+(0,F.getStringIdentifierForProxy)(P));return z.apply(y,O)}_remoteCall(P,L,O){if(this._isDisposed)return Promise.reject(T.canceled());let y=null;if(O.length>0&&I.CancellationToken.isCancellationToken(O[O.length-1])&&(y=O.pop()),y&&y.isCancellationRequested)return Promise.reject(T.canceled());const z=o.serializeRequestArguments(O,this._uriReplacer),M=++this._lastMessageId,B=String(M),V=new R.LazyPromise;y&&y.onCancellationRequested(()=>{const H=o.serializeCancel(M);this._logger&&this._logger.logOutgoing(H.byteLength,M,0,"cancel"),this._protocol.send(o.serializeCancel(M))}),this._pendingRPCReplies[B]=V,this._onWillSendRequest(M);const Y=o.serializeRequest(M,P,L,z,!!y);return this._logger&&this._logger.logOutgoing(Y.byteLength,M,0,`request: ${(0,F.getStringIdentifierForProxy)(P)}.${L}(`,O),this._protocol.send(Y),V}}e.RPCProtocol=i,D=E,i.UNRESPONSIVE_TIME=3*1e3;class r{constructor(P,L){this._buff=P,this._offset=L}static alloc(P,L,O){let y=new r(n.VSBuffer.alloc(O+1+4),0);return y.writeUInt8(P),y.writeUInt32(L),y}static read(P,L){return new r(P,L)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(P){this._buff.writeUInt8(P,this._offset),this._offset+=1}readUInt8(){const P=this._buff.readUInt8(this._offset);return this._offset+=1,P}writeUInt32(P){this._buff.writeUInt32BE(P,this._offset),this._offset+=4}readUInt32(){const P=this._buff.readUInt32BE(this._offset);return this._offset+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this._buff.writeUInt8(P.byteLength,this._offset),this._offset+=1,this._buff.set(P,this._offset),this._offset+=P.byteLength}readShortString(){const P=this._buff.readUInt8(this._offset);this._offset+=1;const O=this._buff.slice(this._offset,this._offset+P).toString();return this._offset+=P,O}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}readLongString(){const P=this._buff.readUInt32BE(this._offset);this._offset+=4;const O=this._buff.slice(this._offset,this._offset+P).toString();return this._offset+=P,O}writeBuffer(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}readVSBuffer(){const P=this._buff.readUInt32BE(this._offset);this._offset+=4;const L=this._buff.slice(this._offset,this._offset+P);return this._offset+=P,L}static sizeMixedArray(P){let L=0;L+=1;for(let O=0,y=P.length;O<y;O++){const z=P[O];switch(L+=1,z.type){case 1:L+=this.sizeLongString(z.value);break;case 2:L+=this.sizeVSBuffer(z.value);break;case 3:L+=this.sizeUInt32,L+=this.sizeLongString(z.value);for(let M=0;M<z.buffers.length;++M)L+=this.sizeVSBuffer(z.buffers[M]);break;case 4:break}}return L}writeMixedArray(P){this._buff.writeUInt8(P.length,this._offset),this._offset+=1;for(let L=0,O=P.length;L<O;L++){const y=P[L];switch(y.type){case 1:this.writeUInt8(1),this.writeLongString(y.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(y.value);break;case 3:this.writeUInt8(3),this.writeUInt32(y.buffers.length),this.writeLongString(y.value);for(let z=0;z<y.buffers.length;++z)this.writeBuffer(y.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this._buff.readUInt8(this._offset);this._offset+=1;let L=new Array(P);for(let O=0;O<P;O++)switch(this.readUInt8()){case 1:L[O]=this.readLongString();break;case 2:L[O]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),M=this.readLongString(),B=[];for(let V=0;V<z;++V)B.push(this.readVSBuffer());L[O]=new F.SerializableObjectWithBuffers(A(M,B,null));break}case 4:L[O]=void 0;break}return L}}r.sizeUInt32=4;var t;(function(w){w[w.Simple=0]="Simple",w[w.Mixed=1]="Mixed"})(t||(t={}));class o{static _useMixedArgSerialization(P){for(let L=0,O=P.length;L<O;L++)if(P[L]instanceof n.VSBuffer||P[L]instanceof F.SerializableObjectWithBuffers||typeof P[L]=="undefined")return!0;return!1}static serializeRequestArguments(P,L){if(this._useMixedArgSerialization(P)){const O=[];for(let y=0,z=P.length;y<z;y++){const M=P[y];if(M instanceof n.VSBuffer)O[y]={type:2,value:M};else if(typeof M=="undefined")O[y]={type:4};else if(M instanceof F.SerializableObjectWithBuffers){const{jsonString:B,referencedBuffers:V}=v(M.value,L);O[y]={type:3,value:n.VSBuffer.fromString(B),buffers:V}}else O[y]={type:1,value:n.VSBuffer.fromString(b(M,L))}}return{type:1,args:O}}return{type:0,args:b(P,L)}}static serializeRequest(P,L,O,y,z){switch(y.type){case 0:return this._requestJSONArgs(P,L,O,y.args,z);case 1:return this._requestMixedArgs(P,L,O,y.args,z)}}static _requestJSONArgs(P,L,O,y,z){const M=n.VSBuffer.fromString(O),B=n.VSBuffer.fromString(y);let V=0;V+=r.sizeUInt8(),V+=r.sizeShortString(M),V+=r.sizeLongString(B);let Y=r.alloc(z?2:1,P,V);return Y.writeUInt8(L),Y.writeShortString(M),Y.writeLongString(B),Y.buffer}static deserializeRequestJSONArgs(P){const L=P.readUInt8(),O=P.readShortString(),y=P.readLongString();return{rpcId:L,method:O,args:JSON.parse(y)}}static _requestMixedArgs(P,L,O,y,z){const M=n.VSBuffer.fromString(O);let B=0;B+=r.sizeUInt8(),B+=r.sizeShortString(M),B+=r.sizeMixedArray(y);let V=r.alloc(z?4:3,P,B);return V.writeUInt8(L),V.writeShortString(M),V.writeMixedArray(y),V.buffer}static deserializeRequestMixedArgs(P){const L=P.readUInt8(),O=P.readShortString(),y=P.readMixedArray(),z=new Array(y.length);for(let M=0,B=y.length;M<B;M++){const V=y[M];typeof V=="string"?z[M]=JSON.parse(V):z[M]=V}return{rpcId:L,method:O,args:z}}static serializeAcknowledged(P){return r.alloc(5,P,0).buffer}static serializeCancel(P){return r.alloc(6,P,0).buffer}static serializeReplyOK(P,L,O){if(typeof L=="undefined")return this._serializeReplyOKEmpty(P);if(L instanceof n.VSBuffer)return this._serializeReplyOKVSBuffer(P,L);if(L instanceof F.SerializableObjectWithBuffers){const{jsonString:y,referencedBuffers:z}=v(L.value,O,!0);return this._serializeReplyOKJSONWithBuffers(P,y,z)}else return this._serializeReplyOKJSON(P,p(L,O))}static _serializeReplyOKEmpty(P){return r.alloc(7,P,0).buffer}static _serializeReplyOKVSBuffer(P,L){let O=0;O+=r.sizeVSBuffer(L);let y=r.alloc(8,P,O);return y.writeVSBuffer(L),y.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static _serializeReplyOKJSON(P,L){const O=n.VSBuffer.fromString(L);let y=0;y+=r.sizeLongString(O);let z=r.alloc(9,P,y);return z.writeLongString(O),z.buffer}static _serializeReplyOKJSONWithBuffers(P,L,O){const y=n.VSBuffer.fromString(L);let z=0;z+=r.sizeUInt32,z+=r.sizeLongString(y);for(const B of O)z+=r.sizeVSBuffer(B);let M=r.alloc(10,P,z);M.writeUInt32(O.length),M.writeLongString(y);for(const B of O)M.writeBuffer(B);return M.buffer}static deserializeReplyOKJSON(P){const L=P.readLongString();return JSON.parse(L)}static deserializeReplyOKJSONWithBuffers(P,L){const O=P.readUInt32(),y=P.readLongString(),z=[];for(let M=0;M<O;++M)z.push(P.readVSBuffer());return new F.SerializableObjectWithBuffers(A(y,z,L))}static serializeReplyErr(P,L){return L?this._serializeReplyErrEror(P,L):this._serializeReplyErrEmpty(P)}static _serializeReplyErrEror(P,L){const O=n.VSBuffer.fromString(p(T.transformErrorForSerialization(L),null));let y=0;y+=r.sizeLongString(O);let z=r.alloc(11,P,y);return z.writeLongString(O),z.buffer}static deserializeReplyErrError(P){const L=P.readLongString();return JSON.parse(L)}static _serializeReplyErrEmpty(P){return r.alloc(12,P,0).buffer}}var f;(function(w){w[w.RequestJSONArgs=1]="RequestJSONArgs",w[w.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",w[w.RequestMixedArgs=3]="RequestMixedArgs",w[w.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",w[w.Acknowledged=5]="Acknowledged",w[w.Cancel=6]="Cancel",w[w.ReplyOKEmpty=7]="ReplyOKEmpty",w[w.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",w[w.ReplyOKJSON=9]="ReplyOKJSON",w[w.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",w[w.ReplyErrError=11]="ReplyErrError",w[w.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var u;(function(w){w[w.String=1]="String",w[w.VSBuffer=2]="VSBuffer",w[w.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",w[w.Undefined=4]="Undefined"})(u||(u={}))}),define(ve[265],we([1,0,4]),function(ee,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,h.createDecorator)("remoteAgentService")}),define(ve[266],we([1,0,29,10,9,12,23,2,4,198,43,223,265]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let _=class qi{constructor(d,v,A,b){this.localUserHome=d,this.remoteAgentService=v,this.environmentService=A,this.contextService=b,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||T.OS)(),this.resolveUserHome=(async()=>{const a=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=a?.userHome||d})()}hasValidBasename(d,v,A){return typeof v=="string"||typeof v=="undefined"?this.resolveOS.then(b=>this.doHasValidBasename(d,b,v)):this.doHasValidBasename(d,v,A)}doHasValidBasename(d,v,A){return d.scheme===n.Schemas.file||d.scheme===n.Schemas.vscodeRemote?(0,h.isValidBasename)(A??(0,C.basename)(d),v===1):!0}get defaultUriScheme(){return qi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(d,v){if(d.remoteAuthority)return n.Schemas.vscodeRemote;const A=(0,R.getVirtualWorkspaceScheme)(v.getWorkspace());if(A)return A;const b=v.getWorkspace().folders[0];if(b)return b.uri.scheme;const a=v.getWorkspace().configuration;return a?a.scheme:n.Schemas.file}async userHome(d){return d?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(d=>d===1?I.win32:I.posix)}async fileURI(d){let v="";if(await this.resolveOS===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const b=d.indexOf("/",2);b===-1?(v=d.substring(2),d="/"):(v=d.substring(2,b),d=d.substring(b)||"/")}return k.URI.from({scheme:n.Schemas.file,authority:v,path:d,query:"",fragment:""})}};_=Be([Fe(1,p.IRemoteAgentService),Fe(2,D.IWorkbenchEnvironmentService),Fe(3,F.IWorkspaceContextService)],_),e.AbstractPathService=_}),define(ve[68],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class h{constructor(C,k){this.line=C,this.character=k}isBefore(C){return!1}isBeforeOrEqual(C){return!1}isAfter(C){return!1}isAfterOrEqual(C){return!1}isEqual(C){return!1}compareTo(C){return 0}translate(C,k){return new h(0,0)}with(C){return new h(0,0)}}e.Position=h;class n{constructor(C,k,S,R){this.isEmpty=!1,this.isSingleLine=!1,this.start=new h(C,k),this.end=new h(S,R)}contains(C){return!1}isEqual(C){return!1}intersection(C){}union(C){return new n(0,0,0,0)}with(C){return new n(0,0,0,0)}}e.Range=n;var I;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(I=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ve[31],we([1,0,18,32,25,29,8,4,9,17,68,15]),function(ee,e,h,n,I,T,C,k,S,R,F,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return F.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const p="\u27EA ",_=" characters skipped \u27EB",g=(p.length+_.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var d;(function(H){H[H.file=0]="file",H[H.text=1]="text"})(d=e.SearchProviderType||(e.SearchProviderType={}));var v;(function(H){H[H.File=1]="File",H[H.Text=2]="Text"})(v=e.QueryType||(e.QueryType={}));function A(H){return!!H.preview}e.resultIsMatch=A;function b(H){return!!H.resource}e.isFileMatch=b;function a(H){return!!H.message}e.isProgressMessage=a;var c;(function(H){H[H.Normal=0]="Normal",H[H.NewSearchStarted=1]="NewSearchStarted"})(c=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class m{constructor(q){this.resource=q,this.results=[]}}e.FileMatch=m;class s{constructor(q,K,G){this.ranges=K;const ie=Array.isArray(K)?K:[K];if(G&&G.matchLines===1&&E(ie)){q=(0,C.getNLines)(q,G.matchLines);let oe="",ue=0,Z=0;const Q=Math.floor(G.charsPerLine/5),se=[];for(const de of ie){const ge=Math.max(de.startColumn-Q,0),Te=de.startColumn+G.charsPerLine;if(ge>Z+Q+g){const Ne=p+(ge-Z)+_;oe+=Ne+q.slice(ge,Te),ue+=ge-(Z+Ne.length)}else oe+=q.slice(Z,Te);se.push(new i(0,de.startColumn-ue,de.endColumn-ue)),Z=Te}this.preview={text:oe,matches:Array.isArray(this.ranges)?se:se[0]}}else{const oe=Array.isArray(K)?K[0].startLineNumber:K.startLineNumber;this.preview={text:q,matches:(0,h.mapArrayOrNot)(K,ue=>new l(ue.startLineNumber-oe,ue.startColumn,ue.endLineNumber-oe,ue.endColumn))}}}}e.TextSearchMatch=s;function E(H){const q=H[0].startLineNumber;for(const K of H)if(K.startLineNumber!==q||K.endLineNumber!==q)return!1;return!0}class l{constructor(q,K,G,ie){this.startLineNumber=q,this.startColumn=K,this.endLineNumber=G,this.endColumn=ie}}e.SearchRange=l;class i extends l{constructor(q,K,G){super(q,K,q,G)}}e.OneLineRange=i;var r;(function(H){H.Default="default",H.FileNames="fileNames",H.Type="type",H.Modified="modified",H.CountDescending="countDescending",H.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function t(H,q=!0){const K=H&&H.files&&H.files.exclude,G=q&&H&&H.search&&H.search.exclude;if(!K&&!G)return;if(!K||!G)return K||G;let ie=Object.create(null);return ie=I.mixin(ie,I.deepClone(K)),ie=I.mixin(ie,I.deepClone(G),!0),ie}e.getExcludes=t;function o(H,q){return H.excludePattern&&n.match(H.excludePattern,q)?!1:H.includePattern||H.usingSearchPaths?H.includePattern&&n.match(H.includePattern,q)?!0:H.usingSearchPaths?!!H.folderQueries&&H.folderQueries.some(K=>{const G=K.folder.fsPath;if(T.isEqualOrParent(q,G)){const ie=S.relative(G,q);return!K.includePattern||!!n.match(K.includePattern,ie)}else return!1}):!1:!0}e.pathIncludedInQuery=o;var f;(function(H){H[H.unknownEncoding=1]="unknownEncoding",H[H.regexParseError=2]="regexParseError",H[H.globParseError=3]="globParseError",H[H.invalidLiteral=4]="invalidLiteral",H[H.rgProcessError=5]="rgProcessError",H[H.other=6]="other",H[H.canceled=7]="canceled"})(f=e.SearchErrorCode||(e.SearchErrorCode={}));class u extends Error{constructor(q,K){super(q);this.code=K}}e.SearchError=u;function w(H){const q=H.message;if((0,R.isCancellationError)(H))return new u(q,f.canceled);try{const K=JSON.parse(q);return new u(K.message,K.code)}catch{return new u(q,f.other)}}e.deserializeSearchError=w;function P(H){const q={message:H.message,code:H.code};return new Error(JSON.stringify(q))}e.serializeSearchError=P;function L(H){return H.type==="error"?!0:H.type==="success"}e.isSerializedSearchComplete=L;function O(H){return H.type==="success"}e.isSerializedSearchSuccess=O;function y(H){return!!H.path}e.isSerializedFileMatch=y;function z(H,q){const K=H.searchPath?H.searchPath:H.relativePath;return(0,C.fuzzyContains)(K,q)}e.isFilePatternMatch=z;class M{constructor(q){this.path=q,this.results=[]}addMatch(q){this.results.push(q)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=M;function B(H,q){const K={...H||{},...q||{}};return Object.keys(K).filter(G=>{const ie=K[G];return typeof ie=="boolean"&&ie})}e.resolvePatternsForProvider=B;class V{constructor(q,K){this._parsedIncludeExpression=null,this._excludeExpression={...q.excludePattern||{},...K.excludePattern||{}},this._parsedExcludeExpression=n.parse(this._excludeExpression);let G=q.includePattern;K.includePattern&&(G?G={...G,...K.includePattern}:G=K.includePattern),G&&(this._parsedIncludeExpression=n.parse(G))}matchesExcludesSync(q,K,G){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(q,K,G))}includedInQuerySync(q,K,G){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(q,K,G)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(q,K,G))}includedInQuery(q,K,G){const ie=this._parsedExcludeExpression(q,K,G),oe=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(q,K,G):!0;return(0,D.isThenable)(ie)?ie.then(ue=>ue?!1:oe()):oe()}hasSiblingExcludeClauses(){return Y(this._excludeExpression)}}e.QueryGlobTester=V;function Y(H){for(const q in H)if(typeof H[q]!="boolean")return!0;return!1}}),define(ve[36],we([1,0,18,15,21,3,24,10,91,23,8,13,2,172,4,11,190,43,44,26,16,14,7,31,5]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_,g,d,v,A,b,a,c,m,s,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function i(L,O,y){return new R.ExtUri(z=>f(z,y)).isEqual(L,O)}function r(L,O,y){return i(L.uri,O.uri,y)?0:(0,F.compare)(L.uri.toString(),O.uri.toString())}function t(L,O,y){return L.index!==O.index?L.index<O.index?-1:1:i(L.uri,O.uri,y)?(0,F.compare)(L.name,O.name):(0,F.compare)(L.uri.toString(),O.uri.toString())}function o(L,O,y,z){const M=L.slice(0).sort((V,Y)=>y(V,Y,z)),B=O.slice(0).sort((V,Y)=>y(V,Y,z));return(0,h.delta)(M,B,(V,Y)=>y(V,Y,z))}function f(L,O){const y=O.getCapabilities(L.scheme);return!(y&&y&1024)}class u extends A.Workspace{constructor(O,y,z,M,B,V,Y){super(O,z.map(H=>new A.WorkspaceFolder(H)),M,B,Y);this._name=y,this._isUntitled=V,this._workspaceFolders=[],this._structure=C.TernarySearchTree.forUris(Y),z.forEach(H=>{this._workspaceFolders.push(H),this._structure.set(H.uri,H)})}static toExtHostWorkspace(O,y,z,M){if(!O)return{workspace:null,added:[],removed:[]};const{id:B,name:V,folders:Y,configuration:H,transient:q,isUntitled:K}=O,G=[],ie=y;y?Y.forEach((Q,se)=>{const de=p.URI.revive(Q.uri),ge=u._findFolder(z||y,de,M);ge?(ge.name=Q.name,ge.index=Q.index,G.push(ge)):G.push({uri:de,name:Q.name,index:se})}):G.push(...Y.map(({uri:Q,name:se,index:de})=>({uri:p.URI.revive(Q),name:se,index:de}))),G.sort((Q,se)=>Q.index<se.index?-1:1);const oe=new u(B,V,G,!!q,H?p.URI.revive(H):null,!!K,Q=>f(Q,M)),{added:ue,removed:Z}=o(ie?ie.workspaceFolders:[],oe.workspaceFolders,r,M);return{workspace:oe,added:ue,removed:Z}}static _findFolder(O,y,z){for(let M=0;M<O.folders.length;M++){const B=O.workspaceFolders[M];if(i(B.uri,y,z))return B}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(O,y){return y&&this._structure.get(O)&&(O=(0,R.dirname)(O)),this._structure.findSubstr(O)}resolveWorkspaceFolder(O){return this._structure.get(O)}}let w=class{constructor(O,y,z,M){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=M,this._extHostFileSystemInfo=z,this._requestIdProvider=new S.Counter,this._barrier=new n.Barrier,this._proxy=O.getProxy(l.MainContext.MainThreadWorkspace),this._messageService=O.getProxy(l.MainContext.MainThreadMessageService);const B=y.workspace;this._confirmedWorkspace=B?new u(B.id,B.name,[],!!B.transient,B.configuration?p.URI.revive(B.configuration):null,!!B.isUntitled,V=>f(V,z)):void 0}$initializeWorkspace(O,y){this._trusted=y,this.$acceptWorkspaceData(O),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?p.URI.from({scheme:k.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(O,y,z,...M){const B=[];if(Array.isArray(M)&&M.forEach(K=>{p.URI.isUri(K.uri)&&!B.some(G=>i(G.uri,K.uri,this._extHostFileSystemInfo))&&B.push({uri:K.uri,name:K.name||(0,R.basenameOrAuthority)(K.uri)})}),this._unconfirmedWorkspace||[y,z].some(K=>typeof K!="number"||K<0)||z===0&&B.length===0)return!1;const V=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(y+z>V.length)return!1;const Y=V.slice(0);Y.splice(y,z,...B.map(K=>({uri:K.uri,name:K.name||(0,R.basenameOrAuthority)(K.uri),index:void 0})));for(let K=0;K<Y.length;K++){const G=Y[K];if(Y.some((ie,oe)=>oe!==K&&i(G.uri,ie.uri,this._extHostFileSystemInfo)))return!1}Y.forEach((K,G)=>K.index=G);const{added:H,removed:q}=o(V,Y,t,this._extHostFileSystemInfo);if(H.length===0&&q.length===0)return!1;if(this._proxy){const K=O.displayName||O.name;this._proxy.$updateWorkspaceFolders(K,y,z,B).then(void 0,G=>{this._unconfirmedWorkspace=void 0;const ie={source:{identifier:O.identifier,label:O.displayName||O.name}};this._messageService.$showMessage(v.Severity.Error,(0,_.localize)(0,null,K,G.toString()),ie,[])})}return this.trySetWorkspaceFolders(Y),!0}getWorkspaceFolder(O,y){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,y)}async getWorkspaceFolder2(O,y){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,y)}async resolveWorkspaceFolder(O){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(O)}getPath(){if(!this._actualWorkspace)return;const{folders:O}=this._actualWorkspace;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,y){let z,M="";if(typeof O=="string"?(z=p.URI.file(O),M=O):typeof O!="undefined"&&(z=O,M=O.fsPath),!z)return M;const B=this.getWorkspaceFolder(z,!0);if(!B)return M;typeof y=="undefined"&&this._actualWorkspace&&(y=this._actualWorkspace.folders.length>1);let V=(0,R.relativePath)(B.uri,z);return y&&B.name&&(V=`${B.name}/${V}`),V}trySetWorkspaceFolders(O){this._actualWorkspace&&(this._unconfirmedWorkspace=u.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:O,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:y,added:z,removed:M}=u.toExtHostWorkspace(O,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=y||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:z,removed:M}))}findFiles(O,y,z,M,B=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${M.value}, entryPoint: findFiles`);let V;if(y===null?V=!1:y&&(typeof y=="string"?V=y:V=y.pattern),B&&B.isCancellationRequested)return Promise.resolve([]);const{includePattern:Y,folder:H}=P(m.GlobPattern.from(O));return this._proxy.$startFileSearch((0,D.withUndefinedAsNull)(Y),(0,D.withUndefinedAsNull)(H),(0,D.withUndefinedAsNull)(V),(0,D.withUndefinedAsNull)(z),B).then(q=>Array.isArray(q)?q.map(K=>p.URI.revive(K)):[])}async findTextInFiles(O,y,z,M,B=I.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${M.value}, entryPoint: findTextInFiles`);const V=this._requestIdProvider.getNext(),Y=typeof y.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:y.previewOptions,{includePattern:H,folder:q}=P(m.GlobPattern.from(y.include)),K=typeof y.exclude=="string"?y.exclude:y.exclude?y.exclude.pattern:void 0,G={ignoreSymlinks:typeof y.followSymlinks=="boolean"?!y.followSymlinks:void 0,disregardIgnoreFiles:typeof y.useIgnoreFiles=="boolean"?!y.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof y.useGlobalIgnoreFiles=="boolean"?!y.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof y.useParentIgnoreFiles=="boolean"?!y.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof y.useDefaultExcludes=="boolean"?!y.useDefaultExcludes:!0,fileEncoding:y.encoding,maxResults:y.maxResults,previewOptions:Y,afterContext:y.afterContext,beforeContext:y.beforeContext,includePattern:H,excludePattern:K},ie=!1;if(this._activeSearchCallbacks[V]=oe=>{if(ie)return;const ue=p.URI.revive(oe.resource);oe.results.forEach(Z=>{(0,E.resultIsMatch)(Z)?z({uri:ue,preview:{text:Z.preview.text,matches:(0,h.mapArrayOrNot)(Z.preview.matches,Q=>new s.Range(Q.startLineNumber,Q.startColumn,Q.endLineNumber,Q.endColumn))},ranges:(0,h.mapArrayOrNot)(Z.ranges,Q=>new s.Range(Q.startLineNumber,Q.startColumn,Q.endLineNumber,Q.endColumn))}):z({uri:ue,text:Z.text,lineNumber:Z.lineNumber})})},B.isCancellationRequested)return{};try{const oe=await this._proxy.$startTextSearch(O,(0,D.withUndefinedAsNull)(q),G,V,B);return delete this._activeSearchCallbacks[V],oe||{}}catch(oe){throw delete this._activeSearchCallbacks[V],oe}}$handleTextSearchResult(O,y){this._activeSearchCallbacks[y]&&this._activeSearchCallbacks[y](O)}saveAll(O){return this._proxy.$saveAll(O)}resolveProxy(O){return this._proxy.$resolveProxy(O)}get trusted(){return this._trusted}requestWorkspaceTrust(O){return this._proxy.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};w=Be([Fe(0,c.IExtHostRpcService),Fe(1,a.IExtHostInitDataService),Fe(2,b.IExtHostFileSystemInfo),Fe(3,d.ILogService)],w),e.ExtHostWorkspace=w,e.IExtHostWorkspace=(0,g.createDecorator)("IExtHostWorkspace");function P(L){let O,y;return L&&(typeof L=="string"?O=L:(O=L.pattern,y=p.URI.revive(L.baseUri))),{includePattern:O,folder:y}}}),define(ve[37],we([1,0,25,3,36,5,7,193,119,13,15,4,16,11,2]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(E,l){if(l){const i=l.split(".");let r=E;for(let t=0;r&&t<i.length;t++)r=r[i[t]];return r}}function v(E){return E instanceof g.URI}function A(E){return E&&E.uri instanceof g.URI&&E.languageId&&typeof E.languageId=="string"}function b(E){return E&&!E.uri&&E.languageId&&typeof E.languageId=="string"}function a(E){return E&&E.uri instanceof g.URI&&(!E.name||typeof E.name=="string")&&(!E.index||typeof E.index=="number")}function c(E){if(v(E))return{resource:E};if(A(E))return{resource:E.uri,overrideIdentifier:E.languageId};if(b(E))return{overrideIdentifier:E.languageId};if(a(E))return{resource:E.uri};if(E===null)return{resource:null}}let m=class{constructor(l,i,r){this._proxy=l.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=r,this._barrier=new F.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(l=>this._actual)}$initializeConfiguration(l){this._actual=new s(this._proxy,this._extHostWorkspace,l,this._logService),this._barrier.open()}$acceptConfigurationChanged(l,i){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(l,i))}};m=Be([Fe(0,p.IExtHostRpcService),Fe(1,I.IExtHostWorkspace),Fe(2,_.ILogService)],m),e.ExtHostConfiguration=m;class s{constructor(l,i,r,t){this._onDidChangeConfiguration=new n.Emitter,this._proxy=l,this._logService=t,this._extHostWorkspace=i,this._configuration=k.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(l,i){const r={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,r))}getConfiguration(l,i,r){const t=c(i)||{},o=this._toReadonlyValue(l?d(this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace),l):this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace));l&&this._validateConfigurationAccess(l,t,r?.identifier);function f(w){if(w==null)return null;if(typeof w=="boolean")return w?1:4;switch(w){case C.ConfigurationTarget.Global:return 1;case C.ConfigurationTarget.Workspace:return 4;case C.ConfigurationTarget.WorkspaceFolder:return 5}}const u={has(w){return typeof d(o,w)!="undefined"},get:(w,P)=>{this._validateConfigurationAccess(l?`${l}.${w}`:w,t,r?.identifier);let L=d(o,w);if(typeof L=="undefined")L=P;else{let O;const y=(z,M)=>{let B;const V=()=>{O=O||(0,h.deepClone)(o),B=B||d(O,M)};return(0,R.isObject)(z)?new Proxy(z,{get:(Y,H)=>{if(typeof H=="string"&&H.toLowerCase()==="tojson")return V(),()=>B;if(O)return B=B||d(O,M),B[H];const q=Y[H];return typeof H=="string"?y(q,`${M}.${H}`):q},set:(Y,H,q)=>(V(),B&&(B[H]=q),!0),deleteProperty:(Y,H)=>(V(),B&&delete B[H],!0),defineProperty:(Y,H,q)=>(V(),B&&Object.defineProperty(B,H,q),!0)}):z};L=y(L,w)}return L},update:(w,P,L,O)=>{w=l?`${l}.${w}`:w;const y=f(L);return P!==void 0?this._proxy.$updateConfigurationOption(y,w,P,t,O):this._proxy.$removeConfigurationOption(y,w,t,O)},inspect:w=>{w=l?`${l}.${w}`:w;const P=(0,h.deepClone)(this._configuration.inspect(w,t,this._extHostWorkspace.workspace));if(P)return{key:w,defaultValue:P.default?.value,globalValue:P.user?.value,workspaceValue:P.workspace?.value,workspaceFolderValue:P.workspaceFolder?.value,defaultLanguageValue:P.default?.override,globalLanguageValue:P.user?.override,workspaceLanguageValue:P.workspace?.override,workspaceFolderLanguageValue:P.workspaceFolder?.override,languageIds:P.overrideIdentifiers}}};return typeof o=="object"&&(0,h.mixin)(u,o,!1),Object.freeze(u)}_toReadonlyValue(l){const i=r=>(0,R.isObject)(r)?new Proxy(r,{get:(t,o)=>i(t[o]),set:(t,o,f)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(o)}' of object`)},deleteProperty:(t,o)=>{throw new Error(`TypeError: Cannot delete read only property '${String(o)}' of object`)},defineProperty:(t,o)=>{throw new Error(`TypeError: Cannot define property '${String(o)}' for a readonly object`)},setPrototypeOf:t=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return i(l)}_validateConfigurationAccess(l,i,r){const t=S.OVERRIDE_PROPERTY_REGEX.test(l)?4:this._configurationScopes.get(l),o=r?`[${r.value}] `:"";if(t===4){typeof i?.resource=="undefined"&&this._logService.warn(`${o}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${l}', provide the URI of a resource or 'null' for any resource.`);return}if(t===3){i?.resource&&this._logService.warn(`${o}Accessing a window scoped configuration for a resource is not expected. To associate '${l}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(l,i){const r=new k.ConfigurationChangeEvent(l,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(t,o)=>r.affectsConfiguration(t,c(o))})}_toMap(l){return l.reduce((i,r)=>(i.set(r[0],r[1]),i),new Map)}}e.ExtHostConfigProvider=s,e.IExtHostConfiguration=(0,D.createDecorator)("IExtHostConfiguration")});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,h,n,I){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?I.call(ee,h):I?I.value=h:e.set(ee,h),h},Pe=this&&this.__classPrivateFieldGet||function(ee,e,h,n){if(h==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!n:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?n:h==="a"?n.call(ee):n?n.value:e.get(ee)};define(ve[69],we([1,0,2,15,3,5,7,36,45,37,21,34,16,26,4,10,12,11,64,215,17]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_,g,d,v,A,b,a,c){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var s;(function(M){function B(Y){if(Y!=null)return Y}M.from=B;function V(Y){if(Y!=null)return Y}M.to=V})(s=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var E;(function(M){function B(Y){if(Y!=null)return Y}M.from=B;function V(Y){if(Y!=null)return Y}M.to=V})(E=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var l;(function(M){function B(Y){if(Y!=null)return Y}M.from=B;function V(Y){if(Y!=null)return Y}M.to=V})(l=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(M){function B(H){if(H){const q=H;return q&&!!q.process}else return!1}M.is=B;function V(H){if(H==null)return;const q={process:H.process,args:H.args};return H.options&&(q.options=l.from(H.options)),q}M.from=V;function Y(H){if(H!=null)return new C.ProcessExecution(H.process,H.args,H.options)}M.to=Y})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var r;(function(M){function B(Y){if(Y!=null)return Y}M.from=B;function V(Y){if(Y!=null)return Y}M.to=V})(r=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var t;(function(M){function B(H){if(H){const q=H;return q&&(!!q.commandLine||!!q.command)}else return!1}M.is=B;function V(H){if(H==null)return;const q={};return H.commandLine!==void 0?q.commandLine=H.commandLine:(q.command=H.command,q.args=H.args),H.options&&(q.options=r.from(H.options)),q}M.from=V;function Y(H){if(!(H==null||H.command===void 0&&H.commandLine===void 0))return H.commandLine?new C.ShellExecution(H.commandLine,H.options):new C.ShellExecution(H.command,H.args?H.args:[],H.options)}M.to=Y})(t=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var o;(function(M){function B(H){if(H){let q=H;return q&&q.customExecution==="customExecution"}else return!1}M.is=B;function V(H){return{customExecution:"customExecution"}}M.from=V;function Y(H,q){return q.get(H)}M.to=Y})(o=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var f;(function(M){function B(V,Y){let H;return V.scope!==void 0&&typeof V.scope!="number"?H=V.scope.uri:V.scope!==void 0&&typeof V.scope=="number"&&(V.scope===C.TaskScope.Workspace&&Y&&Y.workspaceFile?H=Y.workspaceFile:H=a.USER_TASKS_GROUP_KEY),{id:V._id,workspaceFolder:H}}M.from=B})(f=e.TaskHandleDTO||(e.TaskHandleDTO={}));var u;(function(M){function B(V){if(V!=null)return{_id:V.id,isDefault:V.isDefault}}M.from=B})(u=e.TaskGroupDTO||(e.TaskGroupDTO={}));var w;(function(M){function B(H,q){if(H==null)return[];const K=[];for(let G of H){const ie=V(G,q);ie&&K.push(ie)}return K}M.fromMany=B;function V(H,q){if(H==null)return;let K;H.execution instanceof C.ProcessExecution?K=i.from(H.execution):H.execution instanceof C.ShellExecution?K=t.from(H.execution):H.execution&&H.execution instanceof C.CustomExecution&&(K=o.from(H.execution));const G=s.from(H.definition);let ie;return H.scope?typeof H.scope=="number"?ie=H.scope:ie=H.scope.uri:ie=C.TaskScope.Workspace,!G||!ie?void 0:{_id:H._id,definition:G,name:H.name,source:{extensionId:q.identifier.value,label:H.source,scope:ie},execution:K,isBackground:H.isBackground,group:u.from(H.group),presentationOptions:E.from(H.presentationOptions),problemMatchers:H.problemMatchers,hasDefinedMatchers:H.hasDefinedMatchers,runOptions:H.runOptions?H.runOptions:{reevaluateOnRerun:!0},detail:H.detail}}M.from=V;async function Y(H,q,K){if(H==null)return;let G;i.is(H.execution)?G=i.to(H.execution):t.is(H.execution)?G=t.to(H.execution):o.is(H.execution)&&(G=o.to(H._id,K));const ie=s.to(H.definition);let oe;if(H.source&&(H.source.scope!==void 0?typeof H.source.scope=="number"?oe=H.source.scope:oe=await q.resolveWorkspaceFolder(h.URI.revive(H.source.scope)):oe=C.TaskScope.Workspace),!ie||!oe)return;const ue=new C.Task(ie,oe,H.name,H.source.label,G,H.problemMatchers);return H.isBackground!==void 0&&(ue.isBackground=H.isBackground),H.group!==void 0&&(ue.group=C.TaskGroup.from(H.group._id),ue.group&&H.group.isDefault&&(ue.group=new C.TaskGroup(ue.group.id,ue.group.label),H.group.isDefault&&(ue.group.isDefault=H.group.isDefault))),H.presentationOptions&&(ue.presentationOptions=E.to(H.presentationOptions)),H._id&&(ue._id=H._id),H.detail&&(ue.detail=H.detail),ue}M.to=Y})(w=e.TaskDTO||(e.TaskDTO={}));var P;(function(M){function B(Y){return Y}M.from=B;function V(Y){if(!!Y)return Object.assign(Object.create(null),Y)}M.to=V})(P=e.TaskFilterDTO||(e.TaskFilterDTO={}));class L{constructor(B,V,Y){this._id=V,this._task=Y,m.set(this,void 0),Xe(this,m,B,"f")}get task(){return this._task}terminate(){Pe(this,m,"f").terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}m=new WeakMap;var O;(function(M){function B(V){return{id:V._id,task:void 0}}M.from=B})(O=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let y=class{constructor(B,V,Y,H,q,K,G,ie){this._onDidExecuteTask=new I.Emitter,this._onDidTerminateTask=new I.Emitter,this._onDidTaskProcessStarted=new I.Emitter,this._onDidTaskProcessEnded=new I.Emitter,this._proxy=B.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=Y,this._editorService=H,this._configurationService=q,this._terminalService=K,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=G,this._deprecationService=ie,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(B,V,Y){if(!Y)return new C.Disposable(()=>{});const H=this.nextHandle();return this._handlers.set(H,{type:V,provider:Y,extension:B}),this._proxy.$registerTaskProvider(H,V),new C.Disposable(()=>{this._handlers.delete(H),this._proxy.$unregisterTaskProvider(H)})}registerTaskSystem(B,V){this._proxy.$registerTaskSystem(B,V)}fetchTasks(B){return this._proxy.$fetchTasks(P.from(B)).then(async V=>{const Y=[];for(let H of V){const q=await w.to(H,this._workspaceProvider,this._providedCustomExecutions2);q&&Y.push(q)}return Y})}get taskExecutions(){const B=[];return this._taskExecutions.forEach(V=>B.push(V)),B}terminateTask(B){if(!(B instanceof L))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(B._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(B,V,Y){const H=this._providedCustomExecutions2.get(B.id);H&&(this._activeCustomExecutions2.set(B.id,H),this._terminalService.attachPtyToTerminal(V,await H.callback(Y))),this._lastStartedTask=B.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(B)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(B){const V=await this.getTaskExecution(B);this._taskExecutionPromises.delete(B.id),this._taskExecutions.delete(B.id),this.customExecutionComplete(B),this._onDidTerminateTask.fire({execution:V})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(B){const V=await this.getTaskExecution(B.id);this._onDidTaskProcessStarted.fire({execution:V,processId:B.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(B){const V=await this.getTaskExecution(B.id);this._onDidTaskProcessEnded.fire({execution:V,exitCode:B.exitCode})}$provideTasks(B,V){const Y=this._handlers.get(B);if(!Y)return Promise.reject(new Error("no handler found"));const H=[],q=(0,n.asPromise)(()=>Y.provider.provideTasks(F.CancellationToken.None)).then(K=>this.provideTasksInternal(V,H,Y,K));return new Promise(K=>{q.then(G=>{Promise.all(H).then(()=>{K(G)})})})}async $resolveTask(B,V){const Y=this._handlers.get(B);if(!Y)return Promise.reject(new Error("no handler found"));if(V.definition.type!==Y.type)throw new Error(`Unexpected: Task of type [${V.definition.type}] cannot be resolved by provider of type [${Y.type}].`);const H=await w.to(V,this._workspaceProvider,this._providedCustomExecutions2);if(!H)throw new Error("Unexpected: Task cannot be resolved.");const q=await Y.provider.resolveTask(H,F.CancellationToken.None);if(!q)return;this.checkDeprecation(q,Y);const K=w.from(q,Y.extension);if(!K)throw new Error("Unexpected: Task cannot be resolved.");if(q.definition!==H.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return o.is(K.execution)&&await this.addCustomExecution(K,q,!0),await this.resolveTaskInternal(K)}nextHandle(){return this._handleCounter++}async addCustomExecution(B,V,Y){const H=await this._proxy.$createTaskId(B);!Y&&!this._providedCustomExecutions2.has(H)&&(this._notProvidedCustomExecutions.add(H),this._activeCustomExecutions2.set(H,V.execution)),this._providedCustomExecutions2.set(H,V.execution)}async getTaskExecution(B,V){if(typeof B=="string"){const q=this._taskExecutionPromises.get(B);if(!q)throw new Error("Unexpected: The specified task is missing an execution");return q}let Y=this._taskExecutionPromises.get(B.id);if(Y)return Y;const H=new Promise((q,K)=>{function G(ie,oe,ue){ue?q(new L(ie,oe.id,ue)):K("Unexpected: Task does not exist.")}V?G(this,B,V):w.to(B.task,this._workspaceProvider,this._providedCustomExecutions2).then(ie=>G(this,B,ie))});return this._taskExecutionPromises.set(B.id,H),H.then(q=>(this._taskExecutions.set(B.id,q),q),q=>Promise.reject(q))}checkDeprecation(B,V){B._deprecated&&this._deprecationService.report("Task.constructor",V.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(B){this._activeCustomExecutions2.get(B.id)&&this._activeCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.has(B.id)&&this._lastStartedTask!==B.id&&(this._providedCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.delete(B.id));let Y=this._notProvidedCustomExecutions.values(),H=Y.next();for(;!H.done;)!this._activeCustomExecutions2.has(H.value)&&this._lastStartedTask!==H.value&&(this._providedCustomExecutions2.delete(H.value),this._notProvidedCustomExecutions.delete(H.value)),H=Y.next()}};y=Be([Fe(0,p.IExtHostRpcService),Fe(1,_.IExtHostInitDataService),Fe(2,k.IExtHostWorkspace),Fe(3,S.IExtHostDocumentsAndEditors),Fe(4,R.IExtHostConfiguration),Fe(5,D.IExtHostTerminalService),Fe(6,A.ILogService),Fe(7,b.IExtHostApiDeprecationService)],y),e.ExtHostTaskBase=y;let z=class extends y{constructor(B,V,Y,H,q,K,G,ie){super(B,V,Y,H,q,K,G,ie);this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:v.PlatformToString(0)})}async executeTask(B,V){if(!V.execution)throw new Error("Tasks to execute must include an execution");const Y=w.from(V,B);if(Y===void 0)throw new Error("Task is not valid");if(o.is(Y.execution))await this.addCustomExecution(Y,V,!1);else throw new c.NotSupportedError;const H=await this.getTaskExecution(await this._proxy.$getTaskExecution(Y),V);return this._proxy.$executeTask(Y).catch(q=>{throw new Error(q)}),H}provideTasksInternal(B,V,Y,H){const q=[];if(H)for(let K of H){this.checkDeprecation(K,Y),(!K.definition||!B[K.definition.type])&&this._logService.warn(`The task [${K.source}, ${K.name}] uses an undefined task type. The task will be ignored in the future.`);const G=w.from(K,Y.extension);G&&o.is(G.execution)?(q.push(G),V.push(this.addCustomExecution(G,K,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:q,extension:Y.extension}}async resolveTaskInternal(B){if(o.is(B.execution))return B;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(B,V){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(B,V,Y){}};z=Be([Fe(0,p.IExtHostRpcService),Fe(1,_.IExtHostInitDataService),Fe(2,k.IExtHostWorkspace),Fe(3,S.IExtHostDocumentsAndEditors),Fe(4,R.IExtHostConfiguration),Fe(5,D.IExtHostTerminalService),Fe(6,A.ILogService),Fe(7,b.IExtHostApiDeprecationService)],z),e.WorkerExtHostTask=z,e.IExtHostTask=(0,g.createDecorator)("IExtHostTask")}),define(ve[267],we([1,0,9,21,49,32,23,46,31]),function(ee,e,h,n,I,T,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class R{constructor(p,_,g){this.config=p,this.provider=_,this.sessionToken=g,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=p.filePattern,this.includePattern=p.includePattern&&T.parse(p.includePattern),this.maxResults=p.maxResults||void 0,this.exists=p.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=p.excludePattern&&T.parse(p.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(p=>p.cancel()),this.activeCancellationTokens=new Set}search(p){const _=this.config.folderQueries||[];return new Promise((g,d)=>{const v=A=>{this.resultCount++,p(A)};if(this.isCanceled)return g({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(A=>{const b=A.toString(),a=h.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,a)||this.matchFile(v,{base:A,basename:a})}),Promise.all(_.map(A=>this.searchInFolder(A,v))).then(A=>{g({limitHit:this.isLimitHit,stats:A[0]||void 0})},A=>{d(new Error((0,I.toErrorMessage)(A)))})})}async searchInFolder(p,_){const g=new n.CancellationTokenSource,d=this.getSearchOptionsForFolder(p),v=this.initDirectoryTree(),A=new S.QueryGlobTester(this.config,p),b=!A.hasSiblingExcludeClauses();let a;try{this.activeCancellationTokens.add(g),a=k.StopWatch.create();const c=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},d,g.token),m=a.elapsed(),s=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(c&&c.forEach(E=>{const l=h.posix.relative(p.folder.path,E.path);if(b){const i=h.basename(E.path);this.matchFile(_,{base:p.folder,relativePath:l,basename:i});return}this.addDirectoryEntries(v,p.folder,l,_)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(v,A,_),{providerTime:m,postProcessTime:s.elapsed()})}finally{g.dispose(),this.activeCancellationTokens.delete(g)}}getSearchOptionsForFolder(p){const _=(0,S.resolvePatternsForProvider)(this.config.includePattern,p.includePattern),g=(0,S.resolvePatternsForProvider)(this.config.excludePattern,p.excludePattern);return{folder:p.folder,excludes:g,includes:_,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const p={rootEntries:[],pathToEntries:Object.create(null)};return p.pathToEntries["."]=p.rootEntries,p}addDirectoryEntries({pathToEntries:p},_,g,d){if(g===this.filePattern){const A=h.basename(this.filePattern);this.matchFile(d,{base:_,relativePath:this.filePattern,basename:A})}function v(A){const b=h.basename(A),a=h.dirname(A);let c=p[a];c||(c=p[a]=[],v(a)),c.push({base:_,relativePath:A,basename:b})}v(g)}matchDirectoryTree({rootEntries:p,pathToEntries:_},g,d){const v=this,A=this.filePattern;function b(a){const c=T.hasSiblingFn(()=>a.map(m=>m.basename));for(let m=0,s=a.length;m<s;m++){const E=a[m],{relativePath:l,basename:i}=E;if(g.matchesExcludesSync(l,i,A!==i?c:void 0))continue;const r=_[l];if(r)b(r);else{if(l===A)continue;v.matchFile(d,E)}if(v.isLimitHit)break}}b(p)}matchFile(p,_){(!this.includePattern||_.relativePath&&this.includePattern(_.relativePath,_.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||p(_))}}class F{constructor(){this.sessions=new Map}fileSearch(p,_,g,d){const v=this.getSessionTokenSource(p.cacheKey),A=new R(p,_,v&&v.token);let b=0;const a=c=>{b+=c.length,g(c.map(m=>this.rawMatchToSearchItem(m)))};return this.doSearch(A,F.BATCH_SIZE,a,d).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:c.stats}}))}clearCache(p){const _=this.getSessionTokenSource(p);_&&_.cancel()}getSessionTokenSource(p){if(!!p)return this.sessions.has(p)||this.sessions.set(p,new n.CancellationTokenSource),this.sessions.get(p)}rawMatchToSearchItem(p){return p.relativePath?{resource:C.joinPath(p.base,p.relativePath)}:{resource:p.base}}doSearch(p,_,g,d){d.onCancellationRequested(()=>{p.cancel()});const v=b=>{b&&(A.push(b),_>0&&A.length>=_&&(g(A),A=[]))};let A=[];return p.search(v).then(b=>(A.length&&g(A),b),b=>(A.length&&g(A),Promise.reject(b)))}}e.FileSearchManager=F,F.BATCH_SIZE=512}),define(ve[268],we([1,0,18,73,32,100,24,10,9,23,8,13,2,152,181,115,11,43,129,266,31]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_,g,d,v,A,b,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let m=class{constructor(u,w,P,L,O){this.configurationService=u,this.workspaceContextService=w,this.editorGroupsService=P,this.logService=L,this.pathService=O}text(u,w,P={}){u=this.getContentPattern(u,P);const L=this.configurationService.getValue(),O=w&&w.some(z=>!this.configurationService.getValue({resource:z}).search.useRipgrep);return{...this.commonQuery(w?.map(A.toWorkspaceFolder),P),type:2,contentPattern:u,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:L.search.usePCRE2||O||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}getContentPattern(u,w){const P=this.configurationService.getValue();u.isRegExp&&(u.pattern=u.pattern.replace(/\r?\n/g,"\\n"));const L={...u,wordSeparators:P.editor.wordSeparators};return this.isCaseSensitive(u,w)&&(L.isCaseSensitive=!0),this.isMultiline(u)&&(L.isMultiline=!0),L}file(u,w={}){return{...this.commonQuery(u,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey}}handleIncludeExclude(u,w){return u?(u=Array.isArray(u)?u.map(r):r(u),w?this.parseSearchPaths(u):{pattern:E(...Array.isArray(u)?u:[u])}):{}}commonQuery(u=[],w={}){const P=this.handleIncludeExclude(w.includePattern,w.expandPatterns),L=this.handleIncludeExclude(w.excludePattern,w.expandPatterns),O=u.length>1,y=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(B=>this.getFolderQueryForSearchPath(B,w,L)):u.map(B=>this.getFolderQueryForRoot(B,w,L,O))).filter(B=>!!B),z={_reason:w._reason,folderQueries:y,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:L.pattern,includePattern:P.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const B=h.coalesce(h.flatten(this.editorGroupsService.groups.map(H=>H.editors.map(q=>q.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(B));const V=B.filter(H=>(0,c.pathIncludedInQuery)(z,H.fsPath)),Y=this.commonQueryFromFileList(V);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Y)),{...z,...Y}}const M=w.extraFileResources&&w.extraFileResources.filter(B=>(0,c.pathIncludedInQuery)(z,B.fsPath));return z.extraFileResources=M&&M.length?M:void 0,z}commonQueryFromFileList(u){const w=[],P=new C.ResourceMap,L={};let O=!1;return u.forEach(y=>{if(y.scheme===k.Schemas.walkThrough)return;if((0,R.isAbsolutePath)(y)){const M=this.workspaceContextService.getWorkspaceFolder(y)?.uri??y.with({path:S.dirname(y.fsPath)});let B=P.get(M);B||(O=!0,B={folder:M,includePattern:{}},w.push(B),P.set(M,B));const V=S.relative(M.fsPath,y.fsPath);(0,D.assertIsDefined)(B.includePattern)[V.replace(/\\/g,"/")]=!0}else y.fsPath&&(O=!0,L[y.fsPath]=!0)}),{folderQueries:w,includePattern:L,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}isCaseSensitive(u,w){if(w.isSmartCase){if(u.isRegExp){if(F.containsUppercaseCharacter(u.pattern,!0))return!0}else if(F.containsUppercaseCharacter(u.pattern))return!0}return!!u.isCaseSensitive}isMultiline(u){return u.isMultiline||u.isRegExp&&(0,_.isMultilineRegexSource)(u.pattern)||u.pattern.indexOf(`
`)>=0?!0:!!u.isMultiline}parseSearchPaths(u){const w=Y=>S.isAbsolute(Y)||/^\.\.?([\/\\]|$)/.test(Y),L=(Array.isArray(u)?u:l(u)).map(Y=>{const H=this.pathService.resolvedUserHome;return H?(0,T.untildify)(Y,H.scheme===k.Schemas.file?H.fsPath:H.path):Y}),O=n.groupBy(L,Y=>w(Y)?"searchPaths":"exprSegments"),y=(O.exprSegments||[]).map(Y=>F.rtrim(Y,"/")).map(Y=>F.rtrim(Y,"\\")).map(Y=>(Y[0]==="."&&(Y="*"+Y),i(Y))),z={},M=this.expandSearchPathPatterns(O.searchPaths||[]);M&&M.length&&(z.searchPaths=M);const B=h.flatten(y),V=E(...B);return V&&(z.pattern=V),z}getExcludesForFolder(u,w){return w.disregardExcludeSettings?void 0:(0,c.getExcludes)(u,!w.disregardSearchExcludeSettings)}expandSearchPathPatterns(u){if(!u||!u.length)return[];const w=h.flatten(u.map(L=>{let{pathPortion:O,globPortion:y}=s(L);y&&(y=t(y));const z=this.expandOneSearchPath(O);return h.flatten(z.map(M=>this.resolveOneSearchPathPattern(M,y)))})),P=new Map;return w.forEach(L=>{const O=L.searchPath.toString(),y=P.get(O);y?L.pattern&&(y.pattern=y.pattern||{},y.pattern[L.pattern]=!0):P.set(O,{searchPath:L.searchPath,pattern:L.pattern?E(L.pattern):void 0})}),Array.from(P.values())}expandOneSearchPath(u){if(S.isAbsolute(u)){const w=this.workspaceContextService.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==k.Schemas.file?[{searchPath:w[0].uri.with({path:u})}]:[{searchPath:p.URI.file(S.normalize(u))}]}if(this.workspaceContextService.getWorkbenchState()===2){const w=this.workspaceContextService.getWorkspace().folders[0].uri;if(u=r(u),u.startsWith("../")||u===".."){const L=S.posix.resolve(w.path,u);return[{searchPath:w.with({path:L})}]}const P=t(u);return[{searchPath:w,pattern:P}]}else{if(u==="./"||u===".\\")return[];{const w=u.replace(/^\.[\/\\]/,""),L=this.workspaceContextService.getWorkspace().folders.map(O=>{const y=w.match(new RegExp(`^${F.escapeRegExpCharacters(O.name)}(?:/(.*)|$)`));return y?{match:y,folder:O}:null}).filter(D.isDefined);if(L.length)return L.map(O=>{const y=O.match[1];return{searchPath:O.folder.uri,pattern:y&&t(y)}});{const O=u.match(/\.[\/\\](.+)[\/\\]?/),y=O?O[1]:u,z=g.localize(0,null,y);throw new Error(z)}}}}resolveOneSearchPathPattern(u,w){const P=u.pattern&&w?`${u.pattern}/${w}`:u.pattern||w,L=[{searchPath:u.searchPath,pattern:P}];return P&&!P.endsWith("**")&&L.push({searchPath:u.searchPath,pattern:P+"/**"}),L}getFolderQueryForSearchPath(u,w,P){const L=this.getFolderQueryForRoot((0,A.toWorkspaceFolder)(u.searchPath),w,P,!1);return L?{...L,includePattern:u.pattern}:null}getFolderQueryForRoot(u,w,P,L){let O;const y=p.URI.isUri(u)?u:u.uri;if(P.searchPaths){const Y=P.searchPaths.filter(H=>(0,R.isEqual)(H.searchPath,y))[0];if(Y&&!Y.pattern)return null;Y&&(O=Y.pattern)}const z=this.configurationService.getValue({resource:y}),B={...this.getExcludesForFolder(z,w)||{},...O||{}},V=p.URI.isUri(u)?(0,R.basename)(u):u.name;return{folder:y,folderName:L?V:void 0,excludePattern:Object.keys(B).length>0?B:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!z.search.followSymlinks}}};m=Be([Fe(0,d.IConfigurationService),Fe(1,A.IWorkspaceContextService),Fe(2,b.IEditorGroupsService),Fe(3,v.ILogService),Fe(4,a.IPathService)],m),e.QueryBuilder=m;function s(f){const u=f.match(/[\*\{\}\(\)\[\]\?]/);if(u){const w=u.index,P=f.substr(0,w).match(/[/|\\][^/\\]*$/);if(P){let L=f.substr(0,P.index);return L.match(/[/\\]/)||(L+="/"),{pathPortion:L,globPortion:f.substr((P.index||0)+1)}}}return{pathPortion:f}}function E(...f){return f.length?f.reduce((u,w)=>(u[w]=!0,u),Object.create(null)):void 0}function l(f){return I.splitGlobAware(f,",").map(u=>u.trim()).filter(u=>!!u.length)}function i(f){return[`**/${f}/**`,`**/${f}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function r(f){return f.replace(/\\/g,"/")}function t(f){return r(f).replace(/^\.\//,"").replace(/\/+$/g,"")}function o(f,u){f=h.distinct(f,L=>L.toString());const w=[],P=u.getWorkspace();return f&&f.forEach(L=>{let O;if(u.getWorkbenchState()===2)O=(0,R.relativePath)(P.folders[0].uri,L),O&&O!=="."&&(O="./"+O);else{const y=u.getWorkspaceFolder(L);if(y){const z=y.name;if(P.folders.filter(B=>B.name===z).length===1){const B=(0,R.relativePath)(y.uri,L);B===""?O=`./${y.name}`:O=`./${y.name}/${B}`}else O=L.fsPath}}O&&w.push(O)}),w}e.resolveResourcesForSearchIncludes=o}),define(ve[269],we([1,0,23,2,21,17,4,268,31,43]),function(ee,e,h,n,I,T,C,k,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const F=7e3;function D(d,v){const A=v.activationEvents;if(!A)return Promise.resolve(void 0);const b=[],a=[];for(const i of A)if(/^workspaceContains:/.test(i)){const r=i.substr("workspaceContains:".length);r.indexOf("*")>=0||r.indexOf("?")>=0||d.forceUsingSearch?a.push(r):b.push(r)}if(b.length===0&&a.length===0)return Promise.resolve(void 0);let c;const m=new Promise((i,r)=>{c=i}),s=i=>c({activationEvent:i}),E=Promise.all(b.map(i=>p(d,i,s))).then(()=>{}),l=_(d,v.identifier,a,s);return Promise.all([E,l]).then(()=>{c(void 0)}),m}e.checkActivateWorkspaceContainsExtension=D;async function p(d,v,A){for(const b of d.folders)if(await d.exists(h.joinPath(n.URI.revive(b),v))){A(`workspaceContains:${v}`);return}}async function _(d,v,A,b){if(A.length===0)return Promise.resolve(void 0);const a=new I.CancellationTokenSource,c=d.checkExists(d.folders,A,a.token),m=setTimeout(async()=>{a.cancel(),d.logService.info(`Not activating extension '${v.value}': Timed out while searching for 'workspaceContains' pattern ${A.join(",")}`)},F);let s=!1;try{s=await c}catch(E){T.isCancellationError(E)||T.onUnexpectedError(E)}a.dispose(),clearTimeout(m),s&&b(`workspaceContains:${A.join(",")}`)}function g(d,v,A,b){const a=d.get(C.IInstantiationService),c=d.get(S.ISearchService),s=a.createInstance(k.QueryBuilder).file(v.map(E=>(0,R.toWorkspaceFolder)(n.URI.revive(E))),{_reason:"checkExists",includePattern:A,exists:!0});return c.fileSearch(s,b).then(E=>!!E.limitHit,E=>T.isCancellationError(E)?!1:Promise.reject(E))}e.checkGlobFileExists=g});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,h,n,I){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?I.call(ee,h):I?I.value=h:e.set(ee,h),h},Pe=this&&this.__classPrivateFieldGet||function(ee,e,h,n){if(h==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!n:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?n:h==="a"?n.call(ee):n?n.value:e.get(ee)};define(ve[40],we([1,0,167,9,70,23,15,6,24,2,11,5,37,225,87,36,30,224,17,27,22,199,7,120,4,26,66,16,80,51,34,3,269,86,201,10]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_,g,d,v,A,b,a,c,m,s,E,l,i,r,t,o,f,u,w,P,L,O,y){"use strict";var z,M,B;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,l.createDecorator)("IHostUtils");let V=class Gi extends k.Disposable{constructor(G,ie,oe,ue,Z,Q,se,de,ge,Te){super();this._onDidChangeRemoteConnectionData=this._register(new w.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=ie,this._extHostContext=oe,this._initData=se,this._extHostWorkspace=ue,this._extHostConfiguration=Z,this._logService=Q,this._extHostTunnelService=ge,this._extHostTerminalService=Te,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(D.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(D.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(D.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new C.Barrier,this._readyToStartExtensionHost=new C.Barrier,this._readyToRunExtensions=new C.Barrier,this._eagerExtensionsActivated=new C.Barrier,this._registry=new A.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new g.ExtHostStorage(this._extHostContext),this._secretState=new L.ExtHostSecretState(this._extHostContext),this._storagePath=de,this._instaService=G.createChild(new o.ServiceCollection([g.IExtHostStorage,this._storage],[L.IExtHostSecretState,this._secretState]));const Ne=new Set;this._initData.hostExtensions.forEach(be=>Ne.add(a.ExtensionIdentifier.toKey(be))),this._activator=this._register(new _.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(be,Ee,$)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(be,b.transformErrorForSerialization(Ee),$)},actualActivateExtension:async(be,Ee)=>{if(Ne.has(a.ExtensionIdentifier.toKey(be)))return await this._mainThreadExtensionsProxy.$activateExtension(be,Ee),new _.HostExtension;const $=this._registry.getExtensionDescription(be);return this._activateExtension($,Ee)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),I.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(G){b.onUnexpectedError(G)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let G=[];try{G=this._registry.getAllExtensionDescriptions().map(Z=>Z.identifier).filter(Z=>this.isActivated(Z)).map(Z=>this._deactivate(Z))}catch{}await Promise.all(G)}isActivated(G){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(G):!1}_activateByEvent(G,ie){return this._activator.activateByEvent(G,ie)}_activateById(G,ie){return this._activator.activateById(G,ie)}activateByIdWithErrors(G,ie){return this._activateById(G,ie).then(()=>{const oe=this._activator.getActivatedExtension(G);if(oe.activationFailed)return Promise.reject(oe.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(G=>this._registry)}getExtensionExports(G){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(G).exports:null}async _realPathExtensionUri(G){if(G.scheme!==y.Schemas.file)return G;const ie=await this._hostUtils.realpath(G.fsPath);return R.URI.file(ie)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const G=S.TernarySearchTree.forUris(ie=>T.extUriBiasedIgnorePathCase.ignorePathCasing(ie));for(const ie of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(ie)){const oe=await this._realPathExtensionUri(ie.extensionLocation);G.set(oe,ie)}return G})()),this._extensionPathIndex}_deactivate(G){let ie=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(G))return ie;const oe=this._activator.getActivatedExtension(G);if(!oe)return ie;try{typeof oe.module.deactivate=="function"&&(ie=Promise.resolve(oe.module.deactivate()).then(void 0,ue=>(this._logService.error(ue),Promise.resolve(void 0))))}catch(ue){this._logService.error(`An error occurred when deactivating the extension '${G.value}':`),this._logService.error(ue)}try{(0,k.dispose)(oe.subscriptions)}catch(ue){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${G.value}':`),this._logService.error(ue)}return ie}async _activateExtension(G,ie){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(G.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(G.identifier),this._doActivateExtension(G,ie).then(oe=>{const ue=oe.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(G.identifier,ue.codeLoadingTime,ue.activateCallTime,ue.activateResolvedTime,ie),this._logExtensionActivationTimes(G,ie,"success",ue),oe},oe=>{throw this._logExtensionActivationTimes(G,ie,"failure"),oe})}_logExtensionActivationTimes(G,ie,oe,ue){const Z=Y(G,ie);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Z,...ue||{},outcome:oe})}_doActivateExtension(G,ie){const oe=Y(G,ie);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",oe);const ue=this._getEntryPoint(G);if(!ue)return Promise.resolve(new _.EmptyExtension(_.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${G.identifier.value}, startup: ${ie.startup}, activationEvent: '${ie.activationEvent}'${G.identifier.value!==ie.extensionId.value?`, root cause: ${ie.extensionId.value}`:""}`),this._logService.flush();const Z=new _.ExtensionActivationTimesBuilder(ie.startup);return Promise.all([this._loadCommonJSModule(G.identifier,(0,T.joinPath)(G.extensionLocation,ue),Z),this._loadExtensionContext(G)]).then(Q=>(I.mark(`code/extHost/willActivateExtension/${G.identifier.value}`),Gi._callActivate(this._logService,G.identifier,Q[0],Q[1],Z))).then(Q=>(I.mark(`code/extHost/didActivateExtension/${G.identifier.value}`),Q))}_loadExtensionContext(G){const ie=new m.ExtensionGlobalMemento(G,this._storage),oe=new m.ExtensionMemento(G.identifier.value,!1,this._storage),ue=new O.ExtensionSecrets(G,this._secretState),Z=G.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?s.ExtensionMode.Test:s.ExtensionMode.Development:s.ExtensionMode.Production,Q=this._initData.remote.isRemote?s.ExtensionKind.Workspace:s.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${G.identifier.value}`),Promise.all([ie.whenReady,oe.whenReady,this._storagePath.whenReady]).then(()=>{const se=this;let de,ge;const Te=(0,v.isProposedApiEnabled)(G,"ipc")?this._initData.messagePorts?.get(a.ExtensionIdentifier.toKey(G.identifier)):void 0;return Object.freeze({globalState:ie,workspaceState:oe,secrets:ue,subscriptions:[],get extensionUri(){return G.extensionLocation},get extensionPath(){return G.extensionLocation.fsPath},asAbsolutePath(Ne){return n.join(G.extensionLocation.fsPath,Ne)},get storagePath(){return se._storagePath.workspaceValue(G)?.fsPath},get globalStoragePath(){return se._storagePath.globalValue(G).fsPath},get logPath(){return n.join(se._initData.logsLocation.fsPath,G.identifier.value)},get logUri(){return R.URI.joinPath(se._initData.logsLocation,G.identifier.value)},get storageUri(){return se._storagePath.workspaceValue(G)},get globalStorageUri(){return se._storagePath.globalValue(G)},get extensionMode(){return Z},get extension(){return de===void 0&&(de=new H(se,G.identifier,G,Q)),de},get extensionRuntime(){return(0,v.checkProposedApiEnabled)(G,"extensionRuntime"),se.extensionRuntime},get environmentVariableCollection(){return se._extHostTerminalService.getEnvironmentVariableCollection(G)},get messagePassingProtocol(){if(!ge){if(!Te)return;const Ne=w.Event.buffer(w.Event.fromDOMEventEmitter(Te,"message",be=>be.data));Te.start(),ge={onDidReceiveMessage:Ne,postMessage:Te.postMessage.bind(Te)}}return ge}})})}static _callActivate(G,ie,oe,ue,Z){return oe=oe||{activate:void 0,deactivate:void 0},this._callActivateOptional(G,ie,oe,ue,Z).then(Q=>new _.ActivatedExtension(!1,null,Z.build(),oe,Q,ue.subscriptions))}static _callActivateOptional(G,ie,oe,ue,Z){if(typeof oe.activate=="function")try{Z.activateCallStart(),G.trace(`ExtensionService#_callActivateOptional ${ie.value}`);const Q=typeof global=="object"?global:self,se=oe.activate.apply(Q,[ue]);return Z.activateCallStop(),Z.activateResolveStart(),Promise.resolve(se).then(de=>(Z.activateResolveStop(),de))}catch(Q){return Promise.reject(Q)}else return Promise.resolve(oe)}_activateOneStartupFinished(G,ie){this._activateById(G.identifier,{startup:!1,extensionId:G.identifier,activationEvent:ie}).then(void 0,oe=>{this._logService.error(oe)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(I.getMarks());for(const G of this._registry.getAllExtensionDescriptions())if(G.activationEvents)for(const ie of G.activationEvents)ie==="onStartupFinished"&&this._activateOneStartupFinished(G,ie)}_handleEagerExtensions(){const G=this._activateByEvent("*",!0).then(void 0,Z=>{this._logService.error(Z)});this._register(this._extHostWorkspace.onDidChangeWorkspace(Z=>this._handleWorkspaceContainsEagerExtensions(Z.added)));const ie=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],oe=this._handleWorkspaceContainsEagerExtensions(ie),ue=Promise.all([G,oe]).then(()=>{});return Promise.race([ue,(0,C.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ue}_handleWorkspaceContainsEagerExtensions(G){return G.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(ie=>this._handleWorkspaceContainsEagerExtension(G,ie))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(G,ie){if(this.isActivated(ie.identifier))return;const oe=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ue={logService:this._logService,folders:G.map(Q=>Q.uri),forceUsingSearch:oe,exists:Q=>this._hostUtils.exists(Q.fsPath),checkExists:(Q,se,de)=>this._mainThreadWorkspaceProxy.$checkExists(Q,se,de)},Z=await(0,P.checkActivateWorkspaceContainsExtension)(ue,ie);if(!!Z)return this._activateById(ie.identifier,{startup:!0,extensionId:ie.identifier,activationEvent:Z.activationEvent}).then(void 0,Q=>this._logService.error(Q))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(G){throw console.error(G),G}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:G,extensionTestsLocationURI:ie}=this._initData.environment;if(!G||!ie)throw new Error(h.localize(0,null));const oe=await this._loadCommonJSModule(null,ie,new _.ExtensionActivationTimesBuilder(!1));if(!oe||typeof oe.run!="function")throw new Error(h.localize(1,null,ie.toString()));return new Promise((ue,Z)=>{const Q=(ge,Te)=>{ge?Z(ge):ue(typeof Te=="number"&&Te>0?1:0)},se=(0,T.originalFSPath)(ie),de=oe.run(se,Q);de&&de.then&&de.then(()=>{ue(0)}).catch(ge=>{Z(ge instanceof Error&&ge.stack?ge.stack:String(ge))})})}async $extensionTestsExit(G){this._logService.info(`Extension host terminating: test runner requested exit with code ${G}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${G}`),this._logService.flush(),this._hostUtils.exit(G)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(G,ie){return this._resolvers[G]=ie,(0,k.toDisposable)(()=>{delete this._resolvers[G]})}async _activateAndGetResolver(G){const ie=G.indexOf("+");if(ie===-1)throw new Error("Not an authority that can be resolved!");const oe=G.substr(0,ie);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${oe}`,!1),{authorityPrefix:oe,resolver:this._resolvers[oe]}}async $resolveAuthority(G,ie){this._logService.info(`$resolveAuthority invoked for authority (${q(G)})`);const{authorityPrefix:oe,resolver:ue}=await this._activateAndGetResolver(G);if(!ue)return{type:"error",error:{code:E.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${oe}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(ue)),I.mark(`code/extHost/willResolveAuthority/${oe}`);const Z=await ue.resolve(G,{resolveAttempt:ie});I.mark(`code/extHost/didResolveAuthorityOK/${oe}`);const Q={authority:G,host:Z.host,port:Z.port,connectionToken:Z.connectionToken},se={extensionHostEnv:Z.extensionHostEnv,isTrusted:Z.isTrusted,authenticationSession:Z.authenticationSessionForInitializingExtensions?{id:Z.authenticationSessionForInitializingExtensions.id,providerId:Z.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Q,options:se,tunnelInformation:{environmentTunnels:Z.environmentTunnels,features:Z.tunnelFeatures}}}}catch(Z){if(I.mark(`code/extHost/didResolveAuthorityError/${oe}`),Z instanceof s.RemoteAuthorityResolverError)return{type:"error",error:{code:Z._code,message:Z._message,detail:Z._detail}};throw Z}}async $getCanonicalURI(G,ie){this._logService.info(`$getCanonicalURI invoked for authority (${q(G)})`);const{authorityPrefix:oe,resolver:ue}=await this._activateAndGetResolver(G);if(!ue)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${oe}`);const Z=R.URI.revive(ie);if(typeof ue.getCanonicalURI=="undefined")return Z;const Q=await(0,C.asPromise)(()=>ue.getCanonicalURI(Z));return Q||Z}$startExtensionHost(G){return this._registry.keepOnly(G),this._startExtensionHost()}$activateByEvent(G,ie){return ie===1?this._activateByEvent(G,!1):this._readyToRunExtensions.wait().then(oe=>this._activateByEvent(G,!1))}async $activate(G,ie){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(G)?(await this._activateById(G,ie),!0):!1}async $deltaExtensions(G,ie){G.forEach(ue=>ue.extensionLocation=R.URI.revive(ue.extensionLocation));const oe=await this.getExtensionPathIndex();return await Promise.all(ie.map(async ue=>{const Z=this._registry.getExtensionDescription(ue);Z&&oe.delete(await this._realPathExtensionUri(Z.extensionLocation))})),await Promise.all(G.map(async ue=>{const Z=await this._realPathExtensionUri(ue.extensionLocation);oe.set(Z,ue)})),this._registry.deltaExtensions(G,ie),Promise.resolve(void 0)}async $test_latency(G){return G}async $test_up(G){return G.byteLength}async $test_down(G){let ie=c.VSBuffer.alloc(G),oe=Math.random()%256;for(let ue=0;ue<G;ue++)ie.writeUInt8(oe,ue);return ie}async $updateRemoteConnectionData(G){this._remoteConnectionData=G,this._onDidChangeRemoteConnectionData.fire()}};V=Be([Fe(0,l.IInstantiationService),Fe(1,e.IHostUtils),Fe(2,t.IExtHostRpcService),Fe(3,d.IExtHostWorkspace),Fe(4,p.IExtHostConfiguration),Fe(5,F.ILogService),Fe(6,i.IExtHostInitDataService),Fe(7,r.IExtensionStoragePaths),Fe(8,f.IExtHostTunnelService),Fe(9,u.IExtHostTerminalService)],V),e.AbstractExtHostExtensionService=V;function Y(K,G){return{id:K.identifier.value,name:K.name,extensionVersion:K.version,publisherDisplayName:K.publisher,activationEvents:K.activationEvents?K.activationEvents.join(","):null,isBuiltin:K.isBuiltin,reason:G.activationEvent,reasonId:G.extensionId.value}}e.IExtHostExtensionService=(0,l.createDecorator)("IExtHostExtensionService");class H{constructor(G,ie,oe,ue){z.set(this,void 0),M.set(this,void 0),B.set(this,void 0),Xe(this,z,G,"f"),Xe(this,M,ie,"f"),Xe(this,B,oe.identifier,"f"),this.id=oe.identifier.value,this.extensionUri=oe.extensionLocation,this.extensionPath=n.normalize((0,T.originalFSPath)(oe.extensionLocation)),this.packageJSON=oe,this.extensionKind=ue}get isActive(){return Pe(this,z,"f").isActivated(Pe(this,B,"f"))}get exports(){if(this.packageJSON.api!=="none")return Pe(this,z,"f").getExtensionExports(Pe(this,B,"f"))}activate(){return Pe(this,z,"f").activateByIdWithErrors(Pe(this,B,"f"),{startup:!1,extensionId:Pe(this,M,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=H,z=new WeakMap,M=new WeakMap,B=new WeakMap;function q(K){const G=K.indexOf("+");return G===-1?K:K.substring(0,G)}}),define(ve[54],we([1,0,9,2,3,15,5,7,126,36,40,45,217,37,210,16,4,13,41,53]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_,g,d,v,A,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,v.createDecorator)("IExtHostDebugService");let c=class{constructor(o,f,u,w,P,L){this._workspaceService=f,this._extensionService=u,this._editorsService=w,this._configurationService=P,this._editorTabs=L,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new I.Emitter,this._onDidTerminateDebugSession=new I.Emitter,this._onDidChangeActiveDebugSession=new I.Emitter,this._onDidReceiveDebugSessionCustomEvent=new I.Emitter,this._debugServiceProxy=o.getProxy(C.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new I.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new s(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(O=>{O.onDidChange(y=>{this.registerAllDebugTypes(O)}),this.registerAllDebugTypes(O)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(o,f){const u=o;if(typeof u.sourceReference=="number"&&u.sourceReference>0){let w=`debug:${encodeURIComponent(u.path||"")}`,P="?";return f&&(w+=`${P}session=${encodeURIComponent(f.id)}`,P="&"),w+=`${P}ref=${u.sourceReference}`,n.URI.parse(w)}else{if(u.path)return n.URI.file(u.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(o){const f=[];for(const u of o.getAllExtensionDescriptions())if(u.contributes){const w=u.contributes.debuggers;if(w&&w.length>0)for(const P of w)(0,g.isDebuggerMainContribution)(P)&&f.push(P.type)}this._debugServiceProxy.$registerDebugTypes(f)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const o=[];return this._breakpoints.forEach(f=>o.push(f)),o}addBreakpoints(o){this.startBreakpoints();const f=o.filter(P=>{const L=P.id;return this._breakpoints.has(L)?!1:(this._breakpoints.set(L,P),!0)});this.fireBreakpointChanges(f,[],[]);const u=[],w=new Map;for(const P of f)if(P instanceof k.SourceBreakpoint){let L=w.get(P.location.uri.toString());L||(L={type:"sourceMulti",uri:P.location.uri,lines:[]},w.set(P.location.uri.toString(),L),u.push(L)),L.lines.push({id:P.id,enabled:P.enabled,condition:P.condition,hitCondition:P.hitCondition,logMessage:P.logMessage,line:P.location.range.start.line,character:P.location.range.start.character})}else P instanceof k.FunctionBreakpoint&&u.push({type:"function",id:P.id,enabled:P.enabled,hitCondition:P.hitCondition,logMessage:P.logMessage,condition:P.condition,functionName:P.functionName});return this._debugServiceProxy.$registerBreakpoints(u)}removeBreakpoints(o){this.startBreakpoints();const f=o.filter(L=>this._breakpoints.delete(L.id));this.fireBreakpointChanges([],f,[]);const u=f.filter(L=>L instanceof k.SourceBreakpoint).map(L=>L.id),w=f.filter(L=>L instanceof k.FunctionBreakpoint).map(L=>L.id),P=f.filter(L=>L instanceof k.DataBreakpoint).map(L=>L.id);return this._debugServiceProxy.$unregisterBreakpoints(u,w,P)}startDebugging(o,f,u){return this._debugServiceProxy.$startDebugging(o?o.uri:void 0,f,{parentSessionID:u.parentSession?u.parentSession.id:void 0,lifecycleManagedByParent:u.lifecycleManagedByParent,repl:u.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:u.noDebug,compact:u.compact,debugUI:u.debugUI,suppressSaveBeforeStart:u.suppressSaveBeforeStart})}stopDebugging(o){return this._debugServiceProxy.$stopDebugging(o?o.id:void 0)}registerDebugConfigurationProvider(o,f,u){if(!f)return new k.Disposable(()=>{});const w=this._configProviderHandleCounter++;return this._configProviders.push({type:o,handle:w,provider:f}),this._debugServiceProxy.$registerDebugConfigurationProvider(o,u,!!f.provideDebugConfigurations,!!f.resolveDebugConfiguration,!!f.resolveDebugConfigurationWithSubstitutedVariables,w),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(P=>P.provider!==f),this._debugServiceProxy.$unregisterDebugConfigurationProvider(w)})}registerDebugAdapterDescriptorFactory(o,f,u){if(!u)return new k.Disposable(()=>{});if(!this.definesDebugType(o,f))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${f}' debugger.`);if(this.getAdapterDescriptorFactoryByType(f))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const w=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:f,handle:w,factory:u}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(f,w),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(P=>P.factory!==u),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(w)})}registerDebugAdapterTrackerFactory(o,f){if(!f)return new k.Disposable(()=>{});const u=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:o,handle:u,factory:f}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(w=>w.factory!==f)})}async $runInTerminal(o,f){return Promise.resolve(void 0)}async $substituteVariables(o,f){if(!this._variableResolver){const[P,L]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(P||[],this._editorsService,L)}let u;const w=await this.getFolder(o);return w&&(u={uri:w.uri,name:w.name,index:w.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(u,f)}createDebugAdapter(o,f){if(o.type==="implementation")return new i(o.implementation)}createSignService(){}async $startDASession(o,f){const u=this,w=await this.getSession(f);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(w.type),w).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}' (extension might have failed to activate)`);const L=this.convertToDto(P),O=this.createDebugAdapter(L,w);if(!O)throw new Error(`Couldn't create a debug adapter for type '${w.type}'.`);const y=O;return this._debugAdapters.set(o,y),this.getDebugAdapterTrackers(w).then(z=>(z&&this._debugAdaptersTrackers.set(o,z),y.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const B=M,V={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const Y=await this._signService.sign(B.arguments.value);V.body={signature:Y},y.sendResponse(V)}else throw new Error("no signer")}catch(Y){V.success=!1,V.message=Y.message,y.sendResponse(V)}}else z&&z.onDidSendMessage&&z.onDidSendMessage(M),M=(0,g.convertToVSCPaths)(M,!0),u._debugServiceProxy.$acceptDAMessage(o,M)}),y.onError(M=>{z&&z.onError&&z.onError(M),this._debugServiceProxy.$acceptDAError(o,M.name,M.message,M.stack)}),y.onExit(M=>{z&&z.onExit&&z.onExit((0,A.withNullAsUndefined)(M),void 0),this._debugServiceProxy.$acceptDAExit(o,(0,A.withNullAsUndefined)(M),void 0)}),z&&z.onWillStartSession&&z.onWillStartSession(),y.startSession()))})}$sendDAMessage(o,f){f=(0,g.convertToDAPaths)(f,!1);const u=this._debugAdaptersTrackers.get(o);u&&u.onWillReceiveMessage&&u.onWillReceiveMessage(f);const w=this._debugAdapters.get(o);w&&w.sendMessage(f)}$stopDASession(o){const f=this._debugAdaptersTrackers.get(o);this._debugAdaptersTrackers.delete(o),f&&f.onWillStopSession&&f.onWillStopSession();const u=this._debugAdapters.get(o);return this._debugAdapters.delete(o),u?u.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(o){const f=[],u=[],w=[];if(o.added)for(const P of o.added){const L=P.id;if(L&&!this._breakpoints.has(L)){let O;if(P.type==="function")O=new k.FunctionBreakpoint(P.functionName,P.enabled,P.condition,P.hitCondition,P.logMessage);else if(P.type==="data")O=new k.DataBreakpoint(P.label,P.dataId,P.canPersist,P.enabled,P.hitCondition,P.condition,P.logMessage);else{const y=n.URI.revive(P.uri);O=new k.SourceBreakpoint(new k.Location(y,new k.Position(P.line,P.character)),P.enabled,P.condition,P.hitCondition,P.logMessage)}O._id=L,this._breakpoints.set(L,O),f.push(O)}}if(o.removed)for(const P of o.removed){const L=this._breakpoints.get(P);L&&(this._breakpoints.delete(P),u.push(L))}if(o.changed){for(const P of o.changed)if(P.id){const L=this._breakpoints.get(P.id);if(L){if(L instanceof k.FunctionBreakpoint&&P.type==="function"){const O=L;O.enabled=P.enabled,O.condition=P.condition,O.hitCondition=P.hitCondition,O.logMessage=P.logMessage,O.functionName=P.functionName}else if(L instanceof k.SourceBreakpoint&&P.type==="source"){const O=L;O.enabled=P.enabled,O.condition=P.condition,O.hitCondition=P.hitCondition,O.logMessage=P.logMessage,O.location=new k.Location(n.URI.revive(P.uri),new k.Position(P.line,P.character))}w.push(L)}}}this.fireBreakpointChanges(f,u,w)}$provideDebugConfigurations(o,f,u){return(0,T.asPromise)(async()=>{const w=this.getConfigProviderByHandle(o);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const P=await this.getFolder(f);return w.provideDebugConfigurations(P,u)}).then(w=>{if(!w)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return w})}$resolveDebugConfiguration(o,f,u,w){return(0,T.asPromise)(async()=>{const P=this.getConfigProviderByHandle(o);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.getFolder(f);return P.resolveDebugConfiguration(L,u,w)})}$resolveDebugConfigurationWithSubstitutedVariables(o,f,u,w){return(0,T.asPromise)(async()=>{const P=this.getConfigProviderByHandle(o);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.getFolder(f);return P.resolveDebugConfigurationWithSubstitutedVariables(L,u,w)})}async $provideDebugAdapter(o,f){const u=this.getAdapterDescriptorFactoryByHandle(o);if(!u)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const w=await this.getSession(f);return this.getAdapterDescriptor(u,w).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}'`);return this.convertToDto(P)})}async $acceptDebugSessionStarted(o){const f=await this.getSession(o);this._onDidStartDebugSession.fire(f)}async $acceptDebugSessionTerminated(o){const f=await this.getSession(o);f&&(this._onDidTerminateDebugSession.fire(f),this._debugSessions.delete(f.id))}async $acceptDebugSessionActiveChanged(o){this._activeDebugSession=o?await this.getSession(o):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(o,f){const u=await this.getSession(o);u&&u._acceptNameChanged(f)}async $acceptDebugSessionCustomEvent(o,f){const w={session:await this.getSession(o),event:f.event,body:f.body};this._onDidReceiveDebugSessionCustomEvent.fire(w)}convertToDto(o){if(o instanceof k.DebugAdapterExecutable)return{type:"executable",command:o.command,args:o.args,options:o.options};if(o instanceof k.DebugAdapterServer)return{type:"server",port:o.port,host:o.host};if(o instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:o.path};if(o instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:o.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(o){const f=this._adapterFactories.filter(u=>u.type===o);if(f.length>0)return f[0].factory}getAdapterDescriptorFactoryByHandle(o){const f=this._adapterFactories.filter(u=>u.handle===o);if(f.length>0)return f[0].factory}getConfigProviderByHandle(o){const f=this._configProviders.filter(u=>u.handle===o);if(f.length>0)return f[0].provider}definesDebugType(o,f){if(o.contributes){const u=o.contributes.debuggers;if(u&&u.length>0){for(const w of u)if(w.label&&w.type&&w.type===f)return!0}}return!1}getDebugAdapterTrackers(o){const u=o.configuration.type,w=this._trackerFactories.filter(P=>P.type===u||P.type==="*").map(P=>(0,T.asPromise)(()=>P.factory.createDebugAdapterTracker(o)).then(L=>L,L=>null));return Promise.race([Promise.all(w).then(P=>{const L=P.filter(O=>!!O);if(L.length>0)return new l(L)}),new Promise((P,L)=>{const O=setTimeout(()=>{clearTimeout(O),L(new Error("timeout"))},1e3)})]).catch(P=>{})}async getAdapterDescriptor(o,f){const u=f.configuration.debugServer;if(typeof u=="number")return Promise.resolve(new k.DebugAdapterServer(u));if(o){const P=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>o.createDebugAdapterDescriptor(f,this.daExecutableFromPackage(f,P))).then(L=>{if(L)return L})}const w=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(f,w))}daExecutableFromPackage(o,f){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(o,f,u){(o.length>0||f.length>0||u.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:o,removed:f,changed:u}))}async getSession(o){if(o)if(typeof o=="string"){const f=this._debugSessions.get(o);if(f)return f}else{let f=this._debugSessions.get(o.id);if(!f){const u=await this.getFolder(o.folderUri),w=o.parent?this._debugSessions.get(o.parent):void 0;f=new m(this._debugServiceProxy,o.id,o.type,o.name,u,o.configuration,w),this._debugSessions.set(f.id,f),this._debugServiceProxy.$sessionCached(f.id)}return f}throw new Error("cannot find session")}getFolder(o){if(o){const f=n.URI.revive(o);return this._workspaceService.resolveWorkspaceFolder(f)}return Promise.resolve(void 0)}};c=Be([Fe(0,d.IExtHostRpcService),Fe(1,R.IExtHostWorkspace),Fe(2,F.IExtHostExtensionService),Fe(3,D.IExtHostDocumentsAndEditors),Fe(4,_.IExtHostConfiguration),Fe(5,a.IExtHostEditorTabs)],c),e.ExtHostDebugServiceBase=c;class m{constructor(o,f,u,w,P,L,O){this._debugServiceProxy=o,this._id=f,this._type=u,this._name=w,this._workspaceFolder=P,this._configuration=L,this._parentSession=O}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(o){this._name=o,this._debugServiceProxy.$setDebugSessionName(this._id,o)}get parentSession(){return this._parentSession}_acceptNameChanged(o){this._name=o}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(o,f){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,o,f)}getDebugProtocolBreakpoint(o){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,o.id)}}e.ExtHostDebugSession=m;class s{constructor(o){this.value=Object.freeze({append(f){o.$appendDebugConsole(f)},appendLine(f){this.append(f+`
`)}})}}e.ExtHostDebugConsole=s;class E extends p.AbstractVariableResolverService{constructor(o,f,u,w,P,L){function O(){if(f){const y=f.activeEditor();if(y)return y.document.uri;const z=w.tabGroups.all.find(M=>M.isActive)?.activeTab;if(z!==void 0){const M=z.resource;return M&&(M.primary||M.secondary)?M.primary??M.secondary:z.resource}}}super({getFolderUri:y=>{const z=o.filter(M=>M.name===y);if(z&&z.length>0)return z[0].uri},getWorkspaceFolderCount:()=>o.length,getConfigurationValue:(y,z)=>u.getConfiguration(void 0,y).get(z),getAppRoot:()=>b.cwd(),getExecPath:()=>b.env.VSCODE_EXEC_PATH,getFilePath:()=>{const y=O();if(y)return h.normalize(y.fsPath)},getWorkspaceFolderPathForFile:()=>{if(P){const y=O();if(y){const z=P.getWorkspaceFolder(y);if(z)return h.normalize(z.uri.fsPath)}}},getSelectedText:()=>{if(f){const y=f.activeEditor();if(y&&!y.selection.isEmpty)return y.document.getText(y.selection)}},getLineNumber:()=>{if(f){const y=f.activeEditor();if(y)return String(y.selection.end.line+1)}}},void 0,L?Promise.resolve(L):void 0,Promise.resolve(b.env))}}e.ExtHostVariableResolverService=E;class l{constructor(o){this.trackers=o}onWillStartSession(){this.trackers.forEach(o=>o.onWillStartSession?o.onWillStartSession():void 0)}onWillReceiveMessage(o){this.trackers.forEach(f=>f.onWillReceiveMessage?f.onWillReceiveMessage(o):void 0)}onDidSendMessage(o){this.trackers.forEach(f=>f.onDidSendMessage?f.onDidSendMessage(o):void 0)}onWillStopSession(){this.trackers.forEach(o=>o.onWillStopSession?o.onWillStopSession():void 0)}onError(o){this.trackers.forEach(f=>f.onError?f.onError(o):void 0)}onExit(o,f){this.trackers.forEach(u=>u.onExit?u.onExit(o,f):void 0)}}class i extends S.AbstractDebugAdapter{constructor(o){super();this.implementation=o,o.onDidSendMessage(f=>{this.acceptMessage(f)})}startSession(){return Promise.resolve(void 0)}sendMessage(o){this.implementation.handleMessage(o)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let r=class extends c{constructor(o,f,u,w,P,L){super(o,f,u,w,P,L)}createVariableResolver(o,f,u){return new E(o,f,u,this._editorTabs)}};r=Be([Fe(0,d.IExtHostRpcService),Fe(1,R.IExtHostWorkspace),Fe(2,F.IExtHostExtensionService),Fe(3,D.IExtHostDocumentsAndEditors),Fe(4,_.IExtHostConfiguration),Fe(5,a.IExtHostEditorTabs)],r),e.WorkerExtHostDebugService=r}),define(ve[270],we([1,0,70,2,5,37,30,27,16,26,4,40,41,11,8]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let d=class{constructor(m,s,E,l,i,r,t){this._apiFactory=m,this._extensionRegistry=s,this._instaService=E,this._extHostConfiguration=l,this._extHostExtensionService=i,this._initData=r,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),h.mark("code/extHost/willWaitForConfig");const m=await this._extHostConfiguration.getConfigProvider();h.mark("code/extHost/didWaitForConfig");const s=await this._extHostExtensionService.getExtensionPathIndex();this.register(new A(this._apiFactory,s,this._extensionRegistry,m,this._logService)),this.register(this._instaService.createInstance(b,s)),this.register(this._instaService.createInstance(v)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(a,s,this._initData.environment.appUriScheme))}register(m){if("nodeModuleName"in m)if(Array.isArray(m.nodeModuleName))for(let s of m.nodeModuleName)this._factories.set(s,m);else this._factories.set(m.nodeModuleName,m);typeof m.alternativeModuleName=="function"&&this._alternatives.push(s=>m.alternativeModuleName(s))}};d=Be([Fe(2,F.IInstantiationService),Fe(3,T.IExtHostConfiguration),Fe(4,D.IExtHostExtensionService),Fe(5,R.IExtHostInitDataService),Fe(6,_.ILogService)],d),e.RequireInterceptor=d;let v=class $i{constructor(m){if(m.environment.appRoot&&$i.aliased.size){const s=(0,g.escapeRegExpCharacters)(this.forceForwardSlashes(m.environment.appRoot.fsPath)),E="[a-z0-9_.-]",l=`@${E}+\\/${E}+|${E}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${s}/${i}\\/)(${l})(.*)$`,"i")}}alternativeModuleName(m){if(!this.re)return;const s=this.re.exec(this.forceForwardSlashes(m));if(!s)return;const[,E,l,i]=s,r=$i.aliased.get(l);if(r!==void 0)return console.warn(`${l} as been renamed to ${r}, please update your imports`),E+r+i}forceForwardSlashes(m){return m.replace(/\\/g,"/")}};v.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),v=Be([Fe(0,R.IExtHostInitDataService)],v);class A{constructor(m,s,E,l,i){this._apiFactory=m,this._extensionPaths=s,this._extensionRegistry=E,this._configProvider=l,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(m,s){const E=this._extensionPaths.findSubstr(s);if(E){let l=this._extApiImpl.get(k.ExtensionIdentifier.toKey(E.identifier));return l||(l=this._apiFactory(E,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(E.identifier),l)),l}if(!this._defaultApiImpl){let l="";this._extensionPaths.forEach((i,r)=>l+=`	${r} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${l}`),this._defaultApiImpl=this._apiFactory(C.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let b=class{constructor(m,s,E){this._extensionPaths=m,this.nodeModuleName="keytar",this._mainThreadTelemetry=s.getProxy(I.MainContext.MainThreadTelemetry);const{environment:l}=E,i=s.getProxy(I.MainContext.MainThreadKeytar);if(l.appRoot){let r=l.appRoot.fsPath;p.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,t)=>i.$getPassword(r,t),setPassword:(r,t,o)=>i.$setPassword(r,t,o),deletePassword:(r,t)=>i.$deletePassword(r,t),findPassword:r=>i.$findPassword(r),findCredentials(r){return i.$findCredentials(r)}}}load(m,s){const E=this._extensionPaths.findSubstr(s);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:E?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(m){const s=m.length;if(s<=7||!this.alternativeNames)return;const E=s-7;if((m.charAt(E)==="/"||m.charAt(E)==="\\")&&m.endsWith("keytar")&&(m=m.replace(/\\/g,"/"),this.alternativeNames.has(m)))return"keytar"}};b=Be([Fe(1,S.IExtHostRpcService),Fe(2,R.IExtHostInitDataService)],b);let a=class{constructor(m,s,E){this._extensionPaths=m,this._appUriScheme=s,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=E.getProxy(I.MainContext.MainThreadTelemetry);const l=E.getProxy(I.MainContext.MainThreadWindow);this._impl=(i,r)=>{const t=n.URI.parse(i);return r?this.callOriginal(i,r):t.scheme==="http"||t.scheme==="https"?l.$openUri(t,i,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?l.$openUri(t,i,{}):this.callOriginal(i,r)}}load(m,s,E){const l=this._extensionPaths.findSubstr(s);return l&&(this._extensionId=l.identifier.value,this.sendShimmingTelemetry()),this._original=E(m),this._impl}callOriginal(m,s){return this.sendNoForwardTelemetry(),this._original(m,s)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};a=Be([Fe(2,S.IExtHostRpcService)],a)}),define(ve[271],we([1,0,15,17,70,6,2,5,264,11,79,80,26,188,16,63,40,34]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_,g,d,v,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(c,m,s,E,l){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=s,this._rpcProtocol=new S.RPCProtocol(c,null,E),m=b._transform(m,this._rpcProtocol);const i=new D.ServiceCollection(...(0,F.getSingletonServiceDescriptors)());i.set(p.IExtHostInitDataService,{_serviceBrand:void 0,...m,messagePorts:l}),i.set(g.IExtHostRpcService,new g.ExtHostRpcService(this._rpcProtocol)),i.set(d.IURITransformerService,new d.URITransformerService(E)),i.set(v.IHostUtils,s);const r=new _.InstantiationService(i,!0);this._disposables.add(r.invokeFunction(u=>u.get(A.IExtHostTerminalService))),this._disposables.add(r.invokeFunction(u=>u.get(v.IExtHostExtensionService))),this._logService=r.invokeFunction(u=>u.get(R.ILogService)),I.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",m),this._extensionService=r.invokeFunction(u=>u.get(v.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const t=new WeakMap;this._extensionService.getExtensionPathIndex().then(u=>{Error.prepareStackTrace=(w,P)=>{let L="",O,y;for(const z of P)L+=`
	at ${z.toString()}`,y=z.getFileName(),!O&&y&&(O=u.findSubstr(C.URI.file(y)));return t.set(w,O),`${w.name||"Error"}: ${w.message||""}${L}`}});const o=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService),f=this._rpcProtocol.getProxy(k.MainContext.MainThreadErrors);n.setUnexpectedErrorHandler(u=>{const w=n.transformErrorForSerialization(u),P=t.get(u);P?o.$onExtensionRuntimeError(P.identifier,w):f.$onUnexpectedError(w)})}terminate(c){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${c}`),this._logService.flush(),this._disposables.dispose(),n.setUnexpectedErrorHandler(s=>{this._logService.error(s)}),this._rpcProtocol.dispose();const m=this._extensionService.deactivateAll();Promise.race([(0,h.timeout)(5e3),m]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(c,m){c.extensions.forEach(E=>E.extensionLocation=C.URI.revive(m.transformIncomingURIs(E.extensionLocation))),c.environment.appRoot=C.URI.revive(m.transformIncomingURIs(c.environment.appRoot));const s=c.environment.extensionDevelopmentLocationURI;return s&&(c.environment.extensionDevelopmentLocationURI=s.map(E=>C.URI.revive(m.transformIncomingURIs(E)))),c.environment.extensionTestsLocationURI=C.URI.revive(m.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=C.URI.revive(m.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=C.URI.revive(m.transformIncomingURIs(c.environment.workspaceStorageHome)),c.logsLocation=C.URI.revive(m.transformIncomingURIs(c.logsLocation)),c.logFile=C.URI.revive(m.transformIncomingURIs(c.logFile)),c.workspace=m.transformIncomingURIs(c.workspace),c}}e.ExtensionHostMain=b}),define(ve[272],we([1,0,173,60,12,7,211,36,40,45,37,34,16,54,195,15,212,53,187]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_,g,d,v,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.runInExternalTerminal=e.ExtHostDebugService=void 0;let a=class extends _.ExtHostDebugServiceBase{constructor(l,i,r,t,o,f,u){super(l,i,r,t,o,u);this._terminalService=f,this._integratedTerminalInstances=new s}createDebugAdapter(l,i){switch(l.type){case"server":return new C.SocketDebugAdapter(l);case"pipeServer":return new C.NamedPipeDebugAdapter(l);case"executable":return new C.ExecutableDebugAdapter(l,i.type)}return super.createDebugAdapter(l,i)}daExecutableFromPackage(l,i){const r=C.ExecutableDebugAdapter.platformAdapterExecutable(i.getAllExtensionDescriptions(),l.type);if(r)return new T.DebugAdapterExecutable(r.command,r.args,r.options)}createSignService(){return new g.SignService}async $runInTerminal(l,i){if(l.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(M=>{this._integratedTerminalInstances.onTerminalClosed(M)}));const r=await this._configurationService.getConfigProvider(),t=this._terminalService.getDefaultShell(!0),o=this._terminalService.getDefaultShellArgs(!0),f=l.title||h.localize(0,null),u=JSON.stringify({shell:t,shellArgs:o});let w=await this._integratedTerminalInstances.checkout(u,f),P,L=!1;if(w)P=l.cwd;else{const M={shellPath:t,shellArgs:o,cwd:l.cwd,name:f,iconPath:new T.ThemeIcon("debug")};L=!0,w=this._terminalService.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(w,u)}w.show(!0);const O=await w.processId;L?await new Promise(M=>setTimeout(M,1e3)):r.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(t.indexOf("powershell")>=0||t.indexOf("pwsh")>=0||t.indexOf("cmd.exe")>=0?w.sendText("cls"):t.indexOf("bash")>=0?w.sendText("clear"):I.isWindows?w.sendText("cls"):w.sendText("clear"));const y=(0,v.prepareCommand)(t,l.args,P,l.env);w.sendText(y);const z=this.onDidTerminateDebugSession(M=>{M.id===i&&(this._integratedTerminalInstances.free(w),z.dispose())});return O}else if(l.kind==="external")return m(l,await this._configurationService.getConfigProvider());return super.$runInTerminal(l,i)}createVariableResolver(l,i,r){return new _.ExtHostVariableResolverService(l,i,r,this._editorTabs,this._workspaceService,(0,n.homedir)())}};a=Be([Fe(0,p.IExtHostRpcService),Fe(1,k.IExtHostWorkspace),Fe(2,S.IExtHostExtensionService),Fe(3,R.IExtHostDocumentsAndEditors),Fe(4,F.IExtHostConfiguration),Fe(5,D.IExtHostTerminalService),Fe(6,A.IExtHostEditorTabs)],a),e.ExtHostDebugService=a;let c;function m(E,l){if(!c)if(I.isWindows)c=new b.WindowsExternalTerminalService;else if(I.isMacintosh)c=new b.MacExternalTerminalService;else if(I.isLinux)c=new b.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const i=l.getConfiguration("terminal");return c.runInTerminal(E.title,E.cwd,E.args,E.env||{},i.external||{})}e.runInExternalTerminal=m;class s{constructor(){this._terminalInstances=new Map}async checkout(l,i){const t=[...this._terminalInstances.entries()].map(([o,f])=>(0,d.createCancelablePromise)(async u=>{if(o.name!==i||f.lastUsedAt!==-1&&await(0,v.hasChildProcesses)(await o.processId))return null;const w=Date.now();return f.lastUsedAt+s.minUseDelay>w||u.isCancellationRequested||f.config!==l?null:(f.lastUsedAt=w,o)}));return await(0,d.firstParallel)(t,o=>!!o)}insert(l,i){this._terminalInstances.set(l,{lastUsedAt:Date.now(),config:i})}free(l){const i=this._terminalInstances.get(l);i&&(i.lastUsedAt=-1)}onTerminalClosed(l){this._terminalInstances.delete(l)}}s.minUseDelay=1e3}),define(ve[273],we([1,0,9,2,112,36,54,45,37,43,34,16,26,69,10,11,64,53,23,60]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_,g,d,v,A,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let c=class extends _.ExtHostTaskBase{constructor(s,E,l,i,r,t,o,f,u){super(s,E,l,i,r,t,o,f);this.workspaceService=l,this.editorTabs=u,E.remote.isRemote&&E.remote.authority?this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:E.remote.authority,platform:process.platform}):this.registerTaskSystem(g.Schemas.file,{scheme:g.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(s,E){const l=E;if(!E.execution&&l._id===void 0)throw new Error("Tasks to execute must include an execution");if(l._id!==void 0){const i=_.TaskHandleDTO.from(l,this.workspaceService),r=await this._proxy.$getTaskExecution(i);if(r.task===void 0)throw new Error("Task from execution DTO is undefined");const t=await this.getTaskExecution(r,E);return this._proxy.$executeTask(i).catch(()=>{}),t}else{const i=_.TaskDTO.from(E,s);if(i===void 0)return Promise.reject(new Error("Task is not valid"));_.CustomExecutionDTO.is(i.execution)&&await this.addCustomExecution(i,E,!1);const r=await this.getTaskExecution(await this._proxy.$getTaskExecution(i),E);return this._proxy.$executeTask(i).catch(()=>{}),r}}provideTasksInternal(s,E,l,i){const r=[];if(i)for(let t of i){this.checkDeprecation(t,l),(!t.definition||!s[t.definition.type])&&this._logService.warn(`The task [${t.source}, ${t.name}] uses an undefined task type. The task will be ignored in the future.`);const o=_.TaskDTO.from(t,l.extension);o&&(r.push(o),_.CustomExecutionDTO.is(o.execution)&&E.push(this.addCustomExecution(o,t,!0)))}return{tasks:r,extension:l.extension}}async resolveTaskInternal(s){return s}async getVariableResolver(s){if(this._variableResolver===void 0){const E=await this._configurationService.getConfigProvider();this._variableResolver=new C.ExtHostVariableResolverService(s,this._editorService,E,this.editorTabs,this.workspaceService,(0,a.homedir)())}return this._variableResolver}async getAFolder(s){let E=s&&s.length>0?s[0]:void 0;if(!E){const l=n.URI.file((0,a.homedir)());E=new R.WorkspaceFolder({uri:l,name:b.basename(l),index:0})}return{uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(s,E){const l=n.URI.revive(s),i={process:void 0,variables:Object.create(null)},r=await this._workspaceProvider.resolveWorkspaceFolder(l),t=await this._workspaceProvider.getWorkspaceFolders2()??[],o=await this.getVariableResolver(t),f=r?{uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(t);for(let u of E.variables)i.variables[u]=await o.resolveAsync(f,u);if(E.process!==void 0){let u;if(E.process.path!==void 0){u=E.process.path.split(h.delimiter);for(let w=0;w<u.length;w++)u[w]=await o.resolveAsync(f,u[w])}i.process=await I.win32.findExecutable(await o.resolveAsync(f,E.process.name),E.process.cwd!==void 0?await o.resolveAsync(f,E.process.cwd):void 0,u)}return i}async $jsonTasksSupported(){return!0}async $findExecutable(s,E,l){return I.win32.findExecutable(s,E,l)}};c=Be([Fe(0,D.IExtHostRpcService),Fe(1,p.IExtHostInitDataService),Fe(2,T.IExtHostWorkspace),Fe(3,k.IExtHostDocumentsAndEditors),Fe(4,S.IExtHostConfiguration),Fe(5,F.IExtHostTerminalService),Fe(6,d.ILogService),Fe(7,v.IExtHostApiDeprecationService),Fe(8,A.IExtHostEditorTabs)],c),e.ExtHostTask=c}),define(ve[137],we([1,0,18,15,21,49,32,10,9,23,13,2,31]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class _{constructor(c,m,s,E){this.query=c,this.provider=m,this.fileUtils=s,this.processType=E,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(c,m){const s=this.query.folderQueries||[],E=new I.CancellationTokenSource;return m.onCancellationRequested(()=>E.cancel()),new Promise((l,i)=>{this.collector=new d(c);let r=!1;const t=(o,f)=>{if(!r&&!this.isLimitHit){const u=this.resultSize(o);A(o)&&typeof this.query.maxResults=="number"&&this.resultCount+u>this.query.maxResults&&(this.isLimitHit=!0,r=!0,E.cancel(),o=this.trimResultToSize(o,this.query.maxResults-this.resultCount));const w=this.resultSize(o);this.resultCount+=w,(w>0||!A(o))&&this.collector.add(o,f)}};Promise.all(s.map((o,f)=>this.searchInFolder(o,u=>t(u,f),E.token))).then(o=>{E.dispose(),this.collector.flush();const f=o.some(u=>!!u&&!!u.limitHit);l({limitHit:this.isLimitHit||f,messages:(0,h.flatten)(o.map(u=>u?.message?(0,F.isArray)(u.message)?u.message:[u.message]:[])),stats:{type:this.processType}})},o=>{E.dispose();const f=(0,T.toErrorMessage)(o);i(new Error(f))})})}resultSize(c){return A(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}trimResultToSize(c,m){const s=Array.isArray(c.ranges)?c.ranges:[c.ranges],E=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:s.slice(0,m),preview:{matches:E.slice(0,m),text:c.preview.text},uri:c.uri}}async searchInFolder(c,m,s){const E=new p.QueryGlobTester(this.query,c),l=[],i={report:o=>{if(!this.validateProviderResult(o))return;const f=c.folder.scheme===k.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(R.dirname(o.uri))):void 0,u=R.relativePath(c.folder,o.uri);if(u){const w=E.includedInQuery(u,S.basename(u),f);(0,n.isThenable)(w)?l.push(w.then(P=>{P&&m(o)})):w&&m(o)}}},r=this.getSearchOptionsForFolder(c),t=await this.provider.provideTextSearchResults(g(this.query.contentPattern),r,i,s);return l.length&&await Promise.all(l),t}validateProviderResult(c){if(A(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(c){const m=(0,p.resolvePatternsForProvider)(this.query.includePattern,c.includePattern),s=(0,p.resolvePatternsForProvider)(this.query.excludePattern,c.excludePattern),E={folder:D.URI.from(c.folder),excludes:s,includes:m,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.fileUtils.toCanonicalName(c.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return E.usePCRE2=this.query.usePCRE2,E}}e.TextSearchManager=_;function g(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class d{constructor(c){this._onResult=c,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new b(512,m=>this.sendItems(m))}add(c,m){this._currentFileMatch&&(this._currentFolderIdx!==m||!R.isEqual(this._currentUri,c.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=m,this._currentFileMatch={resource:c.uri,results:[]}),this._currentFileMatch.results.push(v(c))}pushToCollector(){const c=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,c)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(c){this._onResult(c)}}e.TextSearchResultsCollector=d;function v(a){return A(a)?{preview:{matches:(0,h.mapArrayOrNot)(a.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:a.preview.text},ranges:(0,h.mapArrayOrNot)(a.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function A(a){return!!a.preview}e.extensionResultIsMatch=A;class b{constructor(c,m){this.maxBatchSize=c,this.cb=m,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(c,m){!c||this.addItemToBatch(c,m)}addItems(c,m){!c||this.addItemsToBatch(c,m)}addItemToBatch(c,m){this.batch.push(c),this.batchSize+=m,this.onUpdate()}addItemsToBatch(c,m){this.batch=this.batch.concat(c),this.batchSize+=m,this.onUpdate()}onUpdate(){this.totalNumberCompleted<b.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},b.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=b,b.TIMEOUT=4e3,b.START_BATCH_AFTER_COUNT=50}),define(ve[71],we([1,0,6,5,4,267,16,63,11,2,137]),function(ee,e,h,n,I,T,C,k,S,R,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let D=class{constructor(d,v,A){this.extHostRpc=d,this._uriTransformer=v,this._logService=A,this._proxy=this.extHostRpc.getProxy(n.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}registerTextSearchProvider(d,v){if(this._textSearchUsedSchemes.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this._textSearchUsedSchemes.add(d);const A=this._handlePool++;return this._textSearchProvider.set(A,v),this._proxy.$registerTextSearchProvider(A,this._transformScheme(d)),(0,h.toDisposable)(()=>{this._textSearchUsedSchemes.delete(d),this._textSearchProvider.delete(A),this._proxy.$unregisterProvider(A)})}registerFileSearchProvider(d,v){if(this._fileSearchUsedSchemes.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this._fileSearchUsedSchemes.add(d);const A=this._handlePool++;return this._fileSearchProvider.set(A,v),this._proxy.$registerFileSearchProvider(A,this._transformScheme(d)),(0,h.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(d),this._fileSearchProvider.delete(A),this._proxy.$unregisterProvider(A)})}$provideFileSearchResults(d,v,A,b){const a=p(A),c=this._fileSearchProvider.get(d);if(c)return this._fileSearchManager.fileSearch(a,c,m=>{this._proxy.$handleFileMatch(d,v,m.map(s=>s.resource))},b);throw new Error("unknown provider: "+d)}$clearCache(d){return this._fileSearchManager.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,v,A,b){const a=this._textSearchProvider.get(d);if(!a||!a.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const c=p(A);return this.createTextSearchManager(c,a).search(s=>this._proxy.$handleTextMatch(d,v,s),b)}$enableExtensionHostSearch(){}createTextSearchManager(d,v){return new F.TextSearchManager(d,v,{readdir:A=>Promise.resolve([]),toCanonicalName:A=>A},"textSearchProvider")}};D=Be([Fe(0,C.IExtHostRpcService),Fe(1,k.IURITransformerService),Fe(2,S.ILogService)],D),e.ExtHostSearch=D;function p(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(_),extraFileResources:g.extraFileResources&&g.extraFileResources.map(d=>R.URI.revive(d))}}e.reviveQuery=p;function _(g){return{...g,folder:R.URI.revive(g.folder)}}}),define(ve[274],we([1,0,79,135,36,133,37,39,45,34,69,54,71,87,51,64,136,65,44,86,124,53,134,11,226]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_,g,d,v,A,b,a,c,m,s,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,h.registerSingleton)(E.ILoggerService,s.ExtHostLoggerService),(0,h.registerSingleton)(E.ILogService,l.ExtHostLogService),(0,h.registerSingleton)(d.IExtHostApiDeprecationService,d.ExtHostApiDeprecationService),(0,h.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,h.registerSingleton)(C.IExtHostConfiguration,C.ExtHostConfiguration),(0,h.registerSingleton)(A.IExtHostConsumerFileSystem,A.ExtHostConsumerFileSystem),(0,h.registerSingleton)(D.IExtHostDebugService,D.WorkerExtHostDebugService),(0,h.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,h.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,h.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo),(0,h.registerSingleton)(n.IExtHostOutputService,n.ExtHostOutputService),(0,h.registerSingleton)(p.IExtHostSearch,p.ExtHostSearch),(0,h.registerSingleton)(_.IExtHostStorage,_.ExtHostStorage),(0,h.registerSingleton)(F.IExtHostTask,F.WorkerExtHostTask),(0,h.registerSingleton)(R.IExtHostTerminalService,R.WorkerExtHostTerminalService),(0,h.registerSingleton)(g.IExtHostTunnelService,g.ExtHostTunnelService),(0,h.registerSingleton)(v.IExtHostWindow,v.ExtHostWindow),(0,h.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace),(0,h.registerSingleton)(a.IExtHostSecretState,a.ExtHostSecretState),(0,h.registerSingleton)(c.IExtHostTelemetry,c.ExtHostTelemetry),(0,h.registerSingleton)(m.IExtHostEditorTabs,m.ExtHostEditorTabs)}),define(ve[88],we([1,0,18,11,31,68]),function(ee,e,h,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function C(D){return D.startsWith("**")||D.startsWith("/")?D:`/${D}`}e.anchorGlob=C;function k(D,p,_,g){const d=(0,h.mapArrayOrNot)(_,S),v=new I.TextSearchMatch(p,d,g),A=v.preview.matches;return{ranges:(0,h.mapArrayOrNot)(d,R),uri:D,preview:{text:v.preview.text,matches:(0,h.mapArrayOrNot)(A,R)}}}e.createTextSearchResult=k;function S(D){return new I.SearchRange(D.start.line,D.start.character,D.end.line,D.end.character)}function R(D){return new T.Range(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn)}let F=class{constructor(p,_){this.prefix=p,this.logService=_}appendLine(p){this.logService.debug(`${this.prefix}#search`,p)}};F=Be([Fe(1,n.ILogService)],F),e.OutputChannel=F}),define(ve[275],we([1,0,38,9,77,29,12,8,88,276]),function(ee,e,h,n,I,T,C,k,S,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const F=R.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function D(a,c,m,s){const E=p(a,c,m,s),l=c.folder.fsPath;return{cmd:h.spawn(F,E.args,{cwd:l}),rgDiskPath:F,siblingClauses:E.siblingClauses,rgArgs:E,cwd:l}}e.spawnRipgrepCmd=D;function p(a,c,m,s){const E=["--files","--hidden","--case-sensitive"];g([c],m,!1).forEach(i=>{const r=(0,S.anchorGlob)(i);if(E.push("-g",r),C.isMacintosh){const t=(0,I.normalizeNFD)(r);t!==r&&E.push("-g",t)}});const l=_([c],s,void 0,!1);return l.globArgs.forEach(i=>{const r=`!${(0,S.anchorGlob)(i)}`;if(E.push("-g",r),C.isMacintosh){const t=(0,I.normalizeNFD)(r);t!==r&&E.push("-g",t)}}),c.disregardIgnoreFiles!==!1?E.push("--no-ignore"):c.disregardParentIgnoreFiles!==!1&&E.push("--no-ignore-parent"),c.ignoreSymlinks||E.push("--follow"),a.exists&&E.push("--quiet"),E.push("--no-config"),c.disregardGlobalIgnoreFiles&&E.push("--no-ignore-global"),{args:E,siblingClauses:l.siblingClauses}}function _(a,c,m,s=!0){const E=[];let l={};return a.forEach(i=>{const r=Object.assign({},i.excludePattern||{},c||{}),t=d(r,s?i.folder.fsPath:void 0,m);E.push(...t.globArgs),t.siblingClauses&&(l=Object.assign(l,t.siblingClauses))}),{globArgs:E,siblingClauses:l}}e.foldersToRgExcludeGlobs=_;function g(a,c,m=!0){const s=[];return a.forEach(E=>{const l=Object.assign({},c||{},E.includePattern||{}),i=d(l,m?E.folder.fsPath:void 0);s.push(...i.globArgs)}),s}e.foldersToIncludeGlobs=g;function d(a,c,m){const s=[],E={};return Object.keys(a).forEach(l=>{if(m&&m.has(l)||!l)return;const i=a[l];l=A(c?v(c,l):l),l.startsWith("\\\\")?l="\\\\"+l.substr(2).replace(/\\/g,"/"):l=l.replace(/\\/g,"/"),typeof i=="boolean"&&i?(l.startsWith("\\\\")&&(l+="**"),s.push(b(l))):i&&i.when&&(E[l]=i)}),{globArgs:s,siblingClauses:E}}function v(a,c){return n.isAbsolute(c)?c:n.join(a,c)}e.getAbsoluteGlob=v;function A(a){return a=k.rtrim(a,"\\"),k.rtrim(a,"/")}function b(a){return T.getRoot(a).toLowerCase()==="c:/"?a.replace(/^c:[/\\]/i,"/"):a}e.fixDriveC=b}),define(ve[277],we([1,0,38,59,9,102,18,49,32,77,29,12,46,8,13,28,31,275,98]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_,g,d,v,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const a=new Set;process.on("exit",()=>{a.forEach(l=>l())});class c{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&S.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,b.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&S.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(r=>{const t=Object.assign({},r.excludePattern||{},this.config.excludePattern||{}),o=r.folder.fsPath;i.folderQueries.map(f=>f.folder.fsPath).filter(f=>f!==o).forEach(f=>{(0,F.isEqualOrParent)(f,o)&&(t[I.relative(o,f)]=!0)}),this.folderExcludePatterns.set(o,new s(t,o))})}cancel(){this.isCanceled=!0,a.forEach(i=>i())}walk(i,r,t,o,f){if(this.fileWalkSW=p.StopWatch.create(!1),this.isCanceled)return f(null,this.isLimitHit);r.forEach(u=>{const w=I.basename(u.fsPath);this.globalExcludePattern&&this.globalExcludePattern(u.fsPath,w)||this.matchFile(t,{relativePath:u.fsPath,searchPath:void 0})}),this.cmdSW=p.StopWatch.create(!1),this.parallel(i,(u,w)=>{this.call(this.cmdTraversal,this,u,t,o,P=>{if(P){const L=(0,k.toErrorMessage)(P);console.error(L),this.errors.push(L),w(P,void 0)}else w(null,void 0)})},(u,w)=>{this.fileWalkSW.stop();const P=u?C.coalesce(u)[0]:null;f(P,this.isLimitHit)})}parallel(i,r,t){const o=new Array(i.length),f=new Array(i.length);let u=!1,w=0;if(i.length===0)return t(null,[]);i.forEach((P,L)=>{r(P,(O,y)=>{if(O?(u=!0,o[L]=null,f[L]=O):(o[L]=y,f[L]=null),++w===i.length)return t(u?f:null,o)})})}call(i,r,...t){try{i.apply(r,t)}catch(o){t[t.length-1](o)}}cmdTraversal(i,r,t,o){const f=i.folder.fsPath,u=D.isMacintosh;let w;const P=()=>w&&w.kill();a.add(P);let L=Y=>{a.delete(P),L=()=>{},o(Y)},O="";const y=this.initDirectoryTree();let z;const M=(0,A.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression);w=M.cmd,z=!Object.keys(M.siblingClauses).length;const B=M.rgArgs.args.map(Y=>Y.match(/^-/)?Y:`'${Y}'`).join(" ");let V=`${M.rgDiskPath} ${B}
 - cwd: ${M.cwd}`;M.rgArgs.siblingClauses&&(V+=`
 - Sibling clauses: ${JSON.stringify(M.rgArgs.siblingClauses)}`),t({message:V}),this.cmdResultCount=0,this.collectStdout(w,"utf8",t,(Y,H,q)=>{if(Y){L(Y);return}if(this.isLimitHit){L();return}const G=(O+(u?R.normalizeNFC(H||""):H)).split(`
`);if(q){const ie=G.length;G[ie-1]=G[ie-1].trim(),G[ie-1]||G.pop()}else O=G.pop()||"";if(G.length&&G[0].indexOf(`
`)!==-1){L(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=G.length,z){for(const ie of G)if(this.matchFile(r,{base:f,relativePath:ie,searchPath:this.getSearchPath(i,ie)}),this.isLimitHit){P();break}(q||this.isLimitHit)&&L();return}this.addDirectoryEntries(i,y,f,G,r),q&&(this.matchDirectoryTree(y,f,r),L())})}spawnFindCmd(i){const r=this.folderExcludePatterns.get(i.folder.fsPath),t=r.getBasenameTerms(),o=r.getPathTerms(),f=["-L","."];if(t.length||o.length){f.push("-not","(","(");for(const u of t)f.push("-name",u),f.push("-o");for(const u of o)f.push("-path",u),f.push("-o");f.pop(),f.push(")","-prune",")")}return f.push("-type","f"),h.spawn("find",f,{cwd:i.folder.fsPath})}readStdout(i,r,t){let o="";this.collectStdout(i,r,()=>{},(f,u,w)=>{if(f){t(f);return}o+=u,w&&t(null,o)})}collectStdout(i,r,t,o){let f=(P,L,O)=>{(P||O)&&(f=()=>{},this.cmdSW&&this.cmdSW.stop()),o(P,L,O)},u=!1;i.stdout?(this.forwardData(i.stdout,r,f),i.stdout.once("data",()=>u=!0)):t({message:"stdout is null"});let w;i.stderr?w=this.collectData(i.stderr):t({message:"stderr is null"}),i.on("error",P=>{f(P)}),i.on("close",P=>{let L;!u&&(L=this.decodeData(w,r))&&E(L)?f(new Error(`command failed with error code ${P}: ${this.decodeData(w,r)}`)):(this.exists&&P===0&&(this.isLimitHit=!0),f(null,"",!0))})}forwardData(i,r,t){const o=new T.StringDecoder(r);return i.on("data",f=>{t(null,o.write(f))}),o}collectData(i){const r=[];return i.on("data",t=>{r.push(t)}),r}decodeData(i,r){const t=new T.StringDecoder(r);return i.map(o=>t.write(o)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:r},t,o,f){o.indexOf(this.filePattern)!==-1&&this.matchFile(f,{base:t,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const u=w=>{const P=I.basename(w),L=I.dirname(w);let O=r[L];O||(O=r[L]=[],u(L)),O.push({base:t,relativePath:w,basename:P,searchPath:this.getSearchPath(i,w)})};o.forEach(u)}matchDirectoryTree({rootEntries:i,pathToEntries:r},t,o){const f=this,u=this.folderExcludePatterns.get(t),w=this.filePattern;function P(L){f.directoriesWalked++;const O=S.hasSiblingFn(()=>L.map(y=>y.basename));for(let y=0,z=L.length;y<z;y++){const M=L[y],{relativePath:B,basename:V}=M;if(u.test(B,V,w!==V?O:void 0))continue;const Y=r[B];if(Y)P(Y);else{if(f.filesWalked++,B===w)continue;f.matchFile(o,M)}if(f.isLimitHit)break}}P(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,r,t,o,f){const u=i.folder,w=S.hasSiblingFn(()=>t);this.parallel(t,(P,L)=>{if(this.isCanceled||this.isLimitHit)return L(null);const O=r?[r,P].join(I.sep):P;if(this.folderExcludePatterns.get(i.folder.fsPath).test(O,P,this.config.filePattern!==P?w:void 0))return L(null);const y=[u.fsPath,O].join(I.sep);n.lstat(y,(z,M)=>{if(z||this.isCanceled||this.isLimitHit)return L(null);this.statLinkIfNeeded(y,M,(B,V)=>B||this.isCanceled||this.isLimitHit?L(null):V.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(y,M,(Y,H)=>Y||this.isCanceled||this.isLimitHit||(H=H||"",this.walkedPaths[H])?L(null):(this.walkedPaths[H]=!0,d.Promises.readdir(y).then(q=>{if(this.isCanceled||this.isLimitHit)return L(null);this.doWalk(i,O,q,o,K=>L(K||null))},q=>{L(null)})))):(this.filesWalked++,O===this.filePattern||this.maxFilesize&&g.isNumber(V.size)&&V.size>this.maxFilesize||this.matchFile(o,{base:u.fsPath,relativePath:O,searchPath:this.getSearchPath(i,O)}),L(null,void 0)))})},P=>{const L=P&&C.coalesce(P);return f(L&&L.length>0?L[0]:void 0)})}matchFile(i,r){this.isFileMatch(r)&&(!this.includePattern||this.includePattern(r.relativePath,I.basename(r.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(r))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,v.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,r,t){return r.isSymbolicLink()?n.stat(i,t):t(null,r)}realPathIfNeeded(i,r,t){return r.isSymbolicLink()?n.realpath(i,(o,f)=>o?t(o):t(null,f)):t(null,i)}getSearchPath(i,r){return i.folderName?I.join(i.folderName,r):r}}e.FileWalker=c;class m{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new c(i)}search(i,r,t){this.walker.walk(this.folderQueries,this.extraFiles,i,r,(o,f)=>{t(o,{limitHit:f,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=m;class s{constructor(i,r){this.expression=i,this.root=r,this.init(i)}init(i){let r,t;Object.keys(i).filter(o=>i[o]).forEach(o=>{I.isAbsolute(o)?(r=r||S.getEmptyExpression(),r[o]=i[o]):(t=t||S.getEmptyExpression(),t[o]=i[o])}),this.absoluteParsedExpr=r&&S.parse(r,{trimForExclusions:!0}),this.relativeParsedExpr=t&&S.parse(t,{trimForExclusions:!0})}test(i,r,t){return this.relativeParsedExpr&&this.relativeParsedExpr(i,r,t)||this.absoluteParsedExpr&&this.absoluteParsedExpr(I.join(this.root,i),r,t)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...S.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...S.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...S.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...S.getPathTerms(this.relativeParsedExpr)),i}}function E(l){const i=l.trim().split(`
`),r=i[0].trim();if(r.startsWith("Error parsing regex"))return r;if(r.startsWith("regex parse error"))return _.uppercaseFirstLetter(i[i.length-1].trim());if(r.startsWith("error parsing glob")||r.startsWith("unsupported encoding"))return r.charAt(0).toUpperCase()+r.substr(1);if(r==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(r.startsWith("Literal "))return r}e.rgErrorMsgForDisplay=E}),define(ve[278],we([1,0,94,22]),function(ee,e,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function I(l){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(i=>i===l)}e.isUTFEncoding=I,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const T=512,C=512,k=512*8,S=512*128;var R;(function(l){l[l.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(R=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class F extends Error{constructor(i,r){super(i);this.decodeStreamErrorKind=r}}e.DecodeStreamError=F;class D{constructor(i){this.iconvLiteDecoder=i}static async create(i){let r;if(i!==e.UTF8)r=(await new Promise((o,f)=>{ee(["@vscode/iconv-lite-umd"],o,f)})).getDecoder(d(i));else{const t=new TextDecoder;r={write(o){return t.decode(o,{stream:!0})},end(){return t.decode()}}}return new D(r)}write(i){return this.iconvLiteDecoder.write(i)}end(){return this.iconvLiteDecoder.end()}}function p(l,i){const r=i.minBytesRequiredForDetection??i.guessEncoding?k:C;return new Promise((t,o)=>{const f=(0,h.newWriteableStream)(y=>y.join("")),u=[];let w=0,P,L;const O=async()=>{try{const y=await E({buffer:n.VSBuffer.concat(u),bytesRead:w},i.guessEncoding);if(y.seemsBinary&&i.acceptTextOnly)throw new F("Stream is binary but only text is accepted for decoding",1);y.encoding=await i.overwriteEncoding(y.encoding),P=await D.create(y.encoding);const z=P.write(n.VSBuffer.concat(u).buffer);f.write(z),u.length=0,w=0,t({stream:f,detected:y})}catch(y){L?.dispose(),f.destroy(),o(y)}};L=(0,h.listenStream)(l,{onData:async y=>{P?f.write(P.write(y.buffer)):(u.push(y),w+=y.byteLength,w>=r&&(l.pause(),await O(),setTimeout(()=>l.resume())))},onError:y=>f.error(y),onEnd:async()=>{P||await O(),f.end(P?.end())}})})}e.toDecodeStream=p;async function _(l,i,r){const o=(await new Promise((w,P)=>{ee(["@vscode/iconv-lite-umd"],w,P)})).getEncoder(d(i),r);let f=!1,u=!1;return{read(){if(u)return null;const w=l.read();if(typeof w!="string"){if(u=!0,!f&&r?.addBOM)switch(i){case e.UTF8:case e.UTF8_with_bom:return n.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return n.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return n.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const P=o.end();return P&&P.length>0?(f=!0,n.VSBuffer.wrap(P)):null}return f=!0,n.VSBuffer.wrap(o.write(w))}}}e.toEncodeReadable=_;async function g(l){return(await new Promise((r,t)=>{ee(["@vscode/iconv-lite-umd"],r,t)})).encodingExists(d(l))}e.encodingExists=g;function d(l){return l===e.UTF8_with_bom||l===null?e.UTF8:l}e.toNodeEncoding=d;function v(l,i){if(!l||i<e.UTF16be_BOM.length)return null;const r=l.readUInt8(0),t=l.readUInt8(1);if(r===e.UTF16be_BOM[0]&&t===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&t===e.UTF16le_BOM[1])return e.UTF16le;if(i<e.UTF8_BOM.length)return null;const o=l.readUInt8(2);return r===e.UTF8_BOM[0]&&t===e.UTF8_BOM[1]&&o===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=v;const A=["ascii","utf-16","utf-32"];async function b(l){const i=await new Promise((u,w)=>{ee(["jschardet"],u,w)}),r=l.slice(0,S),t=m(r.buffer),o=i.detect(t);if(!o||!o.encoding)return null;const f=o.encoding.toLowerCase();return 0<=A.indexOf(f)?null:c(o.encoding)}const a={ibm866:"cp866",big5:"cp950"};function c(l){const i=l.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return a[i]||i}function m(l){let i="";for(let r=0;r<l.length;r++)i+=String.fromCharCode(l[r]);return i}function s(l){switch(l){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const i=l.match(/windows(\d+)/);return i?"windows-"+i[1]:l}}}e.toCanonicalName=s;function E({buffer:l,bytesRead:i},r){let t=v(l,i),o=!1;if(t!==e.UTF16be&&t!==e.UTF16le&&l){let f=!0,u=!0,w=!1;for(let P=0;P<i&&P<T;P++){const L=P%2==1,O=l.readUInt8(P)===0;if(O&&(w=!0),f&&(L&&!O||!L&&O)&&(f=!1),u&&(L&&O||!L&&!O)&&(u=!1),O&&!f&&!u)break}w&&(f?t=e.UTF16le:u?t=e.UTF16be:o=!0)}return r&&!o&&!t&&l?b(l.slice(0,i)).then(f=>({seemsBinary:!1,encoding:f})):{seemsBinary:o,encoding:t}}e.detectEncodingFromBuffer=E,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ve[138],we([1,0,278,28,137]),function(ee,e,h,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class T extends I.TextSearchManager{constructor(k,S,R=n,F="searchProcess"){super(k,S,{readdir:D=>R.Promises.readdir(D.fsPath),toCanonicalName:D=>(0,h.toCanonicalName)(D)},F)}}e.NativeTextSearchManager=T}),define(ve[279],we([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class h{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(I){if(I&&this._dragOperations.has(I)){const T=this._dragOperations.get(I);return this._dragOperations.delete(I),T}}addDragOperationTransfer(I,T){this._dragOperations.set(I,T)}getRenderedTreeElement(I){if(this._renderedElements.has(I))return this._renderedElements.get(I)}addRenderedTreeItemElement(I,T){this._renderedElements.set(I,T)}removeRenderedTreeItemElement(I){this._renderedElements.has(I)&&this._renderedElements.delete(I)}}e.TreeviewsService=h}),define(ve[280],we([1,0,171,23,2,3,6,15,7,13,18,14,21,205,279]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function d(b,a){if((0,R.isString)(b))return{label:b};if(b&&typeof b=="object"&&typeof b.label=="string"){let c;return Array.isArray(b.highlights)&&(c=b.highlights.filter(m=>m.length===2&&typeof m[0]=="number"&&typeof m[1]=="number"),c=c.length?c:void 0),{label:b.label,highlights:c}}}class v{constructor(a,c,m){this._proxy=a,this.commands=c,this.logService=m,this.treeViews=new Map,this.treeDragAndDropService=new g.TreeviewsService;function s(E){return E&&E.$treeViewId&&E.$treeItemHandle}c.registerArgumentProcessor({processArgument:E=>s(E)?this.convertArgument(E):Array.isArray(E)&&E.length>0?E.map(l=>s(l)?this.convertArgument(l):l):E})}registerTreeDataProvider(a,c,m){const s=this.createTreeView(a,{treeDataProvider:c},m);return{dispose:()=>s.dispose()}}createTreeView(a,c,m){if(!c||!c.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=c.dragAndDropController?.dropMimeTypes??[],E=c.dragAndDropController?.dragMimeTypes??[],l=!!c.dragAndDropController?.handleDrag,i=!!c.dragAndDropController?.handleDrop,r=this._proxy.$registerTreeViewDataProvider(a,{showCollapseAll:!!c.showCollapseAll,canSelectMany:!!c.canSelectMany,dropMimeTypes:s,dragMimeTypes:E,hasHandleDrag:l,hasHandleDrop:i}),t=this.createExtHostTreeView(a,c,m);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(o){t.message=o},get title(){return t.title},set title(o){t.title=o},get description(){return t.description},set description(o){t.description=o},reveal:(o,f)=>t.reveal(o,f),dispose:async()=>{await r,this.treeViews.delete(a),t.dispose()}}}$getChildren(a,c){const m=this.treeViews.get(a);return m?m.getChildren(c):Promise.reject(new Error((0,h.localize)(0,null,a)))}async $handleDrop(a,c,m,s,E,l,i){const r=this.treeViews.get(a);if(!r)return Promise.reject(new Error((0,h.localize)(1,null,a)));const t=_.TreeDataTransferConverter.toITreeDataTransfer(c);return l===a&&i&&await this.addAdditionalTransferItems(t,r,i,s,E),r.onDrop(t,m,s)}async addAdditionalTransferItems(a,c,m,s,E){const l=this.treeDragAndDropService.removeDragOperationTransfer(E);if(l)(await l)?.forEach((i,r)=>{i&&a.set(r,i)});else if(E&&c.handleDrag){const i=c.handleDrag(m,a,s);this.treeDragAndDropService.addDragOperationTransfer(E,i),await i}return a}async $handleDrag(a,c,m,s){const E=this.treeViews.get(a);if(!E)return Promise.reject(new Error((0,h.localize)(2,null,a)));const l=await this.addAdditionalTransferItems(new Map,E,c,s,m);if(!!l)return _.TreeDataTransferConverter.toTreeDataTransferDTO(l)}async $hasResolve(a){const c=this.treeViews.get(a);if(!c)throw new Error((0,h.localize)(3,null,a));return c.hasResolve}$resolve(a,c,m){const s=this.treeViews.get(a);if(!s)throw new Error((0,h.localize)(4,null,a));return s.resolveTreeItem(c,m)}$setExpanded(a,c,m){const s=this.treeViews.get(a);if(!s)throw new Error((0,h.localize)(5,null,a));s.setExpanded(c,m)}$setSelection(a,c){const m=this.treeViews.get(a);if(!m)throw new Error((0,h.localize)(6,null,a));m.setSelection(c)}$setVisible(a,c){const m=this.treeViews.get(a);if(!m)throw new Error((0,h.localize)(7,null,a));m.setVisible(c)}createExtHostTreeView(a,c,m){const s=new A(a,c,this._proxy,this.commands.converter,this.logService,m);return this.treeViews.set(a,s),s}convertArgument(a){const c=this.treeViews.get(a.$treeViewId);return c?c.getExtensionElement(a.$treeItemHandle):null}}e.ExtHostTreeViews=v;class A extends C.Disposable{constructor(a,c,m,s,E,l){super();if(this.viewId=a,this.proxy=m,this.commands=s,this.logService=E,this.extension=l,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new p.CancellationTokenSource,l.contributes&&l.contributes.views)for(const t in l.contributes.views)for(const o of l.contributes.views[t])o.id===a&&(this._title=o.name);this.dataProvider=c.treeDataProvider,this.dndController=c.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(t=>this._onDidChangeData.fire({message:!1,element:t}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(t=>this._onDidChangeData.fire({message:!1,element:t})));let i,r;this._register(T.Event.debounce(this._onDidChangeData.event,(t,o)=>(t||(t={message:!1,elements:[]}),o.element!==!1&&(i||(i=new Promise(f=>r=f),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(o.element)?t.elements.push(...o.element):t.elements.push(o.element)),o.message&&(t.message=!0),t),200,!0)(({message:t,elements:o})=>{o.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const f=r;return i=null,this.refresh(o).then(()=>f())})),t&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(a=>this.getExtensionElement(a)).filter(a=>!(0,R.isUndefinedOrNull)(a))}async getChildren(a){const c=a?this.getExtensionElement(a):void 0;if(a&&!c)return this.logService.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let m=this.getChildrenNodes(a);return m||(m=await this.fetchChildrenNodes(c)),m?m.map(s=>s.item):void 0}getExtensionElement(a){return this.elements.get(a)}reveal(a,c){c=c||{select:!0,focus:!1};const m=(0,R.isUndefinedOrNull)(c.select)?!0:c.select,s=(0,R.isUndefinedOrNull)(c.focus)?!1:c.focus,E=(0,R.isUndefinedOrNull)(c.expand)?!1:c.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.refreshPromise.then(()=>this.resolveUnknownParentChain(a)).then(l=>this.resolveTreeNode(a,l[l.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:l.map(r=>r.item)},{select:m,focus:s,expand:E})),l=>this.logService.error(l)):this.proxy.$reveal(this.viewId,void 0,{select:m,focus:s,expand:E})}get message(){return this._message}set message(a){this._message=a,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(a){this._title=a,this.proxy.$setTitle(this.viewId,a,this._description)}get description(){return this._description}set description(a){this._description=a,this.proxy.$setTitle(this.viewId,this._title,a)}setExpanded(a,c){const m=this.getExtensionElement(a);m&&(c?this._onDidExpandElement.fire(Object.freeze({element:m})):this._onDidCollapseElement.fire(Object.freeze({element:m})))}setSelection(a){(0,F.equals)(this._selectedHandles,a)||(this._selectedHandles=a,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(a){a!==this._visible&&(this._visible=a,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(a,c,m){const s=[];for(const E of a){const l=this.getExtensionElement(E);l&&s.push(l)}if(!(!this.dndController?.handleDrag||s.length===0))return await this.dndController.handleDrag(s,c,m),c}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(a,c,m){const s=this.getExtensionElement(c);if(!(!s||!this.dndController?.handleDrop))return(0,k.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(s,a,m):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(a,c){if(!this.dataProvider.resolveTreeItem)return;const m=this.elements.get(a);if(m){const s=this.nodes.get(m);if(s){const E=await this.dataProvider.resolveTreeItem(s.extensionItem,m,c)??s.extensionItem;return s.item.tooltip=this.getTooltip(E.tooltip),s.item.command=this.getCommand(s.disposableStore,E.command),s.item}}}resolveUnknownParentChain(a){return this.resolveParent(a).then(c=>c?this.resolveUnknownParentChain(c).then(m=>this.resolveTreeNode(c,m[m.length-1]).then(s=>(m.push(s),m))):Promise.resolve([]))}resolveParent(a){const c=this.nodes.get(a);return c?Promise.resolve(c.parent?this.elements.get(c.parent.item.handle):void 0):(0,k.asPromise)(()=>this.dataProvider.getParent(a))}resolveTreeNode(a,c){const m=this.nodes.get(a);return m?Promise.resolve(m):(0,k.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(s=>this.createHandle(a,s,c,!0)).then(s=>this.getChildren(c?c.item.handle:void 0).then(()=>{const E=this.getExtensionElement(s);if(E){const l=this.nodes.get(E);if(l)return Promise.resolve(l)}throw new Error(`Cannot resolve tree item for element ${s}`)}))}getChildrenNodes(a){if(a){let c;if(typeof a=="string"){const m=this.getExtensionElement(a);c=m?this.nodes.get(m):void 0}else c=a;return c&&c.children||void 0}return this.roots}async fetchChildrenNodes(a){this.clearChildren(a);const c=new p.CancellationTokenSource(this._refreshCancellationSource.token);try{const m=a?this.nodes.get(a):void 0,s=await this.dataProvider.getChildren(a);if(c.token.isCancellationRequested)return;const E=await Promise.all((0,F.coalesce)(s||[]).map(async l=>{const i=await this.dataProvider.getTreeItem(l);return i&&!c.token.isCancellationRequested?this.createAndRegisterTreeNode(l,i,m):null}));return c.token.isCancellationRequested?void 0:(0,F.coalesce)(E)}finally{c.dispose()}}refresh(a){if(a.some(m=>!m))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new p.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const m=this.getHandlesToRefresh(a);if(m.length)return this.refreshHandles(m)}return Promise.resolve(void 0)}getHandlesToRefresh(a){const c=new Set,m=a.map(E=>this.nodes.get(E));for(const E of m)if(E&&!c.has(E.item.handle)){let l=E;for(;l&&l.parent&&m.findIndex(i=>l&&l.parent&&i&&i.item.handle===l.parent.item.handle)===-1;){const i=this.elements.get(l.parent.item.handle);l=i?this.nodes.get(i):void 0}l&&!l.parent&&c.add(E.item.handle)}const s=[];return c.forEach(E=>{const l=this.elements.get(E);if(l){const i=this.nodes.get(l);i&&(!i.parent||!c.has(i.parent.item.handle))&&s.push(E)}}),s}refreshHandles(a){const c={};return Promise.all(a.map(m=>this.refreshNode(m).then(s=>{s&&(c[m]=s.item)}))).then(()=>Object.keys(c).length?this.proxy.$refresh(this.viewId,c):void 0)}refreshNode(a){const c=this.getExtensionElement(a);if(c){const m=this.nodes.get(c);if(m)return this.clearChildren(c),(0,k.asPromise)(()=>this.dataProvider.getTreeItem(c)).then(s=>{if(s){const E=this.createTreeNode(c,s,m.parent);return this.updateNodeCache(c,E,m,m.parent),m.dispose(),E}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(a,c,m){const s=this.createTreeNode(a,c,m);if(c.id&&this.elements.has(s.item.handle))throw new Error((0,h.localize)(8,null,c.id));return this.addNodeToCache(a,s),this.addNodeToParentCache(s,m),s}getTooltip(a){return S.MarkdownString.isMarkdownString(a)?D.MarkdownString.from(a):a}getCommand(a,c){return c?this.commands.toInternal(c,a):void 0}createTreeNode(a,c,m){const s=new C.DisposableStore,E=this.createHandle(a,c,m),l=this.getLightIconPath(c);return{item:{handle:E,parentHandle:m?m.item.handle:void 0,label:d(c.label,this.extension),description:c.description,resourceUri:c.resourceUri,tooltip:this.getTooltip(c.tooltip),command:this.getCommand(s,c.command),contextValue:c.contextValue,icon:l,iconDark:this.getDarkIconPath(c)||l,themeIcon:this.getThemeIcon(c),collapsibleState:(0,R.isUndefinedOrNull)(c.collapsibleState)?S.TreeItemCollapsibleState.None:c.collapsibleState,accessibilityInformation:c.accessibilityInformation},extensionItem:c,parent:m,children:void 0,disposableStore:s,dispose(){s.dispose()}}}getThemeIcon(a){return a.iconPath instanceof S.ThemeIcon?a.iconPath:void 0}createHandle(a,{id:c,label:m,resourceUri:s},E,l){if(c)return`${A.ID_HANDLE_PREFIX}/${c}`;const i=d(m,this.extension),r=E?E.item.handle:A.LABEL_HANDLE_PREFIX;let t=i?i.label:s?(0,n.basename)(s):"";t=t.indexOf("/")!==-1?t.replace("/","//"):t;const o=this.nodes.has(a)?this.nodes.get(a).item.handle:void 0,f=this.getChildrenNodes(E)||[];let u,w=0;do{if(u=`${r}/${w}:${t}`,l||!this.elements.has(u)||o===u)break;w++}while(w<=f.length);return u}getLightIconPath(a){if(a.iconPath&&!(a.iconPath instanceof S.ThemeIcon))return typeof a.iconPath=="string"||I.URI.isUri(a.iconPath)?this.getIconPath(a.iconPath):this.getIconPath(a.iconPath.light)}getDarkIconPath(a){if(a.iconPath&&!(a.iconPath instanceof S.ThemeIcon)&&a.iconPath.dark)return this.getIconPath(a.iconPath.dark)}getIconPath(a){return I.URI.isUri(a)?a:I.URI.file(a)}addNodeToCache(a,c){this.elements.set(c.item.handle,a),this.nodes.set(a,c)}updateNodeCache(a,c,m,s){this.elements.delete(c.item.handle),this.nodes.delete(a),c.item.handle!==m.item.handle&&this.elements.delete(m.item.handle),this.addNodeToCache(a,c);const E=this.getChildrenNodes(s)||[],l=E.filter(i=>i.item.handle===m.item.handle)[0];l&&E.splice(E.indexOf(l),1,c)}addNodeToParentCache(a,c){c?(c.children||(c.children=[]),c.children.push(a)):(this.roots||(this.roots=[]),this.roots.push(a))}clearChildren(a){if(a){const c=this.nodes.get(a);if(c){if(c.children)for(const m of c.children){const s=this.elements.get(m.item.handle);s&&this.clear(s)}c.children=void 0}}else this.clearAll()}clear(a){const c=this.nodes.get(a);if(c){if(c.children)for(const m of c.children){const s=this.elements.get(m.item.handle);s&&this.clear(s)}this.nodes.delete(a),this.elements.delete(c.item.handle),c.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(a=>a.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}A.LABEL_HANDLE_PREFIX="0",A.ID_HANDLE_PREFIX="1"}),define(ve[281],we([1,0,21,17,3,47,2,113,109,149,108,42,5,132,231,230,39,232,37,233,234,235,219,236,45,40,237,238,241,242,243,135,221,248,249,250,87,34,252,280,14,7,255,67,136,36,73,208,240,121,133,69,54,71,11,63,16,26,244,203,51,64,228,253,202,66,65,258,256,257,229,44,251,254,86,53,124,246,68,247,10,117,245,200,239,6,30,209]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_,g,d,v,A,b,a,c,m,s,E,l,i,r,t,o,f,u,w,P,L,O,y,z,M,B,V,Y,H,q,K,G,ie,oe,ue,Z,Q,se,de,ge,Te,Ne,be,Ee,$,U,N,W,j,re,he,Ce,Ae,We,ze,qe,He,Ue,Je,et,Le,it,ne,ae,J,pe,Se,Me,$e,Ye,lt,vt,wt,je,st){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function _t(nt){const ct=nt.get($.IExtHostInitDataService),Rt=nt.get(Je.IExtHostFileSystemInfo),Tt=nt.get(We.IExtHostConsumerFileSystem),yt=nt.get(i.IExtHostExtensionService),mt=nt.get(ie.IExtHostWorkspace),Lt=nt.get(ae.IExtHostTelemetry),Mt=nt.get(b.IExtHostConfiguration),Ft=nt.get(be.IURITransformerService),xe=nt.get(Ee.IExtHostRpcService),_e=nt.get(z.IExtHostStorage),ye=nt.get(Ae.IExtensionStoragePaths),fe=nt.get(Ne.ILoggerService),te=nt.get(Ne.ILogService),Ie=nt.get(W.IExtHostTunnelService),Re=nt.get(j.IExtHostApiDeprecationService),Ve=nt.get(G.IExtHostWindow),Ke=nt.get(it.IExtHostSecretState),ht=nt.get(ne.IExtHostEditorTabs);xe.set(p.ExtHostContext.ExtHostFileSystemInfo,Rt),xe.set(p.ExtHostContext.ExtHostLogLevelServiceShape,fe),xe.set(p.ExtHostContext.ExtHostWorkspace,mt),xe.set(p.ExtHostContext.ExtHostConfiguration,Mt),xe.set(p.ExtHostContext.ExtHostExtensionService,yt),xe.set(p.ExtHostContext.ExtHostStorage,_e),xe.set(p.ExtHostContext.ExtHostTunnelService,Ie),xe.set(p.ExtHostContext.ExtHostWindow,Ve),xe.set(p.ExtHostContext.ExtHostSecretState,Ke),xe.set(p.ExtHostContext.ExtHostTelemetry,Lt),xe.set(p.ExtHostContext.ExtHostEditorTabs,ht);const Et=xe.set(p.ExtHostContext.ExtHostDecorations,nt.get(se.IExtHostDecorations)),St=xe.set(p.ExtHostContext.ExtHostDocumentsAndEditors,nt.get(l.IExtHostDocumentsAndEditors)),ot=xe.set(p.ExtHostContext.ExtHostCommands,nt.get(v.IExtHostCommands)),dt=xe.set(p.ExtHostContext.ExtHostTerminalService,nt.get(M.IExtHostTerminalService)),ut=xe.set(p.ExtHostContext.ExtHostDebugService,nt.get(ge.IExtHostDebugService)),Nt=xe.set(p.ExtHostContext.ExtHostSearch,nt.get(Te.IExtHostSearch)),pt=xe.set(p.ExtHostContext.ExtHostTask,nt.get(de.IExtHostTask)),kt=xe.set(p.ExtHostContext.ExtHostOutputService,nt.get(w.IExtHostOutputService)),Ut=xe.set(p.ExtHostContext.ExtHostUrls,new q.ExtHostUrls(xe)),Ct=xe.set(p.ExtHostContext.ExtHostDocuments,new E.ExtHostDocuments(xe,St)),Bt=xe.set(p.ExtHostContext.ExtHostDocumentContentProviders,new m.ExtHostDocumentContentProvider(xe,St,te)),Ht=xe.set(p.ExtHostContext.ExtHostDocumentSaveParticipant,new s.ExtHostDocumentSaveParticipant(te,Ct,xe.getProxy(p.MainContext.MainThreadBulkEdits))),bt=xe.set(p.ExtHostContext.ExtHostNotebook,new U.ExtHostNotebookController(xe,ot,St,Ct,ye)),ei=xe.set(p.ExtHostContext.ExtHostNotebookDocuments,new lt.ExtHostNotebookDocuments(te,bt)),Xt=xe.set(p.ExtHostContext.ExtHostNotebookEditors,new Ye.ExtHostNotebookEditors(te,xe,bt)),ti=xe.set(p.ExtHostContext.ExtHostNotebookKernels,new J.ExtHostNotebookKernels(xe,ct,bt,ot,te)),ai=xe.set(p.ExtHostContext.ExtHostNotebookRenderers,new Se.ExtHostNotebookRenderers(xe,bt)),Pt=xe.set(p.ExtHostContext.ExtHostEditors,new B.ExtHostEditors(xe,St)),ii=xe.set(p.ExtHostContext.ExtHostTreeViews,new V.ExtHostTreeViews(xe.getProxy(p.MainContext.MainThreadTreeViews),ot,te)),bi=xe.set(p.ExtHostContext.ExtHostEditorInsets,new ue.ExtHostEditorInsets(xe.getProxy(p.MainContext.MainThreadEditorInsets),Pt,ct)),qt=xe.set(p.ExtHostContext.ExtHostDiagnostics,new a.ExtHostDiagnostics(xe,te,Rt)),Gt=xe.set(p.ExtHostContext.ExtHostLanguages,new f.ExtHostLanguages(xe,Ct,ot.converter,Ft)),at=xe.set(p.ExtHostContext.ExtHostLanguageFeatures,new o.ExtHostLanguageFeatures(xe,Ft,Ct,ot,qt,te,Re)),li=xe.set(p.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(xe,at)),$t=xe.set(p.ExtHostContext.ExtHostFileSystemEventService,new t.ExtHostFileSystemEventService(xe,te,St)),xt=xe.set(p.ExtHostContext.ExtHostQuickOpen,(0,L.createExtHostQuickOpen)(xe,mt,ot)),ni=xe.set(p.ExtHostContext.ExtHostSCM,new O.ExtHostSCM(xe,ot,te)),_i=xe.set(p.ExtHostContext.ExtHostComments,(0,A.createExtHostComments)(xe,ot,Ct)),fi=xe.set(p.ExtHostContext.ExtHostProgress,new P.ExtHostProgress(xe.getProxy(p.MainContext.MainThreadProgress))),Si=xe.set(p.ExtHostContext.ExtHosLabelService,new Z.ExtHostLabelService(xe)),mi=xe.set(p.ExtHostContext.ExtHostTheming,new N.ExtHostTheming(xe)),ri=xe.set(p.ExtHostContext.ExtHostAuthentication,new re.ExtHostAuthentication(xe)),Ci=xe.set(p.ExtHostContext.ExtHostTimeline,new he.ExtHostTimeline(xe,ot)),Qt=xe.set(p.ExtHostContext.ExtHostWebviews,new K.ExtHostWebviews(xe,{remote:ct.remote},mt,te,Re)),Yt=xe.set(p.ExtHostContext.ExtHostWebviewPanels,new He.ExtHostWebviewPanels(xe,Qt,mt)),yi=xe.set(p.ExtHostContext.ExtHostCustomEditors,new qe.ExtHostCustomEditors(xe,Ct,ye,Qt,Yt)),Di=xe.set(p.ExtHostContext.ExtHostWebviewViews,new ze.ExtHostWebviewViews(xe,Qt)),Jt=xe.set(p.ExtHostContext.ExtHostTesting,new et.ExtHostTesting(xe,ot)),si=xe.set(p.ExtHostContext.ExtHostUriOpeners,new Le.ExtHostUriOpeners(xe));xe.set(p.ExtHostContext.ExtHostInteractive,new vt.ExtHostInteractive(xe,bt,St,ot));const Ii=(0,oe.values)(p.ExtHostContext);xe.assertRegistered(Ii);const ki=new Ue.ExtHostBulkEdits(xe,St),Pi=new d.ExtHostClipboard(xe),Zt=new u.ExtHostMessageService(xe,te),gi=new c.ExtHostDialogs(xe),Kt=new y.ExtHostStatusBar(xe,ot.converter);return g.ExtHostApiCommands.register(ot),function(Oe,ci,Ot){const ft=function(){let le=!Oe.isUnderDevelopment;function me(){le||(te.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),le=!0)}return function ke(tt){if(Array.isArray(tt))tt.forEach(ke);else if(typeof tt=="string")me();else{const gt=tt;typeof gt.scheme=="undefined"&&me(),typeof gt.exclusive=="boolean"&&(0,je.checkProposedApiEnabled)(Oe,"documentFiltersExclusive"),typeof gt.notebookType=="string"&&(0,je.checkProposedApiEnabled)(Oe,"notebookDocumentSelector")}return tt}}(),Ti={getSession(le,me,ke){return ri.getSession(Oe,le,me,ke)},async hasSession(le,me){return(0,je.checkProposedApiEnabled)(Oe,"authSession"),!!await ri.getSession(Oe,le,me,{silent:!0})},get onDidChangeSessions(){return ri.onDidChangeSessions},registerAuthenticationProvider(le,me,ke,tt){return ri.registerAuthenticationProvider(le,me,ke,tt)}},Ai={registerCommand(le,me,ke){return ot.registerCommand(!0,le,me,ke,void 0,Oe)},registerTextEditorCommand(le,me,ke){return ot.registerCommand(!0,le,(...tt)=>{const gt=Pt.getActiveTextEditor();if(!gt){te.warn("Cannot execute "+le+" because there is no active text editor.");return}return gt.edit(It=>{me.apply(ke,[gt,It,...tt])}).then(It=>{It||te.warn("Edits from command "+le+" were not applied.")},It=>{te.warn("An error occurred while running command "+le,It)})},void 0,void 0,Oe)},registerDiffInformationCommand:(le,me,ke)=>((0,je.checkProposedApiEnabled)(Oe,"diffCommand"),ot.registerCommand(!0,le,async(...tt)=>{const gt=St.activeEditor(!0);if(!gt){te.warn("Cannot execute "+le+" because there is no active text editor.");return}const It=await Pt.getDiffInformation(gt.id);me.apply(ke,[It,...tt])},void 0,void 0,Oe)),executeCommand(le,...me){return ot.executeCommand(le,...me)},getCommands(le=!1){return ot.getCommands(le)}},pi={get machineId(){return ct.telemetryInfo.machineId},get sessionId(){return ct.telemetryInfo.sessionId},get language(){return ct.environment.appLanguage},get appName(){return ct.environment.appName},get appRoot(){return ct.environment.appRoot?.fsPath??""},get appHost(){return ct.environment.appHost},get uriScheme(){return ct.environment.appUriScheme},get clipboard(){return Pi.value},get shell(){return dt.getDefaultShell(!1)},get isTelemetryEnabled(){return Lt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Lt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Oe,"telemetry"),Lt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,je.checkProposedApiEnabled)(Oe,"telemetry"),Lt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const le=Date.now()-new Date(ct.telemetryInfo.firstSessionDate).getTime();return isNaN(le)?!1:le<1e3*60*60*24},openExternal(le,me){return Ve.openUri(le,{allowTunneling:!!ct.remote.authority,allowContributedOpeners:me?.allowContributedOpeners})},async asExternalUri(le){if(le.scheme===ct.environment.appUriScheme)return Ut.createAppUri(le);try{return await Ve.asExternalUri(le,{allowTunneling:!!ct.remote.authority})}catch(me){if((0,$e.matchesScheme)(le,Me.Schemas.http)||(0,$e.matchesScheme)(le,Me.Schemas.https))return le;throw me}},get remoteName(){return(0,Q.getRemoteName)(ct.remote.authority)},get remoteAuthority(){return(0,je.checkProposedApiEnabled)(Oe,"resolvers"),ct.remote.authority},get uiKind(){return ct.uiKind}};ct.environment.extensionTestsLocationURI||Object.freeze(pi);const vi=ct.remote.isRemote?H.ExtensionKind.Workspace:H.ExtensionKind.UI,Ri={createTestController(le,me,ke){return Jt.createTestController(le,me,ke)},createTestObserver(){return(0,je.checkProposedApiEnabled)(Oe,"testObserver"),Jt.createTestObserver()},runTests(le){return(0,je.checkProposedApiEnabled)(Oe,"testObserver"),Jt.runTests(le)},get onDidChangeTestResults(){return(0,je.checkProposedApiEnabled)(Oe,"testObserver"),Jt.onResultsChanged},get testResults(){return(0,je.checkProposedApiEnabled)(Oe,"testObserver"),Jt.results}},Li={getExtension(le){const me=ci.getExtensionDescription(le);if(me)return new i.Extension(yt,Oe.identifier,me,vi)},get all(){return ci.getAllExtensionDescriptions().map(le=>new i.Extension(yt,Oe.identifier,le,vi))},get onDidChange(){return ci.onDidChange}},Oi={createDiagnosticCollection(le){return qt.createDiagnosticCollection(Oe.identifier,le)},get onDidChangeDiagnostics(){return qt.onDidChangeDiagnostics},getDiagnostics:le=>qt.getDiagnostics(le),getLanguages(){return Gt.getLanguages()},setTextDocumentLanguage(le,me){return Gt.changeLanguage(le.uri,me)},match(le,me){return(0,F.score)(Y.LanguageSelector.from(le),me.uri,me.languageId,!0,me.notebook?.notebookType)},registerCodeActionsProvider(le,me,ke){return at.registerCodeActionProvider(Oe,ft(le),me,ke)},registerCodeLensProvider(le,me){return at.registerCodeLensProvider(Oe,ft(le),me)},registerDefinitionProvider(le,me){return at.registerDefinitionProvider(Oe,ft(le),me)},registerDeclarationProvider(le,me){return at.registerDeclarationProvider(Oe,ft(le),me)},registerImplementationProvider(le,me){return at.registerImplementationProvider(Oe,ft(le),me)},registerTypeDefinitionProvider(le,me){return at.registerTypeDefinitionProvider(Oe,ft(le),me)},registerHoverProvider(le,me){return at.registerHoverProvider(Oe,ft(le),me,Oe.identifier)},registerEvaluatableExpressionProvider(le,me){return at.registerEvaluatableExpressionProvider(Oe,ft(le),me,Oe.identifier)},registerInlineValuesProvider(le,me){return at.registerInlineValuesProvider(Oe,ft(le),me,Oe.identifier)},registerDocumentHighlightProvider(le,me){return at.registerDocumentHighlightProvider(Oe,ft(le),me)},registerLinkedEditingRangeProvider(le,me){return at.registerLinkedEditingRangeProvider(Oe,ft(le),me)},registerReferenceProvider(le,me){return at.registerReferenceProvider(Oe,ft(le),me)},registerRenameProvider(le,me){return at.registerRenameProvider(Oe,ft(le),me)},registerDocumentSymbolProvider(le,me,ke){return at.registerDocumentSymbolProvider(Oe,ft(le),me,ke)},registerWorkspaceSymbolProvider(le){return at.registerWorkspaceSymbolProvider(Oe,le)},registerDocumentFormattingEditProvider(le,me){return at.registerDocumentFormattingEditProvider(Oe,ft(le),me)},registerDocumentRangeFormattingEditProvider(le,me){return at.registerDocumentRangeFormattingEditProvider(Oe,ft(le),me)},registerOnTypeFormattingEditProvider(le,me,ke,...tt){return at.registerOnTypeFormattingEditProvider(Oe,ft(le),me,[ke].concat(tt))},registerDocumentSemanticTokensProvider(le,me,ke){return at.registerDocumentSemanticTokensProvider(Oe,ft(le),me,ke)},registerDocumentRangeSemanticTokensProvider(le,me,ke){return at.registerDocumentRangeSemanticTokensProvider(Oe,ft(le),me,ke)},registerSignatureHelpProvider(le,me,ke,...tt){return typeof ke=="object"?at.registerSignatureHelpProvider(Oe,ft(le),me,ke):at.registerSignatureHelpProvider(Oe,ft(le),me,typeof ke=="undefined"?[]:[ke,...tt])},registerCompletionItemProvider(le,me,...ke){return at.registerCompletionItemProvider(Oe,ft(le),me,ke)},registerInlineCompletionItemProvider(le,me){return(0,je.checkProposedApiEnabled)(Oe,"inlineCompletions"),at.registerInlineCompletionsProvider(Oe,ft(le),me)},registerDocumentLinkProvider(le,me){return at.registerDocumentLinkProvider(Oe,ft(le),me)},registerColorProvider(le,me){return at.registerColorProvider(Oe,ft(le),me)},registerFoldingRangeProvider(le,me){return at.registerFoldingRangeProvider(Oe,ft(le),me)},registerSelectionRangeProvider(le,me){return at.registerSelectionRangeProvider(Oe,le,me)},registerCallHierarchyProvider(le,me){return at.registerCallHierarchyProvider(Oe,le,me)},registerTypeHierarchyProvider(le,me){return at.registerTypeHierarchyProvider(Oe,le,me)},setLanguageConfiguration:(le,me)=>at.setLanguageConfiguration(Oe,le,me),getTokenInformationAtPosition(le,me){return(0,je.checkProposedApiEnabled)(Oe,"tokenInformation"),Gt.tokenAtPosition(le,me)},registerInlayHintsProvider(le,me){return at.registerInlayHintsProvider(Oe,le,me)},createLanguageStatusItem(le,me){return Gt.createLanguageStatusItem(Oe,le,me)}},ui={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return dt.activeTerminal},get terminals(){return dt.terminals},async showTextDocument(le,me,ke){const tt=await(C.URI.isUri(le)?Promise.resolve(wi.openTextDocument(le)):Promise.resolve(le));return Pt.showTextDocument(tt,me,ke)},createTextEditorDecorationType(le){return Pt.createTextEditorDecorationType(Oe,le)},onDidChangeActiveTextEditor(le,me,ke){return Pt.onDidChangeActiveTextEditor(le,me,ke)},onDidChangeVisibleTextEditors(le,me,ke){return Pt.onDidChangeVisibleTextEditors(le,me,ke)},onDidChangeTextEditorSelection(le,me,ke){return Pt.onDidChangeTextEditorSelection(le,me,ke)},onDidChangeTextEditorOptions(le,me,ke){return Pt.onDidChangeTextEditorOptions(le,me,ke)},onDidChangeTextEditorVisibleRanges(le,me,ke){return Pt.onDidChangeTextEditorVisibleRanges(le,me,ke)},onDidChangeTextEditorViewColumn(le,me,ke){return Pt.onDidChangeTextEditorViewColumn(le,me,ke)},onDidCloseTerminal(le,me,ke){return dt.onDidCloseTerminal(le,me,ke)},onDidOpenTerminal(le,me,ke){return dt.onDidOpenTerminal(le,me,ke)},onDidChangeActiveTerminal(le,me,ke){return dt.onDidChangeActiveTerminal(le,me,ke)},onDidChangeTerminalDimensions(le,me,ke){return(0,je.checkProposedApiEnabled)(Oe,"terminalDimensions"),dt.onDidChangeTerminalDimensions(le,me,ke)},onDidChangeTerminalState(le,me,ke){return dt.onDidChangeTerminalState(le,me,ke)},onDidWriteTerminalData(le,me,ke){return(0,je.checkProposedApiEnabled)(Oe,"terminalDataWriteEvent"),dt.onDidWriteTerminalData(le,me,ke)},get state(){return Ve.state},onDidChangeWindowState(le,me,ke){return Ve.onDidChangeWindowState(le,me,ke)},showInformationMessage(le,...me){return Zt.showMessage(Oe,T.default.Info,le,me[0],me.slice(1))},showWarningMessage(le,...me){return Zt.showMessage(Oe,T.default.Warning,le,me[0],me.slice(1))},showErrorMessage(le,...me){return Zt.showMessage(Oe,T.default.Error,le,me[0],me.slice(1))},showQuickPick(le,me,ke){return xt.showQuickPick(le,me,ke)},showWorkspaceFolderPick(le){return xt.showWorkspaceFolderPick(le)},showInputBox(le,me){return xt.showInput(le,me)},showOpenDialog(le){return gi.showOpenDialog(le)},showSaveDialog(le){return gi.showSaveDialog(le)},createStatusBarItem(le,me,ke){let tt,gt,It;return typeof le=="string"?(tt=le,gt=me,It=ke):(gt=le,It=me),Kt.createStatusBarEntry(Oe,tt,gt,It)},setStatusBarMessage(le,me){return Kt.setStatusBarMessage(le,me)},withScmProgress(le){return Re.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),fi.withProgress(Oe,{location:H.ProgressLocation.SourceControl},(me,ke)=>le({report(tt){}}))},withProgress(le,me){return fi.withProgress(Oe,le,me)},createOutputChannel(le,me){return me&&(0,je.checkProposedApiEnabled)(Oe,"outputChannelLanguage"),kt.createOutputChannel(le,me,Oe)},createWebviewPanel(le,me,ke,tt){return Yt.createWebviewPanel(Oe,le,me,ke,tt)},createWebviewTextEditorInset(le,me,ke,tt){return(0,je.checkProposedApiEnabled)(Oe,"editorInsets"),bi.createWebviewEditorInset(le,me,ke,tt,Oe)},createTerminal(le,me,ke){return typeof le=="object"?"pty"in le?dt.createExtensionTerminal(le):dt.createTerminalFromOptions(le):dt.createTerminal(le,me,ke)},registerTerminalLinkProvider(le){return dt.registerLinkProvider(le)},registerTerminalProfileProvider(le,me){return dt.registerProfileProvider(Oe,le,me)},registerTreeDataProvider(le,me){return ii.registerTreeDataProvider(le,me,Oe)},createTreeView(le,me){return ii.createTreeView(le,me,Oe)},registerWebviewPanelSerializer:(le,me)=>Yt.registerWebviewPanelSerializer(Oe,le,me),registerCustomEditorProvider:(le,me,ke={})=>yi.registerCustomEditorProvider(Oe,le,me,ke),registerFileDecorationProvider(le){return Et.registerFileDecorationProvider(le,Oe.identifier)},registerUriHandler(le){return Ut.registerUriHandler(Oe.identifier,le)},createQuickPick(){return xt.createQuickPick(Oe)},createInputBox(){return xt.createInputBox(Oe.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(le,me,ke){return mi.onDidChangeActiveColorTheme(le,me,ke)},registerWebviewViewProvider(le,me,ke){return Di.registerWebviewViewProvider(Oe,le,me,ke?.webviewOptions)},get activeNotebookEditor(){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(le,me,ke){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),bt.onDidChangeActiveNotebookEditor(le,me,ke)},get visibleNotebookEditors(){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(le,me,ke){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),Xt.onDidChangeNotebookEditorSelection(le,me,ke)},onDidChangeNotebookEditorVisibleRanges(le,me,ke){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),Xt.onDidChangeNotebookEditorVisibleRanges(le,me,ke)},showNotebookDocument(le,me){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),bt.showNotebookDocument(le,me)},registerExternalUriOpener(le,me,ke){return(0,je.checkProposedApiEnabled)(Oe,"externalUriOpener"),si.registerExternalUriOpener(Oe.identifier,le,me,ke)},get tabGroups(){return(0,je.checkProposedApiEnabled)(Oe,"tabs"),ht.tabGroups},getInlineCompletionItemController(le){return(0,je.checkProposedApiEnabled)(Oe,"inlineCompletions"),o.InlineCompletionController.get(le)}},wi={get rootPath(){return Re.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(le){throw n.readonly()},getWorkspaceFolder(le){return mt.getWorkspaceFolder(le)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(le){throw n.readonly()},get workspaceFile(){return mt.workspaceFile},set workspaceFile(le){throw n.readonly()},updateWorkspaceFolders:(le,me,...ke)=>mt.updateWorkspaceFolders(Oe,le,me||0,...ke),onDidChangeWorkspaceFolders:function(le,me,ke){return mt.onDidChangeWorkspace(le,me,ke)},asRelativePath:(le,me)=>mt.getRelativePath(le,me),findFiles:(le,me,ke,tt)=>mt.findFiles(le,me,ke,Oe.identifier,tt),findTextInFiles:(le,me,ke,tt)=>{(0,je.checkProposedApiEnabled)(Oe,"findTextInFiles");let gt,It;return typeof me=="object"?(gt=me,It=ke):(gt={},It=me,tt=ke),mt.findTextInFiles(le,gt||{},It,Oe.identifier,tt)},saveAll:le=>mt.saveAll(le),applyEdit(le){return ki.applyWorkspaceEdit(le)},createFileSystemWatcher:(le,me,ke,tt)=>$t.createFileSystemWatcher(mt,Oe,le,me,ke,tt),get textDocuments(){return Ct.getAllDocumentData().map(le=>le.document)},set textDocuments(le){throw n.readonly()},openTextDocument(le){let me;const ke=le;if(typeof le=="string")me=Promise.resolve(C.URI.file(le));else if(C.URI.isUri(le))me=Promise.resolve(le);else if(!ke||typeof ke=="object")me=Ct.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return me.then(tt=>Ct.ensureDocumentData(tt).then(gt=>gt.document))},onDidOpenTextDocument:(le,me,ke)=>Ct.onDidAddDocument(le,me,ke),onDidCloseTextDocument:(le,me,ke)=>Ct.onDidRemoveDocument(le,me,ke),onDidChangeTextDocument:(le,me,ke)=>Ct.onDidChangeDocument(le,me,ke),onDidSaveTextDocument:(le,me,ke)=>Ct.onDidSaveDocument(le,me,ke),onWillSaveTextDocument:(le,me,ke)=>Ht.getOnWillSaveTextDocumentEvent(Oe)(le,me,ke),get notebookDocuments(){return bt.notebookDocuments.map(le=>le.apiNotebook)},async openNotebookDocument(le,me){let ke;if(C.URI.isUri(le))ke=le,await bt.openNotebookDocument(le);else if(typeof le=="string")ke=C.URI.revive(await bt.createNotebookDocument({viewType:le,content:me}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(ke).apiNotebook},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(le,me,ke,tt){return bt.registerNotebookSerializer(Oe,le,me,ke,(0,je.isProposedApiEnabled)(Oe,"notebookLiveShare")?tt:void 0)},registerNotebookContentProvider:(le,me,ke,tt)=>((0,je.checkProposedApiEnabled)(Oe,"notebookContentProvider"),bt.registerNotebookContentProvider(Oe,le,me,ke,(0,je.isProposedApiEnabled)(Oe,"notebookLiveShare")?tt:void 0)),onDidChangeConfiguration:(le,me,ke)=>Ot.onDidChangeConfiguration(le,me,ke),getConfiguration(le,me){return me=arguments.length===1?void 0:me,Ot.getConfiguration(le,me,Oe)},registerTextDocumentContentProvider(le,me){return Bt.registerTextDocumentContentProvider(le,me)},registerTaskProvider:(le,me)=>(Re.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),pt.registerTaskProvider(Oe,le,me)),registerFileSystemProvider(le,me,ke){return(0,wt.combinedDisposable)(li.registerFileSystemProvider(Oe,le,me,ke),Tt.addFileSystemProvider(le,me))},get fs(){return Tt.value},registerFileSearchProvider:(le,me)=>((0,je.checkProposedApiEnabled)(Oe,"fileSearchProvider"),Nt.registerFileSearchProvider(le,me)),registerTextSearchProvider:(le,me)=>((0,je.checkProposedApiEnabled)(Oe,"textSearchProvider"),Nt.registerTextSearchProvider(le,me)),registerRemoteAuthorityResolver:(le,me)=>((0,je.checkProposedApiEnabled)(Oe,"resolvers"),yt.registerRemoteAuthorityResolver(le,me)),registerResourceLabelFormatter:le=>((0,je.checkProposedApiEnabled)(Oe,"resolvers"),Si.$registerResourceLabelFormatter(le)),onDidCreateFiles:(le,me,ke)=>$t.onDidCreateFile(le,me,ke),onDidDeleteFiles:(le,me,ke)=>$t.onDidDeleteFile(le,me,ke),onDidRenameFiles:(le,me,ke)=>$t.onDidRenameFile(le,me,ke),onWillCreateFiles:(le,me,ke)=>$t.getOnWillCreateFileEvent(Oe)(le,me,ke),onWillDeleteFiles:(le,me,ke)=>$t.getOnWillDeleteFileEvent(Oe)(le,me,ke),onWillRenameFiles:(le,me,ke)=>$t.getOnWillRenameFileEvent(Oe)(le,me,ke),openTunnel:le=>((0,je.checkProposedApiEnabled)(Oe,"resolvers"),Ie.openTunnel(Oe,le).then(me=>{if(!me)throw new Error("cannot open tunnel");return me})),get tunnels(){return(0,je.checkProposedApiEnabled)(Oe,"resolvers"),Ie.getTunnels()},onDidChangeTunnels:(le,me,ke)=>((0,je.checkProposedApiEnabled)(Oe,"resolvers"),Ie.onDidChangeTunnels(le,me,ke)),registerPortAttributesProvider:(le,me)=>((0,je.checkProposedApiEnabled)(Oe,"portsAttributes"),Ie.registerPortsAttributesProvider(le,me)),registerTimelineProvider:(le,me)=>((0,je.checkProposedApiEnabled)(Oe,"timeline"),Ci.registerTimelineProvider(le,me,Oe.identifier,ot.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:le=>((0,je.checkProposedApiEnabled)(Oe,"workspaceTrust"),mt.requestWorkspaceTrust(le)),onDidGrantWorkspaceTrust:(le,me,ke)=>mt.onDidGrantWorkspaceTrust(le,me,ke)},Fi={get inputBox(){return Re.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),ni.getLastInputBox(Oe)},createSourceControl(le,me,ke){return ni.createSourceControl(Oe,le,me,ke)}},Ni={createCommentController(le,me){return _i.createCommentController(Oe,le,me)}},Mi={get activeDebugSession(){return ut.activeDebugSession},get activeDebugConsole(){return ut.activeDebugConsole},get breakpoints(){return ut.breakpoints},onDidStartDebugSession(le,me,ke){return ut.onDidStartDebugSession(le,me,ke)},onDidTerminateDebugSession(le,me,ke){return ut.onDidTerminateDebugSession(le,me,ke)},onDidChangeActiveDebugSession(le,me,ke){return ut.onDidChangeActiveDebugSession(le,me,ke)},onDidReceiveDebugSessionCustomEvent(le,me,ke){return ut.onDidReceiveDebugSessionCustomEvent(le,me,ke)},onDidChangeBreakpoints(le,me,ke){return ut.onDidChangeBreakpoints(le,me,ke)},registerDebugConfigurationProvider(le,me,ke){return ut.registerDebugConfigurationProvider(le,me,ke||st.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(le,me){return ut.registerDebugAdapterDescriptorFactory(Oe,le,me)},registerDebugAdapterTrackerFactory(le,me){return ut.registerDebugAdapterTrackerFactory(le,me)},startDebugging(le,me,ke){return!ke||typeof ke=="object"&&"configuration"in ke?ut.startDebugging(le,me,{parentSession:ke}):ut.startDebugging(le,me,ke||{})},stopDebugging(le){return ut.stopDebugging(le)},addBreakpoints(le){return ut.addBreakpoints(le)},removeBreakpoints(le){return ut.removeBreakpoints(le)},asDebugSourceUri(le,me){return ut.asDebugSourceUri(le,me)}},Ui={registerTaskProvider:(le,me)=>pt.registerTaskProvider(Oe,le,me),fetchTasks:le=>pt.fetchTasks(le),executeTask:le=>pt.executeTask(Oe,le),get taskExecutions(){return pt.taskExecutions},onDidStartTask:(le,me,ke)=>pt.onDidStartTask(le,me,ke),onDidEndTask:(le,me,ke)=>pt.onDidEndTask(le,me,ke),onDidStartTaskProcess:(le,me,ke)=>pt.onDidStartTaskProcess(le,me,ke),onDidEndTaskProcess:(le,me,ke)=>pt.onDidEndTaskProcess(le,me,ke)},Bi={createNotebookController(le,me,ke,tt,gt){return ti.createNotebookController(Oe,le,me,ke,tt,(0,je.isProposedApiEnabled)(Oe,"notebookMessaging")?gt:void 0)},registerNotebookCellStatusBarItemProvider:(le,me)=>bt.registerNotebookCellStatusBarItemProvider(Oe,le,me),get onDidSaveNotebookDocument(){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),ei.onDidSaveNotebookDocument},createNotebookEditorDecorationType(le){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditorDecorationType"),Xt.createNotebookEditorDecorationType(le)},createRendererMessaging(le){return ai.createRendererMessaging(Oe,le)},onDidChangeNotebookDocumentMetadata(le,me,ke){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),ei.onDidChangeNotebookDocumentMetadata(le,me,ke)},onDidChangeNotebookCells(le,me,ke){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),bt.onDidChangeNotebookCells(le,me,ke)},onDidChangeNotebookCellExecutionState(le,me,ke){return(0,je.checkProposedApiEnabled)(Oe,"notebookCellExecutionState"),ti.onDidChangeNotebookCellExecutionState(le,me,ke)},onDidChangeCellOutputs(le,me,ke){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),bt.onDidChangeCellOutputs(le,me,ke)},onDidChangeCellMetadata(le,me,ke){return(0,je.checkProposedApiEnabled)(Oe,"notebookEditor"),bt.onDidChangeCellMetadata(le,me,ke)},createConcatTextDocument(le,me){return(0,je.checkProposedApiEnabled)(Oe,"notebookConcatTextDocument"),new Ce.ExtHostNotebookConcatDocument(bt,Ct,le,me)}};return{version:ct.version,authentication:Ti,commands:Ai,comments:Ni,debug:Mi,env:pi,extensions:Li,languages:Oi,notebooks:Bi,scm:Fi,tasks:Ui,tests:Ri,window:ui,workspace:wi,Breakpoint:H.Breakpoint,CallHierarchyIncomingCall:H.CallHierarchyIncomingCall,CallHierarchyItem:H.CallHierarchyItem,CallHierarchyOutgoingCall:H.CallHierarchyOutgoingCall,CancellationError:n.CancellationError,CancellationTokenSource:h.CancellationTokenSource,CandidatePortSource:p.CandidatePortSource,CodeAction:H.CodeAction,CodeActionKind:H.CodeActionKind,CodeActionTriggerKind:H.CodeActionTriggerKind,CodeLens:H.CodeLens,Color:H.Color,ColorInformation:H.ColorInformation,ColorPresentation:H.ColorPresentation,ColorThemeKind:H.ColorThemeKind,CommentMode:H.CommentMode,CommentThreadCollapsibleState:H.CommentThreadCollapsibleState,CommentThreadState:H.CommentThreadState,CompletionItem:H.CompletionItem,CompletionItemKind:H.CompletionItemKind,CompletionItemTag:H.CompletionItemTag,CompletionList:H.CompletionList,CompletionTriggerKind:H.CompletionTriggerKind,ConfigurationTarget:H.ConfigurationTarget,CustomExecution:H.CustomExecution,DebugAdapterExecutable:H.DebugAdapterExecutable,DebugAdapterInlineImplementation:H.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:H.DebugAdapterNamedPipeServer,DebugAdapterServer:H.DebugAdapterServer,DebugConfigurationProviderTriggerKind:st.DebugConfigurationProviderTriggerKind,DebugConsoleMode:H.DebugConsoleMode,DecorationRangeBehavior:H.DecorationRangeBehavior,Diagnostic:H.Diagnostic,DiagnosticRelatedInformation:H.DiagnosticRelatedInformation,DiagnosticSeverity:H.DiagnosticSeverity,DiagnosticTag:H.DiagnosticTag,Disposable:H.Disposable,DocumentHighlight:H.DocumentHighlight,DocumentHighlightKind:H.DocumentHighlightKind,DocumentLink:H.DocumentLink,DocumentSymbol:H.DocumentSymbol,EndOfLine:H.EndOfLine,EnvironmentVariableMutatorType:H.EnvironmentVariableMutatorType,EvaluatableExpression:H.EvaluatableExpression,InlineValueText:H.InlineValueText,InlineValueVariableLookup:H.InlineValueVariableLookup,InlineValueEvaluatableExpression:H.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:H.InlineCompletionTriggerKind,EventEmitter:I.Emitter,ExtensionKind:H.ExtensionKind,ExtensionMode:H.ExtensionMode,ExternalUriOpenerPriority:H.ExternalUriOpenerPriority,FileChangeType:H.FileChangeType,FileDecoration:H.FileDecoration,FileSystemError:H.FileSystemError,FileType:D.FileType,FilePermission:D.FilePermission,FoldingRange:H.FoldingRange,FoldingRangeKind:H.FoldingRangeKind,FunctionBreakpoint:H.FunctionBreakpoint,InlineCompletionItem:H.InlineSuggestion,InlineCompletionList:H.InlineSuggestions,Hover:H.Hover,IndentAction:R.IndentAction,Location:H.Location,MarkdownString:H.MarkdownString,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:H.ParameterInformation,PortAutoForwardAction:H.PortAutoForwardAction,Position:H.Position,ProcessExecution:H.ProcessExecution,ProgressLocation:H.ProgressLocation,QuickInputButtons:H.QuickInputButtons,Range:H.Range,RelativePattern:H.RelativePattern,Selection:H.Selection,SelectionRange:H.SelectionRange,SemanticTokens:H.SemanticTokens,SemanticTokensBuilder:H.SemanticTokensBuilder,SemanticTokensEdit:H.SemanticTokensEdit,SemanticTokensEdits:H.SemanticTokensEdits,SemanticTokensLegend:H.SemanticTokensLegend,ShellExecution:H.ShellExecution,ShellQuoting:H.ShellQuoting,SignatureHelp:H.SignatureHelp,SignatureHelpTriggerKind:H.SignatureHelpTriggerKind,SignatureInformation:H.SignatureInformation,SnippetString:H.SnippetString,SourceBreakpoint:H.SourceBreakpoint,StandardTokenType:H.StandardTokenType,StatusBarAlignment:H.StatusBarAlignment,SymbolInformation:H.SymbolInformation,SymbolKind:H.SymbolKind,SymbolTag:H.SymbolTag,TabKind:p.TabKind,Task:H.Task,TaskGroup:H.TaskGroup,TaskPanelKind:H.TaskPanelKind,TaskRevealKind:H.TaskRevealKind,TaskScope:H.TaskScope,TerminalLink:H.TerminalLink,TerminalLocation:H.TerminalLocation,TerminalProfile:H.TerminalProfile,TextDocumentSaveReason:H.TextDocumentSaveReason,TextEdit:H.TextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:H.TextEditorLineNumbersStyle,TextEditorRevealType:H.TextEditorRevealType,TextEditorSelectionChangeKind:H.TextEditorSelectionChangeKind,TextDocumentChangeReason:H.TextDocumentChangeReason,ThemeColor:H.ThemeColor,ThemeIcon:H.ThemeIcon,TreeItem:H.TreeItem,TreeItemCollapsibleState:H.TreeItemCollapsibleState,TypeHierarchyItem:H.TypeHierarchyItem,UIKind:_.UIKind,Uri:C.URI,ViewColumn:H.ViewColumn,WorkspaceEdit:H.WorkspaceEdit,InlayHint:H.InlayHint,InlayHintLabelPart:H.InlayHintLabelPart,InlayHintKind:H.InlayHintKind,RemoteAuthorityResolverError:H.RemoteAuthorityResolverError,ResolvedAuthority:H.ResolvedAuthority,SourceControlInputBoxValidationType:H.SourceControlInputBoxValidationType,ExtensionRuntime:H.ExtensionRuntime,TimelineItem:H.TimelineItem,NotebookRange:H.NotebookRange,NotebookCellKind:H.NotebookCellKind,NotebookCellExecutionState:H.NotebookCellExecutionState,NotebookCellData:H.NotebookCellData,NotebookData:H.NotebookData,NotebookRendererScript:H.NotebookRendererScript,NotebookCellStatusBarAlignment:H.NotebookCellStatusBarAlignment,NotebookEditorRevealType:H.NotebookEditorRevealType,NotebookCellOutput:H.NotebookCellOutput,NotebookCellOutputItem:H.NotebookCellOutputItem,NotebookCellStatusBarItem:H.NotebookCellStatusBarItem,NotebookControllerAffinity:H.NotebookControllerAffinity,PortAttributes:H.PortAttributes,LinkedEditingRanges:H.LinkedEditingRanges,TestResultState:H.TestResultState,TestRunRequest:H.TestRunRequest,TestMessage:H.TestMessage,TestTag:H.TestTag,TestRunProfileKind:H.TestRunProfileKind,TextSearchCompleteMessageType:pe.TextSearchCompleteMessageType,TreeDataTransfer:H.TreeDataTransfer,TreeDataTransferItem:H.TreeDataTransferItem,CoveredCount:H.CoveredCount,FileCoverage:H.FileCoverage,StatementCoverage:H.StatementCoverage,BranchCoverage:H.BranchCoverage,FunctionCoverage:H.FunctionCoverage,WorkspaceTrustState:H.WorkspaceTrustState,LanguageStatusSeverity:H.LanguageStatusSeverity,QuickPickItemKind:H.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=_t}),define(ve[282],we([1,0,283,292,293,2,294]),function(ee,e,h,n,I,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(D,p,_,g,d,v){const A=v.environment.useHostProxy,b=typeof A=="boolean"?A:!v.remote.isRemote,a=(0,C.createProxyResolver)({resolveProxy:m=>D.resolveProxy(m),getHttpProxySetting:()=>p.getConfiguration("http").get("proxy"),log:(m,s,...E)=>{switch(m){case C.LogLevel.Trace:g.trace(s,...E);break;case C.LogLevel.Debug:g.debug(s,...E);break;case C.LogLevel.Info:g.info(s,...E);break;case C.LogLevel.Warning:g.warn(s,...E);break;case C.LogLevel.Error:g.error(s,...E);break;case C.LogLevel.Critical:g.critical(s,...E);break;case C.LogLevel.Off:break;default:l(m,s,E);break}function l(i,r,...t){g.error("Unknown log level",i),g.error(r,...t)}},getLogLevel:()=>g.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:b,env:process.env}),c=S(p,a);return F(_,c)}e.connectProxyResolver=k;function S(D,p){const _={config:D.getConfiguration("http").get("proxySupport")||"off"};D.onDidChangeConfiguration(d=>{_.config=D.getConfiguration("http").get("proxySupport")||"off"});const g={config:!!D.getConfiguration("http").get("systemCertificates")};return D.onDidChangeConfiguration(d=>{g.config=!!D.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},h,(0,C.createHttpPatch)(h,p,{config:"off"},g,!0)),on:Object.assign({},h,(0,C.createHttpPatch)(h,p,{config:"on"},g,!0)),override:Object.assign({},h,(0,C.createHttpPatch)(h,p,{config:"override"},g,!0)),onRequest:Object.assign({},h,(0,C.createHttpPatch)(h,p,_,g,!0)),default:Object.assign(h,(0,C.createHttpPatch)(h,p,_,g,!1))},https:{off:Object.assign({},n,(0,C.createHttpPatch)(n,p,{config:"off"},g,!0)),on:Object.assign({},n,(0,C.createHttpPatch)(n,p,{config:"on"},g,!0)),override:Object.assign({},n,(0,C.createHttpPatch)(n,p,{config:"override"},g,!0)),onRequest:Object.assign({},n,(0,C.createHttpPatch)(n,p,_,g,!0)),default:Object.assign(n,(0,C.createHttpPatch)(n,p,_,g,!1))},tls:Object.assign(I,(0,C.createTlsPatch)(I))}}const R=new Map;function F(D,p){return D.getExtensionPathIndex().then(_=>{const g=ee.__$__nodeRequire("module"),d=g._load;g._load=function(A,b,a){if(A==="tls")return p.tls;if(A!=="http"&&A!=="https")return d.apply(this,arguments);const c=p[A],m=_.findSubstr(T.URI.file(b.filename));let s=R.get(m);if(s||R.set(m,s={}),!s[A]){let E=c.default;s[A]={...E}}return s[A]}})}}),define(ve[139],we([1,0,38,295,102,18,73,32,9,8,2,31,68,296,276,88]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const v=g.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class A{constructor(u){this.outputChannel=u}provideTextSearchResults(u,w,P,L){return this.outputChannel.appendLine(`provideTextSearchResults ${u.pattern}, ${JSON.stringify({...w,folder:w.folder.toString()})}`),new Promise((O,y)=>{L.onCancellationRequested(()=>K());const z=E(u,w),M=w.folder.fsPath,B=z.map(Z=>Z.match(/^-/)?Z:`'${Z}'`).join(" ");this.outputChannel.appendLine(`${v} ${B}
 - cwd: ${M}`);let V=h.spawn(v,z,{cwd:M});V.on("error",Z=>{console.error(Z),this.outputChannel.appendLine("Error: "+(Z&&Z.message)),y((0,D.serializeSearchError)(new D.SearchError(Z&&Z.message,D.SearchErrorCode.rgProcessError)))});let Y=!1;const H=new c(w.maxResults,M,w.previewOptions);H.on("result",Z=>{Y=!0,ie="",P.report(Z)});let q=!1;const K=()=>{q=!0,V&&V.kill(),H&&H.cancel()};let G=!1;H.on("hitLimit",()=>{G=!0,K()});let ie="";V.stdout.on("data",Z=>{H.handleData(Z),Y||(ie+=Z)});let oe=!1;V.stdout.once("data",()=>oe=!0);let ue="";V.stderr.on("data",Z=>{const Q=Z.toString();this.outputChannel.appendLine(Q),ue+=Q}),V.on("close",()=>{if(this.outputChannel.appendLine(oe?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(Y?"Got result from parser":"No result from parser"),ie&&this.outputChannel.appendLine(`Got data without result: ${ie}`),this.outputChannel.appendLine(""),q)O({limitHit:G});else{H.flush(),V=null;let Z;ue&&!oe&&(Z=b(ue))?y((0,D.serializeSearchError)(new D.SearchError(Z.message,Z.code))):O({limitHit:G})}})})}}e.RipgrepTextSearchEngine=A;function b(f){const u=f.split(`
`),w=u[0].trim();if(u.some(L=>L.startsWith("regex parse error")))return new D.SearchError(a(u),D.SearchErrorCode.regexParseError);const P=w.match(/grep config error: unknown encoding: (.*)/);if(P)return new D.SearchError(`Unknown encoding: ${P[1]}`,D.SearchErrorCode.unknownEncoding);if(w.startsWith("error parsing glob"))return new D.SearchError(w.charAt(0).toUpperCase()+w.substr(1),D.SearchErrorCode.globParseError);if(w.startsWith("the literal"))return new D.SearchError(w.charAt(0).toUpperCase()+w.substr(1),D.SearchErrorCode.invalidLiteral);if(w.startsWith("PCRE2: error compiling pattern"))return new D.SearchError(w,D.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=b;function a(f){const u=["Regex parse error"],w=f.filter(P=>P.startsWith("PCRE2:"));if(w.length>=1){const P=w[0].replace("PCRE2:","");if(P.indexOf(":")!==-1&&P.split(":").length>=2){const L=P.split(":")[1];u.push(":"+L)}}return u.join("")}e.buildRegexParseError=a;class c extends n.EventEmitter{constructor(u,w,P){super();this.maxResults=u,this.rootFolder=w,this.previewOptions=P,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new I.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(u,w){return super.on(u,w),this}handleData(u){if(this.isDone)return;const w=typeof u=="string"?u:this.stringDecoder.write(u);this.handleDecodedData(w)}handleDecodedData(u){let w=u.indexOf(`
`);const P=this.remainder+u;if(w>=0)w+=this.remainder.length;else{this.remainder=P;return}let L=0;for(;w>=0;)this.handleLine(P.substring(L,w).trim()),L=w+1,w=P.indexOf(`
`,L);this.remainder=P.substring(L)}handleLine(u){if(this.isDone||!u)return;let w;try{w=JSON.parse(u)}catch{throw new Error(`malformed line from rg: ${u}`)}if(w.type==="match"){const P=m(w.data.path),L=F.URI.file(S.join(this.rootFolder,P)),O=this.createTextSearchMatch(w.data,L);this.onResult(O),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(w.type==="context"){const P=m(w.data.path),L=F.URI.file(S.join(this.rootFolder,P));this.createTextSearchContext(w.data,L).forEach(y=>this.onResult(y))}}createTextSearchMatch(u,w){const P=u.line_number-1,L=m(u.lines),O=Buffer.from(L);let y=0,z=0,M=P;u.submatches.length===0&&u.submatches.push(L.length?{start:0,end:1,match:{text:L[0]}}:{start:0,end:0,match:{text:""}});const B=(0,T.coalesce)(u.submatches.map((V,Y)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const H=m(V.match),q=O.slice(y,V.start).toString().length,K=z+q,G=s(H),ie=M,oe=G.numLines+ie,ue=G.numLines>0?G.lastLineLength:G.lastLineLength+K;return y=V.end,z=ue,M=oe,new p.Range(ie,K,oe,ue)}));return(0,d.createTextSearchResult)(w,L,B,this.previewOptions)}createTextSearchContext(u,w){const P=m(u.lines),L=u.line_number;return P.replace(/\r?\n$/,"").split(`
`).map((O,y)=>({text:O,uri:w,lineNumber:L+y}))}onResult(u){this.emit("result",u)}}e.RipgrepParser=c;function m(f){return f.bytes?Buffer.from(f.bytes,"base64").toString():f.text}function s(f){const u=/\n/g;let w=0,P=-1,L;for(;L=u.exec(f);)w++,P=L.index;const O=P>=0?f.length-P-1:f.length;return{numLines:w,lastLineLength:O}}function E(f,u){const w=["--hidden"];w.push(f.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:P,otherIncludes:L}=(0,C.groupBy)(u.includes,y=>y.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(L&&L.length){const y=new Set;L.forEach(z=>{y.add(z)}),w.push("-g","!*"),y.forEach(z=>{l(z).map(d.anchorGlob).forEach(M=>{w.push("-g",M)})})}P&&P.length&&P.forEach(y=>{w.push("-g",y)}),u.excludes.map(d.anchorGlob).forEach(y=>w.push("-g",`!${y}`)),u.maxFileSize&&w.push("--max-filesize",u.maxFileSize+""),u.useIgnoreFiles?u.useParentIgnoreFiles||w.push("--no-ignore-parent"):w.push("--no-ignore"),u.followSymlinks&&w.push("--follow"),u.encoding&&u.encoding!=="utf8"&&w.push("--encoding",u.encoding),f.pattern==="--"&&(f.isRegExp=!0,f.pattern="\\-\\-"),f.isMultiline&&!f.isRegExp&&(f.pattern=(0,R.escapeRegExpCharacters)(f.pattern),f.isRegExp=!0),u.usePCRE2&&w.push("--pcre2"),w.push("--crlf"),f.isRegExp&&(f.pattern=i(f.pattern),w.push("--engine","auto"));let O;if(f.isWordMatch){const z=(0,R.createRegExp)(f.pattern,!!f.isRegExp,{wholeWord:f.isWordMatch}).source.replace(/\\\//g,"/");w.push("--regexp",z)}else if(f.isRegExp){let y=t(f.pattern);y=o(y),w.push("--regexp",y)}else O=f.pattern,w.push("--fixed-strings");return w.push("--no-config"),u.useGlobalIgnoreFiles||w.push("--no-ignore-global"),w.push("--json"),f.isMultiline&&w.push("--multiline"),u.beforeContext&&w.push("--before-context",u.beforeContext+""),u.afterContext&&w.push("--after-context",u.afterContext+""),w.push("--"),O&&w.push(O),w.push("."),w}function l(f){const u=(0,k.splitGlobAware)(f,"/");return u.map((w,P)=>u.slice(0,P+1).join("/"))}e.spreadGlobComponents=l;function i(f){const u=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;f.match(u);)f=f.replace(u,"$1\\x{$2}");const w=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;f.match(w);)f=f.replace(w,"$1\\x{$2}");return f}e.unicodeEscapesToPCRE2=i;const r=f=>f.type==="Assertion"&&f.kind==="lookbehind";function t(f){let u;try{u=new _.RegExpParser().parsePattern(f)}catch{return f}let w="",P=0;const L=(z,M,B)=>{w+=f.slice(P,z)+B,P=M},O=[];return new _.RegExpVisitor({onCharacterEnter(z){if(z.raw!=="\\n")return;const M=O[0];if(!M)L(z.start,z.end,"\\r?\\n");else if(!O.some(r))if(M.type==="CharacterClass")if(M.negate){const B=f.slice(M.start+2,z.start)+f.slice(z.end,M.end-1);M.parent?.type==="Quantifier"?L(M.start,M.end,B?`[^${B}]`:"."):L(M.start,M.end,"(?!\\r?\\n"+(B?`|[${B}]`:"")+")")}else{const B=f.slice(M.start+1,z.start)+f.slice(z.end,M.end-1);L(M.start,M.end,B===""?"\\r?\\n":`(?:[${B}]|\\r?\\n)`)}else M.type==="Quantifier"&&L(z.start,z.end,"(?:\\r?\\n)")},onQuantifierEnter(z){O.unshift(z)},onQuantifierLeave(){O.shift()},onCharacterClassRangeEnter(z){O.unshift(z)},onCharacterClassRangeLeave(){O.shift()},onCharacterClassEnter(z){O.unshift(z)},onCharacterClassLeave(){O.shift()},onAssertionEnter(z){r(z)&&O.push(z)},onAssertionLeave(z){O[0]===z&&O.shift()}}).visit(u),w+=f.slice(P),w}e.fixRegexNewline=t;function o(f){return f.replace(/\n/g,"\\r?\\n")}e.fixNewline=o}),define(ve[284],we([1,0,21,139,118,10]),function(ee,e,h,n,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class C{constructor(R){this.outputChannel=R,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(R,F,D,p){const _=new n.RipgrepTextSearchEngine(this.outputChannel);if(F.folder.scheme===T.Schemas.userData){const g={...F,folder:F.folder.with({scheme:T.Schemas.file})},d=new I.Progress(v=>D.report({...v,uri:v.uri.with({scheme:F.folder.scheme})}));return this.withToken(p,v=>_.provideTextSearchResults(R,g,d,v))}else return this.withToken(p,g=>_.provideTextSearchResults(R,F,D,g))}async withToken(R,F){const D=k(R);this.inProgress.add(D);const p=await F(D.token);return this.inProgress.delete(D),p}dispose(){this.inProgress.forEach(R=>R.cancel())}}e.RipgrepSearchProvider=C;function k(S){const R=new h.CancellationTokenSource;return S.onCancellationRequested(()=>R.cancel()),R}}),define(ve[285],we([1,0,28,139,138]),function(ee,e,h,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class T{constructor(S){this.query=S}search(S,R,F){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const D={appendLine(_){F({message:_})}},p=new I.NativeTextSearchManager(this.query,new n.RipgrepTextSearchEngine(D),h);return new Promise((_,g)=>p.search(d=>{R(d.map(C))},S).then(d=>_({limitHit:d.limitHit,type:"success",stats:d.stats}),g))}}e.TextSearchEngineAdapter=T;function C(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((S,R)=>{if(R.ranges){const F=R;return S+(Array.isArray(F.ranges)?F.ranges.length:1)}else return S+1},0)}}}),define(ve[286],we([1,0,18,15,17,3,98,9,46,2,42,31,277,285]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class g{constructor(c="searchProcess"){this.processType=c,this.caches=Object.create(null)}fileSearch(c){let m;const s=A(c),E=new T.Emitter({onFirstListenerDidAdd:()=>{m=(0,n.createCancelablePromise)(l=>this.doFileSearchWithEngine(p.Engine,s,i=>E.fire(i),l)),m.then(l=>E.fire(l),l=>E.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onLastListenerRemove:()=>{m.cancel()}});return E.event}textSearch(c){let m;const s=A(c),E=new T.Emitter({onFirstListenerDidAdd:()=>{m=(0,n.createCancelablePromise)(l=>this.ripgrepTextSearch(s,i=>E.fire(i),l)),m.then(l=>E.fire(l),l=>E.fire({type:"error",error:{message:l.message,stack:l.stack}}))},onLastListenerRemove:()=>{m.cancel()}});return E.event}ripgrepTextSearch(c,m,s){return c.maxFileSize=(0,F.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new _.TextSearchEngineAdapter(c).search(s,m,m)}doFileSearch(c,m,s){return this.doFileSearchWithEngine(p.Engine,c,m,s)}doFileSearchWithEngine(c,m,s,E,l=g.BATCH_SIZE){let i=0;const r=o=>{Array.isArray(o)?(i+=o.length,s(o.map(f=>this.rawMatchToSearchItem(f)))):o.relativePath?(i++,s(this.rawMatchToSearchItem(o))):s(o)};if(m.sortByScore){let o=this.trySortedSearchFromCache(m,r,E);if(!o){const f=m.maxResults?Object.assign({},m,{maxResults:null}):m,u=new c(f);o=this.doSortedSearch(u,m,s,r,E)}return new Promise((f,u)=>{o.then(([w,P])=>{const L=P.map(O=>this.rawMatchToSearchItem(O));this.sendProgress(L,s,l),f(w)},u)})}const t=new c(m);return this.doSearch(t,r,l,E).then(o=>({limitHit:o.limitHit,type:"success",stats:{detailStats:o.stats,type:this.processType,fromCache:!1,resultCount:i,sortingTime:void 0}}))}rawMatchToSearchItem(c){return{path:c.base?(0,k.join)(c.base,c.relativePath):c.relativePath}}doSortedSearch(c,m,s,E,l){const i=new T.Emitter;let r=(0,n.createCancelablePromise)(o=>{let f=[];const u=w=>{Array.isArray(w)?f=w:(E(w),i.fire(w))};return this.doSearch(c,u,-1,o).then(w=>[w,f])}),t;if(m.cacheKey){t=this.getOrCreateCache(m.cacheKey);const o={promise:r,event:i.event,resolved:!1};t.resultsToSearchCache[m.filePattern||""]=o,r.then(()=>{o.resolved=!0},f=>{delete t.resultsToSearchCache[m.filePattern||""]}),r=this.preventCancellation(r)}return r.then(([o,f])=>{const u=t?t.scorerCache:Object.create(null),w=(typeof m.maxResults!="number"||m.maxResults>0)&&S.StopWatch.create(!1);return this.sortResults(m,f,u,l).then(P=>{const L=w?w.elapsed():-1;return[{type:"success",stats:{detailStats:o.stats,sortingTime:L,fromCache:!1,type:this.processType,workspaceFolderCount:m.folderQueries.length,resultCount:P.length},messages:o.messages,limitHit:o.limitHit||typeof m.maxResults=="number"&&f.length>m.maxResults},P]})})}getOrCreateCache(c){const m=this.caches[c];return m||(this.caches[c]=new d)}trySortedSearchFromCache(c,m,s){const E=c.cacheKey&&this.caches[c.cacheKey];if(!E)return;const l=this.getResultsFromCache(E,c.filePattern||"",m,s);if(l)return l.then(([i,r,t])=>{const o=S.StopWatch.create(!1);return this.sortResults(c,r,E.scorerCache,s).then(f=>{const u=o.elapsed(),w={fromCache:!0,detailStats:t,type:this.processType,resultCount:r.length,sortingTime:u};return[{type:"success",limitHit:i.limitHit||typeof c.maxResults=="number"&&r.length>c.maxResults,stats:w},f]})})}sortResults(c,m,s,E){const l=(0,C.prepareQuery)(c.filePattern||""),i=(t,o)=>(0,C.compareItemsByFuzzyScore)(t,o,l,!0,v,s),r=typeof c.maxResults=="number"?c.maxResults:Number.MAX_VALUE;return h.topAsync(m,i,r,1e4,E)}sendProgress(c,m,s){if(s&&s>0)for(let E=0;E<c.length;E+=s)m(c.slice(E,E+s));else m(c)}getResultsFromCache(c,m,s,E){const l=S.StopWatch.create(!1),i=m.indexOf(k.sep)>=0;let r;for(const u in c.resultsToSearchCache)if(m.startsWith(u)){if(i&&u.indexOf(k.sep)<0&&u!=="")continue;const w=c.resultsToSearchCache[u];r={promise:this.preventCancellation(w.promise),event:w.event,resolved:w.resolved};break}if(!r)return null;const t=l.elapsed(),o=S.StopWatch.create(!1),f=r.event(s);return E&&E.onCancellationRequested(()=>{f.dispose()}),r.promise.then(([u,w])=>{if(E&&E.isCancellationRequested)throw(0,I.canceled)();const P=[],L=(0,C.prepareQuery)(m).normalizedLowercase;for(const O of w)!(0,D.isFilePatternMatch)(O,L)||P.push(O);return[u,P,{cacheWasResolved:r.resolved,cacheLookupTime:t,cacheFilterTime:o.elapsed(),cacheEntryCount:w.length}]})}doSearch(c,m,s,E){return new Promise((l,i)=>{let r=[];E&&E.onCancellationRequested(()=>c.cancel()),c.search(t=>{t&&(s?(r.push(t),s>0&&r.length>=s&&(m(r),r=[])):m(t))},t=>{m(t)},(t,o)=>{r.length&&m(r),t?i(t):l(o)})})}clearCache(c){return delete this.caches[c],Promise.resolve(void 0)}preventCancellation(c){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(m,s){return c.then(m,s)}catch(m){return this.then(void 0,m)}finally(m){return c.finally(m)}}}}e.SearchService=g,g.BATCH_SIZE=512;class d{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const v=new class{getItemLabel(a){return(0,k.basename)(a.relativePath)}getItemDescription(a){return(0,k.dirname)(a.relativePath)}getItemPath(a){return a.relativePath}};function A(a){return{...a,folderQueries:a.folderQueries&&a.folderQueries.map(b),extraFileResources:a.extraFileResources&&a.extraFileResources.map(c=>R.URI.revive(c))}}function b(a){return{...a,folder:R.URI.revive(a.folder)}}}),define(ve[287],we([1,0,6,10,2,28,11,26,16,71,63,31,286,284,88,138]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let v=class extends R.ExtHostSearch{constructor(b,a,c,m){super(b,c,m);this._pfs=T,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const s=new g.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(n.Schemas.userData,new _.RipgrepSearchProvider(s)),a.remote.isRemote&&a.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const b=new g.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(n.Schemas.file,new _.RipgrepSearchProvider(b)),this.registerInternalFileSearchProvider(n.Schemas.file,new p.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(b,a){const c=this._handlePool++;return this._internalFileSearchProvider=a,this._internalFileSearchHandle=c,this._proxy.$registerFileSearchProvider(c,this._transformScheme(b)),(0,h.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(c)})}$provideFileSearchResults(b,a,c,m){const s=(0,R.reviveQuery)(c);return b===this._internalFileSearchHandle?this.doInternalFileSearch(b,a,s,m):super.$provideFileSearchResults(b,a,c,m)}doInternalFileSearch(b,a,c,m){const s=E=>{if((0,D.isSerializedFileMatch)(E)&&(E=[E]),Array.isArray(E)){this._proxy.$handleFileMatch(b,a,E.map(l=>I.URI.file(l.path)));return}E.message&&this._logService.debug("ExtHostSearch",E.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(c,s,m)}$clearCache(b){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(b),super.$clearCache(b)}createTextSearchManager(b,a){return new d.NativeTextSearchManager(b,a,void 0,"textSearchProvider")}};v=Be([Fe(0,S.IExtHostRpcService),Fe(1,k.IExtHostInitDataService),Fe(2,F.IURITransformerService),Fe(3,C.ILogService)],v),e.NativeExtHostSearch=v}),define(ve[140],we([1,0,297,127,60,22,17,3,6,9,12,33,104,105,298]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class d{constructor(w,P=""){this.debugLabel=P,this.socket=w,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=L=>{if(this.traceSocketEvent("error",{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,C.onUnexpectedError)(L)}},this.socket.on("error",this._errorListener)}traceSocketEvent(w,P){_.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,w,P)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(w){const P=L=>{this.traceSocketEvent("read",L),w(T.VSBuffer.wrap(L))};return this.socket.on("data",P),{dispose:()=>this.socket.off("data",P)}}onClose(w){const P=L=>{this.traceSocketEvent("close",{hadError:L}),w({type:0,hadError:L,error:void 0})};return this.socket.on("close",P),{dispose:()=>this.socket.off("close",P)}}onEnd(w){const P=()=>{this.traceSocketEvent("nodeEndReceived"),w()};return this.socket.on("end",P),{dispose:()=>this.socket.off("end",P)}}write(w){if(!this.socket.destroyed)try{this.traceSocketEvent("write",w),this.socket.write(w.buffer,P=>{if(P){if(P.code==="EPIPE")return;(0,C.onUnexpectedError)(P)}})}catch(P){if(P.code==="EPIPE")return;(0,C.onUnexpectedError)(P)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((w,P)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),w();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent("nodeDrainEnd"),w()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.NodeSocket=d;var v;(function(u){u[u.MinHeaderByteSize=2]="MinHeaderByteSize"})(v||(v={}));var A;(function(u){u[u.PeekHeader=1]="PeekHeader",u[u.ReadHeader=2]="ReadHeader",u[u.ReadBody=3]="ReadBody",u[u.Fin=4]="Fin"})(A||(A={}));class b extends S.Disposable{constructor(w,P,L,O){super();this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=w,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:P,inflateBytesLength:L?.byteLength||0,recordInflateBytes:O}),this._flowManager=this._register(new a(this,P,L,O,this._onData,(y,z)=>this._write(y,z))),this._register(this._flowManager.onError(y=>{console.error(y),(0,C.onUnexpectedError)(y),this._onClose.fire({type:0,hadError:!0,error:y})})),this._incomingData=new _.ChunkStream,this._register(this.socket.onData(y=>this._acceptChunk(y))),this._register(this.socket.onClose(y=>this._onClose.fire(y)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(w,P){this.socket.traceSocketEvent(w,P)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(w){return this._onData.event(w)}onClose(w){return this._onClose.event(w)}onEnd(w){return this.socket.onEnd(w)}write(w){this._flowManager.writeMessage(w)}_write(w,P){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",w);let L=2;w.byteLength<126?L+=0:w.byteLength<2**16?L+=2:L+=8;const O=T.VSBuffer.alloc(L);if(P?O.writeUInt8(194,0):O.writeUInt8(130,0),w.byteLength<126)O.writeUInt8(w.byteLength,1);else if(w.byteLength<2**16){O.writeUInt8(126,1);let y=1;O.writeUInt8(w.byteLength>>>8&255,++y),O.writeUInt8(w.byteLength>>>0&255,++y)}else{O.writeUInt8(127,1);let y=1;O.writeUInt8(0,++y),O.writeUInt8(0,++y),O.writeUInt8(0,++y),O.writeUInt8(0,++y),O.writeUInt8(w.byteLength>>>24&255,++y),O.writeUInt8(w.byteLength>>>16&255,++y),O.writeUInt8(w.byteLength>>>8&255,++y),O.writeUInt8(w.byteLength>>>0&255,++y)}this.socket.write(T.VSBuffer.concat([O,w]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(w){if(w.byteLength!==0){for(this._incomingData.acceptChunk(w);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const P=this._incomingData.peek(this._state.readLen),L=P.readUInt8(0),O=(L&128)>>>7,y=(L&64)>>>6,z=P.readUInt8(1),M=(z&128)>>>7,B=z&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(B===126?2:0)+(B===127?8:0),this._state.fin=O,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(y)),this._state.firstFrameOfMessage=Boolean(O),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const P=this._incomingData.read(this._state.readLen),L=P.readUInt8(1),O=(L&128)>>>7;let y=L&127,z=1;y===126?y=P.readUInt8(++z)*2**8+P.readUInt8(++z):y===127&&(y=P.readUInt8(++z)*0+P.readUInt8(++z)*0+P.readUInt8(++z)*0+P.readUInt8(++z)*0+P.readUInt8(++z)*2**24+P.readUInt8(++z)*2**16+P.readUInt8(++z)*2**8+P.readUInt8(++z));let M=0;O&&(M=P.readUInt8(++z)*2**24+P.readUInt8(++z)*2**16+P.readUInt8(++z)*2**8+P.readUInt8(++z)),this._state.state=3,this._state.readLen=y,this._state.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const P=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",P),s(P,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",P),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(P,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=b;class a extends S.Disposable{constructor(w,P,L,O,y,z){super();this._tracer=w,this._onData=y,this._writeFn=z,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,P?(this._zlibInflateStream=this._register(new c(this._tracer,O,L,{windowBits:15})),this._zlibDeflateStream=this._register(new m(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(M=>this._onError.fire(M))),this._register(this._zlibDeflateStream.onError(M=>this._onError.fire(M)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:T.VSBuffer.alloc(0)}writeMessage(w){this._writeQueue.push(w),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const w=this._writeQueue.shift();if(this._zlibDeflateStream){const P=await this._deflateMessage(this._zlibDeflateStream,w);this._writeFn(P,!0)}else this._writeFn(w,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(w,P){return new Promise((L,O)=>{w.write(P),w.flush(y=>L(y))})}acceptFrame(w,P,L){this._readQueue.push({data:w,isCompressed:P,isLastFrameOfMessage:L}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const w=this._readQueue.shift();if(this._zlibInflateStream&&w.isCompressed){const P=await this._inflateFrame(this._zlibInflateStream,w.data,w.isLastFrameOfMessage);this._onData.fire(P)}else this._onData.fire(w.data)}this._isProcessingReadQueue=!1}}_inflateFrame(w,P,L){return new Promise((O,y)=>{w.write(P),L&&w.write(T.VSBuffer.fromByteArray([0,0,255,255])),w.flush(z=>O(z))})}}class c extends S.Disposable{constructor(w,P,L,O){super();this._tracer=w,this._recordInflateBytes=P,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=g.createInflateRaw(O),this._zlibInflate.on("error",y=>{this._tracer.traceSocketEvent("zlibInflateError",{message:y?.message,code:y?.code}),this._onError.fire(y)}),this._zlibInflate.on("data",y=>{this._tracer.traceSocketEvent("zlibInflateData",y),this._pendingInflateData.push(T.VSBuffer.wrap(y))}),L&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",L.buffer),this._zlibInflate.write(L.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?T.VSBuffer.concat(this._recordedInflateBytes):T.VSBuffer.alloc(0)}write(w){this._recordInflateBytes&&this._recordedInflateBytes.push(w.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",w),this._zlibInflate.write(w.buffer)}flush(w){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const P=T.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,w(P)})}}class m extends S.Disposable{constructor(w,P){super();this._tracer=w,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=g.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",L=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:L?.message,code:L?.code}),this._onError.fire(L)}),this._zlibDeflate.on("data",L=>{this._tracer.traceSocketEvent("zlibDeflateData",L),this._pendingDeflateData.push(T.VSBuffer.wrap(L))})}write(w){this._tracer.traceSocketEvent("zlibDeflateWrite",w.buffer),this._zlibDeflate.write(w.buffer)}flush(w){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let P=T.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,P=P.slice(0,P.byteLength-4),w(P)})}}function s(u,w){if(w===0)return;let P=u.byteLength>>>2;for(let B=0;B<P;B++){const V=u.readUInt32BE(B*4);u.writeUInt32BE(V^w,B*4)}let L=P*4,O=u.byteLength-L;const y=w>>>24&255,z=w>>>16&255,M=w>>>8&255;O>=1&&u.writeUInt8(u.readUInt8(L)^y,L),O>=2&&u.writeUInt8(u.readUInt8(L+1)^z,L+1),O>=3&&u.writeUInt8(u.readUInt8(L+2)^M,L+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const E={[2]:107,[1]:103};function l(){const u=(0,D.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${u}-sock`;let w;return e.XDG_RUNTIME_DIR?w=(0,R.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${u}.sock`):w=(0,R.join)((0,I.tmpdir)(),`vscode-ipc-${u}.sock`),r(w),w}e.createRandomIPCHandle=l;function i(u,w,P){const L=(0,h.createHash)("md5").update(u).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${P}-${w}-sock`;let O;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?O=(0,R.join)(e.XDG_RUNTIME_DIR,`vscode-${L.substr(0,8)}-${P}-${w}.sock`):O=(0,R.join)(u,`${P}-${w}.sock`),r(O),O}e.createStaticIPCHandle=i;function r(u){const w=E[F.platform];typeof w=="number"&&u.length>=w&&console.warn(`WARNING: IPC handle "${u}" is longer than ${w} chars, try a shorter --user-data-dir`)}class t extends p.IPCServer{constructor(w){super(t.toClientConnectionEvent(w));this.server=w}static toClientConnectionEvent(w){const P=k.Event.fromNodeEventEmitter(w,"connection");return k.Event.map(P,L=>({protocol:new _.Protocol(new d(L,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(L,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=t;function o(u){return new Promise((w,P)=>{const L=(0,n.createServer)();L.on("error",P),L.listen(u,()=>{L.removeListener("error",P),w(new t(L))})})}e.serve=o;function f(u,w){return new Promise((P,L)=>{const O=(0,n.createConnection)(u,()=>{O.removeListener("error",L),P(_.Client.fromSocket(new d(O,`ipc-client${w}`),w))});O.once("error",L)})}e.connect=f}),define(ve[288],we([1,0,140,283,59,39,2,11,43]),function(ee,e,h,n,I,T,C,k,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class R{constructor(p,_,g){this._commands=p,this.logService=_,this._ipcHandlePath=g,this._server=n.createServer((d,v)=>this.onRequest(d,v)),this.setup().catch(d=>(_.error(d),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",p=>this.logService.error(p))}catch{this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(p,_){const g=(v,A)=>{_.writeHead(v,{"content-type":"application/json"}),_.end(JSON.stringify(A),b=>b&&this.logService.error(b))},d=[];p.setEncoding("utf8"),p.on("data",v=>d.push(v)),p.on("end",async()=>{try{const v=JSON.parse(d.join(""));let A;switch(v.type){case"open":A=await this.open(v);break;case"openExternal":A=await this.openExternal(v);break;case"status":A=await this.getStatus(v);break;case"extensionManagement":A=await this.manageExtensions(v);break;default:g(404,`Unknown message type: ${v.type}`);break}g(200,A)}catch(v){const A=v instanceof Error?v.message:JSON.stringify(v);g(500,A),this.logService.error("Error while processing pipe request",v)}})}async open(p){const{fileURIs:_,folderURIs:g,forceNewWindow:d,diffMode:v,addMode:A,forceReuseWindow:b,gotoLineMode:a,waitMarkerFilePath:c,remoteAuthority:m}=p,s=[];if(Array.isArray(g))for(const r of g)try{s.push({folderUri:C.URI.parse(r)})}catch{}if(Array.isArray(_))for(const r of _)try{(0,S.hasWorkspaceFileExtension)(r)?s.push({workspaceUri:C.URI.parse(r)}):s.push({fileUri:C.URI.parse(r)})}catch{}const E=c?C.URI.file(c):void 0,i={forceNewWindow:d,diffMode:v,addMode:A,gotoLineMode:a,forceReuseWindow:b,preferNewWindow:!b&&!E&&!A,waitMarkerFileURI:E,remoteAuthority:m};return this._commands.executeCommand("_remoteCLI.windowOpen",s,i),""}async openExternal(p){for(const _ of p.uris){const g=C.URI.parse(_),d=g.scheme==="file"?g:_;await this._commands.executeCommand("_remoteCLI.openExternal",d)}}async manageExtensions(p){const _=d=>d?.map(v=>/\.vsix$/i.test(v)?C.URI.parse(v):v),g={list:p.list,install:_(p.install),uninstall:_(p.uninstall),force:p.force};return await this._commands.executeCommand("_remoteCLI.manageExtensions",g)}async getStatus(p){return await this._commands.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&I.existsSync(this._ipcHandlePath)&&I.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=R;let F=class extends R{constructor(p,_){super(p,_,(0,h.createRandomIPCHandle)())}};F=Be([Fe(0,T.IExtHostCommands),Fe(1,k.ILogService)],F),e.CLIServer=F}),define(ve[289],we([1,0,70,281,270,5,282,40,259,2,10,7,288,103]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class g extends I.RequireInterceptor{_installInterceptor(){const A=this,b=ee.__$__nodeRequire("module"),a=b._load;b._load=function(E,l,i){return E=m(E),A._factories.has(E)?A._factories.get(E).load(E,R.URI.file((0,_.realpathSync)(l.filename)),r=>a.apply(this,[r,l,i])):a.apply(this,arguments)};const c=b._resolveLookupPaths;b._resolveLookupPaths=(s,E)=>c.call(this,m(s),E);const m=s=>{for(let E of A._alternatives){let l=E(s);if(l){s=l;break}}return s}}}class d extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=D.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const A=this._instaService.invokeFunction(n.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(S.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const s=this._instaService.createInstance(p.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=s.ipcHandlePath}await this._instaService.createInstance(g,A,this._registry).install(),h.mark("code/extHost/didInitAPI");const a=await this._extHostConfiguration.getConfigProvider();await(0,C.connectProxyResolver)(this._extHostWorkspace,a,this,this._logService,this._mainThreadTelemetryProxy,this._initData),h.mark("code/extHost/didInitProxyResolver");const c=process.send,m=this._extHostContext.getProxy(T.MainContext.MainThreadConsole);process.send=(...s)=>s.length===0||!s[0]||s[0].type!=="__$console"?c.apply(process,s):(m.$logExtensionHostMessage(s[0]),!1)}_getEntryPoint(A){return A.main}_loadCommonJSModule(A,b,a){if(b.scheme!==F.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let c=null;a.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this._logService.flush();try{A&&h.mark(`code/extHost/willLoadExtensionCode/${A.value}`),c=ee.__$__nodeRequire(b.fsPath)}catch(m){return Promise.reject(m)}finally{A&&h.mark(`code/extHost/didLoadExtensionCode/${A.value}`),a.codeLoadingStop()}return Promise.resolve(c)}async $setRemoteEnvironment(A){if(!!this._initData.remote.isRemote)for(const b in A){const a=A[b];a===null?delete process.env[b]:process.env[b]=a}}}e.ExtHostExtensionService=d}),define(ve[290],we([1,0,79,262,273,272,287,289,263,54,40,71,69,34,51,66,261,260,11]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_,g,d,v,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,h.registerSingleton)(F.IExtHostExtensionService,k.ExtHostExtensionService),(0,h.registerSingleton)(b.ILoggerService,A.ExtHostLoggerService),(0,h.registerSingleton)(d.IExtensionStoragePaths,v.ExtensionStoragePaths),(0,h.registerSingleton)(R.IExtHostDebugService,T.ExtHostDebugService),(0,h.registerSingleton)(D.IExtHostSearch,C.NativeExtHostSearch),(0,h.registerSingleton)(p.IExtHostTask,I.ExtHostTask),(0,h.registerSingleton)(_.IExtHostTerminalService,n.ExtHostTerminalService),(0,h.registerSingleton)(g.IExtHostTunnelService,S.ExtHostTunnelService)}),define(ve[299],we([1,0,127,300,70,17,105,140,191,132,271,22,28,103,15,113,206,274,290]),function(ee,e,h,n,I,T,C,k,S,R,F,D,p,_,g,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let r=0;r<process.execArgv.length;r++)process.execArgv[r]==="--inspect-port=0"&&(process.execArgv.splice(r,1),r--)}();const A=n(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const i=ee.__$__nodeRequire("module"),r=i._load;i._load=function(t){if(t==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return r.apply(this,arguments)}})();const b=process.exit.bind(process);function a(i){process.exit=function(r){if(i)b(r);else{const t=new Error("An extension called process.exit() and this was prevented.");console.warn(t.stack)}},process.crash=function(){const r=new Error("An extension called process.crash() and this was prevented.");console.warn(r.stack)}}let c=function(i){b()};function m(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((i,r)=>{let t=null,o=setTimeout(()=>{c("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const f=108e5,u=3e5,w=new g.ProcessTimeRunOnceScheduler(()=>c("renderer disconnected for too long (1)"),f),P=new g.ProcessTimeRunOnceScheduler(()=>c("renderer disconnected for too long (2)"),u);process.on("message",(O,y)=>{if(O&&O.type==="VSCODE_EXTHOST_IPC_SOCKET"){y.setNoDelay(!0);const z=D.VSBuffer.wrap(Buffer.from(O.initialDataChunk,"base64"));let M;if(O.skipWebSocketFrames)M=new k.NodeSocket(y,"extHost-socket");else{const B=D.VSBuffer.wrap(Buffer.from(O.inflateBytes,"base64"));M=new k.WebSocketNodeSocket(new k.NodeSocket(y,"extHost-socket"),O.permessageDeflate,B,!1)}t?(w.cancel(),P.cancel(),t.beginAcceptReconnection(M,z),t.endAcceptReconnection(),t.sendResume()):(clearTimeout(o),t=new C.PersistentProtocol(M,z),t.sendResume(),t.onDidDispose(()=>c("renderer disconnected")),i(t),t.onSocketClose(()=>{w.schedule()}))}if(O&&O.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(P.isScheduled())return;w.isScheduled()&&P.schedule()}});const L={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(L)});{const i=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((r,t)=>{const o=h.createConnection(i,()=>{o.removeListener("error",t),r(new C.PersistentProtocol(new k.NodeSocket(o,"extHost-renderer")))});o.once("error",t),o.on("close",()=>{c("renderer closed the socket")})})}}async function s(){const i=await m();return new class{constructor(){this._onMessage=new C.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,i.onMessage(r=>{(0,R.isMessageOfType)(r,2)?(this._terminating=!0,c("received terminate message from renderer")):this._onMessage.fire(r)})}send(r){this._terminating||i.send(r)}drain(){return i.drain()}}}function E(i){return new Promise(r=>{const t=i.onMessage(o=>{t.dispose();const f=JSON.parse(o.toString()),u=f.commit,w=S.default.commit;u&&w&&u!==w&&b(55);let P=0;setInterval(function(){try{process.kill(f.parentPid,0),P=0}catch(O){O&&O.code==="EPERM"?(P++,P>=3&&c(`parent process ${f.parentPid} does not exist anymore (3 x EPERM): ${O.message} (code: ${O.code}) (errno: ${O.errno})`)):c(`parent process ${f.parentPid} does not exist anymore: ${O.message} (code: ${O.code}) (errno: ${O.errno})`)}},1e3);let L;try{L=ee.__$__nodeRequire("native-watchdog"),L.start(f.parentPid)}catch(O){(0,T.onUnexpectedError)(O)}i.send((0,R.createMessageOfType)(0)),r({protocol:i,initData:f})});i.send((0,R.createMessageOfType)(1))})}async function l(){const i=[];process.on("unhandledRejection",(P,L)=>{i.push(L),setTimeout(()=>{const O=i.indexOf(L);O>=0&&L.catch(y=>{i.splice(O,1),(0,T.isCancellationError)(y)||(console.warn(`rejected promise not handled within 1 second: ${y}`),y&&y.stack&&console.warn(`stack trace: ${y.stack}`),P&&(0,T.onUnexpectedError)(P))})},1e3)}),process.on("rejectionHandled",P=>{const L=i.indexOf(P);L>=0&&i.splice(L,1)}),process.on("uncaughtException",function(P){(0,T.onUnexpectedError)(P)}),I.mark("code/extHost/willConnectToRenderer");const r=await s();I.mark("code/extHost/didConnectToRenderer");const t=await E(r);I.mark("code/extHost/didWaitForInitData");const{initData:o}=t;a(!!o.environment.extensionTestsLocationURI),o.environment.useHostProxy=A.useHostProxy!==void 0?A.useHostProxy!=="false":void 0,o.environment.skipWorkspaceStorageLock=(0,d.boolean)(A.skipWorkspaceStorageLock,!1);const f=new class{constructor(){this.pid=process.pid}exit(L){b(L)}exists(L){return p.Promises.exists(L)}realpath(L){return(0,_.realpath)(L)}};let u=null;o.remote.authority&&A.transformURIs&&(u=(0,v.createURITransformer)(o.remote.authority));const w=new F.ExtensionHostMain(t.protocol,o,f,u);c=P=>w.terminate(P)}e.startExtensionHostProcess=l,l().catch(i=>console.log(i))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0f4d3788605a486980fa3a6b3b9d1a38b1102481/core/vs/workbench/api/node/extensionHostProcess.js.map
