/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/network","vs/base/common/strings","vs/base/common/types","vs/platform/log/common/log","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/map","vs/base/common/platform","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/base/common/extpath","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testCollection","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/mime","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/languageSelector","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/editor/common/languages","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/base/common/hash","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/prefixSumComputer","vs/base/common/linkedList","vs/editor/common/core/position","vs/base/common/lazy","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],be=function(Y){for(var e=[],o=0,I=Y.length;o<I;o++)e[o]=Ee[Y[o]];return e};define(Ee[42],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function o(I,w){if(!I)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=o}),define(Ee[70],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const o=Object.prototype.hasOwnProperty;function I(M){const v=[];for(let c in M)o.call(M,c)&&v.push(M[c]);return v}e.values=I;function w(M,v){for(let c in M)if(o.call(M,c)&&v({key:c,value:M[c]},function(){delete M[c]})===!1)return}e.forEach=w;function B(M,v){const c=Object.create(null);for(const g of M){const r=v(g);let n=c[r];n||(n=c[r]=[]),n.push(g)}return c}e.groupBy=B;function S(M){const v=Object.create(null);return M&&M.forEach((c,g)=>{v[g]=c}),v}e.fromMap=S;function A(M,v){const c=[],g=[];for(let r of M)v.has(r)||c.push(r);for(let r of v)M.has(r)||g.push(r);return{removed:c,added:g}}e.diffSets=A;function C(M,v){const c=[],g=[];for(let[r,n]of M)v.has(r)||c.push(n);for(let[r,n]of v)M.has(r)||g.push(n);return{removed:c,added:g}}e.diffMaps=C;class L{constructor(){this.map=new Map}add(v,c){let g=this.map.get(v);g||(g=new Set,this.map.set(v,g)),g.add(c)}delete(v,c){const g=this.map.get(v);!g||(g.delete(c),g.size===0&&this.map.delete(v))}forEach(v,c){const g=this.map.get(v);!g||g.forEach(c)}}e.SetMap=L}),define(Ee[52],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function o(S){return(A,C,L)=>{let M=null,v=null;if(typeof L.value=="function"?(M="value",v=L.value):typeof L.get=="function"&&(M="get",v=L.get),!v)throw new Error("not supported");L[M]=S(v,C)}}e.createDecorator=o;function I(S,A,C){let L=null,M=null;if(typeof C.value=="function"?(L="value",M=C.value,M.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(L="get",M=C.get),!M)throw new Error("not supported");const v=`$memoize$${A}`;C[L]=function(...c){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:M.apply(this,c)}),this[v]}}e.memoize=I;function w(S,A,C){return o((L,M)=>{const v=`$debounce$${M}`,c=`$debounce$result$${M}`;return function(...g){this[c]||(this[c]=C?C():void 0),clearTimeout(this[v]),A&&(this[c]=A(this[c],...g),g=[this[c]]),this[v]=setTimeout(()=>{L.apply(this,g),this[c]=C?C():void 0},S)}})}e.debounce=w;function B(S,A,C){return o((L,M)=>{const v=`$throttle$timer$${M}`,c=`$throttle$result$${M}`,g=`$throttle$lastRun$${M}`,r=`$throttle$pending$${M}`;return function(...n){if(this[c]||(this[c]=C?C():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),A&&(this[c]=A(this[c],...n)),this[r])return;const m=this[g]+S;m<=Date.now()?(this[g]=Date.now(),L.apply(this,[this[c]]),this[c]=C?C():void 0):(this[r]=!0,this[v]=setTimeout(()=>{this[r]=!1,this[g]=Date.now(),L.apply(this,[this[c]]),this[c]=C?C():void 0},m-Date.now()))}})}e.throttle=B}),define(Ee[53],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class o{constructor(w){this._prefix=w,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=o,e.defaultGenerator=new o("id#")}),define(Ee[100],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var o;(function(l){l[l.None=0]="None",l[l.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",l[l.UnexpectedEndOfString=2]="UnexpectedEndOfString",l[l.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",l[l.InvalidUnicode=4]="InvalidUnicode",l[l.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",l[l.InvalidCharacter=6]="InvalidCharacter"})(o=e.ScanError||(e.ScanError={}));var I;(function(l){l[l.OpenBraceToken=1]="OpenBraceToken",l[l.CloseBraceToken=2]="CloseBraceToken",l[l.OpenBracketToken=3]="OpenBracketToken",l[l.CloseBracketToken=4]="CloseBracketToken",l[l.CommaToken=5]="CommaToken",l[l.ColonToken=6]="ColonToken",l[l.NullKeyword=7]="NullKeyword",l[l.TrueKeyword=8]="TrueKeyword",l[l.FalseKeyword=9]="FalseKeyword",l[l.StringLiteral=10]="StringLiteral",l[l.NumericLiteral=11]="NumericLiteral",l[l.LineCommentTrivia=12]="LineCommentTrivia",l[l.BlockCommentTrivia=13]="BlockCommentTrivia",l[l.LineBreakTrivia=14]="LineBreakTrivia",l[l.Trivia=15]="Trivia",l[l.Unknown=16]="Unknown",l[l.EOF=17]="EOF"})(I=e.SyntaxKind||(e.SyntaxKind={}));var w;(function(l){l[l.InvalidSymbol=1]="InvalidSymbol",l[l.InvalidNumberFormat=2]="InvalidNumberFormat",l[l.PropertyNameExpected=3]="PropertyNameExpected",l[l.ValueExpected=4]="ValueExpected",l[l.ColonExpected=5]="ColonExpected",l[l.CommaExpected=6]="CommaExpected",l[l.CloseBraceExpected=7]="CloseBraceExpected",l[l.CloseBracketExpected=8]="CloseBracketExpected",l[l.EndOfFileExpected=9]="EndOfFileExpected",l[l.InvalidCommentToken=10]="InvalidCommentToken",l[l.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",l[l.UnexpectedEndOfString=12]="UnexpectedEndOfString",l[l.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",l[l.InvalidUnicode=14]="InvalidUnicode",l[l.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",l[l.InvalidCharacter=16]="InvalidCharacter"})(w=e.ParseErrorCode||(e.ParseErrorCode={}));var B;(function(l){l.DEFAULT={allowTrailingComma:!0}})(B=e.ParseOptions||(e.ParseOptions={}));function S(l,P=!1){let u=0,i=l.length,s="",t=0,a=16,p=0;function h(q){let $=0,j=0;for(;$<q;){const J=l.charCodeAt(u);if(J>=48&&J<=57)j=j*16+J-48;else if(J>=65&&J<=70)j=j*16+J-65+10;else if(J>=97&&J<=102)j=j*16+J-97+10;else break;u++,$++}return $<q&&(j=-1),j}function _(q){u=q,s="",t=0,a=16,p=0}function T(){const q=u;if(l.charCodeAt(u)===48)u++;else for(u++;u<l.length&&L(l.charCodeAt(u));)u++;if(u<l.length&&l.charCodeAt(u)===46)if(u++,u<l.length&&L(l.charCodeAt(u)))for(u++;u<l.length&&L(l.charCodeAt(u));)u++;else return p=3,l.substring(q,u);let $=u;if(u<l.length&&(l.charCodeAt(u)===69||l.charCodeAt(u)===101))if(u++,(u<l.length&&l.charCodeAt(u)===43||l.charCodeAt(u)===45)&&u++,u<l.length&&L(l.charCodeAt(u))){for(u++;u<l.length&&L(l.charCodeAt(u));)u++;$=u}else p=3;return l.substring(q,$)}function R(){let q="",$=u;for(;;){if(u>=i){q+=l.substring($,u),p=2;break}const j=l.charCodeAt(u);if(j===34){q+=l.substring($,u),u++;break}if(j===92){if(q+=l.substring($,u),u++,u>=i){p=2;break}switch(l.charCodeAt(u++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const z=h(4);z>=0?q+=String.fromCharCode(z):p=4;break}default:p=5}$=u;continue}if(j>=0&&j<=31)if(C(j)){q+=l.substring($,u),p=2;break}else p=6;u++}return q}function W(){if(s="",p=0,t=u,u>=i)return t=i,a=17;let q=l.charCodeAt(u);if(A(q)){do u++,s+=String.fromCharCode(q),q=l.charCodeAt(u);while(A(q));return a=15}if(C(q))return u++,s+=String.fromCharCode(q),q===13&&l.charCodeAt(u)===10&&(u++,s+=`
`),a=14;switch(q){case 123:return u++,a=1;case 125:return u++,a=2;case 91:return u++,a=3;case 93:return u++,a=4;case 58:return u++,a=6;case 44:return u++,a=5;case 34:return u++,s=R(),a=10;case 47:{const $=u-1;if(l.charCodeAt(u+1)===47){for(u+=2;u<i&&!C(l.charCodeAt(u));)u++;return s=l.substring($,u),a=12}if(l.charCodeAt(u+1)===42){u+=2;const j=i-1;let J=!1;for(;u<j;){if(l.charCodeAt(u)===42&&l.charCodeAt(u+1)===47){u+=2,J=!0;break}u++}return J||(u++,p=1),s=l.substring($,u),a=13}return s+=String.fromCharCode(q),u++,a=16}case 45:if(s+=String.fromCharCode(q),u++,u===i||!L(l.charCodeAt(u)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=T(),a=11;default:for(;u<i&&E(q);)u++,q=l.charCodeAt(u);if(t!==u){switch(s=l.substring(t,u),s){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return s+=String.fromCharCode(q),u++,a=16}}function E(q){if(A(q)||C(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let q;do q=W();while(q>=12&&q<=15);return q}return{setPosition:_,getPosition:()=>u,scan:P?H:W,getToken:()=>a,getTokenValue:()=>s,getTokenOffset:()=>t,getTokenLength:()=>u-t,getTokenError:()=>p}}e.createScanner=S;function A(l){return l===32||l===9||l===11||l===12||l===160||l===5760||l>=8192&&l<=8203||l===8239||l===8287||l===12288||l===65279}function C(l){return l===10||l===13||l===8232||l===8233}function L(l){return l>=48&&l<=57}var M;(function(l){l[l.nullCharacter=0]="nullCharacter",l[l.maxAsciiCharacter=127]="maxAsciiCharacter",l[l.lineFeed=10]="lineFeed",l[l.carriageReturn=13]="carriageReturn",l[l.lineSeparator=8232]="lineSeparator",l[l.paragraphSeparator=8233]="paragraphSeparator",l[l.nextLine=133]="nextLine",l[l.space=32]="space",l[l.nonBreakingSpace=160]="nonBreakingSpace",l[l.enQuad=8192]="enQuad",l[l.emQuad=8193]="emQuad",l[l.enSpace=8194]="enSpace",l[l.emSpace=8195]="emSpace",l[l.threePerEmSpace=8196]="threePerEmSpace",l[l.fourPerEmSpace=8197]="fourPerEmSpace",l[l.sixPerEmSpace=8198]="sixPerEmSpace",l[l.figureSpace=8199]="figureSpace",l[l.punctuationSpace=8200]="punctuationSpace",l[l.thinSpace=8201]="thinSpace",l[l.hairSpace=8202]="hairSpace",l[l.zeroWidthSpace=8203]="zeroWidthSpace",l[l.narrowNoBreakSpace=8239]="narrowNoBreakSpace",l[l.ideographicSpace=12288]="ideographicSpace",l[l.mathematicalSpace=8287]="mathematicalSpace",l[l.ogham=5760]="ogham",l[l._=95]="_",l[l.$=36]="$",l[l._0=48]="_0",l[l._1=49]="_1",l[l._2=50]="_2",l[l._3=51]="_3",l[l._4=52]="_4",l[l._5=53]="_5",l[l._6=54]="_6",l[l._7=55]="_7",l[l._8=56]="_8",l[l._9=57]="_9",l[l.a=97]="a",l[l.b=98]="b",l[l.c=99]="c",l[l.d=100]="d",l[l.e=101]="e",l[l.f=102]="f",l[l.g=103]="g",l[l.h=104]="h",l[l.i=105]="i",l[l.j=106]="j",l[l.k=107]="k",l[l.l=108]="l",l[l.m=109]="m",l[l.n=110]="n",l[l.o=111]="o",l[l.p=112]="p",l[l.q=113]="q",l[l.r=114]="r",l[l.s=115]="s",l[l.t=116]="t",l[l.u=117]="u",l[l.v=118]="v",l[l.w=119]="w",l[l.x=120]="x",l[l.y=121]="y",l[l.z=122]="z",l[l.A=65]="A",l[l.B=66]="B",l[l.C=67]="C",l[l.D=68]="D",l[l.E=69]="E",l[l.F=70]="F",l[l.G=71]="G",l[l.H=72]="H",l[l.I=73]="I",l[l.J=74]="J",l[l.K=75]="K",l[l.L=76]="L",l[l.M=77]="M",l[l.N=78]="N",l[l.O=79]="O",l[l.P=80]="P",l[l.Q=81]="Q",l[l.R=82]="R",l[l.S=83]="S",l[l.T=84]="T",l[l.U=85]="U",l[l.V=86]="V",l[l.W=87]="W",l[l.X=88]="X",l[l.Y=89]="Y",l[l.Z=90]="Z",l[l.ampersand=38]="ampersand",l[l.asterisk=42]="asterisk",l[l.at=64]="at",l[l.backslash=92]="backslash",l[l.bar=124]="bar",l[l.caret=94]="caret",l[l.closeBrace=125]="closeBrace",l[l.closeBracket=93]="closeBracket",l[l.closeParen=41]="closeParen",l[l.colon=58]="colon",l[l.comma=44]="comma",l[l.dot=46]="dot",l[l.doubleQuote=34]="doubleQuote",l[l.equals=61]="equals",l[l.exclamation=33]="exclamation",l[l.greaterThan=62]="greaterThan",l[l.lessThan=60]="lessThan",l[l.minus=45]="minus",l[l.openBrace=123]="openBrace",l[l.openBracket=91]="openBracket",l[l.openParen=40]="openParen",l[l.percent=37]="percent",l[l.plus=43]="plus",l[l.question=63]="question",l[l.semicolon=59]="semicolon",l[l.singleQuote=39]="singleQuote",l[l.slash=47]="slash",l[l.tilde=126]="tilde",l[l.backspace=8]="backspace",l[l.formFeed=12]="formFeed",l[l.byteOrderMark=65279]="byteOrderMark",l[l.tab=9]="tab",l[l.verticalTab=11]="verticalTab"})(M||(M={}));function v(l,P){const u=[],i=new Object;let s;const t={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function p(h,_,T,R){t.value=h,t.offset=_,t.length=T,t.type=R,t.colonOffset=void 0,s=t}try{d(l,{onObjectBegin:(h,_)=>{if(P<=h)throw i;s=void 0,a=P>h,u.push("")},onObjectProperty:(h,_,T)=>{if(P<_||(p(h,_,T,"property"),u[u.length-1]=h,P<=_+T))throw i},onObjectEnd:(h,_)=>{if(P<=h)throw i;s=void 0,u.pop()},onArrayBegin:(h,_)=>{if(P<=h)throw i;s=void 0,u.push(0)},onArrayEnd:(h,_)=>{if(P<=h)throw i;s=void 0,u.pop()},onLiteralValue:(h,_,T)=>{if(P<_||(p(h,_,T,b(h)),P<=_+T))throw i},onSeparator:(h,_,T)=>{if(P<=_)throw i;if(h===":"&&s&&s.type==="property")s.colonOffset=_,a=!1,s=void 0;else if(h===","){const R=u[u.length-1];typeof R=="number"?u[u.length-1]=R+1:(a=!0,u[u.length-1]=""),s=void 0}}})}catch(h){if(h!==i)throw h}return{path:u,previousNode:s,isAtPropertyKey:a,matches:h=>{let _=0;for(let T=0;_<h.length&&T<u.length;T++)if(h[_]===u[T]||h[_]==="*")_++;else if(h[_]!=="**")return!1;return _===h.length}}}e.getLocation=v;function c(l,P=[],u=B.DEFAULT){let i=null,s=[];const t=[];function a(h){Array.isArray(s)?s.push(h):i!==null&&(s[i]=h)}return d(l,{onObjectBegin:()=>{const h={};a(h),t.push(s),s=h,i=null},onObjectProperty:h=>{i=h},onObjectEnd:()=>{s=t.pop()},onArrayBegin:()=>{const h=[];a(h),t.push(s),s=h,i=null},onArrayEnd:()=>{s=t.pop()},onLiteralValue:a,onError:(h,_,T)=>{P.push({error:h,offset:_,length:T})}},u),s[0]}e.parse=c;function g(l,P=[],u=B.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(h){i.type==="property"&&(i.length=h-i.offset,i=i.parent)}function t(h){return i.children.push(h),h}d(l,{onObjectBegin:h=>{i=t({type:"object",offset:h,length:-1,parent:i,children:[]})},onObjectProperty:(h,_,T)=>{i=t({type:"property",offset:_,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:h,offset:_,length:T,parent:i})},onObjectEnd:(h,_)=>{i.length=h+_-i.offset,i=i.parent,s(h+_)},onArrayBegin:(h,_)=>{i=t({type:"array",offset:h,length:-1,parent:i,children:[]})},onArrayEnd:(h,_)=>{i.length=h+_-i.offset,i=i.parent,s(h+_)},onLiteralValue:(h,_,T)=>{t({type:b(h),offset:_,length:T,parent:i,value:h}),s(_+T)},onSeparator:(h,_,T)=>{i.type==="property"&&(h===":"?i.colonOffset=_:h===","&&s(_))},onError:(h,_,T)=>{P.push({error:h,offset:_,length:T})}},u);const p=i.children[0];return p&&delete p.parent,p}e.parseTree=g;function r(l,P){if(!l)return;let u=l;for(let i of P)if(typeof i=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let s=!1;for(const t of u.children)if(Array.isArray(t.children)&&t.children[0].value===i){u=t.children[1],s=!0;break}if(!s)return}else{const s=i;if(u.type!=="array"||s<0||!Array.isArray(u.children)||s>=u.children.length)return;u=u.children[s]}return u}e.findNodeAtLocation=r;function n(l){if(!l.parent||!l.parent.children)return[];const P=n(l.parent);if(l.parent.type==="property"){const u=l.parent.children[0].value;P.push(u)}else if(l.parent.type==="array"){const u=l.parent.children.indexOf(l);u!==-1&&P.push(u)}return P}e.getNodePath=n;function m(l){switch(l.type){case"array":return l.children.map(m);case"object":{const P=Object.create(null);for(let u of l.children){const i=u.children[1];i&&(P[u.children[0].value]=m(i))}return P}case"null":case"string":case"number":case"boolean":return l.value;default:return}}e.getNodeValue=m;function y(l,P,u=!1){return P>=l.offset&&P<l.offset+l.length||u&&P===l.offset+l.length}e.contains=y;function k(l,P,u=!1){if(y(l,P,u)){const i=l.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=P;s++){const t=k(i[s],P,u);if(t)return t}return l}}e.findNodeAtOffset=k;function d(l,P,u=B.DEFAULT){const i=S(l,!1);function s(Se){return Se?()=>Se(i.getTokenOffset(),i.getTokenLength()):()=>!0}function t(Se){return Se?fe=>Se(fe,i.getTokenOffset(),i.getTokenLength()):()=>!0}const a=s(P.onObjectBegin),p=t(P.onObjectProperty),h=s(P.onObjectEnd),_=s(P.onArrayBegin),T=s(P.onArrayEnd),R=t(P.onLiteralValue),W=t(P.onSeparator),E=s(P.onComment),H=t(P.onError),q=u&&u.disallowComments,$=u&&u.allowTrailingComma;function j(){for(;;){const Se=i.scan();switch(i.getTokenError()){case 4:J(14);break;case 5:J(15);break;case 3:J(13);break;case 1:q||J(11);break;case 2:J(12);break;case 6:J(16);break}switch(Se){case 12:case 13:q?J(10):E();break;case 16:J(1);break;case 15:case 14:break;default:return Se}}}function J(Se,fe=[],ne=[]){if(H(Se),fe.length+ne.length>0){let me=i.getToken();for(;me!==17;){if(fe.indexOf(me)!==-1){j();break}else if(ne.indexOf(me)!==-1)break;me=j()}}}function z(Se){const fe=i.getTokenValue();return Se?R(fe):p(fe),j(),!0}function ie(){switch(i.getToken()){case 11:{let Se=0;try{Se=JSON.parse(i.getTokenValue()),typeof Se!="number"&&(J(2),Se=0)}catch{J(2)}R(Se);break}case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return j(),!0}function ae(){return i.getToken()!==10?(J(3,[],[2,5]),!1):(z(!1),i.getToken()===6?(W(":"),j(),de()||J(4,[],[2,5])):J(5,[],[2,5]),!0)}function te(){a(),j();let Se=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Se||J(4,[],[]),W(","),j(),i.getToken()===2&&$)break}else Se&&J(6,[],[]);ae()||J(4,[],[2,5]),Se=!0}return h(),i.getToken()!==2?J(7,[2],[]):j(),!0}function ce(){_(),j();let Se=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Se||J(4,[],[]),W(","),j(),i.getToken()===4&&$)break}else Se&&J(6,[],[]);de()||J(4,[],[4,5]),Se=!0}return T(),i.getToken()!==4?J(8,[4],[]):j(),!0}function de(){switch(i.getToken()){case 3:return ce();case 1:return te();case 10:return z(!0);default:return ie()}}return j(),i.getToken()===17?u.allowEmptyContent?!0:(J(4,[],[]),!1):de()?(i.getToken()!==17&&J(9,[],[]),!0):(J(4,[],[]),!1)}e.visit=d;function f(l,P){let u=S(l),i=[],s,t=0,a;do switch(a=u.getPosition(),s=u.scan(),s){case 12:case 13:case 17:t!==a&&i.push(l.substring(t,a)),P!==void 0&&i.push(u.getTokenValue().replace(/[^\r\n]/g,P)),t=u.getPosition();break}while(s!==17);return i.join("")}e.stripComments=f;function b(l){switch(typeof l){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(l){if(Array.isArray(l))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=b}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(Ee[101],be([0]),e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,e(Y.marked={}))}(this,function(Y){"use strict";function e(ge,ue){for(var N=0;N<ue.length;N++){var F=ue[N];F.enumerable=F.enumerable||!1,F.configurable=!0,"value"in F&&(F.writable=!0),Object.defineProperty(ge,F.key,F)}}function o(ge,ue,N){return ue&&e(ge.prototype,ue),N&&e(ge,N),Object.defineProperty(ge,"prototype",{writable:!1}),ge}function I(ge,ue){if(!!ge){if(typeof ge=="string")return w(ge,ue);var N=Object.prototype.toString.call(ge).slice(8,-1);if(N==="Object"&&ge.constructor&&(N=ge.constructor.name),N==="Map"||N==="Set")return Array.from(ge);if(N==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(N))return w(ge,ue)}}function w(ge,ue){(ue==null||ue>ge.length)&&(ue=ge.length);for(var N=0,F=new Array(ue);N<ue;N++)F[N]=ge[N];return F}function B(ge,ue){var N=typeof Symbol!="undefined"&&ge[Symbol.iterator]||ge["@@iterator"];if(N)return(N=N.call(ge)).next.bind(N);if(Array.isArray(ge)||(N=I(ge))||ue&&ge&&typeof ge.length=="number"){N&&(ge=N);var F=0;return function(){return F>=ge.length?{done:!0}:{done:!1,value:ge[F++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function S(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}Y.defaults=S();function A(ge){Y.defaults=ge}var C=/[&<>"']/,L=/[&<>"']/g,M=/[<>"']|&(?!#?\w+;)/,v=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},g=function(ue){return c[ue]};function r(ge,ue){if(ue){if(C.test(ge))return ge.replace(L,g)}else if(M.test(ge))return ge.replace(v,g);return ge}var n=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(ge){return ge.replace(n,function(ue,N){return N=N.toLowerCase(),N==="colon"?":":N.charAt(0)==="#"?N.charAt(1)==="x"?String.fromCharCode(parseInt(N.substring(2),16)):String.fromCharCode(+N.substring(1)):""})}var y=/(^|[^\[])\^/g;function k(ge,ue){ge=ge.source||ge,ue=ue||"";var N={replace:function(D,O){return O=O.source||O,O=O.replace(y,"$1"),ge=ge.replace(D,O),N},getRegex:function(){return new RegExp(ge,ue)}};return N}var d=/[^\w:]/g,f=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function b(ge,ue,N){if(ge){var F;try{F=decodeURIComponent(m(N)).replace(d,"").toLowerCase()}catch{return null}if(F.indexOf("javascript:")===0||F.indexOf("vbscript:")===0||F.indexOf("data:")===0)return null}ue&&!f.test(N)&&(N=s(ue,N));try{N=encodeURI(N).replace(/%25/g,"%")}catch{return null}return N}var l={},P=/^[^:]+:\/*[^/]*$/,u=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(ge,ue){l[" "+ge]||(P.test(ge)?l[" "+ge]=ge+"/":l[" "+ge]=h(ge,"/",!0)),ge=l[" "+ge];var N=ge.indexOf(":")===-1;return ue.substring(0,2)==="//"?N?ue:ge.replace(u,"$1")+ue:ue.charAt(0)==="/"?N?ue:ge.replace(i,"$1")+ue:ge+ue}var t={exec:function(){}};function a(ge){for(var ue=1,N,F;ue<arguments.length;ue++){N=arguments[ue];for(F in N)Object.prototype.hasOwnProperty.call(N,F)&&(ge[F]=N[F])}return ge}function p(ge,ue){var N=ge.replace(/\|/g,function(O,x,X){for(var re=!1,ve=x;--ve>=0&&X[ve]==="\\";)re=!re;return re?"|":" |"}),F=N.split(/ \|/),D=0;if(F[0].trim()||F.shift(),F[F.length-1].trim()||F.pop(),F.length>ue)F.splice(ue);else for(;F.length<ue;)F.push("");for(;D<F.length;D++)F[D]=F[D].trim().replace(/\\\|/g,"|");return F}function h(ge,ue,N){var F=ge.length;if(F===0)return"";for(var D=0;D<F;){var O=ge.charAt(F-D-1);if(O===ue&&!N)D++;else if(O!==ue&&N)D++;else break}return ge.substr(0,F-D)}function _(ge,ue){if(ge.indexOf(ue[1])===-1)return-1;for(var N=ge.length,F=0,D=0;D<N;D++)if(ge[D]==="\\")D++;else if(ge[D]===ue[0])F++;else if(ge[D]===ue[1]&&(F--,F<0))return D;return-1}function T(ge){ge&&ge.sanitize&&!ge.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(ge,ue){if(ue<1)return"";for(var N="";ue>1;)ue&1&&(N+=ge),ue>>=1,ge+=ge;return N+ge}function W(ge,ue,N,F){var D=ue.href,O=ue.title?r(ue.title):null,x=ge[1].replace(/\\([\[\]])/g,"$1");if(ge[0].charAt(0)!=="!"){F.state.inLink=!0;var X={type:"link",raw:N,href:D,title:O,text:x,tokens:F.inlineTokens(x,[])};return F.state.inLink=!1,X}else return{type:"image",raw:N,href:D,title:O,text:r(x)}}function E(ge,ue){var N=ge.match(/^(\s+)(?:```)/);if(N===null)return ue;var F=N[1];return ue.split(`
`).map(function(D){var O=D.match(/^\s+/);if(O===null)return D;var x=O[0];return x.length>=F.length?D.slice(F.length):D}).join(`
`)}var H=function(){function ge(N){this.options=N||Y.defaults}var ue=ge.prototype;return ue.space=function(F){var D=this.rules.block.newline.exec(F);if(D&&D[0].length>0)return{type:"space",raw:D[0]}},ue.code=function(F){var D=this.rules.block.code.exec(F);if(D){var O=D[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:D[0],codeBlockStyle:"indented",text:this.options.pedantic?O:h(O,`
`)}}},ue.fences=function(F){var D=this.rules.block.fences.exec(F);if(D){var O=D[0],x=E(O,D[3]||"");return{type:"code",raw:O,lang:D[2]?D[2].trim():D[2],text:x}}},ue.heading=function(F){var D=this.rules.block.heading.exec(F);if(D){var O=D[2].trim();if(/#$/.test(O)){var x=h(O,"#");(this.options.pedantic||!x||/ $/.test(x))&&(O=x.trim())}var X={type:"heading",raw:D[0],depth:D[1].length,text:O,tokens:[]};return this.lexer.inline(X.text,X.tokens),X}},ue.hr=function(F){var D=this.rules.block.hr.exec(F);if(D)return{type:"hr",raw:D[0]}},ue.blockquote=function(F){var D=this.rules.block.blockquote.exec(F);if(D){var O=D[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:D[0],tokens:this.lexer.blockTokens(O,[]),text:O}}},ue.list=function(F){var D=this.rules.block.list.exec(F);if(D){var O,x,X,re,ve,Ie,Me,Le,ze,xe,Re,Qe,tt=D[1].trim(),Te=tt.length>1,it={type:"list",raw:"",ordered:Te,start:Te?+tt.slice(0,-1):"",loose:!1,items:[]};tt=Te?"\\d{1,9}\\"+tt.slice(-1):"\\"+tt,this.options.pedantic&&(tt=Te?tt:"[*+-]");for(var G=new RegExp("^( {0,3}"+tt+")((?: [^\\n]*)?(?:\\n|$))");F&&(Qe=!1,!(!(D=G.exec(F))||this.rules.block.hr.test(F)));){if(O=D[0],F=F.substring(O.length),Le=D[2].split(`
`,1)[0],ze=F.split(`
`,1)[0],this.options.pedantic?(re=2,Re=Le.trimLeft()):(re=D[2].search(/[^ ]/),re=re>4?1:re,Re=Le.slice(re),re+=D[1].length),Ie=!1,!Le&&/^ *$/.test(ze)&&(O+=ze+`
`,F=F.substring(ze.length+1),Qe=!0),!Qe)for(var Q=new RegExp("^ {0,"+Math.min(3,re-1)+"}(?:[*+-]|\\d{1,9}[.)])");F&&(xe=F.split(`
`,1)[0],Le=xe,this.options.pedantic&&(Le=Le.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!Q.test(Le));){if(Le.search(/[^ ]/)>=re||!Le.trim())Re+=`
`+Le.slice(re);else if(!Ie)Re+=`
`+Le;else break;!Ie&&!Le.trim()&&(Ie=!0),O+=xe+`
`,F=F.substring(xe.length+1)}it.loose||(Me?it.loose=!0:/\n *\n *$/.test(O)&&(Me=!0)),this.options.gfm&&(x=/^\[[ xX]\] /.exec(Re),x&&(X=x[0]!=="[ ] ",Re=Re.replace(/^\[[ xX]\] +/,""))),it.items.push({type:"list_item",raw:O,task:!!x,checked:X,loose:!1,text:Re}),it.raw+=O}it.items[it.items.length-1].raw=O.trimRight(),it.items[it.items.length-1].text=Re.trimRight(),it.raw=it.raw.trimRight();var le=it.items.length;for(ve=0;ve<le;ve++){this.lexer.state.top=!1,it.items[ve].tokens=this.lexer.blockTokens(it.items[ve].text,[]);var Oe=it.items[ve].tokens.filter(function(Ge){return Ge.type==="space"}),He=Oe.every(function(Ge){for(var Je=Ge.raw.split(""),ft=0,It=B(Je),St;!(St=It()).done;){var kt=St.value;if(kt===`
`&&(ft+=1),ft>1)return!0}return!1});!it.loose&&Oe.length&&He&&(it.loose=!0,it.items[ve].loose=!0)}return it}},ue.html=function(F){var D=this.rules.block.html.exec(F);if(D){var O={type:"html",raw:D[0],pre:!this.options.sanitizer&&(D[1]==="pre"||D[1]==="script"||D[1]==="style"),text:D[0]};return this.options.sanitize&&(O.type="paragraph",O.text=this.options.sanitizer?this.options.sanitizer(D[0]):r(D[0]),O.tokens=[],this.lexer.inline(O.text,O.tokens)),O}},ue.def=function(F){var D=this.rules.block.def.exec(F);if(D){D[3]&&(D[3]=D[3].substring(1,D[3].length-1));var O=D[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:O,raw:D[0],href:D[2],title:D[3]}}},ue.table=function(F){var D=this.rules.block.table.exec(F);if(D){var O={type:"table",header:p(D[1]).map(function(Me){return{text:Me}}),align:D[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:D[3]?D[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(O.header.length===O.align.length){O.raw=D[0];var x=O.align.length,X,re,ve,Ie;for(X=0;X<x;X++)/^ *-+: *$/.test(O.align[X])?O.align[X]="right":/^ *:-+: *$/.test(O.align[X])?O.align[X]="center":/^ *:-+ *$/.test(O.align[X])?O.align[X]="left":O.align[X]=null;for(x=O.rows.length,X=0;X<x;X++)O.rows[X]=p(O.rows[X],O.header.length).map(function(Me){return{text:Me}});for(x=O.header.length,re=0;re<x;re++)O.header[re].tokens=[],this.lexer.inlineTokens(O.header[re].text,O.header[re].tokens);for(x=O.rows.length,re=0;re<x;re++)for(Ie=O.rows[re],ve=0;ve<Ie.length;ve++)Ie[ve].tokens=[],this.lexer.inlineTokens(Ie[ve].text,Ie[ve].tokens);return O}}},ue.lheading=function(F){var D=this.rules.block.lheading.exec(F);if(D){var O={type:"heading",raw:D[0],depth:D[2].charAt(0)==="="?1:2,text:D[1],tokens:[]};return this.lexer.inline(O.text,O.tokens),O}},ue.paragraph=function(F){var D=this.rules.block.paragraph.exec(F);if(D){var O={type:"paragraph",raw:D[0],text:D[1].charAt(D[1].length-1)===`
`?D[1].slice(0,-1):D[1],tokens:[]};return this.lexer.inline(O.text,O.tokens),O}},ue.text=function(F){var D=this.rules.block.text.exec(F);if(D){var O={type:"text",raw:D[0],text:D[0],tokens:[]};return this.lexer.inline(O.text,O.tokens),O}},ue.escape=function(F){var D=this.rules.inline.escape.exec(F);if(D)return{type:"escape",raw:D[0],text:r(D[1])}},ue.tag=function(F){var D=this.rules.inline.tag.exec(F);if(D)return!this.lexer.state.inLink&&/^<a /i.test(D[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(D[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(D[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(D[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:D[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(D[0]):r(D[0]):D[0]}},ue.link=function(F){var D=this.rules.inline.link.exec(F);if(D){var O=D[2].trim();if(!this.options.pedantic&&/^</.test(O)){if(!/>$/.test(O))return;var x=h(O.slice(0,-1),"\\");if((O.length-x.length)%2==0)return}else{var X=_(D[2],"()");if(X>-1){var re=D[0].indexOf("!")===0?5:4,ve=re+D[1].length+X;D[2]=D[2].substring(0,X),D[0]=D[0].substring(0,ve).trim(),D[3]=""}}var Ie=D[2],Me="";if(this.options.pedantic){var Le=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ie);Le&&(Ie=Le[1],Me=Le[3])}else Me=D[3]?D[3].slice(1,-1):"";return Ie=Ie.trim(),/^</.test(Ie)&&(this.options.pedantic&&!/>$/.test(O)?Ie=Ie.slice(1):Ie=Ie.slice(1,-1)),W(D,{href:Ie&&Ie.replace(this.rules.inline._escapes,"$1"),title:Me&&Me.replace(this.rules.inline._escapes,"$1")},D[0],this.lexer)}},ue.reflink=function(F,D){var O;if((O=this.rules.inline.reflink.exec(F))||(O=this.rules.inline.nolink.exec(F))){var x=(O[2]||O[1]).replace(/\s+/g," ");if(x=D[x.toLowerCase()],!x||!x.href){var X=O[0].charAt(0);return{type:"text",raw:X,text:X}}return W(O,x,O[0],this.lexer)}},ue.emStrong=function(F,D,O){O===void 0&&(O="");var x=this.rules.inline.emStrong.lDelim.exec(F);if(!!x&&!(x[3]&&O.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var X=x[1]||x[2]||"";if(!X||X&&(O===""||this.rules.inline.punctuation.exec(O))){var re=x[0].length-1,ve,Ie,Me=re,Le=0,ze=x[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ze.lastIndex=0,D=D.slice(-1*F.length+re);(x=ze.exec(D))!=null;)if(ve=x[1]||x[2]||x[3]||x[4]||x[5]||x[6],!!ve){if(Ie=ve.length,x[3]||x[4]){Me+=Ie;continue}else if((x[5]||x[6])&&re%3&&!((re+Ie)%3)){Le+=Ie;continue}if(Me-=Ie,!(Me>0)){if(Ie=Math.min(Ie,Ie+Me+Le),Math.min(re,Ie)%2){var xe=F.slice(1,re+x.index+Ie);return{type:"em",raw:F.slice(0,re+x.index+Ie+1),text:xe,tokens:this.lexer.inlineTokens(xe,[])}}var Re=F.slice(2,re+x.index+Ie-1);return{type:"strong",raw:F.slice(0,re+x.index+Ie+1),text:Re,tokens:this.lexer.inlineTokens(Re,[])}}}}}},ue.codespan=function(F){var D=this.rules.inline.code.exec(F);if(D){var O=D[2].replace(/\n/g," "),x=/[^ ]/.test(O),X=/^ /.test(O)&&/ $/.test(O);return x&&X&&(O=O.substring(1,O.length-1)),O=r(O,!0),{type:"codespan",raw:D[0],text:O}}},ue.br=function(F){var D=this.rules.inline.br.exec(F);if(D)return{type:"br",raw:D[0]}},ue.del=function(F){var D=this.rules.inline.del.exec(F);if(D)return{type:"del",raw:D[0],text:D[2],tokens:this.lexer.inlineTokens(D[2],[])}},ue.autolink=function(F,D){var O=this.rules.inline.autolink.exec(F);if(O){var x,X;return O[2]==="@"?(x=r(this.options.mangle?D(O[1]):O[1]),X="mailto:"+x):(x=r(O[1]),X=x),{type:"link",raw:O[0],text:x,href:X,tokens:[{type:"text",raw:x,text:x}]}}},ue.url=function(F,D){var O;if(O=this.rules.inline.url.exec(F)){var x,X;if(O[2]==="@")x=r(this.options.mangle?D(O[0]):O[0]),X="mailto:"+x;else{var re;do re=O[0],O[0]=this.rules.inline._backpedal.exec(O[0])[0];while(re!==O[0]);x=r(O[0]),O[1]==="www."?X="http://"+x:X=x}return{type:"link",raw:O[0],text:x,href:X,tokens:[{type:"text",raw:x,text:x}]}}},ue.inlineText=function(F,D){var O=this.rules.inline.text.exec(F);if(O){var x;return this.lexer.state.inRawBlock?x=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(O[0]):r(O[0]):O[0]:x=r(this.options.smartypants?D(O[0]):O[0]),{type:"text",raw:O[0],text:x}}},ge}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:t,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=k(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=k(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=k(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=k(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=k(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=k(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=a({},q),q.gfm=a({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=k(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=k(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=a({},q.normal,{html:k(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:t,paragraph:k(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var $={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:t,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:t,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};$._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",$.punctuation=k($.punctuation).replace(/punctuation/g,$._punctuation).getRegex(),$.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,$.escapedEmSt=/\\\*|\\_/g,$._comment=k(q._comment).replace("(?:-->|$)","-->").getRegex(),$.emStrong.lDelim=k($.emStrong.lDelim).replace(/punct/g,$._punctuation).getRegex(),$.emStrong.rDelimAst=k($.emStrong.rDelimAst,"g").replace(/punct/g,$._punctuation).getRegex(),$.emStrong.rDelimUnd=k($.emStrong.rDelimUnd,"g").replace(/punct/g,$._punctuation).getRegex(),$._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,$._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,$._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,$.autolink=k($.autolink).replace("scheme",$._scheme).replace("email",$._email).getRegex(),$._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,$.tag=k($.tag).replace("comment",$._comment).replace("attribute",$._attribute).getRegex(),$._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,$._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,$._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,$.link=k($.link).replace("label",$._label).replace("href",$._href).replace("title",$._title).getRegex(),$.reflink=k($.reflink).replace("label",$._label).replace("ref",q._label).getRegex(),$.nolink=k($.nolink).replace("ref",q._label).getRegex(),$.reflinkSearch=k($.reflinkSearch,"g").replace("reflink",$.reflink).replace("nolink",$.nolink).getRegex(),$.normal=a({},$),$.pedantic=a({},$.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:k(/^!?\[(label)\]\((.*?)\)/).replace("label",$._label).getRegex(),reflink:k(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",$._label).getRegex()}),$.gfm=a({},$.normal,{escape:k($.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),$.gfm.url=k($.gfm.url,"i").replace("email",$.gfm._extended_email).getRegex(),$.breaks=a({},$.gfm,{br:k($.br).replace("{2,}","*").getRegex(),text:k($.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function j(ge){return ge.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function J(ge){var ue="",N,F,D=ge.length;for(N=0;N<D;N++)F=ge.charCodeAt(N),Math.random()>.5&&(F="x"+F.toString(16)),ue+="&#"+F+";";return ue}var z=function(){function ge(N){this.tokens=[],this.tokens.links=Object.create(null),this.options=N||Y.defaults,this.options.tokenizer=this.options.tokenizer||new H,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var F={block:q.normal,inline:$.normal};this.options.pedantic?(F.block=q.pedantic,F.inline=$.pedantic):this.options.gfm&&(F.block=q.gfm,this.options.breaks?F.inline=$.breaks:F.inline=$.gfm),this.tokenizer.rules=F}ge.lex=function(F,D){var O=new ge(D);return O.lex(F)},ge.lexInline=function(F,D){var O=new ge(D);return O.inlineTokens(F)};var ue=ge.prototype;return ue.lex=function(F){F=F.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(F,this.tokens);for(var D;D=this.inlineQueue.shift();)this.inlineTokens(D.src,D.tokens);return this.tokens},ue.blockTokens=function(F,D){var O=this;D===void 0&&(D=[]),this.options.pedantic&&(F=F.replace(/^ +$/gm,""));for(var x,X,re,ve;F;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Me){return(x=Me.call({lexer:O},F,D))?(F=F.substring(x.raw.length),D.push(x),!0):!1}))){if(x=this.tokenizer.space(F)){F=F.substring(x.raw.length),x.raw.length===1&&D.length>0?D[D.length-1].raw+=`
`:D.push(x);continue}if(x=this.tokenizer.code(F)){F=F.substring(x.raw.length),X=D[D.length-1],X&&(X.type==="paragraph"||X.type==="text")?(X.raw+=`
`+x.raw,X.text+=`
`+x.text,this.inlineQueue[this.inlineQueue.length-1].src=X.text):D.push(x);continue}if(x=this.tokenizer.fences(F)){F=F.substring(x.raw.length),D.push(x);continue}if(x=this.tokenizer.heading(F)){F=F.substring(x.raw.length),D.push(x);continue}if(x=this.tokenizer.hr(F)){F=F.substring(x.raw.length),D.push(x);continue}if(x=this.tokenizer.blockquote(F)){F=F.substring(x.raw.length),D.push(x);continue}if(x=this.tokenizer.list(F)){F=F.substring(x.raw.length),D.push(x);continue}if(x=this.tokenizer.html(F)){F=F.substring(x.raw.length),D.push(x);continue}if(x=this.tokenizer.def(F)){F=F.substring(x.raw.length),X=D[D.length-1],X&&(X.type==="paragraph"||X.type==="text")?(X.raw+=`
`+x.raw,X.text+=`
`+x.raw,this.inlineQueue[this.inlineQueue.length-1].src=X.text):this.tokens.links[x.tag]||(this.tokens.links[x.tag]={href:x.href,title:x.title});continue}if(x=this.tokenizer.table(F)){F=F.substring(x.raw.length),D.push(x);continue}if(x=this.tokenizer.lheading(F)){F=F.substring(x.raw.length),D.push(x);continue}if(re=F,this.options.extensions&&this.options.extensions.startBlock&&function(){var Me=1/0,Le=F.slice(1),ze=void 0;O.options.extensions.startBlock.forEach(function(xe){ze=xe.call({lexer:this},Le),typeof ze=="number"&&ze>=0&&(Me=Math.min(Me,ze))}),Me<1/0&&Me>=0&&(re=F.substring(0,Me+1))}(),this.state.top&&(x=this.tokenizer.paragraph(re))){X=D[D.length-1],ve&&X.type==="paragraph"?(X.raw+=`
`+x.raw,X.text+=`
`+x.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=X.text):D.push(x),ve=re.length!==F.length,F=F.substring(x.raw.length);continue}if(x=this.tokenizer.text(F)){F=F.substring(x.raw.length),X=D[D.length-1],X&&X.type==="text"?(X.raw+=`
`+x.raw,X.text+=`
`+x.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=X.text):D.push(x);continue}if(F){var Ie="Infinite loop on byte: "+F.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return this.state.top=!0,D},ue.inline=function(F,D){this.inlineQueue.push({src:F,tokens:D})},ue.inlineTokens=function(F,D){var O=this;D===void 0&&(D=[]);var x,X,re,ve=F,Ie,Me,Le;if(this.tokens.links){var ze=Object.keys(this.tokens.links);if(ze.length>0)for(;(Ie=this.tokenizer.rules.inline.reflinkSearch.exec(ve))!=null;)ze.includes(Ie[0].slice(Ie[0].lastIndexOf("[")+1,-1))&&(ve=ve.slice(0,Ie.index)+"["+R("a",Ie[0].length-2)+"]"+ve.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ie=this.tokenizer.rules.inline.blockSkip.exec(ve))!=null;)ve=ve.slice(0,Ie.index)+"["+R("a",Ie[0].length-2)+"]"+ve.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ie=this.tokenizer.rules.inline.escapedEmSt.exec(ve))!=null;)ve=ve.slice(0,Ie.index)+"++"+ve.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;F;)if(Me||(Le=""),Me=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Re){return(x=Re.call({lexer:O},F,D))?(F=F.substring(x.raw.length),D.push(x),!0):!1}))){if(x=this.tokenizer.escape(F)){F=F.substring(x.raw.length),D.push(x);continue}if(x=this.tokenizer.tag(F)){F=F.substring(x.raw.length),X=D[D.length-1],X&&x.type==="text"&&X.type==="text"?(X.raw+=x.raw,X.text+=x.text):D.push(x);continue}if(x=this.tokenizer.link(F)){F=F.substring(x.raw.length),D.push(x);continue}if(x=this.tokenizer.reflink(F,this.tokens.links)){F=F.substring(x.raw.length),X=D[D.length-1],X&&x.type==="text"&&X.type==="text"?(X.raw+=x.raw,X.text+=x.text):D.push(x);continue}if(x=this.tokenizer.emStrong(F,ve,Le)){F=F.substring(x.raw.length),D.push(x);continue}if(x=this.tokenizer.codespan(F)){F=F.substring(x.raw.length),D.push(x);continue}if(x=this.tokenizer.br(F)){F=F.substring(x.raw.length),D.push(x);continue}if(x=this.tokenizer.del(F)){F=F.substring(x.raw.length),D.push(x);continue}if(x=this.tokenizer.autolink(F,J)){F=F.substring(x.raw.length),D.push(x);continue}if(!this.state.inLink&&(x=this.tokenizer.url(F,J))){F=F.substring(x.raw.length),D.push(x);continue}if(re=F,this.options.extensions&&this.options.extensions.startInline&&function(){var Re=1/0,Qe=F.slice(1),tt=void 0;O.options.extensions.startInline.forEach(function(Te){tt=Te.call({lexer:this},Qe),typeof tt=="number"&&tt>=0&&(Re=Math.min(Re,tt))}),Re<1/0&&Re>=0&&(re=F.substring(0,Re+1))}(),x=this.tokenizer.inlineText(re,j)){F=F.substring(x.raw.length),x.raw.slice(-1)!=="_"&&(Le=x.raw.slice(-1)),Me=!0,X=D[D.length-1],X&&X.type==="text"?(X.raw+=x.raw,X.text+=x.text):D.push(x);continue}if(F){var xe="Infinite loop on byte: "+F.charCodeAt(0);if(this.options.silent){console.error(xe);break}else throw new Error(xe)}}return D},o(ge,null,[{key:"rules",get:function(){return{block:q,inline:$}}}]),ge}(),ie=function(){function ge(N){this.options=N||Y.defaults}var ue=ge.prototype;return ue.code=function(F,D,O){var x=(D||"").match(/\S*/)[0];if(this.options.highlight){var X=this.options.highlight(F,x);X!=null&&X!==F&&(O=!0,F=X)}return F=F.replace(/\n$/,"")+`
`,x?'<pre><code class="'+this.options.langPrefix+r(x,!0)+'">'+(O?F:r(F,!0))+`</code></pre>
`:"<pre><code>"+(O?F:r(F,!0))+`</code></pre>
`},ue.blockquote=function(F){return`<blockquote>
`+F+`</blockquote>
`},ue.html=function(F){return F},ue.heading=function(F,D,O,x){return this.options.headerIds?"<h"+D+' id="'+this.options.headerPrefix+x.slug(O)+'">'+F+"</h"+D+`>
`:"<h"+D+">"+F+"</h"+D+`>
`},ue.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ue.list=function(F,D,O){var x=D?"ol":"ul",X=D&&O!==1?' start="'+O+'"':"";return"<"+x+X+`>
`+F+"</"+x+`>
`},ue.listitem=function(F){return"<li>"+F+`</li>
`},ue.checkbox=function(F){return"<input "+(F?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ue.paragraph=function(F){return"<p>"+F+`</p>
`},ue.table=function(F,D){return D&&(D="<tbody>"+D+"</tbody>"),`<table>
<thead>
`+F+`</thead>
`+D+`</table>
`},ue.tablerow=function(F){return`<tr>
`+F+`</tr>
`},ue.tablecell=function(F,D){var O=D.header?"th":"td",x=D.align?"<"+O+' align="'+D.align+'">':"<"+O+">";return x+F+"</"+O+`>
`},ue.strong=function(F){return"<strong>"+F+"</strong>"},ue.em=function(F){return"<em>"+F+"</em>"},ue.codespan=function(F){return"<code>"+F+"</code>"},ue.br=function(){return this.options.xhtml?"<br/>":"<br>"},ue.del=function(F){return"<del>"+F+"</del>"},ue.link=function(F,D,O){if(F=b(this.options.sanitize,this.options.baseUrl,F),F===null)return O;var x='<a href="'+r(F)+'"';return D&&(x+=' title="'+D+'"'),x+=">"+O+"</a>",x},ue.image=function(F,D,O){if(F=b(this.options.sanitize,this.options.baseUrl,F),F===null)return O;var x='<img src="'+F+'" alt="'+O+'"';return D&&(x+=' title="'+D+'"'),x+=this.options.xhtml?"/>":">",x},ue.text=function(F){return F},ge}(),ae=function(){function ge(){}var ue=ge.prototype;return ue.strong=function(F){return F},ue.em=function(F){return F},ue.codespan=function(F){return F},ue.del=function(F){return F},ue.html=function(F){return F},ue.text=function(F){return F},ue.link=function(F,D,O){return""+O},ue.image=function(F,D,O){return""+O},ue.br=function(){return""},ge}(),te=function(){function ge(){this.seen={}}var ue=ge.prototype;return ue.serialize=function(F){return F.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ue.getNextSafeSlug=function(F,D){var O=F,x=0;if(this.seen.hasOwnProperty(O)){x=this.seen[F];do x++,O=F+"-"+x;while(this.seen.hasOwnProperty(O))}return D||(this.seen[F]=x,this.seen[O]=0),O},ue.slug=function(F,D){D===void 0&&(D={});var O=this.serialize(F);return this.getNextSafeSlug(O,D.dryrun)},ge}(),ce=function(){function ge(N){this.options=N||Y.defaults,this.options.renderer=this.options.renderer||new ie,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ae,this.slugger=new te}ge.parse=function(F,D){var O=new ge(D);return O.parse(F)},ge.parseInline=function(F,D){var O=new ge(D);return O.parseInline(F)};var ue=ge.prototype;return ue.parse=function(F,D){D===void 0&&(D=!0);var O="",x,X,re,ve,Ie,Me,Le,ze,xe,Re,Qe,tt,Te,it,G,Q,le,Oe,He,Ge=F.length;for(x=0;x<Ge;x++){if(Re=F[x],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Re.type]&&(He=this.options.extensions.renderers[Re.type].call({parser:this},Re),He!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Re.type))){O+=He||"";continue}switch(Re.type){case"space":continue;case"hr":{O+=this.renderer.hr();continue}case"heading":{O+=this.renderer.heading(this.parseInline(Re.tokens),Re.depth,m(this.parseInline(Re.tokens,this.textRenderer)),this.slugger);continue}case"code":{O+=this.renderer.code(Re.text,Re.lang,Re.escaped);continue}case"table":{for(ze="",Le="",ve=Re.header.length,X=0;X<ve;X++)Le+=this.renderer.tablecell(this.parseInline(Re.header[X].tokens),{header:!0,align:Re.align[X]});for(ze+=this.renderer.tablerow(Le),xe="",ve=Re.rows.length,X=0;X<ve;X++){for(Me=Re.rows[X],Le="",Ie=Me.length,re=0;re<Ie;re++)Le+=this.renderer.tablecell(this.parseInline(Me[re].tokens),{header:!1,align:Re.align[re]});xe+=this.renderer.tablerow(Le)}O+=this.renderer.table(ze,xe);continue}case"blockquote":{xe=this.parse(Re.tokens),O+=this.renderer.blockquote(xe);continue}case"list":{for(Qe=Re.ordered,tt=Re.start,Te=Re.loose,ve=Re.items.length,xe="",X=0;X<ve;X++)G=Re.items[X],Q=G.checked,le=G.task,it="",G.task&&(Oe=this.renderer.checkbox(Q),Te?G.tokens.length>0&&G.tokens[0].type==="paragraph"?(G.tokens[0].text=Oe+" "+G.tokens[0].text,G.tokens[0].tokens&&G.tokens[0].tokens.length>0&&G.tokens[0].tokens[0].type==="text"&&(G.tokens[0].tokens[0].text=Oe+" "+G.tokens[0].tokens[0].text)):G.tokens.unshift({type:"text",text:Oe}):it+=Oe),it+=this.parse(G.tokens,Te),xe+=this.renderer.listitem(it,le,Q);O+=this.renderer.list(xe,Qe,tt);continue}case"html":{O+=this.renderer.html(Re.text);continue}case"paragraph":{O+=this.renderer.paragraph(this.parseInline(Re.tokens));continue}case"text":{for(xe=Re.tokens?this.parseInline(Re.tokens):Re.text;x+1<Ge&&F[x+1].type==="text";)Re=F[++x],xe+=`
`+(Re.tokens?this.parseInline(Re.tokens):Re.text);O+=D?this.renderer.paragraph(xe):xe;continue}default:{var Je='Token with "'+Re.type+'" type was not found.';if(this.options.silent){console.error(Je);return}else throw new Error(Je)}}}return O},ue.parseInline=function(F,D){D=D||this.renderer;var O="",x,X,re,ve=F.length;for(x=0;x<ve;x++){if(X=F[x],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[X.type]&&(re=this.options.extensions.renderers[X.type].call({parser:this},X),re!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(X.type))){O+=re||"";continue}switch(X.type){case"escape":{O+=D.text(X.text);break}case"html":{O+=D.html(X.text);break}case"link":{O+=D.link(X.href,X.title,this.parseInline(X.tokens,D));break}case"image":{O+=D.image(X.href,X.title,X.text);break}case"strong":{O+=D.strong(this.parseInline(X.tokens,D));break}case"em":{O+=D.em(this.parseInline(X.tokens,D));break}case"codespan":{O+=D.codespan(X.text);break}case"br":{O+=D.br();break}case"del":{O+=D.del(this.parseInline(X.tokens,D));break}case"text":{O+=D.text(X.text);break}default:{var Ie='Token with "'+X.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}}return O},ge}();function de(ge,ue,N){if(typeof ge=="undefined"||ge===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ge!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ge)+", string expected");if(typeof ue=="function"&&(N=ue,ue=null),ue=a({},de.defaults,ue||{}),T(ue),N){var F=ue.highlight,D;try{D=z.lex(ge,ue)}catch(re){return N(re)}var O=function(ve){var Ie;if(!ve)try{ue.walkTokens&&de.walkTokens(D,ue.walkTokens),Ie=ce.parse(D,ue)}catch(Me){ve=Me}return ue.highlight=F,ve?N(ve):N(null,Ie)};if(!F||F.length<3||(delete ue.highlight,!D.length))return O();var x=0;de.walkTokens(D,function(re){re.type==="code"&&(x++,setTimeout(function(){F(re.text,re.lang,function(ve,Ie){if(ve)return O(ve);Ie!=null&&Ie!==re.text&&(re.text=Ie,re.escaped=!0),x--,x===0&&O()})},0))}),x===0&&O();return}try{var X=z.lex(ge,ue);return ue.walkTokens&&de.walkTokens(X,ue.walkTokens),ce.parse(X,ue)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+r(re.message+"",!0)+"</pre>";throw re}}de.options=de.setOptions=function(ge){return a(de.defaults,ge),A(de.defaults),de},de.getDefaults=S,de.defaults=Y.defaults,de.use=function(){for(var ge=arguments.length,ue=new Array(ge),N=0;N<ge;N++)ue[N]=arguments[N];var F=a.apply(void 0,[{}].concat(ue)),D=de.defaults.extensions||{renderers:{},childTokens:{}},O;ue.forEach(function(x){if(x.extensions&&(O=!0,x.extensions.forEach(function(re){if(!re.name)throw new Error("extension name required");if(re.renderer){var ve=D.renderers?D.renderers[re.name]:null;ve?D.renderers[re.name]=function(){for(var Ie=arguments.length,Me=new Array(Ie),Le=0;Le<Ie;Le++)Me[Le]=arguments[Le];var ze=re.renderer.apply(this,Me);return ze===!1&&(ze=ve.apply(this,Me)),ze}:D.renderers[re.name]=re.renderer}if(re.tokenizer){if(!re.level||re.level!=="block"&&re.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");D[re.level]?D[re.level].unshift(re.tokenizer):D[re.level]=[re.tokenizer],re.start&&(re.level==="block"?D.startBlock?D.startBlock.push(re.start):D.startBlock=[re.start]:re.level==="inline"&&(D.startInline?D.startInline.push(re.start):D.startInline=[re.start]))}re.childTokens&&(D.childTokens[re.name]=re.childTokens)})),x.renderer&&function(){var re=de.defaults.renderer||new ie,ve=function(Le){var ze=re[Le];re[Le]=function(){for(var xe=arguments.length,Re=new Array(xe),Qe=0;Qe<xe;Qe++)Re[Qe]=arguments[Qe];var tt=x.renderer[Le].apply(re,Re);return tt===!1&&(tt=ze.apply(re,Re)),tt}};for(var Ie in x.renderer)ve(Ie);F.renderer=re}(),x.tokenizer&&function(){var re=de.defaults.tokenizer||new H,ve=function(Le){var ze=re[Le];re[Le]=function(){for(var xe=arguments.length,Re=new Array(xe),Qe=0;Qe<xe;Qe++)Re[Qe]=arguments[Qe];var tt=x.tokenizer[Le].apply(re,Re);return tt===!1&&(tt=ze.apply(re,Re)),tt}};for(var Ie in x.tokenizer)ve(Ie);F.tokenizer=re}(),x.walkTokens){var X=de.defaults.walkTokens;F.walkTokens=function(re){x.walkTokens.call(this,re),X&&X.call(this,re)}}O&&(F.extensions=D),de.setOptions(F)})},de.walkTokens=function(ge,ue){for(var N=function(){var x=D.value;switch(ue.call(de,x),x.type){case"table":{for(var X=B(x.header),re;!(re=X()).done;){var ve=re.value;de.walkTokens(ve.tokens,ue)}for(var Ie=B(x.rows),Me;!(Me=Ie()).done;)for(var Le=Me.value,ze=B(Le),xe;!(xe=ze()).done;){var Re=xe.value;de.walkTokens(Re.tokens,ue)}break}case"list":{de.walkTokens(x.items,ue);break}default:de.defaults.extensions&&de.defaults.extensions.childTokens&&de.defaults.extensions.childTokens[x.type]?de.defaults.extensions.childTokens[x.type].forEach(function(Qe){de.walkTokens(x[Qe],ue)}):x.tokens&&de.walkTokens(x.tokens,ue)}},F=B(ge),D;!(D=F()).done;)N()},de.parseInline=function(ge,ue){if(typeof ge=="undefined"||ge===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ge!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ge)+", string expected");ue=a({},de.defaults,ue||{}),T(ue);try{var N=z.lexInline(ge,ue);return ue.walkTokens&&de.walkTokens(N,ue.walkTokens),ce.parseInline(N,ue)}catch(F){if(F.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+r(F.message+"",!0)+"</pre>";throw F}},de.Parser=ce,de.parser=ce.parse,de.Renderer=ie,de.TextRenderer=ae,de.Lexer=z,de.lexer=z.lex,de.Tokenizer=H,de.Slugger=te,de.parse=de;var Se=de.options,fe=de.setOptions,ne=de.use,me=de.walkTokens,ke=de.parseInline,Ae=de,Be=ce.parse,Xe=z.lex;Y.Lexer=z,Y.Parser=ce,Y.Renderer=ie,Y.Slugger=te,Y.TextRenderer=ae,Y.Tokenizer=H,Y.getDefaults=S,Y.lexer=Xe,Y.marked=de,Y.options=Se,Y.parse=Ae,Y.parseInline=ke,Y.parser=Be,Y.setOptions=fe,Y.use=ne,Y.walkTokens=me,Object.defineProperty(Y,"__esModule",{value:!0})}),define(Ee[102],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function o(A,C,L){return Math.min(Math.max(A,C),L)}e.clamp=o;function I(A,C){return(C+A%C)%C}e.rot=I;class w{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=w;class B{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=B;class S{constructor(C){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(C),this._values.fill(0,0,C)}update(C){const L=this._values[this._index];return this._values[this._index]=C,this._index=(this._index+1)%this._values.length,this._sum-=L,this._sum+=C,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=S}),function(){function Y(w){const B=[];typeof w=="number"&&B.push("code/timeOrigin",w);function S(C){B.push(C,Date.now())}function A(){const C=[];for(let L=0;L<B.length;L+=2)C.push({name:B[L],startTime:B[L+1]});return C}return{mark:S,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const B=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const S of performance.getEntriesByType("mark"))B.push({name:S.name,startTime:Math.round(w+S.startTime)});return B}};if(typeof process=="object"){const w=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function o(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=e()),w.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return o(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=o(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=o(I))}(),define(Ee[71],be([1,0,17]),function(Y,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var I;(function(v){v.text="text/plain",v.binary="application/octet-stream",v.unknown="application/unknown",v.markdown="text/markdown",v.latex="text/latex",v.uriList="text/uri-list"})(I=e.Mimes||(e.Mimes={}));const w={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},B={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function S(v){const c=(0,o.extname)(v),g=w[c.toLowerCase()];return g!==void 0?g:A(v)}e.getMediaOrTextMime=S;function A(v){const c=(0,o.extname)(v);return B[c.toLowerCase()]}e.getMediaMime=A;function C(v){for(const c in B)if(B[c]===v)return c}e.getExtensionForMimeType=C;const L=/^(.+)\/(.+?)(;.+)?$/;function M(v,c){const g=L.exec(v);return g?`${g[1].toLowerCase()}/${g[2].toLowerCase()}${g[3]??""}`:c?void 0:v}e.normalizeMimeType=M}),define(Ee[103],be([1,0,15,6]),function(Y,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function w(d){const f=d;return f?[f.on,f.pause,f.resume,f.destroy].every(b=>typeof b=="function"):!1}e.isReadableStream=w;function B(d){const f=d;return f?w(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.isReadableBufferedStream=B;function S(d,f){return new A(d,f)}e.newWriteableStream=S;class A{constructor(f,b){this.reducer=f,this.options=b,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(f){if(!this.state.destroyed){if(this.state.flowing)this.emitData(f);else if(this.buffer.data.push(f),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(b=>this.pendingWritePromises.push(b))}}error(f){this.state.destroyed||(this.state.flowing?this.emitError(f):this.buffer.error.push(f))}end(f){this.state.destroyed||(typeof f!="undefined"&&this.write(f),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(f){this.listeners.data.slice(0).forEach(b=>b(f))}emitError(f){this.listeners.error.length===0?(0,o.onUnexpectedError)(f):this.listeners.error.slice(0).forEach(b=>b(f))}emitEnd(){this.listeners.end.slice(0).forEach(f=>f())}on(f,b){if(!this.state.destroyed)switch(f){case"data":this.listeners.data.push(b),this.resume();break;case"end":this.listeners.end.push(b),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(b),this.state.flowing&&this.flowErrors();break}}removeListener(f,b){if(this.state.destroyed)return;let l;switch(f){case"data":l=this.listeners.data;break;case"end":l=this.listeners.end;break;case"error":l=this.listeners.error;break}if(l){const P=l.indexOf(b);P>=0&&l.splice(P,1)}}flowData(){if(this.buffer.data.length>0){const f=this.reducer(this.buffer.data);this.emitData(f),this.buffer.data.length=0;const b=[...this.pendingWritePromises];this.pendingWritePromises.length=0,b.forEach(l=>l())}}flowErrors(){if(this.listeners.error.length>0){for(const f of this.buffer.error)this.emitError(f);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(d,f){const b=[];let l;for(;(l=d.read())!==null;)b.push(l);return f(b)}e.consumeReadable=C;function L(d,f,b){const l=[];let P;for(;(P=d.read())!==null&&l.length<b;)l.push(P);return P===null&&l.length>0?f(l):{read:()=>{if(l.length>0)return l.shift();if(typeof P!="undefined"){const u=P;return P=void 0,u}return d.read()}}}e.peekReadable=L;function M(d,f){return new Promise((b,l)=>{const P=[];v(d,{onData:u=>{f&&P.push(u)},onError:u=>{f?l(u):b(void 0)},onEnd:()=>{b(f?f(P):void 0)}})})}e.consumeStream=M;function v(d,f){let b=!1;return d.on("error",l=>{b||f.onError(l)}),d.on("end",()=>{b||f.onEnd()}),d.on("data",l=>{b||f.onData(l)}),(0,I.toDisposable)(()=>b=!0)}e.listenStream=v;function c(d,f){return new Promise((b,l)=>{const P=new I.DisposableStore,u=[],i=a=>{if(u.push(a),u.length>f)return P.dispose(),d.pause(),b({stream:d,buffer:u,ended:!1})},s=a=>l(a),t=()=>b({stream:d,buffer:u,ended:!0});P.add((0,I.toDisposable)(()=>d.removeListener("error",s))),d.on("error",s),P.add((0,I.toDisposable)(()=>d.removeListener("end",t))),d.on("end",t),P.add((0,I.toDisposable)(()=>d.removeListener("data",i))),d.on("data",i)})}e.peekStream=c;function g(d,f){const b=S(f);return b.end(d),b}e.toStream=g;function r(){const d=S(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=r;function n(d){let f=!1;return{read:()=>f?null:(f=!0,d)}}e.toReadable=n;function m(d,f,b){const l=S(b);return v(d,{onData:P=>l.write(f.data(P)),onError:P=>l.error(f.error?f.error(P):P),onEnd:()=>l.end()}),l}e.transform=m;function y(d,f,b){let l=!1;return{read:()=>{const P=f.read();return l?P:(l=!0,P!==null?b([d,P]):d)}}}e.prefixedReadable=y;function k(d,f,b){let l=!1;const P=S(b);return v(f,{onData:u=>l?P.write(u):(l=!0,P.write(b([d,u]))),onError:u=>P.error(u),onEnd:()=>{l||(l=!0,P.write(d)),P.end()}}),P}e.prefixedStream=k}),define(Ee[21],be([1,0,103]),function(Y,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const I=typeof Buffer!="undefined";let w,B;class S{constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}static alloc(p){return I?new S(Buffer.allocUnsafe(p)):new S(new Uint8Array(p))}static wrap(p){return I&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new S(p)}static fromString(p,h){return!(h?.dontUseNodeBuffer||!1)&&I?new S(Buffer.from(p)):(w||(w=new TextEncoder),new S(w.encode(p)))}static fromByteArray(p){const h=S.alloc(p.length);for(let _=0,T=p.length;_<T;_++)h.buffer[_]=p[_];return h}static concat(p,h){if(typeof h=="undefined"){h=0;for(let R=0,W=p.length;R<W;R++)h+=p[R].byteLength}const _=S.alloc(h);let T=0;for(let R=0,W=p.length;R<W;R++){const E=p[R];_.set(E,T),T+=E.byteLength}return _}clone(){const p=S.alloc(this.byteLength);return p.set(this),p}toString(){return I?this.buffer.toString():(B||(B=new TextDecoder),B.decode(this.buffer))}slice(p,h){return new S(this.buffer.subarray(p,h))}set(p,h){if(p instanceof S)this.buffer.set(p.buffer,h);else if(p instanceof Uint8Array)this.buffer.set(p,h);else if(p instanceof ArrayBuffer)this.buffer.set(new Uint8Array(p),h);else if(ArrayBuffer.isView(p))this.buffer.set(new Uint8Array(p.buffer,p.byteOffset,p.byteLength),h);else throw new Error("Unknown argument 'array'")}readUInt32BE(p){return L(this.buffer,p)}writeUInt32BE(p,h){M(this.buffer,p,h)}readUInt32LE(p){return v(this.buffer,p)}writeUInt32LE(p,h){c(this.buffer,p,h)}readUInt8(p){return g(this.buffer,p)}writeUInt8(p,h){r(this.buffer,p,h)}}e.VSBuffer=S;function A(a,p){return a[p+0]<<0>>>0|a[p+1]<<8>>>0}e.readUInt16LE=A;function C(a,p,h){a[h+0]=p&255,p=p>>>8,a[h+1]=p&255}e.writeUInt16LE=C;function L(a,p){return a[p]*2**24+a[p+1]*2**16+a[p+2]*2**8+a[p+3]}e.readUInt32BE=L;function M(a,p,h){a[h+3]=p,p=p>>>8,a[h+2]=p,p=p>>>8,a[h+1]=p,p=p>>>8,a[h]=p}e.writeUInt32BE=M;function v(a,p){return a[p+0]<<0>>>0|a[p+1]<<8>>>0|a[p+2]<<16>>>0|a[p+3]<<24>>>0}e.readUInt32LE=v;function c(a,p,h){a[h+0]=p&255,p=p>>>8,a[h+1]=p&255,p=p>>>8,a[h+2]=p&255,p=p>>>8,a[h+3]=p&255}e.writeUInt32LE=c;function g(a,p){return a[p]}e.readUInt8=g;function r(a,p,h){a[h]=p}e.writeUInt8=r;function n(a){return o.consumeReadable(a,p=>S.concat(p))}e.readableToBuffer=n;function m(a){return o.toReadable(a)}e.bufferToReadable=m;function y(a){return o.consumeStream(a,p=>S.concat(p))}e.streamToBuffer=y;async function k(a){return a.ended?S.concat(a.buffer):S.concat([...a.buffer,await y(a.stream)])}e.bufferedStreamToBuffer=k;function d(a){return o.toStream(a,p=>S.concat(p))}e.bufferToStream=d;function f(a){return o.transform(a,{data:p=>typeof p=="string"?S.fromString(p):S.wrap(p)},p=>S.concat(p))}e.streamToBufferReadableStream=f;function b(a){return o.newWriteableStream(p=>S.concat(p),a)}e.newWriteableBufferStream=b;function l(a,p){return o.prefixedReadable(a,p,h=>S.concat(h))}e.prefixedBufferReadable=l;function P(a,p){return o.prefixedStream(a,p,h=>S.concat(h))}e.prefixedBufferStream=P;function u(a){let p=0,h=0,_=0;const T=new Uint8Array(Math.floor(a.length/4*3)),R=E=>{switch(h){case 3:T[_++]=p|E,h=0;break;case 2:T[_++]=p|E>>>2,p=E<<6,h=3;break;case 1:T[_++]=p|E>>>4,p=E<<4,h=2;break;default:p=E<<2,h=1}};for(let E=0;E<a.length;E++){const H=a.charCodeAt(E);if(H>=65&&H<=90)R(H-65);else if(H>=97&&H<=122)R(H-97+26);else if(H>=48&&H<=57)R(H-48+52);else if(H===43||H===45)R(62);else if(H===47||H===95)R(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${a[E]}`)}}const W=_;for(;h>0;)R(0);return S.wrap(T).slice(0,W)}e.decodeBase64=u;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function t({buffer:a},p=!0,h=!1){const _=h?s:i;let T="";const R=a.byteLength%3;let W=0;for(;W<a.byteLength-R;W+=3){const E=a[W+0],H=a[W+1],q=a[W+2];T+=_[E>>>2],T+=_[(E<<4|H>>>4)&63],T+=_[(H<<2|q>>>6)&63],T+=_[q&63]}if(R===1){const E=a[W+0];T+=_[E>>>2],T+=_[E<<4&63],p&&(T+="==")}else if(R===2){const E=a[W+0],H=a[W+1];T+=_[E>>>2],T+=_[(E<<4|H>>>4)&63],T+=_[H<<2&63],p&&(T+="=")}return T}e.encodeBase64=t});var je=this&&this.__classPrivateFieldSet||function(Y,e,o,I,w){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!w:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?w.call(Y,o):w?w.value=o:e.set(Y,o),o},De=this&&this.__classPrivateFieldGet||function(Y,e,o,I){if(o==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?I:o==="a"?I.call(Y):I?I.value:e.get(Y)};define(Ee[22],be([1,0,16,10]),function(Y,e,o,I){"use strict";var w,B,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function A(u,i,s){let t=u.get(i);return t===void 0&&(t=s,u.set(i,t)),t}e.getOrSet=A;function C(u){const i=[];return u.forEach((s,t)=>{i.push(`${t} => ${s}`)}),`Map(${u.size}) {${i.join(", ")}}`}e.mapToString=C;function L(u){const i=[];return u.forEach(s=>{i.push(s)}),`Set(${u.size}) {${i.join(", ")}}`}e.setToString=L;class M{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const s=i.charCodeAt(0),t=this._value.charCodeAt(this._pos);return s-t}value(){return this._value[this._pos]}}e.StringIterator=M;class v{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,I.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=v;class c{constructor(i=!0,s=!0){this._splitOnBackslash=i,this._caseSensitive=s}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let s=i.length-1;s>=0;s--,this._valueLen--){const t=this._value.charCodeAt(s);if(!(t===47||this._splitOnBackslash&&t===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,I.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=c;var g;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(g||(g={}));class r{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new c(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,I.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,I.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,I.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,I.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=r;class n{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var m;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(m||(m={}));class y{constructor(i){this._iter=i}static forUris(i=()=>!1){return new y(new r(i))}static forPaths(i=!1){return new y(new c(void 0,!i))}static forStrings(){return new y(new M)}static forConfigKeys(){return new y(new v)}clear(){this._root=void 0}fill(i,s){if(s){const t=s.slice(0);(0,o.shuffle)(t);for(let a of t)this.set(a,i)}else{const t=i.slice(0);(0,o.shuffle)(t);for(let a of t)this.set(a[0],a[1])}}set(i,s){const t=this._iter.reset(i);let a;this._root||(this._root=new n,this._root.segment=t.value());const p=[];for(a=this._root;;){const _=t.cmp(a.segment);if(_>0)a.left||(a.left=new n,a.left.segment=t.value()),p.push([-1,a]),a=a.left;else if(_<0)a.right||(a.right=new n,a.right.segment=t.value()),p.push([1,a]),a=a.right;else if(t.hasNext())t.next(),a.mid||(a.mid=new n,a.mid.segment=t.value()),p.push([0,a]),a=a.mid;else break}const h=a.value;a.value=s,a.key=i;for(let _=p.length-1;_>=0;_--){const T=p[_][1];T.updateHeight();const R=T.balanceFactor();if(R<-1||R>1){const W=p[_][0],E=p[_+1][0];if(W===1&&E===1)p[_][1]=T.rotateLeft();else if(W===-1&&E===-1)p[_][1]=T.rotateRight();else if(W===1&&E===-1)T.right=p[_+1][1]=p[_+1][1].rotateRight(),p[_][1]=T.rotateLeft();else if(W===-1&&E===1)T.left=p[_+1][1]=p[_+1][1].rotateLeft(),p[_][1]=T.rotateRight();else throw new Error;if(_>0)switch(p[_-1][0]){case-1:p[_-1][1].left=p[_][1];break;case 1:p[_-1][1].right=p[_][1];break;case 0:p[_-1][1].mid=p[_][1];break}else this._root=p[0][1]}}return h}get(i){return this._getNode(i)?.value}_getNode(i){const s=this._iter.reset(i);let t=this._root;for(;t;){const a=s.cmp(t.segment);if(a>0)t=t.left;else if(a<0)t=t.right;else if(s.hasNext())s.next(),t=t.mid;else break}return t}has(i){const s=this._getNode(i);return!(s?.value===void 0&&s?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,s){const t=this._iter.reset(i),a=[];let p=this._root;for(;p;){const h=t.cmp(p.segment);if(h>0)a.push([-1,p]),p=p.left;else if(h<0)a.push([1,p]),p=p.right;else if(t.hasNext())t.next(),a.push([0,p]),p=p.mid;else break}if(!!p){if(s?(p.left=void 0,p.mid=void 0,p.right=void 0,p.height=1):(p.key=void 0,p.value=void 0),!p.mid&&!p.value)if(p.left&&p.right){const h=this._min(p.right),{key:_,value:T,segment:R}=h;this._delete(h.key,!1),p.key=_,p.value=T,p.segment=R}else{const h=p.left??p.right;if(a.length>0){const[_,T]=a[a.length-1];switch(_){case-1:T.left=h;break;case 0:T.mid=h;break;case 1:T.right=h;break}}else this._root=h}for(let h=a.length-1;h>=0;h--){const _=a[h][1];_.updateHeight();const T=_.balanceFactor();if(T>1?(_.right.balanceFactor()>=0||(_.right=_.right.rotateRight()),a[h][1]=_.rotateLeft()):T<-1&&(_.left.balanceFactor()<=0||(_.left=_.left.rotateLeft()),a[h][1]=_.rotateRight()),h>0)switch(a[h-1][0]){case-1:a[h-1][1].left=a[h][1];break;case 1:a[h-1][1].right=a[h][1];break;case 0:a[h-1][1].mid=a[h][1];break}else this._root=a[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const s=this._iter.reset(i);let t=this._root,a;for(;t;){const p=s.cmp(t.segment);if(p>0)t=t.left;else if(p<0)t=t.right;else if(s.hasNext())s.next(),a=t.value||a,t=t.mid;else break}return t&&t.value||a}findSuperstr(i){const s=this._iter.reset(i);let t=this._root;for(;t;){const a=s.cmp(t.segment);if(a>0)t=t.left;else if(a<0)t=t.right;else if(s.hasNext())s.next(),t=t.mid;else return t.mid?this._entries(t.mid):void 0}}forEach(i){for(const[s,t]of this)i(t,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=s=>{if(!s)return!0;const t=s.balanceFactor();return t<-1||t>1?!1:i(s.left)&&i(s.right)};return i(this._root)}}e.TernarySearchTree=y;class k{constructor(i,s){this.uri=i,this.value=s}}class d{constructor(i,s){this[w]="ResourceMap",i instanceof d?(this.map=new Map(i.map),this.toKey=s??d.defaultToKey):(this.map=new Map,this.toKey=i??d.defaultToKey)}set(i,s){return this.map.set(this.toKey(i),new k(i,s)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,s){typeof s!="undefined"&&(i=i.bind(s));for(let[t,a]of this.map)i(a.value,a.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=d,d.defaultToKey=u=>u.toString();var f;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(f=e.Touch||(e.Touch={}));class b{constructor(){this[B]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,s=0){const t=this._map.get(i);if(!!t)return s!==0&&this.touch(t,s),t.value}set(i,s,t=0){let a=this._map.get(i);if(a)a.value=s,t!==0&&this.touch(a,t);else{switch(a={key:i,value:s,next:void 0,previous:void 0},t){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(i,a),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this._map.get(i);if(!!s)return this._map.delete(i),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,s){const t=this._state;let a=this._head;for(;a;){if(s?i.bind(s)(a.value,a.key,this):i(a.value,a.key,this),this._state!==t)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const i=this,s=this._state;let t=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const p={value:t.key,done:!1};return t=t.next,p}else return{value:void 0,done:!0}}};return a}values(){const i=this,s=this._state;let t=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const p={value:t.value,done:!1};return t=t.next,p}else return{value:void 0,done:!0}}};return a}entries(){const i=this,s=this._state;let t=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const p={value:[t.key,t.value],done:!1};return t=t.next,p}else return{value:void 0,done:!0}}};return a}[(B=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this._head,t=this.size;for(;s&&t>i;)this._map.delete(s.key),s=s.next,t--;this._head=s,this._size=t,s&&(s.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const s=i.next,t=i.previous;if(!s||!t)throw new Error("Invalid list");s.previous=t,t.next=s}i.next=void 0,i.previous=void 0,this._state++}touch(i,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this._head)return;const t=i.next,a=i.previous;i===this._tail?(a.next=void 0,this._tail=a):(t.previous=a,a.next=t),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(s===2){if(i===this._tail)return;const t=i.next,a=i.previous;i===this._head?(t.previous=void 0,this._head=t):(t.previous=a,a.next=t),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((s,t)=>{i.push([t,s])}),i}fromJSON(i){this.clear();for(const[s,t]of i)this.set(s,t)}}e.LinkedMap=b;class l extends b{constructor(i,s=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l;class P{constructor(i){S.set(this,void 0),je(this,S,i,"f")}get size(){return De(this,S,"f").size}forEach(i,s){De(this,S,"f").forEach(i,s)}get(i){return De(this,S,"f").get(i)}has(i){return De(this,S,"f").has(i)}entries(){return De(this,S,"f").entries()}keys(){return De(this,S,"f").keys()}values(){return De(this,S,"f").values()}[(S=new WeakMap,Symbol.iterator)](){return De(this,S,"f").entries()}}e.ReadonlyMapView=P}),define(Ee[104],be([1,0,22,10]),function(Y,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function w(...D){return function(O,x){for(let X=0,re=D.length;X<re;X++){const ve=D[X](O,x);if(ve)return ve}return null}}e.or=w,e.matchesStrictPrefix=B.bind(void 0,!1),e.matchesPrefix=B.bind(void 0,!0);function B(D,O,x){if(!x||x.length<O.length)return null;let X;return D?X=I.startsWithIgnoreCase(x,O):X=x.indexOf(O)===0,X?O.length>0?[{start:0,end:O.length}]:[]:null}function S(D,O){const x=O.toLowerCase().indexOf(D.toLowerCase());return x===-1?null:[{start:x,end:x+D.length}]}e.matchesContiguousSubString=S;function A(D,O){return C(D.toLowerCase(),O.toLowerCase(),0,0)}e.matchesSubString=A;function C(D,O,x,X){if(x===D.length)return[];if(X===O.length)return null;if(D[x]===O[X]){let re=null;return(re=C(D,O,x+1,X+1))?y({start:X,end:X+1},re):null}return C(D,O,x,X+1)}function L(D){return 97<=D&&D<=122}function M(D){return 65<=D&&D<=90}e.isUpper=M;function v(D){return 48<=D&&D<=57}function c(D){return D===32||D===9||D===10||D===13}const g=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(D=>g.add(D.charCodeAt(0)));function r(D){return c(D)||g.has(D)}function n(D,O){return D===O||r(D)&&r(O)}function m(D){return L(D)||M(D)||v(D)}function y(D,O){return O.length===0?O=[D]:D.end===O[0].start?O[0].start=D.start:O.unshift(D),O}function k(D,O){for(let x=O;x<D.length;x++){const X=D.charCodeAt(x);if(M(X)||v(X)||x>0&&!m(D.charCodeAt(x-1)))return x}return D.length}function d(D,O,x,X){if(x===D.length)return[];if(X===O.length)return null;if(D[x]!==O[X].toLowerCase())return null;{let re=null,ve=X+1;for(re=d(D,O,x+1,X+1);!re&&(ve=k(O,ve))<O.length;)re=d(D,O,x+1,ve),ve++;return re===null?null:y({start:X,end:X+1},re)}}function f(D){let O=0,x=0,X=0,re=0,ve=0;for(let xe=0;xe<D.length;xe++)ve=D.charCodeAt(xe),M(ve)&&O++,L(ve)&&x++,m(ve)&&X++,v(ve)&&re++;const Ie=O/D.length,Me=x/D.length,Le=X/D.length,ze=re/D.length;return{upperPercent:Ie,lowerPercent:Me,alphaPercent:Le,numericPercent:ze}}function b(D){const{upperPercent:O,lowerPercent:x}=D;return x===0&&O>.6}function l(D){const{upperPercent:O,lowerPercent:x,alphaPercent:X,numericPercent:re}=D;return x>.2&&O<.8&&X>.6&&re<.2}function P(D){let O=0,x=0,X=0,re=0;for(let ve=0;ve<D.length;ve++)X=D.charCodeAt(ve),M(X)&&O++,L(X)&&x++,c(X)&&re++;return(O===0||x===0)&&re===0?D.length<=30:O<=5}function u(D,O){if(!O||(O=O.trim(),O.length===0)||!P(D)||O.length>60)return null;const x=f(O);if(!l(x)){if(!b(x))return null;O=O.toLowerCase()}let X=null,re=0;for(D=D.toLowerCase();re<O.length&&(X=d(D,O,0,re))===null;)re=k(O,re+1);return X}e.matchesCamelCase=u;function i(D,O,x=!1){if(!O||O.length===0)return null;let X=null,re=0;for(D=D.toLowerCase(),O=O.toLowerCase();re<O.length&&(X=s(D,O,0,re,x))===null;)re=t(O,re+1);return X}e.matchesWords=i;function s(D,O,x,X,re){if(x===D.length)return[];if(X===O.length)return null;if(n(D.charCodeAt(x),O.charCodeAt(X))){let ve=null,Ie=X+1;if(ve=s(D,O,x+1,X+1,re),!re)for(;!ve&&(Ie=t(O,Ie))<O.length;)ve=s(D,O,x+1,Ie,re),Ie++;return ve===null?null:y({start:X,end:X+1},ve)}else return null}function t(D,O){for(let x=O;x<D.length;x++)if(r(D.charCodeAt(x))||x>0&&r(D.charCodeAt(x-1)))return x;return D.length}const a=w(e.matchesPrefix,u,S),p=w(e.matchesPrefix,u,A),h=new o.LRUCache(1e4);function _(D,O,x=!1){if(typeof D!="string"||typeof O!="string")return null;let X=h.get(D);X||(X=new RegExp(I.convertSimple2RegExpPattern(D),"i"),h.set(D,X));const re=X.exec(O);return re?[{start:re.index,end:re.index+re[0].length}]:x?p(D,O):a(D,O)}e.matchesFuzzy=_;function T(D,O){const x=Ae(D,D.toLowerCase(),0,O,O.toLowerCase(),0,!0);return x?W(x):null}e.matchesFuzzy2=T;function R(D,O,x,X,re,ve){const Ie=Math.min(13,D.length);for(;x<Ie;x++){const Me=Ae(D,O,x,X,re,ve,!1);if(Me)return Me}return[0,ve]}e.anyScore=R;function W(D){if(typeof D=="undefined")return[];const O=[],x=D[1];for(let X=D.length-1;X>1;X--){const re=D[X]+x,ve=O[O.length-1];ve&&ve.end===re?ve.end=re+1:O.push({start:re,end:re+1})}return O}e.createMatches=W;const E=128;function H(){const D=[],O=[];for(let x=0;x<=E;x++)O[x]=0;for(let x=0;x<=E;x++)D.push(O.slice(0));return D}function q(D){const O=[];for(let x=0;x<=D;x++)O[x]=0;return O}const $=q(2*E),j=q(2*E),J=H(),z=H(),ie=H(),ae=!1;function te(D,O,x,X,re){function ve(Me,Le,ze=" "){for(;Me.length<Le;)Me=ze+Me;return Me}let Ie=` |   |${X.split("").map(Me=>ve(Me,3)).join("|")}
`;for(let Me=0;Me<=x;Me++)Me===0?Ie+=" |":Ie+=`${O[Me-1]}|`,Ie+=D[Me].slice(0,re+1).map(Le=>ve(Le.toString(),3)).join("|")+`
`;return Ie}function ce(D,O,x,X){D=D.substr(O),x=x.substr(X),console.log(te(z,D,D.length,x,x.length)),console.log(te(ie,D,D.length,x,x.length)),console.log(te(J,D,D.length,x,x.length))}function de(D,O){if(O<0||O>=D.length)return!1;const x=D.codePointAt(O);switch(x){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!I.isEmojiImprecise(x)}}function Se(D,O){if(O<0||O>=D.length)return!1;switch(D.charCodeAt(O)){case 32:case 9:return!0;default:return!1}}function fe(D,O,x){return O[D]!==x[D]}function ne(D,O,x,X,re,ve,Ie=!1){for(;O<x&&re<ve;)D[O]===X[re]&&(Ie&&($[O]=re),O+=1),re+=1;return O===x}e.isPatternInWord=ne;var me;(function(D){D[D.Diag=1]="Diag",D[D.Left=2]="Left",D[D.LeftLeft=3]="LeftLeft"})(me||(me={}));var ke;(function(D){D.Default=[-100,0];function O(x){return!x||x.length===2&&x[0]===-100&&x[1]===0}D.isDefault=O})(ke=e.FuzzyScore||(e.FuzzyScore={}));function Ae(D,O,x,X,re,ve,Ie){const Me=D.length>E?E:D.length,Le=X.length>E?E:X.length;if(x>=Me||ve>=Le||Me-x>Le-ve||!ne(O,x,Me,re,ve,Le,!0))return;Be(Me,Le,x,ve,O,re);let ze=1,xe=1,Re=x,Qe=ve;const tt=[!1];for(ze=1,Re=x;Re<Me;ze++,Re++){const le=$[Re],Oe=j[Re],He=Re+1<Me?j[Re+1]:Le;for(xe=le-ve+1,Qe=le;Qe<He;xe++,Qe++){let Ge=Number.MIN_SAFE_INTEGER,Je=!1;Qe<=Oe&&(Ge=Xe(D,O,Re,x,X,re,Qe,Le,ve,J[ze-1][xe-1]===0,tt));let ft=0;Ge!==Number.MAX_SAFE_INTEGER&&(Je=!0,ft=Ge+z[ze-1][xe-1]);const It=Qe>le,St=It?z[ze][xe-1]+(J[ze][xe-1]>0?-5:0):0,kt=Qe>le+1&&J[ze][xe-1]>0,qe=kt?z[ze][xe-2]+(J[ze][xe-2]>0?-5:0):0;if(kt&&(!It||qe>=St)&&(!Je||qe>=ft))z[ze][xe]=qe,ie[ze][xe]=3,J[ze][xe]=0;else if(It&&(!Je||St>=ft))z[ze][xe]=St,ie[ze][xe]=2,J[ze][xe]=0;else if(Je)z[ze][xe]=ft,ie[ze][xe]=1,J[ze][xe]=J[ze-1][xe-1]+1;else throw new Error("not possible")}}if(ae&&ce(D,x,X,ve),!tt[0]&&!Ie)return;ze--,xe--;const Te=[z[ze][xe],ve];let it=0,G=0;for(;ze>=1;){let le=xe;do{const Oe=ie[ze][le];if(Oe===3)le=le-2;else if(Oe===2)le=le-1;else break}while(le>=1);it>1&&O[x+ze-1]===re[ve+xe-1]&&!fe(le+ve-1,X,re)&&it+1>J[ze][le]&&(le=xe),le===xe?it++:it=1,G||(G=le),ze--,xe=le-1,Te.push(xe)}Le===Me&&(Te[0]+=2);const Q=G-Me;return Te[0]-=Q,Te}e.fuzzyScore=Ae;function Be(D,O,x,X,re,ve){let Ie=D-1,Me=O-1;for(;Ie>=x&&Me>=X;)re[Ie]===ve[Me]&&(j[Ie]=Me,Ie--),Me--}function Xe(D,O,x,X,re,ve,Ie,Me,Le,ze,xe){if(O[x]!==ve[Ie])return Number.MIN_SAFE_INTEGER;let Re=1,Qe=!1;return Ie===x-X?Re=D[x]===re[Ie]?7:5:fe(Ie,re,ve)&&(Ie===0||!fe(Ie-1,re,ve))?(Re=D[x]===re[Ie]?7:5,Qe=!0):de(ve,Ie)&&(Ie===0||!de(ve,Ie-1))?Re=5:(de(ve,Ie-1)||Se(ve,Ie-1))&&(Re=5,Qe=!0),Re>1&&x===X&&(xe[0]=!0),Qe||(Qe=fe(Ie,re,ve)||de(ve,Ie-1)||Se(ve,Ie-1)),x===X?Ie>Le&&(Re-=Qe?3:5):ze?Re+=Qe?2:0:Re+=Qe?0:1,Ie+1===Me&&(Re-=Qe?3:5),Re}function ge(D,O,x,X,re,ve,Ie){return N(D,O,x,X,re,ve,!0,Ie)}e.fuzzyScoreGracefulAggressive=ge;function ue(D,O,x,X,re,ve,Ie){return N(D,O,x,X,re,ve,!1,Ie)}e.fuzzyScoreGraceful=ue;function N(D,O,x,X,re,ve,Ie,Me){let Le=Ae(D,O,x,X,re,ve,Me);if(Le&&!Ie)return Le;if(D.length>=3){const ze=Math.min(7,D.length-1);for(let xe=x+1;xe<ze;xe++){const Re=F(D,xe);if(Re){const Qe=Ae(Re,Re.toLowerCase(),x,X,re,ve,Me);Qe&&(Qe[0]-=3,(!Le||Qe[0]>Le[0])&&(Le=Qe))}}}return Le}function F(D,O){if(O+1>=D.length)return;const x=D[O],X=D[O+1];if(x!==X)return D.slice(0,O)+X+x+D.slice(O+2)}}),define(Ee[105],be([1,0,106,104,10]),function(Y,e,o,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const B=new RegExp(`\\$\\(${o.CSSIcon.iconNameExpression}(?:${o.CSSIcon.iconModifierExpression})?\\)`,"g"),S=new RegExp(o.CSSIcon.iconNameCharacter),A=new RegExp(`(\\\\)?${B.source}`,"g");function C(m){return m.replace(A,(y,k)=>k?y:`\\${y}`)}e.escapeIcons=C;const L=new RegExp(`\\\\${B.source}`,"g");function M(m){return m.replace(L,y=>`\\${y}`)}e.markdownEscapeEscapedIcons=M;const v=new RegExp(`(\\s)?(\\\\)?${B.source}(\\s)?`,"g");function c(m){return m.indexOf(e.iconStartMarker)===-1?m:m.replace(v,(y,k,d,f)=>d?y:k||f||"")}e.stripIcons=c;function g(m){const y=m.indexOf(e.iconStartMarker);return y===-1?{text:m}:r(m,y)}e.parseLabelWithIcons=g;function r(m,y){const k=[];let d="";function f(a){if(a){d+=a;for(const p of a)k.push(P)}}let b=-1,l="",P=0,u,i,s=y;const t=m.length;for(f(m.substr(0,y));s<t;)u=m[s],i=m[s+1],u===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(b=s,f(l),l=e.iconStartMarker,s++):u===")"&&b!==-1?(P+=s-b+1,b=-1,l=""):b!==-1?S.test(u)?l+=u:(f(l),b=-1,l=""):f(u),s++;return f(l),{text:d,iconOffsets:k}}function n(m,y,k=!1){const{text:d,iconOffsets:f}=y;if(!f||f.length===0)return(0,I.matchesFuzzy)(m,d,k);const b=(0,w.ltrim)(d," "),l=d.length-b.length,P=(0,I.matchesFuzzy)(m,b,k);if(P)for(const u of P){const i=f[u.start+l]+l;u.start+=i,u.end+=i}return P}e.matchesFuzzyIconAware=n}),define(Ee[34],be([1,0,10]),function(Y,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var I;(function(w){w[w.Ignore=0]="Ignore",w[w.Info=1]="Info",w[w.Warning=2]="Warning",w[w.Error=3]="Error"})(I||(I={})),function(w){const B="error",S="warning",A="warn",C="info",L="ignore";function M(c){return c?o.equalsIgnoreCase(B,c)?w.Error:o.equalsIgnoreCase(S,c)||o.equalsIgnoreCase(A,c)?w.Warning:o.equalsIgnoreCase(C,c)?w.Info:w.Ignore:w.Ignore}w.fromValue=M;function v(c){switch(c){case w.Error:return B;case w.Warning:return S;case w.Info:return C;default:return L}}w.toString=v}(I||(I={})),e.default=I}),define(Ee[35],be([1,0,17,23,10,11]),function(Y,e,o,I,w,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function S(s){return s===47||s===92}e.isPathSeparator=S;function A(s){return s.replace(/[\\/]/g,o.posix.sep)}e.toSlashes=A;function C(s){return s.indexOf("/")===-1&&(s=A(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=C;function L(s,t=o.posix.sep){if(!s)return"";const a=s.length,p=s.charCodeAt(0);if(S(p)){if(S(s.charCodeAt(1))&&!S(s.charCodeAt(2))){let _=3;const T=_;for(;_<a&&!S(s.charCodeAt(_));_++);if(T!==_&&!S(s.charCodeAt(_+1))){for(_+=1;_<a;_++)if(S(s.charCodeAt(_)))return s.slice(0,_+1).replace(/[\\/]/g,t)}}return t}else if(y(p)&&s.charCodeAt(1)===58)return S(s.charCodeAt(2))?s.slice(0,2)+t:s.slice(0,2);let h=s.indexOf("://");if(h!==-1){for(h+=3;h<a;h++)if(S(s.charCodeAt(h)))return s.slice(0,h+1)}return""}e.getRoot=L;function M(s){if(!I.isWindows||!s||s.length<5)return!1;let t=s.charCodeAt(0);if(t!==92||(t=s.charCodeAt(1),t!==92))return!1;let a=2;const p=a;for(;a<s.length&&(t=s.charCodeAt(a),t!==92);a++);return!(p===a||(t=s.charCodeAt(a+1),isNaN(t)||t===92))}e.isUNC=M;const v=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function r(s,t=I.isWindows){const a=t?v:c;return!(!s||s.length===0||/^\s+$/.test(s)||(a.lastIndex=0,a.test(s))||t&&g.test(s)||s==="."||s===".."||t&&s[s.length-1]==="."||t&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=r;function n(s,t,a){const p=s===t;return!a||p?p:!s||!t?!1:(0,w.equalsIgnoreCase)(s,t)}e.isEqual=n;function m(s,t,a,p=o.sep){if(s===t)return!0;if(!s||!t||t.length>s.length)return!1;if(a){if(!(0,w.startsWithIgnoreCase)(s,t))return!1;if(t.length===s.length)return!0;let _=t.length;return t.charAt(t.length-1)===p&&_--,s.charAt(_)===p}return t.charAt(t.length-1)!==p&&(t+=p),s.indexOf(t)===0}e.isEqualOrParent=m;function y(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=y;function k(s,t){return I.isWindows&&s.endsWith(":")&&(s+=o.sep),(0,o.isAbsolute)(s)||(s=(0,o.join)(t,s)),s=(0,o.normalize)(s),I.isWindows?(s=(0,w.rtrim)(s,o.sep),s.endsWith(":")&&(s+=o.sep)):(s=(0,w.rtrim)(s,o.sep),s||(s=o.sep)),s}e.sanitizeFilePath=k;function d(s){const t=(0,o.normalize)(s);return I.isWindows?s.length>3?!1:f(t)&&(s.length===2||t.charCodeAt(2)===92):t===o.posix.sep}e.isRootOrDriveLetter=d;function f(s,t){return(t!==void 0?t:I.isWindows)?y(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function b(s){return f(s)?s[0]:void 0}e.getDriveLetter=b;function l(s,t,a){return t.length>s.length?-1:s===t?0:(a&&(s=s.toLowerCase(),t=t.toLowerCase()),s.indexOf(t))}e.indexOfPath=l;function P(s){const t=s.split(":");let a,p,h;for(const _ of t){const T=Number(_);(0,B.isNumber)(T)?p===void 0?p=T:h===void 0&&(h=T):a=a?[a,_].join(":"):_}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:p!==void 0?p:void 0,column:h!==void 0?h:p!==void 0?1:void 0}}e.parseLineAndColumnAware=P;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(s,t,a=8){let p="";for(let _=0;_<a;_++)p+=u.charAt(Math.floor(Math.random()*u.length));let h;return t?h=`${t}-${p}`:h=p,s?(0,o.join)(s,h):h}e.randomPath=i}),define(Ee[54],be([1,0,21,10,2]),function(Y,e,o,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function B(M){return JSON.stringify(M,C)}e.stringify=B;function S(M){let v=JSON.parse(M);return v=L(v),v}e.parse=S;var A;(function(M){M[M.Uri=1]="Uri",M[M.Regexp=2]="Regexp",M[M.ScmResource=3]="ScmResource",M[M.ScmResourceGroup=4]="ScmResourceGroup",M[M.ScmProvider=5]="ScmProvider",M[M.CommentController=6]="CommentController",M[M.CommentThread=7]="CommentThread",M[M.CommentThreadReply=8]="CommentThreadReply",M[M.CommentNode=9]="CommentNode",M[M.CommentThreadNode=10]="CommentThreadNode",M[M.TimelineActionContext=11]="TimelineActionContext",M[M.NotebookCellActionContext=12]="NotebookCellActionContext",M[M.TestItemContext=13]="TestItemContext",M[M.Date=14]="Date"})(A=e.MarshalledId||(e.MarshalledId={}));function C(M,v){return v instanceof RegExp?{$mid:2,source:v.source,flags:(0,I.regExpFlags)(v)}:v}function L(M,v=0){if(!M||v>200)return M;if(typeof M=="object"){switch(M.$mid){case 1:return w.URI.revive(M);case 2:return new RegExp(M.source,M.flags);case 14:return new Date(M.source)}if(M instanceof o.VSBuffer||M instanceof Uint8Array)return M;if(Array.isArray(M))for(let c=0;c<M.length;++c)M[c]=L(M[c],v+1);else for(const c in M)Object.hasOwnProperty.call(M,c)&&(M[c]=L(M[c],v+1))}return M}e.revive=L}),define(Ee[9],be([1,0,23,2]),function(Y,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var w;(function(A){A.inMemory="inmemory",A.vscode="vscode",A.internal="private",A.walkThrough="walkThrough",A.walkThroughSnippet="walkThroughSnippet",A.http="http",A.https="https",A.file="file",A.mailto="mailto",A.untitled="untitled",A.data="data",A.command="command",A.vscodeRemote="vscode-remote",A.vscodeRemoteResource="vscode-remote-resource",A.userData="vscode-userdata",A.vscodeCustomEditor="vscode-custom-editor",A.vscodeNotebook="vscode-notebook",A.vscodeNotebookCell="vscode-notebook-cell",A.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",A.vscodeNotebookCellOutput="vscode-notebook-cell-output",A.vscodeInteractive="vscode-interactive",A.vscodeInteractiveInput="vscode-interactive-input",A.vscodeSettings="vscode-settings",A.vscodeWorkspaceTrust="vscode-workspace-trust",A.vscodeTerminal="vscode-terminal",A.webviewPanel="webview-panel",A.vscodeWebview="vscode-webview",A.extension="extension",A.vscodeFileResource="vscode-file",A.tmp="tmp",A.vsls="vsls"})(w=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class B{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}set(C,L,M){this._hosts[C]=L,this._ports[C]=M}setConnectionToken(C,L){this._connectionTokens[C]=L}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(C){if(this._delegate)return this._delegate(C);const L=C.authority;let M=this._hosts[L];M&&M.indexOf(":")!==-1&&(M=`[${M}]`);const v=this._ports[L],c=this._connectionTokens[L];let g=`path=${encodeURIComponent(C.path)}`;return typeof c=="string"&&(g+=`&${e.connectionTokenQueryName}=${encodeURIComponent(c)}`),I.URI.from({scheme:o.isWeb?this._preferredWebSchema:w.vscodeRemoteResource,authority:`${M}:${v}`,path:"/vscode-remote-resource",query:g})}}e.RemoteAuthorities=new B;class S{asBrowserUri(C,L){const M=this.toUri(C,L);return M.scheme===w.vscodeRemote?e.RemoteAuthorities.rewrite(M):M.scheme===w.file&&(o.isNative||typeof o.globals.importScripts=="function"&&o.globals.origin===`${w.vscodeFileResource}://${S.FALLBACK_AUTHORITY}`)?M.with({scheme:w.vscodeFileResource,authority:M.authority||S.FALLBACK_AUTHORITY,query:null,fragment:null}):M}asFileUri(C,L){const M=this.toUri(C,L);return M.scheme===w.vscodeFileResource?M.with({scheme:w.file,authority:M.authority!==S.FALLBACK_AUTHORITY?M.authority:null,query:null,fragment:null}):M}toUri(C,L){return I.URI.isUri(C)?C:I.URI.parse(L.toUrl(C))}}S.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new S}),define(Ee[24],be([1,0,35,9,17,23,10,2]),function(Y,e,o,I,w,B,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(g){return(0,A.uriToFsPath)(g,!0)}e.originalFSPath=C;class L{constructor(r){this._ignorePathCasing=r}compare(r,n,m=!1){return r===n?0:(0,S.compare)(this.getComparisonKey(r,m),this.getComparisonKey(n,m))}isEqual(r,n,m=!1){return r===n?!0:!r||!n?!1:this.getComparisonKey(r,m)===this.getComparisonKey(n,m)}getComparisonKey(r,n=!1){return r.with({path:this._ignorePathCasing(r)?r.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(r){return this._ignorePathCasing(r)}isEqualOrParent(r,n,m=!1){if(r.scheme===n.scheme){if(r.scheme===I.Schemas.file)return o.isEqualOrParent(C(r),C(n),this._ignorePathCasing(r))&&r.query===n.query&&(m||r.fragment===n.fragment);if((0,e.isEqualAuthority)(r.authority,n.authority))return o.isEqualOrParent(r.path,n.path,this._ignorePathCasing(r),"/")&&r.query===n.query&&(m||r.fragment===n.fragment)}return!1}joinPath(r,...n){return A.URI.joinPath(r,...n)}basenameOrAuthority(r){return(0,e.basename)(r)||r.authority}basename(r){return w.posix.basename(r.path)}extname(r){return w.posix.extname(r.path)}dirname(r){if(r.path.length===0)return r;let n;return r.scheme===I.Schemas.file?n=A.URI.file(w.dirname(C(r))).path:(n=w.posix.dirname(r.path),r.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${r.toString})) resulted in a relative path`),n="/")),r.with({path:n})}normalizePath(r){if(!r.path.length)return r;let n;return r.scheme===I.Schemas.file?n=A.URI.file(w.normalize(C(r))).path:n=w.posix.normalize(r.path),r.with({path:n})}relativePath(r,n){if(r.scheme!==n.scheme||!(0,e.isEqualAuthority)(r.authority,n.authority))return;if(r.scheme===I.Schemas.file){const k=w.relative(C(r),C(n));return B.isWindows?o.toSlashes(k):k}let m=r.path||"/",y=n.path||"/";if(this._ignorePathCasing(r)){let k=0;for(const d=Math.min(m.length,y.length);k<d&&!(m.charCodeAt(k)!==y.charCodeAt(k)&&m.charAt(k).toLowerCase()!==y.charAt(k).toLowerCase());k++);m=y.substr(0,k)+m.substr(k)}return w.posix.relative(m,y)}resolvePath(r,n){if(r.scheme===I.Schemas.file){const m=A.URI.file(w.resolve(C(r),n));return r.with({authority:m.authority,path:m.path})}return n=o.toPosixPath(n),r.with({path:w.posix.resolve(r.path,n)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,n){return r===n||r!==void 0&&n!==void 0&&(0,S.equalsIgnoreCase)(r,n)}hasTrailingPathSeparator(r,n=w.sep){if(r.scheme===I.Schemas.file){const m=C(r);return m.length>o.getRoot(m).length&&m[m.length-1]===n}else{const m=r.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,n=w.sep){return(0,e.hasTrailingPathSeparator)(r,n)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,n=w.sep){let m=!1;if(r.scheme===I.Schemas.file){const y=C(r);m=y!==void 0&&y.length===o.getRoot(y).length&&y[y.length-1]===n}else{n="/";const y=r.path;m=y.length===1&&y.charCodeAt(y.length-1)===47}return!m&&!(0,e.hasTrailingPathSeparator)(r,n)?r.with({path:r.path+"/"}):r}}e.ExtUri=L,e.extUri=new L(()=>!1),e.extUriBiasedIgnorePathCase=new L(g=>g.scheme===I.Schemas.file?!B.isLinux:!0),e.extUriIgnorePathCase=new L(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function M(g,r){const n=[];for(let m=0;m<g.length;m++){const y=r(g[m]);g.some((k,d)=>d===m?!1:(0,e.isEqualOrParent)(y,r(k)))||n.push(g[m])}return n}e.distinctParents=M;var v;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function r(n){const m=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(d=>{const[f,b]=d.split(":");f&&b&&m.set(f,b)});const k=n.path.substring(0,n.path.indexOf(";"));return k&&m.set(g.META_DATA_MIME,k),m}g.parseMetaData=r})(v=e.DataUri||(e.DataUri={}));function c(g,r,n){if(r){let m=g.path;return m&&m[0]!==w.posix.sep&&(m=w.posix.sep+m),g.with({scheme:n,authority:r,path:m})}return g.with({scheme:n})}e.toLocalResource=c}),define(Ee[13],be([1,0,20,15,5,6,24,23]),function(Y,e,o,I,w,B,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(fe){return!!fe&&typeof fe.then=="function"}e.isThenable=C;function L(fe){const ne=new o.CancellationTokenSource,me=fe(ne.token),ke=new Promise((Ae,Be)=>{const Xe=ne.token.onCancellationRequested(()=>{Xe.dispose(),ne.dispose(),Be(new I.CancellationError)});Promise.resolve(me).then(ge=>{Xe.dispose(),ne.dispose(),Ae(ge)},ge=>{Xe.dispose(),ne.dispose(),Be(ge)})});return new class{cancel(){ne.cancel()}then(Ae,Be){return ke.then(Ae,Be)}catch(Ae){return this.then(void 0,Ae)}finally(Ae){return ke.finally(Ae)}}}e.createCancelablePromise=L;function M(fe,ne,me){return new Promise((ke,Ae)=>{const Be=ne.onCancellationRequested(()=>{Be.dispose(),ke(me)});fe.then(ke,Ae).finally(()=>Be.dispose())})}e.raceCancellation=M;function v(fe,ne){return new Promise((me,ke)=>{const Ae=ne.onCancellationRequested(()=>{Ae.dispose(),ke(new I.CancellationError)});fe.then(me,ke).finally(()=>Ae.dispose())})}e.raceCancellationError=v;async function c(fe){let ne=-1;const me=fe.map((Ae,Be)=>Ae.then(Xe=>(ne=Be,Xe))),ke=await Promise.race(me);return fe.forEach((Ae,Be)=>{Be!==ne&&Ae.cancel()}),ke}e.raceCancellablePromises=c;function g(fe,ne,me){let ke;const Ae=setTimeout(()=>{ke?.(void 0),me?.()},ne);return Promise.race([fe.finally(()=>clearTimeout(Ae)),new Promise(Be=>ke=Be)])}e.raceTimeout=g;function r(fe){return new Promise((ne,me)=>{const ke=fe();C(ke)?ke.then(ne,me):ne(ke)})}e.asPromise=r;class n{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(ne){if(this.activePromise){if(this.queuedPromiseFactory=ne,!this.queuedPromise){const me=()=>{this.queuedPromise=null;const ke=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,ke};this.queuedPromise=new Promise(ke=>{this.activePromise.then(me,me).then(ke)})}return new Promise((me,ke)=>{this.queuedPromise.then(me,ke)})}return this.activePromise=ne(),new Promise((me,ke)=>{this.activePromise.then(Ae=>{this.activePromise=null,me(Ae)},Ae=>{this.activePromise=null,ke(Ae)})})}}e.Throttler=n;class m{constructor(){this.current=Promise.resolve(null)}queue(ne){return this.current=this.current.then(()=>ne(),()=>ne())}}e.Sequencer=m;class y{constructor(){this.promiseMap=new Map}queue(ne,me){const Ae=(this.promiseMap.get(ne)??Promise.resolve()).catch(()=>{}).then(me).finally(()=>{this.promiseMap.get(ne)===Ae&&this.promiseMap.delete(ne)});return this.promiseMap.set(ne,Ae),Ae}}e.SequencerByKey=y;const k=(fe,ne)=>{let me=!0;const ke=setTimeout(()=>{me=!1,ne()},fe);return{isTriggered:()=>me,dispose:()=>{clearTimeout(ke),me=!1}}},d=fe=>{let ne=!0;return queueMicrotask(()=>{ne&&(ne=!1,fe())}),{isTriggered:()=>ne,dispose:()=>{ne=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class f{constructor(ne){this.defaultDelay=ne,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(ne,me=this.defaultDelay){this.task=ne,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Ae,Be)=>{this.doResolve=Ae,this.doReject=Be}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Ae=this.task;return this.task=null,Ae()}}));const ke=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=me===e.MicrotaskDelay?d(ke):k(me,ke),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new I.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=f;class b{constructor(ne){this.delayer=new f(ne),this.throttler=new n}trigger(ne,me){return this.delayer.trigger(()=>this.throttler.queue(ne),me)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class l{constructor(){this._isOpen=!1,this._promise=new Promise((ne,me)=>{this._completePromise=ne})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=l;class P extends l{constructor(ne){super();this._timeout=setTimeout(()=>this.open(),ne)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=P;function u(fe,ne){return ne?new Promise((me,ke)=>{const Ae=setTimeout(()=>{Be.dispose(),me()},fe),Be=ne.onCancellationRequested(()=>{clearTimeout(Ae),Be.dispose(),ke(new I.CancellationError)})}):L(me=>u(fe,me))}e.timeout=u;function i(fe,ne=0){const me=setTimeout(fe,ne);return(0,B.toDisposable)(()=>clearTimeout(me))}e.disposableTimeout=i;function s(fe){const ne=[];let me=0;const ke=fe.length;function Ae(){return me<ke?fe[me++]():null}function Be(Xe){Xe!=null&&ne.push(Xe);const ge=Ae();return ge?ge.then(Be):Promise.resolve(ne)}return Promise.resolve(null).then(Be)}e.sequence=s;function t(fe,ne=ke=>!!ke,me=null){let ke=0;const Ae=fe.length,Be=()=>{if(ke>=Ae)return Promise.resolve(me);const Xe=fe[ke++];return Promise.resolve(Xe()).then(ue=>ne(ue)?Promise.resolve(ue):Be())};return Be()}e.first=t;function a(fe,ne=ke=>!!ke,me=null){if(fe.length===0)return Promise.resolve(me);let ke=fe.length;const Ae=()=>{ke=-1;for(const Be of fe)Be.cancel?.()};return new Promise((Be,Xe)=>{for(const ge of fe)ge.then(ue=>{--ke>=0&&ne(ue)?(Ae(),Be(ue)):ke===0&&Be(me)}).catch(ue=>{--ke>=0&&(Ae(),Xe(ue))})})}e.firstParallel=a;class p{constructor(ne){this._size=0,this.maxDegreeOfParalellism=ne,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new w.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(ne){return this._size++,new Promise((me,ke)=>{this.outstandingPromises.push({factory:ne,c:me,e:ke}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const ne=this.outstandingPromises.shift();this.runningPromises++;const me=ne.factory();me.then(ne.c,ne.e),me.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=p;class h extends p{constructor(){super(1)}}e.Queue=h;class _{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const ne=new ie;return this.drainers.add(ne),ne.p}isDrained(){for(const[,ne]of this.queues)if(ne.size>0)return!1;return!0}queueFor(ne,me=S.extUri){const ke=me.getComparisonKey(ne);let Ae=this.queues.get(ke);return Ae||(Ae=new h,w.Event.once(Ae.onFinished)(()=>{Ae?.dispose(),this.queues.delete(ke),this.onDidQueueFinish()}),this.queues.set(ke,Ae)),Ae}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const ne of this.drainers)ne.complete();this.drainers.clear()}dispose(){for(const[,ne]of this.queues)ne.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=_;class T{constructor(ne,me){this._token=-1,typeof ne=="function"&&typeof me=="number"&&this.setIfNotSet(ne,me)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(ne,me){this.cancel(),this._token=setTimeout(()=>{this._token=-1,ne()},me)}setIfNotSet(ne,me){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,ne()},me))}}e.TimeoutTimer=T;class R{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(ne,me){this.cancel(),this._token=setInterval(()=>{ne()},me)}}e.IntervalTimer=R;class W{constructor(ne,me){this.timeoutToken=-1,this.runner=ne,this.timeout=me,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(ne=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,ne)}get delay(){return this.timeout}set delay(ne){this.timeout=ne}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=W;class E{constructor(ne,me){me%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${me}ms is not a multiple of 1000ms.`),this.runner=ne,this.timeout=me,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(ne=this.timeout){ne%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(ne/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=E;class H extends W{constructor(ne,me){super(ne,me);this.units=[]}work(ne){this.units.push(ne),this.isScheduled()||this.schedule()}doRun(){const ne=this.units;this.units=[],this.runner&&this.runner(ne)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=H;class q extends B.Disposable{constructor(ne,me){super();this.options=ne,this.handler=me,this.pendingWork=[],this.throttler=this._register(new B.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(ne){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+ne.length>this.options.maxBufferedWork)return!1}else if(this.pending+ne.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...ne),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new W(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=q,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=fe=>{(0,A.setTimeout0)(()=>{if(ne)return;const me=Date.now()+15;fe(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let ne=!1;return{dispose(){ne||(ne=!0)}}}:e.runWhenIdle=(fe,ne)=>{const me=requestIdleCallback(fe,typeof ne=="number"?{timeout:ne}:void 0);let ke=!1;return{dispose(){ke||(ke=!0,cancelIdleCallback(me))}}}}();class ${constructor(ne){this._didRun=!1,this._executor=()=>{try{this._value=ne()}catch(me){this._error=me}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=$;async function j(fe,ne,me){let ke;for(let Ae=0;Ae<me;Ae++)try{return await fe()}catch(Be){ke=Be,await u(ne)}throw ke}e.retry=j;class J{hasPending(ne){return this._pending?typeof ne=="number"?this._pending.taskId===ne:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(ne,me,ke){return this._pending={taskId:ne,cancel:()=>ke?.(),promise:me},me.then(()=>this.donePending(ne),()=>this.donePending(ne)),me}donePending(ne){this._pending&&ne===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const ne=this._next;this._next=void 0,ne.run().then(ne.promiseResolve,ne.promiseReject)}}setNext(ne){if(this._next)this._next.run=ne;else{let me,ke;const Ae=new Promise((Be,Xe)=>{me=Be,ke=Xe});this._next={run:ne,promise:Ae,promiseResolve:me,promiseReject:ke}}return this._next.promise}}e.TaskSequentializer=J;class z{constructor(ne,me=()=>Date.now()){this.interval=ne,this.nowFn=me,this.lastIncrementTime=0,this.value=0}increment(){const ne=this.nowFn();return ne-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=ne,this.value=0),this.value++,this.value}}e.IntervalCounter=z;class ie{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((ne,me)=>{this.completeCallback=ne,this.errorCallback=me})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(ne){return new Promise(me=>{this.completeCallback(ne),this.resolved=!0,me()})}error(ne){return new Promise(me=>{this.errorCallback(ne),this.rejected=!0,me()})}cancel(){new Promise(ne=>{this.errorCallback(new I.CancellationError),this.rejected=!0,ne()})}}e.DeferredPromise=ie;var ae;(function(fe){async function ne(ke){let Ae;const Be=await Promise.all(ke.map(Xe=>Xe.then(ge=>ge,ge=>{Ae||(Ae=ge)})));if(typeof Ae!="undefined")throw Ae;return Be}fe.settled=ne;function me(ke){return new Promise(async(Ae,Be)=>{try{await ke(Ae,Be)}catch(Xe){Be(Xe)}})}fe.withAsyncBody=me})(ae=e.Promises||(e.Promises={}));var te;(function(fe){fe[fe.Initial=0]="Initial",fe[fe.DoneOK=1]="DoneOK",fe[fe.DoneError=2]="DoneError"})(te||(te={}));class ce{constructor(ne){this._state=0,this._results=[],this._error=null,this._onStateChanged=new w.Emitter,queueMicrotask(async()=>{const me={emitOne:ke=>this.emitOne(ke),emitMany:ke=>this.emitMany(ke),reject:ke=>this.reject(ke)};try{await Promise.resolve(ne(me)),this.resolve()}catch(ke){this.reject(ke)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}static fromArray(ne){return new ce(me=>{me.emitMany(ne)})}static fromPromise(ne){return new ce(async me=>{me.emitMany(await ne)})}static fromPromises(ne){return new ce(async me=>{await Promise.all(ne.map(async ke=>me.emitOne(await ke)))})}static merge(ne){return new ce(async me=>{await Promise.all(ne.map(async ke=>{for await(const Ae of ke)me.emitOne(Ae)}))})}[Symbol.asyncIterator](){let ne=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(ne<this._results.length)return{done:!1,value:this._results[ne++]};if(this._state===1)return{done:!0,value:void 0};await w.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(ne,me){return new ce(async ke=>{for await(const Ae of ne)ke.emitOne(me(Ae))})}map(ne){return ce.map(this,ne)}static filter(ne,me){return new ce(async ke=>{for await(const Ae of ne)me(Ae)&&ke.emitOne(Ae)})}filter(ne){return ce.filter(this,ne)}static coalesce(ne){return ce.filter(ne,me=>!!me)}coalesce(){return ce.coalesce(this)}static async toPromise(ne){const me=[];for await(const ke of ne)me.push(ke);return me}toPromise(){return ce.toPromise(this)}emitOne(ne){this._state===0&&(this._results.push(ne),this._onStateChanged.fire())}emitMany(ne){this._state===0&&(this._results=this._results.concat(ne),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(ne){this._state===0&&(this._state=2,this._error=ne,this._onStateChanged.fire())}}e.AsyncIterableObject=ce,ce.EMPTY=ce.fromArray([]);class de extends ce{constructor(ne,me){super(me);this._source=ne}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=de;function Se(fe){const ne=new o.CancellationTokenSource,me=fe(ne.token);return new de(ne,async ke=>{const Ae=ne.token.onCancellationRequested(()=>{Ae.dispose(),ne.dispose(),ke.reject(new I.CancellationError)});try{for await(const Be of me){if(ne.token.isCancellationRequested)return;ke.emitOne(Be)}Ae.dispose(),ne.dispose()}catch(Be){Ae.dispose(),ne.dispose(),ke.reject(Be)}})}e.createCancelableAsyncIterable=Se}),define(Ee[107],be([1,0,13,17]),function(Y,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const w=new o.IdleValue(()=>{const h=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:h,collatorIsNumeric:h.resolvedOptions().numeric}}),B=new o.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),S=new o.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(h,_,T=!1){const R=h||"",W=_||"",E=w.value.collator.compare(R,W);return w.value.collatorIsNumeric&&E===0&&R!==W?R<W?-1:1:E}e.compareFileNames=A;function C(h,_){const T=B.value.collator;return h=h||"",_=_||"",b(T,h,_)}e.compareFileNamesDefault=C;function L(h,_){const T=B.value.collator;return h=h||"",_=_||"",i(h,_)||b(T,h,_)}e.compareFileNamesUpper=L;function M(h,_){const T=B.value.collator;return h=h||"",_=_||"",u(h,_)||b(T,h,_)}e.compareFileNamesLower=M;function v(h,_){return h=h||"",_=_||"",h===_?0:h<_?-1:1}e.compareFileNamesUnicode=v;function c(h,_,T=!1){T||(h=h&&h.toLowerCase(),_=_&&_.toLowerCase());const[R,W]=d(h),[E,H]=d(_);return R!==E?R<E?-1:1:W===H?0:W<H?-1:1}e.noIntlCompareFileNames=c;function g(h,_){const[T,R]=d(h),[W,E]=d(_);let H=w.value.collator.compare(R,E);if(H===0){if(w.value.collatorIsNumeric&&R!==E)return R<E?-1:1;if(H=w.value.collator.compare(T,W),w.value.collatorIsNumeric&&H===0&&T!==W)return T<W?-1:1}return H}e.compareFileExtensions=g;function r(h,_){h=h||"",_=_||"";const T=f(h),R=f(_),W=B.value.collator,E=S.value.collator;return b(E,T,R)||b(W,h,_)}e.compareFileExtensionsDefault=r;function n(h,_){h=h||"",_=_||"";const T=f(h),R=f(_),W=B.value.collator,E=S.value.collator;return b(E,T,R)||i(h,_)||b(W,h,_)}e.compareFileExtensionsUpper=n;function m(h,_){h=h||"",_=_||"";const T=f(h),R=f(_),W=B.value.collator,E=S.value.collator;return b(E,T,R)||u(h,_)||b(W,h,_)}e.compareFileExtensionsLower=m;function y(h,_){h=h||"",_=_||"";const T=f(h).toLowerCase(),R=f(_).toLowerCase();return T!==R?T<R?-1:1:h!==_?h<_?-1:1:0}e.compareFileExtensionsUnicode=y;const k=/^(.*?)(\.([^.]*))?$/;function d(h,_=!1){const T=h?k.exec(h):[];let R=[T&&T[1]||"",T&&T[3]||""];return _&&(!R[0]&&R[1]||R[0]&&R[0].charAt(0)===".")&&(R=[R[0]+"."+R[1],""]),R}function f(h){const _=h?k.exec(h):[];return _&&_[1]&&_[1].charAt(0)!=="."&&_[3]||""}function b(h,_,T){let R=h.compare(_,T);return R!==0?R:_.length!==T.length?_.length<T.length?-1:1:0}function l(h){const _=h.charAt(0);return _.toLocaleUpperCase()!==_}function P(h){const _=h.charAt(0);return _.toLocaleLowerCase()!==_}function u(h,_){return l(h)&&P(_)?-1:P(h)&&l(_)?1:0}function i(h,_){return P(h)&&l(_)?-1:l(h)&&P(_)?1:0}function s(h,_,T=!1){return T||(h=h&&h.toLowerCase(),_=_&&_.toLowerCase()),h===_?0:h<_?-1:1}function t(h,_,T=!1){const R=h.split(I.sep),W=_.split(I.sep),E=R.length-1,H=W.length-1;let q,$;for(let j=0;;j++){if(q=E===j,$=H===j,q&&$)return A(R[j],W[j],T);if(q)return-1;if($)return 1;const J=s(R[j],W[j],T);if(J!==0)return J}}e.comparePaths=t;function a(h,_,T){const R=h.toLowerCase(),W=_.toLowerCase(),E=p(h,_,T);if(E)return E;const H=R.endsWith(T),q=W.endsWith(T);if(H!==q)return H?-1:1;const $=A(R,W);return $!==0?$:R.localeCompare(W)}e.compareAnything=a;function p(h,_,T){const R=h.toLowerCase(),W=_.toLowerCase(),E=R.startsWith(T),H=W.startsWith(T);if(E!==H)return E?-1:1;if(E&&H){if(R.length<W.length)return-1;if(R.length>W.length)return 1}return 0}e.compareByPrefix=p}),define(Ee[29],be([1,0,13,35,22,17,23,10]),function(Y,e,o,I,w,B,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const L="[/\\\\]",M="[^/\\\\]",v=/\//g;function c(ie){switch(ie){case 0:return"";case 1:return`${M}*?`;default:return`(?:${L}|${M}+${L}|${L}${M}+)*?`}}function g(ie,ae){if(!ie)return[];const te=[];let ce=!1,de=!1,Se="";for(const fe of ie){switch(fe){case ae:if(!ce&&!de){te.push(Se),Se="";continue}break;case"{":ce=!0;break;case"}":ce=!1;break;case"[":de=!0;break;case"]":de=!1;break}Se+=fe}return Se&&te.push(Se),te}e.splitGlobAware=g;function r(ie){if(!ie)return"";let ae="";const te=g(ie,e.GLOB_SPLIT);if(te.every(ce=>ce===e.GLOBSTAR))ae=".*";else{let ce=!1;te.forEach((de,Se)=>{if(de===e.GLOBSTAR){ce||(ae+=c(2),ce=!0);return}let fe=!1,ne="",me=!1,ke="";for(const Ae of de){if(Ae!=="}"&&fe){ne+=Ae;continue}if(me&&(Ae!=="]"||!ke)){let Be;Ae==="-"?Be=Ae:(Ae==="^"||Ae==="!")&&!ke?Be="^":Ae===e.GLOB_SPLIT?Be="":Be=(0,A.escapeRegExpCharacters)(Ae),ke+=Be;continue}switch(Ae){case"{":fe=!0;continue;case"[":me=!0;continue;case"}":{ae+=`(?:${g(ne,",").map(ge=>r(ge)).join("|")})`,fe=!1,ne="";break}case"]":ae+="["+ke+"]",me=!1,ke="";break;case"?":ae+=M;continue;case"*":ae+=c(1);continue;default:ae+=(0,A.escapeRegExpCharacters)(Ae)}}Se<te.length-1&&(te[Se+1]!==e.GLOBSTAR||Se+2<te.length)&&(ae+=L),ce=!1})}return ae}const n=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,y=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,k=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,f=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,b=new w.LRUCache(1e4),l=function(){return!1},P=function(){return null};function u(ie,ae){if(!ie)return P;let te;typeof ie!="string"?te=ie.pattern:te=ie,te=te.trim();const ce=`${te}_${!!ae.trimForExclusions}`;let de=b.get(ce);if(de)return i(de,ie);let Se;if(n.test(te)){const fe=te.substr(4);de=function(ne,me){return typeof ne=="string"&&ne.endsWith(fe)?te:null}}else(Se=m.exec(s(te,ae)))?de=t(Se[1],te):(ae.trimForExclusions?k:y).test(te)?de=a(te,ae):(Se=d.exec(s(te,ae)))?de=p(Se[1].substr(1),te,!0):(Se=f.exec(s(te,ae)))?de=p(Se[1],te,!1):de=h(te);return b.set(ce,de),i(de,ie)}function i(ie,ae){return typeof ae=="string"?ie:function(te,ce){return(0,I.isEqualOrParent)(te,ae.base,!S.isLinux)?ie(te.substr(ae.base.length+1),ce):null}}function s(ie,ae){return ae.trimForExclusions&&ie.endsWith("/**")?ie.substr(0,ie.length-2):ie}function t(ie,ae){const te=`/${ie}`,ce=`\\${ie}`,de=function(fe,ne){return typeof fe!="string"?null:ne?ne===ie?ae:null:fe===ie||fe.endsWith(te)||fe.endsWith(ce)?ae:null},Se=[ie];return de.basenames=Se,de.patterns=[ae],de.allBasenames=Se,de}function a(ie,ae){const te=z(ie.slice(1,-1).split(",").map(ne=>u(ne,ae)).filter(ne=>ne!==P),ie),ce=te.length;if(!ce)return P;if(ce===1)return te[0];const de=function(ne,me){for(let ke=0,Ae=te.length;ke<Ae;ke++)if(te[ke](ne,me))return ie;return null},Se=te.find(ne=>!!ne.allBasenames);Se&&(de.allBasenames=Se.allBasenames);const fe=te.reduce((ne,me)=>me.allPaths?ne.concat(me.allPaths):ne,[]);return fe.length&&(de.allPaths=fe),de}function p(ie,ae,te){const ce=B.sep===B.posix.sep,de=ce?ie:ie.replace(v,B.sep),Se=B.sep+de,fe=B.posix.sep+ie,ne=te?function(me,ke){return typeof me=="string"&&(me===de||me.endsWith(Se)||!ce&&(me===ie||me.endsWith(fe)))?ae:null}:function(me,ke){return typeof me=="string"&&(me===de||!ce&&me===ie)?ae:null};return ne.allPaths=[(te?"*/":"./")+ie],ne}function h(ie){try{const ae=new RegExp(`^${r(ie)}$`);return function(te){return ae.lastIndex=0,typeof te=="string"&&ae.test(te)?ie:null}}catch{return P}}function _(ie,ae,te){return!ie||typeof ae!="string"?!1:T(ie)(ae,void 0,te)}e.match=_;function T(ie,ae={}){if(!ie)return l;if(typeof ie=="string"||H(ie)){const te=u(ie,ae);if(te===P)return l;const ce=function(de,Se){return!!te(de,Se)};return te.allBasenames&&(ce.allBasenames=te.allBasenames),te.allPaths&&(ce.allPaths=te.allPaths),ce}return j(ie,ae)}e.parse=T;function R(ie){if(!ie)return;let ae;return te=>(ae||(ae=(ie()||Promise.resolve([])).then(ce=>ce?E(ce):{})),ae.then(ce=>!!ce[te]))}e.hasSiblingPromiseFn=R;function W(ie){if(!ie)return;let ae;return te=>{if(!ae){const ce=ie();ae=ce?E(ce):{}}return!!ae[te]}}e.hasSiblingFn=W;function E(ie){const ae={};for(const te of ie)ae[te]=!0;return ae}function H(ie){const ae=ie;return ae?typeof ae.base=="string"&&typeof ae.pattern=="string":!1}e.isRelativePattern=H;function q(ie){return ie.allBasenames||[]}e.getBasenameTerms=q;function $(ie){return ie.allPaths||[]}e.getPathTerms=$;function j(ie,ae){const te=z(Object.getOwnPropertyNames(ie).map(ne=>J(ne,ie[ne],ae)).filter(ne=>ne!==P)),ce=te.length;if(!ce)return P;if(!te.some(ne=>!!ne.requiresSiblings)){if(ce===1)return te[0];const ne=function(Ae,Be){for(let Xe=0,ge=te.length;Xe<ge;Xe++){const ue=te[Xe](Ae,Be);if(ue)return ue}return null},me=te.find(Ae=>!!Ae.allBasenames);me&&(ne.allBasenames=me.allBasenames);const ke=te.reduce((Ae,Be)=>Be.allPaths?Ae.concat(Be.allPaths):Ae,[]);return ke.length&&(ne.allPaths=ke),ne}const de=function(ne,me,ke){let Ae;for(let Be=0,Xe=te.length;Be<Xe;Be++){const ge=te[Be];ge.requiresSiblings&&ke&&(me||(me=(0,B.basename)(ne)),Ae||(Ae=me.substr(0,me.length-(0,B.extname)(ne).length)));const ue=ge(ne,me,Ae,ke);if(ue)return ue}return null},Se=te.find(ne=>!!ne.allBasenames);Se&&(de.allBasenames=Se.allBasenames);const fe=te.reduce((ne,me)=>me.allPaths?ne.concat(me.allPaths):ne,[]);return fe.length&&(de.allPaths=fe),de}function J(ie,ae,te){if(ae===!1)return P;const ce=u(ie,te);if(ce===P)return P;if(typeof ae=="boolean")return ce;if(ae){const de=ae.when;if(typeof de=="string"){const Se=(fe,ne,me,ke)=>{if(!ke||!ce(fe,ne))return null;const Ae=de.replace("$(basename)",me),Be=ke(Ae);return(0,o.isThenable)(Be)?Be.then(Xe=>Xe?ie:null):Be?ie:null};return Se.requiresSiblings=!0,Se}}return ce}function z(ie,ae){const te=ie.filter(ne=>!!ne.basenames);if(te.length<2)return ie;const ce=te.reduce((ne,me)=>{const ke=me.basenames;return ke?ne.concat(ke):ne},[]);let de;if(ae){de=[];for(let ne=0,me=ce.length;ne<me;ne++)de.push(ae)}else de=te.reduce((ne,me)=>{const ke=me.patterns;return ke?ne.concat(ke):ne},[]);const Se=function(ne,me){if(typeof ne!="string")return null;if(!me){let Ae;for(Ae=ne.length;Ae>0;Ae--){const Be=ne.charCodeAt(Ae-1);if(Be===47||Be===92)break}me=ne.substr(Ae)}const ke=ce.indexOf(me);return ke!==-1?de[ke]:null};Se.basenames=ce,Se.patterns=de,Se.allBasenames=ce;const fe=ie.filter(ne=>!ne.basenames);return fe.push(Se),fe}}),define(Ee[72],be([1,0,15,105,24,2]),function(Y,e,o,I,w,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var S;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(S=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class A{constructor(n="",m=!1){if(this.value=n,typeof this.value!="string")throw(0,o.illegalArgument)("value");typeof m=="boolean"?(this.isTrusted=m,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=m.isTrusted??void 0,this.supportThemeIcons=m.supportThemeIcons??!1,this.supportHtml=m.supportHtml??!1)}appendText(n,m=0){return this.value+=v(this.supportThemeIcons?(0,I.escapeIcons)(n):n).replace(/([ \t]+)/g,(y,k)=>"&nbsp;".repeat(k.length)).replace(/\>/gm,"\\>").replace(/\n/g,m===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,m){return this.value+="\n```",this.value+=n,this.value+=`
`,this.value+=m,this.value+="\n```\n",this}}e.MarkdownString=A;function C(r){return L(r)?!r.value:Array.isArray(r)?r.every(C):!0}e.isEmptyMarkdownString=C;function L(r){return r instanceof A?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=L;function M(r,n){return r===n?!0:!r||!n?!1:r.value===n.value&&r.isTrusted===n.isTrusted&&r.supportThemeIcons===n.supportThemeIcons&&r.supportHtml===n.supportHtml&&(r.baseUri===n.baseUri||!!r.baseUri&&!!n.baseUri&&(0,w.isEqual)(B.URI.from(r.baseUri),B.URI.from(n.baseUri)))}e.markdownStringEqual=M;function v(r){return r.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=v;function c(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=c;function g(r){const n=[],m=r.split("|").map(k=>k.trim());r=m[0];const y=m[1];if(y){const k=/height=(\d+)/.exec(y),d=/width=(\d+)/.exec(y),f=k?k[1]:"",b=d?d[1]:"",l=isFinite(parseInt(b)),P=isFinite(parseInt(f));l&&n.push(`width="${b}"`),P&&n.push(`height="${f}"`)}return{href:r,dimensions:n}}e.parseHrefAndDimensions=g}),define(Ee[73],be([1,0,35,9,17,23,24,10,2]),function(Y,e,o,I,w,B,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function L(i,s,t){if(typeof i=="string"&&(i=C.URI.file(i)),t){const p=t.getWorkspaceFolder(i);if(p){const h=t.getWorkspace().folders.length>1;let _;if((0,S.isEqual)(p.uri,i)?_="":_=(0,S.relativePath)(p.uri,i),h){const T=p.name?p.name:(0,S.basename)(p.uri);_=_?T+" \u2022 "+_:T}return _}}if(i.scheme!==I.Schemas.file&&i.scheme!==I.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,o.hasDriveLetter)(i.fsPath))return(0,w.normalize)(v(i.fsPath));let a=(0,w.normalize)(i.fsPath);return!B.isWindows&&s?.userHome&&(a=g(a,s.userHome.fsPath)),a}e.getPathLabel=L;function M(i){if(!i)return;typeof i=="string"&&(i=C.URI.file(i));const s=(0,S.basename)(i)||(i.scheme===I.Schemas.file?i.fsPath:i.path);return B.isWindows&&(0,o.isRootOrDriveLetter)(s)?v(s):s}e.getBaseLabel=M;function v(i,s){return(0,o.hasDriveLetter)(i,s)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=v;let c=Object.create(null);function g(i,s){if(B.isWindows||!i||!s)return i;let t=c.original===s?c.normalized:void 0;return t||(t=`${(0,A.rtrim)(s,w.posix.sep)}${w.posix.sep}`,c={original:s,normalized:t}),(B.isLinux?i.startsWith(t):(0,A.startsWithIgnoreCase)(i,t))&&(i=`~/${i.substr(t.length)}`),i}e.tildify=g;function r(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=r;const n="\u2026",m="\\\\",y="~";function k(i,s=w.sep){const t=new Array(i.length);let a=!1;for(let p=0;p<i.length;p++){let h=i[p];if(h===""){t[p]=`.${s}`;continue}if(!h){t[p]=h;continue}a=!0;let _="";h.indexOf(m)===0?(_=h.substr(0,h.indexOf(m)+m.length),h=h.substr(h.indexOf(m)+m.length)):h.indexOf(s)===0?(_=h.substr(0,h.indexOf(s)+s.length),h=h.substr(h.indexOf(s)+s.length)):h.indexOf(y)===0&&(_=h.substr(0,h.indexOf(y)+y.length),h=h.substr(h.indexOf(y)+y.length));const T=h.split(s);for(let R=1;a&&R<=T.length;R++)for(let W=T.length-R;a&&W>=0;W--){a=!1;let E=T.slice(W,W+R).join(s);for(let H=0;!a&&H<i.length;H++)if(H!==p&&i[H]&&i[H].indexOf(E)>-1){const q=W+R===T.length,$=W>0&&i[H].indexOf(s)>-1?s+E:E,j=i[H].endsWith($);a=!q||j}if(!a){let H="";(T[0].endsWith(":")||_!=="")&&(W===1&&(W=0,R++,E=T[0]+s+E),W>0&&(H=T[0]+s),H=_+H),W>0&&(H=H+n+s),H=H+E,W+R<T.length&&(H=H+s+n),t[p]=H}}a&&(t[p]=h)}return t}e.shorten=k;var d;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function f(i,s=Object.create(null)){const t=[];let a=!1,p="";for(const h of i)if(h==="$"||a&&h==="{")p&&t.push({value:p,type:d.TEXT}),p="",a=!0;else if(h==="}"&&a){const _=s[p];if(typeof _=="string")_.length&&t.push({value:_,type:d.VARIABLE});else if(_){const T=t[t.length-1];(!T||T.type!==d.SEPARATOR)&&t.push({value:_.label,type:d.SEPARATOR})}p="",a=!1}else p+=h;return p&&!a&&t.push({value:p,type:d.TEXT}),t.filter((h,_)=>{if(h.type===d.SEPARATOR){const T=t[_-1],R=t[_+1];return[T,R].every(W=>W&&(W.type===d.VARIABLE||W.type===d.TEXT)&&W.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=f;function b(i,s){return B.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,B.isMacintosh?"&":"&&"):i.replace(/&&|&/g,t=>t==="&"?"&&":"&")}e.mnemonicMenuLabel=b;function l(i,s){return B.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,""):B.isWindows?i.replace(/&&|&/g,t=>t==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=l;function P(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=P;function u(i){const s=i.indexOf("/")!==-1?w.posix:w.win32,t=s.basename(i),a=s.dirname(i);return t.length?{name:t,parentPath:a}:{name:a,parentPath:""}}e.splitName=u}),define(Ee[108],be([1,0,2]),function(Y,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function I(M){return M.toJSON()}class w{constructor(v){this._uriTransformer=v}transformIncoming(v){const c=this._uriTransformer.transformIncoming(v);return c===v?v:I(o.URI.from(c))}transformOutgoing(v){const c=this._uriTransformer.transformOutgoing(v);return c===v?v:I(o.URI.from(c))}transformOutgoingURI(v){const c=this._uriTransformer.transformOutgoing(v);return c===v?v:o.URI.from(c)}transformOutgoingScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}}e.URITransformer=w,e.DefaultURITransformer=new class{transformIncoming(M){return M}transformOutgoing(M){return M}transformOutgoingURI(M){return M}transformOutgoingScheme(M){return M}};function B(M,v,c){if(!M||c>200)return null;if(typeof M=="object"){if(M instanceof o.URI)return v.transformOutgoing(M);for(let g in M)if(Object.hasOwnProperty.call(M,g)){const r=B(M[g],v,c+1);r!==null&&(M[g]=r)}}return null}function S(M,v){const c=B(M,v,0);return c===null?M:c}e.transformOutgoingURIs=S;function A(M,v,c,g){if(!M||g>200)return null;if(typeof M=="object"){if(M.$mid===1)return c?o.URI.revive(v.transformIncoming(M)):v.transformIncoming(M);for(let r in M)if(Object.hasOwnProperty.call(M,r)){const n=A(M[r],v,c,g+1);n!==null&&(M[r]=n)}}return null}function C(M,v){const c=A(M,v,!1,0);return c===null?M:c}e.transformIncomingURIs=C;function L(M,v){const c=A(M,v,!0,0);return c===null?M:c}e.transformAndReviveIncomingURIs=L}),define(Ee[36],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const o=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(C){return o.test(C)}e.isUUID=I;const w=new Uint8Array(16),B=[];for(let C=0;C<256;C++)B.push(C.toString(16).padStart(2,"0"));let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(C){for(let L=0;L<C.length;L++)C[L]=Math.floor(Math.random()*256);return C};function A(){S(w),w[6]=w[6]&15|64,w[8]=w[8]&63|128;let C=0,L="";return L+=B[w[C++]],L+=B[w[C++]],L+=B[w[C++]],L+=B[w[C++]],L+="-",L+=B[w[C++]],L+=B[w[C++]],L+="-",L+=B[w[C++]],L+=B[w[C++]],L+="-",L+=B[w[C++]],L+=B[w[C++]],L+="-",L+=B[w[C++]],L+=B[w[C++]],L+=B[w[C++]],L+=B[w[C++]],L+=B[w[C++]],L+=B[w[C++]],L}e.generateUuid=A}),define(Ee[109],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}}}),define(Ee[74],be([1,0,29,17]),function(Y,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function w(B,S,A,C,L){if(Array.isArray(B)){let M=0;for(const v of B){const c=w(v,S,A,C,L);if(c===10)return c;c>M&&(M=c)}return M}else{if(typeof B=="string")return C?B==="*"?5:B===A?10:0:0;if(B){const{language:M,pattern:v,scheme:c,hasAccessToAllModels:g,notebookType:r}=B;if(!C&&!g)return 0;let n=0;if(c)if(c===S.scheme)n=10;else if(c==="*")n=5;else return 0;if(M)if(M===A)n=10;else if(M==="*")n=Math.max(n,5);else return 0;if(r)if(r===L)n=10;else if(r==="*")n=Math.max(n,5);else return 0;if(v){let m;if(typeof v=="string"?m=v:m={...v,base:(0,I.normalize)(v.base)},m===S.fsPath||(0,o.match)(m,S.fsPath))n=10;else return 0}return n}else return 0}}e.score=w}),define(Ee[110],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var o;(function(S){S[S.None=0]="None",S[S.Indent=1]="Indent",S[S.IndentOutdent=2]="IndentOutdent",S[S.Outdent=3]="Outdent"})(o=e.IndentAction||(e.IndentAction={}));class I{constructor(A){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=A.open,this.close=A.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(A.notIn))for(let C=0,L=A.notIn.length;C<L;C++)switch(A.notIn[C]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(A,C){if(A.getTokenCount()===0)return!0;const L=A.findTokenIndexAtOffset(C-2),M=A.getStandardTokenType(L);return this.isOK(M)}_findNeutralCharacterInRange(A,C){for(let L=A;L<=C;L++){const M=String.fromCharCode(L);if(!this.open.includes(M)&&!this.close.includes(M))return M}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=I;class w{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const C of A)B(this.autoClosingPairsOpenByStart,C.open.charAt(0),C),B(this.autoClosingPairsOpenByEnd,C.open.charAt(C.open.length-1),C),B(this.autoClosingPairsCloseByStart,C.close.charAt(0),C),B(this.autoClosingPairsCloseByEnd,C.close.charAt(C.close.length-1),C),C.close.length===1&&C.open.length===1&&B(this.autoClosingPairsCloseSingleChar,C.close,C)}}e.AutoClosingPairs=w;function B(S,A,C){S.has(A)?S.get(A).push(C):S.set(A,[C])}}),define(Ee[75],be([1,0,21,23]),function(Y,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var w;(function(v){v[v.Full=1]="Full",v[v.Delta=2]="Delta"})(w||(w={}));function B(v){for(let c=0,g=v.length;c<g;c+=4){const r=v[c+0],n=v[c+1],m=v[c+2],y=v[c+3];v[c+0]=y,v[c+1]=m,v[c+2]=n,v[c+3]=r}}function S(v){const c=new Uint8Array(v.buffer,v.byteOffset,v.length*4);return I.isLittleEndian()||B(c),o.VSBuffer.wrap(c)}function A(v){const c=v.buffer;if(I.isLittleEndian()||B(c),c.byteOffset%4==0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const g=new Uint8Array(c.byteLength);return g.set(c),new Uint32Array(g.buffer,g.byteOffset,g.length/4)}}function C(v){const c=new Uint32Array(L(v));let g=0;if(c[g++]=v.id,v.type==="full")c[g++]=1,c[g++]=v.data.length,c.set(v.data,g),g+=v.data.length;else{c[g++]=2,c[g++]=v.deltas.length;for(const r of v.deltas)c[g++]=r.start,c[g++]=r.deleteCount,r.data?(c[g++]=r.data.length,c.set(r.data,g),g+=r.data.length):c[g++]=0}return S(c)}e.encodeSemanticTokensDto=C;function L(v){let c=0;if(c+=1+1,v.type==="full")c+=1+v.data.length;else{c+=1,c+=(1+1+1)*v.deltas.length;for(const g of v.deltas)g.data&&(c+=g.data.length)}return c}function M(v){const c=A(v);let g=0;const r=c[g++];if(c[g++]===1){const k=c[g++],d=c.subarray(g,g+k);return g+=k,{id:r,type:"full",data:d}}const m=c[g++],y=[];for(let k=0;k<m;k++){const d=c[g++],f=c[g++],b=c[g++];let l;b>0&&(l=c.subarray(g,g+b),g+=b),y[k]={start:d,deleteCount:f,data:l}}return{id:r,type:"delta",deltas:y}}e.decodeSemanticTokensDto=M}),define(Ee[111],be([18,19]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(Ee[112],be([1,0,111]),function(Y,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const I=60,w=I*60,B=w*24,S=B*7,A=B*30,C=B*365;function L(v,c,g){typeof v!="number"&&(v=v.getTime());const r=Math.round((new Date().getTime()-v)/1e3);if(r<-30)return(0,o.localize)(0,null,L(new Date().getTime()+r*1e3,!1));if(r<30)return(0,o.localize)(1,null);let n;return r<I?(n=r,c?n===1?g?(0,o.localize)(2,null,n):(0,o.localize)(3,null,n):g?(0,o.localize)(4,null,n):(0,o.localize)(5,null,n):n===1?g?(0,o.localize)(6,null,n):(0,o.localize)(7,null,n):g?(0,o.localize)(8,null,n):(0,o.localize)(9,null,n)):r<w?(n=Math.floor(r/I),c?n===1?g?(0,o.localize)(10,null,n):(0,o.localize)(11,null,n):g?(0,o.localize)(12,null,n):(0,o.localize)(13,null,n):n===1?g?(0,o.localize)(14,null,n):(0,o.localize)(15,null,n):g?(0,o.localize)(16,null,n):(0,o.localize)(17,null,n)):r<B?(n=Math.floor(r/w),c?n===1?g?(0,o.localize)(18,null,n):(0,o.localize)(19,null,n):g?(0,o.localize)(20,null,n):(0,o.localize)(21,null,n):n===1?g?(0,o.localize)(22,null,n):(0,o.localize)(23,null,n):g?(0,o.localize)(24,null,n):(0,o.localize)(25,null,n)):r<S?(n=Math.floor(r/B),c?n===1?(0,o.localize)(26,null,n):(0,o.localize)(27,null,n):n===1?(0,o.localize)(28,null,n):(0,o.localize)(29,null,n)):r<A?(n=Math.floor(r/S),c?n===1?g?(0,o.localize)(30,null,n):(0,o.localize)(31,null,n):g?(0,o.localize)(32,null,n):(0,o.localize)(33,null,n):n===1?g?(0,o.localize)(34,null,n):(0,o.localize)(35,null,n):g?(0,o.localize)(36,null,n):(0,o.localize)(37,null,n)):r<C?(n=Math.floor(r/A),c?n===1?g?(0,o.localize)(38,null,n):(0,o.localize)(39,null,n):g?(0,o.localize)(40,null,n):(0,o.localize)(41,null,n):n===1?g?(0,o.localize)(42,null,n):(0,o.localize)(43,null,n):g?(0,o.localize)(44,null,n):(0,o.localize)(45,null,n)):(n=Math.floor(r/C),c?n===1?g?(0,o.localize)(46,null,n):(0,o.localize)(47,null,n):g?(0,o.localize)(48,null,n):(0,o.localize)(49,null,n):n===1?g?(0,o.localize)(50,null,n):(0,o.localize)(51,null,n):g?(0,o.localize)(52,null,n):(0,o.localize)(53,null,n))}e.fromNow=L;function M(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=M}),define(Ee[113],be([18,19]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(Ee[43],be([1,0,16,11,113]),function(Y,e,o,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function B(v,c){return c&&(v.stack||v.stacktrace)?w.localize(0,null,A(v),S(v.stack)||S(v.stacktrace)):A(v)}function S(v){return Array.isArray(v)?v.join(`
`):v}function A(v){return typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?w.localize(1,null,v.message):v.message||w.localize(2,null)}function C(v=null,c=!1){if(!v)return w.localize(3,null);if(Array.isArray(v)){const g=o.coalesce(v),r=C(g[0],c);return g.length>1?w.localize(4,null,r,g.length):r}if(I.isString(v))return v;if(v.detail){const g=v.detail;if(g.error)return B(g.error,c);if(g.exception)return B(g.exception,c)}return v.stack?B(v,c):v.message?v.message:w.localize(5,null)}e.toErrorMessage=C;function L(v){const c=v;return c instanceof Error&&Array.isArray(c.actions)}e.isErrorWithActions=L;function M(v,c=Object.create(null)){const g=new Error(v);return c.actions&&(g.actions=c.actions),g}e.createErrorWithActions=M}),define(Ee[114],be([18,19]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(Ee[115],be([1,0,114,23,116,16,26,109]),function(Y,e,o,I,w,B,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var C;(function(G){G[G.None=0]="None",G[G.Keep=1]="Keep",G[G.Brackets=2]="Brackets",G[G.Advanced=3]="Advanced",G[G.Full=4]="Full"})(C=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class L{constructor(Q){this._values=Q}hasChanged(Q){return this._values[Q]}}e.ConfigurationChangedEvent=L;class M{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=M;class v{constructor(Q,le,Oe,He){this.id=Q,this.name=le,this.defaultValue=Oe,this.schema=He}applyUpdate(Q,le){return g(Q,le)}compute(Q,le,Oe){return Oe}}class c{constructor(Q,le){this.newValue=Q,this.didChange=le}}e.ApplyUpdateResult=c;function g(G,Q){if(typeof G!="object"||typeof Q!="object"||!G||!Q)return new c(Q,G!==Q);if(Array.isArray(G)||Array.isArray(Q)){const Oe=Array.isArray(G)&&Array.isArray(Q)&&B.equals(G,Q);return new c(Q,Oe)}let le=!1;for(const Oe in Q)if(Q.hasOwnProperty(Oe)){const He=g(G[Oe],Q[Oe]);He.didChange&&(G[Oe]=He.newValue,le=!0)}return new c(G,le)}class r{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,le){return g(Q,le)}validate(Q){return this.defaultValue}}class n{constructor(Q,le,Oe,He){this.id=Q,this.name=le,this.defaultValue=Oe,this.schema=He}applyUpdate(Q,le){return g(Q,le)}validate(Q){return typeof Q=="undefined"?this.defaultValue:Q}compute(Q,le,Oe){return Oe}}function m(G,Q){return typeof G=="undefined"?Q:G==="false"?!1:Boolean(G)}e.boolean=m;class y extends n{constructor(Q,le,Oe,He=void 0){typeof He!="undefined"&&(He.type="boolean",He.default=Oe);super(Q,le,Oe,He)}validate(Q){return m(Q,this.defaultValue)}}function k(G,Q,le,Oe){if(typeof G=="undefined")return Q;let He=parseInt(G,10);return isNaN(He)?Q:(He=Math.max(le,He),He=Math.min(Oe,He),He|0)}e.clampedInt=k;class d extends n{constructor(Q,le,Oe,He,Ge,Je=void 0){typeof Je!="undefined"&&(Je.type="integer",Je.default=Oe,Je.minimum=He,Je.maximum=Ge);super(Q,le,Oe,Je);this.minimum=He,this.maximum=Ge}static clampedInt(Q,le,Oe,He){return k(Q,le,Oe,He)}validate(Q){return d.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class f extends n{constructor(Q,le,Oe,He,Ge){typeof Ge!="undefined"&&(Ge.type="number",Ge.default=Oe);super(Q,le,Oe,Ge);this.validationFn=He}static clamp(Q,le,Oe){return Q<le?le:Q>Oe?Oe:Q}static float(Q,le){if(typeof Q=="number")return Q;if(typeof Q=="undefined")return le;const Oe=parseFloat(Q);return isNaN(Oe)?le:Oe}validate(Q){return this.validationFn(f.float(Q,this.defaultValue))}}class b extends n{static string(Q,le){return typeof Q!="string"?le:Q}constructor(Q,le,Oe,He=void 0){typeof He!="undefined"&&(He.type="string",He.default=Oe);super(Q,le,Oe,He)}validate(Q){return b.string(Q,this.defaultValue)}}function l(G,Q,le){return typeof G!="string"||le.indexOf(G)===-1?Q:G}e.stringSet=l;class P extends n{constructor(Q,le,Oe,He,Ge=void 0){typeof Ge!="undefined"&&(Ge.type="string",Ge.enum=He,Ge.default=Oe);super(Q,le,Oe,Ge);this._allowedValues=He}validate(Q){return l(Q,this.defaultValue,this._allowedValues)}}class u extends v{constructor(Q,le,Oe,He,Ge,Je,ft=void 0){typeof ft!="undefined"&&(ft.type="string",ft.enum=Ge,ft.default=He);super(Q,le,Oe,ft);this._allowedValues=Ge,this._convert=Je}validate(Q){return typeof Q!="string"?this.defaultValue:this._allowedValues.indexOf(Q)===-1?this.defaultValue:this._convert(Q)}}function i(G){switch(G){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class s extends v{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[o.localize(0,null),o.localize(1,null),o.localize(2,null)],default:"auto",description:o.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,le,Oe){return Oe===0?Q.accessibilitySupport:Oe}}class t extends v{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:o.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:o.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const le=Q;return{insertSpace:m(le.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:m(le.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var a;(function(G){G[G.Hidden=0]="Hidden",G[G.Blink=1]="Blink",G[G.Smooth=2]="Smooth",G[G.Phase=3]="Phase",G[G.Expand=4]="Expand",G[G.Solid=5]="Solid"})(a=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function p(G){switch(G){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function(G){G[G.Line=1]="Line",G[G.Block=2]="Block",G[G.Underline=3]="Underline",G[G.LineThin=4]="LineThin",G[G.BlockOutline=5]="BlockOutline",G[G.UnderlineThin=6]="UnderlineThin"})(h=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function _(G){switch(G){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=_;function T(G){switch(G){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class R extends r{constructor(){super(128)}compute(Q,le,Oe){const He=["monaco-editor"];return le.get(33)&&He.push(le.get(33)),Q.extraEditorClassName&&He.push(Q.extraEditorClassName),le.get(66)==="default"?He.push("mouse-default"):le.get(66)==="copy"&&He.push("mouse-copy"),le.get(100)&&He.push("showUnused"),le.get(126)&&He.push("showDeprecated"),He.join(" ")}}class W extends y{constructor(){super(32,"emptySelectionClipboard",!0,{description:o.localize(6,null)})}compute(Q,le,Oe){return Oe&&Q.emptySelectionClipboard}}class E extends v{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:o.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[o.localize(8,null),o.localize(9,null),o.localize(10,null)],description:o.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[o.localize(12,null),o.localize(13,null),o.localize(14,null)],description:o.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:o.localize(16,null),included:I.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:o.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:o.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const le=Q;return{cursorMoveOnType:m(le.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":l(le.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":l(le.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:m(le.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:m(le.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:m(le.loop,this.defaultValue.loop)}}}class H extends v{constructor(){super(45,"fontLigatures",H.OFF,{anyOf:[{type:"boolean",description:o.localize(19,null)},{type:"string",description:o.localize(20,null)}],description:o.localize(21,null),default:!1})}validate(Q){return typeof Q=="undefined"?this.defaultValue:typeof Q=="string"?Q==="false"?H.OFF:Q==="true"?H.ON:Q:Boolean(Q)?H.ON:H.OFF}}e.EditorFontLigatures=H,H.OFF='"liga" off, "calt" off',H.ON='"liga" on, "calt" on';class q extends r{constructor(){super(44)}compute(Q,le,Oe){return Q.fontInfo}}class $ extends n{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:o.localize(22,null)})}validate(Q){const le=f.float(Q,this.defaultValue);return le===0?e.EDITOR_FONT_DEFAULTS.fontSize:f.clamp(le,6,100)}compute(Q,le,Oe){return Q.fontInfo.fontSize}}class j extends v{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:j.MINIMUM_VALUE,maximum:j.MAXIMUM_VALUE,errorMessage:o.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:j.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:o.localize(24,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(d.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,j.MINIMUM_VALUE,j.MAXIMUM_VALUE))}}j.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],j.MINIMUM_VALUE=1,j.MAXIMUM_VALUE=1e3;class J extends v{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},le={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[o.localize(25,null),o.localize(26,null),o.localize(27,null)]},Oe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:o.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:o.localize(29,null),...le},"editor.gotoLocation.multipleTypeDefinitions":{description:o.localize(30,null),...le},"editor.gotoLocation.multipleDeclarations":{description:o.localize(31,null),...le},"editor.gotoLocation.multipleImplementations":{description:o.localize(32,null),...le},"editor.gotoLocation.multipleReferences":{description:o.localize(33,null),...le},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Oe,description:o.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Oe,description:o.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Oe,description:o.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Oe,description:o.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Oe,description:o.localize(38,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const le=Q;return{multiple:l(le.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:le.multipleDefinitions??l(le.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:le.multipleTypeDefinitions??l(le.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:le.multipleDeclarations??l(le.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:le.multipleImplementations??l(le.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:le.multipleReferences??l(le.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:b.string(le.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:b.string(le.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:b.string(le.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:b.string(le.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:b.string(le.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class z extends v{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:o.localize(39,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:o.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:o.localize(41,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:o.localize(42,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const le=Q;return{enabled:m(le.enabled,this.defaultValue.enabled),delay:d.clampedInt(le.delay,this.defaultValue.delay,0,1e4),sticky:m(le.sticky,this.defaultValue.sticky),above:m(le.above,this.defaultValue.above)}}}var ie;(function(G){G[G.None=0]="None",G[G.Text=1]="Text",G[G.Blocks=2]="Blocks"})(ie=e.RenderMinimap||(e.RenderMinimap={}));class ae extends r{constructor(){super(131)}compute(Q,le,Oe){return ae.computeLayout(le,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const le=Q.height/Q.lineHeight,Oe=Q.scrollBeyondLastLine?le-1:0,He=(Q.viewLineCount+Oe)/(Q.pixelRatio*Q.height),Ge=Math.floor(Q.viewLineCount/He);return{typicalViewportLineCount:le,extraLinesBeyondLastLine:Oe,desiredRatio:He,minimapLineCount:Ge}}static _computeMinimapLayout(Q,le){const Oe=Q.outerWidth,He=Q.outerHeight,Ge=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ge*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const Je=le.stableMinimapLayoutInput,ft=Je&&Q.outerHeight===Je.outerHeight&&Q.lineHeight===Je.lineHeight&&Q.typicalHalfwidthCharacterWidth===Je.typicalHalfwidthCharacterWidth&&Q.pixelRatio===Je.pixelRatio&&Q.scrollBeyondLastLine===Je.scrollBeyondLastLine&&Q.minimap.enabled===Je.minimap.enabled&&Q.minimap.side===Je.minimap.side&&Q.minimap.size===Je.minimap.size&&Q.minimap.showSlider===Je.minimap.showSlider&&Q.minimap.renderCharacters===Je.minimap.renderCharacters&&Q.minimap.maxColumn===Je.minimap.maxColumn&&Q.minimap.scale===Je.minimap.scale&&Q.verticalScrollbarWidth===Je.verticalScrollbarWidth&&Q.isViewportWrapping===Je.isViewportWrapping,It=Q.lineHeight,St=Q.typicalHalfwidthCharacterWidth,kt=Q.scrollBeyondLastLine,qe=Q.minimap.renderCharacters;let vt=Ge>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const Nt=Q.minimap.maxColumn,nt=Q.minimap.size,ut=Q.minimap.side,At=Q.verticalScrollbarWidth,Tt=Q.viewLineCount,wt=Q.remainingWidth,dt=Q.isViewportWrapping,Rt=qe?2:3;let Lt=Math.floor(Ge*He);const Ft=Lt/Ge;let Ue=!1,he=!1,pe=Rt*vt,se=vt/Ge,K=1;if(nt==="fill"||nt==="fit"){const{typicalViewportLineCount:Et,extraLinesBeyondLastLine:rt,desiredRatio:at,minimapLineCount:ot}=ae.computeContainedMinimapLineCount({viewLineCount:Tt,scrollBeyondLastLine:kt,height:He,lineHeight:It,pixelRatio:Ge});if(Tt/ot>1)Ue=!0,he=!0,vt=1,pe=1,se=vt/Ge;else{let mt=!1,Dt=vt+1;if(nt==="fit"){const Ut=Math.ceil((Tt+rt)*pe);dt&&ft&&wt<=le.stableFitRemainingWidth?(mt=!0,Dt=le.stableFitMaxMinimapScale):mt=Ut>Lt}if(nt==="fill"||mt){Ue=!0;const Ut=vt;pe=Math.min(It*Ge,Math.max(1,Math.floor(1/at))),dt&&ft&&wt<=le.stableFitRemainingWidth&&(Dt=le.stableFitMaxMinimapScale),vt=Math.min(Dt,Math.max(1,Math.floor(pe/Rt))),vt>Ut&&(K=Math.min(2,vt/Ut)),se=vt/Ge/K,Lt=Math.ceil(Math.max(Et,Tt+rt)*pe),dt?(le.stableMinimapLayoutInput=Q,le.stableFitRemainingWidth=wt,le.stableFitMaxMinimapScale=vt):(le.stableMinimapLayoutInput=null,le.stableFitRemainingWidth=0)}}}const _e=Math.floor(Nt*se),Ce=Math.min(_e,Math.max(0,Math.floor((wt-At-2)*se/(St+se)))+e.MINIMAP_GUTTER_WIDTH);let $e=Math.floor(Ge*Ce);const Ve=$e/Ge;$e=Math.floor($e*K);const lt=qe?1:2,gt=ut==="left"?0:Oe-Ce-At;return{renderMinimap:lt,minimapLeft:gt,minimapWidth:Ce,minimapHeightIsEditorHeight:Ue,minimapIsSampling:he,minimapScale:vt,minimapLineHeight:pe,minimapCanvasInnerWidth:$e,minimapCanvasInnerHeight:Lt,minimapCanvasOuterWidth:Ve,minimapCanvasOuterHeight:Ft}}static computeLayout(Q,le){const Oe=le.outerWidth|0,He=le.outerHeight|0,Ge=le.lineHeight|0,Je=le.lineNumbersDigitCount|0,ft=le.typicalHalfwidthCharacterWidth,It=le.maxDigitWidth,St=le.pixelRatio,kt=le.viewLineCount,qe=Q.get(123),vt=qe==="inherit"?Q.get(122):qe,Nt=vt==="inherit"?Q.get(118):vt,nt=Q.get(121),ut=Q.get(2),At=le.isDominatedByLongLines,Tt=Q.get(50),wt=Q.get(60).renderType!==0,dt=Q.get(61),Rt=Q.get(94),Lt=Q.get(65),Ft=Q.get(92),Ue=Ft.verticalScrollbarSize,he=Ft.verticalHasArrows,pe=Ft.arrowSize,se=Ft.horizontalScrollbarSize,K=Q.get(58),_e=Q.get(37);let Ce;if(typeof K=="string"&&/^\d+(\.\d+)?ch$/.test(K)){const Ht=parseFloat(K.substr(0,K.length-2));Ce=d.clampedInt(Ht*ft,0,0,1e3)}else Ce=d.clampedInt(K,0,0,1e3);_e&&(Ce+=16);let $e=0;if(wt){const Ht=Math.max(Je,dt);$e=Math.round(Ht*It)}let Ve=0;Tt&&(Ve=Ge);let lt=0,gt=lt+Ve,Et=gt+$e,rt=Et+Ce;const at=Oe-Ve-$e-Ce;let ot=!1,Mt=!1,mt=-1;ut!==2&&(vt==="inherit"&&At?(ot=!0,Mt=!0):Nt==="on"||Nt==="bounded"?Mt=!0:Nt==="wordWrapColumn"&&(mt=nt));const Dt=ae._computeMinimapLayout({outerWidth:Oe,outerHeight:He,lineHeight:Ge,typicalHalfwidthCharacterWidth:ft,pixelRatio:St,scrollBeyondLastLine:Rt,minimap:Lt,verticalScrollbarWidth:Ue,viewLineCount:kt,remainingWidth:at,isViewportWrapping:Mt},le.memory||new M);Dt.renderMinimap!==0&&Dt.minimapLeft===0&&(lt+=Dt.minimapWidth,gt+=Dt.minimapWidth,Et+=Dt.minimapWidth,rt+=Dt.minimapWidth);const Ut=at-Dt.minimapWidth,bt=Math.max(1,Math.floor((Ut-Ue-2)/ft)),Bt=he?pe:0;return Mt&&(mt=Math.max(1,bt),Nt==="bounded"&&(mt=Math.min(mt,nt))),{width:Oe,height:He,glyphMarginLeft:lt,glyphMarginWidth:Ve,lineNumbersLeft:gt,lineNumbersWidth:$e,decorationsLeft:Et,decorationsWidth:Ce,contentLeft:rt,contentWidth:Ut,minimap:Dt,viewportColumn:bt,isWordWrapMinified:ot,isViewportWrapping:Mt,wrappingColumn:mt,verticalScrollbarWidth:Ue,horizontalScrollbarHeight:se,overviewRuler:{top:Bt,width:Ue,height:He-2*Bt,right:0}}}}e.EditorLayoutInfoComputer=ae;class te extends v{constructor(){const Q={enabled:!0};super(57,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:o.localize(43,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:m(Q.enabled,this.defaultValue.enabled)}}}class ce extends v{constructor(){const Q={enabled:!0,fontSize:0,fontFamily:""};super(127,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"boolean",default:Q.enabled,description:o.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:o.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:o.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const le=Q;return{enabled:m(le.enabled,this.defaultValue.enabled),fontSize:d.clampedInt(le.fontSize,this.defaultValue.fontSize,0,100),fontFamily:b.string(le.fontFamily,this.defaultValue.fontFamily)}}}class de extends f{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>f.clamp(Q,0,150),{markdownDescription:o.localize(47,null)})}compute(Q,le,Oe){return Q.fontInfo.lineHeight}}class Se extends v{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:o.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[o.localize(49,null),o.localize(50,null),o.localize(51,null)],default:Q.size,description:o.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:o.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:o.localize(54,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:o.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:o.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:o.localize(57,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const le=Q;return{enabled:m(le.enabled,this.defaultValue.enabled),size:l(le.size,this.defaultValue.size,["proportional","fill","fit"]),side:l(le.side,this.defaultValue.side,["right","left"]),showSlider:l(le.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:m(le.renderCharacters,this.defaultValue.renderCharacters),scale:d.clampedInt(le.scale,1,1,3),maxColumn:d.clampedInt(le.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function fe(G){return G==="ctrlCmd"?I.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ne extends v{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(59,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const le=Q;return{top:d.clampedInt(le.top,0,0,1e3),bottom:d.clampedInt(le.bottom,0,0,1e3)}}}class me extends v{constructor(){const Q={enabled:!0,cycle:!1};super(76,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:o.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:o.localize(61,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const le=Q;return{enabled:m(le.enabled,this.defaultValue.enabled),cycle:m(le.cycle,this.defaultValue.cycle)}}}class ke extends r{constructor(){super(129)}compute(Q,le,Oe){return Q.pixelRatio}}class Ae extends v{constructor(){const Q={other:!0,comments:!1,strings:!1};super(79,"quickSuggestions",Q,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Q.strings,description:o.localize(62,null)},comments:{type:"boolean",default:Q.comments,description:o.localize(63,null)},other:{type:"boolean",default:Q.other,description:o.localize(64,null)}}}],default:Q,description:o.localize(65,null)});this.defaultValue=Q}validate(Q){if(typeof Q=="boolean")return Q;if(Q&&typeof Q=="object"){const le=Q,Oe={other:m(le.other,this.defaultValue.other),comments:m(le.comments,this.defaultValue.comments),strings:m(le.strings,this.defaultValue.strings)};return Oe.other&&Oe.comments&&Oe.strings?!0:!Oe.other&&!Oe.comments&&!Oe.strings?!1:Oe}return this.defaultValue}}var Be;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval",G[G.Custom=4]="Custom"})(Be=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Xe extends v{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[o.localize(66,null),o.localize(67,null),o.localize(68,null),o.localize(69,null)],default:"on",description:o.localize(70,null)})}validate(Q){let le=this.defaultValue.renderType,Oe=this.defaultValue.renderFn;return typeof Q!="undefined"&&(typeof Q=="function"?(le=4,Oe=Q):Q==="interval"?le=3:Q==="relative"?le=2:Q==="on"?le=1:le=0),{renderType:le,renderFn:Oe}}}function ge(G){const Q=G.get(87);return Q==="editable"?G.get(81):Q!=="on"}e.filterValidationDecorations=ge;class ue extends v{constructor(){const Q=[],le={type:"number",description:o.localize(71,null)};super(91,"rulers",Q,{type:"array",items:{anyOf:[le,{type:["object"],properties:{column:le,color:{type:"string",description:o.localize(72,null),format:"color-hex"}}}]},default:Q,description:o.localize(73,null)})}validate(Q){if(Array.isArray(Q)){const le=[];for(let Oe of Q)if(typeof Oe=="number")le.push({column:d.clampedInt(Oe,0,0,1e4),color:null});else if(Oe&&typeof Oe=="object"){const He=Oe;le.push({column:d.clampedInt(He.column,0,0,1e4),color:He.color})}return le.sort((Oe,He)=>Oe.column-He.column),le}return this.defaultValue}}function N(G,Q){if(typeof G!="string")return Q;switch(G){case"hidden":return 2;case"visible":return 3;default:return 1}}class F extends v{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(74,null),o.localize(75,null),o.localize(76,null)],default:"auto",description:o.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(78,null),o.localize(79,null),o.localize(80,null)],default:"auto",description:o.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:o.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:o.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:o.localize(84,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const le=Q,Oe=d.clampedInt(le.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=d.clampedInt(le.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:d.clampedInt(le.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:N(le.vertical,this.defaultValue.vertical),horizontal:N(le.horizontal,this.defaultValue.horizontal),useShadows:m(le.useShadows,this.defaultValue.useShadows),verticalHasArrows:m(le.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:m(le.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:m(le.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:m(le.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Oe,horizontalSliderSize:d.clampedInt(le.horizontalSliderSize,Oe,0,1e3),verticalScrollbarSize:He,verticalSliderSize:d.clampedInt(le.verticalSliderSize,He,0,1e3),scrollByPage:m(le.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class D extends v{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:o.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:o.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:o.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:o.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:o.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:o.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:o.localize(91,null)}})}applyUpdate(Q,le){let Oe=!1;le.allowedCharacters&&(S.equals(Q.allowedCharacters,le.allowedCharacters)||(Q={...Q,allowedCharacters:le.allowedCharacters},Oe=!0)),le.allowedLocales&&(S.equals(Q.allowedLocales,le.allowedLocales)||(Q={...Q,allowedLocales:le.allowedLocales},Oe=!0));const He=super.applyUpdate(Q,le);return Oe?new c(He.newValue,!0):He}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const le=Q;return{nonBasicASCII:re(le.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:m(le.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:m(le.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:re(le.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:re(le.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Q.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Q,le){if(typeof Q!="object"||!Q)return le;const Oe={};for(const[He,Ge]of Object.entries(Q))Ge===!0&&(Oe[He]=!0);return Oe}}class O extends v{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:o.localize(92,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const le=Q;return{enabled:m(le.enabled,this.defaultValue.enabled),mode:l(le.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class x extends v{constructor(){const Q={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,description:o.localize(93,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:m(Q.enabled,this.defaultValue.enabled)}}}class X extends v{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(94,null),o.localize(95,null),o.localize(96,null)],default:Q.bracketPairs,description:o.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(98,null),o.localize(99,null),o.localize(100,null)],default:Q.bracketPairsHorizontal,description:o.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:o.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:o.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:Q.highlightActiveIndentation,description:o.localize(104,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const le=Q;return{bracketPairs:re(le.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:re(le.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:m(le.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:m(le.indentation,this.defaultValue.indentation),highlightActiveIndentation:m(le.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function re(G,Q,le){const Oe=le.indexOf(G);return Oe===-1?Q:le[Oe]}class ve extends v{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[o.localize(105,null),o.localize(106,null)],default:Q.insertMode,description:o.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:o.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:o.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:o.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:o.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:o.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:o.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:o.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:o.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:o.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:o.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:o.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:o.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:o.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:o.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:o.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:o.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:o.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:o.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:o.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:o.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:o.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:o.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:o.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:o.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:o.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:o.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:o.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:o.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:o.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:o.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:o.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:o.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:o.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:o.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:o.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:o.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:o.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:o.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:o.localize(146,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const le=Q;return{insertMode:l(le.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:m(le.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:m(le.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:m(le.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:m(le.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:m(le.showIcons,this.defaultValue.showIcons),showStatusBar:m(le.showStatusBar,this.defaultValue.showStatusBar),preview:m(le.preview,this.defaultValue.preview),previewMode:l(le.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:m(le.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:m(le.showMethods,this.defaultValue.showMethods),showFunctions:m(le.showFunctions,this.defaultValue.showFunctions),showConstructors:m(le.showConstructors,this.defaultValue.showConstructors),showDeprecated:m(le.showDeprecated,this.defaultValue.showDeprecated),showFields:m(le.showFields,this.defaultValue.showFields),showVariables:m(le.showVariables,this.defaultValue.showVariables),showClasses:m(le.showClasses,this.defaultValue.showClasses),showStructs:m(le.showStructs,this.defaultValue.showStructs),showInterfaces:m(le.showInterfaces,this.defaultValue.showInterfaces),showModules:m(le.showModules,this.defaultValue.showModules),showProperties:m(le.showProperties,this.defaultValue.showProperties),showEvents:m(le.showEvents,this.defaultValue.showEvents),showOperators:m(le.showOperators,this.defaultValue.showOperators),showUnits:m(le.showUnits,this.defaultValue.showUnits),showValues:m(le.showValues,this.defaultValue.showValues),showConstants:m(le.showConstants,this.defaultValue.showConstants),showEnums:m(le.showEnums,this.defaultValue.showEnums),showEnumMembers:m(le.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:m(le.showKeywords,this.defaultValue.showKeywords),showWords:m(le.showWords,this.defaultValue.showWords),showColors:m(le.showColors,this.defaultValue.showColors),showFiles:m(le.showFiles,this.defaultValue.showFiles),showReferences:m(le.showReferences,this.defaultValue.showReferences),showFolders:m(le.showFolders,this.defaultValue.showFolders),showTypeParameters:m(le.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:m(le.showSnippets,this.defaultValue.showSnippets),showUsers:m(le.showUsers,this.defaultValue.showUsers),showIssues:m(le.showIssues,this.defaultValue.showIssues)}}}class Ie extends v{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:o.localize(147,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:m(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Me extends r{constructor(){super(130)}compute(Q,le,Oe){return le.get(81)?!0:Q.tabFocusMode}}var Le;(function(G){G[G.None=0]="None",G[G.Same=1]="Same",G[G.Indent=2]="Indent",G[G.DeepIndent=3]="DeepIndent"})(Le=e.WrappingIndent||(e.WrappingIndent={}));function ze(G){switch(G){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class xe extends r{constructor(){super(132)}compute(Q,le,Oe){const He=le.get(131);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}const Re="Consolas, 'Courier New', monospace",Qe="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.isMacintosh?Qe:I.isLinux?tt:Re,fontWeight:"normal",fontSize:I.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Te(G){return e.editorOptionsRegistry[G.id]=G,G}var it;(function(G){G[G.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",G[G.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",G[G.accessibilitySupport=2]="accessibilitySupport",G[G.accessibilityPageSize=3]="accessibilityPageSize",G[G.ariaLabel=4]="ariaLabel",G[G.autoClosingBrackets=5]="autoClosingBrackets",G[G.autoClosingDelete=6]="autoClosingDelete",G[G.autoClosingOvertype=7]="autoClosingOvertype",G[G.autoClosingQuotes=8]="autoClosingQuotes",G[G.autoIndent=9]="autoIndent",G[G.automaticLayout=10]="automaticLayout",G[G.autoSurround=11]="autoSurround",G[G.bracketPairColorization=12]="bracketPairColorization",G[G.guides=13]="guides",G[G.codeLens=14]="codeLens",G[G.codeLensFontFamily=15]="codeLensFontFamily",G[G.codeLensFontSize=16]="codeLensFontSize",G[G.colorDecorators=17]="colorDecorators",G[G.columnSelection=18]="columnSelection",G[G.comments=19]="comments",G[G.contextmenu=20]="contextmenu",G[G.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",G[G.cursorBlinking=22]="cursorBlinking",G[G.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",G[G.cursorStyle=24]="cursorStyle",G[G.cursorSurroundingLines=25]="cursorSurroundingLines",G[G.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",G[G.cursorWidth=27]="cursorWidth",G[G.disableLayerHinting=28]="disableLayerHinting",G[G.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",G[G.domReadOnly=30]="domReadOnly",G[G.dragAndDrop=31]="dragAndDrop",G[G.emptySelectionClipboard=32]="emptySelectionClipboard",G[G.extraEditorClassName=33]="extraEditorClassName",G[G.fastScrollSensitivity=34]="fastScrollSensitivity",G[G.find=35]="find",G[G.fixedOverflowWidgets=36]="fixedOverflowWidgets",G[G.folding=37]="folding",G[G.foldingStrategy=38]="foldingStrategy",G[G.foldingHighlight=39]="foldingHighlight",G[G.foldingImportsByDefault=40]="foldingImportsByDefault",G[G.foldingMaximumRegions=41]="foldingMaximumRegions",G[G.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",G[G.fontFamily=43]="fontFamily",G[G.fontInfo=44]="fontInfo",G[G.fontLigatures=45]="fontLigatures",G[G.fontSize=46]="fontSize",G[G.fontWeight=47]="fontWeight",G[G.formatOnPaste=48]="formatOnPaste",G[G.formatOnType=49]="formatOnType",G[G.glyphMargin=50]="glyphMargin",G[G.gotoLocation=51]="gotoLocation",G[G.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",G[G.hover=53]="hover",G[G.inDiffEditor=54]="inDiffEditor",G[G.inlineSuggest=55]="inlineSuggest",G[G.letterSpacing=56]="letterSpacing",G[G.lightbulb=57]="lightbulb",G[G.lineDecorationsWidth=58]="lineDecorationsWidth",G[G.lineHeight=59]="lineHeight",G[G.lineNumbers=60]="lineNumbers",G[G.lineNumbersMinChars=61]="lineNumbersMinChars",G[G.linkedEditing=62]="linkedEditing",G[G.links=63]="links",G[G.matchBrackets=64]="matchBrackets",G[G.minimap=65]="minimap",G[G.mouseStyle=66]="mouseStyle",G[G.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",G[G.mouseWheelZoom=68]="mouseWheelZoom",G[G.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",G[G.multiCursorModifier=70]="multiCursorModifier",G[G.multiCursorPaste=71]="multiCursorPaste",G[G.occurrencesHighlight=72]="occurrencesHighlight",G[G.overviewRulerBorder=73]="overviewRulerBorder",G[G.overviewRulerLanes=74]="overviewRulerLanes",G[G.padding=75]="padding",G[G.parameterHints=76]="parameterHints",G[G.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",G[G.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",G[G.quickSuggestions=79]="quickSuggestions",G[G.quickSuggestionsDelay=80]="quickSuggestionsDelay",G[G.readOnly=81]="readOnly",G[G.renameOnType=82]="renameOnType",G[G.renderControlCharacters=83]="renderControlCharacters",G[G.renderFinalNewline=84]="renderFinalNewline",G[G.renderLineHighlight=85]="renderLineHighlight",G[G.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",G[G.renderValidationDecorations=87]="renderValidationDecorations",G[G.renderWhitespace=88]="renderWhitespace",G[G.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",G[G.roundedSelection=90]="roundedSelection",G[G.rulers=91]="rulers",G[G.scrollbar=92]="scrollbar",G[G.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",G[G.scrollBeyondLastLine=94]="scrollBeyondLastLine",G[G.scrollPredominantAxis=95]="scrollPredominantAxis",G[G.selectionClipboard=96]="selectionClipboard",G[G.selectionHighlight=97]="selectionHighlight",G[G.selectOnLineNumbers=98]="selectOnLineNumbers",G[G.showFoldingControls=99]="showFoldingControls",G[G.showUnused=100]="showUnused",G[G.snippetSuggestions=101]="snippetSuggestions",G[G.smartSelect=102]="smartSelect",G[G.smoothScrolling=103]="smoothScrolling",G[G.stickyTabStops=104]="stickyTabStops",G[G.stopRenderingLineAfter=105]="stopRenderingLineAfter",G[G.suggest=106]="suggest",G[G.suggestFontSize=107]="suggestFontSize",G[G.suggestLineHeight=108]="suggestLineHeight",G[G.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",G[G.suggestSelection=110]="suggestSelection",G[G.tabCompletion=111]="tabCompletion",G[G.tabIndex=112]="tabIndex",G[G.unicodeHighlighting=113]="unicodeHighlighting",G[G.unusualLineTerminators=114]="unusualLineTerminators",G[G.useShadowDOM=115]="useShadowDOM",G[G.useTabStops=116]="useTabStops",G[G.wordSeparators=117]="wordSeparators",G[G.wordWrap=118]="wordWrap",G[G.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",G[G.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",G[G.wordWrapColumn=121]="wordWrapColumn",G[G.wordWrapOverride1=122]="wordWrapOverride1",G[G.wordWrapOverride2=123]="wordWrapOverride2",G[G.wrappingIndent=124]="wrappingIndent",G[G.wrappingStrategy=125]="wrappingStrategy",G[G.showDeprecated=126]="showDeprecated",G[G.inlayHints=127]="inlayHints",G[G.editorClassName=128]="editorClassName",G[G.pixelRatio=129]="pixelRatio",G[G.tabFocusMode=130]="tabFocusMode",G[G.layoutInfo=131]="layoutInfo",G[G.wrappingInfo=132]="wrappingInfo"})(it=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Te(new y(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:o.localize(148,null)})),acceptSuggestionOnEnter:Te(new P(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",o.localize(149,null),""],markdownDescription:o.localize(150,null)})),accessibilitySupport:Te(new s),accessibilityPageSize:Te(new d(3,"accessibilityPageSize",10,1,1073741824,{description:o.localize(151,null)})),ariaLabel:Te(new b(4,"ariaLabel",o.localize(152,null))),autoClosingBrackets:Te(new P(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(153,null),o.localize(154,null),""],description:o.localize(155,null)})),autoClosingDelete:Te(new P(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",o.localize(156,null),""],description:o.localize(157,null)})),autoClosingOvertype:Te(new P(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",o.localize(158,null),""],description:o.localize(159,null)})),autoClosingQuotes:Te(new P(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(160,null),o.localize(161,null),""],description:o.localize(162,null)})),autoIndent:Te(new u(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],i,{enumDescriptions:[o.localize(163,null),o.localize(164,null),o.localize(165,null),o.localize(166,null),o.localize(167,null)],description:o.localize(168,null)})),automaticLayout:Te(new y(10,"automaticLayout",!1)),autoSurround:Te(new P(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[o.localize(169,null),o.localize(170,null),o.localize(171,null),""],description:o.localize(172,null)})),bracketPairColorization:Te(new x),bracketPairGuides:Te(new X),stickyTabStops:Te(new y(104,"stickyTabStops",!1,{description:o.localize(173,null)})),codeLens:Te(new y(14,"codeLens",!0,{description:o.localize(174,null)})),codeLensFontFamily:Te(new b(15,"codeLensFontFamily","",{description:o.localize(175,null)})),codeLensFontSize:Te(new d(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:o.localize(176,null)})),colorDecorators:Te(new y(17,"colorDecorators",!0,{description:o.localize(177,null)})),columnSelection:Te(new y(18,"columnSelection",!1,{description:o.localize(178,null)})),comments:Te(new t),contextmenu:Te(new y(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Te(new y(21,"copyWithSyntaxHighlighting",!0,{description:o.localize(179,null)})),cursorBlinking:Te(new u(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],p,{description:o.localize(180,null)})),cursorSmoothCaretAnimation:Te(new y(23,"cursorSmoothCaretAnimation",!1,{description:o.localize(181,null)})),cursorStyle:Te(new u(24,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],T,{description:o.localize(182,null)})),cursorSurroundingLines:Te(new d(25,"cursorSurroundingLines",0,0,1073741824,{description:o.localize(183,null)})),cursorSurroundingLinesStyle:Te(new P(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[o.localize(184,null),o.localize(185,null)],description:o.localize(186,null)})),cursorWidth:Te(new d(27,"cursorWidth",0,0,1073741824,{markdownDescription:o.localize(187,null)})),disableLayerHinting:Te(new y(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Te(new y(29,"disableMonospaceOptimizations",!1)),domReadOnly:Te(new y(30,"domReadOnly",!1)),dragAndDrop:Te(new y(31,"dragAndDrop",!0,{description:o.localize(188,null)})),emptySelectionClipboard:Te(new W),extraEditorClassName:Te(new b(33,"extraEditorClassName","")),fastScrollSensitivity:Te(new f(34,"fastScrollSensitivity",5,G=>G<=0?5:G,{markdownDescription:o.localize(189,null)})),find:Te(new E),fixedOverflowWidgets:Te(new y(36,"fixedOverflowWidgets",!1)),folding:Te(new y(37,"folding",!0,{description:o.localize(190,null)})),foldingStrategy:Te(new P(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[o.localize(191,null),o.localize(192,null)],description:o.localize(193,null)})),foldingHighlight:Te(new y(39,"foldingHighlight",!0,{description:o.localize(194,null)})),foldingImportsByDefault:Te(new y(40,"foldingImportsByDefault",!1,{description:o.localize(195,null)})),foldingMaximumRegions:Te(new d(41,"foldingMaximumRegions",5e3,10,65e3,{description:o.localize(196,null)})),unfoldOnClickAfterEndOfLine:Te(new y(42,"unfoldOnClickAfterEndOfLine",!1,{description:o.localize(197,null)})),fontFamily:Te(new b(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:o.localize(198,null)})),fontInfo:Te(new q),fontLigatures2:Te(new H),fontSize:Te(new $),fontWeight:Te(new j),formatOnPaste:Te(new y(48,"formatOnPaste",!1,{description:o.localize(199,null)})),formatOnType:Te(new y(49,"formatOnType",!1,{description:o.localize(200,null)})),glyphMargin:Te(new y(50,"glyphMargin",!0,{description:o.localize(201,null)})),gotoLocation:Te(new J),hideCursorInOverviewRuler:Te(new y(52,"hideCursorInOverviewRuler",!1,{description:o.localize(202,null)})),hover:Te(new z),inDiffEditor:Te(new y(54,"inDiffEditor",!1)),letterSpacing:Te(new f(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,G=>f.clamp(G,-5,20),{description:o.localize(203,null)})),lightbulb:Te(new te),lineDecorationsWidth:Te(new n(58,"lineDecorationsWidth",10)),lineHeight:Te(new de),lineNumbers:Te(new Xe),lineNumbersMinChars:Te(new d(61,"lineNumbersMinChars",5,1,300)),linkedEditing:Te(new y(62,"linkedEditing",!1,{description:o.localize(204,null)})),links:Te(new y(63,"links",!0,{description:o.localize(205,null)})),matchBrackets:Te(new P(64,"matchBrackets","always",["always","near","never"],{description:o.localize(206,null)})),minimap:Te(new Se),mouseStyle:Te(new P(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Te(new f(67,"mouseWheelScrollSensitivity",1,G=>G===0?1:G,{markdownDescription:o.localize(207,null)})),mouseWheelZoom:Te(new y(68,"mouseWheelZoom",!1,{markdownDescription:o.localize(208,null)})),multiCursorMergeOverlapping:Te(new y(69,"multiCursorMergeOverlapping",!0,{description:o.localize(209,null)})),multiCursorModifier:Te(new u(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],fe,{markdownEnumDescriptions:[o.localize(210,null),o.localize(211,null)],markdownDescription:o.localize(212,null)})),multiCursorPaste:Te(new P(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[o.localize(213,null),o.localize(214,null)],markdownDescription:o.localize(215,null)})),occurrencesHighlight:Te(new y(72,"occurrencesHighlight",!0,{description:o.localize(216,null)})),overviewRulerBorder:Te(new y(73,"overviewRulerBorder",!0,{description:o.localize(217,null)})),overviewRulerLanes:Te(new d(74,"overviewRulerLanes",3,0,3)),padding:Te(new ne),parameterHints:Te(new me),peekWidgetDefaultFocus:Te(new P(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[o.localize(218,null),o.localize(219,null)],description:o.localize(220,null)})),definitionLinkOpensInPeek:Te(new y(78,"definitionLinkOpensInPeek",!1,{description:o.localize(221,null)})),quickSuggestions:Te(new Ae),quickSuggestionsDelay:Te(new d(80,"quickSuggestionsDelay",10,0,1073741824,{description:o.localize(222,null)})),readOnly:Te(new y(81,"readOnly",!1)),renameOnType:Te(new y(82,"renameOnType",!1,{description:o.localize(223,null),markdownDeprecationMessage:o.localize(224,null)})),renderControlCharacters:Te(new y(83,"renderControlCharacters",!0,{description:o.localize(225,null),restricted:!0})),renderFinalNewline:Te(new y(84,"renderFinalNewline",!0,{description:o.localize(226,null)})),renderLineHighlight:Te(new P(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",o.localize(227,null)],description:o.localize(228,null)})),renderLineHighlightOnlyWhenFocus:Te(new y(86,"renderLineHighlightOnlyWhenFocus",!1,{description:o.localize(229,null)})),renderValidationDecorations:Te(new P(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Te(new P(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",o.localize(230,null),o.localize(231,null),o.localize(232,null),""],description:o.localize(233,null)})),revealHorizontalRightPadding:Te(new d(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Te(new y(90,"roundedSelection",!0,{description:o.localize(234,null)})),rulers:Te(new ue),scrollbar:Te(new F),scrollBeyondLastColumn:Te(new d(93,"scrollBeyondLastColumn",5,0,1073741824,{description:o.localize(235,null)})),scrollBeyondLastLine:Te(new y(94,"scrollBeyondLastLine",!0,{description:o.localize(236,null)})),scrollPredominantAxis:Te(new y(95,"scrollPredominantAxis",!0,{description:o.localize(237,null)})),selectionClipboard:Te(new y(96,"selectionClipboard",!0,{description:o.localize(238,null),included:I.isLinux})),selectionHighlight:Te(new y(97,"selectionHighlight",!0,{description:o.localize(239,null)})),selectOnLineNumbers:Te(new y(98,"selectOnLineNumbers",!0)),showFoldingControls:Te(new P(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[o.localize(240,null),o.localize(241,null)],description:o.localize(242,null)})),showUnused:Te(new y(100,"showUnused",!0,{description:o.localize(243,null)})),showDeprecated:Te(new y(126,"showDeprecated",!0,{description:o.localize(244,null)})),inlayHints:Te(new ce),snippetSuggestions:Te(new P(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[o.localize(245,null),o.localize(246,null),o.localize(247,null),o.localize(248,null)],description:o.localize(249,null)})),smartSelect:Te(new Ie),smoothScrolling:Te(new y(103,"smoothScrolling",!1,{description:o.localize(250,null)})),stopRenderingLineAfter:Te(new d(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Te(new ve),inlineSuggest:Te(new O),suggestFontSize:Te(new d(107,"suggestFontSize",0,0,1e3,{markdownDescription:o.localize(251,null)})),suggestLineHeight:Te(new d(108,"suggestLineHeight",0,0,1e3,{markdownDescription:o.localize(252,null)})),suggestOnTriggerCharacters:Te(new y(109,"suggestOnTriggerCharacters",!0,{description:o.localize(253,null)})),suggestSelection:Te(new P(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[o.localize(254,null),o.localize(255,null),o.localize(256,null)],description:o.localize(257,null)})),tabCompletion:Te(new P(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[o.localize(258,null),o.localize(259,null),o.localize(260,null)],description:o.localize(261,null)})),tabIndex:Te(new d(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:Te(new D),unusualLineTerminators:Te(new P(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[o.localize(262,null),o.localize(263,null),o.localize(264,null)],description:o.localize(265,null)})),useShadowDOM:Te(new y(115,"useShadowDOM",!0)),useTabStops:Te(new y(116,"useTabStops",!0,{description:o.localize(266,null)})),wordSeparators:Te(new b(117,"wordSeparators",w.USUAL_WORD_SEPARATORS,{description:o.localize(267,null)})),wordWrap:Te(new P(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[o.localize(268,null),o.localize(269,null),o.localize(270,null),o.localize(271,null)],description:o.localize(272,null)})),wordWrapBreakAfterCharacters:Te(new b(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Te(new b(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Te(new d(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:o.localize(273,null)})),wordWrapOverride1:Te(new P(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Te(new P(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Te(new u(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],ze,{enumDescriptions:[o.localize(274,null),o.localize(275,null),o.localize(276,null),o.localize(277,null)],description:o.localize(278,null)})),wrappingStrategy:Te(new P(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[o.localize(279,null),o.localize(280,null)],description:o.localize(281,null)})),editorClassName:Te(new R),pixelRatio:Te(new ke),tabFocusMode:Te(new Me),layoutInfo:Te(new ae),wrappingInfo:Te(new xe)}}),define(Ee[117],be([18,19]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ee[118],be([18,19]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ee[119],be([18,19]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(Ee[120],be([18,19]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(Ee[121],be([18,19]),function(Y,e){return Y.create("vs/platform/workspace/common/workspace",e)}),define(Ee[122],be([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ee[123],be([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ee[124],be([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(Ee[125],be([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ee[126],be([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ee[127],be([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ee[128],be([18,19]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ee[129],be([18,19]),function(Y,e){return Y.create("vs/workbench/common/editor",e)}),define(Ee[130],be([18,19]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ee[131],be([18,19]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ee[132],be([18,19]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(Ee[133],be([18,19]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ee[134],be([18,19]),function(Y,e){return Y.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ee[135],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var o;(function(A){A[A.ACTIVATE=1]="ACTIVATE",A[A.RESTORE=2]="RESTORE",A[A.PRESERVE=3]="PRESERVE"})(o=e.EditorActivation||(e.EditorActivation={}));var I;(function(A){A[A.PICK=0]="PICK",A[A.DISABLED=1]="DISABLED",A[A.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(I=e.EditorResolution||(e.EditorResolution={}));var w;(function(A){A[A.API=0]="API",A[A.USER=1]="USER"})(w=e.EditorOpenSource||(e.EditorOpenSource={}));var B;(function(A){A[A.Center=0]="Center",A[A.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",A[A.NearTop=2]="NearTop",A[A.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(B=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var S;(function(A){A.PROGRAMMATIC="api",A.NAVIGATION="code.navigation",A.JUMP="code.jump"})(S=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),define(Ee[136],be([1,0,118]),function(Y,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function B(c){return c=c.trim(),c==="*"||I.test(c)}e.isValidVersionStr=B;function S(c){if(!B(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let g=c.match(I);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=S;function A(c){if(!c)return null;let g=c.majorBase,r=c.majorMustEqual,n=c.minorBase,m=c.minorMustEqual,y=c.patchBase,k=c.patchMustEqual;c.hasCaret&&(g===0||(m=!1),k=!1);let d=0;if(c.preRelease){const f=w.exec(c.preRelease);if(f){const[,b,l,P]=f;d=Date.UTC(Number(b),Number(l)-1,Number(P))}}return{majorBase:g,majorMustEqual:r,minorBase:n,minorMustEqual:m,patchBase:y,patchMustEqual:k,isMinimum:c.hasGreaterEquals,notBefore:d}}e.normalizeVersion=A;function C(c,g,r){let n;typeof c=="string"?n=A(S(c)):n=c;let m;g instanceof Date?m=g.getTime():typeof g=="string"&&(m=new Date(g).getTime());let y;if(typeof r=="string"?y=A(S(r)):y=r,!n||!y)return!1;let k=n.majorBase,d=n.minorBase,f=n.patchBase,b=y.majorBase,l=y.minorBase,P=y.patchBase,u=y.notBefore,i=y.majorMustEqual,s=y.minorMustEqual,t=y.patchMustEqual;return y.isMinimum?k>b?!0:k<b?!1:d>l?!0:d<l||m&&m<u?!1:f>=P:(k===1&&b===0&&(!i||!s||!t)&&(b=1,l=0,P=0,i=!0,s=!1,t=!1),k<b?!1:k>b?!i:d<l?!1:d>l?!s:f<P?!1:f>P?!t:!(m&&m<u))}e.isValidVersion=C;function L(c,g,r,n){return r.isBuiltin||typeof r.main=="undefined"?!0:v(c,g,r.engines.vscode,n)}e.isValidExtensionVersion=L;function M(c,g,r){return c==="*"||v(g,r,c)}e.isEngineValid=M;function v(c,g,r,n=[]){let m=A(S(r));if(!m)return n.push(o.localize(0,null,r)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return n.push(o.localize(1,null,r)),!1}else if(!m.majorMustEqual)return n.push(o.localize(2,null,r)),!1;return C(c,g,m)?!0:(n.push(o.localize(3,null,c,r)),!1)}}),define(Ee[76],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class o{constructor(w,B=[],S=!1){this.ctor=w,this.staticArguments=B,this.supportsDelayedInstantiation=S}}e.SyncDescriptor=o}),define(Ee[55],be([1,0,76]),function(Y,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const I=[];function w(S,A,C){A instanceof o.SyncDescriptor||(A=new o.SyncDescriptor(A,[],C)),I.push([S,A])}e.registerSingleton=w;function B(){return I}e.getSingletonServiceDescriptors=B}),define(Ee[137],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class o{constructor(B){this.incoming=new Map,this.outgoing=new Map,this.data=B}}e.Node=o;class I{constructor(B){this._hashFn=B,this._nodes=new Map}roots(){const B=[];for(let S of this._nodes.values())S.outgoing.size===0&&B.push(S);return B}insertEdge(B,S){const A=this.lookupOrInsertNode(B),C=this.lookupOrInsertNode(S);A.outgoing.set(this._hashFn(S),C),C.incoming.set(this._hashFn(B),A)}removeNode(B){const S=this._hashFn(B);this._nodes.delete(S);for(let A of this._nodes.values())A.outgoing.delete(S),A.incoming.delete(S)}lookupOrInsertNode(B){const S=this._hashFn(B);let A=this._nodes.get(S);return A||(A=new o(B),this._nodes.set(S,A)),A}lookup(B){return this._nodes.get(this._hashFn(B))}isEmpty(){return this._nodes.size===0}toString(){let B=[];for(let[S,A]of this._nodes)B.push(`${S}, (incoming)[${[...A.incoming.keys()].join(", ")}], (outgoing)[${[...A.outgoing.keys()].join(",")}]`);return B.join(`
`)}findCycleSlow(){for(let[B,S]of this._nodes){const A=new Set([B]),C=this._findCycle(S,A);if(C)return C}}_findCycle(B,S){for(let[A,C]of B.outgoing){if(S.has(A))return[...S,A].join(" -> ");S.add(A);const L=this._findCycle(C,S);if(L)return L;S.delete(A)}}}e.Graph=I}),define(Ee[3],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var o;(function(S){S.serviceIds=new Map,S.DI_TARGET="$di$target",S.DI_DEPENDENCIES="$di$dependencies";function A(C){return C[S.DI_DEPENDENCIES]||[]}S.getServiceDependencies=A})(o=e._util||(e._util={})),e.IInstantiationService=w("instantiationService");function I(S,A,C){A[o.DI_TARGET]===A?A[o.DI_DEPENDENCIES].push({id:S,index:C}):(A[o.DI_DEPENDENCIES]=[{id:S,index:C}],A[o.DI_TARGET]=A)}function w(S){if(o.serviceIds.has(S))return o.serviceIds.get(S);const A=function(C,L,M){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");I(A,C,M)};return A.toString=()=>S,o.serviceIds.set(S,A),A}e.createDecorator=w;function B(S){return S}e.refineServiceDecorator=B}),define(Ee[77],be([1,0,11,2,3]),function(Y,e,o,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,w.createDecorator)("configurationService");function B(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof I.URI)}e.isConfigurationOverrides=B;function S(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||o.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof I.URI)}e.isConfigurationUpdateOverrides=S;var A;(function(m){m[m.USER=1]="USER",m[m.USER_LOCAL=2]="USER_LOCAL",m[m.USER_REMOTE=3]="USER_REMOTE",m[m.WORKSPACE=4]="WORKSPACE",m[m.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",m[m.DEFAULT=6]="DEFAULT",m[m.MEMORY=7]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function C(m){switch(m){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=C;function L(m,y){const k=Object.create(null);for(let d in m)M(k,d,m[d],y);return k}e.toValuesTree=L;function M(m,y,k,d){const f=y.split("."),b=f.pop();let l=m;for(let P=0;P<f.length;P++){let u=f[P],i=l[u];switch(typeof i){case"undefined":i=l[u]=Object.create(null);break;case"object":break;default:d(`Ignoring ${y} as ${f.slice(0,P+1).join(".")} is ${JSON.stringify(i)}`);return}l=i}if(typeof l=="object"&&l!==null)try{l[b]=k}catch{d(`Ignoring ${y} as ${f.join(".")} is ${JSON.stringify(l)}`)}else d(`Ignoring ${y} as ${f.join(".")} is ${JSON.stringify(l)}`)}e.addToValueTree=M;function v(m,y){const k=y.split(".");c(m,k)}e.removeFromValueTree=v;function c(m,y){const k=y.shift();if(y.length===0){delete m[k];return}if(Object.keys(m).indexOf(k)!==-1){const d=m[k];typeof d=="object"&&!Array.isArray(d)&&(c(d,y),Object.keys(d).length===0&&delete m[k])}}function g(m,y,k){function d(l,P){let u=l;for(const i of P){if(typeof u!="object"||u===null)return;u=u[i]}return u}const f=y.split("."),b=d(m,f);return typeof b=="undefined"?k:b}e.getConfigurationValue=g;function r(m,y,k){Object.keys(y).forEach(d=>{d!=="__proto__"&&(d in m?o.isObject(m[d])&&o.isObject(y[d])?r(m[d],y[d],k):k&&(m[d]=y[d]):m[d]=y[d])})}e.merge=r;function n(m,y,k){const d=m.inspect(y),f=m.inspect(k);return typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:d.defaultValue}e.getMigratedSettingValue=n}),define(Ee[44],be([1,0,23,10,3]),function(Y,e,o,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const B=new Map;B.set("false",!1),B.set("true",!0),B.set("isMac",o.isMacintosh),B.set("isLinux",o.isLinux),B.set("isWindows",o.isWindows),B.set("isWeb",o.isWeb),B.set("isMacNative",o.isMacintosh&&!o.isWeb),B.set("isEdge",o.isEdge),B.set("isFirefox",o.isFirefox),B.set("isChrome",o.isChrome),B.set("isSafari",o.isSafari);const S=Object.prototype.hasOwnProperty;var A;(function(W){W[W.False=0]="False",W[W.True=1]="True",W[W.Defined=2]="Defined",W[W.Not=3]="Not",W[W.Equals=4]="Equals",W[W.NotEquals=5]="NotEquals",W[W.And=6]="And",W[W.Regex=7]="Regex",W[W.NotRegex=8]="NotRegex",W[W.Or=9]="Or",W[W.In=10]="In",W[W.NotIn=11]="NotIn",W[W.Greater=12]="Greater",W[W.GreaterEquals=13]="GreaterEquals",W[W.Smaller=14]="Smaller",W[W.SmallerEquals=15]="SmallerEquals"})(A=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return v.INSTANCE}static true(){return c.INSTANCE}static has(E){return g.create(E)}static equals(E,H){return r.create(E,H)}static notEquals(E,H){return y.create(E,H)}static regex(E,H){return u.create(E,H)}static in(E,H){return n.create(E,H)}static not(E){return k.create(E)}static and(...E){return t.create(E,null)}static or(...E){return a.create(E,null,!0)}static greater(E,H){return f.create(E,H)}static greaterEquals(E,H){return b.create(E,H)}static smaller(E,H){return l.create(E,H)}static smallerEquals(E,H){return P.create(E,H)}static deserialize(E,H=!1){if(!!E)return this._deserializeOrExpression(E,H)}static _deserializeOrExpression(E,H){let q=E.split("||");return a.create(q.map($=>this._deserializeAndExpression($,H)),null,!0)}static _deserializeAndExpression(E,H){let q=E.split("&&");return t.create(q.map($=>this._deserializeOne($,H)),null)}static _deserializeOne(E,H){if(E=E.trim(),E.indexOf("!=")>=0){let q=E.split("!=");return y.create(q[0].trim(),this._deserializeValue(q[1],H))}if(E.indexOf("==")>=0){let q=E.split("==");return r.create(q[0].trim(),this._deserializeValue(q[1],H))}if(E.indexOf("=~")>=0){let q=E.split("=~");return u.create(q[0].trim(),this._deserializeRegexValue(q[1],H))}if(E.indexOf(" in ")>=0){let q=E.split(" in ");return n.create(q[0].trim(),q[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(E)){const q=E.split(">=");return b.create(q[0].trim(),q[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(E)){const q=E.split(">");return f.create(q[0].trim(),q[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(E)){const q=E.split("<=");return P.create(q[0].trim(),q[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(E)){const q=E.split("<");return l.create(q[0].trim(),q[1].trim())}return/^\!\s*/.test(E)?k.create(E.substr(1).trim()):g.create(E)}static _deserializeValue(E,H){if(E=E.trim(),E==="true")return!0;if(E==="false")return!1;let q=/^'([^']*)'$/.exec(E);return q?q[1].trim():E}static _deserializeRegexValue(E,H){if((0,I.isFalsyOrWhitespace)(E)){if(H)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let q=E.indexOf("/"),$=E.lastIndexOf("/");if(q===$||q<0){if(H)throw new Error(`bad regexp-value '${E}', missing /-enclosure`);return console.warn(`bad regexp-value '${E}', missing /-enclosure`),null}let j=E.slice(q+1,$),J=E[$+1]==="i"?"i":"";try{return new RegExp(j,J)}catch(z){if(H)throw new Error(`bad regexp-value '${E}', parse error: ${z}`);return console.warn(`bad regexp-value '${E}', parse error: ${z}`),null}}}e.ContextKeyExpr=C;function L(W,E){const H=W?W.substituteConstants():void 0,q=E?E.substituteConstants():void 0;return!H&&!q?!0:!H||!q?!1:H.equals(q)}e.expressionsAreEqualWithConstantSubstitution=L;function M(W,E){return W.cmp(E)}class v{constructor(){this.type=0}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!1}serialize(){return"false"}keys(){return[]}map(E){return this}negate(){return c.INSTANCE}}e.ContextKeyFalseExpr=v,v.INSTANCE=new v;class c{constructor(){this.type=1}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!0}serialize(){return"true"}keys(){return[]}map(E){return this}negate(){return v.INSTANCE}}e.ContextKeyTrueExpr=c,c.INSTANCE=new c;class g{constructor(E,H){this.key=E,this.negated=H,this.type=2}static create(E,H=null){const q=B.get(E);return typeof q=="boolean"?q?c.INSTANCE:v.INSTANCE:new g(E,H)}cmp(E){return E.type!==this.type?this.type-E.type:h(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}substituteConstants(){const E=B.get(this.key);return typeof E=="boolean"?E?c.INSTANCE:v.INSTANCE:this}evaluate(E){return!!E.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(E){return E.mapDefined(this.key)}negate(){return this.negated||(this.negated=k.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=g;class r{constructor(E,H,q){this.key=E,this.value=H,this.negated=q,this.type=4}static create(E,H,q=null){if(typeof H=="boolean")return H?g.create(E,q):k.create(E,q);const $=B.get(E);return typeof $=="boolean"?H===($?"true":"false")?c.INSTANCE:v.INSTANCE:new r(E,H,q)}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){const E=B.get(this.key);if(typeof E=="boolean"){const H=E?"true":"false";return this.value===H?c.INSTANCE:v.INSTANCE}return this}evaluate(E){return E.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(E){return E.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=r;class n{constructor(E,H){this.key=E,this.valueKey=H,this.type=10,this.negated=null}static create(E,H){return new n(E,H)}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.valueKey,E.key,E.valueKey)}equals(E){return E.type===this.type?this.key===E.key&&this.valueKey===E.valueKey:!1}substituteConstants(){return this}evaluate(E){const H=E.getValue(this.valueKey),q=E.getValue(this.key);return Array.isArray(H)?H.indexOf(q)>=0:typeof q=="string"&&typeof H=="object"&&H!==null?S.call(H,q):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(E){return E.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=m.create(this)),this.negated}}e.ContextKeyInExpr=n;class m{constructor(E){this._actual=E,this.type=11}static create(E){return new m(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}substituteConstants(){return this}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new m(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotInExpr=m;class y{constructor(E,H,q){this.key=E,this.value=H,this.negated=q,this.type=5}static create(E,H,q=null){if(typeof H=="boolean")return H?k.create(E,q):g.create(E,q);const $=B.get(E);return typeof $=="boolean"?H===($?"true":"false")?v.INSTANCE:c.INSTANCE:new y(E,H,q)}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){const E=B.get(this.key);if(typeof E=="boolean"){const H=E?"true":"false";return this.value===H?v.INSTANCE:c.INSTANCE}return this}evaluate(E){return E.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(E){return E.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=y;class k{constructor(E,H){this.key=E,this.negated=H,this.type=3}static create(E,H=null){const q=B.get(E);return typeof q=="boolean"?q?v.INSTANCE:c.INSTANCE:new k(E,H)}cmp(E){return E.type!==this.type?this.type-E.type:h(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}substituteConstants(){const E=B.get(this.key);return typeof E=="boolean"?E?v.INSTANCE:c.INSTANCE:this}evaluate(E){return!E.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(E){return E.mapNot(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=k;function d(W,E){if(typeof W=="string"){const H=parseFloat(W);isNaN(H)||(W=H)}return typeof W=="string"||typeof W=="number"?E(W):v.INSTANCE}class f{constructor(E,H,q){this.key=E,this.value=H,this.negated=q,this.type=12}static create(E,H,q=null){return d(H,$=>new f(E,$,q))}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=P.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=f;class b{constructor(E,H,q){this.key=E,this.value=H,this.negated=q,this.type=13}static create(E,H,q=null){return d(H,$=>new b(E,$,q))}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(E){return E.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=b;class l{constructor(E,H,q){this.key=E,this.value=H,this.negated=q,this.type=14}static create(E,H,q=null){return d(H,$=>new l(E,$,q))}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=l;class P{constructor(E,H,q){this.key=E,this.value=H,this.negated=q,this.type=15}static create(E,H,q=null){return d(H,$=>new P(E,$,q))}cmp(E){return E.type!==this.type?this.type-E.type:_(this.key,this.value,E.key,E.value)}equals(E){return E.type===this.type?this.key===E.key&&this.value===E.value:!1}substituteConstants(){return this}evaluate(E){return typeof this.value=="string"?!1:parseFloat(E.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(E){return E.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=P;class u{constructor(E,H){this.key=E,this.regexp=H,this.type=7,this.negated=null}static create(E,H){return new u(E,H)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.key<E.key)return-1;if(this.key>E.key)return 1;const H=this.regexp?this.regexp.source:"",q=E.regexp?E.regexp.source:"";return H<q?-1:H>q?1:0}equals(E){if(E.type===this.type){const H=this.regexp?this.regexp.source:"",q=E.regexp?E.regexp.source:"";return this.key===E.key&&H===q}return!1}substituteConstants(){return this}evaluate(E){let H=E.getValue(this.key);return this.regexp?this.regexp.test(H):!1}serialize(){const E=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${E}`}keys(){return[this.key]}map(E){return E.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=u;class i{constructor(E){this._actual=E,this.type=8}static create(E){return new i(E)}cmp(E){return E.type!==this.type?this.type-E.type:this._actual.cmp(E._actual)}equals(E){return E.type===this.type?this._actual.equals(E._actual):!1}substituteConstants(){return this}evaluate(E){return!this._actual.evaluate(E)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(E){return new i(this._actual.map(E))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function s(W){let E=null;for(let H=0,q=W.length;H<q;H++){const $=W[H].substituteConstants();if(W[H]!==$&&E===null){E=[];for(let j=0;j<H;j++)E[j]=W[j]}E!==null&&(E[H]=$)}return E===null?W:E}class t{constructor(E,H){this.expr=E,this.negated=H,this.type=6}static create(E,H){return t._normalizeArr(E,H)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let H=0,q=this.expr.length;H<q;H++){const $=M(this.expr[H],E.expr[H]);if($!==0)return $}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let H=0,q=this.expr.length;H<q;H++)if(!this.expr[H].equals(E.expr[H]))return!1;return!0}return!1}substituteConstants(){const E=s(this.expr);return E===this.expr?this:t.create(E,this.negated)}evaluate(E){for(let H=0,q=this.expr.length;H<q;H++)if(!this.expr[H].evaluate(E))return!1;return!0}static _normalizeArr(E,H){const q=[];let $=!1;for(const j of E)if(!!j){if(j.type===1){$=!0;continue}if(j.type===0)return v.INSTANCE;if(j.type===6){q.push(...j.expr);continue}q.push(j)}if(q.length===0&&$)return c.INSTANCE;if(q.length!==0){if(q.length===1)return q[0];q.sort(M);for(let j=1;j<q.length;j++)q[j-1].equals(q[j])&&(q.splice(j,1),j--);if(q.length===1)return q[0];for(;q.length>1;){const j=q[q.length-1];if(j.type!==9)break;q.pop();const J=q.pop(),z=q.length===0,ie=a.create(j.expr.map(ae=>t.create([ae,J],null)),null,z);ie&&(q.push(ie),q.sort(M))}return q.length===1?q[0]:new t(q,H)}}serialize(){return this.expr.map(E=>E.serialize()).join(" && ")}keys(){const E=[];for(let H of this.expr)E.push(...H.keys());return E}map(E){return new t(this.expr.map(H=>H.map(E)),null)}negate(){if(!this.negated){const E=[];for(let H of this.expr)E.push(H.negate());this.negated=a.create(E,this,!0)}return this.negated}}class a{constructor(E,H){this.expr=E,this.negated=H,this.type=9}static create(E,H,q){return a._normalizeArr(E,H,q)}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let H=0,q=this.expr.length;H<q;H++){const $=M(this.expr[H],E.expr[H]);if($!==0)return $}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let H=0,q=this.expr.length;H<q;H++)if(!this.expr[H].equals(E.expr[H]))return!1;return!0}return!1}substituteConstants(){const E=s(this.expr);return E===this.expr?this:a.create(E,this.negated,!1)}evaluate(E){for(let H=0,q=this.expr.length;H<q;H++)if(this.expr[H].evaluate(E))return!0;return!1}static _normalizeArr(E,H,q){let $=[],j=!1;if(E){for(let J=0,z=E.length;J<z;J++){const ie=E[J];if(!!ie){if(ie.type===0){j=!0;continue}if(ie.type===1)return c.INSTANCE;if(ie.type===9){$=$.concat(ie.expr);continue}$.push(ie)}}if($.length===0&&j)return v.INSTANCE;$.sort(M)}if($.length!==0){if($.length===1)return $[0];for(let J=1;J<$.length;J++)$[J-1].equals($[J])&&($.splice(J,1),J--);if($.length===1)return $[0];if(q){for(let J=0;J<$.length;J++)for(let z=J+1;z<$.length;z++)T($[J],$[z])&&($.splice(z,1),z--);if($.length===1)return $[0]}return new a($,H)}}serialize(){return this.expr.map(E=>E.serialize()).join(" || ")}keys(){const E=[];for(let H of this.expr)E.push(...H.keys());return E}map(E){return new a(this.expr.map(H=>H.map(E)),null)}negate(){if(!this.negated){let E=[];for(let H of this.expr)E.push(H.negate());for(;E.length>1;){const H=E.shift(),q=E.shift(),$=[];for(const J of R(H))for(const z of R(q))$.push(t.create([J,z],null));const j=E.length===0;E.unshift(a.create($,null,j))}this.negated=E[0]}return this.negated}}class p extends g{constructor(E,H,q){super(E,null);this._defaultValue=H,typeof q=="object"?p._info.push({...q,key:E}):q!==!0&&p._info.push({key:E,description:q,type:H!=null?typeof H:void 0})}static all(){return p._info.values()}bindTo(E){return E.createKey(this.key,this._defaultValue)}getValue(E){return E.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(E){return r.create(this.key,E)}notEqualsTo(E){return y.create(this.key,E)}}e.RawContextKey=p,p._info=[],e.IContextKeyService=(0,w.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function h(W,E){return W<E?-1:W>E?1:0}function _(W,E,H,q){return W<H?-1:W>H?1:E<q?-1:E>q?1:0}function T(W,E){if(E.type===6&&W.type!==9&&W.type!==6){for(const $ of E.expr)if(W.equals($))return!0}const H=W.negate(),q=R(H).concat(R(E));q.sort(M);for(let $=0;$<q.length;$++){const J=q[$].negate();for(let z=$+1;z<q.length;z++){const ie=q[z];if(J.equals(ie))return!0}}return!1}e.implies=T;function R(W){return W.type===9?W.expr:[W]}}),define(Ee[138],be([1,0,3]),function(Y,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,o.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,o.refineServiceDecorator)(e.IEnvironmentService)}),define(Ee[45],be([1,0,22,17,10,11,2,119,3]),function(Y,e,o,I,w,B,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function L(j){return j.create===!0}e.isFileOpenForWriteOptions=L;var M;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(M=e.FileType||(e.FileType={}));var v;(function(j){j[j.Readonly=1]="Readonly"})(v=e.FilePermission||(e.FilePermission={}));var c;(function(j){j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock",j[j.FileAtomicRead=16384]="FileAtomicRead"})(c=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=g;function r(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=r;function n(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=n;function m(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=m;function y(j){return g(j)?!!(j.capabilities&16384):!1}e.hasFileAtomicReadCapability=y;var k;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(k=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class d extends Error{constructor(J,z){super(J);this.code=z}}e.FileSystemProviderError=d;function f(j,J){const z=new d(j.toString(),J);return l(z,J),z}e.createFileSystemProviderError=f;function b(j){return j||f((0,A.localize)(0,null),k.Unknown)}e.ensureFileSystemProviderError=b;function l(j,J){return j.name=J?`${J} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=l;function P(j){if(!j)return k.Unknown;if(j instanceof d)return j.code;const J=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!J)return k.Unknown;switch(J[1]){case k.FileExists:return k.FileExists;case k.FileIsADirectory:return k.FileIsADirectory;case k.FileNotADirectory:return k.FileNotADirectory;case k.FileNotFound:return k.FileNotFound;case k.FileExceedsMemoryLimit:return k.FileExceedsMemoryLimit;case k.FileTooLarge:return k.FileTooLarge;case k.FileWriteLocked:return k.FileWriteLocked;case k.NoPermissions:return k.NoPermissions;case k.Unavailable:return k.Unavailable}return k.Unknown}e.toFileSystemProviderErrorCode=P;function u(j){if(j instanceof h)return j.fileOperationResult;switch(P(j)){case k.FileNotFound:return 1;case k.FileIsADirectory:return 0;case k.FileNotADirectory:return 10;case k.FileWriteLocked:return 5;case k.NoPermissions:return 6;case k.FileExists:return 4;case k.FileExceedsMemoryLimit:return 9;case k.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=u;var i;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY",j[j.WRITE=4]="WRITE"})(i=e.FileOperation||(e.FileOperation={}));class s{constructor(J,z,ie){this.resource=J,this.operation=z,this.target=ie}isOperation(J){return this.operation===J}}e.FileOperationEvent=s;var t;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(t=e.FileChangeType||(e.FileChangeType={}));class a{constructor(J,z){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=J;const ie=new Map;for(const ae of J){const te=ie.get(ae.type);switch(te?te.push([ae.resource,ae]):ie.set(ae.type,[[ae.resource,ae]]),ae.type){case 1:this.rawAdded.push(ae.resource);break;case 0:this.rawUpdated.push(ae.resource);break;case 2:this.rawDeleted.push(ae.resource);break}}for(const[ae,te]of ie)switch(ae){case 1:this.added=o.TernarySearchTree.forUris(()=>z),this.added.fill(te);break;case 0:this.updated=o.TernarySearchTree.forUris(()=>z),this.updated.fill(te);break;case 2:this.deleted=o.TernarySearchTree.forUris(()=>z),this.deleted.fill(te);break}}contains(J,...z){return this.doContains(J,{includeChildren:!1},...z)}affects(J,...z){return this.doContains(J,{includeChildren:!0},...z)}doContains(J,z,...ie){if(!J)return!1;const ae=ie.length>0;return!!((!ae||ie.includes(1))&&(this.added?.get(J)||z.includeChildren&&this.added?.findSuperstr(J))||(!ae||ie.includes(0))&&(this.updated?.get(J)||z.includeChildren&&this.updated?.findSuperstr(J))||(!ae||ie.includes(2))&&(this.deleted?.findSubstr(J)||z.includeChildren&&this.deleted?.findSuperstr(J)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=a;function p(j,J,z){return!j||!J||j===J||J.length>j.length?!1:(J.charAt(J.length-1)!==I.sep&&(J+=I.sep),z?(0,w.startsWithIgnoreCase)(j,J):j.indexOf(J)===0)}e.isParent=p;class h extends Error{constructor(J,z,ie){super(J);this.fileOperationResult=z,this.options=ie}}e.FileOperationError=h;class _ extends h{constructor(J,z,ie){super(J,2,ie);this.stat=z}}e.NotModifiedSinceFileOperationError=_;var T;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(T=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var R;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(R=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function W(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=W;async function E(j,J){if(!J.hasProvider(S.URI.from({scheme:j.scheme})))return new Promise(z=>{const ie=J.onDidChangeFileSystemProviderRegistrations(ae=>{ae.scheme===j.scheme&&ae.added&&(ie.dispose(),z())})})}e.whenProviderRegistered=E,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class H{static formatSize(J){return(0,B.isNumber)(J)||(J=0),J<H.KB?(0,A.localize)(1,null,J.toFixed(0)):J<H.MB?(0,A.localize)(2,null,(J/H.KB).toFixed(2)):J<H.GB?(0,A.localize)(3,null,(J/H.MB).toFixed(2)):J<H.TB?(0,A.localize)(4,null,(J/H.GB).toFixed(2)):(0,A.localize)(5,null,(J/H.TB).toFixed(2))}}e.ByteSize=H,H.KB=1024,H.MB=H.KB*H.KB,H.GB=H.MB*H.KB,H.TB=H.GB*H.KB;var q;(function(j){j[j.IA32=0]="IA32",j[j.OTHER=1]="OTHER"})(q=e.Arch||(e.Arch={}));function $(j){return{maxFileSize:j===0?300*H.MB:16*H.GB,maxHeapSize:j===0?700*H.MB:2*700*H.MB}}e.getPlatformLimits=$}),define(Ee[56],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class o{constructor(...w){this._entries=new Map;for(let[B,S]of w)this.set(B,S)}set(w,B){const S=this._entries.get(w);return this._entries.set(w,B),S}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}e.ServiceCollection=o}),define(Ee[139],be([1,0,13,15,76,137,3,56]),function(Y,e,o,I,w,B,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const C=!1;class L extends Error{constructor(r){super("cyclic dependency between services");this.message=r.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class M{constructor(r=new A.ServiceCollection,n=!1,m){this._activeInstantiations=new Set,this._services=r,this._strict=n,this._parent=m,this._services.set(S.IInstantiationService,this)}createChild(r){return new M(r,this._strict,this)}invokeFunction(r,...n){let m=c.traceInvocation(r),y=!1;try{return r({get:d=>{if(y)throw(0,I.illegalState)("service accessor is only valid during the invocation of its target method");const f=this._getOrCreateServiceInstance(d,m);if(!f)throw new Error(`[invokeFunction] unknown service '${d}'`);return f}},...n)}finally{y=!0,m.stop()}}createInstance(r,...n){let m,y;return r instanceof w.SyncDescriptor?(m=c.traceCreation(r.ctor),y=this._createInstance(r.ctor,r.staticArguments.concat(n),m)):(m=c.traceCreation(r),y=this._createInstance(r,n,m)),m.stop(),y}_createInstance(r,n=[],m){let y=S._util.getServiceDependencies(r).sort((f,b)=>f.index-b.index),k=[];for(const f of y){let b=this._getOrCreateServiceInstance(f.id,m);b||this._throwIfStrict(`[createInstance] ${r.name} depends on UNKNOWN service ${f.id}.`,!1),k.push(b)}let d=y.length>0?y[0].index:n.length;if(n.length!==d){console.warn(`[createInstance] First service dependency of ${r.name} at position ${d+1} conflicts with ${n.length} static arguments`);let f=d-n.length;f>0?n=n.concat(new Array(f)):n=n.slice(0,d)}return new r(...[...n,...k])}_setServiceInstance(r,n){if(this._services.get(r)instanceof w.SyncDescriptor)this._services.set(r,n);else if(this._parent)this._parent._setServiceInstance(r,n);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(r){let n=this._services.get(r);return!n&&this._parent?this._parent._getServiceInstanceOrDescriptor(r):n}_getOrCreateServiceInstance(r,n){let m=this._getServiceInstanceOrDescriptor(r);return m instanceof w.SyncDescriptor?this._safeCreateAndCacheServiceInstance(r,m,n.branch(r,!0)):(n.branch(r,!1),m)}_safeCreateAndCacheServiceInstance(r,n,m){if(this._activeInstantiations.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this._activeInstantiations.add(r);try{return this._createAndCacheServiceInstance(r,n,m)}finally{this._activeInstantiations.delete(r)}}_createAndCacheServiceInstance(r,n,m){const y=new B.Graph(f=>f.id.toString());let k=0;const d=[{id:r,desc:n,_trace:m}];for(;d.length;){const f=d.pop();if(y.lookupOrInsertNode(f),k++>1e3)throw new L(y);for(let b of S._util.getServiceDependencies(f.desc.ctor)){let l=this._getServiceInstanceOrDescriptor(b.id);if(l||this._throwIfStrict(`[createInstance] ${r} depends on ${b.id} which is NOT registered.`,!0),l instanceof w.SyncDescriptor){const P={id:b.id,desc:l,_trace:f._trace.branch(b.id,!0)};y.insertEdge(f,P),d.push(P)}}}for(;;){const f=y.roots();if(f.length===0){if(!y.isEmpty())throw new L(y);break}for(const{data:b}of f){if(this._getServiceInstanceOrDescriptor(b.id)instanceof w.SyncDescriptor){const P=this._createServiceInstanceWithOwner(b.id,b.desc.ctor,b.desc.staticArguments,b.desc.supportsDelayedInstantiation,b._trace);this._setServiceInstance(b.id,P)}y.removeNode(b)}}return this._getServiceInstanceOrDescriptor(r)}_createServiceInstanceWithOwner(r,n,m=[],y,k){if(this._services.get(r)instanceof w.SyncDescriptor)return this._createServiceInstance(n,m,y,k);if(this._parent)return this._parent._createServiceInstanceWithOwner(r,n,m,y,k);throw new Error(`illegalState - creating UNKNOWN service instance ${n.name}`)}_createServiceInstance(r,n=[],m,y){if(m){const k=new o.IdleValue(()=>this._createInstance(r,n,y));return new Proxy(Object.create(null),{get(d,f){if(f in d)return d[f];let b=k.value,l=b[f];return typeof l!="function"||(l=l.bind(b),d[f]=l),l},set(d,f,b){return k.value[f]=b,!0}})}else return this._createInstance(r,n,y)}_throwIfStrict(r,n){if(n&&console.warn(n),this._strict)throw new Error(r)}}e.InstantiationService=M;var v;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(v||(v={}));class c{constructor(r,n){this.type=r,this.name=n,this._start=Date.now(),this._dep=[]}static traceInvocation(r){return C?new c(1,r.name||r.toString().substring(0,42).replace(/\n/g,"")):c._None}static traceCreation(r){return C?new c(0,r.name):c._None}branch(r,n){let m=new c(2,r.toString());return this._dep.push([r,n,m]),m}stop(){let r=Date.now()-this._start;c._totals+=r;let n=!1;function m(k,d){let f=[],b=new Array(k+1).join("	");for(const[l,P,u]of d._dep)if(P&&u){n=!0,f.push(`${b}CREATES -> ${l}`);let i=m(k+1,u);i&&f.push(i)}else f.push(`${b}uses -> ${l}`);return f.join(`
`)}let y=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${c._totals.toFixed(2)}ms)`];(r>2||n)&&console.log(y.join(`
`))}}e.Trace=c,c._None=new class extends c{constructor(){super(-1,null)}stop(){}branch(){return this}},c._totals=0}),define(Ee[12],be([1,0,43,5,6,23,3]),function(Y,e,o,I,w,B,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logCi=e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,S.createDecorator)("logService"),e.ILoggerService=(0,S.createDecorator)("loggerService");function A(){return new Date().toISOString()}var C;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function L(u,i,s){switch(i){case C.Trace:u.trace(s);break;case C.Debug:u.debug(s);break;case C.Info:u.info(s);break;case C.Warning:u.warn(s);break;case C.Error:u.error(s);break;case C.Critical:u.critical(s);break;default:throw new Error("Invalid log level")}}e.log=L;function M(u){let i="";for(let s=0;s<u.length;s++){let t=u[s];if(typeof t=="object")try{t=JSON.stringify(t)}catch{}i+=(s>0?" ":"")+t}return i}e.format=M;class v extends w.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=v;class c extends v{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...s){this.checkLogLevel(C.Trace)&&this.log(C.Trace,M([i,...s]))}debug(i,...s){this.checkLogLevel(C.Debug)&&this.log(C.Debug,M([i,...s]))}info(i,...s){this.checkLogLevel(C.Info)&&this.log(C.Info,M([i,...s]))}warn(i,...s){this.checkLogLevel(C.Warning)&&this.log(C.Warning,M([i,...s]))}error(i,...s){if(this.checkLogLevel(C.Error))if(i instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=i.stack,this.log(C.Error,M(t))}else this.log(C.Error,M([i,...s]))}critical(i,...s){this.checkLogLevel(C.Critical)&&this.log(C.Critical,M([i,...s]))}flush(){}}e.AbstractMessageLogger=c;class g extends v{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!B.isWindows}trace(i,...s){this.getLevel()<=C.Trace&&(this.useColors?console.log(`[90m[main ${A()}][0m`,i,...s):console.log(`[main ${A()}]`,i,...s))}debug(i,...s){this.getLevel()<=C.Debug&&(this.useColors?console.log(`[90m[main ${A()}][0m`,i,...s):console.log(`[main ${A()}]`,i,...s))}info(i,...s){this.getLevel()<=C.Info&&(this.useColors?console.log(`[90m[main ${A()}][0m`,i,...s):console.log(`[main ${A()}]`,i,...s))}warn(i,...s){this.getLevel()<=C.Warning&&(this.useColors?console.warn(`[93m[main ${A()}][0m`,i,...s):console.warn(`[main ${A()}]`,i,...s))}error(i,...s){this.getLevel()<=C.Error&&(this.useColors?console.error(`[91m[main ${A()}][0m`,i,...s):console.error(`[main ${A()}]`,i,...s))}critical(i,...s){this.getLevel()<=C.Critical&&(this.useColors?console.error(`[90m[main ${A()}][0m`,i,...s):console.error(`[main ${A()}]`,i,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class r extends v{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...s){this.getLevel()<=C.Trace&&console.log("%cTRACE","color: #888",i,...s)}debug(i,...s){this.getLevel()<=C.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...s)}info(i,...s){this.getLevel()<=C.Info&&console.log("%c INFO","color: #33f",i,...s)}warn(i,...s){this.getLevel()<=C.Warning&&console.log("%c WARN","color: #993",i,...s)}error(i,...s){this.getLevel()<=C.Error&&console.log("%c  ERR","color: #f33",i,...s)}critical(i,...s){this.getLevel()<=C.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...s)}dispose(){}flush(){}}e.ConsoleLogger=r;class n extends v{constructor(i,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(s)}trace(i,...s){this.getLevel()<=C.Trace&&this.adapter.log(C.Trace,[this.extractMessage(i),...s])}debug(i,...s){this.getLevel()<=C.Debug&&this.adapter.log(C.Debug,[this.extractMessage(i),...s])}info(i,...s){this.getLevel()<=C.Info&&this.adapter.log(C.Info,[this.extractMessage(i),...s])}warn(i,...s){this.getLevel()<=C.Warning&&this.adapter.log(C.Warning,[this.extractMessage(i),...s])}error(i,...s){this.getLevel()<=C.Error&&this.adapter.log(C.Error,[this.extractMessage(i),...s])}critical(i,...s){this.getLevel()<=C.Critical&&this.adapter.log(C.Critical,[this.extractMessage(i),...s])}extractMessage(i){return typeof i=="string"?i:(0,o.toErrorMessage)(i,this.getLevel()<=C.Trace)}dispose(){}flush(){}}e.AdapterLogger=n;class m extends v{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const s of this.logServices)s.setLevel(i);super.setLevel(i)}trace(i,...s){for(const t of this.logServices)t.trace(i,...s)}debug(i,...s){for(const t of this.logServices)t.debug(i,...s)}info(i,...s){for(const t of this.logServices)t.info(i,...s)}warn(i,...s){for(const t of this.logServices)t.warn(i,...s)}error(i,...s){for(const t of this.logServices)t.error(i,...s)}critical(i,...s){for(const t of this.logServices)t.critical(i,...s)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=m;class y extends w.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...s){this.logger.trace(i,...s)}debug(i,...s){this.logger.debug(i,...s)}info(i,...s){this.logger.info(i,...s)}warn(i,...s){this.logger.warn(i,...s)}error(i,...s){this.logger.error(i,...s)}critical(i,...s){this.logger.critical(i,...s)}flush(){this.logger.flush()}}e.LogService=y;class k extends w.Disposable{constructor(i,s){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(t=>{this.logLevel=t,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(t))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,s){let t=this.loggers.get(i.toString());return t||(t=this.doCreateLogger(i,s?.always?C.Trace:this.logLevel,s),this.loggers.set(i.toString(),t),s?.always||this.logLevelChangeableLoggers.push(t)),t}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=k;class d{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(i){}getLevel(){return C.Info}trace(i,...s){}debug(i,...s){}info(i,...s){}warn(i,...s){}error(i,...s){}critical(i,...s){}dispose(){}flush(){}}e.NullLogService=d;function f(u){if(u.verbose)return C.Trace;if(typeof u.logLevel=="string"){const i=b(u.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=f;function b(u){switch(u){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Critical;case"off":return C.Off}}e.parseLogLevel=b;function l(u){switch(u){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Critical:return"critical";case C.Off:return"off"}}e.LogLevelToString=l;function P(u,i,...s){B.isCI?u.info.call(u,i,...s):u.trace.call(u,i,...s)}e.logCi=P}),define(Ee[78],be([1,0,34,120,3]),function(Y,e,o,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var B;(function(C){C[C.Unnecessary=1]="Unnecessary",C[C.Deprecated=2]="Deprecated"})(B=e.MarkerTag||(e.MarkerTag={}));var S;(function(C){C[C.Hint=1]="Hint",C[C.Info=2]="Info",C[C.Warning=4]="Warning",C[C.Error=8]="Error"})(S=e.MarkerSeverity||(e.MarkerSeverity={})),function(C){function L(r,n){return n-r}C.compare=L;const M=Object.create(null);M[C.Error]=(0,I.localize)(0,null),M[C.Warning]=(0,I.localize)(1,null),M[C.Info]=(0,I.localize)(2,null);function v(r){return M[r]||""}C.toString=v;function c(r){switch(r){case o.default.Error:return C.Error;case o.default.Warning:return C.Warning;case o.default.Info:return C.Info;case o.default.Ignore:return C.Hint}}C.fromSeverity=c;function g(r){switch(r){case C.Error:return o.default.Error;case C.Warning:return o.default.Warning;case C.Info:return o.default.Info;case C.Hint:return o.default.Ignore}}C.toSeverity=g}(S=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(C){const L="";function M(c){return v(c,!0)}C.makeKey=M;function v(c,g){let r=[L];return c.source?r.push(c.source.replace("\xA6","\\\xA6")):r.push(L),c.code?typeof c.code=="string"?r.push(c.code.replace("\xA6","\\\xA6")):r.push(c.code.value.replace("\xA6","\\\xA6")):r.push(L),c.severity!==void 0&&c.severity!==null?r.push(S.toString(c.severity)):r.push(L),c.message&&g?r.push(c.message.replace("\xA6","\\\xA6")):r.push(L),c.startLineNumber!==void 0&&c.startLineNumber!==null?r.push(c.startLineNumber.toString()):r.push(L),c.startColumn!==void 0&&c.startColumn!==null?r.push(c.startColumn.toString()):r.push(L),c.endLineNumber!==void 0&&c.endLineNumber!==null?r.push(c.endLineNumber.toString()):r.push(L),c.endColumn!==void 0&&c.endColumn!==null?r.push(c.endColumn.toString()):r.push(L),r.push(L),r.join("\xA6")}C.makeKeyOptionalMessage=v})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,w.createDecorator)("markerService")}),define(Ee[140],be([1,0,5,34,3]),function(Y,e,o,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=I.default,e.INotificationService=(0,w.createDecorator)("notificationService");var B;(function(L){L[L.WORKSPACE=0]="WORKSPACE",L[L.GLOBAL=1]="GLOBAL"})(B=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var S;(function(L){L[L.OFF=0]="OFF",L[L.SILENT=1]="SILENT",L[L.ERROR=2]="ERROR"})(S=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new C,this.onDidClose=o.Event.None,this.onDidChangeVisibility=o.Event.None}updateSeverity(M){}updateMessage(M){}updateActions(M){}close(){}}e.NoOpNotification=A;class C{infinite(){}done(){}total(M){}worked(M){}}e.NoOpProgress=C}),define(Ee[79],be([1,0,6,10,2,3]),function(Y,e,o,I,w,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.selectionFragment=e.withSelectionFragment=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,B.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return o.Disposable.None},registerValidator(){return o.Disposable.None},registerExternalUriResolver(){return o.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return o.Disposable.None},async open(){return!1},async resolveExternalUri(M){return{resolved:M,dispose(){}}}});function S(M,v){return w.URI.isUri(M)?(0,I.equalsIgnoreCase)(M.scheme,v):(0,I.startsWithIgnoreCase)(M,v+":")}e.matchesScheme=S;function A(M,...v){return v.some(c=>S(M,c))}e.matchesSomeScheme=A;function C(M,v){return M.with({fragment:`${v.startLineNumber},${v.startColumn}${v.endLineNumber?`-${v.endLineNumber}${v.endColumn?`,${v.endColumn}`:""}`:""}`})}e.withSelectionFragment=C;function L(M){let v;const c=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(M.fragment);return c&&(v={startLineNumber:parseInt(c[1]),startColumn:c[2]?parseInt(c[2]):1,endLineNumber:c[4]?parseInt(c[4]):void 0,endColumn:c[4]?c[5]?parseInt(c[5]):1:void 0}),v}e.selectionFragment=L});var Fe=this&&this.__decorate||function(Y,e,o,I){var w=arguments.length,B=w<3?e:I===null?I=Object.getOwnPropertyDescriptor(e,o):I,S;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")B=Reflect.decorate(Y,e,o,I);else for(var A=Y.length-1;A>=0;A--)(S=Y[A])&&(B=(w<3?S(B):w>3?S(e,o,B):S(e,o))||B);return w>3&&B&&Object.defineProperty(e,o,B),B},Ne=this&&this.__param||function(Y,e){return function(o,I){e(o,I,Y)}};define(Ee[141],be([1,0,13,20,6,3]),function(Y,e,o,I,w,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,B.createDecorator)("progressService");var S;(function(M){M[M.Explorer=1]="Explorer",M[M.Scm=3]="Scm",M[M.Extensions=5]="Extensions",M[M.Window=10]="Window",M[M.Notification=15]="Notification",M[M.Dialog=20]="Dialog"})(S=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{constructor(v){this.callback=v}get value(){return this._value}report(v){this._value=v,this.callback(this._value)}}e.Progress=A,A.None=Object.freeze({report(){}});let C=class extends w.Disposable{constructor(v,c){super();this.deferred=new o.DeferredPromise,c.withProgress(v,g=>(this.reporter=g,this.lastStep&&g.report(this.lastStep),this.deferred.p)),this._register((0,w.toDisposable)(()=>this.deferred.complete()))}report(v){this.reporter?this.reporter.report(v):this.lastStep=v}};C=Fe([Ne(1,e.IProgressService)],C),e.UnmanagedProgress=C;class L extends w.Disposable{constructor(v){super();this.progressIndicator=v,this.currentOperationId=0,this.currentOperationDisposables=this._register(new w.DisposableStore)}start(v){this.stop();const c=++this.currentOperationId,g=new I.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{c===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},v),this.currentOperationDisposables.add((0,w.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,w.toDisposable)(()=>g.cancel())),this.currentOperationDisposables.add((0,w.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:c,token:g.token,stop:()=>this.doStop(c),isCurrent:()=>this.currentOperationId===c}}stop(){this.doStop(this.currentOperationId)}doStop(v){this.currentOperationId===v&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=L,e.IEditorProgressService=(0,B.createDecorator)("editorProgressService")}),define(Ee[37],be([1,0,42,11]),function(Y,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class w{constructor(){this.data=new Map}add(S,A){o.ok(I.isString(S)),o.ok(I.isObject(A)),o.ok(!this.data.has(S),"There is already an extension with this id"),this.data.set(S,A)}knows(S){return this.data.has(S)}as(S){return this.data.get(S)||null}}e.Registry=new w}),define(Ee[142],be([1,0,5,37]),function(Y,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function w(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class B{constructor(){this._onDidChangeSchema=new o.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(C,L){this.schemasById[w(C)]=L,this._onDidChangeSchema.fire(C)}notifySchemaChanged(C){this._onDidChangeSchema.fire(C)}getSchemaContributions(){return{schemas:this.schemasById}}}const S=new B;I.Registry.add(e.Extensions.JSONContribution,S)}),define(Ee[80],be([1,0,16,5,11,117,142,37]),function(Y,e,o,I,w,B,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var L;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const M=A.Registry.as(S.Extensions.JSONContribution);class v{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:B.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},M.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(b,l=!0){this.registerConfigurations([b],l)}registerConfigurations(b,l=!0){const P=this.doRegisterConfigurations(b,l);M.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:P})}deregisterConfigurations(b){const l=this.doDeregisterConfigurations(b);M.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}updateConfigurations({add:b,remove:l}){const P=[];P.push(...this.doDeregisterConfigurations(l)),P.push(...this.doRegisterConfigurations(b,!1)),M.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,o.distinct)(P)})}registerDefaultConfigurations(b){const l=[],P=[];for(const{overrides:u,source:i}of b)for(const s in u)if(l.push(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const t={...this.configurationDefaultsOverrides.get(s)?.value||{},...u[s]};this.configurationDefaultsOverrides.set(s,{source:i,value:t});const a={type:"object",default:t,description:B.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:t,source:w.isString(i)?void 0:i};P.push(...r(s)),this.configurationProperties[s]=a,this.defaultLanguageConfigurationOverridesNode.properties[s]=a}else{this.configurationDefaultsOverrides.set(s,{value:u[s],source:i});const t=this.configurationProperties[s];t&&(this.updatePropertyDefaultValue(s,t),this.updateSchema(s,t))}this.registerOverrideIdentifiers(P),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}deregisterDefaultConfigurations(b){const l=[];for(const{overrides:P,source:u}of b)for(const i in P){const s=this.configurationDefaultsOverrides.get(i),t=w.isString(u)?u:u?.id,a=w.isString(s?.source)?s?.source:s?.source?.id;if(t===a)if(l.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const p=this.configurationProperties[i];p&&(this.updatePropertyDefaultValue(i,p),this.updateSchema(i,p))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...b){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(b){for(const l of b)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(b,l){const P=[];return b.forEach(u=>{P.push(...this.validateAndRegisterProperties(u,l,u.extensionInfo,u.restrictedProperties)),this.configurationContributors.push(u),this.registerJSONConfiguration(u)}),P}doDeregisterConfigurations(b){const l=[],P=u=>{if(u.properties)for(const i in u.properties)l.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,u.properties[i]);u.allOf&&u.allOf.forEach(i=>P(i))};for(const u of b){P(u);const i=this.configurationContributors.indexOf(u);i!==-1&&this.configurationContributors.splice(i,1)}return l}validateAndRegisterProperties(b,l=!0,P,u,i=3){i=w.isUndefinedOrNull(b.scope)?i:b.scope;let s=[],t=b.properties;if(t)for(let p in t){if(l&&k(p)){delete t[p];continue}const h=t[p];if(h.source=P,h.defaultDefaultValue=t[p].default,this.updatePropertyDefaultValue(p,h),e.OVERRIDE_PROPERTY_REGEX.test(p)?h.scope=void 0:(h.scope=w.isUndefinedOrNull(h.scope)?i:h.scope,h.restricted=w.isUndefinedOrNull(h.restricted)?!!u?.includes(p):h.restricted),t[p].hasOwnProperty("included")&&!t[p].included){this.excludedConfigurationProperties[p]=t[p],delete t[p];continue}else this.configurationProperties[p]=t[p];!t[p].deprecationMessage&&t[p].markdownDeprecationMessage&&(t[p].deprecationMessage=t[p].markdownDeprecationMessage),s.push(p)}let a=b.allOf;if(a)for(let p of a)s.push(...this.validateAndRegisterProperties(p,l,P,u,i));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(b){const l=P=>{let u=P.properties;if(u)for(const s in u)this.updateSchema(s,u[s]);let i=P.allOf;i&&i.forEach(l)};l(b)}updateSchema(b,l){switch(e.allSettings.properties[b]=l,l.scope){case 1:e.applicationSettings.properties[b]=l;break;case 2:e.machineSettings.properties[b]=l;break;case 6:e.machineOverridableSettings.properties[b]=l;break;case 3:e.windowSettings.properties[b]=l;break;case 4:e.resourceSettings.properties[b]=l;break;case 5:e.resourceSettings.properties[b]=l,this.resourceLanguageSettingsSchema.properties[b]=l;break}}removeFromSchema(b,l){switch(delete e.allSettings.properties[b],l.scope){case 1:delete e.applicationSettings.properties[b];break;case 2:delete e.machineSettings.properties[b];break;case 6:delete e.machineOverridableSettings.properties[b];break;case 3:delete e.windowSettings.properties[b];break;case 4:case 5:delete e.resourceSettings.properties[b],delete this.resourceLanguageSettingsSchema.properties[b];break}}updateOverridePropertyPatternKey(){for(const b of this.overrideIdentifiers.values()){const l=`[${b}]`,P={type:"object",description:B.localize(2,null),errorMessage:B.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,P),e.allSettings.properties[l]=P,e.applicationSettings.properties[l]=P,e.machineSettings.properties[l]=P,e.machineOverridableSettings.properties[l]=P,e.windowSettings.properties[l]=P,e.resourceSettings.properties[l]=P}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const b={type:"object",description:B.localize(4,null),errorMessage:B.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=b,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=b,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=b,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=b,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=b,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=b,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(b,l){const P=this.configurationDefaultsOverrides.get(b);let u=P?.value,i=P?.source;w.isUndefined(u)&&(u=l.defaultDefaultValue,i=void 0),w.isUndefined(u)&&(u=m(l.type)),l.default=u,l.defaultValueSource=i}}const c="\\[([^\\]]+)\\]",g=new RegExp(c,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${c})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function r(f){const b=[];if(e.OVERRIDE_PROPERTY_REGEX.test(f)){let l=g.exec(f);for(;l?.length;){const P=l[1].trim();P&&b.push(P),l=g.exec(f)}}return(0,o.distinct)(b)}e.overrideIdentifiersFromKey=r;function n(f){return f.reduce((b,l)=>`${b}[${l}]`,"")}e.keyFromOverrideIdentifiers=n;function m(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const y=new v;A.Registry.add(e.Extensions.Configuration,y);function k(f){return f.trim()?e.OVERRIDE_PROPERTY_REGEX.test(f)?B.localize(7,null,f):y.getConfigurationProperties()[f]!==void 0?B.localize(8,null,f):null:B.localize(6,null)}e.validateProperty=k;function d(){const f=[],b=y.getConfigurationProperties();for(const l of Object.keys(b))f.push([l,b[l].scope]);return f.push(["launch",4]),f.push(["task",4]),f}e.getScopes=d}),define(Ee[143],be([1,0,16,5,100,6,22,26,11,2,77,80,37]),function(Y,e,o,I,w,B,S,A,C,L,M,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class g{constructor(u={},i=[],s=[]){this._contents=u,this._keys=i,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(u){return u?(0,M.getConfigurationValue)(this.contents,u):this.contents}getOverrideValue(u,i){const s=this.getContentsForOverrideIdentifer(i);return s?u?(0,M.getConfigurationValue)(s,u):s:void 0}getKeysForOverrideIdentifier(u){const i=[];for(const s of this.overrides)s.identifiers.includes(u)&&i.push(...s.keys);return o.distinct(i)}getAllOverrideIdentifiers(){const u=[];for(const i of this.overrides)u.push(...i.identifiers);return o.distinct(u)}override(u){let i=this.overrideConfigurations.get(u);return i||(i=this.createOverrideConfigurationModel(u),this.overrideConfigurations.set(u,i)),i}merge(...u){const i=A.deepClone(this.contents),s=A.deepClone(this.overrides),t=[...this.keys];for(const a of u){this.mergeContents(i,a.contents);for(const p of a.overrides){const[h]=s.filter(_=>o.equals(_.identifiers,p.identifiers));h?(this.mergeContents(h.contents,p.contents),h.keys.push(...p.keys),h.keys=o.distinct(h.keys)):s.push(A.deepClone(p))}for(const p of a.keys)t.indexOf(p)===-1&&t.push(p)}return new g(i,t,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(u){const i=this.getContentsForOverrideIdentifer(u);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let s={};for(const t of o.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[t],p=i[t];p&&(typeof a=="object"&&typeof p=="object"?(a=A.deepClone(a),this.mergeContents(a,p)):a=p),s[t]=a}return new g(s,this.keys,this.overrides)}mergeContents(u,i){for(const s of Object.keys(i)){if(s in u&&C.isObject(u[s])&&C.isObject(i[s])){this.mergeContents(u[s],i[s]);continue}u[s]=A.deepClone(i[s])}}checkAndFreeze(u){return this.isFrozen&&!Object.isFrozen(u)?A.deepFreeze(u):u}getContentsForOverrideIdentifer(u){let i=null,s=null;const t=a=>{a&&(s?this.mergeContents(s,a):s=A.deepClone(a))};for(const a of this.overrides)o.equals(a.identifiers,[u])?i=a.contents:a.identifiers.includes(u)&&t(a.contents);return t(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(u,i){this.addKey(u),(0,M.addToValueTree)(this.contents,u,i,s=>{throw new Error(s)})}removeValue(u){this.removeKey(u)&&(0,M.removeFromValueTree)(this.contents,u)}addKey(u){let i=this.keys.length;for(let s=0;s<i;s++)u.indexOf(this.keys[s])===0&&(i=s);this.keys.splice(i,1,u)}removeKey(u){let i=this.keys.indexOf(u);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=g;class r extends g{constructor(u={}){const i=c.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(i),t=Object.create(null),a=[];for(const p in i){const h=u[p],_=h!==void 0?h:i[p].default;(0,M.addToValueTree)(t,p,_,T=>console.error(`Conflict in default settings: ${T}`))}for(const p of Object.keys(t))v.OVERRIDE_PROPERTY_REGEX.test(p)&&a.push({identifiers:(0,v.overrideIdentifiersFromKey)(p),keys:Object.keys(t[p]),contents:(0,M.toValuesTree)(t[p],h=>console.error(`Conflict in default settings file: ${h}`))});super(t,s,a)}}e.DefaultConfigurationModel=r;class n{constructor(u){this._name=u,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(u,i){if(!C.isUndefinedOrNull(u)){const s=this.doParseContent(u);this.parseRaw(s,i)}}reparse(u){this._raw&&this.parseRaw(this._raw,u)}parseRaw(u,i){this._raw=u;const{contents:s,keys:t,overrides:a,restricted:p}=this.doParseRaw(u,i);this._configurationModel=new g(s,t,a),this._restrictedConfigurations=p||[]}doParseContent(u){let i={},s=null,t=[],a=[],p=[];function h(T){Array.isArray(t)?t.push(T):s!==null&&(t[s]=T)}let _={onObjectBegin:()=>{let T={};h(T),a.push(t),t=T,s=null},onObjectProperty:T=>{s=T},onObjectEnd:()=>{t=a.pop()},onArrayBegin:()=>{let T=[];h(T),a.push(t),t=T,s=null},onArrayEnd:()=>{t=a.pop()},onLiteralValue:h,onError:(T,R,W)=>{p.push({error:T,offset:R,length:W})}};if(u)try{w.visit(u,_),i=t[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return i}doParseRaw(u,i){const s=c.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),t=this.filter(u,s,!0,i);u=t.raw;const a=(0,M.toValuesTree)(u,_=>console.error(`Conflict in settings file ${this._name}: ${_}`)),p=Object.keys(u),h=this.toOverrides(u,_=>console.error(`Conflict in settings file ${this._name}: ${_}`));return{contents:a,keys:p,overrides:h,restricted:t.restricted}}filter(u,i,s,t){if(!t?.scopes&&!t?.skipRestricted)return{raw:u,restricted:[]};const a={},p=[];for(let h in u)if(v.OVERRIDE_PROPERTY_REGEX.test(h)&&s){const _=this.filter(u[h],i,!1,t);a[h]=_.raw,p.push(..._.restricted)}else{const _=i[h],T=_?typeof _.scope!="undefined"?_.scope:3:void 0;_?.restricted&&p.push(h),(T===void 0||t.scopes===void 0||t.scopes.includes(T))&&(t.skipRestricted&&_?.restricted||(a[h]=u[h]))}return{raw:a,restricted:p}}toOverrides(u,i){const s=[];for(const t of Object.keys(u))if(v.OVERRIDE_PROPERTY_REGEX.test(t)){const a={};for(const p in u[t])a[p]=u[t][p];s.push({identifiers:(0,v.overrideIdentifiersFromKey)(t),keys:Object.keys(a),contents:(0,M.toValuesTree)(a,i)})}return s}}e.ConfigurationModelParser=n;class m extends B.Disposable{constructor(u,i,s,t){super();this.userSettingsResource=u,this.scopes=i,this.fileService=t,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new n(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(I.Event.any(I.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),I.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(1)||a.isOperation(4))&&s.isEqual(a.resource,u)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const u=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(u.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=m;class y{constructor(u,i,s=new g,t=new g,a=new S.ResourceMap,p=new g,h=new S.ResourceMap,_=!0){this._defaultConfiguration=u,this._localUserConfiguration=i,this._remoteUserConfiguration=s,this._workspaceConfiguration=t,this._folderConfigurations=a,this._memoryConfiguration=p,this._memoryConfigurationByResource=h,this._freeze=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new S.ResourceMap,this._userConfiguration=null}getValue(u,i,s){return this.getConsolidateConfigurationModel(i,s).getValue(u)}updateValue(u,i,s={}){let t;s.resource?(t=this._memoryConfigurationByResource.get(s.resource),t||(t=new g,this._memoryConfigurationByResource.set(s.resource,t))):t=this._memoryConfiguration,i===void 0?t.removeValue(u):t.setValue(u,i),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(u,i,s){const t=this.getConsolidateConfigurationModel(i,s),a=this.getFolderConfigurationModelForResource(i.resource,s),p=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,h=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(u):this._defaultConfiguration.freeze().getValue(u),_=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(u):this.userConfiguration.freeze().getValue(u),T=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(u):this.localUserConfiguration.freeze().getValue(u),R=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(u):this.remoteUserConfiguration.freeze().getValue(u),W=s?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(u):this._workspaceConfiguration.freeze().getValue(u):void 0,E=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(u):a.freeze().getValue(u):void 0,H=i.overrideIdentifier?p.override(i.overrideIdentifier).getValue(u):p.getValue(u),q=t.getValue(u),$=o.distinct(o.flatten(t.overrides.map(j=>j.identifiers))).filter(j=>t.getOverrideValue(u,j)!==void 0);return{defaultValue:h,userValue:_,userLocalValue:T,userRemoteValue:R,workspaceValue:W,workspaceFolderValue:E,memoryValue:H,value:q,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(u),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(u,i.overrideIdentifier):void 0}:void 0,user:_!==void 0?{value:this.userConfiguration.freeze().getValue(u),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(u,i.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(u),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(u,i.overrideIdentifier):void 0}:void 0,userRemote:R!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(u),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(u,i.overrideIdentifier):void 0}:void 0,workspace:W!==void 0?{value:this._workspaceConfiguration.freeze().getValue(u),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(u,i.overrideIdentifier):void 0}:void 0,workspaceFolder:E!==void 0?{value:a?.freeze().getValue(u),override:i.overrideIdentifier?a?.freeze().getOverrideValue(u,i.overrideIdentifier):void 0}:void 0,memory:H!==void 0?{value:p.getValue(u),override:i.overrideIdentifier?p.getOverrideValue(u,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:$.length?$:void 0}}keys(u){const i=this.getFolderConfigurationModelForResource(void 0,u);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(u){this._defaultConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(u){this._localUserConfiguration=u,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(u){this._remoteUserConfiguration=u,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(u){this._workspaceConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(u,i){this._folderConfigurations.set(u,i),this._foldersConsolidatedConfigurations.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this._foldersConsolidatedConfigurations.delete(u)}compareAndUpdateDefaultConfiguration(u,i){const s=[];if(!i){const{added:t,updated:a,removed:p}=b(this._defaultConfiguration,u);i=[...t,...a,...p]}for(const t of i)for(const a of(0,v.overrideIdentifiersFromKey)(t)){const p=this._defaultConfiguration.getKeysForOverrideIdentifier(a),h=u.getKeysForOverrideIdentifier(a),_=[...h.filter(T=>p.indexOf(T)===-1),...p.filter(T=>h.indexOf(T)===-1),...p.filter(T=>!A.equals(this._defaultConfiguration.override(a).getValue(T),u.override(a).getValue(T)))];s.push([a,_])}return this.updateDefaultConfiguration(u),{keys:i,overrides:s}}compareAndUpdateLocalUserConfiguration(u){const{added:i,updated:s,removed:t,overrides:a}=b(this.localUserConfiguration,u),p=[...i,...s,...t];return p.length&&this.updateLocalUserConfiguration(u),{keys:p,overrides:a}}compareAndUpdateRemoteUserConfiguration(u){const{added:i,updated:s,removed:t,overrides:a}=b(this.remoteUserConfiguration,u);let p=[...i,...s,...t];return p.length&&this.updateRemoteUserConfiguration(u),{keys:p,overrides:a}}compareAndUpdateWorkspaceConfiguration(u){const{added:i,updated:s,removed:t,overrides:a}=b(this.workspaceConfiguration,u);let p=[...i,...s,...t];return p.length&&this.updateWorkspaceConfiguration(u),{keys:p,overrides:a}}compareAndUpdateFolderConfiguration(u,i){const s=this.folderConfigurations.get(u),{added:t,updated:a,removed:p,overrides:h}=b(s,i);let _=[...t,...a,...p];return(_.length||!s)&&this.updateFolderConfiguration(u,i),{keys:_,overrides:h}}compareAndDeleteFolderConfiguration(u){const i=this.folderConfigurations.get(u);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:s,updated:t,removed:a,overrides:p}=b(i,void 0);return{keys:[...s,...t,...a],overrides:p}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(u,i){let s=this.getConsolidatedConfigurationModelForResource(u,i);return u.overrideIdentifier?s.override(u.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:u},i){let s=this.getWorkspaceConsolidatedConfiguration();if(i&&u){const t=i.getFolder(u);t&&(s=this.getFolderConsolidatedConfiguration(t.uri)||s);const a=this._memoryConfigurationByResource.get(u);a&&(s=s.merge(a))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(u){let i=this._foldersConsolidatedConfigurations.get(u);if(!i){const s=this.getWorkspaceConsolidatedConfiguration(),t=this._folderConfigurations.get(u);t?(i=s.merge(t),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(u,i)):i=s}return i}getFolderConfigurationModelForResource(u,i){if(i&&u){const s=i.getFolder(u);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((u,i)=>{const{contents:s,overrides:t,keys:a}=this._folderConfigurations.get(i);return u.push([i,{contents:s,overrides:t,keys:a}]),u},[])}}allKeys(){const u=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>u.add(i)),this.userConfiguration.freeze().keys.forEach(i=>u.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>u.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(s=>u.add(s))),[...u.values()]}allOverrideIdentifiers(){const u=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>u.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>u.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>u.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(s=>u.add(s))),[...u.values()]}getAllKeysForOverrideIdentifier(u){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(u).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(s=>i.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(u).forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(u).forEach(t=>i.add(t))),[...i.values()]}static parse(u){const i=this.parseConfigurationModel(u.defaults),s=this.parseConfigurationModel(u.user),t=this.parseConfigurationModel(u.workspace),a=u.folders.reduce((p,h)=>(p.set(L.URI.revive(h[0]),this.parseConfigurationModel(h[1])),p),new S.ResourceMap);return new y(i,s,new g,t,a,new g,new S.ResourceMap,!1)}static parseConfigurationModel(u){return new g(u.contents,u.keys,u.overrides).freeze()}}e.Configuration=y;function k(...P){if(P.length===0)return{keys:[],overrides:[]};if(P.length===1)return P[0];const u=new Set,i=new Map;for(const t of P)t.keys.forEach(a=>u.add(a)),t.overrides.forEach(([a,p])=>{const h=(0,S.getOrSet)(i,a,new Set);p.forEach(_=>h.add(_))});const s=[];return i.forEach((t,a)=>s.push([a,[...t.values()]])),{keys:[...u.values()],overrides:s}}e.mergeChanges=k;class d{constructor(u,i,s,t){this.change=u,this.previous=i,this.currentConfiguraiton=s,this.currentWorkspace=t,this._previousConfiguration=void 0;const a=new Set;u.keys.forEach(h=>a.add(h)),u.overrides.forEach(([,h])=>h.forEach(_=>a.add(_))),this.affectedKeys=[...a.values()];const p=new g;this.affectedKeys.forEach(h=>p.setValue(h,{})),this.affectedKeysTree=p.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=y.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(u,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,u)){if(i){const s=this.previousConfiguration?this.previousConfiguration.getValue(u,i,this.previous?.workspace):void 0,t=this.currentConfiguraiton.getValue(u,i,this.currentWorkspace);return!A.equals(s,t)}return!0}return!1}doesAffectedKeysTreeContains(u,i){let s=(0,M.toValuesTree)({[i]:!0},()=>{}),t;for(;typeof s=="object"&&(t=Object.keys(s)[0]);){if(u=u[t],!u)return!1;s=s[t]}return!0}}e.ConfigurationChangeEvent=d;class f extends d{constructor(u,i,s,t){super({keys:u.allKeys(),overrides:[]},void 0,u,i);this.source=s,this.sourceConfig=t}}e.AllKeysConfigurationChangeEvent=f;function b(P,u){const{added:i,removed:s,updated:t}=l(u,P),a=[],p=P?.getAllOverrideIdentifiers()||[],h=u?.getAllOverrideIdentifiers()||[];if(u){const _=h.filter(T=>!p.includes(T));for(const T of _)a.push([T,u.getKeysForOverrideIdentifier(T)])}if(P){const _=p.filter(T=>!h.includes(T));for(const T of _)a.push([T,P.getKeysForOverrideIdentifier(T)])}if(u&&P){for(const _ of p)if(h.includes(_)){const T=l({contents:P.getOverrideValue(void 0,_)||{},keys:P.getKeysForOverrideIdentifier(_)},{contents:u.getOverrideValue(void 0,_)||{},keys:u.getKeysForOverrideIdentifier(_)});a.push([_,[...T.added,...T.removed,...T.updated]])}}return{added:i,removed:s,updated:t,overrides:a}}function l(P,u){const i=P?u?P.keys.filter(a=>u.keys.indexOf(a)===-1):[...P.keys]:[],s=u?P?u.keys.filter(a=>P.keys.indexOf(a)===-1):[...u.keys]:[],t=[];if(P&&u){for(const a of u.keys)if(P.keys.indexOf(a)!==-1){const p=(0,M.getConfigurationValue)(u.contents,a),h=(0,M.getConfigurationValue)(P.contents,a);A.equals(p,h)||t.push(a)}}return{added:i,removed:s,updated:t}}}),define(Ee[81],be([1,0,3]),function(Y,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,o.createDecorator)("remoteAuthorityResolverService");var I;(function(B){B.Unknown="Unknown",B.NotAvailable="NotAvailable",B.TemporarilyNotAvailable="TemporarilyNotAvailable",B.NoResolverFound="NoResolverFound"})(I=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class w extends Error{constructor(S,A=I.Unknown,C){super(S);this._message=S,this._code=A,this._detail=C,this.isHandled=A===I.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,w.prototype)}static isTemporarilyNotAvailable(S){return S instanceof w&&S._code===I.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof w&&S._code===I.NoResolverFound}static isHandled(S){return S instanceof w&&S.isHandled}}e.RemoteAuthorityResolverError=w}),define(Ee[82],be([1,0,9]),function(Y,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function I(B){return B.scheme===o.Schemas.vscodeRemote?B.authority:void 0}e.getRemoteAuthority=I;function w(B){if(!B)return;const S=B.indexOf("+");return S<0?B:B.substr(0,S)}e.getRemoteName=w}),define(Ee[25],be([1,0,10,3,82]),function(Y,e,o,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function B(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.getWorkspaceSupportTypeMessage=B;function S(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=S,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class C{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,r){if(typeof g=="undefined"||g===null)return typeof r=="undefined"||r===null;if(typeof r=="undefined"||r===null)return!1;if(typeof g=="string"||typeof r=="string"){let n=typeof g=="string"?g:g.value,m=typeof r=="string"?r:r.value;return o.equalsIgnoreCase(n,m)}return g._lower===r._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.ExtensionIdentifier=C;function L(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}e.isLanguagePackExtension=L;function M(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=M;function v(c,g){if(g){const r=`onResolveRemoteAuthority:${(0,w.getRemoteName)(g)}`;return c.activationEvents?.indexOf(r)!==-1}return!1}e.isResolverExtension=v,e.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ee[144],be([1,0,10,25]),function(Y,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function w(r,n){return r.uuid&&n.uuid?r.uuid===n.uuid:r.id===n.id?!0:(0,o.compareIgnoreCase)(r.id,n.id)===0}e.areSameExtensions=w;class B{constructor(n,m){this.version=m,this.id=n.id,this.uuid=n.uuid}key(){return`${this.id}-${this.version}`}equals(n){return n instanceof B?w(this,n)&&this.version===n.version:!1}}e.ExtensionIdentifierWithVersion=B;function S(r,n){return`${r}.${n}`}e.getExtensionId=S;function A(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=A;function C(r,n){return A(S(r,n))}e.getGalleryExtensionId=C;function L(r,n){const m=[],y=k=>{for(const d of m)if(d.some(f=>w(n(f),n(k))))return d;return null};for(const k of r){const d=y(k);d?d.push(k):m.push([k])}return m}e.groupByExtension=L;function M(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=M;function v(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),...r.telemetryData}}e.getGalleryExtensionTelemetryData=v,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function c(r){const n=new Set;if(r.malicious)for(const m of r.malicious)n.add(m.id);return n}e.getMaliciousExtensionsSet=c;function g(r,n){const m=[],y=n.manifest.extensionDependencies?.slice(0)??[];for(;y.length;){const k=y.shift();if(k&&m.every(d=>!w(d.identifier,{id:k}))){const d=r.filter(f=>w(f.identifier,{id:k}));d.length===1&&(m.push(d[0]),y.push(...d[0].manifest.extensionDependencies?.slice(0)??[]))}}return m}e.getExtensionDependencies=g}),define(Ee[145],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class o{constructor(w){this._callback=w,this._terminalBufferMap=new Map}dispose(){for(const w of this._terminalBufferMap.values())w.dispose()}startBuffering(w,B,S=5){let A;return A=B(C=>{const L=typeof C=="string"?C:C.data;let M=this._terminalBufferMap.get(w);if(M){M.data.push(L);return}const v=setTimeout(()=>this.flushBuffer(w),S);M={data:[L],timeoutId:v,dispose:()=>{clearTimeout(v),this.flushBuffer(w),A.dispose()}},this._terminalBufferMap.set(w,M)}),A}stopBuffering(w){const B=this._terminalBufferMap.get(w);B&&B.dispose()}flushBuffer(w){const B=this._terminalBufferMap.get(w);B&&(this._terminalBufferMap.delete(w),this._callback(w,B.data.join("")))}}e.TerminalDataBufferer=o}),define(Ee[146],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var o;(function(I){I.DARK="dark",I.LIGHT="light",I.HIGH_CONTRAST="hc"})(o=e.ColorScheme||(e.ColorScheme={}))}),define(Ee[57],be([1,0,106,5,6,3,37,146]),function(Y,e,o,I,w,B,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,B.createDecorator)("themeService");var C;(function(m){function y(k){return k&&typeof k=="object"&&typeof k.id=="string"}m.isThemeColor=y})(C=e.ThemeColor||(e.ThemeColor={}));function L(m){return{id:m}}e.themeColorFromId=L;var M;(function(m){function y(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||C.isThemeColor(i.color))}m.isThemeIcon=y;const k=new RegExp(`^\\$\\((${o.CSSIcon.iconNameExpression}(?:${o.CSSIcon.iconModifierExpression})?)\\)$`);function d(i){const s=k.exec(i);if(!s)return;let[,t]=s;return{id:t}}m.fromString=d;function f(i){return{id:i}}m.fromId=f;function b(i,s){let t=i.id;const a=t.lastIndexOf("~");return a!==-1&&(t=t.substring(0,a)),s&&(t=`${t}~${s}`),{id:t}}m.modify=b;function l(i){const s=i.id.lastIndexOf("~");if(s!==-1)return i.id.substring(s+1)}m.getModifier=l;function P(i,s){return i.id===s.id&&i.color?.id===s.color?.id}m.isEqual=P;function u(i,s){return{id:i.id,color:s?L(s):void 0}}m.asThemeIcon=u,m.asClassNameArray=o.CSSIcon.asClassNameArray,m.asClassName=o.CSSIcon.asClassName,m.asCSSSelector=o.CSSIcon.asCSSSelector})(M=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=o.Codicon.file,e.FolderThemeIcon=o.Codicon.folder;function v(m){switch(m){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=v,e.Extensions={ThemingContribution:"base.contributions.theming"};class c{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new I.Emitter}onColorThemeChange(y){return this.themingParticipants.push(y),this.onThemingParticipantAddedEmitter.fire(y),(0,w.toDisposable)(()=>{const k=this.themingParticipants.indexOf(y);this.themingParticipants.splice(k,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let g=new c;S.Registry.add(e.Extensions.ThemingContribution,g);function r(m){return g.onColorThemeChange(m)}e.registerThemingParticipant=r;class n extends w.Disposable{constructor(y){super();this.themeService=y,this.theme=y.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(k=>this.onThemeChange(k)))}onThemeChange(y){this.theme=y,this.updateStyles()}updateStyles(){}getColor(y,k){let d=this.theme.getColor(y);return d&&k&&(d=k(d,this.theme)),d?d.toString():null}}e.Themable=n}),define(Ee[147],be([1,0,5,23,3,12]),function(Y,e,o,I,w,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,w.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,w.createDecorator)("sharedTunnelsService");var S;(function(r){r.Http="http",r.Https="https"})(S=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(r){r.ConstantPrivate="constantPrivate",r.Private="private",r.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(r){r[r.Notify=1]="Notify",r[r.OpenBrowser=2]="OpenBrowser",r[r.OpenPreview=3]="OpenPreview",r[r.Silent=4]="Silent",r[r.Ignore=5]="Ignore",r[r.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function L(r){if(r.scheme!=="http"&&r.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(r.authority);if(!!n)return{address:n[1],port:+n[2]}}e.extractLocalHostUriMetaDataForPortMapping=L,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function M(r){return e.LOCALHOST_ADDRESSES.indexOf(r)>=0}e.isLocalhost=M,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(r){return e.ALL_INTERFACES_ADDRESSES.indexOf(r)>=0}e.isAllInterfaces=v;function c(r,n){return n?n!==1&&r<1024:!I.isWindows&&r<1024}e.isPortPrivileged=c;let g=class{constructor(n){this.logService=n,this._onTunnelOpened=new o.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new o.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new o.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(n){return this._tunnelProvider=n,n?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(n){this._canElevate=n.elevation,this._privacyOptions=n.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const n=[],m=Array.from(this._tunnels.values());for(let y of m){const k=Array.from(y.values());for(let d of k){const f=await d.value;f&&n.push(f)}}return n}async dispose(){for(const n of this._tunnels.values()){for(const{value:m}of n.values())await m.then(y=>y?.dispose());n.clear()}this._tunnels.clear()}openTunnel(n,m,y,k,d=!1,f=A.Private,b){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${m}:${y} on local port ${k}.`),!n)return;m||(m="localhost");const l=this.retainOrCreateTunnel(n,m,y,k,d,f,b);return l?l.then(P=>{if(!P){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(m,y);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const u=this.makeTunnel(P);return(P.tunnelRemoteHost!==m||P.tunnelRemotePort!==y)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(u),u}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}makeTunnel(n){return{tunnelRemotePort:n.tunnelRemotePort,tunnelRemoteHost:n.tunnelRemoteHost,tunnelLocalPort:n.tunnelLocalPort,localAddress:n.localAddress,privacy:n.privacy,protocol:n.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${n.tunnelRemoteHost}:${n.tunnelRemotePort} `);const m=this._tunnels.get(n.tunnelRemoteHost);if(m){const y=m.get(n.tunnelRemotePort);y&&(y.refcount--,await this.tryDisposeTunnel(n.tunnelRemoteHost,n.tunnelRemotePort,y))}}}}async tryDisposeTunnel(n,m,y){if(y.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${n}:${m}.`);const k=y.value.then(async d=>{d&&(await d.dispose(!0),this._onTunnelClosed.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this._tunnels.has(n)&&this._tunnels.get(n).delete(m),k}}async closeTunnel(n,m){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${n}:${m} `);const y=this._tunnels.get(n);if(y&&y.has(m)){const k=y.get(m);k.refcount=0,await this.tryDisposeTunnel(n,m,k)}}addTunnelToMap(n,m,y){this._tunnels.has(n)||this._tunnels.set(n,new Map),this._tunnels.get(n).set(m,{refcount:1,value:y})}async removeEmptyTunnelFromMap(n,m){const y=this._tunnels.get(n);y&&(await y.get(m)||y.delete(m),y.size===0&&this._tunnels.delete(n))}getTunnelFromMap(n,m){let y=[n];M(n)?(y.push(...e.LOCALHOST_ADDRESSES),y.push(...e.ALL_INTERFACES_ADDRESSES)):v(n)&&y.push(...e.ALL_INTERFACES_ADDRESSES);const k=y.map(d=>this._tunnels.get(d));for(const d of k){const f=d?.get(m);if(f)return f}}canTunnel(n){return!!L(n)}createWithProvider(n,m,y,k,d,f,b){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${m}:${y} on local port ${k}.`);const P={elevationRequired:d?c(k===void 0?y:k):!1},u={remoteAddress:{host:m,port:y},localAddressPort:k,privacy:f,public:f!==A.Private,protocol:b},i=n.forwardPort(u,P);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(m,y,i),i}};g=Fe([Ne(0,B.ILogService)],g),e.AbstractTunnelService=g}),define(Ee[148],be([1,0,9]),function(Y,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function I(A){return A.scheme!==o.Schemas.file&&A.scheme!==o.Schemas.vscodeRemote}e.isVirtualResource=I;function w(A){if(A.folders.length)return A.folders.every(C=>I(C.uri))?A.folders[0].uri:void 0;if(A.configuration&&I(A.configuration))return A.configuration}e.getVirtualWorkspaceLocation=w;function B(A){return w(A)?.scheme}e.getVirtualWorkspaceScheme=B;function S(A){return w(A)!==void 0}e.isVirtualWorkspace=S}),define(Ee[46],be([1,0,121,17,22,24,2,3,9]),function(Y,e,o,I,w,B,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function L(P){const u=P;return typeof u?.id=="string"&&S.URI.isUri(u.uri)}e.isSingleFolderWorkspaceIdentifier=L;function M(P){if(P.configuration)return{id:P.id,configPath:P.configuration};if(P.folders.length===1)return{id:P.id,uri:P.folders[0].uri}}e.toWorkspaceIdentifier=M;function v(P){const u=P;return typeof u?.id=="string"&&S.URI.isUri(u.configPath)}e.isWorkspaceIdentifier=v;function c(P){const u=P;if(u?.uri)return{id:u.id,uri:S.URI.revive(u.uri)};const i=P;if(i?.configPath)return{id:i.id,configPath:S.URI.revive(i.configPath)};if(P?.id)return{id:P.id}}e.reviveIdentifier=c;var g;(function(P){P[P.EMPTY=1]="EMPTY",P[P.FOLDER=2]="FOLDER",P[P.WORKSPACE=3]="WORKSPACE"})(g=e.WorkbenchState||(e.WorkbenchState={}));function r(P){const u=P;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&Array.isArray(u.folders))}e.isWorkspace=r;function n(P){const u=P;return!!(u&&typeof u=="object"&&S.URI.isUri(u.uri)&&typeof u.name=="string"&&typeof u.toResource=="function")}e.isWorkspaceFolder=n;class m{constructor(u,i,s,t,a){this._id=u,this._transient=s,this._configuration=t,this._ignorePathCasing=a,this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=i}update(u){this._id=u.id,this._configuration=u.configuration,this._transient=u.transient,this._ignorePathCasing=u._ignorePathCasing,this.folders=u.folders}get folders(){return this._folders}set folders(u){this._folders=u,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(u){this._configuration=u}getFolder(u){return u&&this._foldersMap.findSubstr(u.with({scheme:u.scheme,authority:u.authority,path:u.path}))||null}updateFoldersMap(){this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing);for(const u of this.folders)this._foldersMap.set(u.uri,u)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=m;class y{constructor(u,i){this.raw=i,this.uri=u.uri,this.index=u.index,this.name=u.name}toResource(u){return(0,B.joinPath)(this.uri,u)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=y;function k(P){return new y({uri:P,index:0,name:(0,B.basenameOrAuthority)(P)},{uri:P.toString()})}e.toWorkspaceFolder=k,e.WORKSPACE_EXTENSION="code-workspace";const d=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,o.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function f(P,u){return B.extUriBiasedIgnorePathCase.isEqualOrParent(P,u.untitledWorkspacesHome)}e.isUntitledWorkspace=f;function b(P){let u;return S.URI.isUri(P)?u=P:u=P.configuration,u?.scheme===C.Schemas.tmp}e.isTemporaryWorkspace=b;function l(P){return(typeof P=="string"?(0,I.extname)(P):(0,B.extname)(P))===d}e.hasWorkspaceFileExtension=l}),define(Ee[58],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class o{constructor(w){this.id=w,this._data=new Map,this._idPool=1}add(w){const B=this._idPool++;return this._data.set(B,w),this.logDebugInfo(),B}get(w,B){return this._data.has(w)?this._data.get(w)[B]:void 0}delete(w){this._data.delete(w),this.logDebugInfo()}logDebugInfo(){!o.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=o,o.enableDebugLogging=!1}),define(Ee[30],be([1,0,9,24,3]),function(Y,e,o,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class B{constructor(){this._systemSchemes=new Set(Object.keys(o.Schemas)),this._providerInfo=new Map,this.extUri=new I.ExtUri(A=>{const C=this._providerInfo.get(A.scheme);return!(C===void 0||C&1024)})}$acceptProviderInfos(A,C){C===null?this._providerInfo.delete(A.scheme):this._providerInfo.set(A.scheme,C)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=B,e.IExtHostFileSystemInfo=(0,w.createDecorator)("IExtHostFileSystemInfo")}),define(Ee[27],be([1,0,3]),function(Y,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,o.createDecorator)("IExtHostInitDataService")}),define(Ee[149],be([1,0,13]),function(Y,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class I{constructor(S,A,C){this._deferredPromises=new Map,this._id=S,this._shared=A,this._storage=C,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(L=>(this._value=L,this)),this._storageListener=this._storage.onDidChangeStorage(L=>{L.shared===this._shared&&L.key===this._id&&(this._value=L.value)}),this._scheduler=new o.RunOnceScheduler(()=>{const L=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const M of L.values())M.complete()}catch(M){for(const v of L.values())v.error(M)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,S])=>S!==void 0).map(([S])=>S)}get whenReady(){return this._init}get(S,A){let C=this._value[S];return typeof C=="undefined"&&(C=A),C}update(S,A){this._value[S]=A;let C=this._deferredPromises.get(S);if(C!==void 0)return C.p;const L=new o.DeferredPromise;return this._deferredPromises.set(S,L),this._scheduler.isScheduled()||this._scheduler.schedule(),L.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=I;class w extends I{constructor(S,A){super(S.identifier.value,!0,A);this._extension=S}setKeysForSync(S){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},S)}}e.ExtensionGlobalMemento=w}),define(Ee[150],be([1,0,5,2,12]),function(Y,e,o,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let B=class{constructor(A,C){this._logService=A,this._notebooksAndEditors=C,this._onDidChangeNotebookDocumentMetadata=new o.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new o.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(A,C,L){this._notebooksAndEditors.getNotebookDocument(I.URI.revive(A)).acceptModelChanged(C.value,L)}$acceptDirtyStateChanged(A,C){this._notebooksAndEditors.getNotebookDocument(I.URI.revive(A)).acceptDirty(C)}$acceptModelSaved(A){const C=this._notebooksAndEditors.getNotebookDocument(I.URI.revive(A));this._onDidSaveNotebookDocument.fire(C.apiNotebook)}$acceptDocumentPropertiesChanged(A,C){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",A.path,C);const L=this._notebooksAndEditors.getNotebookDocument(I.URI.revive(A));L.acceptDocumentPropertiesChanged(C),C.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:L.apiNotebook})}};B=Fe([Ne(0,w.ILogService)],B),e.ExtHostNotebookDocuments=B}),define(Ee[14],be([1,0,3]),function(Y,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,o.createDecorator)("IExtHostRpcService");class I{constructor(B){this.getProxy=B.getProxy.bind(B),this.set=B.set.bind(B),this.assertRegistered=B.assertRegistered.bind(B),this.drain=B.drain.bind(B)}}e.ExtHostRpcService=I});var je=this&&this.__classPrivateFieldSet||function(Y,e,o,I,w){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!w:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?w.call(Y,o):w?w.value=o:e.set(Y,o),o},De=this&&this.__classPrivateFieldGet||function(Y,e,o,I){if(o==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?I:o==="a"?I.call(Y):I?I.value:e.get(Y)};define(Ee[151],be([1,0,25,5]),function(Y,e,o,I){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class B{constructor(A,C){w.set(this,void 0),this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._id=o.ExtensionIdentifier.toKey(A.identifier),je(this,w,C,"f"),De(this,w,"f").onDidChangePassword(L=>{L.extensionId===this._id&&this._onDidChange.fire({key:L.key})})}get(A){return De(this,w,"f").get(this._id,A)}store(A,C){return De(this,w,"f").store(this._id,A,C)}delete(A){return De(this,w,"f").delete(this._id,A)}}e.ExtensionSecrets=B,w=new WeakMap}),define(Ee[83],be([1,0,3,5]),function(Y,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class w{constructor(){this._onDidChangeTelemetryEnabled=new I.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new I.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._level>=2,isUsageEnabled:this._level>=3}}$initializeTelemetryLevel(S){this._level=S}$onDidChangeTelemetryLevel(S){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=S,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=w,e.IExtHostTelemetry=(0,o.createDecorator)("IExtHostTelemetry")}),define(Ee[47],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var o;(function(k){k[k.Upsert=0]="Upsert",k[k.RemoveChild=1]="RemoveChild",k[k.Invalidated=2]="Invalidated",k[k.SetProp=3]="SetProp",k[k.Bulk=4]="Bulk"})(o=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const I=new WeakMap,w=(k,d)=>{const f={controllerId:d};return I.set(k,f),f};e.createPrivateApiFor=w;const B=k=>I.get(k);e.getPrivateApiFor=B;const S=(k,d,f,b)=>{let l=f;return{enumerable:!0,configurable:!1,get(){return l},set(P){if(!b(l,P)){const u=l;l=P,k.listener?.({op:3,key:d,value:P,previous:u})}}}},A=(k,d)=>k===d,C={range:(k,d)=>k===d?!0:!k||!d?!1:k.isEqual(d),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(k,d)=>!(k.length!==d.length||k.some(f=>!d.find(b=>f.id===b.id)))},L=Object.keys(C),M=(k,d)=>({range:S(k,"range",void 0,C.range),label:S(k,"label",d,C.label),description:S(k,"description",void 0,C.description),sortText:S(k,"sortText",void 0,C.sortText),canResolveChildren:S(k,"canResolveChildren",!1,C.canResolveChildren),busy:S(k,"busy",!1,C.busy),error:S(k,"error",void 0,C.error),tags:S(k,"tags",[],C.tags)}),v=(k,d)=>{const f=new Map;for(const b of L)C[b](k[b],d[b])||f.set(b,d[b]);return f};e.diffTestItems=v;class c extends Error{constructor(d){super(`Attempted to insert a duplicate test item ID ${d}`)}}e.DuplicateTestItemError=c;class g extends Error{constructor(d){super(`TestItem with ID "${d}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=g;class r extends Error{constructor(d,f,b){super(`TestItem with ID "${d}" is from controller "${f}" and cannot be added as a child of an item from controller "${b}".`)}}e.MixedTestItemController=r;const n=k=>{const d=(0,e.getPrivateApiFor)(k);let f=new Map;return{get size(){return f.size},forEach(b,l){for(const P of f.values())b.call(l,P,this)},replace(b){const l=new Map,P=new Set(f.keys()),u={op:4,ops:[]};for(const i of b){if(!(i instanceof m))throw new g(i.id);const s=(0,e.getPrivateApiFor)(i).controllerId;if(s!==d.controllerId)throw new r(i.id,s,d.controllerId);if(l.has(i.id))throw new c(i.id);l.set(i.id,i),P.delete(i.id),u.ops.push({op:0,item:i})}for(const i of P.keys())u.ops.push({op:1,id:i});d.listener?.(u),f=l},add(b){if(!(b instanceof m))throw new g(b.id);f.set(b.id,b),d.listener?.({op:0,item:b})},delete(b){f.delete(b)&&d.listener?.({op:1,id:b})},get(b){return f.get(b)},toJSON(){return Array.from(f.values())},[Symbol.iterator](){return f.values()}}};class m{constructor(d,f,b,l){if(f.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(f)} symbol`);const P=(0,e.createPrivateApiFor)(this,d);Object.defineProperties(this,{id:{value:f,enumerable:!0,writable:!1},uri:{value:l,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return P.parent instanceof y?void 0:P.parent}},children:{value:n(this),enumerable:!0,writable:!1},...M(P,b)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=m;class y extends m{constructor(d,f){super(d,d,f,void 0)}}e.TestItemRootImpl=y}),define(Ee[59],be([1,0,3,147,5,14]),function(Y,e,o,I,w,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var S;(function(C){function L(v){return{remoteAddress:v.remoteAddress,localAddress:v.localAddress,public:!!v.public,privacy:v.privacy??(v.public?I.TunnelPrivacyId.Public:I.TunnelPrivacyId.Private),protocol:v.protocol}}C.fromApiTunnel=L;function M(v){return{remoteAddress:{host:v.tunnelRemoteHost,port:v.tunnelRemotePort},localAddress:v.localAddress,public:v.privacy!==I.TunnelPrivacyId.ConstantPrivate&&v.privacy!==I.TunnelPrivacyId.ConstantPrivate,privacy:v.privacy,protocol:v.protocol}}C.fromServiceTunnel=M})(S=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,o.createDecorator)("IExtHostTunnelService");let A=class{constructor(L){this.onDidChangeTunnels=new w.Emitter().event}async $applyCandidateFilter(L){return L}async openTunnel(L,M){}async getTunnels(){return[]}async setTunnelFactory(L){return{dispose:()=>{}}}registerPortsAttributesProvider(L,M){return{dispose:()=>{}}}async $providePortAttributes(L,M,v,c,g){return[]}async $forwardPort(L,M){}async $closeTunnel(L){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=Fe([Ne(0,B.IExtHostRpcService)],A),e.ExtHostTunnelService=A});var je=this&&this.__classPrivateFieldSet||function(Y,e,o,I,w){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!w:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?w.call(Y,o):w?w.value=o:e.set(Y,o),o},De=this&&this.__classPrivateFieldGet||function(Y,e,o,I){if(o==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?I:o==="a"?I.call(Y):I?I.value:e.get(Y)};define(Ee[7],be([1,0,16,15,72,22,71,10,11,2,36,45,81]),function(Y,e,o,I,w,B,S,A,C,L,M,v,c){"use strict";var g,r,n,m,y,k,d,f,b,l,P,u,i,s,t,a,p,h,_,T;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function R(V){function U(){return Reflect.construct(V,arguments,this.constructor)}return Object.defineProperty(U,"name",Object.getOwnPropertyDescriptor(V,"name")),Object.setPrototypeOf(U,V),Object.setPrototypeOf(U.prototype,V.prototype),U}let W=y=class{constructor(U){g.set(this,void 0),je(this,g,U,"f")}static from(...U){let ee=U;return new y(function(){if(ee){for(const we of ee)we&&typeof we.dispose=="function"&&we.dispose();ee=void 0}})}dispose(){typeof De(this,g,"f")=="function"&&(De(this,g,"f").call(this),je(this,g,void 0,"f"))}};g=new WeakMap,W=y=Fe([R],W),e.Disposable=W;let E=k=class{constructor(U,ee){if(U<0)throw(0,I.illegalArgument)("line must be non-negative");if(ee<0)throw(0,I.illegalArgument)("character must be non-negative");this._line=U,this._character=ee}static Min(...U){if(U.length===0)throw new TypeError;let ee=U[0];for(let we=1;we<U.length;we++){const We=U[we];We.isBefore(ee)&&(ee=We)}return ee}static Max(...U){if(U.length===0)throw new TypeError;let ee=U[0];for(let we=1;we<U.length;we++){const We=U[we];We.isAfter(ee)&&(ee=We)}return ee}static isPosition(U){if(!U)return!1;if(U instanceof k)return!0;let{line:ee,character:we}=U;return typeof ee=="number"&&typeof we=="number"}static of(U){if(U instanceof k)return U;if(this.isPosition(U))return new k(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(U){return this._line<U._line?!0:U._line<this._line?!1:this._character<U._character}isBeforeOrEqual(U){return this._line<U._line?!0:U._line<this._line?!1:this._character<=U._character}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this._line===U._line&&this._character===U._character}compareTo(U){return this._line<U._line?-1:this._line>U.line?1:this._character<U._character?-1:this._character>U._character?1:0}translate(U,ee=0){if(U===null||ee===null)throw(0,I.illegalArgument)();let we;return typeof U=="undefined"?we=0:typeof U=="number"?we=U:(we=typeof U.lineDelta=="number"?U.lineDelta:0,ee=typeof U.characterDelta=="number"?U.characterDelta:0),we===0&&ee===0?this:new k(this.line+we,this.character+ee)}with(U,ee=this.character){if(U===null||ee===null)throw(0,I.illegalArgument)();let we;return typeof U=="undefined"?we=this.line:typeof U=="number"?we=U:(we=typeof U.line=="number"?U.line:this.line,ee=typeof U.character=="number"?U.character:this.character),we===this.line&&ee===this.character?this:new k(we,ee)}toJSON(){return{line:this.line,character:this.character}}};E=k=Fe([R],E),e.Position=E;let H=d=class{constructor(U,ee,we,We){let Ke,Ye;if(typeof U=="number"&&typeof ee=="number"&&typeof we=="number"&&typeof We=="number"?(Ke=new E(U,ee),Ye=new E(we,We)):E.isPosition(U)&&E.isPosition(ee)&&(Ke=E.of(U),Ye=E.of(ee)),!Ke||!Ye)throw new Error("Invalid arguments");Ke.isBefore(Ye)?(this._start=Ke,this._end=Ye):(this._start=Ye,this._end=Ke)}static isRange(U){return U instanceof d?!0:U?E.isPosition(U.start)&&E.isPosition(U.end):!1}static of(U){if(U instanceof d)return U;if(this.isRange(U))return new d(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(U){return d.isRange(U)?this.contains(U.start)&&this.contains(U.end):E.isPosition(U)?!(E.of(U).isBefore(this._start)||this._end.isBefore(U)):!1}isEqual(U){return this._start.isEqual(U._start)&&this._end.isEqual(U._end)}intersection(U){const ee=E.Max(U.start,this._start),we=E.Min(U.end,this._end);if(!ee.isAfter(we))return new d(ee,we)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const ee=E.Min(U.start,this._start),we=E.Max(U.end,this.end);return new d(ee,we)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(U,ee=this.end){if(U===null||ee===null)throw(0,I.illegalArgument)();let we;return U?E.isPosition(U)?we=U:(we=U.start||this.start,ee=U.end||this.end):we=this.start,we.isEqual(this._start)&&ee.isEqual(this.end)?this:new d(we,ee)}toJSON(){return[this.start,this.end]}};H=d=Fe([R],H),e.Range=H;let q=f=class extends H{constructor(U,ee,we,We){let Ke,Ye;if(typeof U=="number"&&typeof ee=="number"&&typeof we=="number"&&typeof We=="number"?(Ke=new E(U,ee),Ye=new E(we,We)):E.isPosition(U)&&E.isPosition(ee)&&(Ke=E.of(U),Ye=E.of(ee)),!Ke||!Ye)throw new Error("Invalid arguments");super(Ke,Ye);this._anchor=Ke,this._active=Ye}static isSelection(U){return U instanceof f?!0:U?H.isRange(U)&&E.isPosition(U.anchor)&&E.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};q=f=Fe([R],q),e.Selection=q;class ${constructor(U,ee,we){if(typeof U!="string"||U.length===0)throw(0,I.illegalArgument)("host");if(typeof ee!="number"||ee===0||Math.round(ee)!==ee)throw(0,I.illegalArgument)("port");if(typeof we!="undefined"&&(typeof we!="string"||we.length===0||!/^[0-9A-Za-z\-]+$/.test(we)))throw(0,I.illegalArgument)("connectionToken");this.host=U,this.port=Math.round(ee),this.connectionToken=we}}e.ResolvedAuthority=$;class j extends Error{constructor(U,ee=c.RemoteAuthorityResolverErrorCode.Unknown,we){super(U);this._message=U,this._code=ee,this._detail=we,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,j.prototype)}static NotAvailable(U,ee){return new j(U,c.RemoteAuthorityResolverErrorCode.NotAvailable,ee)}static TemporarilyNotAvailable(U){return new j(U,c.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=j;var J;(function(V){V[V.LF=1]="LF",V[V.CRLF=2]="CRLF"})(J=e.EndOfLine||(e.EndOfLine={}));var z;(function(V){V[V.Replace=1]="Replace",V[V.Append=2]="Append",V[V.Prepend=3]="Prepend"})(z=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ie=b=class{constructor(U,ee){this._range=U,this._newText=ee}static isTextEdit(U){return U instanceof b?!0:U?H.isRange(U)&&typeof U.newText=="string":!1}static replace(U,ee){return new b(U,ee)}static insert(U,ee){return b.replace(new H(U,U),ee)}static delete(U){return b.replace(U,"")}static setEndOfLine(U){const ee=new b(new H(new E(0,0),new E(0,0)),"");return ee.newEol=U,ee}get range(){return this._range}set range(U){if(U&&!H.isRange(U))throw(0,I.illegalArgument)("range");this._range=U}get newText(){return this._newText||""}set newText(U){if(U&&typeof U!="string")throw(0,I.illegalArgument)("newText");this._newText=U}get newEol(){return this._newEol}set newEol(U){if(U&&typeof U!="number")throw(0,I.illegalArgument)("newEol");this._newEol=U}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ie=b=Fe([R],ie),e.TextEdit=ie;var ae;(function(V){V[V.File=1]="File",V[V.Text=2]="Text",V[V.Cell=3]="Cell",V[V.CellReplace=5]="CellReplace"})(ae=e.FileEditType||(e.FileEditType={}));let te=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(U,ee,we,We){this._edits.push({_type:1,from:U,to:ee,options:we,metadata:We})}createFile(U,ee,we){this._edits.push({_type:1,from:void 0,to:U,options:ee,metadata:we})}deleteFile(U,ee,we){this._edits.push({_type:1,from:U,to:void 0,options:ee,metadata:we})}replaceNotebookMetadata(U,ee,we){this._edits.push({_type:3,metadata:we,uri:U,edit:{editType:5,metadata:ee},notebookMetadata:ee})}replaceNotebookCells(U,ee,we,We,Ke){let Ye,et,_t=[],Pt;if(Gt.isNotebookRange(ee)&&Pe.isNotebookCellDataArray(we)&&!Pe.isNotebookCellDataArray(We)?(Ye=ee.start,et=ee.end,_t=we,Pt=We):typeof ee=="number"&&typeof we=="number"&&Pe.isNotebookCellDataArray(We)&&(Ye=ee,et=we,_t=We,Pt=Ke),Ye===void 0||et===void 0)throw new Error("Invalid arguments");(Ye!==et||_t.length>0)&&this._edits.push({_type:5,uri:U,index:Ye,count:et-Ye,cells:_t,metadata:Pt})}replaceNotebookCellMetadata(U,ee,we,We){this._edits.push({_type:3,metadata:We,uri:U,edit:{editType:8,index:ee,metadata:we}})}replace(U,ee,we,We){this._edits.push({_type:2,uri:U,edit:new ie(ee,we),metadata:We})}insert(U,ee,we,We){this.replace(U,new H(ee,ee),we,We)}delete(U,ee,we){this.replace(U,ee,"",we)}has(U){return this._edits.some(ee=>ee._type===2&&ee.uri.toString()===U.toString())}set(U,ee){if(ee)for(const we of ee)we&&this._edits.push({_type:2,uri:U,edit:we});else{for(let we=0;we<this._edits.length;we++){const We=this._edits[we];We._type===2&&We.uri.toString()===U.toString()&&(this._edits[we]=void 0)}(0,o.coalesceInPlace)(this._edits)}}get(U){const ee=[];for(let we of this._edits)we._type===2&&we.uri.toString()===U.toString()&&ee.push(we.edit);return ee}entries(){const U=new B.ResourceMap;for(let ee of this._edits)if(ee._type===2){let we=U.get(ee.uri);we||(we=[ee.uri,[]],U.set(ee.uri,we)),we[1].push(ee.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};te=Fe([R],te),e.WorkspaceEdit=te;let ce=l=class{constructor(U){this._tabstop=1,this.value=U||""}static isSnippetString(U){return U instanceof l?!0:U?typeof U.value=="string":!1}static _escape(U){return U.replace(/\$|}|\\/g,"\\$&")}appendText(U){return this.value+=l._escape(U),this}appendTabstop(U=this._tabstop++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,ee=this._tabstop++){if(typeof U=="function"){const we=new l;we._tabstop=this._tabstop,U(we),this._tabstop=we._tabstop,U=we.value}else U=l._escape(U);return this.value+="${",this.value+=ee,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,ee=this._tabstop++){const we=U.map(We=>We.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ee,this.value+="|",this.value+=we,this.value+="|}",this}appendVariable(U,ee){if(typeof ee=="function"){const we=new l;we._tabstop=this._tabstop,ee(we),this._tabstop=we._tabstop,ee=we.value}else typeof ee=="string"&&(ee=ee.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,ee&&(this.value+=":",this.value+=ee),this.value+="}",this}};ce=l=Fe([R],ce),e.SnippetString=ce;var de;(function(V){V[V.Unnecessary=1]="Unnecessary",V[V.Deprecated=2]="Deprecated"})(de=e.DiagnosticTag||(e.DiagnosticTag={}));var Se;(function(V){V[V.Hint=3]="Hint",V[V.Information=2]="Information",V[V.Warning=1]="Warning",V[V.Error=0]="Error"})(Se=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let fe=P=class{constructor(U,ee){if(this.uri=U,ee)if(H.isRange(ee))this.range=H.of(ee);else if(E.isPosition(ee))this.range=new H(ee,ee);else throw new Error("Illegal argument")}static isLocation(U){return U instanceof P?!0:U?H.isRange(U.range)&&L.URI.isUri(U.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};fe=P=Fe([R],fe),e.Location=fe;let ne=class{constructor(U,ee){this.location=U,this.message=ee}static is(U){return U?typeof U.message=="string"&&U.location&&H.isRange(U.location.range)&&L.URI.isUri(U.location.uri):!1}static isEqual(U,ee){return U===ee?!0:!U||!ee?!1:U.message===ee.message&&U.location.range.isEqual(ee.location.range)&&U.location.uri.toString()===ee.location.uri.toString()}};ne=Fe([R],ne),e.DiagnosticRelatedInformation=ne;let me=class{constructor(U,ee,we=Se.Error){if(!H.isRange(U))throw new TypeError("range must be set");if(!ee)throw new TypeError("message must be set");this.range=U,this.message=ee,this.severity=we}toJSON(){return{severity:Se[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,ee){return U===ee?!0:!U||!ee?!1:U.message===ee.message&&U.severity===ee.severity&&U.code===ee.code&&U.severity===ee.severity&&U.source===ee.source&&U.range.isEqual(ee.range)&&(0,o.equals)(U.tags,ee.tags)&&(0,o.equals)(U.relatedInformation,ee.relatedInformation,ne.isEqual)}};me=Fe([R],me),e.Diagnostic=me;let ke=class{constructor(U,ee){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=ee}};ke=Fe([R],ke),e.Hover=ke;var Ae;(function(V){V[V.Text=0]="Text",V[V.Read=1]="Read",V[V.Write=2]="Write"})(Ae=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Be=class{constructor(U,ee=Ae.Text){this.range=U,this.kind=ee}toJSON(){return{range:this.range,kind:Ae[this.kind]}}};Be=Fe([R],Be),e.DocumentHighlight=Be;var Xe;(function(V){V[V.File=0]="File",V[V.Module=1]="Module",V[V.Namespace=2]="Namespace",V[V.Package=3]="Package",V[V.Class=4]="Class",V[V.Method=5]="Method",V[V.Property=6]="Property",V[V.Field=7]="Field",V[V.Constructor=8]="Constructor",V[V.Enum=9]="Enum",V[V.Interface=10]="Interface",V[V.Function=11]="Function",V[V.Variable=12]="Variable",V[V.Constant=13]="Constant",V[V.String=14]="String",V[V.Number=15]="Number",V[V.Boolean=16]="Boolean",V[V.Array=17]="Array",V[V.Object=18]="Object",V[V.Key=19]="Key",V[V.Null=20]="Null",V[V.EnumMember=21]="EnumMember",V[V.Struct=22]="Struct",V[V.Event=23]="Event",V[V.Operator=24]="Operator",V[V.TypeParameter=25]="TypeParameter"})(Xe=e.SymbolKind||(e.SymbolKind={}));var ge;(function(V){V[V.Deprecated=1]="Deprecated"})(ge=e.SymbolTag||(e.SymbolTag={}));let ue=u=class{constructor(U,ee,we,We,Ke){this.name=U,this.kind=ee,this.containerName=Ke,typeof we=="string"&&(this.containerName=we),We instanceof fe?this.location=We:we instanceof H&&(this.location=new fe(We,we)),u.validate(this)}static validate(U){if(!U.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Xe[this.kind],location:this.location,containerName:this.containerName}}};ue=u=Fe([R],ue),e.SymbolInformation=ue;let N=i=class{constructor(U,ee,we,We,Ke){this.name=U,this.detail=ee,this.kind=we,this.range=We,this.selectionRange=Ke,this.children=[],i.validate(this)}static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children&&U.children.forEach(i.validate)}};N=i=Fe([R],N),e.DocumentSymbol=N;var F;(function(V){V[V.Invoke=1]="Invoke",V[V.Automatic=2]="Automatic"})(F=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let D=class{constructor(U,ee){this.title=U,this.kind=ee}};D=Fe([R],D),e.CodeAction=D;let O=s=class{constructor(U){this.value=U}append(U){return new s(this.value?this.value+s.sep+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+s.sep)}};O.sep=".",O=s=Fe([R],O),e.CodeActionKind=O,O.Empty=new O(""),O.QuickFix=O.Empty.append("quickfix"),O.Refactor=O.Empty.append("refactor"),O.RefactorExtract=O.Refactor.append("extract"),O.RefactorInline=O.Refactor.append("inline"),O.RefactorRewrite=O.Refactor.append("rewrite"),O.Source=O.Empty.append("source"),O.SourceOrganizeImports=O.Source.append("organizeImports"),O.SourceFixAll=O.Source.append("fixAll");let x=class{constructor(U,ee){if(this.range=U,this.parent=ee,ee&&!ee.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};x=Fe([R],x),e.SelectionRange=x;class X{constructor(U,ee,we,We,Ke,Ye){this.kind=U,this.name=ee,this.detail=we,this.uri=We,this.range=Ke,this.selectionRange=Ye}}e.CallHierarchyItem=X;class re{constructor(U,ee){this.fromRanges=ee,this.from=U}}e.CallHierarchyIncomingCall=re;class ve{constructor(U,ee){this.fromRanges=ee,this.to=U}}e.CallHierarchyOutgoingCall=ve;var Ie;(function(V){V[V.Information=0]="Information",V[V.Warning=1]="Warning",V[V.Error=2]="Error"})(Ie=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Me=class{constructor(U,ee){this.range=U,this.command=ee}get isResolved(){return!!this.command}};Me=Fe([R],Me),e.CodeLens=Me;let Le=t=class{constructor(U,ee=!1){r.set(this,void 0),je(this,r,new w.MarkdownString(U,{supportThemeIcons:ee}),"f")}static isMarkdownString(U){return U instanceof t?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}get value(){return De(this,r,"f").value}set value(U){De(this,r,"f").value=U}get isTrusted(){return De(this,r,"f").isTrusted}set isTrusted(U){De(this,r,"f").isTrusted=U}get supportThemeIcons(){return De(this,r,"f").supportThemeIcons}set supportThemeIcons(U){De(this,r,"f").supportThemeIcons=U}get supportHtml(){return De(this,r,"f").supportHtml}set supportHtml(U){De(this,r,"f").supportHtml=U}get baseUri(){return De(this,r,"f").baseUri}set baseUri(U){De(this,r,"f").baseUri=U}appendText(U){return De(this,r,"f").appendText(U),this}appendMarkdown(U){return De(this,r,"f").appendMarkdown(U),this}appendCodeblock(U,ee){return De(this,r,"f").appendCodeblock(ee??"",U),this}};r=new WeakMap,Le=t=Fe([R],Le),e.MarkdownString=Le;let ze=class{constructor(U,ee){this.label=U,this.documentation=ee}};ze=Fe([R],ze),e.ParameterInformation=ze;let xe=class{constructor(U,ee){this.label=U,this.documentation=ee,this.parameters=[]}};xe=Fe([R],xe),e.SignatureInformation=xe;let Re=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Re=Fe([R],Re),e.SignatureHelp=Re;var Qe;(function(V){V[V.Invoke=1]="Invoke",V[V.TriggerCharacter=2]="TriggerCharacter",V[V.ContentChange=3]="ContentChange"})(Qe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var tt;(function(V){V[V.Type=1]="Type",V[V.Parameter=2]="Parameter"})(tt=e.InlayHintKind||(e.InlayHintKind={}));let Te=class{constructor(U){this.value=U}};Te=Fe([R],Te),e.InlayHintLabelPart=Te;let it=class{constructor(U,ee,we){this.position=U,this.label=ee,this.kind=we}};it=Fe([R],it),e.InlayHint=it;var G;(function(V){V[V.Invoke=0]="Invoke",V[V.TriggerCharacter=1]="TriggerCharacter",V[V.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(G=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Q;(function(V){V[V.Text=0]="Text",V[V.Method=1]="Method",V[V.Function=2]="Function",V[V.Constructor=3]="Constructor",V[V.Field=4]="Field",V[V.Variable=5]="Variable",V[V.Class=6]="Class",V[V.Interface=7]="Interface",V[V.Module=8]="Module",V[V.Property=9]="Property",V[V.Unit=10]="Unit",V[V.Value=11]="Value",V[V.Enum=12]="Enum",V[V.Keyword=13]="Keyword",V[V.Snippet=14]="Snippet",V[V.Color=15]="Color",V[V.File=16]="File",V[V.Reference=17]="Reference",V[V.Folder=18]="Folder",V[V.EnumMember=19]="EnumMember",V[V.Constant=20]="Constant",V[V.Struct=21]="Struct",V[V.Event=22]="Event",V[V.Operator=23]="Operator",V[V.TypeParameter=24]="TypeParameter",V[V.User=25]="User",V[V.Issue=26]="Issue"})(Q=e.CompletionItemKind||(e.CompletionItemKind={}));var le;(function(V){V[V.Deprecated=1]="Deprecated"})(le=e.CompletionItemTag||(e.CompletionItemTag={}));let Oe=class{constructor(U,ee){this.label=U,this.kind=ee}toJSON(){return{label:this.label,kind:this.kind&&Q[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Oe=Fe([R],Oe),e.CompletionItem=Oe;let He=class{constructor(U=[],ee=!1){this.items=U,this.isIncomplete=ee}};He=Fe([R],He),e.CompletionList=He;let Ge=class{constructor(U,ee,we){this.insertText=U,this.range=ee,this.command=we}};Ge=Fe([R],Ge),e.InlineSuggestion=Ge;let Je=class{constructor(U){this.items=U}};Je=Fe([R],Je),e.InlineSuggestions=Je;var ft;(function(V){V[V.Active=-1]="Active",V[V.Beside=-2]="Beside",V[V.One=1]="One",V[V.Two=2]="Two",V[V.Three=3]="Three",V[V.Four=4]="Four",V[V.Five=5]="Five",V[V.Six=6]="Six",V[V.Seven=7]="Seven",V[V.Eight=8]="Eight",V[V.Nine=9]="Nine"})(ft=e.ViewColumn||(e.ViewColumn={}));var It;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(It=e.StatusBarAlignment||(e.StatusBarAlignment={}));var St;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative"})(St=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var kt;(function(V){V[V.Manual=1]="Manual",V[V.AfterDelay=2]="AfterDelay",V[V.FocusOut=3]="FocusOut"})(kt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var qe;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(qe=e.TextEditorRevealType||(e.TextEditorRevealType={}));var vt;(function(V){V[V.Keyboard=1]="Keyboard",V[V.Mouse=2]="Mouse",V[V.Command=3]="Command"})(vt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Nt;(function(V){V[V.Undo=1]="Undo",V[V.Redo=2]="Redo"})(Nt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var nt;(function(V){V[V.OpenOpen=0]="OpenOpen",V[V.ClosedClosed=1]="ClosedClosed",V[V.OpenClosed=2]="OpenClosed",V[V.ClosedOpen=3]="ClosedOpen"})(nt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(V){function U(ee){switch(ee){case"keyboard":return V.Keyboard;case"mouse":return V.Mouse;case"api":return V.Command}}V.fromValue=U}(vt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ut=class{constructor(U,ee){if(ee&&!L.URI.isUri(ee))throw(0,I.illegalArgument)("target");if(!H.isRange(U)||U.isEmpty)throw(0,I.illegalArgument)("range");this.range=U,this.target=ee}};ut=Fe([R],ut),e.DocumentLink=ut;let At=class{constructor(U,ee,we,We){this.red=U,this.green=ee,this.blue=we,this.alpha=We}};At=Fe([R],At),e.Color=At;let Tt=class{constructor(U,ee){if(ee&&!(ee instanceof At))throw(0,I.illegalArgument)("color");if(!H.isRange(U)||U.isEmpty)throw(0,I.illegalArgument)("range");this.range=U,this.color=ee}};Tt=Fe([R],Tt),e.ColorInformation=Tt;let wt=class{constructor(U){if(!U||typeof U!="string")throw(0,I.illegalArgument)("label");this.label=U}};wt=Fe([R],wt),e.ColorPresentation=wt;var dt;(function(V){V[V.RGB=0]="RGB",V[V.HEX=1]="HEX",V[V.HSL=2]="HSL"})(dt=e.ColorFormat||(e.ColorFormat={}));var Rt;(function(V){V[V.Error=0]="Error",V[V.Warning=1]="Warning",V[V.Information=2]="Information"})(Rt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Lt{constructor(U,ee,we){if(this.startIndex=U,this.length=ee,this.tooltip=we,typeof U!="number"||U<0)throw(0,I.illegalArgument)("startIndex");if(typeof ee!="number"||ee<1)throw(0,I.illegalArgument)("length");if(we!==void 0&&typeof we!="string")throw(0,I.illegalArgument)("tooltip")}}e.TerminalLink=Lt;var Ft;(function(V){V[V.Panel=1]="Panel",V[V.Editor=2]="Editor"})(Ft=e.TerminalLocation||(e.TerminalLocation={}));class Ue{constructor(U){this.options=U,typeof U!="object"&&(0,I.illegalArgument)("options")}}e.TerminalProfile=Ue;var he;(function(V){V[V.Always=1]="Always",V[V.Silent=2]="Silent",V[V.Never=3]="Never"})(he=e.TaskRevealKind||(e.TaskRevealKind={}));var pe;(function(V){V[V.Shared=1]="Shared",V[V.Dedicated=2]="Dedicated",V[V.New=3]="New"})(pe=e.TaskPanelKind||(e.TaskPanelKind={}));let se=a=class{constructor(U,ee){if(this.label=ee,typeof U!="string"||typeof ee!="string")throw(0,I.illegalArgument)("name");this._id=U}static from(U){switch(U){case"clean":return a.Clean;case"build":return a.Build;case"rebuild":return a.Rebuild;case"test":return a.Test;default:return}}get id(){return this._id}};se.Clean=new a("clean","Clean"),se.Build=new a("build","Build"),se.Rebuild=new a("rebuild","Rebuild"),se.Test=new a("test","Test"),se=a=Fe([R],se),e.TaskGroup=se;function K(V){let U="";for(let ee=0;ee<V.length;ee++)U+=V[ee].replace(/,/g,",,")+",";return U}let _e=class{constructor(U,ee,we){if(typeof U!="string")throw(0,I.illegalArgument)("process");this._args=[],this._process=U,ee!==void 0&&(Array.isArray(ee)?(this._args=ee,this._options=we):this._options=ee)}get process(){return this._process}set process(U){if(typeof U!="string")throw(0,I.illegalArgument)("process");this._process=U}get args(){return this._args}set args(U){Array.isArray(U)||(U=[]),this._args=U}get options(){return this._options}set options(U){this._options=U}computeId(){const U=[];if(U.push("process"),this._process!==void 0&&U.push(this._process),this._args&&this._args.length>0)for(let ee of this._args)U.push(ee);return K(U)}};_e=Fe([R],_e),e.ProcessExecution=_e;let Ce=class{constructor(U,ee,we){if(this._args=[],Array.isArray(ee)){if(!U)throw(0,I.illegalArgument)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,I.illegalArgument)("command");this._command=U,this._args=ee,this._options=we}else{if(typeof U!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=U,this._options=ee}}get commandLine(){return this._commandLine}set commandLine(U){if(typeof U!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=U}get command(){return this._command?this._command:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,I.illegalArgument)("command");this._command=U}get args(){return this._args}set args(U){this._args=U||[]}get options(){return this._options}set options(U){this._options=U}computeId(){const U=[];if(U.push("shell"),this._commandLine!==void 0&&U.push(this._commandLine),this._command!==void 0&&U.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ee of this._args)U.push(typeof ee=="string"?ee:ee.value);return K(U)}};Ce=Fe([R],Ce),e.ShellExecution=Ce;var $e;(function(V){V[V.Escape=1]="Escape",V[V.Strong=2]="Strong",V[V.Weak=3]="Weak"})($e=e.ShellQuoting||(e.ShellQuoting={}));var Ve;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace"})(Ve=e.TaskScope||(e.TaskScope={}));class lt{constructor(U){this._callback=U}computeId(){return"customExecution"+(0,M.generateUuid)()}set callback(U){this._callback=U}get callback(){return this._callback}}e.CustomExecution=lt;let gt=p=class{constructor(U,ee,we,We,Ke,Ye){this.__deprecated=!1,this._definition=this.definition=U;let et;typeof ee=="string"?(this._name=this.name=ee,this._source=this.source=we,this.execution=We,et=Ke,this.__deprecated=!0):ee===Ve.Global||ee===Ve.Workspace?(this.target=ee,this._name=this.name=we,this._source=this.source=We,this.execution=Ke,et=Ye):(this.target=ee,this._name=this.name=we,this._source=this.source=We,this.execution=Ke,et=Ye),typeof et=="string"?(this._problemMatchers=[et],this._hasDefinedMatchers=!0):Array.isArray(et)?(this._problemMatchers=et,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(U){this.__id=U}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof _e?this._definition={type:p.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ce?this._definition={type:p.ShellType,id:this._execution.computeId()}:this._execution instanceof lt?this._definition={type:p.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:p.EmptyType,id:(0,M.generateUuid)()}}get definition(){return this._definition}set definition(U){if(U==null)throw(0,I.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=U}get scope(){return this._scope}set target(U){this.clear(),this._scope=U}get name(){return this._name}set name(U){if(typeof U!="string")throw(0,I.illegalArgument)("name");this.clear(),this._name=U}get execution(){return this._execution}set execution(U){U===null&&(U=void 0),this.clear(),this._execution=U;const ee=this._definition.type;(p.EmptyType===ee||p.ProcessType===ee||p.ShellType===ee||p.ExtensionCallbackType===ee)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(U){if(Array.isArray(U))this.clear(),this._problemMatchers=U,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.clear(),this._isBackground=U}get source(){return this._source}set source(U){if(typeof U!="string"||U.length===0)throw(0,I.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=U}get group(){return this._group}set group(U){U===null&&(U=void 0),this.clear(),this._group=U}get detail(){return this._detail}set detail(U){U===null&&(U=void 0),this._detail=U}get presentationOptions(){return this._presentationOptions}set presentationOptions(U){U==null&&(U=Object.create(null)),this.clear(),this._presentationOptions=U}get runOptions(){return this._runOptions}set runOptions(U){U==null&&(U=Object.create(null)),this.clear(),this._runOptions=U}};gt.ExtensionCallbackType="customExecution",gt.ProcessType="process",gt.ShellType="shell",gt.EmptyType="$empty",gt=p=Fe([R],gt),e.Task=gt;var Et;(function(V){V[V.SourceControl=1]="SourceControl",V[V.Window=10]="Window",V[V.Notification=15]="Notification"})(Et=e.ProgressLocation||(e.ProgressLocation={}));let rt=class{constructor(U,ee=at.None){this.collapsibleState=ee,L.URI.isUri(U)?this.resourceUri=U:this.label=U}};rt=Fe([R],rt),e.TreeItem=rt;var at;(function(V){V[V.None=0]="None",V[V.Collapsed=1]="Collapsed",V[V.Expanded=2]="Expanded"})(at=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let ot=class{constructor(U){this.value=U}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}};ot=Fe([R],ot),e.TreeDataTransferItem=ot;let Mt=class{constructor(){this._items=new Map}get(U){return this._items.get(U)}set(U,ee){this._items.set(U,ee)}forEach(U){this._items.forEach(U)}};Mt=Fe([R],Mt),e.TreeDataTransfer=Mt;let mt=class{constructor(U,ee){this.id=U,this.color=ee}};mt=Fe([R],mt),e.ThemeIcon=mt,mt.File=new mt("file"),mt.Folder=new mt("folder");let Dt=class{constructor(U){this.id=U}};Dt=Fe([R],Dt),e.ThemeColor=Dt;var Ut;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace",V[V.WorkspaceFolder=3]="WorkspaceFolder"})(Ut=e.ConfigurationTarget||(e.ConfigurationTarget={}));let bt=class{constructor(U,ee){if(typeof U!="string"&&(!U||!L.URI.isUri(U)&&!L.URI.isUri(U.uri)))throw(0,I.illegalArgument)("base");if(typeof ee!="string")throw(0,I.illegalArgument)("pattern");typeof U=="string"?this.baseUri=L.URI.file(U):L.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=ee}get base(){return this._base}set base(U){this._base=U,this._baseUri=L.URI.file(U)}get baseUri(){return this._baseUri}set baseUri(U){this._baseUri=U,this._base=U.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};bt=Fe([R],bt),e.RelativePattern=bt;let Bt=class{constructor(U,ee,we,We){this.enabled=typeof U=="boolean"?U:!0,typeof ee=="string"&&(this.condition=ee),typeof we=="string"&&(this.hitCondition=we),typeof We=="string"&&(this.logMessage=We)}get id(){return this._id||(this._id=(0,M.generateUuid)()),this._id}};Bt=Fe([R],Bt),e.Breakpoint=Bt;let Ht=class extends Bt{constructor(U,ee,we,We,Ke){super(ee,we,We,Ke);if(U===null)throw(0,I.illegalArgument)("location");this.location=U}};Ht=Fe([R],Ht),e.SourceBreakpoint=Ht;let pt=class extends Bt{constructor(U,ee,we,We,Ke){super(ee,we,We,Ke);this.functionName=U}};pt=Fe([R],pt),e.FunctionBreakpoint=pt;let ei=class extends Bt{constructor(U,ee,we,We,Ke,Ye,et){super(We,Ke,Ye,et);if(!ee)throw(0,I.illegalArgument)("dataId");this.label=U,this.dataId=ee,this.canPersist=we}};ei=Fe([R],ei),e.DataBreakpoint=ei;let Xt=class{constructor(U,ee,we){this.command=U,this.args=ee||[],this.options=we}};Xt=Fe([R],Xt),e.DebugAdapterExecutable=Xt;let ti=class{constructor(U,ee){this.port=U,this.host=ee}};ti=Fe([R],ti),e.DebugAdapterServer=ti;let ai=class{constructor(U){this.path=U}};ai=Fe([R],ai),e.DebugAdapterNamedPipeServer=ai;let Ct=class{constructor(U){this.implementation=U}};Ct=Fe([R],Ct),e.DebugAdapterInlineImplementation=Ct;let ii=class{constructor(U,ee){this.range=U,this.expression=ee}};ii=Fe([R],ii),e.EvaluatableExpression=ii;var wi;(function(V){V[V.Automatic=0]="Automatic",V[V.Explicit=1]="Explicit"})(wi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let qt=class{constructor(U,ee){this.range=U,this.text=ee}};qt=Fe([R],qt),e.InlineValueText=qt;let Kt=class{constructor(U,ee,we=!0){this.range=U,this.variableName=ee,this.caseSensitiveLookup=we}};Kt=Fe([R],Kt),e.InlineValueVariableLookup=Kt;let st=class{constructor(U,ee){this.range=U,this.expression=ee}};st=Fe([R],st),e.InlineValueEvaluatableExpression=st;let li=class{constructor(U,ee){this.frameId=U,this.stoppedLocation=ee}};li=Fe([R],li),e.InlineValueContext=li;var Wt;(function(V){V[V.Changed=1]="Changed",V[V.Created=2]="Created",V[V.Deleted=3]="Deleted"})(Wt=e.FileChangeType||(e.FileChangeType={}));let zt=h=class extends Error{constructor(U,ee=v.FileSystemProviderErrorCode.Unknown,we){super(L.URI.isUri(U)?U.toString(!0):U);this.code=we?.name??"Unknown",(0,v.markAsFileSystemProviderError)(this,ee),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,h.prototype),typeof Error.captureStackTrace=="function"&&typeof we=="function"&&Error.captureStackTrace(this,we)}static FileExists(U){return new h(U,v.FileSystemProviderErrorCode.FileExists,h.FileExists)}static FileNotFound(U){return new h(U,v.FileSystemProviderErrorCode.FileNotFound,h.FileNotFound)}static FileNotADirectory(U){return new h(U,v.FileSystemProviderErrorCode.FileNotADirectory,h.FileNotADirectory)}static FileIsADirectory(U){return new h(U,v.FileSystemProviderErrorCode.FileIsADirectory,h.FileIsADirectory)}static NoPermissions(U){return new h(U,v.FileSystemProviderErrorCode.NoPermissions,h.NoPermissions)}static Unavailable(U){return new h(U,v.FileSystemProviderErrorCode.Unavailable,h.Unavailable)}};zt=h=Fe([R],zt),e.FileSystemError=zt;let ni=class{constructor(U,ee,we){this.start=U,this.end=ee,this.kind=we}};ni=Fe([R],ni),e.FoldingRange=ni;var _i;(function(V){V[V.Comment=1]="Comment",V[V.Imports=2]="Imports",V[V.Region=3]="Region"})(_i=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fi;(function(V){V[V.Collapsed=0]="Collapsed",V[V.Expanded=1]="Expanded"})(fi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Si;(function(V){V[V.Editing=0]="Editing",V[V.Preview=1]="Preview"})(Si=e.CommentMode||(e.CommentMode={}));var mi;(function(V){V[V.Unresolved=0]="Unresolved",V[V.Resolved=1]="Resolved"})(mi=e.CommentThreadState||(e.CommentThreadState={}));class ri{constructor(U,ee=[]){this.tokenTypes=U,this.tokenModifiers=ee}}e.SemanticTokensLegend=ri;function yi(V){return typeof V=="undefined"||(0,C.isStringArray)(V)}class Qt{constructor(U){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,U){this._hasLegend=!0;for(let ee=0,we=U.tokenTypes.length;ee<we;ee++)this._tokenTypeStrToInt.set(U.tokenTypes[ee],ee);for(let ee=0,we=U.tokenModifiers.length;ee<we;ee++)this._tokenModifierStrToInt.set(U.tokenModifiers[ee],ee)}}push(U,ee,we,We,Ke){if(typeof U=="number"&&typeof ee=="number"&&typeof we=="number"&&typeof We=="number"&&(typeof Ke=="number"||typeof Ke=="undefined"))return typeof Ke=="undefined"&&(Ke=0),this._pushEncoded(U,ee,we,We,Ke);if(H.isRange(U)&&typeof ee=="string"&&yi(we))return this._push(U,ee,we);throw(0,I.illegalArgument)()}_push(U,ee,we){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ee))throw new Error("`tokenType` is not in the provided legend");const We=U.start.line,Ke=U.start.character,Ye=U.end.character-U.start.character,et=this._tokenTypeStrToInt.get(ee);let _t=0;if(we)for(const Pt of we){if(!this._tokenModifierStrToInt.has(Pt))throw new Error("`tokenModifier` is not in the provided legend");const xt=this._tokenModifierStrToInt.get(Pt);_t|=1<<xt>>>0}this._pushEncoded(We,Ke,Ye,et,_t)}_pushEncoded(U,ee,we,We,Ke){if(this._dataIsSortedAndDeltaEncoded&&(U<this._prevLine||U===this._prevLine&&ee<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const _t=this._data.length/5|0;let Pt=0,xt=0;for(let $t=0;$t<_t;$t++){let Vt=this._data[5*$t],di=this._data[5*$t+1];Vt===0?(Vt=Pt,di+=xt):Vt+=Pt,this._data[5*$t]=Vt,this._data[5*$t+1]=di,Pt=Vt,xt=di}}let Ye=U,et=ee;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Ye-=this._prevLine,Ye===0&&(et-=this._prevChar)),this._data[this._dataLen++]=Ye,this._data[this._dataLen++]=et,this._data[this._dataLen++]=we,this._data[this._dataLen++]=We,this._data[this._dataLen++]=Ke,this._prevLine=U,this._prevChar=ee}static _sortAndDeltaEncode(U){let ee=[];const we=U.length/5|0;for(let et=0;et<we;et++)ee[et]=et;ee.sort((et,_t)=>{const Pt=U[5*et],xt=U[5*_t];if(Pt===xt){const $t=U[5*et+1],Vt=U[5*_t+1];return $t-Vt}return Pt-xt});const We=new Uint32Array(U.length);let Ke=0,Ye=0;for(let et=0;et<we;et++){const _t=5*ee[et],Pt=U[_t+0],xt=U[_t+1],$t=U[_t+2],Vt=U[_t+3],di=U[_t+4],zi=Pt-Ke,Ji=zi===0?xt-Ye:xt,hi=5*et;We[hi+0]=zi,We[hi+1]=Ji,We[hi+2]=$t,We[hi+3]=Vt,We[hi+4]=di,Ke=Pt,Ye=xt}return We}build(U){return this._dataIsSortedAndDeltaEncoded?new Yt(new Uint32Array(this._data),U):new Yt(Qt._sortAndDeltaEncode(this._data),U)}}e.SemanticTokensBuilder=Qt;class Yt{constructor(U,ee){this.resultId=ee,this.data=U}}e.SemanticTokens=Yt;class Di{constructor(U,ee,we){this.start=U,this.deleteCount=ee,this.data=we}}e.SemanticTokensEdit=Di;class Ci{constructor(U,ee){this.resultId=ee,this.edits=U}}e.SemanticTokensEdits=Ci;var Jt;(function(V){V[V.Separate=0]="Separate",V[V.MergeWithParent=1]="MergeWithParent"})(Jt=e.DebugConsoleMode||(e.DebugConsoleMode={}));let si=class{constructor(){}};si.Back={iconPath:new mt("arrow-left")},si=Fe([R],si),e.QuickInputButtons=si;var Ii;(function(V){V[V.Separator=-1]="Separator",V[V.Default=0]="Default"})(Ii=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(V){V[V.UI=1]="UI",V[V.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class Ti{constructor(U,ee,we){this.badge=U,this.tooltip=ee,this.color=we}static validate(U){if(U.badge){let ee=(0,A.nextCharLength)(U.badge,0);if(ee<U.badge.length&&(ee+=(0,A.nextCharLength)(U.badge,ee)),U.badge.length>ee)throw new Error("The 'badge'-property must be undefined or a short character")}if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Ti;let Zt=class{constructor(U){this.kind=U}};Zt=Fe([R],Zt),e.ColorTheme=Zt;var gi;(function(V){V[V.Light=1]="Light",V[V.Dark=2]="Dark",V[V.HighContrast=3]="HighContrast"})(gi=e.ColorThemeKind||(e.ColorThemeKind={}));class Gt{constructor(U,ee){if(U<0)throw(0,I.illegalArgument)("start must be positive");if(ee<0)throw(0,I.illegalArgument)("end must be positive");U<=ee?(this._start=U,this._end=ee):(this._start=ee,this._end=U)}static isNotebookRange(U){return U instanceof Gt?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(U){let ee=this._start,we=this._end;return U.start!==void 0&&(ee=U.start),U.end!==void 0&&(we=U.end),ee===this._start&&we===this._end?this:new Gt(ee,we)}}e.NotebookRange=Gt;class Pe{constructor(U,ee,we,We,Ke,Ye,et){this.kind=U,this.value=ee,this.languageId=we,this.mime=We,this.outputs=Ke??[],this.metadata=Ye,this.executionSummary=et,Pe.validate(this)}static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(ee=>Pe.isNotebookCellData(ee))}static isNotebookCellData(U){return!0}}e.NotebookCellData=Pe;class ci{constructor(U){this.cells=U}}e.NotebookData=ci;class Ot{constructor(U,ee){this.data=U,this.mime=ee;const we=(0,S.normalizeMimeType)(ee,!0);if(!we)throw new Error(`INVALID mime type: ${ee}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=we}static isNotebookCellOutputItem(U){return U instanceof Ot?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const ee={name:U.name,message:U.message,stack:U.stack};return Ot.json(ee,"application/vnd.code.notebook.error")}static stdout(U){return Ot.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return Ot.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,ee="application/octet-stream"){return new Ot(U,ee)}static text(U,ee=S.Mimes.text){const we=De(Ot,n,"f",m).encode(String(U));return new Ot(we,ee)}static json(U,ee="application/json"){const we=JSON.stringify(U,void 0,"	");return Ot.text(we,ee)}}e.NotebookCellOutputItem=Ot,n=Ot,m={value:new TextEncoder};class ct{constructor(U,ee,we){this.items=ct.ensureUniqueMimeTypes(U,!0),typeof ee=="string"?(this.id=ee,this.metadata=we):(this.id=(0,M.generateUuid)(),this.metadata=ee??we)}static isNotebookCellOutput(U){return U instanceof ct?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&(0,C.isArray)(U.items)}static ensureUniqueMimeTypes(U,ee=!1){const we=new Set,We=new Set;for(let Ke=0;Ke<U.length;Ke++){const Ye=U[Ke],et=(0,S.normalizeMimeType)(Ye.mime);if(!we.has(et)){we.add(et);continue}We.add(Ke),ee&&console.warn(`DUPLICATED mime type '${Ye.mime}' will be dropped`)}return We.size===0?U:U.filter((Ke,Ye)=>!We.has(Ye))}}e.NotebookCellOutput=ct;var Pi;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(Pi=e.NotebookCellKind||(e.NotebookCellKind={}));var Ai;(function(V){V[V.Idle=1]="Idle",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(Ai=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var pi;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(pi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var vi;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(vi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ri{constructor(U,ee){this.text=U,this.alignment=ee}}e.NotebookCellStatusBarItem=Ri;var Oi;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred"})(Oi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Fi{constructor(U,ee=[]){this.uri=U,this.provides=(0,o.asArray)(ee)}}e.NotebookRendererScript=Fi;let ui=class{constructor(U,ee){this.label=U,this.timestamp=ee}};ui=Fe([R],ui),e.TimelineItem=ui;var Ei;(function(V){V[V.Production=1]="Production",V[V.Development=2]="Development",V[V.Test=3]="Test"})(Ei=e.ExtensionMode||(e.ExtensionMode={}));var Mi;(function(V){V[V.Node=1]="Node",V[V.Webworker=2]="Webworker"})(Mi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ni;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=3]="RegEx"})(Ni=e.StandardTokenType||(e.StandardTokenType={}));class Li{constructor(U,ee){this.ranges=U,this.wordPattern=ee}}e.LinkedEditingRanges=Li;class Ui{constructor(U,ee){this._port=U,this._autoForwardAction=ee}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ui;var Bi;(function(V){V[V.Queued=1]="Queued",V[V.Running=2]="Running",V[V.Passed=3]="Passed",V[V.Failed=4]="Failed",V[V.Skipped=5]="Skipped",V[V.Errored=6]="Errored"})(Bi=e.TestResultState||(e.TestResultState={}));var Z;(function(V){V[V.Run=1]="Run",V[V.Debug=2]="Debug",V[V.Coverage=3]="Coverage"})(Z=e.TestRunProfileKind||(e.TestRunProfileKind={}));let oe=class{constructor(U=void 0,ee=void 0,we=void 0){this.include=U,this.exclude=ee,this.profile=we}};oe=Fe([R],oe),e.TestRunRequest=oe;let ye=_=class{constructor(U){this.message=U}static diff(U,ee,we){const We=new _(U);return We.expectedOutput=ee,We.actualOutput=we,We}};ye=_=Fe([R],ye),e.TestMessage=ye;let Ze=class{constructor(U){this.id=U}};Ze=Fe([R],Ze),e.TestTag=Ze;let ht=class{constructor(U,ee){this.covered=U,this.total=ee}};ht=Fe([R],ht),e.CoveredCount=ht;let yt=T=class{constructor(U,ee,we,We){this.uri=U,this.statementCoverage=ee,this.branchCoverage=we,this.functionCoverage=We}static fromDetails(U,ee){const we=new ht(0,0),We=new ht(0,0),Ke=new ht(0,0);for(const et of ee)if("branches"in et){we.total+=1,we.covered+=et.executionCount>0?1:0;for(const _t of et.branches)We.total+=1,We.covered+=_t.executionCount>0?1:0}else Ke.total+=1,Ke.covered+=et.executionCount>0?1:0;const Ye=new T(U,we,We.total>0?We:void 0,Ke.total>0?Ke:void 0);return Ye.detailedCoverage=ee,Ye}};yt=T=Fe([R],yt),e.FileCoverage=yt;let xi=class{constructor(U,ee,we=[]){this.executionCount=U,this.location=ee,this.branches=we}};xi=Fe([R],xi),e.StatementCoverage=xi;let $i=class{constructor(U,ee){this.executionCount=U,this.location=ee}};$i=Fe([R],$i),e.BranchCoverage=$i;let Hi=class{constructor(U,ee){this.executionCount=U,this.location=ee}};Hi=Fe([R],Hi),e.FunctionCoverage=Hi;var Gi;(function(V){V[V.None=0]="None",V[V.Option=1]="Option",V[V.Default=2]="Default",V[V.Preferred=3]="Preferred"})(Gi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Xi;(function(V){V[V.Untrusted=0]="Untrusted",V[V.Trusted=1]="Trusted",V[V.Unspecified=2]="Unspecified"})(Xi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Qi;(function(V){V[V.Notify=1]="Notify",V[V.OpenBrowser=2]="OpenBrowser",V[V.OpenPreview=3]="OpenPreview",V[V.Silent=4]="Silent",V[V.Ignore=5]="Ignore",V[V.OpenBrowserOnce=6]="OpenBrowserOnce"})(Qi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Yi{constructor(U,ee,we,We,Ke,Ye){this.kind=U,this.name=ee,this.detail=we,this.uri=We,this.range=Ke,this.selectionRange=Ye}}e.TypeHierarchyItem=Yi}),define(Ee[84],be([1,0,42,9,10,226,116,7,16]),function(Y,e,o,I,w,B,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const L=new Map;function M(r,n){n?L.set(r,n):L.delete(r)}e.setWordDefinitionFor=M;function v(r){return L.get(r)}e.getWordDefinitionFor=v;class c extends B.MirrorTextModel{constructor(n,m,y,k,d,f,b,l){super(m,y,k,d);this._proxy=n,this._languageId=f,this._isDirty=b,this._notebook=l,this._isDisposed=!1}dispose(){(0,o.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(n){return(0,C.equals)(this._lines,n)}get document(){if(!this._document){const n=this;this._document={get uri(){return n._uri},get fileName(){return n._uri.fsPath},get isUntitled(){return n._uri.scheme===I.Schemas.untitled},get languageId(){return n._languageId},get version(){return n._versionId},get isClosed(){return n._isDisposed},get isDirty(){return n._isDirty},get notebook(){return n._notebook},save(){return n._save()},getText(m){return m?n._getTextInRange(m):n.getText()},get eol(){return n._eol===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return n._lines.length},lineAt(m){return n._lineAt(m)},offsetAt(m){return n._offsetAt(m)},positionAt(m){return n._positionAt(m)},validateRange(m){return n._validateRange(m)},validatePosition(m){return n._validatePosition(m)},getWordRangeAtPosition(m,y){return n._getWordRangeAtPosition(m,y)}}}return Object.freeze(this._document)}_acceptLanguageId(n){(0,o.ok)(!this._isDisposed),this._languageId=n}_acceptIsDirty(n){(0,o.ok)(!this._isDisposed),this._isDirty=n}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(n){const m=this._validateRange(n);if(m.isEmpty)return"";if(m.isSingleLine)return this._lines[m.start.line].substring(m.start.character,m.end.character);const y=this._eol,k=m.start.line,d=m.end.line,f=[];f.push(this._lines[k].substring(m.start.character));for(let b=k+1;b<d;b++)f.push(this._lines[b]);return f.push(this._lines[d].substring(0,m.end.character)),f.join(y)}_lineAt(n){let m;if(n instanceof A.Position?m=n.line:typeof n=="number"&&(m=n),typeof m!="number"||m<0||m>=this._lines.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new g(m,this._lines[m],m===this._lines.length-1)}_offsetAt(n){return n=this._validatePosition(n),this._ensureLineStarts(),this._lineStarts.getPrefixSum(n.line-1)+n.character}_positionAt(n){n=Math.floor(n),n=Math.max(0,n),this._ensureLineStarts();const m=this._lineStarts.getIndexOf(n),y=this._lines[m.index].length;return new A.Position(m.index,Math.min(m.remainder,y))}_validateRange(n){if(!(n instanceof A.Range))throw new Error("Invalid argument");const m=this._validatePosition(n.start),y=this._validatePosition(n.end);return m===n.start&&y===n.end?n:new A.Range(m.line,m.character,y.line,y.character)}_validatePosition(n){if(!(n instanceof A.Position))throw new Error("Invalid argument");if(this._lines.length===0)return n.with(0,0);let{line:m,character:y}=n,k=!1;if(m<0)m=0,y=0,k=!0;else if(m>=this._lines.length)m=this._lines.length-1,y=this._lines[m].length,k=!0;else{const d=this._lines[m].length;y<0?(y=0,k=!0):y>d&&(y=d,k=!0)}return k?new A.Position(m,y):n}_getWordRangeAtPosition(n,m){const y=this._validatePosition(n);if(!m)m=v(this._languageId);else if((0,w.regExpLeadsToEndlessLoop)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const k=(0,S.getWordAtText)(y.character+1,(0,S.ensureValidWordDefinition)(m),this._lines[y.line],0);if(k)return new A.Range(y.line,k.startColumn-1,y.line,k.endColumn-1)}}e.ExtHostDocumentData=c;class g{constructor(n,m,y){this._line=n,this._text=m,this._isLastLine=y}get lineNumber(){return this._line}get text(){return this._text}get range(){return new A.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new A.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=g}),define(Ee[152],be([1,0,7,5,227,6,74,22,2,36]),function(Y,e,o,I,w,B,S,A,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class M{constructor(c,g,r,n){this._notebook=r,this._selector=n,this._disposables=new B.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this.uri=C.URI.from({scheme:"vscode-concat-doc",path:(0,L.generateUuid)()}),this._init(),this._disposables.add(g.onDidChangeDocument(y=>{const k=this._cellUris.get(y.document.uri);k!==void 0&&(this._cellLengths.setValue(k,this._cells[k].document.getText().length+1),this._cellLines.setValue(k,this._cells[k].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const m=y=>{y===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(c.onDidChangeNotebookCells(y=>m(y.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new A.ResourceMap;const c=[],g=[];for(const r of this._notebook.getCells())r.kind===o.NotebookCellKind.Code&&(!this._selector||(0,S.score)(this._selector,r.document.uri,r.document.languageId,!0,void 0))&&(this._cellUris.set(r.document.uri,this._cells.length),this._cells.push(r),c.push(r.document.getText().length+1),g.push(r.document.lineCount));this._cellLengths=new w.PrefixSumComputer(new Uint32Array(c)),this._cellLines=new w.PrefixSumComputer(new Uint32Array(g))}get version(){return this._versionId}getText(c){if(!c){let k="";for(const d of this._cells)k+=d.document.getText()+`
`;return k=k.slice(0,-1),k}if(c.isEmpty)return"";const g=this.locationAt(c.start),r=this.locationAt(c.end),n=this._cellUris.get(g.uri),m=this._cellUris.get(r.uri);if(n===void 0||m===void 0)return"";if(n===m)return this._cells[n].document.getText(new o.Range(g.range.start,r.range.end));const y=[this._cells[n].document.getText(new o.Range(g.range.start,new o.Position(this._cells[n].document.lineCount,0)))];for(let k=n+1;k<m;k++)y.push(this._cells[k].document.getText());return y.push(this._cells[m].document.getText(new o.Range(new o.Position(0,0),r.range.end))),y.join(`
`)}offsetAt(c){const g=this._cellLines.getIndexOf(c.line),r=this._cellLengths.getPrefixSum(g.index-1),n=this._cells[g.index].document.offsetAt(c.with(g.remainder));return r+n}positionAt(c){if(typeof c=="number"){const r=this._cellLengths.getIndexOf(c),n=this._cellLines.getPrefixSum(r.index-1);return this._cells[r.index].document.positionAt(r.remainder).translate(n)}const g=this._cellUris.get(c.uri);if(g!==void 0){const r=this._cellLines.getPrefixSum(g-1);return new o.Position(r+c.range.start.line,c.range.start.character)}return new o.Position(0,0)}locationAt(c){o.Range.isRange(c)||(c=new o.Range(c,c));const g=this._cellLines.getIndexOf(c.start.line);let r=g;c.isEmpty||(r=this._cellLines.getIndexOf(c.end.line));const n=new o.Position(g.remainder,c.start.character),m=new o.Position(r.remainder,c.end.character),y=new o.Range(n,m),k=this._cells[g.index];return new o.Location(k.document.uri,k.document.validateRange(y))}contains(c){return this._cellUris.has(c)}validateRange(c){const g=this.validatePosition(c.start),r=this.validatePosition(c.end);return c.with(g,r)}validatePosition(c){const g=this._cellLines.getIndexOf(c.line),r=new o.Position(g.remainder,c.character),n=this._cells[g.index].document.validatePosition(r),m=this._cellLines.getPrefixSum(g.index-1);return new o.Position(m+n.line,n.character)}}e.ExtHostNotebookConcatDocument=M}),define(Ee[153],be([1,0,7,14,5]),function(Y,e,o,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let B=class{constructor(A){this._actual=new o.ColorTheme(o.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new w.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(A){let C=A==="light"?o.ColorThemeKind.Light:A==="dark"?o.ColorThemeKind.Dark:o.ColorThemeKind.HighContrast;this._actual=new o.ColorTheme(C),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};B=Fe([Ne(0,I.IExtHostRpcService)],B),e.ExtHostTheming=B}),define(Ee[60],be([1,0,3]),function(Y,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,o.createDecorator)("IURITransformerService");class I{constructor(B){B?(this.transformIncoming=B.transformIncoming.bind(B),this.transformOutgoing=B.transformOutgoing.bind(B),this.transformOutgoingURI=B.transformOutgoingURI.bind(B),this.transformOutgoingScheme=B.transformOutgoingScheme.bind(B)):(this.transformIncoming=S=>S,this.transformOutgoing=S=>S,this.transformOutgoingURI=S=>S,this.transformOutgoingScheme=S=>S)}}e.URITransformerService=I}),define(Ee[154],be([1,0,21]),function(Y,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class I{constructor(){this.buffers=[]}add(C){let L=this.buffers.indexOf(C);return L<0&&(L=this.buffers.length,this.buffers.push(C)),L}}function w(A,C){if(C.serializeBuffersForPostMessage){const L=new I,M=(g,r)=>{if(r instanceof ArrayBuffer){const n=L.add(r);return{$$vscode_array_buffer_reference$$:!0,index:n}}else if(ArrayBuffer.isView(r)){const n=B(r);if(n){const m=L.add(r.buffer);return{$$vscode_array_buffer_reference$$:!0,index:m,view:{type:n,byteLength:r.byteLength,byteOffset:r.byteOffset}}}}return r},v=JSON.stringify(A,M),c=L.buffers.map(g=>{const r=new Uint8Array(g);return o.VSBuffer.wrap(r)});return{message:v,buffers:c}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=w;function B(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function S(A,C){const L=C.map(c=>{const g=new ArrayBuffer(c.byteLength);return new Uint8Array(g).set(c.buffer),g}),M=C.length?(c,g)=>{if(g&&typeof g=="object"&&g.$$vscode_array_buffer_reference$$){const r=g,{index:n}=r,m=L[n];if(r.view)switch(r.view.type){case 1:return new Int8Array(m,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(m,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(m,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(m,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(m,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(m,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(m,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(m,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(m,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(m,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(m,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return m}return g}:void 0;return{message:JSON.parse(A,M),arrayBuffers:L}}e.deserializeWebviewMessage=S}),define(Ee[155],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var o;(function(I){function w(S){const A=new Map;return S.types.forEach((C,L)=>{A.set(C,{asString:async()=>S.items[L].asString,value:void 0})}),A}I.toITreeDataTransfer=w;async function B(S){const A={types:[],items:[]},C=Array.from(S.entries());for(const L of C)A.types.push(L[0]),A.items.push({asString:await L[1].asString()});return A}I.toTreeDataTransferDTO=B})(o=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(Ee[156],be([1,0,129,11,2,6,3,37,45,16,9]),function(Y,e,o,I,w,B,S,A,C,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,o.localize)(0,null),providerDisplayName:(0,o.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var v;(function($){$[$.PROGRAMMATIC=1]="PROGRAMMATIC",$[$.USER=2]="USER",$[$.EDIT=3]="EDIT",$[$.NAVIGATION=4]="NAVIGATION",$[$.JUMP=5]="JUMP"})(v=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var c;(function($){$[$.IDENTICAL=1]="IDENTICAL",$[$.SIMILAR=2]="SIMILAR",$[$.DIFFERENT=3]="DIFFERENT"})(c=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function g($){const j=$;return!!j&&typeof j.getSelection=="function"&&!!j.onDidChangeSelection}e.isEditorPaneWithSelection=g;function r($,j,J){for(const z of J.visibleEditorPanes)if(z.group.id===j&&$.matches(z.input))return z.getViewState()}e.findViewStateForEditor=r;function n($){if(P($))return!1;const j=$;return w.URI.isUri(j?.resource)}e.isResourceEditorInput=n;function m($){if(P($))return!1;const j=$;return j?.original!==void 0&&j.modified!==void 0}e.isResourceDiffEditorInput=m;function y($){if(P($)||m($))return!1;const j=$;return j?.primary!==void 0&&j.secondary!==void 0}e.isResourceSideBySideEditorInput=y;function k($){if(P($))return!1;const j=$;return j?j.resource===void 0||j.resource.scheme===M.Schemas.untitled||j.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=k;var d;(function($){$[$.SHORT=0]="SHORT",$[$.MEDIUM=1]="MEDIUM",$[$.LONG=2]="LONG"})(d=e.Verbosity||(e.Verbosity={}));var f;(function($){$[$.EXPLICIT=1]="EXPLICIT",$[$.AUTO=2]="AUTO",$[$.FOCUS_CHANGE=3]="FOCUS_CHANGE",$[$.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(f=e.SaveReason||(e.SaveReason={}));var b;(function($){$[$.None=0]="None",$[$.Readonly=2]="Readonly",$[$.Untitled=4]="Untitled",$[$.Singleton=8]="Singleton",$[$.RequiresTrust=16]="RequiresTrust",$[$.CanSplitInGroup=32]="CanSplitInGroup",$[$.ForceDescription=64]="ForceDescription"})(b=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class l extends B.Disposable{}e.AbstractEditorInput=l;function P($){return $ instanceof l}e.isEditorInput=P;function u($){const j=$;return w.URI.isUri(j?.preferredResource)}function i($){const j=$;return P(j?.primary)&&P(j?.secondary)}e.isSideBySideEditorInput=i;function s($){const j=$;return P(j?.modified)&&P(j?.original)}e.isDiffEditorInput=s;function t($){return P($?.editor)}e.isEditorInputWithOptions=t;function a($){const j=$;return t($)&&j?.group!==void 0}e.isEditorInputWithOptionsAndGroup=a;function p($){const j=$;return typeof j?.groupId=="number"&&P(j.editor)}e.isEditorIdentifier=p;var h;(function($){$[$.UNKNOWN=0]="UNKNOWN",$[$.REPLACE=1]="REPLACE",$[$.MOVE=2]="MOVE",$[$.UNPIN=3]="UNPIN"})(h=e.EditorCloseContext||(e.EditorCloseContext={}));var _;(function($){$[$.GROUP_ACTIVE=0]="GROUP_ACTIVE",$[$.GROUP_INDEX=1]="GROUP_INDEX",$[$.GROUP_LOCKED=2]="GROUP_LOCKED",$[$.EDITOR_OPEN=3]="EDITOR_OPEN",$[$.EDITOR_CLOSE=4]="EDITOR_CLOSE",$[$.EDITOR_MOVE=5]="EDITOR_MOVE",$[$.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",$[$.EDITOR_LABEL=7]="EDITOR_LABEL",$[$.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",$[$.EDITOR_PIN=9]="EDITOR_PIN",$[$.EDITOR_STICKY=10]="EDITOR_STICKY",$[$.EDITOR_DIRTY=11]="EDITOR_DIRTY",$[$.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(_=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var T;(function($){$[$.PRIMARY=1]="PRIMARY",$[$.SECONDARY=2]="SECONDARY",$[$.BOTH=3]="BOTH",$[$.ANY=4]="ANY"})(T=e.SideBySideEditor||(e.SideBySideEditor={}));class R{getOriginalUri(j,J){if(!j)return;if(J?.supportSideBySide){const{primary:ie,secondary:ae}=this.getSideEditors(j);if(ie&&ae){if(J?.supportSideBySide===T.BOTH)return{primary:this.getOriginalUri(ie,{filterByScheme:J.filterByScheme}),secondary:this.getOriginalUri(ae,{filterByScheme:J.filterByScheme})};if(J?.supportSideBySide===T.ANY)return this.getOriginalUri(ie,{filterByScheme:J.filterByScheme})??this.getOriginalUri(ae,{filterByScheme:J.filterByScheme});j=J.supportSideBySide===T.PRIMARY?ie:ae}}if(m(j)||y(j))return;const z=u(j)?j.preferredResource:j.resource;return!z||!J||!J.filterByScheme?z:this.filterUri(z,J.filterByScheme)}getSideEditors(j){return i(j)||y(j)?{primary:j.primary,secondary:j.secondary}:s(j)||m(j)?{primary:j.modified,secondary:j.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(j,J){if(!j)return;if(J?.supportSideBySide){const{primary:ie,secondary:ae}=this.getSideEditors(j);if(ie&&ae){if(J?.supportSideBySide===T.BOTH)return{primary:this.getCanonicalUri(ie,{filterByScheme:J.filterByScheme}),secondary:this.getCanonicalUri(ae,{filterByScheme:J.filterByScheme})};if(J?.supportSideBySide===T.ANY)return this.getCanonicalUri(ie,{filterByScheme:J.filterByScheme})??this.getCanonicalUri(ae,{filterByScheme:J.filterByScheme});j=J.supportSideBySide===T.PRIMARY?ie:ae}}if(m(j)||y(j))return;const z=j.resource;return!z||!J||!J.filterByScheme?z:this.filterUri(z,J.filterByScheme)}filterUri(j,J){if(Array.isArray(J)){if(J.some(z=>j.scheme===z))return j}else if(J===j.scheme)return j}}e.EditorResourceAccessor=new R;var W;(function($){$[$.LEFT=0]="LEFT",$[$.RIGHT=1]="RIGHT"})(W=e.CloseDirection||(e.CloseDirection={}));class E{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(j){const J=this.instantiationService=j.get(S.IInstantiationService);for(const[z,ie]of this.editorSerializerConstructors)this.createEditorSerializer(z,ie,J);this.editorSerializerConstructors.clear()}createEditorSerializer(j,J,z){const ie=z.createInstance(J);this.editorSerializerInstances.set(j,ie)}registerFileEditorFactory(j){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=j}getFileEditorFactory(){return(0,I.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(j,J){if(this.editorSerializerConstructors.has(j)||this.editorSerializerInstances.has(j))throw new Error(`A editor serializer with type ID '${j}' was already registered.`);return this.instantiationService?this.createEditorSerializer(j,J,this.instantiationService):this.editorSerializerConstructors.set(j,J),(0,B.toDisposable)(()=>{this.editorSerializerConstructors.delete(j),this.editorSerializerInstances.delete(j)})}getEditorSerializer(j){return this.editorSerializerInstances.get(typeof j=="string"?j:j.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new E);async function H($,j){if(!$||!$.length)return[];const J=await Promise.all($.map(async z=>{const ie=w.URI.revive(z.fileUri);if(!ie||!await j.canHandleResource(ie))return;let te=z.exists,ce=z.type;if(typeof te!="boolean"||typeof ce!="number")try{ce=(await j.stat(ie)).isDirectory?C.FileType.Directory:C.FileType.Unknown,te=!0}catch{te=!1}if(!te&&z.openOnlyIfExists||ce===C.FileType.Directory)return;const de={selection:te?z.selection:void 0,pinned:!0,override:z.editorOverrideId};let Se;return te?Se={resource:ie,options:de}:Se={resource:ie,options:de,forceUntitled:!0},Se}));return(0,L.coalesce)(J)}e.pathsToEditors=H;var q;(function($){$[$.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",$[$.SEQUENTIAL=1]="SEQUENTIAL"})(q=e.EditorsOrder||(e.EditorsOrder={}))}),define(Ee[61],be([1,0,9,2]),function(Y,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function w(A,C){return A.scheme===o.Schemas.http||A.scheme===o.Schemas.https?A:(C&&C.authority&&C.isRemote&&A.scheme===o.Schemas.file&&(A=I.URI.from({scheme:o.Schemas.vscodeRemote,authority:C.authority,path:A.path})),I.URI.from({scheme:o.Schemas.https,authority:`${A.scheme}+${B(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=w;function B(A){return A.replace(/./g,C=>{const L=C.charCodeAt(0);return L>=97&&L<=122||L>=65&&L<=90||L>=48&&L<=57?C:"-"+L.toString(16).padStart(4,"0")})}function S(A){return A.replace(/-([0-9a-f]{4})/g,(C,L)=>String.fromCharCode(parseInt(L,16)))}e.decodeAuthority=S}),define(Ee[157],be([1,0,5,6,61]),function(Y,e,o,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class B{constructor(A,C,L){this._proxy=A,this._editors=C,this._initData=L,this._handlePool=0,this._disposables=new I.DisposableStore,this._insets=new Map,this._disposables.add(C.onDidChangeVisibleTextEditors(()=>{const M=C.getVisibleTextEditors();for(const v of this._insets.values())M.indexOf(v.editor)<0&&v.inset.dispose()}))}dispose(){this._insets.forEach(A=>A.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(A,C,L,M,v){let c;for(const d of this._editors.getVisibleTextEditors(!0))if(d.value===A){c=d;break}if(!c)throw new Error("not a visible editor");const g=this,r=this._handlePool++,n=new o.Emitter,m=new o.Emitter,y=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(d){return(0,w.asWebviewUri)(d,g._initData.remote)}get cspSource(){return w.webviewGenericCspSource}set options(d){this._options=d,g._proxy.$setOptions(r,d)}get options(){return this._options}set html(d){this._html=d,g._proxy.$setHtml(r,d)}get html(){return this._html}get onDidReceiveMessage(){return n.event}postMessage(d){return g._proxy.$postMessage(r,d)}},k=new class{constructor(){this.editor=A,this.line=C,this.height=L,this.webview=y,this.onDidDispose=m.event}dispose(){g._insets.has(r)&&(g._insets.delete(r),g._proxy.$disposeEditorInset(r),m.fire(),m.dispose(),n.dispose())}};return this._proxy.$createEditorInset(r,c.id,c.value.document.uri,C+1,L,M||{},v.identifier,v.extensionLocation),this._insets.set(r,{editor:A,inset:k,onDidReceiveMessage:n}),k}$onDidDispose(A){const C=this._insets.get(A);C&&C.inset.dispose()}$onDidReceiveMessage(A,C){const L=this._insets.get(A);L&&L.onDidReceiveMessage.fire(C)}}e.ExtHostEditorInsets=B}),define(Ee[158],be([1,0,5,13,130]),function(Y,e,o,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class B{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new o.Emitter,this._onExit=new o.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(A){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=A}onEvent(A){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=A}onRequest(A){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=A}sendResponse(A){A.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.internalSend("response",A)}sendRequest(A,C,L,M){const v={command:A};if(C&&Object.keys(C).length>0&&(v.arguments=C),this.internalSend("request",v),typeof M=="number"){const c=setTimeout(()=>{clearTimeout(c);const g=this.pendingRequests.get(v.seq);if(g){this.pendingRequests.delete(v.seq);const r={type:"response",seq:0,request_seq:v.seq,success:!1,command:A,message:(0,w.localize)(0,null,M,A)};g(r)}},M)}return L&&this.pendingRequests.set(v.seq,L),v.seq}acceptMessage(A){this.messageCallback?this.messageCallback(A):(this.queue.push(A),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(A,C){return A.type!=="event"||C.type!=="event"}async processQueue(){let A;for(;this.queue.length;){if((!A||this.needsTaskBoundaryBetween(this.queue[0],A))&&await(0,I.timeout)(0),A=this.queue.shift(),!A)return;switch(A.type){case"event":this.eventCallback&&this.eventCallback(A);break;case"request":this.requestCallback&&this.requestCallback(A);break;case"response":{const C=A,L=this.pendingRequests.get(C.request_seq);L&&(this.pendingRequests.delete(C.request_seq),L(C));break}}}}internalSend(A,C){C.type=A,C.seq=this.sequence++,this.sendMessage(C)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const A=new Map;this.pendingRequests.forEach((C,L)=>A.set(L,C)),await(0,I.timeout)(500),A.forEach((C,L)=>{C({type:"response",seq:0,request_seq:L,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(L)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=B}),define(Ee[159],be([1,0,131,44,3]),function(Y,e,o,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new I.RawContextKey("debugType",void 0,{type:"string",description:o.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new I.RawContextKey("debugConfigurationType",void 0,{type:"string",description:o.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new I.RawContextKey("debugState","inactive",{type:"string",description:o.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new I.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:o.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new I.RawContextKey("inDebugMode",!1,{type:"boolean",description:o.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new I.RawContextKey("inDebugRepl",!1,{type:"boolean",description:o.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new I.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:o.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new I.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:o.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new I.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:o.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new I.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:o.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new I.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:o.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new I.RawContextKey("variablesFocused",!0,{type:"boolean",description:o.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new I.RawContextKey("expressionSelected",!1,{type:"boolean",description:o.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new I.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:o.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new I.RawContextKey("callStackItemType",void 0,{type:"string",description:o.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new I.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:o.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new I.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:o.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new I.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:o.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new I.RawContextKey("watchItemType",void 0,{type:"string",description:o.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new I.RawContextKey("canViewMemory",void 0,{type:"boolean",description:o.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new I.RawContextKey("breakpointItemType",void 0,{type:"string",description:o.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new I.RawContextKey("breakpointAccessType",void 0,{type:"string",description:o.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new I.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:o.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new I.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:o.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new I.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:o.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new I.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:o.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new I.RawContextKey("stepBackSupported",!1,{type:"boolean",description:o.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new I.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:o.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new I.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:o.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new I.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:o.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new I.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:o.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new I.RawContextKey("breakpointsExist",!1,{type:"boolean",description:o.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new I.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:o.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new I.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:o.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new I.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:o.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new I.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:o.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new I.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:o.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new I.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:o.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new I.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:o.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new I.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:o.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new I.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:o.localize(40,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new I.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:o.localize(41,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new I.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:o.localize(42,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new I.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:o.localize(43,null)}),e.CONTEXT_MULTI_SESSION_REPL=new I.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:o.localize(44,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new I.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:o.localize(45,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new I.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:o.localize(46,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new I.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:o.localize(47,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new I.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:o.localize(48,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new I.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:o.localize(49,null)});const B=v=>o.localize(50,null,v);e.debuggerDisabledMessage=B,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:o.localize(51,null)};var S;(function(v){v[v.Inactive=0]="Inactive",v[v.Initializing=1]="Initializing",v[v.Stopped=2]="Stopped",v[v.Running=3]="Running"})(S=e.State||(e.State={}));function A(v){switch(v){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var C;(function(v){v[v.Valid=0]="Valid",v[v.Unreadable=1]="Unreadable",v[v.Error=2]="Error"})(C=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var L;(function(v){v[v.Initial=1]="Initial",v[v.Dynamic=2]="Dynamic"})(L=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={})),e.IDebugService=(0,w.createDecorator)(e.DEBUG_SERVICE_ID);var M;(function(v){v[v.CONDITION=0]="CONDITION",v[v.HIT_COUNT=1]="HIT_COUNT",v[v.LOG_MESSAGE=2]="LOG_MESSAGE"})(M=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ee[160],be([1,0,10,2,17,26,9]),function(Y,e,o,I,w,B,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function C(u,i,s){return u.replace(A,function(t,a){return i&&a.length>0&&a[0]!=="_"?t:s&&s.hasOwnProperty(a)?s[a]:t})}e.formatPII=C;function L(u){const i={};for(const s of Object.keys(u))s.startsWith("!")||(i[s]=u[s]);return i}e.filterExceptionsFromTelemetry=L;function M(u){return u.configuration.request==="attach"&&!v(u)&&(!u.parentSession||M(u.parentSession))}e.isSessionAttach=M;function v(u){let i=u.configuration.type;if(!!i)return i==="vslsShare"&&(i=u.configuration.adapterProxy.configuration.type),(0,o.equalsIgnoreCase)(i,"extensionhost")||(0,o.equalsIgnoreCase)(i,"pwa-extensionhost")?u:u.parentSession?v(u.parentSession):void 0}e.getExtensionHostDebugSession=v;function c(u){return u.type&&(u.label||u.program||u.runtime)}e.isDebuggerMainContribution=c;function g(u,i,s){let t,a=0;const p=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let h=null;for(;h=p.exec(u);){const _=h.index+1,T=_+h[0].length;if(_<=i&&T>=s){t=h[0],a=_;break}}if(t){const _=/\w+/g;let T=null;for(;(T=_.exec(t))&&!(T.index+1+a+T[0].length>=s););T&&(t=t.substring(0,_.lastIndex))}return t?{start:a,end:a+t.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=g;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(u){return!!(u&&u.match(r))}e.isUri=n;function m(u){if(typeof u.path=="string"&&!(typeof u.sourceReference=="number"&&u.sourceReference>0)){if(n(u.path))return I.URI.parse(u.path);if((0,w.isAbsolute)(u.path))return I.URI.file(u.path)}return u.path}function y(u){if(typeof u.path=="object"){const i=I.URI.revive(u.path);if(i)return i.scheme===S.Schemas.file?i.fsPath:i.toString()}return u.path}function k(u,i){const s=i?m:y,t=(0,B.deepClone)(u);return f(t,(a,p)=>{a&&p&&(p.path=s(p))}),t}e.convertToDAPaths=k;function d(u,i){const s=i?m:y,t=(0,B.deepClone)(u);return f(t,(a,p)=>{!a&&p&&(p.path=s(p))}),t}e.convertToVSCPaths=d;function f(u,i){switch(u.type){case"event":{const s=u;switch(s.event){case"output":i(!1,s.body.source);break;case"loadedSource":i(!1,s.body.source);break;case"breakpoint":i(!1,s.body.breakpoint.source);break;default:break}break}case"request":{const s=u;switch(s.command){case"setBreakpoints":i(!0,s.arguments.source);break;case"breakpointLocations":i(!0,s.arguments.source);break;case"source":i(!0,s.arguments.source);break;case"gotoTargets":i(!0,s.arguments.source);break;case"launchVSCode":s.arguments.args.forEach(t=>i(!1,t));break;default:break}break}case"response":{const s=u;if(s.success&&s.body)switch(s.command){case"stackTrace":s.body.stackFrames.forEach(t=>i(!1,t.source));break;case"loadedSources":s.body.sources.forEach(t=>i(!1,t));break;case"scopes":s.body.scopes.forEach(t=>i(!1,t.source));break;case"setFunctionBreakpoints":s.body.breakpoints.forEach(t=>i(!1,t.source));break;case"setBreakpoints":s.body.breakpoints.forEach(t=>i(!1,t.source));break;case"disassemble":{const t=s;t.body&&t.body.instructions.forEach(a=>i(!1,a.location))}break;default:break}break}}}function b(u){return u.filter(i=>!i.presentation?.hidden).sort((i,s)=>i.presentation?s.presentation?i.presentation.group?s.presentation.group?i.presentation.group!==s.presentation.group?i.presentation.group.localeCompare(s.presentation.group):l(i.presentation.order,s.presentation.order):-1:s.presentation.group?1:l(i.presentation.order,s.presentation.order):-1:s.presentation?1:0)}e.getVisibleAndSorted=b;function l(u,i){return typeof u!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:u-i}async function P(u,i){const s=u.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorLanguageId});if(s!=="none"&&(await i.saveAll(),s==="allEditorsInActiveGroup")){const t=i.activeEditorPane;t&&t.input.resource?.scheme===S.Schemas.untitled&&await i.save({editor:t.input,groupId:t.group.id})}await u.reloadConfiguration()}e.saveAllBeforeDebugStart=P}),define(Ee[85],be([1,0,29,161,71,9,17,23,44]),function(Y,e,o,I,w,B,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var L;(function(t){t[t.Markup=1]="Markup",t[t.Code=2]="Code"})(L=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",w.Mimes.latex,w.Mimes.markdown,"image/png","image/jpeg",w.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[w.Mimes.latex,w.Mimes.markdown,"application/json",w.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var M;(function(t){t[t.Running=1]="Running",t[t.Idle=2]="Idle"})(M=e.NotebookRunState||(e.NotebookRunState={}));var v;(function(t){t[t.Unconfirmed=1]="Unconfirmed",t[t.Pending=2]="Pending",t[t.Executing=3]="Executing"})(v=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var c;(function(t){t[t.WithHardKernelDependency=0]="WithHardKernelDependency",t[t.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",t[t.Pure=2]="Pure",t[t.Never=3]="Never"})(c=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var g;(function(t){t.Always="always",t.Never="never",t.Optional="optional"})(g=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var r;(function(t){t[t.ModelChange=1]="ModelChange",t[t.Move=2]="Move",t[t.ChangeLanguage=5]="ChangeLanguage",t[t.Initialize=6]="Initialize",t[t.ChangeCellMetadata=7]="ChangeCellMetadata",t[t.Output=8]="Output",t[t.OutputItem=9]="OutputItem",t[t.ChangeCellContent=10]="ChangeCellContent",t[t.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",t[t.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",t[t.ChangeCellMime=13]="ChangeCellMime",t[t.Unknown=100]="Unknown"})(r=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var n;(function(t){t[t.Handle=0]="Handle",t[t.Index=1]="Index"})(n=e.SelectionStateType||(e.SelectionStateType={}));var m;(function(t){t[t.Replace=1]="Replace",t[t.Output=2]="Output",t[t.Metadata=3]="Metadata",t[t.CellLanguage=4]="CellLanguage",t[t.DocumentMetadata=5]="DocumentMetadata",t[t.Move=6]="Move",t[t.OutputItems=7]="OutputItems",t[t.PartialMetadata=8]="PartialMetadata",t[t.PartialInternalMetadata=9]="PartialInternalMetadata"})(m=e.CellEditType||(e.CellEditType={}));var y;(function(t){t.scheme=B.Schemas.vscodeNotebookCell;const a=/^ch(\d{7,})/;function p(E,H){return E.with({scheme:t.scheme,fragment:`ch${H.toString().padStart(7,"0")}${E.scheme!==B.Schemas.file?E.scheme:""}`})}t.generate=p;function h(E){if(E.scheme!==t.scheme)return;const H=a.exec(E.fragment);return H?{handle:Number(H[1]),notebook:E.with({scheme:E.fragment.substring(H[0].length)||B.Schemas.file,fragment:null})}:void 0}t.parse=h;function _(E,H){return E.with({scheme:B.Schemas.vscodeNotebookCellOutput,fragment:`op${H??""},${E.scheme!==B.Schemas.file?E.scheme:""}`})}t.generateCellOutputUri=_;function T(E){if(E.scheme!==B.Schemas.vscodeNotebookCellOutput)return;const H=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(E.fragment);if(!H)return;const q=H[1]&&H[1]!==""?H[1]:void 0,$=H[2];return{outputId:q,notebook:E.with({scheme:$||B.Schemas.file,fragment:null})}}t.parseCellOutputUri=T;function R(E,H,q){return E.with({scheme:q,fragment:`ch${H.toString().padStart(7,"0")}${E.scheme!==B.Schemas.file?E.scheme:""}`})}t.generateCellUri=R;function W(E,H){if(E.scheme!==H)return;const q=a.exec(E.fragment);return q?{handle:Number(q[1]),notebook:E.with({scheme:E.fragment.substring(q[0].length)||B.Schemas.file,fragment:null})}:void 0}t.parseCellUri=W})(y=e.CellUri||(e.CellUri={}));const k=t=>A.isWindows?t.replace(/\//g,"\\"):t;class d{constructor(a=[],p=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=p,this.order=[...new Set(a)].map(h=>({pattern:h,matches:o.parse(k(h))}))}sort(a){const p=new Map(I.Iterable.map(a,_=>[_,k(_)]));let h=[];for(const{matches:_}of this.order)for(const[T,R]of p)if(_(R)){h.push(T),p.delete(T);break}return p.size&&(h=h.concat([...p.keys()].sort((_,T)=>this.defaultOrder.indexOf(_)-this.defaultOrder.indexOf(T)))),h}prioritize(a,p){const h=this.findIndex(a);if(h===-1){this.order.unshift({pattern:a,matches:o.parse(k(a))});return}const _=new Set(p.map(R=>this.findIndex(R,h)));_.delete(-1);const T=Array.from(_).sort();this.order.splice(h+1,0,...T.map(R=>this.order[R]));for(let R=T.length-1;R>=0;R--)this.order.splice(T[R],1)}toArray(){return this.order.map(a=>a.pattern)}findIndex(a,p=this.order.length){const h=k(a);for(let _=0;_<p;_++)if(this.order[_].matches(h))return _;return-1}}e.MimeTypeDisplayOrder=d;function f(t,a,p,h=(_,T)=>_===T){const _=[];function T(E,H,q){if(H===0&&q.length===0)return;const $=_[_.length-1];$&&$.start+$.deleteCount===E?($.deleteCount+=H,$.toInsert.push(...q)):_.push({start:E,deleteCount:H,toInsert:q})}let R=0,W=0;for(;;){if(R===t.length){T(R,0,a.slice(W));break}if(W===a.length){T(R,t.length-R,[]);break}const E=t[R],H=a[W];if(h(E,H)){R+=1,W+=1;continue}p(H)?(T(R,1,[]),R+=1):(T(R,0,[H]),W+=1)}return _}e.diff=f,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var b;(function(t){t.default="default",t.option="option"})(b=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function l(t){const a=t;return!!((typeof a.include=="string"||o.isRelativePattern(a.include))&&(typeof a.exclude=="string"||o.isRelativePattern(a.exclude)))}e.isDocumentExcludePattern=l;function P(t,a,p){if(Array.isArray(t.viewType)&&t.viewType.indexOf(a)>=0||t.viewType===a)return!0;if(t.filenamePattern){const h=l(t.filenamePattern)?t.filenamePattern.include:t.filenamePattern,_=l(t.filenamePattern)?t.filenamePattern.exclude:void 0;if(o.match(h,(0,S.basename)(p.fsPath).toLowerCase()))return!(_&&o.match(_,(0,S.basename)(p.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=P;class u{constructor(a){this.textModel=a}getElements(){const a=new Int32Array(this.textModel.cells.length);for(let p=0;p<this.textModel.cells.length;p++)a[p]=this.textModel.cells[p].getHashValue();return a}}e.CellSequence=u,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var i;(function(t){t[t.Left=1]="Left",t[t.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class s{static create(a){return`${s._prefix}${a}`}static parse(a){if(a.startsWith(s._prefix))return a.substring(s._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=s,s._prefix="notebook/"}),define(Ee[162],be([1,0,3]),function(Y,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var I;(function(w){w[w.Output=1]="Output",w[w.OutputItems=2]="OutputItems",w[w.ExecutionState=3]="ExecutionState"})(I=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,o.createDecorator)("INotebookExecutionService")}),define(Ee[163],be([1,0,3,44]),function(Y,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new I.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new I.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new I.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,o.createDecorator)(e.OUTPUT_SERVICE_ID);var w;(function(B){B[B.Append=1]="Append",B[B.Replace=2]="Replace",B[B.Clear=3]="Clear"})(w=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(Ee[164],be([1,0,132,3,44]),function(Y,e,o,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new w.RawContextKey("customExecutionSupported",!0,o.localize(0,null)),e.ShellExecutionSupportedContext=new w.RawContextKey("shellExecutionSupported",!1,o.localize(1,null)),e.ProcessExecutionSupportedContext=new w.RawContextKey("processExecutionSupported",!1,o.localize(2,null)),e.ITaskService=(0,I.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(Ee[165],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function o(w){return[...w.entries()]}e.serializeEnvironmentVariableCollection=o;function I(w){return new Map(w)}e.deserializeEnvironmentVariableCollection=I}),define(Ee[62],be([1,0,2,48]),function(Y,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var w;(function(s){s[s.Unset=0]="Unset",s[s.Queued=1]="Queued",s[s.Running=2]="Running",s[s.Passed=3]="Passed",s[s.Failed=4]="Failed",s[s.Skipped=5]="Skipped",s[s.Errored=6]="Errored"})(w=e.TestResultState||(e.TestResultState={}));var B;(function(s){s[s.Run=2]="Run",s[s.Debug=4]="Debug",s[s.Coverage=8]="Coverage",s[s.HasNonDefaultProfile=16]="HasNonDefaultProfile",s[s.HasConfigurable=32]="HasConfigurable"})(B=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var S;(function(s){s.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),s.deserialize=t=>({range:I.Range.lift(t.range),uri:o.URI.revive(t.uri)})})(S=e.IRichLocation||(e.IRichLocation={}));var A;(function(s){s[s.Error=0]="Error",s[s.Info=1]="Info"})(A=e.TestMessageType||(e.TestMessageType={}));var C;(function(s){s.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&S.serialize(t.location)}),s.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&S.deserialize(t.location)})})(C=e.ITestErrorMessage||(e.ITestErrorMessage={}));var L;(function(s){s.serialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&S.serialize(t.location)}),s.deserialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&S.deserialize(t.location)})})(L=e.ITestOutputMessage||(e.ITestOutputMessage={}));var M;(function(s){s.serialize=t=>t.type===0?C.serialize(t):L.serialize(t),s.deserialize=t=>t.type===0?C.deserialize(t):L.deserialize(t)})(M=e.ITestMessage||(e.ITestMessage={}));var v;(function(s){s.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(M.serialize)}),s.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(M.deserialize)})})(v=e.ITestTaskState||(e.ITestTaskState={}));const c="\0",g=(s,t)=>s+c+t;e.namespaceTestTag=g;const r=s=>{const t=s.indexOf(c);return{ctrlId:s.slice(0,t),tagId:s.slice(t+1)}};e.denamespaceTestTag=r;var n;(function(s){s.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),s.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?o.URI.revive(t.uri):void 0,range:t.range?I.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(n=e.ITestItem||(e.ITestItem={}));var m;(function(s){s[s.NotExpandable=0]="NotExpandable",s[s.Expandable=1]="Expandable",s[s.BusyExpanding=2]="BusyExpanding",s[s.Expanded=3]="Expanded"})(m=e.TestItemExpandState||(e.TestItemExpandState={}));var y;(function(s){s.serialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:n.serialize(t.item)}),s.deserialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:n.deserialize(t.item)})})(y=e.InternalTestItem||(e.InternalTestItem={}));var k;(function(s){s.serialize=t=>{let a;return t.item&&(a={},t.item.label!==void 0&&(a.label=t.item.label),t.item.tags!==void 0&&(a.tags=t.item.tags),t.item.busy!==void 0&&(a.busy=t.item.busy),t.item.uri!==void 0&&(a.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(a.range=t.item.range?.toJSON()),t.item.description!==void 0&&(a.description=t.item.description),t.item.error!==void 0&&(a.error=t.item.error),t.item.sortText!==void 0&&(a.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:a}},s.deserialize=t=>{let a;return t.item&&(a={},t.item.label!==void 0&&(a.label=t.item.label),t.item.tags!==void 0&&(a.tags=t.item.tags),t.item.busy!==void 0&&(a.busy=t.item.busy),t.item.range!==void 0&&(a.range=t.item.range?I.Range.lift(t.item.range):null),t.item.description!==void 0&&(a.description=t.item.description),t.item.error!==void 0&&(a.error=t.item.error),t.item.sortText!==void 0&&(a.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:a}}})(k=e.ITestItemUpdate||(e.ITestItemUpdate={}));const d=(s,t)=>{t.expand!==void 0&&(s.expand=t.expand),t.item!==void 0&&(s.item=s.item?Object.assign(s.item,t.item):t.item)};e.applyTestItemUpdate=d;var f;(function(s){s.serialize=(t,a)=>({...y.serialize(t),children:a,ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(v.serialize)})})(f=e.TestResultItem||(e.TestResultItem={}));var b;(function(s){s[s.Function=0]="Function",s[s.Statement=1]="Statement"})(b=e.DetailType||(e.DetailType={}));var l;(function(s){s[s.Add=0]="Add",s[s.Update=1]="Update",s[s.Remove=2]="Remove",s[s.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",s[s.Retire=4]="Retire",s[s.AddTag=5]="AddTag",s[s.RemoveTag=6]="RemoveTag"})(l=e.TestDiffOpType||(e.TestDiffOpType={}));var P;(function(s){s.deserialize=t=>t.op===0?{op:t.op,item:y.deserialize(t.item)}:t.op===1?{op:t.op,item:k.deserialize(t.item)}:t,s.serialize=t=>t.op===0?{op:t.op,item:y.serialize(t.item)}:t.op===1?{op:t.op,item:k.serialize(t.item)}:t})(P=e.TestsDiffOp||(e.TestsDiffOp={}));class u{add(t){}update(t){}remove(t,a){}complete(){}}e.IncrementalChangeCollector=u;class i{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(t){const a=this.createChangeCollector();for(const p of t)switch(p.op){case 0:{const h=y.deserialize(p.item);if(h.parent){if(this.items.has(h.parent)){const _=this.items.get(h.parent);_.children.add(h.item.extId);const T=this.createItem(h,_);this.items.set(h.item.extId,T),a.add(T)}}else{const _=this.createItem(h);this.roots.add(_),this.items.set(h.item.extId,_),a.add(_)}h.expand===2&&this.busyControllerCount++;break}case 1:{const h=k.deserialize(p.item),_=this.items.get(h.extId);if(!_)break;h.expand!==void 0&&(_.expand===2&&this.busyControllerCount--,h.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(_,h),a.update(_);break}case 2:{const h=this.items.get(p.itemId);if(!h)break;h.parent?this.items.get(h.parent).children.delete(h.item.extId):this.roots.delete(h);const _=[[p.itemId]];for(;_.length;)for(const T of _.pop()){const R=this.items.get(T);R&&(_.push(R.children),this.items.delete(T),a.remove(R,R!==h),R.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(p.itemId);break;case 3:this.updatePendingRoots(p.amount);break;case 5:this._tags.set(p.tag.id,p.tag);break;case 6:this._tags.delete(p.id);break}a.complete()}retireTest(t){}updatePendingRoots(t){this.pendingRootCount+=t}createChangeCollector(){return new u}}e.AbstractIncrementalTestCollection=i}),define(Ee[63],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var o;(function(B){B.Delimiter="\0"})(o=e.TestIdPathParts||(e.TestIdPathParts={}));var I;(function(B){B[B.IsSame=0]="IsSame",B[B.Disconnected=1]="Disconnected",B[B.IsChild=2]="IsChild",B[B.IsParent=3]="IsParent"})(I=e.TestPosition||(e.TestPosition={}));class w{constructor(S,A=S.length){if(this.path=S,this.viewEnd=A,S.length===0||A<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(S,A,C=S.parent){if(S.id===A)return new w([A]);let L=[S.id];for(let M=C;M&&M.id!==A;M=M.parent)L.push(M.id);return L.push(A),new w(L.reverse())}static isRoot(S){return!S.includes("\0")}static root(S){const A=S.indexOf("\0");return A===-1?S:S.slice(0,A)}static fromString(S){return new w(S.split("\0"))}static join(S,A){return new w([...S.path,A])}static joinToString(S,A){return S.toString()+"\0"+A}static compare(S,A){return S===A?0:A.startsWith(S+"\0")?2:S.startsWith(A+"\0")?3:1}get parentId(){return this.viewEnd>1?new w(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let S=1;S<=this.viewEnd;S++)yield new w(this.path,S)}compare(S){if(typeof S=="string")return w.compare(this.toString(),S);for(let A=0;A<S.viewEnd&&A<this.viewEnd;A++)if(S.path[A]!==this.path[A])return 1;return S.viewEnd>this.viewEnd?2:S.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let S=1;S<this.viewEnd;S++)this.stringifed+="\0",this.stringifed+=this.path[S]}return this.stringifed}}e.TestId=w}),define(Ee[166],be([1,0,17,86,11,26,23,73,133]),function(Y,e,o,I,w,B,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class L{constructor(v,c,g,r){this._contributedVariables=new Map,this._context=v,this._labelService=c,this._userHomePromise=g,r&&(this._envVariablesPromise=r.then(n=>this.prepareEnv(n)))}prepareEnv(v){if(S.isWindows){const c=Object.create(null);return Object.keys(v).forEach(g=>{c[g.toLowerCase()]=v[g]}),c}return v}resolveWithEnvironment(v,c,g){return this.recursiveResolve(this.prepareEnv(v),c?c.uri:void 0,g)}async resolveAsync(v,c){const g={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(g,v?v.uri:void 0,c)}async resolveAnyBase(v,c,g,r){const n=B.deepClone(c);S.isWindows&&n.windows?Object.keys(n.windows).forEach(y=>n[y]=n.windows[y]):S.isMacintosh&&n.osx?Object.keys(n.osx).forEach(y=>n[y]=n.osx[y]):S.isLinux&&n.linux&&Object.keys(n.linux).forEach(y=>n[y]=n.linux[y]),delete n.windows,delete n.osx,delete n.linux;const m={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(m,v?v.uri:void 0,n,g,r)}async resolveAnyAsync(v,c,g){return this.resolveAnyBase(v,c,g)}async resolveAnyMap(v,c,g){const r=new Map;return{newConfig:await this.resolveAnyBase(v,c,g,r),resolvedVariables:r}}resolveWithInteractionReplace(v,c,g,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,c,g,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,c){if(this._contributedVariables.has(v))throw new Error("Variable "+v+" is contributed twice.");this._contributedVariables.set(v,c)}recursiveResolve(v,c,g,r,n){if(w.isString(g))return this.resolveString(v,c,g,r,n);if(w.isArray(g))return g.map(m=>this.recursiveResolve(v,c,m,r,n));if(w.isObject(g)){let m=Object.create(null);return Object.keys(g).forEach(y=>{const k=this.resolveString(v,c,y,r,n);m[k]=this.recursiveResolve(v,c,g[y],r,n)}),m}return g}resolveString(v,c,g,r,n){return g.replace(L.VARIABLE_REGEXP,(y,k)=>{if(k.includes(L.VARIABLE_LHS))return y;let d=this.evaluateSingleVariable(v,y,k,c,r);return n&&n.set(k,d),d!==y&&w.isString(d)&&d.match(L.VARIABLE_REGEXP)&&(d=this.resolveString(v,c,d,r,n)),d})}fsPath(v){return this._labelService?this._labelService.getUriLabel(v,{noPrefix:!0}):v.fsPath}evaluateSingleVariable(v,c,g,r,n){let m;const y=g.split(":");y.length>1&&(g=y[0],m=y[1]);const k=()=>{const b=this._context.getFilePath();if(b)return b;throw new Error((0,C.localize)(0,null,c))},d=()=>{const b=k();if(this._context.getWorkspaceFolderPathForFile){const l=this._context.getWorkspaceFolderPathForFile();if(l)return l}throw new Error((0,C.localize)(1,null,c,o.basename(b)))},f=()=>{if(m){const b=this._context.getFolderUri(m);if(b)return b;throw new Error((0,C.localize)(2,null,c,m))}if(r)return r;throw this._context.getWorkspaceFolderCount()>1?new Error((0,C.localize)(3,null,c)):new Error((0,C.localize)(4,null,c))};switch(g){case"env":if(m){if(v.env){const b=v.env[S.isWindows?m.toLowerCase():m];if(w.isString(b))return b}return""}throw new Error((0,C.localize)(5,null,c));case"config":if(m){const b=this._context.getConfigurationValue(r,m);if(w.isUndefinedOrNull(b))throw new Error((0,C.localize)(6,null,c,m));if(w.isObject(b))throw new Error((0,C.localize)(7,null,c,m));return b}throw new Error((0,C.localize)(8,null,c));case"command":return this.resolveFromMap(c,m,n,"command");case"input":return this.resolveFromMap(c,m,n,"input");default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.fsPath(f()));case"cwd":return r||m?(0,A.normalizeDriveLetter)(this.fsPath(f())):I.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return o.basename(this.fsPath(f()));case"userHome":{if(v.userHome)return v.userHome;throw new Error((0,C.localize)(9,null,c))}case"lineNumber":{const b=this._context.getLineNumber();if(b)return b;throw new Error((0,C.localize)(10,null,c))}case"selectedText":{const b=this._context.getSelectedText();if(b)return b;throw new Error((0,C.localize)(11,null,c))}case"file":return k();case"fileWorkspaceFolder":return d();case"relativeFile":return r||m?o.relative(this.fsPath(f()),k()):k();case"relativeFileDirname":{const b=o.dirname(k());if(r||m){const l=o.relative(this.fsPath(f()),b);return l.length===0?".":l}return b}case"fileDirname":return o.dirname(k());case"fileExtname":return o.extname(k());case"fileBasename":return o.basename(k());case"fileBasenameNoExtension":{const b=o.basename(k());return b.slice(0,b.length-o.extname(b).length)}case"fileDirnameBasename":return o.basename(o.dirname(k()));case"execPath":{const b=this._context.getExecPath();return b||c}case"execInstallFolder":{const b=this._context.getAppRoot();return b||c}case"pathSeparator":return o.sep;default:try{const b=m?`${g}:${m}`:g;return this.resolveFromMap(c,b,n,void 0)}catch{return c}}}}resolveFromMap(v,c,g,r){if(c&&g){const n=r===void 0?g[c]:g[r+":"+c];if(typeof n=="string")return n;throw new Error((0,C.localize)(12,null,v))}return v}}e.AbstractVariableResolverService=L,L.VARIABLE_LHS="${",L.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ee[87],be([1,0,3,156]),function(Y,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,o.createDecorator)("editorGroupsService");var w;(function(r){r[r.UP=0]="UP",r[r.DOWN=1]="DOWN",r[r.LEFT=2]="LEFT",r[r.RIGHT=3]="RIGHT"})(w=e.GroupDirection||(e.GroupDirection={}));var B;(function(r){r[r.HORIZONTAL=0]="HORIZONTAL",r[r.VERTICAL=1]="VERTICAL"})(B=e.GroupOrientation||(e.GroupOrientation={}));var S;(function(r){r[r.FIRST=0]="FIRST",r[r.LAST=1]="LAST",r[r.NEXT=2]="NEXT",r[r.PREVIOUS=3]="PREVIOUS"})(S=e.GroupLocation||(e.GroupLocation={}));var A;(function(r){r[r.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",r[r.EVEN=1]="EVEN",r[r.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(r){r[r.COPY_EDITORS=0]="COPY_EDITORS",r[r.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));function L(r){const n=r;return(0,I.isEditorInput)(n?.editor)&&(0,I.isEditorInput)(n?.replacement)}e.isEditorReplacement=L;var M;(function(r){r[r.CREATION_TIME=0]="CREATION_TIME",r[r.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",r[r.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(M=e.GroupsOrder||(e.GroupsOrder={}));var v;(function(r){r[r.NEW_EDITOR=1]="NEW_EDITOR",r[r.MOVE_EDITOR=2]="MOVE_EDITOR",r[r.COPY_EDITOR=3]="COPY_EDITOR"})(v=e.OpenEditorContext||(e.OpenEditorContext={}));function c(r){const n=r;return!!n&&typeof n.id=="number"&&Array.isArray(n.editors)}e.isEditorGroup=c;function g(r){return r.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=g}),define(Ee[167],be([1,0,3,87]),function(Y,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,o.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function w(B){const S=B;return typeof B=="number"||(0,I.isEditorGroup)(S)}e.isPreferredGroup=w}),define(Ee[8],be([1,0,16,21,72,101,54,26,11,2,48,88,135,78,47,85,62,63,167,7]),function(Y,e,o,I,w,B,S,A,C,L,M,v,c,g,r,n,m,y,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var f;(function(he){function pe(K){const{selectionStartLineNumber:_e,selectionStartColumn:Ce,positionLineNumber:$e,positionColumn:Ve}=K,lt=new d.Position(_e-1,Ce-1),gt=new d.Position($e-1,Ve-1);return new d.Selection(lt,gt)}he.to=pe;function se(K){const{anchor:_e,active:Ce}=K;return{selectionStartLineNumber:_e.line+1,selectionStartColumn:_e.character+1,positionLineNumber:Ce.line+1,positionColumn:Ce.character+1}}he.from=se})(f=e.Selection||(e.Selection={}));var b;(function(he){function pe(K){if(!K)return;const{start:_e,end:Ce}=K;return{startLineNumber:_e.line+1,startColumn:_e.character+1,endLineNumber:Ce.line+1,endColumn:Ce.character+1}}he.from=pe;function se(K){if(!K)return;const{startLineNumber:_e,startColumn:Ce,endLineNumber:$e,endColumn:Ve}=K;return new d.Range(_e-1,Ce-1,$e-1,Ve-1)}he.to=se})(b=e.Range||(e.Range={}));var l;(function(he){function pe(se){switch(se){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 3:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}he.to=pe})(l=e.TokenType||(e.TokenType={}));var P;(function(he){function pe(K){return new d.Position(K.lineNumber-1,K.column-1)}he.to=pe;function se(K){return{lineNumber:K.line+1,column:K.character+1}}he.from=se})(P=e.Position||(e.Position={}));var u;(function(he){function pe(_e,Ce){return(0,o.coalesce)((0,o.asArray)(_e).map($e=>se($e,Ce)))}he.from=pe;function se(_e,Ce){if(typeof _e=="string")return{$serialized:!0,language:_e};if(_e)return{$serialized:!0,language:_e.language,scheme:K(_e.scheme,Ce),pattern:le.from(_e.pattern)??void 0,exclusive:_e.exclusive,notebookType:_e.notebookType}}function K(_e,Ce){return Ce&&typeof _e=="string"?Ce.transformOutgoingScheme(_e):_e}})(u=e.DocumentSelector||(e.DocumentSelector={}));var i;(function(he){function pe(K){switch(K){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}he.from=pe;function se(K){switch(K){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}he.to=se})(i=e.DiagnosticTag||(e.DiagnosticTag={}));var s;(function(he){function pe(K){let _e;return K.code&&((0,C.isString)(K.code)||(0,C.isNumber)(K.code)?_e=String(K.code):_e={value:String(K.code.value),target:K.code.target}),{...b.from(K.range),message:K.message,source:K.source,code:_e,severity:a.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(t.from),tags:Array.isArray(K.tags)?(0,o.coalesce)(K.tags.map(i.from)):void 0}}he.from=pe;function se(K){const _e=new d.Diagnostic(b.to(K),K.message,a.to(K.severity));return _e.source=K.source,_e.code=(0,C.isString)(K.code)?K.code:K.code?.value,_e.relatedInformation=K.relatedInformation&&K.relatedInformation.map(t.to),_e.tags=K.tags&&(0,o.coalesce)(K.tags.map(i.to)),_e}he.to=se})(s=e.Diagnostic||(e.Diagnostic={}));var t;(function(he){function pe(K){return{...b.from(K.location.range),message:K.message,resource:K.location.uri}}he.from=pe;function se(K){return new d.DiagnosticRelatedInformation(new d.Location(K.resource,b.to(K)),K.message)}he.to=se})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var a;(function(he){function pe(K){switch(K){case d.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}he.from=pe;function se(K){switch(K){case g.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}he.to=se})(a=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var p;(function(he){function pe(K){return typeof K=="number"&&K>=d.ViewColumn.One?K-1:K===d.ViewColumn.Beside?k.SIDE_GROUP:k.ACTIVE_GROUP}he.from=pe;function se(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}he.to=se})(p=e.ViewColumn||(e.ViewColumn={}));function h(he){return typeof he.range!="undefined"}function _(he){return he.length===0?!0:!!h(he[0])}e.isDecorationOptionsArr=_;var T;(function(he){function pe(Ve){return Ve.map(he.from)}he.fromMany=pe;function se(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function K(Ve){let lt;if(se(Ve)){const{language:at,value:ot}=Ve;lt={value:"```"+at+`
`+ot+"\n```\n"}}else d.MarkdownString.isMarkdownString(Ve)?lt={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?lt={value:Ve}:lt={value:""};const gt=Object.create(null);lt.uris=gt;const Et=at=>{try{let ot=L.URI.parse(at,!0);ot=ot.with({query:_e(ot.query,gt)}),gt[at]=ot}catch{}return""},rt=new B.marked.Renderer;return rt.link=Et,rt.image=at=>typeof at=="string"?Et(w.parseHrefAndDimensions(at).href):"",(0,B.marked)(lt.value,{renderer:rt}),lt}he.from=K;function _e(Ve,lt){if(!Ve)return Ve;let gt;try{gt=(0,S.parse)(Ve)}catch{}if(!gt)return Ve;let Et=!1;return gt=(0,A.cloneAndChange)(gt,rt=>{if(L.URI.isUri(rt)){const at=`__uri_${Math.random().toString(16).slice(2,8)}`;return lt[at]=rt,Et=!0,at}else return}),Et?JSON.stringify(gt):Ve}function Ce(Ve){const lt=new d.MarkdownString(Ve.value,Ve.supportThemeIcons);return lt.isTrusted=Ve.isTrusted,lt.supportHtml=Ve.supportHtml,lt.baseUri=Ve.baseUri?L.URI.from(Ve.baseUri):void 0,lt}he.to=Ce;function $e(Ve){if(!!Ve)return typeof Ve=="string"?Ve:he.from(Ve)}he.fromStrict=$e})(T=e.MarkdownString||(e.MarkdownString={}));function R(he){return _(he)?he.map(pe=>({range:b.from(pe.range),hoverMessage:Array.isArray(pe.hoverMessage)?T.fromMany(pe.hoverMessage):pe.hoverMessage?T.from(pe.hoverMessage):void 0,renderOptions:pe.renderOptions})):he.map(pe=>({range:b.from(pe)}))}e.fromRangeOrRangeWithMessage=R;function W(he){return typeof he=="undefined"?he:typeof he=="string"?L.URI.file(he):he}e.pathOrURIToURI=W;var E;(function(he){function pe(se){return typeof se=="undefined"?se:{contentText:se.contentText,contentIconPath:se.contentIconPath?W(se.contentIconPath):void 0,border:se.border,borderColor:se.borderColor,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,color:se.color,backgroundColor:se.backgroundColor,margin:se.margin,width:se.width,height:se.height}}he.from=pe})(E=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var H;(function(he){function pe(se){return typeof se=="undefined"?se:{backgroundColor:se.backgroundColor,outline:se.outline,outlineColor:se.outlineColor,outlineStyle:se.outlineStyle,outlineWidth:se.outlineWidth,border:se.border,borderColor:se.borderColor,borderRadius:se.borderRadius,borderSpacing:se.borderSpacing,borderStyle:se.borderStyle,borderWidth:se.borderWidth,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,cursor:se.cursor,color:se.color,opacity:se.opacity,letterSpacing:se.letterSpacing,gutterIconPath:se.gutterIconPath?W(se.gutterIconPath):void 0,gutterIconSize:se.gutterIconSize,overviewRulerColor:se.overviewRulerColor,before:se.before?E.from(se.before):void 0,after:se.after?E.from(se.after):void 0}}he.from=pe})(H=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var q;(function(he){function pe(se){if(typeof se=="undefined")return se;switch(se){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}he.from=pe})(q=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var $;(function(he){function pe(se){return{isWholeLine:se.isWholeLine,rangeBehavior:se.rangeBehavior?q.from(se.rangeBehavior):void 0,overviewRulerLane:se.overviewRulerLane,light:se.light?H.from(se.light):void 0,dark:se.dark?H.from(se.dark):void 0,backgroundColor:se.backgroundColor,outline:se.outline,outlineColor:se.outlineColor,outlineStyle:se.outlineStyle,outlineWidth:se.outlineWidth,border:se.border,borderColor:se.borderColor,borderRadius:se.borderRadius,borderSpacing:se.borderSpacing,borderStyle:se.borderStyle,borderWidth:se.borderWidth,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,cursor:se.cursor,color:se.color,opacity:se.opacity,letterSpacing:se.letterSpacing,gutterIconPath:se.gutterIconPath?W(se.gutterIconPath):void 0,gutterIconSize:se.gutterIconSize,overviewRulerColor:se.overviewRulerColor,before:se.before?E.from(se.before):void 0,after:se.after?E.from(se.after):void 0}}he.from=pe})($=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var j;(function(he){function pe(K){return{text:K.newText,eol:K.newEol&&tt.from(K.newEol),range:b.from(K.range)}}he.from=pe;function se(K){const _e=new d.TextEdit(b.to(K.range),K.text);return _e.newEol=typeof K.eol=="undefined"?void 0:tt.to(K.eol),_e}he.to=se})(j=e.TextEdit||(e.TextEdit={}));var J;(function(he){function pe(K,_e){const Ce={edits:[]};if(K instanceof d.WorkspaceEdit)for(let $e of K._allEntries())$e._type===1?Ce.edits.push({_type:1,oldUri:$e.from,newUri:$e.to,options:$e.options,metadata:$e.metadata}):$e._type===2?Ce.edits.push({_type:2,resource:$e.uri,edit:j.from($e.edit),modelVersionId:_e?.getTextDocumentVersion($e.uri),metadata:$e.metadata}):$e._type===3?Ce.edits.push({_type:3,metadata:$e.metadata,resource:$e.uri,edit:$e.edit,notebookMetadata:$e.notebookMetadata,notebookVersionId:_e?.getNotebookDocumentVersion($e.uri)}):$e._type===5&&Ce.edits.push({_type:3,metadata:$e.metadata,resource:$e.uri,notebookVersionId:_e?.getNotebookDocumentVersion($e.uri),edit:{editType:1,index:$e.index,count:$e.count,cells:$e.cells.map(St.from)}});return Ce}he.from=pe;function se(K){const _e=new d.WorkspaceEdit;for(const Ce of K.edits)Ce.edit?_e.replace(L.URI.revive(Ce.resource),b.to(Ce.edit.range),Ce.edit.text):_e.renameFile(L.URI.revive(Ce.oldUri),L.URI.revive(Ce.newUri),Ce.options);return _e}he.to=se})(J=e.WorkspaceEdit||(e.WorkspaceEdit={}));var z;(function(he){const pe=Object.create(null);pe[d.SymbolKind.File]=0,pe[d.SymbolKind.Module]=1,pe[d.SymbolKind.Namespace]=2,pe[d.SymbolKind.Package]=3,pe[d.SymbolKind.Class]=4,pe[d.SymbolKind.Method]=5,pe[d.SymbolKind.Property]=6,pe[d.SymbolKind.Field]=7,pe[d.SymbolKind.Constructor]=8,pe[d.SymbolKind.Enum]=9,pe[d.SymbolKind.Interface]=10,pe[d.SymbolKind.Function]=11,pe[d.SymbolKind.Variable]=12,pe[d.SymbolKind.Constant]=13,pe[d.SymbolKind.String]=14,pe[d.SymbolKind.Number]=15,pe[d.SymbolKind.Boolean]=16,pe[d.SymbolKind.Array]=17,pe[d.SymbolKind.Object]=18,pe[d.SymbolKind.Key]=19,pe[d.SymbolKind.Null]=20,pe[d.SymbolKind.EnumMember]=21,pe[d.SymbolKind.Struct]=22,pe[d.SymbolKind.Event]=23,pe[d.SymbolKind.Operator]=24,pe[d.SymbolKind.TypeParameter]=25;function se(_e){return typeof pe[_e]=="number"?pe[_e]:6}he.from=se;function K(_e){for(const Ce in pe)if(pe[Ce]===_e)return Number(Ce);return d.SymbolKind.Property}he.to=K})(z=e.SymbolKind||(e.SymbolKind={}));var ie;(function(he){function pe(K){switch(K){case d.SymbolTag.Deprecated:return 1}}he.from=pe;function se(K){switch(K){case 1:return d.SymbolTag.Deprecated}}he.to=se})(ie=e.SymbolTag||(e.SymbolTag={}));var ae;(function(he){function pe(K){return{name:K.name,kind:z.from(K.kind),tags:K.tags&&K.tags.map(ie.from),containerName:K.containerName,location:fe.from(K.location)}}he.from=pe;function se(K){const _e=new d.SymbolInformation(K.name,z.to(K.kind),K.containerName,fe.to(K.location));return _e.tags=K.tags&&K.tags.map(ie.to),_e}he.to=se})(ae=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var te;(function(he){function pe(K){const _e={name:K.name||"!!MISSING: name!!",detail:K.detail,range:b.from(K.range),selectionRange:b.from(K.selectionRange),kind:z.from(K.kind),tags:K.tags?.map(ie.from)??[]};return K.children&&(_e.children=K.children.map(pe)),_e}he.from=pe;function se(K){const _e=new d.DocumentSymbol(K.name,K.detail,z.to(K.kind),b.to(K.range),b.to(K.selectionRange));return(0,o.isNonEmptyArray)(K.tags)&&(_e.tags=K.tags.map(ie.to)),K.children&&(_e.children=K.children.map(se)),_e}he.to=se})(te=e.DocumentSymbol||(e.DocumentSymbol={}));var ce;(function(he){function pe(K){const _e=new d.CallHierarchyItem(z.to(K.kind),K.name,K.detail||"",L.URI.revive(K.uri),b.to(K.range),b.to(K.selectionRange));return _e._sessionId=K._sessionId,_e._itemId=K._itemId,_e}he.to=pe;function se(K,_e,Ce){if(_e=_e??K._sessionId,Ce=Ce??K._itemId,_e===void 0||Ce===void 0)throw new Error("invalid item");return{_sessionId:_e,_itemId:Ce,name:K.name,detail:K.detail,kind:z.from(K.kind),uri:K.uri,range:b.from(K.range),selectionRange:b.from(K.selectionRange),tags:K.tags?.map(ie.from)}}he.from=se})(ce=e.CallHierarchyItem||(e.CallHierarchyItem={}));var de;(function(he){function pe(se){return new d.CallHierarchyIncomingCall(ce.to(se.from),se.fromRanges.map(K=>b.to(K)))}he.to=pe})(de=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Se;(function(he){function pe(se){return new d.CallHierarchyOutgoingCall(ce.to(se.to),se.fromRanges.map(K=>b.to(K)))}he.to=pe})(Se=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var fe;(function(he){function pe(K){return{range:K.range&&b.from(K.range),uri:K.uri}}he.from=pe;function se(K){return new d.Location(L.URI.revive(K.uri),b.to(K.range))}he.to=se})(fe=e.location||(e.location={}));var ne;(function(he){function pe(K){const _e=K,Ce=K;return{originSelectionRange:_e.originSelectionRange?b.from(_e.originSelectionRange):void 0,uri:_e.targetUri?_e.targetUri:Ce.uri,range:b.from(_e.targetRange?_e.targetRange:Ce.range),targetSelectionRange:_e.targetSelectionRange?b.from(_e.targetSelectionRange):void 0}}he.from=pe;function se(K){return{targetUri:L.URI.revive(K.uri),targetRange:b.to(K.range),targetSelectionRange:K.targetSelectionRange?b.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?b.to(K.originSelectionRange):void 0}}he.to=se})(ne=e.DefinitionLink||(e.DefinitionLink={}));var me;(function(he){function pe(K){return{range:b.from(K.range),contents:T.fromMany(K.contents)}}he.from=pe;function se(K){return new d.Hover(K.contents.map(T.to),b.to(K.range))}he.to=se})(me=e.Hover||(e.Hover={}));var ke;(function(he){function pe(K){return{range:b.from(K.range),expression:K.expression}}he.from=pe;function se(K){return new d.EvaluatableExpression(b.to(K.range),K.expression)}he.to=se})(ke=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Ae;(function(he){function pe(K){if(K instanceof d.InlineValueText)return{type:"text",range:b.from(K.range),text:K.text};if(K instanceof d.InlineValueVariableLookup)return{type:"variable",range:b.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof d.InlineValueEvaluatableExpression)return{type:"expression",range:b.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}he.from=pe;function se(K){switch(K.type){case"text":return{range:b.to(K.range),text:K.text};case"variable":return{range:b.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:b.to(K.range),expression:K.expression}}}he.to=se})(Ae=e.InlineValue||(e.InlineValue={}));var Be;(function(he){function pe(K){return{frameId:K.frameId,stoppedLocation:b.from(K.stoppedLocation)}}he.from=pe;function se(K){return new d.InlineValueContext(K.frameId,b.to(K.stoppedLocation))}he.to=se})(Be=e.InlineValueContext||(e.InlineValueContext={}));var Xe;(function(he){function pe(K){return{range:b.from(K.range),kind:K.kind}}he.from=pe;function se(K){return new d.DocumentHighlight(b.to(K.range),K.kind)}he.to=se})(Xe=e.DocumentHighlight||(e.DocumentHighlight={}));var ge;(function(he){function pe(se){switch(se){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}he.to=pe})(ge=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ue;(function(he){function pe(se){return{triggerKind:ge.to(se.triggerKind),triggerCharacter:se.triggerCharacter}}he.to=pe})(ue=e.CompletionContext||(e.CompletionContext={}));var N;(function(he){function pe(K){switch(K){case d.CompletionItemTag.Deprecated:return 1}}he.from=pe;function se(K){switch(K){case 1:return d.CompletionItemTag.Deprecated}}he.to=se})(N=e.CompletionItemTag||(e.CompletionItemTag={}));var F;(function(he){const pe=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function se(Ce){return pe.get(Ce)??9}he.from=se;const K=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function _e(Ce){return K.get(Ce)??d.CompletionItemKind.Property}he.to=_e})(F=e.CompletionItemKind||(e.CompletionItemKind={}));var D;(function(he){function pe(se,K){const _e=new d.CompletionItem(se.label);return _e.insertText=se.insertText,_e.kind=F.to(se.kind),_e.tags=se.tags?.map(N.to),_e.detail=se.detail,_e.documentation=w.isMarkdownString(se.documentation)?T.to(se.documentation):se.documentation,_e.sortText=se.sortText,_e.filterText=se.filterText,_e.preselect=se.preselect,_e.commitCharacters=se.commitCharacters,M.Range.isIRange(se.range)?_e.range=b.to(se.range):typeof se.range=="object"&&(_e.range={inserting:b.to(se.range.insert),replacing:b.to(se.range.replace)}),_e.keepWhitespace=typeof se.insertTextRules=="undefined"?!1:Boolean(se.insertTextRules&1),typeof se.insertTextRules!="undefined"&&se.insertTextRules&4?_e.insertText=new d.SnippetString(se.insertText):(_e.insertText=se.insertText,_e.textEdit=_e.range instanceof d.Range?new d.TextEdit(_e.range,_e.insertText):void 0),se.additionalTextEdits&&se.additionalTextEdits.length>0&&(_e.additionalTextEdits=se.additionalTextEdits.map(Ce=>j.to(Ce))),_e.command=K&&se.command?K.fromInternal(se.command):void 0,_e}he.to=pe})(D=e.CompletionItem||(e.CompletionItem={}));var O;(function(he){function pe(K){return{label:K.label,documentation:T.fromStrict(K.documentation)}}he.from=pe;function se(K){return{label:K.label,documentation:w.isMarkdownString(K.documentation)?T.to(K.documentation):K.documentation}}he.to=se})(O=e.ParameterInformation||(e.ParameterInformation={}));var x;(function(he){function pe(K){return{label:K.label,documentation:T.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(O.from):[],activeParameter:K.activeParameter}}he.from=pe;function se(K){return{label:K.label,documentation:w.isMarkdownString(K.documentation)?T.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(O.to):[],activeParameter:K.activeParameter}}he.to=se})(x=e.SignatureInformation||(e.SignatureInformation={}));var X;(function(he){function pe(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(x.from):[]}}he.from=pe;function se(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(x.to):[]}}he.to=se})(X=e.SignatureHelp||(e.SignatureHelp={}));var re;(function(he){function pe(se,K){const _e=new d.InlayHint(P.to(K.position),typeof K.label=="string"?K.label:K.label.map(ve.to.bind(void 0,se)),K.kind&&Ie.to(K.kind));return _e.tooltip=w.isMarkdownString(K.tooltip)?T.to(K.tooltip):K.tooltip,_e.command=K.command&&se.fromInternal(K.command),_e.paddingLeft=K.paddingLeft,_e.paddingRight=K.paddingRight,_e}he.to=pe})(re=e.InlayHint||(e.InlayHint={}));var ve;(function(he){function pe(se,K){const _e=new d.InlayHintLabelPart(K.label);return _e.tooltip=w.isMarkdownString(K.tooltip)?T.to(K.tooltip):K.tooltip,v.Command.is(K.command)&&(_e.command=se.fromInternal(K.command)),K.location&&(_e.location=fe.to(K.location)),_e}he.to=pe})(ve=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ie;(function(he){function pe(K){return K}he.from=pe;function se(K){return K}he.to=se})(Ie=e.InlayHintKind||(e.InlayHintKind={}));var Me;(function(he){function pe(K){return{range:b.from(K.range),url:K.target,tooltip:K.tooltip}}he.from=pe;function se(K){let _e;if(K.url)try{_e=typeof K.url=="string"?L.URI.parse(K.url,!0):L.URI.revive(K.url)}catch{}return new d.DocumentLink(b.to(K.range),_e)}he.to=se})(Me=e.DocumentLink||(e.DocumentLink={}));var Le;(function(he){function pe(K){const _e=new d.ColorPresentation(K.label);return K.textEdit&&(_e.textEdit=j.to(K.textEdit)),K.additionalTextEdits&&(_e.additionalTextEdits=K.additionalTextEdits.map(Ce=>j.to(Ce))),_e}he.to=pe;function se(K){return{label:K.label,textEdit:K.textEdit?j.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(_e=>j.from(_e)):void 0}}he.from=se})(Le=e.ColorPresentation||(e.ColorPresentation={}));var ze;(function(he){function pe(K){return new d.Color(K[0],K[1],K[2],K[3])}he.to=pe;function se(K){return[K.red,K.green,K.blue,K.alpha]}he.from=se})(ze=e.Color||(e.Color={}));var xe;(function(he){function pe(K){return{range:b.from(K.range)}}he.from=pe;function se(K){return new d.SelectionRange(b.to(K.range))}he.to=se})(xe=e.SelectionRange||(e.SelectionRange={}));var Re;(function(he){function pe(se){switch(se){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}he.to=pe})(Re=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Qe;(function(he){function pe(K){switch(K){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.On:default:return 1}}he.from=pe;function se(K){switch(K){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 1:default:return d.TextEditorLineNumbersStyle.On}}he.to=se})(Qe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var tt;(function(he){function pe(K){if(K===d.EndOfLine.CRLF)return 1;if(K===d.EndOfLine.LF)return 0}he.from=pe;function se(K){if(K===1)return d.EndOfLine.CRLF;if(K===0)return d.EndOfLine.LF}he.to=se})(tt=e.EndOfLine||(e.EndOfLine={}));var Te;(function(he){function pe(se){if(typeof se=="object")return se.viewId;switch(se){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}he.from=pe})(Te=e.ProgressLocation||(e.ProgressLocation={}));var it;(function(he){function pe(se){const K={start:se.start+1,end:se.end+1};return se.kind&&(K.kind=G.from(se.kind)),K}he.from=pe})(it=e.FoldingRange||(e.FoldingRange={}));var G;(function(he){function pe(se){if(se)switch(se){case d.FoldingRangeKind.Comment:return v.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports:return v.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region:return v.FoldingRangeKind.Region}}he.from=pe})(G=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Q;(function(he){function pe(se){if(se)return{pinned:typeof se.preview=="boolean"?!se.preview:void 0,inactive:se.background,preserveFocus:se.preserveFocus,selection:typeof se.selection=="object"?b.from(se.selection):void 0,override:typeof se.override=="boolean"?c.EditorResolution.DISABLED:void 0}}he.from=pe})(Q=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var le;(function(he){function pe(Ce){return Ce instanceof d.RelativePattern?Ce.toJSON():typeof Ce=="string"?Ce:se(Ce)||K(Ce)?new d.RelativePattern(Ce.baseUri??Ce.base,Ce.pattern).toJSON():Ce}he.from=pe;function se(Ce){const $e=Ce;return $e?L.URI.isUri($e.baseUri)&&typeof $e.pattern=="string":!1}function K(Ce){const $e=Ce;return $e?typeof $e.base=="string"&&typeof $e.pattern=="string":!1}function _e(Ce){return typeof Ce=="string"?Ce:new d.RelativePattern(L.URI.revive(Ce.baseUri),Ce.pattern)}he.to=_e})(le=e.GlobPattern||(e.GlobPattern={}));var Oe;(function(he){function pe(se){if(se){if(Array.isArray(se))return se.map(pe);if(typeof se=="string")return se;{const K=se;return{language:K.language,scheme:K.scheme,pattern:le.from(K.pattern),exclusive:K.exclusive}}}else return}he.from=pe})(Oe=e.LanguageSelector||(e.LanguageSelector={}));var He;(function(he){function pe(K){return{start:K.start,end:K.end}}he.from=pe;function se(K){return new d.NotebookRange(K.start,K.end)}he.to=se})(He=e.NotebookRange||(e.NotebookRange={}));var Ge;(function(he){function pe(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}he.to=pe;function se(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}he.from=se})(Ge=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Je;(function(he){function pe(se){if(se===n.NotebookCellExecutionState.Executing)return d.NotebookCellExecutionState.Executing;if(se===n.NotebookCellExecutionState.Pending)return d.NotebookCellExecutionState.Pending;if(se===n.NotebookCellExecutionState.Unconfirmed)return d.NotebookCellExecutionState.Pending;throw new Error(`Unknown state: ${se}`)}he.to=pe})(Je=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ft;(function(he){function pe(K){switch(K){case d.NotebookCellKind.Markup:return n.CellKind.Markup;case d.NotebookCellKind.Code:default:return n.CellKind.Code}}he.from=pe;function se(K){switch(K){case n.CellKind.Markup:return d.NotebookCellKind.Markup;case n.CellKind.Code:default:return d.NotebookCellKind.Code}}he.to=se})(ft=e.NotebookCellKind||(e.NotebookCellKind={}));var It;(function(he){function pe(K){const _e={metadata:K.metadata??Object.create(null),cells:[]};for(let Ce of K.cells)d.NotebookCellData.validate(Ce),_e.cells.push(St.from(Ce));return _e}he.from=pe;function se(K){const _e=new d.NotebookData(K.cells.map(St.to));return(0,C.isEmptyObject)(K.metadata)||(_e.metadata=K.metadata),_e}he.to=se})(It=e.NotebookData||(e.NotebookData={}));var St;(function(he){function pe(K){return{cellKind:ft.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Ge.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(qe.from):[]}}he.from=pe;function se(K){return new d.NotebookCellData(ft.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(qe.to):void 0,K.metadata,K.internalMetadata?Ge.to(K.internalMetadata):void 0)}he.to=se})(St=e.NotebookCellData||(e.NotebookCellData={}));var kt;(function(he){function pe(K){return{mime:K.mime,valueBytes:I.VSBuffer.wrap(K.data)}}he.from=pe;function se(K){return new d.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}he.to=se})(kt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var qe;(function(he){function pe(K){return{outputId:K.id,items:K.items.map(kt.from),metadata:K.metadata}}he.from=pe;function se(K){const _e=K.items.map(kt.to);return new d.NotebookCellOutput(_e,K.outputId,K.metadata)}he.to=se})(qe=e.NotebookCellOutput||(e.NotebookCellOutput={}));var vt;(function(he){function pe(_e){return K(_e)?{include:(0,C.withNullAsUndefined)(le.from(_e.include)),exclude:(0,C.withNullAsUndefined)(le.from(_e.exclude))}:(0,C.withNullAsUndefined)(le.from(_e))}he.from=pe;function se(_e){return K(_e)?{include:le.to(_e.include),exclude:le.to(_e.exclude)}:le.to(_e)}he.to=se;function K(_e){const Ce=_e;return Ce?!!Ce.include&&!!Ce.exclude:!1}})(vt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Nt;(function(he){function pe(se){return{backgroundColor:se.backgroundColor,borderColor:se.borderColor,top:se.top?E.from(se.top):void 0}}he.from=pe})(Nt=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var nt;(function(he){function pe(se,K,_e){const Ce=typeof se.command=="string"?{title:"",command:se.command}:se.command;return{alignment:se.alignment===d.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Ce,_e),text:se.text,tooltip:se.tooltip,accessibilityInformation:se.accessibilityInformation,priority:se.priority}}he.from=pe})(nt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ut;(function(he){function pe(se){return{transientOutputs:se?.transientOutputs??!1,transientCellMetadata:se?.transientCellMetadata??{},transientDocumentMetadata:se?.transientDocumentMetadata??{}}}he.from=pe})(ut=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var At;(function(he){function pe(K){return{uri:K.uri,provides:K.provides}}he.from=pe;function se(K){return new d.NotebookRendererScript(L.URI.revive(K.uri),K.provides)}he.to=se})(At=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Tt;(function(he){function pe(K){return{message:T.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,location:K.location&&{range:b.from(K.location.range),uri:K.location.uri}}}he.from=pe;function se(K){const _e=new d.TestMessage(typeof K.message=="string"?K.message:T.to(K.message));return _e.actualOutput=K.actual,_e.expectedOutput=K.expected,_e.location=K.location?fe.to(K.location):void 0,_e}he.to=se})(Tt=e.TestMessage||(e.TestMessage={}));var wt;(function(he){he.namespace=m.namespaceTestTag,he.denamespace=m.denamespaceTestTag})(wt=e.TestTag||(e.TestTag={}));var dt;(function(he){function pe(Ce){const $e=(0,r.getPrivateApiFor)(Ce).controllerId;return{extId:y.TestId.fromExtHostTestItem(Ce,$e).toString(),label:Ce.label,uri:L.URI.revive(Ce.uri),busy:!1,tags:Ce.tags.map(Ve=>wt.namespace($e,Ve.id)),range:M.Range.lift(b.from(Ce.range)),description:Ce.description||null,sortText:Ce.sortText||null,error:Ce.error&&T.fromStrict(Ce.error)||null}}he.from=pe;function se(Ce){return{parent:void 0,error:void 0,id:y.TestId.fromString(Ce.extId).localId,label:Ce.label,uri:L.URI.revive(Ce.uri),tags:(Ce.tags||[]).map($e=>{const{tagId:Ve}=wt.denamespace($e);return new d.TestTag(Ve)}),range:b.to(Ce.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Ce.description||void 0,sortText:Ce.sortText||void 0}}he.toPlain=se;function K(Ce){const $e=y.TestId.fromString(Ce.extId),Ve=new r.TestItemImpl($e.controllerId,$e.localId,Ce.label,L.URI.revive(Ce.uri)||void 0);return Ve.range=b.to(Ce.range||void 0),Ve.description=Ce.description||void 0,Ve.sortText=Ce.sortText||void 0,Ve}function _e(Ce){let $e;for(const Ve of Ce.tests){const lt=K(Ve.item);(0,r.getPrivateApiFor)(lt).parent=$e,$e=lt}return $e}he.toItemFromContext=_e})(dt=e.TestItem||(e.TestItem={})),function(he){function pe(K){return{id:K.id}}he.from=pe;function se(K){return new d.TestTag(K.id)}he.to=se}(wt=e.TestTag||(e.TestTag={}));var Rt;(function(he){const pe=(K,_e)=>{const Ce={...dt.toPlain(K.item),parent:void 0,taskStates:K.tasks.map($e=>({state:$e.state,duration:$e.duration,messages:$e.messages.filter(Ve=>Ve.type===0).map(Tt.to)})),children:K.children.map($e=>_e.get($e)).filter(C.isDefined).map($e=>pe($e,_e))};for(const $e of Ce.children)$e.parent=Ce;return Ce};function se(K){const _e=[],Ce=new Map;for(const $e of K.items)Ce.set($e.item.extId,$e),K.request.targets.some(Ve=>Ve.controllerId===$e.controllerId&&Ve.testIds.includes($e.item.extId))&&_e.push($e);return{completedAt:K.completedAt,results:_e.map($e=>pe($e,Ce))}}he.to=se})(Rt=e.TestResults||(e.TestResults={}));var Lt;(function(he){function pe(Ce){return{covered:Ce.covered,total:Ce.covered}}function se(Ce){return"line"in Ce?P.from(Ce):b.from(Ce)}function K(Ce){return"branches"in Ce?{count:Ce.executionCount,location:se(Ce.location),type:1,branches:Ce.branches.length?Ce.branches.map($e=>({count:$e.executionCount,location:$e.location&&se($e.location)})):void 0}:{type:0,count:Ce.executionCount,location:se(Ce.location)}}he.fromDetailed=K;function _e(Ce){return{uri:Ce.uri,statement:pe(Ce.statementCoverage),branch:Ce.branchCoverage&&pe(Ce.branchCoverage),function:Ce.functionCoverage&&pe(Ce.functionCoverage),details:Ce.detailedCoverage?.map(K)}}he.fromFile=_e})(Lt=e.TestCoverage||(e.TestCoverage={}));var Ft;(function(he){function pe(se){switch(se){case 1:return d.CodeActionTriggerKind.Invoke;case 2:return d.CodeActionTriggerKind.Automatic}}he.to=pe})(Ft=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ue;(function(he){function pe(K){const _e=new d.TypeHierarchyItem(z.to(K.kind),K.name,K.detail||"",L.URI.revive(K.uri),b.to(K.range),b.to(K.selectionRange));return _e._sessionId=K._sessionId,_e._itemId=K._itemId,_e}he.to=pe;function se(K,_e,Ce){if(_e=_e??K._sessionId,Ce=Ce??K._itemId,_e===void 0||Ce===void 0)throw new Error("invalid item");return{_sessionId:_e,_itemId:Ce,kind:z.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:b.from(K.range),selectionRange:b.from(K.selectionRange),tags:K.tags?.map(ie.from)}}he.from=se})(Ue=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(Ee[168],be([1,0,2,15,7,8,228]),function(Y,e,o,I,w,B,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(L,M,v,c={timeout:1500,errors:3}){this._logService=L,this._documents=M,this._mainThreadBulkEdits=v,this._thresholds=c,this._callbacks=new S.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(L){return(M,v,c)=>{const r={dispose:this._callbacks.push([M,v,L])};return Array.isArray(c)&&c.push(r),r}}async $participateInSave(L,M){const v=o.URI.revive(L);let c=!1;const g=setTimeout(()=>c=!0,this._thresholds.timeout),r=[];try{for(let n of[...this._callbacks]){if(c)break;const m=this._documents.getDocument(v),y=await this._deliverEventAsyncAndBlameBadListeners(n,{document:m,reason:B.TextDocumentSaveReason.to(M)});r.push(y)}}finally{clearTimeout(g)}return r}_deliverEventAsyncAndBlameBadListeners([L,M,v],c){const g=this._badListeners.get(L);return typeof g=="number"&&g>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(v,L,M,c).then(()=>!0,r=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${v.identifier.value}' threw ERROR`),this._logService.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const n=this._badListeners.get(L);this._badListeners.set(L,n?n+1:1),typeof n=="number"&&n>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${v.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(L,M,v,c){const g=[],r=Date.now(),{document:n,reason:m}=c,{version:y}=n,k=Object.freeze({document:n,reason:m,waitUntil(d){if(Object.isFrozen(g))throw(0,I.illegalState)("waitUntil can not be called async");g.push(Promise.resolve(d))}});try{M.apply(v,[k])}catch(d){return Promise.reject(d)}return Object.freeze(g),new Promise((d,f)=>{const b=setTimeout(()=>f(new Error("timeout")),this._thresholds.timeout);return Promise.all(g).then(l=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${L.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(b),d(l)}).catch(l=>{clearTimeout(b),f(l)})}).then(d=>{const f={edits:[]};for(const b of d)if(Array.isArray(b)&&b.every(l=>l instanceof w.TextEdit))for(const{newText:l,newEol:P,range:u}of b)f.edits.push({_type:2,resource:n.uri,edit:{range:u&&B.Range.from(u),text:l,eol:P&&B.EndOfLine.from(P)}});if(f.edits.length!==0)return y===n.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(f):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(Ee[169],be([1,0,9,26,2,8,85]),function(Y,e,o,I,w,B,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(v,c,g,r){this.start=v,this.deletedCount=c,this.deletedItems=g,this.items=r}static asApiEvents(v){return v.map(c=>({start:c.start,deletedCount:c.deletedCount,deletedItems:c.deletedItems,items:c.items.map(g=>g.apiCell)}))}}class C{constructor(v,c,g){this.notebook=v,this._extHostDocument=c,this._cellData=g,this.handle=g.handle,this.uri=w.URI.revive(g.uri),this.cellKind=g.cellKind,this._outputs=g.outputs.map(B.NotebookCellOutput.to),this._internalMetadata=g.internalMetadata??{},this._metadata=Object.freeze(g.metadata??{}),this._previousResult=Object.freeze(B.NotebookCellExecutionSummary.to(g.internalMetadata??{}))}static asModelAddData(v,c){return{EOL:c.eol,lines:c.source,languageId:c.language,uri:c.uri,isDirty:!1,versionId:1,notebook:v}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const v=this,c=this._extHostDocument.getDocument(this.uri);if(!c)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return v.notebook.getCellIndex(v)},notebook:v.notebook.apiNotebook,kind:B.NotebookCellKind.to(this._cellData.cellKind),document:c.document,get mime(){return v._mime},set mime(g){v._mime=g},get outputs(){return v._outputs.slice(0)},get metadata(){return v._metadata},get executionSummary(){return v._previousResult}})}return this._apiCell}setOutputs(v){this._outputs=v.map(B.NotebookCellOutput.to)}setOutputItems(v,c,g){const r=g.map(B.NotebookCellOutputItem.to),n=this._outputs.find(m=>m.id===v);n&&(c||(n.items.length=0),n.items.push(...r))}setMetadata(v){this._metadata=Object.freeze(v)}setInternalMetadata(v){this._internalMetadata=v,this._previousResult=Object.freeze(B.NotebookCellExecutionSummary.to(v))}setMime(v){}}e.ExtHostCell=C;class L{constructor(v,c,g,r,n,m){this._proxy=v,this._textDocumentsAndEditors=c,this._textDocuments=g,this._emitter=r,this.uri=n,this.handle=L._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=m.viewType,this._metadata=Object.freeze(m.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,m.cells]],!0),this._versionId=m.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const v=this;this._notebook={get uri(){return v.uri},get version(){return v._versionId},get notebookType(){return v._notebookType},get isDirty(){return v._isDirty},get isUntitled(){return v.uri.scheme===o.Schemas.untitled},get isClosed(){return v._disposed},get metadata(){return v._metadata},get cellCount(){return v._cells.length},cellAt(c){return c=v._validateIndex(c),v._cells[c].apiCell},getCells(c){return(c?v._getCells(c):v._cells).map(r=>r.apiCell)},save(){return v._save()}}}return this._notebook}updateBackup(v){this._backup?.delete(),this._backup=v}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(v){v.metadata&&(this._metadata=Object.freeze({...this._metadata,...v.metadata}))}acceptDirty(v){this._isDirty=v}acceptModelChanged(v,c){this._versionId=v.versionId,this._isDirty=c;for(const g of v.rawEvents)g.kind===S.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(g.changes,!1):g.kind===S.NotebookCellsChangeType.Move?this._moveCell(g.index,g.newIdx):g.kind===S.NotebookCellsChangeType.Output?this._setCellOutputs(g.index,g.outputs):g.kind===S.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(g.index,g.outputId,g.append,g.outputItems):g.kind===S.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(g.index,g.language):g.kind===S.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(g.index,g.mime):g.kind===S.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(g.index,g.metadata):g.kind===S.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(g.index,g.internalMetadata)}_validateIndex(v){return v=v|0,v<0?0:v>=this._cells.length?this._cells.length-1:v}_validateRange(v){let c=v.start|0,g=v.end|0;return c<0&&(c=0),g>this._cells.length&&(g=this._cells.length),v.with({start:c,end:g})}_getCells(v){v=this._validateRange(v);const c=[];for(let g=v.start;g<v.end;g++)c.push(this._cells[g]);return c}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(v,c){if(this._disposed)return;const g=[],r=[],n=[];v.reverse().forEach(m=>{const k=m[2].map(b=>{const l=new C(this,this._textDocumentsAndEditors,b);return c||r.push(C.asModelAddData(this.apiNotebook,b)),l}),d=new A(m[0],m[1],[],k),f=this._cells.splice(m[0],m[1],...k);for(const b of f)n.push(b.uri),d.deletedItems.push(b.apiCell);g.push(d)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:n}),c||this._emitter.emitModelChange((0,I.deepFreeze)({document:this.apiNotebook,changes:A.asApiEvents(g)}))}_moveCell(v,c){const g=this._cells.splice(v,1);this._cells.splice(c,0,...g);const r=[new A(v,1,g.map(n=>n.apiCell),[]),new A(c,0,[],g)];this._emitter.emitModelChange((0,I.deepFreeze)({document:this.apiNotebook,changes:A.asApiEvents(r)}))}_setCellOutputs(v,c){const g=this._cells[v];g.setOutputs(c),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.apiNotebook,cells:[g.apiCell]}))}_setCellOutputItems(v,c,g,r){const n=this._cells[v];n.setOutputItems(c,g,r),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.apiNotebook,cells:[n.apiCell]}))}_changeCellLanguage(v,c){const g=this._cells[v];g.apiCell.document.languageId!==c&&this._textDocuments.$acceptModelLanguageChanged(g.uri,c)}_changeCellMime(v,c){const g=this._cells[v];g.apiCell.mime=c}_changeCellMetadata(v,c){const g=this._cells[v],r=g.apiCell.metadata;g.setMetadata(c);const n=g.apiCell.metadata;(0,I.equals)(r,n)||this._emitter.emitCellMetadataChange((0,I.deepFreeze)({document:this.apiNotebook,cell:g.apiCell}))}_changeCellInternalMetadata(v,c){this._cells[v].setInternalMetadata(c)}getCellFromApiCell(v){return this._cells.find(c=>c.apiCell===v)}getCellFromIndex(v){return this._cells[v]}getCell(v){return this._cells.find(c=>c.handle===v)}getCellIndex(v){return this._cells.indexOf(v)}}e.ExtHostNotebookDocument=L,L._handlePool=0}),define(Ee[89],be([1,0,7,8,15]),function(Y,e,o,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class B{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,L){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:C,metadata:L})}replaceCells(C,L,M){this._throwIfFinalized(),!(C===L&&M.length===0)&&this._collectedEdits.push({editType:1,index:C,count:L-C,cells:M.map(I.NotebookCellData.from)})}}class S{constructor(C,L,M,v,c,g){this.id=C,this._proxy=L,this.notebookData=M,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=c,this._visibleRanges=v,this._viewColumn=g}get apiEditor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.apiNotebook},get selections(){return C._selections},set selections(L){if(!Array.isArray(L)||!L.every(o.NotebookRange.isNotebookRange))throw(0,w.illegalArgument)("selections");C._selections=L,C._trySetSelections(L)},get visibleRanges(){return C._visibleRanges},revealRange(L,M){C._proxy.$tryRevealRange(C.id,I.NotebookRange.from(L),M??o.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(L){const M=new B(this.document.version);return L(M),C._applyEdit(M.finalize())},setDecorations(L,M){return C.setDecorations(L,M)}},S.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_trySetSelections(C){this._proxy.$trySetSelections(this.id,C.map(I.NotebookRange.from))}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const L=[];let M=-1;for(let v=0;v<C.cellEdits.length;v++){if(M<0){L.push(C.cellEdits[v]),M++;continue}const g=L[M],r=C.cellEdits[v];if(g.editType===1&&r.editType===1&&g.index===r.index){g.cells.push(...C.cellEdits[v].cells),g.count+=C.cellEdits[v].count;continue}L.push(C.cellEdits[v]),M++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,L)}setDecorations(C,L){if(!(L.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return L.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,I.NotebookRange.from(L),C.key)}}e.ExtHostNotebookEditor=S,S.apiEditorsToExtHost=new WeakMap}),define(Ee[170],be([1,0,8,141,124,20,52,15]),function(Y,e,o,I,w,B,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(c){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=c}async withProgress(c,g,r){const n=this._handles++,{title:m,location:y,cancellable:k}=g,d={label:(0,w.localize)(0,null,c.displayName||c.name),id:c.identifier.value};return this._proxy.$startProgress(n,{location:o.ProgressLocation.from(y),title:m,source:d,cancellable:k},c.isUnderDevelopment?void 0:c.identifier.value).catch(A.onUnexpectedExternalError),this._withProgress(n,r,!!k)}_withProgress(c,g,r){let n;r&&(n=new B.CancellationTokenSource,this._mapHandleToCancellationSource.set(c,n));const m=k=>{this._proxy.$progressEnd(k),this._mapHandleToCancellationSource.delete(k),n&&n.dispose()};let y;try{y=g(new M(this._proxy,c),r&&n?n.token:B.CancellationToken.None)}catch(k){throw m(c),k}return y.then(k=>m(c),k=>m(c)),y}$acceptProgressCanceled(c){const g=this._mapHandleToCancellationSource.get(c);g&&(g.cancel(),this._mapHandleToCancellationSource.delete(c))}}e.ExtHostProgress=C;function L(v,c){return v.message=c.message,typeof c.increment=="number"&&(typeof v.increment=="number"?v.increment+=c.increment:v.increment=c.increment),v}class M extends I.Progress{constructor(c,g){super(r=>this.throttledReport(r));this._proxy=c,this._handle=g}throttledReport(c){this._proxy.$progressReport(this._handle,c)}}Fe([(0,S.throttle)(100,(v,c)=>L(v,c),()=>Object.create(null))],M.prototype,"throttledReport",null)}),define(Ee[90],be([1,0,42,15,53,8,7]),function(Y,e,o,I,w,B,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class A{constructor(c,g,r){const n=A._Keys.nextId();c.$registerTextEditorDecorationType(g.identifier,n,B.DecorationRenderOptions.from(r)),this.value=Object.freeze({key:n,dispose(){c.$removeTextEditorDecorationType(n)}})}}e.TextEditorDecorationType=A,A._Keys=new w.IdGenerator("TextEditorDecorationType");class C{constructor(c,g){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=c,this._documentVersionId=c.version,this._undoStopBefore=g.undoStopBefore,this._undoStopAfter=g.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(c,g){this._throwIfFinalized();let r=null;if(c instanceof S.Position)r=new S.Range(c,c);else if(c instanceof S.Range)r=c;else throw new Error("Unrecognized location");this._pushEdit(r,g,!1)}insert(c,g){this._throwIfFinalized(),this._pushEdit(new S.Range(c,c),g,!0)}delete(c){this._throwIfFinalized();let g=null;if(c instanceof S.Range)g=c;else throw new Error("Unrecognized location");this._pushEdit(g,null,!0)}_pushEdit(c,g,r){const n=this._document.validateRange(c);this._collectedEdits.push({range:n,text:g,forceMoveMarkers:r})}setEndOfLine(c){if(this._throwIfFinalized(),c!==S.EndOfLine.LF&&c!==S.EndOfLine.CRLF)throw(0,I.illegalArgument)("endOfLine");this._setEndOfLine=c}}e.TextEditorEdit=C;class L{constructor(c,g,r,n){this._proxy=c,this._id=g,this._accept(r),this._logService=n;const m=this;this.value={get tabSize(){return m._tabSize},set tabSize(y){m._setTabSize(y)},get insertSpaces(){return m._insertSpaces},set insertSpaces(y){m._setInsertSpaces(y)},get cursorStyle(){return m._cursorStyle},set cursorStyle(y){m._setCursorStyle(y)},get lineNumbers(){return m._lineNumbers},set lineNumbers(y){m._setLineNumbers(y)}}}_accept(c){this._tabSize=c.tabSize,this._insertSpaces=c.insertSpaces,this._cursorStyle=c.cursorStyle,this._lineNumbers=B.TextEditorLineNumbersStyle.to(c.lineNumbers)}_validateTabSize(c){if(c==="auto")return"auto";if(typeof c=="number"){const g=Math.floor(c);return g>0?g:null}if(typeof c=="string"){const g=parseInt(c,10);return isNaN(g)?null:g>0?g:null}return null}_setTabSize(c){const g=this._validateTabSize(c);if(g!==null){if(typeof g=="number"){if(this._tabSize===g)return;this._tabSize=g}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:g}))}}_validateInsertSpaces(c){return c==="auto"?"auto":c==="false"?!1:Boolean(c)}_setInsertSpaces(c){const g=this._validateInsertSpaces(c);if(typeof g=="boolean"){if(this._insertSpaces===g)return;this._insertSpaces=g}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:g}))}_setCursorStyle(c){this._cursorStyle!==c&&(this._cursorStyle=c,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:c})))}_setLineNumbers(c){this._lineNumbers!==c&&(this._lineNumbers=c,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:B.TextEditorLineNumbersStyle.from(c)})))}assign(c){const g={};let r=!1;if(typeof c.tabSize!="undefined"){const n=this._validateTabSize(c.tabSize);n==="auto"?(r=!0,g.tabSize=n):typeof n=="number"&&this._tabSize!==n&&(this._tabSize=n,r=!0,g.tabSize=n)}if(typeof c.insertSpaces!="undefined"){const n=this._validateInsertSpaces(c.insertSpaces);n==="auto"?(r=!0,g.insertSpaces=n):this._insertSpaces!==n&&(this._insertSpaces=n,r=!0,g.insertSpaces=n)}typeof c.cursorStyle!="undefined"&&this._cursorStyle!==c.cursorStyle&&(this._cursorStyle=c.cursorStyle,r=!0,g.cursorStyle=c.cursorStyle),typeof c.lineNumbers!="undefined"&&this._lineNumbers!==c.lineNumbers&&(this._lineNumbers=c.lineNumbers,r=!0,g.lineNumbers=B.TextEditorLineNumbersStyle.from(c.lineNumbers)),r&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,g))}_warnOnError(c,g){g.catch(r=>{this._logService.warn(`ExtHostTextEditorOptions '${c}' failed:'`),this._logService.warn(r)})}}e.ExtHostTextEditorOptions=L;class M{constructor(c,g,r,n,m,y,k,d){this.id=c,this._proxy=g,this._logService=r,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=m,this._options=new L(this._proxy,this.id,y,r),this._visibleRanges=k,this._viewColumn=d;const f=this;this.value=Object.freeze({get document(){return n.getValue()},set document(b){throw(0,I.readonly)("document")},get selection(){return f._selections&&f._selections[0]},set selection(b){if(!(b instanceof S.Selection))throw(0,I.illegalArgument)("selection");f._selections=[b],f._trySetSelection()},get selections(){return f._selections},set selections(b){if(!Array.isArray(b)||b.some(l=>!(l instanceof S.Selection)))throw(0,I.illegalArgument)("selections");f._selections=b,f._trySetSelection()},get visibleRanges(){return f._visibleRanges},set visibleRanges(b){throw(0,I.readonly)("visibleRanges")},get options(){return f._options.value},set options(b){f._disposed||f._options.assign(b)},get viewColumn(){return f._viewColumn},set viewColumn(b){throw(0,I.readonly)("viewColumn")},edit(b,l={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const P=new C(n.getValue(),l);return b(P),f._applyEdit(P)},insertSnippet(b,l,P={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let u;if(!l||Array.isArray(l)&&l.length===0)u=f._selections.map(i=>B.Range.from(i));else if(l instanceof S.Position){const{lineNumber:i,column:s}=B.Position.from(l);u=[{startLineNumber:i,startColumn:s,endLineNumber:i,endColumn:s}]}else if(l instanceof S.Range)u=[B.Range.from(l)];else{u=[];for(const i of l)if(i instanceof S.Range)u.push(B.Range.from(i));else{const{lineNumber:s,column:t}=B.Position.from(i);u.push({startLineNumber:s,startColumn:t,endLineNumber:s,endColumn:t})}}return g.$tryInsertSnippet(c,b.value,u,P)},setDecorations(b,l){const P=l.length===0;P&&!f._hasDecorationsForKey.has(b.key)||(P?f._hasDecorationsForKey.delete(b.key):f._hasDecorationsForKey.add(b.key),f._runOnProxy(()=>{if(B.isDecorationOptionsArr(l))return g.$trySetDecorations(c,b.key,B.fromRangeOrRangeWithMessage(l));{const u=new Array(4*l.length);for(let i=0,s=l.length;i<s;i++){const t=l[i];u[4*i]=t.start.line+1,u[4*i+1]=t.start.character+1,u[4*i+2]=t.end.line+1,u[4*i+3]=t.end.character+1}return g.$trySetDecorationsFast(c,b.key,u)}}))},revealRange(b,l){f._runOnProxy(()=>g.$tryRevealRange(c,B.Range.from(b),l||S.TextEditorRevealType.Default))},show(b){g.$tryShowEditor(c,B.ViewColumn.from(b))},hide(){g.$tryHideEditor(c)}})}dispose(){(0,o.ok)(!this._disposed),this._disposed=!0}_acceptOptions(c){(0,o.ok)(!this._disposed),this._options._accept(c)}_acceptVisibleRanges(c){(0,o.ok)(!this._disposed),this._visibleRanges=c}_acceptViewColumn(c){(0,o.ok)(!this._disposed),this._viewColumn=c}_acceptSelections(c){(0,o.ok)(!this._disposed),this._selections=c}async _trySetSelection(){const c=this._selections.map(B.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,c)),this.value}_applyEdit(c){const g=c.finalize();if(g.edits.length===0&&!g.setEndOfLine)return Promise.resolve(!0);const r=g.edits.map(m=>m.range);r.sort((m,y)=>m.end.line===y.end.line?m.end.character===y.end.character?m.start.line===y.start.line?m.start.character-y.start.character:m.start.line-y.start.line:m.end.character-y.end.character:m.end.line-y.end.line);for(let m=0,y=r.length-1;m<y;m++){const k=r[m].end;if(r[m+1].start.isBefore(k))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const n=g.edits.map(m=>({range:B.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,g.documentVersionId,n,{setEndOfLine:typeof g.setEndOfLine=="number"?B.EndOfLine.from(g.setEndOfLine):void 0,undoStopBefore:g.undoStopBefore,undoStopAfter:g.undoStopAfter})}_runOnProxy(c){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,g=>(g instanceof Error&&g.name==="DISPOSED"||this._logService.warn(g),null))}}e.ExtHostTextEditor=M}),define(Ee[171],be([1,0,13,5,6,11,47,8,62,63,48]),function(Y,e,o,I,w,B,S,A,C,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class v extends w.Disposable{constructor(g){super();this.controllerId=g,this.debounceSendDiff=this._register(new o.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new I.Emitter),this.root=new S.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(g){this._resolveHandler=g;for(const r of this.tree.values())this.updateExpandability(r)}collectDiff(){const g=this.diff;return this.diff=[],g}pushDiff(g){const r=this.diff[this.diff.length-1];if(r&&g.op===1){if(r.op===1&&r.item.extId===g.item.extId){(0,C.applyTestItemUpdate)(r.item,g.item);return}if(r.op===0&&r.item.item.extId===g.item.extId){(0,C.applyTestItemUpdate)(r.item,g.item);return}}this.diff.push(g),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(g,r){const n=this.tree.get(g);if(!!n){if((n.expandLevels===void 0||r>n.expandLevels)&&(n.expandLevels=r),n.expand===1){const m=this.resolveChildren(n);return m.isOpen()?this.expandChildren(n,r-1):m.wait().then(()=>this.expandChildren(n,r-1))}else if(n.expand===3)return n.resolveBarrier?.isOpen()===!1?n.resolveBarrier.wait().then(()=>this.expandChildren(n,r-1)):this.expandChildren(n,r-1)}}dispose(){for(const g of this.tree.values())(0,S.getPrivateApiFor)(g.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(g,r){switch(r.op){case 2:this.pushDiff({op:4,itemId:g.fullId.toString()});break;case 1:this.removeItem(L.TestId.joinToString(g.fullId,r.id));break;case 0:this.upsertItem(r.item,g);break;case 4:for(const n of r.ops)this.onTestItemEvent(g,n);break;case 3:{const{key:n,value:m,previous:y}=r,k=g.fullId.toString();switch(n){case"canResolveChildren":this.updateExpandability(g);break;case"tags":this.diffTagRefs(m,y,k);break;case"range":this.pushDiff({op:1,item:{extId:k,item:{range:M.Range.lift(A.Range.from(m))}}});break;case"error":this.pushDiff({op:1,item:{extId:k,item:{error:A.MarkdownString.fromStrict(m)||null}}});break;default:this.pushDiff({op:1,item:{extId:k,item:{[n]:m??null}}});break}break}default:(0,B.assertNever)(r)}}upsertItem(g,r){if(!(g instanceof S.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${g.id} did not`);const n=L.TestId.fromExtHostTestItem(g,this.root.id,r?.actual),m=(0,S.getPrivateApiFor)(g);m.parent&&m.parent!==r?.actual&&m.parent.children.delete(g.id);let y=this.tree.get(n.toString());if(!y){y={fullId:n,actual:g,parent:r?n.parentId:null,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:0},g.tags.forEach(this.incrementTagRefs,this),this.tree.set(y.fullId.toString(),y),this.setItemParent(g,r),this.pushDiff({op:0,item:{parent:y.parent&&y.parent.toString(),controllerId:this.controllerId,expand:y.expand,item:A.TestItem.from(g)}}),this.connectItemAndChildren(g,y,r);return}if(y.actual===g){this.connectItem(g,y,r);return}const k=y.actual.children,d=y.actual,f=(0,S.diffTestItems)(d,g);(0,S.getPrivateApiFor)(d).listener=void 0,y.actual=g,y.expand=0;for(const[b,l]of f)this.onTestItemEvent(y,{op:3,key:b,value:l,previous:d[b]});this.connectItemAndChildren(g,y,r);for(const b of k)g.children.get(b.id)||this.removeItem(L.TestId.joinToString(n,b.id))}diffTagRefs(g,r,n){const m=new Set(r.map(y=>y.id));for(const y of g)m.delete(y.id)||this.incrementTagRefs(y);this.pushDiff({op:1,item:{extId:n,item:{tags:g.map(y=>A.TestTag.namespace(this.controllerId,y.id))}}}),m.forEach(this.decrementTagRefs,this)}incrementTagRefs(g){const r=this.tags.get(g.id);r?r.refCount++:(this.tags.set(g.id,{refCount:1}),this.pushDiff({op:5,tag:{id:A.TestTag.namespace(this.controllerId,g.id),ctrlLabel:this.root.label}}))}decrementTagRefs(g){const r=this.tags.get(g);r&&!--r.refCount&&(this.tags.delete(g),this.pushDiff({op:6,id:(0,C.namespaceTestTag)(this.controllerId,g)}))}setItemParent(g,r){(0,S.getPrivateApiFor)(g).parent=r&&r.actual!==this.root?r.actual:void 0}connectItem(g,r,n){this.setItemParent(g,n);const m=(0,S.getPrivateApiFor)(g);m.parent=n?.actual,m.listener=y=>this.onTestItemEvent(r,y),this.updateExpandability(r)}connectItemAndChildren(g,r,n){this.connectItem(g,r,n);for(const m of g.children)this.upsertItem(m,r)}updateExpandability(g){let r;this._resolveHandler?g.resolveBarrier?r=g.resolveBarrier.isOpen()?3:2:r=g.actual.canResolveChildren?1:0:r=0,r!==g.expand&&(g.expand=r,this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:r}}),r===1&&g.expandLevels!==void 0&&this.resolveChildren(g))}expandChildren(g,r){if(r<0)return;const n=[];for(const m of g.actual.children){const y=this.expand(L.TestId.joinToString(g.fullId,m.id),r);(0,o.isThenable)(y)&&n.push(y)}if(n.length)return Promise.all(n).then(()=>{})}resolveChildren(g){if(g.resolveBarrier)return g.resolveBarrier;if(!this._resolveHandler){const y=new o.Barrier;return y.open(),y}g.expand=2,this.pushExpandStateUpdate(g);const r=g.resolveBarrier=new o.Barrier,n=y=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),g.actual!==this.root&&(g.actual.error=y.stack||y.message||String(y))};let m;try{m=this._resolveHandler(g.actual===this.root?void 0:g.actual)}catch(y){n(y)}return(0,o.isThenable)(m)?m.catch(n).then(()=>{r.open(),this.updateExpandability(g)}):(r.open(),this.updateExpandability(g)),g.resolveBarrier}pushExpandStateUpdate(g){this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:g.expand}})}removeItem(g){const r=this.tree.get(g);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:g});const n=[r];for(;n.length;){const m=n.pop();if(!!m){(0,S.getPrivateApiFor)(m.actual).listener=void 0;for(const y of m.actual.tags)this.decrementTagRefs(y.id);this.tree.delete(m.fullId.toString());for(const y of m.actual.children)n.push(this.tree.get(L.TestId.joinToString(m.fullId,y.id)))}}}flushDiff(){const g=this.collectDiff();g.length&&this.diffOpEmitter.fire(g)}}e.SingleUseTestCollection=v}),define(Ee[172],be([1,0,3,138]),function(Y,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,o.refineServiceDecorator)(I.IEnvironmentService)}),define(Ee[173],be([1,0,25,5,17]),function(Y,e,o,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class B{constructor(M){this.removedDueToLooping=M}}e.DeltaExtensionsResult=B;class S{constructor(M){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=M,this._initialize()}_initialize(){this._extensionDescriptions.sort(C),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const M of this._extensionDescriptions){if(this._extensionsMap.has(o.ExtensionIdentifier.toKey(M.identifier))){console.error("Extension `"+M.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(o.ExtensionIdentifier.toKey(M.identifier),M),this._extensionsArr.push(M),Array.isArray(M.activationEvents))for(let v of M.activationEvents)v==="onUri"&&(v=`onUri:${o.ExtensionIdentifier.toKey(M.identifier)}`),this._activationMap.has(v)||this._activationMap.set(v,[]),this._activationMap.get(v).push(M)}}keepOnly(M){const v=new Set;M.forEach(c=>v.add(o.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>v.has(o.ExtensionIdentifier.toKey(c.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(M,v){M.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(M));const c=S._findLoopingExtensions(this._extensionDescriptions);if(v=v.concat(c.map(g=>g.identifier)),v.length>0){const g=new Set;v.forEach(r=>g.add(o.ExtensionIdentifier.toKey(r))),this._extensionDescriptions=this._extensionDescriptions.filter(r=>!g.has(o.ExtensionIdentifier.toKey(r.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new B(c)}static _findLoopingExtensions(M){const v=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(m){this._nodesSet.has(m)||(this._nodesSet.add(m),this._nodesArr.push(m))}addArc(m,y){this.addNode(m),this.addNode(y),this._arcs.has(m)?this._arcs.get(m).push(y):this._arcs.set(m,[y])}getArcs(m){return this._arcs.has(m)?this._arcs.get(m):[]}hasOnlyGoodArcs(m,y){const k=v.getArcs(m);for(let d=0;d<k.length;d++)if(!y.has(k[d]))return!1;return!0}getNodes(){return this._nodesArr}};let c=new Map;for(let m of M){const y=o.ExtensionIdentifier.toKey(m.identifier);if(c.set(y,m),m.extensionDependencies)for(let k of m.extensionDependencies){const d=o.ExtensionIdentifier.toKey(k);v.addArc(y,d)}}let g=new Set;v.getNodes().filter(m=>v.getArcs(m).length===0).forEach(m=>g.add(m));let r=v.getNodes().filter(m=>!g.has(m)),n;do{n=!1;for(let m=0;m<r.length;m++){const y=r[m];v.hasOnlyGoodArcs(y,g)&&(r.splice(m,1),m--,g.add(y),n=!0)}}while(n);return r.map(m=>c.get(m))}containsActivationEvent(M){return this._activationMap.has(M)}containsExtension(M){return this._extensionsMap.has(o.ExtensionIdentifier.toKey(M))}getExtensionDescriptionsForActivationEvent(M){const v=this._activationMap.get(M);return v?v.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(M){const v=this._extensionsMap.get(o.ExtensionIdentifier.toKey(M));return v||void 0}}e.ExtensionDescriptionRegistry=S;var A;(function(L){L[L.Builtin=0]="Builtin",L[L.User=1]="User",L[L.Dev=2]="Dev"})(A||(A={}));function C(L,M){const v=L.isBuiltin?0:L.isUnderDevelopment?2:1,c=M.isBuiltin?0:M.isUnderDevelopment?2:1;if(v!==c)return v-c;const g=w.posix.basename(L.extensionLocation.path),r=w.posix.basename(M.extensionLocation.path);return g<r?-1:g>r?1:0}}),define(Ee[91],be([1,0,21]),function(Y,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var I;(function(C){C[C.Desktop=1]="Desktop",C[C.Web=2]="Web"})(I=e.UIKind||(e.UIKind={}));var w;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(w=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var B;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(B=e.MessageType||(e.MessageType={}));function S(C){const L=o.VSBuffer.alloc(1);switch(C){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.createMessageOfType=S;function A(C,L){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.isMessageOfType=A}),define(Ee[28],be([1,0,5,2,3,25,144]),function(Y,e,o,I,w,B,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new B.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:I.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,w.createDecorator)("extensionService");var A;(function(f){f[f.None=0]="None",f[f.LocalProcess=1]="LocalProcess",f[f.LocalWebWorker=2]="LocalWebWorker",f[f.Remote=3]="Remote"})(A=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function C(f){switch(f){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=C;class L{constructor(b){this.dependency=b}}e.MissingExtensionDependency=L;var M;(function(f){f[f.LocalProcess=0]="LocalProcess",f[f.LocalWebWorker=1]="LocalWebWorker",f[f.Remote=2]="Remote"})(M=e.ExtensionHostKind||(e.ExtensionHostKind={}));function v(f){switch(f){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=v;function c(f,b){return f.enabledApiProposals?f.enabledApiProposals.includes(b):!1}e.isProposedApiEnabled=c;function g(f,b){if(!c(f,b))throw new Error(`Extension '${f.identifier.value}' CANNOT use API proposal: ${b}.
Its package.json#enabledApiProposals-property declares: ${f.enabledApiProposals?.join(", ")??"[]"} but NOT ${b}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${f.identifier.value}`)}e.checkProposedApiEnabled=g;class r{constructor(b,l,P,u){this.codeLoadingTime=b,this.activateCallTime=l,this.activateResolvedTime=P,this.activationReason=u}}e.ActivationTimes=r;class n{constructor(b,l){this.description=b,this.value=l}}e.ExtensionPointContribution=n,e.ExtensionHostLogFileName="exthost";var m;(function(f){f[f.Normal=0]="Normal",f[f.Immediate=1]="Immediate"})(m=e.ActivationKind||(e.ActivationKind={}));function y(f){return{type:f.isBuiltin?0:1,isBuiltin:f.isBuiltin||f.isUserBuiltin,identifier:{id:(0,S.getGalleryExtensionId)(f.publisher,f.name),uuid:f.uuid},manifest:f,location:f.extensionLocation}}e.toExtension=y;function k(f,b){return{identifier:new B.ExtensionIdentifier((0,S.getExtensionId)(f.manifest.publisher,f.manifest.name)),isBuiltin:f.type===0,isUserBuiltin:f.type===1&&f.isBuiltin,isUnderDevelopment:!!b,extensionLocation:f.location,...f.manifest,uuid:f.identifier.uuid}}e.toExtensionDescription=k;class d{constructor(){this.onDidRegisterExtensions=o.Event.None,this.onDidChangeExtensionsStatus=o.Event.None,this.onDidChangeExtensions=o.Event.None,this.onWillActivateByEvent=o.Event.None,this.onDidChangeResponsiveChange=o.Event.None}activateByEvent(b){return Promise.resolve(void 0)}activationEventIsDone(b){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(b){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(b){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(b){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(b,l){return Promise.resolve()}}e.NullExtensionService=d}),define(Ee[174],be([1,0,15,25,28,12]),function(Y,e,o,I,w,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const S=Promise.resolve(void 0);class A{constructor(n,m,y,k){this.startup=n,this.codeLoadingTime=m,this.activateCallTime=y,this.activateResolvedTime=k}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class C{constructor(n){this._startup=n,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(n,m){return n===-1||m===-1?-1:m-n}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class L{constructor(n,m,y,k,d,f){this.activationFailed=n,this.activationFailedError=m,this.activationTimes=y,this.module=k,this.exports=d,this.subscriptions=f}}e.ActivatedExtension=L;class M extends L{constructor(n){super(!1,null,n,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=M;class v extends L{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=v;class c extends L{constructor(n){super(!0,n,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=c;let g=class{constructor(n,m,y,k,d){this._logService=d,this._isDisposed=!1,this._registry=n,this._resolvedExtensionsSet=new Set,m.forEach(f=>this._resolvedExtensionsSet.add(I.ExtensionIdentifier.toKey(f))),this._hostExtensionsMap=new Map,y.forEach(f=>this._hostExtensionsMap.set(I.ExtensionIdentifier.toKey(f),f)),this._host=k,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(n){const m=I.ExtensionIdentifier.toKey(n);return this._activatedExtensions.has(m)}getActivatedExtension(n){const m=I.ExtensionIdentifier.toKey(n),y=this._activatedExtensions.get(m);if(!y)throw new Error("Extension `"+n.value+"` is not known or not activated");return y}activateByEvent(n,m){if(this._alreadyActivatedEvents[n])return S;const y=this._registry.getExtensionDescriptionsForActivationEvent(n);return this._activateExtensions(y.map(k=>({id:k.identifier,reason:{startup:m,extensionId:k.identifier,activationEvent:n}}))).then(()=>{this._alreadyActivatedEvents[n]=!0})}activateById(n,m){const y=this._registry.getExtensionDescription(n);if(!y)throw new Error("Extension `"+n+"` is not known");return this._activateExtensions([{id:y.identifier,reason:m}])}_handleActivateRequest(n,m,y){if(this._hostExtensionsMap.has(I.ExtensionIdentifier.toKey(n.id))){m[I.ExtensionIdentifier.toKey(n.id)]=n;return}const k=this._registry.getExtensionDescription(n.id);if(!k){const b=new Error(`Cannot activate unknown extension '${n.id.value}'`);this._host.onExtensionActivationError(n.id,b,new w.MissingExtensionDependency(n.id.value)),this._activatedExtensions.set(I.ExtensionIdentifier.toKey(n.id),new c(b));return}const d=typeof k.extensionDependencies=="undefined"?[]:k.extensionDependencies;let f=!0;for(let b=0,l=d.length;b<l;b++){const P=d[b];if(this._resolvedExtensionsSet.has(I.ExtensionIdentifier.toKey(P)))continue;const u=this._activatedExtensions.get(I.ExtensionIdentifier.toKey(P));if(u&&!u.activationFailed)continue;if(u&&u.activationFailed){const a=k.displayName||k.identifier.value,p=this._registry.getExtensionDescription(P),h=p&&p.displayName||P,_=new Error(`Cannot activate the '${a}' extension because its dependency '${h}' failed to activate`);_.detail=u.activationFailedError,this._host.onExtensionActivationError(k.identifier,_,null),this._activatedExtensions.set(I.ExtensionIdentifier.toKey(k.identifier),new c(_));return}if(this._hostExtensionsMap.has(I.ExtensionIdentifier.toKey(P))){f=!1,m[I.ExtensionIdentifier.toKey(P)]={id:this._hostExtensionsMap.get(I.ExtensionIdentifier.toKey(P)),reason:n.reason};continue}const i=this._registry.getExtensionDescription(P);if(i){if(!i.main&&!i.browser)continue;f=!1,m[I.ExtensionIdentifier.toKey(P)]={id:i.identifier,reason:n.reason};continue}const s=k.displayName||k.identifier.value,t=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${P}'`);this._host.onExtensionActivationError(k.identifier,t,new w.MissingExtensionDependency(P)),this._activatedExtensions.set(I.ExtensionIdentifier.toKey(k.identifier),new c(t));return}f?m[I.ExtensionIdentifier.toKey(k.identifier)]=n:y.push(n)}_activateExtensions(n){if(n.length===0||(n=n.filter(d=>!this._activatedExtensions.has(I.ExtensionIdentifier.toKey(d.id))),n.length===0))return Promise.resolve(void 0);const m=Object.create(null),y=[];for(let d=0,f=n.length;d<f;d++)this._handleActivateRequest(n[d],m,y);for(let d=0,f=y.length;d<f;d++){const b=I.ExtensionIdentifier.toKey(y[d].id);m[b]&&delete m[b]}const k=Object.keys(m).map(d=>m[d]);return y.length===0?Promise.all(k.map(d=>this._activateExtension(d.id,d.reason))).then(d=>{}):this._activateExtensions(k).then(d=>this._activateExtensions(y))}_activateExtension(n,m){const y=I.ExtensionIdentifier.toKey(n);if(this._activatedExtensions.has(y))return Promise.resolve(void 0);const k=this._activatingExtensions.get(y);if(k)return k;const d=this._host.actualActivateExtension(n,m).then(void 0,f=>{const b=new Error;return f&&f.name&&(b.name=f.name),f&&f.message?b.message=`Activating extension '${n.value}' failed: ${f.message}.`:b.message=`Activating extension '${n.value}' failed: ${f}.`,f&&f.stack&&(b.stack=f.stack),this._isDisposed&&o.isCancellationError(f)?new c(f):(this._host.onExtensionActivationError(n,b,null),this._logService.error(`Activating extension ${n.value} failed due to an error:`),this._logService.error(f),new c(f))}).then(f=>{this._activatedExtensions.set(y,f),this._activatingExtensions.delete(y)});return this._activatingExtensions.set(y,d),d}};g=Fe([Ne(4,B.ILogService)],g),e.ExtensionsActivator=g}),define(Ee[175],be([1,0,12,27,28]),function(Y,e,o,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let B=class extends o.LogService{constructor(A,C){super(A.createLogger(C.logFile,{name:w.ExtensionHostLogFileName}))}};B=Fe([Ne(0,o.ILoggerService),Ne(1,I.IExtHostInitDataService)],B),e.ExtHostLogService=B}),define(Ee[176],be([1,0,15]),function(Y,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class I{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((B,S)=>{this._actualOk=B,this._actualErr=S,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(B){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=B,this._actual&&this._actualOk(B))}resolveErr(B){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=B,this._actual?this._actualErr(B):(0,o.onUnexpectedError)(B))}then(B,S){return this._ensureActual().then(B,S)}catch(B){return this._ensureActual().then(void 0,B)}finally(B){return this._ensureActual().finally(B)}}e.LazyPromise=I}),define(Ee[38],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class o{constructor(C){this._proxyIdentifierBrand=void 0,this.sid=C,this.nid=++o.count}}e.ProxyIdentifier=o,o.count=0;const I=[];function w(A){const C=new o(A);return I[C.nid]=C,C}e.createProxyIdentifier=w;function B(A){return I[A].sid}e.getStringIdentifierForProxy=B;class S{constructor(C){this.value=C}}e.SerializableObjectWithBuffers=S}),define(Ee[4],be([1,0,54,2,38]),function(Y,e,o,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabKind=e.TextEditorRevealType=void 0;var B;(function(k){k[k.Default=0]="Default",k[k.InCenter=1]="InCenter",k[k.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",k[k.AtTop=3]="AtTop"})(B=e.TextEditorRevealType||(e.TextEditorRevealType={}));var S;(function(k){k[k.SINGULAR=0]="SINGULAR",k[k.DIFF=1]="DIFF",k[k.SIDEBYSIDE=2]="SIDEBYSIDE",k[k.OTHER=3]="OTHER"})(S=e.TabKind||(e.TabKind={}));var A;(function(k){k[k.Editable=0]="Editable",k[k.SupportsHotExit=1]="SupportsHotExit"})(A=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var C;(function(k){k[k.Int8Array=1]="Int8Array",k[k.Uint8Array=2]="Uint8Array",k[k.Uint8ClampedArray=3]="Uint8ClampedArray",k[k.Int16Array=4]="Int16Array",k[k.Uint16Array=5]="Uint16Array",k[k.Int32Array=6]="Int32Array",k[k.Uint32Array=7]="Uint32Array",k[k.Float32Array=8]="Float32Array",k[k.Float64Array=9]="Float64Array",k[k.BigInt64Array=10]="BigInt64Array",k[k.BigUint64Array=11]="BigUint64Array"})(C=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var L;(function(k){k[k.Text=1]="Text",k[k.Error=2]="Error",k[k.Rich=3]="Rich"})(L=e.CellOutputKind||(e.CellOutputKind={}));var M;(function(k){k[k.Default=0]="Default",k[k.InCenter=1]="InCenter",k[k.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",k[k.AtTop=3]="AtTop"})(M=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var v;(function(k){k[k.None=0]="None",k[k.Process=1]="Process",k[k.Output=2]="Output"})(v=e.CandidatePortSource||(e.CandidatePortSource={}));class c{static mixin(d){return d._id=c._n++,d}}e.IdObject=c,c._n=0;var g;(function(k){k.label="a",k.kind="b",k.detail="c",k.documentation="d",k.sortText="e",k.filterText="f",k.preselect="g",k.insertText="h",k.insertTextRules="i",k.range="j",k.commitCharacters="k",k.additionalTextEdits="l",k.command="m",k.kindModifier="n"})(g=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var r;(function(k){k.defaultRanges="a",k.completions="b",k.isIncomplete="c",k.duration="d"})(r=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var n;(function(k){k[k.File=1]="File",k[k.Text=2]="Text",k[k.Cell=3]="Cell"})(n=e.WorkspaceEditType||(e.WorkspaceEditType={}));function m(k){if(k&&k.edits)for(const d of k.edits)typeof d.resource=="object"?d.resource=I.URI.revive(d.resource):(d.newUri=I.URI.revive(d.newUri),d.oldUri=I.URI.revive(d.oldUri)),d.metadata&&d.metadata.iconPath&&(d.metadata=(0,o.revive)(d.metadata));return k}e.reviveWorkspaceEditDto=m;var y;(function(k){k[k.Workspace=0]="Workspace",k[k.TextDocument=1]="TextDocument"})(y=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,w.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,w.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,w.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,w.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,w.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,w.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,w.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,w.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,w.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,w.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,w.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,w.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,w.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,w.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,w.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,w.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,w.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,w.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,w.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,w.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,w.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,w.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,w.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,w.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,w.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,w.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,w.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,w.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,w.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,w.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,w.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,w.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,w.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,w.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,w.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,w.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,w.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,w.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,w.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,w.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,w.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,w.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,w.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,w.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,w.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,w.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,w.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,w.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,w.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,w.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,w.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,w.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,w.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,w.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,w.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,w.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,w.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,w.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,w.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,w.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,w.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,w.createProxyIdentifier)("ExtHostTelemetry")}}),define(Ee[64],be([1,0,4,5,3]),function(Y,e,o,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class B{constructor(A){this._onDidChangePassword=new I.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=A.getProxy(o.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this._onDidChangePassword.fire(A)}get(A,C){return this._proxy.$getPassword(A,C)}store(A,C,L){return this._proxy.$setPassword(A,C,L)}delete(A,C){return this._proxy.$deletePassword(A,C)}}e.ExtHostSecretState=B,e.IExtHostSecretState=(0,w.createDecorator)("IExtHostSecretState")}),define(Ee[65],be([1,0,3,12,4,14]),function(Y,e,o,I,w,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,o.createDecorator)("IExtHostApiDeprecationService");let S=class{constructor(C,L){this._extHostLogService=L,this._reportedUsages=new Set,this._telemetryShape=C.getProxy(w.MainContext.MainThreadTelemetry)}report(C,L,M){const v=this.getUsageKey(C,L);this._reportedUsages.has(v)||(this._reportedUsages.add(v),L.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${C}' is deprecated. ${M}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:L.identifier.value,apiId:C}))}getUsageKey(C,L){return`${C}-${L.identifier.value}`}};S=Fe([Ne(0,B.IExtHostRpcService),Ne(1,I.ILogService)],S),e.ExtHostApiDeprecationService=S,e.NullApiDeprecationService=Object.freeze(new class{report(A,C,L){}})}),define(Ee[177],be([1,0,5,4,7,25]),function(Y,e,o,I,w,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class S{constructor(C){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new o.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=C.getProxy(I.MainContext.MainThreadAuthentication)}$setProviders(C){return this._providers=C,Promise.resolve()}async getSession(C,L,M,v={}){const c=B.ExtensionIdentifier.toKey(C.identifier),g=this._inFlightRequests.get(c)||[],r=[...M].sort().join(" ");let n=g.find(m=>m.scopes===r);if(n)return n.result;{const m=this._getSession(C,c,L,M,v);n={scopes:r,result:m},g.push(n),this._inFlightRequests.set(c,g);try{await m}finally{const y=g.findIndex(k=>k.scopes===r);y>-1&&(g.splice(y),this._inFlightRequests.set(c,g))}return m}}async _getSession(C,L,M,v,c={}){await this._proxy.$ensureProvider(M);const g=C.displayName||C.name;return this._proxy.$getSession(M,v,L,g,c)}async removeSession(C,L){const M=this._authenticationProviders.get(C);return M?M.provider.removeSession(L):this._proxy.$removeSession(C,L)}registerAuthenticationProvider(C,L,M,v){if(this._authenticationProviders.get(C))throw new Error(`An authentication provider with id '${C}' is already registered.`);this._authenticationProviders.set(C,{label:L,provider:M,options:v??{supportsMultipleAccounts:!1}}),this._providers.find(g=>g.id===C)||this._providers.push({id:C,label:L});const c=M.onDidChangeSessions(g=>{this._proxy.$sendDidChangeSessions(C,{added:g.added??[],changed:g.changed??[],removed:g.removed??[]})});return this._proxy.$registerAuthenticationProvider(C,L,v?.supportsMultipleAccounts??!1),new w.Disposable(()=>{c.dispose(),this._authenticationProviders.delete(C);const g=this._providers.findIndex(r=>r.id===C);g>-1&&this._providers.splice(g),this._proxy.$unregisterAuthenticationProvider(C)})}$createSession(C,L){const M=this._authenticationProviders.get(C);if(M)return Promise.resolve(M.provider.createSession(L));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$removeSession(C,L){const M=this._authenticationProviders.get(C);if(M)return Promise.resolve(M.provider.removeSession(L));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$getSessions(C,L){const M=this._authenticationProviders.get(C);if(M)return Promise.resolve(M.provider.getSessions(L));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$onDidChangeAuthenticationSessions(C,L){return this._onDidChangeSessions.fire({provider:{id:C,label:L}}),Promise.resolve()}}e.ExtHostAuthentication=S}),define(Ee[178],be([1,0,4,14,8]),function(Y,e,o,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let B=class{constructor(A,C){this._proxy=A.getProxy(o.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:L=>C.getDocument(L)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A){const C=w.WorkspaceEdit.from(A,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(C)}};B=Fe([Ne(0,I.IExtHostRpcService)],B),e.ExtHostBulkEdits=B}),define(Ee[179],be([1,0,4]),function(Y,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class I{constructor(B){const S=B.getProxy(o.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return S.$readText()},writeText(A){return S.$writeText(A)}})}}e.ExtHostClipboard=I});var je=this&&this.__classPrivateFieldSet||function(Y,e,o,I,w){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!w:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?w.call(Y,o):w?w.value=o:e.set(Y,o),o},De=this&&this.__classPrivateFieldGet||function(Y,e,o,I){if(o==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?I:o==="a"?I.call(Y):I?I.value:e.get(Y)};define(Ee[39],be([1,0,11,7,8,26,4,16,12,54,48,229,2,6,3,14,47,21,38,43]),function(Y,e,o,I,w,B,S,A,C,L,M,v,c,g,r,n,m,y,k,d){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let b=class{constructor(t,a){f.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,je(this,f,t.getProxy(S.MainContext.MainThreadCommands),"f"),this._logService=a,this.converter=new l(this,p=>{const h=this._apiCommands.get(p);return h?.result===u.Void?h:void 0},a),this._argumentProcessors=[{processArgument(p){return(0,L.revive)(p)}},{processArgument(p){return(0,B.cloneAndChange)(p,function(h){if(M.Range.isIRange(h))return w.Range.to(h);if(v.Position.isIPosition(h))return w.Position.to(h);if(M.Range.isIRange(h.range)&&c.URI.isUri(h.uri))return w.location.to(h);if(h instanceof y.VSBuffer)return h.buffer.buffer;if(!Array.isArray(h))return h})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const a=this.registerCommand(!1,t.id,async(...p)=>{const h=t.args.map((T,R)=>{if(!T.validate(p[R]))throw new Error(`Invalid argument '${T.name}' when running '${t.id}', received: ${p[R]}`);return T.convert(p[R])}),_=await this.executeCommand(t.internalId,...h);return t.result.convert(_,p,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new I.Disposable(()=>{a.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,a,p,h,_,T){if(this._logService.trace("ExtHostCommands#registerCommand",a),!a.trim().length)throw new Error("invalid id");if(this._commands.has(a))throw new Error(`command '${a}' already exists`);return this._commands.set(a,{callback:p,thisArg:h,description:_,extension:T}),t&&De(this,f,"f").$registerCommand(a),new I.Disposable(()=>{this._commands.delete(a)&&t&&De(this,f,"f").$unregisterCommand(a)})}executeCommand(t,...a){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,a,!0)}async _doExecuteCommand(t,a,p){if(this._commands.has(t))return this._executeContributedCommand(t,a,!1);{let h=!1;const _=(0,B.cloneAndChange)(a,function(T){if(T instanceof I.Position)return w.Position.from(T);if(T instanceof I.Range)return w.Range.from(T);if(T instanceof I.Location)return w.location.from(T);if(I.NotebookRange.isNotebookRange(T))return w.NotebookRange.from(T);if(T instanceof ArrayBuffer)return h=!0,y.VSBuffer.wrap(new Uint8Array(T));if(T instanceof Uint8Array)return h=!0,y.VSBuffer.wrap(T);if(!Array.isArray(T))return T});try{const T=await De(this,f,"f").$executeCommand(t,h?new k.SerializableObjectWithBuffers(_):_,p);return(0,L.revive)(T)}catch(T){if(T instanceof Error&&T.message==="$executeCommand:retry")return this._doExecuteCommand(t,a,!1);throw T}}}async _executeContributedCommand(t,a,p){const h=this._commands.get(t);if(!h)throw new Error("Unknown command");let{callback:_,thisArg:T,description:R}=h;if(R)for(let W=0;W<R.args.length;W++)try{(0,o.validateConstraint)(a[W],R.args[W].constraint)}catch{throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${R.args[W].name}' - ${R.args[W].description}`)}try{return await _.apply(T,a)}catch(W){if(t===this.converter.delegatingCommandId){const E=this.converter.getActualCommand(...a);E&&(t=E.command)}throw this._logService.error(W,t,h.extension?.identifier),p?new class extends Error{constructor(){super((0,d.toErrorMessage)(W));this.id=t,this.source=h.extension?.displayName??h.extension?.name}}:W}}$executeContributedCommand(t,...a){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(a=a.map(p=>this._argumentProcessors.reduce((h,_)=>_.processArgument(h),p)),this._executeContributedCommand(t,a,!0)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),De(this,f,"f").$getCommands().then(a=>(t&&(a=a.filter(p=>p[0]!=="_")),a))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[a,p]of this._commands){let{description:h}=p;h&&(t[a]=h)}return Promise.resolve(t)}};f=new WeakMap,b=Fe([Ne(0,n.IExtHostRpcService),Ne(1,C.ILogService)],b),e.ExtHostCommands=b,e.IExtHostCommands=(0,r.createDecorator)("IExtHostCommands");class l{constructor(t,a,p){this._commands=t,this._lookupApiCommand=a,this._logService=p,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,a){if(!t)return;const p={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return p;const h=this._lookupApiCommand(t.command);if(h)p.id=h.internalId,p.arguments=h.args.map((_,T)=>_.convert(t.arguments&&t.arguments[T]));else if((0,A.isNonEmptyArray)(t.arguments)){const _=++this._cachIdPool;this._cache.set(_,t),a.add((0,g.toDisposable)(()=>{this._cache.delete(_),this._logService.trace("CommandsConverter#DISPOSE",_)})),p.$ident=_,p.id=this.delegatingCommandId,p.arguments=[_],this._logService.trace("CommandsConverter#CREATE",t.command,_)}return p}fromInternal(t){return typeof t.$ident=="number"?this._cache.get(t.$ident):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const a=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],a?a.command:"MISSING"),a?this._commands.executeCommand(a.command,...a.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=l;class P{constructor(t,a,p,h){this.name=t,this.description=a,this.validate=p,this.convert=h}optional(){return new P(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,a){return new P(t??this.name,a??this.description,this.validate,this.convert)}}e.ApiCommandArgument=P,P.Uri=new P("uri","Uri of a text document",s=>c.URI.isUri(s),s=>s),P.Position=new P("position","A position in a text document",s=>I.Position.isPosition(s),w.Position.from),P.Range=new P("range","A range in a text document",s=>I.Range.isRange(s),w.Range.from),P.Selection=new P("selection","A selection in a text document",s=>I.Selection.isSelection(s),w.Selection.from),P.Number=new P("number","",s=>typeof s=="number",s=>s),P.String=new P("string","",s=>typeof s=="string",s=>s),P.CallHierarchyItem=new P("item","A call hierarchy item",s=>s instanceof I.CallHierarchyItem,w.CallHierarchyItem.from),P.TypeHierarchyItem=new P("item","A type hierarchy item",s=>s instanceof I.TypeHierarchyItem,w.TypeHierarchyItem.from),P.TestItem=new P("testItem","A VS Code TestItem",s=>s instanceof m.TestItemImpl,w.TestItem.from);class u{constructor(t,a){this.description=t,this.convert=a}}e.ApiCommandResult=u,u.Void=new u("no result",s=>s);class i{constructor(t,a,p,h,_){this.id=t,this.internalId=a,this.description=p,this.args=h,this.result=_}}e.ApiCommand=i}),define(Ee[180],be([1,0,2,8,7,88,39,16,75,79,9]),function(Y,e,o,I,w,B,S,A,C,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const v=[new S.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",g(I.DocumentHighlight.to))),new S.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,m)=>{if((0,A.isFalsyOrEmpty)(n))return;class y extends w.SymbolInformation{static to(d){const f=new y(d.name,I.SymbolKind.to(d.kind),d.containerName||"",new w.Location(m[0],I.Range.to(d.range)));return f.detail=d.detail,f.range=f.location.range,f.selectionRange=I.Range.to(d.selectionRange),f.children=d.children?d.children.map(y.to):[],f}}return n.map(y.to)})),new S.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(I.TextEdit.to))),new S.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range,new S.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(I.TextEdit.to))),new S.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,new S.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new S.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(I.TextEdit.to))),new S.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",r)),new S.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",r)),new S.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",r)),new S.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",r)),new S.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location-instances.",g(I.location.to))),new S.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Hover-instances.",g(I.Hover.to))),new S.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(m=>w.Position.isPosition(m)),n=>n.map(I.Position.from))],new S.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(m=>{let y;for(const k of m.reverse())y=new w.SelectionRange(I.Range.to(k),y);return y}))),new S.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[S.ApiCommandArgument.String.with("query","Search string")],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(I.WorkspaceSymbol.to))),new S.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(I.CallHierarchyItem.to))),new S.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(I.CallHierarchyIncomingCall.to))),new S.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(I.CallHierarchyOutgoingCall.to))),new S.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(!!n)return{range:I.Range.to(n.range),placeholder:n.text}})),new S.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("newName","The new symbol name")],new S.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return I.WorkspaceEdit.to(n)}})),new S.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new S.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(I.DocumentLink.to))),new S.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new w.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const m=(0,C.decodeSemanticTokensDto)(n);if(m.type==="full")return new w.SemanticTokens(m.data,void 0)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range.optional()],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new w.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const m=(0,C.decodeSemanticTokensDto)(n);if(m.type==="full")return new w.SemanticTokens(m.data,void 0)})),new S.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new S.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,m,y)=>{if(!n)return new w.CompletionList([]);const k=n.suggestions.map(d=>I.CompletionItem.to(d,y));return new w.CompletionList(k,n.incomplete)})),new S.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new S.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return I.SignatureHelp.to(n)})),new S.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new S.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,m,y)=>g(k=>new w.CodeLens(I.Range.to(k.range),k.command&&y.fromInternal(k.command)))(n))),new S.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>w.Range.isRange(n),n=>w.Selection.isSelection(n)?I.Selection.from(n):I.Range.from(n)),S.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new S.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,m,y)=>g(k=>{if(k._isSynthetic){if(!k.command)throw new Error("Synthetic code actions must have a command");return y.fromInternal(k.command)}else{const d=new w.CodeAction(k.title,k.kind?new w.CodeActionKind(k.kind):void 0);return k.edit&&(d.edit=I.WorkspaceEdit.to(k.edit)),k.command&&(d.command=y.fromInternal(k.command)),d.isPreferred=k.isPreferred,d}})(n))),new S.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(m=>new w.ColorInformation(I.Range.to(m.range),I.Color.to(m.color))):[])),new S.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new S.ApiCommandArgument("color","The color to show and insert",n=>n instanceof w.Color,I.Color.from),new S.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:I.Range.from(n.range)}))],new S.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(I.ColorPresentation.to):[])),new S.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of Inlay objects",(n,m,y)=>n.map(I.InlayHint.to.bind(void 0,y)))),new S.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new S.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",g(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(m=>I.NotebookExclusiveDocumentPattern.to(m))})))),new S.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(I.InlineValue.to))),new S.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new S.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",n=>o.URI.isUri(n)||typeof n=="string"&&(0,L.matchesSomeScheme)(n,M.Schemas.http,M.Schemas.https),n=>n),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[I.ViewColumn.from(n),void 0]:[I.ViewColumn.from(n.viewColumn),I.TextEditorOpenOptions.from(n)])).optional(),S.ApiCommandArgument.String.with("label","").optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[S.ApiCommandArgument.Uri.with("resource","Resource to open"),S.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[I.ViewColumn.from(n),void 0]:[I.ViewColumn.from(n.viewColumn),I.TextEditorOpenOptions.from(n)])).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[S.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),S.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),S.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[I.ViewColumn.from(n.viewColumn),I.TextEditorOpenOptions.from(n)]).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(I.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(I.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(I.TypeHierarchyItem.to))),new S.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[S.ApiCommandArgument.TestItem],S.ApiCommandResult.Void)];class c{static register(m){v.forEach(m.registerApiCommand,m)}}e.ExtHostApiCommands=c;function g(n){return m=>{if(Array.isArray(m))return m.map(n)}}function r(n){if(!Array.isArray(n))return;const m=[];for(const y of n)B.isLocationLink(y)?m.push(I.DefinitionLink.to(y)):m.push(I.location.to(y));return m}}),define(Ee[181],be([1,0,13,52,5,6,2,88,25,8,7,4]),function(Y,e,o,I,w,B,S,A,C,L,M,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function c(g,r,n){const m=g.getProxy(v.MainContext.MainThreadComments);class y{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,r.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const s=this._commentControllers.get(i.handle);return s||i}else if(i&&i.$mid===7){const s=this._commentControllers.get(i.commentControlHandle);if(!s)return i;const t=s.getCommentThread(i.commentThreadHandle);return t||i}else if(i&&i.$mid===8){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const t=s.getCommentThread(i.thread.commentThreadHandle);return t?{thread:t,text:i.text}:i}else if(i&&i.$mid===9){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const t=s.getCommentThread(i.thread.commentThreadHandle);if(!t)return i;let a=i.commentUniqueId,p=t.getCommentByUniqueId(a);return p||i}else if(i&&i.$mid===10){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const t=s.getCommentThread(i.thread.commentThreadHandle);if(!t)return i;let a=i.text,p=i.commentUniqueId,h=t.getCommentByUniqueId(p);return h?(h.body=a,h):i}return i}})}createCommentController(i,s,t){const a=y.handlePool++,p=new d(i,a,s,t);this._commentControllers.set(p.handle,p);const h=this._commentControllersByExtension.get(C.ExtensionIdentifier.toKey(i.identifier))||[];return h.push(p),this._commentControllersByExtension.set(C.ExtensionIdentifier.toKey(i.identifier),h),p.value}$createCommentThreadTemplate(i,s,t){const a=this._commentControllers.get(i);!a||a.$createCommentThreadTemplate(s,t)}async $updateCommentThreadTemplate(i,s,t){const a=this._commentControllers.get(i);!a||a.$updateCommentThreadTemplate(s,t)}$deleteCommentThread(i,s){const t=this._commentControllers.get(i);t&&t.$deleteCommentThread(s)}$provideCommentingRanges(i,s,t){const a=this._commentControllers.get(i);if(!a||!a.commentingRangeProvider)return Promise.resolve(void 0);const p=n.getDocument(S.URI.revive(s));return(0,o.asPromise)(()=>a.commentingRangeProvider.provideCommentingRanges(p,t)).then(h=>h?h.map(_=>L.Range.from(_)):void 0)}$toggleReaction(i,s,t,a,p){const h=this._commentControllers.get(i);return!h||!h.reactionHandler?Promise.resolve(void 0):(0,o.asPromise)(()=>{const _=h.getCommentThread(s);if(_){const T=_.getCommentByUniqueId(a.uniqueIdInThread);if(h!==void 0&&T&&h.reactionHandler)return h.reactionHandler(T,l(p))}return Promise.resolve(void 0)})}dispose(){}}y.handlePool=0;class k{constructor(i,s,t,a,p,h,_){this._commentControllerHandle=s,this._id=t,this._uri=a,this._range=p,this._comments=h,this.extensionDescription=_,this.handle=k._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new w.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new B.MutableDisposable,this._acceptInputDisposables.value=new B.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),m.$createCommentThread(s,this.handle,this._id,this._uri,L.Range.from(this._range),_.identifier),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=h,this._localDisposables.push({dispose:()=>{m.$deleteCommentThread(s,this.handle)}});const T=this;this.value={get uri(){return T.uri},get range(){return T.range},set range(R){T.range=R},get comments(){return T.comments},set comments(R){T.comments=R},get collapsibleState(){return T.collapsibleState},set collapsibleState(R){T.collapsibleState=R},get canReply(){return T.canReply},set canReply(R){T.canReply=R},get contextValue(){return T.contextValue},set contextValue(R){T.contextValue=R},get label(){return T.label},set label(R){T.label=R},dispose:()=>{T.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new B.DisposableStore);const i=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),s={};i("range")&&(s.range=L.Range.from(this._range)),i("label")&&(s.label=this.label),i("contextValue")&&(s.contextValue=this.contextValue??null),i("comments")&&(s.comments=this._comments.map(t=>f(this,t,this._commentsMap))),i("collapsibleState")&&(s.collapseState=P(this._collapseState)),i("canReply")&&(s.canReply=this.canReply),this.modifications={},m.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,s)}getCommentByUniqueId(i){for(let s of this._commentsMap){let t=s[0],a=s[1];if(i===a)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}k._handlePool=0,Fe([(0,I.debounce)(100)],k.prototype,"eventuallyUpdateCommentThread",null);class d{constructor(i,s,t,a){this._extension=i,this._handle=s,this._id=t,this._label=a,this._threads=new Map,m.$registerCommentController(this.handle,t,a);const p=this;this.value=Object.freeze({id:p.id,label:p.label,get options(){return p.options},set options(h){p.options=h},get commentingRangeProvider(){return p.commentingRangeProvider},set commentingRangeProvider(h){p.commentingRangeProvider=h},get reactionHandler(){return p.reactionHandler},set reactionHandler(h){p.reactionHandler=h},createCommentThread(h,_,T){return p.createCommentThread(h,_,T).value},dispose:()=>{p.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{m.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(i){this._commentingRangeProvider=i,m.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,m.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,m.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,s,t,a){if(typeof i=="string"){const p=new k(this.id,this.handle,i,s,t,a,this._extension);return this._threads.set(p.handle,p),p}else{const p=new k(this.id,this.handle,void 0,i,s,t,this._extension);return this._threads.set(p.handle,p),p}}$createCommentThreadTemplate(i,s){const t=new k(this.id,this.handle,void 0,S.URI.revive(i),L.Range.to(s),[],this._extension);return t.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(i,s){let t=this._threads.get(i);t&&(t.range=L.Range.to(s))}$deleteCommentThread(i){let s=this._threads.get(i);s&&s.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function f(u,i,s){let t=s.get(i);t||(t=++u.commentHandle,s.set(i,t));const a=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:t,body:typeof i.body=="string"?i.body:L.MarkdownString.from(i.body),userName:i.author.name,userIconPath:a,label:i.label,commentReactions:i.reactions?i.reactions.map(p=>b(p)):void 0,timestamp:i.timestamp?.toJSON()}}function b(u){return{label:u.label,iconPath:u.iconPath?L.pathOrURIToURI(u.iconPath):void 0,count:u.count,hasReacted:u.authorHasReacted}}function l(u){return{label:u.label||"",count:u.count||0,iconPath:u.iconPath?S.URI.revive(u.iconPath):"",authorHasReacted:u.hasReacted||!1}}function P(u){if(u!==void 0)switch(u){case M.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case M.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}return new y}e.createExtHostComments=c}),define(Ee[92],be([1,0,2,4,7,3,14,12,16,10,17]),function(Y,e,o,I,w,B,S,A,C,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let v=class bi{constructor(g,r){this._logService=r,this._provider=new Map,this._proxy=g.getProxy(I.MainContext.MainThreadDecorations)}registerFileDecorationProvider(g,r){const n=bi._handlePool++;this._provider.set(n,{provider:g,extensionId:r}),this._proxy.$registerDecorationProvider(n,r.value);const m=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(y=>{if(!y){this._proxy.$onDidChange(n,null);return}let k=(0,C.asArray)(y);if(k.length<=bi._maxEventSize){this._proxy.$onDidChange(n,k);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",r.value,k.length);const d=k.map(l=>({uri:l,rank:(0,L.count)(l.path,"/")})),f=(0,C.groupBy)(d,(l,P)=>l.rank-P.rank||(0,L.compare)(l.uri.path,P.uri.path));let b=[];e:for(let l of f){let P;for(let u of l){let i=(0,M.dirname)(u.uri.path);if(P!==i&&(P=i,b.push(u.uri)>=bi._maxEventSize))break e}}this._proxy.$onDidChange(n,b)});return new w.Disposable(()=>{m?.dispose(),this._proxy.$unregisterDecorationProvider(n),this._provider.delete(n)})}async $provideDecorations(g,r,n){if(!this._provider.has(g))return Object.create(null);const m=Object.create(null),{provider:y,extensionId:k}=this._provider.get(g);return await Promise.all(r.map(async d=>{try{const{uri:f,id:b}=d,l=await Promise.resolve(y.provideFileDecoration(o.URI.revive(f),n));if(!l)return;try{w.FileDecoration.validate(l),m[b]=[l.propagate,l.tooltip,l.badge,l.color]}catch(P){this._logService.warn(`INVALID decoration from extension '${k.value}': ${P}`)}}catch(f){this._logService.error(f)}})),m}};v._handlePool=0,v._maxEventSize=250,v=Fe([Ne(0,S.IExtHostRpcService),Ne(1,A.ILogService)],v),e.ExtHostDecorations=v,e.IExtHostDecorations=(0,B.createDecorator)("IExtHostDecorations")});var je=this&&this.__classPrivateFieldSet||function(Y,e,o,I,w){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!w:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?w.call(Y,o):w?w.value=o:e.set(Y,o),o},De=this&&this.__classPrivateFieldGet||function(Y,e,o,I){if(o==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?I:o==="a"?I.call(Y):I?I.value:e.get(Y)};define(Ee[182],be([1,0,122,78,2,4,7,8,5,12,22,30]),function(Y,e,o,I,w,B,S,A,C,L,M,v){"use strict";var c,g,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class n{constructor(k,d,f,b,l,P){this._name=k,this._owner=d,this._maxDiagnosticsPerFile=f,c.set(this,void 0),g.set(this,void 0),r.set(this,void 0),this._isDisposed=!1,je(this,r,new M.ResourceMap(u=>b.getComparisonKey(u)),"f"),je(this,c,l,"f"),je(this,g,P,"f")}dispose(){this._isDisposed||(De(this,g,"f").fire([...De(this,r,"f").keys()]),De(this,c,"f")&&De(this,c,"f").$clear(this._owner),De(this,r,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(k,d){if(!k){this.clear();return}this._checkDisposed();let f=[];if(w.URI.isUri(k)){if(!d){this.delete(k);return}De(this,r,"f").set(k,d.slice()),f=[k]}else if(Array.isArray(k)){f=[];let l;k=[...k].sort(n._compareIndexedTuplesByUri);for(const P of k){const[u,i]=P;if((!l||u.toString()!==l.toString())&&(l&&De(this,r,"f").get(l).length===0&&De(this,r,"f").delete(l),l=u,f.push(u),De(this,r,"f").set(u,[])),i){const s=De(this,r,"f").get(u);s&&s.push(...i)}else{const s=De(this,r,"f").get(u);s&&(s.length=0)}}}if(De(this,g,"f").fire(f),!De(this,c,"f"))return;const b=[];for(let l of f){let P=[];const u=De(this,r,"f").get(l);if(u)if(u.length>this._maxDiagnosticsPerFile){P=[];const i=[S.DiagnosticSeverity.Error,S.DiagnosticSeverity.Warning,S.DiagnosticSeverity.Information,S.DiagnosticSeverity.Hint];e:for(let s=0;s<4;s++)for(let t of u)if(t.severity===i[s]&&P.push(A.Diagnostic.from(t))===this._maxDiagnosticsPerFile)break e;P.push({severity:I.MarkerSeverity.Info,message:(0,o.localize)(0,null,u.length-this._maxDiagnosticsPerFile),startLineNumber:P[P.length-1].startLineNumber,startColumn:P[P.length-1].startColumn,endLineNumber:P[P.length-1].endLineNumber,endColumn:P[P.length-1].endColumn})}else P=u.map(i=>A.Diagnostic.from(i));b.push([l,P])}De(this,c,"f").$changeMany(this._owner,b)}delete(k){this._checkDisposed(),De(this,g,"f").fire([k]),De(this,r,"f").delete(k),De(this,c,"f")&&De(this,c,"f").$changeMany(this._owner,[[k,void 0]])}clear(){this._checkDisposed(),De(this,g,"f").fire([...De(this,r,"f").keys()]),De(this,r,"f").clear(),De(this,c,"f")&&De(this,c,"f").$clear(this._owner)}forEach(k,d){this._checkDisposed();for(let f of De(this,r,"f").keys())k.apply(d,[f,this.get(f),this])}get(k){this._checkDisposed();const d=De(this,r,"f").get(k);return Array.isArray(d)?Object.freeze(d.slice(0)):[]}has(k){return this._checkDisposed(),Array.isArray(De(this,r,"f").get(k))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(k,d){return k[0].toString()<d[0].toString()?-1:k[0].toString()>d[0].toString()?1:0}}e.DiagnosticCollection=n,c=new WeakMap,g=new WeakMap,r=new WeakMap;let m=class oi{constructor(k,d,f){this._logService=d,this._fileSystemInfoService=f,this._collections=new Map,this._onDidChangeDiagnostics=new C.DebounceEmitter({merge:b=>b.flat(),delay:50}),this.onDidChangeDiagnostics=C.Event.map(this._onDidChangeDiagnostics.event,oi._mapper),this._proxy=k.getProxy(B.MainContext.MainThreadDiagnostics)}static _mapper(k){const d=new M.ResourceMap;for(const f of k)d.set(f,f);return{uris:Object.freeze(Array.from(d.values()))}}createDiagnosticCollection(k,d){const{_collections:f,_proxy:b,_onDidChangeDiagnostics:l,_logService:P,_fileSystemInfoService:u}=this,i=new class{$changeMany(a,p){b.$changeMany(a,p),P.trace("[DiagnosticCollection] change many (extension, owner, uris)",k.value,a,p.length===0?"CLEARING":p)}$clear(a){b.$clear(a),P.trace("[DiagnosticCollection] remove all (extension, owner)",k.value,a)}dispose(){b.dispose()}};let s;if(!d)d="_generated_diagnostic_collection_name_#"+oi._idPool++,s=d;else if(!f.has(d))s=d;else{this._logService.warn(`DiagnosticCollection with name '${d}' does already exist.`);do s=d+oi._idPool++;while(f.has(s))}return new class extends n{constructor(){super(d,s,oi._maxDiagnosticsPerFile,u.extUri,i,l);f.set(s,this)}dispose(){super.dispose(),f.delete(s)}}}getDiagnostics(k){if(k)return this._getDiagnostics(k);{const d=new Map,f=[];for(const b of this._collections.values())b.forEach((l,P)=>{let u=d.get(l.toString());typeof u=="undefined"&&(u=f.length,d.set(l.toString(),u),f.push([l,[]])),f[u][1]=f[u][1].concat(...P)});return f}}_getDiagnostics(k){let d=[];for(let f of this._collections.values())f.has(k)&&(d=d.concat(f.get(k)));return d}$acceptMarkersChange(k){if(!this._mirrorCollection){const d="_generated_mirror",f=new n(d,d,oi._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(d,f),this._mirrorCollection=f}for(const[d,f]of k)this._mirrorCollection.set(w.URI.revive(d),f.map(A.Diagnostic.to))}};m._idPool=0,m._maxDiagnosticsPerFile=1e3,m=Fe([Ne(1,L.ILogService),Ne(2,v.IExtHostFileSystemInfo)],m),e.ExtHostDiagnostics=m}),define(Ee[183],be([1,0,2,4]),function(Y,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class w{constructor(S){this._proxy=S.getProxy(I.MainContext.MainThreadDialogs)}showOpenDialog(S){return this._proxy.$showOpenDialog(S).then(A=>A?A.map(C=>o.URI.revive(C)):void 0)}showSaveDialog(S){return this._proxy.$showSaveDialog(S).then(A=>A?o.URI.revive(A):void 0)}}e.ExtHostDialogs=w}),define(Ee[184],be([1,0,15,2,7,4,9,20,10]),function(Y,e,o,I,w,B,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class L{constructor(v,c,g){this._documentsAndEditors=c,this._logService=g,this._documentContentProviders=new Map,this._proxy=v.getProxy(B.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(v,c){if(Object.keys(S.Schemas).indexOf(v)>=0)throw new Error(`scheme '${v}' already registered`);const g=L._handlePool++;this._documentContentProviders.set(g,c),this._proxy.$registerTextContentProvider(g,v);let r;return typeof c.onDidChange=="function"&&(r=c.onDidChange(n=>{if(n.scheme!==v){this._logService.warn(`Provider for scheme '${v}' is firing event for schema '${n.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(n)&&this.$provideTextDocumentContent(g,n).then(m=>{if(!m&&typeof m!="string")return;const y=this._documentsAndEditors.getDocument(n);if(!y)return;const k=(0,C.splitLines)(m);if(!y.equalLines(k))return this._proxy.$onVirtualDocumentChange(n,m)},o.onUnexpectedError)})),new w.Disposable(()=>{this._documentContentProviders.delete(g)&&this._proxy.$unregisterTextContentProvider(g),r&&(r.dispose(),r=void 0)})}$provideTextDocumentContent(v,c){const g=this._documentContentProviders.get(v);return g?Promise.resolve(g.provideTextDocumentContent(I.URI.revive(c),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.ExtHostDocumentContentProvider=L,L._handlePool=0}),define(Ee[185],be([1,0,5,6,2,4,84,8,11,26,7]),function(Y,e,o,I,w,B,S,A,C,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class v{constructor(g,r){this._onDidAddDocument=new o.Emitter,this._onDidRemoveDocument=new o.Emitter,this._onDidChangeDocument=new o.Emitter,this._onDidSaveDocument=new o.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new I.DisposableStore,this._documentLoader=new Map,this._proxy=g.getProxy(B.MainContext.MainThreadDocuments),this._documentsAndEditors=r,this._documentsAndEditors.onDidRemoveDocuments(n=>{for(const m of n)this._onDidRemoveDocument.fire(m.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(n=>{for(const m of n)this._onDidAddDocument.fire(m.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(g){if(!g)return;const r=this._documentsAndEditors.getDocument(g);if(r)return r}getDocument(g){const r=this.getDocumentData(g);if(!r?.document)throw new Error(`Unable to retrieve document from URI '${g}'`);return r.document}ensureDocumentData(g){const r=this._documentsAndEditors.getDocument(g);if(r)return Promise.resolve(r);let n=this._documentLoader.get(g.toString());return n||(n=this._proxy.$tryOpenDocument(g).then(m=>{this._documentLoader.delete(g.toString());const y=w.URI.revive(m);return(0,C.assertIsDefined)(this._documentsAndEditors.getDocument(y))},m=>(this._documentLoader.delete(g.toString()),Promise.reject(m))),this._documentLoader.set(g.toString(),n)),n}createDocumentData(g){return this._proxy.$tryCreateDocument(g).then(r=>w.URI.revive(r))}$acceptModelLanguageChanged(g,r){const n=w.URI.revive(g),m=this._documentsAndEditors.getDocument(n);if(!m)throw new Error("unknown document");this._onDidRemoveDocument.fire(m.document),m._acceptLanguageId(r),this._onDidAddDocument.fire(m.document)}$acceptModelSaved(g){const r=w.URI.revive(g),n=this._documentsAndEditors.getDocument(r);if(!n)throw new Error("unknown document");this.$acceptDirtyStateChanged(g,!1),this._onDidSaveDocument.fire(n.document)}$acceptDirtyStateChanged(g,r){const n=w.URI.revive(g),m=this._documentsAndEditors.getDocument(n);if(!m)throw new Error("unknown document");m._acceptIsDirty(r),this._onDidChangeDocument.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(g,r,n){const m=w.URI.revive(g),y=this._documentsAndEditors.getDocument(m);if(!y)throw new Error("unknown document");y._acceptIsDirty(n),y.onEvents(r);let k;r.isUndoing?k=M.TextDocumentChangeReason.Undo:r.isRedoing&&(k=M.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,L.deepFreeze)({document:y.document,contentChanges:r.changes.map(d=>({range:A.Range.to(d.range),rangeOffset:d.rangeOffset,rangeLength:d.rangeLength,text:d.text})),reason:k}))}setWordDefinitionFor(g,r){(0,S.setWordDefinitionFor)(g,r)}}e.ExtHostDocuments=v}),define(Ee[49],be([1,0,42,5,6,2,3,4,84,14,90,8,12,22,9,161,230]),function(Y,e,o,I,w,B,S,A,C,L,M,v,c,g,r,n,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class y{constructor(f){this.value=f,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let k=class{constructor(f,b){this._extHostRpc=f,this._logService=b,this._activeEditorId=null,this._editors=new Map,this._documents=new g.ResourceMap,this._onDidAddDocuments=new I.Emitter,this._onDidRemoveDocuments=new I.Emitter,this._onDidChangeVisibleTextEditors=new I.Emitter,this._onDidChangeActiveTextEditor=new I.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(f){this.acceptDocumentsAndEditorsDelta(f)}acceptDocumentsAndEditorsDelta(f){const b=[],l=[],P=[];if(f.removedDocuments)for(const u of f.removedDocuments){const i=B.URI.revive(u),s=this._documents.get(i);s?.unref()&&(this._documents.delete(i),b.push(s.value))}if(f.addedDocuments)for(const u of f.addedDocuments){const i=B.URI.revive(u.uri);let s=this._documents.get(i);if(s&&i.scheme!==r.Schemas.vscodeNotebookCell&&i.scheme!==r.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);s||(s=new y(new C.ExtHostDocumentData(this._extHostRpc.getProxy(A.MainContext.MainThreadDocuments),i,u.lines,u.EOL,u.versionId,u.languageId,u.isDirty,u.notebook)),this._documents.set(i,s),l.push(s.value)),s.ref()}if(f.removedEditors)for(const u of f.removedEditors){const i=this._editors.get(u);this._editors.delete(u),i&&P.push(i)}if(f.addedEditors)for(const u of f.addedEditors){const i=B.URI.revive(u.documentUri);o.ok(this._documents.has(i),`document '${i}' does not exist`),o.ok(!this._editors.has(u.id),`editor '${u.id}' already exists!`);const s=this._documents.get(i).value,t=new M.ExtHostTextEditor(u.id,this._extHostRpc.getProxy(A.MainContext.MainThreadTextEditors),this._logService,new m.Lazy(()=>s.document),u.selections.map(v.Selection.to),u.options,u.visibleRanges.map(a=>v.Range.to(a)),typeof u.editorPosition=="number"?v.ViewColumn.to(u.editorPosition):void 0);this._editors.set(u.id,t)}f.newActiveEditor!==void 0&&(o.ok(f.newActiveEditor===null||this._editors.has(f.newActiveEditor),`active editor '${f.newActiveEditor}' does not exist`),this._activeEditorId=f.newActiveEditor),(0,w.dispose)(b),(0,w.dispose)(P),f.removedDocuments&&this._onDidRemoveDocuments.fire(b),f.addedDocuments&&this._onDidAddDocuments.fire(l),(f.removedEditors||f.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(u=>u.value)),f.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(f){return this._documents.get(f)?.value}allDocuments(){return n.Iterable.map(this._documents.values(),f=>f.value)}getEditor(f){return this._editors.get(f)}activeEditor(f){if(!this._activeEditorId)return;const b=this._editors.get(this._activeEditorId);return f?b:b?.value}allEditors(){return[...this._editors.values()]}};k=Fe([Ne(0,L.IExtHostRpcService),Ne(1,c.ILogService)],k),e.ExtHostDocumentsAndEditors=k,e.IExtHostDocumentsAndEditors=(0,S.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ee[66],be([1,0,8,4,2,5,3,14]),function(Y,e,o,I,w,B,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,S.createDecorator)("IExtHostEditorTabs");let C=class{constructor(M){this._onDidChangeTabGroup=new B.Emitter,this.onDidChangeTabGroup=this._onDidChangeTabGroup.event,this._tabGroups={all:[],onDidChangeTabGroup:this._onDidChangeTabGroup.event},this._proxy=M.getProxy(I.MainContext.MainThreadEditorTabs)}get tabGroups(){return this._tabGroups}$acceptEditorTabModel(M){this._tabGroups.all.length=0;for(const v of M){let c;const g=v.tabs.map(r=>{const n=this.createExtHostTabObject(r);return r.isActive&&(c=n),n});this._tabGroups.all.push(Object.freeze({isActive:v.isActive,viewColumn:o.ViewColumn.to(v.viewColumn),activeTab:c,tabs:g}))}this._onDidChangeTabGroup.fire()}createExtHostTabObject(M){return Object.freeze({label:M.label,viewColumn:o.ViewColumn.to(M.viewColumn),resource:w.URI.revive(M.resource),additionalResourcesAndViewIds:M.additionalResourcesAndViewIds.map(({resource:v,viewId:c})=>({resource:w.URI.revive(v),viewId:c})),viewId:M.editorId,isActive:M.isActive,kind:M.kind,isDirty:M.isDirty,move:async(v,c)=>{this._proxy.$moveTab(M,v,o.ViewColumn.from(c))},close:async()=>{await this._proxy.$closeTab(M)}})}};C=Fe([Ne(0,A.IExtHostRpcService)],C),e.ExtHostEditorTabs=C}),define(Ee[186],be([1,0,2,4,6,7,8,231,10,21,28]),function(Y,e,o,I,w,B,S,A,C,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class v{constructor(){this._schemes=[]}add(r){this._stateMachine=void 0,this._schemes.push(r)}delete(r){const n=this._schemes.indexOf(r);n>=0&&(this._schemes.splice(n,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const r=this._schemes.sort(),n=[];let m,y,k=14,d=14;for(const f of r){let b=m?(0,C.commonPrefixLength)(m,f):0;for(b===0?y=1:y=d;b<f.length;b++)b+1===f.length?(k=d,d=9):d+=1,n.push([y,f.toUpperCase().charCodeAt(b),d]),n.push([y,f.toLowerCase().charCodeAt(b),d]),y=d;m=f,d=k}n.push([9,58,10]),n.push([10,47,12]),this._stateMachine=new A.StateMachine(n)}}provideDocumentLinks(r){this._initStateMachine();const n=[],m=A.LinkComputer.computeLinks({getLineContent(y){return r.lineAt(y-1).text},getLineCount(){return r.lineCount}},this._stateMachine);for(const y of m){const k=S.DocumentLink.to(y);k.target&&n.push(k)}return n}}class c{constructor(r,n){this._extHostLanguageFeatures=n,this._linkProvider=new v,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=r.getProxy(I.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(r,n,m,y={}){if(this._registeredSchemes.has(n))throw new Error(`a provider for the scheme '${n}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(r,"*",this._linkProvider));const k=this._handlePool++;this._linkProvider.add(n),this._registeredSchemes.add(n),this._fsProvider.set(k,m);let d=2;y.isCaseSensitive&&(d+=1024),y.isReadonly&&(d+=2048),typeof m.copy=="function"&&(d+=8),typeof m.open=="function"&&typeof m.close=="function"&&typeof m.read=="function"&&typeof m.write=="function"&&((0,M.checkProposedApiEnabled)(r,"fsChunks"),d+=4),this._proxy.$registerFileSystemProvider(k,n,d).catch(b=>{console.error(`FAILED to register filesystem provider of ${r.identifier.value}-extension for the scheme ${n}`),console.error(b)});const f=m.onDidChangeFile(b=>{const l=[];for(const P of b){let{uri:u,type:i}=P;if(u.scheme!==n)continue;let s;switch(i){case B.FileChangeType.Changed:s=0;break;case B.FileChangeType.Created:s=1;break;case B.FileChangeType.Deleted:s=2;break;default:throw new Error("Unknown FileChangeType")}l.push({resource:u,type:s})}this._proxy.$onFileSystemChange(k,l)});return(0,w.toDisposable)(()=>{f.dispose(),this._linkProvider.delete(n),this._registeredSchemes.delete(n),this._fsProvider.delete(k),this._proxy.$unregisterProvider(k)})}static _asIStat(r){const{type:n,ctime:m,mtime:y,size:k,permissions:d}=r;return{type:n,ctime:m,mtime:y,size:k,permissions:d}}$stat(r,n){return Promise.resolve(this._getFsProvider(r).stat(o.URI.revive(n))).then(m=>c._asIStat(m))}$readdir(r,n){return Promise.resolve(this._getFsProvider(r).readDirectory(o.URI.revive(n)))}$readFile(r,n){return Promise.resolve(this._getFsProvider(r).readFile(o.URI.revive(n))).then(m=>L.VSBuffer.wrap(m))}$writeFile(r,n,m,y){return Promise.resolve(this._getFsProvider(r).writeFile(o.URI.revive(n),m.buffer,y))}$delete(r,n,m){return Promise.resolve(this._getFsProvider(r).delete(o.URI.revive(n),m))}$rename(r,n,m,y){return Promise.resolve(this._getFsProvider(r).rename(o.URI.revive(n),o.URI.revive(m),y))}$copy(r,n,m,y){const k=this._getFsProvider(r);if(!k.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(k.copy(o.URI.revive(n),o.URI.revive(m),y))}$mkdir(r,n){return Promise.resolve(this._getFsProvider(r).createDirectory(o.URI.revive(n)))}$watch(r,n,m,y){const k=this._getFsProvider(r).watch(o.URI.revive(m),y);this._watches.set(n,k)}$unwatch(r,n){const m=this._watches.get(n);m&&(m.dispose(),this._watches.delete(n))}$open(r,n,m){const y=this._getFsProvider(r);if(!y.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(y.open(o.URI.revive(n),m))}$close(r,n){const m=this._getFsProvider(r);if(!m.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(m.close(n))}$read(r,n,m,y){const k=this._getFsProvider(r);if(!k.read)throw new Error('FileSystemProvider does not implement "read"');const d=L.VSBuffer.alloc(y);return Promise.resolve(k.read(n,m,d.buffer,0,y)).then(f=>d.slice(0,f))}$write(r,n,m,y){const k=this._getFsProvider(r);if(!k.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(k.write(n,m,y.buffer,0,y.byteLength))}_getFsProvider(r){const n=this._fsProvider.get(r);if(!n){const m=new Error;throw m.name="ENOPRO",m.message="no provider",m}return n}}e.ExtHostFileSystem=c}),define(Ee[50],be([1,0,4,45,7,21,3,14,30,6]),function(Y,e,o,I,w,B,S,A,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let M=class jt{constructor(c,g){this._fileSystemProvider=new Map,this._proxy=c.getProxy(o.MainContext.MainThreadFileSystem);const r=this;this.value=Object.freeze({async stat(n){try{const m=r._fileSystemProvider.get(n.scheme);if(!m)return await r._proxy.$stat(n);await r._proxy.$ensureActivation(n.scheme);const y=await m.stat(n);return{type:y.type,ctime:y.ctime,mtime:y.mtime,size:y.size,permissions:y.permissions}}catch(m){jt._handleError(m)}},async readDirectory(n){try{const m=r._fileSystemProvider.get(n.scheme);return m?(await r._proxy.$ensureActivation(n.scheme),(await m.readDirectory(n)).slice()):await r._proxy.$readdir(n)}catch(m){return jt._handleError(m)}},async createDirectory(n){try{return await r._proxy.$mkdir(n)}catch(m){return jt._handleError(m)}},async readFile(n){try{const m=r._fileSystemProvider.get(n.scheme);return m?(await r._proxy.$ensureActivation(n.scheme),(await m.readFile(n)).slice()):(await r._proxy.$readFile(n)).buffer}catch(m){return jt._handleError(m)}},async writeFile(n,m){try{return await r._proxy.$writeFile(n,B.VSBuffer.wrap(m))}catch(y){return jt._handleError(y)}},async delete(n,m){try{const y=r._fileSystemProvider.get(n.scheme);return y?(await r._proxy.$ensureActivation(n.scheme),await y.delete(n,{recursive:!1,...m})):await r._proxy.$delete(n,{recursive:!1,useTrash:!1,...m})}catch(y){return jt._handleError(y)}},async rename(n,m,y){try{return await r._proxy.$rename(n,m,{overwrite:!1,...y})}catch(k){return jt._handleError(k)}},async copy(n,m,y){try{return await r._proxy.$copy(n,m,{overwrite:!1,...y})}catch(k){return jt._handleError(k)}},isWritableFileSystem(n){const m=g.getCapabilities(n);if(typeof m=="number")return!(m&2048)}})}static _handleError(c){if(c instanceof w.FileSystemError)throw c;if(!(c instanceof Error))throw new w.FileSystemError(String(c));if(c.name==="ENOPRO")throw w.FileSystemError.Unavailable(c.message);switch(c.name){case I.FileSystemProviderErrorCode.FileExists:throw w.FileSystemError.FileExists(c.message);case I.FileSystemProviderErrorCode.FileNotFound:throw w.FileSystemError.FileNotFound(c.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw w.FileSystemError.FileNotADirectory(c.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw w.FileSystemError.FileIsADirectory(c.message);case I.FileSystemProviderErrorCode.NoPermissions:throw w.FileSystemError.NoPermissions(c.message);case I.FileSystemProviderErrorCode.Unavailable:throw w.FileSystemError.Unavailable(c.message);default:throw new w.FileSystemError(c.message,c.name)}}addFileSystemProvider(c,g){return this._fileSystemProvider.set(c,g),(0,L.toDisposable)(()=>this._fileSystemProvider.delete(c))}};M=Fe([Ne(0,A.IExtHostRpcService),Ne(1,C.IExtHostFileSystemInfo)],M),e.ExtHostConsumerFileSystem=M,e.IExtHostConsumerFileSystem=(0,S.createDecorator)("IExtHostConsumerFileSystem")}),define(Ee[187],be([1,0,5,29,2,4,8,7]),function(Y,e,o,I,w,B,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class C{constructor(v,c,g,r,n,m,y,k){this._onDidCreate=new o.Emitter,this._onDidChange=new o.Emitter,this._onDidDelete=new o.Emitter;const d=this.ensureWatching(v,g,n);this._config=0,m&&(this._config+=1),y&&(this._config+=2),k&&(this._config+=4);const f=(0,I.parse)(n),b=typeof n=="string",l=r(P=>{if(!m)for(let u of P.created){const i=w.URI.revive(u);f(i.fsPath)&&(!b||c.getWorkspaceFolder(i))&&this._onDidCreate.fire(i)}if(!y)for(let u of P.changed){const i=w.URI.revive(u);f(i.fsPath)&&(!b||c.getWorkspaceFolder(i))&&this._onDidChange.fire(i)}if(!k)for(let u of P.deleted){const i=w.URI.revive(u);f(i.fsPath)&&(!b||c.getWorkspaceFolder(i))&&this._onDidDelete.fire(i)}});this._disposable=A.Disposable.from(d,this._onDidCreate,this._onDidChange,this._onDidDelete,l)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(v,c,g){let r=A.Disposable.from();if(typeof g=="string")return r;const n=v.getProxy(B.MainContext.MainThreadFileSystem);let m=!1;(g.pattern.includes(I.GLOBSTAR)||g.pattern.includes(I.GLOB_SPLIT))&&(m=!0);const y=Math.random();return n.$watch(c.identifier.value,y,g.baseUri,{recursive:m,excludes:[]}),A.Disposable.from({dispose:()=>n.$unwatch(y)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class L{constructor(v,c,g){this._mainContext=v,this._logService=c,this._extHostDocumentsAndEditors=g,this._onFileSystemEvent=new o.Emitter,this._onDidRenameFile=new o.Emitter,this._onDidCreateFile=new o.Emitter,this._onDidDeleteFile=new o.Emitter,this._onWillRenameFile=new o.AsyncEmitter,this._onWillCreateFile=new o.AsyncEmitter,this._onWillDeleteFile=new o.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(v,c,g,r,n,m){return new C(this._mainContext,v,c,this._onFileSystemEvent.event,S.GlobPattern.from(g),r,n,m)}$onFileEvent(v){this._onFileSystemEvent.fire(v)}$onDidRunFileOperation(v,c){switch(v){case 2:this._onDidRenameFile.fire(Object.freeze({files:c.map(g=>({oldUri:w.URI.revive(g.source),newUri:w.URI.revive(g.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:c.map(g=>w.URI.revive(g.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:c.map(g=>w.URI.revive(g.target))}));break;default:}}getOnWillRenameFileEvent(v){return this._createWillExecuteEvent(v,this._onWillRenameFile)}getOnWillCreateFileEvent(v){return this._createWillExecuteEvent(v,this._onWillCreateFile)}getOnWillDeleteFileEvent(v){return this._createWillExecuteEvent(v,this._onWillDeleteFile)}_createWillExecuteEvent(v,c){return(g,r,n)=>{const m=function(k){g.call(r,k)};return m.extension=v,c.event(m,void 0,n)}}async $onWillRunFileOperation(v,c,g,r){switch(v){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:c.map(n=>({oldUri:w.URI.revive(n.source),newUri:w.URI.revive(n.target)}))},g,r);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:c.map(n=>w.URI.revive(n.target))},g,r);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:c.map(n=>w.URI.revive(n.target))},g,r)}}async _fireWillEvent(v,c,g,r){const n=new Set,m=[];if(await v.fireAsync(c,r,async(k,d)=>{const f=Date.now(),b=await Promise.resolve(k);b instanceof A.WorkspaceEdit&&(m.push(b),n.add(d.extension.displayName??d.extension.identifier.value)),Date.now()-f>g&&this._logService.warn("SLOW file-participant",d.extension.identifier)}),r.isCancellationRequested||m.length===0)return;const y={edits:[]};for(let k of m){let{edits:d}=S.WorkspaceEdit.from(k,{getTextDocumentVersion:f=>this._extHostDocumentsAndEditors.getDocument(f)?.version,getNotebookDocumentVersion:()=>{}});y.edits=y.edits.concat(d)}return{edit:y,extensionNames:Array.from(n)}}}e.ExtHostFileSystemEventService=L}),define(Ee[188],be([1,0,2,39]),function(Y,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class w{constructor(S,A,C,L){this._extHostNotebooks=A,this._textDocumentsAndEditors=C,this._commands=L;const M=new I.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new I.ApiCommandArgument("showOptions","Show Options",v=>!0,v=>v),new I.ApiCommandArgument("resource","Interactive resource Uri",v=>!0,v=>v),new I.ApiCommandArgument("controllerId","Notebook controller Id",v=>!0,v=>v),new I.ApiCommandArgument("title","Interactive editor title",v=>!0,v=>v)],new I.ApiCommandResult("Notebook and input URI",v=>{if(v.notebookEditorId!==void 0){const c=this._extHostNotebooks.getEditorById(v.notebookEditorId);return{notebookUri:o.URI.revive(v.notebookUri),inputUri:o.URI.revive(v.inputUri),notebookEditor:c.apiEditor}}return{notebookUri:o.URI.revive(v.notebookUri),inputUri:o.URI.revive(v.inputUri)}}));this._commands.registerApiCommand(M)}$willAddInteractiveDocument(S,A,C,L){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:C,uri:S,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(o.URI.revive(L))?.apiNotebook}]})}$willRemoveInteractiveDocument(S,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[S]})}}e.ExtHostInteractive=w}),define(Ee[189],be([1,0,6,4]),function(Y,e,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class w{constructor(S){this._handlePool=0,this._proxy=S.getProxy(I.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(S){const A=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(A,S),(0,o.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=w}),define(Ee[190],be([1,0,2,26,8,7,4,10,48,16,11,232,20,6,75,53,58,191,15,5,13]),function(Y,e,o,I,w,B,S,A,C,L,M,v,c,g,r,n,m,y,k,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class b{constructor(N,F){this._documents=N,this._provider=F}async provideDocumentSymbols(N,F){const D=this._documents.getDocument(N),O=await this._provider.provideDocumentSymbols(D,F);if(!(0,L.isFalsyOrEmpty)(O))return O[0]instanceof B.DocumentSymbol?O.map(w.DocumentSymbol.from):b._asDocumentSymbolTree(O)}static _asDocumentSymbolTree(N){N=N.slice(0).sort((O,x)=>{let X=O.location.range.start.compareTo(x.location.range.start);return X===0&&(X=x.location.range.end.compareTo(O.location.range.end)),X});const F=[],D=[];for(const O of N){const x={name:O.name||"!!MISSING: name!!",kind:w.SymbolKind.from(O.kind),tags:O.tags?.map(w.SymbolTag.from)||[],detail:"",containerName:O.containerName,range:w.Range.from(O.location.range),selectionRange:w.Range.from(O.location.range),children:[]};for(;;){if(D.length===0){D.push(x),F.push(x);break}const X=D[D.length-1];if(C.Range.containsRange(X.range,x.range)&&!C.Range.equalsRange(X.range,x.range)){X.children&&X.children.push(x),D.push(x);break}D.pop()}}return F}}class l{constructor(N,F,D){this._documents=N,this._commands=F,this._provider=D,this._cache=new m.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(N,F){const D=this._documents.getDocument(N),O=await this._provider.provideCodeLenses(D,F);if(!O||F.isCancellationRequested)return;const x=this._cache.add(O),X=new g.DisposableStore;this._disposables.set(x,X);const re={cacheId:x,lenses:[]};for(let ve=0;ve<O.length;ve++)re.lenses.push({cacheId:[x,ve],range:w.Range.from(O[ve].range),command:this._commands.toInternal(O[ve].command,X)});return re}async resolveCodeLens(N,F){const D=N.cacheId&&this._cache.get(...N.cacheId);if(!D)return;let O;if(typeof this._provider.resolveCodeLens!="function"||D.isResolved?O=D:O=await this._provider.resolveCodeLens(D,F),O||(O=D),F.isCancellationRequested)return;const x=N.cacheId&&this._disposables.get(N.cacheId[0]);if(!!x)return N.command=this._commands.toInternal(O.command??l._badCmd,x),N}releaseCodeLenses(N){this._disposables.get(N)?.dispose(),this._disposables.delete(N),this._cache.delete(N)}}l._badCmd={command:"missing",title:"!!MISSING: command!!"};function P(ue){return Array.isArray(ue)?ue.map(w.DefinitionLink.from):ue?[w.DefinitionLink.from(ue)]:[]}class u{constructor(N,F){this._documents=N,this._provider=F}async provideDefinition(N,F,D){const O=this._documents.getDocument(N),x=w.Position.to(F),X=await this._provider.provideDefinition(O,x,D);return P(X)}}class i{constructor(N,F){this._documents=N,this._provider=F}async provideDeclaration(N,F,D){const O=this._documents.getDocument(N),x=w.Position.to(F),X=await this._provider.provideDeclaration(O,x,D);return P(X)}}class s{constructor(N,F){this._documents=N,this._provider=F}async provideImplementation(N,F,D){const O=this._documents.getDocument(N),x=w.Position.to(F),X=await this._provider.provideImplementation(O,x,D);return P(X)}}class t{constructor(N,F){this._documents=N,this._provider=F}async provideTypeDefinition(N,F,D){const O=this._documents.getDocument(N),x=w.Position.to(F),X=await this._provider.provideTypeDefinition(O,x,D);return P(X)}}class a{constructor(N,F){this._documents=N,this._provider=F}async provideHover(N,F,D){const O=this._documents.getDocument(N),x=w.Position.to(F),X=await this._provider.provideHover(O,x,D);if(!(!X||(0,L.isFalsyOrEmpty)(X.contents)))return X.range||(X.range=O.getWordRangeAtPosition(x)),X.range||(X.range=new B.Range(x,x)),w.Hover.from(X)}}class p{constructor(N,F){this._documents=N,this._provider=F}async provideEvaluatableExpression(N,F,D){const O=this._documents.getDocument(N),x=w.Position.to(F),X=await this._provider.provideEvaluatableExpression(O,x,D);if(X)return w.EvaluatableExpression.from(X)}}class h{constructor(N,F){this._documents=N,this._provider=F}async provideInlineValues(N,F,D,O){const x=this._documents.getDocument(N),X=await this._provider.provideInlineValues(x,w.Range.to(F),w.InlineValueContext.to(D),O);if(Array.isArray(X))return X.map(re=>w.InlineValue.from(re))}}class _{constructor(N,F){this._documents=N,this._provider=F}async provideDocumentHighlights(N,F,D){const O=this._documents.getDocument(N),x=w.Position.to(F),X=await this._provider.provideDocumentHighlights(O,x,D);if(Array.isArray(X))return X.map(w.DocumentHighlight.from)}}class T{constructor(N,F){this._documents=N,this._provider=F}async provideLinkedEditingRanges(N,F,D){const O=this._documents.getDocument(N),x=w.Position.to(F),X=await this._provider.provideLinkedEditingRanges(O,x,D);if(X&&Array.isArray(X.ranges))return{ranges:(0,L.coalesce)(X.ranges.map(w.Range.from)),wordPattern:X.wordPattern}}}class R{constructor(N,F){this._documents=N,this._provider=F}async provideReferences(N,F,D,O){const x=this._documents.getDocument(N),X=w.Position.to(F),re=await this._provider.provideReferences(x,X,D,O);if(Array.isArray(re))return re.map(w.location.from)}}class W{constructor(N,F,D,O,x,X,re){this._documents=N,this._commands=F,this._diagnostics=D,this._provider=O,this._logService=x,this._extension=X,this._apiDeprecation=re,this._cache=new m.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(N,F,D,O){const x=this._documents.getDocument(N),X=v.Selection.isISelection(F)?w.Selection.to(F):w.Range.to(F),re=[];for(const xe of this._diagnostics.getDiagnostics(N))if(X.intersection(xe.range)&&re.push(xe)>W._maxCodeActionsPerFile)break;const ve={diagnostics:re,only:D.only?new B.CodeActionKind(D.only):void 0,triggerKind:w.CodeActionTriggerKind.to(D.trigger)},Ie=await this._provider.provideCodeActions(x,X,ve,O);if(!(0,L.isNonEmptyArray)(Ie)||O.isCancellationRequested)return;const Me=this._cache.add(Ie),Le=new g.DisposableStore;this._disposables.set(Me,Le);const ze=[];for(let xe=0;xe<Ie.length;xe++){const Re=Ie[xe];!Re||(W._isCommand(Re)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ze.push({_isSynthetic:!0,title:Re.title,command:this._commands.toInternal(Re,Le)})):(ve.only&&(Re.kind?ve.only.contains(Re.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ve.only.value} 'requested but returned code action is of kind '${Re.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ze.push({cacheId:[Me,xe],title:Re.title,command:Re.command&&this._commands.toInternal(Re.command,Le),diagnostics:Re.diagnostics&&Re.diagnostics.map(w.Diagnostic.from),edit:Re.edit&&w.WorkspaceEdit.from(Re.edit),kind:Re.kind&&Re.kind.value,isPreferred:Re.isPreferred,disabled:Re.disabled?.reason})))}return{cacheId:Me,actions:ze}}async resolveCodeAction(N,F){const[D,O]=N,x=this._cache.get(D,O);if(!x||W._isCommand(x)||!this._provider.resolveCodeAction)return;const X=await this._provider.resolveCodeAction(x,F)??x;return X?.edit?w.WorkspaceEdit.from(X.edit):void 0}releaseCodeActions(N){this._disposables.get(N)?.dispose(),this._disposables.delete(N),this._cache.delete(N)}static _isCommand(N){return typeof N.command=="string"&&typeof N.title=="string"}}W._maxCodeActionsPerFile=1e3;class E{constructor(N,F){this._documents=N,this._provider=F}async provideDocumentFormattingEdits(N,F,D){const O=this._documents.getDocument(N),x=await this._provider.provideDocumentFormattingEdits(O,F,D);if(Array.isArray(x))return x.map(w.TextEdit.from)}}class H{constructor(N,F){this._documents=N,this._provider=F}async provideDocumentRangeFormattingEdits(N,F,D,O){const x=this._documents.getDocument(N),X=w.Range.to(F),re=await this._provider.provideDocumentRangeFormattingEdits(x,X,D,O);if(Array.isArray(re))return re.map(w.TextEdit.from)}}class q{constructor(N,F){this._documents=N,this._provider=F,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(N,F,D,O,x){const X=this._documents.getDocument(N),re=w.Position.to(F),ve=await this._provider.provideOnTypeFormattingEdits(X,re,D,O,x);if(Array.isArray(ve))return ve.map(w.TextEdit.from)}}class ${constructor(N,F){this._provider=N,this._logService=F,this._cache=new m.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(N,F){const D=await this._provider.provideWorkspaceSymbols(N,F);if(!(0,L.isNonEmptyArray)(D))return{symbols:[]};const O=this._cache.add(D),x={cacheId:O,symbols:[]};for(let X=0;X<D.length;X++){const re=D[X];if(!re||!re.name){this._logService.warn("INVALID SymbolInformation",re);continue}x.symbols.push({...w.WorkspaceSymbol.from(re),cacheId:[O,X]})}return x}async resolveWorkspaceSymbol(N,F){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!N.cacheId)return N;const D=this._cache.get(...N.cacheId);if(D){const O=await this._provider.resolveWorkspaceSymbol(D,F);return O&&(0,I.mixin)(N,w.WorkspaceSymbol.from(O),!0)}}releaseWorkspaceSymbols(N){this._cache.delete(N)}}class j{constructor(N,F,D){this._documents=N,this._provider=F,this._logService=D}static supportsResolving(N){return typeof N.prepareRename=="function"}async provideRenameEdits(N,F,D,O){const x=this._documents.getDocument(N),X=w.Position.to(F);try{const re=await this._provider.provideRenameEdits(x,X,D,O);return re?w.WorkspaceEdit.from(re):void 0}catch(re){const ve=j._asMessage(re);return ve?{rejectReason:ve,edits:void 0}:Promise.reject(re)}}async resolveRenameLocation(N,F,D){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const O=this._documents.getDocument(N),x=w.Position.to(F);try{const X=await this._provider.prepareRename(O,x,D);let re,ve;if(B.Range.isRange(X)?(re=X,ve=O.getText(X)):(0,M.isObject)(X)&&(re=X.range,ve=X.placeholder),!re||!ve)return;if(re.start.line>x.line||re.end.line<x.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:w.Range.from(re),text:ve}}catch(X){const re=j._asMessage(X);return re?{rejectReason:re,range:void 0,text:void 0}:Promise.reject(X)}}static _asMessage(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class J{constructor(N,F){this.resultId=N,this.tokens=F}}class z{constructor(N,F){this._documents=N,this._provider=F,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(N,F,D){const O=this._documents.getDocument(N),x=F!==0?this._previousResults.get(F):null;let X=typeof x?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(O,x.resultId,D):await this._provider.provideDocumentSemanticTokens(O,D);return x&&this._previousResults.delete(F),X?(X=z._fixProvidedSemanticTokens(X),this._send(z._convertToEdits(x,X),X)):null}async releaseDocumentSemanticColoring(N){this._previousResults.delete(N)}static _fixProvidedSemanticTokens(N){return z._isSemanticTokens(N)?z._isCorrectSemanticTokens(N)?N:new B.SemanticTokens(new Uint32Array(N.data),N.resultId):z._isSemanticTokensEdits(N)?z._isCorrectSemanticTokensEdits(N)?N:new B.SemanticTokensEdits(N.edits.map(F=>new B.SemanticTokensEdit(F.start,F.deleteCount,F.data?new Uint32Array(F.data):F.data)),N.resultId):N}static _isSemanticTokens(N){return N&&!!N.data}static _isCorrectSemanticTokens(N){return N.data instanceof Uint32Array}static _isSemanticTokensEdits(N){return N&&Array.isArray(N.edits)}static _isCorrectSemanticTokensEdits(N){for(const F of N.edits)if(!(F.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(N,F){if(!z._isSemanticTokens(F)||!N||!N.tokens)return F;const D=N.tokens,O=D.length,x=F.data,X=x.length;let re=0;const ve=Math.min(O,X);for(;re<ve&&D[re]===x[re];)re++;if(re===O&&re===X)return new B.SemanticTokensEdits([],F.resultId);let Ie=0;const Me=ve-re;for(;Ie<Me&&D[O-Ie-1]===x[X-Ie-1];)Ie++;return new B.SemanticTokensEdits([{start:re,deleteCount:O-re-Ie,data:x.subarray(re,X-Ie)}],F.resultId)}_send(N,F){if(z._isSemanticTokens(N)){const D=this._nextResultId++;return this._previousResults.set(D,new J(N.resultId,N.data)),(0,r.encodeSemanticTokensDto)({id:D,type:"full",data:N.data})}if(z._isSemanticTokensEdits(N)){const D=this._nextResultId++;return z._isSemanticTokens(F)?this._previousResults.set(D,new J(F.resultId,F.data)):this._previousResults.set(D,new J(N.resultId)),(0,r.encodeSemanticTokensDto)({id:D,type:"delta",deltas:(N.edits||[]).map(O=>({start:O.start,deleteCount:O.deleteCount,data:O.data}))})}return null}}e.DocumentSemanticTokensAdapter=z;class ie{constructor(N,F){this._documents=N,this._provider=F}async provideDocumentRangeSemanticTokens(N,F,D){const O=this._documents.getDocument(N),x=await this._provider.provideDocumentRangeSemanticTokens(O,w.Range.to(F),D);return x?this._send(x):null}_send(N){return(0,r.encodeSemanticTokensDto)({id:0,type:"full",data:N.data})}}e.DocumentRangeSemanticTokensAdapter=ie;class ae{constructor(N,F,D,O,x){this._documents=N,this._commands=F,this._provider=D,this._apiDeprecation=O,this._extension=x,this._cache=new m.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(N){return typeof N.resolveCompletionItem=="function"}async provideCompletionItems(N,F,D,O){const x=this._documents.getDocument(N),X=w.Position.to(F),re=x.getWordRangeAtPosition(X)||new B.Range(X,X),ve=re.with({end:X}),Ie=new y.StopWatch(!0),Me=await this._provider.provideCompletionItems(x,X,O,w.CompletionContext.to(D));if(!Me||O.isCancellationRequested)return;const Le=Array.isArray(Me)?new B.CompletionList(Me):Me,ze=ae.supportsResolving(this._provider)?this._cache.add(Le.items):this._cache.add([]),xe=new g.DisposableStore;this._disposables.set(ze,xe);const Re=[],Qe={x:ze,b:Re,a:{replace:w.Range.from(re),insert:w.Range.from(ve)},c:Le.isIncomplete||void 0,d:Ie.elapsed()};for(let tt=0;tt<Le.items.length;tt++){const Te=Le.items[tt],it=this._convertCompletionItem(Te,[ze,tt],ve,re);Re.push(it)}return Qe}async resolveCompletionItem(N,F){if(typeof this._provider.resolveCompletionItem!="function")return;const D=this._cache.get(...N);if(!D)return;const O=await this._provider.resolveCompletionItem(D,F);if(!!O)return this._convertCompletionItem(O,N)}releaseCompletionItems(N){this._disposables.get(N)?.dispose(),this._disposables.delete(N),this._cache.delete(N)}_convertCompletionItem(N,F,D,O){const x=this._disposables.get(F[0]);if(!x)throw Error("DisposableStore is missing...");const X={x:F,a:N.label,b:N.kind!==void 0?w.CompletionItemKind.from(N.kind):void 0,n:N.tags&&N.tags.map(w.CompletionItemTag.from),c:N.detail,d:typeof N.documentation=="undefined"?void 0:w.MarkdownString.fromStrict(N.documentation),e:N.sortText!==N.label?N.sortText:void 0,f:N.filterText!==N.label?N.filterText:void 0,g:N.preselect||void 0,i:N.keepWhitespace?1:0,k:N.commitCharacters,l:N.additionalTextEdits&&N.additionalTextEdits.map(w.TextEdit.from),m:this._commands.toInternal(N.command,x)};N.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),X.h=N.textEdit.newText):typeof N.insertText=="string"?X.h=N.insertText:N.insertText instanceof B.SnippetString&&(X.h=N.insertText.value,X.i|=4);let re;return N.textEdit?re=N.textEdit.range:N.range&&(re=N.range),B.Range.isRange(re)?X.j=w.Range.from(re):re&&(!D?.isEqual(re.inserting)||!O?.isEqual(re.replacing))&&(X.j={insert:w.Range.from(re.inserting),replace:w.Range.from(re.replacing)}),X}}class te{constructor(N,F,D){this._documents=N,this._provider=F,this._commands=D,this._cache=new m.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(N,F,D,O){const x=this._documents.getDocument(N),X=w.Position.to(F),re=await this._provider.provideInlineCompletionItems(x,X,{selectedCompletionInfo:D.selectedSuggestionInfo?{range:w.Range.to(D.selectedSuggestionInfo.range),text:D.selectedSuggestionInfo.text,isSnippetText:D.selectedSuggestionInfo.isSnippetText,completionKind:w.CompletionItemKind.to(D.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:D.triggerKind},O);if(!re||O.isCancellationRequested)return;const ve=(0,M.isArray)(re)?re:re.items,Ie=this._cache.add(ve);let Me;return{pid:Ie,items:ve.map((Le,ze)=>{let xe;Le.command&&(Me||(Me=new g.DisposableStore,this._disposables.set(Ie,Me)),xe=this._commands.toInternal(Le.command,Me));const Re=Le.insertText??Le.text;if(Re===void 0)throw new Error("text or insertText must be defined");return{text:Re,range:Le.range?w.Range.from(Le.range):void 0,command:xe,idx:ze,completeBracketPairs:Le.completeBracketPairs}})}}disposeCompletions(N){this._cache.delete(N);const F=this._disposables.get(N);F&&F.clear(),this._disposables.delete(N)}handleDidShowCompletionItem(N,F){const D=this._cache.get(N,F);D&&ce.get(this._provider).fireOnDidShowCompletionItem({completionItem:D})}}class ce{constructor(){this._onDidShowCompletionItemEmitter=new d.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(N){let F=ce.map.get(N);return F||(F=new ce,ce.map.set(N,F)),F}fireOnDidShowCompletionItem(N){this._onDidShowCompletionItemEmitter.fire(N)}}e.InlineCompletionController=ce,ce.map=new WeakMap;class de{constructor(N,F){this._documents=N,this._provider=F,this._cache=new m.Cache("SignatureHelp")}async provideSignatureHelp(N,F,D,O){const x=this._documents.getDocument(N),X=w.Position.to(F),re=this.reviveContext(D),ve=await this._provider.provideSignatureHelp(x,X,O,re);if(ve){const Ie=this._cache.add([ve]);return{...w.SignatureHelp.from(ve),id:Ie}}}reviveContext(N){let F;if(N.activeSignatureHelp){const D=w.SignatureHelp.to(N.activeSignatureHelp),O=this._cache.get(N.activeSignatureHelp.id,0);O?(F=O,F.activeSignature=D.activeSignature,F.activeParameter=D.activeParameter):F=D}return{...N,activeSignatureHelp:F}}releaseSignatureHelp(N){this._cache.delete(N)}}class Se{constructor(N,F,D,O,x){this._documents=N,this._commands=F,this._provider=D,this._logService=O,this._extension=x,this._cache=new m.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(N,F,D){const O=this._documents.getDocument(N),x=w.Range.to(F),X=await this._provider.provideInlayHints(O,x,D);if(!Array.isArray(X)||X.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${F}`);return}if(D.isCancellationRequested)return;const re=this._cache.add(X);this._disposables.set(re,new g.DisposableStore);const ve={hints:[],cacheId:re};for(let Ie=0;Ie<X.length;Ie++)this._isValidInlayHint(X[Ie],x)&&ve.hints.push(this._convertInlayHint(X[Ie],[re,Ie]));return this._logService.trace(`[InlayHints] ${ve.hints.length} inlay hints from '${this._extension.identifier.value}' for ${F}`),ve}async resolveInlayHint(N,F){if(typeof this._provider.resolveInlayHint!="function")return;const D=this._cache.get(...N);if(!D)return;const O=await this._provider.resolveInlayHint(D,F);if(!!O&&!!this._isValidInlayHint(O))return this._convertInlayHint(O,N)}releaseHints(N){this._disposables.get(N)?.dispose(),this._disposables.delete(N),this._cache.delete(N)}_isValidInlayHint(N,F){return N.label.length===0||Array.isArray(N.label)&&N.label.every(D=>D.value.length===0)?(console.log("INVALID inlay hint, empty label",N),!1):!(F&&!F.contains(N.position))}_convertInlayHint(N,F){const D=this._disposables.get(F[0]);if(!D)throw Error("DisposableStore is missing...");const O={label:"",cacheId:F,tooltip:w.MarkdownString.fromStrict(N.tooltip),command:N.command&&this._commands.toInternal(N.command,D),position:w.Position.from(N.position),kind:N.kind&&w.InlayHintKind.from(N.kind),paddingLeft:N.paddingLeft,paddingRight:N.paddingRight};return typeof N.label=="string"?O.label=N.label:O.label=N.label.map(x=>{let X={label:x.value};return X.tooltip=w.MarkdownString.fromStrict(x.tooltip),B.Location.isLocation(x.location)&&(X.location=w.location.from(x.location)),x.command&&(X.command=this._commands.toInternal(x.command,D)),X}),O}}class fe{constructor(N,F){this._documents=N,this._provider=F,this._cache=new m.Cache("DocumentLink")}async provideLinks(N,F){const D=this._documents.getDocument(N),O=await this._provider.provideDocumentLinks(D,F);if(!(!Array.isArray(O)||O.length===0)&&!F.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:O.filter(fe._validateLink).map(w.DocumentLink.from)};{const x=this._cache.add(O),X={links:[],cacheId:x};for(let re=0;re<O.length;re++){if(!fe._validateLink(O[re]))continue;const ve=w.DocumentLink.from(O[re]);ve.cacheId=[x,re],X.links.push(ve)}return X}}}static _validateLink(N){return N.target&&N.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(N,F){if(typeof this._provider.resolveDocumentLink!="function")return;const D=this._cache.get(...N);if(!D)return;const O=await this._provider.resolveDocumentLink(D,F);if(!(!O||!fe._validateLink(O)))return w.DocumentLink.from(O)}releaseLinks(N){this._cache.delete(N)}}class ne{constructor(N,F){this._documents=N,this._provider=F}async provideColors(N,F){const D=this._documents.getDocument(N),O=await this._provider.provideDocumentColors(D,F);return Array.isArray(O)?O.map(X=>({color:w.Color.from(X.color),range:w.Range.from(X.range)})):[]}async provideColorPresentations(N,F,D){const O=this._documents.getDocument(N),x=w.Range.to(F.range),X=w.Color.to(F.color),re=await this._provider.provideColorPresentations(X,{document:O,range:x},D);if(!!Array.isArray(re))return re.map(w.ColorPresentation.from)}}class me{constructor(N,F){this._documents=N,this._provider=F}async provideFoldingRanges(N,F,D){const O=this._documents.getDocument(N),x=await this._provider.provideFoldingRanges(O,F,D);if(!!Array.isArray(x))return x.map(w.FoldingRange.from)}}class ke{constructor(N,F,D){this._documents=N,this._provider=F,this._logService=D}async provideSelectionRanges(N,F,D){const O=this._documents.getDocument(N),x=F.map(w.Position.to),X=await this._provider.provideSelectionRanges(O,x,D);if(!(0,L.isNonEmptyArray)(X))return[];if(X.length!==x.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const re=[];for(let ve=0;ve<x.length;ve++){const Ie=[];re.push(Ie);let Me=x[ve],Le=X[ve];for(;;){if(!Le.range.contains(Me))throw new Error("INVALID selection range, must contain the previous range");if(Ie.push(w.SelectionRange.from(Le)),!Le.parent)break;Me=Le.range,Le=Le.parent}}return re}}class Ae{constructor(N,F){this._documents=N,this._provider=F,this._idPool=new n.IdGenerator(""),this._cache=new Map}async prepareSession(N,F,D){const O=this._documents.getDocument(N),x=w.Position.to(F),X=await this._provider.prepareCallHierarchy(O,x,D);if(!X)return;const re=this._idPool.nextId();return this._cache.set(re,new Map),Array.isArray(X)?X.map(ve=>this._cacheAndConvertItem(re,ve)):[this._cacheAndConvertItem(re,X)]}async provideCallsTo(N,F,D){const O=this._itemFromCache(N,F);if(!O)throw new Error("missing call hierarchy item");const x=await this._provider.provideCallHierarchyIncomingCalls(O,D);if(!!x)return x.map(X=>({from:this._cacheAndConvertItem(N,X.from),fromRanges:X.fromRanges.map(re=>w.Range.from(re))}))}async provideCallsFrom(N,F,D){const O=this._itemFromCache(N,F);if(!O)throw new Error("missing call hierarchy item");const x=await this._provider.provideCallHierarchyOutgoingCalls(O,D);if(!!x)return x.map(X=>({to:this._cacheAndConvertItem(N,X.to),fromRanges:X.fromRanges.map(re=>w.Range.from(re))}))}releaseSession(N){this._cache.delete(N)}_cacheAndConvertItem(N,F){const D=this._cache.get(N),O=w.CallHierarchyItem.from(F,N,D.size.toString(36));return D.set(O._itemId,F),O}_itemFromCache(N,F){return this._cache.get(N)?.get(F)}}class Be{constructor(N,F){this._documents=N,this._provider=F,this._idPool=new n.IdGenerator(""),this._cache=new Map}async prepareSession(N,F,D){const O=this._documents.getDocument(N),x=w.Position.to(F),X=await this._provider.prepareTypeHierarchy(O,x,D);if(!X)return;const re=this._idPool.nextId();return this._cache.set(re,new Map),Array.isArray(X)?X.map(ve=>this._cacheAndConvertItem(re,ve)):[this._cacheAndConvertItem(re,X)]}async provideSupertypes(N,F,D){const O=this._itemFromCache(N,F);if(!O)throw new Error("missing type hierarchy item");const x=await this._provider.provideTypeHierarchySupertypes(O,D);if(!!x)return x.map(X=>this._cacheAndConvertItem(N,X))}async provideSubtypes(N,F,D){const O=this._itemFromCache(N,F);if(!O)throw new Error("missing type hierarchy item");const x=await this._provider.provideTypeHierarchySubtypes(O,D);if(!!x)return x.map(X=>this._cacheAndConvertItem(N,X))}releaseSession(N){this._cache.delete(N)}_cacheAndConvertItem(N,F){const D=this._cache.get(N),O=w.TypeHierarchyItem.from(F,N,D.size.toString(36));return D.set(O._itemId,F),O}_itemFromCache(N,F){return this._cache.get(N)?.get(F)}}class Xe{constructor(N,F){this.adapter=N,this.extension=F}}class ge{constructor(N,F,D,O,x,X,re){this._adapter=new Map,this._uriTransformer=F,this._proxy=N.getProxy(S.MainContext.MainThreadLanguageFeatures),this._documents=D,this._commands=O,this._diagnostics=x,this._logService=X,this._apiDeprecation=re}_transformDocumentSelector(N){return w.DocumentSelector.from(N,this._uriTransformer)}_createDisposable(N){return new B.Disposable(()=>{this._adapter.delete(N),this._proxy.$unregister(N)})}_nextHandle(){return ge._handlePool++}async _withAdapter(N,F,D,O,x){const X=this._adapter.get(N);if(!X||!(X.adapter instanceof F))return O;const re=Date.now();this._logService.trace(`[${X.extension.identifier.value}] INVOKE provider '${D.toString().replace(/[\r\n]/g,"")}'`);const ve=D(X.adapter,X.extension);return Promise.resolve(ve).catch(Ie=>{(0,k.isCancellationError)(Ie)||(this._logService.error(`[${X.extension.identifier.value}] provider FAILED`),this._logService.error(Ie))}).finally(()=>{this._logService.trace(`[${X.extension.identifier.value}] provider DONE after ${Date.now()-re}ms`)}),c.CancellationToken.isCancellationToken(x)?(0,f.raceCancellationError)(ve,x):ve}_addNewAdapter(N,F){const D=this._nextHandle();return this._adapter.set(D,new Xe(N,F)),D}static _extLabel(N){return N.displayName||N.name}registerDocumentSymbolProvider(N,F,D,O){const x=this._addNewAdapter(new b(this._documents,D),N),X=O&&O.label||ge._extLabel(N);return this._proxy.$registerDocumentSymbolProvider(x,this._transformDocumentSelector(F),X),this._createDisposable(x)}$provideDocumentSymbols(N,F,D){return this._withAdapter(N,b,O=>O.provideDocumentSymbols(o.URI.revive(F),D),void 0,D)}registerCodeLensProvider(N,F,D){const O=this._nextHandle(),x=typeof D.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(O,new Xe(new l(this._documents,this._commands.converter,D),N)),this._proxy.$registerCodeLensSupport(O,this._transformDocumentSelector(F),x);let X=this._createDisposable(O);if(x!==void 0){const re=D.onDidChangeCodeLenses(ve=>this._proxy.$emitCodeLensEvent(x));X=B.Disposable.from(X,re)}return X}$provideCodeLenses(N,F,D){return this._withAdapter(N,l,O=>O.provideCodeLenses(o.URI.revive(F),D),void 0,D)}$resolveCodeLens(N,F,D){return this._withAdapter(N,l,O=>O.resolveCodeLens(F,D),void 0,void 0)}$releaseCodeLenses(N,F){this._withAdapter(N,l,D=>Promise.resolve(D.releaseCodeLenses(F)),void 0,void 0)}registerDefinitionProvider(N,F,D){const O=this._addNewAdapter(new u(this._documents,D),N);return this._proxy.$registerDefinitionSupport(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideDefinition(N,F,D,O){return this._withAdapter(N,u,x=>x.provideDefinition(o.URI.revive(F),D,O),[],O)}registerDeclarationProvider(N,F,D){const O=this._addNewAdapter(new i(this._documents,D),N);return this._proxy.$registerDeclarationSupport(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideDeclaration(N,F,D,O){return this._withAdapter(N,i,x=>x.provideDeclaration(o.URI.revive(F),D,O),[],O)}registerImplementationProvider(N,F,D){const O=this._addNewAdapter(new s(this._documents,D),N);return this._proxy.$registerImplementationSupport(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideImplementation(N,F,D,O){return this._withAdapter(N,s,x=>x.provideImplementation(o.URI.revive(F),D,O),[],O)}registerTypeDefinitionProvider(N,F,D){const O=this._addNewAdapter(new t(this._documents,D),N);return this._proxy.$registerTypeDefinitionSupport(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideTypeDefinition(N,F,D,O){return this._withAdapter(N,t,x=>x.provideTypeDefinition(o.URI.revive(F),D,O),[],O)}registerHoverProvider(N,F,D,O){const x=this._addNewAdapter(new a(this._documents,D),N);return this._proxy.$registerHoverProvider(x,this._transformDocumentSelector(F)),this._createDisposable(x)}$provideHover(N,F,D,O){return this._withAdapter(N,a,x=>x.provideHover(o.URI.revive(F),D,O),void 0,O)}registerEvaluatableExpressionProvider(N,F,D,O){const x=this._addNewAdapter(new p(this._documents,D),N);return this._proxy.$registerEvaluatableExpressionProvider(x,this._transformDocumentSelector(F)),this._createDisposable(x)}$provideEvaluatableExpression(N,F,D,O){return this._withAdapter(N,p,x=>x.provideEvaluatableExpression(o.URI.revive(F),D,O),void 0,O)}registerInlineValuesProvider(N,F,D,O){const x=typeof D.onDidChangeInlineValues=="function"?this._nextHandle():void 0,X=this._addNewAdapter(new h(this._documents,D),N);this._proxy.$registerInlineValuesProvider(X,this._transformDocumentSelector(F),x);let re=this._createDisposable(X);if(x!==void 0){const ve=D.onDidChangeInlineValues(Ie=>this._proxy.$emitInlineValuesEvent(x));re=B.Disposable.from(re,ve)}return re}$provideInlineValues(N,F,D,O,x){return this._withAdapter(N,h,X=>X.provideInlineValues(o.URI.revive(F),D,O,x),void 0,x)}registerDocumentHighlightProvider(N,F,D){const O=this._addNewAdapter(new _(this._documents,D),N);return this._proxy.$registerDocumentHighlightProvider(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideDocumentHighlights(N,F,D,O){return this._withAdapter(N,_,x=>x.provideDocumentHighlights(o.URI.revive(F),D,O),void 0,O)}registerLinkedEditingRangeProvider(N,F,D){const O=this._addNewAdapter(new T(this._documents,D),N);return this._proxy.$registerLinkedEditingRangeProvider(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideLinkedEditingRanges(N,F,D,O){return this._withAdapter(N,T,async x=>{const X=await x.provideLinkedEditingRanges(o.URI.revive(F),D,O);if(X)return{ranges:X.ranges,wordPattern:X.wordPattern?ge._serializeRegExp(X.wordPattern):void 0}},void 0,O)}registerReferenceProvider(N,F,D){const O=this._addNewAdapter(new R(this._documents,D),N);return this._proxy.$registerReferenceSupport(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideReferences(N,F,D,O,x){return this._withAdapter(N,R,X=>X.provideReferences(o.URI.revive(F),D,O,x),void 0,x)}registerCodeActionProvider(N,F,D,O){const x=new g.DisposableStore,X=this._addNewAdapter(new W(this._documents,this._commands.converter,this._diagnostics,D,this._logService,N,this._apiDeprecation),N);return this._proxy.$registerQuickFixSupport(X,this._transformDocumentSelector(F),{providedKinds:O?.providedCodeActionKinds?.map(re=>re.value),documentation:O?.documentation?.map(re=>({kind:re.kind.value,command:this._commands.converter.toInternal(re.command,x)}))},ge._extLabel(N),Boolean(D.resolveCodeAction)),x.add(this._createDisposable(X)),x}$provideCodeActions(N,F,D,O,x){return this._withAdapter(N,W,X=>X.provideCodeActions(o.URI.revive(F),D,O,x),void 0,x)}$resolveCodeAction(N,F,D){return this._withAdapter(N,W,O=>O.resolveCodeAction(F,D),void 0,void 0)}$releaseCodeActions(N,F){this._withAdapter(N,W,D=>Promise.resolve(D.releaseCodeActions(F)),void 0,void 0)}registerDocumentFormattingEditProvider(N,F,D){const O=this._addNewAdapter(new E(this._documents,D),N);return this._proxy.$registerDocumentFormattingSupport(O,this._transformDocumentSelector(F),N.identifier,N.displayName||N.name),this._createDisposable(O)}$provideDocumentFormattingEdits(N,F,D,O){return this._withAdapter(N,E,x=>x.provideDocumentFormattingEdits(o.URI.revive(F),D,O),void 0,O)}registerDocumentRangeFormattingEditProvider(N,F,D){const O=this._addNewAdapter(new H(this._documents,D),N);return this._proxy.$registerRangeFormattingSupport(O,this._transformDocumentSelector(F),N.identifier,N.displayName||N.name),this._createDisposable(O)}$provideDocumentRangeFormattingEdits(N,F,D,O,x){return this._withAdapter(N,H,X=>X.provideDocumentRangeFormattingEdits(o.URI.revive(F),D,O,x),void 0,x)}registerOnTypeFormattingEditProvider(N,F,D,O){const x=this._addNewAdapter(new q(this._documents,D),N);return this._proxy.$registerOnTypeFormattingSupport(x,this._transformDocumentSelector(F),O,N.identifier),this._createDisposable(x)}$provideOnTypeFormattingEdits(N,F,D,O,x,X){return this._withAdapter(N,q,re=>re.provideOnTypeFormattingEdits(o.URI.revive(F),D,O,x,X),void 0,X)}registerWorkspaceSymbolProvider(N,F){const D=this._addNewAdapter(new $(F,this._logService),N);return this._proxy.$registerNavigateTypeSupport(D,typeof F.resolveWorkspaceSymbol=="function"),this._createDisposable(D)}$provideWorkspaceSymbols(N,F,D){return this._withAdapter(N,$,O=>O.provideWorkspaceSymbols(F,D),{symbols:[]},D)}$resolveWorkspaceSymbol(N,F,D){return this._withAdapter(N,$,O=>O.resolveWorkspaceSymbol(F,D),void 0,void 0)}$releaseWorkspaceSymbols(N,F){this._withAdapter(N,$,D=>D.releaseWorkspaceSymbols(F),void 0,void 0)}registerRenameProvider(N,F,D){const O=this._addNewAdapter(new j(this._documents,D,this._logService),N);return this._proxy.$registerRenameSupport(O,this._transformDocumentSelector(F),j.supportsResolving(D)),this._createDisposable(O)}$provideRenameEdits(N,F,D,O,x){return this._withAdapter(N,j,X=>X.provideRenameEdits(o.URI.revive(F),D,O,x),void 0,x)}$resolveRenameLocation(N,F,D,O){return this._withAdapter(N,j,x=>x.resolveRenameLocation(o.URI.revive(F),D,O),void 0,O)}registerDocumentSemanticTokensProvider(N,F,D,O){const x=this._addNewAdapter(new z(this._documents,D),N),X=typeof D.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(x,this._transformDocumentSelector(F),O,X);let re=this._createDisposable(x);if(X){const ve=D.onDidChangeSemanticTokens(Ie=>this._proxy.$emitDocumentSemanticTokensEvent(X));re=B.Disposable.from(re,ve)}return re}$provideDocumentSemanticTokens(N,F,D,O){return this._withAdapter(N,z,x=>x.provideDocumentSemanticTokens(o.URI.revive(F),D,O),null,O)}$releaseDocumentSemanticTokens(N,F){this._withAdapter(N,z,D=>D.releaseDocumentSemanticColoring(F),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(N,F,D,O){const x=this._addNewAdapter(new ie(this._documents,D),N);return this._proxy.$registerDocumentRangeSemanticTokensProvider(x,this._transformDocumentSelector(F),O),this._createDisposable(x)}$provideDocumentRangeSemanticTokens(N,F,D,O){return this._withAdapter(N,ie,x=>x.provideDocumentRangeSemanticTokens(o.URI.revive(F),D,O),null,O)}registerCompletionItemProvider(N,F,D,O){const x=this._addNewAdapter(new ae(this._documents,this._commands.converter,D,this._apiDeprecation,N),N);return this._proxy.$registerSuggestSupport(x,this._transformDocumentSelector(F),O,ae.supportsResolving(D),`${N.identifier.value}(${O.join("")})`),this._createDisposable(x)}$provideCompletionItems(N,F,D,O,x){return this._withAdapter(N,ae,X=>X.provideCompletionItems(o.URI.revive(F),D,O,x),void 0,x)}$resolveCompletionItem(N,F,D){return this._withAdapter(N,ae,O=>O.resolveCompletionItem(F,D),void 0,D)}$releaseCompletionItems(N,F){this._withAdapter(N,ae,D=>D.releaseCompletionItems(F),void 0,void 0)}registerInlineCompletionsProvider(N,F,D){const O=this._addNewAdapter(new te(this._documents,D,this._commands.converter),N);return this._proxy.$registerInlineCompletionsSupport(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideInlineCompletions(N,F,D,O,x){return this._withAdapter(N,te,X=>X.provideInlineCompletions(o.URI.revive(F),D,O,x),void 0,x)}$handleInlineCompletionDidShow(N,F,D){this._withAdapter(N,te,async O=>{O.handleDidShowCompletionItem(F,D)},void 0,void 0)}$freeInlineCompletionsList(N,F){this._withAdapter(N,te,async D=>{D.disposeCompletions(F)},void 0,void 0)}registerSignatureHelpProvider(N,F,D,O){const x=Array.isArray(O)?{triggerCharacters:O,retriggerCharacters:[]}:O,X=this._addNewAdapter(new de(this._documents,D),N);return this._proxy.$registerSignatureHelpProvider(X,this._transformDocumentSelector(F),x),this._createDisposable(X)}$provideSignatureHelp(N,F,D,O,x){return this._withAdapter(N,de,X=>X.provideSignatureHelp(o.URI.revive(F),D,O,x),void 0,x)}$releaseSignatureHelp(N,F){this._withAdapter(N,de,D=>D.releaseSignatureHelp(F),void 0,void 0)}registerInlayHintsProvider(N,F,D){const O=typeof D.onDidChangeInlayHints=="function"?this._nextHandle():void 0,x=this._addNewAdapter(new Se(this._documents,this._commands.converter,D,this._logService,N),N);this._proxy.$registerInlayHintsProvider(x,this._transformDocumentSelector(F),typeof D.resolveInlayHint=="function",O,ge._extLabel(N));let X=this._createDisposable(x);if(O!==void 0){const re=D.onDidChangeInlayHints(ve=>this._proxy.$emitInlayHintsEvent(O));X=B.Disposable.from(X,re)}return X}$provideInlayHints(N,F,D,O){return this._withAdapter(N,Se,x=>x.provideInlayHints(o.URI.revive(F),D,O),void 0,O)}$resolveInlayHint(N,F,D){return this._withAdapter(N,Se,O=>O.resolveInlayHint(F,D),void 0,D)}$releaseInlayHints(N,F){this._withAdapter(N,Se,D=>D.releaseHints(F),void 0,void 0)}registerDocumentLinkProvider(N,F,D){const O=this._addNewAdapter(new fe(this._documents,D),N);return this._proxy.$registerDocumentLinkProvider(O,this._transformDocumentSelector(F),typeof D.resolveDocumentLink=="function"),this._createDisposable(O)}$provideDocumentLinks(N,F,D){return this._withAdapter(N,fe,O=>O.provideLinks(o.URI.revive(F),D),void 0,D)}$resolveDocumentLink(N,F,D){return this._withAdapter(N,fe,O=>O.resolveLink(F,D),void 0,void 0)}$releaseDocumentLinks(N,F){this._withAdapter(N,fe,D=>D.releaseLinks(F),void 0,void 0)}registerColorProvider(N,F,D){const O=this._addNewAdapter(new ne(this._documents,D),N);return this._proxy.$registerDocumentColorProvider(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideDocumentColors(N,F,D){return this._withAdapter(N,ne,O=>O.provideColors(o.URI.revive(F),D),[],D)}$provideColorPresentations(N,F,D,O){return this._withAdapter(N,ne,x=>x.provideColorPresentations(o.URI.revive(F),D,O),void 0,O)}registerFoldingRangeProvider(N,F,D){const O=this._nextHandle(),x=typeof D.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(O,new Xe(new me(this._documents,D),N)),this._proxy.$registerFoldingRangeProvider(O,this._transformDocumentSelector(F),x);let X=this._createDisposable(O);if(x!==void 0){const re=D.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(x));X=B.Disposable.from(X,re)}return X}$provideFoldingRanges(N,F,D,O){return this._withAdapter(N,me,x=>x.provideFoldingRanges(o.URI.revive(F),D,O),void 0,O)}registerSelectionRangeProvider(N,F,D){const O=this._addNewAdapter(new ke(this._documents,D,this._logService),N);return this._proxy.$registerSelectionRangeProvider(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$provideSelectionRanges(N,F,D,O){return this._withAdapter(N,ke,x=>x.provideSelectionRanges(o.URI.revive(F),D,O),[],O)}registerCallHierarchyProvider(N,F,D){const O=this._addNewAdapter(new Ae(this._documents,D),N);return this._proxy.$registerCallHierarchyProvider(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$prepareCallHierarchy(N,F,D,O){return this._withAdapter(N,Ae,x=>Promise.resolve(x.prepareSession(o.URI.revive(F),D,O)),void 0,O)}$provideCallHierarchyIncomingCalls(N,F,D,O){return this._withAdapter(N,Ae,x=>x.provideCallsTo(F,D,O),void 0,O)}$provideCallHierarchyOutgoingCalls(N,F,D,O){return this._withAdapter(N,Ae,x=>x.provideCallsFrom(F,D,O),void 0,O)}$releaseCallHierarchy(N,F){this._withAdapter(N,Ae,D=>Promise.resolve(D.releaseSession(F)),void 0,void 0)}registerTypeHierarchyProvider(N,F,D){const O=this._addNewAdapter(new Be(this._documents,D),N);return this._proxy.$registerTypeHierarchyProvider(O,this._transformDocumentSelector(F)),this._createDisposable(O)}$prepareTypeHierarchy(N,F,D,O){return this._withAdapter(N,Be,x=>Promise.resolve(x.prepareSession(o.URI.revive(F),D,O)),void 0,O)}$provideTypeHierarchySupertypes(N,F,D,O){return this._withAdapter(N,Be,x=>x.provideSupertypes(F,D,O),void 0,O)}$provideTypeHierarchySubtypes(N,F,D,O){return this._withAdapter(N,Be,x=>x.provideSubtypes(F,D,O),void 0,O)}$releaseTypeHierarchy(N,F){this._withAdapter(N,Be,D=>Promise.resolve(D.releaseSession(F)),void 0,void 0)}static _serializeRegExp(N){return{pattern:N.source,flags:(0,A.regExpFlags)(N)}}static _serializeIndentationRule(N){return{decreaseIndentPattern:ge._serializeRegExp(N.decreaseIndentPattern),increaseIndentPattern:ge._serializeRegExp(N.increaseIndentPattern),indentNextLinePattern:N.indentNextLinePattern?ge._serializeRegExp(N.indentNextLinePattern):void 0,unIndentedLinePattern:N.unIndentedLinePattern?ge._serializeRegExp(N.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(N){return{beforeText:ge._serializeRegExp(N.beforeText),afterText:N.afterText?ge._serializeRegExp(N.afterText):void 0,previousLineText:N.previousLineText?ge._serializeRegExp(N.previousLineText):void 0,action:N.action}}static _serializeOnEnterRules(N){return N.map(ge._serializeOnEnterRule)}setLanguageConfiguration(N,F,D){let{wordPattern:O}=D;if(O&&(0,A.regExpLeadsToEndlessLoop)(O))throw new Error(`Invalid language configuration: wordPattern '${O}' is not allowed to match the empty string.`);O?this._documents.setWordDefinitionFor(F,O):this._documents.setWordDefinitionFor(F,void 0),D.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",N,"Do not use."),D.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",N,"Do not use.");const x=this._nextHandle(),X={comments:D.comments,brackets:D.brackets,wordPattern:D.wordPattern?ge._serializeRegExp(D.wordPattern):void 0,indentationRules:D.indentationRules?ge._serializeIndentationRule(D.indentationRules):void 0,onEnterRules:D.onEnterRules?ge._serializeOnEnterRules(D.onEnterRules):void 0,__electricCharacterSupport:D.__electricCharacterSupport,__characterPairSupport:D.__characterPairSupport};return this._proxy.$setLanguageConfiguration(x,F,X),this._createDisposable(x)}$setWordDefinitions(N){for(const F of N)this._documents.setWordDefinitionFor(F.languageId,new RegExp(F.regexSource,F.regexFlags))}}e.ExtHostLanguageFeatures=ge,ge._handlePool=0}),define(Ee[192],be([1,0,4,8,7,34,13,6]),function(Y,e,o,I,w,B,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class C{constructor(M,v,c,g){this._documents=v,this._commands=c,this._uriTransformer=g,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=M.getProxy(o.MainContext.MainThreadLanguages)}$acceptLanguageIds(M){this._languageIds=M}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(M,v){await this._proxy.$changeLanguage(M,v);const c=this._documents.getDocumentData(M);if(!c)throw new Error(`document '${M.toString()}' NOT found`);return c.document}async tokenAtPosition(M,v){const c=M.version,g=I.Position.from(v),r=await this._proxy.$tokensAtPosition(M.uri,g),n={type:w.StandardTokenType.Other,range:M.getWordRangeAtPosition(v)??new w.Range(v.line,v.character,v.line,v.character)};if(!r)return n;const m={range:I.Range.to(r.range),type:I.TokenType.to(r.type)};return!m.range.contains(v)||c!==M.version?n:m}createLanguageStatusItem(M,v,c){const g=this._handlePool++,r=this._proxy,n=this._ids,m=`${M.identifier.value}/${v}`;if(n.has(m))throw new Error(`LanguageStatusItem with id '${v}' ALREADY exists`);n.add(m);const y={selector:c,id:v,name:M.displayName??M.name,severity:w.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let k,d=new A.DisposableStore;const f=()=>{k?.dispose(),k=(0,S.disposableTimeout)(()=>{d.clear(),this._proxy.$setLanguageStatus(g,{id:m,name:y.name??M.displayName??M.name,source:M.displayName??M.name,selector:I.DocumentSelector.from(y.selector,this._uriTransformer),label:y.text,detail:y.detail??"",severity:y.severity===w.LanguageStatusSeverity.Error?B.default.Error:y.severity===w.LanguageStatusSeverity.Warning?B.default.Warning:B.default.Info,command:y.command&&this._commands.toInternal(y.command,d),accessibilityInfo:y.accessibilityInformation,busy:y.busy})},0)},b={dispose(){d.dispose(),k?.dispose(),r.$removeLanguageStatus(g),n.delete(m)},get id(){return y.id},get name(){return y.name},set name(l){y.name=l,f()},get selector(){return y.selector},set selector(l){y.selector=l,f()},get text(){return y.text},set text(l){y.text=l,f()},get detail(){return y.detail},set detail(l){y.detail=l,f()},get severity(){return y.severity},set severity(l){y.severity=l,f()},get accessibilityInformation(){return y.accessibilityInformation},set accessibilityInformation(l){y.accessibilityInformation=l,f()},get command(){return y.command},set command(l){y.command=l,f()},get busy(){return y.busy},set busy(l){y.busy=l,f()}};return f(),b}}e.ExtHostLanguages=C}),define(Ee[193],be([1,0,12,4,27,14,5]),function(Y,e,o,I,w,B,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let A=class extends o.AbstractLoggerService{constructor(M,v){const c=new S.Emitter;super(v.logLevel,c.event);this._proxy=M.getProxy(I.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(c)}$setLevel(M){this._onDidChangeLogLevel.fire(M)}doCreateLogger(M,v,c){return new C(this._proxy,M,v,c)}};A=Fe([Ne(0,B.IExtHostRpcService),Ne(1,w.IExtHostInitDataService)],A),e.ExtHostLoggerService=A;class C extends o.AbstractMessageLogger{constructor(M,v,c,g){super(g?.always);this.proxy=M,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(c),this.proxy.$createLogger(v,g).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(M,v){const c=[[M,v]];this.isLoggerCreated?this.doLog(c):this.buffer.push(...c)}doLog(M){this.proxy.$log(this.file,M)}}}),define(Ee[194],be([1,0,4,12,28]),function(Y,e,o,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function B(A){return A&&A.title}let S=class{constructor(C,L){this._logService=L,this._proxy=C.getProxy(o.MainContext.MainThreadMessageService)}showMessage(C,L,M,v,c){const g={source:{identifier:C.identifier,label:C.displayName||C.name}};let r;typeof v=="string"||B(v)?r=[v,...c]:(g.modal=v?.modal,g.useCustom=v?.useCustom,g.detail=v?.detail,r=c),g.useCustom&&(0,w.checkProposedApiEnabled)(C,"resolvers");const n=[];for(let m=0;m<r.length;m++){const y=r[m];if(typeof y=="string")n.push({title:y,handle:m,isCloseAffordance:!1});else if(typeof y=="object"){let{title:k,isCloseAffordance:d}=y;n.push({title:k,isCloseAffordance:!!d,handle:m})}else this._logService.warn("Invalid message item:",y)}return this._proxy.$showMessage(L,M,g,n).then(m=>{if(typeof m=="number")return r[m]})}};S=Fe([Ne(1,I.ILogService)],S),e.ExtHostMessageService=S}),define(Ee[195],be([1,0,21,5,93,6,22,10,11,2,58,4,8,7,38,169,89]),function(Y,e,o,I,w,B,S,A,C,L,M,v,c,g,r,n,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class y{constructor(d,f,b,l,P){this._textDocumentsAndEditors=b,this._textDocuments=l,this._extensionStoragePaths=P,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new S.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new I.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new I.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new I.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new I.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new I.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new I.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new I.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new M.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=d.getProxy(v.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=d.getProxy(v.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=d.getProxy(v.MainContext.MainThreadNotebookEditors),this._commandsConverter=f.converter,f.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===12){const i=u.notebookEditor?.notebookUri,s=u.cell.handle,a=this._documents.get(i)?.getCell(s);if(a)return a.apiCell}return u}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(d=>d.apiEditor)}getEditorById(d){const f=this._editors.get(d);if(!f)throw new Error(`unknown text editor: ${d}. known editors: ${[...this._editors.keys()]} `);return f}getIdByEditor(d){for(const[f,b]of this._editors)if(b.apiEditor===d)return f}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(d,f){const b=this._documents.get(d);if(!b&&!f)throw new Error(`NO notebook document for '${d}'`);return b}_getProviderData(d){const f=this._notebookContentProviders.get(d);if(!f)throw new Error(`NO provider for '${d}'`);return f}registerNotebookContentProvider(d,f,b,l,P){if((0,A.isFalsyOrWhitespace)(f))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(f))throw new Error(`Notebook provider for '${f}' already registered`);this._notebookContentProviders.set(f,{extension:d,provider:b});let u;return b.onDidChangeNotebookContentOptions&&(u=b.onDidChangeNotebookContentOptions(()=>{const i=c.NotebookDocumentContentOptions.from(b.options);this._notebookProxy.$updateNotebookProviderOptions(f,i)})),this._notebookProxy.$registerNotebookProvider({id:d.identifier,location:d.extensionLocation},f,c.NotebookDocumentContentOptions.from(l),y._convertNotebookRegistrationData(d,P)),new g.Disposable(()=>{u?.dispose(),this._notebookContentProviders.delete(f),this._notebookProxy.$unregisterNotebookProvider(f)})}static _convertNotebookRegistrationData(d,f){if(!f)return;const b=f.filenamePattern.map(l=>c.NotebookExclusiveDocumentPattern.from(l)).filter(l=>l!==void 0);if(f.filenamePattern&&!b){console.warn(`Notebook content provider view options file name pattern is invalid ${f.filenamePattern}`);return}return{extension:d.identifier,providerDisplayName:d.displayName||d.name,displayName:f.displayName,filenamePattern:b,exclusive:f.exclusive||!1}}registerNotebookCellStatusBarItemProvider(d,f,b){const l=y._notebookStatusBarItemProviderHandlePool++,P=typeof b.onDidChangeCellStatusBarItems=="function"?y._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(l,b),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(l,P,f);let u;return P!==void 0&&(u=b.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(P))),new g.Disposable(()=>{this._notebookStatusBarItemProviders.delete(l),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(l,P),u&&u.dispose()})}async createNotebookDocument(d){const f=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:d.viewType,content:d.content&&c.NotebookData.from(d.content)});return L.URI.revive(f)}async openNotebookDocument(d){const f=this._documents.get(d);if(f)return f.apiNotebook;const b=await this._notebookDocumentsProxy.$tryOpenNotebook(d),l=this._documents.get(L.URI.revive(b));return(0,C.assertIsDefined)(l?.apiNotebook)}async showNotebookDocument(d,f){L.URI.isUri(d)&&(d=await this.openNotebookDocument(d));let b;typeof f=="object"?b={position:c.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus,selections:f.selections&&f.selections.map(c.NotebookRange.from),pinned:typeof f.preview=="boolean"?!f.preview:void 0}:b={preserveFocus:!1};const l=await this._notebookEditorsProxy.$tryShowNotebookDocument(d.uri,d.notebookType,b),P=l&&this._editors.get(l)?.apiEditor;if(P)return P;throw l?new Error(`Could NOT open editor for "${d.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${d.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(d,f,b,l){const P=this._notebookStatusBarItemProviders.get(d),u=L.URI.revive(f),i=this._documents.get(u);if(!i||!P)return;const s=i.getCellFromIndex(b);if(!s)return;const t=await P.provideCellStatusBarItems(s.apiCell,l);if(!t)return;const a=new B.DisposableStore,p=this._statusBarCache.add([a]),_=(Array.isArray(t)?t:[t]).map(T=>c.NotebookStatusBarItem.from(T,this._commandsConverter,a));return{cacheId:p,items:_}}$releaseNotebookCellStatusBarItems(d){this._statusBarCache.delete(d)}registerNotebookSerializer(d,f,b,l,P){if((0,A.isFalsyOrWhitespace)(f))throw new Error("viewType cannot be empty or just whitespace");const u=this._handlePool++;return this._notebookSerializer.set(u,b),this._notebookProxy.$registerNotebookSerializer(u,{id:d.identifier,location:d.extensionLocation},f,c.NotebookDocumentContentOptions.from(l),y._convertNotebookRegistrationData(d,P)),(0,B.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(u)})}async $dataToNotebook(d,f,b){const l=this._notebookSerializer.get(d);if(!l)throw new Error("NO serializer found");const P=await l.deserializeNotebook(f.buffer,b);return new r.SerializableObjectWithBuffers(c.NotebookData.from(P))}async $notebookToData(d,f,b){const l=this._notebookSerializer.get(d);if(!l)throw new Error("NO serializer found");const P=await l.serializeNotebook(c.NotebookData.to(f.value),b);return o.VSBuffer.wrap(P)}async $openNotebook(d,f,b,l,P){const{provider:u}=this._getProviderData(d),i=await u.openNotebook(L.URI.revive(f),{backupId:b,untitledDocumentData:l?.buffer},P);return new r.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(c.NotebookCellData.from)})}async $saveNotebook(d,f,b){const l=this.getNotebookDocument(L.URI.revive(f)),{provider:P}=this._getProviderData(d);return await P.saveNotebook(l.apiNotebook,b),!0}async $saveNotebookAs(d,f,b,l){const P=this.getNotebookDocument(L.URI.revive(f)),{provider:u}=this._getProviderData(d);return await u.saveNotebookAs(L.URI.revive(b),P.apiNotebook,l),!0}async $backupNotebook(d,f,b){const l=this.getNotebookDocument(L.URI.revive(f)),P=this._getProviderData(d),u=this._extensionStoragePaths.workspaceValue(P.extension)??this._extensionStoragePaths.globalValue(P.extension),i=String((0,w.hash)([l.uri.toString(),this._backupIdPool++])),s=L.URI.joinPath(u,i),t=await P.provider.backupNotebook(l.apiNotebook,{destination:s},b);return l.updateBackup(t),t.id}_createExtHostEditor(d,f,b){if(this._editors.has(f))throw new Error(`editor with id ALREADY EXSIST: ${f}`);const l=new m.ExtHostNotebookEditor(f,this._notebookEditorsProxy,d,b.visibleRanges.map(c.NotebookRange.to),b.selections.map(c.NotebookRange.to),typeof b.viewColumn=="number"?c.ViewColumn.to(b.viewColumn):void 0);this._editors.set(f,l)}$acceptDocumentAndEditorsDelta(d){if(d.value.removedDocuments)for(const b of d.value.removedDocuments){const l=L.URI.revive(b),P=this._documents.get(l);P&&(P.dispose(),this._documents.delete(l),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:P.apiNotebook.getCells().map(u=>u.document.uri)}),this._onDidCloseNotebookDocument.fire(P.apiNotebook));for(const u of this._editors.values())u.notebookData.uri.toString()===l.toString()&&this._editors.delete(u.id)}if(d.value.addedDocuments){const b=[];for(const l of d.value.addedDocuments){const P=L.URI.revive(l.uri);if(this._documents.has(P))throw new Error(`adding EXISTING notebook ${P} `);const u=this,i=new n.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(s){u._onDidChangeNotebookCells.fire(s)},emitCellOutputsChange(s){u._onDidChangeCellOutputs.fire(s)},emitCellMetadataChange(s){u._onDidChangeCellMetadata.fire(s)}},P,l);b.push(...l.cells.map(s=>n.ExtHostCell.asModelAddData(i.apiNotebook,s))),this._documents.get(P)?.dispose(),this._documents.set(P,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:b}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(d.value.addedEditors)for(const b of d.value.addedEditors){if(this._editors.has(b.id))return;const l=L.URI.revive(b.documentUri),P=this._documents.get(l);P&&this._createExtHostEditor(P,b.id,b)}const f=[];if(d.value.removedEditors)for(const b of d.value.removedEditors){const l=this._editors.get(b);l&&(this._editors.delete(b),this._activeNotebookEditor?.id===l.id&&(this._activeNotebookEditor=void 0),f.push(l))}if(d.value.visibleEditors){this._visibleNotebookEditors=d.value.visibleEditors.map(l=>this._editors.get(l)).filter(l=>!!l);const b=new Set;this._visibleNotebookEditors.forEach(l=>b.add(l.id));for(const l of this._editors.values()){const P=b.has(l.id);l._acceptVisibility(P)}this._visibleNotebookEditors=[...this._editors.values()].map(l=>l).filter(l=>l.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}d.value.newActiveEditor===null?this._activeNotebookEditor=void 0:d.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(d.value.newActiveEditor)),d.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=y,y._notebookStatusBarItemProviderHandlePool=0}),define(Ee[196],be([1,0,5,53,12,4,14,8]),function(Y,e,o,I,w,B,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class C{constructor(v,c){const g=C._Keys.nextId();v.$registerNotebookEditorDecorationType(g,A.NotebookDecorationRenderOptions.from(c)),this.value={key:g,dispose(){v.$removeNotebookEditorDecorationType(g)}}}}C._Keys=new I.IdGenerator("NotebookEditorDecorationType");let L=class{constructor(v,c,g){this._logService=v,this._extHostRpc=c,this._notebooksAndEditors=g,this._onDidChangeNotebookEditorSelection=new o.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new o.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(v){return new C(this._extHostRpc.getProxy(B.MainContext.MainThreadNotebookEditors),v).value}$acceptEditorPropertiesChanged(v,c){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",v,c);const g=this._notebooksAndEditors.getEditorById(v);c.visibleRanges&&g._acceptVisibleRanges(c.visibleRanges.ranges.map(A.NotebookRange.to)),c.selections&&g._acceptSelections(c.selections.selections.map(A.NotebookRange.to)),c.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:g.apiEditor,visibleRanges:g.apiEditor.visibleRanges}),c.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:g.apiEditor,selections:g.apiEditor.selections}))}$acceptEditorViewColumns(v){for(const c in v)this._notebooksAndEditors.getEditorById(c)._acceptViewColumn(A.ViewColumn.to(v[c]))}};L=Fe([Ne(0,w.ILogService),Ne(1,S.IExtHostRpcService)],L),e.ExtHostNotebookEditors=L}),define(Ee[197],be([1,0,16,13,20,5,6,22,2,25,12,4,39,8,7,61,162,28,38]),function(Y,e,o,I,w,B,S,A,C,L,M,v,c,g,r,n,m,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let d=class{constructor(i,s,t,a,p){this._initData=s,this._extHostNotebook=t,this._commands=a,this._logService=p,this._activeExecutions=new A.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new B.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=i.getProxy(v.MainContext.MainThreadNotebookKernels);const h=new c.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new c.ApiCommandArgument("options","Select kernel options",_=>!0,_=>{if(_&&"notebookEditor"in _&&"id"in _){const T=this._extHostNotebook.getIdByEditor(_.notebookEditor);return{id:_.id,extension:_.extension,notebookEditorId:T}}else if(_&&"notebookEditor"in _){const T=this._extHostNotebook.getIdByEditor(_.notebookEditor);if(T===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${_.notebookEditor.document.uri.toString()}`);return{notebookEditorId:T}}return _})],c.ApiCommandResult.Void);this._commands.registerApiCommand(h)}createNotebookController(i,s,t,a,p,h){for(const ce of this._kernelData.values())if(ce.controller.id===s&&L.ExtensionIdentifier.equals(i.identifier,ce.extensionId))throw new Error(`notebook controller with id '${s}' ALREADY exist`);const _=this._handlePool++,T=this;this._logService.trace(`NotebookController[${_}], CREATED by ${i.identifier.value}, ${s}`);const R=()=>console.warn(`NO execute handler from notebook controller '${$.id}' of extension: '${i.identifier}'`);let W=!1;const E=new S.DisposableStore,H=new B.Emitter,q=new B.Emitter,$={id:P(i,s),notebookType:t,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:a||i.identifier.value,preloads:h?h.map(g.NotebookRendererScript.from):[]};let j=p??R,J;this._proxy.$addKernel(_,$).catch(ce=>{console.log(ce),W=!0});let z=0;const ie=()=>{if(W)return;const ce=++z;Promise.resolve().then(()=>{ce===z&&this._proxy.$updateKernel(_,$)})},ae=new A.ResourceMap,te={get id(){return s},get notebookType(){return $.notebookType},onDidChangeSelectedNotebooks:H.event,get label(){return $.label},set label(ce){$.label=ce??i.displayName??i.name,ie()},get detail(){return $.detail??""},set detail(ce){$.detail=ce,ie()},get description(){return $.description??""},set description(ce){$.description=ce,ie()},get kind(){return(0,y.checkProposedApiEnabled)(i,"notebookControllerKind"),$.kind??""},set kind(ce){(0,y.checkProposedApiEnabled)(i,"notebookControllerKind"),$.kind=ce,ie()},get supportedLanguages(){return $.supportedLanguages},set supportedLanguages(ce){$.supportedLanguages=ce,ie()},get supportsExecutionOrder(){return $.supportsExecutionOrder??!1},set supportsExecutionOrder(ce){$.supportsExecutionOrder=ce,ie()},get rendererScripts(){return $.preloads?$.preloads.map(g.NotebookRendererScript.to):[]},get executeHandler(){return j},set executeHandler(ce){j=ce??R},get interruptHandler(){return J},set interruptHandler(ce){J=ce,$.supportsInterrupt=Boolean(ce),ie()},createNotebookCellExecution(ce){if(W)throw new Error("notebook controller is DISPOSED");if(!ae.has(ce.notebook.uri))throw T._logService.trace(`NotebookController[${_}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ae.keys()).map(de=>de.toString())),new Error(`notebook controller is NOT associated to notebook: ${ce.notebook.uri.toString()}`);return T._createNotebookCellExecution(ce,P(i,this.id))},dispose:()=>{W||(this._logService.trace(`NotebookController[${_}], DISPOSED`),W=!0,this._kernelData.delete(_),E.dispose(),H.dispose(),q.dispose(),this._proxy.$removeKernel(_))},updateNotebookAffinity(ce,de){T._proxy.$updateNotebookPriority(_,ce.uri,de)},onDidReceiveMessage:q.event,postMessage(ce,de){return(0,y.checkProposedApiEnabled)(i,"notebookMessaging"),T._proxy.$postMessage(_,de&&T._extHostNotebook.getIdByEditor(de),ce)},asWebviewUri(ce){return(0,y.checkProposedApiEnabled)(i,"notebookMessaging"),(0,n.asWebviewUri)(ce,T._initData.remote)}};return this._kernelData.set(_,{extensionId:i.identifier,controller:te,onDidReceiveMessage:q,onDidChangeSelection:H,associatedNotebooks:ae}),te}$acceptNotebookAssociation(i,s,t){const a=this._kernelData.get(i);if(a){const p=this._extHostNotebook.getNotebookDocument(C.URI.revive(s));t?a.associatedNotebooks.set(p.uri,!0):a.associatedNotebooks.delete(p.uri),this._logService.trace(`NotebookController[${i}] ASSOCIATE notebook`,p.uri.toString(),t),a.onDidChangeSelection.fire({selected:t,notebook:p.apiNotebook})}}async $executeCells(i,s,t){const a=this._kernelData.get(i);if(!a)return;const p=this._extHostNotebook.getNotebookDocument(C.URI.revive(s)),h=[];for(const _ of t){const T=p.getCell(_);T&&h.push(T.apiCell)}try{this._logService.trace(`NotebookController[${i}] EXECUTE cells`,p.uri.toString(),h.length),await a.controller.executeHandler.call(a.controller,h,p.apiNotebook,a.controller)}catch(_){this._logService.error(`NotebookController[${i}] execute cells FAILED`,_),console.error(_)}}async $cancelCells(i,s,t){const a=this._kernelData.get(i);if(!a)return;const p=this._extHostNotebook.getNotebookDocument(C.URI.revive(s));if(a.controller.interruptHandler)await a.controller.interruptHandler.call(a.controller,p.apiNotebook);else for(const h of t){const _=p.getCell(h);_&&this._activeExecutions.get(_.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,s,t){const a=this._kernelData.get(i);if(!a)return;const p=this._extHostNotebook.getEditorById(s);a.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:t}))}$cellExecutionChanged(i,s,t){const p=this._extHostNotebook.getNotebookDocument(C.URI.revive(i)).getCell(s);p&&this._onDidChangeCellExecutionState.fire({cell:p.apiCell,state:t?g.NotebookCellExecutionState.to(t):r.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(i,s){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const a=this._extHostNotebook.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!a)throw new Error("invalid cell");if(this._activeExecutions.has(a.uri))throw new Error(`duplicate execution for ${a.uri}`);const p=new b(s,a,this._proxy);this._activeExecutions.set(a.uri,p);const h=p.onDidChangeState(()=>{p.state===f.Resolved&&(p.dispose(),h.dispose(),this._activeExecutions.delete(a.uri))});return p.asApiObject()}};d=Fe([Ne(4,M.ILogService)],d),e.ExtHostNotebookKernels=d;var f;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(f||(f={}));class b extends S.Disposable{constructor(i,s,t){super();this._cell=s,this._proxy=t,this._handle=b.HANDLE++,this._onDidChangeState=new B.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=f.Init,this._tokenSource=this._register(new w.CancellationTokenSource),this._collector=new l(10,a=>this.update(a)),this._executionOrder=s.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,i,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(i){await this._collector.addItem(i)}async update(i){const s=Array.isArray(i)?i:[i];return this._proxy.$updateExecution(this._handle,new k.SerializableObjectWithBuffers(s))}verifyStateForOutput(){if(this._state===f.Init)throw new Error("Must call start before modifying cell output");if(this._state===f.Resolved)throw new Error("Cannot modify cell output after calling resolve")}validateAndConvertOutputs(i){return i.map(s=>{const t=r.NotebookCellOutput.ensureUniqueMimeTypes(s.items,!0);return t===s.items?g.NotebookCellOutput.from(s):g.NotebookCellOutput.from({items:t,id:s.id,metadata:s.metadata})})}async updateOutputs(i,s,t){const a=this.validateAndConvertOutputs((0,o.asArray)(i));return this.updateSoon({editType:m.CellExecutionUpdateType.Output,append:t,outputs:a})}async updateOutputItems(i,s,t){return i=r.NotebookCellOutput.ensureUniqueMimeTypes((0,o.asArray)(i),!0),this.updateSoon({editType:m.CellExecutionUpdateType.OutputItems,items:i.map(g.NotebookCellOutputItem.from),outputId:s.id,append:t})}asApiObject(){const i=this;return Object.freeze({get token(){return i._tokenSource.token},get cell(){return i._cell.apiCell},get executionOrder(){return i._executionOrder},set executionOrder(t){i._executionOrder=t,i.update([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:i._executionOrder}])},start(t){if(i._state===f.Resolved||i._state===f.Started)throw new Error("Cannot call start again");i._state=f.Started,i._onDidChangeState.fire(),i.update({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:t})},end(t,a){if(i._state===f.Resolved)throw new Error("Cannot call resolve twice");i._state=f.Resolved,i._onDidChangeState.fire(),i._collector.flush(),i._proxy.$completeExecution(i._handle,new k.SerializableObjectWithBuffers({runEndTime:a,lastRunSuccess:t}))},clearOutput(t){return i.verifyStateForOutput(),i.updateOutputs([],t,!1)},appendOutput(t,a){return i.verifyStateForOutput(),i.updateOutputs(t,a,!0)},replaceOutput(t,a){return i.verifyStateForOutput(),i.updateOutputs(t,a,!1)},appendOutputItems(t,a){return i.verifyStateForOutput(),i.updateOutputItems(t,a,!0)},replaceOutputItems(t,a){return i.verifyStateForOutput(),i.updateOutputItems(t,a,!1)}})}}b.HANDLE=0;class l{constructor(i,s){this.delay=i,this.callback=s,this.batch=[],this.startedTimer=Date.now()}addItem(i){return this.batch.push(i),this.currentDeferred||(this.currentDeferred=new I.DeferredPromise,this.startedTimer=Date.now(),(0,I.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const i=this.currentDeferred;this.currentDeferred=void 0;const s=this.batch;return this.batch=[],this.callback(s).finally(()=>i.complete())}}function P(u,i){return`${u.identifier.value}/${i}`}}),define(Ee[198],be([1,0,5,4,89,28]),function(Y,e,o,I,w,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class S{constructor(C,L){this._extHostNotebook=L,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(I.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,L,M){const v=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(L)?.fire({editor:v.apiEditor,message:M})}createRendererMessaging(C,L){if(!C.contributes?.notebookRenderer?.some(g=>g.id===L))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${L})`);const M=(0,B.isProposedApiEnabled)(C,"notebookEditor"),v=new WeakMap;return{onDidReceiveMessage:(g,r,n)=>{const m=M?g:y=>{const k={};v.set(k,y.editor),g({editor:k,message:y.message})};return this.getOrCreateEmitterFor(L).event(m,r,n)},postMessage:(g,r)=>{w.ExtHostNotebookEditor.apiEditorsToExtHost.has(g)&&([g,r]=[r,g]);const n=M?r:v.get(r),m=n&&w.ExtHostNotebookEditor.apiEditorsToExtHost.get(n);return this.proxy.$postMessage(m?.id,L,g)}}}getOrCreateEmitterFor(C){let L=this._rendererMessageEmitters.get(C);return L||(L=new o.Emitter({onLastListenerRemove:()=>{L?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,L),L)}}e.ExtHostNotebookRenderers=S}),define(Ee[94],be([1,0,4,6,3,14,12,163,50,27,30,112,21,11]),function(Y,e,o,I,w,B,S,A,C,L,M,v,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class r extends I.Disposable{constructor(y,k,d,f){super();this.id=y,this.name=k,this.logger=d,this.proxy=f,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(y){this.append(y+`
`)}append(y){this.write(y),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Append))}clear(){const y=this.offset;this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Clear,y)}replace(y){const k=this.offset;this.write(y),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Replace,k),this.visible&&this.logger.flush()}show(y,k){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof y=="boolean"?y:k))}hide(){this.proxy.$close(this.id)}write(y){this.offset+=c.VSBuffer.fromString(y).byteLength,this.logger.info(y)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=r;let n=class{constructor(y,k,d,f,b){this.extHostFileSystem=d,this.extHostFileSystemInfo=f,this.loggerService=b,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=y.getProxy(o.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(k.logsLocation,`output_logging_${(0,v.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(y){this.visibleChannelId=y;for(const[k,d]of this.channels)d.visible=k===this.visibleChannelId}createOutputChannel(y,k,d){if(y=y.trim(),!y)throw new Error("illegal argument `name`. must not be falsy");if((0,g.isString)(k)&&!k.trim())throw new Error("illegal argument `languageId`. must not be empty");const f=this.doCreateOutputChannel(y,k,d);return f.then(b=>{this.channels.set(b.id,b),b.visible=b.id===this.visibleChannelId}),this.createExtHostOutputChannel(y,f)}async doCreateOutputChannel(y,k,d){const f=await this.createOutputDirectory(),b=this.extHostFileSystemInfo.extUri.joinPath(f,`${this.namePool++}-${y.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),l=this.loggerService.createLogger(b,{always:!0,donotRotate:!0,donotUseFormatters:!0}),P=await this.proxy.$register(y,!1,b,k,d.identifier.value);return new r(P,y,l,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(y,k){let d=!1;const f=()=>{if(d)throw new Error("Channel has been closed")};return{get name(){return y},append(b){f(),k.then(l=>l.append(b))},appendLine(b){f(),k.then(l=>l.appendLine(b))},clear(){f(),k.then(b=>b.clear())},replace(b){f(),k.then(l=>l.replace(b))},show(b,l){f(),k.then(P=>P.show(b,l))},hide(){f(),k.then(b=>b.hide())},dispose(){d=!0,k.then(b=>b.dispose())}}}};n=Fe([Ne(0,B.IExtHostRpcService),Ne(1,L.IExtHostInitDataService),Ne(2,C.IExtHostConsumerFileSystem),Ne(3,M.IExtHostFileSystemInfo),Ne(4,S.ILoggerService)],n),e.ExtHostOutputService=n,e.IExtHostOutputService=(0,w.createDecorator)("IExtHostOutputService")}),define(Ee[199],be([1,0,13,20,5,6,4,2,7,15,16,34,57]),function(Y,e,o,I,w,B,S,A,C,L,M,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function g(r,n,m){const y=r.getProxy(S.MainContext.MainThreadQuickOpen);class k{constructor(t,a){this._sessions=new Map,this._instances=0,this._workspace=t,this._commands=a}showQuickPick(t,a,p=I.CancellationToken.None){this._onDidSelectItem=void 0;const h=Promise.resolve(t),_=++this._instances,T=y.$show(_,{title:a?.title,placeHolder:a?.placeHolder,matchOnDescription:a?.matchOnDescription,matchOnDetail:a?.matchOnDetail,ignoreFocusLost:a?.ignoreFocusOut,canPickMany:a?.canPickMany},p),R={},W=T.then(()=>R);return Promise.race([W,h]).then(E=>{if(E!==R)return h.then(H=>{const q=[];for(let $=0;$<H.length;$++){const j=H[$];typeof j=="string"?q.push({label:j,handle:$}):j.kind===C.QuickPickItemKind.Separator?q.push({type:"separator",label:j.label}):q.push({label:j.label,description:j.description,detail:j.detail,picked:j.picked,alwaysShow:j.alwaysShow,handle:$})}return a&&typeof a.onDidSelectItem=="function"&&(this._onDidSelectItem=$=>{a.onDidSelectItem(H[$])}),y.$setItems(_,q),T.then($=>{if(typeof $=="number")return H[$];if(Array.isArray($))return $.map(j=>H[j])})})}).then(void 0,E=>{if(!(0,L.isCancellationError)(E))return y.$setError(_,E),Promise.reject(E)})}$onItemSelected(t){this._onDidSelectItem&&this._onDidSelectItem(t)}showInput(t,a=I.CancellationToken.None){return this._validateInput=t?t.validateInput:void 0,y.$input(t,typeof this._validateInput=="function",a).then(void 0,p=>{if(!(0,L.isCancellationError)(p))return Promise.reject(p)})}$validateInput(t){return this._validateInput?(0,o.asPromise)(()=>this._validateInput(t)):Promise.resolve(void 0)}async showWorkspaceFolderPick(t,a=I.CancellationToken.None){const p=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[t]);if(!p)return;const h=await this._workspace.getWorkspaceFolders2();if(!!h)return h.find(_=>_.uri.toString()===p.uri.toString())}createQuickPick(t){const a=new u(t,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}createInputBox(t){const a=new i(t,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}$onDidChangeValue(t,a){const p=this._sessions.get(t);p&&p._fireDidChangeValue(a)}$onDidAccept(t){const a=this._sessions.get(t);a&&a._fireDidAccept()}$onDidChangeActive(t,a){const p=this._sessions.get(t);p instanceof u&&p._fireDidChangeActive(a)}$onDidChangeSelection(t,a){const p=this._sessions.get(t);p instanceof u&&p._fireDidChangeSelection(a)}$onDidTriggerButton(t,a){const p=this._sessions.get(t);p&&p._fireDidTriggerButton(a)}$onDidTriggerItemButton(t,a,p){const h=this._sessions.get(t);h instanceof u&&h._fireDidTriggerItemButton(a,p)}$onDidHide(t){const a=this._sessions.get(t);a&&a._fireDidHide()}}class d{constructor(t,a){this._extensionId=t,this._onDidDispose=a,this._id=u._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new w.Emitter,this._onDidChangeValueEmitter=new w.Emitter,this._onDidTriggerButtonEmitter=new w.Emitter,this._onDidHideEmitter=new w.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(t){this._title=t,this.update({title:t})}get step(){return this._steps}set step(t){this._steps=t,this.update({step:t})}get totalSteps(){return this._totalSteps}set totalSteps(t){this._totalSteps=t,this.update({totalSteps:t})}get enabled(){return this._enabled}set enabled(t){this._enabled=t,this.update({enabled:t})}get busy(){return this._busy}set busy(t){this._busy=t,this.update({busy:t})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(t){this._ignoreFocusOut=t,this.update({ignoreFocusOut:t})}get value(){return this._value}set value(t){this._value=t,this.update({value:t})}get placeholder(){return this._placeholder}set placeholder(t){this._placeholder=t,this.update({placeholder:t})}get buttons(){return this._buttons}set buttons(t){this._buttons=t.slice(),this._handlesToButtons.clear(),t.forEach((a,p)=>{const h=a===C.QuickInputButtons.Back?-1:p;this._handlesToButtons.set(h,a)}),this.update({buttons:t.map((a,p)=>({...P(a),tooltip:a.tooltip,handle:a===C.QuickInputButtons.Back?-1:p}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(t){this._value=t,this._onDidChangeValueEmitter.fire(t)}_fireDidTriggerButton(t){const a=this._handlesToButtons.get(t);a&&this._onDidTriggerButtonEmitter.fire(a)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,B.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),y.$dispose(this._id))}update(t){if(!this._disposed){for(const a of Object.keys(t)){const p=t[a];this._pendingUpdate[a]=p===void 0?null:p}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){y.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}d._nextId=1;function f(s){if(s instanceof C.ThemeIcon)return{id:s.id};const t=l(s),a=b(s);return{dark:typeof t=="string"?A.URI.file(t):t,light:typeof a=="string"?A.URI.file(a):a}}function b(s){return typeof s=="object"&&"light"in s?s.light:s}function l(s){return typeof s=="object"&&"dark"in s?s.dark:s}function P(s){const t=f(s.iconPath);let a,p;return"id"in t?p=c.ThemeIcon.asClassName(t):a=t,{iconPath:a,iconClass:p}}class u extends d{constructor(t,a){super(t.identifier,a);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new w.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new w.Emitter,this._onDidTriggerItemButtonEmitter=new w.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(t){this._items=t.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),t.forEach((p,h)=>{this._handlesToItems.set(h,p),this._itemsToHandles.set(p,h)});const a=[];for(let p=0;p<t.length;p++){const h=t[p];h.kind===C.QuickPickItemKind.Separator?a.push({type:"separator",label:h.label}):a.push({handle:p,label:h.label,description:h.description,detail:h.detail,picked:h.picked,alwaysShow:h.alwaysShow,buttons:h.buttons?.map((_,T)=>({...P(_),tooltip:_.tooltip,handle:T}))})}this.update({items:a})}get canSelectMany(){return this._canSelectMany}set canSelectMany(t){this._canSelectMany=t,this.update({canSelectMany:t})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(t){this._matchOnDescription=t,this.update({matchOnDescription:t})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(t){this._matchOnDetail=t,this.update({matchOnDetail:t})}get sortByLabel(){return this._sortByLabel}set sortByLabel(t){this._sortByLabel=t,this.update({sortByLabel:t})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(t){this._keepScrollPosition=t,this.update({keepScrollPosition:t})}get activeItems(){return this._activeItems}set activeItems(t){this._activeItems=t.filter(a=>this._itemsToHandles.has(a)),this.update({activeItems:this._activeItems.map(a=>this._itemsToHandles.get(a))})}get selectedItems(){return this._selectedItems}set selectedItems(t){this._selectedItems=t.filter(a=>this._itemsToHandles.has(a)),this.update({selectedItems:this._selectedItems.map(a=>this._itemsToHandles.get(a))})}_fireDidChangeActive(t){const a=(0,M.coalesce)(t.map(p=>this._handlesToItems.get(p)));this._activeItems=a,this._onDidChangeActiveEmitter.fire(a)}_fireDidChangeSelection(t){const a=(0,M.coalesce)(t.map(p=>this._handlesToItems.get(p)));this._selectedItems=a,this._onDidChangeSelectionEmitter.fire(a)}_fireDidTriggerItemButton(t,a){const p=this._handlesToItems.get(t);if(!p||!p.buttons||!p.buttons.length)return;const h=p.buttons[a];h&&this._onDidTriggerItemButtonEmitter.fire({button:h,item:p})}}class i extends d{constructor(t,a){super(t,a);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(t){this._password=t,this.update({password:t})}get prompt(){return this._prompt}set prompt(t){this._prompt=t,this.update({prompt:t})}get validationMessage(){return this._validationMessage}set validationMessage(t){this._validationMessage=t,this.update({validationMessage:t,severity:t?v.default.Error:v.default.Ignore})}}return new k(n,m)}e.createExtHostQuickOpen=g});var je=this&&this.__classPrivateFieldSet||function(Y,e,o,I,w){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!w:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?w.call(Y,o):w?w.value=o:e.set(Y,o),o},De=this&&this.__classPrivateFieldGet||function(Y,e,o,I){if(o==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?I:o==="a"?I.call(Y):I?I.value:e.get(Y)};define(Ee[200],be([1,0,2,5,52,6,13,4,16,107,12,25,57,8,28]),function(Y,e,o,I,w,B,S,A,C,L,M,v,c,g,r){"use strict";var n,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function y(p){if(p)return typeof p.iconPath=="string"?o.URI.file(p.iconPath):o.URI.isUri(p.iconPath)||c.ThemeIcon.isThemeIcon(p.iconPath)?p.iconPath:void 0}function k(p,h){if(!p.iconPath&&!h.iconPath)return 0;if(p.iconPath){if(!h.iconPath)return 1}else return-1;const _=typeof p.iconPath=="string"?p.iconPath:o.URI.isUri(p.iconPath)?p.iconPath.fsPath:p.iconPath.id,T=typeof h.iconPath=="string"?h.iconPath:o.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,L.comparePaths)(_,T)}function d(p,h){let _=0;if(p.strikeThrough!==h.strikeThrough)return p.strikeThrough?1:-1;if(p.faded!==h.faded)return p.faded?1:-1;if(p.tooltip!==h.tooltip)return(p.tooltip||"").localeCompare(h.tooltip||"");if(_=k(p,h),_!==0)return _;if(p.light&&h.light)_=k(p.light,h.light);else{if(p.light)return 1;if(h.light)return-1}if(_!==0)return _;if(p.dark&&h.dark)_=k(p.dark,h.dark);else{if(p.dark)return 1;if(h.dark)return-1}return _}function f(p,h){if(p.command!==h.command)return p.command<h.command?-1:1;if(p.title!==h.title)return p.title<h.title?-1:1;if(p.tooltip!==h.tooltip){if(p.tooltip!==void 0&&h.tooltip!==void 0)return p.tooltip<h.tooltip?-1:1;if(p.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(p.arguments===h.arguments)return 0;if(p.arguments)if(h.arguments){if(p.arguments.length!==h.arguments.length)return p.arguments.length-h.arguments.length}else return 1;else return-1;for(let _=0;_<p.arguments.length;_++){const T=p.arguments[_],R=h.arguments[_];if(T!==R)return T<R?-1:1}return 0}function b(p,h){let _=(0,L.comparePaths)(p.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(_!==0)return _;if(p.command&&h.command)_=f(p.command,h.command);else{if(p.command)return 1;if(h.command)return-1}if(_!==0)return _;if(p.decorations&&h.decorations)_=d(p.decorations,h.decorations);else{if(p.decorations)return 1;if(h.decorations)return-1}return _}function l(p,h){for(let _=0;_<p.length;_++)if(p[_]!==h[_])return!1;return!0}function P(p,h){return p.command===h.command&&p.title===h.title&&p.tooltip===h.tooltip&&(p.arguments&&h.arguments?l(p.arguments,h.arguments):p.arguments===h.arguments)}function u(p,h){return(0,C.equals)(p,h,P)}class i{constructor(h,_,T){this._extension=h,this._sourceControlHandle=T,n.set(this,void 0),this._value="",this._onDidChange=new I.Emitter,this._placeholder="",this._visible=!0,je(this,n,_,"f")}get value(){return this._value}set value(h){h=h??"",De(this,n,"f").$setInputBoxValue(this._sourceControlHandle,h),this.updateValue(h)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(h){De(this,n,"f").$setInputBoxPlaceholder(this._sourceControlHandle,h),this._placeholder=h}get validateInput(){return(0,r.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(h){if((0,r.checkProposedApiEnabled)(this._extension,"scmValidation"),h&&typeof h!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=h,De(this,n,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!h)}get visible(){return this._visible}set visible(h){h=!!h,this._visible!==h&&(this._visible=h,De(this,n,"f").$setInputBoxVisibility(this._sourceControlHandle,h))}showValidationMessage(h,_){(0,r.checkProposedApiEnabled)(this._extension,"scmValidation"),De(this,n,"f").$showValidationMessage(this._sourceControlHandle,h,_)}$onInputBoxValueChange(h){this.updateValue(h)}updateValue(h){this._value=h,this._onDidChange.fire(h)}}e.ExtHostSCMInputBox=i,n=new WeakMap;class s{constructor(h,_,T,R,W){this._proxy=h,this._commands=_,this._sourceControlHandle=T,this._id=R,this._label=W,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new I.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new I.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=s._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(h){this._label=h,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,h)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(h){this._hideWhenEmpty=h,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(h){this._resourceStates=[...h],this._onDidUpdateResourceStates.fire()}getResourceState(h){return this._resourceStatesMap.get(h)}$executeResourceCommand(h,_){const T=this._resourceStatesCommandsMap.get(h);return T?(0,S.asPromise)(()=>this._commands.executeCommand(T.command,...T.arguments||[],_)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this._resourceStates].sort(b),T=(0,C.sortedDiff)(this._resourceSnapshot,h,b).map(E=>{const H=E.toInsert.map(q=>{const $=this._resourceHandlePool++;this._resourceStatesMap.set($,q);const j=q.resourceUri;let J;if(q.command)if(q.command.command==="vscode.open"||q.command.command==="vscode.diff"){const me=new B.DisposableStore;J=this._commands.converter.toInternal(q.command,me),this._resourceStatesDisposablesMap.set($,me)}else this._resourceStatesCommandsMap.set($,q.command);const z=y(q.decorations),ie=q.decorations&&y(q.decorations.light)||z,ae=q.decorations&&y(q.decorations.dark)||z,te=[ie,ae],ce=q.decorations&&q.decorations.tooltip||"",de=q.decorations&&!!q.decorations.strikeThrough,Se=q.decorations&&!!q.decorations.faded,fe=q.contextValue||"";return{rawResource:[$,j,te,ce,de,Se,fe,J],handle:$}});return{start:E.start,deleteCount:E.deleteCount,toInsert:H}}),R=T.map(({start:E,deleteCount:H,toInsert:q})=>[E,H,q.map($=>$.rawResource)]),W=T.reverse();for(const{start:E,deleteCount:H,toInsert:q}of W){const $=q.map(J=>J.handle),j=this._handlesSnapshot.splice(E,H,...$);for(const J of j)this._resourceStatesMap.delete(J),this._resourceStatesCommandsMap.delete(J),this._resourceStatesDisposablesMap.get(J)?.dispose(),this._resourceStatesDisposablesMap.delete(J)}return this._resourceSnapshot=h,R}dispose(){this._disposed=!0,this._onDidDispose.fire()}}s._handlePool=0;class t{constructor(h,_,T,R,W,E){this._extension=h,this._commands=T,this._id=R,this._label=W,this._rootUri=E,m.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new B.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new B.MutableDisposable,this._statusBarDisposables=new B.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new I.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,je(this,m,_,"f"),this._inputBox=new i(h,De(this,m,"f"),this.handle),De(this,m,"f").$registerSourceControl(this.handle,R,W,E)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(h){this._count!==h&&(this._count=h,De(this,m,"f").$updateSourceControl(this.handle,{count:h}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(h){this._quickDiffProvider=h,De(this,m,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!h})}get commitTemplate(){return this._commitTemplate}set commitTemplate(h){h!==this._commitTemplate&&(this._commitTemplate=h,De(this,m,"f").$updateSourceControl(this.handle,{commitTemplate:h}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(h){this._acceptInputDisposables.value=new B.DisposableStore,this._acceptInputCommand=h;const _=this._commands.converter.toInternal(h,this._acceptInputDisposables.value);De(this,m,"f").$updateSourceControl(this.handle,{acceptInputCommand:_})}get actionButton(){return(0,r.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(h){(0,r.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new B.DisposableStore,this._actionButton=h;const _=h!==void 0?{command:this._commands.converter.toInternal(h.command,this._actionButtonDisposables.value),description:h.description}:void 0;De(this,m,"f").$updateSourceControl(this.handle,{actionButton:_??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(h){if(this._statusBarCommands&&h&&u(this._statusBarCommands,h))return;this._statusBarDisposables.value=new B.DisposableStore,this._statusBarCommands=h;const _=(h||[]).map(T=>this._commands.converter.toInternal(T,this._statusBarDisposables.value));De(this,m,"f").$updateSourceControl(this.handle,{statusBarCommands:_})}get selected(){return this._selected}createResourceGroup(h,_){const T=new s(De(this,m,"f"),this._commands,this.handle,h,_),R=I.Event.once(T.onDidDispose)(()=>this.createdResourceGroups.delete(T));return this.createdResourceGroups.set(T,R),this.eventuallyAddResourceGroups(),T}eventuallyAddResourceGroups(){const h=[],_=[];for(const[T,R]of this.createdResourceGroups){R.dispose();const W=T.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(T),this.eventuallyUpdateResourceStates()});I.Event.once(T.onDidDispose)(()=>{this.updatedResourceGroups.delete(T),W.dispose(),this._groups.delete(T.handle),De(this,m,"f").$unregisterGroup(this.handle,T.handle)}),h.push([T.handle,T.id,T.label,T.features]);const E=T._takeResourceStateSnapshot();E.length>0&&_.push([T.handle,E]),this._groups.set(T.handle,T)}De(this,m,"f").$registerGroups(this.handle,h,_),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const h=[];this.updatedResourceGroups.forEach(_=>{const T=_._takeResourceStateSnapshot();T.length!==0&&h.push([_.handle,T])}),h.length>0&&De(this,m,"f").$spliceResourceStates(this.handle,h),this.updatedResourceGroups.clear()}getResourceGroup(h){return this._groups.get(h)}setSelectionState(h){this._selected=h,this._onDidChangeSelection.fire(h)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(h=>h.dispose()),De(this,m,"f").$unregisterSourceControl(this.handle)}}m=new WeakMap,t._handlePool=0,Fe([(0,w.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),Fe([(0,w.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let a=class Vi{constructor(h,_,T){this._commands=_,this.logService=T,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new I.Emitter,this._proxy=h.getProxy(A.MainContext.MainThreadSCM),this._telemetry=h.getProxy(A.MainContext.MainThreadTelemetry),_.registerArgumentProcessor({processArgument:R=>{if(R&&R.$mid===3){const W=this._sourceControls.get(R.sourceControlHandle);if(!W)return R;const E=W.getResourceGroup(R.groupHandle);return E?E.getResourceState(R.handle):R}else if(R&&R.$mid===4){const W=this._sourceControls.get(R.sourceControlHandle);return W?W.getResourceGroup(R.groupHandle):R}else if(R&&R.$mid===5){const W=this._sourceControls.get(R.handle);return W||R}return R}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(h,_,T,R){this.logService.trace("ExtHostSCM#createSourceControl",h.identifier.value,_,T,R),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const W=Vi._handlePool++,E=new t(h,this._proxy,this._commands,_,T,R);this._sourceControls.set(W,E);const H=this._sourceControlsByExtension.get(v.ExtensionIdentifier.toKey(h.identifier))||[];return H.push(E),this._sourceControlsByExtension.set(v.ExtensionIdentifier.toKey(h.identifier),H),E}getLastInputBox(h){this.logService.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const _=this._sourceControlsByExtension.get(v.ExtensionIdentifier.toKey(h.identifier)),T=_&&_[_.length-1];return T&&T.inputBox}$provideOriginalResource(h,_,T){const R=o.URI.revive(_);this.logService.trace("ExtHostSCM#$provideOriginalResource",h,R.toString());const W=this._sourceControls.get(h);return!W||!W.quickDiffProvider||!W.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,S.asPromise)(()=>W.quickDiffProvider.provideOriginalResource(R,T)).then(E=>E||null)}$onInputBoxValueChange(h,_){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",h);const T=this._sourceControls.get(h);return T&&T.inputBox.$onInputBoxValueChange(_),Promise.resolve(void 0)}$executeResourceCommand(h,_,T,R){this.logService.trace("ExtHostSCM#$executeResourceCommand",h,_,T);const W=this._sourceControls.get(h);if(!W)return Promise.resolve(void 0);const E=W.getResourceGroup(_);return E?E.$executeResourceCommand(T,R):Promise.resolve(void 0)}$validateInput(h,_,T){this.logService.trace("ExtHostSCM#$validateInput",h);const R=this._sourceControls.get(h);return!R||!R.inputBox.validateInput?Promise.resolve(void 0):(0,S.asPromise)(()=>R.inputBox.validateInput(_,T)).then(W=>{if(!W)return Promise.resolve(void 0);const E=g.MarkdownString.fromStrict(W.message);return E?Promise.resolve([E,W.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this._sourceControls.get(h)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=h,Promise.resolve(void 0)}};a._handlePool=0,a=Fe([Ne(2,M.ILogService)],a),e.ExtHostSCM=a});var je=this&&this.__classPrivateFieldSet||function(Y,e,o,I,w){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!w:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?w.call(Y,o):w?w.value=o:e.set(Y,o),o},De=this&&this.__classPrivateFieldGet||function(Y,e,o,I){if(o==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?I:o==="a"?I.call(Y):I?I.value:e.get(Y)};define(Ee[201],be([1,0,7,4,125,6,8,11]),function(Y,e,o,I,w,B,S,A){"use strict";var C,L;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class M{constructor(r,n,m,y,k=o.StatusBarAlignment.Left,d){C.set(this,void 0),L.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new B.DisposableStore,je(this,C,r,"f"),je(this,L,n,"f"),this._entryId=M.ID_GEN++,this._extension=m,this._id=y,this._alignment=k,this._priority=this.validatePriority(d)}validatePriority(r){if(!!(0,A.isNumber)(r))return r===Number.POSITIVE_INFINITY?Number.MAX_VALUE:r===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:r}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(r){this._text=r,this.update()}set name(r){this._name=r,this.update()}set tooltip(r){this._tooltip=r,this.update()}set color(r){this._color=r,this.update()}set backgroundColor(r){r&&!M.ALLOWED_BACKGROUND_COLORS.has(r.id)&&(r=void 0),this._backgroundColor=r,this.update()}set command(r){this._command?.fromApi!==r&&(this._internalCommandRegistration.clear(),typeof r=="string"?this._command={fromApi:r,internal:De(this,L,"f").toInternal({title:"",command:r},this._internalCommandRegistration)}:r?this._command={fromApi:r,internal:De(this,L,"f").toInternal(r,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(r){this._accessibilityInformation=r,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,De(this,C,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let r;this._extension?this._id?r=`${this._extension.identifier.value}.${this._id}`:r=this._extension.identifier.value:r=this._id;let n;this._name?n=this._name:n=(0,w.localize)(0,null,this._extension.displayName||this._extension.name);let m=this._color;this._backgroundColor&&(m=M.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const y=S.MarkdownString.fromStrict(this._tooltip);De(this,C,"f").$setEntry(this._entryId,r,n,this._text,y,this._command?.internal,m,this._backgroundColor,this._alignment===o.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=M,C=new WeakMap,L=new WeakMap,M.ID_GEN=0,M.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new o.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new o.ThemeColor("statusBarItem.warningForeground")]]);class v{constructor(r){this._messages=[],this._item=r.createStatusBarEntry(void 0,"status.extensionMessage",o.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,w.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(r){const n={message:r};return this._messages.unshift(n),this._update(),new o.Disposable(()=>{const m=this._messages.indexOf(n);m>=0&&(this._messages.splice(m,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class c{constructor(r,n){this._proxy=r.getProxy(I.MainContext.MainThreadStatusBar),this._commands=n,this._statusMessage=new v(this)}createStatusBarEntry(r,n,m,y){return new M(this._proxy,this._commands,r,n,m,y)}setStatusBarMessage(r,n){const m=this._statusMessage.setMessage(r);let y;return typeof n=="number"?y=setTimeout(()=>m.dispose(),n):typeof n!="undefined"&&n.then(()=>m.dispose(),()=>m.dispose()),new o.Disposable(()=>{m.dispose(),clearTimeout(y)})}}e.ExtHostStatusBar=c}),define(Ee[67],be([1,0,4,5,3]),function(Y,e,o,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class B{constructor(A){this._onDidChangeStorage=new I.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=A.getProxy(o.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,C){this._proxy.$registerExtensionStorageKeysToSync(A,C)}initializeExtensionStorage(A,C,L){return this._proxy.$initializeExtensionStorage(A,C).then(M=>M||L)}setValue(A,C,L){return this._proxy.$setValue(A,C,L)}$acceptValue(A,C,L){this._onDidChangeStorage.fire({shared:A,key:C,value:L})}}e.ExtHostStorage=B,e.IExtHostStorage=(0,w.createDecorator)("IExtHostStorage")}),define(Ee[68],be([1,0,3,27,12,50,2]),function(Y,e,o,I,w,B,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,o.createDecorator)("IExtensionStoragePaths");let A=class{constructor(L,M,v){this._logService=M,this._extHostFileSystem=v,this._workspace=L.workspace??void 0,this._environment=L.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(c=>this._value=c)}async _getWorkspaceStorageURI(L){return S.URI.joinPath(this._environment.workspaceStorageHome,L)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const L=this._workspace.id,M=await this._getWorkspaceStorageURI(L);try{return await this._extHostFileSystem.value.stat(M),this._logService.trace("[ExtHostStorage] storage dir already exists",M),M}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",M),await this._extHostFileSystem.value.createDirectory(M),await this._extHostFileSystem.value.writeFile(S.URI.joinPath(M,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:S.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),M}catch(v){this._logService.error("[ExtHostStorage]",v);return}}workspaceValue(L){if(this._value)return S.URI.joinPath(this._value,L.identifier.value)}globalValue(L){return S.URI.joinPath(this._environment.globalStorageHome,L.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=Fe([Ne(0,I.IExtHostInitDataService),Ne(1,w.ILogService),Ne(2,B.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(Ee[40],be([1,0,5,4,3,2,14,6,7,126,15,165,20,36,145,57,11,13]),function(Y,e,o,I,w,B,S,A,C,L,M,v,c,g,r,n,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,w.createDecorator)("IExtHostTerminalService");class k{constructor(t,a,p,h){this._proxy=t,this._id=a,this._creationOptions=p,this._name=h,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(T=>this._pidPromiseComplete=T);const _=this;this.value={get name(){return _._name||""},get processId(){return _._pidPromise},get creationOptions(){return _._creationOptions},get exitStatus(){return _._exitStatus},get state(){return _._state},sendText(T,R=!0){_._checkDisposed(),_._proxy.$sendText(_._id,T,R)},show(T){_._checkDisposed(),_._proxy.$show(_._id,T)},hide(){_._checkDisposed(),_._proxy.$hide(_._id)},dispose(){_._disposed||(_._disposed=!0,_._proxy.$dispose(_._id))},get dimensions(){if(!(_._cols===void 0||_._rows===void 0))return{columns:_._cols,rows:_._rows}}}}async create(t,a){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:t.name,shellPath:(0,m.withNullAsUndefined)(t.shellPath),shellArgs:(0,m.withNullAsUndefined)(t.shellArgs),cwd:(0,m.withNullAsUndefined)(t.cwd),env:(0,m.withNullAsUndefined)(t.env),icon:(0,m.withNullAsUndefined)(u(t.iconPath)),color:n.ThemeColor.isThemeColor(t.color)?t.color.id:void 0,initialText:(0,m.withNullAsUndefined)(t.message),strictEnv:(0,m.withNullAsUndefined)(t.strictEnv),hideFromUser:(0,m.withNullAsUndefined)(t.hideFromUser),isFeatureTerminal:(0,m.withNullAsUndefined)(a?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,m.withNullAsUndefined)(a?.useShellEnvironment),location:a?.location||this._serializeParentTerminal(t.location,a?.resolvedExtHostIdentifier),isTransient:(0,m.withNullAsUndefined)(t.isTransient)})}async createExtensionTerminal(t,a,p,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:p,color:n.ThemeColor.isThemeColor(h)?h.id:void 0,location:this._serializeParentTerminal(t,a),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(t,a){return typeof t=="object"?"parentTerminal"in t&&t.parentTerminal&&a?{parentTerminal:a}:"viewColumn"in t?{viewColumn:t.viewColumn,preserveFocus:t.preserveFocus}:void 0:t}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,a){return t===this._cols&&a===this._rows||t===0||a===0?!1:(this._cols=t,this._rows=a,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(a=>{a!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=k;class d{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new o.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new o.Emitter,this._onDidChangeProperty=new o.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new o.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(t){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${t}`)}updateProperty(t,a){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${t}, value: ${a}`)}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput?.(t)}resize(t,a){this._pty.setDimensions?.({columns:t,rows:a})}async processBinary(t){}acknowledgeDataEvent(t){}async setUnicodeVersion(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(a=>this._onProcessData.fire(a)),this._pty.onDidClose?.((a=void 0)=>{this._onProcessExit.fire(a===void 0?void 0:a)}),this._pty.onDidOverrideDimensions?.(a=>{a&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:a.columns,rows:a.rows}})}),this._pty.onDidChangeName?.(a=>{this._onDidChangeProperty.fire({type:"title",value:a})}),this._pty.open(t||void 0),t&&this._pty.setDimensions?.(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=d;let f=1,b=class extends A.Disposable{constructor(t,a){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new o.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new o.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new o.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new o.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new o.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=a.getProxy(I.MainContext.MainThreadTerminalService),this._bufferer=new r.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new o.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[p,h]of this._terminalProcesses)h.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(t,a){const p=new k(this._proxy,(0,g.generateUuid)(),t,t.name),h=new d(t.pty);return p.createExtensionTerminal(t.location,this._serializeParentTerminal(t,a).resolvedExtHostIdentifier,u(t.iconPath),i(t.color)).then(_=>{const T=this._setupExtHostProcessListeners(_,h);this._terminalProcessDisposables[_]=T}),this._terminals.push(p),p.value}_serializeParentTerminal(t,a){if(a=a||{},t.location&&typeof t.location=="object"&&"parentTerminal"in t.location){const p=t.location.parentTerminal;if(p){const h=this._terminals.find(_=>_.value===p);h&&(a.resolvedExtHostIdentifier=h._id)}}else t.location&&typeof t.location!="object"?a.location=t.location:a.location&&typeof a.location=="object"&&"splitActiveTerminal"in a.location&&(a.location={splitActiveTerminal:!0});return a}attachPtyToTerminal(t,a){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const h=new d(a),_=this._setupExtHostProcessListeners(t,h);this._terminalProcessDisposables[t]=_}async $acceptActiveTerminalChanged(t){const a=this._activeTerminal;if(t===null){this._activeTerminal=void 0,a!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const p=this._getTerminalById(t);p&&(this._activeTerminal=p,a!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,a){const p=this._getTerminalById(t);p&&this._onDidWriteTerminalData.fire({terminal:p.value,data:a})}async $acceptTerminalDimensions(t,a,p){const h=this._getTerminalById(t);h&&h.setDimensions(a,p)&&this._onDidChangeTerminalDimensions.fire({terminal:h.value,dimensions:h.value.dimensions})}async $acceptTerminalMaximumDimensions(t,a,p){this._terminalProcesses.get(t)?.resize(a,p)}async $acceptTerminalTitleChange(t,a){const p=this._getTerminalById(t);p&&(p.name=a)}async $acceptTerminalClosed(t,a){const p=this._getTerminalObjectIndexById(this._terminals,t);if(p!==null){const h=this._terminals.splice(p,1)[0];h.setExitCode(a),this._onDidCloseTerminal.fire(h.value)}}$acceptTerminalOpened(t,a,p,h){if(a){const R=this._getTerminalObjectIndexById(this._terminals,a);if(R!==null){this._terminals[R]._id=t,this._onDidOpenTerminal.fire(this.terminals[R]),this._terminals[R].isOpen=!0;return}}const _={name:h.name,shellPath:h.executable,shellArgs:h.args,cwd:typeof h.cwd=="string"?h.cwd:B.URI.revive(h.cwd),env:h.env,hideFromUser:h.hideFromUser},T=new k(this._proxy,t,_,p);this._terminals.push(T),this._onDidOpenTerminal.fire(T.value),T.isOpen=!0}async $acceptTerminalProcessId(t,a){const p=this._getTerminalById(t);p&&p._setProcessId(a)}async $startExtensionTerminal(t,a){const p=this._getTerminalById(t);if(!p)return{message:(0,L.localize)(0,null,t)};p.isOpen||await new Promise(_=>{const T=this.onDidOpenTerminal(async R=>{R===p.value&&(T.dispose(),_())})});const h=this._terminalProcesses.get(t);h?h.startSendingEvents(a):this._extensionTerminalAwaitingStart[t]={initialDimensions:a}}_setupExtHostProcessListeners(t,a){const p=new A.DisposableStore;p.add(a.onProcessReady(_=>this._proxy.$sendProcessReady(t,_.pid,_.cwd))),p.add(a.onDidChangeProperty(_=>this._proxy.$sendProcessProperty(t,_))),this._bufferer.startBuffering(t,a.onProcessData),p.add(a.onProcessExit(_=>this._onProcessExit(t,_))),this._terminalProcesses.set(t,a);const h=this._extensionTerminalAwaitingStart[t];return h&&a instanceof d&&(a.startSendingEvents(h.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),p}$acceptProcessAckDataEvent(t,a){this._terminalProcesses.get(t)?.acknowledgeDataEvent(a)}$acceptProcessInput(t,a){this._terminalProcesses.get(t)?.input(a)}$acceptTerminalInteraction(t){const a=this._getTerminalById(t);a?.setInteractedWith()&&this._onDidChangeTerminalState.fire(a.value)}$acceptProcessResize(t,a,p){try{this._terminalProcesses.get(t)?.resize(a,p)}catch(h){if(h.code!=="EPIPE"&&h.code!=="ERR_IPC_CHANNEL_CLOSED")throw h}}$acceptProcessShutdown(t,a){this._terminalProcesses.get(t)?.shutdown(a)}$acceptProcessRequestInitialCwd(t){this._terminalProcesses.get(t)?.getInitialCwd().then(a=>this._proxy.$sendProcessProperty(t,{type:"initialCwd",value:a}))}$acceptProcessRequestCwd(t){this._terminalProcesses.get(t)?.getCwd().then(a=>this._proxy.$sendProcessProperty(t,{type:"cwd",value:a}))}$acceptProcessRequestLatency(t){return Promise.resolve(t)}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new C.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(t,a,p){if(this._profileProviders.has(a))throw new Error(`Terminal profile provider "${a}" already registered`);return this._profileProviders.set(a,p),this._proxy.$registerProfileProvider(a,t.identifier.value),new C.Disposable(()=>{this._profileProviders.delete(a),this._proxy.$unregisterProfileProvider(a)})}async $createContributedProfileTerminal(t,a){const p=new c.CancellationTokenSource().token;let h=await this._profileProviders.get(t)?.provideTerminalProfile(p);if(!p.isCancellationRequested){if(h&&!("options"in h)&&(h={options:h}),!h||!("options"in h))throw new Error(`No terminal profile options provided for id "${t}"`);if("pty"in h.options){this.createExtensionTerminal(h.options,a);return}this.createTerminalFromOptions(h.options,a)}}async $provideLinks(t,a){const p=this._getTerminalById(t);if(!p)return[];this._terminalLinkCache.delete(t);const h=this._terminalLinkCancellationSource.get(t);h&&h.dispose(!0);const _=new c.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,_);const T=[],R={terminal:p.value,line:a},W=[];for(const q of this._linkProviders)W.push(y.Promises.withAsyncBody(async $=>{_.token.onCancellationRequested(()=>$({provider:q,links:[]}));const j=await q.provideTerminalLinks(R,_.token)||[];_.token.isCancellationRequested||$({provider:q,links:j})}));const E=await Promise.all(W);if(_.token.isCancellationRequested)return[];const H=new Map;for(const q of E)q&&q.links.length>0&&T.push(...q.links.map($=>{const j={id:f++,startIndex:$.startIndex,length:$.length,label:$.tooltip};return H.set(j.id,{provider:q.provider,link:$}),j}));return this._terminalLinkCache.set(t,H),T}$activateLink(t,a){const p=this._terminalLinkCache.get(t)?.get(a);!p||p.provider.handleTerminalLink(p.link)}_onProcessExit(t,a){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const p=this._terminalProcessDisposables[t];p&&(p.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,a)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,a){const p=this._getTerminalObjectIndexById(t,a);return p!==null?t[p]:null}_getTerminalObjectIndexById(t,a){let p=null;return t.some((h,_)=>h._id===a?(p=_,!0):!1),p}getEnvironmentVariableCollection(t){let a=this._environmentVariableCollections.get(t.identifier.value);return a||(a=new l,this._setEnvironmentVariableCollection(t.identifier.value,a)),a}_syncEnvironmentVariableCollection(t,a){const p=(0,v.serializeEnvironmentVariableCollection)(a.map);this._proxy.$setEnvironmentVariableCollection(t,a.persistent,p.length===0?void 0:p)}$initEnvironmentVariableCollections(t){t.forEach(a=>{const p=a[0],h=new l(a[1]);this._setEnvironmentVariableCollection(p,h)})}$acceptDefaultProfile(t,a){this._defaultProfile=t,this._defaultAutomationProfile=a}_setEnvironmentVariableCollection(t,a){this._environmentVariableCollections.set(t,a),a.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,a)})}};b=Fe([Ne(1,S.IExtHostRpcService)],b),e.BaseExtHostTerminalService=b;class l{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new o.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,a){this._setIfDiffers(t,{value:a,type:C.EnvironmentVariableMutatorType.Replace})}append(t,a){this._setIfDiffers(t,{value:a,type:C.EnvironmentVariableMutatorType.Append})}prepend(t,a){this._setIfDiffers(t,{value:a,type:C.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,a){const p=this.map.get(t);(!p||p.value!==a.value||p.type!==a.type)&&(this.map.set(t,a),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,a){this.map.forEach((p,h)=>t.call(a,h,p,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=l;let P=class extends b{constructor(t){super(!1,t)}createTerminal(t,a,p){throw new M.NotSupportedError}createTerminalFromOptions(t,a){throw new M.NotSupportedError}};P=Fe([Ne(0,S.IExtHostRpcService)],P),e.WorkerExtHostTerminalService=P;function u(s){if(!(!s||typeof s=="string"))return"id"in s?{id:s.id,color:s.color}:s}function i(s){return n.ThemeColor.isThemeColor(s)?s:void 0}});var je=this&&this.__classPrivateFieldSet||function(Y,e,o,I,w){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!w:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?w.call(Y,o):w?w.value=o:e.set(Y,o),o},De=this&&this.__classPrivateFieldGet||function(Y,e,o,I){if(o==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?I:o==="a"?I.call(Y):I?I.value:e.get(Y)};define(Ee[202],be([1,0,16,21,20,5,233,93,6,26,11,36,4,14,47,8,7,171,62,63]),function(Y,e,o,I,w,B,S,A,C,L,M,v,c,g,r,n,m,y,k,d){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let b=class{constructor(R,W){this.resultsChangedEmitter=new B.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(c.MainContext.MainThreadTesting),this.observer=new p(this.proxy),this.runTracker=new P(this.proxy),W.registerArgumentProcessor({processArgument:E=>E?.$mid===13?n.TestItem.toItemFromContext(E):E})}createTestController(R,W,E){if(this.controllers.has(R))throw new Error(`Attempt to insert a duplicate controller with ID "${R}"`);const H=new C.DisposableStore,q=H.add(new y.SingleUseTestCollection(R));q.root.label=W;const $=new Map,j=this.proxy,J={items:q.root.children,get label(){return W},set label(ie){W=ie,q.root.label=ie,j.$updateController(R,{label:W})},get refreshHandler(){return E},set refreshHandler(ie){E=ie,j.$updateController(R,{canRefresh:!!ie})},get id(){return R},createRunProfile:(ie,ae,te,ce,de)=>{let Se=(0,A.hash)(ie);for(;$.has(Se);)Se++;const fe=new h(this.proxy,R,Se,ie,ae,te,ce,de);return $.set(Se,fe),fe},createTestItem(ie,ae,te){return new r.TestItemImpl(R,ie,ae,te)},createTestRun:(ie,ae,te=!0)=>this.runTracker.createTestRun(R,q,ie,ae,te),set resolveHandler(ie){q.resolveHandler=ie},get resolveHandler(){return q.resolveHandler},dispose:()=>{H.dispose()}};j.$registerTestController(R,W,!!E),H.add((0,C.toDisposable)(()=>j.$unregisterTestController(R)));const z={controller:J,collection:q,profiles:$};return this.controllers.set(R,z),H.add((0,C.toDisposable)(()=>this.controllers.delete(R))),H.add(q.onDidGenerateDiff(ie=>j.$publishDiff(R,ie.map(k.TestsDiffOp.serialize)))),J}createTestObserver(){return this.observer.checkout()}async runTests(R,W=w.CancellationToken.None){const E=u(R);if(!E)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const H=this.controllers.get(E.controllerId);if(!H)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:R.include?.map(q=>q.id)??[H.collection.root.id],profileGroup:_[E.kind],profileId:E.profileId,controllerId:E.controllerId}],exclude:R.exclude?.map(q=>q.id)},W)}$provideFileCoverage(R,W,E){return(0,o.mapFind)(this.runTracker.trackers,q=>q.id===R?q.getCoverage(W):void 0)?.provideFileCoverage(E)??Promise.resolve([])}$resolveFileCoverage(R,W,E,H){return(0,o.mapFind)(this.runTracker.trackers,$=>$.id===R?$.getCoverage(W):void 0)?.resolveFileCoverage(E,H)??Promise.resolve([])}$configureRunProfile(R,W){this.controllers.get(R)?.profiles.get(W)?.configureHandler?.()}async $refreshTests(R,W){await this.controllers.get(R)?.controller.refreshHandler?.(W)}$publishTestResults(R){this.results=Object.freeze(R.map(W=>(0,L.deepFreeze)(n.TestResults.to(W))).concat(this.results).sort((W,E)=>E.completedAt-W.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(R,W){const E=this.controllers.get(d.TestId.fromString(R).controllerId)?.collection;E&&(await E.expand(R,W<0?1/0:W),E.flushDiff())}$acceptDiff(R){this.observer.applyDiff(R.map(k.TestsDiffOp.deserialize))}async $runControllerTests(R,W){const E=this.controllers.get(R.controllerId);if(!E)return;const{collection:H,profiles:q}=E,$=q.get(R.profileId);if(!$)return;const j=R.testIds.map(ae=>H.tree.get(ae)).filter(M.isDefined),J=R.excludeExtIds.map(ae=>E.collection.tree.get(ae)).filter(M.isDefined).filter(ae=>j.some(te=>te.fullId.compare(ae.fullId)===2));if(!j.length)return;const z=new m.TestRunRequest(j.some(ae=>ae.actual instanceof r.TestItemRootImpl)?void 0:j.map(ae=>ae.actual),J.map(ae=>ae.actual),$),ie=this.runTracker.prepareForMainThreadTestRun(z,i.fromInternal(R,E.collection),W);try{await $.runHandler(z,W)}finally{ie.isRunning&&!W.isCancellationRequested&&await B.Event.toPromise(ie.onEnd),ie.dispose()}}$cancelExtensionTestRun(R){R===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(R)}};b=Fe([Ne(0,g.IExtHostRpcService)],b),e.ExtHostTesting=b;class l extends C.Disposable{constructor(R,W,E){super();this.dto=R,this.proxy=W,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new B.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new w.CancellationTokenSource(E)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:H}of this.tasks.values())H.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(R){return this.tasks.get(R)?.coverage}createRun(R){const W=this.dto.id,E=this.dto.controllerId,H=(0,v.generateUuid)(),q=new s(this.proxy,W,H),$=ie=>(ae,...te)=>{if(J){console.warn(`Setting the state of test "${ae.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(ae)||(this.ensureTestIsKnown(ae),ie(ae,...te))},j=(ie,ae)=>{const te=ae instanceof Array?ae.map(n.TestMessage.from):[n.TestMessage.from(ae)];if(ie.uri&&ie.range){const ce={range:n.Range.from(ie.range),uri:ie.uri};for(const de of te)de.location=de.location||ce}this.proxy.$appendTestMessagesInRun(W,H,d.TestId.fromExtHostTestItem(ie,E).toString(),te)};let J=!1;const z={isPersisted:this.dto.isPersisted,token:this.cts.token,name:R,get coverageProvider(){return q.coverageProvider},set coverageProvider(ie){q.coverageProvider=ie},enqueued:$(ie=>{this.proxy.$updateTestStateInRun(W,H,d.TestId.fromExtHostTestItem(ie,E).toString(),1)}),skipped:$(ie=>{this.proxy.$updateTestStateInRun(W,H,d.TestId.fromExtHostTestItem(ie,E).toString(),5)}),started:$(ie=>{this.proxy.$updateTestStateInRun(W,H,d.TestId.fromExtHostTestItem(ie,E).toString(),2)}),errored:$((ie,ae,te)=>{j(ie,ae),this.proxy.$updateTestStateInRun(W,H,d.TestId.fromExtHostTestItem(ie,E).toString(),6,te)}),failed:$((ie,ae,te)=>{j(ie,ae),this.proxy.$updateTestStateInRun(W,H,d.TestId.fromExtHostTestItem(ie,E).toString(),4,te)}),passed:$((ie,ae)=>{this.proxy.$updateTestStateInRun(W,H,d.TestId.fromExtHostTestItem(ie,this.dto.controllerId).toString(),3,ae)}),appendOutput:(ie,ae,te)=>{J||(te&&(this.dto.isIncluded(te)?this.ensureTestIsKnown(te):te=void 0),this.proxy.$appendOutputToRun(W,H,I.VSBuffer.fromString(ie),ae&&n.location.from(ae),te&&d.TestId.fromExtHostTestItem(te,E).toString()))},end:()=>{J||(J=!0,this.proxy.$finishedTestRunTask(W,H),this.tasks.delete(H),this.isRunning||this.dispose())}};return this.tasks.set(H,{run:z,coverage:q}),this.proxy.$startedTestRunTask(W,{id:H,name:R,running:!0}),z}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(R){if(!(R instanceof r.TestItemImpl))throw new r.InvalidTestItemError(R.id);if(this.sharedTestIds.has(d.TestId.fromExtHostTestItem(R,this.dto.controllerId).toString()))return;const W=[],E=this.dto.colllection.root;for(;;){const H=n.TestItem.from(R);if(W.unshift(H),this.sharedTestIds.has(H.extId)||(this.sharedTestIds.add(H.extId),R===E))break;R=R.parent||E}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,W)}}class P{constructor(R){this.proxy=R,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(R,W,E){return this.getTracker(R,W,E)}cancelRunById(R){for(const W of this.tracked.values())if(W.id===R){W.dispose();return}}cancelAllRuns(){for(const R of this.tracked.values())R.dispose()}createTestRun(R,W,E,H,q){const $=this.tracked.get(E);if($)return $.createRun(H);const j=i.fromPublic(R,W,E,q),J=u(E);this.proxy.$startedExtensionTestRun({controllerId:R,profile:J&&{group:_[J.kind],id:J.profileId},exclude:E.exclude?.map(ie=>ie.id)??[],id:j.id,include:E.include?.map(ie=>ie.id)??[W.root.id],persist:q});const z=this.getTracker(E,j);return z.onEnd(()=>this.proxy.$finishedExtensionTestRun(j.id)),z.createRun(H)}getTracker(R,W,E){const H=new l(W,this.proxy,E);return this.tracked.set(R,H),H.onEnd(()=>this.tracked.delete(R)),H}}e.TestRunCoordinator=P;const u=T=>{if(!!T.profile){if(!(T.profile instanceof h))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return T.profile}};class i{constructor(R,W,E,H,q,$){this.controllerId=R,this.id=W,this.isPersisted=q,this.colllection=$,this.includePrefix=E.map(j=>j+"\0"),this.excludePrefix=H.map(j=>j+"\0")}static fromPublic(R,W,E,H){return new i(R,(0,v.generateUuid)(),E.include?.map(q=>d.TestId.fromExtHostTestItem(q,R).toString())??[R],E.exclude?.map(q=>d.TestId.fromExtHostTestItem(q,R).toString())??[],H,W)}static fromInternal(R,W){return new i(R.controllerId,R.runId,R.testIds,R.excludeExtIds,!0,W)}isIncluded(R){const W=d.TestId.fromExtHostTestItem(R,this.controllerId).toString()+"\0";for(const E of this.excludePrefix)if(W===E||W.startsWith(E))return!1;for(const E of this.includePrefix)if(W===E||W.startsWith(E))return!0;return!1}}e.TestRunDto=i;class s{constructor(R,W,E){this.proxy=R,this.runId=W,this.taskId=E}set coverageProvider(R){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!R||(this._coverageProvider=R,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(R){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(R))());try{return(await this.fileCoverage)?.map(n.TestCoverage.fromFile)??[]}catch(W){throw this.fileCoverage=void 0,W}}async resolveFileCoverage(R,W){const E=await this.fileCoverage;let H=E?.[R];return!this._coverageProvider||!E||!H?[]:(H.detailedCoverage||(H=E[R]=await this._coverageProvider.resolveFileCoverage?.(H,W)??H),H.detailedCoverage?.map(n.TestCoverage.fromDetailed)??[])}}class t extends k.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,n.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:W,removed:E}=this;return{get added(){return[...R].map(H=>H.revived)},get updated(){return[...W].map(H=>H.revived)},get removed(){return[...E].map(H=>H.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class a extends k.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new B.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,W){return{...R,revived:n.TestItem.toPlain(R.item),depth:W?W.depth+1:0,children:new Set}}createChangeCollector(){return new t(this.changeEmitter)}}e.MirroredTestCollection=a;class p{constructor(R){this.proxy=R}checkout(){this.current||(this.current=this.createObserverData());const R=this.current;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map(W=>W.revived)},dispose:(0,S.once)(()=>{--R.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(R){return this.current?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.current?.tests.apply(R)}createObserverData(){const R=new a;return this.proxy.$subscribeToDiffs(),{observers:0,tests:R}}}class h{constructor(R,W,E,H,q,$,j=!1,J=void 0){this.controllerId=W,this.profileId=E,this._label=H,this.kind=q,this.runHandler=$,this._isDefault=j,this._tag=J,f.set(this,void 0),je(this,f,R,"f");const z=_[q];if(typeof z!="number")throw new Error(`Unknown TestRunProfile.group ${q}`);De(this,f,"f").$publishTestRunProfile({profileId:E,controllerId:W,tag:J?n.TestTag.namespace(this.controllerId,J.id):null,label:H,group:z,isDefault:j,hasConfigurationHandler:!1})}get label(){return this._label}set label(R){R!==this._label&&(this._label=R,De(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:R}))}get isDefault(){return this._isDefault}set isDefault(R){R!==this._isDefault&&(this._isDefault=R,De(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:R}))}get tag(){return this._tag}set tag(R){R?.id!==this._tag?.id&&(this._tag=R,De(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:R?n.TestTag.namespace(this.controllerId,R.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(R){R!==this._configureHandler&&(this._configureHandler=R,De(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!R}))}dispose(){De(this,f,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=h,f=new WeakMap;const _={[m.TestRunProfileKind.Coverage]:8,[m.TestRunProfileKind.Debug]:4,[m.TestRunProfileKind.Run]:2}}),define(Ee[203],be([1,0,5,16,4,90,8,7]),function(Y,e,o,I,w,B,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class C{constructor(M,v){this._extHostDocumentsAndEditors=v,this._onDidChangeTextEditorSelection=new o.Emitter,this._onDidChangeTextEditorOptions=new o.Emitter,this._onDidChangeTextEditorVisibleRanges=new o.Emitter,this._onDidChangeTextEditorViewColumn=new o.Emitter,this._onDidChangeActiveTextEditor=new o.Emitter,this._onDidChangeVisibleTextEditors=new o.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=M.getProxy(w.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(c=>this._onDidChangeVisibleTextEditors.fire(c)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(c=>this._onDidChangeActiveTextEditor.fire(c))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(M){const v=this._extHostDocumentsAndEditors.allEditors();return M?v:v.map(c=>c.value)}async showTextDocument(M,v,c){let g;typeof v=="number"?g={position:S.ViewColumn.from(v),preserveFocus:c}:typeof v=="object"?g={position:S.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus,selection:typeof v.selection=="object"?S.Range.from(v.selection):void 0,pinned:typeof v.preview=="boolean"?!v.preview:void 0}:g={preserveFocus:!1};const r=await this._proxy.$tryShowTextDocument(M.uri,g),n=r&&this._extHostDocumentsAndEditors.getEditor(r);if(n)return n.value;throw r?new Error(`Could NOT open editor for "${M.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${M.uri.toString()}".`)}createTextEditorDecorationType(M,v){return new B.TextEditorDecorationType(this._proxy,M,v).value}$acceptEditorPropertiesChanged(M,v){const c=this._extHostDocumentsAndEditors.getEditor(M);if(!c)throw new Error("unknown text editor");if(v.options&&c._acceptOptions(v.options),v.selections){const g=v.selections.selections.map(S.Selection.to);c._acceptSelections(g)}if(v.visibleRanges){const g=I.coalesce(v.visibleRanges.map(S.Range.to));c._acceptVisibleRanges(g)}if(v.options&&this._onDidChangeTextEditorOptions.fire({textEditor:c.value,options:{...v.options,lineNumbers:S.TextEditorLineNumbersStyle.to(v.options.lineNumbers)}}),v.selections){const g=A.TextEditorSelectionChangeKind.fromValue(v.selections.source),r=v.selections.selections.map(S.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:c.value,selections:r,kind:g})}if(v.visibleRanges){const g=I.coalesce(v.visibleRanges.map(S.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:c.value,visibleRanges:g})}}$acceptEditorPositionData(M){for(const v in M){const c=this._extHostDocumentsAndEditors.getEditor(v);if(!c)throw new Error("Unknown text editor");const g=S.ViewColumn.to(M[v]);c.value.viewColumn!==g&&(c._acceptViewColumn(g),this._onDidChangeTextEditorViewColumn.fire({textEditor:c.value,viewColumn:g}))}}getDiffInformation(M){return Promise.resolve(this._proxy.$getDiffInformation(M))}}e.ExtHostEditors=C}),define(Ee[204],be([1,0,2,3,4,6,7,8,11]),function(Y,e,o,I,w,B,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,I.createDecorator)("IExtHostTimeline");class L{constructor(c,g){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=c.getProxy(w.MainContext.MainThreadTimeline),g.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===11){const n=r.uri===void 0?void 0:o.URI.revive(r.uri);return this._itemsBySourceAndUriMap.get(r.source)?.get(M(n))?.get(r.handle)}return r}})}async $getTimeline(c,g,r,n,m){return this._providers.get(c)?.provideTimeline(o.URI.revive(g),r,n,m)}registerTimelineProvider(c,g,r,n){const m=new B.DisposableStore,y=this.convertTimelineItem(g.id,n,m).bind(this);let k;g.onDidChange&&(k=g.onDidChange(f=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...f,id:g.id}),this));const d=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...g,scheme:c,onDidChange:void 0,async provideTimeline(f,b,l,P){P?.resetCache&&(m.clear(),d.get(g.id)?.clear());const u=await g.provideTimeline(f,b,l);if(u==null)return;const i=y(f,P);return{...u,source:g.id,items:u.items.map(i)}},dispose(){for(const f of d.values())f.get(g.id)?.clear();k?.dispose(),m.dispose()}})}convertTimelineItem(c,g,r){return(n,m)=>{let y;if(m?.cacheResults){let k=this._itemsBySourceAndUriMap.get(c);k===void 0&&(k=new Map,this._itemsBySourceAndUriMap.set(c,k));const d=M(n);y=k.get(d),y===void 0&&(y=new Map,k.set(d,y))}return k=>{const{iconPath:d,...f}=k,b=`${c}|${k.id??k.timestamp}`;y?.set(b,k);let l,P,u;k.iconPath&&(d instanceof S.ThemeIcon?u={id:d.id,color:d.color}:o.URI.isUri(d)?(l=d,P=d):{light:l,dark:P}=d);let i;return S.MarkdownString.isMarkdownString(f.detail)?i=A.MarkdownString.from(f.detail):(0,C.isString)(f.detail)&&(i=f.detail),{...f,id:f.id??void 0,handle:b,source:c,command:k.command?g.toInternal(k.command,r):void 0,icon:l,iconDark:P,themeIcon:u,detail:i,accessibilityInformation:k.accessibilityInformation}}}}registerTimelineProviderCore(c){if(this._providers.get(c.id))throw new Error(`Timeline Provider ${c.id} already exists.`);return this._proxy.$registerTimelineProvider({id:c.id,label:c.label,scheme:c.scheme}),this._providers.set(c.id,c),(0,B.toDisposable)(()=>{for(const r of this._itemsBySourceAndUriMap.values())r.get(c.id)?.clear();this._providers.delete(c.id),this._proxy.$unregisterTimelineProvider(c.id),c.dispose()})}}e.ExtHostTimeline=L;function M(v){return v?.toString()}}),define(Ee[205],be([1,0,6,9,2,4]),function(Y,e,o,I,w,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class S{constructor(C){this._openers=new Map,this._proxy=C.getProxy(B.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(C,L,M,v){if(this._openers.has(L))throw new Error(`Opener with id '${L}' already registered`);const c=v.schemes.find(g=>!S.supportedSchemes.has(g));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this._openers.set(L,M),this._proxy.$registerUriOpener(L,v.schemes,C,v.label),(0,o.toDisposable)(()=>{this._openers.delete(L),this._proxy.$unregisterUriOpener(L)})}async $canOpenUri(C,L,M){const v=this._openers.get(C);if(!v)throw new Error(`Unknown opener with id: ${C}`);const c=w.URI.revive(L);return v.canOpenExternalUri(c,M)}async $openUri(C,L,M){const v=this._openers.get(C);if(!v)throw new Error(`Unknown opener id: '${C}'`);return v.openExternalUri(w.URI.revive(L.resolvedUri),{sourceUri:w.URI.revive(L.sourceUri)},M)}}e.ExtHostUriOpeners=S,S.supportedSchemes=new Set([I.Schemas.http,I.Schemas.https])}),define(Ee[206],be([1,0,4,2,6,15,25]),function(Y,e,o,I,w,B,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(L){this.handles=new Set,this.handlers=new Map,this._proxy=L.getProxy(o.MainContext.MainThreadUrls)}registerUriHandler(L,M){if(this.handles.has(S.ExtensionIdentifier.toKey(L)))throw new Error(`Protocol handler already registered for extension ${L}`);const v=A.HandlePool++;return this.handles.add(S.ExtensionIdentifier.toKey(L)),this.handlers.set(v,M),this._proxy.$registerUriHandler(v,L),(0,w.toDisposable)(()=>{this.handles.delete(S.ExtensionIdentifier.toKey(L)),this.handlers.delete(v),this._proxy.$unregisterUriHandler(v)})}$handleExternalUri(L,M){const v=this.handlers.get(L);if(!v)return Promise.resolve(void 0);try{v.handleUri(I.URI.revive(M))}catch(c){(0,B.onUnexpectedError)(c)}return Promise.resolve(void 0)}async createAppUri(L){return I.URI.revive(await this._proxy.$createAppUri(L))}}e.ExtHostUrls=A,A.HandlePool=0});var je=this&&this.__classPrivateFieldSet||function(Y,e,o,I,w){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!w:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?w.call(Y,o):w?w.value=o:e.set(Y,o),o},De=this&&this.__classPrivateFieldGet||function(Y,e,o,I){if(o==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?I:o==="a"?I.call(Y):I?I.value:e.get(Y)};define(Ee[51],be([1,0,5,9,2,136,154,61,4]),function(Y,e,o,I,w,B,S,A,C){"use strict";var L,M,v,c,g,r,n,m,y,k,d,f;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class b{constructor(p,h,_,T,R,W,E){L.set(this,void 0),M.set(this,void 0),v.set(this,void 0),c.set(this,void 0),g.set(this,void 0),r.set(this,void 0),n.set(this,""),m.set(this,void 0),y.set(this,!1),k.set(this,!1),d.set(this,!1),this._onMessageEmitter=new o.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,f.set(this,new o.Emitter),this._onDidDispose=De(this,f,"f").event,je(this,L,p,"f"),je(this,M,h,"f"),je(this,m,_,"f"),je(this,c,T,"f"),je(this,g,R,"f"),je(this,r,W,"f"),je(this,d,l(W),"f"),je(this,v,E,"f")}dispose(){je(this,y,!0,"f"),De(this,f,"f").fire(),De(this,f,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(p){return je(this,k,!0,"f"),(0,A.asWebviewUri)(p,De(this,c,"f").remote)}get cspSource(){const p=De(this,r,"f").extensionLocation;if(p.scheme===I.Schemas.https||p.scheme===I.Schemas.http){let h=p.toString();return h.endsWith("/")||(h+="/"),h+" "+A.webviewGenericCspSource}return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),De(this,n,"f")}set html(p){this.assertNotDisposed(),De(this,n,"f")!==p&&(je(this,n,p,"f"),!De(this,k,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(p)&&(je(this,k,!0,"f"),De(this,v,"f").report("Webview vscode-resource: uris",De(this,r,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),De(this,M,"f").$setHtml(De(this,L,"f"),p))}get options(){return this.assertNotDisposed(),De(this,m,"f")}set options(p){this.assertNotDisposed(),De(this,M,"f").$setOptions(De(this,L,"f"),i(De(this,r,"f"),De(this,g,"f"),p)),je(this,m,p,"f")}async postMessage(p){if(De(this,y,"f"))return!1;const h=(0,S.serializeWebviewMessage)(p,{serializeBuffersForPostMessage:De(this,d,"f")});return De(this,M,"f").$postMessage(De(this,L,"f"),h.message,...h.buffers)}assertNotDisposed(){if(De(this,y,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=b,L=new WeakMap,M=new WeakMap,v=new WeakMap,c=new WeakMap,g=new WeakMap,r=new WeakMap,n=new WeakMap,m=new WeakMap,y=new WeakMap,k=new WeakMap,d=new WeakMap,f=new WeakMap;function l(a){try{const p=(0,B.normalizeVersion)((0,B.parseVersion)(a.engines.vscode));return!!p&&p.majorBase>=1&&p.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=l;class P{constructor(p,h,_,T,R){this.initData=h,this.workspace=_,this._logService=T,this._deprecationService=R,this._webviews=new Map,this._webviewProxy=p.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(p,h,_){const T=this.getWebview(p);if(T){const{message:R}=(0,S.deserializeWebviewMessage)(h,_.value);T._onMessageEmitter.fire(R)}}$onMissingCsp(p,h){this._logService.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(p,h,_){const T=new b(p,this._webviewProxy,s(h),this.initData,this.workspace,_,this._deprecationService);return this._webviews.set(p,T),T._onDidDispose(()=>{this._webviews.delete(p)}),T}deleteWebview(p){this._webviews.delete(p)}getWebview(p){return this._webviews.get(p)}}e.ExtHostWebviews=P;function u(a){return{id:a.identifier,location:a.extensionLocation}}e.toExtensionData=u;function i(a,p,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||t(a,p)}}e.serializeWebviewOptions=i;function s(a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots?.map(p=>w.URI.from(p))}}e.reviveOptions=s;function t(a,p){return[...(p?.getWorkspaceFolders()||[]).map(h=>h.uri),a.extensionLocation]}}),define(Ee[207],be([1,0,20,93,6,9,24,2,8,51,58,4,7]),function(Y,e,o,I,w,B,S,A,C,L,M,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class g{constructor(l,P){this.document=l,this._storagePath=P,this._backupCounter=1,this._edits=new M.Cache("custom documents")}addEdit(l){return this._edits.add([l])}async undo(l,P){await this.getEdit(l).undo(),P||this.disposeBackup()}async redo(l,P){await this.getEdit(l).redo(),P||this.disposeBackup()}disposeEdits(l){for(const P of l)this._edits.delete(P)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const l=f(this.document.uri)+this._backupCounter++;return(0,S.joinPath)(this._storagePath,l)}updateBackup(l){this._backup?.delete(),this._backup=l}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(l){const P=this._edits.get(l,0);if(!P)throw new Error("No edit found");return P}}class r{constructor(){this._documents=new Map}get(l,P){return this._documents.get(this.key(l,P))}add(l,P,u){const i=this.key(l,P.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${l} resource:${P.uri}`);const s=new g(P,u);return this._documents.set(i,s),s}delete(l,P){const u=this.key(l,P.uri);this._documents.delete(u)}key(l,P){return`${l}@@@${P}`}}var n;(function(b){b[b.Text=0]="Text",b[b.Custom=1]="Custom"})(n||(n={}));class m{constructor(){this._providers=new Map}addTextProvider(l,P,u){return this.add(0,l,P,u)}addCustomProvider(l,P,u){return this.add(1,l,P,u)}get(l){return this._providers.get(l)}add(l,P,u,i){if(this._providers.has(P))throw new Error(`Provider for viewType:${P} already registered`);return this._providers.set(P,{type:l,extension:u,provider:i}),new c.Disposable(()=>this._providers.delete(P))}}class y{constructor(l,P,u,i,s){this._extHostDocuments=P,this._extensionStoragePaths=u,this._extHostWebview=i,this._extHostWebviewPanels=s,this._editorProviders=new m,this._documents=new r,this._proxy=l.getProxy(v.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(l,P,u,i){const s=new w.DisposableStore;return k(u)?(s.add(this._editorProviders.addTextProvider(P,l,u)),this._proxy.$registerTextEditorProvider((0,L.toExtensionData)(l),P,i.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,L.shouldSerializeBuffersForPostMessage)(l))):(s.add(this._editorProviders.addCustomProvider(P,l,u)),this.supportEditing(u)&&s.add(u.onDidChangeCustomDocument(t=>{const a=this.getCustomDocumentEntry(P,t.document.uri);if(d(t)){const p=a.addEdit(t);this._proxy.$onDidEdit(t.document.uri,P,p,t.label)}else this._proxy.$onContentChange(t.document.uri,P)})),this._proxy.$registerCustomEditorProvider((0,L.toExtensionData)(l),P,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,L.shouldSerializeBuffersForPostMessage)(l))),c.Disposable.from(s,new c.Disposable(()=>{this._proxy.$unregisterEditorProvider(P)}))}async $createCustomDocument(l,P,u,i,s){const t=this._editorProviders.get(P);if(!t)throw new Error(`No provider found for '${P}'`);if(t.type!==1)throw new Error(`Invalid provide type for '${P}'`);const a=A.URI.revive(l),p=await t.provider.openCustomDocument(a,{backupId:u,untitledDocumentData:i?.buffer},s);let h;return this.supportEditing(t.provider)&&this._extensionStoragePaths&&(h=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension)),this._documents.add(P,p,h),{editable:this.supportEditing(t.provider)}}async $disposeCustomDocument(l,P){const u=this._editorProviders.get(P);if(!u)throw new Error(`No provider found for '${P}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${P}'`);const i=A.URI.revive(l),{document:s}=this.getCustomDocumentEntry(P,i);this._documents.delete(P,s),s.dispose()}async $resolveWebviewEditor(l,P,u,i,s,t){const a=this._editorProviders.get(u);if(!a)throw new Error(`No provider found for '${u}'`);const p=C.ViewColumn.to(s),h=this._extHostWebview.createNewWebview(P,i.webviewOptions,a.extension),_=this._extHostWebviewPanels.createNewWebviewPanel(P,u,i.title,p,i.panelOptions,h),T=A.URI.revive(l);switch(a.type){case 1:{const{document:R}=this.getCustomDocumentEntry(u,T);return a.provider.resolveCustomEditor(R,_,t)}case 0:{const R=this._extHostDocuments.getDocument(T);return a.provider.resolveCustomTextEditor(R,_,t)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(l,P,u){this.getCustomDocumentEntry(P,l).disposeEdits(u)}async $onMoveCustomEditor(l,P,u){const i=this._editorProviders.get(u);if(!i)throw new Error(`No provider found for '${u}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const s=this._extHostWebviewPanels.getWebviewPanel(l);if(!s)throw new Error("No webview found");const t=A.URI.revive(P),a=this._extHostDocuments.getDocument(t);await i.provider.moveCustomTextEditor(a,s,o.CancellationToken.None)}async $undo(l,P,u,i){return this.getCustomDocumentEntry(P,l).undo(u,i)}async $redo(l,P,u,i){return this.getCustomDocumentEntry(P,l).redo(u,i)}async $revert(l,P,u){const i=this.getCustomDocumentEntry(P,l);await this.getCustomEditorProvider(P).revertCustomDocument(i.document,u),i.disposeBackup()}async $onSave(l,P,u){const i=this.getCustomDocumentEntry(P,l);await this.getCustomEditorProvider(P).saveCustomDocument(i.document,u),i.disposeBackup()}async $onSaveAs(l,P,u,i){const s=this.getCustomDocumentEntry(P,l);return this.getCustomEditorProvider(P).saveCustomDocumentAs(s.document,A.URI.revive(u),i)}async $backup(l,P,u){const i=this.getCustomDocumentEntry(P,l),t=await this.getCustomEditorProvider(P).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},u);return i.updateBackup(t),t.id}getCustomDocumentEntry(l,P){const u=this._documents.get(l,A.URI.revive(P));if(!u)throw new Error("No custom document found");return u}getCustomEditorProvider(l){const u=this._editorProviders.get(l)?.provider;if(!u||!this.supportEditing(u))throw new Error("Custom document is not editable");return u}supportEditing(l){return!!l.onDidChangeCustomDocument}}e.ExtHostCustomEditors=y;function k(b){return typeof b.resolveCustomTextEditor=="function"}function d(b){return typeof b.undo=="function"&&typeof b.redo=="function"}function f(b){const l=b.scheme===B.Schemas.file||b.scheme===B.Schemas.untitled?b.fsPath:b.toString();return(0,I.hash)(l)+""}});var je=this&&this.__classPrivateFieldSet||function(Y,e,o,I,w){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!w:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?w.call(Y,o):w?w.value=o:e.set(Y,o),o},De=this&&this.__classPrivateFieldGet||function(Y,e,o,I){if(o==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?I:o==="a"?I.call(Y):I?I.value:e.get(Y)};define(Ee[208],be([1,0,5,6,2,36,8,51,4,7]),function(Y,e,o,I,w,B,S,A,C,L){"use strict";var M,v,c,g,r,n,m,y,k,d,f,b,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class P extends I.Disposable{constructor(t,a,p,h,_,T,R){super();M.set(this,void 0),v.set(this,void 0),c.set(this,void 0),g.set(this,void 0),r.set(this,void 0),n.set(this,void 0),m.set(this,void 0),y.set(this,void 0),k.set(this,!0),d.set(this,!0),f.set(this,!1),b.set(this,this._register(new o.Emitter)),this.onDidDispose=De(this,b,"f").event,l.set(this,this._register(new o.Emitter)),this.onDidChangeViewState=De(this,l,"f").event,je(this,M,t,"f"),je(this,v,a,"f"),je(this,c,p,"f"),je(this,r,T,"f"),je(this,y,_,"f"),je(this,n,h,"f"),je(this,g,R,"f")}dispose(){De(this,f,"f")||(je(this,f,!0,"f"),De(this,b,"f").fire(),De(this,v,"f").$disposeWebview(De(this,M,"f")),De(this,g,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),De(this,g,"f")}get viewType(){return this.assertNotDisposed(),De(this,c,"f")}get title(){return this.assertNotDisposed(),De(this,n,"f")}set title(t){this.assertNotDisposed(),De(this,n,"f")!==t&&(je(this,n,t,"f"),De(this,v,"f").$setTitle(De(this,M,"f"),t))}get iconPath(){return this.assertNotDisposed(),De(this,m,"f")}set iconPath(t){this.assertNotDisposed(),De(this,m,"f")!==t&&(je(this,m,t,"f"),De(this,v,"f").$setIconPath(De(this,M,"f"),w.URI.isUri(t)?{light:t,dark:t}:t))}get options(){return De(this,r,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof De(this,y,"f")=="number"&&De(this,y,"f")<0))return De(this,y,"f")}get active(){return this.assertNotDisposed(),De(this,d,"f")}get visible(){return this.assertNotDisposed(),De(this,k,"f")}_updateViewState(t){De(this,f,"f")||(this.active!==t.active||this.visible!==t.visible||this.viewColumn!==t.viewColumn)&&(je(this,d,t.active,"f"),je(this,k,t.visible,"f"),je(this,y,t.viewColumn,"f"),De(this,l,"f").fire({webviewPanel:this}))}reveal(t,a){this.assertNotDisposed(),De(this,v,"f").$reveal(De(this,M,"f"),{viewColumn:typeof t=="undefined"?void 0:S.ViewColumn.from(t),preserveFocus:!!a})}assertNotDisposed(){if(De(this,f,"f"))throw new Error("Webview is disposed")}}M=new WeakMap,v=new WeakMap,c=new WeakMap,g=new WeakMap,r=new WeakMap,n=new WeakMap,m=new WeakMap,y=new WeakMap,k=new WeakMap,d=new WeakMap,f=new WeakMap,b=new WeakMap,l=new WeakMap;class u{constructor(t,a,p){this.webviews=a,this.workspace=p,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=t.getProxy(C.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,B.generateUuid)()}createWebviewPanel(t,a,p,h,_={}){const T=typeof h=="object"?h.viewColumn:h,R={viewColumn:S.ViewColumn.from(T),preserveFocus:typeof h=="object"&&!!h.preserveFocus},W=(0,A.shouldSerializeBuffersForPostMessage)(t),E=u.newHandle();this._proxy.$createWebviewPanel((0,A.toExtensionData)(t),E,a,{title:p,panelOptions:i(_),webviewOptions:(0,A.serializeWebviewOptions)(t,this.workspace,_),serializeBuffersForPostMessage:W},R);const H=this.webviews.createNewWebview(E,_,t);return this.createNewWebviewPanel(E,a,p,T,_,H)}$onDidChangeWebviewPanelViewStates(t){const a=Object.keys(t);a.sort((p,h)=>{const _=t[p],T=t[h];return _.active?1:T.active?-1:+_.visible-+T.visible});for(const p of a){const h=this.getWebviewPanel(p);if(!h)continue;const _=t[p];h._updateViewState({active:_.active,visible:_.visible,viewColumn:S.ViewColumn.to(_.position)})}}async $onDidDisposeWebviewPanel(t){this.getWebviewPanel(t)?.dispose(),this._webviewPanels.delete(t),this.webviews.deleteWebview(t)}registerWebviewPanelSerializer(t,a,p){if(this._serializers.has(a))throw new Error(`Serializer for '${a}' already registered`);return this._serializers.set(a,{serializer:p,extension:t}),this._proxy.$registerSerializer(a,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(t)}),new L.Disposable(()=>{this._serializers.delete(a),this._proxy.$unregisterSerializer(a)})}async $deserializeWebviewPanel(t,a,p,h){const _=this._serializers.get(a);if(!_)throw new Error(`No serializer found for '${a}'`);const{serializer:T,extension:R}=_,W=this.webviews.createNewWebview(t,p.webviewOptions,R),E=this.createNewWebviewPanel(t,a,p.title,h,p.panelOptions,W);await T.deserializeWebviewPanel(E,p.state)}createNewWebviewPanel(t,a,p,h,_,T){const R=new P(t,this._proxy,a,p,h,_,T);return this._webviewPanels.set(t,R),R}getWebviewPanel(t){return this._webviewPanels.get(t)}}e.ExtHostWebviewPanels=u;function i(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var je=this&&this.__classPrivateFieldSet||function(Y,e,o,I,w){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!w:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?w.call(Y,o):w?w.value=o:e.set(Y,o),o},De=this&&this.__classPrivateFieldGet||function(Y,e,o,I){if(o==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?I:o==="a"?I.call(Y):I?I.value:e.get(Y)};define(Ee[209],be([1,0,5,6,51,4,7]),function(Y,e,o,I,w,B,S){"use strict";var A,C,L,M,v,c,g,r,n,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class y extends I.Disposable{constructor(f,b,l,P,u,i){super();A.set(this,void 0),C.set(this,void 0),L.set(this,void 0),M.set(this,void 0),v.set(this,!1),c.set(this,void 0),g.set(this,void 0),r.set(this,void 0),n.set(this,this._register(new o.Emitter)),this.onDidChangeVisibility=De(this,n,"f").event,m.set(this,this._register(new o.Emitter)),this.onDidDispose=De(this,m,"f").event,je(this,L,l,"f"),je(this,g,P,"f"),je(this,A,f,"f"),je(this,C,b,"f"),je(this,M,u,"f"),je(this,c,i,"f")}dispose(){De(this,v,"f")||(je(this,v,!0,"f"),De(this,m,"f").fire(),De(this,M,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),De(this,g,"f")}set title(f){this.assertNotDisposed(),De(this,g,"f")!==f&&(je(this,g,f,"f"),De(this,C,"f").$setWebviewViewTitle(De(this,A,"f"),f))}get description(){return this.assertNotDisposed(),De(this,r,"f")}set description(f){this.assertNotDisposed(),De(this,r,"f")!==f&&(je(this,r,f,"f"),De(this,C,"f").$setWebviewViewDescription(De(this,A,"f"),f))}get visible(){return De(this,c,"f")}get webview(){return De(this,M,"f")}get viewType(){return De(this,L,"f")}_setVisible(f){f===De(this,c,"f")||De(this,v,"f")||(je(this,c,f,"f"),De(this,n,"f").fire())}show(f){this.assertNotDisposed(),De(this,C,"f").$show(De(this,A,"f"),!!f)}assertNotDisposed(){if(De(this,v,"f"))throw new Error("Webview is disposed")}}A=new WeakMap,C=new WeakMap,L=new WeakMap,M=new WeakMap,v=new WeakMap,c=new WeakMap,g=new WeakMap,r=new WeakMap,n=new WeakMap,m=new WeakMap;class k{constructor(f,b){this._extHostWebview=b,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=f.getProxy(B.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(f,b,l,P){if(this._viewProviders.has(b))throw new Error(`View provider for '${b}' already registered`);return this._viewProviders.set(b,{provider:l,extension:f}),this._proxy.$registerWebviewViewProvider((0,w.toExtensionData)(f),b,{retainContextWhenHidden:P?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new S.Disposable(()=>{this._viewProviders.delete(b),this._proxy.$unregisterWebviewViewProvider(b)})}async $resolveWebviewView(f,b,l,P,u){const i=this._viewProviders.get(b);if(!i)throw new Error(`No view provider found for '${b}'`);const{provider:s,extension:t}=i,a=this._extHostWebview.createNewWebview(f,{},t),p=new y(f,this._proxy,b,l,a,!0);this._webviewViews.set(f,p),await s.resolveWebviewView(p,{state:P},u)}async $onDidChangeWebviewViewVisibility(f,b){this.getWebviewView(f)._setVisible(b)}async $disposeWebviewView(f){const b=this.getWebviewView(f);this._webviewViews.delete(f),b.dispose(),this._extHostWebview.deleteWebview(f)}getWebviewView(f){const b=this._webviewViews.get(f);if(!b)throw new Error("No webview found");return b}}e.ExtHostWebviewViews=k}),define(Ee[95],be([1,0,5,4,2,9,10,3,14]),function(Y,e,o,I,w,B,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let L=class ji{constructor(v){this._onDidChangeWindowState=new o.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=ji.InitialState,this._proxy=v.getProxy(I.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(c=>this.$onDidChangeWindowFocus(c))}get state(){return this._state}$onDidChangeWindowFocus(v){v!==this._state.focused&&(this._state={...this._state,focused:v},this._onDidChangeWindowState.fire(this._state))}openUri(v,c){let g;if(typeof v=="string"){g=v;try{v=w.URI.parse(v)}catch{return Promise.reject(`Invalid uri - '${v}'`)}}return(0,S.isFalsyOrWhitespace)(v.scheme)?Promise.reject("Invalid scheme - cannot be empty"):v.scheme===B.Schemas.command?Promise.reject(`Invalid scheme '${v.scheme}'`):this._proxy.$openUri(v,g,c)}async asExternalUri(v,c){if((0,S.isFalsyOrWhitespace)(v.scheme))return Promise.reject("Invalid scheme - cannot be empty");const g=await this._proxy.$asExternalUri(v,c);return w.URI.from(g)}};L.InitialState={focused:!0},L=Fe([Ne(0,C.IExtHostRpcService)],L),e.ExtHostWindow=L,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(Ee[210],be([1,0,13,21,20,15,5,6,108,176,38]),function(Y,e,o,I,w,B,S,A,C,L,M){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function c(_,T){try{return JSON.stringify(_,T)}catch{return"null"}}const g="$$ref$$",r={[g]:-1};class n{constructor(T,R){this.jsonString=T,this.referencedBuffers=R}}function m(_,T=null,R=!1){const W=[];return{jsonString:(R?c:JSON.stringify)(_,(H,q)=>{if(typeof q=="undefined")return r;if(typeof q=="object"){if(q instanceof I.VSBuffer){const $=W.push(q)-1;return{[g]:$}}if(T)return T(H,q)}return q}),referencedBuffers:W}}e.stringifyJsonWithBufferRefs=m;function y(_,T,R){return JSON.parse(_,(W,E)=>{if(E){const H=E[g];if(typeof H=="number")return T[H];if(R&&E.$mid===1)return R.transformIncoming(E)}return E})}e.parseJsonAndRestoreBufferRefs=y;function k(_,T){return JSON.stringify(_,T)}function d(_){return _?(T,R)=>R&&R.$mid===1?_.transformOutgoing(R):R:null}var f;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));var b;(function(_){_[_.Responsive=0]="Responsive",_[_.Unresponsive=1]="Unresponsive"})(b=e.ResponsiveState||(e.ResponsiveState={}));const l=()=>{},P=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class i extends A.Disposable{constructor(T,R=null,W=null){super();this[v]=!0,this._onDidChangeResponsiveState=this._register(new S.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=T,this._logger=R,this._uriTransformer=W,this._uriReplacer=d(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let E=0,H=M.ProxyIdentifier.count;E<H;E++)this._locals[E]=null,this._proxies[E]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new o.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(E=>this._receiveOneMessage(E))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(T=>{this._pendingRPCReplies[T].resolveErr(B.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(T){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(T){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(T){this._responsiveState!==T&&(this._responsiveState=T,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(T){return this._uriTransformer?(0,C.transformIncomingURIs)(T,this._uriTransformer):T}getProxy(T){const{nid:R,sid:W}=T;return this._proxies[R]||(this._proxies[R]=this._createProxy(R,W)),this._proxies[R]}_createProxy(T,R){let W={get:(E,H)=>(typeof H=="string"&&!E[H]&&H.charCodeAt(0)===36&&(E[H]=(...q)=>this._remoteCall(T,H,q)),H===u?R:E[H])};return new Proxy(Object.create(null),W)}set(T,R){return this._locals[T.nid]=R,R}assertRegistered(T){for(let R=0,W=T.length;R<W;R++){const E=T[R];if(!this._locals[E.nid])throw new Error(`Missing proxy instance ${E.sid}`)}}_receiveOneMessage(T){if(this._isDisposed)return;const R=T.byteLength,W=s.read(T,0),E=W.readUInt8(),H=W.readUInt32();switch(E){case 1:case 2:{let{rpcId:q,method:$,args:j}=a.deserializeRequestJSONArgs(W);this._uriTransformer&&(j=(0,C.transformIncomingURIs)(j,this._uriTransformer)),this._receiveRequest(R,H,q,$,j,E===2);break}case 3:case 4:{let{rpcId:q,method:$,args:j}=a.deserializeRequestMixedArgs(W);this._uriTransformer&&(j=(0,C.transformIncomingURIs)(j,this._uriTransformer)),this._receiveRequest(R,H,q,$,j,E===4);break}case 5:{this._logger&&this._logger.logIncoming(R,H,0,"ack"),this._onDidReceiveAcknowledge(H);break}case 6:{this._receiveCancel(R,H);break}case 7:{this._receiveReply(R,H,void 0);break}case 9:{let q=a.deserializeReplyOKJSON(W);this._uriTransformer&&(q=(0,C.transformIncomingURIs)(q,this._uriTransformer)),this._receiveReply(R,H,q);break}case 10:{const q=a.deserializeReplyOKJSONWithBuffers(W,this._uriTransformer);this._receiveReply(R,H,q);break}case 8:{let q=a.deserializeReplyOKVSBuffer(W);this._receiveReply(R,H,q);break}case 11:{let q=a.deserializeReplyErrError(W);this._uriTransformer&&(q=(0,C.transformIncomingURIs)(q,this._uriTransformer)),this._receiveReplyErr(R,H,q);break}case 12:{this._receiveReplyErr(R,H,void 0);break}default:console.error("received unexpected message"),console.error(T)}}_receiveRequest(T,R,W,E,H,q){this._logger&&this._logger.logIncoming(T,R,1,`receiveRequest ${(0,M.getStringIdentifierForProxy)(W)}.${E}(`,H);const $=String(R);let j,J;if(q){const ie=new w.CancellationTokenSource;H.push(ie.token),j=this._invokeHandler(W,E,H),J=()=>ie.cancel()}else j=this._invokeHandler(W,E,H),J=l;this._cancelInvokedHandlers[$]=J;const z=a.serializeAcknowledged(R);this._logger&&this._logger.logOutgoing(z.byteLength,R,1,"ack"),this._protocol.send(z),j.then(ie=>{delete this._cancelInvokedHandlers[$];const ae=a.serializeReplyOK(R,ie,this._uriReplacer);this._logger&&this._logger.logOutgoing(ae.byteLength,R,1,"reply:",ie),this._protocol.send(ae)},ie=>{delete this._cancelInvokedHandlers[$];const ae=a.serializeReplyErr(R,ie);this._logger&&this._logger.logOutgoing(ae.byteLength,R,1,"replyErr:",ie),this._protocol.send(ae)})}_receiveCancel(T,R){this._logger&&this._logger.logIncoming(T,R,1,"receiveCancel");const W=String(R);this._cancelInvokedHandlers[W]&&this._cancelInvokedHandlers[W]()}_receiveReply(T,R,W){this._logger&&this._logger.logIncoming(T,R,0,"receiveReply:",W);const E=String(R);if(!this._pendingRPCReplies.hasOwnProperty(E))return;const H=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E],H.resolveOk(W)}_receiveReplyErr(T,R,W){this._logger&&this._logger.logIncoming(T,R,0,"receiveReplyErr:",W);const E=String(R);if(!this._pendingRPCReplies.hasOwnProperty(E))return;const H=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E];let q;W&&(W.$isError?(q=new Error,q.name=W.name,q.message=W.message,q.stack=W.stack):q=W),H.resolveErr(q)}_invokeHandler(T,R,W){try{return Promise.resolve(this._doInvokeHandler(T,R,W))}catch(E){return Promise.reject(E)}}_doInvokeHandler(T,R,W){const E=this._locals[T];if(!E)throw new Error("Unknown actor "+(0,M.getStringIdentifierForProxy)(T));let H=E[R];if(typeof H!="function")throw new Error("Unknown method "+R+" on actor "+(0,M.getStringIdentifierForProxy)(T));return H.apply(E,W)}_remoteCall(T,R,W){if(this._isDisposed)return Promise.reject(B.canceled());let E=null;if(W.length>0&&w.CancellationToken.isCancellationToken(W[W.length-1])&&(E=W.pop()),E&&E.isCancellationRequested)return Promise.reject(B.canceled());const H=a.serializeRequestArguments(W,this._uriReplacer),q=++this._lastMessageId,$=String(q),j=new L.LazyPromise;E&&E.onCancellationRequested(()=>{const z=a.serializeCancel(q);this._logger&&this._logger.logOutgoing(z.byteLength,q,0,"cancel"),this._protocol.send(a.serializeCancel(q))}),this._pendingRPCReplies[$]=j,this._onWillSendRequest(q);const J=a.serializeRequest(q,T,R,H,!!E);return this._logger&&this._logger.logOutgoing(J.byteLength,q,0,`request: ${(0,M.getStringIdentifierForProxy)(T)}.${R}(`,W),this._protocol.send(J),j}}e.RPCProtocol=i,v=P,i.UNRESPONSIVE_TIME=3*1e3;class s{constructor(T,R){this._buff=T,this._offset=R}static alloc(T,R,W){let E=new s(I.VSBuffer.alloc(W+1+4),0);return E.writeUInt8(T),E.writeUInt32(R),E}static read(T,R){return new s(T,R)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(T){this._buff.writeUInt8(T,this._offset),this._offset+=1}readUInt8(){const T=this._buff.readUInt8(this._offset);return this._offset+=1,T}writeUInt32(T){this._buff.writeUInt32BE(T,this._offset),this._offset+=4}readUInt32(){const T=this._buff.readUInt32BE(this._offset);return this._offset+=4,T}static sizeShortString(T){return 1+T.byteLength}writeShortString(T){this._buff.writeUInt8(T.byteLength,this._offset),this._offset+=1,this._buff.set(T,this._offset),this._offset+=T.byteLength}readShortString(){const T=this._buff.readUInt8(this._offset);this._offset+=1;const W=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,W}static sizeLongString(T){return 4+T.byteLength}writeLongString(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readLongString(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const W=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,W}writeBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}static sizeVSBuffer(T){return 4+T.byteLength}writeVSBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readVSBuffer(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const R=this._buff.slice(this._offset,this._offset+T);return this._offset+=T,R}static sizeMixedArray(T){let R=0;R+=1;for(let W=0,E=T.length;W<E;W++){const H=T[W];switch(R+=1,H.type){case 1:R+=this.sizeLongString(H.value);break;case 2:R+=this.sizeVSBuffer(H.value);break;case 3:R+=this.sizeUInt32,R+=this.sizeLongString(H.value);for(let q=0;q<H.buffers.length;++q)R+=this.sizeVSBuffer(H.buffers[q]);break;case 4:break}}return R}writeMixedArray(T){this._buff.writeUInt8(T.length,this._offset),this._offset+=1;for(let R=0,W=T.length;R<W;R++){const E=T[R];switch(E.type){case 1:this.writeUInt8(1),this.writeLongString(E.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(E.value);break;case 3:this.writeUInt8(3),this.writeUInt32(E.buffers.length),this.writeLongString(E.value);for(let H=0;H<E.buffers.length;++H)this.writeBuffer(E.buffers[H]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const T=this._buff.readUInt8(this._offset);this._offset+=1;let R=new Array(T);for(let W=0;W<T;W++)switch(this.readUInt8()){case 1:R[W]=this.readLongString();break;case 2:R[W]=this.readVSBuffer();break;case 3:{const H=this.readUInt32(),q=this.readLongString(),$=[];for(let j=0;j<H;++j)$.push(this.readVSBuffer());R[W]=new M.SerializableObjectWithBuffers(y(q,$,null));break}case 4:R[W]=void 0;break}return R}}s.sizeUInt32=4;var t;(function(_){_[_.Simple=0]="Simple",_[_.Mixed=1]="Mixed"})(t||(t={}));class a{static _useMixedArgSerialization(T){for(let R=0,W=T.length;R<W;R++)if(T[R]instanceof I.VSBuffer||T[R]instanceof M.SerializableObjectWithBuffers||typeof T[R]=="undefined")return!0;return!1}static serializeRequestArguments(T,R){if(this._useMixedArgSerialization(T)){const W=[];for(let E=0,H=T.length;E<H;E++){const q=T[E];if(q instanceof I.VSBuffer)W[E]={type:2,value:q};else if(typeof q=="undefined")W[E]={type:4};else if(q instanceof M.SerializableObjectWithBuffers){const{jsonString:$,referencedBuffers:j}=m(q.value,R);W[E]={type:3,value:I.VSBuffer.fromString($),buffers:j}}else W[E]={type:1,value:I.VSBuffer.fromString(k(q,R))}}return{type:1,args:W}}return{type:0,args:k(T,R)}}static serializeRequest(T,R,W,E,H){switch(E.type){case 0:return this._requestJSONArgs(T,R,W,E.args,H);case 1:return this._requestMixedArgs(T,R,W,E.args,H)}}static _requestJSONArgs(T,R,W,E,H){const q=I.VSBuffer.fromString(W),$=I.VSBuffer.fromString(E);let j=0;j+=s.sizeUInt8(),j+=s.sizeShortString(q),j+=s.sizeLongString($);let J=s.alloc(H?2:1,T,j);return J.writeUInt8(R),J.writeShortString(q),J.writeLongString($),J.buffer}static deserializeRequestJSONArgs(T){const R=T.readUInt8(),W=T.readShortString(),E=T.readLongString();return{rpcId:R,method:W,args:JSON.parse(E)}}static _requestMixedArgs(T,R,W,E,H){const q=I.VSBuffer.fromString(W);let $=0;$+=s.sizeUInt8(),$+=s.sizeShortString(q),$+=s.sizeMixedArray(E);let j=s.alloc(H?4:3,T,$);return j.writeUInt8(R),j.writeShortString(q),j.writeMixedArray(E),j.buffer}static deserializeRequestMixedArgs(T){const R=T.readUInt8(),W=T.readShortString(),E=T.readMixedArray(),H=new Array(E.length);for(let q=0,$=E.length;q<$;q++){const j=E[q];typeof j=="string"?H[q]=JSON.parse(j):H[q]=j}return{rpcId:R,method:W,args:H}}static serializeAcknowledged(T){return s.alloc(5,T,0).buffer}static serializeCancel(T){return s.alloc(6,T,0).buffer}static serializeReplyOK(T,R,W){if(typeof R=="undefined")return this._serializeReplyOKEmpty(T);if(R instanceof I.VSBuffer)return this._serializeReplyOKVSBuffer(T,R);if(R instanceof M.SerializableObjectWithBuffers){const{jsonString:E,referencedBuffers:H}=m(R.value,W,!0);return this._serializeReplyOKJSONWithBuffers(T,E,H)}else return this._serializeReplyOKJSON(T,c(R,W))}static _serializeReplyOKEmpty(T){return s.alloc(7,T,0).buffer}static _serializeReplyOKVSBuffer(T,R){let W=0;W+=s.sizeVSBuffer(R);let E=s.alloc(8,T,W);return E.writeVSBuffer(R),E.buffer}static deserializeReplyOKVSBuffer(T){return T.readVSBuffer()}static _serializeReplyOKJSON(T,R){const W=I.VSBuffer.fromString(R);let E=0;E+=s.sizeLongString(W);let H=s.alloc(9,T,E);return H.writeLongString(W),H.buffer}static _serializeReplyOKJSONWithBuffers(T,R,W){const E=I.VSBuffer.fromString(R);let H=0;H+=s.sizeUInt32,H+=s.sizeLongString(E);for(const $ of W)H+=s.sizeVSBuffer($);let q=s.alloc(10,T,H);q.writeUInt32(W.length),q.writeLongString(E);for(const $ of W)q.writeBuffer($);return q.buffer}static deserializeReplyOKJSON(T){const R=T.readLongString();return JSON.parse(R)}static deserializeReplyOKJSONWithBuffers(T,R){const W=T.readUInt32(),E=T.readLongString(),H=[];for(let q=0;q<W;++q)H.push(T.readVSBuffer());return new M.SerializableObjectWithBuffers(y(E,H,R))}static serializeReplyErr(T,R){return R?this._serializeReplyErrEror(T,R):this._serializeReplyErrEmpty(T)}static _serializeReplyErrEror(T,R){const W=I.VSBuffer.fromString(c(B.transformErrorForSerialization(R),null));let E=0;E+=s.sizeLongString(W);let H=s.alloc(11,T,E);return H.writeLongString(W),H.buffer}static deserializeReplyErrError(T){const R=T.readLongString();return JSON.parse(R)}static _serializeReplyErrEmpty(T){return s.alloc(12,T,0).buffer}}var p;(function(_){_[_.RequestJSONArgs=1]="RequestJSONArgs",_[_.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",_[_.RequestMixedArgs=3]="RequestMixedArgs",_[_.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",_[_.Acknowledged=5]="Acknowledged",_[_.Cancel=6]="Cancel",_[_.ReplyOKEmpty=7]="ReplyOKEmpty",_[_.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",_[_.ReplyOKJSON=9]="ReplyOKJSON",_[_.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",_[_.ReplyErrError=11]="ReplyErrError",_[_.ReplyErrEmpty=12]="ReplyErrEmpty"})(p||(p={}));var h;(function(_){_[_.String=1]="String",_[_.VSBuffer=2]="VSBuffer",_[_.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",_[_.Undefined=4]="Undefined"})(h||(h={}))}),define(Ee[211],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const o=function(B){const S=A=>{self.removeEventListener("message",S);const C=A.data;Object.defineProperties(self,{postMessage:{value(L,M){C.postMessage(L,M)}},onmessage:{get(){return C.onmessage},set(L){C.onmessage=L}}}),C.addEventListener("message",L=>{self.dispatchEvent(new MessageEvent("message",{data:L.data}))}),C.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(B)};self.addEventListener("message",S)}.toString();class I extends EventTarget{constructor(B,S,A){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const C=`((${o})('${S}'))`,L=new Blob([C],{type:"application/javascript"}),M=URL.createObjectURL(L),v=new MessageChannel,c=M,g={type:"_newWorker",id:c,port:v.port2,url:M,options:A};B(g,[v.port2]),this.postMessage=v.port1.postMessage.bind(v.port1),this.terminate=()=>{const r={type:"_terminateWorker",id:c};v.port1.postMessage(r),URL.revokeObjectURL(M),v.port1.close(),v.port2.close()},Object.defineProperties(this,{onmessage:{get(){return v.port1.onmessage},set(r){v.port1.onmessage=r}},onmessageerror:{get(){return v.port1.onmessageerror},set(r){v.port1.onmessageerror=r}}}),v.port1.addEventListener("messageerror",r=>{const n=new MessageEvent("messageerror",{data:r.data});this.dispatchEvent(n)}),v.port1.addEventListener("message",r=>{const n=new MessageEvent("message",{data:r.data});this.dispatchEvent(n)}),v.port1.start()}}e.NestedWorker=I}),define(Ee[212],be([1,0,3]),function(Y,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,o.createDecorator)("remoteAgentService")}),define(Ee[213],be([1,0,35,9,17,23,24,2,3,148,46,172,212]),function(Y,e,o,I,w,B,S,A,C,L,M,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,C.createDecorator)("pathService");let g=class qi{constructor(n,m,y,k){this.localUserHome=n,this.remoteAgentService=m,this.environmentService=y,this.contextService=k,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||B.OS)(),this.resolveUserHome=(async()=>{const d=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=d?.userHome||n})()}hasValidBasename(n,m,y){return typeof m=="string"||typeof m=="undefined"?this.resolveOS.then(k=>this.doHasValidBasename(n,k,m)):this.doHasValidBasename(n,m,y)}doHasValidBasename(n,m,y){return n.scheme===I.Schemas.file||n.scheme===I.Schemas.vscodeRemote?(0,o.isValidBasename)(y??(0,S.basename)(n),m===1):!0}get defaultUriScheme(){return qi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(n,m){if(n.remoteAuthority)return I.Schemas.vscodeRemote;const y=(0,L.getVirtualWorkspaceScheme)(m.getWorkspace());if(y)return y;const k=m.getWorkspace().folders[0];if(k)return k.uri.scheme;const d=m.getWorkspace().configuration;return d?d.scheme:I.Schemas.file}async userHome(n){return n?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(n=>n===1?w.win32:w.posix)}async fileURI(n){let m="";if(await this.resolveOS===1&&(n=n.replace(/\\/g,"/")),n[0]==="/"&&n[1]==="/"){const k=n.indexOf("/",2);k===-1?(m=n.substring(2),n="/"):(m=n.substring(2,k),n=n.substring(k)||"/")}return A.URI.from({scheme:I.Schemas.file,authority:m,path:n,query:"",fragment:""})}};g=Fe([Ne(1,c.IRemoteAgentService),Ne(2,v.IWorkbenchEnvironmentService),Ne(3,M.IWorkspaceContextService)],g),e.AbstractPathService=g}),define(Ee[96],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class o{constructor(S,A){this.line=S,this.character=A}isBefore(S){return!1}isBeforeOrEqual(S){return!1}isAfter(S){return!1}isAfterOrEqual(S){return!1}isEqual(S){return!1}compareTo(S){return 0}translate(S,A){return new o(0,0)}with(S){return new o(0,0)}}e.Position=o;class I{constructor(S,A,C,L){this.isEmpty=!1,this.isSingleLine=!1,this.start=new o(S,A),this.end=new o(C,L)}contains(S){return!1}isEqual(S){return!1}intersection(S){}union(S){return new I(0,0,0,0)}with(S){return new I(0,0,0,0)}}e.Range=I;var w;(function(B){B[B.Information=1]="Information",B[B.Warning=2]="Warning"})(w=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ee[41],be([1,0,16,29,26,35,10,3,17,15,96,13]),function(Y,e,o,I,w,B,S,A,C,L,M,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return M.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const c="\u27EA ",g=" characters skipped \u27EB",r=(c.length+g.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var n;(function(z){z[z.file=0]="file",z[z.text=1]="text"})(n=e.SearchProviderType||(e.SearchProviderType={}));var m;(function(z){z[z.File=1]="File",z[z.Text=2]="Text"})(m=e.QueryType||(e.QueryType={}));function y(z){return!!z.preview}e.resultIsMatch=y;function k(z){return!!z.resource}e.isFileMatch=k;function d(z){return!!z.message}e.isProgressMessage=d;var f;(function(z){z[z.Normal=0]="Normal",z[z.NewSearchStarted=1]="NewSearchStarted"})(f=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class b{constructor(ie){this.resource=ie,this.results=[]}}e.FileMatch=b;class l{constructor(ie,ae,te){this.ranges=ae;const ce=Array.isArray(ae)?ae:[ae];if(te&&te.matchLines===1&&P(ce)){ie=(0,S.getNLines)(ie,te.matchLines);let de="",Se=0,fe=0;const ne=Math.floor(te.charsPerLine/5),me=[];for(const ke of ce){const Ae=Math.max(ke.startColumn-ne,0),Be=ke.startColumn+te.charsPerLine;if(Ae>fe+ne+r){const Xe=c+(Ae-fe)+g;de+=Xe+ie.slice(Ae,Be),Se+=Ae-(fe+Xe.length)}else de+=ie.slice(fe,Be);me.push(new i(0,ke.startColumn-Se,ke.endColumn-Se)),fe=Be}this.preview={text:de,matches:Array.isArray(this.ranges)?me:me[0]}}else{const de=Array.isArray(ae)?ae[0].startLineNumber:ae.startLineNumber;this.preview={text:ie,matches:(0,o.mapArrayOrNot)(ae,Se=>new u(Se.startLineNumber-de,Se.startColumn,Se.endLineNumber-de,Se.endColumn))}}}}e.TextSearchMatch=l;function P(z){const ie=z[0].startLineNumber;for(const ae of z)if(ae.startLineNumber!==ie||ae.endLineNumber!==ie)return!1;return!0}class u{constructor(ie,ae,te,ce){this.startLineNumber=ie,this.startColumn=ae,this.endLineNumber=te,this.endColumn=ce}}e.SearchRange=u;class i extends u{constructor(ie,ae,te){super(ie,ae,ie,te)}}e.OneLineRange=i;var s;(function(z){z.Default="default",z.FileNames="fileNames",z.Type="type",z.Modified="modified",z.CountDescending="countDescending",z.CountAscending="countAscending"})(s=e.SearchSortOrder||(e.SearchSortOrder={}));function t(z,ie=!0){const ae=z&&z.files&&z.files.exclude,te=ie&&z&&z.search&&z.search.exclude;if(!ae&&!te)return;if(!ae||!te)return ae||te;let ce=Object.create(null);return ce=w.mixin(ce,w.deepClone(ae)),ce=w.mixin(ce,w.deepClone(te),!0),ce}e.getExcludes=t;function a(z,ie){return z.excludePattern&&I.match(z.excludePattern,ie)?!1:z.includePattern||z.usingSearchPaths?z.includePattern&&I.match(z.includePattern,ie)?!0:z.usingSearchPaths?!!z.folderQueries&&z.folderQueries.some(ae=>{const te=ae.folder.fsPath;if(B.isEqualOrParent(ie,te)){const ce=C.relative(te,ie);return!ae.includePattern||!!I.match(ae.includePattern,ce)}else return!1}):!1:!0}e.pathIncludedInQuery=a;var p;(function(z){z[z.unknownEncoding=1]="unknownEncoding",z[z.regexParseError=2]="regexParseError",z[z.globParseError=3]="globParseError",z[z.invalidLiteral=4]="invalidLiteral",z[z.rgProcessError=5]="rgProcessError",z[z.other=6]="other",z[z.canceled=7]="canceled"})(p=e.SearchErrorCode||(e.SearchErrorCode={}));class h extends Error{constructor(ie,ae){super(ie);this.code=ae}}e.SearchError=h;function _(z){const ie=z.message;if((0,L.isCancellationError)(z))return new h(ie,p.canceled);try{const ae=JSON.parse(ie);return new h(ae.message,ae.code)}catch{return new h(ie,p.other)}}e.deserializeSearchError=_;function T(z){const ie={message:z.message,code:z.code};return new Error(JSON.stringify(ie))}e.serializeSearchError=T;function R(z){return z.type==="error"?!0:z.type==="success"}e.isSerializedSearchComplete=R;function W(z){return z.type==="success"}e.isSerializedSearchSuccess=W;function E(z){return!!z.path}e.isSerializedFileMatch=E;function H(z,ie){const ae=z.searchPath?z.searchPath:z.relativePath;return(0,S.fuzzyContains)(ae,ie)}e.isFilePatternMatch=H;class q{constructor(ie){this.path=ie,this.results=[]}addMatch(ie){this.results.push(ie)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=q;function $(z,ie){const ae={...z||{},...ie||{}};return Object.keys(ae).filter(te=>{const ce=ae[te];return typeof ce=="boolean"&&ce})}e.resolvePatternsForProvider=$;class j{constructor(ie,ae){this._parsedIncludeExpression=null,this._excludeExpression={...ie.excludePattern||{},...ae.excludePattern||{}},this._parsedExcludeExpression=I.parse(this._excludeExpression);let te=ie.includePattern;ae.includePattern&&(te?te={...te,...ae.includePattern}:te=ae.includePattern),te&&(this._parsedIncludeExpression=I.parse(te))}matchesExcludesSync(ie,ae,te){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ie,ae,te))}includedInQuerySync(ie,ae,te){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ie,ae,te)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ie,ae,te))}includedInQuery(ie,ae,te){const ce=this._parsedExcludeExpression(ie,ae,te),de=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ie,ae,te):!0;return(0,v.isThenable)(ce)?ce.then(Se=>Se?!1:de()):de()}hasSiblingExcludeClauses(){return J(this._excludeExpression)}}e.QueryGlobTester=j;function J(z){for(const ie in z)if(typeof z[ie]!="boolean")return!0;return!1}}),define(Ee[31],be([1,0,16,13,20,5,22,9,102,24,10,11,2,128,3,12,140,46,30,27,14,8,7,41,4]),function(Y,e,o,I,w,B,S,A,C,L,M,v,c,g,r,n,m,y,k,d,f,b,l,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function i(R,W,E){return new L.ExtUri(H=>p(H,E)).isEqual(R,W)}function s(R,W,E){return i(R.uri,W.uri,E)?0:(0,M.compare)(R.uri.toString(),W.uri.toString())}function t(R,W,E){return R.index!==W.index?R.index<W.index?-1:1:i(R.uri,W.uri,E)?(0,M.compare)(R.name,W.name):(0,M.compare)(R.uri.toString(),W.uri.toString())}function a(R,W,E,H){const q=R.slice(0).sort((j,J)=>E(j,J,H)),$=W.slice(0).sort((j,J)=>E(j,J,H));return(0,o.delta)(q,$,(j,J)=>E(j,J,H))}function p(R,W){const E=W.getCapabilities(R.scheme);return!(E&&E&1024)}class h extends y.Workspace{constructor(W,E,H,q,$,j,J){super(W,H.map(z=>new y.WorkspaceFolder(z)),q,$,J);this._name=E,this._isUntitled=j,this._workspaceFolders=[],this._structure=S.TernarySearchTree.forUris(J),H.forEach(z=>{this._workspaceFolders.push(z),this._structure.set(z.uri,z)})}static toExtHostWorkspace(W,E,H,q){if(!W)return{workspace:null,added:[],removed:[]};const{id:$,name:j,folders:J,configuration:z,transient:ie,isUntitled:ae}=W,te=[],ce=E;E?J.forEach((ne,me)=>{const ke=c.URI.revive(ne.uri),Ae=h._findFolder(H||E,ke,q);Ae?(Ae.name=ne.name,Ae.index=ne.index,te.push(Ae)):te.push({uri:ke,name:ne.name,index:me})}):te.push(...J.map(({uri:ne,name:me,index:ke})=>({uri:c.URI.revive(ne),name:me,index:ke}))),te.sort((ne,me)=>ne.index<me.index?-1:1);const de=new h($,j,te,!!ie,z?c.URI.revive(z):null,!!ae,ne=>p(ne,q)),{added:Se,removed:fe}=a(ce?ce.workspaceFolders:[],de.workspaceFolders,s,q);return{workspace:de,added:Se,removed:fe}}static _findFolder(W,E,H){for(let q=0;q<W.folders.length;q++){const $=W.workspaceFolders[q];if(i($.uri,E,H))return $}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(W,E){return E&&this._structure.get(W)&&(W=(0,L.dirname)(W)),this._structure.findSubstr(W)}resolveWorkspaceFolder(W){return this._structure.get(W)}}let _=class{constructor(W,E,H,q){this._onDidChangeWorkspace=new B.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new B.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=q,this._extHostFileSystemInfo=H,this._requestIdProvider=new C.Counter,this._barrier=new I.Barrier,this._proxy=W.getProxy(u.MainContext.MainThreadWorkspace),this._messageService=W.getProxy(u.MainContext.MainThreadMessageService);const $=E.workspace;this._confirmedWorkspace=$?new h($.id,$.name,[],!!$.transient,$.configuration?c.URI.revive($.configuration):null,!!$.isUntitled,j=>p(j,H)):void 0}$initializeWorkspace(W,E){this._trusted=E,this.$acceptWorkspaceData(W),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?c.URI.from({scheme:A.Schemas.untitled,path:(0,L.basename)((0,L.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(W,E,H,...q){const $=[];if(Array.isArray(q)&&q.forEach(ae=>{c.URI.isUri(ae.uri)&&!$.some(te=>i(te.uri,ae.uri,this._extHostFileSystemInfo))&&$.push({uri:ae.uri,name:ae.name||(0,L.basenameOrAuthority)(ae.uri)})}),this._unconfirmedWorkspace||[E,H].some(ae=>typeof ae!="number"||ae<0)||H===0&&$.length===0)return!1;const j=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(E+H>j.length)return!1;const J=j.slice(0);J.splice(E,H,...$.map(ae=>({uri:ae.uri,name:ae.name||(0,L.basenameOrAuthority)(ae.uri),index:void 0})));for(let ae=0;ae<J.length;ae++){const te=J[ae];if(J.some((ce,de)=>de!==ae&&i(te.uri,ce.uri,this._extHostFileSystemInfo)))return!1}J.forEach((ae,te)=>ae.index=te);const{added:z,removed:ie}=a(j,J,t,this._extHostFileSystemInfo);if(z.length===0&&ie.length===0)return!1;if(this._proxy){const ae=W.displayName||W.name;this._proxy.$updateWorkspaceFolders(ae,E,H,$).then(void 0,te=>{this._unconfirmedWorkspace=void 0;const ce={source:{identifier:W.identifier,label:W.displayName||W.name}};this._messageService.$showMessage(m.Severity.Error,(0,g.localize)(0,null,ae,te.toString()),ce,[])})}return this.trySetWorkspaceFolders(J),!0}getWorkspaceFolder(W,E){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(W,E)}async getWorkspaceFolder2(W,E){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(W,E)}async resolveWorkspaceFolder(W){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(W)}getPath(){if(!this._actualWorkspace)return;const{folders:W}=this._actualWorkspace;if(W.length!==0)return W[0].uri.fsPath}getRelativePath(W,E){let H,q="";if(typeof W=="string"?(H=c.URI.file(W),q=W):typeof W!="undefined"&&(H=W,q=W.fsPath),!H)return q;const $=this.getWorkspaceFolder(H,!0);if(!$)return q;typeof E=="undefined"&&this._actualWorkspace&&(E=this._actualWorkspace.folders.length>1);let j=(0,L.relativePath)($.uri,H);return E&&$.name&&(j=`${$.name}/${j}`),j}trySetWorkspaceFolders(W){this._actualWorkspace&&(this._unconfirmedWorkspace=h.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:W,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(W){const{workspace:E,added:H,removed:q}=h.toExtHostWorkspace(W,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=E||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:H,removed:q}))}findFiles(W,E,H,q,$=w.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${q.value}, entryPoint: findFiles`);let j;if(E===null?j=!1:E&&(typeof E=="string"?j=E:j=E.pattern),$&&$.isCancellationRequested)return Promise.resolve([]);const{includePattern:J,folder:z}=T(b.GlobPattern.from(W));return this._proxy.$startFileSearch((0,v.withUndefinedAsNull)(J),(0,v.withUndefinedAsNull)(z),(0,v.withUndefinedAsNull)(j),(0,v.withUndefinedAsNull)(H),$).then(ie=>Array.isArray(ie)?ie.map(ae=>c.URI.revive(ae)):[])}async findTextInFiles(W,E,H,q,$=w.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${q.value}, entryPoint: findTextInFiles`);const j=this._requestIdProvider.getNext(),J=typeof E.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:E.previewOptions,{includePattern:z,folder:ie}=T(b.GlobPattern.from(E.include)),ae=typeof E.exclude=="string"?E.exclude:E.exclude?E.exclude.pattern:void 0,te={ignoreSymlinks:typeof E.followSymlinks=="boolean"?!E.followSymlinks:void 0,disregardIgnoreFiles:typeof E.useIgnoreFiles=="boolean"?!E.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof E.useGlobalIgnoreFiles=="boolean"?!E.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof E.useParentIgnoreFiles=="boolean"?!E.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof E.useDefaultExcludes=="boolean"?!E.useDefaultExcludes:!0,fileEncoding:E.encoding,maxResults:E.maxResults,previewOptions:J,afterContext:E.afterContext,beforeContext:E.beforeContext,includePattern:z,excludePattern:ae},ce=!1;if(this._activeSearchCallbacks[j]=de=>{if(ce)return;const Se=c.URI.revive(de.resource);de.results.forEach(fe=>{(0,P.resultIsMatch)(fe)?H({uri:Se,preview:{text:fe.preview.text,matches:(0,o.mapArrayOrNot)(fe.preview.matches,ne=>new l.Range(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,o.mapArrayOrNot)(fe.ranges,ne=>new l.Range(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):H({uri:Se,text:fe.text,lineNumber:fe.lineNumber})})},$.isCancellationRequested)return{};try{const de=await this._proxy.$startTextSearch(W,(0,v.withUndefinedAsNull)(ie),te,j,$);return delete this._activeSearchCallbacks[j],de||{}}catch(de){throw delete this._activeSearchCallbacks[j],de}}$handleTextSearchResult(W,E){this._activeSearchCallbacks[E]&&this._activeSearchCallbacks[E](W)}saveAll(W){return this._proxy.$saveAll(W)}resolveProxy(W){return this._proxy.$resolveProxy(W)}get trusted(){return this._trusted}requestWorkspaceTrust(W){return this._proxy.$requestWorkspaceTrust(W)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};_=Fe([Ne(0,f.IExtHostRpcService),Ne(1,d.IExtHostInitDataService),Ne(2,k.IExtHostFileSystemInfo),Ne(3,n.ILogService)],_),e.ExtHostWorkspace=_,e.IExtHostWorkspace=(0,r.createDecorator)("IExtHostWorkspace");function T(R){let W,E;return R&&(typeof R=="string"?W=R:(W=R.pattern,E=c.URI.revive(R.baseUri))),{includePattern:W,folder:E}}}),define(Ee[32],be([1,0,26,5,31,4,7,143,80,11,13,3,14,12,2]),function(Y,e,o,I,w,B,S,A,C,L,M,v,c,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function n(P,u){if(u){const i=u.split(".");let s=P;for(let t=0;s&&t<i.length;t++)s=s[i[t]];return s}}function m(P){return P instanceof r.URI}function y(P){return P&&P.uri instanceof r.URI&&P.languageId&&typeof P.languageId=="string"}function k(P){return P&&!P.uri&&P.languageId&&typeof P.languageId=="string"}function d(P){return P&&P.uri instanceof r.URI&&(!P.name||typeof P.name=="string")&&(!P.index||typeof P.index=="number")}function f(P){if(m(P))return{resource:P};if(y(P))return{resource:P.uri,overrideIdentifier:P.languageId};if(k(P))return{overrideIdentifier:P.languageId};if(d(P))return{resource:P.uri};if(P===null)return{resource:null}}let b=class{constructor(u,i,s){this._proxy=u.getProxy(B.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=s,this._barrier=new M.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(u=>this._actual)}$initializeConfiguration(u){this._actual=new l(this._proxy,this._extHostWorkspace,u,this._logService),this._barrier.open()}$acceptConfigurationChanged(u,i){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(u,i))}};b=Fe([Ne(0,c.IExtHostRpcService),Ne(1,w.IExtHostWorkspace),Ne(2,g.ILogService)],b),e.ExtHostConfiguration=b;class l{constructor(u,i,s,t){this._onDidChangeConfiguration=new I.Emitter,this._proxy=u,this._logService=t,this._extHostWorkspace=i,this._configuration=A.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(u,i){const s={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=A.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,s))}getConfiguration(u,i,s){const t=f(i)||{},a=this._toReadonlyValue(u?n(this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace),u):this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace));u&&this._validateConfigurationAccess(u,t,s?.identifier);function p(_){if(_==null)return null;if(typeof _=="boolean")return _?1:4;switch(_){case S.ConfigurationTarget.Global:return 1;case S.ConfigurationTarget.Workspace:return 4;case S.ConfigurationTarget.WorkspaceFolder:return 5}}const h={has(_){return typeof n(a,_)!="undefined"},get:(_,T)=>{this._validateConfigurationAccess(u?`${u}.${_}`:_,t,s?.identifier);let R=n(a,_);if(typeof R=="undefined")R=T;else{let W;const E=(H,q)=>{let $;const j=()=>{W=W||(0,o.deepClone)(a),$=$||n(W,q)};return(0,L.isObject)(H)?new Proxy(H,{get:(J,z)=>{if(typeof z=="string"&&z.toLowerCase()==="tojson")return j(),()=>$;if(W)return $=$||n(W,q),$[z];const ie=J[z];return typeof z=="string"?E(ie,`${q}.${z}`):ie},set:(J,z,ie)=>(j(),$&&($[z]=ie),!0),deleteProperty:(J,z)=>(j(),$&&delete $[z],!0),defineProperty:(J,z,ie)=>(j(),$&&Object.defineProperty($,z,ie),!0)}):H};R=E(R,_)}return R},update:(_,T,R,W)=>{_=u?`${u}.${_}`:_;const E=p(R);return T!==void 0?this._proxy.$updateConfigurationOption(E,_,T,t,W):this._proxy.$removeConfigurationOption(E,_,t,W)},inspect:_=>{_=u?`${u}.${_}`:_;const T=(0,o.deepClone)(this._configuration.inspect(_,t,this._extHostWorkspace.workspace));if(T)return{key:_,defaultValue:T.default?.value,globalValue:T.user?.value,workspaceValue:T.workspace?.value,workspaceFolderValue:T.workspaceFolder?.value,defaultLanguageValue:T.default?.override,globalLanguageValue:T.user?.override,workspaceLanguageValue:T.workspace?.override,workspaceFolderLanguageValue:T.workspaceFolder?.override,languageIds:T.overrideIdentifiers}}};return typeof a=="object"&&(0,o.mixin)(h,a,!1),Object.freeze(h)}_toReadonlyValue(u){const i=s=>(0,L.isObject)(s)?new Proxy(s,{get:(t,a)=>i(t[a]),set:(t,a,p)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(a)}' of object`)},deleteProperty:(t,a)=>{throw new Error(`TypeError: Cannot delete read only property '${String(a)}' of object`)},defineProperty:(t,a)=>{throw new Error(`TypeError: Cannot define property '${String(a)}' for a readonly object`)},setPrototypeOf:t=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return i(u)}_validateConfigurationAccess(u,i,s){const t=C.OVERRIDE_PROPERTY_REGEX.test(u)?4:this._configurationScopes.get(u),a=s?`[${s.value}] `:"";if(t===4){typeof i?.resource=="undefined"&&this._logService.warn(`${a}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(t===3){i?.resource&&this._logService.warn(`${a}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(u,i){const s=new A.ConfigurationChangeEvent(u,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(t,a)=>s.affectsConfiguration(t,f(a))})}_toMap(u){return u.reduce((i,s)=>(i.set(s[0],s[1]),i),new Map)}}e.ExtHostConfigProvider=l,e.IExtHostConfiguration=(0,v.createDecorator)("IExtHostConfiguration")});var je=this&&this.__classPrivateFieldSet||function(Y,e,o,I,w){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!w:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?w.call(Y,o):w?w.value=o:e.set(Y,o),o},De=this&&this.__classPrivateFieldGet||function(Y,e,o,I){if(o==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?I:o==="a"?I.call(Y):I?I.value:e.get(Y)};define(Ee[97],be([1,0,2,13,5,4,7,31,49,32,20,40,14,27,3,9,23,12,65,164,15]),function(Y,e,o,I,w,B,S,A,C,L,M,v,c,g,r,n,m,y,k,d,f){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var l;(function(q){function $(J){if(J!=null)return J}q.from=$;function j(J){if(J!=null)return J}q.to=j})(l=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var P;(function(q){function $(J){if(J!=null)return J}q.from=$;function j(J){if(J!=null)return J}q.to=j})(P=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var u;(function(q){function $(J){if(J!=null)return J}q.from=$;function j(J){if(J!=null)return J}q.to=j})(u=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(q){function $(z){if(z){const ie=z;return ie&&!!ie.process}else return!1}q.is=$;function j(z){if(z==null)return;const ie={process:z.process,args:z.args};return z.options&&(ie.options=u.from(z.options)),ie}q.from=j;function J(z){if(z!=null)return new S.ProcessExecution(z.process,z.args,z.options)}q.to=J})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var s;(function(q){function $(J){if(J!=null)return J}q.from=$;function j(J){if(J!=null)return J}q.to=j})(s=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var t;(function(q){function $(z){if(z){const ie=z;return ie&&(!!ie.commandLine||!!ie.command)}else return!1}q.is=$;function j(z){if(z==null)return;const ie={};return z.commandLine!==void 0?ie.commandLine=z.commandLine:(ie.command=z.command,ie.args=z.args),z.options&&(ie.options=s.from(z.options)),ie}q.from=j;function J(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new S.ShellExecution(z.commandLine,z.options):new S.ShellExecution(z.command,z.args?z.args:[],z.options)}q.to=J})(t=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var a;(function(q){function $(z){if(z){let ie=z;return ie&&ie.customExecution==="customExecution"}else return!1}q.is=$;function j(z){return{customExecution:"customExecution"}}q.from=j;function J(z,ie){return ie.get(z)}q.to=J})(a=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var p;(function(q){function $(j,J){let z;return j.scope!==void 0&&typeof j.scope!="number"?z=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===S.TaskScope.Workspace&&J&&J.workspaceFile?z=J.workspaceFile:z=d.USER_TASKS_GROUP_KEY),{id:j._id,workspaceFolder:z}}q.from=$})(p=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(q){function $(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}q.from=$})(h=e.TaskGroupDTO||(e.TaskGroupDTO={}));var _;(function(q){function $(z,ie){if(z==null)return[];const ae=[];for(let te of z){const ce=j(te,ie);ce&&ae.push(ce)}return ae}q.fromMany=$;function j(z,ie){if(z==null)return;let ae;z.execution instanceof S.ProcessExecution?ae=i.from(z.execution):z.execution instanceof S.ShellExecution?ae=t.from(z.execution):z.execution&&z.execution instanceof S.CustomExecution&&(ae=a.from(z.execution));const te=l.from(z.definition);let ce;return z.scope?typeof z.scope=="number"?ce=z.scope:ce=z.scope.uri:ce=S.TaskScope.Workspace,!te||!ce?void 0:{_id:z._id,definition:te,name:z.name,source:{extensionId:ie.identifier.value,label:z.source,scope:ce},execution:ae,isBackground:z.isBackground,group:h.from(z.group),presentationOptions:P.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}q.from=j;async function J(z,ie,ae){if(z==null)return;let te;i.is(z.execution)?te=i.to(z.execution):t.is(z.execution)?te=t.to(z.execution):a.is(z.execution)&&(te=a.to(z._id,ae));const ce=l.to(z.definition);let de;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?de=z.source.scope:de=await ie.resolveWorkspaceFolder(o.URI.revive(z.source.scope)):de=S.TaskScope.Workspace),!ce||!de)return;const Se=new S.Task(ce,de,z.name,z.source.label,te,z.problemMatchers);return z.isBackground!==void 0&&(Se.isBackground=z.isBackground),z.group!==void 0&&(Se.group=S.TaskGroup.from(z.group._id),Se.group&&z.group.isDefault&&(Se.group=new S.TaskGroup(Se.group.id,Se.group.label),z.group.isDefault&&(Se.group.isDefault=z.group.isDefault))),z.presentationOptions&&(Se.presentationOptions=P.to(z.presentationOptions)),z._id&&(Se._id=z._id),z.detail&&(Se.detail=z.detail),Se}q.to=J})(_=e.TaskDTO||(e.TaskDTO={}));var T;(function(q){function $(J){return J}q.from=$;function j(J){if(!!J)return Object.assign(Object.create(null),J)}q.to=j})(T=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor($,j,J){this._id=j,this._task=J,b.set(this,void 0),je(this,b,$,"f")}get task(){return this._task}terminate(){De(this,b,"f").terminateTask(this)}fireDidStartProcess($){}fireDidEndProcess($){}}b=new WeakMap;var W;(function(q){function $(j){return{id:j._id,task:void 0}}q.from=$})(W=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let E=class{constructor($,j,J,z,ie,ae,te,ce){this._onDidExecuteTask=new w.Emitter,this._onDidTerminateTask=new w.Emitter,this._onDidTaskProcessStarted=new w.Emitter,this._onDidTaskProcessEnded=new w.Emitter,this._proxy=$.getProxy(B.MainContext.MainThreadTask),this._workspaceProvider=J,this._editorService=z,this._configurationService=ie,this._terminalService=ae,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=te,this._deprecationService=ce,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider($,j,J){if(!J)return new S.Disposable(()=>{});const z=this.nextHandle();return this._handlers.set(z,{type:j,provider:J,extension:$}),this._proxy.$registerTaskProvider(z,j),new S.Disposable(()=>{this._handlers.delete(z),this._proxy.$unregisterTaskProvider(z)})}registerTaskSystem($,j){this._proxy.$registerTaskSystem($,j)}fetchTasks($){return this._proxy.$fetchTasks(T.from($)).then(async j=>{const J=[];for(let z of j){const ie=await _.to(z,this._workspaceProvider,this._providedCustomExecutions2);ie&&J.push(ie)}return J})}get taskExecutions(){const $=[];return this._taskExecutions.forEach(j=>$.push(j)),$}terminateTask($){if(!($ instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask($._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask($,j,J){const z=this._providedCustomExecutions2.get($.id);z&&(this._activeCustomExecutions2.set($.id,z),this._terminalService.attachPtyToTerminal(j,await z.callback(J))),this._lastStartedTask=$.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution($)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask($){const j=await this.getTaskExecution($);this._taskExecutionPromises.delete($.id),this._taskExecutions.delete($.id),this.customExecutionComplete($),this._onDidTerminateTask.fire({execution:j})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess($){const j=await this.getTaskExecution($.id);this._onDidTaskProcessStarted.fire({execution:j,processId:$.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess($){const j=await this.getTaskExecution($.id);this._onDidTaskProcessEnded.fire({execution:j,exitCode:$.exitCode})}$provideTasks($,j){const J=this._handlers.get($);if(!J)return Promise.reject(new Error("no handler found"));const z=[],ie=(0,I.asPromise)(()=>J.provider.provideTasks(M.CancellationToken.None)).then(ae=>this.provideTasksInternal(j,z,J,ae));return new Promise(ae=>{ie.then(te=>{Promise.all(z).then(()=>{ae(te)})})})}async $resolveTask($,j){const J=this._handlers.get($);if(!J)return Promise.reject(new Error("no handler found"));if(j.definition.type!==J.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${J.type}].`);const z=await _.to(j,this._workspaceProvider,this._providedCustomExecutions2);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const ie=await J.provider.resolveTask(z,M.CancellationToken.None);if(!ie)return;this.checkDeprecation(ie,J);const ae=_.from(ie,J.extension);if(!ae)throw new Error("Unexpected: Task cannot be resolved.");if(ie.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return a.is(ae.execution)&&await this.addCustomExecution(ae,ie,!0),await this.resolveTaskInternal(ae)}nextHandle(){return this._handleCounter++}async addCustomExecution($,j,J){const z=await this._proxy.$createTaskId($);!J&&!this._providedCustomExecutions2.has(z)&&(this._notProvidedCustomExecutions.add(z),this._activeCustomExecutions2.set(z,j.execution)),this._providedCustomExecutions2.set(z,j.execution)}async getTaskExecution($,j){if(typeof $=="string"){const ie=this._taskExecutionPromises.get($);if(!ie)throw new Error("Unexpected: The specified task is missing an execution");return ie}let J=this._taskExecutionPromises.get($.id);if(J)return J;const z=new Promise((ie,ae)=>{function te(ce,de,Se){Se?ie(new R(ce,de.id,Se)):ae("Unexpected: Task does not exist.")}j?te(this,$,j):_.to($.task,this._workspaceProvider,this._providedCustomExecutions2).then(ce=>te(this,$,ce))});return this._taskExecutionPromises.set($.id,z),z.then(ie=>(this._taskExecutions.set($.id,ie),ie),ie=>Promise.reject(ie))}checkDeprecation($,j){$._deprecated&&this._deprecationService.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete($){this._activeCustomExecutions2.get($.id)&&this._activeCustomExecutions2.delete($.id),this._notProvidedCustomExecutions.has($.id)&&this._lastStartedTask!==$.id&&(this._providedCustomExecutions2.delete($.id),this._notProvidedCustomExecutions.delete($.id));let J=this._notProvidedCustomExecutions.values(),z=J.next();for(;!z.done;)!this._activeCustomExecutions2.has(z.value)&&this._lastStartedTask!==z.value&&(this._providedCustomExecutions2.delete(z.value),this._notProvidedCustomExecutions.delete(z.value)),z=J.next()}};E=Fe([Ne(0,c.IExtHostRpcService),Ne(1,g.IExtHostInitDataService),Ne(2,A.IExtHostWorkspace),Ne(3,C.IExtHostDocumentsAndEditors),Ne(4,L.IExtHostConfiguration),Ne(5,v.IExtHostTerminalService),Ne(6,y.ILogService),Ne(7,k.IExtHostApiDeprecationService)],E),e.ExtHostTaskBase=E;let H=class extends E{constructor($,j,J,z,ie,ae,te,ce){super($,j,J,z,ie,ae,te,ce);this.registerTaskSystem(n.Schemas.vscodeRemote,{scheme:n.Schemas.vscodeRemote,authority:"",platform:m.PlatformToString(0)})}async executeTask($,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const J=_.from(j,$);if(J===void 0)throw new Error("Task is not valid");if(a.is(J.execution))await this.addCustomExecution(J,j,!1);else throw new f.NotSupportedError;const z=await this.getTaskExecution(await this._proxy.$getTaskExecution(J),j);return this._proxy.$executeTask(J).catch(ie=>{throw new Error(ie)}),z}provideTasksInternal($,j,J,z){const ie=[];if(z)for(let ae of z){this.checkDeprecation(ae,J),(!ae.definition||!$[ae.definition.type])&&this._logService.warn(`The task [${ae.source}, ${ae.name}] uses an undefined task type. The task will be ignored in the future.`);const te=_.from(ae,J.extension);te&&a.is(te.execution)?(ie.push(te),j.push(this.addCustomExecution(te,ae,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ie,extension:J.extension}}async resolveTaskInternal($){if(a.is($.execution))return $;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables($,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable($,j,J){}};H=Fe([Ne(0,c.IExtHostRpcService),Ne(1,g.IExtHostInitDataService),Ne(2,A.IExtHostWorkspace),Ne(3,C.IExtHostDocumentsAndEditors),Ne(4,L.IExtHostConfiguration),Ne(5,v.IExtHostTerminalService),Ne(6,y.ILogService),Ne(7,k.IExtHostApiDeprecationService)],H),e.WorkerExtHostTask=H,e.IExtHostTask=(0,r.createDecorator)("IExtHostTask")}),define(Ee[214],be([1,0,17,20,43,29,24,191,41]),function(Y,e,o,I,w,B,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class L{constructor(c,g,r){this.config=c,this.provider=g,this.sessionToken=r,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=c.filePattern,this.includePattern=c.includePattern&&B.parse(c.includePattern),this.maxResults=c.maxResults||void 0,this.exists=c.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=c.excludePattern&&B.parse(c.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(c=>c.cancel()),this.activeCancellationTokens=new Set}search(c){const g=this.config.folderQueries||[];return new Promise((r,n)=>{const m=y=>{this.resultCount++,c(y)};if(this.isCanceled)return r({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(y=>{const k=y.toString(),d=o.basename(k);this.globalExcludePattern&&this.globalExcludePattern(k,d)||this.matchFile(m,{base:y,basename:d})}),Promise.all(g.map(y=>this.searchInFolder(y,m))).then(y=>{r({limitHit:this.isLimitHit,stats:y[0]||void 0})},y=>{n(new Error((0,w.toErrorMessage)(y)))})})}async searchInFolder(c,g){const r=new I.CancellationTokenSource,n=this.getSearchOptionsForFolder(c),m=this.initDirectoryTree(),y=new C.QueryGlobTester(this.config,c),k=!y.hasSiblingExcludeClauses();let d;try{this.activeCancellationTokens.add(r),d=A.StopWatch.create();const f=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},n,r.token),b=d.elapsed(),l=A.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(f&&f.forEach(P=>{const u=o.posix.relative(c.folder.path,P.path);if(k){const i=o.basename(P.path);this.matchFile(g,{base:c.folder,relativePath:u,basename:i});return}this.addDirectoryEntries(m,c.folder,u,g)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(m,y,g),{providerTime:b,postProcessTime:l.elapsed()})}finally{r.dispose(),this.activeCancellationTokens.delete(r)}}getSearchOptionsForFolder(c){const g=(0,C.resolvePatternsForProvider)(this.config.includePattern,c.includePattern),r=(0,C.resolvePatternsForProvider)(this.config.excludePattern,c.excludePattern);return{folder:c.folder,excludes:r,includes:g,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}addDirectoryEntries({pathToEntries:c},g,r,n){if(r===this.filePattern){const y=o.basename(this.filePattern);this.matchFile(n,{base:g,relativePath:this.filePattern,basename:y})}function m(y){const k=o.basename(y),d=o.dirname(y);let f=c[d];f||(f=c[d]=[],m(d)),f.push({base:g,relativePath:y,basename:k})}m(r)}matchDirectoryTree({rootEntries:c,pathToEntries:g},r,n){const m=this,y=this.filePattern;function k(d){const f=B.hasSiblingFn(()=>d.map(b=>b.basename));for(let b=0,l=d.length;b<l;b++){const P=d[b],{relativePath:u,basename:i}=P;if(r.matchesExcludesSync(u,i,y!==i?f:void 0))continue;const s=g[u];if(s)k(s);else{if(u===y)continue;m.matchFile(n,P)}if(m.isLimitHit)break}}k(c)}matchFile(c,g){(!this.includePattern||g.relativePath&&this.includePattern(g.relativePath,g.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||c(g))}}class M{constructor(){this.sessions=new Map}fileSearch(c,g,r,n){const m=this.getSessionTokenSource(c.cacheKey),y=new L(c,g,m&&m.token);let k=0;const d=f=>{k+=f.length,r(f.map(b=>this.rawMatchToSearchItem(b)))};return this.doSearch(y,M.BATCH_SIZE,d,n).then(f=>({limitHit:f.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:k,detailStats:f.stats}}))}clearCache(c){const g=this.getSessionTokenSource(c);g&&g.cancel()}getSessionTokenSource(c){if(!!c)return this.sessions.has(c)||this.sessions.set(c,new I.CancellationTokenSource),this.sessions.get(c)}rawMatchToSearchItem(c){return c.relativePath?{resource:S.joinPath(c.base,c.relativePath)}:{resource:c.base}}doSearch(c,g,r,n){n.onCancellationRequested(()=>{c.cancel()});const m=k=>{k&&(y.push(k),g>0&&y.length>=g&&(r(y),y=[]))};let y=[];return c.search(m).then(k=>(y.length&&r(y),k),k=>(y.length&&r(y),Promise.reject(k)))}}e.FileSearchManager=M,M.BATCH_SIZE=512}),define(Ee[215],be([1,0,16,70,29,73,22,9,17,24,10,11,2,234,134,77,12,46,87,213,41]),function(Y,e,o,I,w,B,S,A,C,L,M,v,c,g,r,n,m,y,k,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let b=class{constructor(h,_,T,R,W){this.configurationService=h,this.workspaceContextService=_,this.editorGroupsService=T,this.logService=R,this.pathService=W}text(h,_,T={}){h=this.getContentPattern(h,T);const R=this.configurationService.getValue(),W=_&&_.some(H=>!this.configurationService.getValue({resource:H}).search.useRipgrep);return{...this.commonQuery(_?.map(y.toWorkspaceFolder),T),type:2,contentPattern:h,previewOptions:T.previewOptions,maxFileSize:T.maxFileSize,usePCRE2:R.search.usePCRE2||W||!1,beforeContext:T.beforeContext,afterContext:T.afterContext,userDisabledExcludesAndIgnoreFiles:T.disregardExcludeSettings&&T.disregardIgnoreFiles}}getContentPattern(h,_){const T=this.configurationService.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const R={...h,wordSeparators:T.editor.wordSeparators};return this.isCaseSensitive(h,_)&&(R.isCaseSensitive=!0),this.isMultiline(h)&&(R.isMultiline=!0),R}file(h,_={}){return{...this.commonQuery(h,_),type:1,filePattern:_.filePattern?_.filePattern.trim():_.filePattern,exists:_.exists,sortByScore:_.sortByScore,cacheKey:_.cacheKey}}handleIncludeExclude(h,_){return h?(h=Array.isArray(h)?h.map(s):s(h),_?this.parseSearchPaths(h):{pattern:P(...Array.isArray(h)?h:[h])}):{}}commonQuery(h=[],_={}){const T=this.handleIncludeExclude(_.includePattern,_.expandPatterns),R=this.handleIncludeExclude(_.excludePattern,_.expandPatterns),W=h.length>1,E=(T.searchPaths&&T.searchPaths.length?T.searchPaths.map($=>this.getFolderQueryForSearchPath($,_,R)):h.map($=>this.getFolderQueryForRoot($,_,R,W))).filter($=>!!$),H={_reason:_._reason,folderQueries:E,usingSearchPaths:!!(T.searchPaths&&T.searchPaths.length),extraFileResources:_.extraFileResources,excludePattern:R.pattern,includePattern:T.pattern,onlyOpenEditors:_.onlyOpenEditors,maxResults:_.maxResults};if(_.onlyOpenEditors){const $=o.coalesce(o.flatten(this.editorGroupsService.groups.map(z=>z.editors.map(ie=>ie.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify($));const j=$.filter(z=>(0,f.pathIncludedInQuery)(H,z.fsPath)),J=this.commonQueryFromFileList(j);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(J)),{...H,...J}}const q=_.extraFileResources&&_.extraFileResources.filter($=>(0,f.pathIncludedInQuery)(H,$.fsPath));return H.extraFileResources=q&&q.length?q:void 0,H}commonQueryFromFileList(h){const _=[],T=new S.ResourceMap,R={};let W=!1;return h.forEach(E=>{if(E.scheme===A.Schemas.walkThrough)return;if((0,L.isAbsolutePath)(E)){const q=this.workspaceContextService.getWorkspaceFolder(E)?.uri??E.with({path:C.dirname(E.fsPath)});let $=T.get(q);$||(W=!0,$={folder:q,includePattern:{}},_.push($),T.set(q,$));const j=C.relative(q.fsPath,E.fsPath);(0,v.assertIsDefined)($.includePattern)[j.replace(/\\/g,"/")]=!0}else E.fsPath&&(W=!0,R[E.fsPath]=!0)}),{folderQueries:_,includePattern:R,usingSearchPaths:!0,excludePattern:W?void 0:{"**/*":!0}}}isCaseSensitive(h,_){if(_.isSmartCase){if(h.isRegExp){if(M.containsUppercaseCharacter(h.pattern,!0))return!0}else if(M.containsUppercaseCharacter(h.pattern))return!0}return!!h.isCaseSensitive}isMultiline(h){return h.isMultiline||h.isRegExp&&(0,g.isMultilineRegexSource)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const _=J=>C.isAbsolute(J)||/^\.\.?([\/\\]|$)/.test(J),R=(Array.isArray(h)?h:u(h)).map(J=>{const z=this.pathService.resolvedUserHome;return z?(0,B.untildify)(J,z.scheme===A.Schemas.file?z.fsPath:z.path):J}),W=I.groupBy(R,J=>_(J)?"searchPaths":"exprSegments"),E=(W.exprSegments||[]).map(J=>M.rtrim(J,"/")).map(J=>M.rtrim(J,"\\")).map(J=>(J[0]==="."&&(J="*"+J),i(J))),H={},q=this.expandSearchPathPatterns(W.searchPaths||[]);q&&q.length&&(H.searchPaths=q);const $=o.flatten(E),j=P(...$);return j&&(H.pattern=j),H}getExcludesForFolder(h,_){return _.disregardExcludeSettings?void 0:(0,f.getExcludes)(h,!_.disregardSearchExcludeSettings)}expandSearchPathPatterns(h){if(!h||!h.length)return[];const _=o.flatten(h.map(R=>{let{pathPortion:W,globPortion:E}=l(R);E&&(E=t(E));const H=this.expandOneSearchPath(W);return o.flatten(H.map(q=>this.resolveOneSearchPathPattern(q,E)))})),T=new Map;return _.forEach(R=>{const W=R.searchPath.toString(),E=T.get(W);E?R.pattern&&(E.pattern=E.pattern||{},E.pattern[R.pattern]=!0):T.set(W,{searchPath:R.searchPath,pattern:R.pattern?P(R.pattern):void 0})}),Array.from(T.values())}expandOneSearchPath(h){if(C.isAbsolute(h)){const _=this.workspaceContextService.getWorkspace().folders;return _[0]&&_[0].uri.scheme!==A.Schemas.file?[{searchPath:_[0].uri.with({path:h})}]:[{searchPath:c.URI.file(C.normalize(h))}]}if(this.workspaceContextService.getWorkbenchState()===2){const _=this.workspaceContextService.getWorkspace().folders[0].uri;if(h=s(h),h.startsWith("../")||h===".."){const R=C.posix.resolve(_.path,h);return[{searchPath:_.with({path:R})}]}const T=t(h);return[{searchPath:_,pattern:T}]}else{if(h==="./"||h===".\\")return[];{const _=h.replace(/^\.[\/\\]/,""),R=this.workspaceContextService.getWorkspace().folders.map(W=>{const E=_.match(new RegExp(`^${M.escapeRegExpCharacters(W.name)}(?:/(.*)|$)`));return E?{match:E,folder:W}:null}).filter(v.isDefined);if(R.length)return R.map(W=>{const E=W.match[1];return{searchPath:W.folder.uri,pattern:E&&t(E)}});{const W=h.match(/\.[\/\\](.+)[\/\\]?/),E=W?W[1]:h,H=r.localize(0,null,E);throw new Error(H)}}}}resolveOneSearchPathPattern(h,_){const T=h.pattern&&_?`${h.pattern}/${_}`:h.pattern||_,R=[{searchPath:h.searchPath,pattern:T}];return T&&!T.endsWith("**")&&R.push({searchPath:h.searchPath,pattern:T+"/**"}),R}getFolderQueryForSearchPath(h,_,T){const R=this.getFolderQueryForRoot((0,y.toWorkspaceFolder)(h.searchPath),_,T,!1);return R?{...R,includePattern:h.pattern}:null}getFolderQueryForRoot(h,_,T,R){let W;const E=c.URI.isUri(h)?h:h.uri;if(T.searchPaths){const J=T.searchPaths.filter(z=>(0,L.isEqual)(z.searchPath,E))[0];if(J&&!J.pattern)return null;J&&(W=J.pattern)}const H=this.configurationService.getValue({resource:E}),$={...this.getExcludesForFolder(H,_)||{},...W||{}},j=c.URI.isUri(h)?(0,L.basename)(h):h.name;return{folder:E,folderName:R?j:void 0,excludePattern:Object.keys($).length>0?$:void 0,fileEncoding:H.files&&H.files.encoding,disregardIgnoreFiles:typeof _.disregardIgnoreFiles=="boolean"?_.disregardIgnoreFiles:!H.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof _.disregardGlobalIgnoreFiles=="boolean"?_.disregardGlobalIgnoreFiles:!H.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof _.disregardParentIgnoreFiles=="boolean"?_.disregardParentIgnoreFiles:!H.search.useParentIgnoreFiles,ignoreSymlinks:typeof _.ignoreSymlinks=="boolean"?_.ignoreSymlinks:!H.search.followSymlinks}}};b=Fe([Ne(0,n.IConfigurationService),Ne(1,y.IWorkspaceContextService),Ne(2,k.IEditorGroupsService),Ne(3,m.ILogService),Ne(4,d.IPathService)],b),e.QueryBuilder=b;function l(p){const h=p.match(/[\*\{\}\(\)\[\]\?]/);if(h){const _=h.index,T=p.substr(0,_).match(/[/|\\][^/\\]*$/);if(T){let R=p.substr(0,T.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:p.substr((T.index||0)+1)}}}return{pathPortion:p}}function P(...p){return p.length?p.reduce((h,_)=>(h[_]=!0,h),Object.create(null)):void 0}function u(p){return w.splitGlobAware(p,",").map(h=>h.trim()).filter(h=>!!h.length)}function i(p){return[`**/${p}/**`,`**/${p}`].map(_=>_.replace(/\*\*\/\*\*/g,"**"))}function s(p){return p.replace(/\\/g,"/")}function t(p){return s(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function a(p,h){p=o.distinct(p,R=>R.toString());const _=[],T=h.getWorkspace();return p&&p.forEach(R=>{let W;if(h.getWorkbenchState()===2)W=(0,L.relativePath)(T.folders[0].uri,R),W&&W!=="."&&(W="./"+W);else{const E=h.getWorkspaceFolder(R);if(E){const H=E.name;if(T.folders.filter($=>$.name===H).length===1){const $=(0,L.relativePath)(E.uri,R);$===""?W=`./${E.name}`:W=`./${E.name}/${$}`}else W=R.fsPath}}W&&_.push(W)}),_}e.resolveResourcesForSearchIncludes=a}),define(Ee[216],be([1,0,24,2,20,15,3,215,41,46]),function(Y,e,o,I,w,B,S,A,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const M=7e3;function v(n,m){const y=m.activationEvents;if(!y)return Promise.resolve(void 0);const k=[],d=[];for(const i of y)if(/^workspaceContains:/.test(i)){const s=i.substr("workspaceContains:".length);s.indexOf("*")>=0||s.indexOf("?")>=0||n.forceUsingSearch?d.push(s):k.push(s)}if(k.length===0&&d.length===0)return Promise.resolve(void 0);let f;const b=new Promise((i,s)=>{f=i}),l=i=>f({activationEvent:i}),P=Promise.all(k.map(i=>c(n,i,l))).then(()=>{}),u=g(n,m.identifier,d,l);return Promise.all([P,u]).then(()=>{f(void 0)}),b}e.checkActivateWorkspaceContainsExtension=v;async function c(n,m,y){for(const k of n.folders)if(await n.exists(o.joinPath(I.URI.revive(k),m))){y(`workspaceContains:${m}`);return}}async function g(n,m,y,k){if(y.length===0)return Promise.resolve(void 0);const d=new w.CancellationTokenSource,f=n.checkExists(n.folders,y,d.token),b=setTimeout(async()=>{d.cancel(),n.logService.info(`Not activating extension '${m.value}': Timed out while searching for 'workspaceContains' pattern ${y.join(",")}`)},M);let l=!1;try{l=await f}catch(P){B.isCancellationError(P)||B.onUnexpectedError(P)}d.dispose(),clearTimeout(b),l&&k(`workspaceContains:${y.join(",")}`)}function r(n,m,y,k){const d=n.get(S.IInstantiationService),f=n.get(C.ISearchService),l=d.createInstance(A.QueryBuilder).file(m.map(P=>(0,L.toWorkspaceFolder)(I.URI.revive(P))),{_reason:"checkExists",includePattern:y,exists:!0});return f.fileSearch(l,k).then(P=>!!P.limitHit,P=>B.isCancellationError(P)?!1:Promise.reject(P))}e.checkGlobFileExists=r});var je=this&&this.__classPrivateFieldSet||function(Y,e,o,I,w){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!w:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?w.call(Y,o):w?w.value=o:e.set(Y,o),o},De=this&&this.__classPrivateFieldGet||function(Y,e,o,I){if(o==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!I:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?I:o==="a"?I.call(Y):I?I.value:e.get(Y)};define(Ee[33],be([1,0,123,17,69,24,13,6,22,2,12,4,32,174,67,31,28,173,15,25,21,149,7,81,3,27,68,14,56,59,40,5,216,64,151,9]),function(Y,e,o,I,w,B,S,A,C,L,M,v,c,g,r,n,m,y,k,d,f,b,l,P,u,i,s,t,a,p,h,_,T,R,W,E){"use strict";var H,q,$;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,u.createDecorator)("IHostUtils");let j=class Ki extends A.Disposable{constructor(te,ce,de,Se,fe,ne,me,ke,Ae,Be){super();this._onDidChangeRemoteConnectionData=this._register(new _.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=ce,this._extHostContext=de,this._initData=me,this._extHostWorkspace=Se,this._extHostConfiguration=fe,this._logService=ne,this._extHostTunnelService=Ae,this._extHostTerminalService=Be,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(v.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(v.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(v.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new S.Barrier,this._readyToStartExtensionHost=new S.Barrier,this._readyToRunExtensions=new S.Barrier,this._eagerExtensionsActivated=new S.Barrier,this._registry=new y.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new r.ExtHostStorage(this._extHostContext),this._secretState=new R.ExtHostSecretState(this._extHostContext),this._storagePath=ke,this._instaService=te.createChild(new a.ServiceCollection([r.IExtHostStorage,this._storage],[R.IExtHostSecretState,this._secretState]));const Xe=new Set;this._initData.hostExtensions.forEach(ge=>Xe.add(d.ExtensionIdentifier.toKey(ge))),this._activator=this._register(new g.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ge,ue,N)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ge,k.transformErrorForSerialization(ue),N)},actualActivateExtension:async(ge,ue)=>{if(Xe.has(d.ExtensionIdentifier.toKey(ge)))return await this._mainThreadExtensionsProxy.$activateExtension(ge,ue),new g.HostExtension;const N=this._registry.getExtensionDescription(ge);return this._activateExtension(N,ue)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),w.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(te){k.onUnexpectedError(te)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let te=[];try{te=this._registry.getAllExtensionDescriptions().map(fe=>fe.identifier).filter(fe=>this.isActivated(fe)).map(fe=>this._deactivate(fe))}catch{}await Promise.all(te)}isActivated(te){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(te):!1}_activateByEvent(te,ce){return this._activator.activateByEvent(te,ce)}_activateById(te,ce){return this._activator.activateById(te,ce)}activateByIdWithErrors(te,ce){return this._activateById(te,ce).then(()=>{const de=this._activator.getActivatedExtension(te);if(de.activationFailed)return Promise.reject(de.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(te=>this._registry)}getExtensionExports(te){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(te).exports:null}async _realPathExtensionUri(te){if(te.scheme!==E.Schemas.file)return te;const ce=await this._hostUtils.realpath(te.fsPath);return L.URI.file(ce)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const te=C.TernarySearchTree.forUris(ce=>B.extUriBiasedIgnorePathCase.ignorePathCasing(ce));for(const ce of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(ce)){const de=await this._realPathExtensionUri(ce.extensionLocation);te.set(de,ce)}return te})()),this._extensionPathIndex}_deactivate(te){let ce=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(te))return ce;const de=this._activator.getActivatedExtension(te);if(!de)return ce;try{typeof de.module.deactivate=="function"&&(ce=Promise.resolve(de.module.deactivate()).then(void 0,Se=>(this._logService.error(Se),Promise.resolve(void 0))))}catch(Se){this._logService.error(`An error occurred when deactivating the extension '${te.value}':`),this._logService.error(Se)}try{(0,A.dispose)(de.subscriptions)}catch(Se){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${te.value}':`),this._logService.error(Se)}return ce}async _activateExtension(te,ce){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(te.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(te.identifier),this._doActivateExtension(te,ce).then(de=>{const Se=de.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(te.identifier,Se.codeLoadingTime,Se.activateCallTime,Se.activateResolvedTime,ce),this._logExtensionActivationTimes(te,ce,"success",Se),de},de=>{throw this._logExtensionActivationTimes(te,ce,"failure"),de})}_logExtensionActivationTimes(te,ce,de,Se){const fe=J(te,ce);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...fe,...Se||{},outcome:de})}_doActivateExtension(te,ce){const de=J(te,ce);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",de);const Se=this._getEntryPoint(te);if(!Se)return Promise.resolve(new g.EmptyExtension(g.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${te.identifier.value}, startup: ${ce.startup}, activationEvent: '${ce.activationEvent}'${te.identifier.value!==ce.extensionId.value?`, root cause: ${ce.extensionId.value}`:""}`),this._logService.flush();const fe=new g.ExtensionActivationTimesBuilder(ce.startup);return Promise.all([this._loadCommonJSModule(te.identifier,(0,B.joinPath)(te.extensionLocation,Se),fe),this._loadExtensionContext(te)]).then(ne=>(w.mark(`code/extHost/willActivateExtension/${te.identifier.value}`),Ki._callActivate(this._logService,te.identifier,ne[0],ne[1],fe))).then(ne=>(w.mark(`code/extHost/didActivateExtension/${te.identifier.value}`),ne))}_loadExtensionContext(te){const ce=new b.ExtensionGlobalMemento(te,this._storage),de=new b.ExtensionMemento(te.identifier.value,!1,this._storage),Se=new W.ExtensionSecrets(te,this._secretState),fe=te.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?l.ExtensionMode.Test:l.ExtensionMode.Development:l.ExtensionMode.Production,ne=this._initData.remote.isRemote?l.ExtensionKind.Workspace:l.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${te.identifier.value}`),Promise.all([ce.whenReady,de.whenReady,this._storagePath.whenReady]).then(()=>{const me=this;let ke,Ae;const Be=(0,m.isProposedApiEnabled)(te,"ipc")?this._initData.messagePorts?.get(d.ExtensionIdentifier.toKey(te.identifier)):void 0;return Object.freeze({globalState:ce,workspaceState:de,secrets:Se,subscriptions:[],get extensionUri(){return te.extensionLocation},get extensionPath(){return te.extensionLocation.fsPath},asAbsolutePath(Xe){return I.join(te.extensionLocation.fsPath,Xe)},get storagePath(){return me._storagePath.workspaceValue(te)?.fsPath},get globalStoragePath(){return me._storagePath.globalValue(te).fsPath},get logPath(){return I.join(me._initData.logsLocation.fsPath,te.identifier.value)},get logUri(){return L.URI.joinPath(me._initData.logsLocation,te.identifier.value)},get storageUri(){return me._storagePath.workspaceValue(te)},get globalStorageUri(){return me._storagePath.globalValue(te)},get extensionMode(){return fe},get extension(){return ke===void 0&&(ke=new z(me,te.identifier,te,ne)),ke},get extensionRuntime(){return(0,m.checkProposedApiEnabled)(te,"extensionRuntime"),me.extensionRuntime},get environmentVariableCollection(){return me._extHostTerminalService.getEnvironmentVariableCollection(te)},get messagePassingProtocol(){if(!Ae){if(!Be)return;const Xe=_.Event.buffer(_.Event.fromDOMEventEmitter(Be,"message",ge=>ge.data));Be.start(),Ae={onDidReceiveMessage:Xe,postMessage:Be.postMessage.bind(Be)}}return Ae}})})}static _callActivate(te,ce,de,Se,fe){return de=de||{activate:void 0,deactivate:void 0},this._callActivateOptional(te,ce,de,Se,fe).then(ne=>new g.ActivatedExtension(!1,null,fe.build(),de,ne,Se.subscriptions))}static _callActivateOptional(te,ce,de,Se,fe){if(typeof de.activate=="function")try{fe.activateCallStart(),te.trace(`ExtensionService#_callActivateOptional ${ce.value}`);const ne=typeof global=="object"?global:self,me=de.activate.apply(ne,[Se]);return fe.activateCallStop(),fe.activateResolveStart(),Promise.resolve(me).then(ke=>(fe.activateResolveStop(),ke))}catch(ne){return Promise.reject(ne)}else return Promise.resolve(de)}_activateOneStartupFinished(te,ce){this._activateById(te.identifier,{startup:!1,extensionId:te.identifier,activationEvent:ce}).then(void 0,de=>{this._logService.error(de)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(w.getMarks());for(const te of this._registry.getAllExtensionDescriptions())if(te.activationEvents)for(const ce of te.activationEvents)ce==="onStartupFinished"&&this._activateOneStartupFinished(te,ce)}_handleEagerExtensions(){const te=this._activateByEvent("*",!0).then(void 0,fe=>{this._logService.error(fe)});this._register(this._extHostWorkspace.onDidChangeWorkspace(fe=>this._handleWorkspaceContainsEagerExtensions(fe.added)));const ce=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],de=this._handleWorkspaceContainsEagerExtensions(ce),Se=Promise.all([te,de]).then(()=>{});return Promise.race([Se,(0,S.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),Se}_handleWorkspaceContainsEagerExtensions(te){return te.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(ce=>this._handleWorkspaceContainsEagerExtension(te,ce))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(te,ce){if(this.isActivated(ce.identifier))return;const de=!this._initData.remote.isRemote&&!!this._initData.remote.authority,Se={logService:this._logService,folders:te.map(ne=>ne.uri),forceUsingSearch:de,exists:ne=>this._hostUtils.exists(ne.fsPath),checkExists:(ne,me,ke)=>this._mainThreadWorkspaceProxy.$checkExists(ne,me,ke)},fe=await(0,T.checkActivateWorkspaceContainsExtension)(Se,ce);if(!!fe)return this._activateById(ce.identifier,{startup:!0,extensionId:ce.identifier,activationEvent:fe.activationEvent}).then(void 0,ne=>this._logService.error(ne))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(te){throw console.error(te),te}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:te,extensionTestsLocationURI:ce}=this._initData.environment;if(!te||!ce)throw new Error(o.localize(0,null));const de=await this._loadCommonJSModule(null,ce,new g.ExtensionActivationTimesBuilder(!1));if(!de||typeof de.run!="function")throw new Error(o.localize(1,null,ce.toString()));return new Promise((Se,fe)=>{const ne=(Ae,Be)=>{Ae?fe(Ae):Se(typeof Be=="number"&&Be>0?1:0)},me=(0,B.originalFSPath)(ce),ke=de.run(me,ne);ke&&ke.then&&ke.then(()=>{Se(0)}).catch(Ae=>{fe(Ae instanceof Error&&Ae.stack?Ae.stack:String(Ae))})})}async $extensionTestsExit(te){this._logService.info(`Extension host terminating: test runner requested exit with code ${te}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${te}`),this._logService.flush(),this._hostUtils.exit(te)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(te,ce){return this._resolvers[te]=ce,(0,A.toDisposable)(()=>{delete this._resolvers[te]})}async _activateAndGetResolver(te){const ce=te.indexOf("+");if(ce===-1)throw new Error("Not an authority that can be resolved!");const de=te.substr(0,ce);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${de}`,!1),{authorityPrefix:de,resolver:this._resolvers[de]}}async $resolveAuthority(te,ce){this._logService.info(`$resolveAuthority invoked for authority (${ie(te)})`);const{authorityPrefix:de,resolver:Se}=await this._activateAndGetResolver(te);if(!Se)return{type:"error",error:{code:P.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${de}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(Se)),w.mark(`code/extHost/willResolveAuthority/${de}`);const fe=await Se.resolve(te,{resolveAttempt:ce});w.mark(`code/extHost/didResolveAuthorityOK/${de}`);const ne={authority:te,host:fe.host,port:fe.port,connectionToken:fe.connectionToken},me={extensionHostEnv:fe.extensionHostEnv,isTrusted:fe.isTrusted,authenticationSession:fe.authenticationSessionForInitializingExtensions?{id:fe.authenticationSessionForInitializingExtensions.id,providerId:fe.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ne,options:me,tunnelInformation:{environmentTunnels:fe.environmentTunnels,features:fe.tunnelFeatures}}}}catch(fe){if(w.mark(`code/extHost/didResolveAuthorityError/${de}`),fe instanceof l.RemoteAuthorityResolverError)return{type:"error",error:{code:fe._code,message:fe._message,detail:fe._detail}};throw fe}}async $getCanonicalURI(te,ce){this._logService.info(`$getCanonicalURI invoked for authority (${ie(te)})`);const{authorityPrefix:de,resolver:Se}=await this._activateAndGetResolver(te);if(!Se)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${de}`);const fe=L.URI.revive(ce);if(typeof Se.getCanonicalURI=="undefined")return fe;const ne=await(0,S.asPromise)(()=>Se.getCanonicalURI(fe));return ne||fe}$startExtensionHost(te){return this._registry.keepOnly(te),this._startExtensionHost()}$activateByEvent(te,ce){return ce===1?this._activateByEvent(te,!1):this._readyToRunExtensions.wait().then(de=>this._activateByEvent(te,!1))}async $activate(te,ce){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(te)?(await this._activateById(te,ce),!0):!1}async $deltaExtensions(te,ce){te.forEach(Se=>Se.extensionLocation=L.URI.revive(Se.extensionLocation));const de=await this.getExtensionPathIndex();return await Promise.all(ce.map(async Se=>{const fe=this._registry.getExtensionDescription(Se);fe&&de.delete(await this._realPathExtensionUri(fe.extensionLocation))})),await Promise.all(te.map(async Se=>{const fe=await this._realPathExtensionUri(Se.extensionLocation);de.set(fe,Se)})),this._registry.deltaExtensions(te,ce),Promise.resolve(void 0)}async $test_latency(te){return te}async $test_up(te){return te.byteLength}async $test_down(te){let ce=f.VSBuffer.alloc(te),de=Math.random()%256;for(let Se=0;Se<te;Se++)ce.writeUInt8(de,Se);return ce}async $updateRemoteConnectionData(te){this._remoteConnectionData=te,this._onDidChangeRemoteConnectionData.fire()}};j=Fe([Ne(0,u.IInstantiationService),Ne(1,e.IHostUtils),Ne(2,t.IExtHostRpcService),Ne(3,n.IExtHostWorkspace),Ne(4,c.IExtHostConfiguration),Ne(5,M.ILogService),Ne(6,i.IExtHostInitDataService),Ne(7,s.IExtensionStoragePaths),Ne(8,p.IExtHostTunnelService),Ne(9,h.IExtHostTerminalService)],j),e.AbstractExtHostExtensionService=j;function J(ae,te){return{id:ae.identifier.value,name:ae.name,extensionVersion:ae.version,publisherDisplayName:ae.publisher,activationEvents:ae.activationEvents?ae.activationEvents.join(","):null,isBuiltin:ae.isBuiltin,reason:te.activationEvent,reasonId:te.extensionId.value}}e.IExtHostExtensionService=(0,u.createDecorator)("IExtHostExtensionService");class z{constructor(te,ce,de,Se){H.set(this,void 0),q.set(this,void 0),$.set(this,void 0),je(this,H,te,"f"),je(this,q,ce,"f"),je(this,$,de.identifier,"f"),this.id=de.identifier.value,this.extensionUri=de.extensionLocation,this.extensionPath=I.normalize((0,B.originalFSPath)(de.extensionLocation)),this.packageJSON=de,this.extensionKind=Se}get isActive(){return De(this,H,"f").isActivated(De(this,$,"f"))}get exports(){if(this.packageJSON.api!=="none")return De(this,H,"f").getExtensionExports(De(this,$,"f"))}activate(){return De(this,H,"f").activateByIdWithErrors(De(this,$,"f"),{startup:!1,extensionId:De(this,q,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=z,H=new WeakMap,q=new WeakMap,$=new WeakMap;function ie(ae){const te=ae.indexOf("+");return te===-1?ae:ae.substring(0,te)}}),define(Ee[98],be([1,0,17,2,5,13,4,7,158,31,33,49,166,32,160,14,3,11,86,66]),function(Y,e,o,I,w,B,S,A,C,L,M,v,c,g,r,n,m,y,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,m.createDecorator)("IExtHostDebugService");let f=class{constructor(a,p,h,_,T,R){this._workspaceService=p,this._extensionService=h,this._editorsService=_,this._configurationService=T,this._editorTabs=R,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new w.Emitter,this._onDidTerminateDebugSession=new w.Emitter,this._onDidChangeActiveDebugSession=new w.Emitter,this._onDidReceiveDebugSessionCustomEvent=new w.Emitter,this._debugServiceProxy=a.getProxy(S.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new w.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new l(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(W=>{W.onDidChange(E=>{this.registerAllDebugTypes(W)}),this.registerAllDebugTypes(W)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(a,p){const h=a;if(typeof h.sourceReference=="number"&&h.sourceReference>0){let _=`debug:${encodeURIComponent(h.path||"")}`,T="?";return p&&(_+=`${T}session=${encodeURIComponent(p.id)}`,T="&"),_+=`${T}ref=${h.sourceReference}`,I.URI.parse(_)}else{if(h.path)return I.URI.file(h.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(a){const p=[];for(const h of a.getAllExtensionDescriptions())if(h.contributes){const _=h.contributes.debuggers;if(_&&_.length>0)for(const T of _)(0,r.isDebuggerMainContribution)(T)&&p.push(T.type)}this._debugServiceProxy.$registerDebugTypes(p)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const a=[];return this._breakpoints.forEach(p=>a.push(p)),a}addBreakpoints(a){this.startBreakpoints();const p=a.filter(T=>{const R=T.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,T),!0)});this.fireBreakpointChanges(p,[],[]);const h=[],_=new Map;for(const T of p)if(T instanceof A.SourceBreakpoint){let R=_.get(T.location.uri.toString());R||(R={type:"sourceMulti",uri:T.location.uri,lines:[]},_.set(T.location.uri.toString(),R),h.push(R)),R.lines.push({id:T.id,enabled:T.enabled,condition:T.condition,hitCondition:T.hitCondition,logMessage:T.logMessage,line:T.location.range.start.line,character:T.location.range.start.character})}else T instanceof A.FunctionBreakpoint&&h.push({type:"function",id:T.id,enabled:T.enabled,hitCondition:T.hitCondition,logMessage:T.logMessage,condition:T.condition,functionName:T.functionName});return this._debugServiceProxy.$registerBreakpoints(h)}removeBreakpoints(a){this.startBreakpoints();const p=a.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],p,[]);const h=p.filter(R=>R instanceof A.SourceBreakpoint).map(R=>R.id),_=p.filter(R=>R instanceof A.FunctionBreakpoint).map(R=>R.id),T=p.filter(R=>R instanceof A.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(h,_,T)}startDebugging(a,p,h){return this._debugServiceProxy.$startDebugging(a?a.uri:void 0,p,{parentSessionID:h.parentSession?h.parentSession.id:void 0,lifecycleManagedByParent:h.lifecycleManagedByParent,repl:h.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:h.noDebug,compact:h.compact,debugUI:h.debugUI,suppressSaveBeforeStart:h.suppressSaveBeforeStart})}stopDebugging(a){return this._debugServiceProxy.$stopDebugging(a?a.id:void 0)}registerDebugConfigurationProvider(a,p,h){if(!p)return new A.Disposable(()=>{});const _=this._configProviderHandleCounter++;return this._configProviders.push({type:a,handle:_,provider:p}),this._debugServiceProxy.$registerDebugConfigurationProvider(a,h,!!p.provideDebugConfigurations,!!p.resolveDebugConfiguration,!!p.resolveDebugConfigurationWithSubstitutedVariables,_),new A.Disposable(()=>{this._configProviders=this._configProviders.filter(T=>T.provider!==p),this._debugServiceProxy.$unregisterDebugConfigurationProvider(_)})}registerDebugAdapterDescriptorFactory(a,p,h){if(!h)return new A.Disposable(()=>{});if(!this.definesDebugType(a,p))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${p}' debugger.`);if(this.getAdapterDescriptorFactoryByType(p))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const _=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:p,handle:_,factory:h}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(p,_),new A.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(T=>T.factory!==h),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(_)})}registerDebugAdapterTrackerFactory(a,p){if(!p)return new A.Disposable(()=>{});const h=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:a,handle:h,factory:p}),new A.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(_=>_.factory!==p)})}async $runInTerminal(a,p){return Promise.resolve(void 0)}async $substituteVariables(a,p){if(!this._variableResolver){const[T,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(T||[],this._editorsService,R)}let h;const _=await this.getFolder(a);return _&&(h={uri:_.uri,name:_.name,index:_.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(h,p)}createDebugAdapter(a,p){if(a.type==="implementation")return new i(a.implementation)}createSignService(){}async $startDASession(a,p){const h=this,_=await this.getSession(p);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(_.type),_).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${_.type}' (extension might have failed to activate)`);const R=this.convertToDto(T),W=this.createDebugAdapter(R,_);if(!W)throw new Error(`Couldn't create a debug adapter for type '${_.type}'.`);const E=W;return this._debugAdapters.set(a,E),this.getDebugAdapterTrackers(_).then(H=>(H&&this._debugAdaptersTrackers.set(a,H),E.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const $=q,j={type:"response",seq:0,command:$.command,request_seq:$.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const J=await this._signService.sign($.arguments.value);j.body={signature:J},E.sendResponse(j)}else throw new Error("no signer")}catch(J){j.success=!1,j.message=J.message,E.sendResponse(j)}}else H&&H.onDidSendMessage&&H.onDidSendMessage(q),q=(0,r.convertToVSCPaths)(q,!0),h._debugServiceProxy.$acceptDAMessage(a,q)}),E.onError(q=>{H&&H.onError&&H.onError(q),this._debugServiceProxy.$acceptDAError(a,q.name,q.message,q.stack)}),E.onExit(q=>{H&&H.onExit&&H.onExit((0,y.withNullAsUndefined)(q),void 0),this._debugServiceProxy.$acceptDAExit(a,(0,y.withNullAsUndefined)(q),void 0)}),H&&H.onWillStartSession&&H.onWillStartSession(),E.startSession()))})}$sendDAMessage(a,p){p=(0,r.convertToDAPaths)(p,!1);const h=this._debugAdaptersTrackers.get(a);h&&h.onWillReceiveMessage&&h.onWillReceiveMessage(p);const _=this._debugAdapters.get(a);_&&_.sendMessage(p)}$stopDASession(a){const p=this._debugAdaptersTrackers.get(a);this._debugAdaptersTrackers.delete(a),p&&p.onWillStopSession&&p.onWillStopSession();const h=this._debugAdapters.get(a);return this._debugAdapters.delete(a),h?h.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(a){const p=[],h=[],_=[];if(a.added)for(const T of a.added){const R=T.id;if(R&&!this._breakpoints.has(R)){let W;if(T.type==="function")W=new A.FunctionBreakpoint(T.functionName,T.enabled,T.condition,T.hitCondition,T.logMessage);else if(T.type==="data")W=new A.DataBreakpoint(T.label,T.dataId,T.canPersist,T.enabled,T.hitCondition,T.condition,T.logMessage);else{const E=I.URI.revive(T.uri);W=new A.SourceBreakpoint(new A.Location(E,new A.Position(T.line,T.character)),T.enabled,T.condition,T.hitCondition,T.logMessage)}W._id=R,this._breakpoints.set(R,W),p.push(W)}}if(a.removed)for(const T of a.removed){const R=this._breakpoints.get(T);R&&(this._breakpoints.delete(T),h.push(R))}if(a.changed){for(const T of a.changed)if(T.id){const R=this._breakpoints.get(T.id);if(R){if(R instanceof A.FunctionBreakpoint&&T.type==="function"){const W=R;W.enabled=T.enabled,W.condition=T.condition,W.hitCondition=T.hitCondition,W.logMessage=T.logMessage,W.functionName=T.functionName}else if(R instanceof A.SourceBreakpoint&&T.type==="source"){const W=R;W.enabled=T.enabled,W.condition=T.condition,W.hitCondition=T.hitCondition,W.logMessage=T.logMessage,W.location=new A.Location(I.URI.revive(T.uri),new A.Position(T.line,T.character))}_.push(R)}}}this.fireBreakpointChanges(p,h,_)}$provideDebugConfigurations(a,p,h){return(0,B.asPromise)(async()=>{const _=this.getConfigProviderByHandle(a);if(!_)throw new Error("no DebugConfigurationProvider found");if(!_.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const T=await this.getFolder(p);return _.provideDebugConfigurations(T,h)}).then(_=>{if(!_)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return _})}$resolveDebugConfiguration(a,p,h,_){return(0,B.asPromise)(async()=>{const T=this.getConfigProviderByHandle(a);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(p);return T.resolveDebugConfiguration(R,h,_)})}$resolveDebugConfigurationWithSubstitutedVariables(a,p,h,_){return(0,B.asPromise)(async()=>{const T=this.getConfigProviderByHandle(a);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(p);return T.resolveDebugConfigurationWithSubstitutedVariables(R,h,_)})}async $provideDebugAdapter(a,p){const h=this.getAdapterDescriptorFactoryByHandle(a);if(!h)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const _=await this.getSession(p);return this.getAdapterDescriptor(h,_).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${_.type}'`);return this.convertToDto(T)})}async $acceptDebugSessionStarted(a){const p=await this.getSession(a);this._onDidStartDebugSession.fire(p)}async $acceptDebugSessionTerminated(a){const p=await this.getSession(a);p&&(this._onDidTerminateDebugSession.fire(p),this._debugSessions.delete(p.id))}async $acceptDebugSessionActiveChanged(a){this._activeDebugSession=a?await this.getSession(a):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(a,p){const h=await this.getSession(a);h&&h._acceptNameChanged(p)}async $acceptDebugSessionCustomEvent(a,p){const _={session:await this.getSession(a),event:p.event,body:p.body};this._onDidReceiveDebugSessionCustomEvent.fire(_)}convertToDto(a){if(a instanceof A.DebugAdapterExecutable)return{type:"executable",command:a.command,args:a.args,options:a.options};if(a instanceof A.DebugAdapterServer)return{type:"server",port:a.port,host:a.host};if(a instanceof A.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:a.path};if(a instanceof A.DebugAdapterInlineImplementation)return{type:"implementation",implementation:a.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(a){const p=this._adapterFactories.filter(h=>h.type===a);if(p.length>0)return p[0].factory}getAdapterDescriptorFactoryByHandle(a){const p=this._adapterFactories.filter(h=>h.handle===a);if(p.length>0)return p[0].factory}getConfigProviderByHandle(a){const p=this._configProviders.filter(h=>h.handle===a);if(p.length>0)return p[0].provider}definesDebugType(a,p){if(a.contributes){const h=a.contributes.debuggers;if(h&&h.length>0){for(const _ of h)if(_.label&&_.type&&_.type===p)return!0}}return!1}getDebugAdapterTrackers(a){const h=a.configuration.type,_=this._trackerFactories.filter(T=>T.type===h||T.type==="*").map(T=>(0,B.asPromise)(()=>T.factory.createDebugAdapterTracker(a)).then(R=>R,R=>null));return Promise.race([Promise.all(_).then(T=>{const R=T.filter(W=>!!W);if(R.length>0)return new u(R)}),new Promise((T,R)=>{const W=setTimeout(()=>{clearTimeout(W),R(new Error("timeout"))},1e3)})]).catch(T=>{})}async getAdapterDescriptor(a,p){const h=p.configuration.debugServer;if(typeof h=="number")return Promise.resolve(new A.DebugAdapterServer(h));if(a){const T=await this._extensionService.getExtensionRegistry();return(0,B.asPromise)(()=>a.createDebugAdapterDescriptor(p,this.daExecutableFromPackage(p,T))).then(R=>{if(R)return R})}const _=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(p,_))}daExecutableFromPackage(a,p){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(a,p,h){(a.length>0||p.length>0||h.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:a,removed:p,changed:h}))}async getSession(a){if(a)if(typeof a=="string"){const p=this._debugSessions.get(a);if(p)return p}else{let p=this._debugSessions.get(a.id);if(!p){const h=await this.getFolder(a.folderUri),_=a.parent?this._debugSessions.get(a.parent):void 0;p=new b(this._debugServiceProxy,a.id,a.type,a.name,h,a.configuration,_),this._debugSessions.set(p.id,p),this._debugServiceProxy.$sessionCached(p.id)}return p}throw new Error("cannot find session")}getFolder(a){if(a){const p=I.URI.revive(a);return this._workspaceService.resolveWorkspaceFolder(p)}return Promise.resolve(void 0)}};f=Fe([Ne(0,n.IExtHostRpcService),Ne(1,L.IExtHostWorkspace),Ne(2,M.IExtHostExtensionService),Ne(3,v.IExtHostDocumentsAndEditors),Ne(4,g.IExtHostConfiguration),Ne(5,d.IExtHostEditorTabs)],f),e.ExtHostDebugServiceBase=f;class b{constructor(a,p,h,_,T,R,W){this._debugServiceProxy=a,this._id=p,this._type=h,this._name=_,this._workspaceFolder=T,this._configuration=R,this._parentSession=W}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(a){this._name=a,this._debugServiceProxy.$setDebugSessionName(this._id,a)}get parentSession(){return this._parentSession}_acceptNameChanged(a){this._name=a}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(a,p){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,a,p)}getDebugProtocolBreakpoint(a){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,a.id)}}e.ExtHostDebugSession=b;class l{constructor(a){this.value=Object.freeze({append(p){a.$appendDebugConsole(p)},appendLine(p){this.append(p+`
`)}})}}e.ExtHostDebugConsole=l;class P extends c.AbstractVariableResolverService{constructor(a,p,h,_,T,R){function W(){if(p){const E=p.activeEditor();if(E)return E.document.uri;const H=_.tabGroups.all.find(q=>q.isActive)?.activeTab;if(H!==void 0){const q=H.resource;return q&&(q.primary||q.secondary)?q.primary??q.secondary:H.resource}}}super({getFolderUri:E=>{const H=a.filter(q=>q.name===E);if(H&&H.length>0)return H[0].uri},getWorkspaceFolderCount:()=>a.length,getConfigurationValue:(E,H)=>h.getConfiguration(void 0,E).get(H),getAppRoot:()=>k.cwd(),getExecPath:()=>k.env.VSCODE_EXEC_PATH,getFilePath:()=>{const E=W();if(E)return o.normalize(E.fsPath)},getWorkspaceFolderPathForFile:()=>{if(T){const E=W();if(E){const H=T.getWorkspaceFolder(E);if(H)return o.normalize(H.uri.fsPath)}}},getSelectedText:()=>{if(p){const E=p.activeEditor();if(E&&!E.selection.isEmpty)return E.document.getText(E.selection)}},getLineNumber:()=>{if(p){const E=p.activeEditor();if(E)return String(E.selection.end.line+1)}}},void 0,R?Promise.resolve(R):void 0,Promise.resolve(k.env))}}e.ExtHostVariableResolverService=P;class u{constructor(a){this.trackers=a}onWillStartSession(){this.trackers.forEach(a=>a.onWillStartSession?a.onWillStartSession():void 0)}onWillReceiveMessage(a){this.trackers.forEach(p=>p.onWillReceiveMessage?p.onWillReceiveMessage(a):void 0)}onDidSendMessage(a){this.trackers.forEach(p=>p.onDidSendMessage?p.onDidSendMessage(a):void 0)}onWillStopSession(){this.trackers.forEach(a=>a.onWillStopSession?a.onWillStopSession():void 0)}onError(a){this.trackers.forEach(p=>p.onError?p.onError(a):void 0)}onExit(a,p){this.trackers.forEach(h=>h.onExit?h.onExit(a,p):void 0)}}class i extends C.AbstractDebugAdapter{constructor(a){super();this.implementation=a,a.onDidSendMessage(p=>{this.acceptMessage(p)})}startSession(){return Promise.resolve(void 0)}sendMessage(a){this.implementation.handleMessage(a)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let s=class extends f{constructor(a,p,h,_,T,R){super(a,p,h,_,T,R)}createVariableResolver(a,p,h){return new P(a,p,h,this._editorTabs)}};s=Fe([Ne(0,n.IExtHostRpcService),Ne(1,L.IExtHostWorkspace),Ne(2,M.IExtHostExtensionService),Ne(3,v.IExtHostDocumentsAndEditors),Ne(4,g.IExtHostConfiguration),Ne(5,d.IExtHostEditorTabs)],s),e.WorkerExtHostDebugService=s}),define(Ee[217],be([1,0,69,2,4,32,28,25,14,27,3,33,86,12,10]),function(Y,e,o,I,w,B,S,A,C,L,M,v,c,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let n=class{constructor(b,l,P,u,i,s,t){this._apiFactory=b,this._extensionRegistry=l,this._instaService=P,this._extHostConfiguration=u,this._extHostExtensionService=i,this._initData=s,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),o.mark("code/extHost/willWaitForConfig");const b=await this._extHostConfiguration.getConfigProvider();o.mark("code/extHost/didWaitForConfig");const l=await this._extHostExtensionService.getExtensionPathIndex();this.register(new y(this._apiFactory,l,this._extensionRegistry,b,this._logService)),this.register(this._instaService.createInstance(k,l)),this.register(this._instaService.createInstance(m)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(d,l,this._initData.environment.appUriScheme))}register(b){if("nodeModuleName"in b)if(Array.isArray(b.nodeModuleName))for(let l of b.nodeModuleName)this._factories.set(l,b);else this._factories.set(b.nodeModuleName,b);typeof b.alternativeModuleName=="function"&&this._alternatives.push(l=>b.alternativeModuleName(l))}};n=Fe([Ne(2,M.IInstantiationService),Ne(3,B.IExtHostConfiguration),Ne(4,v.IExtHostExtensionService),Ne(5,L.IExtHostInitDataService),Ne(6,g.ILogService)],n),e.RequireInterceptor=n;let m=class Wi{constructor(b){if(b.environment.appRoot&&Wi.aliased.size){const l=(0,r.escapeRegExpCharacters)(this.forceForwardSlashes(b.environment.appRoot.fsPath)),P="[a-z0-9_.-]",u=`@${P}+\\/${P}+|${P}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${l}/${i}\\/)(${u})(.*)$`,"i")}}alternativeModuleName(b){if(!this.re)return;const l=this.re.exec(this.forceForwardSlashes(b));if(!l)return;const[,P,u,i]=l,s=Wi.aliased.get(u);if(s!==void 0)return console.warn(`${u} as been renamed to ${s}, please update your imports`),P+s+i}forceForwardSlashes(b){return b.replace(/\\/g,"/")}};m.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),m=Fe([Ne(0,L.IExtHostInitDataService)],m);class y{constructor(b,l,P,u,i){this._apiFactory=b,this._extensionPaths=l,this._extensionRegistry=P,this._configProvider=u,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(b,l){const P=this._extensionPaths.findSubstr(l);if(P){let u=this._extApiImpl.get(A.ExtensionIdentifier.toKey(P.identifier));return u||(u=this._apiFactory(P,this._extensionRegistry,this._configProvider),this._extApiImpl.set(A.ExtensionIdentifier.toKey(P.identifier),u)),u}if(!this._defaultApiImpl){let u="";this._extensionPaths.forEach((i,s)=>u+=`	${s} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${l}. These are the extension path mappings: 
${u}`),this._defaultApiImpl=this._apiFactory(S.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let k=class{constructor(b,l,P){this._extensionPaths=b,this.nodeModuleName="keytar",this._mainThreadTelemetry=l.getProxy(w.MainContext.MainThreadTelemetry);const{environment:u}=P,i=l.getProxy(w.MainContext.MainThreadKeytar);if(u.appRoot){let s=u.appRoot.fsPath;c.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${s}/node_modules.asar/keytar`),this.alternativeNames.add(`${s}/node_modules/keytar`)}this._impl={getPassword:(s,t)=>i.$getPassword(s,t),setPassword:(s,t,a)=>i.$setPassword(s,t,a),deletePassword:(s,t)=>i.$deletePassword(s,t),findPassword:s=>i.$findPassword(s),findCredentials(s){return i.$findCredentials(s)}}}load(b,l){const P=this._extensionPaths.findSubstr(l);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:P?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(b){const l=b.length;if(l<=7||!this.alternativeNames)return;const P=l-7;if((b.charAt(P)==="/"||b.charAt(P)==="\\")&&b.endsWith("keytar")&&(b=b.replace(/\\/g,"/"),this.alternativeNames.has(b)))return"keytar"}};k=Fe([Ne(1,C.IExtHostRpcService),Ne(2,L.IExtHostInitDataService)],k);let d=class{constructor(b,l,P){this._extensionPaths=b,this._appUriScheme=l,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=P.getProxy(w.MainContext.MainThreadTelemetry);const u=P.getProxy(w.MainContext.MainThreadWindow);this._impl=(i,s)=>{const t=I.URI.parse(i);return s?this.callOriginal(i,s):t.scheme==="http"||t.scheme==="https"?u.$openUri(t,i,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?u.$openUri(t,i,{}):this.callOriginal(i,s)}}load(b,l,P){const u=this._extensionPaths.findSubstr(l);return u&&(this._extensionId=u.identifier.value,this.sendShimmingTelemetry()),this._original=P(b),this._impl}callOriginal(b,l){return this.sendNoForwardTelemetry(),this._original(b,l)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};d=Fe([Ne(2,C.IExtHostRpcService)],d)}),define(Ee[218],be([1,0,13,15,69,6,2,4,210,12,55,56,27,139,14,60,33,40]),function(Y,e,o,I,w,B,S,A,C,L,M,v,c,g,r,n,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class k{constructor(f,b,l,P,u){this._disposables=new B.DisposableStore,this._isTerminating=!1,this._hostUtils=l,this._rpcProtocol=new C.RPCProtocol(f,null,P),b=k._transform(b,this._rpcProtocol);const i=new v.ServiceCollection(...(0,M.getSingletonServiceDescriptors)());i.set(c.IExtHostInitDataService,{_serviceBrand:void 0,...b,messagePorts:u}),i.set(r.IExtHostRpcService,new r.ExtHostRpcService(this._rpcProtocol)),i.set(n.IURITransformerService,new n.URITransformerService(P)),i.set(m.IHostUtils,l);const s=new g.InstantiationService(i,!0);this._disposables.add(s.invokeFunction(h=>h.get(y.IExtHostTerminalService))),this._disposables.add(s.invokeFunction(h=>h.get(m.IExtHostExtensionService))),this._logService=s.invokeFunction(h=>h.get(L.ILogService)),w.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",b),this._extensionService=s.invokeFunction(h=>h.get(m.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const t=new WeakMap;this._extensionService.getExtensionPathIndex().then(h=>{Error.prepareStackTrace=(_,T)=>{let R="",W,E;for(const H of T)R+=`
	at ${H.toString()}`,E=H.getFileName(),!W&&E&&(W=h.findSubstr(S.URI.file(E)));return t.set(_,W),`${_.name||"Error"}: ${_.message||""}${R}`}});const a=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService),p=this._rpcProtocol.getProxy(A.MainContext.MainThreadErrors);I.setUnexpectedErrorHandler(h=>{const _=I.transformErrorForSerialization(h),T=t.get(h);T?a.$onExtensionRuntimeError(T.identifier,_):p.$onUnexpectedError(_)})}terminate(f){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${f}`),this._logService.flush(),this._disposables.dispose(),I.setUnexpectedErrorHandler(l=>{this._logService.error(l)}),this._rpcProtocol.dispose();const b=this._extensionService.deactivateAll();Promise.race([(0,o.timeout)(5e3),b]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(f,b){f.extensions.forEach(P=>P.extensionLocation=S.URI.revive(b.transformIncomingURIs(P.extensionLocation))),f.environment.appRoot=S.URI.revive(b.transformIncomingURIs(f.environment.appRoot));const l=f.environment.extensionDevelopmentLocationURI;return l&&(f.environment.extensionDevelopmentLocationURI=l.map(P=>S.URI.revive(b.transformIncomingURIs(P)))),f.environment.extensionTestsLocationURI=S.URI.revive(b.transformIncomingURIs(f.environment.extensionTestsLocationURI)),f.environment.globalStorageHome=S.URI.revive(b.transformIncomingURIs(f.environment.globalStorageHome)),f.environment.workspaceStorageHome=S.URI.revive(b.transformIncomingURIs(f.environment.workspaceStorageHome)),f.logsLocation=S.URI.revive(b.transformIncomingURIs(f.logsLocation)),f.logFile=S.URI.revive(b.transformIncomingURIs(f.logFile)),f.workspace=b.transformIncomingURIs(f.workspace),f}}e.ExtensionHostMain=k}),define(Ee[219],be([1,0,16,13,20,43,29,9,17,24,11,2,41]),function(Y,e,o,I,w,B,S,A,C,L,M,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class g{constructor(f,b,l,P){this.query=f,this.provider=b,this.fileUtils=l,this.processType=P,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(f,b){const l=this.query.folderQueries||[],P=new w.CancellationTokenSource;return b.onCancellationRequested(()=>P.cancel()),new Promise((u,i)=>{this.collector=new n(f);let s=!1;const t=(a,p)=>{if(!s&&!this.isLimitHit){const h=this.resultSize(a);y(a)&&typeof this.query.maxResults=="number"&&this.resultCount+h>this.query.maxResults&&(this.isLimitHit=!0,s=!0,P.cancel(),a=this.trimResultToSize(a,this.query.maxResults-this.resultCount));const _=this.resultSize(a);this.resultCount+=_,(_>0||!y(a))&&this.collector.add(a,p)}};Promise.all(l.map((a,p)=>this.searchInFolder(a,h=>t(h,p),P.token))).then(a=>{P.dispose(),this.collector.flush();const p=a.some(h=>!!h&&!!h.limitHit);u({limitHit:this.isLimitHit||p,messages:(0,o.flatten)(a.map(h=>h?.message?(0,M.isArray)(h.message)?h.message:[h.message]:[])),stats:{type:this.processType}})},a=>{P.dispose();const p=(0,B.toErrorMessage)(a);i(new Error(p))})})}resultSize(f){return y(f)?Array.isArray(f.ranges)?f.ranges.length:1:0}trimResultToSize(f,b){const l=Array.isArray(f.ranges)?f.ranges:[f.ranges],P=Array.isArray(f.preview.matches)?f.preview.matches:[f.preview.matches];return{ranges:l.slice(0,b),preview:{matches:P.slice(0,b),text:f.preview.text},uri:f.uri}}async searchInFolder(f,b,l){const P=new c.QueryGlobTester(this.query,f),u=[],i={report:a=>{if(!this.validateProviderResult(a))return;const p=f.folder.scheme===A.Schemas.file?S.hasSiblingPromiseFn(()=>this.fileUtils.readdir(L.dirname(a.uri))):void 0,h=L.relativePath(f.folder,a.uri);if(h){const _=P.includedInQuery(h,C.basename(h),p);(0,I.isThenable)(_)?u.push(_.then(T=>{T&&b(a)})):_&&b(a)}}},s=this.getSearchOptionsForFolder(f),t=await this.provider.provideTextSearchResults(r(this.query.contentPattern),s,i,l);return u.length&&await Promise.all(u),t}validateProviderResult(f){if(y(f)){if(Array.isArray(f.ranges)){if(!Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(f.preview.matches.length!==f.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(f){const b=(0,c.resolvePatternsForProvider)(this.query.includePattern,f.includePattern),l=(0,c.resolvePatternsForProvider)(this.query.excludePattern,f.excludePattern),P={folder:v.URI.from(f.folder),excludes:l,includes:b,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!f.disregardParentIgnoreFiles,followSymlinks:!f.ignoreSymlinks,encoding:f.fileEncoding&&this.fileUtils.toCanonicalName(f.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return P.usePCRE2=this.query.usePCRE2,P}}e.TextSearchManager=g;function r(d){return{isCaseSensitive:d.isCaseSensitive||!1,isRegExp:d.isRegExp||!1,isWordMatch:d.isWordMatch||!1,isMultiline:d.isMultiline||!1,pattern:d.pattern}}class n{constructor(f){this._onResult=f,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new k(512,b=>this.sendItems(b))}add(f,b){this._currentFileMatch&&(this._currentFolderIdx!==b||!L.isEqual(this._currentUri,f.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=b,this._currentFileMatch={resource:f.uri,results:[]}),this._currentFileMatch.results.push(m(f))}pushToCollector(){const f=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,f)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(f){this._onResult(f)}}e.TextSearchResultsCollector=n;function m(d){return y(d)?{preview:{matches:(0,o.mapArrayOrNot)(d.preview.matches,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character})),text:d.preview.text},ranges:(0,o.mapArrayOrNot)(d.ranges,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character}))}:{text:d.text,lineNumber:d.lineNumber}}function y(d){return!!d.preview}e.extensionResultIsMatch=y;class k{constructor(f,b){this.maxBatchSize=f,this.cb=b,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(f,b){!f||this.addItemToBatch(f,b)}addItems(f,b){!f||this.addItemsToBatch(f,b)}addItemToBatch(f,b){this.batch.push(f),this.batchSize+=b,this.onUpdate()}addItemsToBatch(f,b){this.batch=this.batch.concat(f),this.batchSize+=b,this.onUpdate()}onUpdate(){this.totalNumberCompleted<k.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},k.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=k,k.TIMEOUT=4e3,k.START_BATCH_AFTER_COUNT=50}),define(Ee[99],be([1,0,6,4,3,214,14,60,12,2,219]),function(Y,e,o,I,w,B,S,A,C,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,w.createDecorator)("IExtHostSearch");let v=class{constructor(n,m,y){this.extHostRpc=n,this._uriTransformer=m,this._logService=y,this._proxy=this.extHostRpc.getProxy(I.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new B.FileSearchManager}_transformScheme(n){return this._uriTransformer.transformOutgoingScheme(n)}registerTextSearchProvider(n,m){if(this._textSearchUsedSchemes.has(n))throw new Error(`a text search provider for the scheme '${n}' is already registered`);this._textSearchUsedSchemes.add(n);const y=this._handlePool++;return this._textSearchProvider.set(y,m),this._proxy.$registerTextSearchProvider(y,this._transformScheme(n)),(0,o.toDisposable)(()=>{this._textSearchUsedSchemes.delete(n),this._textSearchProvider.delete(y),this._proxy.$unregisterProvider(y)})}registerFileSearchProvider(n,m){if(this._fileSearchUsedSchemes.has(n))throw new Error(`a file search provider for the scheme '${n}' is already registered`);this._fileSearchUsedSchemes.add(n);const y=this._handlePool++;return this._fileSearchProvider.set(y,m),this._proxy.$registerFileSearchProvider(y,this._transformScheme(n)),(0,o.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(n),this._fileSearchProvider.delete(y),this._proxy.$unregisterProvider(y)})}$provideFileSearchResults(n,m,y,k){const d=c(y),f=this._fileSearchProvider.get(n);if(f)return this._fileSearchManager.fileSearch(d,f,b=>{this._proxy.$handleFileMatch(n,m,b.map(l=>l.resource))},k);throw new Error("unknown provider: "+n)}$clearCache(n){return this._fileSearchManager.clearCache(n),Promise.resolve(void 0)}$provideTextSearchResults(n,m,y,k){const d=this._textSearchProvider.get(n);if(!d||!d.provideTextSearchResults)throw new Error(`Unknown provider ${n}`);const f=c(y);return this.createTextSearchManager(f,d).search(l=>this._proxy.$handleTextMatch(n,m,l),k)}$enableExtensionHostSearch(){}createTextSearchManager(n,m){return new M.TextSearchManager(n,m,{readdir:y=>Promise.resolve([]),toCanonicalName:y=>y},"textSearchProvider")}};v=Fe([Ne(0,S.IExtHostRpcService),Ne(1,A.IURITransformerService),Ne(2,C.ILogService)],v),e.ExtHostSearch=v;function c(r){return{...r,folderQueries:r.folderQueries&&r.folderQueries.map(g),extraFileResources:r.extraFileResources&&r.extraFileResources.map(n=>L.URI.revive(n))}}e.reviveQuery=c;function g(r){return{...r,folder:L.URI.revive(r.folder)}}}),define(Ee[220],be([1,0,55,94,31,92,32,39,49,40,97,98,99,67,59,65,95,50,30,64,83,66,193,12,175]),function(Y,e,o,I,w,B,S,A,C,L,M,v,c,g,r,n,m,y,k,d,f,b,l,P,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,o.registerSingleton)(P.ILoggerService,l.ExtHostLoggerService),(0,o.registerSingleton)(P.ILogService,u.ExtHostLogService),(0,o.registerSingleton)(n.IExtHostApiDeprecationService,n.ExtHostApiDeprecationService),(0,o.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands),(0,o.registerSingleton)(S.IExtHostConfiguration,S.ExtHostConfiguration),(0,o.registerSingleton)(y.IExtHostConsumerFileSystem,y.ExtHostConsumerFileSystem),(0,o.registerSingleton)(v.IExtHostDebugService,v.WorkerExtHostDebugService),(0,o.registerSingleton)(B.IExtHostDecorations,B.ExtHostDecorations),(0,o.registerSingleton)(C.IExtHostDocumentsAndEditors,C.ExtHostDocumentsAndEditors),(0,o.registerSingleton)(k.IExtHostFileSystemInfo,k.ExtHostFileSystemInfo),(0,o.registerSingleton)(I.IExtHostOutputService,I.ExtHostOutputService),(0,o.registerSingleton)(c.IExtHostSearch,c.ExtHostSearch),(0,o.registerSingleton)(g.IExtHostStorage,g.ExtHostStorage),(0,o.registerSingleton)(M.IExtHostTask,M.WorkerExtHostTask),(0,o.registerSingleton)(L.IExtHostTerminalService,L.WorkerExtHostTerminalService),(0,o.registerSingleton)(r.IExtHostTunnelService,r.ExtHostTunnelService),(0,o.registerSingleton)(m.IExtHostWindow,m.ExtHostWindow),(0,o.registerSingleton)(w.IExtHostWorkspace,w.ExtHostWorkspace),(0,o.registerSingleton)(d.IExtHostSecretState,d.ExtHostSecretState),(0,o.registerSingleton)(f.IExtHostTelemetry,f.ExtHostTelemetry),(0,o.registerSingleton)(b.IExtHostEditorTabs,b.ExtHostEditorTabs)}),define(Ee[221],be([1,0]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class o{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(w){if(w&&this._dragOperations.has(w)){const B=this._dragOperations.get(w);return this._dragOperations.delete(w),B}}addDragOperationTransfer(w,B){this._dragOperations.set(w,B)}getRenderedTreeElement(w){if(this._renderedElements.has(w))return this._renderedElements.get(w)}addRenderedTreeItemElement(w,B){this._renderedElements.set(w,B)}removeRenderedTreeItemElement(w){this._renderedElements.has(w)&&this._renderedElements.delete(w)}}e.TreeviewsService=o}),define(Ee[222],be([1,0,127,24,2,5,6,13,7,11,16,8,20,155,221]),function(Y,e,o,I,w,B,S,A,C,L,M,v,c,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function n(k,d){if((0,L.isString)(k))return{label:k};if(k&&typeof k=="object"&&typeof k.label=="string"){let f;return Array.isArray(k.highlights)&&(f=k.highlights.filter(b=>b.length===2&&typeof b[0]=="number"&&typeof b[1]=="number"),f=f.length?f:void 0),{label:k.label,highlights:f}}}class m{constructor(d,f,b){this._proxy=d,this.commands=f,this.logService=b,this.treeViews=new Map,this.treeDragAndDropService=new r.TreeviewsService;function l(P){return P&&P.$treeViewId&&P.$treeItemHandle}f.registerArgumentProcessor({processArgument:P=>l(P)?this.convertArgument(P):Array.isArray(P)&&P.length>0?P.map(u=>l(u)?this.convertArgument(u):u):P})}registerTreeDataProvider(d,f,b){const l=this.createTreeView(d,{treeDataProvider:f},b);return{dispose:()=>l.dispose()}}createTreeView(d,f,b){if(!f||!f.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const l=f.dragAndDropController?.dropMimeTypes??[],P=f.dragAndDropController?.dragMimeTypes??[],u=!!f.dragAndDropController?.handleDrag,i=!!f.dragAndDropController?.handleDrop,s=this._proxy.$registerTreeViewDataProvider(d,{showCollapseAll:!!f.showCollapseAll,canSelectMany:!!f.canSelectMany,dropMimeTypes:l,dragMimeTypes:P,hasHandleDrag:u,hasHandleDrop:i}),t=this.createExtHostTreeView(d,f,b);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(a){t.message=a},get title(){return t.title},set title(a){t.title=a},get description(){return t.description},set description(a){t.description=a},reveal:(a,p)=>t.reveal(a,p),dispose:async()=>{await s,this.treeViews.delete(d),t.dispose()}}}$getChildren(d,f){const b=this.treeViews.get(d);return b?b.getChildren(f):Promise.reject(new Error((0,o.localize)(0,null,d)))}async $handleDrop(d,f,b,l,P,u,i){const s=this.treeViews.get(d);if(!s)return Promise.reject(new Error((0,o.localize)(1,null,d)));const t=g.TreeDataTransferConverter.toITreeDataTransfer(f);return u===d&&i&&await this.addAdditionalTransferItems(t,s,i,l,P),s.onDrop(t,b,l)}async addAdditionalTransferItems(d,f,b,l,P){const u=this.treeDragAndDropService.removeDragOperationTransfer(P);if(u)(await u)?.forEach((i,s)=>{i&&d.set(s,i)});else if(P&&f.handleDrag){const i=f.handleDrag(b,d,l);this.treeDragAndDropService.addDragOperationTransfer(P,i),await i}return d}async $handleDrag(d,f,b,l){const P=this.treeViews.get(d);if(!P)return Promise.reject(new Error((0,o.localize)(2,null,d)));const u=await this.addAdditionalTransferItems(new Map,P,f,l,b);if(!!u)return g.TreeDataTransferConverter.toTreeDataTransferDTO(u)}async $hasResolve(d){const f=this.treeViews.get(d);if(!f)throw new Error((0,o.localize)(3,null,d));return f.hasResolve}$resolve(d,f,b){const l=this.treeViews.get(d);if(!l)throw new Error((0,o.localize)(4,null,d));return l.resolveTreeItem(f,b)}$setExpanded(d,f,b){const l=this.treeViews.get(d);if(!l)throw new Error((0,o.localize)(5,null,d));l.setExpanded(f,b)}$setSelection(d,f){const b=this.treeViews.get(d);if(!b)throw new Error((0,o.localize)(6,null,d));b.setSelection(f)}$setVisible(d,f){const b=this.treeViews.get(d);if(!b)throw new Error((0,o.localize)(7,null,d));b.setVisible(f)}createExtHostTreeView(d,f,b){const l=new y(d,f,this._proxy,this.commands.converter,this.logService,b);return this.treeViews.set(d,l),l}convertArgument(d){const f=this.treeViews.get(d.$treeViewId);return f?f.getExtensionElement(d.$treeItemHandle):null}}e.ExtHostTreeViews=m;class y extends S.Disposable{constructor(d,f,b,l,P,u){super();if(this.viewId=d,this.proxy=b,this.commands=l,this.logService=P,this.extension=u,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new B.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new B.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new B.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new B.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new B.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new c.CancellationTokenSource,u.contributes&&u.contributes.views)for(const t in u.contributes.views)for(const a of u.contributes.views[t])a.id===d&&(this._title=a.name);this.dataProvider=f.treeDataProvider,this.dndController=f.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(t=>this._onDidChangeData.fire({message:!1,element:t}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(t=>this._onDidChangeData.fire({message:!1,element:t})));let i,s;this._register(B.Event.debounce(this._onDidChangeData.event,(t,a)=>(t||(t={message:!1,elements:[]}),a.element!==!1&&(i||(i=new Promise(p=>s=p),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(a.element)?t.elements.push(...a.element):t.elements.push(a.element)),a.message&&(t.message=!0),t),200,!0)(({message:t,elements:a})=>{a.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const p=s;return i=null,this.refresh(a).then(()=>p())})),t&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(d=>this.getExtensionElement(d)).filter(d=>!(0,L.isUndefinedOrNull)(d))}async getChildren(d){const f=d?this.getExtensionElement(d):void 0;if(d&&!f)return this.logService.error(`No tree item with id '${d}' found.`),Promise.resolve([]);let b=this.getChildrenNodes(d);return b||(b=await this.fetchChildrenNodes(f)),b?b.map(l=>l.item):void 0}getExtensionElement(d){return this.elements.get(d)}reveal(d,f){f=f||{select:!0,focus:!1};const b=(0,L.isUndefinedOrNull)(f.select)?!0:f.select,l=(0,L.isUndefinedOrNull)(f.focus)?!1:f.focus,P=(0,L.isUndefinedOrNull)(f.expand)?!1:f.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):d?this.refreshPromise.then(()=>this.resolveUnknownParentChain(d)).then(u=>this.resolveTreeNode(d,u[u.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:u.map(s=>s.item)},{select:b,focus:l,expand:P})),u=>this.logService.error(u)):this.proxy.$reveal(this.viewId,void 0,{select:b,focus:l,expand:P})}get message(){return this._message}set message(d){this._message=d,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(d){this._title=d,this.proxy.$setTitle(this.viewId,d,this._description)}get description(){return this._description}set description(d){this._description=d,this.proxy.$setTitle(this.viewId,this._title,d)}setExpanded(d,f){const b=this.getExtensionElement(d);b&&(f?this._onDidExpandElement.fire(Object.freeze({element:b})):this._onDidCollapseElement.fire(Object.freeze({element:b})))}setSelection(d){(0,M.equals)(this._selectedHandles,d)||(this._selectedHandles=d,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(d){d!==this._visible&&(this._visible=d,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(d,f,b){const l=[];for(const P of d){const u=this.getExtensionElement(P);u&&l.push(u)}if(!(!this.dndController?.handleDrag||l.length===0))return await this.dndController.handleDrag(l,f,b),f}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(d,f,b){const l=this.getExtensionElement(f);if(!(!l||!this.dndController?.handleDrop))return(0,A.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(l,d,b):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(d,f){if(!this.dataProvider.resolveTreeItem)return;const b=this.elements.get(d);if(b){const l=this.nodes.get(b);if(l){const P=await this.dataProvider.resolveTreeItem(l.extensionItem,b,f)??l.extensionItem;return l.item.tooltip=this.getTooltip(P.tooltip),l.item.command=this.getCommand(l.disposableStore,P.command),l.item}}}resolveUnknownParentChain(d){return this.resolveParent(d).then(f=>f?this.resolveUnknownParentChain(f).then(b=>this.resolveTreeNode(f,b[b.length-1]).then(l=>(b.push(l),b))):Promise.resolve([]))}resolveParent(d){const f=this.nodes.get(d);return f?Promise.resolve(f.parent?this.elements.get(f.parent.item.handle):void 0):(0,A.asPromise)(()=>this.dataProvider.getParent(d))}resolveTreeNode(d,f){const b=this.nodes.get(d);return b?Promise.resolve(b):(0,A.asPromise)(()=>this.dataProvider.getTreeItem(d)).then(l=>this.createHandle(d,l,f,!0)).then(l=>this.getChildren(f?f.item.handle:void 0).then(()=>{const P=this.getExtensionElement(l);if(P){const u=this.nodes.get(P);if(u)return Promise.resolve(u)}throw new Error(`Cannot resolve tree item for element ${l}`)}))}getChildrenNodes(d){if(d){let f;if(typeof d=="string"){const b=this.getExtensionElement(d);f=b?this.nodes.get(b):void 0}else f=d;return f&&f.children||void 0}return this.roots}async fetchChildrenNodes(d){this.clearChildren(d);const f=new c.CancellationTokenSource(this._refreshCancellationSource.token);try{const b=d?this.nodes.get(d):void 0,l=await this.dataProvider.getChildren(d);if(f.token.isCancellationRequested)return;const P=await Promise.all((0,M.coalesce)(l||[]).map(async u=>{const i=await this.dataProvider.getTreeItem(u);return i&&!f.token.isCancellationRequested?this.createAndRegisterTreeNode(u,i,b):null}));return f.token.isCancellationRequested?void 0:(0,M.coalesce)(P)}finally{f.dispose()}}refresh(d){if(d.some(b=>!b))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new c.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const b=this.getHandlesToRefresh(d);if(b.length)return this.refreshHandles(b)}return Promise.resolve(void 0)}getHandlesToRefresh(d){const f=new Set,b=d.map(P=>this.nodes.get(P));for(const P of b)if(P&&!f.has(P.item.handle)){let u=P;for(;u&&u.parent&&b.findIndex(i=>u&&u.parent&&i&&i.item.handle===u.parent.item.handle)===-1;){const i=this.elements.get(u.parent.item.handle);u=i?this.nodes.get(i):void 0}u&&!u.parent&&f.add(P.item.handle)}const l=[];return f.forEach(P=>{const u=this.elements.get(P);if(u){const i=this.nodes.get(u);i&&(!i.parent||!f.has(i.parent.item.handle))&&l.push(P)}}),l}refreshHandles(d){const f={};return Promise.all(d.map(b=>this.refreshNode(b).then(l=>{l&&(f[b]=l.item)}))).then(()=>Object.keys(f).length?this.proxy.$refresh(this.viewId,f):void 0)}refreshNode(d){const f=this.getExtensionElement(d);if(f){const b=this.nodes.get(f);if(b)return this.clearChildren(f),(0,A.asPromise)(()=>this.dataProvider.getTreeItem(f)).then(l=>{if(l){const P=this.createTreeNode(f,l,b.parent);return this.updateNodeCache(f,P,b,b.parent),b.dispose(),P}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(d,f,b){const l=this.createTreeNode(d,f,b);if(f.id&&this.elements.has(l.item.handle))throw new Error((0,o.localize)(8,null,f.id));return this.addNodeToCache(d,l),this.addNodeToParentCache(l,b),l}getTooltip(d){return C.MarkdownString.isMarkdownString(d)?v.MarkdownString.from(d):d}getCommand(d,f){return f?this.commands.toInternal(f,d):void 0}createTreeNode(d,f,b){const l=new S.DisposableStore,P=this.createHandle(d,f,b),u=this.getLightIconPath(f);return{item:{handle:P,parentHandle:b?b.item.handle:void 0,label:n(f.label,this.extension),description:f.description,resourceUri:f.resourceUri,tooltip:this.getTooltip(f.tooltip),command:this.getCommand(l,f.command),contextValue:f.contextValue,icon:u,iconDark:this.getDarkIconPath(f)||u,themeIcon:this.getThemeIcon(f),collapsibleState:(0,L.isUndefinedOrNull)(f.collapsibleState)?C.TreeItemCollapsibleState.None:f.collapsibleState,accessibilityInformation:f.accessibilityInformation},extensionItem:f,parent:b,children:void 0,disposableStore:l,dispose(){l.dispose()}}}getThemeIcon(d){return d.iconPath instanceof C.ThemeIcon?d.iconPath:void 0}createHandle(d,{id:f,label:b,resourceUri:l},P,u){if(f)return`${y.ID_HANDLE_PREFIX}/${f}`;const i=n(b,this.extension),s=P?P.item.handle:y.LABEL_HANDLE_PREFIX;let t=i?i.label:l?(0,I.basename)(l):"";t=t.indexOf("/")!==-1?t.replace("/","//"):t;const a=this.nodes.has(d)?this.nodes.get(d).item.handle:void 0,p=this.getChildrenNodes(P)||[];let h,_=0;do{if(h=`${s}/${_}:${t}`,u||!this.elements.has(h)||a===h)break;_++}while(_<=p.length);return h}getLightIconPath(d){if(d.iconPath&&!(d.iconPath instanceof C.ThemeIcon))return typeof d.iconPath=="string"||w.URI.isUri(d.iconPath)?this.getIconPath(d.iconPath):this.getIconPath(d.iconPath.light)}getDarkIconPath(d){if(d.iconPath&&!(d.iconPath instanceof C.ThemeIcon)&&d.iconPath.dark)return this.getIconPath(d.iconPath.dark)}getIconPath(d){return w.URI.isUri(d)?d:w.URI.file(d)}addNodeToCache(d,f){this.elements.set(f.item.handle,d),this.nodes.set(d,f)}updateNodeCache(d,f,b,l){this.elements.delete(f.item.handle),this.nodes.delete(d),f.item.handle!==b.item.handle&&this.elements.delete(b.item.handle),this.addNodeToCache(d,f);const P=this.getChildrenNodes(l)||[],u=P.filter(i=>i.item.handle===b.item.handle)[0];u&&P.splice(P.indexOf(u),1,f)}addNodeToParentCache(d,f){f?(f.children||(f.children=[]),f.children.push(d)):(this.roots||(this.roots=[]),this.roots.push(d))}clearChildren(d){if(d){const f=this.nodes.get(d);if(f){if(f.children)for(const b of f.children){const l=this.elements.get(b.item.handle);l&&this.clear(l)}f.children=void 0}}else this.clearAll()}clear(d){const f=this.nodes.get(d);if(f){if(f.children)for(const b of f.children){const l=this.elements.get(b.item.handle);l&&this.clear(l)}this.nodes.delete(d),this.elements.delete(f.item.handle),f.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(d=>d.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}y.LABEL_HANDLE_PREFIX="0",y.ID_HANDLE_PREFIX="1"}),define(Ee[223],be([1,0,20,15,5,34,2,115,235,110,74,45,4,91,180,179,39,181,32,182,183,184,168,185,49,33,186,187,190,192,194,94,170,199,200,201,67,40,203,222,8,7,206,51,95,31,70,157,189,82,92,97,98,99,12,60,14,27,195,153,59,65,177,204,152,68,50,209,207,208,178,30,202,205,64,66,83,197,96,198,9,79,196,150,188,6,28,159]),function(Y,e,o,I,w,B,S,A,C,L,M,v,c,g,r,n,m,y,k,d,f,b,l,P,u,i,s,t,a,p,h,_,T,R,W,E,H,q,$,j,J,z,ie,ae,te,ce,de,Se,fe,ne,me,ke,Ae,Be,Xe,ge,ue,N,F,D,O,x,X,re,ve,Ie,Me,Le,ze,xe,Re,Qe,tt,Te,it,G,Q,le,Oe,He,Ge,Je,ft,It,St,kt,qe,vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Nt(nt){const ut=nt.get(N.IExtHostInitDataService),At=nt.get(Qe.IExtHostFileSystemInfo),Tt=nt.get(Me.IExtHostConsumerFileSystem),wt=nt.get(i.IExtHostExtensionService),dt=nt.get(ce.IExtHostWorkspace),Rt=nt.get(Q.IExtHostTelemetry),Lt=nt.get(k.IExtHostConfiguration),Ft=nt.get(ge.IURITransformerService),Ue=nt.get(ue.IExtHostRpcService),he=nt.get(H.IExtHostStorage),pe=nt.get(Ie.IExtensionStoragePaths),se=nt.get(Xe.ILoggerService),K=nt.get(Xe.ILogService),_e=nt.get(O.IExtHostTunnelService),Ce=nt.get(x.IExtHostApiDeprecationService),$e=nt.get(te.IExtHostWindow),Ve=nt.get(it.IExtHostSecretState),lt=nt.get(G.IExtHostEditorTabs);Ue.set(c.ExtHostContext.ExtHostFileSystemInfo,At),Ue.set(c.ExtHostContext.ExtHostLogLevelServiceShape,se),Ue.set(c.ExtHostContext.ExtHostWorkspace,dt),Ue.set(c.ExtHostContext.ExtHostConfiguration,Lt),Ue.set(c.ExtHostContext.ExtHostExtensionService,wt),Ue.set(c.ExtHostContext.ExtHostStorage,he),Ue.set(c.ExtHostContext.ExtHostTunnelService,_e),Ue.set(c.ExtHostContext.ExtHostWindow,$e),Ue.set(c.ExtHostContext.ExtHostSecretState,Ve),Ue.set(c.ExtHostContext.ExtHostTelemetry,Rt),Ue.set(c.ExtHostContext.ExtHostEditorTabs,lt);const gt=Ue.set(c.ExtHostContext.ExtHostDecorations,nt.get(me.IExtHostDecorations)),Et=Ue.set(c.ExtHostContext.ExtHostDocumentsAndEditors,nt.get(u.IExtHostDocumentsAndEditors)),rt=Ue.set(c.ExtHostContext.ExtHostCommands,nt.get(m.IExtHostCommands)),at=Ue.set(c.ExtHostContext.ExtHostTerminalService,nt.get(q.IExtHostTerminalService)),ot=Ue.set(c.ExtHostContext.ExtHostDebugService,nt.get(Ae.IExtHostDebugService)),Mt=Ue.set(c.ExtHostContext.ExtHostSearch,nt.get(Be.IExtHostSearch)),mt=Ue.set(c.ExtHostContext.ExtHostTask,nt.get(ke.IExtHostTask)),Dt=Ue.set(c.ExtHostContext.ExtHostOutputService,nt.get(_.IExtHostOutputService)),Ut=Ue.set(c.ExtHostContext.ExtHostUrls,new ie.ExtHostUrls(Ue)),bt=Ue.set(c.ExtHostContext.ExtHostDocuments,new P.ExtHostDocuments(Ue,Et)),Bt=Ue.set(c.ExtHostContext.ExtHostDocumentContentProviders,new b.ExtHostDocumentContentProvider(Ue,Et,K)),Ht=Ue.set(c.ExtHostContext.ExtHostDocumentSaveParticipant,new l.ExtHostDocumentSaveParticipant(K,bt,Ue.getProxy(c.MainContext.MainThreadBulkEdits))),pt=Ue.set(c.ExtHostContext.ExtHostNotebook,new F.ExtHostNotebookController(Ue,rt,Et,bt,pe)),ei=Ue.set(c.ExtHostContext.ExtHostNotebookDocuments,new It.ExtHostNotebookDocuments(K,pt)),Xt=Ue.set(c.ExtHostContext.ExtHostNotebookEditors,new ft.ExtHostNotebookEditors(K,Ue,pt)),ti=Ue.set(c.ExtHostContext.ExtHostNotebookKernels,new le.ExtHostNotebookKernels(Ue,ut,pt,rt,K)),ai=Ue.set(c.ExtHostContext.ExtHostNotebookRenderers,new He.ExtHostNotebookRenderers(Ue,pt)),Ct=Ue.set(c.ExtHostContext.ExtHostEditors,new $.ExtHostEditors(Ue,Et)),ii=Ue.set(c.ExtHostContext.ExtHostTreeViews,new j.ExtHostTreeViews(Ue.getProxy(c.MainContext.MainThreadTreeViews),rt,K)),wi=Ue.set(c.ExtHostContext.ExtHostEditorInsets,new Se.ExtHostEditorInsets(Ue.getProxy(c.MainContext.MainThreadEditorInsets),Ct,ut)),qt=Ue.set(c.ExtHostContext.ExtHostDiagnostics,new d.ExtHostDiagnostics(Ue,K,At)),Kt=Ue.set(c.ExtHostContext.ExtHostLanguages,new p.ExtHostLanguages(Ue,bt,rt.converter,Ft)),st=Ue.set(c.ExtHostContext.ExtHostLanguageFeatures,new a.ExtHostLanguageFeatures(Ue,Ft,bt,rt,qt,K,Ce)),li=Ue.set(c.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(Ue,st)),Wt=Ue.set(c.ExtHostContext.ExtHostFileSystemEventService,new t.ExtHostFileSystemEventService(Ue,K,Et)),zt=Ue.set(c.ExtHostContext.ExtHostQuickOpen,(0,R.createExtHostQuickOpen)(Ue,dt,rt)),ni=Ue.set(c.ExtHostContext.ExtHostSCM,new W.ExtHostSCM(Ue,rt,K)),_i=Ue.set(c.ExtHostContext.ExtHostComments,(0,y.createExtHostComments)(Ue,rt,bt)),fi=Ue.set(c.ExtHostContext.ExtHostProgress,new T.ExtHostProgress(Ue.getProxy(c.MainContext.MainThreadProgress))),Si=Ue.set(c.ExtHostContext.ExtHosLabelService,new fe.ExtHostLabelService(Ue)),mi=Ue.set(c.ExtHostContext.ExtHostTheming,new D.ExtHostTheming(Ue)),ri=Ue.set(c.ExtHostContext.ExtHostAuthentication,new X.ExtHostAuthentication(Ue)),yi=Ue.set(c.ExtHostContext.ExtHostTimeline,new re.ExtHostTimeline(Ue,rt)),Qt=Ue.set(c.ExtHostContext.ExtHostWebviews,new ae.ExtHostWebviews(Ue,{remote:ut.remote},dt,K,Ce)),Yt=Ue.set(c.ExtHostContext.ExtHostWebviewPanels,new xe.ExtHostWebviewPanels(Ue,Qt,dt)),Di=Ue.set(c.ExtHostContext.ExtHostCustomEditors,new ze.ExtHostCustomEditors(Ue,bt,pe,Qt,Yt)),Ci=Ue.set(c.ExtHostContext.ExtHostWebviewViews,new Le.ExtHostWebviewViews(Ue,Qt)),Jt=Ue.set(c.ExtHostContext.ExtHostTesting,new tt.ExtHostTesting(Ue,rt)),si=Ue.set(c.ExtHostContext.ExtHostUriOpeners,new Te.ExtHostUriOpeners(Ue));Ue.set(c.ExtHostContext.ExtHostInteractive,new St.ExtHostInteractive(Ue,pt,Et,rt));const Ii=(0,de.values)(c.ExtHostContext);Ue.assertRegistered(Ii);const ki=new Re.ExtHostBulkEdits(Ue,Et),Ti=new n.ExtHostClipboard(Ue),Zt=new h.ExtHostMessageService(Ue,K),gi=new f.ExtHostDialogs(Ue),Gt=new E.ExtHostStatusBar(Ue,rt.converter);return r.ExtHostApiCommands.register(rt),function(Pe,ci,Ot){const ct=function(){let Z=!Pe.isUnderDevelopment;function oe(){Z||(K.info(`Extension '${Pe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Z=!0)}return function ye(Ze){if(Array.isArray(Ze))Ze.forEach(ye);else if(typeof Ze=="string")oe();else{const ht=Ze;typeof ht.scheme=="undefined"&&oe(),typeof ht.exclusive=="boolean"&&(0,qe.checkProposedApiEnabled)(Pe,"documentFiltersExclusive"),typeof ht.notebookType=="string"&&(0,qe.checkProposedApiEnabled)(Pe,"notebookDocumentSelector")}return Ze}}(),Pi={getSession(Z,oe,ye){return ri.getSession(Pe,Z,oe,ye)},async hasSession(Z,oe){return(0,qe.checkProposedApiEnabled)(Pe,"authSession"),!!await ri.getSession(Pe,Z,oe,{silent:!0})},get onDidChangeSessions(){return ri.onDidChangeSessions},registerAuthenticationProvider(Z,oe,ye,Ze){return ri.registerAuthenticationProvider(Z,oe,ye,Ze)}},Ai={registerCommand(Z,oe,ye){return rt.registerCommand(!0,Z,oe,ye,void 0,Pe)},registerTextEditorCommand(Z,oe,ye){return rt.registerCommand(!0,Z,(...Ze)=>{const ht=Ct.getActiveTextEditor();if(!ht){K.warn("Cannot execute "+Z+" because there is no active text editor.");return}return ht.edit(yt=>{oe.apply(ye,[ht,yt,...Ze])}).then(yt=>{yt||K.warn("Edits from command "+Z+" were not applied.")},yt=>{K.warn("An error occurred while running command "+Z,yt)})},void 0,void 0,Pe)},registerDiffInformationCommand:(Z,oe,ye)=>((0,qe.checkProposedApiEnabled)(Pe,"diffCommand"),rt.registerCommand(!0,Z,async(...Ze)=>{const ht=Et.activeEditor(!0);if(!ht){K.warn("Cannot execute "+Z+" because there is no active text editor.");return}const yt=await Ct.getDiffInformation(ht.id);oe.apply(ye,[yt,...Ze])},void 0,void 0,Pe)),executeCommand(Z,...oe){return rt.executeCommand(Z,...oe)},getCommands(Z=!1){return rt.getCommands(Z)}},pi={get machineId(){return ut.telemetryInfo.machineId},get sessionId(){return ut.telemetryInfo.sessionId},get language(){return ut.environment.appLanguage},get appName(){return ut.environment.appName},get appRoot(){return ut.environment.appRoot?.fsPath??""},get appHost(){return ut.environment.appHost},get uriScheme(){return ut.environment.appUriScheme},get clipboard(){return Ti.value},get shell(){return at.getDefaultShell(!1)},get isTelemetryEnabled(){return Rt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Rt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,qe.checkProposedApiEnabled)(Pe,"telemetry"),Rt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,qe.checkProposedApiEnabled)(Pe,"telemetry"),Rt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const Z=Date.now()-new Date(ut.telemetryInfo.firstSessionDate).getTime();return isNaN(Z)?!1:Z<1e3*60*60*24},openExternal(Z,oe){return $e.openUri(Z,{allowTunneling:!!ut.remote.authority,allowContributedOpeners:oe?.allowContributedOpeners})},async asExternalUri(Z){if(Z.scheme===ut.environment.appUriScheme)return Ut.createAppUri(Z);try{return await $e.asExternalUri(Z,{allowTunneling:!!ut.remote.authority})}catch(oe){if((0,Je.matchesScheme)(Z,Ge.Schemas.http)||(0,Je.matchesScheme)(Z,Ge.Schemas.https))return Z;throw oe}},get remoteName(){return(0,ne.getRemoteName)(ut.remote.authority)},get remoteAuthority(){return(0,qe.checkProposedApiEnabled)(Pe,"resolvers"),ut.remote.authority},get uiKind(){return ut.uiKind}};ut.environment.extensionTestsLocationURI||Object.freeze(pi);const vi=ut.remote.isRemote?z.ExtensionKind.Workspace:z.ExtensionKind.UI,Ri={createTestController(Z,oe,ye){return Jt.createTestController(Z,oe,ye)},createTestObserver(){return(0,qe.checkProposedApiEnabled)(Pe,"testObserver"),Jt.createTestObserver()},runTests(Z){return(0,qe.checkProposedApiEnabled)(Pe,"testObserver"),Jt.runTests(Z)},get onDidChangeTestResults(){return(0,qe.checkProposedApiEnabled)(Pe,"testObserver"),Jt.onResultsChanged},get testResults(){return(0,qe.checkProposedApiEnabled)(Pe,"testObserver"),Jt.results}},Oi={getExtension(Z){const oe=ci.getExtensionDescription(Z);if(oe)return new i.Extension(wt,Pe.identifier,oe,vi)},get all(){return ci.getAllExtensionDescriptions().map(Z=>new i.Extension(wt,Pe.identifier,Z,vi))},get onDidChange(){return ci.onDidChange}},Fi={createDiagnosticCollection(Z){return qt.createDiagnosticCollection(Pe.identifier,Z)},get onDidChangeDiagnostics(){return qt.onDidChangeDiagnostics},getDiagnostics:Z=>qt.getDiagnostics(Z),getLanguages(){return Kt.getLanguages()},setTextDocumentLanguage(Z,oe){return Kt.changeLanguage(Z.uri,oe)},match(Z,oe){return(0,M.score)(J.LanguageSelector.from(Z),oe.uri,oe.languageId,!0,oe.notebook?.notebookType)},registerCodeActionsProvider(Z,oe,ye){return st.registerCodeActionProvider(Pe,ct(Z),oe,ye)},registerCodeLensProvider(Z,oe){return st.registerCodeLensProvider(Pe,ct(Z),oe)},registerDefinitionProvider(Z,oe){return st.registerDefinitionProvider(Pe,ct(Z),oe)},registerDeclarationProvider(Z,oe){return st.registerDeclarationProvider(Pe,ct(Z),oe)},registerImplementationProvider(Z,oe){return st.registerImplementationProvider(Pe,ct(Z),oe)},registerTypeDefinitionProvider(Z,oe){return st.registerTypeDefinitionProvider(Pe,ct(Z),oe)},registerHoverProvider(Z,oe){return st.registerHoverProvider(Pe,ct(Z),oe,Pe.identifier)},registerEvaluatableExpressionProvider(Z,oe){return st.registerEvaluatableExpressionProvider(Pe,ct(Z),oe,Pe.identifier)},registerInlineValuesProvider(Z,oe){return st.registerInlineValuesProvider(Pe,ct(Z),oe,Pe.identifier)},registerDocumentHighlightProvider(Z,oe){return st.registerDocumentHighlightProvider(Pe,ct(Z),oe)},registerLinkedEditingRangeProvider(Z,oe){return st.registerLinkedEditingRangeProvider(Pe,ct(Z),oe)},registerReferenceProvider(Z,oe){return st.registerReferenceProvider(Pe,ct(Z),oe)},registerRenameProvider(Z,oe){return st.registerRenameProvider(Pe,ct(Z),oe)},registerDocumentSymbolProvider(Z,oe,ye){return st.registerDocumentSymbolProvider(Pe,ct(Z),oe,ye)},registerWorkspaceSymbolProvider(Z){return st.registerWorkspaceSymbolProvider(Pe,Z)},registerDocumentFormattingEditProvider(Z,oe){return st.registerDocumentFormattingEditProvider(Pe,ct(Z),oe)},registerDocumentRangeFormattingEditProvider(Z,oe){return st.registerDocumentRangeFormattingEditProvider(Pe,ct(Z),oe)},registerOnTypeFormattingEditProvider(Z,oe,ye,...Ze){return st.registerOnTypeFormattingEditProvider(Pe,ct(Z),oe,[ye].concat(Ze))},registerDocumentSemanticTokensProvider(Z,oe,ye){return st.registerDocumentSemanticTokensProvider(Pe,ct(Z),oe,ye)},registerDocumentRangeSemanticTokensProvider(Z,oe,ye){return st.registerDocumentRangeSemanticTokensProvider(Pe,ct(Z),oe,ye)},registerSignatureHelpProvider(Z,oe,ye,...Ze){return typeof ye=="object"?st.registerSignatureHelpProvider(Pe,ct(Z),oe,ye):st.registerSignatureHelpProvider(Pe,ct(Z),oe,typeof ye=="undefined"?[]:[ye,...Ze])},registerCompletionItemProvider(Z,oe,...ye){return st.registerCompletionItemProvider(Pe,ct(Z),oe,ye)},registerInlineCompletionItemProvider(Z,oe){return(0,qe.checkProposedApiEnabled)(Pe,"inlineCompletions"),st.registerInlineCompletionsProvider(Pe,ct(Z),oe)},registerDocumentLinkProvider(Z,oe){return st.registerDocumentLinkProvider(Pe,ct(Z),oe)},registerColorProvider(Z,oe){return st.registerColorProvider(Pe,ct(Z),oe)},registerFoldingRangeProvider(Z,oe){return st.registerFoldingRangeProvider(Pe,ct(Z),oe)},registerSelectionRangeProvider(Z,oe){return st.registerSelectionRangeProvider(Pe,Z,oe)},registerCallHierarchyProvider(Z,oe){return st.registerCallHierarchyProvider(Pe,Z,oe)},registerTypeHierarchyProvider(Z,oe){return st.registerTypeHierarchyProvider(Pe,Z,oe)},setLanguageConfiguration:(Z,oe)=>st.setLanguageConfiguration(Pe,Z,oe),getTokenInformationAtPosition(Z,oe){return(0,qe.checkProposedApiEnabled)(Pe,"tokenInformation"),Kt.tokenAtPosition(Z,oe)},registerInlayHintsProvider(Z,oe){return st.registerInlayHintsProvider(Pe,Z,oe)},createLanguageStatusItem(Z,oe){return Kt.createLanguageStatusItem(Pe,Z,oe)}},ui={get activeTextEditor(){return Ct.getActiveTextEditor()},get visibleTextEditors(){return Ct.getVisibleTextEditors()},get activeTerminal(){return at.activeTerminal},get terminals(){return at.terminals},async showTextDocument(Z,oe,ye){const Ze=await(S.URI.isUri(Z)?Promise.resolve(Ei.openTextDocument(Z)):Promise.resolve(Z));return Ct.showTextDocument(Ze,oe,ye)},createTextEditorDecorationType(Z){return Ct.createTextEditorDecorationType(Pe,Z)},onDidChangeActiveTextEditor(Z,oe,ye){return Ct.onDidChangeActiveTextEditor(Z,oe,ye)},onDidChangeVisibleTextEditors(Z,oe,ye){return Ct.onDidChangeVisibleTextEditors(Z,oe,ye)},onDidChangeTextEditorSelection(Z,oe,ye){return Ct.onDidChangeTextEditorSelection(Z,oe,ye)},onDidChangeTextEditorOptions(Z,oe,ye){return Ct.onDidChangeTextEditorOptions(Z,oe,ye)},onDidChangeTextEditorVisibleRanges(Z,oe,ye){return Ct.onDidChangeTextEditorVisibleRanges(Z,oe,ye)},onDidChangeTextEditorViewColumn(Z,oe,ye){return Ct.onDidChangeTextEditorViewColumn(Z,oe,ye)},onDidCloseTerminal(Z,oe,ye){return at.onDidCloseTerminal(Z,oe,ye)},onDidOpenTerminal(Z,oe,ye){return at.onDidOpenTerminal(Z,oe,ye)},onDidChangeActiveTerminal(Z,oe,ye){return at.onDidChangeActiveTerminal(Z,oe,ye)},onDidChangeTerminalDimensions(Z,oe,ye){return(0,qe.checkProposedApiEnabled)(Pe,"terminalDimensions"),at.onDidChangeTerminalDimensions(Z,oe,ye)},onDidChangeTerminalState(Z,oe,ye){return at.onDidChangeTerminalState(Z,oe,ye)},onDidWriteTerminalData(Z,oe,ye){return(0,qe.checkProposedApiEnabled)(Pe,"terminalDataWriteEvent"),at.onDidWriteTerminalData(Z,oe,ye)},get state(){return $e.state},onDidChangeWindowState(Z,oe,ye){return $e.onDidChangeWindowState(Z,oe,ye)},showInformationMessage(Z,...oe){return Zt.showMessage(Pe,B.default.Info,Z,oe[0],oe.slice(1))},showWarningMessage(Z,...oe){return Zt.showMessage(Pe,B.default.Warning,Z,oe[0],oe.slice(1))},showErrorMessage(Z,...oe){return Zt.showMessage(Pe,B.default.Error,Z,oe[0],oe.slice(1))},showQuickPick(Z,oe,ye){return zt.showQuickPick(Z,oe,ye)},showWorkspaceFolderPick(Z){return zt.showWorkspaceFolderPick(Z)},showInputBox(Z,oe){return zt.showInput(Z,oe)},showOpenDialog(Z){return gi.showOpenDialog(Z)},showSaveDialog(Z){return gi.showSaveDialog(Z)},createStatusBarItem(Z,oe,ye){let Ze,ht,yt;return typeof Z=="string"?(Ze=Z,ht=oe,yt=ye):(ht=Z,yt=oe),Gt.createStatusBarEntry(Pe,Ze,ht,yt)},setStatusBarMessage(Z,oe){return Gt.setStatusBarMessage(Z,oe)},withScmProgress(Z){return Ce.report("window.withScmProgress",Pe,"Use 'withProgress' instead."),fi.withProgress(Pe,{location:z.ProgressLocation.SourceControl},(oe,ye)=>Z({report(Ze){}}))},withProgress(Z,oe){return fi.withProgress(Pe,Z,oe)},createOutputChannel(Z,oe){return oe&&(0,qe.checkProposedApiEnabled)(Pe,"outputChannelLanguage"),Dt.createOutputChannel(Z,oe,Pe)},createWebviewPanel(Z,oe,ye,Ze){return Yt.createWebviewPanel(Pe,Z,oe,ye,Ze)},createWebviewTextEditorInset(Z,oe,ye,Ze){return(0,qe.checkProposedApiEnabled)(Pe,"editorInsets"),wi.createWebviewEditorInset(Z,oe,ye,Ze,Pe)},createTerminal(Z,oe,ye){return typeof Z=="object"?"pty"in Z?at.createExtensionTerminal(Z):at.createTerminalFromOptions(Z):at.createTerminal(Z,oe,ye)},registerTerminalLinkProvider(Z){return at.registerLinkProvider(Z)},registerTerminalProfileProvider(Z,oe){return at.registerProfileProvider(Pe,Z,oe)},registerTreeDataProvider(Z,oe){return ii.registerTreeDataProvider(Z,oe,Pe)},createTreeView(Z,oe){return ii.createTreeView(Z,oe,Pe)},registerWebviewPanelSerializer:(Z,oe)=>Yt.registerWebviewPanelSerializer(Pe,Z,oe),registerCustomEditorProvider:(Z,oe,ye={})=>Di.registerCustomEditorProvider(Pe,Z,oe,ye),registerFileDecorationProvider(Z){return gt.registerFileDecorationProvider(Z,Pe.identifier)},registerUriHandler(Z){return Ut.registerUriHandler(Pe.identifier,Z)},createQuickPick(){return zt.createQuickPick(Pe)},createInputBox(){return zt.createInputBox(Pe.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(Z,oe,ye){return mi.onDidChangeActiveColorTheme(Z,oe,ye)},registerWebviewViewProvider(Z,oe,ye){return Ci.registerWebviewViewProvider(Pe,Z,oe,ye?.webviewOptions)},get activeNotebookEditor(){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(Z,oe,ye){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),pt.onDidChangeActiveNotebookEditor(Z,oe,ye)},get visibleNotebookEditors(){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),pt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Z,oe,ye){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),Xt.onDidChangeNotebookEditorSelection(Z,oe,ye)},onDidChangeNotebookEditorVisibleRanges(Z,oe,ye){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),Xt.onDidChangeNotebookEditorVisibleRanges(Z,oe,ye)},showNotebookDocument(Z,oe){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),pt.showNotebookDocument(Z,oe)},registerExternalUriOpener(Z,oe,ye){return(0,qe.checkProposedApiEnabled)(Pe,"externalUriOpener"),si.registerExternalUriOpener(Pe.identifier,Z,oe,ye)},get tabGroups(){return(0,qe.checkProposedApiEnabled)(Pe,"tabs"),lt.tabGroups},getInlineCompletionItemController(Z){return(0,qe.checkProposedApiEnabled)(Pe,"inlineCompletions"),a.InlineCompletionController.get(Z)}},Ei={get rootPath(){return Ce.report("workspace.rootPath",Pe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(Z){throw I.readonly()},getWorkspaceFolder(Z){return dt.getWorkspaceFolder(Z)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(Z){throw I.readonly()},get workspaceFile(){return dt.workspaceFile},set workspaceFile(Z){throw I.readonly()},updateWorkspaceFolders:(Z,oe,...ye)=>dt.updateWorkspaceFolders(Pe,Z,oe||0,...ye),onDidChangeWorkspaceFolders:function(Z,oe,ye){return dt.onDidChangeWorkspace(Z,oe,ye)},asRelativePath:(Z,oe)=>dt.getRelativePath(Z,oe),findFiles:(Z,oe,ye,Ze)=>dt.findFiles(Z,oe,ye,Pe.identifier,Ze),findTextInFiles:(Z,oe,ye,Ze)=>{(0,qe.checkProposedApiEnabled)(Pe,"findTextInFiles");let ht,yt;return typeof oe=="object"?(ht=oe,yt=ye):(ht={},yt=oe,Ze=ye),dt.findTextInFiles(Z,ht||{},yt,Pe.identifier,Ze)},saveAll:Z=>dt.saveAll(Z),applyEdit(Z){return ki.applyWorkspaceEdit(Z)},createFileSystemWatcher:(Z,oe,ye,Ze)=>Wt.createFileSystemWatcher(dt,Pe,Z,oe,ye,Ze),get textDocuments(){return bt.getAllDocumentData().map(Z=>Z.document)},set textDocuments(Z){throw I.readonly()},openTextDocument(Z){let oe;const ye=Z;if(typeof Z=="string")oe=Promise.resolve(S.URI.file(Z));else if(S.URI.isUri(Z))oe=Promise.resolve(Z);else if(!ye||typeof ye=="object")oe=bt.createDocumentData(ye);else throw new Error("illegal argument - uriOrFileNameOrOptions");return oe.then(Ze=>bt.ensureDocumentData(Ze).then(ht=>ht.document))},onDidOpenTextDocument:(Z,oe,ye)=>bt.onDidAddDocument(Z,oe,ye),onDidCloseTextDocument:(Z,oe,ye)=>bt.onDidRemoveDocument(Z,oe,ye),onDidChangeTextDocument:(Z,oe,ye)=>bt.onDidChangeDocument(Z,oe,ye),onDidSaveTextDocument:(Z,oe,ye)=>bt.onDidSaveDocument(Z,oe,ye),onWillSaveTextDocument:(Z,oe,ye)=>Ht.getOnWillSaveTextDocumentEvent(Pe)(Z,oe,ye),get notebookDocuments(){return pt.notebookDocuments.map(Z=>Z.apiNotebook)},async openNotebookDocument(Z,oe){let ye;if(S.URI.isUri(Z))ye=Z,await pt.openNotebookDocument(Z);else if(typeof Z=="string")ye=S.URI.revive(await pt.createNotebookDocument({viewType:Z,content:oe}));else throw new Error("Invalid arguments");return pt.getNotebookDocument(ye).apiNotebook},get onDidOpenNotebookDocument(){return pt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return pt.onDidCloseNotebookDocument},registerNotebookSerializer(Z,oe,ye,Ze){return pt.registerNotebookSerializer(Pe,Z,oe,ye,(0,qe.isProposedApiEnabled)(Pe,"notebookLiveShare")?Ze:void 0)},registerNotebookContentProvider:(Z,oe,ye,Ze)=>((0,qe.checkProposedApiEnabled)(Pe,"notebookContentProvider"),pt.registerNotebookContentProvider(Pe,Z,oe,ye,(0,qe.isProposedApiEnabled)(Pe,"notebookLiveShare")?Ze:void 0)),onDidChangeConfiguration:(Z,oe,ye)=>Ot.onDidChangeConfiguration(Z,oe,ye),getConfiguration(Z,oe){return oe=arguments.length===1?void 0:oe,Ot.getConfiguration(Z,oe,Pe)},registerTextDocumentContentProvider(Z,oe){return Bt.registerTextDocumentContentProvider(Z,oe)},registerTaskProvider:(Z,oe)=>(Ce.report("window.registerTaskProvider",Pe,"Use the corresponding function on the 'tasks' namespace instead"),mt.registerTaskProvider(Pe,Z,oe)),registerFileSystemProvider(Z,oe,ye){return(0,kt.combinedDisposable)(li.registerFileSystemProvider(Pe,Z,oe,ye),Tt.addFileSystemProvider(Z,oe))},get fs(){return Tt.value},registerFileSearchProvider:(Z,oe)=>((0,qe.checkProposedApiEnabled)(Pe,"fileSearchProvider"),Mt.registerFileSearchProvider(Z,oe)),registerTextSearchProvider:(Z,oe)=>((0,qe.checkProposedApiEnabled)(Pe,"textSearchProvider"),Mt.registerTextSearchProvider(Z,oe)),registerRemoteAuthorityResolver:(Z,oe)=>((0,qe.checkProposedApiEnabled)(Pe,"resolvers"),wt.registerRemoteAuthorityResolver(Z,oe)),registerResourceLabelFormatter:Z=>((0,qe.checkProposedApiEnabled)(Pe,"resolvers"),Si.$registerResourceLabelFormatter(Z)),onDidCreateFiles:(Z,oe,ye)=>Wt.onDidCreateFile(Z,oe,ye),onDidDeleteFiles:(Z,oe,ye)=>Wt.onDidDeleteFile(Z,oe,ye),onDidRenameFiles:(Z,oe,ye)=>Wt.onDidRenameFile(Z,oe,ye),onWillCreateFiles:(Z,oe,ye)=>Wt.getOnWillCreateFileEvent(Pe)(Z,oe,ye),onWillDeleteFiles:(Z,oe,ye)=>Wt.getOnWillDeleteFileEvent(Pe)(Z,oe,ye),onWillRenameFiles:(Z,oe,ye)=>Wt.getOnWillRenameFileEvent(Pe)(Z,oe,ye),openTunnel:Z=>((0,qe.checkProposedApiEnabled)(Pe,"resolvers"),_e.openTunnel(Pe,Z).then(oe=>{if(!oe)throw new Error("cannot open tunnel");return oe})),get tunnels(){return(0,qe.checkProposedApiEnabled)(Pe,"resolvers"),_e.getTunnels()},onDidChangeTunnels:(Z,oe,ye)=>((0,qe.checkProposedApiEnabled)(Pe,"resolvers"),_e.onDidChangeTunnels(Z,oe,ye)),registerPortAttributesProvider:(Z,oe)=>((0,qe.checkProposedApiEnabled)(Pe,"portsAttributes"),_e.registerPortsAttributesProvider(Z,oe)),registerTimelineProvider:(Z,oe)=>((0,qe.checkProposedApiEnabled)(Pe,"timeline"),yi.registerTimelineProvider(Z,oe,Pe.identifier,rt.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:Z=>((0,qe.checkProposedApiEnabled)(Pe,"workspaceTrust"),dt.requestWorkspaceTrust(Z)),onDidGrantWorkspaceTrust:(Z,oe,ye)=>dt.onDidGrantWorkspaceTrust(Z,oe,ye)},Mi={get inputBox(){return Ce.report("scm.inputBox",Pe,"Use 'SourceControl.inputBox' instead"),ni.getLastInputBox(Pe)},createSourceControl(Z,oe,ye){return ni.createSourceControl(Pe,Z,oe,ye)}},Ni={createCommentController(Z,oe){return _i.createCommentController(Pe,Z,oe)}},Li={get activeDebugSession(){return ot.activeDebugSession},get activeDebugConsole(){return ot.activeDebugConsole},get breakpoints(){return ot.breakpoints},onDidStartDebugSession(Z,oe,ye){return ot.onDidStartDebugSession(Z,oe,ye)},onDidTerminateDebugSession(Z,oe,ye){return ot.onDidTerminateDebugSession(Z,oe,ye)},onDidChangeActiveDebugSession(Z,oe,ye){return ot.onDidChangeActiveDebugSession(Z,oe,ye)},onDidReceiveDebugSessionCustomEvent(Z,oe,ye){return ot.onDidReceiveDebugSessionCustomEvent(Z,oe,ye)},onDidChangeBreakpoints(Z,oe,ye){return ot.onDidChangeBreakpoints(Z,oe,ye)},registerDebugConfigurationProvider(Z,oe,ye){return ot.registerDebugConfigurationProvider(Z,oe,ye||vt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Z,oe){return ot.registerDebugAdapterDescriptorFactory(Pe,Z,oe)},registerDebugAdapterTrackerFactory(Z,oe){return ot.registerDebugAdapterTrackerFactory(Z,oe)},startDebugging(Z,oe,ye){return!ye||typeof ye=="object"&&"configuration"in ye?ot.startDebugging(Z,oe,{parentSession:ye}):ot.startDebugging(Z,oe,ye||{})},stopDebugging(Z){return ot.stopDebugging(Z)},addBreakpoints(Z){return ot.addBreakpoints(Z)},removeBreakpoints(Z){return ot.removeBreakpoints(Z)},asDebugSourceUri(Z,oe){return ot.asDebugSourceUri(Z,oe)}},Ui={registerTaskProvider:(Z,oe)=>mt.registerTaskProvider(Pe,Z,oe),fetchTasks:Z=>mt.fetchTasks(Z),executeTask:Z=>mt.executeTask(Pe,Z),get taskExecutions(){return mt.taskExecutions},onDidStartTask:(Z,oe,ye)=>mt.onDidStartTask(Z,oe,ye),onDidEndTask:(Z,oe,ye)=>mt.onDidEndTask(Z,oe,ye),onDidStartTaskProcess:(Z,oe,ye)=>mt.onDidStartTaskProcess(Z,oe,ye),onDidEndTaskProcess:(Z,oe,ye)=>mt.onDidEndTaskProcess(Z,oe,ye)},Bi={createNotebookController(Z,oe,ye,Ze,ht){return ti.createNotebookController(Pe,Z,oe,ye,Ze,(0,qe.isProposedApiEnabled)(Pe,"notebookMessaging")?ht:void 0)},registerNotebookCellStatusBarItemProvider:(Z,oe)=>pt.registerNotebookCellStatusBarItemProvider(Pe,Z,oe),get onDidSaveNotebookDocument(){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),ei.onDidSaveNotebookDocument},createNotebookEditorDecorationType(Z){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditorDecorationType"),Xt.createNotebookEditorDecorationType(Z)},createRendererMessaging(Z){return ai.createRendererMessaging(Pe,Z)},onDidChangeNotebookDocumentMetadata(Z,oe,ye){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),ei.onDidChangeNotebookDocumentMetadata(Z,oe,ye)},onDidChangeNotebookCells(Z,oe,ye){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),pt.onDidChangeNotebookCells(Z,oe,ye)},onDidChangeNotebookCellExecutionState(Z,oe,ye){return(0,qe.checkProposedApiEnabled)(Pe,"notebookCellExecutionState"),ti.onDidChangeNotebookCellExecutionState(Z,oe,ye)},onDidChangeCellOutputs(Z,oe,ye){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),pt.onDidChangeCellOutputs(Z,oe,ye)},onDidChangeCellMetadata(Z,oe,ye){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),pt.onDidChangeCellMetadata(Z,oe,ye)},createConcatTextDocument(Z,oe){return(0,qe.checkProposedApiEnabled)(Pe,"notebookConcatTextDocument"),new ve.ExtHostNotebookConcatDocument(pt,bt,Z,oe)}};return{version:ut.version,authentication:Pi,commands:Ai,comments:Ni,debug:Li,env:pi,extensions:Oi,languages:Fi,notebooks:Bi,scm:Mi,tasks:Ui,tests:Ri,window:ui,workspace:Ei,Breakpoint:z.Breakpoint,CallHierarchyIncomingCall:z.CallHierarchyIncomingCall,CallHierarchyItem:z.CallHierarchyItem,CallHierarchyOutgoingCall:z.CallHierarchyOutgoingCall,CancellationError:I.CancellationError,CancellationTokenSource:o.CancellationTokenSource,CandidatePortSource:c.CandidatePortSource,CodeAction:z.CodeAction,CodeActionKind:z.CodeActionKind,CodeActionTriggerKind:z.CodeActionTriggerKind,CodeLens:z.CodeLens,Color:z.Color,ColorInformation:z.ColorInformation,ColorPresentation:z.ColorPresentation,ColorThemeKind:z.ColorThemeKind,CommentMode:z.CommentMode,CommentThreadCollapsibleState:z.CommentThreadCollapsibleState,CommentThreadState:z.CommentThreadState,CompletionItem:z.CompletionItem,CompletionItemKind:z.CompletionItemKind,CompletionItemTag:z.CompletionItemTag,CompletionList:z.CompletionList,CompletionTriggerKind:z.CompletionTriggerKind,ConfigurationTarget:z.ConfigurationTarget,CustomExecution:z.CustomExecution,DebugAdapterExecutable:z.DebugAdapterExecutable,DebugAdapterInlineImplementation:z.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:z.DebugAdapterNamedPipeServer,DebugAdapterServer:z.DebugAdapterServer,DebugConfigurationProviderTriggerKind:vt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:z.DebugConsoleMode,DecorationRangeBehavior:z.DecorationRangeBehavior,Diagnostic:z.Diagnostic,DiagnosticRelatedInformation:z.DiagnosticRelatedInformation,DiagnosticSeverity:z.DiagnosticSeverity,DiagnosticTag:z.DiagnosticTag,Disposable:z.Disposable,DocumentHighlight:z.DocumentHighlight,DocumentHighlightKind:z.DocumentHighlightKind,DocumentLink:z.DocumentLink,DocumentSymbol:z.DocumentSymbol,EndOfLine:z.EndOfLine,EnvironmentVariableMutatorType:z.EnvironmentVariableMutatorType,EvaluatableExpression:z.EvaluatableExpression,InlineValueText:z.InlineValueText,InlineValueVariableLookup:z.InlineValueVariableLookup,InlineValueEvaluatableExpression:z.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:z.InlineCompletionTriggerKind,EventEmitter:w.Emitter,ExtensionKind:z.ExtensionKind,ExtensionMode:z.ExtensionMode,ExternalUriOpenerPriority:z.ExternalUriOpenerPriority,FileChangeType:z.FileChangeType,FileDecoration:z.FileDecoration,FileSystemError:z.FileSystemError,FileType:v.FileType,FilePermission:v.FilePermission,FoldingRange:z.FoldingRange,FoldingRangeKind:z.FoldingRangeKind,FunctionBreakpoint:z.FunctionBreakpoint,InlineCompletionItem:z.InlineSuggestion,InlineCompletionList:z.InlineSuggestions,Hover:z.Hover,IndentAction:L.IndentAction,Location:z.Location,MarkdownString:z.MarkdownString,OverviewRulerLane:C.OverviewRulerLane,ParameterInformation:z.ParameterInformation,PortAutoForwardAction:z.PortAutoForwardAction,Position:z.Position,ProcessExecution:z.ProcessExecution,ProgressLocation:z.ProgressLocation,QuickInputButtons:z.QuickInputButtons,Range:z.Range,RelativePattern:z.RelativePattern,Selection:z.Selection,SelectionRange:z.SelectionRange,SemanticTokens:z.SemanticTokens,SemanticTokensBuilder:z.SemanticTokensBuilder,SemanticTokensEdit:z.SemanticTokensEdit,SemanticTokensEdits:z.SemanticTokensEdits,SemanticTokensLegend:z.SemanticTokensLegend,ShellExecution:z.ShellExecution,ShellQuoting:z.ShellQuoting,SignatureHelp:z.SignatureHelp,SignatureHelpTriggerKind:z.SignatureHelpTriggerKind,SignatureInformation:z.SignatureInformation,SnippetString:z.SnippetString,SourceBreakpoint:z.SourceBreakpoint,StandardTokenType:z.StandardTokenType,StatusBarAlignment:z.StatusBarAlignment,SymbolInformation:z.SymbolInformation,SymbolKind:z.SymbolKind,SymbolTag:z.SymbolTag,TabKind:c.TabKind,Task:z.Task,TaskGroup:z.TaskGroup,TaskPanelKind:z.TaskPanelKind,TaskRevealKind:z.TaskRevealKind,TaskScope:z.TaskScope,TerminalLink:z.TerminalLink,TerminalLocation:z.TerminalLocation,TerminalProfile:z.TerminalProfile,TextDocumentSaveReason:z.TextDocumentSaveReason,TextEdit:z.TextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:z.TextEditorLineNumbersStyle,TextEditorRevealType:z.TextEditorRevealType,TextEditorSelectionChangeKind:z.TextEditorSelectionChangeKind,TextDocumentChangeReason:z.TextDocumentChangeReason,ThemeColor:z.ThemeColor,ThemeIcon:z.ThemeIcon,TreeItem:z.TreeItem,TreeItemCollapsibleState:z.TreeItemCollapsibleState,TypeHierarchyItem:z.TypeHierarchyItem,UIKind:g.UIKind,Uri:S.URI,ViewColumn:z.ViewColumn,WorkspaceEdit:z.WorkspaceEdit,InlayHint:z.InlayHint,InlayHintLabelPart:z.InlayHintLabelPart,InlayHintKind:z.InlayHintKind,RemoteAuthorityResolverError:z.RemoteAuthorityResolverError,ResolvedAuthority:z.ResolvedAuthority,SourceControlInputBoxValidationType:z.SourceControlInputBoxValidationType,ExtensionRuntime:z.ExtensionRuntime,TimelineItem:z.TimelineItem,NotebookRange:z.NotebookRange,NotebookCellKind:z.NotebookCellKind,NotebookCellExecutionState:z.NotebookCellExecutionState,NotebookCellData:z.NotebookCellData,NotebookData:z.NotebookData,NotebookRendererScript:z.NotebookRendererScript,NotebookCellStatusBarAlignment:z.NotebookCellStatusBarAlignment,NotebookEditorRevealType:z.NotebookEditorRevealType,NotebookCellOutput:z.NotebookCellOutput,NotebookCellOutputItem:z.NotebookCellOutputItem,NotebookCellStatusBarItem:z.NotebookCellStatusBarItem,NotebookControllerAffinity:z.NotebookControllerAffinity,PortAttributes:z.PortAttributes,LinkedEditingRanges:z.LinkedEditingRanges,TestResultState:z.TestResultState,TestRunRequest:z.TestRunRequest,TestMessage:z.TestMessage,TestTag:z.TestTag,TestRunProfileKind:z.TestRunProfileKind,TextSearchCompleteMessageType:Oe.TextSearchCompleteMessageType,TreeDataTransfer:z.TreeDataTransfer,TreeDataTransferItem:z.TreeDataTransferItem,CoveredCount:z.CoveredCount,FileCoverage:z.FileCoverage,StatementCoverage:z.StatementCoverage,BranchCoverage:z.BranchCoverage,FunctionCoverage:z.FunctionCoverage,WorkspaceTrustState:z.WorkspaceTrustState,LanguageStatusSeverity:z.LanguageStatusSeverity,QuickPickItemKind:z.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=Nt}),define(Ee[224],be([1,0,223,33,217,7,13,4,9]),function(Y,e,o,I,w,B,S,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class L extends w.RequireInterceptor{_installInterceptor(){}getModule(r,n){for(let m of this._alternatives){let y=m(r);if(y){r=y;break}}if(this._factories.has(r))return this._factories.get(r).load(r,n,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class M extends I.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=B.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const r=this._extHostContext.getProxy(A.MainContext.MainThreadConsole);c(r,this._initData.environment.isExtensionDevelopmentDebug);const n=this._instaService.invokeFunction(o.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(L,n,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(r){return r.browser}async _loadCommonJSModule(r,n,m){n=n.with({path:v(n.path,".js")}),r&&performance.mark(`code/extHost/willFetchExtensionCode/${r.value}`);const y=await fetch(C.FileAccess.asBrowserUri(n).toString(!0));if(r&&performance.mark(`code/extHost/didFetchExtensionCode/${r.value}`),y.status!==200)throw new Error(y.statusText);const k=await y.text(),d=`${n.toString(!0)}#vscode-extension`,f=`${k}
//# sourceURL=${d}`;let b;try{b=new Function("module","exports","require",f)}catch(i){throw console.error(r?`Loading code for extension ${r.value} failed: ${i.message}`:`Loading code failed: ${i.message}`),console.error(`${n.toString(!0)}${typeof i.line=="number"?` line ${i.line}`:""}${typeof i.column=="number"?` column ${i.column}`:""}`),console.error(i),i}const l={},P={exports:l},u=i=>{const s=this._fakeModules.getModule(i,n);if(s===void 0)throw new Error(`Cannot load module '${i}'`);return s};try{return m.codeLoadingStart(),r&&performance.mark(`code/extHost/willLoadExtensionCode/${r.value}`),b(P,l,u),P.exports!==l?P.exports:l}finally{r&&performance.mark(`code/extHost/didLoadExtensionCode/${r.value}`),m.codeLoadingStop()}}async $setRemoteEnvironment(r){}async _waitForDebuggerAttachment(r=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const n=Date.now()+r;for(;Date.now()<n&&!("__jsDebugIsReady"in globalThis);)await(0,S.timeout)(10)}}e.ExtHostExtensionService=M;function v(g,r){return g.endsWith(r)?g:g+r}function c(g,r){n("info","log"),n("log","log"),n("warn","warn"),n("error","error");function n(k,d){const f=console[k];console[k]=function(){g.$logExtensionHostMessage({type:"__$console",severity:d,arguments:y(arguments)}),r&&f.apply(console,arguments)}}const m=1e5;function y(k){const d=[],f=[];if(k.length)for(let b=0;b<k.length;b++){if(typeof k[b]=="undefined")k[b]="undefined";else if(k[b]instanceof Error){const l=k[b];l.stack?k[b]=l.stack:k[b]=l.toString()}f.push(k[b])}try{const b=JSON.stringify(f,function(l,P){if(P&&typeof P=="object"){if(d.indexOf(P)!==-1)return"[Circular]";d.push(P)}return P});return b.length>m?"Output omitted for a large object that exceeds the limits":b}catch(b){return`Output omitted for an object that cannot be inspected ('${b.toString()}')`}}}}),define(Ee[225],be([1,0,55,33,68,224]),function(Y,e,o,I,w,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,o.registerSingleton)(I.IExtHostExtensionService,B.ExtHostExtensionService),(0,o.registerSingleton)(w.IExtensionStoragePaths,w.ExtensionStoragePaths)}),define(Ee[236],be([1,0,21,5,91,218,211,17,69,9,2,220,225]),function(Y,e,o,I,w,B,S,A,C,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const v=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const c=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const g=fetch.bind(self);if(self.fetch=function(f,b){return f instanceof Request||/^file:/i.test(String(f))&&(f=L.FileAccess.asBrowserUri(M.URI.parse(String(f))).toString(!0)),g(f,b)},self.XMLHttpRequest=class extends XMLHttpRequest{open(f,b,l,P,u){return/^file:/i.test(b.toString())&&(b=L.FileAccess.asBrowserUri(M.URI.parse(b.toString())).toString(!0)),super.open(f,b,l??!0,P,u)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const f=self.Worker;Worker=function(b,l){/^file:/i.test(b.toString())&&(b=L.FileAccess.asBrowserUri(M.URI.parse(b.toString())).toString(!0));const u=`(${function(a){function p(T){return typeof T=="string"||T instanceof URL?String(T).replace(/^file:\/\//i,"vscode-file://vscode-app"):T}const h=fetch.bind(self);self.fetch=function(T,R){return T instanceof Request?h(T,R):h(p(T),R)},self.XMLHttpRequest=class extends XMLHttpRequest{open(T,R,W,E,H){return super.open(T,p(R),W??!0,E,H)}};const _=importScripts.bind(self);self.importScripts=(...T)=>{_(...T.map(p))},_(a)}.toString()}('${b}'))`;l=l||{},l.name=l.name||A.basename(b.toString());const i=new Blob([u],{type:"application/javascript"}),s=URL.createObjectURL(i);return new f(s,l)}}else self.Worker=class extends S.NestedWorker{constructor(f,b){super(c,f,{name:A.basename(f.toString()),...b})}};const r=new class{constructor(){this.pid=void 0}exit(f){v()}async exists(f){return!0}async realpath(f){return f}};class n{constructor(){const b=new MessageChannel,l=new I.Emitter;let P=!1;c(b.port2,[b.port2]),b.port1.onmessage=u=>{const{data:i}=u;if(!(i instanceof ArrayBuffer)){console.warn("UNKNOWN data received",i);return}const s=o.VSBuffer.wrap(new Uint8Array(i,0,i.byteLength));if((0,w.isMessageOfType)(s,2)){P=!0,y("received terminate message from renderer");return}l.fire(s)},this.protocol={onMessage:l.event,send:u=>{if(!P){const i=u.buffer.buffer.slice(u.buffer.byteOffset,u.buffer.byteOffset+u.buffer.byteLength);b.port1.postMessage(i,[i])}}}}}function m(f){return new Promise(b=>{const l=f.onMessage(P=>{l.dispose();const u=JSON.parse(P.toString());f.send((0,w.createMessageOfType)(0)),b({protocol:f,initData:u})});f.send((0,w.createMessageOfType)(1))})}let y=f=>v();function k(f){return!!f&&typeof f=="object"&&f.type==="vscode.init"&&f.data instanceof Map}function d(){C.mark("code/extHost/willConnectToRenderer");const f=new n;return{onmessage(b){!k(b)||m(f.protocol).then(l=>{C.mark("code/extHost/didWaitForInitData");const P=new B.ExtensionHostMain(l.protocol,l.initData,r,null,b.data);y=u=>P.terminate(u)})}}}e.create=d})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0f4d3788605a486980fa3a6b3b9d1a38b1102481/core/vs/workbench/api/worker/extensionHostWorker.js.map
